/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var De=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/errors","vs/base/common/platform","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/buffer","vs/base/common/objects","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/base/node/pfs","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/uuid","vs/editor/common/core/range","vs/base/common/glob","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","vs/base/common/severity","vs/platform/files/common/files","vs/platform/registry/common/platform","child_process","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/editor/common/core/position","vs/base/common/errorMessage","vs/base/common/stopwatch","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/decorators","vs/base/common/functional","vs/base/common/iterator","fs","vs/editor/common/languages","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/collections","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/hash","vs/base/common/normalization","vs/base/common/marshalling","os","vs/platform/instantiation/common/extensions","vs/platform/configuration/common/configuration","vs/platform/extensionManagement/common/extensionManagement","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/common/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/stream","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/mime","vs/base/common/processes","vs/base/common/filters","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","vs/base/node/extpath","vs/base/node/processes","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.net","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/tunnel/common/tunnel","vs/workbench/api/common/extHostTelemetry","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostTelemetryLogService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/json","vs/base/common/marked/marked","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/iconLabels","vs/editor/common/languageSelector","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/uriTransformer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","net","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostCLIServer","http","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/extHostExtensionService","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","vscode-proxy-agent","events","vscode-regexpp","vs/workbench/api/node/extensionHostProcess","minimist"],Ie=function(J){for(var e=[],l=0,t=J.length;l<t;l++)e[l]=De[J[l]];return e};define(De[74],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function l(_){return _?_.replace(/\$\((.*?)\)/g,(D,b)=>` ${b} `).trim():""}e.getCodiconAriaLabel=l;class t{constructor(D,b,I){this.id=D,this.definition=b,this.description=I,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function C(_,D){const b=["codicon","codicon-"+_];return D&&b.push("codicon-modifier-"+D),b}e.getClassNamesArray=C;var P;(function(_){_.iconNameSegment="[A-Za-z0-9]+",_.iconNameExpression="[A-Za-z0-9-]+",_.iconModifierExpression="~[A-Za-z]+",_.iconNameCharacter="[A-Za-z0-9~-]";const D=new RegExp(`^(${_.iconNameExpression})(${_.iconModifierExpression})?$`);function b(k){if(k instanceof t)return["codicon","codicon-"+k.id];const S=D.exec(k.id);if(!S)return b(t.error);const[,T,E]=S,p=["codicon","codicon-"+T];return E&&p.push("codicon-modifier-"+E.substr(1)),p}_.asClassNameArray=b;function I(k){return b(k).join(" ")}_.asClassName=I;function L(k){return"."+b(k).join(".")}_.asCSSSelector=L})(P=e.CSSIcon||(e.CSSIcon={}))}),define(De[75],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function l(_,D){const b=Object.create(null);for(const I of _){const L=D(I);let k=b[L];k||(k=b[L]=[]),k.push(I)}return b}e.groupBy=l;function t(_,D){const b=[],I=[];for(const L of _)D.has(L)||b.push(L);for(const L of D)_.has(L)||I.push(L);return{removed:b,added:I}}e.diffSets=t;function C(_,D){const b=[],I=[];for(const[L,k]of _)D.has(L)||b.push(k);for(const[L,k]of D)_.has(L)||I.push(k);return{removed:b,added:I}}e.diffMaps=C;class P{constructor(){this.map=new Map}add(D,b){let I=this.map.get(D);I||(I=new Set,this.map.set(D,I)),I.add(b)}delete(D,b){const I=this.map.get(D);!I||(I.delete(b),I.size===0&&this.map.delete(D))}forEach(D,b){const I=this.map.get(D);!I||I.forEach(b)}}e.SetMap=P}),define(De[58],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function l(_){return(D,b,I)=>{let L=null,k=null;if(typeof I.value=="function"?(L="value",k=I.value):typeof I.get=="function"&&(L="get",k=I.get),!k)throw new Error("not supported");I[L]=_(k,b)}}e.createDecorator=l;function t(_,D,b){let I=null,L=null;if(typeof b.value=="function"?(I="value",L=b.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(I="get",L=b.get),!L)throw new Error("not supported");const k=`$memoize$${D}`;b[I]=function(...S){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,S)}),this[k]}}e.memoize=t;function C(_,D,b){return l((I,L)=>{const k=`$debounce$${L}`,S=`$debounce$result$${L}`;return function(...T){this[S]||(this[S]=b?b():void 0),clearTimeout(this[k]),D&&(this[S]=D(this[S],...T),T=[this[S]]),this[k]=setTimeout(()=>{I.apply(this,T),this[S]=b?b():void 0},_)}})}e.debounce=C;function P(_,D,b){return l((I,L)=>{const k=`$throttle$timer$${L}`,S=`$throttle$result$${L}`,T=`$throttle$lastRun$${L}`,E=`$throttle$pending$${L}`;return function(...p){if(this[S]||(this[S]=b?b():void 0),(this[T]===null||this[T]===void 0)&&(this[T]=-Number.MAX_VALUE),D&&(this[S]=D(this[S],...p)),this[E])return;const w=this[T]+_;w<=Date.now()?(this[T]=Date.now(),I.apply(this,[this[S]]),this[S]=b?b():void 0):(this[E]=!0,this[k]=setTimeout(()=>{this[E]=!1,this[T]=Date.now(),I.apply(this,[this[S]]),this[S]=b?b():void 0},w-Date.now()))}})}e.throttle=P}),define(De[10],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class l{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(n){setTimeout(()=>{throw n.stack?m.isErrorNoTelemetry(n)?new m(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.listeners.push(n),()=>{this._removeListener(n)}}emit(n){this.listeners.forEach(d=>{d(n)})}_removeListener(n){this.listeners.splice(this.listeners.indexOf(n),1)}setUnexpectedErrorHandler(n){this.unexpectedErrorHandler=n}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(n){this.unexpectedErrorHandler(n),this.emit(n)}onUnexpectedExternalError(n){this.unexpectedErrorHandler(n)}}e.ErrorHandler=l,e.errorHandler=new l;function t(g){e.errorHandler.setUnexpectedErrorHandler(g)}e.setUnexpectedErrorHandler=t;function C(g){b(g)||e.errorHandler.onUnexpectedError(g)}e.onUnexpectedError=C;function P(g){b(g)||e.errorHandler.onUnexpectedExternalError(g)}e.onUnexpectedExternalError=P;function _(g){if(g instanceof Error){const{name:n,message:d}=g,s=g.stacktrace||g.stack;return{$isError:!0,name:n,message:d,stack:s,noTelemetry:m.isErrorNoTelemetry(g)}}return g}e.transformErrorForSerialization=_;const D="Canceled";function b(g){return g instanceof I?!0:g instanceof Error&&g.name===D&&g.message===D}e.isCancellationError=b;class I extends Error{constructor(){super(D),this.name=this.message}}e.CancellationError=I;function L(){const g=new Error(D);return g.name=g.message,g}e.canceled=L;function k(g){return g?new Error(`Illegal argument: ${g}`):new Error("Illegal argument")}e.illegalArgument=k;function S(g){return g?new Error(`Illegal state: ${g}`):new Error("Illegal state")}e.illegalState=S;function T(g){return g?new Error(`readonly property '${g} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=T;function E(g){const n=new Error(`${g} has been disposed`);return n.name="DISPOSED",n}e.disposed=E;function p(g){return g?g.message?g.message:g.stack?g.stack.split(`
`)[0]:String(g):"Error"}e.getErrorMessage=p;class w extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.NotImplementedError=w;class f extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.NotSupportedError=f;class v extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=v;class m extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof m)return n;const d=new m;return d.message=n.message,d.stack=n.stack,d}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.ErrorNoTelemetry=m;class a extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,a.prototype);debugger}}e.BugIndicatingError=a}),define(De[17],Ie([1,0,10]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(oe,le=0){return oe[oe.length-(1+le)]}e.tail=t;function C(oe){if(oe.length===0)throw new Error("Invalid tail call");return[oe.slice(0,oe.length-1),oe[oe.length-1]]}e.tail2=C;function P(oe,le,fe=(Z,ae)=>Z===ae){if(oe===le)return!0;if(!oe||!le||oe.length!==le.length)return!1;for(let Z=0,ae=oe.length;Z<ae;Z++)if(!fe(oe[Z],le[Z]))return!1;return!0}e.equals=P;function _(oe,le){const fe=oe.length-1;le<fe&&(oe[le]=oe[fe]),oe.pop()}e.removeFastWithoutKeepingOrder=_;function D(oe,le,fe){return b(oe.length,Z=>fe(oe[Z],le))}e.binarySearch=D;function b(oe,le){let fe=0,Z=oe-1;for(;fe<=Z;){const ae=(fe+Z)/2|0,ee=le(ae);if(ee<0)fe=ae+1;else if(ee>0)Z=ae-1;else return ae}return-(fe+1)}e.binarySearch2=b;function I(oe,le){let fe=0,Z=oe.length;if(Z===0)return 0;for(;fe<Z;){const ae=Math.floor((fe+Z)/2);le(oe[ae])?Z=ae:fe=ae+1}return fe}e.findFirstInSorted=I;function L(oe,le,fe){if(oe=oe|0,oe>=le.length)throw new TypeError("invalid index");const Z=le[Math.floor(le.length*Math.random())],ae=[],ee=[],ie=[];for(const F of le){const H=fe(F,Z);H<0?ae.push(F):H>0?ee.push(F):ie.push(F)}return oe<ae.length?L(oe,ae,fe):oe<ae.length+ie.length?ie[0]:L(oe-(ae.length+ie.length),ee,fe)}e.quickSelect=L;function k(oe,le){const fe=[];let Z;for(const ae of oe.slice(0).sort(le))!Z||le(Z[0],ae)!==0?(Z=[ae],fe.push(Z)):Z.push(ae);return fe}e.groupBy=k;function S(oe,le,fe){const Z=[];function ae(F,H,G){if(H===0&&G.length===0)return;const X=Z[Z.length-1];X&&X.start+X.deleteCount===F?(X.deleteCount+=H,X.toInsert.push(...G)):Z.push({start:F,deleteCount:H,toInsert:G})}let ee=0,ie=0;for(;;){if(ee===oe.length){ae(ee,0,le.slice(ie));break}if(ie===le.length){ae(ee,oe.length-ee,[]);break}const F=oe[ee],H=le[ie],G=fe(F,H);G===0?(ee+=1,ie+=1):G<0?(ae(ee,1,[]),ee+=1):G>0&&(ae(ee,0,[H]),ie+=1)}return Z}e.sortedDiff=S;function T(oe,le,fe){const Z=S(oe,le,fe),ae=[],ee=[];for(const ie of Z)ae.push(...oe.slice(ie.start,ie.start+ie.deleteCount)),ee.push(...ie.toInsert);return{removed:ae,added:ee}}e.delta=T;function E(oe,le,fe){if(fe===0)return[];const Z=oe.slice(0,fe).sort(le);return w(oe,le,Z,fe,oe.length),Z}e.top=E;function p(oe,le,fe,Z,ae){return fe===0?Promise.resolve([]):new Promise((ee,ie)=>{(async()=>{const F=oe.length,H=oe.slice(0,fe).sort(le);for(let G=fe,X=Math.min(fe+Z,F);G<F;G=X,X=Math.min(X+Z,F)){if(G>fe&&await new Promise(me=>setTimeout(me)),ae&&ae.isCancellationRequested)throw new l.CancellationError;w(oe,le,H,G,X)}return H})().then(ee,ie)})}e.topAsync=p;function w(oe,le,fe,Z,ae){for(const ee=fe.length;Z<ae;Z++){const ie=oe[Z];if(le(ie,fe[ee-1])<0){fe.pop();const F=I(fe,H=>le(ie,H)<0);fe.splice(F,0,ie)}}}function f(oe){return oe.filter(le=>!!le)}e.coalesce=f;function v(oe){let le=0;for(let fe=0;fe<oe.length;fe++)oe[fe]&&(oe[le]=oe[fe],le+=1);oe.length=le}e.coalesceInPlace=v;function m(oe,le,fe){oe.splice(fe,0,oe.splice(le,1)[0])}e.move=m;function a(oe){return!Array.isArray(oe)||oe.length===0}e.isFalsyOrEmpty=a;function g(oe){return Array.isArray(oe)&&oe.length>0}e.isNonEmptyArray=g;function n(oe,le=fe=>fe){const fe=new Set;return oe.filter(Z=>{const ae=le(Z);return fe.has(ae)?!1:(fe.add(ae),!0)})}e.distinct=n;function d(oe){const le=new Set;return fe=>{const Z=oe(fe);return le.has(Z)?!1:(le.add(Z),!0)}}e.uniqueFilter=d;function s(oe,le){const fe=i(oe,le);if(fe!==-1)return oe[fe]}e.findLast=s;function i(oe,le){for(let fe=oe.length-1;fe>=0;fe--){const Z=oe[fe];if(le(Z))return fe}return-1}e.lastIndex=i;function r(oe,le){return oe.length>0?oe[0]:le}e.firstOrDefault=r;function c(oe,le){return oe.length>0?oe[oe.length-1]:le}e.lastOrDefault=c;function o(oe,le,fe=(Z,ae)=>Z===ae){let Z=0;for(let ae=0,ee=Math.min(oe.length,le.length);ae<ee&&fe(oe[ae],le[ae]);ae++)Z++;return Z}e.commonPrefixLength=o;function u(oe){return[].concat(...oe)}e.flatten=u;function h(oe,le){let fe=typeof le=="number"?oe:0;typeof le=="number"?fe=oe:(fe=0,le=oe);const Z=[];if(fe<=le)for(let ae=fe;ae<le;ae++)Z.push(ae);else for(let ae=fe;ae>le;ae--)Z.push(ae);return Z}e.range=h;function y(oe,le,fe){return oe.reduce((Z,ae)=>(Z[le(ae)]=fe?fe(ae):ae,Z),Object.create(null))}e.index=y;function R(oe,le){return oe.push(le),()=>M(oe,le)}e.insert=R;function M(oe,le){const fe=oe.indexOf(le);if(fe>-1)return oe.splice(fe,1),le}e.remove=M;function U(oe,le,fe){const Z=oe.slice(0,le),ae=oe.slice(le);return Z.concat(fe,ae)}e.arrayInsert=U;function A(oe,le){let fe;if(typeof le=="number"){let Z=le;fe=()=>{const ae=Math.sin(Z++)*179426549;return ae-Math.floor(ae)}}else fe=Math.random;for(let Z=oe.length-1;Z>0;Z-=1){const ae=Math.floor(fe()*(Z+1)),ee=oe[Z];oe[Z]=oe[ae],oe[ae]=ee}}e.shuffle=A;function z(oe,le){const fe=oe.indexOf(le);fe>-1&&(oe.splice(fe,1),oe.unshift(le))}e.pushToStart=z;function $(oe,le){const fe=oe.indexOf(le);fe>-1&&(oe.splice(fe,1),oe.push(le))}e.pushToEnd=$;function N(oe,le){for(const fe of le)oe.push(fe)}e.pushMany=N;function K(oe,le){return Array.isArray(oe)?oe.map(le):le(oe)}e.mapArrayOrNot=K;function B(oe){return Array.isArray(oe)?oe:[oe]}e.asArray=B;function O(oe){return oe[Math.floor(Math.random()*oe.length)]}e.getRandomElement=O;function x(oe,le){for(const fe of oe){const Z=le(fe);if(Z!==void 0)return Z}}e.mapFind=x;function V(oe,le,fe){const Z=Y(oe,le),ae=oe.length,ee=fe.length;oe.length=ae+ee;for(let ie=ae-1;ie>=Z;ie--)oe[ie+ee]=oe[ie];for(let ie=0;ie<ee;ie++)oe[ie+Z]=fe[ie]}e.insertInto=V;function q(oe,le,fe,Z){const ae=Y(oe,le),ee=oe.splice(ae,fe);return V(oe,ae,Z),ee}e.splice=q;function Y(oe,le){return le<0?Math.max(le+oe.length,0):Math.min(le,oe.length)}var Q;(function(oe){function le(ae){return ae<0}oe.isLessThan=le;function fe(ae){return ae>0}oe.isGreaterThan=fe;function Z(ae){return ae===0}oe.isNeitherLessOrGreaterThan=Z,oe.greaterThan=1,oe.lessThan=-1,oe.neitherLessOrGreaterThan=0})(Q=e.CompareResult||(e.CompareResult={}));function de(oe,le){return(fe,Z)=>le(oe(fe),oe(Z))}e.compareBy=de;function ve(...oe){return(le,fe)=>{for(const Z of oe){const ae=Z(le,fe);if(!Q.isNeitherLessOrGreaterThan(ae))return ae}return Q.neitherLessOrGreaterThan}}e.tieBreakComparators=ve;const ne=(oe,le)=>oe-le;e.numberComparator=ne;function pe(oe,le){if(oe.length===0)return;let fe=oe[0];for(let Z=1;Z<oe.length;Z++){const ae=oe[Z];le(ae,fe)>0&&(fe=ae)}return fe}e.findMaxBy=pe;function be(oe,le){if(oe.length===0)return;let fe=oe[0];for(let Z=1;Z<oe.length;Z++){const ae=oe[Z];le(ae,fe)>=0&&(fe=ae)}return fe}e.findLastMaxBy=be;function ke(oe,le){return pe(oe,(fe,Z)=>-le(fe,Z))}e.findMinBy=ke;class Oe{constructor(le){this.items=le,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(le){let fe=this.firstIdx;for(;fe<this.items.length&&le(this.items[fe]);)fe++;const Z=fe===this.firstIdx?null:this.items.slice(this.firstIdx,fe);return this.firstIdx=fe,Z}takeFromEndWhile(le){let fe=this.lastIdx;for(;fe>=0&&le(this.items[fe]);)fe--;const Z=fe===this.lastIdx?null:this.items.slice(fe+1,this.lastIdx+1);return this.lastIdx=fe,Z}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const le=this.items[this.firstIdx];return this.firstIdx++,le}removeLast(){const le=this.items[this.lastIdx];return this.lastIdx--,le}takeCount(le){const fe=this.items.slice(this.firstIdx,this.firstIdx+le);return this.firstIdx+=le,fe}}e.ArrayQueue=Oe;class We{constructor(le){this.iterate=le}forEach(le){this.iterate(fe=>(le(fe),!0))}toArray(){const le=[];return this.iterate(fe=>(le.push(fe),!0)),le}filter(le){return new We(fe=>this.iterate(Z=>le(Z)?fe(Z):!0))}map(le){return new We(fe=>this.iterate(Z=>fe(le(Z))))}some(le){let fe=!1;return this.iterate(Z=>(fe=le(Z),!fe)),fe}findFirst(le){let fe;return this.iterate(Z=>le(Z)?(fe=Z,!1):!0),fe}findLast(le){let fe;return this.iterate(Z=>(le(Z)&&(fe=Z),!0)),fe}findLastMaxBy(le){let fe,Z=!0;return this.iterate(ae=>((Z||Q.isGreaterThan(le(ae,fe)))&&(Z=!1,fe=ae),!0)),fe}}e.CallbackIterable=We,We.empty=new We(oe=>{})}),define(De[48],Ie([1,0,10]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(b,I){if(!b)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}e.ok=t;function C(b,I="Unreachable"){throw new Error(I)}e.assertNever=C;function P(b){if(!b)throw new l.BugIndicatingError("Assertion Failed")}e.assert=P;function _(b){if(!b()){debugger;b(),(0,l.onUnexpectedError)(new l.BugIndicatingError("Assertion Failed"))}}e.assertFn=_;function D(b,I){let L=0;for(;L<b.length-1;){const k=b[L],S=b[L+1];if(!I(k,S))return!1;L++}return!0}e.checkAdjacentItems=D}),define(De[59],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function l(t){const C=this;let P=!1,_;return function(){return P||(P=!0,_=t.apply(C,arguments)),_}}e.once=l}),define(De[94],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class l{constructor(C){this._prefix=C,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=l,e.defaultGenerator=new l("id#")}),define(De[60],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var l;(function(t){function C(d){return d&&typeof d=="object"&&typeof d[Symbol.iterator]=="function"}t.is=C;const P=Object.freeze([]);function _(){return P}t.empty=_;function*D(d){yield d}t.single=D;function b(d){return d||P}t.from=b;function I(d){return!d||d[Symbol.iterator]().next().done===!0}t.isEmpty=I;function L(d){return d[Symbol.iterator]().next().value}t.first=L;function k(d,s){for(const i of d)if(s(i))return!0;return!1}t.some=k;function S(d,s){for(const i of d)if(s(i))return i}t.find=S;function*T(d,s){for(const i of d)s(i)&&(yield i)}t.filter=T;function*E(d,s){let i=0;for(const r of d)yield s(r,i++)}t.map=E;function*p(...d){for(const s of d)for(const i of s)yield i}t.concat=p;function*w(d){for(const s of d)for(const i of s)yield i}t.concatNested=w;function f(d,s,i){let r=i;for(const c of d)r=s(r,c);return r}t.reduce=f;function v(d,s){let i=0;for(const r of d)s(r,i++)}t.forEach=v;function*m(d,s,i=d.length){for(s<0&&(s+=d.length),i<0?i+=d.length:i>d.length&&(i=d.length);s<i;s++)yield d[s]}t.slice=m;function a(d,s=Number.POSITIVE_INFINITY){const i=[];if(s===0)return[i,d];const r=d[Symbol.iterator]();for(let c=0;c<s;c++){const o=r.next();if(o.done)return[i,t.empty()];i.push(o.value)}return[i,{[Symbol.iterator](){return r}}]}t.consume=a;function g(d){return a(d)[0]}t.collect=g;function n(d,s,i=(r,c)=>r===c){const r=d[Symbol.iterator](),c=s[Symbol.iterator]();for(;;){const o=r.next(),u=c.next();if(o.done!==u.done)return!1;if(o.done)return!0;if(!i(o.value,u.value))return!1}}t.equals=n})(l=e.Iterable||(e.Iterable={}))}),define(De[143],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var l;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(l=e.ScanError||(e.ScanError={}));var t;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var C;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(C=e.ParseErrorCode||(e.ParseErrorCode={}));var P;(function(n){n.DEFAULT={allowTrailingComma:!0}})(P=e.ParseOptions||(e.ParseOptions={}));function _(n,d=!1){let s=0;const i=n.length;let r="",c=0,o=16,u=0;function h($){let N=0,K=0;for(;N<$;){const B=n.charCodeAt(s);if(B>=48&&B<=57)K=K*16+B-48;else if(B>=65&&B<=70)K=K*16+B-65+10;else if(B>=97&&B<=102)K=K*16+B-97+10;else break;s++,N++}return N<$&&(K=-1),K}function y($){s=$,r="",c=0,o=16,u=0}function R(){const $=s;if(n.charCodeAt(s)===48)s++;else for(s++;s<n.length&&I(n.charCodeAt(s));)s++;if(s<n.length&&n.charCodeAt(s)===46)if(s++,s<n.length&&I(n.charCodeAt(s)))for(s++;s<n.length&&I(n.charCodeAt(s));)s++;else return u=3,n.substring($,s);let N=s;if(s<n.length&&(n.charCodeAt(s)===69||n.charCodeAt(s)===101))if(s++,(s<n.length&&n.charCodeAt(s)===43||n.charCodeAt(s)===45)&&s++,s<n.length&&I(n.charCodeAt(s))){for(s++;s<n.length&&I(n.charCodeAt(s));)s++;N=s}else u=3;return n.substring($,N)}function M(){let $="",N=s;for(;;){if(s>=i){$+=n.substring(N,s),u=2;break}const K=n.charCodeAt(s);if(K===34){$+=n.substring(N,s),s++;break}if(K===92){if($+=n.substring(N,s),s++,s>=i){u=2;break}switch(n.charCodeAt(s++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:{const O=h(4);O>=0?$+=String.fromCharCode(O):u=4;break}default:u=5}N=s;continue}if(K>=0&&K<=31)if(b(K)){$+=n.substring(N,s),u=2;break}else u=6;s++}return $}function U(){if(r="",u=0,c=s,s>=i)return c=i,o=17;let $=n.charCodeAt(s);if(D($)){do s++,r+=String.fromCharCode($),$=n.charCodeAt(s);while(D($));return o=15}if(b($))return s++,r+=String.fromCharCode($),$===13&&n.charCodeAt(s)===10&&(s++,r+=`
`),o=14;switch($){case 123:return s++,o=1;case 125:return s++,o=2;case 91:return s++,o=3;case 93:return s++,o=4;case 58:return s++,o=6;case 44:return s++,o=5;case 34:return s++,r=M(),o=10;case 47:{const N=s-1;if(n.charCodeAt(s+1)===47){for(s+=2;s<i&&!b(n.charCodeAt(s));)s++;return r=n.substring(N,s),o=12}if(n.charCodeAt(s+1)===42){s+=2;const K=i-1;let B=!1;for(;s<K;){if(n.charCodeAt(s)===42&&n.charCodeAt(s+1)===47){s+=2,B=!0;break}s++}return B||(s++,u=1),r=n.substring(N,s),o=13}return r+=String.fromCharCode($),s++,o=16}case 45:if(r+=String.fromCharCode($),s++,s===i||!I(n.charCodeAt(s)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=R(),o=11;default:for(;s<i&&A($);)s++,$=n.charCodeAt(s);if(c!==s){switch(r=n.substring(c,s),r){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return r+=String.fromCharCode($),s++,o=16}}function A($){if(D($)||b($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function z(){let $;do $=U();while($>=12&&$<=15);return $}return{setPosition:y,getPosition:()=>s,scan:d?z:U,getToken:()=>o,getTokenValue:()=>r,getTokenOffset:()=>c,getTokenLength:()=>s-c,getTokenError:()=>u}}e.createScanner=_;function D(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function b(n){return n===10||n===13||n===8232||n===8233}function I(n){return n>=48&&n<=57}var L;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(L||(L={}));function k(n,d){const s=[],i=new Object;let r;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function u(h,y,R,M){c.value=h,c.offset=y,c.length=R,c.type=M,c.colonOffset=void 0,r=c}try{m(n,{onObjectBegin:(h,y)=>{if(d<=h)throw i;r=void 0,o=d>h,s.push("")},onObjectProperty:(h,y,R)=>{if(d<y||(u(h,y,R,"property"),s[s.length-1]=h,d<=y+R))throw i},onObjectEnd:(h,y)=>{if(d<=h)throw i;r=void 0,s.pop()},onArrayBegin:(h,y)=>{if(d<=h)throw i;r=void 0,s.push(0)},onArrayEnd:(h,y)=>{if(d<=h)throw i;r=void 0,s.pop()},onLiteralValue:(h,y,R)=>{if(d<y||(u(h,y,R,g(h)),d<=y+R))throw i},onSeparator:(h,y,R)=>{if(d<=y)throw i;if(h===":"&&r&&r.type==="property")r.colonOffset=y,o=!1,r=void 0;else if(h===","){const M=s[s.length-1];typeof M=="number"?s[s.length-1]=M+1:(o=!0,s[s.length-1]=""),r=void 0}}})}catch(h){if(h!==i)throw h}return{path:s,previousNode:r,isAtPropertyKey:o,matches:h=>{let y=0;for(let R=0;y<h.length&&R<s.length;R++)if(h[y]===s[R]||h[y]==="*")y++;else if(h[y]!=="**")return!1;return y===h.length}}}e.getLocation=k;function S(n,d=[],s=P.DEFAULT){let i=null,r=[];const c=[];function o(h){Array.isArray(r)?r.push(h):i!==null&&(r[i]=h)}return m(n,{onObjectBegin:()=>{const h={};o(h),c.push(r),r=h,i=null},onObjectProperty:h=>{i=h},onObjectEnd:()=>{r=c.pop()},onArrayBegin:()=>{const h=[];o(h),c.push(r),r=h,i=null},onArrayEnd:()=>{r=c.pop()},onLiteralValue:o,onError:(h,y,R)=>{d.push({error:h,offset:y,length:R})}},s),r[0]}e.parse=S;function T(n,d=[],s=P.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(h){i.type==="property"&&(i.length=h-i.offset,i=i.parent)}function c(h){return i.children.push(h),h}m(n,{onObjectBegin:h=>{i=c({type:"object",offset:h,length:-1,parent:i,children:[]})},onObjectProperty:(h,y,R)=>{i=c({type:"property",offset:y,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:h,offset:y,length:R,parent:i})},onObjectEnd:(h,y)=>{i.length=h+y-i.offset,i=i.parent,r(h+y)},onArrayBegin:(h,y)=>{i=c({type:"array",offset:h,length:-1,parent:i,children:[]})},onArrayEnd:(h,y)=>{i.length=h+y-i.offset,i=i.parent,r(h+y)},onLiteralValue:(h,y,R)=>{c({type:g(h),offset:y,length:R,parent:i,value:h}),r(y+R)},onSeparator:(h,y,R)=>{i.type==="property"&&(h===":"?i.colonOffset=y:h===","&&r(y))},onError:(h,y,R)=>{d.push({error:h,offset:y,length:R})}},s);const u=i.children[0];return u&&delete u.parent,u}e.parseTree=T;function E(n,d){if(!n)return;let s=n;for(const i of d)if(typeof i=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let r=!1;for(const c of s.children)if(Array.isArray(c.children)&&c.children[0].value===i){s=c.children[1],r=!0;break}if(!r)return}else{const r=i;if(s.type!=="array"||r<0||!Array.isArray(s.children)||r>=s.children.length)return;s=s.children[r]}return s}e.findNodeAtLocation=E;function p(n){if(!n.parent||!n.parent.children)return[];const d=p(n.parent);if(n.parent.type==="property"){const s=n.parent.children[0].value;d.push(s)}else if(n.parent.type==="array"){const s=n.parent.children.indexOf(n);s!==-1&&d.push(s)}return d}e.getNodePath=p;function w(n){switch(n.type){case"array":return n.children.map(w);case"object":{const d=Object.create(null);for(const s of n.children){const i=s.children[1];i&&(d[s.children[0].value]=w(i))}return d}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=w;function f(n,d,s=!1){return d>=n.offset&&d<n.offset+n.length||s&&d===n.offset+n.length}e.contains=f;function v(n,d,s=!1){if(f(n,d,s)){const i=n.children;if(Array.isArray(i))for(let r=0;r<i.length&&i[r].offset<=d;r++){const c=v(i[r],d,s);if(c)return c}return n}}e.findNodeAtOffset=v;function m(n,d,s=P.DEFAULT){const i=_(n,!1);function r(de){return de?()=>de(i.getTokenOffset(),i.getTokenLength()):()=>!0}function c(de){return de?ve=>de(ve,i.getTokenOffset(),i.getTokenLength()):()=>!0}const o=r(d.onObjectBegin),u=c(d.onObjectProperty),h=r(d.onObjectEnd),y=r(d.onArrayBegin),R=r(d.onArrayEnd),M=c(d.onLiteralValue),U=c(d.onSeparator),A=r(d.onComment),z=c(d.onError),$=s&&s.disallowComments,N=s&&s.allowTrailingComma;function K(){for(;;){const de=i.scan();switch(i.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:$||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(de){case 12:case 13:$?B(10):A();break;case 16:B(1);break;case 15:case 14:break;default:return de}}}function B(de,ve=[],ne=[]){if(z(de),ve.length+ne.length>0){let pe=i.getToken();for(;pe!==17;){if(ve.indexOf(pe)!==-1){K();break}else if(ne.indexOf(pe)!==-1)break;pe=K()}}}function O(de){const ve=i.getTokenValue();return de?M(ve):u(ve),K(),!0}function x(){switch(i.getToken()){case 11:{let de=0;try{de=JSON.parse(i.getTokenValue()),typeof de!="number"&&(B(2),de=0)}catch{B(2)}M(de);break}case 7:M(null);break;case 8:M(!0);break;case 9:M(!1);break;default:return!1}return K(),!0}function V(){return i.getToken()!==10?(B(3,[],[2,5]),!1):(O(!1),i.getToken()===6?(U(":"),K(),Q()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function q(){o(),K();let de=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(de||B(4,[],[]),U(","),K(),i.getToken()===2&&N)break}else de&&B(6,[],[]);V()||B(4,[],[2,5]),de=!0}return h(),i.getToken()!==2?B(7,[2],[]):K(),!0}function Y(){y(),K();let de=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(de||B(4,[],[]),U(","),K(),i.getToken()===4&&N)break}else de&&B(6,[],[]);Q()||B(4,[],[4,5]),de=!0}return R(),i.getToken()!==4?B(8,[4],[]):K(),!0}function Q(){switch(i.getToken()){case 3:return Y();case 1:return q();case 10:return O(!0);default:return x()}}return K(),i.getToken()===17?s.allowEmptyContent?!0:(B(4,[],[]),!1):Q()?(i.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}e.visit=m;function a(n,d){const s=_(n),i=[];let r,c=0,o;do switch(o=s.getPosition(),r=s.scan(),r){case 12:case 13:case 17:c!==o&&i.push(n.substring(c,o)),d!==void 0&&i.push(s.getTokenValue().replace(/[^\r\n]/g,d)),c=s.getPosition();break}while(r!==17);return i.join("")}e.stripComments=a;function g(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=g}),define(De[76],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class l{constructor(C){this.executor=C,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(C){this._error=C}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(C){return new l(()=>C(this.getValue()))}}e.Lazy=l}),define(De[6],Ie([1,0,59,60]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const C=!1;let P=null;function _(r){P=r}if(e.setDisposableTracker=_,C){const r="__is_disposable_tracked__";_(new class{trackDisposable(c){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{c[r]||console.log(o)},3e3)}setParent(c,o){if(c&&c!==v.None)try{c[r]=!0}catch{}}markAsDisposed(c){if(c&&c!==v.None)try{c[r]=!0}catch{}}markAsSingleton(c){}})}function D(r){return P?.trackDisposable(r),r}function b(r){P?.markAsDisposed(r)}function I(r,c){P?.setParent(r,c)}function L(r,c){if(!!P)for(const o of r)P.setParent(o,c)}function k(r){return P?.markAsSingleton(r),r}e.markAsSingleton=k;function S(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=S;function T(r){if(t.Iterable.is(r)){const c=[];for(const o of r)if(o)try{o.dispose()}catch(u){c.push(u)}if(c.length===1)throw c[0];if(c.length>1)throw new AggregateError(c,"Encountered errors while disposing of store");return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=T;function E(r){for(const c of r)S(c)&&c.dispose();return[]}e.disposeIfDisposable=E;function p(...r){const c=w(()=>T(r));return L(r,c),c}e.combinedDisposable=p;function w(r){const c=D({dispose:(0,l.once)(()=>{b(c),r()})});return c}e.toDisposable=w;class f{constructor(){this._toDispose=new Set,this._isDisposed=!1,D(this)}dispose(){this._isDisposed||(b(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{T(this._toDispose.values())}finally{this._toDispose.clear()}}add(c){if(!c)return c;if(c===this)throw new Error("Cannot register a disposable on itself!");return I(c,this),this._isDisposed?f.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(c),c}}e.DisposableStore=f,f.DISABLE_DISPOSED_WARNING=!1;class v{constructor(){this._store=new f,D(this),I(this._store,this)}dispose(){b(this),this._store.dispose()}_register(c){if(c===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(c)}}e.Disposable=v,v.None=Object.freeze({dispose(){}});class m{constructor(){this._isDisposed=!1,D(this)}get value(){return this._isDisposed?void 0:this._value}set value(c){this._isDisposed||c===this._value||(this._value?.dispose(),c&&I(c,this),this._value=c)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,b(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const c=this._value;return this._value=void 0,c&&I(c,null),c}}e.MutableDisposable=m;class a{constructor(c){this._disposable=c,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=a;class g{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,D(this)}set(c){let o=c;return this.unset=()=>o=void 0,this.isset=()=>o!==void 0,this.dispose=()=>{o&&(o(),o=void 0,b(this))},this}}e.SafeDisposable=g;class n{constructor(){this.references=new Map}acquire(c,...o){let u=this.references.get(c);u||(u={counter:0,object:this.createReferencedObject(c,...o)},this.references.set(c,u));const{object:h}=u,y=(0,l.once)(()=>{--u.counter===0&&(this.destroyReferencedObject(c,u.object),this.references.delete(c))});return u.counter++,{object:h,dispose:y}}}e.ReferenceCollection=n;class d{constructor(c){this.referenceCollection=c}async acquire(c,...o){const u=this.referenceCollection.acquire(c,...o);try{return{object:await u.object,dispose:()=>u.dispose()}}catch(h){throw u.dispose(),h}}}e.AsyncReferenceCollection=d;class s{constructor(c){this.object=c}dispose(){}}e.ImmortalReference=s;function i(r){const c=new f;try{r(c)}finally{c.dispose()}}e.disposeOnReturn=i}),define(De[77],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class l{constructor(P){this.element=P,this.next=l.Undefined,this.prev=l.Undefined}}l.Undefined=new l(void 0);class t{constructor(){this._first=l.Undefined,this._last=l.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===l.Undefined}clear(){let P=this._first;for(;P!==l.Undefined;){const _=P.next;P.prev=l.Undefined,P.next=l.Undefined,P=_}this._first=l.Undefined,this._last=l.Undefined,this._size=0}unshift(P){return this._insert(P,!1)}push(P){return this._insert(P,!0)}_insert(P,_){const D=new l(P);if(this._first===l.Undefined)this._first=D,this._last=D;else if(_){const I=this._last;this._last=D,D.prev=I,I.next=D}else{const I=this._first;this._first=D,D.next=I,I.prev=D}this._size+=1;let b=!1;return()=>{b||(b=!0,this._remove(D))}}shift(){if(this._first!==l.Undefined){const P=this._first.element;return this._remove(this._first),P}}pop(){if(this._last!==l.Undefined){const P=this._last.element;return this._remove(this._last),P}}_remove(P){if(P.prev!==l.Undefined&&P.next!==l.Undefined){const _=P.prev;_.next=P.next,P.next.prev=_}else P.prev===l.Undefined&&P.next===l.Undefined?(this._first=l.Undefined,this._last=l.Undefined):P.next===l.Undefined?(this._last=this._last.prev,this._last.next=l.Undefined):P.prev===l.Undefined&&(this._first=this._first.next,this._first.prev=l.Undefined);this._size-=1}*[Symbol.iterator](){let P=this._first;for(;P!==l.Undefined;)yield P.element,P=P.next}}e.LinkedList=t}),function(J,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(De[144],Ie([0]),e):(J=typeof globalThis<"u"?globalThis:J||self,e(J.marked={}))}(this,function(J){"use strict";function e(oe,le){for(var fe=0;fe<le.length;fe++){var Z=le[fe];Z.enumerable=Z.enumerable||!1,Z.configurable=!0,"value"in Z&&(Z.writable=!0),Object.defineProperty(oe,Z.key,Z)}}function l(oe,le,fe){return le&&e(oe.prototype,le),fe&&e(oe,fe),Object.defineProperty(oe,"prototype",{writable:!1}),oe}function t(oe,le){if(!!oe){if(typeof oe=="string")return C(oe,le);var fe=Object.prototype.toString.call(oe).slice(8,-1);if(fe==="Object"&&oe.constructor&&(fe=oe.constructor.name),fe==="Map"||fe==="Set")return Array.from(oe);if(fe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(fe))return C(oe,le)}}function C(oe,le){(le==null||le>oe.length)&&(le=oe.length);for(var fe=0,Z=new Array(le);fe<le;fe++)Z[fe]=oe[fe];return Z}function P(oe,le){var fe=typeof Symbol<"u"&&oe[Symbol.iterator]||oe["@@iterator"];if(fe)return(fe=fe.call(oe)).next.bind(fe);if(Array.isArray(oe)||(fe=t(oe))||le&&oe&&typeof oe.length=="number"){fe&&(oe=fe);var Z=0;return function(){return Z>=oe.length?{done:!0}:{done:!1,value:oe[Z++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function _(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}J.defaults=_();function D(oe){J.defaults=oe}var b=/[&<>"']/,I=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,S={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},T=function(le){return S[le]};function E(oe,le){if(le){if(b.test(oe))return oe.replace(I,T)}else if(L.test(oe))return oe.replace(k,T);return oe}var p=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function w(oe){return oe.replace(p,function(le,fe){return fe=fe.toLowerCase(),fe==="colon"?":":fe.charAt(0)==="#"?fe.charAt(1)==="x"?String.fromCharCode(parseInt(fe.substring(2),16)):String.fromCharCode(+fe.substring(1)):""})}var f=/(^|[^\[])\^/g;function v(oe,le){oe=typeof oe=="string"?oe:oe.source,le=le||"";var fe={replace:function(ae,ee){return ee=ee.source||ee,ee=ee.replace(f,"$1"),oe=oe.replace(ae,ee),fe},getRegex:function(){return new RegExp(oe,le)}};return fe}var m=/[^\w:]/g,a=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function g(oe,le,fe){if(oe){var Z;try{Z=decodeURIComponent(w(fe)).replace(m,"").toLowerCase()}catch{return null}if(Z.indexOf("javascript:")===0||Z.indexOf("vbscript:")===0||Z.indexOf("data:")===0)return null}le&&!a.test(fe)&&(fe=r(le,fe));try{fe=encodeURI(fe).replace(/%25/g,"%")}catch{return null}return fe}var n={},d=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(oe,le){n[" "+oe]||(d.test(oe)?n[" "+oe]=oe+"/":n[" "+oe]=h(oe,"/",!0)),oe=n[" "+oe];var fe=oe.indexOf(":")===-1;return le.substring(0,2)==="//"?fe?le:oe.replace(s,"$1")+le:le.charAt(0)==="/"?fe?le:oe.replace(i,"$1")+le:oe+le}var c={exec:function(){}};function o(oe){for(var le=1,fe,Z;le<arguments.length;le++){fe=arguments[le];for(Z in fe)Object.prototype.hasOwnProperty.call(fe,Z)&&(oe[Z]=fe[Z])}return oe}function u(oe,le){var fe=oe.replace(/\|/g,function(ee,ie,F){for(var H=!1,G=ie;--G>=0&&F[G]==="\\";)H=!H;return H?"|":" |"}),Z=fe.split(/ \|/),ae=0;if(Z[0].trim()||Z.shift(),Z.length>0&&!Z[Z.length-1].trim()&&Z.pop(),Z.length>le)Z.splice(le);else for(;Z.length<le;)Z.push("");for(;ae<Z.length;ae++)Z[ae]=Z[ae].trim().replace(/\\\|/g,"|");return Z}function h(oe,le,fe){var Z=oe.length;if(Z===0)return"";for(var ae=0;ae<Z;){var ee=oe.charAt(Z-ae-1);if(ee===le&&!fe)ae++;else if(ee!==le&&fe)ae++;else break}return oe.slice(0,Z-ae)}function y(oe,le){if(oe.indexOf(le[1])===-1)return-1;for(var fe=oe.length,Z=0,ae=0;ae<fe;ae++)if(oe[ae]==="\\")ae++;else if(oe[ae]===le[0])Z++;else if(oe[ae]===le[1]&&(Z--,Z<0))return ae;return-1}function R(oe){oe&&oe.sanitize&&!oe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function M(oe,le){if(le<1)return"";for(var fe="";le>1;)le&1&&(fe+=oe),le>>=1,oe+=oe;return fe+oe}function U(oe,le,fe,Z){var ae=le.href,ee=le.title?E(le.title):null,ie=oe[1].replace(/\\([\[\]])/g,"$1");if(oe[0].charAt(0)!=="!"){Z.state.inLink=!0;var F={type:"link",raw:fe,href:ae,title:ee,text:ie,tokens:Z.inlineTokens(ie)};return Z.state.inLink=!1,F}return{type:"image",raw:fe,href:ae,title:ee,text:E(ie)}}function A(oe,le){var fe=oe.match(/^(\s+)(?:```)/);if(fe===null)return le;var Z=fe[1];return le.split(`
`).map(function(ae){var ee=ae.match(/^\s+/);if(ee===null)return ae;var ie=ee[0];return ie.length>=Z.length?ae.slice(Z.length):ae}).join(`
`)}var z=function(){function oe(fe){this.options=fe||J.defaults}var le=oe.prototype;return le.space=function(Z){var ae=this.rules.block.newline.exec(Z);if(ae&&ae[0].length>0)return{type:"space",raw:ae[0]}},le.code=function(Z){var ae=this.rules.block.code.exec(Z);if(ae){var ee=ae[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ae[0],codeBlockStyle:"indented",text:this.options.pedantic?ee:h(ee,`
`)}}},le.fences=function(Z){var ae=this.rules.block.fences.exec(Z);if(ae){var ee=ae[0],ie=A(ee,ae[3]||"");return{type:"code",raw:ee,lang:ae[2]?ae[2].trim():ae[2],text:ie}}},le.heading=function(Z){var ae=this.rules.block.heading.exec(Z);if(ae){var ee=ae[2].trim();if(/#$/.test(ee)){var ie=h(ee,"#");(this.options.pedantic||!ie||/ $/.test(ie))&&(ee=ie.trim())}return{type:"heading",raw:ae[0],depth:ae[1].length,text:ee,tokens:this.lexer.inline(ee)}}},le.hr=function(Z){var ae=this.rules.block.hr.exec(Z);if(ae)return{type:"hr",raw:ae[0]}},le.blockquote=function(Z){var ae=this.rules.block.blockquote.exec(Z);if(ae){var ee=ae[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ae[0],tokens:this.lexer.blockTokens(ee,[]),text:ee}}},le.list=function(Z){var ae=this.rules.block.list.exec(Z);if(ae){var ee,ie,F,H,G,X,me,we,ce,Ce,ye,$e,Ve=ae[1].trim(),Ze=Ve.length>1,Qe={type:"list",raw:"",ordered:Ze,start:Ze?+Ve.slice(0,-1):"",loose:!1,items:[]};Ve=Ze?"\\d{1,9}\\"+Ve.slice(-1):"\\"+Ve,this.options.pedantic&&(Ve=Ze?Ve:"[*+-]");for(var Le=new RegExp("^( {0,3}"+Ve+")((?:[	 ][^\\n]*)?(?:\\n|$))");Z&&($e=!1,!(!(ae=Le.exec(Z))||this.rules.block.hr.test(Z)));){if(ee=ae[0],Z=Z.substring(ee.length),we=ae[2].split(`
`,1)[0],ce=Z.split(`
`,1)[0],this.options.pedantic?(H=2,ye=we.trimLeft()):(H=ae[2].search(/[^ ]/),H=H>4?1:H,ye=we.slice(H),H+=ae[1].length),X=!1,!we&&/^ *$/.test(ce)&&(ee+=ce+`
`,Z=Z.substring(ce.length+1),$e=!0),!$e)for(var ot=new RegExp("^ {0,"+Math.min(3,H-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),re=new RegExp("^ {0,"+Math.min(3,H-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),se=new RegExp("^ {0,"+Math.min(3,H-1)+"}(?:```|~~~)"),Ee=new RegExp("^ {0,"+Math.min(3,H-1)+"}#");Z&&(Ce=Z.split(`
`,1)[0],we=Ce,this.options.pedantic&&(we=we.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(se.test(we)||Ee.test(we)||ot.test(we)||re.test(Z)));){if(we.search(/[^ ]/)>=H||!we.trim())ye+=`
`+we.slice(H);else if(!X)ye+=`
`+we;else break;!X&&!we.trim()&&(X=!0),ee+=Ce+`
`,Z=Z.substring(Ce.length+1)}Qe.loose||(me?Qe.loose=!0:/\n *\n *$/.test(ee)&&(me=!0)),this.options.gfm&&(ie=/^\[[ xX]\] /.exec(ye),ie&&(F=ie[0]!=="[ ] ",ye=ye.replace(/^\[[ xX]\] +/,""))),Qe.items.push({type:"list_item",raw:ee,task:!!ie,checked:F,loose:!1,text:ye}),Qe.raw+=ee}Qe.items[Qe.items.length-1].raw=ee.trimRight(),Qe.items[Qe.items.length-1].text=ye.trimRight(),Qe.raw=Qe.raw.trimRight();var ue=Qe.items.length;for(G=0;G<ue;G++){this.lexer.state.top=!1,Qe.items[G].tokens=this.lexer.blockTokens(Qe.items[G].text,[]);var Te=Qe.items[G].tokens.filter(function(Be){return Be.type==="space"}),Me=Te.every(function(Be){for(var ze=Be.raw.split(""),Ye=0,it=P(ze),ct;!(ct=it()).done;){var st=ct.value;if(st===`
`&&(Ye+=1),Ye>1)return!0}return!1});!Qe.loose&&Te.length&&Me&&(Qe.loose=!0,Qe.items[G].loose=!0)}return Qe}},le.html=function(Z){var ae=this.rules.block.html.exec(Z);if(ae){var ee={type:"html",raw:ae[0],pre:!this.options.sanitizer&&(ae[1]==="pre"||ae[1]==="script"||ae[1]==="style"),text:ae[0]};if(this.options.sanitize){var ie=this.options.sanitizer?this.options.sanitizer(ae[0]):E(ae[0]);ee.type="paragraph",ee.text=ie,ee.tokens=this.lexer.inline(ie)}return ee}},le.def=function(Z){var ae=this.rules.block.def.exec(Z);if(ae){ae[3]&&(ae[3]=ae[3].substring(1,ae[3].length-1));var ee=ae[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ee,raw:ae[0],href:ae[2],title:ae[3]}}},le.table=function(Z){var ae=this.rules.block.table.exec(Z);if(ae){var ee={type:"table",header:u(ae[1]).map(function(me){return{text:me}}),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ae[3]&&ae[3].trim()?ae[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ee.header.length===ee.align.length){ee.raw=ae[0];var ie=ee.align.length,F,H,G,X;for(F=0;F<ie;F++)/^ *-+: *$/.test(ee.align[F])?ee.align[F]="right":/^ *:-+: *$/.test(ee.align[F])?ee.align[F]="center":/^ *:-+ *$/.test(ee.align[F])?ee.align[F]="left":ee.align[F]=null;for(ie=ee.rows.length,F=0;F<ie;F++)ee.rows[F]=u(ee.rows[F],ee.header.length).map(function(me){return{text:me}});for(ie=ee.header.length,H=0;H<ie;H++)ee.header[H].tokens=this.lexer.inline(ee.header[H].text);for(ie=ee.rows.length,H=0;H<ie;H++)for(X=ee.rows[H],G=0;G<X.length;G++)X[G].tokens=this.lexer.inline(X[G].text);return ee}}},le.lheading=function(Z){var ae=this.rules.block.lheading.exec(Z);if(ae)return{type:"heading",raw:ae[0],depth:ae[2].charAt(0)==="="?1:2,text:ae[1],tokens:this.lexer.inline(ae[1])}},le.paragraph=function(Z){var ae=this.rules.block.paragraph.exec(Z);if(ae){var ee=ae[1].charAt(ae[1].length-1)===`
`?ae[1].slice(0,-1):ae[1];return{type:"paragraph",raw:ae[0],text:ee,tokens:this.lexer.inline(ee)}}},le.text=function(Z){var ae=this.rules.block.text.exec(Z);if(ae)return{type:"text",raw:ae[0],text:ae[0],tokens:this.lexer.inline(ae[0])}},le.escape=function(Z){var ae=this.rules.inline.escape.exec(Z);if(ae)return{type:"escape",raw:ae[0],text:E(ae[1])}},le.tag=function(Z){var ae=this.rules.inline.tag.exec(Z);if(ae)return!this.lexer.state.inLink&&/^<a /i.test(ae[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ae[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ae[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ae[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ae[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ae[0]):E(ae[0]):ae[0]}},le.link=function(Z){var ae=this.rules.inline.link.exec(Z);if(ae){var ee=ae[2].trim();if(!this.options.pedantic&&/^</.test(ee)){if(!/>$/.test(ee))return;var ie=h(ee.slice(0,-1),"\\");if((ee.length-ie.length)%2===0)return}else{var F=y(ae[2],"()");if(F>-1){var H=ae[0].indexOf("!")===0?5:4,G=H+ae[1].length+F;ae[2]=ae[2].substring(0,F),ae[0]=ae[0].substring(0,G).trim(),ae[3]=""}}var X=ae[2],me="";if(this.options.pedantic){var we=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(X);we&&(X=we[1],me=we[3])}else me=ae[3]?ae[3].slice(1,-1):"";return X=X.trim(),/^</.test(X)&&(this.options.pedantic&&!/>$/.test(ee)?X=X.slice(1):X=X.slice(1,-1)),U(ae,{href:X&&X.replace(this.rules.inline._escapes,"$1"),title:me&&me.replace(this.rules.inline._escapes,"$1")},ae[0],this.lexer)}},le.reflink=function(Z,ae){var ee;if((ee=this.rules.inline.reflink.exec(Z))||(ee=this.rules.inline.nolink.exec(Z))){var ie=(ee[2]||ee[1]).replace(/\s+/g," ");if(ie=ae[ie.toLowerCase()],!ie||!ie.href){var F=ee[0].charAt(0);return{type:"text",raw:F,text:F}}return U(ee,ie,ee[0],this.lexer)}},le.emStrong=function(Z,ae,ee){ee===void 0&&(ee="");var ie=this.rules.inline.emStrong.lDelim.exec(Z);if(!!ie&&!(ie[3]&&ee.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var F=ie[1]||ie[2]||"";if(!F||F&&(ee===""||this.rules.inline.punctuation.exec(ee))){var H=ie[0].length-1,G,X,me=H,we=0,ce=ie[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ce.lastIndex=0,ae=ae.slice(-1*Z.length+H);(ie=ce.exec(ae))!=null;)if(G=ie[1]||ie[2]||ie[3]||ie[4]||ie[5]||ie[6],!!G){if(X=G.length,ie[3]||ie[4]){me+=X;continue}else if((ie[5]||ie[6])&&H%3&&!((H+X)%3)){we+=X;continue}if(me-=X,!(me>0)){if(X=Math.min(X,X+me+we),Math.min(H,X)%2){var Ce=Z.slice(1,H+ie.index+X);return{type:"em",raw:Z.slice(0,H+ie.index+X+1),text:Ce,tokens:this.lexer.inlineTokens(Ce)}}var ye=Z.slice(2,H+ie.index+X-1);return{type:"strong",raw:Z.slice(0,H+ie.index+X+1),text:ye,tokens:this.lexer.inlineTokens(ye)}}}}}},le.codespan=function(Z){var ae=this.rules.inline.code.exec(Z);if(ae){var ee=ae[2].replace(/\n/g," "),ie=/[^ ]/.test(ee),F=/^ /.test(ee)&&/ $/.test(ee);return ie&&F&&(ee=ee.substring(1,ee.length-1)),ee=E(ee,!0),{type:"codespan",raw:ae[0],text:ee}}},le.br=function(Z){var ae=this.rules.inline.br.exec(Z);if(ae)return{type:"br",raw:ae[0]}},le.del=function(Z){var ae=this.rules.inline.del.exec(Z);if(ae)return{type:"del",raw:ae[0],text:ae[2],tokens:this.lexer.inlineTokens(ae[2])}},le.autolink=function(Z,ae){var ee=this.rules.inline.autolink.exec(Z);if(ee){var ie,F;return ee[2]==="@"?(ie=E(this.options.mangle?ae(ee[1]):ee[1]),F="mailto:"+ie):(ie=E(ee[1]),F=ie),{type:"link",raw:ee[0],text:ie,href:F,tokens:[{type:"text",raw:ie,text:ie}]}}},le.url=function(Z,ae){var ee;if(ee=this.rules.inline.url.exec(Z)){var ie,F;if(ee[2]==="@")ie=E(this.options.mangle?ae(ee[0]):ee[0]),F="mailto:"+ie;else{var H;do H=ee[0],ee[0]=this.rules.inline._backpedal.exec(ee[0])[0];while(H!==ee[0]);ie=E(ee[0]),ee[1]==="www."?F="http://"+ie:F=ie}return{type:"link",raw:ee[0],text:ie,href:F,tokens:[{type:"text",raw:ie,text:ie}]}}},le.inlineText=function(Z,ae){var ee=this.rules.inline.text.exec(Z);if(ee){var ie;return this.lexer.state.inRawBlock?ie=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):E(ee[0]):ee[0]:ie=E(this.options.smartypants?ae(ee[0]):ee[0]),{type:"text",raw:ee[0],text:ie}}},oe}(),$={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:c,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};$._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,$._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,$.def=v($.def).replace("label",$._label).replace("title",$._title).getRegex(),$.bullet=/(?:[*+-]|\d{1,9}[.)])/,$.listItemStart=v(/^( *)(bull) */).replace("bull",$.bullet).getRegex(),$.list=v($.list).replace(/bull/g,$.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+$.def.source+")").getRegex(),$._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",$._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,$.html=v($.html,"i").replace("comment",$._comment).replace("tag",$._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),$.paragraph=v($._paragraph).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.blockquote=v($.blockquote).replace("paragraph",$.paragraph).getRegex(),$.normal=o({},$),$.gfm=o({},$.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),$.gfm.table=v($.gfm.table).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.gfm.paragraph=v($._paragraph).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",$.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.pedantic=o({},$.normal,{html:v(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",$._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:c,paragraph:v($.normal._paragraph).replace("hr",$.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",$.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var N={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:c,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:c,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};N._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",N.punctuation=v(N.punctuation).replace(/punctuation/g,N._punctuation).getRegex(),N.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,N.escapedEmSt=/\\\*|\\_/g,N._comment=v($._comment).replace("(?:-->|$)","-->").getRegex(),N.emStrong.lDelim=v(N.emStrong.lDelim).replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimAst=v(N.emStrong.rDelimAst,"g").replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimUnd=v(N.emStrong.rDelimUnd,"g").replace(/punct/g,N._punctuation).getRegex(),N._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,N._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,N._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,N.autolink=v(N.autolink).replace("scheme",N._scheme).replace("email",N._email).getRegex(),N._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,N.tag=v(N.tag).replace("comment",N._comment).replace("attribute",N._attribute).getRegex(),N._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,N._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,N._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,N.link=v(N.link).replace("label",N._label).replace("href",N._href).replace("title",N._title).getRegex(),N.reflink=v(N.reflink).replace("label",N._label).replace("ref",$._label).getRegex(),N.nolink=v(N.nolink).replace("ref",$._label).getRegex(),N.reflinkSearch=v(N.reflinkSearch,"g").replace("reflink",N.reflink).replace("nolink",N.nolink).getRegex(),N.normal=o({},N),N.pedantic=o({},N.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:v(/^!?\[(label)\]\((.*?)\)/).replace("label",N._label).getRegex(),reflink:v(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",N._label).getRegex()}),N.gfm=o({},N.normal,{escape:v(N.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),N.gfm.url=v(N.gfm.url,"i").replace("email",N.gfm._extended_email).getRegex(),N.breaks=o({},N.gfm,{br:v(N.br).replace("{2,}","*").getRegex(),text:v(N.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function K(oe){return oe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function B(oe){var le="",fe,Z,ae=oe.length;for(fe=0;fe<ae;fe++)Z=oe.charCodeAt(fe),Math.random()>.5&&(Z="x"+Z.toString(16)),le+="&#"+Z+";";return le}var O=function(){function oe(fe){this.tokens=[],this.tokens.links=Object.create(null),this.options=fe||J.defaults,this.options.tokenizer=this.options.tokenizer||new z,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Z={block:$.normal,inline:N.normal};this.options.pedantic?(Z.block=$.pedantic,Z.inline=N.pedantic):this.options.gfm&&(Z.block=$.gfm,this.options.breaks?Z.inline=N.breaks:Z.inline=N.gfm),this.tokenizer.rules=Z}oe.lex=function(Z,ae){var ee=new oe(ae);return ee.lex(Z)},oe.lexInline=function(Z,ae){var ee=new oe(ae);return ee.inlineTokens(Z)};var le=oe.prototype;return le.lex=function(Z){Z=Z.replace(/\r\n|\r/g,`
`),this.blockTokens(Z,this.tokens);for(var ae;ae=this.inlineQueue.shift();)this.inlineTokens(ae.src,ae.tokens);return this.tokens},le.blockTokens=function(Z,ae){var ee=this;ae===void 0&&(ae=[]),this.options.pedantic?Z=Z.replace(/\t/g,"    ").replace(/^ +$/gm,""):Z=Z.replace(/^( *)(\t+)/gm,function(me,we,ce){return we+"    ".repeat(ce.length)});for(var ie,F,H,G;Z;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(me){return(ie=me.call({lexer:ee},Z,ae))?(Z=Z.substring(ie.raw.length),ae.push(ie),!0):!1}))){if(ie=this.tokenizer.space(Z)){Z=Z.substring(ie.raw.length),ie.raw.length===1&&ae.length>0?ae[ae.length-1].raw+=`
`:ae.push(ie);continue}if(ie=this.tokenizer.code(Z)){Z=Z.substring(ie.raw.length),F=ae[ae.length-1],F&&(F.type==="paragraph"||F.type==="text")?(F.raw+=`
`+ie.raw,F.text+=`
`+ie.text,this.inlineQueue[this.inlineQueue.length-1].src=F.text):ae.push(ie);continue}if(ie=this.tokenizer.fences(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.heading(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.hr(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.blockquote(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.list(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.html(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.def(Z)){Z=Z.substring(ie.raw.length),F=ae[ae.length-1],F&&(F.type==="paragraph"||F.type==="text")?(F.raw+=`
`+ie.raw,F.text+=`
`+ie.raw,this.inlineQueue[this.inlineQueue.length-1].src=F.text):this.tokens.links[ie.tag]||(this.tokens.links[ie.tag]={href:ie.href,title:ie.title});continue}if(ie=this.tokenizer.table(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.lheading(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(H=Z,this.options.extensions&&this.options.extensions.startBlock&&function(){var me=1/0,we=Z.slice(1),ce=void 0;ee.options.extensions.startBlock.forEach(function(Ce){ce=Ce.call({lexer:this},we),typeof ce=="number"&&ce>=0&&(me=Math.min(me,ce))}),me<1/0&&me>=0&&(H=Z.substring(0,me+1))}(),this.state.top&&(ie=this.tokenizer.paragraph(H))){F=ae[ae.length-1],G&&F.type==="paragraph"?(F.raw+=`
`+ie.raw,F.text+=`
`+ie.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=F.text):ae.push(ie),G=H.length!==Z.length,Z=Z.substring(ie.raw.length);continue}if(ie=this.tokenizer.text(Z)){Z=Z.substring(ie.raw.length),F=ae[ae.length-1],F&&F.type==="text"?(F.raw+=`
`+ie.raw,F.text+=`
`+ie.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=F.text):ae.push(ie);continue}if(Z){var X="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(X);break}else throw new Error(X)}}return this.state.top=!0,ae},le.inline=function(Z,ae){return ae===void 0&&(ae=[]),this.inlineQueue.push({src:Z,tokens:ae}),ae},le.inlineTokens=function(Z,ae){var ee=this;ae===void 0&&(ae=[]);var ie,F,H,G=Z,X,me,we;if(this.tokens.links){var ce=Object.keys(this.tokens.links);if(ce.length>0)for(;(X=this.tokenizer.rules.inline.reflinkSearch.exec(G))!=null;)ce.includes(X[0].slice(X[0].lastIndexOf("[")+1,-1))&&(G=G.slice(0,X.index)+"["+M("a",X[0].length-2)+"]"+G.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(X=this.tokenizer.rules.inline.blockSkip.exec(G))!=null;)G=G.slice(0,X.index)+"["+M("a",X[0].length-2)+"]"+G.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(X=this.tokenizer.rules.inline.escapedEmSt.exec(G))!=null;)G=G.slice(0,X.index)+"++"+G.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Z;)if(me||(we=""),me=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ye){return(ie=ye.call({lexer:ee},Z,ae))?(Z=Z.substring(ie.raw.length),ae.push(ie),!0):!1}))){if(ie=this.tokenizer.escape(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.tag(Z)){Z=Z.substring(ie.raw.length),F=ae[ae.length-1],F&&ie.type==="text"&&F.type==="text"?(F.raw+=ie.raw,F.text+=ie.text):ae.push(ie);continue}if(ie=this.tokenizer.link(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.reflink(Z,this.tokens.links)){Z=Z.substring(ie.raw.length),F=ae[ae.length-1],F&&ie.type==="text"&&F.type==="text"?(F.raw+=ie.raw,F.text+=ie.text):ae.push(ie);continue}if(ie=this.tokenizer.emStrong(Z,G,we)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.codespan(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.br(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.del(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.autolink(Z,B)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(!this.state.inLink&&(ie=this.tokenizer.url(Z,B))){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(H=Z,this.options.extensions&&this.options.extensions.startInline&&function(){var ye=1/0,$e=Z.slice(1),Ve=void 0;ee.options.extensions.startInline.forEach(function(Ze){Ve=Ze.call({lexer:this},$e),typeof Ve=="number"&&Ve>=0&&(ye=Math.min(ye,Ve))}),ye<1/0&&ye>=0&&(H=Z.substring(0,ye+1))}(),ie=this.tokenizer.inlineText(H,K)){Z=Z.substring(ie.raw.length),ie.raw.slice(-1)!=="_"&&(we=ie.raw.slice(-1)),me=!0,F=ae[ae.length-1],F&&F.type==="text"?(F.raw+=ie.raw,F.text+=ie.text):ae.push(ie);continue}if(Z){var Ce="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(Ce);break}else throw new Error(Ce)}}return ae},l(oe,null,[{key:"rules",get:function(){return{block:$,inline:N}}}]),oe}(),x=function(){function oe(fe){this.options=fe||J.defaults}var le=oe.prototype;return le.code=function(Z,ae,ee){var ie=(ae||"").match(/\S*/)[0];if(this.options.highlight){var F=this.options.highlight(Z,ie);F!=null&&F!==Z&&(ee=!0,Z=F)}return Z=Z.replace(/\n$/,"")+`
`,ie?'<pre><code class="'+this.options.langPrefix+E(ie,!0)+'">'+(ee?Z:E(Z,!0))+`</code></pre>
`:"<pre><code>"+(ee?Z:E(Z,!0))+`</code></pre>
`},le.blockquote=function(Z){return`<blockquote>
`+Z+`</blockquote>
`},le.html=function(Z){return Z},le.heading=function(Z,ae,ee,ie){if(this.options.headerIds){var F=this.options.headerPrefix+ie.slug(ee);return"<h"+ae+' id="'+F+'">'+Z+"</h"+ae+`>
`}return"<h"+ae+">"+Z+"</h"+ae+`>
`},le.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},le.list=function(Z,ae,ee){var ie=ae?"ol":"ul",F=ae&&ee!==1?' start="'+ee+'"':"";return"<"+ie+F+`>
`+Z+"</"+ie+`>
`},le.listitem=function(Z){return"<li>"+Z+`</li>
`},le.checkbox=function(Z){return"<input "+(Z?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},le.paragraph=function(Z){return"<p>"+Z+`</p>
`},le.table=function(Z,ae){return ae&&(ae="<tbody>"+ae+"</tbody>"),`<table>
<thead>
`+Z+`</thead>
`+ae+`</table>
`},le.tablerow=function(Z){return`<tr>
`+Z+`</tr>
`},le.tablecell=function(Z,ae){var ee=ae.header?"th":"td",ie=ae.align?"<"+ee+' align="'+ae.align+'">':"<"+ee+">";return ie+Z+("</"+ee+`>
`)},le.strong=function(Z){return"<strong>"+Z+"</strong>"},le.em=function(Z){return"<em>"+Z+"</em>"},le.codespan=function(Z){return"<code>"+Z+"</code>"},le.br=function(){return this.options.xhtml?"<br/>":"<br>"},le.del=function(Z){return"<del>"+Z+"</del>"},le.link=function(Z,ae,ee){if(Z=g(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ee;var ie='<a href="'+E(Z)+'"';return ae&&(ie+=' title="'+ae+'"'),ie+=">"+ee+"</a>",ie},le.image=function(Z,ae,ee){if(Z=g(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ee;var ie='<img src="'+Z+'" alt="'+ee+'"';return ae&&(ie+=' title="'+ae+'"'),ie+=this.options.xhtml?"/>":">",ie},le.text=function(Z){return Z},oe}(),V=function(){function oe(){}var le=oe.prototype;return le.strong=function(Z){return Z},le.em=function(Z){return Z},le.codespan=function(Z){return Z},le.del=function(Z){return Z},le.html=function(Z){return Z},le.text=function(Z){return Z},le.link=function(Z,ae,ee){return""+ee},le.image=function(Z,ae,ee){return""+ee},le.br=function(){return""},oe}(),q=function(){function oe(){this.seen={}}var le=oe.prototype;return le.serialize=function(Z){return Z.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},le.getNextSafeSlug=function(Z,ae){var ee=Z,ie=0;if(this.seen.hasOwnProperty(ee)){ie=this.seen[Z];do ie++,ee=Z+"-"+ie;while(this.seen.hasOwnProperty(ee))}return ae||(this.seen[Z]=ie,this.seen[ee]=0),ee},le.slug=function(Z,ae){ae===void 0&&(ae={});var ee=this.serialize(Z);return this.getNextSafeSlug(ee,ae.dryrun)},oe}(),Y=function(){function oe(fe){this.options=fe||J.defaults,this.options.renderer=this.options.renderer||new x,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new V,this.slugger=new q}oe.parse=function(Z,ae){var ee=new oe(ae);return ee.parse(Z)},oe.parseInline=function(Z,ae){var ee=new oe(ae);return ee.parseInline(Z)};var le=oe.prototype;return le.parse=function(Z,ae){ae===void 0&&(ae=!0);var ee="",ie,F,H,G,X,me,we,ce,Ce,ye,$e,Ve,Ze,Qe,Le,ot,re,se,Ee,ue=Z.length;for(ie=0;ie<ue;ie++){if(ye=Z[ie],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ye.type]&&(Ee=this.options.extensions.renderers[ye.type].call({parser:this},ye),Ee!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ye.type))){ee+=Ee||"";continue}switch(ye.type){case"space":continue;case"hr":{ee+=this.renderer.hr();continue}case"heading":{ee+=this.renderer.heading(this.parseInline(ye.tokens),ye.depth,w(this.parseInline(ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{ee+=this.renderer.code(ye.text,ye.lang,ye.escaped);continue}case"table":{for(ce="",we="",G=ye.header.length,F=0;F<G;F++)we+=this.renderer.tablecell(this.parseInline(ye.header[F].tokens),{header:!0,align:ye.align[F]});for(ce+=this.renderer.tablerow(we),Ce="",G=ye.rows.length,F=0;F<G;F++){for(me=ye.rows[F],we="",X=me.length,H=0;H<X;H++)we+=this.renderer.tablecell(this.parseInline(me[H].tokens),{header:!1,align:ye.align[H]});Ce+=this.renderer.tablerow(we)}ee+=this.renderer.table(ce,Ce);continue}case"blockquote":{Ce=this.parse(ye.tokens),ee+=this.renderer.blockquote(Ce);continue}case"list":{for($e=ye.ordered,Ve=ye.start,Ze=ye.loose,G=ye.items.length,Ce="",F=0;F<G;F++)Le=ye.items[F],ot=Le.checked,re=Le.task,Qe="",Le.task&&(se=this.renderer.checkbox(ot),Ze?Le.tokens.length>0&&Le.tokens[0].type==="paragraph"?(Le.tokens[0].text=se+" "+Le.tokens[0].text,Le.tokens[0].tokens&&Le.tokens[0].tokens.length>0&&Le.tokens[0].tokens[0].type==="text"&&(Le.tokens[0].tokens[0].text=se+" "+Le.tokens[0].tokens[0].text)):Le.tokens.unshift({type:"text",text:se}):Qe+=se),Qe+=this.parse(Le.tokens,Ze),Ce+=this.renderer.listitem(Qe,re,ot);ee+=this.renderer.list(Ce,$e,Ve);continue}case"html":{ee+=this.renderer.html(ye.text);continue}case"paragraph":{ee+=this.renderer.paragraph(this.parseInline(ye.tokens));continue}case"text":{for(Ce=ye.tokens?this.parseInline(ye.tokens):ye.text;ie+1<ue&&Z[ie+1].type==="text";)ye=Z[++ie],Ce+=`
`+(ye.tokens?this.parseInline(ye.tokens):ye.text);ee+=ae?this.renderer.paragraph(Ce):Ce;continue}default:{var Te='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(Te);return}else throw new Error(Te)}}}return ee},le.parseInline=function(Z,ae){ae=ae||this.renderer;var ee="",ie,F,H,G=Z.length;for(ie=0;ie<G;ie++){if(F=Z[ie],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[F.type]&&(H=this.options.extensions.renderers[F.type].call({parser:this},F),H!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(F.type))){ee+=H||"";continue}switch(F.type){case"escape":{ee+=ae.text(F.text);break}case"html":{ee+=ae.html(F.text);break}case"link":{ee+=ae.link(F.href,F.title,this.parseInline(F.tokens,ae));break}case"image":{ee+=ae.image(F.href,F.title,F.text);break}case"strong":{ee+=ae.strong(this.parseInline(F.tokens,ae));break}case"em":{ee+=ae.em(this.parseInline(F.tokens,ae));break}case"codespan":{ee+=ae.codespan(F.text);break}case"br":{ee+=ae.br();break}case"del":{ee+=ae.del(this.parseInline(F.tokens,ae));break}case"text":{ee+=ae.text(F.text);break}default:{var X='Token with "'+F.type+'" type was not found.';if(this.options.silent){console.error(X);return}else throw new Error(X)}}}return ee},oe}();function Q(oe,le,fe){if(typeof oe>"u"||oe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof oe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(oe)+", string expected");if(typeof le=="function"&&(fe=le,le=null),le=o({},Q.defaults,le||{}),R(le),fe){var Z=le.highlight,ae;try{ae=O.lex(oe,le)}catch(G){return fe(G)}var ee=function(X){var me;if(!X)try{le.walkTokens&&Q.walkTokens(ae,le.walkTokens),me=Y.parse(ae,le)}catch(we){X=we}return le.highlight=Z,X?fe(X):fe(null,me)};if(!Z||Z.length<3||(delete le.highlight,!ae.length))return ee();var ie=0;Q.walkTokens(ae,function(G){G.type==="code"&&(ie++,setTimeout(function(){Z(G.text,G.lang,function(X,me){if(X)return ee(X);me!=null&&me!==G.text&&(G.text=me,G.escaped=!0),ie--,ie===0&&ee()})},0))}),ie===0&&ee();return}function F(G){if(G.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+E(G.message+"",!0)+"</pre>";throw G}try{var H=O.lex(oe,le);if(le.walkTokens){if(le.async)return Promise.all(Q.walkTokens(H,le.walkTokens)).then(function(){return Y.parse(H,le)}).catch(F);Q.walkTokens(H,le.walkTokens)}return Y.parse(H,le)}catch(G){F(G)}}Q.options=Q.setOptions=function(oe){return o(Q.defaults,oe),D(Q.defaults),Q},Q.getDefaults=_,Q.defaults=J.defaults,Q.use=function(){for(var oe=arguments.length,le=new Array(oe),fe=0;fe<oe;fe++)le[fe]=arguments[fe];var Z=o.apply(void 0,[{}].concat(le)),ae=Q.defaults.extensions||{renderers:{},childTokens:{}},ee;le.forEach(function(ie){if(ie.extensions&&(ee=!0,ie.extensions.forEach(function(H){if(!H.name)throw new Error("extension name required");if(H.renderer){var G=ae.renderers?ae.renderers[H.name]:null;G?ae.renderers[H.name]=function(){for(var X=arguments.length,me=new Array(X),we=0;we<X;we++)me[we]=arguments[we];var ce=H.renderer.apply(this,me);return ce===!1&&(ce=G.apply(this,me)),ce}:ae.renderers[H.name]=H.renderer}if(H.tokenizer){if(!H.level||H.level!=="block"&&H.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ae[H.level]?ae[H.level].unshift(H.tokenizer):ae[H.level]=[H.tokenizer],H.start&&(H.level==="block"?ae.startBlock?ae.startBlock.push(H.start):ae.startBlock=[H.start]:H.level==="inline"&&(ae.startInline?ae.startInline.push(H.start):ae.startInline=[H.start]))}H.childTokens&&(ae.childTokens[H.name]=H.childTokens)})),ie.renderer&&function(){var H=Q.defaults.renderer||new x,G=function(we){var ce=H[we];H[we]=function(){for(var Ce=arguments.length,ye=new Array(Ce),$e=0;$e<Ce;$e++)ye[$e]=arguments[$e];var Ve=ie.renderer[we].apply(H,ye);return Ve===!1&&(Ve=ce.apply(H,ye)),Ve}};for(var X in ie.renderer)G(X);Z.renderer=H}(),ie.tokenizer&&function(){var H=Q.defaults.tokenizer||new z,G=function(we){var ce=H[we];H[we]=function(){for(var Ce=arguments.length,ye=new Array(Ce),$e=0;$e<Ce;$e++)ye[$e]=arguments[$e];var Ve=ie.tokenizer[we].apply(H,ye);return Ve===!1&&(Ve=ce.apply(H,ye)),Ve}};for(var X in ie.tokenizer)G(X);Z.tokenizer=H}(),ie.walkTokens){var F=Q.defaults.walkTokens;Z.walkTokens=function(H){var G=[];return G.push(ie.walkTokens.call(this,H)),F&&(G=G.concat(F.call(this,H))),G}}ee&&(Z.extensions=ae),Q.setOptions(Z)})},Q.walkTokens=function(oe,le){for(var fe=[],Z=function(){var F=ee.value;switch(fe=fe.concat(le.call(Q,F)),F.type){case"table":{for(var H=P(F.header),G;!(G=H()).done;){var X=G.value;fe=fe.concat(Q.walkTokens(X.tokens,le))}for(var me=P(F.rows),we;!(we=me()).done;)for(var ce=we.value,Ce=P(ce),ye;!(ye=Ce()).done;){var $e=ye.value;fe=fe.concat(Q.walkTokens($e.tokens,le))}break}case"list":{fe=fe.concat(Q.walkTokens(F.items,le));break}default:Q.defaults.extensions&&Q.defaults.extensions.childTokens&&Q.defaults.extensions.childTokens[F.type]?Q.defaults.extensions.childTokens[F.type].forEach(function(Ve){fe=fe.concat(Q.walkTokens(F[Ve],le))}):F.tokens&&(fe=fe.concat(Q.walkTokens(F.tokens,le)))}},ae=P(oe),ee;!(ee=ae()).done;)Z();return fe},Q.parseInline=function(oe,le){if(typeof oe>"u"||oe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof oe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(oe)+", string expected");le=o({},Q.defaults,le||{}),R(le);try{var fe=O.lexInline(oe,le);return le.walkTokens&&Q.walkTokens(fe,le.walkTokens),Y.parseInline(fe,le)}catch(Z){if(Z.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+E(Z.message+"",!0)+"</pre>";throw Z}},Q.Parser=Y,Q.parser=Y.parse,Q.Renderer=x,Q.TextRenderer=V,Q.Lexer=O,Q.lexer=O.lex,Q.Tokenizer=z,Q.Slugger=q,Q.parse=Q;var de=Q.options,ve=Q.setOptions,ne=Q.use,pe=Q.walkTokens,be=Q.parseInline,ke=Q,Oe=Y.parse,We=O.lex;J.Lexer=O,J.Parser=Y,J.Renderer=x,J.Slugger=q,J.TextRenderer=V,J.Tokenizer=z,J.getDefaults=_,J.lexer=We,J.marked=Q,J.options=de,J.parse=ke,J.parseInline=be,J.parser=Oe,J.setOptions=ve,J.use=ne,J.walkTokens=pe,Object.defineProperty(J,"__esModule",{value:!0})}),define(De[95],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function l(D,b,I){return Math.min(Math.max(D,b),I)}e.clamp=l;function t(D,b){return(b+D%b)%b}e.rot=t;class C{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=C;class P{constructor(){this._n=1,this._val=0}update(b){return this._val=this._val+(b-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=P;class _{constructor(b){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(b),this._values.fill(0,0,b)}update(b){const I=this._values[this._index];return this._values[this._index]=b,this._index=(this._index+1)%this._values.length,this._sum-=I,this._sum+=b,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=_}),function(){function J(C){const P=[];typeof C=="number"&&P.push("code/timeOrigin",C);function _(b){P.push(b,Date.now())}function D(){const b=[];for(let I=0;I<P.length;I+=2)b.push({name:P[I],startTime:P[I+1]});return b}return{mark:_,getMarks:D}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const _ of performance.getEntriesByType("mark"))P.push({name:_.name,startTime:Math.round(C+_.startTime)});return P}};if(typeof process=="object"){const C=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function l(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return l(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=l(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=l(t))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var l=e();for(var t in l)(typeof exports=="object"?exports:J)[t]=l[t]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function l(t){if(e[t])return e[t].exports;var C=e[t]={i:t,l:!1,exports:{}};return J[t].call(C.exports,C,C.exports,l),C.l=!0,C.exports}return l.m=J,l.c=e,l.d=function(t,C,P){l.o(t,C)||Object.defineProperty(t,C,{enumerable:!0,get:P})},l.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},l.t=function(t,C){if(1&C&&(t=l(t)),8&C||4&C&&typeof t=="object"&&t&&t.__esModule)return t;var P=Object.create(null);if(l.r(P),Object.defineProperty(P,"default",{enumerable:!0,value:t}),2&C&&typeof t!="string")for(var _ in t)l.d(P,_,function(D){return t[D]}.bind(null,_));return P},l.n=function(t){var C=t&&t.__esModule?function(){return t.default}:function(){return t};return l.d(C,"a",C),C},l.o=function(t,C){return Object.prototype.hasOwnProperty.call(t,C)},l.p="",l(l.s=0)}([function(J,e,l){(function(t){var C;e=J.exports=ne,C=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var ce=Array.prototype.slice.call(arguments,0);ce.unshift("SEMVER"),console.log.apply(console,ce)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var P=256,_=Number.MAX_SAFE_INTEGER||9007199254740991,D=e.re=[],b=e.src=[],I=0,L=I++;b[L]="0|[1-9]\\d*";var k=I++;b[k]="[0-9]+";var S=I++;b[S]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var T=I++;b[T]="("+b[L]+")\\.("+b[L]+")\\.("+b[L]+")";var E=I++;b[E]="("+b[k]+")\\.("+b[k]+")\\.("+b[k]+")";var p=I++;b[p]="(?:"+b[L]+"|"+b[S]+")";var w=I++;b[w]="(?:"+b[k]+"|"+b[S]+")";var f=I++;b[f]="(?:-("+b[p]+"(?:\\."+b[p]+")*))";var v=I++;b[v]="(?:-?("+b[w]+"(?:\\."+b[w]+")*))";var m=I++;b[m]="[0-9A-Za-z-]+";var a=I++;b[a]="(?:\\+("+b[m]+"(?:\\."+b[m]+")*))";var g=I++,n="v?"+b[T]+b[f]+"?"+b[a]+"?";b[g]="^"+n+"$";var d="[v=\\s]*"+b[E]+b[v]+"?"+b[a]+"?",s=I++;b[s]="^"+d+"$";var i=I++;b[i]="((?:<|>)?=?)";var r=I++;b[r]=b[k]+"|x|X|\\*";var c=I++;b[c]=b[L]+"|x|X|\\*";var o=I++;b[o]="[v=\\s]*("+b[c]+")(?:\\.("+b[c]+")(?:\\.("+b[c]+")(?:"+b[f]+")?"+b[a]+"?)?)?";var u=I++;b[u]="[v=\\s]*("+b[r]+")(?:\\.("+b[r]+")(?:\\.("+b[r]+")(?:"+b[v]+")?"+b[a]+"?)?)?";var h=I++;b[h]="^"+b[i]+"\\s*"+b[o]+"$";var y=I++;b[y]="^"+b[i]+"\\s*"+b[u]+"$";var R=I++;b[R]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var M=I++;b[M]="(?:~>?)";var U=I++;b[U]="(\\s*)"+b[M]+"\\s+",D[U]=new RegExp(b[U],"g");var A=I++;b[A]="^"+b[M]+b[o]+"$";var z=I++;b[z]="^"+b[M]+b[u]+"$";var $=I++;b[$]="(?:\\^)";var N=I++;b[N]="(\\s*)"+b[$]+"\\s+",D[N]=new RegExp(b[N],"g");var K=I++;b[K]="^"+b[$]+b[o]+"$";var B=I++;b[B]="^"+b[$]+b[u]+"$";var O=I++;b[O]="^"+b[i]+"\\s*("+d+")$|^$";var x=I++;b[x]="^"+b[i]+"\\s*("+n+")$|^$";var V=I++;b[V]="(\\s*)"+b[i]+"\\s*("+d+"|"+b[o]+")",D[V]=new RegExp(b[V],"g");var q=I++;b[q]="^\\s*("+b[o]+")\\s+-\\s+("+b[o]+")\\s*$";var Y=I++;b[Y]="^\\s*("+b[u]+")\\s+-\\s+("+b[u]+")\\s*$";var Q=I++;b[Q]="(<|>)?=?\\s*\\*";for(var de=0;de<35;de++)C(de,b[de]),D[de]||(D[de]=new RegExp(b[de]));function ve(ce,Ce){if(ce instanceof ne)return ce;if(typeof ce!="string"||ce.length>P||!(Ce?D[s]:D[g]).test(ce))return null;try{return new ne(ce,Ce)}catch{return null}}function ne(ce,Ce){if(ce instanceof ne){if(ce.loose===Ce)return ce;ce=ce.version}else if(typeof ce!="string")throw new TypeError("Invalid Version: "+ce);if(ce.length>P)throw new TypeError("version is longer than "+P+" characters");if(!(this instanceof ne))return new ne(ce,Ce);C("SemVer",ce,Ce),this.loose=Ce;var ye=ce.trim().match(Ce?D[s]:D[g]);if(!ye)throw new TypeError("Invalid Version: "+ce);if(this.raw=ce,this.major=+ye[1],this.minor=+ye[2],this.patch=+ye[3],this.major>_||this.major<0)throw new TypeError("Invalid major version");if(this.minor>_||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>_||this.patch<0)throw new TypeError("Invalid patch version");ye[4]?this.prerelease=ye[4].split(".").map(function($e){if(/^[0-9]+$/.test($e)){var Ve=+$e;if(Ve>=0&&Ve<_)return Ve}return $e}):this.prerelease=[],this.build=ye[5]?ye[5].split("."):[],this.format()}e.parse=ve,e.valid=function(ce,Ce){var ye=ve(ce,Ce);return ye?ye.version:null},e.clean=function(ce,Ce){var ye=ve(ce.trim().replace(/^[=v]+/,""),Ce);return ye?ye.version:null},e.SemVer=ne,ne.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ne.prototype.toString=function(){return this.version},ne.prototype.compare=function(ce){return C("SemVer.compare",this.version,this.loose,ce),ce instanceof ne||(ce=new ne(ce,this.loose)),this.compareMain(ce)||this.comparePre(ce)},ne.prototype.compareMain=function(ce){return ce instanceof ne||(ce=new ne(ce,this.loose)),be(this.major,ce.major)||be(this.minor,ce.minor)||be(this.patch,ce.patch)},ne.prototype.comparePre=function(ce){if(ce instanceof ne||(ce=new ne(ce,this.loose)),this.prerelease.length&&!ce.prerelease.length)return-1;if(!this.prerelease.length&&ce.prerelease.length)return 1;if(!this.prerelease.length&&!ce.prerelease.length)return 0;var Ce=0;do{var ye=this.prerelease[Ce],$e=ce.prerelease[Ce];if(C("prerelease compare",Ce,ye,$e),ye===void 0&&$e===void 0)return 0;if($e===void 0)return 1;if(ye===void 0)return-1;if(ye!==$e)return be(ye,$e)}while(++Ce)},ne.prototype.inc=function(ce,Ce){switch(ce){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Ce);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Ce);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Ce),this.inc("pre",Ce);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Ce),this.inc("pre",Ce);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ye=this.prerelease.length;--ye>=0;)typeof this.prerelease[ye]=="number"&&(this.prerelease[ye]++,ye=-2);ye===-1&&this.prerelease.push(0)}Ce&&(this.prerelease[0]===Ce?isNaN(this.prerelease[1])&&(this.prerelease=[Ce,0]):this.prerelease=[Ce,0]);break;default:throw new Error("invalid increment argument: "+ce)}return this.format(),this.raw=this.version,this},e.inc=function(ce,Ce,ye,$e){typeof ye=="string"&&($e=ye,ye=void 0);try{return new ne(ce,ye).inc(Ce,$e).version}catch{return null}},e.diff=function(ce,Ce){if(oe(ce,Ce))return null;var ye=ve(ce),$e=ve(Ce);if(ye.prerelease.length||$e.prerelease.length){for(var Ve in ye)if((Ve==="major"||Ve==="minor"||Ve==="patch")&&ye[Ve]!==$e[Ve])return"pre"+Ve;return"prerelease"}for(var Ve in ye)if((Ve==="major"||Ve==="minor"||Ve==="patch")&&ye[Ve]!==$e[Ve])return Ve},e.compareIdentifiers=be;var pe=/^[0-9]+$/;function be(ce,Ce){var ye=pe.test(ce),$e=pe.test(Ce);return ye&&$e&&(ce=+ce,Ce=+Ce),ye&&!$e?-1:$e&&!ye?1:ce<Ce?-1:ce>Ce?1:0}function ke(ce,Ce,ye){return new ne(ce,ye).compare(new ne(Ce,ye))}function Oe(ce,Ce,ye){return ke(ce,Ce,ye)>0}function We(ce,Ce,ye){return ke(ce,Ce,ye)<0}function oe(ce,Ce,ye){return ke(ce,Ce,ye)===0}function le(ce,Ce,ye){return ke(ce,Ce,ye)!==0}function fe(ce,Ce,ye){return ke(ce,Ce,ye)>=0}function Z(ce,Ce,ye){return ke(ce,Ce,ye)<=0}function ae(ce,Ce,ye,$e){var Ve;switch(Ce){case"===":typeof ce=="object"&&(ce=ce.version),typeof ye=="object"&&(ye=ye.version),Ve=ce===ye;break;case"!==":typeof ce=="object"&&(ce=ce.version),typeof ye=="object"&&(ye=ye.version),Ve=ce!==ye;break;case"":case"=":case"==":Ve=oe(ce,ye,$e);break;case"!=":Ve=le(ce,ye,$e);break;case">":Ve=Oe(ce,ye,$e);break;case">=":Ve=fe(ce,ye,$e);break;case"<":Ve=We(ce,ye,$e);break;case"<=":Ve=Z(ce,ye,$e);break;default:throw new TypeError("Invalid operator: "+Ce)}return Ve}function ee(ce,Ce){if(ce instanceof ee){if(ce.loose===Ce)return ce;ce=ce.value}if(!(this instanceof ee))return new ee(ce,Ce);C("comparator",ce,Ce),this.loose=Ce,this.parse(ce),this.semver===ie?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(ce,Ce){return be(Ce,ce)},e.major=function(ce,Ce){return new ne(ce,Ce).major},e.minor=function(ce,Ce){return new ne(ce,Ce).minor},e.patch=function(ce,Ce){return new ne(ce,Ce).patch},e.compare=ke,e.compareLoose=function(ce,Ce){return ke(ce,Ce,!0)},e.rcompare=function(ce,Ce,ye){return ke(Ce,ce,ye)},e.sort=function(ce,Ce){return ce.sort(function(ye,$e){return e.compare(ye,$e,Ce)})},e.rsort=function(ce,Ce){return ce.sort(function(ye,$e){return e.rcompare(ye,$e,Ce)})},e.gt=Oe,e.lt=We,e.eq=oe,e.neq=le,e.gte=fe,e.lte=Z,e.cmp=ae,e.Comparator=ee;var ie={};function F(ce,Ce){if(ce instanceof F)return ce.loose===Ce?ce:new F(ce.raw,Ce);if(ce instanceof ee)return new F(ce.value,Ce);if(!(this instanceof F))return new F(ce,Ce);if(this.loose=Ce,this.raw=ce,this.set=ce.split(/\s*\|\|\s*/).map(function(ye){return this.parseRange(ye.trim())},this).filter(function(ye){return ye.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ce);this.format()}function H(ce){return!ce||ce.toLowerCase()==="x"||ce==="*"}function G(ce,Ce,ye,$e,Ve,Ze,Qe,Le,ot,re,se,Ee,ue){return((Ce=H(ye)?"":H($e)?">="+ye+".0.0":H(Ve)?">="+ye+"."+$e+".0":">="+Ce)+" "+(Le=H(ot)?"":H(re)?"<"+(+ot+1)+".0.0":H(se)?"<"+ot+"."+(+re+1)+".0":Ee?"<="+ot+"."+re+"."+se+"-"+Ee:"<="+Le)).trim()}function X(ce,Ce){for(var ye=0;ye<ce.length;ye++)if(!ce[ye].test(Ce))return!1;if(Ce.prerelease.length){for(ye=0;ye<ce.length;ye++)if(C(ce[ye].semver),ce[ye].semver!==ie&&ce[ye].semver.prerelease.length>0){var $e=ce[ye].semver;if($e.major===Ce.major&&$e.minor===Ce.minor&&$e.patch===Ce.patch)return!0}return!1}return!0}function me(ce,Ce,ye){try{Ce=new F(Ce,ye)}catch{return!1}return Ce.test(ce)}function we(ce,Ce,ye,$e){var Ve,Ze,Qe,Le,ot;switch(ce=new ne(ce,$e),Ce=new F(Ce,$e),ye){case">":Ve=Oe,Ze=Z,Qe=We,Le=">",ot=">=";break;case"<":Ve=We,Ze=fe,Qe=Oe,Le="<",ot="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(me(ce,Ce,$e))return!1;for(var re=0;re<Ce.set.length;++re){var se=Ce.set[re],Ee=null,ue=null;if(se.forEach(function(Te){Te.semver===ie&&(Te=new ee(">=0.0.0")),Ee=Ee||Te,ue=ue||Te,Ve(Te.semver,Ee.semver,$e)?Ee=Te:Qe(Te.semver,ue.semver,$e)&&(ue=Te)}),Ee.operator===Le||Ee.operator===ot||(!ue.operator||ue.operator===Le)&&Ze(ce,ue.semver)||ue.operator===ot&&Qe(ce,ue.semver))return!1}return!0}ee.prototype.parse=function(ce){var Ce=this.loose?D[O]:D[x],ye=ce.match(Ce);if(!ye)throw new TypeError("Invalid comparator: "+ce);this.operator=ye[1],this.operator==="="&&(this.operator=""),ye[2]?this.semver=new ne(ye[2],this.loose):this.semver=ie},ee.prototype.toString=function(){return this.value},ee.prototype.test=function(ce){return C("Comparator.test",ce,this.loose),this.semver===ie||(typeof ce=="string"&&(ce=new ne(ce,this.loose)),ae(ce,this.operator,this.semver,this.loose))},ee.prototype.intersects=function(ce,Ce){if(!(ce instanceof ee))throw new TypeError("a Comparator is required");var ye;if(this.operator==="")return ye=new F(ce.value,Ce),me(this.value,ye,Ce);if(ce.operator==="")return ye=new F(this.value,Ce),me(ce.semver,ye,Ce);var $e=!(this.operator!==">="&&this.operator!==">"||ce.operator!==">="&&ce.operator!==">"),Ve=!(this.operator!=="<="&&this.operator!=="<"||ce.operator!=="<="&&ce.operator!=="<"),Ze=this.semver.version===ce.semver.version,Qe=!(this.operator!==">="&&this.operator!=="<="||ce.operator!==">="&&ce.operator!=="<="),Le=ae(this.semver,"<",ce.semver,Ce)&&(this.operator===">="||this.operator===">")&&(ce.operator==="<="||ce.operator==="<"),ot=ae(this.semver,">",ce.semver,Ce)&&(this.operator==="<="||this.operator==="<")&&(ce.operator===">="||ce.operator===">");return $e||Ve||Ze&&Qe||Le||ot},e.Range=F,F.prototype.format=function(){return this.range=this.set.map(function(ce){return ce.join(" ").trim()}).join("||").trim(),this.range},F.prototype.toString=function(){return this.range},F.prototype.parseRange=function(ce){var Ce=this.loose;ce=ce.trim(),C("range",ce,Ce);var ye=Ce?D[Y]:D[q];ce=ce.replace(ye,G),C("hyphen replace",ce),ce=ce.replace(D[V],"$1$2$3"),C("comparator trim",ce,D[V]),ce=(ce=(ce=ce.replace(D[U],"$1~")).replace(D[N],"$1^")).split(/\s+/).join(" ");var $e=Ce?D[O]:D[x],Ve=ce.split(" ").map(function(Ze){return function(Qe,Le){return C("comp",Qe),Qe=function(ot,re){return ot.trim().split(/\s+/).map(function(se){return function(Ee,ue){C("caret",Ee,ue);var Te=ue?D[B]:D[K];return Ee.replace(Te,function(Me,Be,ze,Ye,it){var ct;return C("caret",Ee,Me,Be,ze,Ye,it),H(Be)?ct="":H(ze)?ct=">="+Be+".0.0 <"+(+Be+1)+".0.0":H(Ye)?ct=Be==="0"?">="+Be+"."+ze+".0 <"+Be+"."+(+ze+1)+".0":">="+Be+"."+ze+".0 <"+(+Be+1)+".0.0":it?(C("replaceCaret pr",it),it.charAt(0)!=="-"&&(it="-"+it),ct=Be==="0"?ze==="0"?">="+Be+"."+ze+"."+Ye+it+" <"+Be+"."+ze+"."+(+Ye+1):">="+Be+"."+ze+"."+Ye+it+" <"+Be+"."+(+ze+1)+".0":">="+Be+"."+ze+"."+Ye+it+" <"+(+Be+1)+".0.0"):(C("no pr"),ct=Be==="0"?ze==="0"?">="+Be+"."+ze+"."+Ye+" <"+Be+"."+ze+"."+(+Ye+1):">="+Be+"."+ze+"."+Ye+" <"+Be+"."+(+ze+1)+".0":">="+Be+"."+ze+"."+Ye+" <"+(+Be+1)+".0.0"),C("caret return",ct),ct})}(se,re)}).join(" ")}(Qe,Le),C("caret",Qe),Qe=function(ot,re){return ot.trim().split(/\s+/).map(function(se){return function(Ee,ue){var Te=ue?D[z]:D[A];return Ee.replace(Te,function(Me,Be,ze,Ye,it){var ct;return C("tilde",Ee,Me,Be,ze,Ye,it),H(Be)?ct="":H(ze)?ct=">="+Be+".0.0 <"+(+Be+1)+".0.0":H(Ye)?ct=">="+Be+"."+ze+".0 <"+Be+"."+(+ze+1)+".0":it?(C("replaceTilde pr",it),it.charAt(0)!=="-"&&(it="-"+it),ct=">="+Be+"."+ze+"."+Ye+it+" <"+Be+"."+(+ze+1)+".0"):ct=">="+Be+"."+ze+"."+Ye+" <"+Be+"."+(+ze+1)+".0",C("tilde return",ct),ct})}(se,re)}).join(" ")}(Qe,Le),C("tildes",Qe),Qe=function(ot,re){return C("replaceXRanges",ot,re),ot.split(/\s+/).map(function(se){return function(Ee,ue){Ee=Ee.trim();var Te=ue?D[y]:D[h];return Ee.replace(Te,function(Me,Be,ze,Ye,it,ct){C("xRange",Ee,Me,Be,ze,Ye,it,ct);var st=H(ze),et=st||H(Ye),ft=et||H(it);return Be==="="&&ft&&(Be=""),st?Me=Be===">"||Be==="<"?"<0.0.0":"*":Be&&ft?(et&&(Ye=0),ft&&(it=0),Be===">"?(Be=">=",et?(ze=+ze+1,Ye=0,it=0):ft&&(Ye=+Ye+1,it=0)):Be==="<="&&(Be="<",et?ze=+ze+1:Ye=+Ye+1),Me=Be+ze+"."+Ye+"."+it):et?Me=">="+ze+".0.0 <"+(+ze+1)+".0.0":ft&&(Me=">="+ze+"."+Ye+".0 <"+ze+"."+(+Ye+1)+".0"),C("xRange return",Me),Me})}(se,re)}).join(" ")}(Qe,Le),C("xrange",Qe),Qe=function(ot,re){return C("replaceStars",ot,re),ot.trim().replace(D[Q],"")}(Qe,Le),C("stars",Qe),Qe}(Ze,Ce)}).join(" ").split(/\s+/);return this.loose&&(Ve=Ve.filter(function(Ze){return!!Ze.match($e)})),Ve=Ve.map(function(Ze){return new ee(Ze,Ce)})},F.prototype.intersects=function(ce,Ce){if(!(ce instanceof F))throw new TypeError("a Range is required");return this.set.some(function(ye){return ye.every(function($e){return ce.set.some(function(Ve){return Ve.every(function(Ze){return $e.intersects(Ze,Ce)})})})})},e.toComparators=function(ce,Ce){return new F(ce,Ce).set.map(function(ye){return ye.map(function($e){return $e.value}).join(" ").trim().split(" ")})},F.prototype.test=function(ce){if(!ce)return!1;typeof ce=="string"&&(ce=new ne(ce,this.loose));for(var Ce=0;Ce<this.set.length;Ce++)if(X(this.set[Ce],ce))return!0;return!1},e.satisfies=me,e.maxSatisfying=function(ce,Ce,ye){var $e=null,Ve=null;try{var Ze=new F(Ce,ye)}catch{return null}return ce.forEach(function(Qe){Ze.test(Qe)&&($e&&Ve.compare(Qe)!==-1||(Ve=new ne($e=Qe,ye)))}),$e},e.minSatisfying=function(ce,Ce,ye){var $e=null,Ve=null;try{var Ze=new F(Ce,ye)}catch{return null}return ce.forEach(function(Qe){Ze.test(Qe)&&($e&&Ve.compare(Qe)!==1||(Ve=new ne($e=Qe,ye)))}),$e},e.validRange=function(ce,Ce){try{return new F(ce,Ce).range||"*"}catch{return null}},e.ltr=function(ce,Ce,ye){return we(ce,Ce,"<",ye)},e.gtr=function(ce,Ce,ye){return we(ce,Ce,">",ye)},e.outside=we,e.prerelease=function(ce,Ce){var ye=ve(ce,Ce);return ye&&ye.prerelease.length?ye.prerelease:null},e.intersects=function(ce,Ce,ye){return ce=new F(ce,ye),Ce=new F(Ce,ye),ce.intersects(Ce)},e.coerce=function(ce){if(ce instanceof ne)return ce;if(typeof ce!="string")return null;var Ce=ce.match(D[R]);return Ce==null?null:ve((Ce[1]||"0")+"."+(Ce[2]||"0")+"."+(Ce[3]||"0"))}}).call(this,l(1))},function(J,e){var l,t,C=J.exports={};function P(){throw new Error("setTimeout has not been defined")}function _(){throw new Error("clearTimeout has not been defined")}function D(w){if(l===setTimeout)return setTimeout(w,0);if((l===P||!l)&&setTimeout)return l=setTimeout,setTimeout(w,0);try{return l(w,0)}catch{try{return l.call(null,w,0)}catch{return l.call(this,w,0)}}}(function(){try{l=typeof setTimeout=="function"?setTimeout:P}catch{l=P}try{t=typeof clearTimeout=="function"?clearTimeout:_}catch{t=_}})();var b,I=[],L=!1,k=-1;function S(){L&&b&&(L=!1,b.length?I=b.concat(I):k=-1,I.length&&T())}function T(){if(!L){var w=D(S);L=!0;for(var f=I.length;f;){for(b=I,I=[];++k<f;)b&&b[k].run();k=-1,f=I.length}b=null,L=!1,function(v){if(t===clearTimeout)return clearTimeout(v);if((t===_||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(v);try{t(v)}catch{try{return t.call(null,v)}catch{return t.call(this,v)}}}(w)}}function E(w,f){this.fun=w,this.array=f}function p(){}C.nextTick=function(w){var f=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)f[v-1]=arguments[v];I.push(new E(w,f)),I.length!==1||L||D(T)},E.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=p,C.addListener=p,C.once=p,C.off=p,C.removeListener=p,C.removeAllListeners=p,C.emit=p,C.prependListener=p,C.prependOnceListener=p,C.listeners=function(w){return[]},C.binding=function(w){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(w){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(De[96],Ie([1,0,10,6]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function C(a){const g=a;return g?typeof g.read=="function":!1}e.isReadable=C;function P(a){const g=a;return g?[g.on,g.pause,g.resume,g.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=P;function _(a){const g=a;return g?P(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean":!1}e.isReadableBufferedStream=_;function D(a,g){return new b(a,g)}e.newWriteableStream=D;class b{constructor(g,n){this.reducer=g,this.options=n,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(g){if(!this.state.destroyed){if(this.state.flowing)this.emitData(g);else if(this.buffer.data.push(g),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(n=>this.pendingWritePromises.push(n))}}error(g){this.state.destroyed||(this.state.flowing?this.emitError(g):this.buffer.error.push(g))}end(g){this.state.destroyed||(typeof g<"u"&&this.write(g),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(g){this.listeners.data.slice(0).forEach(n=>n(g))}emitError(g){this.listeners.error.length===0?(0,l.onUnexpectedError)(g):this.listeners.error.slice(0).forEach(n=>n(g))}emitEnd(){this.listeners.end.slice(0).forEach(g=>g())}on(g,n){if(!this.state.destroyed)switch(g){case"data":this.listeners.data.push(n),this.resume();break;case"end":this.listeners.end.push(n),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(n),this.state.flowing&&this.flowErrors();break}}removeListener(g,n){if(this.state.destroyed)return;let d;switch(g){case"data":d=this.listeners.data;break;case"end":d=this.listeners.end;break;case"error":d=this.listeners.error;break}if(d){const s=d.indexOf(n);s>=0&&d.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const g=this.reducer(this.buffer.data);this.emitData(g),this.buffer.data.length=0;const n=[...this.pendingWritePromises];this.pendingWritePromises.length=0,n.forEach(d=>d())}}flowErrors(){if(this.listeners.error.length>0){for(const g of this.buffer.error)this.emitError(g);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function I(a,g){const n=[];let d;for(;(d=a.read())!==null;)n.push(d);return g(n)}e.consumeReadable=I;function L(a,g,n){const d=[];let s;for(;(s=a.read())!==null&&d.length<n;)d.push(s);return s===null&&d.length>0?g(d):{read:()=>{if(d.length>0)return d.shift();if(typeof s<"u"){const i=s;return s=void 0,i}return a.read()}}}e.peekReadable=L;function k(a,g){return new Promise((n,d)=>{const s=[];S(a,{onData:i=>{g&&s.push(i)},onError:i=>{g?d(i):n(void 0)},onEnd:()=>{n(g?g(s):void 0)}})})}e.consumeStream=k;function S(a,g){let n=!1;return a.on("error",d=>{n||g.onError(d)}),a.on("end",()=>{n||g.onEnd()}),a.on("data",d=>{n||g.onData(d)}),(0,t.toDisposable)(()=>n=!0)}e.listenStream=S;function T(a,g){return new Promise((n,d)=>{const s=new t.DisposableStore,i=[],r=u=>{if(i.push(u),i.length>g)return s.dispose(),a.pause(),n({stream:a,buffer:i,ended:!1})},c=u=>d(u),o=()=>n({stream:a,buffer:i,ended:!0});s.add((0,t.toDisposable)(()=>a.removeListener("error",c))),a.on("error",c),s.add((0,t.toDisposable)(()=>a.removeListener("end",o))),a.on("end",o),s.add((0,t.toDisposable)(()=>a.removeListener("data",r))),a.on("data",r)})}e.peekStream=T;function E(a,g){const n=D(g);return n.end(a),n}e.toStream=E;function p(){const a=D(()=>{throw new Error("not supported")});return a.end(),a}e.emptyStream=p;function w(a){let g=!1;return{read:()=>g?null:(g=!0,a)}}e.toReadable=w;function f(a,g,n){const d=D(n);return S(a,{onData:s=>d.write(g.data(s)),onError:s=>d.error(g.error?g.error(s):s),onEnd:()=>d.end()}),d}e.transform=f;function v(a,g,n){let d=!1;return{read:()=>{const s=g.read();return d?s:(d=!0,s!==null?n([a,s]):a)}}}e.prefixedReadable=v;function m(a,g,n){let d=!1;const s=D(n);return S(g,{onData:i=>d?s.write(i):(d=!0,s.write(n([a,i]))),onError:i=>s.error(i),onEnd:()=>{d||(d=!0,s.write(a)),s.end()}}),s}e.prefixedStream=m}),define(De[23],Ie([1,0,96]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let C,P;class _{constructor(u){this.buffer=u,this.byteLength=this.buffer.byteLength}static alloc(u){return t?new _(Buffer.allocUnsafe(u)):new _(new Uint8Array(u))}static wrap(u){return t&&!Buffer.isBuffer(u)&&(u=Buffer.from(u.buffer,u.byteOffset,u.byteLength)),new _(u)}static fromString(u,h){return!(h?.dontUseNodeBuffer||!1)&&t?new _(Buffer.from(u)):(C||(C=new TextEncoder),new _(C.encode(u)))}static fromByteArray(u){const h=_.alloc(u.length);for(let y=0,R=u.length;y<R;y++)h.buffer[y]=u[y];return h}static concat(u,h){if(typeof h>"u"){h=0;for(let M=0,U=u.length;M<U;M++)h+=u[M].byteLength}const y=_.alloc(h);let R=0;for(let M=0,U=u.length;M<U;M++){const A=u[M];y.set(A,R),R+=A.byteLength}return y}clone(){const u=_.alloc(this.byteLength);return u.set(this),u}toString(){return t?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(u,h){return new _(this.buffer.subarray(u,h))}set(u,h){if(u instanceof _)this.buffer.set(u.buffer,h);else if(u instanceof Uint8Array)this.buffer.set(u,h);else if(u instanceof ArrayBuffer)this.buffer.set(new Uint8Array(u),h);else if(ArrayBuffer.isView(u))this.buffer.set(new Uint8Array(u.buffer,u.byteOffset,u.byteLength),h);else throw new Error("Unknown argument 'array'")}readUInt32BE(u){return I(this.buffer,u)}writeUInt32BE(u,h){L(this.buffer,u,h)}readUInt32LE(u){return k(this.buffer,u)}writeUInt32LE(u,h){S(this.buffer,u,h)}readUInt8(u){return T(this.buffer,u)}writeUInt8(u,h){E(this.buffer,u,h)}}e.VSBuffer=_;function D(o,u){return o[u+0]<<0>>>0|o[u+1]<<8>>>0}e.readUInt16LE=D;function b(o,u,h){o[h+0]=u&255,u=u>>>8,o[h+1]=u&255}e.writeUInt16LE=b;function I(o,u){return o[u]*2**24+o[u+1]*2**16+o[u+2]*2**8+o[u+3]}e.readUInt32BE=I;function L(o,u,h){o[h+3]=u,u=u>>>8,o[h+2]=u,u=u>>>8,o[h+1]=u,u=u>>>8,o[h]=u}e.writeUInt32BE=L;function k(o,u){return o[u+0]<<0>>>0|o[u+1]<<8>>>0|o[u+2]<<16>>>0|o[u+3]<<24>>>0}e.readUInt32LE=k;function S(o,u,h){o[h+0]=u&255,u=u>>>8,o[h+1]=u&255,u=u>>>8,o[h+2]=u&255,u=u>>>8,o[h+3]=u&255}e.writeUInt32LE=S;function T(o,u){return o[u]}e.readUInt8=T;function E(o,u,h){o[h]=u}e.writeUInt8=E;function p(o){return l.consumeReadable(o,u=>_.concat(u))}e.readableToBuffer=p;function w(o){return l.toReadable(o)}e.bufferToReadable=w;function f(o){return l.consumeStream(o,u=>_.concat(u))}e.streamToBuffer=f;async function v(o){return o.ended?_.concat(o.buffer):_.concat([...o.buffer,await f(o.stream)])}e.bufferedStreamToBuffer=v;function m(o){return l.toStream(o,u=>_.concat(u))}e.bufferToStream=m;function a(o){return l.transform(o,{data:u=>typeof u=="string"?_.fromString(u):_.wrap(u)},u=>_.concat(u))}e.streamToBufferReadableStream=a;function g(o){return l.newWriteableStream(u=>_.concat(u),o)}e.newWriteableBufferStream=g;function n(o,u){return l.prefixedReadable(o,u,h=>_.concat(h))}e.prefixedBufferReadable=n;function d(o,u){return l.prefixedStream(o,u,h=>_.concat(h))}e.prefixedBufferStream=d;function s(o){let u=0,h=0,y=0;const R=new Uint8Array(Math.floor(o.length/4*3)),M=A=>{switch(h){case 3:R[y++]=u|A,h=0;break;case 2:R[y++]=u|A>>>2,u=A<<6,h=3;break;case 1:R[y++]=u|A>>>4,u=A<<4,h=2;break;default:u=A<<2,h=1}};for(let A=0;A<o.length;A++){const z=o.charCodeAt(A);if(z>=65&&z<=90)M(z-65);else if(z>=97&&z<=122)M(z-97+26);else if(z>=48&&z<=57)M(z-48+52);else if(z===43||z===45)M(62);else if(z===47||z===95)M(63);else{if(z===61)break;throw new SyntaxError(`Unexpected base64 character ${o[A]}`)}}const U=y;for(;h>0;)M(0);return _.wrap(R).slice(0,U)}e.decodeBase64=s;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:o},u=!0,h=!1){const y=h?r:i;let R="";const M=o.byteLength%3;let U=0;for(;U<o.byteLength-M;U+=3){const A=o[U+0],z=o[U+1],$=o[U+2];R+=y[A>>>2],R+=y[(A<<4|z>>>4)&63],R+=y[(z<<2|$>>>6)&63],R+=y[$&63]}if(M===1){const A=o[U+0];R+=y[A>>>2],R+=y[A<<4&63],u&&(R+="==")}else if(M===2){const A=o[U+0],z=o[U+1];R+=y[A>>>2],R+=y[(A<<4|z>>>4)&63],R+=y[z<<2&63],u&&(R+="=")}return R}e.encodeBase64=c}),define(De[14],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function l(d){return typeof d=="string"}e.isString=l;function t(d){return Array.isArray(d)&&d.every(s=>l(s))}e.isStringArray=t;function C(d){return typeof d=="object"&&d!==null&&!Array.isArray(d)&&!(d instanceof RegExp)&&!(d instanceof Date)}e.isObject=C;function P(d){const s=Object.getPrototypeOf(Uint8Array);return typeof d=="object"&&d instanceof s}e.isTypedArray=P;function _(d){return typeof d=="number"&&!isNaN(d)}e.isNumber=_;function D(d){return!!d&&typeof d[Symbol.iterator]=="function"}e.isIterable=D;function b(d){return d===!0||d===!1}e.isBoolean=b;function I(d){return typeof d>"u"}e.isUndefined=I;function L(d){return!k(d)}e.isDefined=L;function k(d){return I(d)||d===null}e.isUndefinedOrNull=k;function S(d,s){if(!d)throw new Error(s?`Unexpected type, expected '${s}'`:"Unexpected type")}e.assertType=S;function T(d){if(k(d))throw new Error("Assertion Failed: argument is undefined or null");return d}e.assertIsDefined=T;function E(...d){const s=[];for(let i=0;i<d.length;i++){const r=d[i];if(k(r))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);s.push(r)}return s}e.assertAllDefined=E;const p=Object.prototype.hasOwnProperty;function w(d){if(!C(d))return!1;for(const s in d)if(p.call(d,s))return!1;return!0}e.isEmptyObject=w;function f(d){return typeof d=="function"}e.isFunction=f;function v(...d){return d.length>0&&d.every(f)}e.areFunctions=v;function m(d,s){const i=Math.min(d.length,s.length);for(let r=0;r<i;r++)a(d[r],s[r])}e.validateConstraints=m;function a(d,s){if(l(s)){if(typeof d!==s)throw new Error(`argument does not match constraint: typeof ${s}`)}else if(f(s)){try{if(d instanceof s)return}catch{}if(!k(d)&&d.constructor===s||s.length===1&&s.call(void 0,d)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=a;function g(d){return d===null?void 0:d}e.withNullAsUndefined=g;function n(d){return typeof d>"u"?null:d}e.withUndefinedAsNull=n}),define(De[24],Ie([1,0,14]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const v=Array.isArray(f)?[]:{};return Object.keys(f).forEach(m=>{f[m]&&typeof f[m]=="object"?v[m]=t(f[m]):v[m]=f[m]}),v}e.deepClone=t;function C(f){if(!f||typeof f!="object")return f;const v=[f];for(;v.length>0;){const m=v.shift();Object.freeze(m);for(const a in m)if(P.call(m,a)){const g=m[a];typeof g=="object"&&!Object.isFrozen(g)&&!(0,l.isTypedArray)(g)&&v.push(g)}}return f}e.deepFreeze=C;const P=Object.prototype.hasOwnProperty;function _(f,v){return D(f,v,new Set)}e.cloneAndChange=_;function D(f,v,m){if((0,l.isUndefinedOrNull)(f))return f;const a=v(f);if(typeof a<"u")return a;if(Array.isArray(f)){const g=[];for(const n of f)g.push(D(n,v,m));return g}if((0,l.isObject)(f)){if(m.has(f))throw new Error("Cannot clone recursive data-structure");m.add(f);const g={};for(const n in f)P.call(f,n)&&(g[n]=D(f[n],v,m));return m.delete(f),g}return f}function b(f,v,m=!0){return(0,l.isObject)(f)?((0,l.isObject)(v)&&Object.keys(v).forEach(a=>{a in f?m&&((0,l.isObject)(f[a])&&(0,l.isObject)(v[a])?b(f[a],v[a],m):f[a]=v[a]):f[a]=v[a]}),f):v}e.mixin=b;function I(f,v){if(f===v)return!0;if(f==null||v===null||v===void 0||typeof f!=typeof v||typeof f!="object"||Array.isArray(f)!==Array.isArray(v))return!1;let m,a;if(Array.isArray(f)){if(f.length!==v.length)return!1;for(m=0;m<f.length;m++)if(!I(f[m],v[m]))return!1}else{const g=[];for(a in f)g.push(a);g.sort();const n=[];for(a in v)n.push(a);if(n.sort(),!I(g,n))return!1;for(m=0;m<g.length;m++)if(!I(f[g[m]],v[g[m]]))return!1}return!0}e.equals=I;function L(f){const v=new Set;return JSON.stringify(f,(m,a)=>{if((0,l.isObject)(a)||Array.isArray(a)){if(v.has(a))return"[Circular]";v.add(a)}return a})}e.safeStringify=L;function k(f,v){const m=Object.create(null);return!f||!v||Object.keys(v).forEach(g=>{const n=f[g],d=v[g];I(n,d)||(m[g]=d)}),m}e.distinct=k;function S(f,v){const m=v.toLowerCase(),a=Object.keys(f).find(g=>g.toLowerCase()===m);return a?f[a]:f[v]}e.getCaseInsensitive=S;function T(f,v){const m=Object.create(null);for(const[a,g]of Object.entries(f))v(a,g)&&(m[a]=g);return m}e.filter=T;function E(f){let v=[],m=Object.getPrototypeOf(f);for(;Object.prototype!==m;)v=v.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return v}e.getAllPropertyNames=E;function p(f){const v=[];for(const m of E(f))typeof f[m]=="function"&&v.push(m);return v}e.getAllMethodNames=p;function w(f,v){const m=g=>function(){const n=Array.prototype.slice.call(arguments,0);return v(g,n)},a={};for(const g of f)a[g]=m(g);return a}e.createProxyObject=w}),define(De[97],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var l;(function(P){P[P.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",P[P.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",P[P.MAX_UINT_8=255]="MAX_UINT_8",P[P.MAX_UINT_16=65535]="MAX_UINT_16",P[P.MAX_UINT_32=4294967295]="MAX_UINT_32",P[P.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(l=e.Constants||(e.Constants={}));function t(P){return P<0?0:P>255?255:P|0}e.toUint8=t;function C(P){return P<0?0:P>4294967295?4294967295:P|0}e.toUint32=C}),define(De[34],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const l=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(C){return l.test(C)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(D){for(let b=0;b<D.length;b++)D[b]=Math.floor(Math.random()*256);return D};const P=new Uint8Array(16),_=[];for(let D=0;D<256;D++)_.push(D.toString(16).padStart(2,"0"));return function(){C(P),P[6]=P[6]&15|64,P[8]=P[8]&63|128;let b=0,I="";return I+=_[P[b++]],I+=_[P[b++]],I+=_[P[b++]],I+=_[P[b++]],I+="-",I+=_[P[b++]],I+=_[P[b++]],I+="-",I+=_[P[b++]],I+=_[P[b++]],I+="-",I+=_[P[b++]],I+=_[P[b++]],I+="-",I+=_[P[b++]],I+=_[P[b++]],I+=_[P[b++]],I+=_[P[b++]],I+=_[P[b++]],I+=_[P[b++]],I}}()}),define(De[98],Ie([1,0,97]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class t{constructor(D){const b=(0,l.toUint8)(D);this._defaultValue=b,this._asciiMap=t._createAsciiMap(b),this._map=new Map}static _createAsciiMap(D){const b=new Uint8Array(256);for(let I=0;I<256;I++)b[I]=D;return b}set(D,b){const I=(0,l.toUint8)(b);D>=0&&D<256?this._asciiMap[D]=I:this._map.set(D,I)}get(D){return D>=0&&D<256?this._asciiMap[D]:this._map.get(D)||this._defaultValue}}e.CharacterClassifier=t;var C;(function(_){_[_.False=0]="False",_[_.True=1]="True"})(C||(C={}));class P{constructor(){this._actual=new t(0)}add(D){this._actual.set(D,1)}has(D){return this._actual.get(D)===1}}e.CharacterSet=P}),define(De[49],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class l{constructor(C,P){this.lineNumber=C,this.column=P}with(C=this.lineNumber,P=this.column){return C===this.lineNumber&&P===this.column?this:new l(C,P)}delta(C=0,P=0){return this.with(this.lineNumber+C,this.column+P)}equals(C){return l.equals(this,C)}static equals(C,P){return!C&&!P?!0:!!C&&!!P&&C.lineNumber===P.lineNumber&&C.column===P.column}isBefore(C){return l.isBefore(this,C)}static isBefore(C,P){return C.lineNumber<P.lineNumber?!0:P.lineNumber<C.lineNumber?!1:C.column<P.column}isBeforeOrEqual(C){return l.isBeforeOrEqual(this,C)}static isBeforeOrEqual(C,P){return C.lineNumber<P.lineNumber?!0:P.lineNumber<C.lineNumber?!1:C.column<=P.column}static compare(C,P){const _=C.lineNumber|0,D=P.lineNumber|0;if(_===D){const b=C.column|0,I=P.column|0;return b-I}return _-D}clone(){return new l(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(C){return new l(C.lineNumber,C.column)}static isIPosition(C){return C&&typeof C.lineNumber=="number"&&typeof C.column=="number"}}e.Position=l}),define(De[35],Ie([1,0,49]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(P,_,D,b){P>D||P===D&&_>b?(this.startLineNumber=D,this.startColumn=b,this.endLineNumber=P,this.endColumn=_):(this.startLineNumber=P,this.startColumn=_,this.endLineNumber=D,this.endColumn=b)}isEmpty(){return t.isEmpty(this)}static isEmpty(P){return P.startLineNumber===P.endLineNumber&&P.startColumn===P.endColumn}containsPosition(P){return t.containsPosition(this,P)}static containsPosition(P,_){return!(_.lineNumber<P.startLineNumber||_.lineNumber>P.endLineNumber||_.lineNumber===P.startLineNumber&&_.column<P.startColumn||_.lineNumber===P.endLineNumber&&_.column>P.endColumn)}static strictContainsPosition(P,_){return!(_.lineNumber<P.startLineNumber||_.lineNumber>P.endLineNumber||_.lineNumber===P.startLineNumber&&_.column<=P.startColumn||_.lineNumber===P.endLineNumber&&_.column>=P.endColumn)}containsRange(P){return t.containsRange(this,P)}static containsRange(P,_){return!(_.startLineNumber<P.startLineNumber||_.endLineNumber<P.startLineNumber||_.startLineNumber>P.endLineNumber||_.endLineNumber>P.endLineNumber||_.startLineNumber===P.startLineNumber&&_.startColumn<P.startColumn||_.endLineNumber===P.endLineNumber&&_.endColumn>P.endColumn)}strictContainsRange(P){return t.strictContainsRange(this,P)}static strictContainsRange(P,_){return!(_.startLineNumber<P.startLineNumber||_.endLineNumber<P.startLineNumber||_.startLineNumber>P.endLineNumber||_.endLineNumber>P.endLineNumber||_.startLineNumber===P.startLineNumber&&_.startColumn<=P.startColumn||_.endLineNumber===P.endLineNumber&&_.endColumn>=P.endColumn)}plusRange(P){return t.plusRange(this,P)}static plusRange(P,_){let D,b,I,L;return _.startLineNumber<P.startLineNumber?(D=_.startLineNumber,b=_.startColumn):_.startLineNumber===P.startLineNumber?(D=_.startLineNumber,b=Math.min(_.startColumn,P.startColumn)):(D=P.startLineNumber,b=P.startColumn),_.endLineNumber>P.endLineNumber?(I=_.endLineNumber,L=_.endColumn):_.endLineNumber===P.endLineNumber?(I=_.endLineNumber,L=Math.max(_.endColumn,P.endColumn)):(I=P.endLineNumber,L=P.endColumn),new t(D,b,I,L)}intersectRanges(P){return t.intersectRanges(this,P)}static intersectRanges(P,_){let D=P.startLineNumber,b=P.startColumn,I=P.endLineNumber,L=P.endColumn;const k=_.startLineNumber,S=_.startColumn,T=_.endLineNumber,E=_.endColumn;return D<k?(D=k,b=S):D===k&&(b=Math.max(b,S)),I>T?(I=T,L=E):I===T&&(L=Math.min(L,E)),D>I||D===I&&b>L?null:new t(D,b,I,L)}equalsRange(P){return t.equalsRange(this,P)}static equalsRange(P,_){return!!P&&!!_&&P.startLineNumber===_.startLineNumber&&P.startColumn===_.startColumn&&P.endLineNumber===_.endLineNumber&&P.endColumn===_.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(P){return new l.Position(P.endLineNumber,P.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(P){return new l.Position(P.startLineNumber,P.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(P,_){return new t(this.startLineNumber,this.startColumn,P,_)}setStartPosition(P,_){return new t(P,_,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}delta(P){return new t(this.startLineNumber+P,this.startColumn,this.endLineNumber+P,this.endColumn)}static collapseToStart(P){return new t(P.startLineNumber,P.startColumn,P.startLineNumber,P.startColumn)}static fromPositions(P,_=P){return new t(P.lineNumber,P.column,_.lineNumber,_.column)}static lift(P){return P?new t(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):null}static isIRange(P){return P&&typeof P.startLineNumber=="number"&&typeof P.startColumn=="number"&&typeof P.endLineNumber=="number"&&typeof P.endColumn=="number"}static areIntersectingOrTouching(P,_){return!(P.endLineNumber<_.startLineNumber||P.endLineNumber===_.startLineNumber&&P.endColumn<_.startColumn||_.endLineNumber<P.startLineNumber||_.endLineNumber===P.startLineNumber&&_.endColumn<P.startColumn)}static areIntersecting(P,_){return!(P.endLineNumber<_.startLineNumber||P.endLineNumber===_.startLineNumber&&P.endColumn<=_.startColumn||_.endLineNumber<P.startLineNumber||_.endLineNumber===P.startLineNumber&&_.endColumn<=P.startColumn)}static compareRangesUsingStarts(P,_){if(P&&_){const I=P.startLineNumber|0,L=_.startLineNumber|0;if(I===L){const k=P.startColumn|0,S=_.startColumn|0;if(k===S){const T=P.endLineNumber|0,E=_.endLineNumber|0;if(T===E){const p=P.endColumn|0,w=_.endColumn|0;return p-w}return T-E}return k-S}return I-L}return(P?1:0)-(_?1:0)}static compareRangesUsingEnds(P,_){return P.endLineNumber===_.endLineNumber?P.endColumn===_.endColumn?P.startLineNumber===_.startLineNumber?P.startColumn-_.startColumn:P.startLineNumber-_.startLineNumber:P.endColumn-_.endColumn:P.endLineNumber-_.endLineNumber}static spansMultipleLines(P){return P.endLineNumber>P.startLineNumber}toJSON(){return this}}e.Range=t}),define(De[145],Ie([1,0,49,35]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var C;(function(_){_[_.LTR=0]="LTR",_[_.RTL=1]="RTL"})(C=e.SelectionDirection||(e.SelectionDirection={}));class P extends t.Range{constructor(D,b,I,L){super(D,b,I,L),this.selectionStartLineNumber=D,this.selectionStartColumn=b,this.positionLineNumber=I,this.positionColumn=L}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(D){return P.selectionsEqual(this,D)}static selectionsEqual(D,b){return D.selectionStartLineNumber===b.selectionStartLineNumber&&D.selectionStartColumn===b.selectionStartColumn&&D.positionLineNumber===b.positionLineNumber&&D.positionColumn===b.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(D,b){return this.getDirection()===0?new P(this.startLineNumber,this.startColumn,D,b):new P(D,b,this.startLineNumber,this.startColumn)}getPosition(){return new l.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new l.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(D,b){return this.getDirection()===0?new P(D,b,this.endLineNumber,this.endColumn):new P(this.endLineNumber,this.endColumn,D,b)}static fromPositions(D,b=D){return new P(D.lineNumber,D.column,b.lineNumber,b.column)}static fromRange(D,b){return b===0?new P(D.startLineNumber,D.startColumn,D.endLineNumber,D.endColumn):new P(D.endLineNumber,D.endColumn,D.startLineNumber,D.startColumn)}static liftSelection(D){return new P(D.selectionStartLineNumber,D.selectionStartColumn,D.positionLineNumber,D.positionColumn)}static selectionsArrEqual(D,b){if(D&&!b||!D&&b)return!1;if(!D&&!b)return!0;if(D.length!==b.length)return!1;for(let I=0,L=D.length;I<L;I++)if(!this.selectionsEqual(D[I],b[I]))return!1;return!0}static isISelection(D){return D&&typeof D.selectionStartLineNumber=="number"&&typeof D.selectionStartColumn=="number"&&typeof D.positionLineNumber=="number"&&typeof D.positionColumn=="number"}static createWithDirection(D,b,I,L,k){return k===0?new P(D,b,I,L):new P(I,L,D,b)}}e.Selection=P}),define(De[146],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(De[147],Ie([1,0,98]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var t;(function(_){_[_.Regular=0]="Regular",_[_.Whitespace=1]="Whitespace",_[_.WordSeparator=2]="WordSeparator"})(t=e.WordCharacterClass||(e.WordCharacterClass={}));class C extends l.CharacterClassifier{constructor(D){super(0);for(let b=0,I=D.length;b<I;b++)this.set(D.charCodeAt(b),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=C;function P(_){const D={};return b=>(D.hasOwnProperty(b)||(D[b]=_(b)),D[b])}e.getMapForWordSeparators=P(_=>new C(_))}),define(De[99],Ie([1,0,60,6,77]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function P(k=""){let S="(-?\\d*\\.\\d\\w*)|([^";for(const T of e.USUAL_WORD_SEPARATORS)k.indexOf(T)>=0||(S+="\\"+T);return S+="\\s]+)",new RegExp(S,"g")}e.DEFAULT_WORD_REGEXP=P();function _(k){let S=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)S=k;else{let T="g";k.ignoreCase&&(T+="i"),k.multiline&&(T+="m"),k.unicode&&(T+="u"),S=new RegExp(k.source,T)}return S.lastIndex=0,S}e.ensureValidWordDefinition=_;const D=new C.LinkedList;D.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function b(k){const S=D.unshift(k);return(0,t.toDisposable)(S)}e.setDefaultGetWordAtTextConfig=b;function I(k,S,T,E,p){if(p||(p=l.Iterable.first(D)),T.length>p.maxLen){let a=k-p.maxLen/2;return a<0?a=0:E+=a,T=T.substring(a,k+p.maxLen/2),I(k,S,T,E,p)}const w=Date.now(),f=k-1-E;let v=-1,m=null;for(let a=1;!(Date.now()-w>=p.timeBudget);a++){const g=f-p.windowSize*a;S.lastIndex=Math.max(0,g);const n=L(S,T,f,v);if(!n&&m||(m=n,g<=0))break;v=g}if(m){const a={word:m[0],startColumn:E+1+m.index,endColumn:E+1+m.index+m[0].length};return S.lastIndex=0,a}return null}e.getWordAtText=I;function L(k,S,T,E){let p;for(;p=k.exec(S);){const w=p.index||0;if(w<=T&&k.lastIndex>=T)return p;if(E>0&&w>E)return null}return null}}),define(De[148],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var l;(function(_){_[_.None=0]="None",_[_.Indent=1]="Indent",_[_.IndentOutdent=2]="IndentOutdent",_[_.Outdent=3]="Outdent"})(l=e.IndentAction||(e.IndentAction={}));class t{constructor(D){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=D.open,this.close=D.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(D.notIn))for(let b=0,I=D.notIn.length;b<I;b++)switch(D.notIn[b]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(D){switch(D){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(D,b){if(D.getTokenCount()===0)return!0;const I=D.findTokenIndexAtOffset(b-2),L=D.getStandardTokenType(I);return this.isOK(L)}_findNeutralCharacterInRange(D,b){for(let I=D;I<=b;I++){const L=String.fromCharCode(I);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=t;class C{constructor(D){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const b of D)P(this.autoClosingPairsOpenByStart,b.open.charAt(0),b),P(this.autoClosingPairsOpenByEnd,b.open.charAt(b.open.length-1),b),P(this.autoClosingPairsCloseByStart,b.close.charAt(0),b),P(this.autoClosingPairsCloseByEnd,b.close.charAt(b.close.length-1),b),b.close.length===1&&b.open.length===1&&P(this.autoClosingPairsCloseSingleChar,b.close,b)}}e.AutoClosingPairs=C;function P(_,D,b){_.has(D)?_.get(D).push(b):_.set(D,[b])}}),define(De[149],Ie([1,0,98]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var t;(function(T){T[T.Invalid=0]="Invalid",T[T.Start=1]="Start",T[T.H=2]="H",T[T.HT=3]="HT",T[T.HTT=4]="HTT",T[T.HTTP=5]="HTTP",T[T.F=6]="F",T[T.FI=7]="FI",T[T.FIL=8]="FIL",T[T.BeforeColon=9]="BeforeColon",T[T.AfterColon=10]="AfterColon",T[T.AlmostThere=11]="AlmostThere",T[T.End=12]="End",T[T.Accept=13]="Accept",T[T.LastKnownState=14]="LastKnownState"})(t=e.State||(e.State={}));class C{constructor(E,p,w){const f=new Uint8Array(E*p);for(let v=0,m=E*p;v<m;v++)f[v]=w;this._data=f,this.rows=E,this.cols=p}get(E,p){return this._data[E*this.cols+p]}set(E,p,w){this._data[E*this.cols+p]=w}}e.Uint8Matrix=C;class P{constructor(E){let p=0,w=0;for(let v=0,m=E.length;v<m;v++){const[a,g,n]=E[v];g>p&&(p=g),a>w&&(w=a),n>w&&(w=n)}p++,w++;const f=new C(w,p,0);for(let v=0,m=E.length;v<m;v++){const[a,g,n]=E[v];f.set(a,g,n)}this._states=f,this._maxCharCode=p}nextState(E,p){return p<0||p>=this._maxCharCode?0:this._states.get(E,p)}}e.StateMachine=P;let _=null;function D(){return _===null&&(_=new P([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),_}var b;(function(T){T[T.None=0]="None",T[T.ForceTermination=1]="ForceTermination",T[T.CannotEndIn=2]="CannotEndIn"})(b||(b={}));let I=null;function L(){if(I===null){I=new l.CharacterClassifier(0);const T=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let p=0;p<T.length;p++)I.set(T.charCodeAt(p),1);const E=".,;:";for(let p=0;p<E.length;p++)I.set(E.charCodeAt(p),2)}return I}class k{static _createLink(E,p,w,f,v){let m=v-1;do{const a=p.charCodeAt(m);if(E.get(a)!==2)break;m--}while(m>f);if(f>0){const a=p.charCodeAt(f-1),g=p.charCodeAt(m);(a===40&&g===41||a===91&&g===93||a===123&&g===125)&&m--}return{range:{startLineNumber:w,startColumn:f+1,endLineNumber:w,endColumn:m+2},url:p.substring(f,m+1)}}static computeLinks(E,p=D()){const w=L(),f=[];for(let v=1,m=E.getLineCount();v<=m;v++){const a=E.getLineContent(v),g=a.length;let n=0,d=0,s=0,i=1,r=!1,c=!1,o=!1,u=!1;for(;n<g;){let h=!1;const y=a.charCodeAt(n);if(i===13){let R;switch(y){case 40:r=!0,R=0;break;case 41:R=r?0:1;break;case 91:o=!0,c=!0,R=0;break;case 93:o=!1,R=c?0:1;break;case 123:u=!0,R=0;break;case 125:R=u?0:1;break;case 39:R=s===39?1:0;break;case 34:R=s===34?1:0;break;case 96:R=s===96?1:0;break;case 42:R=s===42?1:0;break;case 124:R=s===124?1:0;break;case 32:R=o?0:1;break;default:R=w.get(y)}R===1&&(f.push(k._createLink(w,a,v,d,n)),h=!0)}else if(i===12){let R;y===91?(c=!0,R=0):R=w.get(y),R===1?h=!0:i=13}else i=p.nextState(i,y),i===0&&(h=!0);h&&(i=1,r=!1,c=!1,u=!1,d=n+1,s=y),n++}i===13&&f.push(k._createLink(w,a,v,d,g))}return f}}e.LinkComputer=k;function S(T){return!T||typeof T.getLineCount!="function"||typeof T.getLineContent!="function"?[]:k.computeLinks(T)}e.computeLinks=S}),define(De[100],Ie([1,0,24]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var t;(function(m){m[m.Left=1]="Left",m[m.Center=2]="Center",m[m.Right=4]="Right",m[m.Full=7]="Full"})(t=e.OverviewRulerLane||(e.OverviewRulerLane={}));var C;(function(m){m[m.Inline=1]="Inline",m[m.Gutter=2]="Gutter"})(C=e.MinimapPosition||(e.MinimapPosition={}));var P;(function(m){m[m.Both=0]="Both",m[m.Right=1]="Right",m[m.Left=2]="Left",m[m.None=3]="None"})(P=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var _;(function(m){m[m.TextDefined=0]="TextDefined",m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(_=e.EndOfLinePreference||(e.EndOfLinePreference={}));var D;(function(m){m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(D=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var b;(function(m){m[m.LF=0]="LF",m[m.CRLF=1]="CRLF"})(b=e.EndOfLineSequence||(e.EndOfLineSequence={}));class I{constructor(a){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,a.tabSize|0),this.indentSize=a.tabSize|0,this.insertSpaces=Boolean(a.insertSpaces),this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=Boolean(a.trimAutoWhitespace),this.bracketPairColorizationOptions=a.bracketPairColorizationOptions}equals(a){return this.tabSize===a.tabSize&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace&&(0,l.equals)(this.bracketPairColorizationOptions,a.bracketPairColorizationOptions)}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}e.TextModelResolvedOptions=I;class L{constructor(a,g){this._findMatchBrand=void 0,this.range=a,this.matches=g}}e.FindMatch=L;var k;(function(m){m[m.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",m[m.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",m[m.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",m[m.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(k=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));function S(m){return m&&typeof m.read=="function"}e.isITextSnapshot=S;var T;(function(m){m[m.Left=0]="Left",m[m.Right=1]="Right",m[m.None=2]="None",m[m.LeftOfInjectedText=3]="LeftOfInjectedText",m[m.RightOfInjectedText=4]="RightOfInjectedText"})(T=e.PositionAffinity||(e.PositionAffinity={}));var E;(function(m){m[m.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(E=e.ModelConstants||(e.ModelConstants={}));class p{constructor(a,g,n,d,s,i){this.identifier=a,this.range=g,this.text=n,this.forceMoveMarkers=d,this.isAutoWhitespaceEdit=s,this._isTracked=i}}e.ValidAnnotatedEditOperation=p;class w{constructor(a,g,n){this.regex=a,this.wordSeparators=g,this.simpleSearch=n}}e.SearchData=w;class f{constructor(a,g,n){this.reverseEdits=a,this.changes=g,this.trimAutoWhitespaceLineNumbers=n}}e.ApplyEditsResult=f;function v(m){return!m.isTooLargeForSyncing()&&!m.isForSimpleWidget}e.shouldSynchronizeModel=v}),define(De[150],Ie([1,0,17,97]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class C{constructor(b){this.values=b,this.prefixSum=new Uint32Array(b.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(b,I){b=(0,t.toUint32)(b);const L=this.values,k=this.prefixSum,S=I.length;return S===0?!1:(this.values=new Uint32Array(L.length+S),this.values.set(L.subarray(0,b),0),this.values.set(L.subarray(b),b+S),this.values.set(I,b),b-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=b-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(b,I){return b=(0,t.toUint32)(b),I=(0,t.toUint32)(I),this.values[b]===I?!1:(this.values[b]=I,b-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=b-1),!0)}removeValues(b,I){b=(0,t.toUint32)(b),I=(0,t.toUint32)(I);const L=this.values,k=this.prefixSum;if(b>=L.length)return!1;const S=L.length-b;return I>=S&&(I=S),I===0?!1:(this.values=new Uint32Array(L.length-I),this.values.set(L.subarray(0,b),0),this.values.set(L.subarray(b+I),b),this.prefixSum=new Uint32Array(this.values.length),b-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=b-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(b){return b<0?0:(b=(0,t.toUint32)(b),this._getPrefixSum(b))}_getPrefixSum(b){if(b<=this.prefixSumValidIndex[0])return this.prefixSum[b];let I=this.prefixSumValidIndex[0]+1;I===0&&(this.prefixSum[0]=this.values[0],I++),b>=this.values.length&&(b=this.values.length-1);for(let L=I;L<=b;L++)this.prefixSum[L]=this.prefixSum[L-1]+this.values[L];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],b),this.prefixSum[b]}getIndexOf(b){b=Math.floor(b),this.getTotalSum();let I=0,L=this.values.length-1,k=0,S=0,T=0;for(;I<=L;)if(k=I+(L-I)/2|0,S=this.prefixSum[k],T=S-this.values[k],b<T)L=k-1;else if(b>=S)I=k+1;else break;return new _(k,b-T)}}e.PrefixSumComputer=C;class P{constructor(b){this._values=b,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(b){return this._ensureValid(),b===0?0:this._prefixSum[b-1]}getIndexOf(b){this._ensureValid();const I=this._indexBySum[b],L=I>0?this._prefixSum[I-1]:0;return new _(I,b-L)}removeValues(b,I){this._values.splice(b,I),this._invalidate(b)}insertValues(b,I){this._values=(0,l.arrayInsert)(this._values,b,I),this._invalidate(b)}_invalidate(b){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,b-1)}_ensureValid(){if(!this._isValid){for(let b=this._validEndIndex+1,I=this._values.length;b<I;b++){const L=this._values[b],k=b>0?this._prefixSum[b-1]:0;this._prefixSum[b]=k+L;for(let S=0;S<L;S++)this._indexBySum[k+S]=b}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(b,I){this._values[b]!==I&&(this._values[b]=I,this._invalidate(b))}}e.ConstantTimePrefixSumComputer=P;class _{constructor(b,I){this.index=b,this.remainder=I,this._prefixSumIndexOfResultBrand=void 0,this.index=b,this.remainder=I}}e.PrefixSumIndexOfResult=_}),define(De[151],Ie([19,20]),function(J,e){return J.create("vs/base/common/date",e)}),define(De[152],Ie([1,0,151]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,C=t*60,P=C*24,_=P*7,D=P*30,b=P*365;function I(k,S,T){typeof k!="number"&&(k=k.getTime());const E=Math.round((new Date().getTime()-k)/1e3);if(E<-30)return(0,l.localize)(0,null,I(new Date().getTime()+E*1e3,!1));if(E<30)return(0,l.localize)(1,null);let p;return E<t?(p=E,S?p===1?T?(0,l.localize)(2,null,p):(0,l.localize)(3,null,p):T?(0,l.localize)(4,null,p):(0,l.localize)(5,null,p):p===1?T?(0,l.localize)(6,null,p):(0,l.localize)(7,null,p):T?(0,l.localize)(8,null,p):(0,l.localize)(9,null,p)):E<C?(p=Math.floor(E/t),S?p===1?T?(0,l.localize)(10,null,p):(0,l.localize)(11,null,p):T?(0,l.localize)(12,null,p):(0,l.localize)(13,null,p):p===1?T?(0,l.localize)(14,null,p):(0,l.localize)(15,null,p):T?(0,l.localize)(16,null,p):(0,l.localize)(17,null,p)):E<P?(p=Math.floor(E/C),S?p===1?T?(0,l.localize)(18,null,p):(0,l.localize)(19,null,p):T?(0,l.localize)(20,null,p):(0,l.localize)(21,null,p):p===1?T?(0,l.localize)(22,null,p):(0,l.localize)(23,null,p):T?(0,l.localize)(24,null,p):(0,l.localize)(25,null,p)):E<_?(p=Math.floor(E/P),S?p===1?(0,l.localize)(26,null,p):(0,l.localize)(27,null,p):p===1?(0,l.localize)(28,null,p):(0,l.localize)(29,null,p)):E<D?(p=Math.floor(E/_),S?p===1?T?(0,l.localize)(30,null,p):(0,l.localize)(31,null,p):T?(0,l.localize)(32,null,p):(0,l.localize)(33,null,p):p===1?T?(0,l.localize)(34,null,p):(0,l.localize)(35,null,p):T?(0,l.localize)(36,null,p):(0,l.localize)(37,null,p)):E<b?(p=Math.floor(E/D),S?p===1?T?(0,l.localize)(38,null,p):(0,l.localize)(39,null,p):T?(0,l.localize)(40,null,p):(0,l.localize)(41,null,p):p===1?T?(0,l.localize)(42,null,p):(0,l.localize)(43,null,p):T?(0,l.localize)(44,null,p):(0,l.localize)(45,null,p)):(p=Math.floor(E/b),S?p===1?T?(0,l.localize)(46,null,p):(0,l.localize)(47,null,p):T?(0,l.localize)(48,null,p):(0,l.localize)(49,null,p):p===1?T?(0,l.localize)(50,null,p):(0,l.localize)(51,null,p):T?(0,l.localize)(52,null,p):(0,l.localize)(53,null,p))}e.fromNow=I;function L(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=L}),define(De[153],Ie([19,20]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(De[50],Ie([1,0,17,14,153]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function P(k,S){return S&&(k.stack||k.stacktrace)?C.localize(0,null,D(k),_(k.stack)||_(k.stacktrace)):D(k)}function _(k){return Array.isArray(k)?k.join(`
`):k}function D(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?C.localize(1,null,k.message):k.message||C.localize(2,null)}function b(k=null,S=!1){if(!k)return C.localize(3,null);if(Array.isArray(k)){const T=l.coalesce(k),E=b(T[0],S);return T.length>1?C.localize(4,null,E,T.length):E}if(t.isString(k))return k;if(k.detail){const T=k.detail;if(T.error)return P(T.error,S);if(T.exception)return P(T.exception,S)}return k.stack?P(k,S):k.message?k.message:C.localize(5,null)}e.toErrorMessage=b;function I(k){const S=k;return S instanceof Error&&Array.isArray(S.actions)}e.isErrorWithActions=I;function L(k,S){let T;return typeof k=="string"?T=new Error(k):T=k,T.actions=S,T}e.createErrorWithActions=L}),define(De[154],Ie([19,20]),function(J,e){return J.create("vs/base/common/platform",e)}),define(De[11],Ie([1,0,154]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const t="en";let C=!1,P=!1,_=!1,D=!1,b=!1,I=!1,L=!1,k=!1,S=!1,T=!1,E,p=t,w,f;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let v;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?v=e.globals.vscode.process:typeof process<"u"&&(v=process);const m=typeof v?.versions?.electron=="string",a=m&&v?.type==="renderer";if(typeof navigator=="object"&&!a)f=navigator.userAgent,C=f.indexOf("Windows")>=0,P=f.indexOf("Macintosh")>=0,k=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,_=f.indexOf("Linux")>=0,T=f?.indexOf("Mobi")>=0,I=!0,E=l.getConfiguredDefaultLocale(l.localize(0,null))||t,p=E;else if(typeof v=="object"){C=v.platform==="win32",P=v.platform==="darwin",_=v.platform==="linux",D=_&&!!v.env.SNAP&&!!v.env.SNAP_REVISION,L=m,S=!!v.env.CI||!!v.env.BUILD_ARTIFACTSTAGINGDIRECTORY,E=t,p=t;const u=v.env.VSCODE_NLS_CONFIG;if(u)try{const h=JSON.parse(u),y=h.availableLanguages["*"];E=h.locale,p=y||t,w=h._translationsConfigFile}catch{}b=!0}else console.error("Unable to resolve platform.");var g;(function(u){u[u.Web=0]="Web",u[u.Mac=1]="Mac",u[u.Linux=2]="Linux",u[u.Windows=3]="Windows"})(g=e.Platform||(e.Platform={}));function n(u){switch(u){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=n;let d=0;P?d=1:C?d=3:_&&(d=2),e.isWindows=C,e.isMacintosh=P,e.isLinux=_,e.isLinuxSnap=D,e.isNative=b,e.isElectron=L,e.isWeb=I,e.isWebWorker=I&&typeof e.globals.importScripts=="function",e.isIOS=k,e.isMobile=T,e.isCI=S,e.platform=d,e.userAgent=f,e.language=p;var s;(function(u){function h(){return e.language}u.value=h;function y(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}u.isDefaultVariant=y;function R(){return e.language==="en"}u.isDefault=R})(s=e.Language||(e.Language={})),e.locale=E,e.translationsConfigFile=w,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const u=[];e.globals.addEventListener("message",y=>{if(y.data&&y.data.vscodeScheduleAsyncWork)for(let R=0,M=u.length;R<M;R++){const U=u[R];if(U.id===y.data.vscodeScheduleAsyncWork){u.splice(R,1),U.callback();return}}});let h=0;return y=>{const R=++h;u.push({id:R,callback:y}),e.globals.postMessage({vscodeScheduleAsyncWork:R},"*")}}return u=>setTimeout(u)})();var i;(function(u){u[u.Windows=1]="Windows",u[u.Macintosh=2]="Macintosh",u[u.Linux=3]="Linux"})(i=e.OperatingSystem||(e.OperatingSystem={})),e.OS=P||k?2:C?1:3;let r=!0,c=!1;function o(){if(!c){c=!0;const u=new Uint8Array(2);u[0]=1,u[1]=2,r=new Uint16Array(u.buffer)[0]===(2<<8)+1}return r}e.isLittleEndian=o,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(De[40],Ie([1,0,11]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof l.globals.vscode<"u"&&typeof l.globals.vscode.process<"u"){const C=l.globals.vscode.process;t={get platform(){return C.platform},get arch(){return C.arch},get env(){return C.env},cwd(){return C.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return l.isWindows?"win32":l.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(De[9],Ie([1,0,40]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,C=97,P=90,_=122,D=46,b=47,I=92,L=58,k=63;class S extends Error{constructor(a,g,n){let d;typeof g=="string"&&g.indexOf("not ")===0?(d="must not be",g=g.replace(/^not /,"")):d="must be";const s=a.indexOf(".")!==-1?"property":"argument";let i=`The "${a}" ${s} ${d} of type ${g}`;i+=`. Received type ${typeof n}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function T(m,a){if(typeof m!="string")throw new S(a,"string",m)}function E(m){return m===b||m===I}function p(m){return m===b}function w(m){return m>=t&&m<=P||m>=C&&m<=_}function f(m,a,g,n){let d="",s=0,i=-1,r=0,c=0;for(let o=0;o<=m.length;++o){if(o<m.length)c=m.charCodeAt(o);else{if(n(c))break;c=b}if(n(c)){if(!(i===o-1||r===1))if(r===2){if(d.length<2||s!==2||d.charCodeAt(d.length-1)!==D||d.charCodeAt(d.length-2)!==D){if(d.length>2){const u=d.lastIndexOf(g);u===-1?(d="",s=0):(d=d.slice(0,u),s=d.length-1-d.lastIndexOf(g)),i=o,r=0;continue}else if(d.length!==0){d="",s=0,i=o,r=0;continue}}a&&(d+=d.length>0?`${g}..`:"..",s=2)}else d.length>0?d+=`${g}${m.slice(i+1,o)}`:d=m.slice(i+1,o),s=o-i-1;i=o,r=0}else c===D&&r!==-1?++r:r=-1}return d}function v(m,a){if(a===null||typeof a!="object")throw new S("pathObject","Object",a);const g=a.dir||a.root,n=a.base||`${a.name||""}${a.ext||""}`;return g?g===a.root?`${g}${n}`:`${g}${m}${n}`:n}e.win32={resolve(...m){let a="",g="",n=!1;for(let d=m.length-1;d>=-1;d--){let s;if(d>=0){if(s=m[d],T(s,"path"),s.length===0)continue}else a.length===0?s=l.cwd():(s=l.env[`=${a}`]||l.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==a.toLowerCase()&&s.charCodeAt(2)===I)&&(s=`${a}\\`));const i=s.length;let r=0,c="",o=!1;const u=s.charCodeAt(0);if(i===1)E(u)&&(r=1,o=!0);else if(E(u))if(o=!0,E(s.charCodeAt(1))){let h=2,y=h;for(;h<i&&!E(s.charCodeAt(h));)h++;if(h<i&&h!==y){const R=s.slice(y,h);for(y=h;h<i&&E(s.charCodeAt(h));)h++;if(h<i&&h!==y){for(y=h;h<i&&!E(s.charCodeAt(h));)h++;(h===i||h!==y)&&(c=`\\\\${R}\\${s.slice(y,h)}`,r=h)}}}else r=1;else w(u)&&s.charCodeAt(1)===L&&(c=s.slice(0,2),r=2,i>2&&E(s.charCodeAt(2))&&(o=!0,r=3));if(c.length>0)if(a.length>0){if(c.toLowerCase()!==a.toLowerCase())continue}else a=c;if(n){if(a.length>0)break}else if(g=`${s.slice(r)}\\${g}`,n=o,o&&a.length>0)break}return g=f(g,!n,"\\",E),n?`${a}\\${g}`:`${a}${g}`||"."},normalize(m){T(m,"path");const a=m.length;if(a===0)return".";let g=0,n,d=!1;const s=m.charCodeAt(0);if(a===1)return p(s)?"\\":m;if(E(s))if(d=!0,E(m.charCodeAt(1))){let r=2,c=r;for(;r<a&&!E(m.charCodeAt(r));)r++;if(r<a&&r!==c){const o=m.slice(c,r);for(c=r;r<a&&E(m.charCodeAt(r));)r++;if(r<a&&r!==c){for(c=r;r<a&&!E(m.charCodeAt(r));)r++;if(r===a)return`\\\\${o}\\${m.slice(c)}\\`;r!==c&&(n=`\\\\${o}\\${m.slice(c,r)}`,g=r)}}}else g=1;else w(s)&&m.charCodeAt(1)===L&&(n=m.slice(0,2),g=2,a>2&&E(m.charCodeAt(2))&&(d=!0,g=3));let i=g<a?f(m.slice(g),!d,"\\",E):"";return i.length===0&&!d&&(i="."),i.length>0&&E(m.charCodeAt(a-1))&&(i+="\\"),n===void 0?d?`\\${i}`:i:d?`${n}\\${i}`:`${n}${i}`},isAbsolute(m){T(m,"path");const a=m.length;if(a===0)return!1;const g=m.charCodeAt(0);return E(g)||a>2&&w(g)&&m.charCodeAt(1)===L&&E(m.charCodeAt(2))},join(...m){if(m.length===0)return".";let a,g;for(let s=0;s<m.length;++s){const i=m[s];T(i,"path"),i.length>0&&(a===void 0?a=g=i:a+=`\\${i}`)}if(a===void 0)return".";let n=!0,d=0;if(typeof g=="string"&&E(g.charCodeAt(0))){++d;const s=g.length;s>1&&E(g.charCodeAt(1))&&(++d,s>2&&(E(g.charCodeAt(2))?++d:n=!1))}if(n){for(;d<a.length&&E(a.charCodeAt(d));)d++;d>=2&&(a=`\\${a.slice(d)}`)}return e.win32.normalize(a)},relative(m,a){if(T(m,"from"),T(a,"to"),m===a)return"";const g=e.win32.resolve(m),n=e.win32.resolve(a);if(g===n||(m=g.toLowerCase(),a=n.toLowerCase(),m===a))return"";let d=0;for(;d<m.length&&m.charCodeAt(d)===I;)d++;let s=m.length;for(;s-1>d&&m.charCodeAt(s-1)===I;)s--;const i=s-d;let r=0;for(;r<a.length&&a.charCodeAt(r)===I;)r++;let c=a.length;for(;c-1>r&&a.charCodeAt(c-1)===I;)c--;const o=c-r,u=i<o?i:o;let h=-1,y=0;for(;y<u;y++){const M=m.charCodeAt(d+y);if(M!==a.charCodeAt(r+y))break;M===I&&(h=y)}if(y!==u){if(h===-1)return n}else{if(o>u){if(a.charCodeAt(r+y)===I)return n.slice(r+y+1);if(y===2)return n.slice(r+y)}i>u&&(m.charCodeAt(d+y)===I?h=y:y===2&&(h=3)),h===-1&&(h=0)}let R="";for(y=d+h+1;y<=s;++y)(y===s||m.charCodeAt(y)===I)&&(R+=R.length===0?"..":"\\..");return r+=h,R.length>0?`${R}${n.slice(r,c)}`:(n.charCodeAt(r)===I&&++r,n.slice(r,c))},toNamespacedPath(m){if(typeof m!="string")return m;if(m.length===0)return"";const a=e.win32.resolve(m);if(a.length<=2)return m;if(a.charCodeAt(0)===I){if(a.charCodeAt(1)===I){const g=a.charCodeAt(2);if(g!==k&&g!==D)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(w(a.charCodeAt(0))&&a.charCodeAt(1)===L&&a.charCodeAt(2)===I)return`\\\\?\\${a}`;return m},dirname(m){T(m,"path");const a=m.length;if(a===0)return".";let g=-1,n=0;const d=m.charCodeAt(0);if(a===1)return E(d)?m:".";if(E(d)){if(g=n=1,E(m.charCodeAt(1))){let r=2,c=r;for(;r<a&&!E(m.charCodeAt(r));)r++;if(r<a&&r!==c){for(c=r;r<a&&E(m.charCodeAt(r));)r++;if(r<a&&r!==c){for(c=r;r<a&&!E(m.charCodeAt(r));)r++;if(r===a)return m;r!==c&&(g=n=r+1)}}}}else w(d)&&m.charCodeAt(1)===L&&(g=a>2&&E(m.charCodeAt(2))?3:2,n=g);let s=-1,i=!0;for(let r=a-1;r>=n;--r)if(E(m.charCodeAt(r))){if(!i){s=r;break}}else i=!1;if(s===-1){if(g===-1)return".";s=g}return m.slice(0,s)},basename(m,a){a!==void 0&&T(a,"ext"),T(m,"path");let g=0,n=-1,d=!0,s;if(m.length>=2&&w(m.charCodeAt(0))&&m.charCodeAt(1)===L&&(g=2),a!==void 0&&a.length>0&&a.length<=m.length){if(a===m)return"";let i=a.length-1,r=-1;for(s=m.length-1;s>=g;--s){const c=m.charCodeAt(s);if(E(c)){if(!d){g=s+1;break}}else r===-1&&(d=!1,r=s+1),i>=0&&(c===a.charCodeAt(i)?--i===-1&&(n=s):(i=-1,n=r))}return g===n?n=r:n===-1&&(n=m.length),m.slice(g,n)}for(s=m.length-1;s>=g;--s)if(E(m.charCodeAt(s))){if(!d){g=s+1;break}}else n===-1&&(d=!1,n=s+1);return n===-1?"":m.slice(g,n)},extname(m){T(m,"path");let a=0,g=-1,n=0,d=-1,s=!0,i=0;m.length>=2&&m.charCodeAt(1)===L&&w(m.charCodeAt(0))&&(a=n=2);for(let r=m.length-1;r>=a;--r){const c=m.charCodeAt(r);if(E(c)){if(!s){n=r+1;break}continue}d===-1&&(s=!1,d=r+1),c===D?g===-1?g=r:i!==1&&(i=1):g!==-1&&(i=-1)}return g===-1||d===-1||i===0||i===1&&g===d-1&&g===n+1?"":m.slice(g,d)},format:v.bind(null,"\\"),parse(m){T(m,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return a;const g=m.length;let n=0,d=m.charCodeAt(0);if(g===1)return E(d)?(a.root=a.dir=m,a):(a.base=a.name=m,a);if(E(d)){if(n=1,E(m.charCodeAt(1))){let h=2,y=h;for(;h<g&&!E(m.charCodeAt(h));)h++;if(h<g&&h!==y){for(y=h;h<g&&E(m.charCodeAt(h));)h++;if(h<g&&h!==y){for(y=h;h<g&&!E(m.charCodeAt(h));)h++;h===g?n=h:h!==y&&(n=h+1)}}}}else if(w(d)&&m.charCodeAt(1)===L){if(g<=2)return a.root=a.dir=m,a;if(n=2,E(m.charCodeAt(2))){if(g===3)return a.root=a.dir=m,a;n=3}}n>0&&(a.root=m.slice(0,n));let s=-1,i=n,r=-1,c=!0,o=m.length-1,u=0;for(;o>=n;--o){if(d=m.charCodeAt(o),E(d)){if(!c){i=o+1;break}continue}r===-1&&(c=!1,r=o+1),d===D?s===-1?s=o:u!==1&&(u=1):s!==-1&&(u=-1)}return r!==-1&&(s===-1||u===0||u===1&&s===r-1&&s===i+1?a.base=a.name=m.slice(i,r):(a.name=m.slice(i,s),a.base=m.slice(i,r),a.ext=m.slice(s,r))),i>0&&i!==n?a.dir=m.slice(0,i-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...m){let a="",g=!1;for(let n=m.length-1;n>=-1&&!g;n--){const d=n>=0?m[n]:l.cwd();T(d,"path"),d.length!==0&&(a=`${d}/${a}`,g=d.charCodeAt(0)===b)}return a=f(a,!g,"/",p),g?`/${a}`:a.length>0?a:"."},normalize(m){if(T(m,"path"),m.length===0)return".";const a=m.charCodeAt(0)===b,g=m.charCodeAt(m.length-1)===b;return m=f(m,!a,"/",p),m.length===0?a?"/":g?"./":".":(g&&(m+="/"),a?`/${m}`:m)},isAbsolute(m){return T(m,"path"),m.length>0&&m.charCodeAt(0)===b},join(...m){if(m.length===0)return".";let a;for(let g=0;g<m.length;++g){const n=m[g];T(n,"path"),n.length>0&&(a===void 0?a=n:a+=`/${n}`)}return a===void 0?".":e.posix.normalize(a)},relative(m,a){if(T(m,"from"),T(a,"to"),m===a||(m=e.posix.resolve(m),a=e.posix.resolve(a),m===a))return"";const g=1,n=m.length,d=n-g,s=1,i=a.length-s,r=d<i?d:i;let c=-1,o=0;for(;o<r;o++){const h=m.charCodeAt(g+o);if(h!==a.charCodeAt(s+o))break;h===b&&(c=o)}if(o===r)if(i>r){if(a.charCodeAt(s+o)===b)return a.slice(s+o+1);if(o===0)return a.slice(s+o)}else d>r&&(m.charCodeAt(g+o)===b?c=o:o===0&&(c=0));let u="";for(o=g+c+1;o<=n;++o)(o===n||m.charCodeAt(o)===b)&&(u+=u.length===0?"..":"/..");return`${u}${a.slice(s+c)}`},toNamespacedPath(m){return m},dirname(m){if(T(m,"path"),m.length===0)return".";const a=m.charCodeAt(0)===b;let g=-1,n=!0;for(let d=m.length-1;d>=1;--d)if(m.charCodeAt(d)===b){if(!n){g=d;break}}else n=!1;return g===-1?a?"/":".":a&&g===1?"//":m.slice(0,g)},basename(m,a){a!==void 0&&T(a,"ext"),T(m,"path");let g=0,n=-1,d=!0,s;if(a!==void 0&&a.length>0&&a.length<=m.length){if(a===m)return"";let i=a.length-1,r=-1;for(s=m.length-1;s>=0;--s){const c=m.charCodeAt(s);if(c===b){if(!d){g=s+1;break}}else r===-1&&(d=!1,r=s+1),i>=0&&(c===a.charCodeAt(i)?--i===-1&&(n=s):(i=-1,n=r))}return g===n?n=r:n===-1&&(n=m.length),m.slice(g,n)}for(s=m.length-1;s>=0;--s)if(m.charCodeAt(s)===b){if(!d){g=s+1;break}}else n===-1&&(d=!1,n=s+1);return n===-1?"":m.slice(g,n)},extname(m){T(m,"path");let a=-1,g=0,n=-1,d=!0,s=0;for(let i=m.length-1;i>=0;--i){const r=m.charCodeAt(i);if(r===b){if(!d){g=i+1;break}continue}n===-1&&(d=!1,n=i+1),r===D?a===-1?a=i:s!==1&&(s=1):a!==-1&&(s=-1)}return a===-1||n===-1||s===0||s===1&&a===n-1&&a===g+1?"":m.slice(a,n)},format:v.bind(null,"/"),parse(m){T(m,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return a;const g=m.charCodeAt(0)===b;let n;g?(a.root="/",n=1):n=0;let d=-1,s=0,i=-1,r=!0,c=m.length-1,o=0;for(;c>=n;--c){const u=m.charCodeAt(c);if(u===b){if(!r){s=c+1;break}continue}i===-1&&(r=!1,i=c+1),u===D?d===-1?d=c:o!==1&&(o=1):d!==-1&&(o=-1)}if(i!==-1){const u=s===0&&g?1:s;d===-1||o===0||o===1&&d===i-1&&d===s+1?a.base=a.name=m.slice(u,i):(a.name=m.slice(u,d),a.base=m.slice(u,i),a.ext=m.slice(d,i))}return s>0?a.dir=m.slice(0,s-1):g&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=l.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=l.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=l.platform==="win32"?e.win32.join:e.posix.join,e.resolve=l.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=l.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=l.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=l.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=l.platform==="win32"?e.win32.extname:e.posix.extname,e.format=l.platform==="win32"?e.win32.format:e.posix.format,e.parse=l.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=l.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=l.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=l.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(De[101],Ie([1,0,9]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const t={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function P(L){const k=(0,l.extname)(L),S=t[k.toLowerCase()];return S!==void 0?S:_(L)}e.getMediaOrTextMime=P;function _(L){const k=(0,l.extname)(L);return C[k.toLowerCase()]}e.getMediaMime=_;function D(L){for(const k in C)if(C[k]===L)return k}e.getExtensionForMimeType=D;const b=/^(.+)\/(.+?)(;.+)?$/;function I(L,k){const S=b.exec(L);return S?`${S[1].toLowerCase()}/${S[2].toLowerCase()}${S[3]??""}`:k?void 0:L}e.normalizeMimeType=I}),define(De[102],Ie([1,0,11]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(D){D[D.stdout=0]="stdout",D[D.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var C;(function(D){D[D.Success=0]="Success",D[D.Unknown=1]="Unknown",D[D.AccessDenied=2]="AccessDenied",D[D.ProcessNotFound=3]="ProcessNotFound"})(C=e.TerminateResponseCode||(e.TerminateResponseCode={}));function P(D,...b){const I=b.reduce((S,T)=>(S[T]=!0,S),{}),L=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(D).filter(S=>!I[S]).forEach(S=>{for(let T=0;T<L.length;T++)if(S.search(L[T])!==-1){delete D[S];break}})}e.sanitizeProcessEnvironment=P;function _(D){!D||(delete D.DEBUG,l.isMacintosh&&delete D.DYLD_LIBRARY_PATH,l.isLinux&&delete D.LD_PRELOAD)}e.removeDangerousEnvVariables=_}),define(De[51],Ie([1,0,11]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=l.globals.performance&&typeof l.globals.performance.now=="function";class C{constructor(_){this._highResolution=t&&_,this._startTime=this._now(),this._stopTime=-1}static create(_=!0){return new C(_)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?l.globals.performance.now():Date.now()}}e.StopWatch=C}),define(De[4],Ie([1,0,10,59,6,77,51]),function(J,e,l,t,C,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;const D=!1,b=!1;var I;(function(c){c.None=()=>C.Disposable.None;function o(pe){if(b){const{onListenerDidAdd:be}=pe,ke=E.create();let Oe=0;pe.onListenerDidAdd=()=>{++Oe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ke.print()),be?.()}}}function u(pe){return(be,ke=null,Oe)=>{let We=!1,oe;return oe=pe(le=>{if(!We)return oe?oe.dispose():We=!0,be.call(ke,le)},null,Oe),We&&oe.dispose(),oe}}c.once=u;function h(pe,be,ke){return z((Oe,We=null,oe)=>pe(le=>Oe.call(We,be(le)),null,oe),ke)}c.map=h;function y(pe,be,ke){return z((Oe,We=null,oe)=>pe(le=>{be(le),Oe.call(We,le)},null,oe),ke)}c.forEach=y;function R(pe,be,ke){return z((Oe,We=null,oe)=>pe(le=>be(le)&&Oe.call(We,le),null,oe),ke)}c.filter=R;function M(pe){return pe}c.signal=M;function U(...pe){return(be,ke=null,Oe)=>(0,C.combinedDisposable)(...pe.map(We=>We(oe=>be.call(ke,oe),null,Oe)))}c.any=U;function A(pe,be,ke,Oe){let We=ke;return h(pe,oe=>(We=be(We,oe),We),Oe)}c.reduce=A;function z(pe,be){let ke;const Oe={onFirstListenerAdd(){ke=pe(We.fire,We)},onLastListenerRemove(){ke?.dispose()}};be||o(Oe);const We=new w(Oe);return be?.add(We),We.event}function $(pe,be,ke=100,Oe=!1,We,oe){let le,fe,Z,ae=0;const ee={leakWarningThreshold:We,onFirstListenerAdd(){le=pe(F=>{ae++,fe=be(fe,F),Oe&&!Z&&(ie.fire(fe),fe=void 0),clearTimeout(Z),Z=setTimeout(()=>{const H=fe;fe=void 0,Z=void 0,(!Oe||ae>1)&&ie.fire(H),ae=0},ke)})},onLastListenerRemove(){le.dispose()}};oe||o(ee);const ie=new w(ee);return oe?.add(ie),ie.event}c.debounce=$;function N(pe,be=(Oe,We)=>Oe===We,ke){let Oe=!0,We;return R(pe,oe=>{const le=Oe||!be(oe,We);return Oe=!1,We=oe,le},ke)}c.latch=N;function K(pe,be,ke){return[c.filter(pe,be,ke),c.filter(pe,Oe=>!be(Oe),ke)]}c.split=K;function B(pe,be=!1,ke=[]){let Oe=ke.slice(),We=pe(fe=>{Oe?Oe.push(fe):le.fire(fe)});const oe=()=>{Oe?.forEach(fe=>le.fire(fe)),Oe=null},le=new w({onFirstListenerAdd(){We||(We=pe(fe=>le.fire(fe)))},onFirstListenerDidAdd(){Oe&&(be?setTimeout(oe):oe())},onLastListenerRemove(){We&&We.dispose(),We=null}});return le.event}c.buffer=B;class O{constructor(be){this.event=be,this.disposables=new C.DisposableStore}map(be){return new O(h(this.event,be,this.disposables))}forEach(be){return new O(y(this.event,be,this.disposables))}filter(be){return new O(R(this.event,be,this.disposables))}reduce(be,ke){return new O(A(this.event,be,ke,this.disposables))}latch(){return new O(N(this.event,void 0,this.disposables))}debounce(be,ke=100,Oe=!1,We){return new O($(this.event,be,ke,Oe,We,this.disposables))}on(be,ke,Oe){return this.event(be,ke,Oe)}once(be,ke,Oe){return u(this.event)(be,ke,Oe)}dispose(){this.disposables.dispose()}}function x(pe){return new O(pe)}c.chain=x;function V(pe,be,ke=Oe=>Oe){const Oe=(...fe)=>le.fire(ke(...fe)),We=()=>pe.on(be,Oe),oe=()=>pe.removeListener(be,Oe),le=new w({onFirstListenerAdd:We,onLastListenerRemove:oe});return le.event}c.fromNodeEventEmitter=V;function q(pe,be,ke=Oe=>Oe){const Oe=(...fe)=>le.fire(ke(...fe)),We=()=>pe.addEventListener(be,Oe),oe=()=>pe.removeEventListener(be,Oe),le=new w({onFirstListenerAdd:We,onLastListenerRemove:oe});return le.event}c.fromDOMEventEmitter=q;function Y(pe){return new Promise(be=>u(pe)(be))}c.toPromise=Y;function Q(pe,be){return be(void 0),pe(ke=>be(ke))}c.runAndSubscribe=Q;function de(pe,be){let ke=null;function Oe(oe){ke?.dispose(),ke=new C.DisposableStore,be(oe,ke)}Oe(void 0);const We=pe(oe=>Oe(oe));return(0,C.toDisposable)(()=>{We.dispose(),ke?.dispose()})}c.runAndSubscribeWithStore=de;class ve{constructor(be,ke){this.obs=be,this._counter=0,this._hasChanged=!1;const Oe={onFirstListenerAdd:()=>{be.addObserver(this)},onLastListenerRemove:()=>{be.removeObserver(this)}};ke||o(Oe),this.emitter=new w(Oe),ke&&ke.add(this.emitter)}beginUpdate(be){this._counter++}handleChange(be,ke){this._hasChanged=!0}endUpdate(be){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function ne(pe,be){return new ve(pe,be).emitter.event}c.fromObservable=ne})(I=e.Event||(e.Event={}));class L{constructor(o){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${o}_${L._idPool++}`}start(o){this._stopWatch=new _.StopWatch(!0),this._listenerCount=o}stop(){if(this._stopWatch){const o=this._stopWatch.elapsed();this._elapsedOverall+=o,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${o.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}L._idPool=0;let k=-1;function S(c){const o=k;return k=c,{dispose(){k=o}}}e.setGlobalLeakWarningThreshold=S;class T{constructor(o,u=Math.random().toString(18).slice(2,5)){this.customThreshold=o,this.name=u,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(o,u){let h=k;if(typeof this.customThreshold=="number"&&(h=this.customThreshold),h<=0||u<h)return;this._stacks||(this._stacks=new Map);const y=this._stacks.get(o.value)||0;if(this._stacks.set(o.value,y+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=h*.5;let R,M=0;for(const[U,A]of this._stacks)(!R||M<A)&&(R=U,M=A);console.warn(`[${this.name}] potential listener LEAK detected, having ${u} listeners already. MOST frequent listener (${M}):`),console.warn(R)}return()=>{const R=this._stacks.get(o.value)||0;this._stacks.set(o.value,R-1)}}}class E{constructor(o){this.value=o}static create(){return new E(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class p{constructor(o,u,h){this.callback=o,this.callbackThis=u,this.stack=h,this.subscription=new C.SafeDisposable}invoke(o){this.callback.call(this.callbackThis,o)}}class w{constructor(o){this._disposed=!1,this._options=o,this._leakageMon=k>0?new T(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new L(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(D){const o=Array.from(this._listeners);queueMicrotask(()=>{for(const u of o)u.subscription.isset()&&(u.subscription.unset(),u.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(o,u,h)=>{this._listeners||(this._listeners=new P.LinkedList);const y=this._listeners.isEmpty();y&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let R,M;this._leakageMon&&this._listeners.size>=30&&(M=E.create(),R=this._leakageMon.check(M,this._listeners.size+1)),D&&(M=M??E.create());const U=new p(o,u,M),A=this._listeners.push(U);y&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,o,u);const z=U.subscription.set(()=>{R?.(),this._disposed||(A(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return h instanceof C.DisposableStore?h.add(z):Array.isArray(h)&&h.push(z),z}),this._event}fire(o){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new v);for(const u of this._listeners)this._deliveryQueue.push(this,u,o);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=w;class f{constructor(){this._queue=new P.LinkedList}get size(){return this._queue.size}push(o,u,h){this._queue.push(new m(o,u,h))}clear(o){const u=new P.LinkedList;for(const h of this._queue)h.emitter!==o&&u.push(h);this._queue=u}deliver(){for(;this._queue.size>0;){const o=this._queue.shift();try{o.listener.invoke(o.event)}catch(u){(0,l.onUnexpectedError)(u)}}}}e.EventDeliveryQueue=f;class v extends f{clear(o){this._queue.clear()}}class m{constructor(o,u,h){this.emitter=o,this.listener=u,this.event=h}}class a extends w{async fireAsync(o,u,h){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new P.LinkedList);for(const y of this._listeners)this._asyncDeliveryQueue.push([y,o]);for(;this._asyncDeliveryQueue.size>0&&!u.isCancellationRequested;){const[y,R]=this._asyncDeliveryQueue.shift(),M=[],U={...R,token:u,waitUntil:A=>{if(Object.isFrozen(M))throw new Error("waitUntil can NOT be called asynchronous");h&&(A=h(A,y.callback)),M.push(A)}};try{y.invoke(U)}catch(A){(0,l.onUnexpectedError)(A);continue}Object.freeze(M),await Promise.allSettled(M).then(A=>{for(const z of A)z.status==="rejected"&&(0,l.onUnexpectedError)(z.reason)})}}}}e.AsyncEmitter=a;class g extends w{constructor(o){super(o),this._isPaused=0,this._eventQueue=new P.LinkedList,this._mergeFn=o?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){const o=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(o))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(o){this._listeners&&(this._isPaused!==0?this._eventQueue.push(o):super.fire(o))}}e.PauseableEmitter=g;class n extends g{constructor(o){super(o),this._delay=o.delay??100}fire(o){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(o)}}e.DebounceEmitter=n;class d extends w{constructor(o){super(o),this._queuedEvents=[],this._mergeFn=o?.merge}fire(o){!this.hasListeners()||(this._queuedEvents.push(o),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(u=>super.fire(u)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=d;class s{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new w({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(o){const u={event:o,listener:null};this.events.push(u),this.hasListeners&&this.hook(u);const h=()=>{this.hasListeners&&this.unhook(u);const y=this.events.indexOf(u);this.events.splice(y,1)};return(0,C.toDisposable)((0,t.once)(h))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(o=>this.hook(o))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(o=>this.unhook(o))}hook(o){o.listener=o.event(u=>this.emitter.fire(u))}unhook(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=s;class i{constructor(){this.buffers=[]}wrapEvent(o){return(u,h,y)=>o(R=>{const M=this.buffers[this.buffers.length-1];M?M.push(()=>u.call(h,R)):u.call(h,R)},void 0,y)}bufferEvents(o){const u=[];this.buffers.push(u);const h=o();return this.buffers.pop(),u.forEach(y=>y()),h}}e.EventBufferer=i;class r{constructor(){this.listening=!1,this.inputEvent=I.None,this.inputEventListener=C.Disposable.None,this.emitter=new w({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(o){this.inputEvent=o,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=o(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=r}),define(De[21],Ie([1,0,4]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(D,b){const I=setTimeout(D.bind(b),0);return{dispose(){clearTimeout(I)}}});var C;(function(D){function b(I){return I===D.None||I===D.Cancelled||I instanceof P?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}D.isCancellationToken=b,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:l.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(C=e.CancellationToken||(e.CancellationToken={}));class P{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new l.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class _{constructor(b){this._token=void 0,this._parentListener=void 0,this._parentListener=b&&b.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new P),this._token}cancel(){this._token?this._token instanceof P&&this._token.cancel():this._token=C.Cancelled}dispose(b=!1){b&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof P&&this._token.dispose():this._token=C.None}}e.CancellationTokenSource=_}),define(De[155],Ie([1,0,21]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(D){this.task=D,this.result=null}get(){if(this.result)return this.result;const D=new l.CancellationTokenSource,b=this.task(D.token);return this.result={promise:b,dispose:()=>{this.result=null,D.cancel(),D.dispose()}},this.result}}e.Cache=t;class C{constructor(D){this.fn=D,this.lastCache=void 0,this.lastArgKey=void 0}get(D){const b=JSON.stringify(D);return this.lastArgKey!==b&&(this.lastArgKey=b,this.lastCache=this.fn(D)),this.lastCache}}e.LRUCachedFunction=C;class P{constructor(D){this.fn=D,this._map=new Map}get cachedValues(){return this._map}get(D){if(this._map.has(D))return this._map.get(D);const b=this.fn(D);return this._map.set(D,b),b}}e.CachedFunction=P}),define(De[8],Ie([1,0,155,76]),function(J,e,l,t){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function P(ue){return!ue||typeof ue!="string"?!0:ue.trim().length===0}e.isFalsyOrWhitespace=P;const _=/{(\d+)}/g;function D(ue,...Te){return Te.length===0?ue:ue.replace(_,function(Me,Be){const ze=parseInt(Be,10);return isNaN(ze)||ze<0||ze>=Te.length?Me:Te[ze]})}e.format=D;const b=/{([^}]+)}/g;function I(ue,Te){return ue.replace(b,(Me,Be)=>Te[Be]??Me)}e.format2=I;function L(ue){return ue.replace(/[<>&]/g,function(Te){switch(Te){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Te}})}e.escape=L;function k(ue){return ue.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=k;function S(ue,Te){let Me=0;const Be=Te.charCodeAt(0);for(let ze=ue.length-1;ze>=0;ze--)ue.charCodeAt(ze)===Be&&Me++;return Me}e.count=S;function T(ue,Te,Me="\u2026"){return ue.length<=Te?ue:`${ue.substr(0,Te)}${Me}`}e.truncate=T;function E(ue,Te=" "){const Me=p(ue,Te);return w(Me,Te)}e.trim=E;function p(ue,Te){if(!ue||!Te)return ue;const Me=Te.length;if(Me===0||ue.length===0)return ue;let Be=0;for(;ue.indexOf(Te,Be)===Be;)Be=Be+Me;return ue.substring(Be)}e.ltrim=p;function w(ue,Te){if(!ue||!Te)return ue;const Me=Te.length,Be=ue.length;if(Me===0||Be===0)return ue;let ze=Be,Ye=-1;for(;Ye=ue.lastIndexOf(Te,ze-1),!(Ye===-1||Ye+Me!==ze);){if(Ye===0)return"";ze=Ye}return ue.substring(0,ze)}e.rtrim=w;function f(ue){return ue.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=f;function v(ue){return ue.replace(/\*/g,"")}e.stripWildcards=v;function m(ue,Te,Me={}){if(!ue)throw new Error("Cannot create regex from empty string");Te||(ue=k(ue)),Me.wholeWord&&(/\B/.test(ue.charAt(0))||(ue="\\b"+ue),/\B/.test(ue.charAt(ue.length-1))||(ue=ue+"\\b"));let Be="";return Me.global&&(Be+="g"),Me.matchCase||(Be+="i"),Me.multiline&&(Be+="m"),Me.unicode&&(Be+="u"),new RegExp(ue,Be)}e.createRegExp=m;function a(ue){return ue.source==="^"||ue.source==="^$"||ue.source==="$"||ue.source==="^\\s*$"?!1:!!(ue.exec("")&&ue.lastIndex===0)}e.regExpLeadsToEndlessLoop=a;function g(ue){return!!ue.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=g;function n(ue){return(ue.global?"g":"")+(ue.ignoreCase?"i":"")+(ue.multiline?"m":"")+(ue.unicode?"u":"")}e.regExpFlags=n;function d(ue){return ue.split(/\r\n|\r|\n/)}e.splitLines=d;function s(ue){for(let Te=0,Me=ue.length;Te<Me;Te++){const Be=ue.charCodeAt(Te);if(Be!==32&&Be!==9)return Te}return-1}e.firstNonWhitespaceIndex=s;function i(ue,Te=0,Me=ue.length){for(let Be=Te;Be<Me;Be++){const ze=ue.charCodeAt(Be);if(ze!==32&&ze!==9)return ue.substring(Te,Be)}return ue.substring(Te,Me)}e.getLeadingWhitespace=i;function r(ue,Te=ue.length-1){for(let Me=Te;Me>=0;Me--){const Be=ue.charCodeAt(Me);if(Be!==32&&Be!==9)return Me}return-1}e.lastNonWhitespaceIndex=r;function c(ue,Te,Me){const Be=[];let ze=0;for(const Ye of ue.matchAll(Te)){if(Be.push(ue.slice(ze,Ye.index)),Ye.index===void 0)throw new Error("match.index should be defined");ze=Ye.index+Ye[0].length,Be.push(Me(Ye[0],...Ye.slice(1),Ye.index,ue,Ye.groups))}return Be.push(ue.slice(ze)),Promise.all(Be).then(Ye=>Ye.join(""))}e.replaceAsync=c;function o(ue,Te){return ue<Te?-1:ue>Te?1:0}e.compare=o;function u(ue,Te,Me=0,Be=ue.length,ze=0,Ye=Te.length){for(;Me<Be&&ze<Ye;Me++,ze++){const st=ue.charCodeAt(Me),et=Te.charCodeAt(ze);if(st<et)return-1;if(st>et)return 1}const it=Be-Me,ct=Ye-ze;return it<ct?-1:it>ct?1:0}e.compareSubstring=u;function h(ue,Te){return y(ue,Te,0,ue.length,0,Te.length)}e.compareIgnoreCase=h;function y(ue,Te,Me=0,Be=ue.length,ze=0,Ye=Te.length){for(;Me<Be&&ze<Ye;Me++,ze++){let st=ue.charCodeAt(Me),et=Te.charCodeAt(ze);if(st===et)continue;if(st>=128||et>=128)return u(ue.toLowerCase(),Te.toLowerCase(),Me,Be,ze,Ye);M(st)&&(st-=32),M(et)&&(et-=32);const ft=st-et;if(ft!==0)return ft}const it=Be-Me,ct=Ye-ze;return it<ct?-1:it>ct?1:0}e.compareSubstringIgnoreCase=y;function R(ue){return ue>=48&&ue<=57}e.isAsciiDigit=R;function M(ue){return ue>=97&&ue<=122}e.isLowerAsciiLetter=M;function U(ue){return ue>=65&&ue<=90}e.isUpperAsciiLetter=U;function A(ue,Te){return ue.length===Te.length&&y(ue,Te)===0}e.equalsIgnoreCase=A;function z(ue,Te){const Me=Te.length;return Te.length>ue.length?!1:y(ue,Te,0,Me)===0}e.startsWithIgnoreCase=z;function $(ue,Te){const Me=Math.min(ue.length,Te.length);let Be;for(Be=0;Be<Me;Be++)if(ue.charCodeAt(Be)!==Te.charCodeAt(Be))return Be;return Me}e.commonPrefixLength=$;function N(ue,Te){const Me=Math.min(ue.length,Te.length);let Be;const ze=ue.length-1,Ye=Te.length-1;for(Be=0;Be<Me;Be++)if(ue.charCodeAt(ze-Be)!==Te.charCodeAt(Ye-Be))return Be;return Me}e.commonSuffixLength=N;function K(ue){return 55296<=ue&&ue<=56319}e.isHighSurrogate=K;function B(ue){return 56320<=ue&&ue<=57343}e.isLowSurrogate=B;function O(ue,Te){return(ue-55296<<10)+(Te-56320)+65536}e.computeCodePoint=O;function x(ue,Te,Me){const Be=ue.charCodeAt(Me);if(K(Be)&&Me+1<Te){const ze=ue.charCodeAt(Me+1);if(B(ze))return O(Be,ze)}return Be}e.getNextCodePoint=x;function V(ue,Te){const Me=ue.charCodeAt(Te-1);if(B(Me)&&Te>1){const Be=ue.charCodeAt(Te-2);if(K(Be))return O(Be,Me)}return Me}class q{constructor(Te,Me=0){this._str=Te,this._len=Te.length,this._offset=Me}get offset(){return this._offset}setOffset(Te){this._offset=Te}prevCodePoint(){const Te=V(this._str,this._offset);return this._offset-=Te>=65536?2:1,Te}nextCodePoint(){const Te=x(this._str,this._len,this._offset);return this._offset+=Te>=65536?2:1,Te}eol(){return this._offset>=this._len}}e.CodePointIterator=q;class Y{constructor(Te,Me=0){this._iterator=new q(Te,Me)}get offset(){return this._iterator.offset}nextGraphemeLength(){const Te=Ve.getInstance(),Me=this._iterator,Be=Me.offset;let ze=Te.getGraphemeBreakType(Me.nextCodePoint());for(;!Me.eol();){const Ye=Me.offset,it=Te.getGraphemeBreakType(Me.nextCodePoint());if(ye(ze,it)){Me.setOffset(Ye);break}ze=it}return Me.offset-Be}prevGraphemeLength(){const Te=Ve.getInstance(),Me=this._iterator,Be=Me.offset;let ze=Te.getGraphemeBreakType(Me.prevCodePoint());for(;Me.offset>0;){const Ye=Me.offset,it=Te.getGraphemeBreakType(Me.prevCodePoint());if(ye(it,ze)){Me.setOffset(Ye);break}ze=it}return Be-Me.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=Y;function Q(ue,Te){return new Y(ue,Te).nextGraphemeLength()}e.nextCharLength=Q;function de(ue,Te){return new Y(ue,Te).prevGraphemeLength()}e.prevCharLength=de;function ve(ue,Te){Te>0&&B(ue.charCodeAt(Te))&&Te--;const Me=Te+Q(ue,Te);return[Me-de(ue,Me),Me]}e.getCharContainingOffset=ve;let ne;function pe(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function be(ue){return ne||(ne=pe()),ne.test(ue)}e.containsRTL=be;const ke=/^[\t\n\r\x20-\x7E]*$/;function Oe(ue){return ke.test(ue)}e.isBasicASCII=Oe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function We(ue){return e.UNUSUAL_LINE_TERMINATORS.test(ue)}e.containsUnusualLineTerminators=We;function oe(ue){return ue>=11904&&ue<=55215||ue>=63744&&ue<=64255||ue>=65281&&ue<=65374}e.isFullWidthCharacter=oe;function le(ue){return ue>=127462&&ue<=127487||ue===8986||ue===8987||ue===9200||ue===9203||ue>=9728&&ue<=10175||ue===11088||ue===11093||ue>=127744&&ue<=128591||ue>=128640&&ue<=128764||ue>=128992&&ue<=129008||ue>=129280&&ue<=129535||ue>=129648&&ue<=129782}e.isEmojiImprecise=le;function fe(ue,Te){if(ue.length<Te)return ue;const Me=/\b/g;let Be=0;for(;Me.test(ue)&&!(ue.length-Me.lastIndex<Te);)Be=Me.lastIndex,Me.lastIndex+=1;return ue.substring(Be).replace(/^\s/,"")}e.lcut=fe;const Z=/\x1B\x5B[12]?K/g,ae=/\x1b\[\d+m/g,ee=/\x1b\[0?m/g;function ie(ue){return ue&&(ue=ue.replace(Z,""),ue=ue.replace(ae,""),ue=ue.replace(ee,"")),ue}e.removeAnsiEscapeCodes=ie,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function F(ue){return!!(ue&&ue.length>0&&ue.charCodeAt(0)===65279)}e.startsWithUTF8BOM=F;function H(ue){return F(ue)?ue.substr(1):ue}e.stripUTF8BOM=H;function G(ue,Te){if(!ue||!Te||ue.length<Te.length)return!1;const Me=Te.length,Be=ue.toLowerCase();let ze=0,Ye=-1;for(;ze<Me;){const it=Be.indexOf(Te[ze],Ye+1);if(it<0)return!1;Ye=it,ze++}return!0}e.fuzzyContains=G;function X(ue,Te=!1){return ue?(Te&&(ue=ue.replace(/\\./g,"")),ue.toLowerCase()!==ue):!1}e.containsUppercaseCharacter=X;function me(ue){return ue.charAt(0).toUpperCase()+ue.slice(1)}e.uppercaseFirstLetter=me;function we(ue,Te=1){if(Te===0)return"";let Me=-1;do Me=ue.indexOf(`
`,Me+1),Te--;while(Te>0&&Me>=0);return Me===-1?ue:(ue[Me-1]==="\r"&&Me--,ue.substr(0,Me))}e.getNLines=we;function ce(ue){return ue=ue%(2*26),ue<26?String.fromCharCode(97+ue):String.fromCharCode(65+ue-26)}e.singleLetterHash=ce;function Ce(ue){return Ve.getInstance().getGraphemeBreakType(ue)}e.getGraphemeBreakType=Ce;function ye(ue,Te){return ue===0?Te!==5&&Te!==7:ue===2&&Te===3?!1:ue===4||ue===2||ue===3||Te===4||Te===2||Te===3?!0:!(ue===8&&(Te===8||Te===9||Te===11||Te===12)||(ue===11||ue===9)&&(Te===9||Te===10)||(ue===12||ue===10)&&Te===10||Te===5||Te===13||Te===7||ue===1||ue===13&&Te===14||ue===6&&Te===6)}var $e;(function(ue){ue[ue.Other=0]="Other",ue[ue.Prepend=1]="Prepend",ue[ue.CR=2]="CR",ue[ue.LF=3]="LF",ue[ue.Control=4]="Control",ue[ue.Extend=5]="Extend",ue[ue.Regional_Indicator=6]="Regional_Indicator",ue[ue.SpacingMark=7]="SpacingMark",ue[ue.L=8]="L",ue[ue.V=9]="V",ue[ue.T=10]="T",ue[ue.LV=11]="LV",ue[ue.LVT=12]="LVT",ue[ue.ZWJ=13]="ZWJ",ue[ue.Extended_Pictographic=14]="Extended_Pictographic"})($e=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ve{constructor(){this._data=Ze()}static getInstance(){return Ve._INSTANCE||(Ve._INSTANCE=new Ve),Ve._INSTANCE}getGraphemeBreakType(Te){if(Te<32)return Te===10?3:Te===13?2:4;if(Te<127)return 0;const Me=this._data,Be=Me.length/3;let ze=1;for(;ze<=Be;)if(Te<Me[3*ze])ze=2*ze;else if(Te>Me[3*ze+1])ze=2*ze+1;else return Me[3*ze+2];return 0}}Ve._INSTANCE=null;function Ze(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Qe(ue,Te){if(ue===0)return 0;const Me=Le(ue,Te);if(Me!==void 0)return Me;const Be=new q(Te,ue);return Be.prevCodePoint(),Be.offset}e.getLeftDeleteOffset=Qe;function Le(ue,Te){const Me=new q(Te,ue);let Be=Me.prevCodePoint();for(;ot(Be)||Be===65039||Be===8419;){if(Me.offset===0)return;Be=Me.prevCodePoint()}if(!le(Be))return;let ze=Me.offset;return ze>0&&Me.prevCodePoint()===8205&&(ze=Me.offset),ze}function ot(ue){return 127995<=ue&&ue<=127999}var re;(function(ue){ue[ue.zwj=8205]="zwj",ue[ue.emojiVariantSelector=65039]="emojiVariantSelector",ue[ue.enclosingKeyCap=8419]="enclosingKeyCap"})(re||(re={})),e.noBreakWhitespace="\xA0";class se{constructor(Te){this.confusableDictionary=Te}static getInstance(Te){return se.cache.get(Array.from(Te))}static getLocales(){return se._locales.getValue()}isAmbiguous(Te){return this.confusableDictionary.has(Te)}getPrimaryConfusable(Te){return this.confusableDictionary.get(Te)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=se,C=se,se.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),se.cache=new l.LRUCachedFunction(ue=>{function Te(et){const ft=new Map;for(let Et=0;Et<et.length;Et+=2)ft.set(et[Et],et[Et+1]);return ft}function Me(et,ft){const Et=new Map(et);for(const[Dt,mt]of ft)Et.set(Dt,mt);return Et}function Be(et,ft){if(!et)return ft;const Et=new Map;for(const[Dt,mt]of et)ft.has(Dt)&&Et.set(Dt,mt);return Et}const ze=C.ambiguousCharacterData.getValue();let Ye=ue.filter(et=>!et.startsWith("_")&&et in ze);Ye.length===0&&(Ye=["_default"]);let it;for(const et of Ye){const ft=Te(ze[et]);it=Be(it,ft)}const ct=Te(ze._common),st=Me(ct,it);return new se(st)}),se._locales=new t.Lazy(()=>Object.keys(se.ambiguousCharacterData.getValue()).filter(ue=>!ue.startsWith("_")));class Ee{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ee.getRawData())),this._data}static isInvisibleCharacter(Te){return Ee.getData().has(Te)}static get codePoints(){return Ee.getData()}}e.InvisibleCharacters=Ee,Ee._data=void 0}),define(De[31],Ie([1,0,9,11,8,14]),function(J,e,l,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function _(r){return r===47||r===92}e.isPathSeparator=_;function D(r){return r.replace(/[\\/]/g,l.posix.sep)}e.toSlashes=D;function b(r){return r.indexOf("/")===-1&&(r=D(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=b;function I(r,c=l.posix.sep){if(!r)return"";const o=r.length,u=r.charCodeAt(0);if(_(u)){if(_(r.charCodeAt(1))&&!_(r.charCodeAt(2))){let y=3;const R=y;for(;y<o&&!_(r.charCodeAt(y));y++);if(R!==y&&!_(r.charCodeAt(y+1))){for(y+=1;y<o;y++)if(_(r.charCodeAt(y)))return r.slice(0,y+1).replace(/[\\/]/g,c)}}return c}else if(f(u)&&r.charCodeAt(1)===58)return _(r.charCodeAt(2))?r.slice(0,2)+c:r.slice(0,2);let h=r.indexOf("://");if(h!==-1){for(h+=3;h<o;h++)if(_(r.charCodeAt(h)))return r.slice(0,h+1)}return""}e.getRoot=I;function L(r){if(!t.isWindows||!r||r.length<5)return!1;let c=r.charCodeAt(0);if(c!==92||(c=r.charCodeAt(1),c!==92))return!1;let o=2;const u=o;for(;o<r.length&&(c=r.charCodeAt(o),c!==92);o++);return!(u===o||(c=r.charCodeAt(o+1),isNaN(c)||c===92))}e.isUNC=L;const k=/[\\/:\*\?"<>\|]/g,S=/[\\/]/g,T=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function E(r,c=t.isWindows){const o=c?k:S;return!(!r||r.length===0||/^\s+$/.test(r)||(o.lastIndex=0,o.test(r))||c&&T.test(r)||r==="."||r===".."||c&&r[r.length-1]==="."||c&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=E;function p(r,c,o){const u=r===c;return!o||u?u:!r||!c?!1:(0,C.equalsIgnoreCase)(r,c)}e.isEqual=p;function w(r,c,o,u=l.sep){if(r===c)return!0;if(!r||!c||c.length>r.length)return!1;if(o){if(!(0,C.startsWithIgnoreCase)(r,c))return!1;if(c.length===r.length)return!0;let y=c.length;return c.charAt(c.length-1)===u&&y--,r.charAt(y)===u}return c.charAt(c.length-1)!==u&&(c+=u),r.indexOf(c)===0}e.isEqualOrParent=w;function f(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=f;function v(r,c){return t.isWindows&&r.endsWith(":")&&(r+=l.sep),(0,l.isAbsolute)(r)||(r=(0,l.join)(c,r)),r=(0,l.normalize)(r),t.isWindows?(r=(0,C.rtrim)(r,l.sep),r.endsWith(":")&&(r+=l.sep)):(r=(0,C.rtrim)(r,l.sep),r||(r=l.sep)),r}e.sanitizeFilePath=v;function m(r){const c=(0,l.normalize)(r);return t.isWindows?r.length>3?!1:a(c)&&(r.length===2||c.charCodeAt(2)===92):c===l.posix.sep}e.isRootOrDriveLetter=m;function a(r,c=t.isWindows){return c?f(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=a;function g(r){return a(r)?r[0]:void 0}e.getDriveLetter=g;function n(r,c,o){return c.length>r.length?-1:r===c?0:(o&&(r=r.toLowerCase(),c=c.toLowerCase()),r.indexOf(c))}e.indexOfPath=n;function d(r){const c=r.split(":");let o,u,h;for(const y of c){const R=Number(y);(0,P.isNumber)(R)?u===void 0?u=R:h===void 0&&(h=R):o=o?[o,y].join(":"):y}if(!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:u!==void 0?u:void 0,column:h!==void 0?h:u!==void 0?1:void 0}}e.parseLineAndColumnAware=d;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(r,c,o=8){let u="";for(let y=0;y<o;y++)u+=s.charAt(Math.floor(Math.random()*s.length));let h;return c?h=`${c}-${u}`:h=u,r?(0,l.join)(r,h):h}e.randomPath=i}),define(De[78],Ie([1,0,8]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(f){return C(f,0)}e.hash=t;function C(f,v){switch(typeof f){case"object":return f===null?P(349,v):Array.isArray(f)?b(f,v):I(f,v);case"string":return D(f,v);case"boolean":return _(f,v);case"number":return P(f,v);case"undefined":return P(937,v);default:return P(617,v)}}e.doHash=C;function P(f,v){return(v<<5)-v+f|0}e.numberHash=P;function _(f,v){return P(f?433:863,v)}function D(f,v){v=P(149417,v);for(let m=0,a=f.length;m<a;m++)v=P(f.charCodeAt(m),v);return v}e.stringHash=D;function b(f,v){return v=P(104579,v),f.reduce((m,a)=>C(a,m),v)}function I(f,v){return v=P(181387,v),Object.keys(f).sort().reduce((m,a)=>(m=D(a,m),C(f[a],m)),v)}class L{constructor(){this._value=0}get value(){return this._value}hash(v){return this._value=C(v,this._value),this._value}}e.Hasher=L;var k;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function S(f,v,m=32){const a=m-v,g=~((1<<a)-1);return(f<<v|(g&f)>>>a)>>>0}function T(f,v=0,m=f.byteLength,a=0){for(let g=0;g<m;g++)f[v+g]=a}function E(f,v,m="0"){for(;f.length<v;)f=m+f;return f}function p(f,v=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(m=>m.toString(16).padStart(2,"0")).join(""):E((f>>>0).toString(16),v/4)}e.toHexString=p;class w{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(v){const m=v.length;if(m===0)return;const a=this._buff;let g=this._buffLen,n=this._leftoverHighSurrogate,d,s;for(n!==0?(d=n,s=-1,n=0):(d=v.charCodeAt(0),s=0);;){let i=d;if(l.isHighSurrogate(d))if(s+1<m){const r=v.charCodeAt(s+1);l.isLowSurrogate(r)?(s++,i=l.computeCodePoint(d,r)):i=65533}else{n=d;break}else l.isLowSurrogate(d)&&(i=65533);if(g=this._push(a,g,i),s++,s<m)d=v.charCodeAt(s);else break}this._buffLen=g,this._leftoverHighSurrogate=n}_push(v,m,a){return a<128?v[m++]=a:a<2048?(v[m++]=192|(a&1984)>>>6,v[m++]=128|(a&63)>>>0):a<65536?(v[m++]=224|(a&61440)>>>12,v[m++]=128|(a&4032)>>>6,v[m++]=128|(a&63)>>>0):(v[m++]=240|(a&1835008)>>>18,v[m++]=128|(a&258048)>>>12,v[m++]=128|(a&4032)>>>6,v[m++]=128|(a&63)>>>0),m>=64&&(this._step(),m-=64,this._totalLen+=64,v[0]=v[64+0],v[1]=v[64+1],v[2]=v[64+2]),m}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),p(this._h0)+p(this._h1)+p(this._h2)+p(this._h3)+p(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,T(this._buff,this._buffLen),this._buffLen>56&&(this._step(),T(this._buff));const v=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(v/4294967296),!1),this._buffDV.setUint32(60,v%4294967296,!1),this._step()}_step(){const v=w._bigBlock32,m=this._buffDV;for(let o=0;o<64;o+=4)v.setUint32(o,m.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)v.setUint32(o,S(v.getUint32(o-12,!1)^v.getUint32(o-32,!1)^v.getUint32(o-56,!1)^v.getUint32(o-64,!1),1),!1);let a=this._h0,g=this._h1,n=this._h2,d=this._h3,s=this._h4,i,r,c;for(let o=0;o<80;o++)o<20?(i=g&n|~g&d,r=1518500249):o<40?(i=g^n^d,r=1859775393):o<60?(i=g&n|g&d|n&d,r=2400959708):(i=g^n^d,r=3395469782),c=S(a,5)+i+s+r+v.getUint32(o*4,!1)&4294967295,s=d,d=n,n=S(g,30),g=a,a=c;this._h0=this._h0+a&4294967295,this._h1=this._h1+g&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+d&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=w,w._bigBlock32=new DataView(new ArrayBuffer(320))}),define(De[25],Ie([1,0,17,8]),function(J,e,l,t){"use strict";var C,P,_;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function D(s,i,r){let c=s.get(i);return c===void 0&&(c=r,s.set(i,c)),c}e.getOrSet=D;function b(s){const i=[];return s.forEach((r,c)=>{i.push(`${c} => ${r}`)}),`Map(${s.size}) {${i.join(", ")}}`}e.mapToString=b;function I(s){const i=[];return s.forEach(r=>{i.push(r)}),`Set(${s.size}) {${i.join(", ")}}`}e.setToString=I;class L{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const r=i.charCodeAt(0),c=this._value.charCodeAt(this._pos);return r-c}value(){return this._value[this._pos]}}e.StringIterator=L;class k{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=k;class S{constructor(i=!0,r=!0){this._splitOnBackslash=i,this._caseSensitive=r}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let r=i.length-1;r>=0;r--,this._valueLen--){const c=this._value.charCodeAt(r);if(!(c===47||this._splitOnBackslash&&c===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=S;var T;(function(s){s[s.Scheme=1]="Scheme",s[s.Authority=2]="Authority",s[s.Path=3]="Path",s[s.Query=4]="Query",s[s.Fragment=5]="Fragment"})(T||(T={}));class E{constructor(i,r){this._ignorePathCasing=i,this._ignoreQueryAndFragment=r,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new S(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(i)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,t.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=E;class p{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var w;(function(s){s[s.Left=-1]="Left",s[s.Mid=0]="Mid",s[s.Right=1]="Right"})(w||(w={}));class f{constructor(i){this._iter=i}static forUris(i=()=>!1,r=()=>!1){return new f(new E(i,r))}static forPaths(i=!1){return new f(new S(void 0,!i))}static forStrings(){return new f(new L)}static forConfigKeys(){return new f(new k)}clear(){this._root=void 0}fill(i,r){if(r){const c=r.slice(0);(0,l.shuffle)(c);for(const o of c)this.set(o,i)}else{const c=i.slice(0);(0,l.shuffle)(c);for(const o of c)this.set(o[0],o[1])}}set(i,r){const c=this._iter.reset(i);let o;this._root||(this._root=new p,this._root.segment=c.value());const u=[];for(o=this._root;;){const y=c.cmp(o.segment);if(y>0)o.left||(o.left=new p,o.left.segment=c.value()),u.push([-1,o]),o=o.left;else if(y<0)o.right||(o.right=new p,o.right.segment=c.value()),u.push([1,o]),o=o.right;else if(c.hasNext())c.next(),o.mid||(o.mid=new p,o.mid.segment=c.value()),u.push([0,o]),o=o.mid;else break}const h=o.value;o.value=r,o.key=i;for(let y=u.length-1;y>=0;y--){const R=u[y][1];R.updateHeight();const M=R.balanceFactor();if(M<-1||M>1){const U=u[y][0],A=u[y+1][0];if(U===1&&A===1)u[y][1]=R.rotateLeft();else if(U===-1&&A===-1)u[y][1]=R.rotateRight();else if(U===1&&A===-1)R.right=u[y+1][1]=u[y+1][1].rotateRight(),u[y][1]=R.rotateLeft();else if(U===-1&&A===1)R.left=u[y+1][1]=u[y+1][1].rotateLeft(),u[y][1]=R.rotateRight();else throw new Error;if(y>0)switch(u[y-1][0]){case-1:u[y-1][1].left=u[y][1];break;case 1:u[y-1][1].right=u[y][1];break;case 0:u[y-1][1].mid=u[y][1];break}else this._root=u[0][1]}}return h}get(i){return this._getNode(i)?.value}_getNode(i){const r=this._iter.reset(i);let c=this._root;for(;c;){const o=r.cmp(c.segment);if(o>0)c=c.left;else if(o<0)c=c.right;else if(r.hasNext())r.next(),c=c.mid;else break}return c}has(i){const r=this._getNode(i);return!(r?.value===void 0&&r?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,r){const c=this._iter.reset(i),o=[];let u=this._root;for(;u;){const h=c.cmp(u.segment);if(h>0)o.push([-1,u]),u=u.left;else if(h<0)o.push([1,u]),u=u.right;else if(c.hasNext())c.next(),o.push([0,u]),u=u.mid;else break}if(!!u){if(r?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const h=this._min(u.right),{key:y,value:R,segment:M}=h;this._delete(h.key,!1),u.key=y,u.value=R,u.segment=M}else{const h=u.left??u.right;if(o.length>0){const[y,R]=o[o.length-1];switch(y){case-1:R.left=h;break;case 0:R.mid=h;break;case 1:R.right=h;break}}else this._root=h}for(let h=o.length-1;h>=0;h--){const y=o[h][1];y.updateHeight();const R=y.balanceFactor();if(R>1?(y.right.balanceFactor()>=0||(y.right=y.right.rotateRight()),o[h][1]=y.rotateLeft()):R<-1&&(y.left.balanceFactor()<=0||(y.left=y.left.rotateLeft()),o[h][1]=y.rotateRight()),h>0)switch(o[h-1][0]){case-1:o[h-1][1].left=o[h][1];break;case 1:o[h-1][1].right=o[h][1];break;case 0:o[h-1][1].mid=o[h][1];break}else this._root=o[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const r=this._iter.reset(i);let c=this._root,o;for(;c;){const u=r.cmp(c.segment);if(u>0)c=c.left;else if(u<0)c=c.right;else if(r.hasNext())r.next(),o=c.value||o,c=c.mid;else break}return c&&c.value||o}findSuperstr(i){const r=this._iter.reset(i);let c=this._root;for(;c;){const o=r.cmp(c.segment);if(o>0)c=c.left;else if(o<0)c=c.right;else if(r.hasNext())r.next(),c=c.mid;else return c.mid?this._entries(c.mid):void 0}}forEach(i){for(const[r,c]of this)i(c,r)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(i){const r=[];return this._dfsEntries(i,r),r[Symbol.iterator]()}_dfsEntries(i,r){!i||(i.left&&this._dfsEntries(i.left,r),i.value&&r.push([i.key,i.value]),i.mid&&this._dfsEntries(i.mid,r),i.right&&this._dfsEntries(i.right,r))}_isBalanced(){const i=r=>{if(!r)return!0;const c=r.balanceFactor();return c<-1||c>1?!1:i(r.left)&&i(r.right)};return i(this._root)}}e.TernarySearchTree=f;class v{constructor(i,r){this.uri=i,this.value=r}}class m{constructor(i,r){this[C]="ResourceMap",i instanceof m?(this.map=new Map(i.map),this.toKey=r??m.defaultToKey):(this.map=new Map,this.toKey=i??m.defaultToKey)}set(i,r){return this.map.set(this.toKey(i),new v(i,r)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,r){typeof r<"u"&&(i=i.bind(r));for(const[c,o]of this.map)i(o.value,o.uri,this)}*values(){for(const i of this.map.values())yield i.value}*keys(){for(const i of this.map.values())yield i.uri}*entries(){for(const i of this.map.values())yield[i.uri,i.value]}*[(C=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=m,m.defaultToKey=s=>s.toString();class a{constructor(i,r){this[P]="ResourceSet",!i||typeof i=="function"?this._map=new m(i):(this._map=new m(r),i.forEach(this.add,this))}get size(){return this._map.size}add(i){return this._map.set(i,i),this}clear(){this._map.clear()}delete(i){return this._map.delete(i)}forEach(i,r){this._map.forEach((c,o)=>i.call(r,o,o,this))}has(i){return this._map.has(i)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=a;var g;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(g=e.Touch||(e.Touch={}));class n{constructor(){this[_]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,r=0){const c=this._map.get(i);if(!!c)return r!==0&&this.touch(c,r),c.value}set(i,r,c=0){let o=this._map.get(i);if(o)o.value=r,c!==0&&this.touch(o,c);else{switch(o={key:i,value:r,next:void 0,previous:void 0},c){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(i,o),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const r=this._map.get(i);if(!!r)return this._map.delete(i),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,r){const c=this._state;let o=this._head;for(;o;){if(r?i.bind(r)(o.value,o.key,this):i(o.value,o.key,this),this._state!==c)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const i=this,r=this._state;let c=this._head;const o={[Symbol.iterator](){return o},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(c){const u={value:c.key,done:!1};return c=c.next,u}else return{value:void 0,done:!0}}};return o}values(){const i=this,r=this._state;let c=this._head;const o={[Symbol.iterator](){return o},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(c){const u={value:c.value,done:!1};return c=c.next,u}else return{value:void 0,done:!0}}};return o}entries(){const i=this,r=this._state;let c=this._head;const o={[Symbol.iterator](){return o},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(c){const u={value:[c.key,c.value],done:!1};return c=c.next,u}else return{value:void 0,done:!0}}};return o}[(_=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let r=this._head,c=this.size;for(;r&&c>i;)this._map.delete(r.key),r=r.next,c--;this._head=r,this._size=c,r&&(r.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const r=i.next,c=i.previous;if(!r||!c)throw new Error("Invalid list");r.previous=c,c.next=r}i.next=void 0,i.previous=void 0,this._state++}touch(i,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(i===this._head)return;const c=i.next,o=i.previous;i===this._tail?(o.next=void 0,this._tail=o):(c.previous=o,o.next=c),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(r===2){if(i===this._tail)return;const c=i.next,o=i.previous;i===this._head?(c.previous=void 0,this._head=c):(c.previous=o,o.next=c),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((r,c)=>{i.push([c,r])}),i}fromJSON(i){this.clear();for(const[r,c]of i)this.set(r,c)}}e.LinkedMap=n;class d extends n{constructor(i,r=1){super(),this._limit=i,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,r=2){return super.get(i,r)}peek(i){return super.get(i,0)}set(i,r){return super.set(i,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=d}),define(De[103],Ie([1,0,25,8]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function C(...ee){return function(ie,F){for(let H=0,G=ee.length;H<G;H++){const X=ee[H](ie,F);if(X)return X}return null}}e.or=C,e.matchesStrictPrefix=P.bind(void 0,!1),e.matchesPrefix=P.bind(void 0,!0);function P(ee,ie,F){if(!F||F.length<ie.length)return null;let H;return ee?H=t.startsWithIgnoreCase(F,ie):H=F.indexOf(ie)===0,H?ie.length>0?[{start:0,end:ie.length}]:[]:null}function _(ee,ie){const F=ie.toLowerCase().indexOf(ee.toLowerCase());return F===-1?null:[{start:F,end:F+ee.length}]}e.matchesContiguousSubString=_;function D(ee,ie){return b(ee.toLowerCase(),ie.toLowerCase(),0,0)}e.matchesSubString=D;function b(ee,ie,F,H){if(F===ee.length)return[];if(H===ie.length)return null;if(ee[F]===ie[H]){let G=null;return(G=b(ee,ie,F+1,H+1))?f({start:H,end:H+1},G):null}return b(ee,ie,F,H+1)}function I(ee){return 97<=ee&&ee<=122}function L(ee){return 65<=ee&&ee<=90}e.isUpper=L;function k(ee){return 48<=ee&&ee<=57}function S(ee){return ee===32||ee===9||ee===10||ee===13}const T=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ee=>T.add(ee.charCodeAt(0)));function E(ee){return S(ee)||T.has(ee)}function p(ee,ie){return ee===ie||E(ee)&&E(ie)}function w(ee){return I(ee)||L(ee)||k(ee)}function f(ee,ie){return ie.length===0?ie=[ee]:ee.end===ie[0].start?ie[0].start=ee.start:ie.unshift(ee),ie}function v(ee,ie){for(let F=ie;F<ee.length;F++){const H=ee.charCodeAt(F);if(L(H)||k(H)||F>0&&!w(ee.charCodeAt(F-1)))return F}return ee.length}function m(ee,ie,F,H){if(F===ee.length)return[];if(H===ie.length)return null;if(ee[F]!==ie[H].toLowerCase())return null;{let G=null,X=H+1;for(G=m(ee,ie,F+1,H+1);!G&&(X=v(ie,X))<ie.length;)G=m(ee,ie,F+1,X),X++;return G===null?null:f({start:H,end:H+1},G)}}function a(ee){let ie=0,F=0,H=0,G=0,X=0;for(let ye=0;ye<ee.length;ye++)X=ee.charCodeAt(ye),L(X)&&ie++,I(X)&&F++,w(X)&&H++,k(X)&&G++;const me=ie/ee.length,we=F/ee.length,ce=H/ee.length,Ce=G/ee.length;return{upperPercent:me,lowerPercent:we,alphaPercent:ce,numericPercent:Ce}}function g(ee){const{upperPercent:ie,lowerPercent:F}=ee;return F===0&&ie>.6}function n(ee){const{upperPercent:ie,lowerPercent:F,alphaPercent:H,numericPercent:G}=ee;return F>.2&&ie<.8&&H>.6&&G<.2}function d(ee){let ie=0,F=0,H=0,G=0;for(let X=0;X<ee.length;X++)H=ee.charCodeAt(X),L(H)&&ie++,I(H)&&F++,S(H)&&G++;return(ie===0||F===0)&&G===0?ee.length<=30:ie<=5}function s(ee,ie){if(!ie||(ie=ie.trim(),ie.length===0)||!d(ee)||ie.length>60)return null;const F=a(ie);if(!n(F)){if(!g(F))return null;ie=ie.toLowerCase()}let H=null,G=0;for(ee=ee.toLowerCase();G<ie.length&&(H=m(ee,ie,0,G))===null;)G=v(ie,G+1);return H}e.matchesCamelCase=s;function i(ee,ie,F=!1){if(!ie||ie.length===0)return null;let H=null,G=0;for(ee=ee.toLowerCase(),ie=ie.toLowerCase();G<ie.length&&(H=r(ee,ie,0,G,F))===null;)G=c(ie,G+1);return H}e.matchesWords=i;function r(ee,ie,F,H,G){if(F===ee.length)return[];if(H===ie.length)return null;if(p(ee.charCodeAt(F),ie.charCodeAt(H))){let X=null,me=H+1;if(X=r(ee,ie,F+1,H+1,G),!G)for(;!X&&(me=c(ie,me))<ie.length;)X=r(ee,ie,F+1,me,G),me++;return X?ee.charCodeAt(F)!==ie.charCodeAt(H)?X:f({start:H,end:H+1},X):null}else return null}function c(ee,ie){for(let F=ie;F<ee.length;F++)if(E(ee.charCodeAt(F))||F>0&&E(ee.charCodeAt(F-1)))return F;return ee.length}const o=C(e.matchesPrefix,s,_),u=C(e.matchesPrefix,s,D),h=new l.LRUCache(1e4);function y(ee,ie,F=!1){if(typeof ee!="string"||typeof ie!="string")return null;let H=h.get(ee);H||(H=new RegExp(t.convertSimple2RegExpPattern(ee),"i"),h.set(ee,H));const G=H.exec(ie);return G?[{start:G.index,end:G.index+G[0].length}]:F?u(ee,ie):o(ee,ie)}e.matchesFuzzy=y;function R(ee,ie){const F=Oe(ee,ee.toLowerCase(),0,ie,ie.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return F?U(F):null}e.matchesFuzzy2=R;function M(ee,ie,F,H,G,X){const me=Math.min(13,ee.length);for(;F<me;F++){const we=Oe(ee,ie,F,H,G,X,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(we)return we}return[0,X]}e.anyScore=M;function U(ee){if(typeof ee>"u")return[];const ie=[],F=ee[1];for(let H=ee.length-1;H>1;H--){const G=ee[H]+F,X=ie[ie.length-1];X&&X.end===G?X.end=G+1:ie.push({start:G,end:G+1})}return ie}e.createMatches=U;const A=128;function z(){const ee=[],ie=[];for(let F=0;F<=A;F++)ie[F]=0;for(let F=0;F<=A;F++)ee.push(ie.slice(0));return ee}function $(ee){const ie=[];for(let F=0;F<=ee;F++)ie[F]=0;return ie}const N=$(2*A),K=$(2*A),B=z(),O=z(),x=z(),V=!1;function q(ee,ie,F,H,G){function X(we,ce,Ce=" "){for(;we.length<ce;)we=Ce+we;return we}let me=` |   |${H.split("").map(we=>X(we,3)).join("|")}
`;for(let we=0;we<=F;we++)we===0?me+=" |":me+=`${ie[we-1]}|`,me+=ee[we].slice(0,G+1).map(ce=>X(ce.toString(),3)).join("|")+`
`;return me}function Y(ee,ie,F,H){ee=ee.substr(ie),F=F.substr(H),console.log(q(O,ee,ee.length,F,F.length)),console.log(q(x,ee,ee.length,F,F.length)),console.log(q(B,ee,ee.length,F,F.length))}function Q(ee,ie){if(ie<0||ie>=ee.length)return!1;const F=ee.codePointAt(ie);switch(F){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(F)}}function de(ee,ie){if(ie<0||ie>=ee.length)return!1;switch(ee.charCodeAt(ie)){case 32:case 9:return!0;default:return!1}}function ve(ee,ie,F){return ie[ee]!==F[ee]}function ne(ee,ie,F,H,G,X,me=!1){for(;ie<F&&G<X;)ee[ie]===H[G]&&(me&&(N[ie]=G),ie+=1),G+=1;return ie===F}e.isPatternInWord=ne;var pe;(function(ee){ee[ee.Diag=1]="Diag",ee[ee.Left=2]="Left",ee[ee.LeftLeft=3]="LeftLeft"})(pe||(pe={}));var be;(function(ee){ee.Default=[-100,0];function ie(F){return!F||F.length===2&&F[0]===-100&&F[1]===0}ee.isDefault=ie})(be=e.FuzzyScore||(e.FuzzyScore={}));class ke{constructor(ie,F){this.firstMatchCanBeWeak=ie,this.boostFullMatch=F}}e.FuzzyScoreOptions=ke,ke.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Oe(ee,ie,F,H,G,X,me=ke.default){const we=ee.length>A?A:ee.length,ce=H.length>A?A:H.length;if(F>=we||X>=ce||we-F>ce-X||!ne(ie,F,we,G,X,ce,!0))return;We(we,ce,F,X,ie,G);let Ce=1,ye=1,$e=F,Ve=X;const Ze=[!1];for(Ce=1,$e=F;$e<we;Ce++,$e++){const se=N[$e],Ee=K[$e],ue=$e+1<we?K[$e+1]:ce;for(ye=se-X+1,Ve=se;Ve<ue;ye++,Ve++){let Te=Number.MIN_SAFE_INTEGER,Me=!1;Ve<=Ee&&(Te=oe(ee,ie,$e,F,H,G,Ve,ce,X,B[Ce-1][ye-1]===0,Ze));let Be=0;Te!==Number.MAX_SAFE_INTEGER&&(Me=!0,Be=Te+O[Ce-1][ye-1]);const ze=Ve>se,Ye=ze?O[Ce][ye-1]+(B[Ce][ye-1]>0?-5:0):0,it=Ve>se+1&&B[Ce][ye-1]>0,ct=it?O[Ce][ye-2]+(B[Ce][ye-2]>0?-5:0):0;if(it&&(!ze||ct>=Ye)&&(!Me||ct>=Be))O[Ce][ye]=ct,x[Ce][ye]=3,B[Ce][ye]=0;else if(ze&&(!Me||Ye>=Be))O[Ce][ye]=Ye,x[Ce][ye]=2,B[Ce][ye]=0;else if(Me)O[Ce][ye]=Be,x[Ce][ye]=1,B[Ce][ye]=B[Ce-1][ye-1]+1;else throw new Error("not possible")}}if(V&&Y(ee,F,H,X),!Ze[0]&&!me.firstMatchCanBeWeak)return;Ce--,ye--;const Qe=[O[Ce][ye],X];let Le=0,ot=0;for(;Ce>=1;){let se=ye;do{const Ee=x[Ce][se];if(Ee===3)se=se-2;else if(Ee===2)se=se-1;else break}while(se>=1);Le>1&&ie[F+Ce-1]===G[X+ye-1]&&!ve(se+X-1,H,G)&&Le+1>B[Ce][se]&&(se=ye),se===ye?Le++:Le=1,ot||(ot=se),Ce--,ye=se-1,Qe.push(ye)}ce===we&&me.boostFullMatch&&(Qe[0]+=2);const re=ot-we;return Qe[0]-=re,Qe}e.fuzzyScore=Oe;function We(ee,ie,F,H,G,X){let me=ee-1,we=ie-1;for(;me>=F&&we>=H;)G[me]===X[we]&&(K[me]=we,me--),we--}function oe(ee,ie,F,H,G,X,me,we,ce,Ce,ye){if(ie[F]!==X[me])return Number.MIN_SAFE_INTEGER;let $e=1,Ve=!1;return me===F-H?$e=ee[F]===G[me]?7:5:ve(me,G,X)&&(me===0||!ve(me-1,G,X))?($e=ee[F]===G[me]?7:5,Ve=!0):Q(X,me)&&(me===0||!Q(X,me-1))?$e=5:(Q(X,me-1)||de(X,me-1))&&($e=5,Ve=!0),$e>1&&F===H&&(ye[0]=!0),Ve||(Ve=ve(me,G,X)||Q(X,me-1)||de(X,me-1)),F===H?me>ce&&($e-=Ve?3:5):Ce?$e+=Ve?2:0:$e+=Ve?0:1,me+1===we&&($e-=Ve?3:5),$e}function le(ee,ie,F,H,G,X,me){return Z(ee,ie,F,H,G,X,!0,me)}e.fuzzyScoreGracefulAggressive=le;function fe(ee,ie,F,H,G,X,me){return Z(ee,ie,F,H,G,X,!1,me)}e.fuzzyScoreGraceful=fe;function Z(ee,ie,F,H,G,X,me,we){let ce=Oe(ee,ie,F,H,G,X,we);if(ce&&!me)return ce;if(ee.length>=3){const Ce=Math.min(7,ee.length-1);for(let ye=F+1;ye<Ce;ye++){const $e=ae(ee,ye);if($e){const Ve=Oe($e,$e.toLowerCase(),F,H,G,X,we);Ve&&(Ve[0]-=3,(!ce||Ve[0]>ce[0])&&(ce=Ve))}}}return ce}function ae(ee,ie){if(ie+1>=ee.length)return;const F=ee[ie],H=ee[ie+1];if(F!==H)return ee.slice(0,ie)+H+F+ee.slice(ie+2)}}),define(De[156],Ie([1,0,74,103,8]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const P=new RegExp(`\\$\\(${l.CSSIcon.iconNameExpression}(?:${l.CSSIcon.iconModifierExpression})?\\)`,"g"),_=new RegExp(l.CSSIcon.iconNameCharacter),D=new RegExp(`(\\\\)?${P.source}`,"g");function b(w){return w.replace(D,(f,v)=>v?f:`\\${f}`)}e.escapeIcons=b;const I=new RegExp(`\\\\${P.source}`,"g");function L(w){return w.replace(I,f=>`\\${f}`)}e.markdownEscapeEscapedIcons=L;const k=new RegExp(`(\\s)?(\\\\)?${P.source}(\\s)?`,"g");function S(w){return w.indexOf(e.iconStartMarker)===-1?w:w.replace(k,(f,v,m,a)=>m?f:v||a||"")}e.stripIcons=S;function T(w){const f=w.indexOf(e.iconStartMarker);return f===-1?{text:w}:E(w,f)}e.parseLabelWithIcons=T;function E(w,f){const v=[];let m="";function a(o){if(o){m+=o;for(const u of o)v.push(d)}}let g=-1,n="",d=0,s,i,r=f;const c=w.length;for(a(w.substr(0,f));r<c;)s=w[r],i=w[r+1],s===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(g=r,a(n),n=e.iconStartMarker,r++):s===")"&&g!==-1?(d+=r-g+1,g=-1,n=""):g!==-1?_.test(s)?n+=s:(a(n),g=-1,n=""):a(s),r++;return a(n),{text:m,iconOffsets:v}}function p(w,f,v=!1){const{text:m,iconOffsets:a}=f;if(!a||a.length===0)return(0,t.matchesFuzzy)(w,m,v);const g=(0,C.ltrim)(m," "),n=m.length-g.length,d=(0,t.matchesFuzzy)(w,g,v);if(d)for(const s of d){const i=a[s.start+n]+n;s.start+=i,s.end+=i}return d}e.matchesFuzzyIconAware=p}),define(De[79],Ie([1,0,25]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new l.LRUCache(1e4);function C(I){return b(I,"NFC",t)}e.normalizeNFC=C;const P=new l.LRUCache(1e4);function _(I){return b(I,"NFD",P)}e.normalizeNFD=_;const D=/[^\u0000-\u0080]/;function b(I,L,k){if(!I)return I;const S=k.get(I);if(S)return S;let T;return D.test(I)?T=I.normalize(L):T=I,k.set(I,T),T}e.removeAccents=function(){const I=/[\u0300-\u036f]/g;return function(L){return _(L).replace(I,"")}}()}),define(De[41],Ie([1,0,8]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(t||(t={})),function(C){const P="error",_="warning",D="warn",b="info",I="ignore";function L(S){return S?l.equalsIgnoreCase(P,S)?C.Error:l.equalsIgnoreCase(_,S)||l.equalsIgnoreCase(D,S)?C.Warning:l.equalsIgnoreCase(b,S)?C.Info:C.Ignore:C.Ignore}C.fromValue=L;function k(S){switch(S){case C.Error:return P;case C.Warning:return _;case C.Info:return b;default:return I}}C.toString=k}(t||(t={})),e.default=t}),define(De[2],Ie([1,0,9,11]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const C=/^\w[\w\d+.-]*$/,P=/^\//,_=/^\/\//;function D(s,i){if(!s.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!C.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!P.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(_.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function b(s,i){return!s&&!i?"file":s}function I(s,i){switch(s){case"https":case"http":case"file":i?i[0]!==k&&(i=k+i):i=k;break}return i}const L="",k="/",S=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class T{constructor(i,r,c,o,u,h=!1){typeof i=="object"?(this.scheme=i.scheme||L,this.authority=i.authority||L,this.path=i.path||L,this.query=i.query||L,this.fragment=i.fragment||L):(this.scheme=b(i,h),this.authority=r||L,this.path=I(this.scheme,c||L),this.query=o||L,this.fragment=u||L,D(this,h))}static isUri(i){return i instanceof T?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return m(this,!1)}with(i){if(!i)return this;let{scheme:r,authority:c,path:o,query:u,fragment:h}=i;return r===void 0?r=this.scheme:r===null&&(r=L),c===void 0?c=this.authority:c===null&&(c=L),o===void 0?o=this.path:o===null&&(o=L),u===void 0?u=this.query:u===null&&(u=L),h===void 0?h=this.fragment:h===null&&(h=L),r===this.scheme&&c===this.authority&&o===this.path&&u===this.query&&h===this.fragment?this:new p(r,c,o,u,h)}static parse(i,r=!1){const c=S.exec(i);return c?new p(c[2]||L,d(c[4]||L),d(c[5]||L),d(c[7]||L),d(c[9]||L),r):new p(L,L,L,L,L)}static file(i){let r=L;if(t.isWindows&&(i=i.replace(/\\/g,k)),i[0]===k&&i[1]===k){const c=i.indexOf(k,2);c===-1?(r=i.substring(2),i=k):(r=i.substring(2,c),i=i.substring(c)||k)}return new p("file",r,i,L,L)}static from(i){const r=new p(i.scheme,i.authority,i.path,i.query,i.fragment);return D(r,!0),r}static joinPath(i,...r){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return t.isWindows&&i.scheme==="file"?c=T.file(l.win32.join(m(i,!0),...r)).path:c=l.posix.join(i.path,...r),i.with({path:c})}toString(i=!1){return a(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof T)return i;{const r=new p(i);return r._formatted=i.external,r._fsPath=i._sep===E?i.fsPath:null,r}}else return i}}e.URI=T;const E=t.isWindows?1:void 0;class p extends T{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(i=!1){return i?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=E),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const w={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function f(s,i){let r,c=-1;for(let o=0;o<s.length;o++){const u=s.charCodeAt(o);if(u>=97&&u<=122||u>=65&&u<=90||u>=48&&u<=57||u===45||u===46||u===95||u===126||i&&u===47)c!==-1&&(r+=encodeURIComponent(s.substring(c,o)),c=-1),r!==void 0&&(r+=s.charAt(o));else{r===void 0&&(r=s.substr(0,o));const h=w[u];h!==void 0?(c!==-1&&(r+=encodeURIComponent(s.substring(c,o)),c=-1),r+=h):c===-1&&(c=o)}}return c!==-1&&(r+=encodeURIComponent(s.substring(c))),r!==void 0?r:s}function v(s){let i;for(let r=0;r<s.length;r++){const c=s.charCodeAt(r);c===35||c===63?(i===void 0&&(i=s.substr(0,r)),i+=w[c]):i!==void 0&&(i+=s[r])}return i!==void 0?i:s}function m(s,i){let r;return s.authority&&s.path.length>1&&s.scheme==="file"?r=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?i?r=s.path.substr(1):r=s.path[1].toLowerCase()+s.path.substr(2):r=s.path,t.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=m;function a(s,i){const r=i?v:f;let c="",{scheme:o,authority:u,path:h,query:y,fragment:R}=s;if(o&&(c+=o,c+=":"),(u||o==="file")&&(c+=k,c+=k),u){let M=u.indexOf("@");if(M!==-1){const U=u.substr(0,M);u=u.substr(M+1),M=U.indexOf(":"),M===-1?c+=r(U,!1):(c+=r(U.substr(0,M),!1),c+=":",c+=r(U.substr(M+1),!1)),c+="@"}u=u.toLowerCase(),M=u.indexOf(":"),M===-1?c+=r(u,!1):(c+=r(u.substr(0,M),!1),c+=u.substr(M))}if(h){if(h.length>=3&&h.charCodeAt(0)===47&&h.charCodeAt(2)===58){const M=h.charCodeAt(1);M>=65&&M<=90&&(h=`/${String.fromCharCode(M+32)}:${h.substr(3)}`)}else if(h.length>=2&&h.charCodeAt(1)===58){const M=h.charCodeAt(0);M>=65&&M<=90&&(h=`${String.fromCharCode(M+32)}:${h.substr(2)}`)}c+=r(h,!0)}return y&&(c+="?",c+=r(y,!1)),R&&(c+="#",c+=i?R:f(R,!1)),c}function g(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+g(s.substr(3)):s}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function d(s){return s.match(n)?s.replace(n,i=>g(i)):s}}),define(De[80],Ie([1,0,23,8,2]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function P(I){return JSON.stringify(I,D)}e.stringify=P;function _(I){let L=JSON.parse(I);return L=b(L),L}e.parse=_;function D(I,L){return L instanceof RegExp?{$mid:2,source:L.source,flags:(0,t.regExpFlags)(L)}:L}function b(I,L=0){if(!I||L>200)return I;if(typeof I=="object"){switch(I.$mid){case 1:return C.URI.revive(I);case 2:return new RegExp(I.source,I.flags);case 14:return new Date(I.source)}if(I instanceof l.VSBuffer||I instanceof Uint8Array)return I;if(Array.isArray(I))for(let k=0;k<I.length;++k)I[k]=b(I[k],L+1);else for(const k in I)Object.hasOwnProperty.call(I,k)&&(I[k]=b(I[k],L+1))}return I}e.revive=b}),define(De[12],Ie([1,0,11,2]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var C;(function(b){b.inMemory="inmemory",b.vscode="vscode",b.internal="private",b.walkThrough="walkThrough",b.walkThroughSnippet="walkThroughSnippet",b.http="http",b.https="https",b.file="file",b.mailto="mailto",b.untitled="untitled",b.data="data",b.command="command",b.vscodeRemote="vscode-remote",b.vscodeRemoteResource="vscode-remote-resource",b.vscodeUserData="vscode-userdata",b.vscodeCustomEditor="vscode-custom-editor",b.vscodeNotebook="vscode-notebook",b.vscodeNotebookCell="vscode-notebook-cell",b.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",b.vscodeNotebookCellOutput="vscode-notebook-cell-output",b.vscodeInteractive="vscode-interactive",b.vscodeInteractiveInput="vscode-interactive-input",b.vscodeSettings="vscode-settings",b.vscodeWorkspaceTrust="vscode-workspace-trust",b.vscodeTerminal="vscode-terminal",b.webviewPanel="webview-panel",b.vscodeWebview="vscode-webview",b.extension="extension",b.vscodeFileResource="vscode-file",b.tmp="tmp",b.vsls="vsls",b.vscodeSourceControl="vscode-scm"})(C=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class P{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${C.vscodeRemoteResource}`}setPreferredWebSchema(I){this._preferredWebSchema=I}setDelegate(I){this._delegate=I}setServerRootPath(I){this._remoteResourcesPath=`${I}/${C.vscodeRemoteResource}`}set(I,L,k){this._hosts[I]=L,this._ports[I]=k}setConnectionToken(I,L){this._connectionTokens[I]=L}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(I){if(this._delegate)return this._delegate(I);const L=I.authority;let k=this._hosts[L];k&&k.indexOf(":")!==-1&&(k=`[${k}]`);const S=this._ports[L],T=this._connectionTokens[L];let E=`path=${encodeURIComponent(I.path)}`;return typeof T=="string"&&(E+=`&${e.connectionTokenQueryName}=${encodeURIComponent(T)}`),t.URI.from({scheme:l.isWeb?this._preferredWebSchema:C.vscodeRemoteResource,authority:`${k}:${S}`,path:this._remoteResourcesPath,query:E})}}e.RemoteAuthorities=new P;class _{asBrowserUri(I,L){const k=this.toUri(I,L);return k.scheme===C.vscodeRemote?e.RemoteAuthorities.rewrite(k):k.scheme===C.file&&(l.isNative||l.isWebWorker&&l.globals.origin===`${C.vscodeFileResource}://${_.FALLBACK_AUTHORITY}`)?k.with({scheme:C.vscodeFileResource,authority:k.authority||_.FALLBACK_AUTHORITY,query:null,fragment:null}):k}asFileUri(I,L){const k=this.toUri(I,L);return k.scheme===C.vscodeFileResource?k.with({scheme:C.file,authority:k.authority!==_.FALLBACK_AUTHORITY?k.authority:null,query:null,fragment:null}):k}toUri(I,L){return t.URI.isUri(I)?I:t.URI.parse(L.toUrl(I))}}_.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new _;var D;(function(b){const I=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);b.CoopAndCoep=Object.freeze(I.get("3"));const L="vscode-coi";function k(T){let E;typeof T=="string"?E=new URL(T).searchParams:T instanceof URL?E=T.searchParams:t.URI.isUri(T)&&(E=new URL(T.toString(!0)).searchParams);const p=E?.get(L);if(!!p)return I.get(p)}b.getHeadersFromQuery=k;function S(T,E,p){if(!globalThis.crossOriginIsolated)return;const w=E&&p?"3":p?"2":"1";T instanceof URLSearchParams?T.set(L,w):T[L]=w}b.addSearchParam=S})(D=e.COI||(e.COI={}))}),define(De[22],Ie([1,0,31,12,9,11,8,2]),function(J,e,l,t,C,P,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function b(T){return(0,D.uriToFsPath)(T,!0)}e.originalFSPath=b;class I{constructor(E){this._ignorePathCasing=E}compare(E,p,w=!1){return E===p?0:(0,_.compare)(this.getComparisonKey(E,w),this.getComparisonKey(p,w))}isEqual(E,p,w=!1){return E===p?!0:!E||!p?!1:this.getComparisonKey(E,w)===this.getComparisonKey(p,w)}getComparisonKey(E,p=!1){return E.with({path:this._ignorePathCasing(E)?E.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(E){return this._ignorePathCasing(E)}isEqualOrParent(E,p,w=!1){if(E.scheme===p.scheme){if(E.scheme===t.Schemas.file)return l.isEqualOrParent(b(E),b(p),this._ignorePathCasing(E))&&E.query===p.query&&(w||E.fragment===p.fragment);if((0,e.isEqualAuthority)(E.authority,p.authority))return l.isEqualOrParent(E.path,p.path,this._ignorePathCasing(E),"/")&&E.query===p.query&&(w||E.fragment===p.fragment)}return!1}joinPath(E,...p){return D.URI.joinPath(E,...p)}basenameOrAuthority(E){return(0,e.basename)(E)||E.authority}basename(E){return C.posix.basename(E.path)}extname(E){return C.posix.extname(E.path)}dirname(E){if(E.path.length===0)return E;let p;return E.scheme===t.Schemas.file?p=D.URI.file(C.dirname(b(E))).path:(p=C.posix.dirname(E.path),E.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${E.toString})) resulted in a relative path`),p="/")),E.with({path:p})}normalizePath(E){if(!E.path.length)return E;let p;return E.scheme===t.Schemas.file?p=D.URI.file(C.normalize(b(E))).path:p=C.posix.normalize(E.path),E.with({path:p})}relativePath(E,p){if(E.scheme!==p.scheme||!(0,e.isEqualAuthority)(E.authority,p.authority))return;if(E.scheme===t.Schemas.file){const v=C.relative(b(E),b(p));return P.isWindows?l.toSlashes(v):v}let w=E.path||"/";const f=p.path||"/";if(this._ignorePathCasing(E)){let v=0;for(const m=Math.min(w.length,f.length);v<m&&!(w.charCodeAt(v)!==f.charCodeAt(v)&&w.charAt(v).toLowerCase()!==f.charAt(v).toLowerCase());v++);w=f.substr(0,v)+w.substr(v)}return C.posix.relative(w,f)}resolvePath(E,p){if(E.scheme===t.Schemas.file){const w=D.URI.file(C.resolve(b(E),p));return E.with({authority:w.authority,path:w.path})}return p=l.toPosixPath(p),E.with({path:C.posix.resolve(E.path,p)})}isAbsolutePath(E){return!!E.path&&E.path[0]==="/"}isEqualAuthority(E,p){return E===p||E!==void 0&&p!==void 0&&(0,_.equalsIgnoreCase)(E,p)}hasTrailingPathSeparator(E,p=C.sep){if(E.scheme===t.Schemas.file){const w=b(E);return w.length>l.getRoot(w).length&&w[w.length-1]===p}else{const w=E.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(E.fsPath)}}removeTrailingPathSeparator(E,p=C.sep){return(0,e.hasTrailingPathSeparator)(E,p)?E.with({path:E.path.substr(0,E.path.length-1)}):E}addTrailingPathSeparator(E,p=C.sep){let w=!1;if(E.scheme===t.Schemas.file){const f=b(E);w=f!==void 0&&f.length===l.getRoot(f).length&&f[f.length-1]===p}else{p="/";const f=E.path;w=f.length===1&&f.charCodeAt(f.length-1)===47}return!w&&!(0,e.hasTrailingPathSeparator)(E,p)?E.with({path:E.path+"/"}):E}}e.ExtUri=I,e.extUri=new I(()=>!1),e.extUriBiasedIgnorePathCase=new I(T=>T.scheme===t.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new I(T=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function L(T,E){const p=[];for(let w=0;w<T.length;w++){const f=E(T[w]);T.some((v,m)=>m===w?!1:(0,e.isEqualOrParent)(f,E(v)))||p.push(T[w])}return p}e.distinctParents=L;var k;(function(T){T.META_DATA_LABEL="label",T.META_DATA_DESCRIPTION="description",T.META_DATA_SIZE="size",T.META_DATA_MIME="mime";function E(p){const w=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(m=>{const[a,g]=m.split(":");a&&g&&w.set(a,g)});const v=p.path.substring(0,p.path.indexOf(";"));return v&&w.set(T.META_DATA_MIME,v),w}T.parseMetaData=E})(k=e.DataUri||(e.DataUri={}));function S(T,E,p){if(E){let w=T.path;return w&&w[0]!==C.posix.sep&&(w=C.posix.sep+w),T.with({scheme:p,authority:E,path:w})}return T.with({scheme:p})}e.toLocalResource=S}),define(De[18],Ie([1,0,21,10,4,6,22,11]),function(J,e,l,t,C,P,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function b(ve){return!!ve&&typeof ve.then=="function"}e.isThenable=b;function I(ve){const ne=new l.CancellationTokenSource,pe=ve(ne.token),be=new Promise((ke,Oe)=>{const We=ne.token.onCancellationRequested(()=>{We.dispose(),ne.dispose(),Oe(new t.CancellationError)});Promise.resolve(pe).then(oe=>{We.dispose(),ne.dispose(),ke(oe)},oe=>{We.dispose(),ne.dispose(),Oe(oe)})});return new class{cancel(){ne.cancel()}then(ke,Oe){return be.then(ke,Oe)}catch(ke){return this.then(void 0,ke)}finally(ke){return be.finally(ke)}}}e.createCancelablePromise=I;function L(ve,ne,pe){return new Promise((be,ke)=>{const Oe=ne.onCancellationRequested(()=>{Oe.dispose(),be(pe)});ve.then(be,ke).finally(()=>Oe.dispose())})}e.raceCancellation=L;function k(ve,ne){return new Promise((pe,be)=>{const ke=ne.onCancellationRequested(()=>{ke.dispose(),be(new t.CancellationError)});ve.then(pe,be).finally(()=>ke.dispose())})}e.raceCancellationError=k;async function S(ve){let ne=-1;const pe=ve.map((ke,Oe)=>ke.then(We=>(ne=Oe,We))),be=await Promise.race(pe);return ve.forEach((ke,Oe)=>{Oe!==ne&&ke.cancel()}),be}e.raceCancellablePromises=S;function T(ve,ne,pe){let be;const ke=setTimeout(()=>{be?.(void 0),pe?.()},ne);return Promise.race([ve.finally(()=>clearTimeout(ke)),new Promise(Oe=>be=Oe)])}e.raceTimeout=T;function E(ve){return new Promise((ne,pe)=>{const be=ve();b(be)?be.then(ne,pe):ne(be)})}e.asPromise=E;class p{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(ne){if(this.activePromise){if(this.queuedPromiseFactory=ne,!this.queuedPromise){const pe=()=>{this.queuedPromise=null;const be=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,be};this.queuedPromise=new Promise(be=>{this.activePromise.then(pe,pe).then(be)})}return new Promise((pe,be)=>{this.queuedPromise.then(pe,be)})}return this.activePromise=ne(),new Promise((pe,be)=>{this.activePromise.then(ke=>{this.activePromise=null,pe(ke)},ke=>{this.activePromise=null,be(ke)})})}}e.Throttler=p;class w{constructor(){this.current=Promise.resolve(null)}queue(ne){return this.current=this.current.then(()=>ne(),()=>ne())}}e.Sequencer=w;class f{constructor(){this.promiseMap=new Map}queue(ne,pe){const ke=(this.promiseMap.get(ne)??Promise.resolve()).catch(()=>{}).then(pe).finally(()=>{this.promiseMap.get(ne)===ke&&this.promiseMap.delete(ne)});return this.promiseMap.set(ne,ke),ke}}e.SequencerByKey=f;const v=(ve,ne)=>{let pe=!0;const be=setTimeout(()=>{pe=!1,ne()},ve);return{isTriggered:()=>pe,dispose:()=>{clearTimeout(be),pe=!1}}},m=ve=>{let ne=!0;return queueMicrotask(()=>{ne&&(ne=!1,ve())}),{isTriggered:()=>ne,dispose:()=>{ne=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class a{constructor(ne){this.defaultDelay=ne,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(ne,pe=this.defaultDelay){this.task=ne,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ke,Oe)=>{this.doResolve=ke,this.doReject=Oe}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ke=this.task;return this.task=null,ke()}}));const be=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=pe===e.MicrotaskDelay?m(be):v(pe,be),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=a;class g{constructor(ne){this.delayer=new a(ne),this.throttler=new p}trigger(ne,pe){return this.delayer.trigger(()=>this.throttler.queue(ne),pe)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=g;class n{constructor(){this._isOpen=!1,this._promise=new Promise((ne,pe)=>{this._completePromise=ne})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=n;class d extends n{constructor(ne){super(),this._timeout=setTimeout(()=>this.open(),ne)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=d;function s(ve,ne){return ne?new Promise((pe,be)=>{const ke=setTimeout(()=>{Oe.dispose(),pe()},ve),Oe=ne.onCancellationRequested(()=>{clearTimeout(ke),Oe.dispose(),be(new t.CancellationError)})}):I(pe=>s(ve,pe))}e.timeout=s;function i(ve,ne=0){const pe=setTimeout(ve,ne);return(0,P.toDisposable)(()=>clearTimeout(pe))}e.disposableTimeout=i;function r(ve){const ne=[];let pe=0;const be=ve.length;function ke(){return pe<be?ve[pe++]():null}function Oe(We){We!=null&&ne.push(We);const oe=ke();return oe?oe.then(Oe):Promise.resolve(ne)}return Promise.resolve(null).then(Oe)}e.sequence=r;function c(ve,ne=be=>!!be,pe=null){let be=0;const ke=ve.length,Oe=()=>{if(be>=ke)return Promise.resolve(pe);const We=ve[be++];return Promise.resolve(We()).then(le=>ne(le)?Promise.resolve(le):Oe())};return Oe()}e.first=c;function o(ve,ne=be=>!!be,pe=null){if(ve.length===0)return Promise.resolve(pe);let be=ve.length;const ke=()=>{be=-1;for(const Oe of ve)Oe.cancel?.()};return new Promise((Oe,We)=>{for(const oe of ve)oe.then(le=>{--be>=0&&ne(le)?(ke(),Oe(le)):be===0&&Oe(pe)}).catch(le=>{--be>=0&&(ke(),We(le))})})}e.firstParallel=o;class u{constructor(ne){this._size=0,this.maxDegreeOfParalellism=ne,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new C.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(ne){return this._size++,new Promise((pe,be)=>{this.outstandingPromises.push({factory:ne,c:pe,e:be}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const ne=this.outstandingPromises.shift();this.runningPromises++;const pe=ne.factory();pe.then(ne.c,ne.e),pe.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=u;class h extends u{constructor(){super(1)}}e.Queue=h;class y{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const ne=new x;return this.drainers.add(ne),ne.p}isDrained(){for(const[,ne]of this.queues)if(ne.size>0)return!1;return!0}queueFor(ne,pe=_.extUri){const be=pe.getComparisonKey(ne);let ke=this.queues.get(be);return ke||(ke=new h,C.Event.once(ke.onDrained)(()=>{ke?.dispose(),this.queues.delete(be),this.onDidQueueDrain()}),this.queues.set(be,ke)),ke}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const ne of this.drainers)ne.complete();this.drainers.clear()}dispose(){for(const[,ne]of this.queues)ne.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=y;class R{constructor(ne,pe){this._token=-1,typeof ne=="function"&&typeof pe=="number"&&this.setIfNotSet(ne,pe)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(ne,pe){this.cancel(),this._token=setTimeout(()=>{this._token=-1,ne()},pe)}setIfNotSet(ne,pe){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,ne()},pe))}}e.TimeoutTimer=R;class M{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(ne,pe){this.cancel(),this._token=setInterval(()=>{ne()},pe)}}e.IntervalTimer=M;class U{constructor(ne,pe){this.timeoutToken=-1,this.runner=ne,this.timeout=pe,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(ne=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,ne)}get delay(){return this.timeout}set delay(ne){this.timeout=ne}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=U;class A{constructor(ne,pe){pe%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${pe}ms is not a multiple of 1000ms.`),this.runner=ne,this.timeout=pe,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(ne=this.timeout){ne%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ne}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(ne/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=A;class z extends U{constructor(ne,pe){super(ne,pe),this.units=[]}work(ne){this.units.push(ne),this.isScheduled()||this.schedule()}doRun(){const ne=this.units;this.units=[],this.runner?.(ne)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=z;class $ extends P.Disposable{constructor(ne,pe){super(),this.options=ne,this.handler=pe,this.pendingWork=[],this.throttler=this._register(new P.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(ne){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+ne.length>this.options.maxBufferedWork)return!1}else if(this.pending+ne.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...ne),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new U(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=$,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=ve=>{(0,D.setTimeout0)(()=>{if(ne)return;const pe=Date.now()+15;ve(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,pe-Date.now())}}))});let ne=!1;return{dispose(){ne||(ne=!0)}}}:e.runWhenIdle=(ve,ne)=>{const pe=requestIdleCallback(ve,typeof ne=="number"?{timeout:ne}:void 0);let be=!1;return{dispose(){be||(be=!0,cancelIdleCallback(pe))}}}}();class N{constructor(ne){this._didRun=!1,this._executor=()=>{try{this._value=ne()}catch(pe){this._error=pe}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=N;async function K(ve,ne,pe){let be;for(let ke=0;ke<pe;ke++)try{return await ve()}catch(Oe){be=Oe,await s(ne)}throw be}e.retry=K;class B{hasPending(ne){return this._pending?typeof ne=="number"?this._pending.taskId===ne:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(ne,pe,be){return this._pending={taskId:ne,cancel:()=>be?.(),promise:pe},pe.then(()=>this.donePending(ne),()=>this.donePending(ne)),pe}donePending(ne){this._pending&&ne===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const ne=this._next;this._next=void 0,ne.run().then(ne.promiseResolve,ne.promiseReject)}}setNext(ne){if(this._next)this._next.run=ne;else{let pe,be;const ke=new Promise((Oe,We)=>{pe=Oe,be=We});this._next={run:ne,promise:ke,promiseResolve:pe,promiseReject:be}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=B;class O{constructor(ne,pe=()=>Date.now()){this.interval=ne,this.nowFn=pe,this.lastIncrementTime=0,this.value=0}increment(){const ne=this.nowFn();return ne-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=ne,this.value=0),this.value++,this.value}}e.IntervalCounter=O;class x{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((ne,pe)=>{this.completeCallback=ne,this.errorCallback=pe})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(ne){return new Promise(pe=>{this.completeCallback(ne),this.resolved=!0,pe()})}error(ne){return new Promise(pe=>{this.errorCallback(ne),this.rejected=!0,pe()})}cancel(){new Promise(ne=>{this.errorCallback(new t.CancellationError),this.rejected=!0,ne()})}}e.DeferredPromise=x;var V;(function(ve){async function ne(be){let ke;const Oe=await Promise.all(be.map(We=>We.then(oe=>oe,oe=>{ke||(ke=oe)})));if(typeof ke<"u")throw ke;return Oe}ve.settled=ne;function pe(be){return new Promise(async(ke,Oe)=>{try{await be(ke,Oe)}catch(We){Oe(We)}})}ve.withAsyncBody=pe})(V=e.Promises||(e.Promises={}));var q;(function(ve){ve[ve.Initial=0]="Initial",ve[ve.DoneOK=1]="DoneOK",ve[ve.DoneError=2]="DoneError"})(q||(q={}));class Y{constructor(ne){this._state=0,this._results=[],this._error=null,this._onStateChanged=new C.Emitter,queueMicrotask(async()=>{const pe={emitOne:be=>this.emitOne(be),emitMany:be=>this.emitMany(be),reject:be=>this.reject(be)};try{await Promise.resolve(ne(pe)),this.resolve()}catch(be){this.reject(be)}finally{pe.emitOne=void 0,pe.emitMany=void 0,pe.reject=void 0}})}static fromArray(ne){return new Y(pe=>{pe.emitMany(ne)})}static fromPromise(ne){return new Y(async pe=>{pe.emitMany(await ne)})}static fromPromises(ne){return new Y(async pe=>{await Promise.all(ne.map(async be=>pe.emitOne(await be)))})}static merge(ne){return new Y(async pe=>{await Promise.all(ne.map(async be=>{for await(const ke of be)pe.emitOne(ke)}))})}[Symbol.asyncIterator](){let ne=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(ne<this._results.length)return{done:!1,value:this._results[ne++]};if(this._state===1)return{done:!0,value:void 0};await C.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(ne,pe){return new Y(async be=>{for await(const ke of ne)be.emitOne(pe(ke))})}map(ne){return Y.map(this,ne)}static filter(ne,pe){return new Y(async be=>{for await(const ke of ne)pe(ke)&&be.emitOne(ke)})}filter(ne){return Y.filter(this,ne)}static coalesce(ne){return Y.filter(ne,pe=>!!pe)}coalesce(){return Y.coalesce(this)}static async toPromise(ne){const pe=[];for await(const be of ne)pe.push(be);return pe}toPromise(){return Y.toPromise(this)}emitOne(ne){this._state===0&&(this._results.push(ne),this._onStateChanged.fire())}emitMany(ne){this._state===0&&(this._results=this._results.concat(ne),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(ne){this._state===0&&(this._state=2,this._error=ne,this._onStateChanged.fire())}}e.AsyncIterableObject=Y,Y.EMPTY=Y.fromArray([]);class Q extends Y{constructor(ne,pe){super(pe),this._source=ne}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Q;function de(ve){const ne=new l.CancellationTokenSource,pe=ve(ne.token);return new Q(ne,async be=>{const ke=ne.token.onCancellationRequested(()=>{ke.dispose(),ne.dispose(),be.reject(new t.CancellationError)});try{for await(const Oe of pe){if(ne.token.isCancellationRequested)return;be.emitOne(Oe)}ke.dispose(),ne.dispose()}catch(Oe){ke.dispose(),ne.dispose(),be.reject(Oe)}})}e.createCancelableAsyncIterable=de}),define(De[104],Ie([1,0,18,9]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const C=new l.IdleValue(()=>{const h=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:h,collatorIsNumeric:h.resolvedOptions().numeric}}),P=new l.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),_=new l.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function D(h,y,R=!1){const M=h||"",U=y||"",A=C.value.collator.compare(M,U);return C.value.collatorIsNumeric&&A===0&&M!==U?M<U?-1:1:A}e.compareFileNames=D;function b(h,y){const R=P.value.collator;return h=h||"",y=y||"",g(R,h,y)}e.compareFileNamesDefault=b;function I(h,y){const R=P.value.collator;return h=h||"",y=y||"",i(h,y)||g(R,h,y)}e.compareFileNamesUpper=I;function L(h,y){const R=P.value.collator;return h=h||"",y=y||"",s(h,y)||g(R,h,y)}e.compareFileNamesLower=L;function k(h,y){return h=h||"",y=y||"",h===y?0:h<y?-1:1}e.compareFileNamesUnicode=k;function S(h,y,R=!1){R||(h=h&&h.toLowerCase(),y=y&&y.toLowerCase());const[M,U]=m(h),[A,z]=m(y);return M!==A?M<A?-1:1:U===z?0:U<z?-1:1}e.noIntlCompareFileNames=S;function T(h,y){const[R,M]=m(h),[U,A]=m(y);let z=C.value.collator.compare(M,A);if(z===0){if(C.value.collatorIsNumeric&&M!==A)return M<A?-1:1;if(z=C.value.collator.compare(R,U),C.value.collatorIsNumeric&&z===0&&R!==U)return R<U?-1:1}return z}e.compareFileExtensions=T;function E(h,y){h=h||"",y=y||"";const R=a(h),M=a(y),U=P.value.collator,A=_.value.collator;return g(A,R,M)||g(U,h,y)}e.compareFileExtensionsDefault=E;function p(h,y){h=h||"",y=y||"";const R=a(h),M=a(y),U=P.value.collator,A=_.value.collator;return g(A,R,M)||i(h,y)||g(U,h,y)}e.compareFileExtensionsUpper=p;function w(h,y){h=h||"",y=y||"";const R=a(h),M=a(y),U=P.value.collator,A=_.value.collator;return g(A,R,M)||s(h,y)||g(U,h,y)}e.compareFileExtensionsLower=w;function f(h,y){h=h||"",y=y||"";const R=a(h).toLowerCase(),M=a(y).toLowerCase();return R!==M?R<M?-1:1:h!==y?h<y?-1:1:0}e.compareFileExtensionsUnicode=f;const v=/^(.*?)(\.([^.]*))?$/;function m(h,y=!1){const R=h?v.exec(h):[];let M=[R&&R[1]||"",R&&R[3]||""];return y&&(!M[0]&&M[1]||M[0]&&M[0].charAt(0)===".")&&(M=[M[0]+"."+M[1],""]),M}function a(h){const y=h?v.exec(h):[];return y&&y[1]&&y[1].charAt(0)!=="."&&y[3]||""}function g(h,y,R){const M=h.compare(y,R);return M!==0?M:y.length!==R.length?y.length<R.length?-1:1:0}function n(h){const y=h.charAt(0);return y.toLocaleUpperCase()!==y}function d(h){const y=h.charAt(0);return y.toLocaleLowerCase()!==y}function s(h,y){return n(h)&&d(y)?-1:d(h)&&n(y)?1:0}function i(h,y){return d(h)&&n(y)?-1:n(h)&&d(y)?1:0}function r(h,y,R=!1){return R||(h=h&&h.toLowerCase(),y=y&&y.toLowerCase()),h===y?0:h<y?-1:1}function c(h,y,R=!1){const M=h.split(t.sep),U=y.split(t.sep),A=M.length-1,z=U.length-1;let $,N;for(let K=0;;K++){if($=A===K,N=z===K,$&&N)return D(M[K],U[K],R);if($)return-1;if(N)return 1;const B=r(M[K],U[K],R);if(B!==0)return B}}e.comparePaths=c;function o(h,y,R){const M=h.toLowerCase(),U=y.toLowerCase(),A=u(h,y,R);if(A)return A;const z=M.endsWith(R),$=U.endsWith(R);if(z!==$)return z?-1:1;const N=D(M,U);return N!==0?N:M.localeCompare(U)}e.compareAnything=o;function u(h,y,R){const M=h.toLowerCase(),U=y.toLowerCase(),A=M.startsWith(R),z=U.startsWith(R);if(A!==z)return A?-1:1;if(A&&z){if(M.length<U.length)return-1;if(M.length>U.length)return 1}return 0}e.compareByPrefix=u}),define(De[105],Ie([1,0,104,103,78,9,11,8]),function(J,e,l,t,C,P,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const b=0,I=[b,[]];function L(B,O,x,V){if(!B||!O)return I;const q=B.length,Y=O.length;if(q<Y)return I;const Q=B.toLowerCase();return k(O,x,Y,B,Q,q,V)}e.scoreFuzzy=L;function k(B,O,x,V,q,Y,Q){const de=[],ve=[];for(let ke=0;ke<x;ke++){const Oe=ke*Y,We=Oe-Y,oe=ke>0,le=B[ke],fe=O[ke];for(let Z=0;Z<Y;Z++){const ae=Z>0,ee=Oe+Z,ie=ee-1,F=We+Z-1,H=ae?de[ie]:0,G=oe&&ae?de[F]:0,X=oe&&ae?ve[F]:0;let me;!G&&oe?me=0:me=S(le,fe,V,q,Z,X),me&&G+me>=H&&(Q||oe||q.startsWith(O,Z))?(ve[ee]=X+1,de[ee]=G+me):(ve[ee]=b,de[ee]=H)}}const ne=[];let pe=x-1,be=Y-1;for(;pe>=0&&be>=0;){const ke=pe*Y+be;ve[ke]===b||(ne.push(be),pe--),be--}return[de[x*Y-1],ne.reverse()]}function S(B,O,x,V,q,Y){let Q=0;if(!T(O,V[q]))return Q;if(Q+=1,Y>0&&(Q+=Y*5),B===x[q]&&(Q+=1),q===0)Q+=8;else{const de=E(x.charCodeAt(q-1));de?Q+=de:(0,t.isUpper)(x.charCodeAt(q))&&Y===0&&(Q+=2)}return Q}function T(B,O){return B===O?!0:B==="/"||B==="\\"?O==="/"||O==="\\":!1}function E(B){switch(B){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const p=[void 0,[]];function w(B,O,x=0,V=0){const q=O;return q.values&&q.values.length>1?f(B,q.values,x,V):v(B,O,x,V)}e.scoreFuzzy2=w;function f(B,O,x,V){let q=0;const Y=[];for(const Q of O){const[de,ve]=v(B,Q,x,V);if(typeof de!="number")return p;q+=de,Y.push(...ve)}return[q,u(Y)]}function v(B,O,x,V){const q=(0,t.fuzzyScore)(O.original,O.originalLowercase,x,B,B.toLowerCase(),V,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return q?[q[0],(0,t.createMatches)(q)]:p}const m=Object.freeze({score:0}),a=1<<18,g=1<<17,n=1<<16;function d(B,O,x,V){const q=V.values?V.values:[V];return(0,C.hash)({[V.normalized]:{values:q.map(Q=>({value:Q.normalized,expectContiguousMatch:Q.expectContiguousMatch})),label:B,description:O,allowNonContiguousMatches:x}})}function s(B,O,x,V,q){if(!B||!O.normalized)return m;const Y=V.getItemLabel(B);if(!Y)return m;const Q=V.getItemDescription(B),de=d(Y,Q,x,O),ve=q[de];if(ve)return ve;const ne=i(Y,Q,V.getItemPath(B),O,x);return q[de]=ne,ne}e.scoreItemFuzzy=s;function i(B,O,x,V,q){const Y=!x||!V.containsPathSeparator;return x&&(_.isLinux?V.pathNormalized===x:(0,D.equalsIgnoreCase)(V.pathNormalized,x))?{score:a,labelMatch:[{start:0,end:B.length}],descriptionMatch:O?[{start:0,end:O.length}]:void 0}:V.values&&V.values.length>1?r(B,O,x,V.values,Y,q):c(B,O,x,V,Y,q)}function r(B,O,x,V,q,Y){let Q=0;const de=[],ve=[];for(const ne of V){const{score:pe,labelMatch:be,descriptionMatch:ke}=c(B,O,x,ne,q,Y);if(pe===b)return m;Q+=pe,be&&de.push(...be),ke&&ve.push(...ke)}return{score:Q,labelMatch:u(de),descriptionMatch:u(ve)}}function c(B,O,x,V,q,Y){if(q||!O){const[Q,de]=L(B,V.normalized,V.normalizedLowercase,Y&&!V.expectContiguousMatch);if(Q){const ve=(0,t.matchesPrefix)(V.normalized,B);let ne;return ve?(ne=g,ne+=Math.round(V.normalized.length/B.length*100)):ne=n,{score:ne+Q,labelMatch:ve||o(de)}}}if(O){let Q=O;x&&(Q=`${O}${P.sep}`);const de=Q.length,ve=`${Q}${B}`,[ne,pe]=L(ve,V.normalized,V.normalizedLowercase,Y&&!V.expectContiguousMatch);if(ne){const be=o(pe),ke=[],Oe=[];return be.forEach(We=>{We.start<de&&We.end>de?(ke.push({start:0,end:We.end-de}),Oe.push({start:We.start,end:de})):We.start>=de?ke.push({start:We.start-de,end:We.end-de}):Oe.push(We)}),{score:ne,labelMatch:ke,descriptionMatch:Oe}}}return m}function o(B){const O=[];if(!B)return O;let x;for(const V of B)x&&x.end===V?x.end+=1:(x={start:V,end:V+1},O.push(x));return O}function u(B){const O=B.sort((q,Y)=>q.start-Y.start),x=[];let V;for(const q of O)!V||!h(V,q)?(V=q,x.push(q)):(V.start=Math.min(V.start,q.start),V.end=Math.max(V.end,q.end));return x}function h(B,O){return!(B.end<O.start||O.end<B.start)}function y(B,O,x,V,q,Y){const Q=s(B,x,V,q,Y),de=s(O,x,V,q,Y),ve=Q.score,ne=de.score;if((ve===a||ne===a)&&ve!==ne)return ve===a?-1:1;if(ve>n||ne>n){if(ve!==ne)return ve>ne?-1:1;if(ve<g&&ne<g){const le=M(Q.labelMatch,de.labelMatch);if(le!==0)return le}const We=q.getItemLabel(B)||"",oe=q.getItemLabel(O)||"";if(We.length!==oe.length)return We.length-oe.length}if(ve!==ne)return ve>ne?-1:1;const pe=Array.isArray(Q.labelMatch)&&Q.labelMatch.length>0,be=Array.isArray(de.labelMatch)&&de.labelMatch.length>0;if(pe&&!be)return-1;if(be&&!pe)return 1;const ke=R(B,Q,q),Oe=R(O,de,q);return ke&&Oe&&ke!==Oe?Oe>ke?-1:1:U(B,O,x,q)}e.compareItemsByFuzzyScore=y;function R(B,O,x){let V=-1,q=-1;if(O.descriptionMatch&&O.descriptionMatch.length?V=O.descriptionMatch[0].start:O.labelMatch&&O.labelMatch.length&&(V=O.labelMatch[0].start),O.labelMatch&&O.labelMatch.length){if(q=O.labelMatch[O.labelMatch.length-1].end,O.descriptionMatch&&O.descriptionMatch.length){const Y=x.getItemDescription(B);Y&&(q+=Y.length)}}else O.descriptionMatch&&O.descriptionMatch.length&&(q=O.descriptionMatch[O.descriptionMatch.length-1].end);return q-V}function M(B,O){if(!B&&!O||(!B||!B.length)&&(!O||!O.length))return 0;if(!O||!O.length)return-1;if(!B||!B.length)return 1;const x=B[0].start,q=B[B.length-1].end-x,Y=O[0].start,de=O[O.length-1].end-Y;return q===de?0:de<q?1:-1}function U(B,O,x,V){const q=V.getItemLabel(B)||"",Y=V.getItemLabel(O)||"",Q=V.getItemDescription(B),de=V.getItemDescription(O),ve=q.length+(Q?Q.length:0),ne=Y.length+(de?de.length:0);if(ve!==ne)return ve-ne;const pe=V.getItemPath(B),be=V.getItemPath(O);return pe&&be&&pe.length!==be.length?pe.length-be.length:q!==Y?(0,l.compareAnything)(q,Y,x.normalized):Q&&de&&Q!==de?(0,l.compareAnything)(Q,de,x.normalized):pe&&be&&pe!==be?(0,l.compareAnything)(pe,be,x.normalized):0}function A(B){return B.startsWith('"')&&B.endsWith('"')}const z=" ";function $(B){typeof B!="string"&&(B="");const O=B.toLowerCase(),{pathNormalized:x,normalized:V,normalizedLowercase:q}=N(B),Y=x.indexOf(P.sep)>=0,Q=A(B);let de;const ve=B.split(z);if(ve.length>1)for(const ne of ve){const pe=A(ne),{pathNormalized:be,normalized:ke,normalizedLowercase:Oe}=N(ne);ke&&(de||(de=[]),de.push({original:ne,originalLowercase:ne.toLowerCase(),pathNormalized:be,normalized:ke,normalizedLowercase:Oe,expectContiguousMatch:pe}))}return{original:B,originalLowercase:O,pathNormalized:x,normalized:V,normalizedLowercase:q,values:de,containsPathSeparator:Y,expectContiguousMatch:Q}}e.prepareQuery=$;function N(B){let O;_.isWindows?O=B.replace(/\//g,P.sep):O=B.replace(/\\/g,P.sep);const x=(0,D.stripWildcards)(O).replace(/\s|"/g,"");return{pathNormalized:O,normalized:x,normalizedLowercase:x.toLowerCase()}}function K(B){return Array.isArray(B)?$(B.map(O=>O.original).join(z)):$(B.original)}e.pieceToQuery=K}),define(De[36],Ie([1,0,17,18,31,25,9,11,8]),function(J,e,l,t,C,P,_,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function I(){return Object.create(null)}e.getEmptyExpression=I,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const L="[/\\\\]",k="[^/\\\\]",S=/\//g;function T(x,V){switch(x){case 0:return"";case 1:return`${k}*?`;default:return`(?:${L}|${k}+${L}${V?`|${L}${k}+`:""})*?`}}function E(x,V){if(!x)return[];const q=[];let Y=!1,Q=!1,de="";for(const ve of x){switch(ve){case V:if(!Y&&!Q){q.push(de),de="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":Q=!0;break;case"]":Q=!1;break}de+=ve}return de&&q.push(de),q}e.splitGlobAware=E;function p(x){if(!x)return"";let V="";const q=E(x,e.GLOB_SPLIT);if(q.every(Y=>Y===e.GLOBSTAR))V=".*";else{let Y=!1;q.forEach((Q,de)=>{if(Q===e.GLOBSTAR){if(Y)return;V+=T(2,de===q.length-1)}else{let ve=!1,ne="",pe=!1,be="";for(const ke of Q){if(ke!=="}"&&ve){ne+=ke;continue}if(pe&&(ke!=="]"||!be)){let Oe;ke==="-"?Oe=ke:(ke==="^"||ke==="!")&&!be?Oe="^":ke===e.GLOB_SPLIT?Oe="":Oe=(0,b.escapeRegExpCharacters)(ke),be+=Oe;continue}switch(ke){case"{":ve=!0;continue;case"[":pe=!0;continue;case"}":{V+=`(?:${E(ne,",").map(oe=>p(oe)).join("|")})`,ve=!1,ne="";break}case"]":{V+="["+be+"]",pe=!1,be="";break}case"?":V+=k;continue;case"*":V+=T(1);continue;default:V+=(0,b.escapeRegExpCharacters)(ke)}}de<q.length-1&&(q[de+1]!==e.GLOBSTAR||de+2<q.length)&&(V+=L)}Y=Q===e.GLOBSTAR})}return V}const w=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,m=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,g=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new P.LRUCache(1e4),d=function(){return!1},s=function(){return null};function i(x,V){if(!x)return s;let q;typeof x!="string"?q=x.pattern:q=x,q=q.trim();const Y=`${q}_${!!V.trimForExclusions}`;let Q=n.get(Y);if(Q)return r(Q,x);let de;return w.test(q)?Q=o(q.substr(4),q):(de=f.exec(c(q,V)))?Q=u(de[1],q):(V.trimForExclusions?m:v).test(q)?Q=h(q,V):(de=a.exec(c(q,V)))?Q=y(de[1].substr(1),q,!0):(de=g.exec(c(q,V)))?Q=y(de[1],q,!1):Q=R(q),n.set(Y,Q),r(Q,x)}function r(x,V){if(typeof V=="string")return x;const q=function(Y,Q){return(0,C.isEqualOrParent)(Y,V.base,!D.isLinux)?x(Y.substr(V.base.length+1),Q):null};return q.allBasenames=x.allBasenames,q.allPaths=x.allPaths,q.basenames=x.basenames,q.patterns=x.patterns,q}function c(x,V){return V.trimForExclusions&&x.endsWith("/**")?x.substr(0,x.length-2):x}function o(x,V){return function(q,Y){return typeof q=="string"&&q.endsWith(x)?V:null}}function u(x,V){const q=`/${x}`,Y=`\\${x}`,Q=function(ve,ne){return typeof ve!="string"?null:ne?ne===x?V:null:ve===x||ve.endsWith(q)||ve.endsWith(Y)?V:null},de=[x];return Q.basenames=de,Q.patterns=[V],Q.allBasenames=de,Q}function h(x,V){const q=B(x.slice(1,-1).split(",").map(ne=>i(ne,V)).filter(ne=>ne!==s),x),Y=q.length;if(!Y)return s;if(Y===1)return q[0];const Q=function(ne,pe){for(let be=0,ke=q.length;be<ke;be++)if(q[be](ne,pe))return x;return null},de=q.find(ne=>!!ne.allBasenames);de&&(Q.allBasenames=de.allBasenames);const ve=q.reduce((ne,pe)=>pe.allPaths?ne.concat(pe.allPaths):ne,[]);return ve.length&&(Q.allPaths=ve),Q}function y(x,V,q){const Y=_.sep===_.posix.sep,Q=Y?x:x.replace(S,_.sep),de=_.sep+Q,ve=_.posix.sep+x;let ne;return q?ne=function(pe,be){return typeof pe=="string"&&(pe===Q||pe.endsWith(de)||!Y&&(pe===x||pe.endsWith(ve)))?V:null}:ne=function(pe,be){return typeof pe=="string"&&(pe===Q||!Y&&pe===x)?V:null},ne.allPaths=[(q?"*/":"./")+x],ne}function R(x){try{const V=new RegExp(`^${p(x)}$`);return function(q){return V.lastIndex=0,typeof q=="string"&&V.test(q)?x:null}}catch{return s}}function M(x,V,q){return!x||typeof V!="string"?!1:U(x)(V,void 0,q)}e.match=M;function U(x,V={}){if(!x)return d;if(typeof x=="string"||A(x)){const q=i(x,V);if(q===s)return d;const Y=function(Q,de){return!!q(Q,de)};return q.allBasenames&&(Y.allBasenames=q.allBasenames),q.allPaths&&(Y.allPaths=q.allPaths),Y}return N(x,V)}e.parse=U;function A(x){const V=x;return V?typeof V.base=="string"&&typeof V.pattern=="string":!1}e.isRelativePattern=A;function z(x){return x.allBasenames||[]}e.getBasenameTerms=z;function $(x){return x.allPaths||[]}e.getPathTerms=$;function N(x,V){const q=B(Object.getOwnPropertyNames(x).map(ne=>K(ne,x[ne],V)).filter(ne=>ne!==s)),Y=q.length;if(!Y)return s;if(!q.some(ne=>!!ne.requiresSiblings)){if(Y===1)return q[0];const ne=function(ke,Oe){let We;for(let oe=0,le=q.length;oe<le;oe++){const fe=q[oe](ke,Oe);if(typeof fe=="string")return fe;(0,t.isThenable)(fe)&&(We||(We=[]),We.push(fe))}return We?(async()=>{for(const oe of We){const le=await oe;if(typeof le=="string")return le}return null})():null},pe=q.find(ke=>!!ke.allBasenames);pe&&(ne.allBasenames=pe.allBasenames);const be=q.reduce((ke,Oe)=>Oe.allPaths?ke.concat(Oe.allPaths):ke,[]);return be.length&&(ne.allPaths=be),ne}const Q=function(ne,pe,be){let ke,Oe;for(let We=0,oe=q.length;We<oe;We++){const le=q[We];le.requiresSiblings&&be&&(pe||(pe=(0,_.basename)(ne)),ke||(ke=pe.substr(0,pe.length-(0,_.extname)(ne).length)));const fe=le(ne,pe,ke,be);if(typeof fe=="string")return fe;(0,t.isThenable)(fe)&&(Oe||(Oe=[]),Oe.push(fe))}return Oe?(async()=>{for(const We of Oe){const oe=await We;if(typeof oe=="string")return oe}return null})():null},de=q.find(ne=>!!ne.allBasenames);de&&(Q.allBasenames=de.allBasenames);const ve=q.reduce((ne,pe)=>pe.allPaths?ne.concat(pe.allPaths):ne,[]);return ve.length&&(Q.allPaths=ve),Q}function K(x,V,q){if(V===!1)return s;const Y=i(x,q);if(Y===s)return s;if(typeof V=="boolean")return Y;if(V){const Q=V.when;if(typeof Q=="string"){const de=(ve,ne,pe,be)=>{if(!be||!Y(ve,ne))return null;const ke=Q.replace("$(basename)",pe),Oe=be(ke);return(0,t.isThenable)(Oe)?Oe.then(We=>We?x:null):Oe?x:null};return de.requiresSiblings=!0,de}}return Y}function B(x,V){const q=x.filter(ne=>!!ne.basenames);if(q.length<2)return x;const Y=q.reduce((ne,pe)=>{const be=pe.basenames;return be?ne.concat(be):ne},[]);let Q;if(V){Q=[];for(let ne=0,pe=Y.length;ne<pe;ne++)Q.push(V)}else Q=q.reduce((ne,pe)=>{const be=pe.patterns;return be?ne.concat(be):ne},[]);const de=function(ne,pe){if(typeof ne!="string")return null;if(!pe){let ke;for(ke=ne.length;ke>0;ke--){const Oe=ne.charCodeAt(ke-1);if(Oe===47||Oe===92)break}pe=ne.substr(ke)}const be=Y.indexOf(pe);return be!==-1?Q[be]:null};de.basenames=Y,de.patterns=Q,de.allBasenames=Y;const ve=x.filter(ne=>!ne.basenames);return ve.push(de),ve}function O(x,V){return(0,l.equals)(x,V,(q,Y)=>typeof q=="string"&&typeof Y=="string"?q===Y:typeof q!="string"&&typeof Y!="string"?q.base===Y.base&&q.pattern===Y.pattern:!1)}e.patternsEquals=O}),define(De[106],Ie([1,0,10,156,22,8,2]),function(J,e,l,t,C,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var D;(function(w){w[w.Paragraph=0]="Paragraph",w[w.Break=1]="Break"})(D=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class b{constructor(f="",v=!1){if(this.value=f,typeof this.value!="string")throw(0,l.illegalArgument)("value");typeof v=="boolean"?(this.isTrusted=v,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=v.isTrusted??void 0,this.supportThemeIcons=v.supportThemeIcons??!1,this.supportHtml=v.supportHtml??!1)}appendText(f,v=0){return this.value+=S(this.supportThemeIcons?(0,t.escapeIcons)(f):f).replace(/([ \t]+)/g,(m,a)=>"&nbsp;".repeat(a.length)).replace(/\>/gm,"\\>").replace(/\n/g,v===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,v){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=v,this.value+="\n```\n",this}appendLink(f,v,m){return this.value+="[",this.value+=this._escape(v,"]"),this.value+="](",this.value+=this._escape(String(f),")"),m&&(this.value+=` "${this._escape(this._escape(m,'"'),")")}"`),this.value+=")",this}_escape(f,v){const m=new RegExp((0,P.escapeRegExpCharacters)(v),"g");return f.replace(m,(a,g)=>f.charAt(g-1)!=="\\"?`\\${a}`:a)}}e.MarkdownString=b;function I(w){return L(w)?!w.value:Array.isArray(w)?w.every(I):!0}e.isEmptyMarkdownString=I;function L(w){return w instanceof b?!0:w&&typeof w=="object"?typeof w.value=="string"&&(typeof w.isTrusted=="boolean"||w.isTrusted===void 0)&&(typeof w.supportThemeIcons=="boolean"||w.supportThemeIcons===void 0):!1}e.isMarkdownString=L;function k(w,f){return w===f?!0:!w||!f?!1:w.value===f.value&&w.isTrusted===f.isTrusted&&w.supportThemeIcons===f.supportThemeIcons&&w.supportHtml===f.supportHtml&&(w.baseUri===f.baseUri||!!w.baseUri&&!!f.baseUri&&(0,C.isEqual)(_.URI.from(w.baseUri),_.URI.from(f.baseUri)))}e.markdownStringEqual=k;function S(w){return w.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=S;function T(w){return w.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=T;function E(w){return w&&w.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=E;function p(w){const f=[],v=w.split("|").map(a=>a.trim());w=v[0];const m=v[1];if(m){const a=/height=(\d+)/.exec(m),g=/width=(\d+)/.exec(m),n=a?a[1]:"",d=g?g[1]:"",s=isFinite(parseInt(d)),i=isFinite(parseInt(n));s&&f.push(`width="${d}"`),i&&f.push(`height="${n}"`)}return{href:w,dimensions:f}}e.parseHrefAndDimensions=p}),define(De[107],Ie([1,0,17,31,9,11,22,8]),function(J,e,l,t,C,P,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function b(s,i){const{os:r,tildify:c,relative:o}=i;if(o){const y=I(s,o,r);if(typeof y=="string")return y}let u=s.fsPath;if(r===1&&!P.isWindows?u=u.replace(/\//g,"\\"):r!==1&&P.isWindows&&(u=u.replace(/\\/g,"/")),r!==1&&c?.userHome){const y=c.userHome.fsPath;let R;s.scheme!==c.userHome.scheme&&s.path.startsWith(C.posix.sep)?R=c.userHome.with({path:s.path}).fsPath:R=s.fsPath,u=S(R,y,r)}return(r===1?C.win32:C.posix).normalize(L(u,r===1))}e.getPathLabel=b;function I(s,i,r){const c=r===1?C.win32:C.posix,o=r===3?_.extUri:_.extUriIgnorePathCase,u=i.getWorkspace(),h=(0,l.firstOrDefault)(u.folders);if(!h)return;s.scheme!==h.uri.scheme&&s.path.startsWith(C.posix.sep)&&(s=h.uri.with({path:s.path}));const y=i.getWorkspaceFolder(s);if(!y)return;let R;if(o.isEqual(y.uri,s)?R="":R=o.relativePath(y.uri,s)??"",R&&(R=c.normalize(R)),u.folders.length>1&&!i.noPrefix){const M=y.name?y.name:o.basenameOrAuthority(y.uri);R=R?`${M} \u2022 ${R}`:M}return R}function L(s,i=P.isWindows){return(0,t.hasDriveLetter)(s,i)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=L;let k=Object.create(null);function S(s,i,r=P.OS){if(r===1||!s||!i)return s;let c=k.original===i?k.normalized:void 0;c||(c=i,P.isWindows&&(c=(0,t.toSlashes)(c)),c=`${(0,D.rtrim)(c,C.posix.sep)}${C.posix.sep}`,k={original:i,normalized:c});let o=s;return P.isWindows&&(o=(0,t.toSlashes)(o)),(r===3?o.startsWith(c):(0,D.startsWithIgnoreCase)(o,c))?`~/${o.substr(c.length)}`:s}e.tildify=S;function T(s,i){return s.replace(/^~($|\/|\\)/,`${i}$1`)}e.untildify=T;const E="\u2026",p="\\\\",w="~";function f(s,i=C.sep){const r=new Array(s.length);let c=!1;for(let o=0;o<s.length;o++){const u=s[o];if(u===""){r[o]=`.${i}`;continue}if(!u){r[o]=u;continue}c=!0;let h="",y=u;y.indexOf(p)===0?(h=y.substr(0,y.indexOf(p)+p.length),y=y.substr(y.indexOf(p)+p.length)):y.indexOf(i)===0?(h=y.substr(0,y.indexOf(i)+i.length),y=y.substr(y.indexOf(i)+i.length)):y.indexOf(w)===0&&(h=y.substr(0,y.indexOf(w)+w.length),y=y.substr(y.indexOf(w)+w.length));const R=y.split(i);for(let M=1;c&&M<=R.length;M++)for(let U=R.length-M;c&&U>=0;U--){c=!1;let A=R.slice(U,U+M).join(i);for(let z=0;!c&&z<s.length;z++)if(z!==o&&s[z]&&s[z].indexOf(A)>-1){const $=U+M===R.length,N=U>0&&s[z].indexOf(i)>-1?i+A:A,K=s[z].endsWith(N);c=!$||K}if(!c){let z="";(R[0].endsWith(":")||h!=="")&&(U===1&&(U=0,M++,A=R[0]+i+A),U>0&&(z=R[0]+i),z=h+z),U>0&&(z=z+E+i),z=z+A,U+M<R.length&&(z=z+i+E),r[o]=z}}c&&(r[o]=u)}return r}e.shorten=f;var v;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(v||(v={}));function m(s,i=Object.create(null)){const r=[];let c=!1,o="";for(const u of s)if(u==="$"||c&&u==="{")o&&r.push({value:o,type:v.TEXT}),o="",c=!0;else if(u==="}"&&c){const h=i[o];if(typeof h=="string")h.length&&r.push({value:h,type:v.VARIABLE});else if(h){const y=r[r.length-1];(!y||y.type!==v.SEPARATOR)&&r.push({value:h.label,type:v.SEPARATOR})}o="",c=!1}else o+=u;return o&&!c&&r.push({value:o,type:v.TEXT}),r.filter((u,h)=>{if(u.type===v.SEPARATOR){const y=r[h-1],R=r[h+1];return[y,R].every(M=>M&&(M.type===v.VARIABLE||M.type===v.TEXT)&&M.value.length>0)}return!0}).map(u=>u.value).join("")}e.template=m;function a(s,i){return P.isMacintosh||i?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,P.isMacintosh?"&":"&&"):s.replace(/&&|&/g,r=>r==="&"?"&&":"&")}e.mnemonicMenuLabel=a;function g(s,i){return P.isMacintosh||i?s.replace(/\(&&\w\)|&&/g,""):P.isWindows?s.replace(/&&|&/g,r=>r==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=g;function n(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=n;function d(s){const i=s.indexOf("/")!==-1?C.posix:C.win32,r=i.basename(s),c=i.dirname(s);return r.length?{name:r,parentPath:c}:{name:c,parentPath:""}}e.splitName=d}),define(De[108],Ie([1,0,2]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(L){return L.toJSON()}class C{constructor(k){this._uriTransformer=k}transformIncoming(k){const S=this._uriTransformer.transformIncoming(k);return S===k?k:t(l.URI.from(S))}transformOutgoing(k){const S=this._uriTransformer.transformOutgoing(k);return S===k?k:t(l.URI.from(S))}transformOutgoingURI(k){const S=this._uriTransformer.transformOutgoing(k);return S===k?k:l.URI.from(S)}transformOutgoingScheme(k){return this._uriTransformer.transformOutgoingScheme(k)}}e.URITransformer=C,e.DefaultURITransformer=new class{transformIncoming(L){return L}transformOutgoing(L){return L}transformOutgoingURI(L){return L}transformOutgoingScheme(L){return L}};function P(L,k,S){if(!L||S>200)return null;if(typeof L=="object"){if(L instanceof l.URI)return k.transformOutgoing(L);for(const T in L)if(Object.hasOwnProperty.call(L,T)){const E=P(L[T],k,S+1);E!==null&&(L[T]=E)}}return null}function _(L,k){const S=P(L,k,0);return S===null?L:S}e.transformOutgoingURIs=_;function D(L,k,S,T){if(!L||T>200)return null;if(typeof L=="object"){if(L.$mid===1)return S?l.URI.revive(k.transformIncoming(L)):k.transformIncoming(L);for(const E in L)if(Object.hasOwnProperty.call(L,E)){const p=D(L[E],k,S,T+1);p!==null&&(L[E]=p)}}return null}function b(L,k){const S=D(L,k,!1,0);return S===null?L:S}e.transformIncomingURIs=b;function I(L,k){const S=D(L,k,!0,0);return S===null?L:S}e.transformAndReviveIncomingURIs=I}),define(De[29],Ie([1,0,61,81,301,18,31,79,9,11,22,2]),function(J,e,l,t,C,P,_,D,b,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var S;(function(N){N[N.UNLINK=0]="UNLINK",N[N.MOVE=1]="MOVE"})(S=e.RimRafMode||(e.RimRafMode={}));async function T(N,K=S.UNLINK){if((0,_.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");return K===S.UNLINK?p(N):E(N)}async function E(N){try{const K=(0,_.randomPath)((0,t.tmpdir)());try{await l.promises.rename(N,K)}catch(B){return B.code==="ENOENT"?void 0:p(N)}p(K).catch(B=>{})}catch(K){if(K.code!=="ENOENT")throw K}}async function p(N){return(0,C.promisify)(l.rm)(N,{recursive:!0,force:!0,maxRetries:3})}function w(N){if((0,_.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");l.rmSync(N,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=w;async function f(N,K){return a(await(K?v(N):(0,C.promisify)(l.readdir)(N)))}async function v(N){try{return await(0,C.promisify)(l.readdir)(N,{withFileTypes:!0})}catch(O){console.warn("[node.js fs] readdir with filetypes failed with error: ",O)}const K=[],B=await f(N);for(const O of B){let x=!1,V=!1,q=!1;try{const Y=await e.Promises.lstat((0,b.join)(N,O));x=Y.isFile(),V=Y.isDirectory(),q=Y.isSymbolicLink()}catch(Y){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Y)}K.push({name:O,isFile:()=>x,isDirectory:()=>V,isSymbolicLink:()=>q})}return K}function m(N){return a(l.readdirSync(N))}e.readdirSync=m;function a(N){return N.map(K=>typeof K=="string"?I.isMacintosh?(0,D.normalizeNFC)(K):K:(K.name=I.isMacintosh?(0,D.normalizeNFC)(K.name):K.name,K))}async function g(N){const K=await f(N),B=[];for(const O of K)await d.existsDirectory((0,b.join)(N,O))&&B.push(O);return B}function n(N,K=1e3){return new Promise(B=>{let O=!1;const x=setInterval(()=>{O||(O=!0,l.access(N,V=>{O=!1,V&&(clearInterval(x),B(void 0))}))},K)})}e.whenDeleted=n;var d;(function(N){async function K(x){let V;try{if(V=await e.Promises.lstat(x),!V.isSymbolicLink())return{stat:V}}catch{}try{return{stat:await e.Promises.stat(x),symbolicLink:V?.isSymbolicLink()?{dangling:!1}:void 0}}catch(q){if(q.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};if(I.isWindows&&q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(Y){if(Y.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};throw Y}throw q}}N.stat=K;async function B(x){try{const{stat:V,symbolicLink:q}=await N.stat(x);return V.isFile()&&q?.dangling!==!0}catch{}return!1}N.existsFile=B;async function O(x){try{const{stat:V,symbolicLink:q}=await N.stat(x);return V.isDirectory()&&q?.dangling!==!0}catch{}return!1}N.existsDirectory=O})(d=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new P.ResourceQueue;function i(N,K,B){return s.queueFor(k.URI.file(N),L.extUriBiasedIgnorePathCase).queue(()=>{const O=h(B);return new Promise((x,V)=>o(N,K,O,q=>q?V(q):x()))})}let r=!0;function c(N){r=N}e.configureFlushOnWrite=c;function o(N,K,B,O){if(!r)return l.writeFile(N,K,{mode:B.mode,flag:B.flag},O);l.open(N,B.flag,B.mode,(x,V)=>{if(x)return O(x);l.writeFile(V,K,q=>{if(q)return l.close(V,()=>O(q));l.fdatasync(V,Y=>(Y&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Y),c(!1)),l.close(V,Q=>O(Q))))})})}function u(N,K,B){const O=h(B);if(!r)return l.writeFileSync(N,K,{mode:O.mode,flag:O.flag});const x=l.openSync(N,O.flag,O.mode);try{l.writeFileSync(x,K);try{l.fdatasyncSync(x)}catch(V){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",V),c(!1)}}finally{l.closeSync(x)}}e.writeFileSync=u;function h(N){return N?{mode:typeof N.mode=="number"?N.mode:438,flag:typeof N.flag=="string"?N.flag:"w"}:{mode:438,flag:"w"}}async function y(N,K){if(N!==K)try{await e.Promises.rename(N,K)}catch(B){if(N.toLowerCase()!==K.toLowerCase()&&B.code==="EXDEV"||N.endsWith("."))await R(N,K,{preserveSymlinks:!1}),await T(N,S.MOVE);else throw B}}async function R(N,K,B){return U(N,K,{root:{source:N,target:K},options:B,handledSourcePaths:new Set})}const M=511;async function U(N,K,B){if(B.handledSourcePaths.has(N))return;B.handledSourcePaths.add(N);const{stat:O,symbolicLink:x}=await d.stat(N);if(x){if(B.options.preserveSymlinks)try{return await $(N,K,B)}catch(V){console.warn("[node.js fs] copy of symlink failed: ",V)}if(x.dangling)return}return O.isDirectory()?A(N,K,O.mode&M,B):z(N,K,O.mode&M)}async function A(N,K,B,O){await e.Promises.mkdir(K,{recursive:!0,mode:B});const x=await f(N);for(const V of x)await U((0,b.join)(N,V),(0,b.join)(K,V),O)}async function z(N,K,B){await e.Promises.copyFile(N,K),await e.Promises.chmod(K,B)}async function $(N,K,B){let O=await e.Promises.readlink(N);(0,_.isEqualOrParent)(O,B.root.source,!I.isLinux)&&(O=(0,b.join)(B.root.target,O.substr(B.root.source.length+1))),await e.Promises.symlink(O,K)}e.Promises=new class{get access(){return(0,C.promisify)(l.access)}get stat(){return(0,C.promisify)(l.stat)}get lstat(){return(0,C.promisify)(l.lstat)}get utimes(){return(0,C.promisify)(l.utimes)}get read(){return(N,K,B,O,x)=>new Promise((V,q)=>{l.read(N,K,B,O,x,(Y,Q,de)=>Y?q(Y):V({bytesRead:Q,buffer:de}))})}get readFile(){return(0,C.promisify)(l.readFile)}get write(){return(N,K,B,O,x)=>new Promise((V,q)=>{l.write(N,K,B,O,x,(Y,Q,de)=>Y?q(Y):V({bytesWritten:Q,buffer:de}))})}get appendFile(){return(0,C.promisify)(l.appendFile)}get fdatasync(){return(0,C.promisify)(l.fdatasync)}get truncate(){return(0,C.promisify)(l.truncate)}get rename(){return(0,C.promisify)(l.rename)}get copyFile(){return(0,C.promisify)(l.copyFile)}get open(){return(0,C.promisify)(l.open)}get close(){return(0,C.promisify)(l.close)}get symlink(){return(0,C.promisify)(l.symlink)}get readlink(){return(0,C.promisify)(l.readlink)}get chmod(){return(0,C.promisify)(l.chmod)}get mkdir(){return(0,C.promisify)(l.mkdir)}get unlink(){return(0,C.promisify)(l.unlink)}get rmdir(){return(0,C.promisify)(l.rmdir)}get realpath(){return(0,C.promisify)(l.realpath)}async exists(N){try{return await e.Promises.access(N),!0}catch{return!1}}get readdir(){return f}get readDirsInDir(){return g}get writeFile(){return i}get rm(){return T}get move(){return y}get copy(){return R}}}),define(De[109],Ie([1,0,61,9,11,8,29]),function(J,e,l,t,C,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function D(S){if(C.isLinux)return S;const T=(0,t.dirname)(S);if(S===T)return S;const E=((0,t.basename)(S)||S).toLowerCase();try{const w=(0,_.readdirSync)(T).filter(f=>f.toLowerCase()===E);if(w.length===1){const f=D(T);if(f)return(0,t.join)(f,w[0])}else if(w.length>1){const f=w.indexOf(E);if(f>=0){const v=D(T);if(v)return(0,t.join)(v,w[f])}}}catch{}return null}e.realcaseSync=D;async function b(S){if(C.isLinux)return S;const T=(0,t.dirname)(S);if(S===T)return S;const E=((0,t.basename)(S)||S).toLowerCase();try{const w=(await _.Promises.readdir(T)).filter(f=>f.toLowerCase()===E);if(w.length===1){const f=await b(T);if(f)return(0,t.join)(f,w[0])}else if(w.length>1){const f=w.indexOf(E);if(f>=0){const v=await b(T);if(v)return(0,t.join)(v,w[f])}}}catch{}return null}e.realcase=b;async function I(S){try{return await _.Promises.realpath(S)}catch{const E=k(S);return await _.Promises.access(E,l.constants.R_OK),E}}e.realpath=I;function L(S){try{return l.realpathSync(S)}catch{const E=k(S);return l.accessSync(E,l.constants.R_OK),E}}e.realpathSync=L;function k(S){return(0,P.rtrim)((0,t.normalize)(S),t.sep)}}),define(De[110],Ie([1,0,9,11,40,102,14,29]),function(J,e,l,t,C,P,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return P.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return P.TerminateResponseCode}});function b(k=C.env){return k.comspec||"cmd.exe"}e.getWindowsShell=b;function I(k){let S=[],T=!1;const E=function(p){if(T){S.push(p);return}(!k.send(p,f=>{if(f&&console.error(f),T=!1,S.length>0){const v=S.slice(0);S=[],v.forEach(m=>E(m))}})||t.isWindows)&&(T=!0)};return{send:E}}e.createQueuedSender=I;var L;(function(k){async function S(T,E,p){if(l.isAbsolute(T))return T;if(E===void 0&&(E=C.cwd()),l.dirname(T)!=="."||(p===void 0&&_.isString(C.env.PATH)&&(p=C.env.PATH.split(l.delimiter)),p===void 0||p.length===0))return l.join(E,T);async function f(v){if(await D.Promises.exists(v)){let m;try{m=await D.Promises.stat(v)}catch(a){a.message.startsWith("EACCES")&&(m=await D.Promises.lstat(v))}return m?!m.isDirectory():!1}return!1}for(const v of p){let m;if(l.isAbsolute(v)?m=l.join(v,T):m=l.join(E,v,T),await f(m))return m;let a=m+".com";if(await f(a)||(a=m+".exe",await f(a)))return a}return l.join(E,T)}k.findExecutable=S})(L=e.win32||(e.win32={}))});var qe=this&&this.__decorate||function(J,e,l,t){var C=arguments.length,P=C<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,l):t,_;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(J,e,l,t);else for(var D=J.length-1;D>=0;D--)(_=J[D])&&(P=(C<3?_(P):C>3?_(e,l,P):_(e,l))||P);return C>3&&P&&Object.defineProperty(e,l,P),P};define(De[111],Ie([1,0,17,18,23,21,58,10,4,6,80,8,14]),function(J,e,l,t,C,P,_,D,b,I,L,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var T;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(T=e.RequestType||(e.RequestType={}));function E(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(p=e.ResponseType||(e.ResponseType={}));function w(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(f||(f={}));class v{constructor(V){this.buffer=V,this.pos=0}read(V){const q=this.buffer.slice(this.pos,this.pos+V);return this.pos+=q.byteLength,q}}class m{constructor(){this.buffers=[]}get buffer(){return C.VSBuffer.concat(this.buffers)}write(V){this.buffers.push(V)}}var a;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object"})(a||(a={}));function g(x){const V=C.VSBuffer.alloc(4);return V.writeUInt32BE(x,0),V}function n(x){return x.read(4).readUInt32BE(0)}function d(x){const V=C.VSBuffer.alloc(1);return V.writeUInt8(x,0),V}const s={Undefined:d(a.Undefined),String:d(a.String),Buffer:d(a.Buffer),VSBuffer:d(a.VSBuffer),Array:d(a.Array),Object:d(a.Object)},i=typeof Buffer<"u";function r(x,V){if(typeof V>"u")x.write(s.Undefined);else if(typeof V=="string"){const q=C.VSBuffer.fromString(V);x.write(s.String),x.write(g(q.byteLength)),x.write(q)}else if(i&&Buffer.isBuffer(V)){const q=C.VSBuffer.wrap(V);x.write(s.Buffer),x.write(g(q.byteLength)),x.write(q)}else if(V instanceof C.VSBuffer)x.write(s.VSBuffer),x.write(g(V.byteLength)),x.write(V);else if(Array.isArray(V)){x.write(s.Array),x.write(g(V.length));for(const q of V)r(x,q)}else{const q=C.VSBuffer.fromString(JSON.stringify(V));x.write(s.Object),x.write(g(q.byteLength)),x.write(q)}}function c(x){switch(x.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return x.read(n(x)).toString();case a.Buffer:return x.read(n(x)).buffer;case a.VSBuffer:return x.read(n(x));case a.Array:{const q=n(x),Y=[];for(let Q=0;Q<q;Q++)Y.push(c(x));return Y}case a.Object:return JSON.parse(x.read(n(x)).toString())}}class o{constructor(V,q,Y=null,Q=1e3){this.protocol=V,this.ctx=q,this.logger=Y,this.timeoutDelay=Q,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(de=>this.onRawMessage(de)),this.sendResponse({type:200})}registerChannel(V,q){this.channels.set(V,q),setTimeout(()=>this.flushPendingRequests(V),0)}sendResponse(V){switch(V.type){case 200:{const q=this.send([V.type]);this.logger?.logOutgoing(q,0,1,w(V.type));return}case 201:case 202:case 204:case 203:{const q=this.send([V.type,V.id],V.data);this.logger?.logOutgoing(q,V.id,1,w(V.type),V.data);return}}}send(V,q=void 0){const Y=new m;return r(Y,V),r(Y,q),this.sendBuffer(Y.buffer)}sendBuffer(V){try{return this.protocol.send(V),V.byteLength}catch{return 0}}onRawMessage(V){const q=new v(V),Y=c(q),Q=c(q),de=Y[0];switch(de){case 100:return this.logger?.logIncoming(V.byteLength,Y[1],1,`${E(de)}: ${Y[2]}.${Y[3]}`,Q),this.onPromise({type:de,id:Y[1],channelName:Y[2],name:Y[3],arg:Q});case 102:return this.logger?.logIncoming(V.byteLength,Y[1],1,`${E(de)}: ${Y[2]}.${Y[3]}`,Q),this.onEventListen({type:de,id:Y[1],channelName:Y[2],name:Y[3],arg:Q});case 101:return this.logger?.logIncoming(V.byteLength,Y[1],1,`${E(de)}`),this.disposeActiveRequest({type:de,id:Y[1]});case 103:return this.logger?.logIncoming(V.byteLength,Y[1],1,`${E(de)}`),this.disposeActiveRequest({type:de,id:Y[1]})}}onPromise(V){const q=this.channels.get(V.channelName);if(!q){this.collectPendingRequest(V);return}const Y=new P.CancellationTokenSource;let Q;try{Q=q.call(this.ctx,V.name,V.arg,Y.token)}catch(ne){Q=Promise.reject(ne)}const de=V.id;Q.then(ne=>{this.sendResponse({id:de,data:ne,type:201}),this.activeRequests.delete(V.id)},ne=>{ne instanceof Error?this.sendResponse({id:de,data:{message:ne.message,name:ne.name,stack:ne.stack?ne.stack.split?ne.stack.split(`
`):ne.stack:void 0},type:202}):this.sendResponse({id:de,data:ne,type:203}),this.activeRequests.delete(V.id)});const ve=(0,I.toDisposable)(()=>Y.cancel());this.activeRequests.set(V.id,ve)}onEventListen(V){const q=this.channels.get(V.channelName);if(!q){this.collectPendingRequest(V);return}const Y=V.id,de=q.listen(this.ctx,V.name,V.arg)(ve=>this.sendResponse({id:Y,data:ve,type:204}));this.activeRequests.set(V.id,de)}disposeActiveRequest(V){const q=this.activeRequests.get(V.id);q&&(q.dispose(),this.activeRequests.delete(V.id))}collectPendingRequest(V){let q=this.pendingRequests.get(V.channelName);q||(q=[],this.pendingRequests.set(V.channelName,q));const Y=setTimeout(()=>{console.error(`Unknown channel: ${V.channelName}`),V.type===100&&this.sendResponse({id:V.id,data:{name:"Unknown channel",message:`Channel name '${V.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);q.push({request:V,timeoutTimer:Y})}flushPendingRequests(V){const q=this.pendingRequests.get(V);if(q){for(const Y of q)switch(clearTimeout(Y.timeoutTimer),Y.request.type){case 100:this.onPromise(Y.request);break;case 102:this.onEventListen(Y.request);break}this.pendingRequests.delete(V)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,I.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=o;var u;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(u=e.RequestInitiator||(e.RequestInitiator={}));class h{constructor(V,q=null){this.protocol=V,this.isDisposed=!1,this.state=f.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new b.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(Y=>this.onBuffer(Y)),this.logger=q}getChannel(V){const q=this;return{call(Y,Q,de){return q.isDisposed?Promise.reject(new D.CancellationError):q.requestPromise(V,Y,Q,de)},listen(Y,Q){return q.isDisposed?b.Event.None:q.requestEvent(V,Y,Q)}}}requestPromise(V,q,Y,Q=P.CancellationToken.None){const de=this.lastRequestId++,ne={id:de,type:100,channelName:V,name:q,arg:Y};if(Q.isCancellationRequested)return Promise.reject(new D.CancellationError);let pe;return new Promise((ke,Oe)=>{if(Q.isCancellationRequested)return Oe(new D.CancellationError);const We=()=>{const Z=ae=>{switch(ae.type){case 201:this.handlers.delete(de),ke(ae.data);break;case 202:{this.handlers.delete(de);const ee=new Error(ae.data.message);ee.stack=ae.data.stack,ee.name=ae.data.name,Oe(ee);break}case 203:this.handlers.delete(de),Oe(ae.data);break}};this.handlers.set(de,Z),this.sendRequest(ne)};let oe=null;this.state===f.Idle?We():(oe=(0,t.createCancelablePromise)(Z=>this.whenInitialized()),oe.then(()=>{oe=null,We()}));const le=()=>{oe?(oe.cancel(),oe=null):this.sendRequest({id:de,type:101}),Oe(new D.CancellationError)},fe=Q.onCancellationRequested(le);pe=(0,I.combinedDisposable)((0,I.toDisposable)(le),fe),this.activeRequests.add(pe)}).finally(()=>{this.activeRequests.delete(pe)})}requestEvent(V,q,Y){const Q=this.lastRequestId++,ve={id:Q,type:102,channelName:V,name:q,arg:Y};let ne=null;const pe=new b.Emitter({onFirstListenerAdd:()=>{ne=(0,t.createCancelablePromise)(ke=>this.whenInitialized()),ne.then(()=>{ne=null,this.activeRequests.add(pe),this.sendRequest(ve)})},onLastListenerRemove:()=>{ne?(ne.cancel(),ne=null):(this.activeRequests.delete(pe),this.sendRequest({id:Q,type:103}))}}),be=ke=>pe.fire(ke.data);return this.handlers.set(Q,be),pe.event}sendRequest(V){switch(V.type){case 100:case 102:{const q=this.send([V.type,V.id,V.channelName,V.name],V.arg);this.logger?.logOutgoing(q,V.id,0,`${E(V.type)}: ${V.channelName}.${V.name}`,V.arg);return}case 101:case 103:{const q=this.send([V.type,V.id]);this.logger?.logOutgoing(q,V.id,0,E(V.type));return}}}send(V,q=void 0){const Y=new m;return r(Y,V),r(Y,q),this.sendBuffer(Y.buffer)}sendBuffer(V){try{return this.protocol.send(V),V.byteLength}catch{return 0}}onBuffer(V){const q=new v(V),Y=c(q),Q=c(q),de=Y[0];switch(de){case 200:return this.logger?.logIncoming(V.byteLength,0,0,w(de)),this.onResponse({type:Y[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(V.byteLength,Y[1],0,w(de),Q),this.onResponse({type:Y[0],id:Y[1],data:Q})}}onResponse(V){if(V.type===200){this.state=f.Idle,this._onDidInitialize.fire();return}this.handlers.get(V.id)?.(V)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,I.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}qe([_.memoize],h.prototype,"onDidInitializePromise",null),e.ChannelClient=h;class y{constructor(V){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new b.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new b.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,V(({protocol:q,onDidClientDisconnect:Y})=>{b.Event.once(q.onMessage)(de=>{const ve=new v(de),ne=c(ve),pe=new o(q,ne),be=new h(q);this.channels.forEach((Oe,We)=>pe.registerChannel(We,Oe));const ke={channelServer:pe,channelClient:be,ctx:ne};this._connections.add(ke),this._onDidAddConnection.fire(ke),Y(()=>{pe.dispose(),be.dispose(),this._connections.delete(ke),this._onDidRemoveConnection.fire(ke)})})})}get connections(){const V=[];return this._connections.forEach(q=>V.push(q)),V}getChannel(V,q){const Y=this;return{call(Q,de,ve){let ne;if((0,S.isFunction)(q)){const be=(0,l.getRandomElement)(Y.connections.filter(q));ne=be?Promise.resolve(be):b.Event.toPromise(b.Event.filter(Y.onDidAddConnection,q))}else ne=q.routeCall(Y,Q,de);const pe=ne.then(be=>be.channelClient.getChannel(V));return M(pe).call(Q,de,ve)},listen(Q,de){if((0,S.isFunction)(q))return Y.getMulticastEvent(V,q,Q,de);const ve=q.routeEvent(Y,Q,de).then(ne=>ne.channelClient.getChannel(V));return M(ve).listen(Q,de)}}}getMulticastEvent(V,q,Y,Q){const de=this;let ve=new I.DisposableStore;const ne=new b.Emitter({onFirstListenerAdd:()=>{ve=new I.DisposableStore;const pe=new b.EventMultiplexer,be=new Map,ke=We=>{const le=We.channelClient.getChannel(V).listen(Y,Q),fe=pe.add(le);be.set(We,fe)},Oe=We=>{const oe=be.get(We);!oe||(oe.dispose(),be.delete(We))};de.connections.filter(q).forEach(ke),b.Event.filter(de.onDidAddConnection,q)(ke,void 0,ve),de.onDidRemoveConnection(Oe,void 0,ve),pe.event(ne.fire,ne,ve),ve.add(pe)},onLastListenerRemove:()=>{ve.dispose()}});return ne.event}registerChannel(V,q){this.channels.set(V,q),this._connections.forEach(Y=>{Y.channelServer.registerChannel(V,q)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=y;class R{constructor(V,q,Y=null){const Q=new m;r(Q,q),V.send(Q.buffer),this.channelClient=new h(V,Y),this.channelServer=new o(V,q,Y)}getChannel(V){return this.channelClient.getChannel(V)}registerChannel(V,q){this.channelServer.registerChannel(V,q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=R;function M(x){return{call(V,q,Y){return x.then(Q=>Q.call(V,q,Y))},listen(V,q){const Y=new b.Relay;return x.then(Q=>Y.input=Q.listen(V,q)),Y.event}}}e.getDelayedChannel=M;function U(x){let V=!1;return{call(q,Y,Q){return V?x.call(q,Y,Q):(0,t.timeout)(0).then(()=>V=!0).then(()=>x.call(q,Y,Q))},listen(q,Y){if(V)return x.listen(q,Y);const Q=new b.Relay;return(0,t.timeout)(0).then(()=>V=!0).then(()=>Q.input=x.listen(q,Y)),Q.event}}}e.getNextTickChannel=U;class A{constructor(V){this.fn=V}routeCall(V){return this.route(V)}routeEvent(V){return this.route(V)}async route(V){for(const q of V.connections)if(await Promise.resolve(this.fn(q.ctx)))return Promise.resolve(q);return await b.Event.toPromise(V.onDidAddConnection),await this.route(V)}}e.StaticRouter=A;var z;(function(x){function V(de,ve){const ne=de,pe=ve&&ve.disableMarshalling,be=new Map;for(const ke in ne)Y(ke)&&be.set(ke,b.Event.buffer(ne[ke],!0));return new class{listen(ke,Oe,We){const oe=be.get(Oe);if(oe)return oe;if(Q(Oe)){const le=ne[Oe];if(typeof le=="function")return le.call(ne,We)}throw new Error(`Event not found: ${Oe}`)}call(ke,Oe,We){const oe=ne[Oe];if(typeof oe=="function"){if(!pe&&Array.isArray(We))for(let le=0;le<We.length;le++)We[le]=(0,L.revive)(We[le]);return oe.apply(ne,We)}throw new Error(`Method not found: ${Oe}`)}}}x.fromService=V;function q(de,ve){const ne=ve&&ve.disableMarshalling;return new Proxy({},{get(pe,be){if(typeof be=="string")return ve?.properties?.has(be)?ve.properties.get(be):Q(be)?function(ke){return de.listen(be,ke)}:Y(be)?de.listen(be):async function(...ke){let Oe;ve&&!(0,S.isUndefinedOrNull)(ve.context)?Oe=[ve.context,...ke]:Oe=ke;const We=await de.call(be,Oe);return ne?We:(0,L.revive)(We)};throw new Error(`Property not found: ${String(be)}`)}})}x.toService=q;function Y(de){return de[0]==="o"&&de[1]==="n"&&k.isUpperAsciiLetter(de.charCodeAt(2))}function Q(de){return/^onDynamic/.test(de)&&k.isUpperAsciiLetter(de.charCodeAt(9))}})(z=e.ProxyChannel||(e.ProxyChannel={}));const $=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function N(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){const V=x.toString();if(V!=="[object Object]")return V}return x}function K(x){return Array.isArray(x)?x.map(N):N(x)}function B(x,V,q,Y,Q,de,ve){ve=K(ve);const ne=$[Q],pe=ne[Y%ne.length];let be=[`%c[${x}]%c[${String(V).padStart(7," ")}]%c[len: ${String(q).padStart(5," ")}]%c${String(Y).padStart(5," ")} - ${de}`,"color: darkgreen","color: grey","color: grey",`color: ${pe}`];/\($/.test(de)?(be=be.concat(ve),be.push(")")):be.push(ve),console.log.apply(console,be)}e.logWithColors=B;class O{constructor(V,q){this._outgoingPrefix=V,this._incomingPrefix=q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(V,q,Y,Q,de){this._totalOutgoing+=V,B(this._outgoingPrefix,this._totalOutgoing,V,q,Y,Q,de)}logIncoming(V,q,Y,Q,de){this._totalIncoming+=V,B(this._incomingPrefix,this._totalIncoming,V,q,Y,Q,de)}}e.IPCLogger=O}),define(De[112],Ie([1,0,23,4,6,111]),function(J,e,l,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var _;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(_=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var D;(function(i){i.enableDiagnostics=!1,i.records=[];const r=new WeakMap;let c=0;function o(h,y){if(!r.has(h)){const R=String(++c);r.set(h,R)}return r.get(h)}function u(h,y,R,M){if(!i.enableDiagnostics)return;const U=o(h,y);if(M instanceof l.VSBuffer||M instanceof Uint8Array||M instanceof ArrayBuffer||ArrayBuffer.isView(M)){const A=l.VSBuffer.alloc(M.byteLength);A.set(M),i.records.push({timestamp:Date.now(),id:U,label:y,type:R,buff:A})}else i.records.push({timestamp:Date.now(),id:U,label:y,type:R,data:M})}i.traceSocketEvent=u})(D=e.SocketDiagnostics||(e.SocketDiagnostics={}));var b;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(b=e.SocketCloseEventType||(e.SocketCloseEventType={}));let I=null;function L(){return I||(I=l.VSBuffer.alloc(0)),I}class k{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,c){if(r===0)return L();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const y=this._chunks[0];return c&&(this._chunks.shift(),this._totalLength-=r),y}if(this._chunks[0].byteLength>r){const y=this._chunks[0].slice(0,r);return c&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),y}const o=l.VSBuffer.alloc(r);let u=0,h=0;for(;r>0;){const y=this._chunks[h];if(y.byteLength>r){const R=y.slice(0,r);o.set(R,u),u+=r,c&&(this._chunks[h]=y.slice(r),this._totalLength-=r),r-=r}else o.set(y,u),u+=y.byteLength,c?(this._chunks.shift(),this._totalLength-=y.byteLength):h++,r-=y.byteLength}return o}}e.ChunkStream=k;var S;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(S||(S={}));function T(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var E;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(E=e.ProtocolConstants||(e.ProtocolConstants={}));class p{constructor(r,c,o,u){this.type=r,this.id=c,this.ack=o,this.data=u,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends C.Disposable{constructor(r){super(),this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new k,this._register(this._socket.onData(c=>this.acceptChunk(c))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const c=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=c.readUInt32BE(9),this._state.messageType=c.readUInt8(0),this._state.id=c.readUInt32BE(1),this._state.ack=c.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:T(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const o=this._state.messageType,u=this._state.id,h=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",c),this._onMessage.fire(new p(o,u,h,c)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class f{constructor(r){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const c=l.VSBuffer.alloc(13);c.writeUInt8(r.type,0),c.writeUInt32BE(r.id,1),c.writeUInt32BE(r.ack,5),c.writeUInt32BE(r.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:T(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",r.data),this._writeSoon(c,r.data)}_bufferAdd(r,c){const o=this._totalLength===0;return this._data.push(r,c),this._totalLength+=r.byteLength+c.byteLength,o}_bufferTake(){const r=l.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,c){this._bufferAdd(r,c)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const r=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this._socket.write(r)}}class v extends C.Disposable{constructor(r){super(),this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new f(this._socket)),this._socketReader=this._register(new w(this._socket)),this._register(this._socketReader.onMessage(c=>{c.type===1&&this._onMessage.fire(c.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new p(1,0,0,r))}}e.Protocol=v;class m extends P.IPCClient{constructor(r,c,o=null){super(r,c,o),this.protocol=r}static fromSocket(r,c){return new m(new v(r),c)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=m;class a{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=a;class g{constructor(r){this.data=r,this.next=null}}class n{constructor(){this._first=null,this._last=null}length(){let r=0,c=this._first;for(;c;)c=c.next,r++;return r}peek(){return this._first?this._first.data:null}toArray(){const r=[];let c=0,o=this._first;for(;o;)r[c++]=o.data,o=o.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const c=new g(r);if(!this._first){this._first=c,this._last=c;return}this._last.next=c,this._last=c}}class d{constructor(){this.lastRuns=[];const r=Date.now();for(let c=0;c<d._HISTORY_LENGTH;c++)this.lastRuns[c]=r-1e3*c;setInterval(()=>{for(let c=d._HISTORY_LENGTH;c>=1;c--)this.lastRuns[c]=this.lastRuns[c-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return d._INSTANCE||(d._INSTANCE=new d),d._INSTANCE}load(){const r=Date.now(),c=(1+d._HISTORY_LENGTH)*1e3;let o=0;for(let u=0;u<d._HISTORY_LENGTH;u++)r-this.lastRuns[u]<=c&&o++;return 1-o/d._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}d._HISTORY_LENGTH=10,d._INSTANCE=null;class s{constructor(r,c=null,o=d.getInstance()){this._onControlMessage=new a,this.onControlMessage=this._onControlMessage.event,this._onMessage=new a,this.onMessage=this._onMessage.event,this._onDidDispose=new a,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new a,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new a,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=o,this._isReconnecting=!1,this._outgoingUnackMsg=new n,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=r,this._socketWriter=new f(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(u=>this._onSocketClose.fire(u))),c&&this._socketReader.acceptChunk(c),this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables=(0,C.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new p(5,0,0,L());this._socketWriter.write(r),this._socketWriter.flush()}sendPause(){const r=new p(7,0,0,L());this._socketWriter.write(r)}sendResume(){const r=new p(8,0,0,L());this._socketWriter.write(r)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,c){this._isReconnecting=!0,this._socketDisposables=(0,C.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=r,this._socketWriter=new f(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.push(this._socket.onClose(o=>this._onSocketClose.fire(o))),this._socketReader.acceptChunk(c)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const r=new p(3,0,this._incomingAckId,L());this._socketWriter.write(r);const c=this._outgoingUnackMsg.toArray();for(let o=0,u=c.length;o<u;o++)this._socketWriter.write(c[o]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const c=this._outgoingUnackMsg.peek();if(c&&c.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const c=Date.now();c-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=c,this._socketWriter.write(new p(6,0,0,L())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data);break}case 2:{this._onControlMessage.fire(r.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const c=this._outgoingUnackMsg.toArray();for(let o=0,u=c.length;o<u;o++)this._socketWriter.write(c[o]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const c=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const o=new p(1,c,this._incomingAckId,r);this._outgoingUnackMsg.push(o),this._isReconnecting||(this._socketWriter.write(o),this._recvAckCheck())}sendControl(r){const c=new p(2,0,0,r);this._socketWriter.write(c)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),c=Date.now()-r.writtenTime,o=Date.now()-this._socketReader.lastReadTime,u=Date.now()-this._lastSocketTimeoutTime;if(c>=2e4&&o>=2e4&&u>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:c,timeSinceLastReceivedSomeData:o});return}const h=Math.max(2e4-c,2e4-o,2e4-u,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},h)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new p(3,0,this._incomingAckId,L());this._socketWriter.write(r)}_sendKeepAlive(){const r=new p(9,0,0,L());this._socketWriter.write(r)}}e.PersistentProtocol=s}),define(De[113],Ie([1,0,23,10,4,6,9,11,34,111,112]),function(J,e,l,t,C,P,_,D,b,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function k(){return{crypto:J.__$__nodeRequire("crypto"),zlib:J.__$__nodeRequire("zlib"),net:J.__$__nodeRequire("net"),os:J.__$__nodeRequire("os")}}class S{constructor(o,u=""){this.debugLabel=u,this.socket=o,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=h=>{if(this.traceSocketEvent("error",{code:h?.code,message:h?.message}),h){if(h.code==="EPIPE")return;(0,t.onUnexpectedError)(h)}},this.socket.on("error",this._errorListener)}traceSocketEvent(o,u){L.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,o,u)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(o){const u=h=>{this.traceSocketEvent("read",h),o(l.VSBuffer.wrap(h))};return this.socket.on("data",u),{dispose:()=>this.socket.off("data",u)}}onClose(o){const u=h=>{this.traceSocketEvent("close",{hadError:h}),o({type:0,hadError:h,error:void 0})};return this.socket.on("close",u),{dispose:()=>this.socket.off("close",u)}}onEnd(o){const u=()=>{this.traceSocketEvent("nodeEndReceived"),o()};return this.socket.on("end",u),{dispose:()=>this.socket.off("end",u)}}write(o){if(!this.socket.destroyed)try{this.traceSocketEvent("write",o),this.socket.write(o.buffer,u=>{if(u){if(u.code==="EPIPE")return;(0,t.onUnexpectedError)(u)}})}catch(u){if(u.code==="EPIPE")return;(0,t.onUnexpectedError)(u)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((o,u)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),o();return}const h=()=>{this.socket.off("close",h),this.socket.off("end",h),this.socket.off("error",h),this.socket.off("timeout",h),this.socket.off("drain",h),this.traceSocketEvent("nodeDrainEnd"),o()};this.socket.on("close",h),this.socket.on("end",h),this.socket.on("error",h),this.socket.on("timeout",h),this.socket.on("drain",h)})}}e.NodeSocket=S;var T;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize"})(T||(T={}));var E;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(E||(E={}));class p extends P.Disposable{constructor(o,u,h,y){super(),this._onData=this._register(new C.Emitter),this._onClose=this._register(new C.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=o,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:u,inflateBytesLength:h?.byteLength||0,recordInflateBytes:y}),this._flowManager=this._register(new w(this,u,h,y,this._onData,(R,M)=>this._write(R,M))),this._register(this._flowManager.onError(R=>{console.error(R),(0,t.onUnexpectedError)(R),this._onClose.fire({type:0,hadError:!0,error:R})})),this._incomingData=new L.ChunkStream,this._register(this.socket.onData(R=>this._acceptChunk(R))),this._register(this.socket.onClose(R=>this._onClose.fire(R)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(o,u){this.socket.traceSocketEvent(o,u)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(o){return this._onData.event(o)}onClose(o){return this._onClose.event(o)}onEnd(o){return this.socket.onEnd(o)}write(o){this._flowManager.writeMessage(o)}_write(o,u){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",o);let h=2;o.byteLength<126?h+=0:o.byteLength<2**16?h+=2:h+=8;const y=l.VSBuffer.alloc(h);if(u?y.writeUInt8(194,0):y.writeUInt8(130,0),o.byteLength<126)y.writeUInt8(o.byteLength,1);else if(o.byteLength<2**16){y.writeUInt8(126,1);let R=1;y.writeUInt8(o.byteLength>>>8&255,++R),y.writeUInt8(o.byteLength>>>0&255,++R)}else{y.writeUInt8(127,1);let R=1;y.writeUInt8(0,++R),y.writeUInt8(0,++R),y.writeUInt8(0,++R),y.writeUInt8(0,++R),y.writeUInt8(o.byteLength>>>24&255,++R),y.writeUInt8(o.byteLength>>>16&255,++R),y.writeUInt8(o.byteLength>>>8&255,++R),y.writeUInt8(o.byteLength>>>0&255,++R)}this.socket.write(l.VSBuffer.concat([y,o]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(o){if(o.byteLength!==0){for(this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const u=this._incomingData.peek(this._state.readLen),h=u.readUInt8(0),y=(h&128)>>>7,R=(h&64)>>>6,M=u.readUInt8(1),U=(M&128)>>>7,A=M&127;this._state.state=2,this._state.readLen=2+(U?4:0)+(A===126?2:0)+(A===127?8:0),this._state.fin=y,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(R)),this._state.firstFrameOfMessage=Boolean(y),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const u=this._incomingData.read(this._state.readLen),h=u.readUInt8(1),y=(h&128)>>>7;let R=h&127,M=1;R===126?R=u.readUInt8(++M)*2**8+u.readUInt8(++M):R===127&&(R=u.readUInt8(++M)*0+u.readUInt8(++M)*0+u.readUInt8(++M)*0+u.readUInt8(++M)*0+u.readUInt8(++M)*2**24+u.readUInt8(++M)*2**16+u.readUInt8(++M)*2**8+u.readUInt8(++M));let U=0;y&&(U=u.readUInt8(++M)*2**24+u.readUInt8(++M)*2**16+u.readUInt8(++M)*2**8+u.readUInt8(++M)),this._state.state=3,this._state.readLen=R,this._state.mask=U,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const u=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",u),m(u,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",u),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(u,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await C.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=p;class w extends P.Disposable{constructor(o,u,h,y,R,M){super(),this._tracer=o,this._onData=R,this._writeFn=M,this._onError=this._register(new C.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new C.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,u?(this._zlibInflateStream=this._register(new f(this._tracer,y,h,{windowBits:15})),this._zlibDeflateStream=this._register(new v(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(U=>this._onError.fire(U))),this._register(this._zlibDeflateStream.onError(U=>this._onError.fire(U)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:l.VSBuffer.alloc(0)}writeMessage(o){this._writeQueue.push(o),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const o=this._writeQueue.shift();if(this._zlibDeflateStream){const u=await this._deflateMessage(this._zlibDeflateStream,o);this._writeFn(u,!0)}else this._writeFn(o,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(o,u){return new Promise((h,y)=>{o.write(u),o.flush(R=>h(R))})}acceptFrame(o,u,h){this._readQueue.push({data:o,isCompressed:u,isLastFrameOfMessage:h}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const o=this._readQueue.shift();if(this._zlibInflateStream&&o.isCompressed){const u=await this._inflateFrame(this._zlibInflateStream,o.data,o.isLastFrameOfMessage);this._onData.fire(u)}else this._onData.fire(o.data)}this._isProcessingReadQueue=!1}}_inflateFrame(o,u,h){return new Promise((y,R)=>{o.write(u),h&&o.write(l.VSBuffer.fromByteArray([0,0,255,255])),o.flush(M=>y(M))})}}class f extends P.Disposable{constructor(o,u,h,y){super(),this._tracer=o,this._recordInflateBytes=u,this._onError=this._register(new C.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=k().zlib.createInflateRaw(y),this._zlibInflate.on("error",R=>{this._tracer.traceSocketEvent("zlibInflateError",{message:R?.message,code:R?.code}),this._onError.fire(R)}),this._zlibInflate.on("data",R=>{this._tracer.traceSocketEvent("zlibInflateData",R),this._pendingInflateData.push(l.VSBuffer.wrap(R))}),h&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",h.buffer),this._zlibInflate.write(h.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?l.VSBuffer.concat(this._recordedInflateBytes):l.VSBuffer.alloc(0)}write(o){this._recordInflateBytes&&this._recordedInflateBytes.push(o.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",o),this._zlibInflate.write(o.buffer)}flush(o){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const u=l.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,o(u)})}}class v extends P.Disposable{constructor(o,u){super(),this._tracer=o,this._onError=this._register(new C.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=k().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",h=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:h?.message,code:h?.code}),this._onError.fire(h)}),this._zlibDeflate.on("data",h=>{this._tracer.traceSocketEvent("zlibDeflateData",h),this._pendingDeflateData.push(l.VSBuffer.wrap(h))})}write(o){this._tracer.traceSocketEvent("zlibDeflateWrite",o.buffer),this._zlibDeflate.write(o.buffer)}flush(o){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let u=l.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,u=u.slice(0,u.byteLength-4),o(u)})}}function m(c,o){if(o===0)return;const u=c.byteLength>>>2;for(let A=0;A<u;A++){const z=c.readUInt32BE(A*4);c.writeUInt32BE(z^o,A*4)}const h=u*4,y=c.byteLength-h,R=o>>>24&255,M=o>>>16&255,U=o>>>8&255;y>=1&&c.writeUInt8(c.readUInt8(h)^R,h),y>=2&&c.writeUInt8(c.readUInt8(h+1)^M,h+1),y>=3&&c.writeUInt8(c.readUInt8(h+2)^U,h+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const a={[2]:107,[1]:103};function g(){const c=(0,b.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;let o;return e.XDG_RUNTIME_DIR?o=(0,_.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${c}.sock`):o=(0,_.join)(k().os.tmpdir(),`vscode-ipc-${c}.sock`),d(o),o}e.createRandomIPCHandle=g;function n(c,o,u){const h=k().crypto.createHash("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${h}-${u}-${o}-sock`;let y;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?y=(0,_.join)(e.XDG_RUNTIME_DIR,`vscode-${h.substr(0,8)}-${u}-${o}.sock`):y=(0,_.join)(c,`${u}-${o}.sock`),d(y),y}e.createStaticIPCHandle=n;function d(c){const o=a[D.platform];typeof o=="number"&&c.length>=o&&console.warn(`WARNING: IPC handle "${c}" is longer than ${o} chars, try a shorter --user-data-dir`)}class s extends I.IPCServer{constructor(o){super(s.toClientConnectionEvent(o)),this.server=o}static toClientConnectionEvent(o){const u=C.Event.fromNodeEventEmitter(o,"connection");return C.Event.map(u,h=>({protocol:new L.Protocol(new S(h,"ipc-server-connection")),onDidClientDisconnect:C.Event.once(C.Event.fromNodeEventEmitter(h,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function i(c){return new Promise((o,u)=>{const h=k().net.createServer();h.on("error",u),h.listen(c,()=>{h.removeListener("error",u),o(new s(h))})})}e.serve=i;function r(c,o){return new Promise((u,h)=>{const y=k().net.createConnection(c,()=>{y.removeListener("error",h),u(L.Client.fromSocket(new S(y,`ipc-client${o}`),o))});y.once("error",h)})}e.connect=r}),define(De[157],Ie([1,0,36,9]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function C(P,_,D,b,I,L){if(Array.isArray(P)){let k=0;for(const S of P){const T=C(S,_,D,b,I,L);if(T===10)return T;T>k&&(k=T)}return k}else{if(typeof P=="string")return b?P==="*"?5:P===D?10:0:0;if(P){const{language:k,pattern:S,scheme:T,hasAccessToAllModels:E,notebookType:p}=P;if(!b&&!E)return 0;p&&I&&(_=I);let w=0;if(T)if(T===_.scheme)w=10;else if(T==="*")w=5;else return 0;if(k)if(k===D)w=10;else if(k==="*")w=Math.max(w,5);else return 0;if(p)if(p===L)w=10;else if(p==="*"&&L!==void 0)w=Math.max(w,5);else return 0;if(S){let f;if(typeof S=="string"?f=S:f={...S,base:(0,t.normalize)(S.base)},f===_.fsPath||(0,l.match)(f,_.fsPath))w=10;else return 0}return w}else return 0}}e.score=C}),define(De[158],Ie([1,0,8,49,150]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class P{constructor(D,b,I,L){this._uri=D,this._lines=b,this._eol=I,this._versionId=L,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(D){D.eol&&D.eol!==this._eol&&(this._eol=D.eol,this._lineStarts=null);const b=D.changes;for(const I of b)this._acceptDeleteRange(I.range),this._acceptInsertText(new t.Position(I.range.startLineNumber,I.range.startColumn),I.text);this._versionId=D.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const D=this._eol.length,b=this._lines.length,I=new Uint32Array(b);for(let L=0;L<b;L++)I[L]=this._lines[L].length+D;this._lineStarts=new C.PrefixSumComputer(I)}}_setLineText(D,b){this._lines[D]=b,this._lineStarts&&this._lineStarts.setValue(D,this._lines[D].length+this._eol.length)}_acceptDeleteRange(D){if(D.startLineNumber===D.endLineNumber){if(D.startColumn===D.endColumn)return;this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.startLineNumber-1].substring(D.endColumn-1));return}this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.endLineNumber-1].substring(D.endColumn-1)),this._lines.splice(D.startLineNumber,D.endLineNumber-D.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(D.startLineNumber,D.endLineNumber-D.startLineNumber)}_acceptInsertText(D,b){if(b.length===0)return;const I=(0,l.splitLines)(b);if(I.length===1){this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+I[0]+this._lines[D.lineNumber-1].substring(D.column-1));return}I[I.length-1]+=this._lines[D.lineNumber-1].substring(D.column-1),this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+I[0]);const L=new Uint32Array(I.length-1);for(let k=1;k<I.length;k++)this._lines.splice(D.lineNumber+k-1,0,I[k]),L[k-1]=I[k].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(D.lineNumber,L)}}e.MirrorTextModel=P}),define(De[159],Ie([1,0,8,147,49,35,100]),function(J,e,l,t,C,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const D=999;class b{constructor(v,m,a,g){this.searchString=v,this.isRegex=m,this.matchCase=a,this.wordSeparators=g}parseSearchRequest(){if(this.searchString==="")return null;let v;this.isRegex?v=I(this.searchString):v=this.searchString.indexOf(`
`)>=0;let m=null;try{m=l.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:v,global:!0,unicode:!0})}catch{return null}if(!m)return null;let a=!this.isRegex&&!v;return a&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(a=this.matchCase),new _.SearchData(m,this.wordSeparators?(0,t.getMapForWordSeparators)(this.wordSeparators):null,a?this.searchString:null)}}e.SearchParams=b;function I(f){if(!f||f.length===0)return!1;for(let v=0,m=f.length;v<m;v++){const a=f.charCodeAt(v);if(a===10)return!0;if(a===92){if(v++,v>=m)break;const g=f.charCodeAt(v);if(g===110||g===114||g===87)return!0}}return!1}e.isMultilineRegexSource=I;function L(f,v,m){if(!m)return new _.FindMatch(f,null);const a=[];for(let g=0,n=v.length;g<n;g++)a[g]=v[g];return new _.FindMatch(f,a)}e.createFindMatch=L;class k{constructor(v){const m=[];let a=0;for(let g=0,n=v.length;g<n;g++)v.charCodeAt(g)===10&&(m[a++]=g);this._lineFeedsOffsets=m}findLineFeedCountBeforeOffset(v){const m=this._lineFeedsOffsets;let a=0,g=m.length-1;if(g===-1||v<=m[0])return 0;for(;a<g;){const n=a+((g-a)/2>>0);m[n]>=v?g=n-1:m[n+1]>=v?(a=n,g=n):a=n+1}return a+1}}class S{static findMatches(v,m,a,g,n){const d=m.parseSearchRequest();return d?d.regex.multiline?this._doFindMatchesMultiline(v,a,new w(d.wordSeparators,d.regex),g,n):this._doFindMatchesLineByLine(v,a,d,g,n):[]}static _getMultilineMatchRange(v,m,a,g,n,d){let s,i=0;g?(i=g.findLineFeedCountBeforeOffset(n),s=m+n+i):s=m+n;let r;if(g){const h=g.findLineFeedCountBeforeOffset(n+d.length)-i;r=s+d.length+h}else r=s+d.length;const c=v.getPositionAt(s),o=v.getPositionAt(r);return new P.Range(c.lineNumber,c.column,o.lineNumber,o.column)}static _doFindMatchesMultiline(v,m,a,g,n){const d=v.getOffsetAt(m.getStartPosition()),s=v.getValueInRange(m,1),i=v.getEOL()===`\r
`?new k(s):null,r=[];let c=0,o;for(a.reset(0);o=a.next(s);)if(r[c++]=L(this._getMultilineMatchRange(v,d,s,i,o.index,o[0]),o,g),c>=n)return r;return r}static _doFindMatchesLineByLine(v,m,a,g,n){const d=[];let s=0;if(m.startLineNumber===m.endLineNumber){const r=v.getLineContent(m.startLineNumber).substring(m.startColumn-1,m.endColumn-1);return s=this._findMatchesInLine(a,r,m.startLineNumber,m.startColumn-1,s,d,g,n),d}const i=v.getLineContent(m.startLineNumber).substring(m.startColumn-1);s=this._findMatchesInLine(a,i,m.startLineNumber,m.startColumn-1,s,d,g,n);for(let r=m.startLineNumber+1;r<m.endLineNumber&&s<n;r++)s=this._findMatchesInLine(a,v.getLineContent(r),r,0,s,d,g,n);if(s<n){const r=v.getLineContent(m.endLineNumber).substring(0,m.endColumn-1);s=this._findMatchesInLine(a,r,m.endLineNumber,0,s,d,g,n)}return d}static _findMatchesInLine(v,m,a,g,n,d,s,i){const r=v.wordSeparators;if(!s&&v.simpleSearch){const u=v.simpleSearch,h=u.length,y=m.length;let R=-h;for(;(R=m.indexOf(u,R+h))!==-1;)if((!r||p(r,m,y,R,h))&&(d[n++]=new _.FindMatch(new P.Range(a,R+1+g,a,R+1+h+g),null),n>=i))return n;return n}const c=new w(v.wordSeparators,v.regex);let o;c.reset(0);do if(o=c.next(m),o&&(d[n++]=L(new P.Range(a,o.index+1+g,a,o.index+1+o[0].length+g),o,s),n>=i))return n;while(o);return n}static findNextMatch(v,m,a,g){const n=m.parseSearchRequest();if(!n)return null;const d=new w(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindNextMatchMultiline(v,a,d,g):this._doFindNextMatchLineByLine(v,a,d,g)}static _doFindNextMatchMultiline(v,m,a,g){const n=new C.Position(m.lineNumber,1),d=v.getOffsetAt(n),s=v.getLineCount(),i=v.getValueInRange(new P.Range(n.lineNumber,n.column,s,v.getLineMaxColumn(s)),1),r=v.getEOL()===`\r
`?new k(i):null;a.reset(m.column-1);const c=a.next(i);return c?L(this._getMultilineMatchRange(v,d,i,r,c.index,c[0]),c,g):m.lineNumber!==1||m.column!==1?this._doFindNextMatchMultiline(v,new C.Position(1,1),a,g):null}static _doFindNextMatchLineByLine(v,m,a,g){const n=v.getLineCount(),d=m.lineNumber,s=v.getLineContent(d),i=this._findFirstMatchInLine(a,s,d,m.column,g);if(i)return i;for(let r=1;r<=n;r++){const c=(d+r-1)%n,o=v.getLineContent(c+1),u=this._findFirstMatchInLine(a,o,c+1,1,g);if(u)return u}return null}static _findFirstMatchInLine(v,m,a,g,n){v.reset(g-1);const d=v.next(m);return d?L(new P.Range(a,d.index+1,a,d.index+1+d[0].length),d,n):null}static findPreviousMatch(v,m,a,g){const n=m.parseSearchRequest();if(!n)return null;const d=new w(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindPreviousMatchMultiline(v,a,d,g):this._doFindPreviousMatchLineByLine(v,a,d,g)}static _doFindPreviousMatchMultiline(v,m,a,g){const n=this._doFindMatchesMultiline(v,new P.Range(1,1,m.lineNumber,m.column),a,g,10*D);if(n.length>0)return n[n.length-1];const d=v.getLineCount();return m.lineNumber!==d||m.column!==v.getLineMaxColumn(d)?this._doFindPreviousMatchMultiline(v,new C.Position(d,v.getLineMaxColumn(d)),a,g):null}static _doFindPreviousMatchLineByLine(v,m,a,g){const n=v.getLineCount(),d=m.lineNumber,s=v.getLineContent(d).substring(0,m.column-1),i=this._findLastMatchInLine(a,s,d,g);if(i)return i;for(let r=1;r<=n;r++){const c=(n+d-r-1)%n,o=v.getLineContent(c+1),u=this._findLastMatchInLine(a,o,c+1,g);if(u)return u}return null}static _findLastMatchInLine(v,m,a,g){let n=null,d;for(v.reset(0);d=v.next(m);)n=L(new P.Range(a,d.index+1,a,d.index+1+d[0].length),d,g);return n}}e.TextModelSearch=S;function T(f,v,m,a,g){if(a===0)return!0;const n=v.charCodeAt(a-1);if(f.get(n)!==0||n===13||n===10)return!0;if(g>0){const d=v.charCodeAt(a);if(f.get(d)!==0)return!0}return!1}function E(f,v,m,a,g){if(a+g===m)return!0;const n=v.charCodeAt(a+g);if(f.get(n)!==0||n===13||n===10)return!0;if(g>0){const d=v.charCodeAt(a+g-1);if(f.get(d)!==0)return!0}return!1}function p(f,v,m,a,g){return T(f,v,m,a,g)&&E(f,v,m,a,g)}e.isValidMatch=p;class w{constructor(v,m){this._wordSeparators=v,this._searchRegex=m,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(v){this._searchRegex.lastIndex=v,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(v){const m=v.length;let a;do{if(this._prevMatchStartIndex+this._prevMatchLength===m||(a=this._searchRegex.exec(v),!a))return null;const g=a.index,n=a[0].length;if(g===this._prevMatchStartIndex&&n===this._prevMatchLength){if(n===0){l.getNextCodePoint(v,m,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=g,this._prevMatchLength=n,!this._wordSeparators||p(this._wordSeparators,v,m,g,n))return a}while(a);return null}}e.Searcher=w}),define(De[114],Ie([1,0,23,11]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var C;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(C||(C={}));function P(k){for(let S=0,T=k.length;S<T;S+=4){const E=k[S+0],p=k[S+1],w=k[S+2],f=k[S+3];k[S+0]=f,k[S+1]=w,k[S+2]=p,k[S+3]=E}}function _(k){const S=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return t.isLittleEndian()||P(S),l.VSBuffer.wrap(S)}function D(k){const S=k.buffer;if(t.isLittleEndian()||P(S),S.byteOffset%4===0)return new Uint32Array(S.buffer,S.byteOffset,S.length/4);{const T=new Uint8Array(S.byteLength);return T.set(S),new Uint32Array(T.buffer,T.byteOffset,T.length/4)}}function b(k){const S=new Uint32Array(I(k));let T=0;if(S[T++]=k.id,k.type==="full")S[T++]=1,S[T++]=k.data.length,S.set(k.data,T),T+=k.data.length;else{S[T++]=2,S[T++]=k.deltas.length;for(const E of k.deltas)S[T++]=E.start,S[T++]=E.deleteCount,E.data?(S[T++]=E.data.length,S.set(E.data,T),T+=E.data.length):S[T++]=0}return _(S)}e.encodeSemanticTokensDto=b;function I(k){let S=0;if(S+=1+1,k.type==="full")S+=1+k.data.length;else{S+=1,S+=(1+1+1)*k.deltas.length;for(const T of k.deltas)T.data&&(S+=T.data.length)}return S}function L(k){const S=D(k);let T=0;const E=S[T++];if(S[T++]===1){const v=S[T++],m=S.subarray(T,T+v);return T+=v,{id:E,type:"full",data:m}}const w=S[T++],f=[];for(let v=0;v<w;v++){const m=S[T++],a=S[T++],g=S[T++];let n;g>0&&(n=S.subarray(T,T+g),T+=g),f[v]={start:m,deleteCount:a,data:n}}return{id:E,type:"delta",deltas:f}}e.decodeSemanticTokensDto=L}),define(De[160],Ie([1,0,4,6]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class C{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new l.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(D){this._onDidChange.fire({changedLanguages:D,changedColorMap:!1})}register(D,b){return this._map.set(D,b),this.fire([D]),(0,t.toDisposable)(()=>{this._map.get(D)===b&&(this._map.delete(D),this.fire([D]))})}registerFactory(D,b){this._factories.get(D)?.dispose();const I=new P(this,D,b);return this._factories.set(D,I),(0,t.toDisposable)(()=>{const L=this._factories.get(D);!L||L!==I||(this._factories.delete(D),L.dispose())})}async getOrCreate(D){const b=this.get(D);if(b)return b;const I=this._factories.get(D);return!I||I.isResolved?null:(await I.resolve(),this.get(D))}get(D){return this._map.get(D)||null}isResolved(D){if(this.get(D))return!0;const I=this._factories.get(D);return!!(!I||I.isResolved)}setColorMap(D){this._colorMap=D,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=C;class P extends t.Disposable{constructor(D,b,I){super(),this._registry=D,this._languageId=b,this._factory=I,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const D=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,D&&!this._isDisposed&&this._register(this._registry.register(this._languageId,D))}}}),define(De[62],Ie([1,0,74,2,35,160]),function(J,e,l,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class _{constructor(h,y,R){this._tokenBrand=void 0,this.offset=h,this.type=y,this.language=R}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=_;class D{constructor(h,y){this._tokenizationResultBrand=void 0,this.tokens=h,this.endState=y}}e.TokenizationResult=D;class b{constructor(h,y){this._encodedTokenizationResultBrand=void 0,this.tokens=h,this.endState=y}}e.EncodedTokenizationResult=b;var I;(function(u){u[u.Method=0]="Method",u[u.Function=1]="Function",u[u.Constructor=2]="Constructor",u[u.Field=3]="Field",u[u.Variable=4]="Variable",u[u.Class=5]="Class",u[u.Struct=6]="Struct",u[u.Interface=7]="Interface",u[u.Module=8]="Module",u[u.Property=9]="Property",u[u.Event=10]="Event",u[u.Operator=11]="Operator",u[u.Unit=12]="Unit",u[u.Value=13]="Value",u[u.Constant=14]="Constant",u[u.Enum=15]="Enum",u[u.EnumMember=16]="EnumMember",u[u.Keyword=17]="Keyword",u[u.Text=18]="Text",u[u.Color=19]="Color",u[u.File=20]="File",u[u.Reference=21]="Reference",u[u.Customcolor=22]="Customcolor",u[u.Folder=23]="Folder",u[u.TypeParameter=24]="TypeParameter",u[u.User=25]="User",u[u.Issue=26]="Issue",u[u.Snippet=27]="Snippet"})(I=e.CompletionItemKind||(e.CompletionItemKind={}));var L;(function(u){const h=new Map;h.set(0,l.Codicon.symbolMethod),h.set(1,l.Codicon.symbolFunction),h.set(2,l.Codicon.symbolConstructor),h.set(3,l.Codicon.symbolField),h.set(4,l.Codicon.symbolVariable),h.set(5,l.Codicon.symbolClass),h.set(6,l.Codicon.symbolStruct),h.set(7,l.Codicon.symbolInterface),h.set(8,l.Codicon.symbolModule),h.set(9,l.Codicon.symbolProperty),h.set(10,l.Codicon.symbolEvent),h.set(11,l.Codicon.symbolOperator),h.set(12,l.Codicon.symbolUnit),h.set(13,l.Codicon.symbolValue),h.set(15,l.Codicon.symbolEnum),h.set(14,l.Codicon.symbolConstant),h.set(15,l.Codicon.symbolEnum),h.set(16,l.Codicon.symbolEnumMember),h.set(17,l.Codicon.symbolKeyword),h.set(27,l.Codicon.symbolSnippet),h.set(18,l.Codicon.symbolText),h.set(19,l.Codicon.symbolColor),h.set(20,l.Codicon.symbolFile),h.set(21,l.Codicon.symbolReference),h.set(22,l.Codicon.symbolCustomColor),h.set(23,l.Codicon.symbolFolder),h.set(24,l.Codicon.symbolTypeParameter),h.set(25,l.Codicon.account),h.set(26,l.Codicon.issues);function y(U){let A=h.get(U);return A||(console.info("No codicon found for CompletionItemKind "+U),A=l.Codicon.symbolProperty),A}u.toIcon=y;const R=new Map;R.set("method",0),R.set("function",1),R.set("constructor",2),R.set("field",3),R.set("variable",4),R.set("class",5),R.set("struct",6),R.set("interface",7),R.set("module",8),R.set("property",9),R.set("event",10),R.set("operator",11),R.set("unit",12),R.set("value",13),R.set("constant",14),R.set("enum",15),R.set("enum-member",16),R.set("enumMember",16),R.set("keyword",17),R.set("snippet",27),R.set("text",18),R.set("color",19),R.set("file",20),R.set("reference",21),R.set("customcolor",22),R.set("folder",23),R.set("type-parameter",24),R.set("typeParameter",24),R.set("account",25),R.set("issue",26);function M(U,A){let z=R.get(U);return typeof z>"u"&&!A&&(z=9),z}u.fromString=M})(L=e.CompletionItemKinds||(e.CompletionItemKinds={}));var k;(function(u){u[u.Deprecated=1]="Deprecated"})(k=e.CompletionItemTag||(e.CompletionItemTag={}));var S;(function(u){u[u.KeepWhitespace=1]="KeepWhitespace",u[u.InsertAsSnippet=4]="InsertAsSnippet"})(S=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var T;(function(u){u[u.Invoke=0]="Invoke",u[u.TriggerCharacter=1]="TriggerCharacter",u[u.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(T=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var E;(function(u){u[u.Automatic=0]="Automatic",u[u.Explicit=1]="Explicit"})(E=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var p;(function(u){u[u.Invoke=1]="Invoke",u[u.Auto=2]="Auto"})(p=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var w;(function(u){u[u.Invoke=1]="Invoke",u[u.TriggerCharacter=2]="TriggerCharacter",u[u.ContentChange=3]="ContentChange"})(w=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var f;(function(u){u[u.Text=0]="Text",u[u.Read=1]="Read",u[u.Write=2]="Write"})(f=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function v(u){return u&&t.URI.isUri(u.uri)&&C.Range.isIRange(u.range)&&(C.Range.isIRange(u.originSelectionRange)||C.Range.isIRange(u.targetSelectionRange))}e.isLocationLink=v;var m;(function(u){u[u.File=0]="File",u[u.Module=1]="Module",u[u.Namespace=2]="Namespace",u[u.Package=3]="Package",u[u.Class=4]="Class",u[u.Method=5]="Method",u[u.Property=6]="Property",u[u.Field=7]="Field",u[u.Constructor=8]="Constructor",u[u.Enum=9]="Enum",u[u.Interface=10]="Interface",u[u.Function=11]="Function",u[u.Variable=12]="Variable",u[u.Constant=13]="Constant",u[u.String=14]="String",u[u.Number=15]="Number",u[u.Boolean=16]="Boolean",u[u.Array=17]="Array",u[u.Object=18]="Object",u[u.Key=19]="Key",u[u.Null=20]="Null",u[u.EnumMember=21]="EnumMember",u[u.Struct=22]="Struct",u[u.Event=23]="Event",u[u.Operator=24]="Operator",u[u.TypeParameter=25]="TypeParameter"})(m=e.SymbolKind||(e.SymbolKind={}));var a;(function(u){u[u.Deprecated=1]="Deprecated"})(a=e.SymbolTag||(e.SymbolTag={}));var g;(function(u){const h=new Map;h.set(0,l.Codicon.symbolFile),h.set(1,l.Codicon.symbolModule),h.set(2,l.Codicon.symbolNamespace),h.set(3,l.Codicon.symbolPackage),h.set(4,l.Codicon.symbolClass),h.set(5,l.Codicon.symbolMethod),h.set(6,l.Codicon.symbolProperty),h.set(7,l.Codicon.symbolField),h.set(8,l.Codicon.symbolConstructor),h.set(9,l.Codicon.symbolEnum),h.set(10,l.Codicon.symbolInterface),h.set(11,l.Codicon.symbolFunction),h.set(12,l.Codicon.symbolVariable),h.set(13,l.Codicon.symbolConstant),h.set(14,l.Codicon.symbolString),h.set(15,l.Codicon.symbolNumber),h.set(16,l.Codicon.symbolBoolean),h.set(17,l.Codicon.symbolArray),h.set(18,l.Codicon.symbolObject),h.set(19,l.Codicon.symbolKey),h.set(20,l.Codicon.symbolNull),h.set(21,l.Codicon.symbolEnumMember),h.set(22,l.Codicon.symbolStruct),h.set(23,l.Codicon.symbolEvent),h.set(24,l.Codicon.symbolOperator),h.set(25,l.Codicon.symbolTypeParameter);function y(R){let M=h.get(R);return M||(console.info("No codicon found for SymbolKind "+R),M=l.Codicon.symbolProperty),M}u.toIcon=y})(g=e.SymbolKinds||(e.SymbolKinds={}));class n{constructor(h){this.value=h}}e.FoldingRangeKind=n,n.Comment=new n("comment"),n.Imports=new n("imports"),n.Region=new n("region");var d;(function(u){function h(y){return!y||typeof y!="object"?!1:typeof y.id=="string"&&typeof y.title=="string"}u.is=h})(d=e.Command||(e.Command={}));var s;(function(u){u[u.Collapsed=0]="Collapsed",u[u.Expanded=1]="Expanded"})(s=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var i;(function(u){u[u.Unresolved=0]="Unresolved",u[u.Resolved=1]="Resolved"})(i=e.CommentThreadState||(e.CommentThreadState={}));var r;(function(u){u[u.Editing=0]="Editing",u[u.Preview=1]="Preview"})(r=e.CommentMode||(e.CommentMode={}));var c;(function(u){u[u.Type=1]="Type",u[u.Parameter=2]="Parameter"})(c=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new P.TokenizationRegistry;var o;(function(u){u[u.None=0]="None",u[u.Option=1]="Option",u[u.Default=2]="Default",u[u.Preferred=3]="Preferred"})(o=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(De[161],Ie([19,20]),function(J,e){return J.create("vs/editor/common/config/editorOptions",e)}),define(De[115],Ie([1,0,161,11,99,17,24,146]),function(J,e,l,t,C,P,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var b;(function(re){re[re.None=0]="None",re[re.Keep=1]="Keep",re[re.Brackets=2]="Brackets",re[re.Advanced=3]="Advanced",re[re.Full=4]="Full"})(b=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class I{constructor(se){this._values=se}hasChanged(se){return this._values[se]}}e.ConfigurationChangedEvent=I;class L{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=L;class k{constructor(se,Ee,ue,Te){this.id=se,this.name=Ee,this.defaultValue=ue,this.schema=Te}applyUpdate(se,Ee){return T(se,Ee)}compute(se,Ee,ue){return ue}}class S{constructor(se,Ee){this.newValue=se,this.didChange=Ee}}e.ApplyUpdateResult=S;function T(re,se){if(typeof re!="object"||typeof se!="object"||!re||!se)return new S(se,re!==se);if(Array.isArray(re)||Array.isArray(se)){const ue=Array.isArray(re)&&Array.isArray(se)&&P.equals(re,se);return new S(se,!ue)}let Ee=!1;for(const ue in se)if(se.hasOwnProperty(ue)){const Te=T(re[ue],se[ue]);Te.didChange&&(re[ue]=Te.newValue,Ee=!0)}return new S(re,Ee)}class E{constructor(se){this.schema=void 0,this.id=se,this.name="_never_",this.defaultValue=void 0}applyUpdate(se,Ee){return T(se,Ee)}validate(se){return this.defaultValue}}class p{constructor(se,Ee,ue,Te){this.id=se,this.name=Ee,this.defaultValue=ue,this.schema=Te}applyUpdate(se,Ee){return T(se,Ee)}validate(se){return typeof se>"u"?this.defaultValue:se}compute(se,Ee,ue){return ue}}function w(re,se){return typeof re>"u"?se:re==="false"?!1:Boolean(re)}e.boolean=w;class f extends p{constructor(se,Ee,ue,Te=void 0){typeof Te<"u"&&(Te.type="boolean",Te.default=ue),super(se,Ee,ue,Te)}validate(se){return w(se,this.defaultValue)}}function v(re,se,Ee,ue){if(typeof re>"u")return se;let Te=parseInt(re,10);return isNaN(Te)?se:(Te=Math.max(Ee,Te),Te=Math.min(ue,Te),Te|0)}e.clampedInt=v;class m extends p{constructor(se,Ee,ue,Te,Me,Be=void 0){typeof Be<"u"&&(Be.type="integer",Be.default=ue,Be.minimum=Te,Be.maximum=Me),super(se,Ee,ue,Be),this.minimum=Te,this.maximum=Me}static clampedInt(se,Ee,ue,Te){return v(se,Ee,ue,Te)}validate(se){return m.clampedInt(se,this.defaultValue,this.minimum,this.maximum)}}class a extends p{constructor(se,Ee,ue,Te,Me){typeof Me<"u"&&(Me.type="number",Me.default=ue),super(se,Ee,ue,Me),this.validationFn=Te}static clamp(se,Ee,ue){return se<Ee?Ee:se>ue?ue:se}static float(se,Ee){if(typeof se=="number")return se;if(typeof se>"u")return Ee;const ue=parseFloat(se);return isNaN(ue)?Ee:ue}validate(se){return this.validationFn(a.float(se,this.defaultValue))}}class g extends p{static string(se,Ee){return typeof se!="string"?Ee:se}constructor(se,Ee,ue,Te=void 0){typeof Te<"u"&&(Te.type="string",Te.default=ue),super(se,Ee,ue,Te)}validate(se){return g.string(se,this.defaultValue)}}function n(re,se,Ee){return typeof re!="string"||Ee.indexOf(re)===-1?se:re}e.stringSet=n;class d extends p{constructor(se,Ee,ue,Te,Me=void 0){typeof Me<"u"&&(Me.type="string",Me.enum=Te,Me.default=ue),super(se,Ee,ue,Me),this._allowedValues=Te}validate(se){return n(se,this.defaultValue,this._allowedValues)}}class s extends k{constructor(se,Ee,ue,Te,Me,Be,ze=void 0){typeof ze<"u"&&(ze.type="string",ze.enum=Me,ze.default=Te),super(se,Ee,ue,ze),this._allowedValues=Me,this._convert=Be}validate(se){return typeof se!="string"?this.defaultValue:this._allowedValues.indexOf(se)===-1?this.defaultValue:this._convert(se)}}function i(re){switch(re){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class r extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[l.localize(0,null),l.localize(1,null),l.localize(2,null)],default:"auto",description:l.localize(3,null)})}validate(se){switch(se){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(se,Ee,ue){return ue===0?se.accessibilitySupport:ue}}class c extends k{constructor(){const se={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",se,{"editor.comments.insertSpace":{type:"boolean",default:se.insertSpace,description:l.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:se.ignoreEmptyLines,description:l.localize(5,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{insertSpace:w(Ee.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:w(Ee.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var o;(function(re){re[re.Hidden=0]="Hidden",re[re.Blink=1]="Blink",re[re.Smooth=2]="Smooth",re[re.Phase=3]="Phase",re[re.Expand=4]="Expand",re[re.Solid=5]="Solid"})(o=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function u(re){switch(re){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var h;(function(re){re[re.Line=1]="Line",re[re.Block=2]="Block",re[re.Underline=3]="Underline",re[re.LineThin=4]="LineThin",re[re.BlockOutline=5]="BlockOutline",re[re.UnderlineThin=6]="UnderlineThin"})(h=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function y(re){switch(re){case h.Line:return"line";case h.Block:return"block";case h.Underline:return"underline";case h.LineThin:return"line-thin";case h.BlockOutline:return"block-outline";case h.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=y;function R(re){switch(re){case"line":return h.Line;case"block":return h.Block;case"underline":return h.Underline;case"line-thin":return h.LineThin;case"block-outline":return h.BlockOutline;case"underline-thin":return h.UnderlineThin}}class M extends E{constructor(){super(130)}compute(se,Ee,ue){const Te=["monaco-editor"];return Ee.get(34)&&Te.push(Ee.get(34)),se.extraEditorClassName&&Te.push(se.extraEditorClassName),Ee.get(67)==="default"?Te.push("mouse-default"):Ee.get(67)==="copy"&&Te.push("mouse-copy"),Ee.get(101)&&Te.push("showUnused"),Ee.get(128)&&Te.push("showDeprecated"),Te.join(" ")}}class U extends f{constructor(){super(33,"emptySelectionClipboard",!0,{description:l.localize(6,null)})}compute(se,Ee,ue){return ue&&se.emptySelectionClipboard}}class A extends k{constructor(){const se={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(36,"find",se,{"editor.find.cursorMoveOnType":{type:"boolean",default:se.cursorMoveOnType,description:l.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:se.seedSearchStringFromSelection,enumDescriptions:[l.localize(8,null),l.localize(9,null),l.localize(10,null)],description:l.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:se.autoFindInSelection,enumDescriptions:[l.localize(12,null),l.localize(13,null),l.localize(14,null)],description:l.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:se.globalFindClipboard,description:l.localize(16,null),included:t.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:se.addExtraSpaceOnTop,description:l.localize(17,null)},"editor.find.loop":{type:"boolean",default:se.loop,description:l.localize(18,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{cursorMoveOnType:w(Ee.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof se.seedSearchStringFromSelection=="boolean"?se.seedSearchStringFromSelection?"always":"never":n(Ee.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof se.autoFindInSelection=="boolean"?se.autoFindInSelection?"always":"never":n(Ee.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:w(Ee.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:w(Ee.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:w(Ee.loop,this.defaultValue.loop)}}}class z extends k{constructor(){super(46,"fontLigatures",z.OFF,{anyOf:[{type:"boolean",description:l.localize(19,null)},{type:"string",description:l.localize(20,null)}],description:l.localize(21,null),default:!1})}validate(se){return typeof se>"u"?this.defaultValue:typeof se=="string"?se==="false"?z.OFF:se==="true"?z.ON:se:Boolean(se)?z.ON:z.OFF}}e.EditorFontLigatures=z,z.OFF='"liga" off, "calt" off',z.ON='"liga" on, "calt" on';class $ extends E{constructor(){super(45)}compute(se,Ee,ue){return se.fontInfo}}class N extends p{constructor(){super(47,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:l.localize(22,null)})}validate(se){const Ee=a.float(se,this.defaultValue);return Ee===0?e.EDITOR_FONT_DEFAULTS.fontSize:a.clamp(Ee,6,100)}compute(se,Ee,ue){return se.fontInfo.fontSize}}class K extends k{constructor(){super(48,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:K.MINIMUM_VALUE,maximum:K.MAXIMUM_VALUE,errorMessage:l.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:K.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:l.localize(24,null)})}validate(se){return se==="normal"||se==="bold"?se:String(m.clampedInt(se,e.EDITOR_FONT_DEFAULTS.fontWeight,K.MINIMUM_VALUE,K.MAXIMUM_VALUE))}}K.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],K.MINIMUM_VALUE=1,K.MAXIMUM_VALUE=1e3;class B extends k{constructor(){const se={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ee={type:"string",enum:["peek","gotoAndPeek","goto"],default:se.multiple,enumDescriptions:[l.localize(25,null),l.localize(26,null),l.localize(27,null)]},ue=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(52,"gotoLocation",se,{"editor.gotoLocation.multiple":{deprecationMessage:l.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:l.localize(29,null),...Ee},"editor.gotoLocation.multipleTypeDefinitions":{description:l.localize(30,null),...Ee},"editor.gotoLocation.multipleDeclarations":{description:l.localize(31,null),...Ee},"editor.gotoLocation.multipleImplementations":{description:l.localize(32,null),...Ee},"editor.gotoLocation.multipleReferences":{description:l.localize(33,null),...Ee},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:se.alternativeDefinitionCommand,enum:ue,description:l.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:se.alternativeTypeDefinitionCommand,enum:ue,description:l.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:se.alternativeDeclarationCommand,enum:ue,description:l.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:se.alternativeImplementationCommand,enum:ue,description:l.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:se.alternativeReferenceCommand,enum:ue,description:l.localize(38,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{multiple:n(Ee.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ee.multipleDefinitions??n(Ee.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ee.multipleTypeDefinitions??n(Ee.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ee.multipleDeclarations??n(Ee.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ee.multipleImplementations??n(Ee.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ee.multipleReferences??n(Ee.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:g.string(Ee.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:g.string(Ee.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:g.string(Ee.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:g.string(Ee.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:g.string(Ee.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class O extends k{constructor(){const se={enabled:!0,delay:300,sticky:!0,above:!0};super(54,"hover",se,{"editor.hover.enabled":{type:"boolean",default:se.enabled,description:l.localize(39,null)},"editor.hover.delay":{type:"number",default:se.delay,minimum:0,maximum:1e4,description:l.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:se.sticky,description:l.localize(41,null)},"editor.hover.above":{type:"boolean",default:se.above,description:l.localize(42,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:w(Ee.enabled,this.defaultValue.enabled),delay:m.clampedInt(Ee.delay,this.defaultValue.delay,0,1e4),sticky:w(Ee.sticky,this.defaultValue.sticky),above:w(Ee.above,this.defaultValue.above)}}}var x;(function(re){re[re.None=0]="None",re[re.Text=1]="Text",re[re.Blocks=2]="Blocks"})(x=e.RenderMinimap||(e.RenderMinimap={}));class V extends E{constructor(){super(133)}compute(se,Ee,ue){return V.computeLayout(Ee,{memory:se.memory,outerWidth:se.outerWidth,outerHeight:se.outerHeight,isDominatedByLongLines:se.isDominatedByLongLines,lineHeight:se.fontInfo.lineHeight,viewLineCount:se.viewLineCount,lineNumbersDigitCount:se.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:se.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:se.fontInfo.maxDigitWidth,pixelRatio:se.pixelRatio})}static computeContainedMinimapLineCount(se){const Ee=se.height/se.lineHeight,ue=se.scrollBeyondLastLine?Ee-1:0,Te=(se.viewLineCount+ue)/(se.pixelRatio*se.height),Me=Math.floor(se.viewLineCount/Te);return{typicalViewportLineCount:Ee,extraLinesBeyondLastLine:ue,desiredRatio:Te,minimapLineCount:Me}}static _computeMinimapLayout(se,Ee){const ue=se.outerWidth,Te=se.outerHeight,Me=se.pixelRatio;if(!se.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Me*Te),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Te};const Be=Ee.stableMinimapLayoutInput,ze=Be&&se.outerHeight===Be.outerHeight&&se.lineHeight===Be.lineHeight&&se.typicalHalfwidthCharacterWidth===Be.typicalHalfwidthCharacterWidth&&se.pixelRatio===Be.pixelRatio&&se.scrollBeyondLastLine===Be.scrollBeyondLastLine&&se.minimap.enabled===Be.minimap.enabled&&se.minimap.side===Be.minimap.side&&se.minimap.size===Be.minimap.size&&se.minimap.showSlider===Be.minimap.showSlider&&se.minimap.renderCharacters===Be.minimap.renderCharacters&&se.minimap.maxColumn===Be.minimap.maxColumn&&se.minimap.scale===Be.minimap.scale&&se.verticalScrollbarWidth===Be.verticalScrollbarWidth&&se.isViewportWrapping===Be.isViewportWrapping,Ye=se.lineHeight,it=se.typicalHalfwidthCharacterWidth,ct=se.scrollBeyondLastLine,st=se.minimap.renderCharacters;let et=Me>=2?Math.round(se.minimap.scale*2):se.minimap.scale;const ft=se.minimap.maxColumn,Et=se.minimap.size,Dt=se.minimap.side,mt=se.verticalScrollbarWidth,It=se.viewLineCount,Ft=se.remainingWidth,Nt=se.isViewportWrapping,Ke=st?2:3;let Ut=Math.floor(Me*Te);const Ot=Ut/Me;let Pt=!1,pt=!1,Ct=Ke*et,Ae=et/Me,Re=1;if(Et==="fill"||Et==="fit"){const{typicalViewportLineCount:Xe,extraLinesBeyondLastLine:lt,desiredRatio:kt,minimapLineCount:vt}=V.computeContainedMinimapLineCount({viewLineCount:It,scrollBeyondLastLine:ct,height:Te,lineHeight:Ye,pixelRatio:Me});if(It/vt>1)Pt=!0,pt=!0,et=1,Ct=1,Ae=et/Me;else{let St=!1,wt=et+1;if(Et==="fit"){const _t=Math.ceil((It+lt)*Ct);Nt&&ze&&Ft<=Ee.stableFitRemainingWidth?(St=!0,wt=Ee.stableFitMaxMinimapScale):St=_t>Ut}if(Et==="fill"||St){Pt=!0;const _t=et;Ct=Math.min(Ye*Me,Math.max(1,Math.floor(1/kt))),Nt&&ze&&Ft<=Ee.stableFitRemainingWidth&&(wt=Ee.stableFitMaxMinimapScale),et=Math.min(wt,Math.max(1,Math.floor(Ct/Ke))),et>_t&&(Re=Math.min(2,et/_t)),Ae=et/Me/Re,Ut=Math.ceil(Math.max(Xe,It+lt)*Ct),Nt?(Ee.stableMinimapLayoutInput=se,Ee.stableFitRemainingWidth=Ft,Ee.stableFitMaxMinimapScale=et):(Ee.stableMinimapLayoutInput=null,Ee.stableFitRemainingWidth=0)}}}const _e=Math.floor(ft*Ae),te=Math.min(_e,Math.max(0,Math.floor((Ft-mt-2)*Ae/(it+Ae)))+e.MINIMAP_GUTTER_WIDTH);let Fe=Math.floor(Me*te);const je=Fe/Me;Fe=Math.floor(Fe*Re);const rt=st?1:2,Je=Dt==="left"?0:ue-te-mt;return{renderMinimap:rt,minimapLeft:Je,minimapWidth:te,minimapHeightIsEditorHeight:Pt,minimapIsSampling:pt,minimapScale:et,minimapLineHeight:Ct,minimapCanvasInnerWidth:Fe,minimapCanvasInnerHeight:Ut,minimapCanvasOuterWidth:je,minimapCanvasOuterHeight:Ot}}static computeLayout(se,Ee){const ue=Ee.outerWidth|0,Te=Ee.outerHeight|0,Me=Ee.lineHeight|0,Be=Ee.lineNumbersDigitCount|0,ze=Ee.typicalHalfwidthCharacterWidth,Ye=Ee.maxDigitWidth,it=Ee.pixelRatio,ct=Ee.viewLineCount,st=se.get(125),et=st==="inherit"?se.get(124):st,ft=et==="inherit"?se.get(120):et,Et=se.get(123),Dt=se.get(2),mt=Ee.isDominatedByLongLines,It=se.get(51),Ft=se.get(61).renderType!==0,Nt=se.get(62),Ke=se.get(95),Ut=se.get(66),Ot=se.get(93),Pt=Ot.verticalScrollbarSize,pt=Ot.verticalHasArrows,Ct=Ot.arrowSize,Ae=Ot.horizontalScrollbarSize,Re=se.get(59),_e=se.get(38),te=se.get(100)!=="never";let Fe;if(typeof Re=="string"&&/^\d+(\.\d+)?ch$/.test(Re)){const Ht=parseFloat(Re.substr(0,Re.length-2));Fe=m.clampedInt(Ht*ze,0,0,1e3)}else Fe=m.clampedInt(Re,0,0,1e3);_e&&te&&(Fe+=16);let je=0;if(Ft){const Ht=Math.max(Be,Nt);je=Math.round(Ht*Ye)}let rt=0;It&&(rt=Me);let Je=0,Xe=Je+rt,lt=Xe+je,kt=lt+Fe;const vt=ue-rt-je-Fe;let Tt=!1,St=!1,wt=-1;Dt!==2&&(et==="inherit"&&mt?(Tt=!0,St=!0):ft==="on"||ft==="bounded"?St=!0:ft==="wordWrapColumn"&&(wt=Et));const _t=V._computeMinimapLayout({outerWidth:ue,outerHeight:Te,lineHeight:Me,typicalHalfwidthCharacterWidth:ze,pixelRatio:it,scrollBeyondLastLine:Ke,minimap:Ut,verticalScrollbarWidth:Pt,viewLineCount:ct,remainingWidth:vt,isViewportWrapping:St},Ee.memory||new L);_t.renderMinimap!==0&&_t.minimapLeft===0&&(Je+=_t.minimapWidth,Xe+=_t.minimapWidth,lt+=_t.minimapWidth,kt+=_t.minimapWidth);const tn=vt-_t.minimapWidth,bt=Math.max(1,Math.floor((tn-Pt-2)/ze)),$t=pt?Ct:0;return St&&(wt=Math.max(1,bt),ft==="bounded"&&(wt=Math.min(wt,Et))),{width:ue,height:Te,glyphMarginLeft:Je,glyphMarginWidth:rt,lineNumbersLeft:Xe,lineNumbersWidth:je,decorationsLeft:lt,decorationsWidth:Fe,contentLeft:kt,contentWidth:tn,minimap:_t,viewportColumn:bt,isWordWrapMinified:Tt,isViewportWrapping:St,wrappingColumn:wt,verticalScrollbarWidth:Pt,horizontalScrollbarHeight:Ae,overviewRuler:{top:$t,width:Pt,height:Te-2*$t,right:0}}}}e.EditorLayoutInfoComputer=V;class q extends k{constructor(){const se={enabled:!0};super(58,"lightbulb",se,{"editor.lightbulb.enabled":{type:"boolean",default:se.enabled,description:l.localize(43,null)}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{enabled:w(se.enabled,this.defaultValue.enabled)}}}class Y extends k{constructor(){const se={enabled:!1,maxLineCount:5};super(105,"stickyScroll",se,{"editor.stickyScroll.enabled":{type:"boolean",default:se.enabled,description:l.localize(44,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:se.maxLineCount,minimum:1,maximum:10,description:l.localize(45,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:w(Ee.enabled,this.defaultValue.enabled),maxLineCount:m.clampedInt(Ee.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class Q extends k{constructor(){const se={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(129,"inlayHints",se,{"editor.inlayHints.enabled":{type:"string",default:se.enabled,description:l.localize(46,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[l.localize(47,null),l.localize(48,null,t.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),l.localize(49,null,t.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),l.localize(50,null)]},"editor.inlayHints.fontSize":{type:"number",default:se.fontSize,markdownDescription:l.localize(51,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:se.fontFamily,markdownDescription:l.localize(52,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:se.padding,description:l.localize(53,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return typeof Ee.enabled=="boolean"&&(Ee.enabled=Ee.enabled?"on":"off"),{enabled:n(Ee.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:m.clampedInt(Ee.fontSize,this.defaultValue.fontSize,0,100),fontFamily:g.string(Ee.fontFamily,this.defaultValue.fontFamily),padding:w(Ee.padding,this.defaultValue.padding)}}}class de extends a{constructor(){super(60,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,se=>a.clamp(se,0,150),{markdownDescription:l.localize(54,null)})}compute(se,Ee,ue){return se.fontInfo.lineHeight}}class ve extends k{constructor(){const se={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(66,"minimap",se,{"editor.minimap.enabled":{type:"boolean",default:se.enabled,description:l.localize(55,null)},"editor.minimap.autohide":{type:"boolean",default:se.autohide,description:l.localize(56,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[l.localize(57,null),l.localize(58,null),l.localize(59,null)],default:se.size,description:l.localize(60,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:se.side,description:l.localize(61,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:se.showSlider,description:l.localize(62,null)},"editor.minimap.scale":{type:"number",default:se.scale,minimum:1,maximum:3,enum:[1,2,3],description:l.localize(63,null)},"editor.minimap.renderCharacters":{type:"boolean",default:se.renderCharacters,description:l.localize(64,null)},"editor.minimap.maxColumn":{type:"number",default:se.maxColumn,description:l.localize(65,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:w(Ee.enabled,this.defaultValue.enabled),autohide:w(Ee.autohide,this.defaultValue.autohide),size:n(Ee.size,this.defaultValue.size,["proportional","fill","fit"]),side:n(Ee.side,this.defaultValue.side,["right","left"]),showSlider:n(Ee.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:w(Ee.renderCharacters,this.defaultValue.renderCharacters),scale:m.clampedInt(Ee.scale,1,1,3),maxColumn:m.clampedInt(Ee.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ne(re){return re==="ctrlCmd"?t.isMacintosh?"metaKey":"ctrlKey":"altKey"}class pe extends k{constructor(){super(76,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(66,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(67,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{top:m.clampedInt(Ee.top,0,0,1e3),bottom:m.clampedInt(Ee.bottom,0,0,1e3)}}}class be extends k{constructor(){const se={enabled:!0,cycle:!1};super(77,"parameterHints",se,{"editor.parameterHints.enabled":{type:"boolean",default:se.enabled,description:l.localize(68,null)},"editor.parameterHints.cycle":{type:"boolean",default:se.cycle,description:l.localize(69,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:w(Ee.enabled,this.defaultValue.enabled),cycle:w(Ee.cycle,this.defaultValue.cycle)}}}class ke extends E{constructor(){super(131)}compute(se,Ee,ue){return se.pixelRatio}}class Oe extends k{constructor(){const se={other:"on",comments:"off",strings:"off"},Ee=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[l.localize(70,null),l.localize(71,null),l.localize(72,null)]}];super(80,"quickSuggestions",se,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ee,default:se.strings,description:l.localize(73,null)},comments:{anyOf:Ee,default:se.comments,description:l.localize(74,null)},other:{anyOf:Ee,default:se.other,description:l.localize(75,null)}},default:se,markdownDescription:l.localize(76,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=se}validate(se){if(typeof se=="boolean"){const it=se?"on":"off";return{comments:it,strings:it,other:it}}if(!se||typeof se!="object")return this.defaultValue;const{other:Ee,comments:ue,strings:Te}=se,Me=["on","inline","off"];let Be,ze,Ye;return typeof Ee=="boolean"?Be=Ee?"on":"off":Be=n(Ee,this.defaultValue.other,Me),typeof ue=="boolean"?ze=ue?"on":"off":ze=n(ue,this.defaultValue.comments,Me),typeof Te=="boolean"?Ye=Te?"on":"off":Ye=n(Te,this.defaultValue.strings,Me),{other:Be,comments:ze,strings:Ye}}}var We;(function(re){re[re.Off=0]="Off",re[re.On=1]="On",re[re.Relative=2]="Relative",re[re.Interval=3]="Interval",re[re.Custom=4]="Custom"})(We=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class oe extends k{constructor(){super(61,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[l.localize(77,null),l.localize(78,null),l.localize(79,null),l.localize(80,null)],default:"on",description:l.localize(81,null)})}validate(se){let Ee=this.defaultValue.renderType,ue=this.defaultValue.renderFn;return typeof se<"u"&&(typeof se=="function"?(Ee=4,ue=se):se==="interval"?Ee=3:se==="relative"?Ee=2:se==="on"?Ee=1:Ee=0),{renderType:Ee,renderFn:ue}}}function le(re){const se=re.get(88);return se==="editable"?re.get(82):se!=="on"}e.filterValidationDecorations=le;class fe extends k{constructor(){const se=[],Ee={type:"number",description:l.localize(82,null)};super(92,"rulers",se,{type:"array",items:{anyOf:[Ee,{type:["object"],properties:{column:Ee,color:{type:"string",description:l.localize(83,null),format:"color-hex"}}}]},default:se,description:l.localize(84,null)})}validate(se){if(Array.isArray(se)){const Ee=[];for(const ue of se)if(typeof ue=="number")Ee.push({column:m.clampedInt(ue,0,0,1e4),color:null});else if(ue&&typeof ue=="object"){const Te=ue;Ee.push({column:m.clampedInt(Te.column,0,0,1e4),color:Te.color})}return Ee.sort((ue,Te)=>ue.column-Te.column),Ee}return this.defaultValue}}function Z(re,se){if(typeof re!="string")return se;switch(re){case"hidden":return 2;case"visible":return 3;default:return 1}}class ae extends k{constructor(){const se={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(93,"scrollbar",se,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(85,null),l.localize(86,null),l.localize(87,null)],default:"auto",description:l.localize(88,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(89,null),l.localize(90,null),l.localize(91,null)],default:"auto",description:l.localize(92,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:se.verticalScrollbarSize,description:l.localize(93,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:se.horizontalScrollbarSize,description:l.localize(94,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:se.scrollByPage,description:l.localize(95,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se,ue=m.clampedInt(Ee.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Te=m.clampedInt(Ee.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:m.clampedInt(Ee.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Z(Ee.vertical,this.defaultValue.vertical),horizontal:Z(Ee.horizontal,this.defaultValue.horizontal),useShadows:w(Ee.useShadows,this.defaultValue.useShadows),verticalHasArrows:w(Ee.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:w(Ee.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:w(Ee.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:w(Ee.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:ue,horizontalSliderSize:m.clampedInt(Ee.horizontalSliderSize,ue,0,1e3),verticalScrollbarSize:Te,verticalSliderSize:m.clampedInt(Ee.verticalSliderSize,Te,0,1e3),scrollByPage:w(Ee.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class ee extends k{constructor(){const se={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(115,"unicodeHighlight",se,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.nonBasicASCII,description:l.localize(96,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:se.invisibleCharacters,description:l.localize(97,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:se.ambiguousCharacters,description:l.localize(98,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.includeComments,description:l.localize(99,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.includeStrings,description:l.localize(100,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:se.allowedCharacters,description:l.localize(101,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:se.allowedLocales,description:l.localize(102,null)}})}applyUpdate(se,Ee){let ue=!1;Ee.allowedCharacters&&se&&(_.equals(se.allowedCharacters,Ee.allowedCharacters)||(se={...se,allowedCharacters:Ee.allowedCharacters},ue=!0)),Ee.allowedLocales&&se&&(_.equals(se.allowedLocales,Ee.allowedLocales)||(se={...se,allowedLocales:Ee.allowedLocales},ue=!0));const Te=super.applyUpdate(se,Ee);return ue?new S(Te.newValue,!0):Te}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{nonBasicASCII:G(Ee.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:w(Ee.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:w(Ee.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:G(Ee.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:G(Ee.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(se.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(se.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(se,Ee){if(typeof se!="object"||!se)return Ee;const ue={};for(const[Te,Me]of Object.entries(se))Me===!0&&(ue[Te]=!0);return ue}}class ie extends k{constructor(){const se={enabled:!0,mode:"subwordSmart"};super(56,"inlineSuggest",se,{"editor.inlineSuggest.enabled":{type:"boolean",default:se.enabled,description:l.localize(103,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:w(Ee.enabled,this.defaultValue.enabled),mode:n(Ee.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class F extends k{constructor(){const se={enabled:D.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:D.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",se,{"editor.bracketPairColorization.enabled":{type:"boolean",default:se.enabled,markdownDescription:l.localize(104,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:se.independentColorPoolPerBracketType,description:l.localize(105,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:w(Ee.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:w(Ee.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class H extends k{constructor(){const se={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",se,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(106,null),l.localize(107,null),l.localize(108,null)],default:se.bracketPairs,description:l.localize(109,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(110,null),l.localize(111,null),l.localize(112,null)],default:se.bracketPairsHorizontal,description:l.localize(113,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:se.highlightActiveBracketPair,description:l.localize(114,null)},"editor.guides.indentation":{type:"boolean",default:se.indentation,description:l.localize(115,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[l.localize(116,null),l.localize(117,null),l.localize(118,null)],default:se.highlightActiveIndentation,description:l.localize(119,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{bracketPairs:G(Ee.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:G(Ee.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:w(Ee.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:w(Ee.indentation,this.defaultValue.indentation),highlightActiveIndentation:G(Ee.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function G(re,se,Ee){const ue=Ee.indexOf(re);return ue===-1?se:Ee[ue]}class X extends k{constructor(){const se={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(108,"suggest",se,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[l.localize(120,null),l.localize(121,null)],default:se.insertMode,description:l.localize(122,null)},"editor.suggest.filterGraceful":{type:"boolean",default:se.filterGraceful,description:l.localize(123,null)},"editor.suggest.localityBonus":{type:"boolean",default:se.localityBonus,description:l.localize(124,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:se.shareSuggestSelections,markdownDescription:l.localize(125,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:se.snippetsPreventQuickSuggestions,description:l.localize(126,null)},"editor.suggest.showIcons":{type:"boolean",default:se.showIcons,description:l.localize(127,null)},"editor.suggest.showStatusBar":{type:"boolean",default:se.showStatusBar,description:l.localize(128,null)},"editor.suggest.preview":{type:"boolean",default:se.preview,description:l.localize(129,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:se.showInlineDetails,description:l.localize(130,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:l.localize(131,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:l.localize(132,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:l.localize(133,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:l.localize(134,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:l.localize(135,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:l.localize(136,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:l.localize(137,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:l.localize(138,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:l.localize(139,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:l.localize(140,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:l.localize(141,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:l.localize(142,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:l.localize(143,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:l.localize(144,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:l.localize(145,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:l.localize(146,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:l.localize(147,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:l.localize(148,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:l.localize(149,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:l.localize(150,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:l.localize(151,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:l.localize(152,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:l.localize(153,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:l.localize(154,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:l.localize(155,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:l.localize(156,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:l.localize(157,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:l.localize(158,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:l.localize(159,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:l.localize(160,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:l.localize(161,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:l.localize(162,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{insertMode:n(Ee.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:w(Ee.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:w(Ee.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:w(Ee.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:w(Ee.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:w(Ee.showIcons,this.defaultValue.showIcons),showStatusBar:w(Ee.showStatusBar,this.defaultValue.showStatusBar),preview:w(Ee.preview,this.defaultValue.preview),previewMode:n(Ee.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:w(Ee.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:w(Ee.showMethods,this.defaultValue.showMethods),showFunctions:w(Ee.showFunctions,this.defaultValue.showFunctions),showConstructors:w(Ee.showConstructors,this.defaultValue.showConstructors),showDeprecated:w(Ee.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:w(Ee.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:w(Ee.showFields,this.defaultValue.showFields),showVariables:w(Ee.showVariables,this.defaultValue.showVariables),showClasses:w(Ee.showClasses,this.defaultValue.showClasses),showStructs:w(Ee.showStructs,this.defaultValue.showStructs),showInterfaces:w(Ee.showInterfaces,this.defaultValue.showInterfaces),showModules:w(Ee.showModules,this.defaultValue.showModules),showProperties:w(Ee.showProperties,this.defaultValue.showProperties),showEvents:w(Ee.showEvents,this.defaultValue.showEvents),showOperators:w(Ee.showOperators,this.defaultValue.showOperators),showUnits:w(Ee.showUnits,this.defaultValue.showUnits),showValues:w(Ee.showValues,this.defaultValue.showValues),showConstants:w(Ee.showConstants,this.defaultValue.showConstants),showEnums:w(Ee.showEnums,this.defaultValue.showEnums),showEnumMembers:w(Ee.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:w(Ee.showKeywords,this.defaultValue.showKeywords),showWords:w(Ee.showWords,this.defaultValue.showWords),showColors:w(Ee.showColors,this.defaultValue.showColors),showFiles:w(Ee.showFiles,this.defaultValue.showFiles),showReferences:w(Ee.showReferences,this.defaultValue.showReferences),showFolders:w(Ee.showFolders,this.defaultValue.showFolders),showTypeParameters:w(Ee.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:w(Ee.showSnippets,this.defaultValue.showSnippets),showUsers:w(Ee.showUsers,this.defaultValue.showUsers),showIssues:w(Ee.showIssues,this.defaultValue.showIssues)}}}class me extends k{constructor(){super(103,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:l.localize(163,null),default:!0,type:"boolean"}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:w(se.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class we extends E{constructor(){super(132)}compute(se,Ee,ue){return Ee.get(82)?!0:se.tabFocusMode}}var ce;(function(re){re[re.None=0]="None",re[re.Same=1]="Same",re[re.Indent=2]="Indent",re[re.DeepIndent=3]="DeepIndent"})(ce=e.WrappingIndent||(e.WrappingIndent={}));function Ce(re){switch(re){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ye extends E{constructor(){super(134)}compute(se,Ee,ue){const Te=Ee.get(133);return{isDominatedByLongLines:se.isDominatedByLongLines,isWordWrapMinified:Te.isWordWrapMinified,isViewportWrapping:Te.isViewportWrapping,wrappingColumn:Te.wrappingColumn}}}class $e extends k{constructor(){const se={enabled:!0};super(32,"dropIntoEditor",se,{"editor.dropIntoEditor.enabled":{type:"boolean",default:se.enabled,markdownDescription:l.localize(164,null)}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{enabled:w(se.enabled,this.defaultValue.enabled)}}}const Ve="Consolas, 'Courier New', monospace",Ze="Menlo, Monaco, 'Courier New', monospace",Qe="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:t.isMacintosh?Ze:t.isLinux?Qe:Ve,fontWeight:"normal",fontSize:t.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Le(re){return e.editorOptionsRegistry[re.id]=re,re}var ot;(function(re){re[re.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",re[re.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",re[re.accessibilitySupport=2]="accessibilitySupport",re[re.accessibilityPageSize=3]="accessibilityPageSize",re[re.ariaLabel=4]="ariaLabel",re[re.autoClosingBrackets=5]="autoClosingBrackets",re[re.autoClosingDelete=6]="autoClosingDelete",re[re.autoClosingOvertype=7]="autoClosingOvertype",re[re.autoClosingQuotes=8]="autoClosingQuotes",re[re.autoIndent=9]="autoIndent",re[re.automaticLayout=10]="automaticLayout",re[re.autoSurround=11]="autoSurround",re[re.bracketPairColorization=12]="bracketPairColorization",re[re.guides=13]="guides",re[re.codeLens=14]="codeLens",re[re.codeLensFontFamily=15]="codeLensFontFamily",re[re.codeLensFontSize=16]="codeLensFontSize",re[re.colorDecorators=17]="colorDecorators",re[re.columnSelection=18]="columnSelection",re[re.comments=19]="comments",re[re.contextmenu=20]="contextmenu",re[re.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",re[re.cursorBlinking=22]="cursorBlinking",re[re.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",re[re.cursorStyle=24]="cursorStyle",re[re.cursorSurroundingLines=25]="cursorSurroundingLines",re[re.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",re[re.cursorWidth=27]="cursorWidth",re[re.disableLayerHinting=28]="disableLayerHinting",re[re.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",re[re.domReadOnly=30]="domReadOnly",re[re.dragAndDrop=31]="dragAndDrop",re[re.dropIntoEditor=32]="dropIntoEditor",re[re.emptySelectionClipboard=33]="emptySelectionClipboard",re[re.extraEditorClassName=34]="extraEditorClassName",re[re.fastScrollSensitivity=35]="fastScrollSensitivity",re[re.find=36]="find",re[re.fixedOverflowWidgets=37]="fixedOverflowWidgets",re[re.folding=38]="folding",re[re.foldingStrategy=39]="foldingStrategy",re[re.foldingHighlight=40]="foldingHighlight",re[re.foldingImportsByDefault=41]="foldingImportsByDefault",re[re.foldingMaximumRegions=42]="foldingMaximumRegions",re[re.unfoldOnClickAfterEndOfLine=43]="unfoldOnClickAfterEndOfLine",re[re.fontFamily=44]="fontFamily",re[re.fontInfo=45]="fontInfo",re[re.fontLigatures=46]="fontLigatures",re[re.fontSize=47]="fontSize",re[re.fontWeight=48]="fontWeight",re[re.formatOnPaste=49]="formatOnPaste",re[re.formatOnType=50]="formatOnType",re[re.glyphMargin=51]="glyphMargin",re[re.gotoLocation=52]="gotoLocation",re[re.hideCursorInOverviewRuler=53]="hideCursorInOverviewRuler",re[re.hover=54]="hover",re[re.inDiffEditor=55]="inDiffEditor",re[re.inlineSuggest=56]="inlineSuggest",re[re.letterSpacing=57]="letterSpacing",re[re.lightbulb=58]="lightbulb",re[re.lineDecorationsWidth=59]="lineDecorationsWidth",re[re.lineHeight=60]="lineHeight",re[re.lineNumbers=61]="lineNumbers",re[re.lineNumbersMinChars=62]="lineNumbersMinChars",re[re.linkedEditing=63]="linkedEditing",re[re.links=64]="links",re[re.matchBrackets=65]="matchBrackets",re[re.minimap=66]="minimap",re[re.mouseStyle=67]="mouseStyle",re[re.mouseWheelScrollSensitivity=68]="mouseWheelScrollSensitivity",re[re.mouseWheelZoom=69]="mouseWheelZoom",re[re.multiCursorMergeOverlapping=70]="multiCursorMergeOverlapping",re[re.multiCursorModifier=71]="multiCursorModifier",re[re.multiCursorPaste=72]="multiCursorPaste",re[re.occurrencesHighlight=73]="occurrencesHighlight",re[re.overviewRulerBorder=74]="overviewRulerBorder",re[re.overviewRulerLanes=75]="overviewRulerLanes",re[re.padding=76]="padding",re[re.parameterHints=77]="parameterHints",re[re.peekWidgetDefaultFocus=78]="peekWidgetDefaultFocus",re[re.definitionLinkOpensInPeek=79]="definitionLinkOpensInPeek",re[re.quickSuggestions=80]="quickSuggestions",re[re.quickSuggestionsDelay=81]="quickSuggestionsDelay",re[re.readOnly=82]="readOnly",re[re.renameOnType=83]="renameOnType",re[re.renderControlCharacters=84]="renderControlCharacters",re[re.renderFinalNewline=85]="renderFinalNewline",re[re.renderLineHighlight=86]="renderLineHighlight",re[re.renderLineHighlightOnlyWhenFocus=87]="renderLineHighlightOnlyWhenFocus",re[re.renderValidationDecorations=88]="renderValidationDecorations",re[re.renderWhitespace=89]="renderWhitespace",re[re.revealHorizontalRightPadding=90]="revealHorizontalRightPadding",re[re.roundedSelection=91]="roundedSelection",re[re.rulers=92]="rulers",re[re.scrollbar=93]="scrollbar",re[re.scrollBeyondLastColumn=94]="scrollBeyondLastColumn",re[re.scrollBeyondLastLine=95]="scrollBeyondLastLine",re[re.scrollPredominantAxis=96]="scrollPredominantAxis",re[re.selectionClipboard=97]="selectionClipboard",re[re.selectionHighlight=98]="selectionHighlight",re[re.selectOnLineNumbers=99]="selectOnLineNumbers",re[re.showFoldingControls=100]="showFoldingControls",re[re.showUnused=101]="showUnused",re[re.snippetSuggestions=102]="snippetSuggestions",re[re.smartSelect=103]="smartSelect",re[re.smoothScrolling=104]="smoothScrolling",re[re.stickyScroll=105]="stickyScroll",re[re.stickyTabStops=106]="stickyTabStops",re[re.stopRenderingLineAfter=107]="stopRenderingLineAfter",re[re.suggest=108]="suggest",re[re.suggestFontSize=109]="suggestFontSize",re[re.suggestLineHeight=110]="suggestLineHeight",re[re.suggestOnTriggerCharacters=111]="suggestOnTriggerCharacters",re[re.suggestSelection=112]="suggestSelection",re[re.tabCompletion=113]="tabCompletion",re[re.tabIndex=114]="tabIndex",re[re.unicodeHighlighting=115]="unicodeHighlighting",re[re.unusualLineTerminators=116]="unusualLineTerminators",re[re.useShadowDOM=117]="useShadowDOM",re[re.useTabStops=118]="useTabStops",re[re.wordSeparators=119]="wordSeparators",re[re.wordWrap=120]="wordWrap",re[re.wordWrapBreakAfterCharacters=121]="wordWrapBreakAfterCharacters",re[re.wordWrapBreakBeforeCharacters=122]="wordWrapBreakBeforeCharacters",re[re.wordWrapColumn=123]="wordWrapColumn",re[re.wordWrapOverride1=124]="wordWrapOverride1",re[re.wordWrapOverride2=125]="wordWrapOverride2",re[re.wrappingIndent=126]="wrappingIndent",re[re.wrappingStrategy=127]="wrappingStrategy",re[re.showDeprecated=128]="showDeprecated",re[re.inlayHints=129]="inlayHints",re[re.editorClassName=130]="editorClassName",re[re.pixelRatio=131]="pixelRatio",re[re.tabFocusMode=132]="tabFocusMode",re[re.layoutInfo=133]="layoutInfo",re[re.wrappingInfo=134]="wrappingInfo"})(ot=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Le(new f(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:l.localize(165,null)})),acceptSuggestionOnEnter:Le(new d(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",l.localize(166,null),""],markdownDescription:l.localize(167,null)})),accessibilitySupport:Le(new r),accessibilityPageSize:Le(new m(3,"accessibilityPageSize",10,1,1073741824,{description:l.localize(168,null)})),ariaLabel:Le(new g(4,"ariaLabel",l.localize(169,null))),autoClosingBrackets:Le(new d(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(170,null),l.localize(171,null),""],description:l.localize(172,null)})),autoClosingDelete:Le(new d(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",l.localize(173,null),""],description:l.localize(174,null)})),autoClosingOvertype:Le(new d(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",l.localize(175,null),""],description:l.localize(176,null)})),autoClosingQuotes:Le(new d(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(177,null),l.localize(178,null),""],description:l.localize(179,null)})),autoIndent:Le(new s(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],i,{enumDescriptions:[l.localize(180,null),l.localize(181,null),l.localize(182,null),l.localize(183,null),l.localize(184,null)],description:l.localize(185,null)})),automaticLayout:Le(new f(10,"automaticLayout",!1)),autoSurround:Le(new d(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[l.localize(186,null),l.localize(187,null),l.localize(188,null),""],description:l.localize(189,null)})),bracketPairColorization:Le(new F),bracketPairGuides:Le(new H),stickyTabStops:Le(new f(106,"stickyTabStops",!1,{description:l.localize(190,null)})),codeLens:Le(new f(14,"codeLens",!0,{description:l.localize(191,null)})),codeLensFontFamily:Le(new g(15,"codeLensFontFamily","",{description:l.localize(192,null)})),codeLensFontSize:Le(new m(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:l.localize(193,null)})),colorDecorators:Le(new f(17,"colorDecorators",!0,{description:l.localize(194,null)})),columnSelection:Le(new f(18,"columnSelection",!1,{description:l.localize(195,null)})),comments:Le(new c),contextmenu:Le(new f(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Le(new f(21,"copyWithSyntaxHighlighting",!0,{description:l.localize(196,null)})),cursorBlinking:Le(new s(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],u,{description:l.localize(197,null)})),cursorSmoothCaretAnimation:Le(new f(23,"cursorSmoothCaretAnimation",!1,{description:l.localize(198,null)})),cursorStyle:Le(new s(24,"cursorStyle",h.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],R,{description:l.localize(199,null)})),cursorSurroundingLines:Le(new m(25,"cursorSurroundingLines",0,0,1073741824,{description:l.localize(200,null)})),cursorSurroundingLinesStyle:Le(new d(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[l.localize(201,null),l.localize(202,null)],description:l.localize(203,null)})),cursorWidth:Le(new m(27,"cursorWidth",0,0,1073741824,{markdownDescription:l.localize(204,null)})),disableLayerHinting:Le(new f(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Le(new f(29,"disableMonospaceOptimizations",!1)),domReadOnly:Le(new f(30,"domReadOnly",!1)),dragAndDrop:Le(new f(31,"dragAndDrop",!0,{description:l.localize(205,null)})),emptySelectionClipboard:Le(new U),dropIntoEditor:Le(new $e),stickyScroll:Le(new Y),extraEditorClassName:Le(new g(34,"extraEditorClassName","")),fastScrollSensitivity:Le(new a(35,"fastScrollSensitivity",5,re=>re<=0?5:re,{markdownDescription:l.localize(206,null)})),find:Le(new A),fixedOverflowWidgets:Le(new f(37,"fixedOverflowWidgets",!1)),folding:Le(new f(38,"folding",!0,{description:l.localize(207,null)})),foldingStrategy:Le(new d(39,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[l.localize(208,null),l.localize(209,null)],description:l.localize(210,null)})),foldingHighlight:Le(new f(40,"foldingHighlight",!0,{description:l.localize(211,null)})),foldingImportsByDefault:Le(new f(41,"foldingImportsByDefault",!1,{description:l.localize(212,null)})),foldingMaximumRegions:Le(new m(42,"foldingMaximumRegions",5e3,10,65e3,{description:l.localize(213,null)})),unfoldOnClickAfterEndOfLine:Le(new f(43,"unfoldOnClickAfterEndOfLine",!1,{description:l.localize(214,null)})),fontFamily:Le(new g(44,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:l.localize(215,null)})),fontInfo:Le(new $),fontLigatures2:Le(new z),fontSize:Le(new N),fontWeight:Le(new K),formatOnPaste:Le(new f(49,"formatOnPaste",!1,{description:l.localize(216,null)})),formatOnType:Le(new f(50,"formatOnType",!1,{description:l.localize(217,null)})),glyphMargin:Le(new f(51,"glyphMargin",!0,{description:l.localize(218,null)})),gotoLocation:Le(new B),hideCursorInOverviewRuler:Le(new f(53,"hideCursorInOverviewRuler",!1,{description:l.localize(219,null)})),hover:Le(new O),inDiffEditor:Le(new f(55,"inDiffEditor",!1)),letterSpacing:Le(new a(57,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,re=>a.clamp(re,-5,20),{description:l.localize(220,null)})),lightbulb:Le(new q),lineDecorationsWidth:Le(new p(59,"lineDecorationsWidth",10)),lineHeight:Le(new de),lineNumbers:Le(new oe),lineNumbersMinChars:Le(new m(62,"lineNumbersMinChars",5,1,300)),linkedEditing:Le(new f(63,"linkedEditing",!1,{description:l.localize(221,null)})),links:Le(new f(64,"links",!0,{description:l.localize(222,null)})),matchBrackets:Le(new d(65,"matchBrackets","always",["always","near","never"],{description:l.localize(223,null)})),minimap:Le(new ve),mouseStyle:Le(new d(67,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Le(new a(68,"mouseWheelScrollSensitivity",1,re=>re===0?1:re,{markdownDescription:l.localize(224,null)})),mouseWheelZoom:Le(new f(69,"mouseWheelZoom",!1,{markdownDescription:l.localize(225,null)})),multiCursorMergeOverlapping:Le(new f(70,"multiCursorMergeOverlapping",!0,{description:l.localize(226,null)})),multiCursorModifier:Le(new s(71,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ne,{markdownEnumDescriptions:[l.localize(227,null),l.localize(228,null)],markdownDescription:l.localize(229,null)})),multiCursorPaste:Le(new d(72,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[l.localize(230,null),l.localize(231,null)],markdownDescription:l.localize(232,null)})),occurrencesHighlight:Le(new f(73,"occurrencesHighlight",!0,{description:l.localize(233,null)})),overviewRulerBorder:Le(new f(74,"overviewRulerBorder",!0,{description:l.localize(234,null)})),overviewRulerLanes:Le(new m(75,"overviewRulerLanes",3,0,3)),padding:Le(new pe),parameterHints:Le(new be),peekWidgetDefaultFocus:Le(new d(78,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[l.localize(235,null),l.localize(236,null)],description:l.localize(237,null)})),definitionLinkOpensInPeek:Le(new f(79,"definitionLinkOpensInPeek",!1,{description:l.localize(238,null)})),quickSuggestions:Le(new Oe),quickSuggestionsDelay:Le(new m(81,"quickSuggestionsDelay",10,0,1073741824,{description:l.localize(239,null)})),readOnly:Le(new f(82,"readOnly",!1)),renameOnType:Le(new f(83,"renameOnType",!1,{description:l.localize(240,null),markdownDeprecationMessage:l.localize(241,null)})),renderControlCharacters:Le(new f(84,"renderControlCharacters",!0,{description:l.localize(242,null),restricted:!0})),renderFinalNewline:Le(new f(85,"renderFinalNewline",!0,{description:l.localize(243,null)})),renderLineHighlight:Le(new d(86,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",l.localize(244,null)],description:l.localize(245,null)})),renderLineHighlightOnlyWhenFocus:Le(new f(87,"renderLineHighlightOnlyWhenFocus",!1,{description:l.localize(246,null)})),renderValidationDecorations:Le(new d(88,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Le(new d(89,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",l.localize(247,null),l.localize(248,null),l.localize(249,null),""],description:l.localize(250,null)})),revealHorizontalRightPadding:Le(new m(90,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Le(new f(91,"roundedSelection",!0,{description:l.localize(251,null)})),rulers:Le(new fe),scrollbar:Le(new ae),scrollBeyondLastColumn:Le(new m(94,"scrollBeyondLastColumn",4,0,1073741824,{description:l.localize(252,null)})),scrollBeyondLastLine:Le(new f(95,"scrollBeyondLastLine",!0,{description:l.localize(253,null)})),scrollPredominantAxis:Le(new f(96,"scrollPredominantAxis",!0,{description:l.localize(254,null)})),selectionClipboard:Le(new f(97,"selectionClipboard",!0,{description:l.localize(255,null),included:t.isLinux})),selectionHighlight:Le(new f(98,"selectionHighlight",!0,{description:l.localize(256,null)})),selectOnLineNumbers:Le(new f(99,"selectOnLineNumbers",!0)),showFoldingControls:Le(new d(100,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[l.localize(257,null),l.localize(258,null),l.localize(259,null)],description:l.localize(260,null)})),showUnused:Le(new f(101,"showUnused",!0,{description:l.localize(261,null)})),showDeprecated:Le(new f(128,"showDeprecated",!0,{description:l.localize(262,null)})),inlayHints:Le(new Q),snippetSuggestions:Le(new d(102,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[l.localize(263,null),l.localize(264,null),l.localize(265,null),l.localize(266,null)],description:l.localize(267,null)})),smartSelect:Le(new me),smoothScrolling:Le(new f(104,"smoothScrolling",!1,{description:l.localize(268,null)})),stopRenderingLineAfter:Le(new m(107,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Le(new X),inlineSuggest:Le(new ie),suggestFontSize:Le(new m(109,"suggestFontSize",0,0,1e3,{markdownDescription:l.localize(269,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Le(new m(110,"suggestLineHeight",0,0,1e3,{markdownDescription:l.localize(270,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Le(new f(111,"suggestOnTriggerCharacters",!0,{description:l.localize(271,null)})),suggestSelection:Le(new d(112,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[l.localize(272,null),l.localize(273,null),l.localize(274,null)],description:l.localize(275,null)})),tabCompletion:Le(new d(113,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[l.localize(276,null),l.localize(277,null),l.localize(278,null)],description:l.localize(279,null)})),tabIndex:Le(new m(114,"tabIndex",0,-1,1073741824)),unicodeHighlight:Le(new ee),unusualLineTerminators:Le(new d(116,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[l.localize(280,null),l.localize(281,null),l.localize(282,null)],description:l.localize(283,null)})),useShadowDOM:Le(new f(117,"useShadowDOM",!0)),useTabStops:Le(new f(118,"useTabStops",!0,{description:l.localize(284,null)})),wordSeparators:Le(new g(119,"wordSeparators",C.USUAL_WORD_SEPARATORS,{description:l.localize(285,null)})),wordWrap:Le(new d(120,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[l.localize(286,null),l.localize(287,null),l.localize(288,null),l.localize(289,null)],description:l.localize(290,null)})),wordWrapBreakAfterCharacters:Le(new g(121,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Le(new g(122,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Le(new m(123,"wordWrapColumn",80,1,1073741824,{markdownDescription:l.localize(291,null)})),wordWrapOverride1:Le(new d(124,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Le(new d(125,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Le(new s(126,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Ce,{enumDescriptions:[l.localize(292,null),l.localize(293,null),l.localize(294,null),l.localize(295,null)],description:l.localize(296,null)})),wrappingStrategy:Le(new d(127,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[l.localize(297,null),l.localize(298,null)],description:l.localize(299,null)})),editorClassName:Le(new M),pixelRatio:Le(new ke),tabFocusMode:Le(new we),layoutInfo:Le(new V),wrappingInfo:Le(new ye)}}),define(De[162],Ie([19,20]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(De[163],Ie([19,20]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(De[164],Ie([19,20]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(De[165],Ie([19,20]),function(J,e){return J.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(De[166],Ie([19,20]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(De[167],Ie([19,20]),function(J,e){return J.create("vs/platform/markers/common/markers",e)}),define(De[168],Ie([19,20]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(De[169],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(De[170],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostExtensionService",e)}),define(De[171],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostProgress",e)}),define(De[172],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostStatusBar",e)}),define(De[173],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostTerminalService",e)}),define(De[174],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostTreeViews",e)}),define(De[175],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostWorkspace",e)}),define(De[176],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/node/extHostDebugService",e)}),define(De[177],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/node/extHostTunnelService",e)}),define(De[178],Ie([19,20]),function(J,e){return J.create("vs/workbench/common/editor",e)}),define(De[179],Ie([19,20]),function(J,e){return J.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(De[180],Ie([19,20]),function(J,e){return J.create("vs/workbench/contrib/debug/common/debug",e)}),define(De[181],Ie([19,20]),function(J,e){return J.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(De[182],Ie([19,20]),function(J,e){return J.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(De[183],Ie([19,20]),function(J,e){return J.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(De[184],Ie([19,20]),function(J,e){return J.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(De[185],Ie([19,20]),function(J,e){return J.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(De[186],Ie([19,20]),function(J,e){return J.create("vs/workbench/services/search/common/queryBuilder",e)}),define(De[187],Ie([1,0,22,41,164,302]),function(J,e,l,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const _=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function b(f){return f=f.trim(),f==="*"||_.test(f)}e.isValidVersionStr=b;function I(f){if(!b(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const v=f.match(_);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=I;function L(f){if(!f)return null;const v=f.majorBase,m=f.majorMustEqual,a=f.minorBase;let g=f.minorMustEqual;const n=f.patchBase;let d=f.patchMustEqual;f.hasCaret&&(v===0||(g=!1),d=!1);let s=0;if(f.preRelease){const i=D.exec(f.preRelease);if(i){const[,r,c,o]=i;s=Date.UTC(Number(r),Number(c)-1,Number(o))}}return{majorBase:v,majorMustEqual:m,minorBase:a,minorMustEqual:g,patchBase:n,patchMustEqual:d,isMinimum:f.hasGreaterEquals,notBefore:s}}e.normalizeVersion=L;function k(f,v,m){let a;typeof f=="string"?a=L(I(f)):a=f;let g;v instanceof Date?g=v.getTime():typeof v=="string"&&(g=new Date(v).getTime());let n;if(typeof m=="string"?n=L(I(m)):n=m,!a||!n)return!1;const d=a.majorBase,s=a.minorBase,i=a.patchBase;let r=n.majorBase,c=n.minorBase,o=n.patchBase;const u=n.notBefore;let h=n.majorMustEqual,y=n.minorMustEqual,R=n.patchMustEqual;return n.isMinimum?d>r?!0:d<r?!1:s>c?!0:s<c||g&&g<u?!1:i>=o:(d===1&&r===0&&(!h||!y||!R)&&(r=1,c=0,o=0,h=!0,y=!1,R=!1),d<r?!1:d>r?!h:s<c?!1:s>c?!y:i<o?!1:i>o?!R:!(g&&g<u))}e.isValidVersion=k;function S(f,v,m,a,g){const n=[];if(typeof a.publisher<"u"&&typeof a.publisher!="string")return n.push([t.default.Error,C.localize(0,null)]),n;if(typeof a.name!="string")return n.push([t.default.Error,C.localize(1,null,"name")]),n;if(typeof a.version!="string")return n.push([t.default.Error,C.localize(2,null,"version")]),n;if(!a.engines)return n.push([t.default.Error,C.localize(3,null,"engines")]),n;if(typeof a.engines.vscode!="string")return n.push([t.default.Error,C.localize(4,null,"engines.vscode")]),n;if(typeof a.extensionDependencies<"u"&&!w(a.extensionDependencies))return n.push([t.default.Error,C.localize(5,null,"extensionDependencies")]),n;if(typeof a.activationEvents<"u"){if(!w(a.activationEvents))return n.push([t.default.Error,C.localize(6,null,"activationEvents")]),n;if(typeof a.main>"u"&&typeof a.browser>"u")return n.push([t.default.Error,C.localize(7,null,"activationEvents","main")]),n}if(typeof a.extensionKind<"u"&&typeof a.main>"u"&&n.push([t.default.Warning,C.localize(8,null,"extensionKind")]),typeof a.main<"u"){if(typeof a.main!="string")return n.push([t.default.Error,C.localize(9,null,"main")]),n;{const i=(0,l.joinPath)(m,a.main);(0,l.isEqualOrParent)(i,m)||n.push([t.default.Warning,C.localize(10,null,i.path,m.path)])}if(typeof a.activationEvents>"u")return n.push([t.default.Error,C.localize(11,null,"activationEvents","main")]),n}if(typeof a.browser<"u"){if(typeof a.browser!="string")return n.push([t.default.Error,C.localize(12,null,"browser")]),n;{const i=(0,l.joinPath)(m,a.browser);(0,l.isEqualOrParent)(i,m)||n.push([t.default.Warning,C.localize(13,null,i.path,m.path)])}if(typeof a.activationEvents>"u")return n.push([t.default.Error,C.localize(14,null,"activationEvents","browser")]),n}if(!P.valid(a.version))return n.push([t.default.Error,C.localize(15,null)]),n;const d=[];if(!T(f,v,a,g,d))for(const i of d)n.push([t.default.Error,i]);return n}e.validateExtensionManifest=S;function T(f,v,m,a,g){return a||typeof m.main>"u"&&typeof m.browser>"u"?!0:p(f,v,m.engines.vscode,g)}e.isValidExtensionVersion=T;function E(f,v,m){return f==="*"||p(v,m,f)}e.isEngineValid=E;function p(f,v,m,a=[]){const g=L(I(m));if(!g)return a.push(C.localize(16,null,m)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return a.push(C.localize(17,null,m)),!1}else if(!g.majorMustEqual)return a.push(C.localize(18,null,m)),!1;return k(f,v,g)?!0:(a.push(C.localize(19,null,f,m)),!1)}function w(f){if(!Array.isArray(f))return!1;for(let v=0,m=f.length;v<m;v++)if(typeof f[v]!="string")return!1;return!0}}),define(De[116],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class l{constructor(C,P=[],_=!1){this.ctor=C,this.staticArguments=P,this.supportsDelayedInstantiation=_}}e.SyncDescriptor=l}),define(De[82],Ie([1,0,116]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var C;(function(D){D[D.Eager=0]="Eager",D[D.Delayed=1]="Delayed"})(C=e.InstantiationType||(e.InstantiationType={}));function P(D,b,I){b instanceof l.SyncDescriptor||(b=new l.SyncDescriptor(b,[],Boolean(I))),t.push([D,b])}e.registerSingleton=P;function _(){return t}e.getSingletonServiceDescriptors=_}),define(De[188],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class l{constructor(P,_){this.key=P,this.data=_,this.incoming=new Map,this.outgoing=new Map}}e.Node=l;class t{constructor(P){this._hashFn=P,this._nodes=new Map}roots(){const P=[];for(const _ of this._nodes.values())_.outgoing.size===0&&P.push(_);return P}insertEdge(P,_){const D=this.lookupOrInsertNode(P),b=this.lookupOrInsertNode(_);D.outgoing.set(b.key,b),b.incoming.set(D.key,D)}removeNode(P){const _=this._hashFn(P);this._nodes.delete(_);for(const D of this._nodes.values())D.outgoing.delete(_),D.incoming.delete(_)}lookupOrInsertNode(P){const _=this._hashFn(P);let D=this._nodes.get(_);return D||(D=new l(_,P),this._nodes.set(_,D)),D}lookup(P){return this._nodes.get(this._hashFn(P))}isEmpty(){return this._nodes.size===0}toString(){const P=[];for(const[_,D]of this._nodes)P.push(`${_}
	(-> incoming)[${[...D.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...D.outgoing.keys()].join(",")}]
`);return P.join(`
`)}findCycleSlow(){for(const[P,_]of this._nodes){const D=new Set([P]),b=this._findCycle(_,D);if(b)return b}}_findCycle(P,_){for(const[D,b]of P.outgoing){if(_.has(D))return[..._,D].join(" -> ");_.add(D);const I=this._findCycle(b,_);if(I)return I;_.delete(D)}}}e.Graph=t}),define(De[3],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var l;(function(_){_.serviceIds=new Map,_.DI_TARGET="$di$target",_.DI_DEPENDENCIES="$di$dependencies";function D(b){return b[_.DI_DEPENDENCIES]||[]}_.getServiceDependencies=D})(l=e._util||(e._util={})),e.IInstantiationService=C("instantiationService");function t(_,D,b){D[l.DI_TARGET]===D?D[l.DI_DEPENDENCIES].push({id:_,index:b}):(D[l.DI_DEPENDENCIES]=[{id:_,index:b}],D[l.DI_TARGET]=D)}function C(_){if(l.serviceIds.has(_))return l.serviceIds.get(_);const D=function(b,I,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(D,b,L)};return D.toString=()=>_,l.serviceIds.set(_,D),D}e.createDecorator=C;function P(_){return _}e.refineServiceDecorator=P}),define(De[83],Ie([1,0,14,2,3]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,C.createDecorator)("configurationService");function P(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof t.URI)}e.isConfigurationOverrides=P;function _(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||Array.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=_;var D;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.USER=2]="USER",f[f.USER_LOCAL=3]="USER_LOCAL",f[f.USER_REMOTE=4]="USER_REMOTE",f[f.WORKSPACE=5]="WORKSPACE",f[f.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",f[f.DEFAULT=7]="DEFAULT",f[f.MEMORY=8]="MEMORY"})(D=e.ConfigurationTarget||(e.ConfigurationTarget={}));function b(f){switch(f){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=b;function I(f,v){const m=Object.create(null);for(const a in f)L(m,a,f[a],v);return m}e.toValuesTree=I;function L(f,v,m,a){const g=v.split("."),n=g.pop();let d=f;for(let s=0;s<g.length;s++){const i=g[s];let r=d[i];switch(typeof r){case"undefined":r=d[i]=Object.create(null);break;case"object":break;default:a(`Ignoring ${v} as ${g.slice(0,s+1).join(".")} is ${JSON.stringify(r)}`);return}d=r}if(typeof d=="object"&&d!==null)try{d[n]=m}catch{a(`Ignoring ${v} as ${g.join(".")} is ${JSON.stringify(d)}`)}else a(`Ignoring ${v} as ${g.join(".")} is ${JSON.stringify(d)}`)}e.addToValueTree=L;function k(f,v){const m=v.split(".");S(f,m)}e.removeFromValueTree=k;function S(f,v){const m=v.shift();if(v.length===0){delete f[m];return}if(Object.keys(f).indexOf(m)!==-1){const a=f[m];typeof a=="object"&&!Array.isArray(a)&&(S(a,v),Object.keys(a).length===0&&delete f[m])}}function T(f,v,m){function a(d,s){let i=d;for(const r of s){if(typeof i!="object"||i===null)return;i=i[r]}return i}const g=v.split("."),n=a(f,g);return typeof n>"u"?m:n}e.getConfigurationValue=T;function E(f,v,m){Object.keys(v).forEach(a=>{a!=="__proto__"&&(a in f?l.isObject(f[a])&&l.isObject(v[a])?E(f[a],v[a],m):m&&(f[a]=v[a]):f[a]=v[a])})}e.merge=E;function p(f,v,m){const a=f.inspect(v),g=f.inspect(m);return typeof a.userValue<"u"||typeof a.workspaceValue<"u"||typeof a.workspaceFolderValue<"u"?a.value:typeof g.userValue<"u"||typeof g.workspaceValue<"u"||typeof g.workspaceFolderValue<"u"?g.value:a.defaultValue}e.getMigratedSettingValue=p;function w(f){return f.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=w}),define(De[52],Ie([1,0,11,8,3]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const P=new Map;P.set("false",!1),P.set("true",!0),P.set("isMac",l.isMacintosh),P.set("isLinux",l.isLinux),P.set("isWindows",l.isWindows),P.set("isWeb",l.isWeb),P.set("isMacNative",l.isMacintosh&&!l.isWeb),P.set("isEdge",l.isEdge),P.set("isFirefox",l.isFirefox),P.set("isChrome",l.isChrome),P.set("isSafari",l.isSafari);const _=Object.prototype.hasOwnProperty;var D;(function(U){U[U.False=0]="False",U[U.True=1]="True",U[U.Defined=2]="Defined",U[U.Not=3]="Not",U[U.Equals=4]="Equals",U[U.NotEquals=5]="NotEquals",U[U.And=6]="And",U[U.Regex=7]="Regex",U[U.NotRegex=8]="NotRegex",U[U.Or=9]="Or",U[U.In=10]="In",U[U.NotIn=11]="NotIn",U[U.Greater=12]="Greater",U[U.GreaterEquals=13]="GreaterEquals",U[U.Smaller=14]="Smaller",U[U.SmallerEquals=15]="SmallerEquals"})(D=e.ContextKeyExprType||(e.ContextKeyExprType={}));class b{static false(){return k.INSTANCE}static true(){return S.INSTANCE}static has(A){return T.create(A)}static equals(A,z){return E.create(A,z)}static notEquals(A,z){return f.create(A,z)}static regex(A,z){return s.create(A,z)}static in(A,z){return p.create(A,z)}static notIn(A,z){return w.create(A,z)}static not(A){return v.create(A)}static and(...A){return c.create(A,null)}static or(...A){return o.create(A,null,!0)}static greater(A,z){return a.create(A,z)}static greaterEquals(A,z){return g.create(A,z)}static smaller(A,z){return n.create(A,z)}static smallerEquals(A,z){return d.create(A,z)}static deserialize(A,z=!1){if(!!A)return this._deserializeOrExpression(A,z)}static _deserializeOrExpression(A,z){const $=A.split("||");return o.create($.map(N=>this._deserializeAndExpression(N,z)),null,!0)}static _deserializeAndExpression(A,z){const $=A.split("&&");return c.create($.map(N=>this._deserializeOne(N,z)),null)}static _deserializeOne(A,z){if(A=A.trim(),A.indexOf("!=")>=0){const $=A.split("!=");return f.create($[0].trim(),this._deserializeValue($[1],z))}if(A.indexOf("==")>=0){const $=A.split("==");return E.create($[0].trim(),this._deserializeValue($[1],z))}if(A.indexOf("=~")>=0){const $=A.split("=~");return s.create($[0].trim(),this._deserializeRegexValue($[1],z))}if(A.indexOf(" not in ")>=0){const $=A.split(" not in ");return w.create($[0].trim(),$[1].trim())}if(A.indexOf(" in ")>=0){const $=A.split(" in ");return p.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(A)){const $=A.split(">=");return g.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(A)){const $=A.split(">");return a.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(A)){const $=A.split("<=");return d.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(A)){const $=A.split("<");return n.create($[0].trim(),$[1].trim())}return/^\!\s*/.test(A)?v.create(A.substr(1).trim()):T.create(A)}static _deserializeValue(A,z){if(A=A.trim(),A==="true")return!0;if(A==="false")return!1;const $=/^'([^']*)'$/.exec(A);return $?$[1].trim():A}static _deserializeRegexValue(A,z){if((0,t.isFalsyOrWhitespace)(A)){if(z)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const $=A.indexOf("/"),N=A.lastIndexOf("/");if($===N||$<0){if(z)throw new Error(`bad regexp-value '${A}', missing /-enclosure`);return console.warn(`bad regexp-value '${A}', missing /-enclosure`),null}const K=A.slice($+1,N),B=A[N+1]==="i"?"i":"";try{return new RegExp(K,B)}catch(O){if(z)throw new Error(`bad regexp-value '${A}', parse error: ${O}`);return console.warn(`bad regexp-value '${A}', parse error: ${O}`),null}}}e.ContextKeyExpr=b;function I(U,A){const z=U?U.substituteConstants():void 0,$=A?A.substituteConstants():void 0;return!z&&!$?!0:!z||!$?!1:z.equals($)}e.expressionsAreEqualWithConstantSubstitution=I;function L(U,A){return U.cmp(A)}class k{constructor(){this.type=0}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!1}serialize(){return"false"}keys(){return[]}map(A){return this}negate(){return S.INSTANCE}}e.ContextKeyFalseExpr=k,k.INSTANCE=new k;class S{constructor(){this.type=1}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!0}serialize(){return"true"}keys(){return[]}map(A){return this}negate(){return k.INSTANCE}}e.ContextKeyTrueExpr=S,S.INSTANCE=new S;class T{constructor(A,z){this.key=A,this.negated=z,this.type=2}static create(A,z=null){const $=P.get(A);return typeof $=="boolean"?$?S.INSTANCE:k.INSTANCE:new T(A,z)}cmp(A){return A.type!==this.type?this.type-A.type:h(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=P.get(this.key);return typeof A=="boolean"?A?S.INSTANCE:k.INSTANCE:this}evaluate(A){return!!A.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(A){return A.mapDefined(this.key)}negate(){return this.negated||(this.negated=v.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=T;class E{constructor(A,z,$){this.key=A,this.value=z,this.negated=$,this.type=4}static create(A,z,$=null){if(typeof z=="boolean")return z?T.create(A,$):v.create(A,$);const N=P.get(A);return typeof N=="boolean"?z===(N?"true":"false")?S.INSTANCE:k.INSTANCE:new E(A,z,$)}cmp(A){return A.type!==this.type?this.type-A.type:y(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){const A=P.get(this.key);if(typeof A=="boolean"){const z=A?"true":"false";return this.value===z?S.INSTANCE:k.INSTANCE}return this}evaluate(A){return A.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(A){return A.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=E;class p{constructor(A,z){this.key=A,this.valueKey=z,this.type=10,this.negated=null}static create(A,z){return new p(A,z)}cmp(A){return A.type!==this.type?this.type-A.type:y(this.key,this.valueKey,A.key,A.valueKey)}equals(A){return A.type===this.type?this.key===A.key&&this.valueKey===A.valueKey:!1}substituteConstants(){return this}evaluate(A){const z=A.getValue(this.valueKey),$=A.getValue(this.key);return Array.isArray(z)?z.includes($):typeof $=="string"&&typeof z=="object"&&z!==null?_.call(z,$):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(A){return A.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=w.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=p;class w{constructor(A,z){this.key=A,this.valueKey=z,this.type=11,this._negated=p.create(A,z)}static create(A,z){return new w(A,z)}cmp(A){return A.type!==this.type?this.type-A.type:this._negated.cmp(A._negated)}equals(A){return A.type===this.type?this._negated.equals(A._negated):!1}substituteConstants(){return this}evaluate(A){return!this._negated.evaluate(A)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(A){return A.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=w;class f{constructor(A,z,$){this.key=A,this.value=z,this.negated=$,this.type=5}static create(A,z,$=null){if(typeof z=="boolean")return z?v.create(A,$):T.create(A,$);const N=P.get(A);return typeof N=="boolean"?z===(N?"true":"false")?k.INSTANCE:S.INSTANCE:new f(A,z,$)}cmp(A){return A.type!==this.type?this.type-A.type:y(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){const A=P.get(this.key);if(typeof A=="boolean"){const z=A?"true":"false";return this.value===z?k.INSTANCE:S.INSTANCE}return this}evaluate(A){return A.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(A){return A.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=E.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=f;class v{constructor(A,z){this.key=A,this.negated=z,this.type=3}static create(A,z=null){const $=P.get(A);return typeof $=="boolean"?$?k.INSTANCE:S.INSTANCE:new v(A,z)}cmp(A){return A.type!==this.type?this.type-A.type:h(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=P.get(this.key);return typeof A=="boolean"?A?k.INSTANCE:S.INSTANCE:this}evaluate(A){return!A.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(A){return A.mapNot(this.key)}negate(){return this.negated||(this.negated=T.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=v;function m(U,A){if(typeof U=="string"){const z=parseFloat(U);isNaN(z)||(U=z)}return typeof U=="string"||typeof U=="number"?A(U):k.INSTANCE}class a{constructor(A,z,$){this.key=A,this.value=z,this.negated=$,this.type=12}static create(A,z,$=null){return m(z,N=>new a(A,N,$))}cmp(A){return A.type!==this.type?this.type-A.type:y(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(A){return A.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=a;class g{constructor(A,z,$){this.key=A,this.value=z,this.negated=$,this.type=13}static create(A,z,$=null){return m(z,N=>new g(A,N,$))}cmp(A){return A.type!==this.type?this.type-A.type:y(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(A){return A.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=g;class n{constructor(A,z,$){this.key=A,this.value=z,this.negated=$,this.type=14}static create(A,z,$=null){return m(z,N=>new n(A,N,$))}cmp(A){return A.type!==this.type?this.type-A.type:y(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(A){return A.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=n;class d{constructor(A,z,$){this.key=A,this.value=z,this.negated=$,this.type=15}static create(A,z,$=null){return m(z,N=>new d(A,N,$))}cmp(A){return A.type!==this.type?this.type-A.type:y(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(A){return A.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=d;class s{constructor(A,z){this.key=A,this.regexp=z,this.type=7,this.negated=null}static create(A,z){return new s(A,z)}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.key<A.key)return-1;if(this.key>A.key)return 1;const z=this.regexp?this.regexp.source:"",$=A.regexp?A.regexp.source:"";return z<$?-1:z>$?1:0}equals(A){if(A.type===this.type){const z=this.regexp?this.regexp.source:"",$=A.regexp?A.regexp.source:"";return this.key===A.key&&z===$}return!1}substituteConstants(){return this}evaluate(A){const z=A.getValue(this.key);return this.regexp?this.regexp.test(z):!1}serialize(){const A=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${A}`}keys(){return[this.key]}map(A){return A.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=i.create(this)),this.negated}}e.ContextKeyRegexExpr=s;class i{constructor(A){this._actual=A,this.type=8}static create(A){return new i(A)}cmp(A){return A.type!==this.type?this.type-A.type:this._actual.cmp(A._actual)}equals(A){return A.type===this.type?this._actual.equals(A._actual):!1}substituteConstants(){return this}evaluate(A){return!this._actual.evaluate(A)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(A){return new i(this._actual.map(A))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;function r(U){let A=null;for(let z=0,$=U.length;z<$;z++){const N=U[z].substituteConstants();if(U[z]!==N&&A===null){A=[];for(let K=0;K<z;K++)A[K]=U[K]}A!==null&&(A[z]=N)}return A===null?U:A}class c{constructor(A,z){this.expr=A,this.negated=z,this.type=6}static create(A,z){return c._normalizeArr(A,z)}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let z=0,$=this.expr.length;z<$;z++){const N=L(this.expr[z],A.expr[z]);if(N!==0)return N}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let z=0,$=this.expr.length;z<$;z++)if(!this.expr[z].equals(A.expr[z]))return!1;return!0}return!1}substituteConstants(){const A=r(this.expr);return A===this.expr?this:c.create(A,this.negated)}evaluate(A){for(let z=0,$=this.expr.length;z<$;z++)if(!this.expr[z].evaluate(A))return!1;return!0}static _normalizeArr(A,z){const $=[];let N=!1;for(const K of A)if(!!K){if(K.type===1){N=!0;continue}if(K.type===0)return k.INSTANCE;if(K.type===6){$.push(...K.expr);continue}$.push(K)}if($.length===0&&N)return S.INSTANCE;if($.length!==0){if($.length===1)return $[0];$.sort(L);for(let K=1;K<$.length;K++)$[K-1].equals($[K])&&($.splice(K,1),K--);if($.length===1)return $[0];for(;$.length>1;){const K=$[$.length-1];if(K.type!==9)break;$.pop();const B=$.pop(),O=$.length===0,x=o.create(K.expr.map(V=>c.create([V,B],null)),null,O);x&&($.push(x),$.sort(L))}return $.length===1?$[0]:new c($,z)}}serialize(){return this.expr.map(A=>A.serialize()).join(" && ")}keys(){const A=[];for(const z of this.expr)A.push(...z.keys());return A}map(A){return new c(this.expr.map(z=>z.map(A)),null)}negate(){if(!this.negated){const A=[];for(const z of this.expr)A.push(z.negate());this.negated=o.create(A,this,!0)}return this.negated}}class o{constructor(A,z){this.expr=A,this.negated=z,this.type=9}static create(A,z,$){return o._normalizeArr(A,z,$)}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let z=0,$=this.expr.length;z<$;z++){const N=L(this.expr[z],A.expr[z]);if(N!==0)return N}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let z=0,$=this.expr.length;z<$;z++)if(!this.expr[z].equals(A.expr[z]))return!1;return!0}return!1}substituteConstants(){const A=r(this.expr);return A===this.expr?this:o.create(A,this.negated,!1)}evaluate(A){for(let z=0,$=this.expr.length;z<$;z++)if(this.expr[z].evaluate(A))return!0;return!1}static _normalizeArr(A,z,$){let N=[],K=!1;if(A){for(let B=0,O=A.length;B<O;B++){const x=A[B];if(!!x){if(x.type===0){K=!0;continue}if(x.type===1)return S.INSTANCE;if(x.type===9){N=N.concat(x.expr);continue}N.push(x)}}if(N.length===0&&K)return k.INSTANCE;N.sort(L)}if(N.length!==0){if(N.length===1)return N[0];for(let B=1;B<N.length;B++)N[B-1].equals(N[B])&&(N.splice(B,1),B--);if(N.length===1)return N[0];if($){for(let B=0;B<N.length;B++)for(let O=B+1;O<N.length;O++)R(N[B],N[O])&&(N.splice(O,1),O--);if(N.length===1)return N[0]}return new o(N,z)}}serialize(){return this.expr.map(A=>A.serialize()).join(" || ")}keys(){const A=[];for(const z of this.expr)A.push(...z.keys());return A}map(A){return new o(this.expr.map(z=>z.map(A)),null)}negate(){if(!this.negated){const A=[];for(const z of this.expr)A.push(z.negate());for(;A.length>1;){const z=A.shift(),$=A.shift(),N=[];for(const B of M(z))for(const O of M($))N.push(c.create([B,O],null));const K=A.length===0;A.unshift(o.create(N,null,K))}this.negated=A[0]}return this.negated}}class u extends T{constructor(A,z,$){super(A,null),this._defaultValue=z,typeof $=="object"?u._info.push({...$,key:A}):$!==!0&&u._info.push({key:A,description:$,type:z!=null?typeof z:void 0})}static all(){return u._info.values()}bindTo(A){return A.createKey(this.key,this._defaultValue)}getValue(A){return A.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(A){return E.create(this.key,A)}notEqualsTo(A){return f.create(this.key,A)}}e.RawContextKey=u,u._info=[],e.IContextKeyService=(0,C.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function h(U,A){return U<A?-1:U>A?1:0}function y(U,A,z,$){return U<z?-1:U>z?1:A<$?-1:A>$?1:0}function R(U,A){if(A.type===6&&U.type!==9&&U.type!==6){for(const N of A.expr)if(U.equals(N))return!0}const z=U.negate(),$=M(z).concat(M(A));$.sort(L);for(let N=0;N<$.length;N++){const B=$[N].negate();for(let O=N+1;O<$.length;O++){const x=$[O];if(B.equals(x))return!0}}return!1}e.implies=R;function M(U){return U.type===9?U.expr:[U]}}),define(De[189],Ie([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,l.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,l.refineServiceDecorator)(e.IEnvironmentService)}),define(De[84],Ie([1,0,163,3]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function C(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=C;function P(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=P;function _(f,v){switch(f){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=_;function D(f,v){return v==="web"&&!f.includes("web")}e.isNotWebExtensionInWebTargetPlatform=D;function b(f,v,m){return D(v,m)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===m?!0:I(m).includes(f)}e.isTargetPlatformCompatible=b;function I(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=I;function L(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=L;var k;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(k=e.SortBy||(e.SortBy={}));var S;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(S=e.SortOrder||(e.SortOrder={}));var T;(function(f){f.Install="install",f.Uninstall="uninstall"})(T=e.StatisticType||(e.StatisticType={}));var E;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(E=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var p;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatiblePreRelease="IncompatiblePreRelease",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Internal="Internal"})(p=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class w extends Error{constructor(v,m){super(v),this.code=m,this.name=m}}e.ExtensionManagementError=w,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,l.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,l.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(De[190],Ie([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,l.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,l.createDecorator)("externalTerminal")}),define(De[191],Ie([1,0,44,12,9,11,102,29,110,165,190]),function(J,e,l,t,C,P,_,D,b,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const k=I.localize(0,null);class S{async getDefaultTerminalForPlatforms(){return{windows:T.getDefaultTerminalWindows(),linux:await p.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class T extends S{openTerminal(a,g){return this.spawnTerminal(l,a,b.getWindowsShell(),g)}spawnTerminal(a,g,n,d){const s=g.windowsExec||T.getDefaultTerminalWindows();d&&d[1]===":"&&(d=d[0].toUpperCase()+d.substr(1));const i=C.basename(s).toLowerCase();if(i==="cmder"||i==="cmder.exe")return a.spawn(s,d?[d]:void 0),Promise.resolve(void 0);const r=["/c","start","/wait"];return s.indexOf(" ")>=0&&r.push('""'),r.push(s),(i==="wt"||i==="wt.exe")&&r.push("-d ."),new Promise((c,o)=>{const u=w(process),h=a.spawn(n,r,{cwd:d,env:u});h.on("error",o),h.on("exit",()=>c())})}runInTerminal(a,g,n,d,s){const i="windowsExec"in s&&s.windowsExec?s.windowsExec:T.getDefaultTerminalWindows();return new Promise((r,c)=>{const o=`"${g} - ${k}"`,u=`""${n.join('" "')}" & pause"`,h=["/c","start",o,"/wait",i,"/c",u],y=Object.assign({},w(process),d);Object.keys(y).filter(U=>y[U]===null).forEach(U=>delete y[U]);const R={cwd:g,env:y,windowsVerbatimArguments:!0};l.spawn(T.CMD,h,R).on("error",U=>{c(f(U))}),r(void 0)})}static getDefaultTerminalWindows(){if(!T._DEFAULT_TERMINAL_WINDOWS){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");T._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return T._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=T,T.CMD="cmd.exe";class E extends S{openTerminal(a,g){return this.spawnTerminal(l,a,g)}runInTerminal(a,g,n,d,s){const i=s.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((r,c)=>{if(i===L.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const o=i===L.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",h=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${o}.scpt`,J).fsPath,"-t",a||k,"-w",g];for(const M of n)h.push("-a"),h.push(M);if(d){const M=Object.assign({},w(process),d);for(const U in M){const A=M[U];A===null?(h.push("-u"),h.push(U)):(h.push("-e"),h.push(`${U}=${A}`))}}let y="";const R=l.spawn(E.OSASCRIPT,h);R.on("error",M=>{c(f(M))}),R.stderr.on("data",M=>{y+=M.toString()}),R.on("exit",M=>{if(M===0)r(void 0);else if(y){const U=y.split(`
`,1);c(new Error(U[0]))}else c(new Error(I.localize(1,null,o,M)))})}else c(new Error(I.localize(2,null,i)))})}spawnTerminal(a,g,n){const d=g.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((s,i)=>{const r=["-a",d];n&&r.push(n);const c=w(process),o=a.spawn("/usr/bin/open",r,{cwd:n,env:c});o.on("error",i),o.on("exit",()=>s())})}}e.MacExternalTerminalService=E,E.OSASCRIPT="/usr/bin/osascript";class p extends S{openTerminal(a,g){return this.spawnTerminal(l,a,g)}runInTerminal(a,g,n,d,s){const i=s.linuxExec?Promise.resolve(s.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((r,c)=>{const o=[];i.then(u=>{u.indexOf("gnome-terminal")>=0?o.push("-x"):o.push("-e"),o.push("bash"),o.push("-c");const h=`${v(n)}; echo; read -p "${p.WAIT_MESSAGE}" -n1;`;o.push(`''${h}''`);const y=Object.assign({},w(process),d);Object.keys(y).filter(A=>y[A]===null).forEach(A=>delete y[A]);const R={cwd:g,env:y};let M="";const U=l.spawn(u,o,R);U.on("error",A=>{c(f(A))}),U.stderr.on("data",A=>{M+=A.toString()}),U.on("exit",A=>{if(A===0)r(void 0);else if(M){const z=M.split(`
`,1);c(new Error(z[0]))}else c(new Error(I.localize(4,null,u,A)))})})})}static async getDefaultTerminalLinuxReady(){if(!p._DEFAULT_TERMINAL_LINUX_READY)if(!P.isLinux)p._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const a=await D.Promises.exists("/etc/debian_version");p._DEFAULT_TERMINAL_LINUX_READY=new Promise(g=>{a?g("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?g("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?g("konsole"):process.env.COLORTERM?g(process.env.COLORTERM):process.env.TERM?g(process.env.TERM):g("xterm")})}return p._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(a,g,n){const d=g.linuxExec?Promise.resolve(g.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((s,i)=>{d.then(r=>{const c=w(process),o=a.spawn(r,[],{cwd:n,env:c});o.on("error",i),o.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=p,p.WAIT_MESSAGE=I.localize(3,null);function w(m){const a={...m.env};return(0,_.sanitizeProcessEnvironment)(a),a}function f(m){return"errno"in m&&m.errno==="ENOENT"&&"path"in m&&typeof m.path=="string"?new Error(I.localize(5,null,m.path)):m}function v(m){let a="";for(const g of m)g.indexOf(" ")>=0?a+='"'+g+'"':a+=g,a+=" ";return a}}),define(De[42],Ie([1,0,25,9,8,14,2,166,3]),function(J,e,l,t,C,P,_,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,b.createDecorator)("fileService");function I(B){return B.create===!0}e.isFileOpenForWriteOptions=I;var L;(function(B){B[B.Unknown=0]="Unknown",B[B.File=1]="File",B[B.Directory=2]="Directory",B[B.SymbolicLink=64]="SymbolicLink"})(L=e.FileType||(e.FileType={}));var k;(function(B){B[B.Readonly=1]="Readonly"})(k=e.FilePermission||(e.FilePermission={}));var S;(function(B){B[B.FileReadWrite=2]="FileReadWrite",B[B.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",B[B.FileReadStream=16]="FileReadStream",B[B.FileFolderCopy=8]="FileFolderCopy",B[B.PathCaseSensitive=1024]="PathCaseSensitive",B[B.Readonly=2048]="Readonly",B[B.Trash=4096]="Trash",B[B.FileWriteUnlock=8192]="FileWriteUnlock",B[B.FileAtomicRead=16384]="FileAtomicRead",B[B.FileClone=32768]="FileClone"})(S=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function T(B){return!!(B.capabilities&2)}e.hasReadWriteCapability=T;function E(B){return!!(B.capabilities&8)}e.hasFileFolderCopyCapability=E;function p(B){return!!(B.capabilities&32768)}e.hasFileCloneCapability=p;function w(B){return!!(B.capabilities&4)}e.hasOpenReadWriteCloseCapability=w;function f(B){return!!(B.capabilities&16)}e.hasFileReadStreamCapability=f;function v(B){return T(B)?!!(B.capabilities&16384):!1}e.hasFileAtomicReadCapability=v;var m;(function(B){B.FileExists="EntryExists",B.FileNotFound="EntryNotFound",B.FileNotADirectory="EntryNotADirectory",B.FileIsADirectory="EntryIsADirectory",B.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",B.FileTooLarge="EntryTooLarge",B.FileWriteLocked="EntryWriteLocked",B.NoPermissions="NoPermissions",B.Unavailable="Unavailable",B.Unknown="Unknown"})(m=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class a extends Error{constructor(O,x){super(O),this.code=x}}e.FileSystemProviderError=a;function g(B,O){const x=new a(B.toString(),O);return d(x,O),x}e.createFileSystemProviderError=g;function n(B){return B||g((0,D.localize)(0,null),m.Unknown)}e.ensureFileSystemProviderError=n;function d(B,O){return B.name=O?`${O} (FileSystemError)`:"FileSystemError",B}e.markAsFileSystemProviderError=d;function s(B){if(!B)return m.Unknown;if(B instanceof a)return B.code;const O=/^(.+) \(FileSystemError\)$/.exec(B.name);if(!O)return m.Unknown;switch(O[1]){case m.FileExists:return m.FileExists;case m.FileIsADirectory:return m.FileIsADirectory;case m.FileNotADirectory:return m.FileNotADirectory;case m.FileNotFound:return m.FileNotFound;case m.FileExceedsMemoryLimit:return m.FileExceedsMemoryLimit;case m.FileTooLarge:return m.FileTooLarge;case m.FileWriteLocked:return m.FileWriteLocked;case m.NoPermissions:return m.NoPermissions;case m.Unavailable:return m.Unavailable}return m.Unknown}e.toFileSystemProviderErrorCode=s;function i(B){if(B instanceof y)return B.fileOperationResult;switch(s(B)){case m.FileNotFound:return 1;case m.FileIsADirectory:return 0;case m.FileNotADirectory:return 10;case m.FileWriteLocked:return 5;case m.NoPermissions:return 6;case m.FileExists:return 4;case m.FileExceedsMemoryLimit:return 9;case m.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=i;var r;(function(B){B[B.CREATE=0]="CREATE",B[B.DELETE=1]="DELETE",B[B.MOVE=2]="MOVE",B[B.COPY=3]="COPY",B[B.WRITE=4]="WRITE"})(r=e.FileOperation||(e.FileOperation={}));class c{constructor(O,x,V){this.resource=O,this.operation=x,this.target=V}isOperation(O){return this.operation===O}}e.FileOperationEvent=c;var o;(function(B){B[B.UPDATED=0]="UPDATED",B[B.ADDED=1]="ADDED",B[B.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class u{constructor(O,x){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=O;const V=new Map;for(const q of O){const Y=V.get(q.type);switch(Y?Y.push([q.resource,q]):V.set(q.type,[[q.resource,q]]),q.type){case 1:this.rawAdded.push(q.resource);break;case 0:this.rawUpdated.push(q.resource);break;case 2:this.rawDeleted.push(q.resource);break}}for(const[q,Y]of V)switch(q){case 1:this.added=l.TernarySearchTree.forUris(()=>x),this.added.fill(Y);break;case 0:this.updated=l.TernarySearchTree.forUris(()=>x),this.updated.fill(Y);break;case 2:this.deleted=l.TernarySearchTree.forUris(()=>x),this.deleted.fill(Y);break}}contains(O,...x){return this.doContains(O,{includeChildren:!1},...x)}affects(O,...x){return this.doContains(O,{includeChildren:!0},...x)}doContains(O,x,...V){if(!O)return!1;const q=V.length>0;return!!((!q||V.includes(1))&&(this.added?.get(O)||x.includeChildren&&this.added?.findSuperstr(O))||(!q||V.includes(0))&&(this.updated?.get(O)||x.includeChildren&&this.updated?.findSuperstr(O))||(!q||V.includes(2))&&(this.deleted?.findSubstr(O)||x.includeChildren&&this.deleted?.findSuperstr(O)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=u;function h(B,O,x){return!B||!O||B===O||O.length>B.length?!1:(O.charAt(O.length-1)!==t.sep&&(O+=t.sep),x?(0,C.startsWithIgnoreCase)(B,O):B.indexOf(O)===0)}e.isParent=h;class y extends Error{constructor(O,x,V){super(O),this.fileOperationResult=x,this.options=V}}e.FileOperationError=y;class R extends y{constructor(O,x,V){super(O,2,V),this.stat=x}}e.NotModifiedSinceFileOperationError=R;var M;(function(B){B[B.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",B[B.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",B[B.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",B[B.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",B[B.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",B[B.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",B[B.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",B[B.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",B[B.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",B[B.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",B[B.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",B[B.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(M=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var U;(function(B){B[B.FILE=0]="FILE",B[B.FOLDER=1]="FOLDER",B[B.ROOT_FOLDER=2]="ROOT_FOLDER"})(U=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function A(B){if(!(typeof B.size!="number"||typeof B.mtime!="number"))return B.mtime.toString(29)+B.size.toString(31)}e.etag=A;async function z(B,O){if(!O.hasProvider(_.URI.from({scheme:B.scheme})))return new Promise(x=>{const V=O.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===B.scheme&&q.added&&(V.dispose(),x())})})}e.whenProviderRegistered=z,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ${static formatSize(O){return(0,P.isNumber)(O)||(O=0),O<$.KB?(0,D.localize)(1,null,O.toFixed(0)):O<$.MB?(0,D.localize)(2,null,(O/$.KB).toFixed(2)):O<$.GB?(0,D.localize)(3,null,(O/$.MB).toFixed(2)):O<$.TB?(0,D.localize)(4,null,(O/$.GB).toFixed(2)):(0,D.localize)(5,null,(O/$.TB).toFixed(2))}}e.ByteSize=$,$.KB=1024,$.MB=$.KB*$.KB,$.GB=$.MB*$.KB,$.TB=$.GB*$.KB;var N;(function(B){B[B.IA32=0]="IA32",B[B.OTHER=1]="OTHER"})(N=e.Arch||(e.Arch={}));function K(B){return{maxFileSize:B===0?300*$.MB:16*$.GB,maxHeapSize:B===0?700*$.MB:2*700*$.MB}}e.getPlatformLimits=K}),define(De[85],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class l{constructor(...C){this._entries=new Map;for(const[P,_]of C)this.set(P,_)}set(C,P){const _=this._entries.get(C);return this._entries.set(C,P),_}has(C){return this._entries.has(C)}get(C){return this._entries.get(C)}}e.ServiceCollection=l}),define(De[192],Ie([1,0,18,10,116,188,3,85]),function(J,e,l,t,C,P,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const b=!1;class I extends Error{constructor(E){super("cyclic dependency between services"),this.message=E.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${E.toString()}`}}class L{constructor(E=new D.ServiceCollection,p=!1,w){this._activeInstantiations=new Set,this._services=E,this._strict=p,this._parent=w,this._services.set(_.IInstantiationService,this)}createChild(E){return new L(E,this._strict,this)}invokeFunction(E,...p){const w=S.traceInvocation(E);let f=!1;try{return E({get:m=>{if(f)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(m,w);if(!a)throw new Error(`[invokeFunction] unknown service '${m}'`);return a}},...p)}finally{f=!0,w.stop()}}createInstance(E,...p){let w,f;return E instanceof C.SyncDescriptor?(w=S.traceCreation(E.ctor),f=this._createInstance(E.ctor,E.staticArguments.concat(p),w)):(w=S.traceCreation(E),f=this._createInstance(E,p,w)),w.stop(),f}_createInstance(E,p=[],w){const f=_._util.getServiceDependencies(E).sort((a,g)=>a.index-g.index),v=[];for(const a of f){const g=this._getOrCreateServiceInstance(a.id,w);g||this._throwIfStrict(`[createInstance] ${E.name} depends on UNKNOWN service ${a.id}.`,!1),v.push(g)}const m=f.length>0?f[0].index:p.length;if(p.length!==m){console.trace(`[createInstance] First service dependency of ${E.name} at position ${m+1} conflicts with ${p.length} static arguments`);const a=m-p.length;a>0?p=p.concat(new Array(a)):p=p.slice(0,m)}return new E(...p,...v)}_setServiceInstance(E,p){if(this._services.get(E)instanceof C.SyncDescriptor)this._services.set(E,p);else if(this._parent)this._parent._setServiceInstance(E,p);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(E){const p=this._services.get(E);return!p&&this._parent?this._parent._getServiceInstanceOrDescriptor(E):p}_getOrCreateServiceInstance(E,p){const w=this._getServiceInstanceOrDescriptor(E);return w instanceof C.SyncDescriptor?this._safeCreateAndCacheServiceInstance(E,w,p.branch(E,!0)):(p.branch(E,!1),w)}_safeCreateAndCacheServiceInstance(E,p,w){if(this._activeInstantiations.has(E))throw new Error(`illegal state - RECURSIVELY instantiating service '${E}'`);this._activeInstantiations.add(E);try{return this._createAndCacheServiceInstance(E,p,w)}finally{this._activeInstantiations.delete(E)}}_createAndCacheServiceInstance(E,p,w){const f=new P.Graph(a=>a.id.toString());let v=0;const m=[{id:E,desc:p,_trace:w}];for(;m.length;){const a=m.pop();if(f.lookupOrInsertNode(a),v++>1e3)throw new I(f);for(const g of _._util.getServiceDependencies(a.desc.ctor)){const n=this._getServiceInstanceOrDescriptor(g.id);if(n||this._throwIfStrict(`[createInstance] ${E} depends on ${g.id} which is NOT registered.`,!0),n instanceof C.SyncDescriptor){const d={id:g.id,desc:n,_trace:a._trace.branch(g.id,!0)};f.insertEdge(a,d),m.push(d)}}}for(;;){const a=f.roots();if(a.length===0){if(!f.isEmpty())throw new I(f);break}for(const{data:g}of a){if(this._getServiceInstanceOrDescriptor(g.id)instanceof C.SyncDescriptor){const d=this._createServiceInstanceWithOwner(g.id,g.desc.ctor,g.desc.staticArguments,g.desc.supportsDelayedInstantiation,g._trace);this._setServiceInstance(g.id,d)}f.removeNode(g)}}return this._getServiceInstanceOrDescriptor(E)}_createServiceInstanceWithOwner(E,p,w=[],f,v){if(this._services.get(E)instanceof C.SyncDescriptor)return this._createServiceInstance(p,w,f,v);if(this._parent)return this._parent._createServiceInstanceWithOwner(E,p,w,f,v);throw new Error(`illegalState - creating UNKNOWN service instance ${p.name}`)}_createServiceInstance(E,p=[],w,f){if(w){const v=new l.IdleValue(()=>this._createInstance(E,p,f));return new Proxy(Object.create(null),{get(m,a){if(a in m)return m[a];const g=v.value;let n=g[a];return typeof n!="function"||(n=n.bind(g),m[a]=n),n},set(m,a,g){return v.value[a]=g,!0}})}else return this._createInstance(E,p,f)}_throwIfStrict(E,p){if(p&&console.warn(E),this._strict)throw new Error(E)}}e.InstantiationService=L;var k;(function(T){T[T.Creation=0]="Creation",T[T.Invocation=1]="Invocation",T[T.Branch=2]="Branch"})(k||(k={}));class S{constructor(E,p){this.type=E,this.name=p,this._start=Date.now(),this._dep=[]}static traceInvocation(E){return b?new S(1,E.name||E.toString().substring(0,42).replace(/\n/g,"")):S._None}static traceCreation(E){return b?new S(0,E.name):S._None}branch(E,p){const w=new S(2,E.toString());return this._dep.push([E,p,w]),w}stop(){const E=Date.now()-this._start;S._totals+=E;let p=!1;function w(v,m){const a=[],g=new Array(v+1).join("	");for(const[n,d,s]of m._dep)if(d&&s){p=!0,a.push(`${g}CREATES -> ${n}`);const i=w(v+1,s);i&&a.push(i)}else a.push(`${g}uses -> ${n}`);return a.join(`
`)}const f=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${E.toFixed(2)}ms (grand total ${S._totals.toFixed(2)}ms)`];(E>2||p)&&console.log(f.join(`
`))}}e.Trace=S,S._None=new class extends S{constructor(){super(-1,null)}stop(){}branch(){return this}},S._totals=0}),define(De[15],Ie([1,0,50,4,6,11,3]),function(J,e,l,t,C,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,_.createDecorator)("logService"),e.ILoggerService=(0,_.createDecorator)("loggerService");function D(){return new Date().toISOString()}var b;(function(d){d[d.Trace=0]="Trace",d[d.Debug=1]="Debug",d[d.Info=2]="Info",d[d.Warning=3]="Warning",d[d.Error=4]="Error",d[d.Critical=5]="Critical",d[d.Off=6]="Off"})(b=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=b.Info;function I(d,s,i){switch(s){case b.Trace:d.trace(i);break;case b.Debug:d.debug(i);break;case b.Info:d.info(i);break;case b.Warning:d.warn(i);break;case b.Error:d.error(i);break;case b.Critical:d.critical(i);break;default:throw new Error("Invalid log level")}}e.log=I;function L(d){let s="";for(let i=0;i<d.length;i++){let r=d[i];if(typeof r=="object")try{r=JSON.stringify(r)}catch{}s+=(i>0?" ":"")+r}return s}e.format=L;class k extends C.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(s){this.level!==s&&(this.level=s,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=k;class S extends k{constructor(s){super(),this.logAlways=s}checkLogLevel(s){return this.logAlways||this.getLevel()<=s}trace(s,...i){this.checkLogLevel(b.Trace)&&this.log(b.Trace,L([s,...i]))}debug(s,...i){this.checkLogLevel(b.Debug)&&this.log(b.Debug,L([s,...i]))}info(s,...i){this.checkLogLevel(b.Info)&&this.log(b.Info,L([s,...i]))}warn(s,...i){this.checkLogLevel(b.Warning)&&this.log(b.Warning,L([s,...i]))}error(s,...i){if(this.checkLogLevel(b.Error))if(s instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=s.stack,this.log(b.Error,L(r))}else this.log(b.Error,L([s,...i]))}critical(s,...i){this.checkLogLevel(b.Critical)&&this.log(b.Critical,L([s,...i]))}flush(){}}e.AbstractMessageLogger=S;class T extends k{constructor(s=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(s),this.useColors=!P.isWindows}trace(s,...i){this.getLevel()<=b.Trace&&(this.useColors?console.log(`\x1B[90m[main ${D()}]\x1B[0m`,s,...i):console.log(`[main ${D()}]`,s,...i))}debug(s,...i){this.getLevel()<=b.Debug&&(this.useColors?console.log(`\x1B[90m[main ${D()}]\x1B[0m`,s,...i):console.log(`[main ${D()}]`,s,...i))}info(s,...i){this.getLevel()<=b.Info&&(this.useColors?console.log(`\x1B[90m[main ${D()}]\x1B[0m`,s,...i):console.log(`[main ${D()}]`,s,...i))}warn(s,...i){this.getLevel()<=b.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${D()}]\x1B[0m`,s,...i):console.warn(`[main ${D()}]`,s,...i))}error(s,...i){this.getLevel()<=b.Error&&(this.useColors?console.error(`\x1B[91m[main ${D()}]\x1B[0m`,s,...i):console.error(`[main ${D()}]`,s,...i))}critical(s,...i){this.getLevel()<=b.Critical&&(this.useColors?console.error(`\x1B[90m[main ${D()}]\x1B[0m`,s,...i):console.error(`[main ${D()}]`,s,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=T;class E extends k{constructor(s=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(s)}trace(s,...i){this.getLevel()<=b.Trace&&console.log("%cTRACE","color: #888",s,...i)}debug(s,...i){this.getLevel()<=b.Debug&&console.log("%cDEBUG","background: #eee; color: #888",s,...i)}info(s,...i){this.getLevel()<=b.Info&&console.log("%c INFO","color: #33f",s,...i)}warn(s,...i){this.getLevel()<=b.Warning&&console.log("%c WARN","color: #993",s,...i)}error(s,...i){this.getLevel()<=b.Error&&console.log("%c  ERR","color: #f33",s,...i)}critical(s,...i){this.getLevel()<=b.Critical&&console.log("%cCRITI","background: #f33; color: white",s,...i)}dispose(){}flush(){}}e.ConsoleLogger=E;class p extends k{constructor(s,i=e.DEFAULT_LOG_LEVEL){super(),this.adapter=s,this.setLevel(i)}trace(s,...i){this.getLevel()<=b.Trace&&this.adapter.log(b.Trace,[this.extractMessage(s),...i])}debug(s,...i){this.getLevel()<=b.Debug&&this.adapter.log(b.Debug,[this.extractMessage(s),...i])}info(s,...i){this.getLevel()<=b.Info&&this.adapter.log(b.Info,[this.extractMessage(s),...i])}warn(s,...i){this.getLevel()<=b.Warning&&this.adapter.log(b.Warning,[this.extractMessage(s),...i])}error(s,...i){this.getLevel()<=b.Error&&this.adapter.log(b.Error,[this.extractMessage(s),...i])}critical(s,...i){this.getLevel()<=b.Critical&&this.adapter.log(b.Critical,[this.extractMessage(s),...i])}extractMessage(s){return typeof s=="string"?s:(0,l.toErrorMessage)(s,this.getLevel()<=b.Trace)}dispose(){}flush(){}}e.AdapterLogger=p;class w extends k{constructor(s){super(),this.logServices=s,s.length&&this.setLevel(s[0].getLevel())}setLevel(s){for(const i of this.logServices)i.setLevel(s);super.setLevel(s)}trace(s,...i){for(const r of this.logServices)r.trace(s,...i)}debug(s,...i){for(const r of this.logServices)r.debug(s,...i)}info(s,...i){for(const r of this.logServices)r.info(s,...i)}warn(s,...i){for(const r of this.logServices)r.warn(s,...i)}error(s,...i){for(const r of this.logServices)r.error(s,...i)}critical(s,...i){for(const r of this.logServices)r.critical(s,...i)}flush(){for(const s of this.logServices)s.flush()}dispose(){for(const s of this.logServices)s.dispose()}}e.MultiplexLogService=w;class f extends C.Disposable{constructor(s){super(),this.logger=s,this._register(s)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(s){this.logger.setLevel(s)}getLevel(){return this.logger.getLevel()}trace(s,...i){this.logger.trace(s,...i)}debug(s,...i){this.logger.debug(s,...i)}info(s,...i){this.logger.info(s,...i)}warn(s,...i){this.logger.warn(s,...i)}error(s,...i){this.logger.error(s,...i)}critical(s,...i){this.logger.critical(s,...i)}flush(){this.logger.flush()}}e.LogService=f;class v extends C.Disposable{constructor(s,i){super(),this.logLevel=s,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(c=>c.setLevel(r))}))}getLogger(s){return this.loggers.get(s.toString())}createLogger(s,i){let r=this.loggers.get(s.toString());return r||(r=this.doCreateLogger(s,i?.always?b.Trace:this.logLevel,i),this.loggers.set(s.toString(),r),i?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(s=>s.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=v;class m{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(s){}getLevel(){return b.Info}trace(s,...i){}debug(s,...i){}info(s,...i){}warn(s,...i){}error(s,...i){}critical(s,...i){}dispose(){}flush(){}}e.NullLogService=m;function a(d){if(d.verbose)return b.Trace;if(typeof d.logLevel=="string"){const s=g(d.logLevel.toLowerCase());if(s!==void 0)return s}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function g(d){switch(d){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Critical;case"off":return b.Off}}e.parseLogLevel=g;function n(d){switch(d){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Critical:return"critical";case b.Off:return"off"}}e.LogLevelToString=n}),define(De[193],Ie([1,0,42,15]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function C(D,b,I,L,k){try{const S=await new Promise((E,p)=>{J(["spdlog"],E,p)});S.setFlushOn(t.LogLevel.Trace);const T=await S.createAsyncRotatingLogger(D,b,I,L);return k&&T.clearFormatters(),T}catch(S){console.error(S)}return null}function P(D,b,I){switch(b){case t.LogLevel.Trace:D.trace(I);break;case t.LogLevel.Debug:D.debug(I);break;case t.LogLevel.Info:D.info(I);break;case t.LogLevel.Warning:D.warn(I);break;case t.LogLevel.Error:D.error(I);break;case t.LogLevel.Critical:D.critical(I);break;default:throw new Error("Invalid log level")}}class _ extends t.AbstractMessageLogger{constructor(b,I,L,k,S){super(),this.buffer=[],this.setLevel(S),this._loggerCreationPromise=this._createSpdLogLogger(b,I,L,k),this._register(this.onDidChangeLogLevel(T=>{this._logger?.setLevel(T)}))}async _createSpdLogLogger(b,I,L,k){const S=L?6:1,T=30/S*l.ByteSize.MB,E=await C(b,I,T,S,k);if(E){this._logger=E,this._logger.setLevel(this.getLevel());for(const{level:p,message:w}of this.buffer)P(this._logger,p,w);this.buffer=[]}}log(b,I){this._logger?P(this._logger,b,I):this.getLevel()<=b&&this.buffer.push({level:b,message:I})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=_}),define(De[117],Ie([1,0,41,167,3]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function(b){b[b.Unnecessary=1]="Unnecessary",b[b.Deprecated=2]="Deprecated"})(P=e.MarkerTag||(e.MarkerTag={}));var _;(function(b){b[b.Hint=1]="Hint",b[b.Info=2]="Info",b[b.Warning=4]="Warning",b[b.Error=8]="Error"})(_=e.MarkerSeverity||(e.MarkerSeverity={})),function(b){function I(E,p){return p-E}b.compare=I;const L=Object.create(null);L[b.Error]=(0,t.localize)(0,null),L[b.Warning]=(0,t.localize)(1,null),L[b.Info]=(0,t.localize)(2,null);function k(E){return L[E]||""}b.toString=k;function S(E){switch(E){case l.default.Error:return b.Error;case l.default.Warning:return b.Warning;case l.default.Info:return b.Info;case l.default.Ignore:return b.Hint}}b.fromSeverity=S;function T(E){switch(E){case b.Error:return l.default.Error;case b.Warning:return l.default.Warning;case b.Info:return l.default.Info;case b.Hint:return l.default.Ignore}}b.toSeverity=T}(_=e.MarkerSeverity||(e.MarkerSeverity={}));var D;(function(b){const I="";function L(S){return k(S,!0)}b.makeKey=L;function k(S,T){const E=[I];return S.source?E.push(S.source.replace("\xA6","\\\xA6")):E.push(I),S.code?typeof S.code=="string"?E.push(S.code.replace("\xA6","\\\xA6")):E.push(S.code.value.replace("\xA6","\\\xA6")):E.push(I),S.severity!==void 0&&S.severity!==null?E.push(_.toString(S.severity)):E.push(I),S.message&&T?E.push(S.message.replace("\xA6","\\\xA6")):E.push(I),S.startLineNumber!==void 0&&S.startLineNumber!==null?E.push(S.startLineNumber.toString()):E.push(I),S.startColumn!==void 0&&S.startColumn!==null?E.push(S.startColumn.toString()):E.push(I),S.endLineNumber!==void 0&&S.endLineNumber!==null?E.push(S.endLineNumber.toString()):E.push(I),S.endColumn!==void 0&&S.endColumn!==null?E.push(S.endColumn.toString()):E.push(I),E.push(I),E.join("\xA6")}b.makeKeyOptionalMessage=k})(D=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,C.createDecorator)("markerService")}),define(De[194],Ie([1,0,4,41,3]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,C.createDecorator)("notificationService");var P;(function(I){I[I.WORKSPACE=0]="WORKSPACE",I[I.PROFILE=1]="PROFILE",I[I.APPLICATION=2]="APPLICATION"})(P=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var _;(function(I){I[I.OFF=0]="OFF",I[I.SILENT=1]="SILENT",I[I.ERROR=2]="ERROR"})(_=e.NotificationsFilter||(e.NotificationsFilter={}));class D{constructor(){this.progress=new b,this.onDidClose=l.Event.None,this.onDidChangeVisibility=l.Event.None}updateSeverity(L){}updateMessage(L){}updateActions(L){}close(){}}e.NoOpNotification=D;class b{infinite(){}done(){}total(L){}worked(L){}}e.NoOpProgress=b}),define(De[118],Ie([1,0,6,8,2,3]),function(J,e,l,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,P.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return l.Disposable.None},registerValidator(){return l.Disposable.None},registerExternalUriResolver(){return l.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return l.Disposable.None},async open(){return!1},async resolveExternalUri(L){return{resolved:L,dispose(){}}}});function _(L,k){return C.URI.isUri(L)?(0,t.equalsIgnoreCase)(L.scheme,k):(0,t.startsWithIgnoreCase)(L,k+":")}e.matchesScheme=_;function D(L,...k){return k.some(S=>_(L,S))}e.matchesSomeScheme=D;function b(L,k){return L.with({fragment:`${k.startLineNumber},${k.startColumn}${k.endLineNumber?`-${k.endLineNumber}${k.endColumn?`,${k.endColumn}`:""}`:""}`})}e.withSelection=b;function I(L){let k;const S=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(L.fragment);return S&&(k={startLineNumber:parseInt(S[1]),startColumn:S[2]?parseInt(S[2]):1,endLineNumber:S[4]?parseInt(S[4]):void 0,endColumn:S[4]?S[5]?parseInt(S[5]):1:void 0},L=L.with({fragment:""})),{selection:k,uri:L}}e.extractSelection=I}),define(De[195],Ie([1,0,12,11,40,22]),function(J,e,l,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let _;if(typeof t.globals.vscode<"u"&&typeof t.globals.vscode.context<"u"){const D=t.globals.vscode.context.configuration();if(D)_=D.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof J?.__$__nodeRequire=="function"){const D=(0,P.dirname)(l.FileAccess.asFileUri("",J));_=J.__$__nodeRequire((0,P.joinPath)(D,"product.json").fsPath);const b=J.__$__nodeRequire((0,P.joinPath)(D,"package.json").fsPath);C.env.VSCODE_DEV&&Object.assign(_,{nameShort:`${_.nameShort} Dev`,nameLong:`${_.nameLong} Dev`,dataFolderName:`${_.dataFolderName}-dev`,serverDataFolderName:_.serverDataFolderName?`${_.serverDataFolderName}-dev`:void 0}),Object.assign(_,{version:b.version})}else _={},Object.keys(_).length===0&&Object.assign(_,{version:"1.67.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=_}),define(De[196],Ie([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,l.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var xe=this&&this.__param||function(J,e){return function(l,t){e(l,t,J)}};define(De[119],Ie([1,0,18,21,6,3]),function(J,e,l,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,P.createDecorator)("progressService");var _;(function(L){L[L.Explorer=1]="Explorer",L[L.Scm=3]="Scm",L[L.Extensions=5]="Extensions",L[L.Window=10]="Window",L[L.Notification=15]="Notification",L[L.Dialog=20]="Dialog"})(_=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class D{constructor(k){this.callback=k}get value(){return this._value}report(k){this._value=k,this.callback(this._value)}}e.Progress=D,D.None=Object.freeze({report(){}});let b=class extends C.Disposable{constructor(k,S){super(),this.deferred=new l.DeferredPromise,S.withProgress(k,T=>(this.reporter=T,this.lastStep&&T.report(this.lastStep),this.deferred.p)),this._register((0,C.toDisposable)(()=>this.deferred.complete()))}report(k){this.reporter?this.reporter.report(k):this.lastStep=k}};b=qe([xe(1,e.IProgressService)],b),e.UnmanagedProgress=b;class I extends C.Disposable{constructor(k){super(),this.progressIndicator=k,this.currentOperationId=0,this.currentOperationDisposables=this._register(new C.DisposableStore)}start(k){this.stop();const S=++this.currentOperationId,T=new t.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{S===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},k),this.currentOperationDisposables.add((0,C.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,C.toDisposable)(()=>T.cancel())),this.currentOperationDisposables.add((0,C.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:S,token:T.token,stop:()=>this.doStop(S),isCurrent:()=>this.currentOperationId===S}}stop(){this.doStop(this.currentOperationId)}doStop(k){this.currentOperationId===k&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=I,e.IEditorProgressService=(0,P.createDecorator)("editorProgressService")}),define(De[43],Ie([1,0,48,14]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class C{constructor(){this.data=new Map}add(_,D){l.ok(t.isString(_)),l.ok(t.isObject(D)),l.ok(!this.data.has(_),"There is already an extension with this id"),this.data.set(_,D)}knows(_){return this.data.has(_)}as(_){return this.data.get(_)||null}}e.Registry=new C}),define(De[120],Ie([1,0,4,43]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function C(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class P{constructor(){this._onDidChangeSchema=new l.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(b,I){this.schemasById[C(b)]=I,this._onDidChangeSchema.fire(b)}notifySchemaChanged(b){this._onDidChangeSchema.fire(b)}getSchemaContributions(){return{schemas:this.schemasById}}}const _=new P;t.Registry.add(e.Extensions.JSONContribution,_)}),define(De[121],Ie([1,0,17,4,14,162,83,120,43]),function(J,e,l,t,C,P,_,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var I;(function(g){g.Multiline="multilineText",g.Singleline="singlelineText"})(I=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var L;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.MACHINE=2]="MACHINE",g[g.WINDOW=3]="WINDOW",g[g.RESOURCE=4]="RESOURCE",g[g.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",g[g.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const k=b.Registry.as(D.Extensions.JSONContribution);class S{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:P.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(n,d=!0){this.registerConfigurations([n],d)}registerConfigurations(n,d=!0){const s=this.doRegisterConfigurations(n,d);k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}deregisterConfigurations(n){const d=this.doDeregisterConfigurations(n);k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d})}updateConfigurations({add:n,remove:d}){const s=[];s.push(...this.doDeregisterConfigurations(d)),s.push(...this.doRegisterConfigurations(n,!1)),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,l.distinct)(s)})}registerDefaultConfigurations(n){const d=[],s=[];for(const{overrides:i,source:r}of n)for(const c in i)if(d.push(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){const o=this.configurationDefaultsOverrides.get(c),u=o?.valuesSources??new Map;if(r)for(const M of Object.keys(i[c]))u.set(M,r);const h={...o?.value||{},...i[c]};this.configurationDefaultsOverrides.set(c,{source:r,value:h,valuesSources:u});const y=(0,_.getLanguageTagSettingPlainKey)(c),R={type:"object",default:h,description:P.localize(1,null,y),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:h,source:C.isString(r)?void 0:r,defaultValueSource:r};s.push(...p(c)),this.configurationProperties[c]=R,this.defaultLanguageConfigurationOverridesNode.properties[c]=R}else{this.configurationDefaultsOverrides.set(c,{value:i[c],source:r});const o=this.configurationProperties[c];o&&(this.updatePropertyDefaultValue(c,o),this.updateSchema(c,o))}this.registerOverrideIdentifiers(s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d,defaultsOverrides:!0})}deregisterDefaultConfigurations(n){const d=[];for(const{overrides:s,source:i}of n)for(const r in s){const c=this.configurationDefaultsOverrides.get(r),o=C.isString(i)?i:i?.id,u=C.isString(c?.source)?c?.source:c?.source?.id;if(o===u)if(d.push(r),this.configurationDefaultsOverrides.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.configurationProperties[r],delete this.defaultLanguageConfigurationOverridesNode.properties[r];else{const h=this.configurationProperties[r];h&&(this.updatePropertyDefaultValue(r,h),this.updateSchema(r,h))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...n){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(n){for(const d of n)this.overrideIdentifiers.add(d);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(n,d){const s=[];return n.forEach(i=>{s.push(...this.validateAndRegisterProperties(i,d,i.extensionInfo,i.restrictedProperties)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),s}doDeregisterConfigurations(n){const d=[],s=i=>{if(i.properties)for(const r in i.properties){d.push(r);const c=this.configurationProperties[r];c?.policy?.name&&this.policyConfigurations.delete(c.policy.name),delete this.configurationProperties[r],this.removeFromSchema(r,i.properties[r])}i.allOf?.forEach(r=>s(r))};for(const i of n){s(i);const r=this.configurationContributors.indexOf(i);r!==-1&&this.configurationContributors.splice(r,1)}return d}validateAndRegisterProperties(n,d=!0,s,i,r=3){r=C.isUndefinedOrNull(n.scope)?r:n.scope;const c=[],o=n.properties;if(o)for(const h in o){const y=o[h];if(d&&m(h,y)){delete o[h];continue}if(y.source=s,y.defaultDefaultValue=o[h].default,this.updatePropertyDefaultValue(h,y),e.OVERRIDE_PROPERTY_REGEX.test(h)?y.scope=void 0:(y.scope=C.isUndefinedOrNull(y.scope)?r:y.scope,y.restricted=C.isUndefinedOrNull(y.restricted)?!!i?.includes(h):y.restricted),o[h].hasOwnProperty("included")&&!o[h].included){this.excludedConfigurationProperties[h]=o[h],delete o[h];continue}else this.configurationProperties[h]=o[h],o[h].policy?.name&&this.policyConfigurations.set(o[h].policy.name,h);!o[h].deprecationMessage&&o[h].markdownDeprecationMessage&&(o[h].deprecationMessage=o[h].markdownDeprecationMessage),c.push(h)}const u=n.allOf;if(u)for(const h of u)c.push(...this.validateAndRegisterProperties(h,d,s,i,r));return c}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(n){const d=s=>{const i=s.properties;if(i)for(const c in i)this.updateSchema(c,i[c]);s.allOf?.forEach(d)};d(n)}updateSchema(n,d){switch(e.allSettings.properties[n]=d,d.scope){case 1:e.applicationSettings.properties[n]=d;break;case 2:e.machineSettings.properties[n]=d;break;case 6:e.machineOverridableSettings.properties[n]=d;break;case 3:e.windowSettings.properties[n]=d;break;case 4:e.resourceSettings.properties[n]=d;break;case 5:e.resourceSettings.properties[n]=d,this.resourceLanguageSettingsSchema.properties[n]=d;break}}removeFromSchema(n,d){switch(delete e.allSettings.properties[n],d.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.resourceLanguageSettingsSchema.properties[n];break}}updateOverridePropertyPatternKey(){for(const n of this.overrideIdentifiers.values()){const d=`[${n}]`,s={type:"object",description:P.localize(2,null),errorMessage:P.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(d,s),e.allSettings.properties[d]=s,e.applicationSettings.properties[d]=s,e.machineSettings.properties[d]=s,e.machineOverridableSettings.properties[d]=s,e.windowSettings.properties[d]=s,e.resourceSettings.properties[d]=s}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const n={type:"object",description:P.localize(4,null),errorMessage:P.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(n,d){const s=this.configurationDefaultsOverrides.get(n);let i=s?.value,r=s?.source;C.isUndefined(i)&&(i=d.defaultDefaultValue,r=void 0),C.isUndefined(i)&&(i=f(d.type)),d.default=i,d.defaultValueSource=r}}const T="\\[([^\\]]+)\\]",E=new RegExp(T,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${T})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function p(g){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(g)){let d=E.exec(g);for(;d?.length;){const s=d[1].trim();s&&n.push(s),d=E.exec(g)}}return(0,l.distinct)(n)}e.overrideIdentifiersFromKey=p;function w(g){return g.reduce((n,d)=>`${n}[${d}]`,"")}e.keyFromOverrideIdentifiers=w;function f(g){switch(Array.isArray(g)?g[0]:g){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const v=new S;b.Registry.add(e.Extensions.Configuration,v);function m(g,n){return g.trim()?e.OVERRIDE_PROPERTY_REGEX.test(g)?P.localize(7,null,g):v.getConfigurationProperties()[g]!==void 0?P.localize(8,null,g):n.policy?.name&&v.getPolicyConfigurations().get(n.policy?.name)!==void 0?P.localize(9,null,g,n.policy?.name,v.getPolicyConfigurations().get(n.policy?.name)):null:P.localize(6,null)}e.validateProperty=m;function a(){const g=[],n=v.getConfigurationProperties();for(const d of Object.keys(n))g.push([d,n[d].scope]);return g.push(["launch",4]),g.push(["task",4]),g}e.getScopes=a}),define(De[197],Ie([1,0,17,4,143,6,25,24,14,2,83,121,43]),function(J,e,l,t,C,P,_,D,b,I,L,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class T{constructor(n={},d=[],s=[]){this._contents=n,this._keys=d,this._overrides=s,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(n){return n?(0,L.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,d){const s=this.getContentsForOverrideIdentifer(d);return s?n?(0,L.getConfigurationValue)(s,n):s:void 0}getKeysForOverrideIdentifier(n){const d=[];for(const s of this.overrides)s.identifiers.includes(n)&&d.push(...s.keys);return l.distinct(d)}getAllOverrideIdentifiers(){const n=[];for(const d of this.overrides)n.push(...d.identifiers);return l.distinct(n)}override(n){let d=this.overrideConfigurations.get(n);return d||(d=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,d)),d}merge(...n){const d=D.deepClone(this.contents),s=D.deepClone(this.overrides),i=[...this.keys];for(const r of n)if(!r.isEmpty()){this.mergeContents(d,r.contents);for(const c of r.overrides){const[o]=s.filter(u=>l.equals(u.identifiers,c.identifiers));o?(this.mergeContents(o.contents,c.contents),o.keys.push(...c.keys),o.keys=l.distinct(o.keys)):s.push(D.deepClone(c))}for(const c of r.keys)i.indexOf(c)===-1&&i.push(c)}return new T(d,i,s)}freeze(){return this.frozen=!0,this}clone(){return new T(D.deepClone(this.contents),[...this.keys],D.deepClone(this.overrides))}createOverrideConfigurationModel(n){const d=this.getContentsForOverrideIdentifer(n);if(!d||typeof d!="object"||!Object.keys(d).length)return this;const s={};for(const i of l.distinct([...Object.keys(this.contents),...Object.keys(d)])){let r=this.contents[i];const c=d[i];c&&(typeof r=="object"&&typeof c=="object"?(r=D.deepClone(r),this.mergeContents(r,c)):r=c),s[i]=r}return new T(s,this.keys,this.overrides)}mergeContents(n,d){for(const s of Object.keys(d)){if(s in n&&b.isObject(n[s])&&b.isObject(d[s])){this.mergeContents(n[s],d[s]);continue}n[s]=D.deepClone(d[s])}}checkAndFreeze(n){return this.frozen&&!Object.isFrozen(n)?D.deepFreeze(n):n}getContentsForOverrideIdentifer(n){let d=null,s=null;const i=r=>{r&&(s?this.mergeContents(s,r):s=D.deepClone(r))};for(const r of this.overrides)l.equals(r.identifiers,[n])?d=r.contents:r.identifiers.includes(n)&&i(r.contents);return i(d),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,d){this.addKey(n),(0,L.addToValueTree)(this.contents,n,d,s=>{throw new Error(s)})}removeValue(n){this.removeKey(n)&&(0,L.removeFromValueTree)(this.contents,n)}addKey(n){let d=this.keys.length;for(let s=0;s<d;s++)n.indexOf(this.keys[s])===0&&(d=s);this.keys.splice(d,1,n)}removeKey(n){const d=this.keys.indexOf(n);return d!==-1?(this.keys.splice(d,1),!0):!1}}e.ConfigurationModel=T;class E{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new T}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,d){if(!b.isUndefinedOrNull(n)){const s=this.doParseContent(n);this.parseRaw(s,d)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,d){this._raw=n;const{contents:s,keys:i,overrides:r,restricted:c}=this.doParseRaw(n,d);this._configurationModel=new T(s,i,r),this._restrictedConfigurations=c||[]}doParseContent(n){let d={},s=null,i=[];const r=[],c=[];function o(h){Array.isArray(i)?i.push(h):s!==null&&(i[s]=h)}const u={onObjectBegin:()=>{const h={};o(h),r.push(i),i=h,s=null},onObjectProperty:h=>{s=h},onObjectEnd:()=>{i=r.pop()},onArrayBegin:()=>{const h=[];o(h),r.push(i),i=h,s=null},onArrayEnd:()=>{i=r.pop()},onLiteralValue:o,onError:(h,y,R)=>{c.push({error:h,offset:y,length:R})}};if(n)try{C.visit(n,u),d=i[0]||{}}catch(h){console.error(`Error while parsing settings file ${this._name}: ${h}`),this._parseErrors=[h]}return d}doParseRaw(n,d){const s=S.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),i=this.filter(n,s,!0,d);n=i.raw;const r=(0,L.toValuesTree)(n,u=>console.error(`Conflict in settings file ${this._name}: ${u}`)),c=Object.keys(n),o=this.toOverrides(n,u=>console.error(`Conflict in settings file ${this._name}: ${u}`));return{contents:r,keys:c,overrides:o,restricted:i.restricted}}filter(n,d,s,i){if(!i?.scopes&&!i?.skipRestricted)return{raw:n,restricted:[]};const r={},c=[];for(const o in n)if(k.OVERRIDE_PROPERTY_REGEX.test(o)&&s){const u=this.filter(n[o],d,!1,i);r[o]=u.raw,c.push(...u.restricted)}else{const u=d[o],h=u?typeof u.scope<"u"?u.scope:3:void 0;u?.restricted&&c.push(o),(h===void 0||i.scopes===void 0||i.scopes.includes(h))&&(i.skipRestricted&&u?.restricted||(r[o]=n[o]))}return{raw:r,restricted:c}}toOverrides(n,d){const s=[];for(const i of Object.keys(n))if(k.OVERRIDE_PROPERTY_REGEX.test(i)){const r={};for(const c in n[i])r[c]=n[i][c];s.push({identifiers:(0,k.overrideIdentifiersFromKey)(i),keys:Object.keys(r),contents:(0,L.toValuesTree)(r,d)})}return s}}e.ConfigurationModelParser=E;class p extends P.Disposable{constructor(n,d,s,i){super(),this.userSettingsResource=n,this.scopes=d,this.fileService=i,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new E(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,r=>r.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,r=>(r.isOperation(0)||r.isOperation(3)||r.isOperation(1)||r.isOperation(4))&&s.isEqual(r.resource,n)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new T}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=p;class w{constructor(n,d,s,i,r=new T,c=new T,o=new _.ResourceMap,u=new T,h=new _.ResourceMap,y=!0){this._defaultConfiguration=n,this._policyConfiguration=d,this._applicationConfiguration=s,this._localUserConfiguration=i,this._remoteUserConfiguration=r,this._workspaceConfiguration=c,this._folderConfigurations=o,this._memoryConfiguration=u,this._memoryConfigurationByResource=h,this._freeze=y,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new _.ResourceMap,this._userConfiguration=null}getValue(n,d,s){return this.getConsolidatedConfigurationModel(n,d,s).getValue(n)}updateValue(n,d,s={}){let i;s.resource?(i=this._memoryConfigurationByResource.get(s.resource),i||(i=new T,this._memoryConfigurationByResource.set(s.resource,i))):i=this._memoryConfiguration,d===void 0?i.removeValue(n):i.setValue(n,d),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,d,s){const i=this.getConsolidatedConfigurationModel(n,d,s),r=this.getFolderConfigurationModelForResource(d.resource,s),c=d.resource?this._memoryConfigurationByResource.get(d.resource)||this._memoryConfiguration:this._memoryConfiguration,o=d.overrideIdentifier?this._defaultConfiguration.freeze().override(d.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),u=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(n),h=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(n),y=d.overrideIdentifier?this.userConfiguration.freeze().override(d.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),R=d.overrideIdentifier?this.localUserConfiguration.freeze().override(d.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),M=d.overrideIdentifier?this.remoteUserConfiguration.freeze().override(d.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),U=s?d.overrideIdentifier?this._workspaceConfiguration.freeze().override(d.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,A=r?d.overrideIdentifier?r.freeze().override(d.overrideIdentifier).getValue(n):r.freeze().getValue(n):void 0,z=d.overrideIdentifier?c.override(d.overrideIdentifier).getValue(n):c.getValue(n),$=i.getValue(n),N=l.distinct(i.overrides.map(K=>K.identifiers).flat()).filter(K=>i.getOverrideValue(n,K)!==void 0);return{defaultValue:o,policyValue:u,applicationValue:h,userValue:y,userLocalValue:R,userRemoteValue:M,workspaceValue:U,workspaceFolderValue:A,memoryValue:z,value:$,default:o!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:d.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,d.overrideIdentifier):void 0}:void 0,policy:u!==void 0?{value:u}:void 0,application:h!==void 0?{value:h,override:d.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(n,d.overrideIdentifier):void 0}:void 0,user:y!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:d.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,d.overrideIdentifier):void 0}:void 0,userLocal:R!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:d.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,d.overrideIdentifier):void 0}:void 0,userRemote:M!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:d.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,d.overrideIdentifier):void 0}:void 0,workspace:U!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:d.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,d.overrideIdentifier):void 0}:void 0,workspaceFolder:A!==void 0?{value:r?.freeze().getValue(n),override:d.overrideIdentifier?r?.freeze().getOverrideValue(n,d.overrideIdentifier):void 0}:void 0,memory:z!==void 0?{value:c.getValue(n),override:d.overrideIdentifier?c.getOverrideValue(n,d.overrideIdentifier):void 0}:void 0,overrideIdentifiers:N.length?N:void 0}}keys(n){const d=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:d?d.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(n){this._policyConfiguration=n}updateApplicationConfiguration(n){this._applicationConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,d){this._folderConfigurations.set(n,d),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,d){const s=[];if(!d){const{added:i,updated:r,removed:c}=m(this._defaultConfiguration,n);d=[...i,...r,...c]}for(const i of d)for(const r of(0,k.overrideIdentifiersFromKey)(i)){const c=this._defaultConfiguration.getKeysForOverrideIdentifier(r),o=n.getKeysForOverrideIdentifier(r),u=[...o.filter(h=>c.indexOf(h)===-1),...c.filter(h=>o.indexOf(h)===-1),...c.filter(h=>!D.equals(this._defaultConfiguration.override(r).getValue(h),n.override(r).getValue(h)))];s.push([r,u])}return this.updateDefaultConfiguration(n),{keys:d,overrides:s}}compareAndUpdatePolicyConfiguration(n){const{added:d,updated:s,removed:i}=m(this._policyConfiguration,n),r=[...d,...s,...i];return r.length&&this.updatePolicyConfiguration(n),{keys:r,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:d,updated:s,removed:i,overrides:r}=m(this.applicationConfiguration,n),c=[...d,...s,...i];return c.length&&this.updateApplicationConfiguration(n),{keys:c,overrides:r}}compareAndUpdateLocalUserConfiguration(n){const{added:d,updated:s,removed:i,overrides:r}=m(this.localUserConfiguration,n),c=[...d,...s,...i];return c.length&&this.updateLocalUserConfiguration(n),{keys:c,overrides:r}}compareAndUpdateRemoteUserConfiguration(n){const{added:d,updated:s,removed:i,overrides:r}=m(this.remoteUserConfiguration,n),c=[...d,...s,...i];return c.length&&this.updateRemoteUserConfiguration(n),{keys:c,overrides:r}}compareAndUpdateWorkspaceConfiguration(n){const{added:d,updated:s,removed:i,overrides:r}=m(this.workspaceConfiguration,n),c=[...d,...s,...i];return c.length&&this.updateWorkspaceConfiguration(n),{keys:c,overrides:r}}compareAndUpdateFolderConfiguration(n,d){const s=this.folderConfigurations.get(n),{added:i,updated:r,removed:c,overrides:o}=m(s,d),u=[...i,...r,...c];return(u.length||!s)&&this.updateFolderConfiguration(n,d),{keys:u,overrides:o}}compareAndDeleteFolderConfiguration(n){const d=this.folderConfigurations.get(n);if(!d)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:s,updated:i,removed:r,overrides:c}=m(d,void 0);return{keys:[...s,...i,...r],overrides:c}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(n,d,s){let i=this.getConsolidatedConfigurationModelForResource(d,s);return d.overrideIdentifier&&(i=i.override(d.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(n)!==void 0&&(i=i.merge(this._policyConfiguration)),i}getConsolidatedConfigurationModelForResource({resource:n},d){let s=this.getWorkspaceConsolidatedConfiguration();if(d&&n){const i=d.getFolder(n);i&&(s=this.getFolderConsolidatedConfiguration(i.uri)||s);const r=this._memoryConfigurationByResource.get(n);r&&(s=s.merge(r))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let d=this._foldersConsolidatedConfigurations.get(n);if(!d){const s=this.getWorkspaceConsolidatedConfiguration(),i=this._folderConfigurations.get(n);i?(d=s.merge(i),this._freeze&&(d=d.freeze()),this._foldersConsolidatedConfigurations.set(n,d)):d=s}return d}getFolderConfigurationModelForResource(n,d){if(d&&n){const s=d.getFolder(n);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,d)=>{const{contents:s,overrides:i,keys:r}=this._folderConfigurations.get(d);return n.push([d,{contents:s,overrides:i,keys:r}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(d=>n.add(d)),this.userConfiguration.freeze().keys.forEach(d=>n.add(d)),this._workspaceConfiguration.freeze().keys.forEach(d=>n.add(d)),this._folderConfigurations.forEach(d=>d.freeze().keys.forEach(s=>n.add(s))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(d=>n.add(d)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(d=>n.add(d)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(d=>n.add(d)),this._folderConfigurations.forEach(d=>d.freeze().getAllOverrideIdentifiers().forEach(s=>n.add(s))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const d=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>d.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>d.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>d.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(n).forEach(i=>d.add(i))),[...d.values()]}static parse(n){const d=this.parseConfigurationModel(n.defaults),s=this.parseConfigurationModel(n.policy),i=this.parseConfigurationModel(n.application),r=this.parseConfigurationModel(n.user),c=this.parseConfigurationModel(n.workspace),o=n.folders.reduce((u,h)=>(u.set(I.URI.revive(h[0]),this.parseConfigurationModel(h[1])),u),new _.ResourceMap);return new w(d,s,i,r,new T,c,o,new T,new _.ResourceMap,!1)}static parseConfigurationModel(n){return new T(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=w;function f(...g){if(g.length===0)return{keys:[],overrides:[]};if(g.length===1)return g[0];const n=new Set,d=new Map;for(const i of g)i.keys.forEach(r=>n.add(r)),i.overrides.forEach(([r,c])=>{const o=(0,_.getOrSet)(d,r,new Set);c.forEach(u=>o.add(u))});const s=[];return d.forEach((i,r)=>s.push([r,[...i.values()]])),{keys:[...n.values()],overrides:s}}e.mergeChanges=f;class v{constructor(n,d,s,i){this.change=n,this.previous=d,this.currentConfiguraiton=s,this.currentWorkspace=i,this._previousConfiguration=void 0;const r=new Set;n.keys.forEach(o=>r.add(o)),n.overrides.forEach(([,o])=>o.forEach(u=>r.add(u))),this.affectedKeys=[...r.values()];const c=new T;this.affectedKeys.forEach(o=>c.setValue(o,{})),this.affectedKeysTree=c.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,d){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(d){const s=this.previousConfiguration?this.previousConfiguration.getValue(n,d,this.previous?.workspace):void 0,i=this.currentConfiguraiton.getValue(n,d,this.currentWorkspace);return!D.equals(s,i)}return!0}return!1}doesAffectedKeysTreeContains(n,d){let s=(0,L.toValuesTree)({[d]:!0},()=>{}),i;for(;typeof s=="object"&&(i=Object.keys(s)[0]);){if(n=n[i],!n)return!1;s=s[i]}return!0}}e.ConfigurationChangeEvent=v;function m(g,n){const{added:d,removed:s,updated:i}=a(n,g),r=[],c=g?.getAllOverrideIdentifiers()||[],o=n?.getAllOverrideIdentifiers()||[];if(n){const u=o.filter(h=>!c.includes(h));for(const h of u)r.push([h,n.getKeysForOverrideIdentifier(h)])}if(g){const u=c.filter(h=>!o.includes(h));for(const h of u)r.push([h,g.getKeysForOverrideIdentifier(h)])}if(n&&g){for(const u of c)if(o.includes(u)){const h=a({contents:g.getOverrideValue(void 0,u)||{},keys:g.getKeysForOverrideIdentifier(u)},{contents:n.getOverrideValue(void 0,u)||{},keys:n.getKeysForOverrideIdentifier(u)});r.push([u,[...h.added,...h.removed,...h.updated]])}}return{added:d,removed:s,updated:i,overrides:r}}function a(g,n){const d=g?n?g.keys.filter(r=>n.keys.indexOf(r)===-1):[...g.keys]:[],s=n?g?n.keys.filter(r=>g.keys.indexOf(r)===-1):[...n.keys]:[],i=[];if(g&&n){for(const r of n.keys)if(g.keys.indexOf(r)!==-1){const c=(0,L.getConfigurationValue)(n.contents,r),o=(0,L.getConfigurationValue)(g.contents,r);D.equals(c,o)||i.push(r)}}return{added:d,removed:s,updated:i}}}),define(De[122],Ie([1,0,10,3]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var C;(function(_){_.Unknown="Unknown",_.NotAvailable="NotAvailable",_.TemporarilyNotAvailable="TemporarilyNotAvailable",_.NoResolverFound="NoResolverFound"})(C=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class P extends l.ErrorNoTelemetry{constructor(D,b=C.Unknown,I){super(D),this._message=D,this._code=b,this._detail=I,this.isHandled=b===C.NotAvailable&&I===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,P.prototype)}static isTemporarilyNotAvailable(D){return D instanceof P&&D._code===C.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof P&&D._code===C.NoResolverFound}static isHandled(D){return D instanceof P&&D.isHandled}}e.RemoteAuthorityResolverError=P}),define(De[123],Ie([1,0,12]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(I){return I.scheme===l.Schemas.vscodeRemote?I.authority:void 0}e.getRemoteAuthority=t;function C(I){if(!I)return;const L=I.indexOf("+");return L<0?I:I.substr(0,L)}e.getRemoteName=C;function P(I){return`/${I.quality??"oss"}-${I.commit??"dev"}`}e.getRemoteServerRootPath=P;function _(I){const{host:L,port:k}=b(I);if(typeof k>"u")throw new Error("Remote authority doesn't contain a port!");return{host:L,port:k}}e.parseAuthorityWithPort=_;function D(I,L){let{host:k,port:S}=b(I);return typeof S>"u"&&(S=L),{host:k,port:S}}e.parseAuthorityWithOptionalPort=D;function b(I){const L=I.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(L)return{host:L[1],port:parseInt(L[2],10)};const k=I.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const S=I.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:I,port:void 0}}}),define(De[28],Ie([1,0,8,3,123]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function P(E){if(typeof E=="object"&&E!==null&&E.supported!==!0)return E.description}e.getWorkspaceSupportTypeMessage=P;function _(E){return E&&typeof E=="object"&&typeof E.id=="string"&&(!E.uuid||typeof E.uuid=="string")}e.isIExtensionIdentifier=_,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(E){E[E.System=0]="System",E[E.User=1]="User"})(D=e.ExtensionType||(e.ExtensionType={}));var b;(function(E){E.WIN32_X64="win32-x64",E.WIN32_IA32="win32-ia32",E.WIN32_ARM64="win32-arm64",E.LINUX_X64="linux-x64",E.LINUX_ARM64="linux-arm64",E.LINUX_ARMHF="linux-armhf",E.ALPINE_X64="alpine-x64",E.ALPINE_ARM64="alpine-arm64",E.DARWIN_X64="darwin-x64",E.DARWIN_ARM64="darwin-arm64",E.WEB="web",E.UNIVERSAL="universal",E.UNKNOWN="unknown",E.UNDEFINED="undefined"})(b=e.TargetPlatform||(e.TargetPlatform={}));class I{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,w){if(typeof p>"u"||p===null)return typeof w>"u"||w===null;if(typeof w>"u"||w===null)return!1;if(typeof p=="string"||typeof w=="string"){const f=typeof p=="string"?p:p.value,v=typeof w=="string"?w:w.value;return l.equalsIgnoreCase(f,v)}return p._lower===w._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.ExtensionIdentifier=I;function L(E){return k(E)}e.isApplicationScopedExtension=L;function k(E){return E.contributes&&E.contributes.localizations?E.contributes.localizations.length>0:!1}e.isLanguagePackExtension=k;function S(E){return E.contributes&&E.contributes.authentication?E.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=S;function T(E,p){if(p){const w=`onResolveRemoteAuthority:${(0,C.getRemoteName)(p)}`;return E.activationEvents?.indexOf(w)!==-1}return!1}e.isResolverExtension=T,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(De[198],Ie([1,0,8,84,28,11,2,10,40]),function(J,e,l,t,C,P,_,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function I(d,s){return d.uuid&&s.uuid?d.uuid===s.uuid:d.id===s.id?!0:(0,l.compareIgnoreCase)(d.id,s.id)===0}e.areSameExtensions=I;const L=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class k{constructor(s,i,r="undefined"){this.version=i,this.targetPlatform=r,this.id=s.id}static create(s){const i=s.manifest?s.manifest.version:s.version,r=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new k(s.identifier,i,r)}static parse(s){const i=L.exec(s);return i&&i[1]&&i[2]?new k({id:i[1]},i[2],i[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof k?I(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.ExtensionKey=k;const S=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function T(d){const s=S.exec(d);return s&&s[1]?[p(s[1]),s[2]]:[p(d),void 0]}e.getIdAndVersion=T;function E(d,s){return`${d}.${s}`}e.getExtensionId=E;function p(d){return d.toLocaleLowerCase()}e.adoptToGalleryExtensionId=p;function w(d,s){return p(E(d,s))}e.getGalleryExtensionId=w;function f(d,s){const i=[],r=c=>{for(const o of i)if(o.some(u=>I(s(u),s(c))))return o;return null};for(const c of d){const o=r(c);o?o.push(c):i.push([c])}return i}e.groupByExtension=f;function v(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=v;function m(d){return{id:d.identifier.id,name:d.name,galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,isPreReleaseVersion:d.properties.isPreReleaseVersion,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),...d.telemetryData}}e.getGalleryExtensionTelemetryData=m,e.BetterMergeId=new C.ExtensionIdentifier("pprice.better-merge");function a(d,s){const i=[],r=s.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const c=r.shift();if(c&&i.every(o=>!I(o.identifier,{id:c}))){const o=d.filter(u=>I(u.identifier,{id:c}));o.length===1&&(i.push(o[0]),r.push(...o[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}e.getExtensionDependencies=a;async function g(d,s){if(!P.isLinux)return!1;let i;try{i=(await d.readFile(_.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await d.readFile(_.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){s.debug("Error while getting the os-release file.",(0,D.getErrorMessage)(c))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=g;async function n(d,s){const i=await g(d,s),r=(0,t.getTargetPlatform)(i?"alpine":P.platform,b.arch);return s.debug("ComputeTargetPlatform:",r),r}e.computeTargetPlatform=n}),define(De[199],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class l{constructor(){this.validators=new Map}vsda(){return new Promise((C,P)=>J(["vsda"],C,P))}async createNewMessage(C){try{const P=await this.vsda(),_=new P.validator;if(_){const D=String(l._nextId++);return this.validators.set(D,_),{id:D,data:_.createNewMessage(C)}}}catch{}return{id:"",data:C}}async validate(C,P){if(!C.id)return!0;const _=this.validators.get(C.id);if(!_)return!1;this.validators.delete(C.id);try{return _.validate(P)==="ok"}catch{return!1}}async sign(C){try{const P=await this.vsda(),_=new P.signer;if(_)return _.sign(C)}catch{}return C}}e.SignService=l,l._nextId=1}),define(De[200],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class l{constructor(C){this._callback=C,this._terminalBufferMap=new Map}dispose(){for(const C of this._terminalBufferMap.values())C.dispose()}startBuffering(C,P,_=5){const D=P(b=>{const I=typeof b=="string"?b:b.data;let L=this._terminalBufferMap.get(C);if(L){L.data.push(I);return}const k=setTimeout(()=>this.flushBuffer(C),_);L={data:[I],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(C),D.dispose()}},this._terminalBufferMap.set(C,L)});return D}stopBuffering(C){this._terminalBufferMap.get(C)?.dispose()}flushBuffer(C){const P=this._terminalBufferMap.get(C);P&&(this._terminalBufferMap.delete(C),this._callback(C,P.data.join("")))}}e.TerminalDataBufferer=l}),define(De[201],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var l;(function(P){P.DARK="dark",P.LIGHT="light",P.HIGH_CONTRAST_DARK="hcDark",P.HIGH_CONTRAST_LIGHT="hcLight"})(l=e.ColorScheme||(e.ColorScheme={}));function t(P){return P===l.HIGH_CONTRAST_DARK||P===l.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function C(P){return P===l.DARK||P===l.HIGH_CONTRAST_DARK}e.isDark=C}),define(De[86],Ie([1,0,74,4,6,3,43,201]),function(J,e,l,t,C,P,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,P.createDecorator)("themeService");var b;(function(w){function f(v){return v&&typeof v=="object"&&typeof v.id=="string"}w.isThemeColor=f})(b=e.ThemeColor||(e.ThemeColor={}));function I(w){return{id:w}}e.themeColorFromId=I;var L;(function(w){function f(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||b.isThemeColor(i.color))}w.isThemeIcon=f;const v=new RegExp(`^\\$\\((${l.CSSIcon.iconNameExpression}(?:${l.CSSIcon.iconModifierExpression})?)\\)$`);function m(i){const r=v.exec(i);if(!r)return;const[,c]=r;return{id:c}}w.fromString=m;function a(i){return{id:i}}w.fromId=a;function g(i,r){let c=i.id;const o=c.lastIndexOf("~");return o!==-1&&(c=c.substring(0,o)),r&&(c=`${c}~${r}`),{id:c}}w.modify=g;function n(i){const r=i.id.lastIndexOf("~");if(r!==-1)return i.id.substring(r+1)}w.getModifier=n;function d(i,r){return i.id===r.id&&i.color?.id===r.color?.id}w.isEqual=d;function s(i,r){return{id:i.id,color:r?I(r):void 0}}w.asThemeIcon=s,w.asClassNameArray=l.CSSIcon.asClassNameArray,w.asClassName=l.CSSIcon.asClassName,w.asCSSSelector=l.CSSIcon.asCSSSelector})(L=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=l.Codicon.file,e.FolderThemeIcon=l.Codicon.folder;function k(w){switch(w){case D.ColorScheme.DARK:return"vs-dark";case D.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case D.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=k,e.Extensions={ThemingContribution:"base.contributions.theming"};class S{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(f){return this.themingParticipants.push(f),this.onThemingParticipantAddedEmitter.fire(f),(0,C.toDisposable)(()=>{const v=this.themingParticipants.indexOf(f);this.themingParticipants.splice(v,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const T=new S;_.Registry.add(e.Extensions.ThemingContribution,T);function E(w){return T.onColorThemeChange(w)}e.registerThemingParticipant=E;class p extends C.Disposable{constructor(f){super(),this.themeService=f,this.theme=f.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(v=>this.onThemeChange(v)))}onThemeChange(f){this.theme=f,this.updateStyles()}updateStyles(){}getColor(f,v){let m=this.theme.getColor(f);return m&&v&&(m=v(m,this.theme)),m?m.toString():null}}e.Themable=p}),define(De[124],Ie([1,0,4,11,3,15]),function(J,e,l,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,C.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,C.createDecorator)("sharedTunnelsService");var _;(function(p){p.Http="http",p.Https="https"})(_=e.TunnelProtocol||(e.TunnelProtocol={}));var D;(function(p){p.ConstantPrivate="constantPrivate",p.Private="private",p.Public="public"})(D=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var b;(function(p){p[p.Notify=1]="Notify",p[p.OpenBrowser=2]="OpenBrowser",p[p.OpenPreview=3]="OpenPreview",p[p.Silent=4]="Silent",p[p.Ignore=5]="Ignore",p[p.OpenBrowserOnce=6]="OpenBrowserOnce"})(b=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function I(p){if(p.scheme!=="http"&&p.scheme!=="https")return;const w=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(p.authority);if(!!w)return{address:w[1],port:+w[2]}}e.extractLocalHostUriMetaDataForPortMapping=I,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function L(p){return e.LOCALHOST_ADDRESSES.indexOf(p)>=0}e.isLocalhost=L,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function k(p){return e.ALL_INTERFACES_ADDRESSES.indexOf(p)>=0}e.isAllInterfaces=k;function S(p,w){return w?w!==1&&p<1024:!t.isWindows&&p<1024}e.isPortPrivileged=S;class T{constructor(w,f,v){this.remoteAddress=w,this.localAddress=f,this._dispose=v,this._onDispose=new l.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=T;let E=class{constructor(w){this.logService=w,this._onTunnelOpened=new l.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new l.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new l.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(w){return this._tunnelProvider=w,w?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(w){this._canElevate=w.elevation,this._privacyOptions=w.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const w=[],f=Array.from(this._tunnels.values());for(const v of f){const m=Array.from(v.values());for(const a of m){const g=await a.value;g&&w.push(g)}}return w}async dispose(){for(const w of this._tunnels.values()){for(const{value:f}of w.values())await f.then(v=>v?.dispose());w.clear()}this._tunnels.clear()}openTunnel(w,f,v,m,a=!1,g,n){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${f}:${v} on local port ${m}.`),!w)return;if(f||(f="localhost"),this._tunnelProvider&&this._factoryInProgress.has(v)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const d=this.retainOrCreateTunnel(w,f,v,m,a,g,n);return d?d.then(s=>{if(!s){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(f,v);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.makeTunnel(s);return(s.tunnelRemoteHost!==f||s.tunnelRemotePort!==v)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(i),i}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),d)}makeTunnel(w){return{tunnelRemotePort:w.tunnelRemotePort,tunnelRemoteHost:w.tunnelRemoteHost,tunnelLocalPort:w.tunnelLocalPort,localAddress:w.localAddress,privacy:w.privacy,protocol:w.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${w.tunnelRemoteHost}:${w.tunnelRemotePort} `);const f=this._tunnels.get(w.tunnelRemoteHost);if(f){const v=f.get(w.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(w.tunnelRemoteHost,w.tunnelRemotePort,v))}}}}async tryDisposeTunnel(w,f,v){if(v.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${w}:${f}.`);const m=v.value.then(async a=>{a&&(await a.dispose(!0),this._onTunnelClosed.fire({host:a.tunnelRemoteHost,port:a.tunnelRemotePort}))});return this._tunnels.has(w)&&this._tunnels.get(w).delete(f),m}}async closeTunnel(w,f){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${w}:${f} `);const v=this._tunnels.get(w);if(v&&v.has(f)){const m=v.get(f);m.refcount=0,await this.tryDisposeTunnel(w,f,m)}}addTunnelToMap(w,f,v){this._tunnels.has(w)||this._tunnels.set(w,new Map),this._tunnels.get(w).set(f,{refcount:1,value:v})}async removeEmptyTunnelFromMap(w,f){const v=this._tunnels.get(w);v&&(await v.get(f)||v.delete(f),v.size===0&&this._tunnels.delete(w))}getTunnelFromMap(w,f){const v=[w];L(w)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):k(w)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const m=v.map(a=>this._tunnels.get(a));for(const a of m){const g=a?.get(f);if(g)return g}}canTunnel(w){return!!I(w)}createWithProvider(w,f,v,m,a,g,n){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${f}:${v} on local port ${m}.`);const d=v;this._factoryInProgress.add(d);const i={elevationRequired:a?S(m===void 0?v:m):!1},r={remoteAddress:{host:f,port:v},localAddressPort:m,privacy:g,public:g?g!==D.Private:void 0,protocol:n},c=w.forwardPort(r,i);return c?(this.addTunnelToMap(f,v,c),c.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(d)})):this._factoryInProgress.delete(d),c}};E=qe([xe(0,P.ILogService)],E),e.AbstractTunnelService=E}),define(De[202],Ie([1,0,12]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function t(b){return b.scheme!==l.Schemas.file&&b.scheme!==l.Schemas.vscodeRemote}e.isVirtualResource=t;function C(b){if(b.folders.length)return b.folders.every(I=>t(I.uri))?b.folders[0].uri:void 0;if(b.configuration&&t(b.configuration))return b.configuration}e.getVirtualWorkspaceLocation=C;function P(b){return C(b)?.scheme}e.getVirtualWorkspaceScheme=P;function _(b){return C(b)?.authority}e.getVirtualWorkspaceAuthority=_;function D(b){return C(b)!==void 0}e.isVirtualWorkspace=D}),define(De[45],Ie([1,0,168,9,25,22,2,3,12]),function(J,e,l,t,C,P,_,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,D.createDecorator)("contextService");function I(d){const s=d;return typeof s?.id=="string"&&_.URI.isUri(s.uri)}e.isSingleFolderWorkspaceIdentifier=I,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function L(d,s){if(typeof d=="string"||typeof d>"u")return typeof d=="string"?{id:(0,t.basename)(d)}:s?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const i=d;if(i.configuration)return{id:i.id,configPath:i.configuration};if(i.folders.length===1)return{id:i.id,uri:i.folders[0].uri}}e.toWorkspaceIdentifier=L;function k(d){const s=d;return typeof s?.id=="string"&&_.URI.isUri(s.configPath)}e.isWorkspaceIdentifier=k;function S(d){const s=d;if(s?.uri)return{id:s.id,uri:_.URI.revive(s.uri)};const i=d;if(i?.configPath)return{id:i.id,configPath:_.URI.revive(i.configPath)};if(d?.id)return{id:d.id}}e.reviveIdentifier=S;var T;(function(d){d[d.EMPTY=1]="EMPTY",d[d.FOLDER=2]="FOLDER",d[d.WORKSPACE=3]="WORKSPACE"})(T=e.WorkbenchState||(e.WorkbenchState={}));function E(d){const s=d;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.isWorkspace=E;function p(d){const s=d;return!!(s&&typeof s=="object"&&_.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.isWorkspaceFolder=p;class w{constructor(s,i,r,c,o){this._id=s,this._transient=r,this._configuration=c,this._ignorePathCasing=o,this._foldersMap=C.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=i}update(s){this._id=s.id,this._configuration=s.configuration,this._transient=s.transient,this._ignorePathCasing=s._ignorePathCasing,this.folders=s.folders}get folders(){return this._folders}set folders(s){this._folders=s,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(s){this._configuration=s}getFolder(s){return s&&this._foldersMap.findSubstr(s)||null}updateFoldersMap(){this._foldersMap=C.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const s of this.folders)this._foldersMap.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=w;class f{constructor(s,i){this.raw=i,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,P.joinPath)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=f;function v(d){return new f({uri:d,index:0,name:(0,P.basenameOrAuthority)(d)},{uri:d.toString()})}e.toWorkspaceFolder=v,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,l.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function m(d,s){return P.extUriBiasedIgnorePathCase.isEqualOrParent(d,s.untitledWorkspacesHome)}e.isUntitledWorkspace=m;function a(d){let s;return _.URI.isUri(d)?s=d:s=d.configuration,s?.scheme===b.Schemas.tmp}e.isTemporaryWorkspace=a;function g(d,s){return!m(d,s)&&!a(d)}e.isSavedWorkspace=g;function n(d){return(typeof d=="string"?(0,t.extname)(d):(0,P.extname)(d))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=n}),define(De[87],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class l{constructor(C){this.id=C,this._data=new Map,this._idPool=1}add(C){const P=this._idPool++;return this._data.set(P,C),this.logDebugInfo(),P}get(C,P){return this._data.has(C)?this._data.get(C)[P]:void 0}delete(C){this._data.delete(C),this.logDebugInfo()}logDebugInfo(){!l.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=l,l.enableDebugLogging=!1}),define(De[46],Ie([1,0,12,22,3]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class P{constructor(){this._systemSchemes=new Set(Object.keys(l.Schemas)),this._providerInfo=new Map,this.extUri=new t.ExtUri(D=>{const b=this._providerInfo.get(D.scheme);return!(b===void 0||b&1024)})}$acceptProviderInfos(D,b){b===null?this._providerInfo.delete(D.scheme):this._providerInfo.set(D.scheme,b)}isFreeScheme(D){return!this._providerInfo.has(D)&&!this._systemSchemes.has(D)}getCapabilities(D){return this._providerInfo.get(D)}}e.ExtHostFileSystemInfo=P,e.IExtHostFileSystemInfo=(0,C.createDecorator)("IExtHostFileSystemInfo")}),define(De[26],Ie([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,l.createDecorator)("IExtHostInitDataService")}),define(De[203],Ie([1,0,18]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class t{constructor(_,D,b){this._deferredPromises=new Map,this._id=_,this._shared=D,this._storage=b,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(I=>(this._value=I,this)),this._storageListener=this._storage.onDidChangeStorage(I=>{I.shared===this._shared&&I.key===this._id&&(this._value=I.value)}),this._scheduler=new l.RunOnceScheduler(()=>{const I=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const L of I.values())L.complete()}catch(L){for(const k of I.values())k.error(L)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,_])=>_!==void 0).map(([_])=>_)}get whenReady(){return this._init}get(_,D){let b=this._value[_];return typeof b>"u"&&(b=D),b}update(_,D){this._value[_]=D;const b=this._deferredPromises.get(_);if(b!==void 0)return b.p;const I=new l.DeferredPromise;return this._deferredPromises.set(_,I),this._scheduler.isScheduled()||this._scheduler.schedule(),I.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=t;class C extends t{constructor(_,D){super(_.identifier.value,!0,D),this._extension=_}setKeysForSync(_){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},_)}}e.ExtensionGlobalMemento=C}),define(De[204],Ie([1,0,4,2]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class C{constructor(_){this._notebooksAndEditors=_,this._onDidSaveNotebookDocument=new l.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new l.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(_,D,b,I){const k=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(_)).acceptModelChanged(D.value,b,I);this._onDidChangeNotebookDocument.fire(k)}$acceptDirtyStateChanged(_,D){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(_)).acceptDirty(D)}$acceptModelSaved(_){const D=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(_));this._onDidSaveNotebookDocument.fire(D.apiNotebook)}}e.ExtHostNotebookDocuments=C}),define(De[16],Ie([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,l.createDecorator)("IExtHostRpcService");class t{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.dispose=P.dispose.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.ExtHostRpcService=t});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,C){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?C.call(J,l):C?C.value=l:e.set(J,l),l},Ue=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[205],Ie([1,0,28,4]),function(J,e,l,t){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class P{constructor(D,b){C.set(this,void 0),this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._id=l.ExtensionIdentifier.toKey(D.identifier),tt(this,C,b,"f"),Ue(this,C,"f").onDidChangePassword(I=>{I.extensionId===this._id&&this._onDidChange.fire({key:I.key})})}get(D){return Ue(this,C,"f").get(this._id,D)}store(D,b){return Ue(this,C,"f").store(this._id,D,b)}delete(D){return Ue(this,C,"f").delete(this._id,D)}}e.ExtensionSecrets=P,C=new WeakMap}),define(De[125],Ie([1,0,3,4]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class C{constructor(){this._onDidChangeTelemetryEnabled=new t.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new t.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}$initializeTelemetryLevel(_,D){this._level=_,this._productConfig=D||{usage:!0,error:!0}}$onDidChangeTelemetryLevel(_){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=_,this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}}e.ExtHostTelemetry=C,e.IExtHostTelemetry=(0,l.createDecorator)("IExtHostTelemetry")}),define(De[53],Ie([1,0,3,124,4,16]),function(J,e,l,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var _;(function(b){function I(k){return{remoteAddress:k.remoteAddress,localAddress:k.localAddress,public:!!k.public,privacy:k.privacy??(k.public?t.TunnelPrivacyId.Public:t.TunnelPrivacyId.Private),protocol:k.protocol}}b.fromApiTunnel=I;function L(k){return{remoteAddress:{host:k.tunnelRemoteHost,port:k.tunnelRemotePort},localAddress:k.localAddress,public:k.privacy!==t.TunnelPrivacyId.ConstantPrivate&&k.privacy!==t.TunnelPrivacyId.ConstantPrivate,privacy:k.privacy,protocol:k.protocol}}b.fromServiceTunnel=L})(_=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,l.createDecorator)("IExtHostTunnelService");let D=class{constructor(I){this.onDidChangeTunnels=new C.Emitter().event}async $applyCandidateFilter(I){return I}async openTunnel(I,L){}async getTunnels(){return[]}async setTunnelFactory(I){return{dispose:()=>{}}}registerPortsAttributesProvider(I,L){return{dispose:()=>{}}}async $providePortAttributes(I,L,k,S,T){return[]}async $forwardPort(I,L){}async $closeTunnel(I){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};D=qe([xe(0,P.IExtHostRpcService)],D),e.ExtHostTunnelService=D}),define(De[54],Ie([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,l.createDecorator)("IURITransformerService");class t{constructor(P){P?(this.transformIncoming=P.transformIncoming.bind(P),this.transformOutgoing=P.transformOutgoing.bind(P),this.transformOutgoingURI=P.transformOutgoingURI.bind(P),this.transformOutgoingScheme=P.transformOutgoingScheme.bind(P)):(this.transformIncoming=_=>_,this.transformOutgoing=_=>_,this.transformOutgoingURI=_=>_,this.transformOutgoingScheme=_=>_)}}e.URITransformerService=t}),define(De[206],Ie([1,0,23]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class t{constructor(){this.buffers=[]}add(b){let I=this.buffers.indexOf(b);return I<0&&(I=this.buffers.length,this.buffers.push(b)),I}}function C(D,b){if(b.serializeBuffersForPostMessage){const I=new t,L=(T,E)=>{if(E instanceof ArrayBuffer){const p=I.add(E);return{$$vscode_array_buffer_reference$$:!0,index:p}}else if(ArrayBuffer.isView(E)){const p=P(E);if(p){const w=I.add(E.buffer);return{$$vscode_array_buffer_reference$$:!0,index:w,view:{type:p,byteLength:E.byteLength,byteOffset:E.byteOffset}}}}return E},k=JSON.stringify(D,L),S=I.buffers.map(T=>{const E=new Uint8Array(T);return l.VSBuffer.wrap(E)});return{message:k,buffers:S}}else return{message:JSON.stringify(D),buffers:[]}}e.serializeWebviewMessage=C;function P(D){switch(D.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function _(D,b){const I=b.map(S=>{const T=new ArrayBuffer(S.byteLength);return new Uint8Array(T).set(S.buffer),T}),L=b.length?(S,T)=>{if(T&&typeof T=="object"&&T.$$vscode_array_buffer_reference$$){const E=T,{index:p}=E,w=I[p];if(E.view)switch(E.view.type){case 1:return new Int8Array(w,E.view.byteOffset,E.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(w,E.view.byteOffset,E.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(w,E.view.byteOffset,E.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(w,E.view.byteOffset,E.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(w,E.view.byteOffset,E.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(w,E.view.byteOffset,E.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(w,E.view.byteOffset,E.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(w,E.view.byteOffset,E.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(w,E.view.byteOffset,E.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(w,E.view.byteOffset,E.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(w,E.view.byteOffset,E.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return w}return T}:void 0;return{message:JSON.parse(D,L),arrayBuffers:I}}e.deserializeWebviewMessage=_}),define(De[207],Ie([1,0,108]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function t(P){return{transformIncoming:_=>_.scheme==="vscode-remote"?{scheme:"file",path:_.path,query:_.query,fragment:_.fragment}:_.scheme==="file"?{scheme:"vscode-local",path:_.path,query:_.query,fragment:_.fragment}:_,transformOutgoing:_=>_.scheme==="file"?{scheme:"vscode-remote",authority:P,path:_.path,query:_.query,fragment:_.fragment}:_.scheme==="vscode-local"?{scheme:"file",path:_.path,query:_.query,fragment:_.fragment}:_,transformOutgoingScheme:_=>_==="file"?"vscode-remote":_==="vscode-local"?"file":_}}function C(P){return new l.URITransformer(t(P))}e.createURITransformer=C}),define(De[126],Ie([1,0,178,14,2,6,3,43,42,17,12]),function(J,e,l,t,C,P,_,D,b,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,l.localize)(0,null),providerDisplayName:(0,l.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var k;(function(O){O[O.PROGRAMMATIC=1]="PROGRAMMATIC",O[O.USER=2]="USER",O[O.EDIT=3]="EDIT",O[O.NAVIGATION=4]="NAVIGATION",O[O.JUMP=5]="JUMP"})(k=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var S;(function(O){O[O.IDENTICAL=1]="IDENTICAL",O[O.SIMILAR=2]="SIMILAR",O[O.DIFFERENT=3]="DIFFERENT"})(S=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function T(O){const x=O;return!!x&&typeof x.getSelection=="function"&&!!x.onDidChangeSelection}e.isEditorPaneWithSelection=T;function E(O,x,V){for(const q of V.visibleEditorPanes)if(q.group.id===x&&O.matches(q.input))return q.getViewState()}e.findViewStateForEditor=E;function p(O){if(i(O))return!1;const x=O;return C.URI.isUri(x?.resource)}e.isResourceEditorInput=p;function w(O){if(i(O))return!1;const x=O;return x?.original!==void 0&&x.modified!==void 0}e.isResourceDiffEditorInput=w;function f(O){if(i(O)||w(O))return!1;const x=O;return x?.primary!==void 0&&x.secondary!==void 0}e.isResourceSideBySideEditorInput=f;function v(O){if(i(O))return!1;const x=O;return x?x.resource===void 0||x.resource.scheme===L.Schemas.untitled||x.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=v;function m(O){if(i(O))return!1;const x=O;return C.URI.isUri(x?.base?.resource)&&C.URI.isUri(x?.input1?.resource)&&C.URI.isUri(x?.input2?.resource)&&C.URI.isUri(x?.result?.resource)}e.isResourceMergeEditorInput=m;var a;(function(O){O[O.SHORT=0]="SHORT",O[O.MEDIUM=1]="MEDIUM",O[O.LONG=2]="LONG"})(a=e.Verbosity||(e.Verbosity={}));var g;(function(O){O[O.EXPLICIT=1]="EXPLICIT",O[O.AUTO=2]="AUTO",O[O.FOCUS_CHANGE=3]="FOCUS_CHANGE",O[O.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(g=e.SaveReason||(e.SaveReason={}));class n{constructor(){this.mapIdToSaveSource=new Map}registerSource(x,V){let q=this.mapIdToSaveSource.get(x);return q||(q={source:x,label:V},this.mapIdToSaveSource.set(x,q)),q.source}getSourceLabel(x){return this.mapIdToSaveSource.get(x)?.label??x}}e.SaveSourceRegistry=new n;var d;(function(O){O[O.None=0]="None",O[O.Readonly=2]="Readonly",O[O.Untitled=4]="Untitled",O[O.Singleton=8]="Singleton",O[O.RequiresTrust=16]="RequiresTrust",O[O.CanSplitInGroup=32]="CanSplitInGroup",O[O.ForceDescription=64]="ForceDescription",O[O.CanDropIntoEditor=128]="CanDropIntoEditor",O[O.MultipleEditors=256]="MultipleEditors"})(d=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class s extends P.Disposable{}e.AbstractEditorInput=s;function i(O){return O instanceof s}e.isEditorInput=i;function r(O){const x=O;return C.URI.isUri(x?.preferredResource)}function c(O){const x=O;return i(x?.primary)&&i(x?.secondary)}e.isSideBySideEditorInput=c;function o(O){const x=O;return i(x?.modified)&&i(x?.original)}e.isDiffEditorInput=o;function u(O){return i(O?.editor)}e.isEditorInputWithOptions=u;function h(O){const x=O;return u(O)&&x?.group!==void 0}e.isEditorInputWithOptionsAndGroup=h;function y(O){const x=O;return typeof x?.groupId=="number"&&i(x.editor)}e.isEditorIdentifier=y;var R;(function(O){O[O.UNKNOWN=0]="UNKNOWN",O[O.REPLACE=1]="REPLACE",O[O.MOVE=2]="MOVE",O[O.UNPIN=3]="UNPIN"})(R=e.EditorCloseContext||(e.EditorCloseContext={}));var M;(function(O){O[O.GROUP_ACTIVE=0]="GROUP_ACTIVE",O[O.GROUP_INDEX=1]="GROUP_INDEX",O[O.GROUP_LOCKED=2]="GROUP_LOCKED",O[O.EDITOR_OPEN=3]="EDITOR_OPEN",O[O.EDITOR_CLOSE=4]="EDITOR_CLOSE",O[O.EDITOR_MOVE=5]="EDITOR_MOVE",O[O.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",O[O.EDITOR_LABEL=7]="EDITOR_LABEL",O[O.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",O[O.EDITOR_PIN=9]="EDITOR_PIN",O[O.EDITOR_STICKY=10]="EDITOR_STICKY",O[O.EDITOR_DIRTY=11]="EDITOR_DIRTY",O[O.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(M=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var U;(function(O){O[O.PRIMARY=1]="PRIMARY",O[O.SECONDARY=2]="SECONDARY",O[O.BOTH=3]="BOTH",O[O.ANY=4]="ANY"})(U=e.SideBySideEditor||(e.SideBySideEditor={}));class A{getOriginalUri(x,V){if(!x)return;if(m(x))return e.EditorResourceAccessor.getOriginalUri(x.result,V);if(V?.supportSideBySide){const{primary:Y,secondary:Q}=this.getSideEditors(x);if(Y&&Q){if(V?.supportSideBySide===U.BOTH)return{primary:this.getOriginalUri(Y,{filterByScheme:V.filterByScheme}),secondary:this.getOriginalUri(Q,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===U.ANY)return this.getOriginalUri(Y,{filterByScheme:V.filterByScheme})??this.getOriginalUri(Q,{filterByScheme:V.filterByScheme});x=V.supportSideBySide===U.PRIMARY?Y:Q}}if(w(x)||f(x)||m(x))return;const q=r(x)?x.preferredResource:x.resource;return!q||!V||!V.filterByScheme?q:this.filterUri(q,V.filterByScheme)}getSideEditors(x){return c(x)||f(x)?{primary:x.primary,secondary:x.secondary}:o(x)||w(x)?{primary:x.modified,secondary:x.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(x,V){if(!x)return;if(m(x))return e.EditorResourceAccessor.getCanonicalUri(x.result,V);if(V?.supportSideBySide){const{primary:Y,secondary:Q}=this.getSideEditors(x);if(Y&&Q){if(V?.supportSideBySide===U.BOTH)return{primary:this.getCanonicalUri(Y,{filterByScheme:V.filterByScheme}),secondary:this.getCanonicalUri(Q,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===U.ANY)return this.getCanonicalUri(Y,{filterByScheme:V.filterByScheme})??this.getCanonicalUri(Q,{filterByScheme:V.filterByScheme});x=V.supportSideBySide===U.PRIMARY?Y:Q}}if(w(x)||f(x)||m(x))return;const q=x.resource;return!q||!V||!V.filterByScheme?q:this.filterUri(q,V.filterByScheme)}filterUri(x,V){if(Array.isArray(V)){if(V.some(q=>x.scheme===q))return x}else if(V===x.scheme)return x}}e.EditorResourceAccessor=new A;var z;(function(O){O[O.LEFT=0]="LEFT",O[O.RIGHT=1]="RIGHT"})(z=e.CloseDirection||(e.CloseDirection={}));class ${constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(x){const V=this.instantiationService=x.get(_.IInstantiationService);for(const[q,Y]of this.editorSerializerConstructors)this.createEditorSerializer(q,Y,V);this.editorSerializerConstructors.clear()}createEditorSerializer(x,V,q){const Y=q.createInstance(V);this.editorSerializerInstances.set(x,Y)}registerFileEditorFactory(x){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=x}getFileEditorFactory(){return(0,t.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(x,V){if(this.editorSerializerConstructors.has(x)||this.editorSerializerInstances.has(x))throw new Error(`A editor serializer with type ID '${x}' was already registered.`);return this.instantiationService?this.createEditorSerializer(x,V,this.instantiationService):this.editorSerializerConstructors.set(x,V),(0,P.toDisposable)(()=>{this.editorSerializerConstructors.delete(x),this.editorSerializerInstances.delete(x)})}getEditorSerializer(x){return this.editorSerializerInstances.get(typeof x=="string"?x:x.typeId)}}D.Registry.add(e.EditorExtensions.EditorFactory,new $);async function N(O,x){if(!O||!O.length)return[];const V=await Promise.all(O.map(async q=>{const Y=C.URI.revive(q.fileUri);if(!Y||!await x.canHandleResource(Y))return;let de=q.exists,ve=q.type;if(typeof de!="boolean"||typeof ve!="number")try{ve=(await x.stat(Y)).isDirectory?b.FileType.Directory:b.FileType.Unknown,de=!0}catch{de=!1}if(!de&&q.openOnlyIfExists||ve===b.FileType.Directory)return;const ne={...q.options,pinned:!0};let pe;return de?pe={resource:Y,options:ne}:pe={resource:Y,options:ne,forceUntitled:!0},pe}));return(0,I.coalesce)(V)}e.pathsToEditors=N;var K;(function(O){O[O.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",O[O.SEQUENTIAL=1]="SEQUENTIAL"})(K=e.EditorsOrder||(e.EditorsOrder={}));function B(O){const x=O;if(!x)return!1;const V=x;if(V.modified)return B(V.modified);const q=x;return!!(q.contributionsState&&q.viewState&&Array.isArray(q.cursorState))}e.isTextEditorViewState=B}),define(De[88],Ie([1,0,12,2]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function C(D,b){return D.scheme===l.Schemas.http||D.scheme===l.Schemas.https?D:(b&&b.authority&&b.isRemote&&D.scheme===l.Schemas.file&&(D=t.URI.from({scheme:l.Schemas.vscodeRemote,authority:b.authority,path:D.path})),t.URI.from({scheme:l.Schemas.https,authority:`${D.scheme}+${P(D.authority)}.${e.webviewRootResourceAuthority}`,path:D.path,fragment:D.fragment,query:D.query}))}e.asWebviewUri=C;function P(D){return D.replace(/./g,b=>{const I=b.charCodeAt(0);return I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57?b:"-"+I.toString(16).padStart(4,"0")})}function _(D){return D.replace(/-([0-9a-f]{4})/g,(b,I)=>String.fromCharCode(parseInt(I,16)))}e.decodeAuthority=_}),define(De[208],Ie([1,0,4,6,88]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class P{constructor(D,b,I){this._proxy=D,this._editors=b,this._remoteInfo=I,this._handlePool=0,this._disposables=new t.DisposableStore,this._insets=new Map,this._disposables.add(b.onDidChangeVisibleTextEditors(()=>{const L=b.getVisibleTextEditors();for(const k of this._insets.values())L.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this._insets.forEach(D=>D.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(D,b,I,L,k){let S;for(const m of this._editors.getVisibleTextEditors(!0))if(m.value===D){S=m;break}if(!S)throw new Error("not a visible editor");const T=this,E=this._handlePool++,p=new l.Emitter,w=new l.Emitter,f=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(m){return(0,C.asWebviewUri)(m,T._remoteInfo)}get cspSource(){return C.webviewGenericCspSource}set options(m){this._options=m,T._proxy.$setOptions(E,m)}get options(){return this._options}set html(m){this._html=m,T._proxy.$setHtml(E,m)}get html(){return this._html}get onDidReceiveMessage(){return p.event}postMessage(m){return T._proxy.$postMessage(E,m)}},v=new class{constructor(){this.editor=D,this.line=b,this.height=I,this.webview=f,this.onDidDispose=w.event}dispose(){T._insets.has(E)&&(T._insets.delete(E),T._proxy.$disposeEditorInset(E),w.fire(),w.dispose(),p.dispose())}};return this._proxy.$createEditorInset(E,S.id,S.value.document.uri,b+1,I,L||{},k.identifier,k.extensionLocation),this._insets.set(E,{editor:D,inset:v,onDidReceiveMessage:p}),v}$onDidDispose(D){const b=this._insets.get(D);b&&b.inset.dispose()}$onDidReceiveMessage(D,b){this._insets.get(D)?.onDidReceiveMessage.fire(b)}}e.ExtHostEditorInsets=P}),define(De[127],Ie([1,0,4,18,179]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class P{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new l.Emitter,this._onExit=new l.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(D){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=D}onEvent(D){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=D}onRequest(D){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=D}sendResponse(D){D.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${D.command}`)):this.internalSend("response",D)}sendRequest(D,b,I,L){const k={command:D};if(b&&Object.keys(b).length>0&&(k.arguments=b),this.internalSend("request",k),typeof L=="number"){const S=setTimeout(()=>{clearTimeout(S);const T=this.pendingRequests.get(k.seq);if(T){this.pendingRequests.delete(k.seq);const E={type:"response",seq:0,request_seq:k.seq,success:!1,command:D,message:(0,C.localize)(0,null,L,D)};T(E)}},L)}return I&&this.pendingRequests.set(k.seq,I),k.seq}acceptMessage(D){this.messageCallback?this.messageCallback(D):(this.queue.push(D),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(D,b){return D.type!=="event"||b.type!=="event"}async processQueue(){let D;for(;this.queue.length;){if((!D||this.needsTaskBoundaryBetween(this.queue[0],D))&&await(0,t.timeout)(0),D=this.queue.shift(),!D)return;switch(D.type){case"event":this.eventCallback?.(D);break;case"request":this.requestCallback?.(D);break;case"response":{const b=D,I=this.pendingRequests.get(b.request_seq);I&&(this.pendingRequests.delete(b.request_seq),I(b));break}}}}internalSend(D,b){b.type=D,b.seq=this.sequence++,this.sendMessage(b)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const D=new Map;this.pendingRequests.forEach((b,I)=>D.set(I,b)),await(0,t.timeout)(500),D.forEach((b,I)=>{b({type:"response",seq:0,request_seq:I,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(I)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=P}),define(De[209],Ie([1,0,180,52,3]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerUiMessage=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new t.RawContextKey("debugType",void 0,{type:"string",description:l.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new t.RawContextKey("debugConfigurationType",void 0,{type:"string",description:l.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new t.RawContextKey("debugState","inactive",{type:"string",description:l.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new t.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:l.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new t.RawContextKey("inDebugMode",!1,{type:"boolean",description:l.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new t.RawContextKey("inDebugRepl",!1,{type:"boolean",description:l.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new t.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:l.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new t.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:l.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new t.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:l.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new t.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:l.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new t.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:l.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new t.RawContextKey("variablesFocused",!0,{type:"boolean",description:l.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new t.RawContextKey("expressionSelected",!1,{type:"boolean",description:l.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new t.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:l.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new t.RawContextKey("callStackItemType",void 0,{type:"string",description:l.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new t.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:l.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new t.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:l.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new t.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:l.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new t.RawContextKey("watchItemType",void 0,{type:"string",description:l.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new t.RawContextKey("canViewMemory",void 0,{type:"boolean",description:l.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new t.RawContextKey("breakpointItemType",void 0,{type:"string",description:l.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new t.RawContextKey("breakpointAccessType",void 0,{type:"string",description:l.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new t.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:l.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new t.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:l.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new t.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:l.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new t.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:l.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new t.RawContextKey("stepBackSupported",!1,{type:"boolean",description:l.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new t.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:l.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new t.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:l.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new t.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:l.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new t.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:l.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new t.RawContextKey("breakpointsExist",!1,{type:"boolean",description:l.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new t.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:l.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new t.RawContextKey("debugExtensionAvailable",!1,{type:"boolean",description:l.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new t.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:l.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new t.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:l.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new t.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:l.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new t.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:l.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new t.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:l.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new t.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:l.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new t.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:l.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new t.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:l.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new t.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:l.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new t.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:l.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new t.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:l.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new t.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:l.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new t.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:l.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new t.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:l.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new t.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:l.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new t.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:l.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new t.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:l.localize(50,null)});const P=S=>l.localize(51,null,S);e.debuggerDisabledMessage=P,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:l.localize(52,null)};var _;(function(S){S[S.Inactive=0]="Inactive",S[S.Initializing=1]="Initializing",S[S.Stopped=2]="Stopped",S[S.Running=3]="Running"})(_=e.State||(e.State={}));function D(S){switch(S){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=D;var b;(function(S){S[S.Valid=0]="Valid",S[S.Unreadable=1]="Unreadable",S[S.Error=2]="Error"})(b=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var I;(function(S){S[S.Initial=1]="Initial",S[S.Dynamic=2]="Dynamic"})(I=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var L;(function(S){S.UnverifiedBreakpoints="unverifiedBreakpoints"})(L=e.DebuggerUiMessage||(e.DebuggerUiMessage={})),e.IDebugService=(0,C.createDecorator)(e.DEBUG_SERVICE_ID);var k;(function(S){S[S.CONDITION=0]="CONDITION",S[S.HIT_COUNT=1]="HIT_COUNT",S[S.LOG_MESSAGE=2]="LOG_MESSAGE"})(k=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(De[210],Ie([1,0,8,2,9,24,12]),function(J,e,l,t,C,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const D=/{([^}]+)}/g;function b(s,i,r){return s.replace(D,function(c,o){return i&&o.length>0&&o[0]!=="_"?c:r&&r.hasOwnProperty(o)?r[o]:c})}e.formatPII=b;function I(s){const i={};for(const r of Object.keys(s))r.startsWith("!")||(i[r]=s[r]);return i}e.filterExceptionsFromTelemetry=I;function L(s){return s.configuration.request==="attach"&&!k(s)&&(!s.parentSession||L(s.parentSession))}e.isSessionAttach=L;function k(s){let i=s.configuration.type;if(!!i)return i==="vslsShare"&&(i=s.configuration.adapterProxy.configuration.type),(0,l.equalsIgnoreCase)(i,"extensionhost")||(0,l.equalsIgnoreCase)(i,"pwa-extensionhost")?s:s.parentSession?k(s.parentSession):void 0}e.getExtensionHostDebugSession=k;function S(s){return s.type&&(s.label||s.program||s.runtime)}e.isDebuggerMainContribution=S;function T(s,i,r){let c,o=0;const u=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let h=null;for(;h=u.exec(s);){const y=h.index+1,R=y+h[0].length;if(y<=i&&R>=r){c=h[0],o=y;break}}if(c){const y=/\w+/g;let R=null;for(;(R=y.exec(c))&&!(R.index+1+o+R[0].length>=r););R&&(c=c.substring(0,y.lastIndex))}return c?{start:o,end:o+c.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=T;const E=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function p(s){return!!(s&&s.match(E))}e.isUri=p;function w(s){if(typeof s.path=="string"&&!(typeof s.sourceReference=="number"&&s.sourceReference>0)){if(p(s.path))return t.URI.parse(s.path);if((0,C.isAbsolute)(s.path))return t.URI.file(s.path)}return s.path}function f(s){if(typeof s.path=="object"){const i=t.URI.revive(s.path);if(i)return i.scheme===_.Schemas.file?i.fsPath:i.toString()}return s.path}function v(s,i){const r=i?w:f,c=(0,P.deepClone)(s);return a(c,(o,u)=>{o&&u&&(u.path=r(u))}),c}e.convertToDAPaths=v;function m(s,i){const r=i?w:f,c=(0,P.deepClone)(s);return a(c,(o,u)=>{!o&&u&&(u.path=r(u))}),c}e.convertToVSCPaths=m;function a(s,i){switch(s.type){case"event":{const r=s;switch(r.event){case"output":i(!1,r.body.source);break;case"loadedSource":i(!1,r.body.source);break;case"breakpoint":i(!1,r.body.breakpoint.source);break;default:break}break}case"request":{const r=s;switch(r.command){case"setBreakpoints":i(!0,r.arguments.source);break;case"breakpointLocations":i(!0,r.arguments.source);break;case"source":i(!0,r.arguments.source);break;case"gotoTargets":i(!0,r.arguments.source);break;case"launchVSCode":r.arguments.args.forEach(c=>i(!1,c));break;default:break}break}case"response":{const r=s;if(r.success&&r.body)switch(r.command){case"stackTrace":r.body.stackFrames.forEach(c=>i(!1,c.source));break;case"loadedSources":r.body.sources.forEach(c=>i(!1,c));break;case"scopes":r.body.scopes.forEach(c=>i(!1,c.source));break;case"setFunctionBreakpoints":r.body.breakpoints.forEach(c=>i(!1,c.source));break;case"setBreakpoints":r.body.breakpoints.forEach(c=>i(!1,c.source));break;case"disassemble":r.body?.instructions.forEach(o=>i(!1,o.location));break;default:break}break}}}function g(s){return s.filter(i=>!i.presentation?.hidden).sort((i,r)=>i.presentation?r.presentation?i.presentation.group?r.presentation.group?i.presentation.group!==r.presentation.group?i.presentation.group.localeCompare(r.presentation.group):n(i.presentation.order,r.presentation.order):-1:r.presentation.group?1:n(i.presentation.order,r.presentation.order):-1:r.presentation?1:0)}e.getVisibleAndSorted=g;function n(s,i){return typeof s!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:s-i}async function d(s,i){const r=s.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorLanguageId});if(r!=="none"&&(await i.saveAll(),r==="allEditorsInActiveGroup")){const c=i.activeEditorPane;c&&c.input.resource?.scheme===_.Schemas.untitled&&await i.save({editor:c.input,groupId:c.group.id})}await s.reloadConfiguration()}e.saveAllBeforeDebugStart=d}),define(De[211],Ie([1,0,29,44,181,212,9,8,24,11,84,127]),function(J,e,l,t,C,P,_,D,b,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class S extends k.AbstractDebugAdapter{constructor(){super(),this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(v,m){this.outputStream=m,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,v.on("data",a=>this.handleData(a))}sendMessage(v){if(this.outputStream){const m=JSON.stringify(v);this.outputStream.write(`Content-Length: ${Buffer.byteLength(m,"utf8")}${S.TWO_CRLF}${m}`,"utf8")}}handleData(v){for(this.rawData=Buffer.concat([this.rawData,v]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const m=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,m.length>0)try{this.acceptMessage(JSON.parse(m))}catch(a){this._onError.fire(new Error((a.message||a)+`
`+m))}continue}}else{const m=this.rawData.indexOf(S.TWO_CRLF);if(m!==-1){const g=this.rawData.toString("utf8",0,m).split(S.HEADER_LINESEPARATOR);for(const n of g){const d=n.split(S.HEADER_FIELDSEPARATOR);d[0]==="Content-Length"&&(this.contentLength=Number(d[1]))}this.rawData=this.rawData.slice(m+S.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=S,S.TWO_CRLF=`\r
\r
`,S.HEADER_LINESEPARATOR=/\r?\n/,S.HEADER_FIELDSEPARATOR=/: */;class T extends S{startSession(){return new Promise((v,m)=>{let a=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),v(),a=!0}),this.socket.on("close",()=>{a?this._onError.fire(new Error("connection closed")):m(new Error("connection closed"))}),this.socket.on("error",g=>{a?this._onError.fire(g):m(g)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=T;class E extends T{constructor(v){super(),this.adapterServer=v}createConnection(v){return P.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",v)}}e.SocketDebugAdapter=E;class p extends T{constructor(v){super(),this.adapterServer=v}createConnection(v){return P.createConnection(this.adapterServer.path,v)}}e.NamedPipeDebugAdapter=p;class w extends S{constructor(v,m,a){super(),this.adapterExecutable=v,this.debugType=m,this.outputService=a}async startSession(){const v=this.adapterExecutable.command,m=this.adapterExecutable.args,a=this.adapterExecutable.options||{};try{if(v)if(_.isAbsolute(v)){if(!await l.Promises.exists(v))throw new Error(C.localize(0,null,v))}else v.indexOf("/")<0&&v.indexOf("\\")<0;else throw new Error(C.localize(1,null,this.debugType));let g=process.env;if(a.env&&Object.keys(a.env).length>0&&(g=b.mixin(b.deepClone(process.env),a.env)),v==="node")if(Array.isArray(m)&&m.length>0){const d=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,s={env:g,execArgv:d?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};a.cwd&&(s.cwd=a.cwd);const i=t.fork(m[0],m.slice(1),s);if(!i.pid)throw new Error(C.localize(2,null,m[0]));this.serverProcess=i}else throw new Error(C.localize(3,null));else{const d={env:g};a.cwd&&(d.cwd=a.cwd),this.serverProcess=t.spawn(v,m,d)}this.serverProcess.on("error",d=>{this._onError.fire(d)}),this.serverProcess.on("exit",(d,s)=>{this._onExit.fire(d)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",d=>{this._onError.fire(d)}),this.serverProcess.stdin.on("error",d=>{this._onError.fire(d)});const n=this.outputService;if(n){const d=s=>s.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",s=>{n.getChannel(L.ExtensionsChannelId)?.append(d(s))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(g){this._onError.fire(g)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),I.isWindows?new Promise((v,m)=>{const a=t.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(g,n,d){if(g)return m(g)});a.on("exit",v),a.on("error",m)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(v,m){if(!v)return;const a=Object.create(null);v.runtime&&(v.runtime.indexOf("./")===0?a.runtime=_.join(m,v.runtime):a.runtime=v.runtime),v.runtimeArgs&&(a.runtimeArgs=v.runtimeArgs),v.program&&(_.isAbsolute(v.program)?a.program=v.program:a.program=_.join(m,v.program)),v.args&&(a.args=v.args);const g=v;return g.win&&(a.win=w.extract(g.win,m)),g.winx86&&(a.winx86=w.extract(g.winx86,m)),g.windows&&(a.windows=w.extract(g.windows,m)),g.osx&&(a.osx=w.extract(g.osx,m)),g.linux&&(a.linux=w.extract(g.linux,m)),a}static platformAdapterExecutable(v,m){let a=Object.create(null);m=m.toLowerCase();for(const r of v)if(r.contributes){const c=r.contributes.debuggers;c&&c.length>0&&c.filter(o=>typeof o.type=="string"&&D.equalsIgnoreCase(o.type,m)).forEach(o=>{const u=w.extract(o,r.extensionLocation.fsPath);a=b.mixin(a,u,r.isBuiltin)})}let g;I.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?g=a.winx86||a.win||a.windows:I.isWindows?g=a.win||a.windows:I.isMacintosh?g=a.osx:I.isLinux&&(g=a.linux),g=g||a;const n=g.program||a.program,d=g.args||a.args,s=g.runtime||a.runtime,i=g.runtimeArgs||a.runtimeArgs;if(s)return{type:"executable",command:s,args:(i||[]).concat(typeof n=="string"?[n]:[]).concat(d||[])};if(n)return{type:"executable",command:n,args:d||[]}}}e.ExecutableDebugAdapter=w}),define(De[213],Ie([1,0,44,31,11]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function P(I,L){return new Promise((k,S)=>{let T="";const E=l.spawn(I,L);E.pid&&E.stdout.on("data",p=>{T+=p.toString()}),E.on("error",p=>{S(p)}),E.on("close",p=>{k(T)})})}async function _(I){if(I)if(C.isWindows){const L=await new Promise((k,S)=>{J(["windows-process-tree"],k,S)});return new Promise(k=>{L.getProcessTree(I,S=>{k(!!S&&S.children.length>0)})})}else return P("/usr/bin/pgrep",["-lP",String(I)]).then(L=>{const k=L.trim();return!(k.length===0||k.indexOf(" tmux")>=0)},L=>!0);return Promise.resolve(!0)}e.hasChildProcesses=_;var D;(function(I){I[I.cmd=0]="cmd",I[I.powershell=1]="powershell",I[I.bash=2]="bash"})(D||(D={}));function b(I,L,k,S,T){I=I.trim().toLowerCase();let E;I.indexOf("powershell")>=0||I.indexOf("pwsh")>=0?E=1:I.indexOf("cmd.exe")>=0?E=0:I.indexOf("bash")>=0?E=2:C.isWindows?E=0:E=2;let p,w=" ";switch(E){case 1:if(p=f=>(f=f.replace(/\'/g,"''"),f.length>0&&f.charAt(f.length-1)==="\\"?`'${f}\\'`:`'${f}'`),S){const f=(0,t.getDriveLetter)(S);f&&(w+=`${f}:; `),w+=`cd ${p(S)}; `}if(T)for(const f in T){const v=T[f];v===null?w+=`Remove-Item env:${f}; `:w+=`\${env:${f}}='${v}'; `}if(L.length>0){const f=L.shift(),v=k?f:p(f);w+=v[0]==="'"?`& ${v} `:`${v} `;for(const m of L)w+=m==="<"||m===">"||k?m:p(m),w+=" "}break;case 0:if(p=f=>(f=f.replace(/\"/g,'""'),f=f.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(v=>f.includes(v))||f.length===0?`"${f}"`:f),S){const f=(0,t.getDriveLetter)(S);f&&(w+=`${f}: && `),w+=`cd ${p(S)} && `}if(T){w+='cmd /C "';for(const f in T){let v=T[f];v===null?w+=`set "${f}=" && `:(v=v.replace(/[&^|<>]/g,m=>`^${m}`),w+=`set "${f}=${v}" && `)}}for(const f of L)w+=f==="<"||f===">"||k?f:p(f),w+=" ";T&&(w+='"');break;case 2:{p=v=>(v=v.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),v.length===0?'""':v);const f=v=>/[^\w@%\/+=,.:^-]/.test(v)?`'${v.replace(/'/g,"'\\''")}'`:v;if(S&&(w+=`cd ${p(S)} ; `),T){w+="/usr/bin/env";for(const v in T){const m=T[v];m===null?w+=` -u ${f(v)}`:w+=` ${f(`${v}=${m}`)}`}w+=" "}for(const v of L)w+=v==="<"||v===">"||k?v:p(v),w+=" ";break}}return w}e.prepareCommand=b}),define(De[89],Ie([1,0,23,36,60,101,12,9,11,52]),function(J,e,l,t,C,P,_,D,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var L;(function(o){o[o.Markup=1]="Markup",o[o.Code=2]="Code"})(L=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",P.Mimes.latex,P.Mimes.markdown,"image/png","image/jpeg",P.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[P.Mimes.latex,P.Mimes.markdown,"application/json",P.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var k;(function(o){o[o.Running=1]="Running",o[o.Idle=2]="Idle"})(k=e.NotebookRunState||(e.NotebookRunState={}));var S;(function(o){o[o.Unconfirmed=1]="Unconfirmed",o[o.Pending=2]="Pending",o[o.Executing=3]="Executing"})(S=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var T;(function(o){o[o.WithHardKernelDependency=0]="WithHardKernelDependency",o[o.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",o[o.Pure=2]="Pure",o[o.Never=3]="Never"})(T=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var E;(function(o){o.Always="always",o.Never="never",o.Optional="optional"})(E=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var p;(function(o){o[o.ModelChange=1]="ModelChange",o[o.Move=2]="Move",o[o.ChangeCellLanguage=5]="ChangeCellLanguage",o[o.Initialize=6]="Initialize",o[o.ChangeCellMetadata=7]="ChangeCellMetadata",o[o.Output=8]="Output",o[o.OutputItem=9]="OutputItem",o[o.ChangeCellContent=10]="ChangeCellContent",o[o.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",o[o.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",o[o.ChangeCellMime=13]="ChangeCellMime",o[o.Unknown=100]="Unknown"})(p=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var w;(function(o){o[o.Handle=0]="Handle",o[o.Index=1]="Index"})(w=e.SelectionStateType||(e.SelectionStateType={}));var f;(function(o){o[o.Replace=1]="Replace",o[o.Output=2]="Output",o[o.Metadata=3]="Metadata",o[o.CellLanguage=4]="CellLanguage",o[o.DocumentMetadata=5]="DocumentMetadata",o[o.Move=6]="Move",o[o.OutputItems=7]="OutputItems",o[o.PartialMetadata=8]="PartialMetadata",o[o.PartialInternalMetadata=9]="PartialInternalMetadata"})(f=e.CellEditType||(e.CellEditType={}));var v;(function(o){o.scheme=_.Schemas.vscodeNotebookCell;const u=["W","X","Y","Z","a","b","c","d","e","f"],h=new RegExp(`^[${u.join("")}]+`),y=7;function R(N,K){const B=K.toString(y),x=`${B.length<u.length?u[B.length-1]:"z"}${B}s${(0,l.encodeBase64)(l.VSBuffer.fromString(N.scheme),!0,!0)}`;return N.with({scheme:o.scheme,fragment:x})}o.generate=R;function M(N){if(N.scheme!==o.scheme)return;const K=N.fragment.indexOf("s");if(K<0)return;const B=parseInt(N.fragment.substring(0,K).replace(h,""),y),O=(0,l.decodeBase64)(N.fragment.substring(K+1)).toString();if(!isNaN(B))return{handle:B,notebook:N.with({scheme:O,fragment:null})}}o.parse=M;function U(N,K){return N.with({scheme:_.Schemas.vscodeNotebookCellOutput,fragment:`op${K??""},${N.scheme!==_.Schemas.file?N.scheme:""}`})}o.generateCellOutputUri=U;function A(N){if(N.scheme!==_.Schemas.vscodeNotebookCellOutput)return;const K=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(N.fragment);if(!K)return;const B=K[1]&&K[1]!==""?K[1]:void 0,O=K[2];return{outputId:B,notebook:N.with({scheme:O||_.Schemas.file,fragment:null})}}o.parseCellOutputUri=A;function z(N,K,B){return o.generate(N,K).with({scheme:B})}o.generateCellPropertyUri=z;function $(N,K){if(N.scheme===K)return o.parse(N.with({scheme:o.scheme}))}o.parseCellPropertyUri=$})(v=e.CellUri||(e.CellUri={}));const m=o=>b.isWindows?o.replace(/\//g,"\\"):o;class a{constructor(u=[],h=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=h,this.order=[...new Set(u)].map(y=>({pattern:y,matches:t.parse(m(y))}))}sort(u){const h=new Map(C.Iterable.map(u,R=>[R,m(R)]));let y=[];for(const{matches:R}of this.order)for(const[M,U]of h)if(R(U)){y.push(M),h.delete(M);break}return h.size&&(y=y.concat([...h.keys()].sort((R,M)=>this.defaultOrder.indexOf(R)-this.defaultOrder.indexOf(M)))),y}prioritize(u,h){const y=this.findIndex(u);if(y===-1){this.order.unshift({pattern:u,matches:t.parse(m(u))});return}const R=new Set(h.map(U=>this.findIndex(U,y)));R.delete(-1);const M=Array.from(R).sort();this.order.splice(y+1,0,...M.map(U=>this.order[U]));for(let U=M.length-1;U>=0;U--)this.order.splice(M[U],1)}toArray(){return this.order.map(u=>u.pattern)}findIndex(u,h=this.order.length){const y=m(u);for(let R=0;R<h;R++)if(this.order[R].matches(y))return R;return-1}}e.MimeTypeDisplayOrder=a;function g(o,u,h,y=(R,M)=>R===M){const R=[];function M(z,$,N){if($===0&&N.length===0)return;const K=R[R.length-1];K&&K.start+K.deleteCount===z?(K.deleteCount+=$,K.toInsert.push(...N)):R.push({start:z,deleteCount:$,toInsert:N})}let U=0,A=0;for(;;){if(U===o.length){M(U,0,u.slice(A));break}if(A===u.length){M(U,o.length-U,[]);break}const z=o[U],$=u[A];if(y(z,$)){U+=1,A+=1;continue}h($)?(M(U,1,[]),U+=1):(M(U,0,[$]),A+=1)}return R}e.diff=g,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new I.RawContextKey("notebookEditorCursorAtBoundary","none");var n;(function(o){o.default="default",o.option="option"})(n=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function d(o){const u=o;return!!((typeof u.include=="string"||t.isRelativePattern(u.include))&&(typeof u.exclude=="string"||t.isRelativePattern(u.exclude)))}e.isDocumentExcludePattern=d;function s(o,u,h){if(Array.isArray(o.viewType)&&o.viewType.indexOf(u)>=0||o.viewType===u)return!0;if(o.filenamePattern){const y=d(o.filenamePattern)?o.filenamePattern.include:o.filenamePattern,R=d(o.filenamePattern)?o.filenamePattern.exclude:void 0;if(t.match(y,(0,D.basename)(h.fsPath).toLowerCase()))return!(R&&t.match(R,(0,D.basename)(h.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=s,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily"};var i;(function(o){o[o.Left=1]="Left",o[o.Right=2]="Right"})(i=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class r{static create(u){return`${r._prefix}${u}`}static parse(u){if(u.startsWith(r._prefix))return u.substring(r._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=r,r._prefix="notebook/";function c(o){return["application/vnd.code.notebook.stdout","application/x.notebook.stdout","application/x.notebook.stream","application/vnd.code.notebook.stderr","application/x.notebook.stderr"].includes(o)}e.isTextStreamMime=c}),define(De[214],Ie([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var t;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState"})(t=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,l.createDecorator)("INotebookExecutionService")}),define(De[215],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function l(_){return[..._.entries()]}e.serializeEnvironmentVariableCollection=l;function t(_){return new Map(_)}e.deserializeEnvironmentVariableCollection=t;function C(_){return Array.from(_.entries()).map(D=>[D[0],l(D[1].map)])}e.serializeEnvironmentVariableCollections=C;function P(_){return new Map(_.map(D=>[D[0],{map:t(D[1])}]))}e.deserializeEnvironmentVariableCollections=P}),define(De[63],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var l;(function(P){P.Delimiter="\0"})(l=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(P){P[P.IsSame=0]="IsSame",P[P.Disconnected=1]="Disconnected",P[P.IsChild=2]="IsChild",P[P.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class C{constructor(_,D=_.length){if(this.path=_,this.viewEnd=D,_.length===0||D<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(_,D,b=_.parent){if(_.id===D)return new C([D]);const I=[_.id];for(let L=b;L&&L.id!==D;L=L.parent)I.push(L.id);return I.push(D),new C(I.reverse())}static isRoot(_){return!_.includes("\0")}static root(_){const D=_.indexOf("\0");return D===-1?_:_.slice(0,D)}static fromString(_){return new C(_.split("\0"))}static join(_,D){return new C([..._.path,D])}static joinToString(_,D){return _.toString()+"\0"+D}static compare(_,D){return _===D?0:D.startsWith(_+"\0")?2:_.startsWith(D+"\0")?3:1}get parentId(){return this.viewEnd>1?new C(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let _=1;_<=this.viewEnd;_++)yield new C(this.path,_)}compare(_){if(typeof _=="string")return C.compare(this.toString(),_);for(let D=0;D<_.viewEnd&&D<this.viewEnd;D++)if(_.path[D]!==this.path[D])return 1;return _.viewEnd>this.viewEnd?2:_.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let _=1;_<this.viewEnd;_++)this.stringifed+="\0",this.stringifed+=this.path[_]}return this.stringifed}}e.TestId=C}),define(De[64],Ie([1,0,2,35]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var C;(function(r){r[r.Unset=0]="Unset",r[r.Queued=1]="Queued",r[r.Running=2]="Running",r[r.Passed=3]="Passed",r[r.Failed=4]="Failed",r[r.Skipped=5]="Skipped",r[r.Errored=6]="Errored"})(C=e.TestResultState||(e.TestResultState={}));var P;(function(r){r[r.Run=2]="Run",r[r.Debug=4]="Debug",r[r.Coverage=8]="Coverage",r[r.HasNonDefaultProfile=16]="HasNonDefaultProfile",r[r.HasConfigurable=32]="HasConfigurable"})(P=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var _;(function(r){r.serialize=c=>({range:c.range.toJSON(),uri:c.uri.toJSON()}),r.deserialize=c=>({range:t.Range.lift(c.range),uri:l.URI.revive(c.uri)})})(_=e.IRichLocation||(e.IRichLocation={}));var D;(function(r){r[r.Error=0]="Error",r[r.Output=1]="Output"})(D=e.TestMessageType||(e.TestMessageType={}));var b;(function(r){r.serialize=c=>({message:c.message,type:0,expected:c.expected,actual:c.actual,location:c.location&&_.serialize(c.location)}),r.deserialize=c=>({message:c.message,type:0,expected:c.expected,actual:c.actual,location:c.location&&_.deserialize(c.location)})})(b=e.ITestErrorMessage||(e.ITestErrorMessage={}));var I;(function(r){r.serialize=c=>({message:c.message,type:1,offset:c.offset,length:c.length,location:c.location&&_.serialize(c.location)}),r.deserialize=c=>({message:c.message,type:1,offset:c.offset,length:c.length,location:c.location&&_.deserialize(c.location)})})(I=e.ITestOutputMessage||(e.ITestOutputMessage={}));var L;(function(r){r.serialize=c=>c.type===0?b.serialize(c):I.serialize(c),r.deserialize=c=>c.type===0?b.deserialize(c):I.deserialize(c)})(L=e.ITestMessage||(e.ITestMessage={}));var k;(function(r){r.serializeWithoutMessages=c=>({state:c.state,duration:c.duration,messages:[]}),r.serialize=c=>({state:c.state,duration:c.duration,messages:c.messages.map(L.serialize)}),r.deserialize=c=>({state:c.state,duration:c.duration,messages:c.messages.map(L.deserialize)})})(k=e.ITestTaskState||(e.ITestTaskState={}));const S="\0",T=(r,c)=>r+S+c;e.namespaceTestTag=T;const E=r=>{const c=r.indexOf(S);return{ctrlId:r.slice(0,c),tagId:r.slice(c+1)}};e.denamespaceTestTag=E;var p;(function(r){r.serialize=c=>({extId:c.extId,label:c.label,tags:c.tags,busy:c.busy,children:void 0,uri:c.uri?.toJSON(),range:c.range?.toJSON()||null,description:c.description,error:c.error,sortText:c.sortText}),r.deserialize=c=>({extId:c.extId,label:c.label,tags:c.tags,busy:c.busy,children:void 0,uri:c.uri?l.URI.revive(c.uri):void 0,range:c.range?t.Range.lift(c.range):null,description:c.description,error:c.error,sortText:c.sortText})})(p=e.ITestItem||(e.ITestItem={}));var w;(function(r){r[r.NotExpandable=0]="NotExpandable",r[r.Expandable=1]="Expandable",r[r.BusyExpanding=2]="BusyExpanding",r[r.Expanded=3]="Expanded"})(w=e.TestItemExpandState||(e.TestItemExpandState={}));var f;(function(r){r.serialize=c=>({controllerId:c.controllerId,expand:c.expand,parent:c.parent,item:p.serialize(c.item)}),r.deserialize=c=>({controllerId:c.controllerId,expand:c.expand,parent:c.parent,item:p.deserialize(c.item)})})(f=e.InternalTestItem||(e.InternalTestItem={}));var v;(function(r){r.serialize=c=>{let o;return c.item&&(o={},c.item.label!==void 0&&(o.label=c.item.label),c.item.tags!==void 0&&(o.tags=c.item.tags),c.item.busy!==void 0&&(o.busy=c.item.busy),c.item.uri!==void 0&&(o.uri=c.item.uri?.toJSON()),c.item.range!==void 0&&(o.range=c.item.range?.toJSON()),c.item.description!==void 0&&(o.description=c.item.description),c.item.error!==void 0&&(o.error=c.item.error),c.item.sortText!==void 0&&(o.sortText=c.item.sortText)),{extId:c.extId,expand:c.expand,item:o,docv:c.docv}},r.deserialize=c=>{let o;return c.item&&(o={},c.item.label!==void 0&&(o.label=c.item.label),c.item.tags!==void 0&&(o.tags=c.item.tags),c.item.busy!==void 0&&(o.busy=c.item.busy),c.item.range!==void 0&&(o.range=c.item.range?t.Range.lift(c.item.range):null),c.item.description!==void 0&&(o.description=c.item.description),c.item.error!==void 0&&(o.error=c.item.error),c.item.sortText!==void 0&&(o.sortText=c.item.sortText)),{extId:c.extId,expand:c.expand,item:o,docv:c.docv}}})(v=e.ITestItemUpdate||(e.ITestItemUpdate={}));const m=(r,c)=>{c.expand!==void 0&&(r.expand=c.expand),c.item!==void 0&&(r.item=r.item?Object.assign(r.item,c.item):c.item)};e.applyTestItemUpdate=m;var a;(function(r){r.serializeWithoutMessages=c=>({...f.serialize(c),ownComputedState:c.ownComputedState,computedState:c.computedState,tasks:c.tasks.map(k.serializeWithoutMessages),retired:c.retired}),r.serialize=c=>({...f.serialize(c),ownComputedState:c.ownComputedState,computedState:c.computedState,tasks:c.tasks.map(k.serialize),retired:c.retired})})(a=e.TestResultItem||(e.TestResultItem={}));var g;(function(r){r[r.Function=0]="Function",r[r.Statement=1]="Statement"})(g=e.DetailType||(e.DetailType={}));var n;(function(r){r[r.Add=0]="Add",r[r.Update=1]="Update",r[r.Remove=2]="Remove",r[r.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",r[r.Retire=4]="Retire",r[r.AddTag=5]="AddTag",r[r.RemoveTag=6]="RemoveTag"})(n=e.TestDiffOpType||(e.TestDiffOpType={}));var d;(function(r){r.deserialize=c=>c.op===0?{op:c.op,item:f.deserialize(c.item)}:c.op===1?{op:c.op,item:v.deserialize(c.item)}:c,r.serialize=c=>c.op===0?{op:c.op,item:f.serialize(c.item)}:c.op===1?{op:c.op,item:v.serialize(c.item)}:c})(d=e.TestsDiffOp||(e.TestsDiffOp={}));class s{add(c){}update(c){}remove(c,o){}complete(){}}e.IncrementalChangeCollector=s;class i{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(c){const o=this.createChangeCollector();for(const u of c)switch(u.op){case 0:{const h=f.deserialize(u.item);if(h.parent){if(this.items.has(h.parent)){const y=this.items.get(h.parent);y.children.add(h.item.extId);const R=this.createItem(h,y);this.items.set(h.item.extId,R),o.add(R)}}else{const y=this.createItem(h);this.roots.add(y),this.items.set(h.item.extId,y),o.add(y)}h.expand===2&&this.busyControllerCount++;break}case 1:{const h=v.deserialize(u.item),y=this.items.get(h.extId);if(!y)break;h.expand!==void 0&&(y.expand===2&&this.busyControllerCount--,h.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(y,h),o.update(y);break}case 2:{const h=this.items.get(u.itemId);if(!h)break;h.parent?this.items.get(h.parent).children.delete(h.item.extId):this.roots.delete(h);const y=[[u.itemId]];for(;y.length;)for(const R of y.pop()){const M=this.items.get(R);M&&(y.push(M.children),this.items.delete(R),o.remove(M,M!==h),M.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(u.itemId);break;case 3:this.updatePendingRoots(u.amount);break;case 5:this._tags.set(u.tag.id,u.tag);break;case 6:this._tags.delete(u.id);break}o.complete()}retireTest(c){}updatePendingRoots(c){this.pendingRootCount+=c}createChangeCollector(){return new s}}e.AbstractIncrementalTestCollection=i}),define(De[90],Ie([1,0,18,4,6,48,64,63]),function(J,e,l,t,C,P,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var b;(function(f){f[f.Upsert=0]="Upsert",f[f.SetTags=1]="SetTags",f[f.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",f[f.RemoveChild=3]="RemoveChild",f[f.SetProp=4]="SetProp",f[f.Bulk=5]="Bulk"})(b=e.TestItemEventOp||(e.TestItemEventOp={}));const I=(f,v)=>f===v,L={range:(f,v)=>f===v?!0:!f||!v?!1:f.equalsRange(v),busy:I,label:I,description:I,error:I,tags:(f,v)=>!(f.length!==v.length||f.some(m=>!v.includes(m)))},k=(f,v)=>{let m;for(const[a,g]of Object.entries(L))g(f[a],v[a])||(m?m[a]=v[a]:m={[a]:v[a]});return m};class S extends C.Disposable{constructor(v){super(),this.options=v,this.debounceSendDiff=this._register(new l.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new t.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}get root(){return this.options.root}set resolveHandler(v){this._resolveHandler=v;for(const m of this.tree.values())this.updateExpandability(m)}collectDiff(){const v=this.diff;return this.diff=[],v}pushDiff(v){const m=this.diff[this.diff.length-1];if(m&&v.op===1){if(m.op===1&&m.item.extId===v.item.extId){(0,_.applyTestItemUpdate)(m.item,v.item);return}if(m.op===0&&m.item.item.extId===v.item.extId){(0,_.applyTestItemUpdate)(m.item,v.item);return}}this.diff.push(v),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(v,m){const a=this.tree.get(v);if(!!a){if((a.expandLevels===void 0||m>a.expandLevels)&&(a.expandLevels=m),a.expand===1){const g=this.resolveChildren(a);return g.isOpen()?this.expandChildren(a,m-1):g.wait().then(()=>this.expandChildren(a,m-1))}else if(a.expand===3)return a.resolveBarrier?.isOpen()===!1?a.resolveBarrier.wait().then(()=>this.expandChildren(a,m-1)):this.expandChildren(a,m-1)}}dispose(){for(const v of this.tree.values())this.options.getApiFor(v.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(v,m){switch(m.op){case 3:this.removeItem(D.TestId.joinToString(v.fullId,m.id));break;case 0:this.upsertItem(m.item,v);break;case 5:for(const a of m.ops)this.onTestItemEvent(v,a);break;case 1:this.diffTagRefs(m.new,m.old,v.fullId.toString());break;case 2:this.updateExpandability(v);break;case 4:this.pushDiff({op:1,item:{extId:v.fullId.toString(),item:m.update,docv:this.options.getDocumentVersion(v.actual.uri)}});break;default:(0,P.assertNever)(m)}}upsertItem(v,m){const a=D.TestId.fromExtHostTestItem(v,this.root.id,m?.actual),g=this.options.getApiFor(v);g.parent&&g.parent!==m?.actual&&this.options.getChildren(g.parent).delete(v.id);let n=this.tree.get(a.toString());if(!n){n={fullId:a,actual:v,parent:m?a.parentId:null,expandLevels:m?.expandLevels?m.expandLevels-1:void 0,expand:0},v.tags.forEach(this.incrementTagRefs,this),this.tree.set(n.fullId.toString(),n),this.setItemParent(v,m),this.pushDiff({op:0,item:{parent:n.parent&&n.parent.toString(),controllerId:this.options.controllerId,expand:n.expand,item:this.options.toITestItem(v)}}),this.connectItemAndChildren(v,n,m);return}if(n.actual===v){this.connectItem(v,n,m);return}const d=this.options.getChildren(n.actual),s=n.actual,i=k(this.options.toITestItem(s),this.options.toITestItem(v));this.options.getApiFor(s).listener=void 0,n.actual=v,n.expand=0,i&&(i.hasOwnProperty("tags")&&(this.diffTagRefs(v.tags,s.tags,a.toString()),delete i.tags),this.onTestItemEvent(n,{op:4,update:i})),this.connectItemAndChildren(v,n,m);for(const[r,c]of d)this.options.getChildren(v).get(c.id)||this.removeItem(D.TestId.joinToString(a,c.id))}diffTagRefs(v,m,a){const g=new Set(m.map(n=>n.id));for(const n of v)g.delete(n.id)||this.incrementTagRefs(n);this.pushDiff({op:1,item:{extId:a,item:{tags:v.map(n=>(0,_.namespaceTestTag)(this.options.controllerId,n.id))}}}),g.forEach(this.decrementTagRefs,this)}incrementTagRefs(v){const m=this.tags.get(v.id);m?m.refCount++:(this.tags.set(v.id,{refCount:1}),this.pushDiff({op:5,tag:{id:(0,_.namespaceTestTag)(this.options.controllerId,v.id)}}))}decrementTagRefs(v){const m=this.tags.get(v);m&&!--m.refCount&&(this.tags.delete(v),this.pushDiff({op:6,id:(0,_.namespaceTestTag)(this.options.controllerId,v)}))}setItemParent(v,m){this.options.getApiFor(v).parent=m&&m.actual!==this.root?m.actual:void 0}connectItem(v,m,a){this.setItemParent(v,a);const g=this.options.getApiFor(v);g.parent=a?.actual,g.listener=n=>this.onTestItemEvent(m,n),this.updateExpandability(m)}connectItemAndChildren(v,m,a){this.connectItem(v,m,a);for(const[g,n]of this.options.getChildren(v))this.upsertItem(n,m)}updateExpandability(v){let m;this._resolveHandler?v.resolveBarrier?m=v.resolveBarrier.isOpen()?3:2:m=v.actual.canResolveChildren?1:0:m=0,m!==v.expand&&(v.expand=m,this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:m}}),m===1&&v.expandLevels!==void 0&&this.resolveChildren(v))}expandChildren(v,m){if(m<0)return;const a=[];for(const[g,n]of this.options.getChildren(v.actual)){const d=this.expand(D.TestId.joinToString(v.fullId,n.id),m);(0,l.isThenable)(d)&&a.push(d)}if(a.length)return Promise.all(a).then(()=>{})}resolveChildren(v){if(v.resolveBarrier)return v.resolveBarrier;if(!this._resolveHandler){const n=new l.Barrier;return n.open(),n}v.expand=2,this.pushExpandStateUpdate(v);const m=v.resolveBarrier=new l.Barrier,a=n=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,n)};let g;try{g=this._resolveHandler(v.actual===this.root?void 0:v.actual)}catch(n){a(n)}return(0,l.isThenable)(g)?g.catch(a).then(()=>{m.open(),this.updateExpandability(v)}):(m.open(),this.updateExpandability(v)),v.resolveBarrier}pushExpandStateUpdate(v){this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:v.expand}})}removeItem(v){const m=this.tree.get(v);if(!m)throw new Error("attempting to remove non-existent child");this.pushDiff({op:2,itemId:v});const a=[m];for(;a.length;){const g=a.pop();if(!!g){this.options.getApiFor(g.actual).listener=void 0;for(const n of g.actual.tags)this.decrementTagRefs(n.id);this.tree.delete(g.fullId.toString());for(const[n,d]of this.options.getChildren(g.actual))a.push(this.tree.get(D.TestId.joinToString(g.fullId,d.id)))}}}flushDiff(){const v=this.collectDiff();v.length&&this.diffOpEmitter.fire(v)}}e.TestItemCollection=S;class T extends Error{constructor(v){super(`Attempted to insert a duplicate test item ID ${v}`)}}e.DuplicateTestItemError=T;class E extends Error{constructor(v){super(`TestItem with ID "${v}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=E;class p extends Error{constructor(v,m,a){super(`TestItem with ID "${v}" is from controller "${m}" and cannot be added as a child of an item from controller "${a}".`)}}e.MixedTestItemController=p;const w=(f,v,m)=>{let a=new Map;return{get size(){return a.size},forEach(g,n){for(const d of a.values())g.call(n,d,this)},[Symbol.iterator](){return a.entries()},replace(g){const n=new Map,d=new Set(a.keys()),s={op:5,ops:[]};for(const i of g){if(!(i instanceof m))throw new E(i.id);const r=v(i).controllerId;if(r!==f.controllerId)throw new p(i.id,r,f.controllerId);if(n.has(i.id))throw new T(i.id);n.set(i.id,i),d.delete(i.id),s.ops.push({op:0,item:i})}for(const i of d.keys())s.ops.push({op:3,id:i});f.listener?.(s),a=n},add(g){if(!(g instanceof m))throw new E(g.id);a.set(g.id,g),f.listener?.({op:0,item:g})},delete(g){a.delete(g)&&f.listener?.({op:3,id:g})},get(g){return a.get(g)},toJSON(){return Array.from(a.values())}}};e.createTestItemChildren=w}),define(De[128],Ie([1,0,90]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const t=new WeakMap,C=(_,D)=>{const b={controllerId:D};return t.set(_,b),b};e.createPrivateApiFor=C;const P=_=>{const D=t.get(_);if(!D)throw new l.InvalidTestItemError(_?.id||"<unknown>");return D};e.getPrivateApiFor=P}),define(De[216],Ie([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,l.createDecorator)("configurationResolverService");var t;(function(P){P.Unknown="unknown",P.Env="env",P.Config="config",P.Command="command",P.Input="input",P.ExtensionInstallFolder="extensionInstallFolder",P.WorkspaceFolder="workspaceFolder",P.Cwd="cwd",P.WorkspaceFolderBasename="workspaceFolderBasename",P.UserHome="userHome",P.LineNumber="lineNumber",P.SelectedText="selectedText",P.File="file",P.FileWorkspaceFolder="fileWorkspaceFolder",P.RelativeFile="relativeFile",P.RelativeFileDirname="relativeFileDirname",P.FileDirname="fileDirname",P.FileExtname="fileExtname",P.FileBasename="fileBasename",P.FileBasenameNoExtension="fileBasenameNoExtension",P.FileDirnameBasename="fileDirnameBasename",P.ExecPath="execPath",P.ExecInstallFolder="execInstallFolder",P.PathSeparator="pathSeparator"})(t=e.VariableKind||(e.VariableKind={}));class C extends Error{constructor(_,D){super(D),this.variable=_}}e.VariableError=C}),define(De[217],Ie([1,0,9,40,14,24,11,107,184,216,8]),function(J,e,l,t,C,P,_,D,b,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{constructor(T,E,p,w){this._contributedVariables=new Map,this._context=T,this._labelService=E,this._userHomePromise=p,w&&(this._envVariablesPromise=w.then(f=>this.prepareEnv(f)))}prepareEnv(T){if(_.isWindows){const E=Object.create(null);return Object.keys(T).forEach(p=>{E[p.toLowerCase()]=T[p]}),E}return T}resolveWithEnvironment(T,E,p){return this.recursiveResolve({env:this.prepareEnv(T),userHome:void 0},E?E.uri:void 0,p)}async resolveAsync(T,E){const p={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(p,T?T.uri:void 0,E)}async resolveAnyBase(T,E,p,w){const f=P.deepClone(E);_.isWindows&&f.windows?Object.keys(f.windows).forEach(m=>f[m]=f.windows[m]):_.isMacintosh&&f.osx?Object.keys(f.osx).forEach(m=>f[m]=f.osx[m]):_.isLinux&&f.linux&&Object.keys(f.linux).forEach(m=>f[m]=f.linux[m]),delete f.windows,delete f.osx,delete f.linux;const v={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(v,T?T.uri:void 0,f,p,w)}async resolveAnyAsync(T,E,p){return this.resolveAnyBase(T,E,p)}async resolveAnyMap(T,E,p){const w=new Map;return{newConfig:await this.resolveAnyBase(T,E,p,w),resolvedVariables:w}}resolveWithInteractionReplace(T,E,p,w){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(T,E,p,w){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(T,E){if(this._contributedVariables.has(T))throw new Error("Variable "+T+" is contributed twice.");this._contributedVariables.set(T,E)}async recursiveResolve(T,E,p,w,f){if(C.isString(p))return this.resolveString(T,E,p,w,f);if(Array.isArray(p))return Promise.all(p.map(v=>this.recursiveResolve(T,E,v,w,f)));if(C.isObject(p)){const v=Object.create(null),m=await Promise.all(Object.keys(p).map(async a=>[await this.resolveString(T,E,a,w,f),await this.recursiveResolve(T,E,p[a],w,f)]));for(const[a,g]of m)v[a]=g;return v}return p}resolveString(T,E,p,w,f){return(0,L.replaceAsync)(p,k.VARIABLE_REGEXP,async(v,m)=>{if(m.includes(k.VARIABLE_LHS))return v;let a=await this.evaluateSingleVariable(T,v,m,E,w);return f?.set(m,a),a!==v&&C.isString(a)&&a.match(k.VARIABLE_REGEXP)&&(a=await this.resolveString(T,E,a,w,f)),a})}fsPath(T){return this._labelService?this._labelService.getUriLabel(T,{noPrefix:!0}):T.fsPath}async evaluateSingleVariable(T,E,p,w,f){let v;const m=p.split(":");m.length>1&&(p=m[0],v=m[1]);const a=d=>{const s=this._context.getFilePath();if(s)return s;throw new I.VariableError(d,(0,b.localize)(0,null,E))},g=d=>{const s=a(d);if(this._context.getWorkspaceFolderPathForFile){const i=this._context.getWorkspaceFolderPathForFile();if(i)return i}throw new I.VariableError(d,(0,b.localize)(1,null,E,l.basename(s)))},n=d=>{if(v){const s=this._context.getFolderUri(v);if(s)return s;throw new I.VariableError(d,(0,b.localize)(2,null,E,v))}if(w)return w;throw this._context.getWorkspaceFolderCount()>1?new I.VariableError(d,(0,b.localize)(3,null,E)):new I.VariableError(d,(0,b.localize)(4,null,E))};switch(p){case"env":if(v){if(T.env){const d=T.env[_.isWindows?v.toLowerCase():v];if(C.isString(d))return d}return""}throw new I.VariableError(I.VariableKind.Env,(0,b.localize)(5,null,E));case"config":if(v){const d=this._context.getConfigurationValue(w,v);if(C.isUndefinedOrNull(d))throw new I.VariableError(I.VariableKind.Config,(0,b.localize)(6,null,E,v));if(C.isObject(d))throw new I.VariableError(I.VariableKind.Config,(0,b.localize)(7,null,E,v));return d}throw new I.VariableError(I.VariableKind.Config,(0,b.localize)(8,null,E));case"command":return this.resolveFromMap(I.VariableKind.Command,E,v,f,"command");case"input":return this.resolveFromMap(I.VariableKind.Input,E,v,f,"input");case"extensionInstallFolder":if(v){const d=await this._context.getExtension(v);if(!d)throw new I.VariableError(I.VariableKind.ExtensionInstallFolder,(0,b.localize)(9,null,E,v));return this.fsPath(d.extensionLocation)}throw new I.VariableError(I.VariableKind.ExtensionInstallFolder,(0,b.localize)(10,null,E));default:switch(p){case"workspaceRoot":case"workspaceFolder":return(0,D.normalizeDriveLetter)(this.fsPath(n(I.VariableKind.WorkspaceFolder)));case"cwd":return w||v?(0,D.normalizeDriveLetter)(this.fsPath(n(I.VariableKind.Cwd))):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return l.basename(this.fsPath(n(I.VariableKind.WorkspaceFolderBasename)));case"userHome":{if(T.userHome)return T.userHome;throw new I.VariableError(I.VariableKind.UserHome,(0,b.localize)(11,null,E))}case"lineNumber":{const d=this._context.getLineNumber();if(d)return d;throw new I.VariableError(I.VariableKind.LineNumber,(0,b.localize)(12,null,E))}case"selectedText":{const d=this._context.getSelectedText();if(d)return d;throw new I.VariableError(I.VariableKind.SelectedText,(0,b.localize)(13,null,E))}case"file":return a(I.VariableKind.File);case"fileWorkspaceFolder":return g(I.VariableKind.FileWorkspaceFolder);case"relativeFile":return w||v?l.relative(this.fsPath(n(I.VariableKind.RelativeFile)),a(I.VariableKind.RelativeFile)):a(I.VariableKind.RelativeFile);case"relativeFileDirname":{const d=l.dirname(a(I.VariableKind.RelativeFileDirname));if(w||v){const s=l.relative(this.fsPath(n(I.VariableKind.RelativeFileDirname)),d);return s.length===0?".":s}return d}case"fileDirname":return l.dirname(a(I.VariableKind.FileDirname));case"fileExtname":return l.extname(a(I.VariableKind.FileExtname));case"fileBasename":return l.basename(a(I.VariableKind.FileBasename));case"fileBasenameNoExtension":{const d=l.basename(a(I.VariableKind.FileBasenameNoExtension));return d.slice(0,d.length-l.extname(d).length)}case"fileDirnameBasename":return l.basename(l.dirname(a(I.VariableKind.FileDirnameBasename)));case"execPath":{const d=this._context.getExecPath();return d||E}case"execInstallFolder":{const d=this._context.getAppRoot();return d||E}case"pathSeparator":return l.sep;default:try{const d=v?`${p}:${v}`:p;return this.resolveFromMap(I.VariableKind.Unknown,E,d,f,void 0)}catch{return E}}}}resolveFromMap(T,E,p,w,f){if(p&&w){const v=f===void 0?w[p]:w[f+":"+p];if(typeof v=="string")return v;throw new I.VariableError(T,(0,b.localize)(14,null,E))}return E}}e.AbstractVariableResolverService=k,k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(De[129],Ie([1,0,3,126]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,l.createDecorator)("editorGroupsService");var C;(function(E){E[E.UP=0]="UP",E[E.DOWN=1]="DOWN",E[E.LEFT=2]="LEFT",E[E.RIGHT=3]="RIGHT"})(C=e.GroupDirection||(e.GroupDirection={}));var P;(function(E){E[E.HORIZONTAL=0]="HORIZONTAL",E[E.VERTICAL=1]="VERTICAL"})(P=e.GroupOrientation||(e.GroupOrientation={}));var _;(function(E){E[E.FIRST=0]="FIRST",E[E.LAST=1]="LAST",E[E.NEXT=2]="NEXT",E[E.PREVIOUS=3]="PREVIOUS"})(_=e.GroupLocation||(e.GroupLocation={}));var D;(function(E){E[E.MAXIMIZE=0]="MAXIMIZE",E[E.EVEN=1]="EVEN",E[E.TOGGLE=2]="TOGGLE"})(D=e.GroupsArrangement||(e.GroupsArrangement={}));var b;(function(E){E[E.COPY_EDITORS=0]="COPY_EDITORS",E[E.MOVE_EDITORS=1]="MOVE_EDITORS"})(b=e.MergeGroupMode||(e.MergeGroupMode={}));function I(E){const p=E;return(0,t.isEditorInput)(p?.editor)&&(0,t.isEditorInput)(p?.replacement)}e.isEditorReplacement=I;var L;(function(E){E[E.CREATION_TIME=0]="CREATION_TIME",E[E.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",E[E.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L=e.GroupsOrder||(e.GroupsOrder={}));var k;(function(E){E[E.NEW_EDITOR=1]="NEW_EDITOR",E[E.MOVE_EDITOR=2]="MOVE_EDITOR",E[E.COPY_EDITOR=3]="COPY_EDITOR"})(k=e.OpenEditorContext||(e.OpenEditorContext={}));function S(E){const p=E;return!!p&&typeof p.id=="number"&&Array.isArray(p.editors)}e.isEditorGroup=S;function T(E){return E.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=T}),define(De[218],Ie([1,0,3,129]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,l.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function C(P){const _=P;return typeof P=="number"||(0,t.isEditorGroup)(_)}e.isPreferredGroup=C}),define(De[219],Ie([1,0,3,189]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,l.refineServiceDecorator)(t.IEnvironmentService)}),define(De[220],Ie([1,0,28,4,9]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class P{constructor(k){this.removedDueToLooping=k}}e.DeltaExtensionsResult=P;class _{constructor(k){this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=k,this._initialize()}_initialize(){this._extensionDescriptions.sort(b),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const k of this._extensionDescriptions){if(this._extensionsMap.has(l.ExtensionIdentifier.toKey(k.identifier))){console.error("Extension `"+k.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(l.ExtensionIdentifier.toKey(k.identifier),k),this._extensionsArr.push(k),Array.isArray(k.activationEvents))for(let S of k.activationEvents)S==="onUri"&&(S=`onUri:${l.ExtensionIdentifier.toKey(k.identifier)}`),this._activationMap.has(S)||this._activationMap.set(S,[]),this._activationMap.get(S).push(k)}}set(k){this._extensionDescriptions=k,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(k,S){this._extensionDescriptions=I(this._extensionDescriptions,S),this._extensionDescriptions=this._extensionDescriptions.concat(k);const T=_._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=I(this._extensionDescriptions,T.map(E=>E.identifier)),this._initialize(),this._onDidChange.fire(void 0),new P(T)}static _findLoopingExtensions(k){const S=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(f){this._nodesSet.has(f)||(this._nodesSet.add(f),this._nodesArr.push(f))}addArc(f,v){this.addNode(f),this.addNode(v),this._arcs.has(f)?this._arcs.get(f).push(v):this._arcs.set(f,[v])}getArcs(f){return this._arcs.has(f)?this._arcs.get(f):[]}hasOnlyGoodArcs(f,v){const m=S.getArcs(f);for(let a=0;a<m.length;a++)if(!v.has(m[a]))return!1;return!0}getNodes(){return this._nodesArr}},T=new Map;for(const f of k){const v=l.ExtensionIdentifier.toKey(f.identifier);if(T.set(v,f),f.extensionDependencies)for(const m of f.extensionDependencies){const a=l.ExtensionIdentifier.toKey(m);S.addArc(v,a)}}const E=new Set;S.getNodes().filter(f=>S.getArcs(f).length===0).forEach(f=>E.add(f));const p=S.getNodes().filter(f=>!E.has(f));let w;do{w=!1;for(let f=0;f<p.length;f++){const v=p[f];S.hasOnlyGoodArcs(v,E)&&(p.splice(f,1),f--,E.add(v),w=!0)}}while(w);return p.map(f=>T.get(f))}containsActivationEvent(k){return this._activationMap.has(k)}containsExtension(k){return this._extensionsMap.has(l.ExtensionIdentifier.toKey(k))}getExtensionDescriptionsForActivationEvent(k){const S=this._activationMap.get(k);return S?S.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(k){const S=this._extensionsMap.get(l.ExtensionIdentifier.toKey(k));return S||void 0}getExtensionDescriptionByUUID(k){for(const S of this._extensionsArr)if(S.uuid===k)return S}getExtensionDescriptionByIdOrUUID(k,S){return this.getExtensionDescription(k)??(S?this.getExtensionDescriptionByUUID(S):void 0)}}e.ExtensionDescriptionRegistry=_;var D;(function(L){L[L.Builtin=0]="Builtin",L[L.User=1]="User",L[L.Dev=2]="Dev"})(D||(D={}));function b(L,k){const S=L.isBuiltin?0:L.isUnderDevelopment?2:1,T=k.isBuiltin?0:k.isUnderDevelopment?2:1;if(S!==T)return S-T;const E=C.posix.basename(L.extensionLocation.path),p=C.posix.basename(k.extensionLocation.path);return E<p?-1:E>p?1:0}function I(L,k){const S=new Set;return k.forEach(T=>S.add(l.ExtensionIdentifier.toKey(T))),L.filter(T=>!S.has(l.ExtensionIdentifier.toKey(T.identifier)))}}),define(De[221],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var l;(function(L){L[L.IPC=1]="IPC",L[L.Socket=2]="Socket",L[L.MessagePort=3]="MessagePort"})(l=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class t{constructor(k){this.pipeName=k,this.type=1}serialize(k){k[t.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=t,t.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class C{constructor(){this.type=2}serialize(k){k[C.ENV_KEY]="1"}}e.SocketExtHostConnection=C,C.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class P{constructor(){this.type=3}serialize(k){k[P.ENV_KEY]="1"}}e.MessagePortExtHostConnection=P,P.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function _(L){delete L[t.ENV_KEY],delete L[C.ENV_KEY],delete L[P.ENV_KEY]}function D(L,k){_(k),L.serialize(k)}e.writeExtHostConnection=D;function b(L){if(L[t.ENV_KEY])return I(L,new t(L[t.ENV_KEY]));if(L[C.ENV_KEY])return I(L,new C);if(L[P.ENV_KEY])return I(L,new P);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=b;function I(L,k){return _(L),k}}),define(De[130],Ie([1,0,23]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var t;(function(I){I[I.Desktop=1]="Desktop",I[I.Web=2]="Web"})(t=e.UIKind||(e.UIKind={}));var C;(function(I){I[I.VersionMismatch=55]="VersionMismatch",I[I.UnexpectedError=81]="UnexpectedError"})(C=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var P;(function(I){I[I.Initialized=0]="Initialized",I[I.Ready=1]="Ready",I[I.Terminate=2]="Terminate"})(P=e.MessageType||(e.MessageType={}));function _(I){const L=l.VSBuffer.alloc(1);switch(I){case 0:L.writeUInt8(1,0);break;case 1:L.writeUInt8(2,0);break;case 2:L.writeUInt8(3,0);break}return L}e.createMessageOfType=_;function D(I,L){if(I.byteLength!==1)return!1;switch(I.readUInt8(0)){case 1:return L===0;case 2:return L===1;case 3:return L===2;default:return!1}}e.isMessageOfType=D;var b;(function(I){I.Start="START_NATIVE_LOG",I.End="END_NATIVE_LOG"})(b=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(De[27],Ie([1,0,4,2,3,28,198]),function(J,e,l,t,C,P,_){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new P.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,C.createDecorator)("extensionService");class b{constructor(c){this.affinity=c,this.kind=1}equals(c){return this.kind===c.kind&&this.affinity===c.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=b;class I{constructor(){this.kind=2,this.affinity=0}equals(c){return this.kind===c.kind}asString(){return"LocalWebWorker"}}e.LocalWebWorkerRunningLocation=I;class L{constructor(){this.kind=3,this.affinity=0}equals(c){return this.kind===c.kind}asString(){return"Remote"}}e.RemoteRunningLocation=L;class k{constructor(c){this.dependency=c}}e.MissingExtensionDependency=k;var S;(function(r){r[r.LocalProcess=1]="LocalProcess",r[r.LocalWebWorker=2]="LocalWebWorker",r[r.Remote=3]="Remote"})(S=e.ExtensionHostKind||(e.ExtensionHostKind={}));function T(r){if(r===null)return"None";switch(r){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=T;class E{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(c,o){const u=[],h=[],y=[],R=[],M=f(this._allExtensions),U=f(c),A=(K,B)=>K.extensionLocation.toString()===B.extensionLocation.toString()||K.isBuiltin===B.isBuiltin||K.isUserBuiltin===B.isUserBuiltin||K.isUnderDevelopment===B.isUnderDevelopment;for(const K of this._allExtensions){const B=U.get(P.ExtensionIdentifier.toKey(K.identifier));if(!B){u.push(K.identifier),M.delete(P.ExtensionIdentifier.toKey(K.identifier));continue}if(!A(K,B)){u.push(K.identifier),M.delete(P.ExtensionIdentifier.toKey(K.identifier));continue}}for(const K of c){const B=M.get(P.ExtensionIdentifier.toKey(K.identifier));if(!B){h.push(K);continue}if(!A(B,K)){u.push(B.identifier),M.delete(P.ExtensionIdentifier.toKey(B.identifier));continue}}const z=w(this._myExtensions),$=w(o);for(const K of this._myExtensions)$.has(P.ExtensionIdentifier.toKey(K))||y.push(K);for(const K of o)z.has(P.ExtensionIdentifier.toKey(K))||R.push(K);const N={toRemove:u,toAdd:h,myToRemove:y,myToAdd:R};return this.delta(N),N}delta(c){const{toRemove:o,toAdd:u,myToRemove:h,myToAdd:y}=c,R=w(o),M=w(h);for(let U=0;U<this._allExtensions.length;U++)R.has(P.ExtensionIdentifier.toKey(this._allExtensions[U].identifier))&&(this._allExtensions.splice(U,1),U--);for(let U=0;U<this._myExtensions.length;U++)M.has(P.ExtensionIdentifier.toKey(this._myExtensions[U]))&&(this._myExtensions.splice(U,1),U--);for(const U of u)this._allExtensions.push(U);for(const U of y)this._myExtensions.push(U)}containsExtension(c){for(const o of this._myExtensions)if(P.ExtensionIdentifier.equals(o,c))return!0;return!1}}e.ExtensionHostExtensions=E;class p{constructor(c){if(this[D]="ExtensionIdentifierSet",this._map=new Map,this._toKey=P.ExtensionIdentifier.toKey,c)for(const o of c)this.add(o)}get size(){return this._map.size}add(c){return this._map.set(this._toKey(c),c),this}clear(){this._map.clear()}delete(c){return this._map.delete(this._toKey(c))}has(c){return this._map.has(this._toKey(c))}forEach(c,o){this._map.forEach(u=>c.call(o,u,u,this))}*entries(){for(const[c,o]of this._map)yield[o,o]}keys(){return this._map.values()}values(){return this._map.values()}[(D=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=p;function w(r){const c=new Set;for(const o of r)c.add(P.ExtensionIdentifier.toKey(o));return c}e.extensionIdentifiersArrayToSet=w;function f(r){const c=new Map;for(const o of r)c.set(P.ExtensionIdentifier.toKey(o.identifier),o);return c}function v(r,c){return r.enabledApiProposals?r.enabledApiProposals.includes(c):!1}e.isProposedApiEnabled=v;function m(r,c){if(!v(r,c))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${c}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${c}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}e.checkProposedApiEnabled=m;class a{constructor(c,o,u,h){this.codeLoadingTime=c,this.activateCallTime=o,this.activateResolvedTime=u,this.activationReason=h}}e.ActivationTimes=a;class g{constructor(c,o){this.description=c,this.value=o}}e.ExtensionPointContribution=g,e.ExtensionHostLogFileName="exthost";var n;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(n=e.ActivationKind||(e.ActivationKind={}));function d(r){return{type:r.isBuiltin?0:1,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,_.getGalleryExtensionId)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation,targetPlatform:r.targetPlatform,validations:[],isValid:!0}}e.toExtension=d;function s(r,c){return{identifier:new P.ExtensionIdentifier((0,_.getExtensionId)(r.manifest.publisher,r.manifest.name)),isBuiltin:r.type===0,isUserBuiltin:r.type===1&&r.isBuiltin,isUnderDevelopment:!!c,extensionLocation:r.location,...r.manifest,uuid:r.identifier.uuid,targetPlatform:r.targetPlatform,browserNlsBundleUris:r.browserNlsBundleUris}}e.toExtensionDescription=s;class i{constructor(){this.onDidRegisterExtensions=l.Event.None,this.onDidChangeExtensionsStatus=l.Event.None,this.onDidChangeExtensions=l.Event.None,this.onWillActivateByEvent=l.Event.None,this.onDidChangeResponsiveChange=l.Event.None}activateByEvent(c){return Promise.resolve(void 0)}activationEventIsDone(c){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(c){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(c,o){return Promise.resolve(0)}getInspectPorts(c,o){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(c){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(c,o){return Promise.resolve()}}e.NullExtensionService=i}),define(De[222],Ie([1,0,10,28,27,15,18]),function(J,e,l,t,C,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class D{constructor(w,f,v,m){this.startup=w,this.codeLoadingTime=f,this.activateCallTime=v,this.activateResolvedTime=m}}e.ExtensionActivationTimes=D,D.NONE=new D(!1,-1,-1,-1);class b{constructor(w){this._startup=w,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(w,f){return w===-1||f===-1?-1:f-w}build(){return new D(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=b;class I{constructor(w,f,v,m,a,g){this.activationFailed=w,this.activationFailedError=f,this.activationTimes=v,this.module=m,this.exports=a,this.subscriptions=g}}e.ActivatedExtension=I;class L extends I{constructor(w){super(!1,null,w,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=L;class k extends I{constructor(){super(!1,null,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=k;class S extends I{constructor(w){super(!0,w,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=S;let T=class{constructor(w,f,v,m,a){this._logService=a,this._registry=w,this._resolvedExtensionsSet=new Set,f.forEach(g=>this._resolvedExtensionsSet.add(t.ExtensionIdentifier.toKey(g))),this._externalExtensionsMap=new Map,v.forEach(g=>this._externalExtensionsMap.set(t.ExtensionIdentifier.toKey(g),g)),this._host=m,this._operations=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[w,f]of this._operations)f.dispose()}isActivated(w){const f=this._operations.get(t.ExtensionIdentifier.toKey(w));return Boolean(f&&f.value)}getActivatedExtension(w){const f=this._operations.get(t.ExtensionIdentifier.toKey(w));if(!f||!f.value)throw new Error(`Extension '${w.value}' is not known or not activated`);return f.value}async activateByEvent(w,f){if(this._alreadyActivatedEvents[w])return;const v=this._registry.getExtensionDescriptionsForActivationEvent(w);await this._activateExtensions(v.map(m=>({id:m.identifier,reason:{startup:f,extensionId:m.identifier,activationEvent:w}}))),this._alreadyActivatedEvents[w]=!0}activateById(w,f){const v=this._registry.getExtensionDescription(w);if(!v)throw new Error(`Extension '${w}' is not known`);return this._activateExtensions([{id:v.identifier,reason:f}])}async _activateExtensions(w){const f=w.filter(v=>!this.isActivated(v.id)).map(v=>this._handleActivationRequest(v));await Promise.all(f.map(v=>v.wait()))}_handleActivationRequest(w){if(this._operations.has(t.ExtensionIdentifier.toKey(w.id)))return this._operations.get(t.ExtensionIdentifier.toKey(w.id));if(this._externalExtensionsMap.has(t.ExtensionIdentifier.toKey(w.id)))return this._createAndSaveOperation(w,null,[],null);const f=this._registry.getExtensionDescription(w.id);if(!f){const a=new Error(`Cannot activate unknown extension '${w.id.value}'`),g=this._createAndSaveOperation(w,null,[],new S(a));return this._host.onExtensionActivationError(w.id,a,new C.MissingExtensionDependency(w.id.value)),g}const v=[],m=typeof f.extensionDependencies>"u"?[]:f.extensionDependencies;for(const a of m){if(this._resolvedExtensionsSet.has(t.ExtensionIdentifier.toKey(a)))continue;const g=this._operations.get(t.ExtensionIdentifier.toKey(a));if(g){v.push(g);continue}if(this._externalExtensionsMap.has(t.ExtensionIdentifier.toKey(a))){v.push(this._handleActivationRequest({id:this._externalExtensionsMap.get(t.ExtensionIdentifier.toKey(a)),reason:w.reason}));continue}const n=this._registry.getExtensionDescription(a);if(n){if(!n.main&&!n.browser)continue;v.push(this._handleActivationRequest({id:n.identifier,reason:w.reason}));continue}const d=f.displayName||f.identifier.value,s=new Error(`Cannot activate the '${d}' extension because it depends on unknown extension '${a}'`),i=this._createAndSaveOperation(w,f.displayName,[],new S(s));return this._host.onExtensionActivationError(f.identifier,s,new C.MissingExtensionDependency(a)),i}return this._createAndSaveOperation(w,f.displayName,v,null)}_createAndSaveOperation(w,f,v,m){const a=new E(w.id,f,w.reason,v,m,this._host,this._logService);return this._operations.set(t.ExtensionIdentifier.toKey(w.id),a),a}};T=qe([xe(4,P.ILogService)],T),e.ExtensionsActivator=T;let E=class{constructor(w,f,v,m,a,g,n){this._id=w,this._displayName=f,this._reason=v,this._deps=m,this._value=a,this._host=g,this._logService=n,this._barrier=new _.Barrier,this._isDisposed=!1,this._initialize()}get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let w=0;w<this._deps.length;w++){const f=this._deps[w];if(f.value&&!f.value.activationFailed){this._deps.splice(w,1),w--;continue}if(f.value&&f.value.activationFailed){const v=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${f.friendlyName}' failed to activate`);v.detail=f.value.activationFailedError,this._value=new S(v),this._host.onExtensionActivationError(this._id,v,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(w=>w.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(w){const f=new Error;if(w&&w.name&&(f.name=w.name),w&&w.message?f.message=`Activating extension '${this._id.value}' failed: ${w.message}.`:f.message=`Activating extension '${this._id.value}' failed: ${w}.`,w&&w.stack&&(f.stack=w.stack),this._value=new S(f),this._isDisposed&&l.isCancellationError(w))return;this._host.onExtensionActivationError(this._id,f,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(w)}}};E=qe([xe(6,P.ILogService)],E)}),define(De[223],Ie([1,0,15,26,27]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let P=class extends l.LogService{constructor(D,b){super(D.createLogger(b.logFile,{name:C.ExtensionHostLogFileName}))}};P=qe([xe(0,l.ILoggerService),xe(1,t.IExtHostInitDataService)],P),e.ExtHostLogService=P});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,C){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?C.call(J,l):C?C.value=l:e.set(J,l),l},Ue=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[7],Ie([1,0,17,10,106,25,101,8,14,2,34,42,122,89,27]),function(J,e,l,t,C,P,_,D,b,I,L,k,S,T,E){"use strict";var p,w,f,v,m,a,g,n,d,s,i,r,c,o,u,h,y,R,M,U,A,z,$;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function N(j){function W(){return Reflect.construct(j,arguments,this.constructor)}return Object.defineProperty(W,"name",Object.getOwnPropertyDescriptor(j,"name")),Object.setPrototypeOf(W,j),Object.setPrototypeOf(W.prototype,j.prototype),W}let K=a=class{constructor(W){p.set(this,void 0),tt(this,p,W,"f")}static from(...W){let he=W;return new a(function(){if(he){for(const Pe of he)Pe&&typeof Pe.dispose=="function"&&Pe.dispose();he=void 0}})}dispose(){typeof Ue(this,p,"f")=="function"&&(Ue(this,p,"f").call(this),tt(this,p,void 0,"f"))}};p=new WeakMap,K=a=qe([N],K),e.Disposable=K;let B=g=class{constructor(W,he){if(W<0)throw(0,t.illegalArgument)("line must be non-negative");if(he<0)throw(0,t.illegalArgument)("character must be non-negative");this._line=W,this._character=he}static Min(...W){if(W.length===0)throw new TypeError;let he=W[0];for(let Pe=1;Pe<W.length;Pe++){const Ge=W[Pe];Ge.isBefore(he)&&(he=Ge)}return he}static Max(...W){if(W.length===0)throw new TypeError;let he=W[0];for(let Pe=1;Pe<W.length;Pe++){const Ge=W[Pe];Ge.isAfter(he)&&(he=Ge)}return he}static isPosition(W){if(!W)return!1;if(W instanceof g)return!0;const{line:he,character:Pe}=W;return typeof he=="number"&&typeof Pe=="number"}static of(W){if(W instanceof g)return W;if(this.isPosition(W))return new g(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}isBefore(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<W._character}isBeforeOrEqual(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<=W._character}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this._line===W._line&&this._character===W._character}compareTo(W){return this._line<W._line?-1:this._line>W.line?1:this._character<W._character?-1:this._character>W._character?1:0}translate(W,he=0){if(W===null||he===null)throw(0,t.illegalArgument)();let Pe;return typeof W>"u"?Pe=0:typeof W=="number"?Pe=W:(Pe=typeof W.lineDelta=="number"?W.lineDelta:0,he=typeof W.characterDelta=="number"?W.characterDelta:0),Pe===0&&he===0?this:new g(this.line+Pe,this.character+he)}with(W,he=this.character){if(W===null||he===null)throw(0,t.illegalArgument)();let Pe;return typeof W>"u"?Pe=this.line:typeof W=="number"?Pe=W:(Pe=typeof W.line=="number"?W.line:this.line,he=typeof W.character=="number"?W.character:this.character),Pe===this.line&&he===this.character?this:new g(Pe,he)}toJSON(){return{line:this.line,character:this.character}}};B=g=qe([N],B),e.Position=B;let O=n=class{constructor(W,he,Pe,Ge){let nt,ut;if(typeof W=="number"&&typeof he=="number"&&typeof Pe=="number"&&typeof Ge=="number"?(nt=new B(W,he),ut=new B(Pe,Ge)):B.isPosition(W)&&B.isPosition(he)&&(nt=B.of(W),ut=B.of(he)),!nt||!ut)throw new Error("Invalid arguments");nt.isBefore(ut)?(this._start=nt,this._end=ut):(this._start=ut,this._end=nt)}static isRange(W){return W instanceof n?!0:W?B.isPosition(W.start)&&B.isPosition(W.end):!1}static of(W){if(W instanceof n)return W;if(this.isRange(W))return new n(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}contains(W){return n.isRange(W)?this.contains(W.start)&&this.contains(W.end):B.isPosition(W)?!(B.of(W).isBefore(this._start)||this._end.isBefore(W)):!1}isEqual(W){return this._start.isEqual(W._start)&&this._end.isEqual(W._end)}intersection(W){const he=B.Max(W.start,this._start),Pe=B.Min(W.end,this._end);if(!he.isAfter(Pe))return new n(he,Pe)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const he=B.Min(W.start,this._start),Pe=B.Max(W.end,this.end);return new n(he,Pe)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(W,he=this.end){if(W===null||he===null)throw(0,t.illegalArgument)();let Pe;return W?B.isPosition(W)?Pe=W:(Pe=W.start||this.start,he=W.end||this.end):Pe=this.start,Pe.isEqual(this._start)&&he.isEqual(this.end)?this:new n(Pe,he)}toJSON(){return[this.start,this.end]}};O=n=qe([N],O),e.Range=O;let x=d=class extends O{constructor(W,he,Pe,Ge){let nt,ut;if(typeof W=="number"&&typeof he=="number"&&typeof Pe=="number"&&typeof Ge=="number"?(nt=new B(W,he),ut=new B(Pe,Ge)):B.isPosition(W)&&B.isPosition(he)&&(nt=B.of(W),ut=B.of(he)),!nt||!ut)throw new Error("Invalid arguments");super(nt,ut),this._anchor=nt,this._active=ut}static isSelection(W){return W instanceof d?!0:W?O.isRange(W)&&B.isPosition(W.anchor)&&B.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};x=d=qe([N],x),e.Selection=x;class V{constructor(W,he,Pe){if(typeof W!="string"||W.length===0)throw(0,t.illegalArgument)("host");if(typeof he!="number"||he===0||Math.round(he)!==he)throw(0,t.illegalArgument)("port");if(typeof Pe<"u"&&(typeof Pe!="string"||Pe.length===0||!/^[0-9A-Za-z\-]+$/.test(Pe)))throw(0,t.illegalArgument)("connectionToken");this.host=W,this.port=Math.round(he),this.connectionToken=Pe}}e.ResolvedAuthority=V;class q extends Error{constructor(W,he=S.RemoteAuthorityResolverErrorCode.Unknown,Pe){super(W),this._message=W,this._code=he,this._detail=Pe,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,q.prototype)}static NotAvailable(W,he){return new q(W,S.RemoteAuthorityResolverErrorCode.NotAvailable,he)}static TemporarilyNotAvailable(W){return new q(W,S.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=q;var Y;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(Y=e.EndOfLine||(e.EndOfLine={}));var Q;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(Q=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let de=s=class{constructor(W,he){this._range=W,this._newText=he}static isTextEdit(W){return W instanceof s?!0:W?O.isRange(W)&&typeof W.newText=="string":!1}static replace(W,he){return new s(W,he)}static insert(W,he){return s.replace(new O(W,W),he)}static delete(W){return s.replace(W,"")}static setEndOfLine(W){const he=new s(new O(new B(0,0),new B(0,0)),"");return he.newEol=W,he}get range(){return this._range}set range(W){if(W&&!O.isRange(W))throw(0,t.illegalArgument)("range");this._range=W}get newText(){return this._newText||""}set newText(W){if(W&&typeof W!="string")throw(0,t.illegalArgument)("newText");this._newText=W}get newEol(){return this._newEol}set newEol(W){if(W&&typeof W!="number")throw(0,t.illegalArgument)("newEol");this._newEol=W}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};de=s=qe([N],de),e.TextEdit=de;let ve=i=class{constructor(W,he){this.range=W,this.newCells=he}static isNotebookCellEdit(W){return W instanceof i?!0:W?jt.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,he){return new i(W,he)}static insertCells(W,he){return new i(new jt(W,W),he)}static deleteCells(W){return new i(W,[])}static updateCellMetadata(W,he){const Pe=new i(new jt(W,W),[]);return Pe.newCellMetadata=he,Pe}static updateNotebookMetadata(W){const he=new i(new jt(0,0),[]);return he.newNotebookMetadata=W,he}};ve=i=qe([N],ve),e.NotebookEdit=ve;class ne{constructor(W,he){this.range=W,this.snippet=he}static isSnippetTextEdit(W){return W instanceof ne?!0:W?O.isRange(W.range)&&ke.isSnippetString(W.snippet):!1}static replace(W,he){return new ne(W,he)}static insert(W,he){return ne.replace(new O(W,W),he)}}e.SnippetTextEdit=ne;var pe;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace",j[j.Snippet=6]="Snippet"})(pe=e.FileEditType||(e.FileEditType={}));let be=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(W,he,Pe,Ge){this._edits.push({_type:1,from:W,to:he,options:Pe,metadata:Ge})}createFile(W,he,Pe){this._edits.push({_type:1,from:void 0,to:W,options:he,metadata:Pe})}deleteFile(W,he,Pe){this._edits.push({_type:1,from:W,to:void 0,options:he,metadata:Pe})}replaceNotebookMetadata(W,he,Pe){this._edits.push({_type:3,metadata:Pe,uri:W,edit:{editType:5,metadata:he},notebookMetadata:he})}replaceNotebookCells(W,he,Pe,Ge){const nt=he.start,ut=he.end;(nt!==ut||Pe.length>0)&&this._edits.push({_type:5,uri:W,index:nt,count:ut-nt,cells:Pe,metadata:Ge})}replaceNotebookCellMetadata(W,he,Pe,Ge){this._edits.push({_type:3,metadata:Ge,uri:W,edit:{editType:8,index:he,metadata:Pe}})}replace(W,he,Pe,Ge){this._edits.push({_type:2,uri:W,edit:new de(he,Pe),metadata:Ge})}insert(W,he,Pe,Ge){this.replace(W,new O(he,he),Pe,Ge)}delete(W,he,Pe){this.replace(W,he,"",Pe)}has(W){return this._edits.some(he=>he._type===2&&he.uri.toString()===W.toString())}set(W,he){if(he)for(const Pe of he){if(!Pe)continue;let Ge,nt;Array.isArray(Pe)?(Ge=Pe[0],nt=Pe[1]):Ge=Pe,ve.isNotebookCellEdit(Ge)?Ge.newCellMetadata?this.replaceNotebookCellMetadata(W,Ge.range.start,Ge.newCellMetadata,nt):Ge.newNotebookMetadata?this.replaceNotebookMetadata(W,Ge.newNotebookMetadata,nt):this.replaceNotebookCells(W,Ge.range,Ge.newCells,nt):ne.isSnippetTextEdit(Ge)?this._edits.push({_type:6,uri:W,range:Ge.range,edit:Ge.snippet,metadata:nt}):this._edits.push({_type:2,uri:W,edit:Ge,metadata:nt})}else{for(let Pe=0;Pe<this._edits.length;Pe++){const Ge=this._edits[Pe];switch(Ge._type){case 2:case 6:case 3:case 5:Ge.uri.toString()===W.toString()&&(this._edits[Pe]=void 0);break}}(0,l.coalesceInPlace)(this._edits)}}get(W){const he=[];for(const Pe of this._edits)Pe._type===2&&Pe.uri.toString()===W.toString()&&he.push(Pe.edit);return he}entries(){const W=new P.ResourceMap;for(const he of this._edits)if(he._type===2){let Pe=W.get(he.uri);Pe||(Pe=[he.uri,[]],W.set(he.uri,Pe)),Pe[1].push(he.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};be=qe([N],be),e.WorkspaceEdit=be;let ke=r=class{constructor(W){this._tabstop=1,this.value=W||""}static isSnippetString(W){return W instanceof r?!0:W?typeof W.value=="string":!1}static _escape(W){return W.replace(/\$|}|\\/g,"\\$&")}appendText(W){return this.value+=r._escape(W),this}appendTabstop(W=this._tabstop++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,he=this._tabstop++){if(typeof W=="function"){const Pe=new r;Pe._tabstop=this._tabstop,W(Pe),this._tabstop=Pe._tabstop,W=Pe.value}else W=r._escape(W);return this.value+="${",this.value+=he,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,he=this._tabstop++){const Pe=W.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=he,this.value+="|",this.value+=Pe,this.value+="|}",this}appendVariable(W,he){if(typeof he=="function"){const Pe=new r;Pe._tabstop=this._tabstop,he(Pe),this._tabstop=Pe._tabstop,he=Pe.value}else typeof he=="string"&&(he=he.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,he&&(this.value+=":",this.value+=he),this.value+="}",this}};ke=r=qe([N],ke),e.SnippetString=ke;var Oe;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(Oe=e.DiagnosticTag||(e.DiagnosticTag={}));var We;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(We=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let oe=c=class{constructor(W,he){if(this.uri=W,he)if(O.isRange(he))this.range=O.of(he);else if(B.isPosition(he))this.range=new O(he,he);else throw new Error("Illegal argument")}static isLocation(W){return W instanceof c?!0:W?O.isRange(W.range)&&I.URI.isUri(W.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};oe=c=qe([N],oe),e.Location=oe;let le=class{constructor(W,he){this.location=W,this.message=he}static is(W){return W?typeof W.message=="string"&&W.location&&O.isRange(W.location.range)&&I.URI.isUri(W.location.uri):!1}static isEqual(W,he){return W===he?!0:!W||!he?!1:W.message===he.message&&W.location.range.isEqual(he.location.range)&&W.location.uri.toString()===he.location.uri.toString()}};le=qe([N],le),e.DiagnosticRelatedInformation=le;let fe=class{constructor(W,he,Pe=We.Error){if(!O.isRange(W))throw new TypeError("range must be set");if(!he)throw new TypeError("message must be set");this.range=W,this.message=he,this.severity=Pe}toJSON(){return{severity:We[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,he){return W===he?!0:!W||!he?!1:W.message===he.message&&W.severity===he.severity&&W.code===he.code&&W.severity===he.severity&&W.source===he.source&&W.range.isEqual(he.range)&&(0,l.equals)(W.tags,he.tags)&&(0,l.equals)(W.relatedInformation,he.relatedInformation,le.isEqual)}};fe=qe([N],fe),e.Diagnostic=fe;let Z=class{constructor(W,he){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=he}};Z=qe([N],Z),e.Hover=Z;var ae;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(ae=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let ee=class{constructor(W,he=ae.Text){this.range=W,this.kind=he}toJSON(){return{range:this.range,kind:ae[this.kind]}}};ee=qe([N],ee),e.DocumentHighlight=ee;var ie;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(ie=e.SymbolKind||(e.SymbolKind={}));var F;(function(j){j[j.Deprecated=1]="Deprecated"})(F=e.SymbolTag||(e.SymbolTag={}));let H=o=class{constructor(W,he,Pe,Ge,nt){this.name=W,this.kind=he,this.containerName=nt,typeof Pe=="string"&&(this.containerName=Pe),Ge instanceof oe?this.location=Ge:Pe instanceof O&&(this.location=new oe(Ge,Pe)),o.validate(this)}static validate(W){if(!W.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:ie[this.kind],location:this.location,containerName:this.containerName}}};H=o=qe([N],H),e.SymbolInformation=H;let G=u=class{constructor(W,he,Pe,Ge,nt){this.name=W,this.detail=he,this.kind=Pe,this.range=Ge,this.selectionRange=nt,this.children=[],u.validate(this)}static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(u.validate)}};G=u=qe([N],G),e.DocumentSymbol=G;var X;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(X=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let me=class{constructor(W,he){this.title=W,this.kind=he}};me=qe([N],me),e.CodeAction=me;let we=h=class{constructor(W){this.value=W}append(W){return new h(this.value?this.value+h.sep+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+h.sep)}};we.sep=".",we=h=qe([N],we),e.CodeActionKind=we,we.Empty=new we(""),we.QuickFix=we.Empty.append("quickfix"),we.Refactor=we.Empty.append("refactor"),we.RefactorExtract=we.Refactor.append("extract"),we.RefactorInline=we.Refactor.append("inline"),we.RefactorMove=we.Refactor.append("move"),we.RefactorRewrite=we.Refactor.append("rewrite"),we.Source=we.Empty.append("source"),we.SourceOrganizeImports=we.Source.append("organizeImports"),we.SourceFixAll=we.Source.append("fixAll");let ce=class{constructor(W,he){if(this.range=W,this.parent=he,he&&!he.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ce=qe([N],ce),e.SelectionRange=ce;class Ce{constructor(W,he,Pe,Ge,nt,ut){this.kind=W,this.name=he,this.detail=Pe,this.uri=Ge,this.range=nt,this.selectionRange=ut}}e.CallHierarchyItem=Ce;class ye{constructor(W,he){this.fromRanges=he,this.from=W}}e.CallHierarchyIncomingCall=ye;class $e{constructor(W,he){this.fromRanges=he,this.to=W}}e.CallHierarchyOutgoingCall=$e;var Ve;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(Ve=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Ze=class{constructor(W,he){this.range=W,this.command=he}get isResolved(){return!!this.command}};Ze=qe([N],Ze),e.CodeLens=Ze;let Qe=y=class{constructor(W,he=!1){w.set(this,void 0),tt(this,w,new C.MarkdownString(W,{supportThemeIcons:he}),"f")}static isMarkdownString(W){return W instanceof y?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}get value(){return Ue(this,w,"f").value}set value(W){Ue(this,w,"f").value=W}get isTrusted(){return Ue(this,w,"f").isTrusted}set isTrusted(W){Ue(this,w,"f").isTrusted=W}get supportThemeIcons(){return Ue(this,w,"f").supportThemeIcons}set supportThemeIcons(W){Ue(this,w,"f").supportThemeIcons=W}get supportHtml(){return Ue(this,w,"f").supportHtml}set supportHtml(W){Ue(this,w,"f").supportHtml=W}get baseUri(){return Ue(this,w,"f").baseUri}set baseUri(W){Ue(this,w,"f").baseUri=W}appendText(W){return Ue(this,w,"f").appendText(W),this}appendMarkdown(W){return Ue(this,w,"f").appendMarkdown(W),this}appendCodeblock(W,he){return Ue(this,w,"f").appendCodeblock(he??"",W),this}};w=new WeakMap,Qe=y=qe([N],Qe),e.MarkdownString=Qe;let Le=class{constructor(W,he){this.label=W,this.documentation=he}};Le=qe([N],Le),e.ParameterInformation=Le;let ot=class{constructor(W,he){this.label=W,this.documentation=he,this.parameters=[]}};ot=qe([N],ot),e.SignatureInformation=ot;let re=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};re=qe([N],re),e.SignatureHelp=re;var se;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(se=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ee;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(Ee=e.InlayHintKind||(e.InlayHintKind={}));let ue=class{constructor(W){this.value=W}};ue=qe([N],ue),e.InlayHintLabelPart=ue;let Te=class{constructor(W,he,Pe){this.position=W,this.label=he,this.kind=Pe}};Te=qe([N],Te),e.InlayHint=Te;var Me;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Me=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Be;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(Be=e.CompletionItemKind||(e.CompletionItemKind={}));var ze;(function(j){j[j.Deprecated=1]="Deprecated"})(ze=e.CompletionItemTag||(e.CompletionItemTag={}));let Ye=class{constructor(W,he){this.label=W,this.kind=he}toJSON(){return{label:this.label,kind:this.kind&&Be[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ye=qe([N],Ye),e.CompletionItem=Ye;let it=class{constructor(W=[],he=!1){this.items=W,this.isIncomplete=he}};it=qe([N],it),e.CompletionList=it;let ct=class{constructor(W,he,Pe){this.insertText=W,this.range=he,this.command=Pe}};ct=qe([N],ct),e.InlineSuggestion=ct;let st=class{constructor(W){this.commands=void 0,this.items=W}};st=qe([N],st),e.InlineSuggestionList=st;let et=class{constructor(W,he,Pe){this.insertText=W,this.range=he,this.command=Pe}};et=qe([N],et),e.InlineSuggestionNew=et;let ft=class{constructor(W,he){this.items=W,this.commands=he}};ft=qe([N],ft),e.InlineSuggestionsNew=ft;var Et;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(Et=e.ViewColumn||(e.ViewColumn={}));var Dt;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Dt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var mt;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(mt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var It;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(It=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ft;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Ft=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Nt;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(Nt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Ke;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(Ke=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Ut;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(Ut=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(j){function W(he){switch(he){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=W}(Nt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ot=class{constructor(W,he){if(he&&!I.URI.isUri(he))throw(0,t.illegalArgument)("target");if(!O.isRange(W)||W.isEmpty)throw(0,t.illegalArgument)("range");this.range=W,this.target=he}};Ot=qe([N],Ot),e.DocumentLink=Ot;let Pt=class{constructor(W,he,Pe,Ge){this.red=W,this.green=he,this.blue=Pe,this.alpha=Ge}};Pt=qe([N],Pt),e.Color=Pt;let pt=class{constructor(W,he){if(he&&!(he instanceof Pt))throw(0,t.illegalArgument)("color");if(!O.isRange(W)||W.isEmpty)throw(0,t.illegalArgument)("range");this.range=W,this.color=he}};pt=qe([N],pt),e.ColorInformation=pt;let Ct=class{constructor(W){if(!W||typeof W!="string")throw(0,t.illegalArgument)("label");this.label=W}};Ct=qe([N],Ct),e.ColorPresentation=Ct;var Ae;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(Ae=e.ColorFormat||(e.ColorFormat={}));var Re;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(Re=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var _e;(function(j){j[j.Unknown=0]="Unknown",j[j.Shutdown=1]="Shutdown",j[j.Process=2]="Process",j[j.User=3]="User",j[j.Extension=4]="Extension"})(_e=e.TerminalExitReason||(e.TerminalExitReason={}));class te{constructor(W,he,Pe){if(this.startIndex=W,this.length=he,this.tooltip=Pe,typeof W!="number"||W<0)throw(0,t.illegalArgument)("startIndex");if(typeof he!="number"||he<1)throw(0,t.illegalArgument)("length");if(Pe!==void 0&&typeof Pe!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=te;var Fe;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(Fe=e.TerminalLocation||(e.TerminalLocation={}));class je{constructor(W){if(this.options=W,typeof W!="object")throw(0,t.illegalArgument)("options")}}e.TerminalProfile=je;var rt;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(rt=e.TaskRevealKind||(e.TaskRevealKind={}));var Je;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(Je=e.TaskPanelKind||(e.TaskPanelKind={}));let Xe=R=class{constructor(W,he){if(this.label=he,typeof W!="string"||typeof he!="string")throw(0,t.illegalArgument)("name");this._id=W}static from(W){switch(W){case"clean":return R.Clean;case"build":return R.Build;case"rebuild":return R.Rebuild;case"test":return R.Test;default:return}}get id(){return this._id}};Xe.Clean=new R("clean","Clean"),Xe.Build=new R("build","Build"),Xe.Rebuild=new R("rebuild","Rebuild"),Xe.Test=new R("test","Test"),Xe=R=qe([N],Xe),e.TaskGroup=Xe;function lt(j){let W="";for(let he=0;he<j.length;he++)W+=j[he].replace(/,/g,",,")+",";return W}let kt=class{constructor(W,he,Pe){if(typeof W!="string")throw(0,t.illegalArgument)("process");this._args=[],this._process=W,he!==void 0&&(Array.isArray(he)?(this._args=he,this._options=Pe):this._options=he)}get process(){return this._process}set process(W){if(typeof W!="string")throw(0,t.illegalArgument)("process");this._process=W}get args(){return this._args}set args(W){Array.isArray(W)||(W=[]),this._args=W}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("process"),this._process!==void 0&&W.push(this._process),this._args&&this._args.length>0)for(const he of this._args)W.push(he);return lt(W)}};kt=qe([N],kt),e.ProcessExecution=kt;let vt=class{constructor(W,he,Pe){if(this._args=[],Array.isArray(he)){if(!W)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,t.illegalArgument)("command");this._command=W,this._args=he,this._options=Pe}else{if(typeof W!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=W,this._options=he}}get commandLine(){return this._commandLine}set commandLine(W){if(typeof W!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=W}get command(){return this._command?this._command:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,t.illegalArgument)("command");this._command=W}get args(){return this._args}set args(W){this._args=W||[]}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("shell"),this._commandLine!==void 0&&W.push(this._commandLine),this._command!==void 0&&W.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const he of this._args)W.push(typeof he=="string"?he:he.value);return lt(W)}};vt=qe([N],vt),e.ShellExecution=vt;var Tt;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(Tt=e.ShellQuoting||(e.ShellQuoting={}));var St;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(St=e.TaskScope||(e.TaskScope={}));class wt{constructor(W){this._callback=W}computeId(){return"customExecution"+(0,L.generateUuid)()}set callback(W){this._callback=W}get callback(){return this._callback}}e.CustomExecution=wt;let _t=M=class{constructor(W,he,Pe,Ge,nt,ut){this.__deprecated=!1,this._definition=this.definition=W;let ht;typeof he=="string"?(this._name=this.name=he,this._source=this.source=Pe,this.execution=Ge,ht=nt,this.__deprecated=!0):he===St.Global||he===St.Workspace?(this.target=he,this._name=this.name=Pe,this._source=this.source=Ge,this.execution=nt,ht=ut):(this.target=he,this._name=this.name=Pe,this._source=this.source=Ge,this.execution=nt,ht=ut),typeof ht=="string"?(this._problemMatchers=[ht],this._hasDefinedMatchers=!0):Array.isArray(ht)?(this._problemMatchers=ht,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(W){this.__id=W}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof kt?this._definition={type:M.ProcessType,id:this._execution.computeId()}:this._execution instanceof vt?this._definition={type:M.ShellType,id:this._execution.computeId()}:this._execution instanceof wt?this._definition={type:M.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:M.EmptyType,id:(0,L.generateUuid)()}}get definition(){return this._definition}set definition(W){if(W==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=W}get scope(){return this._scope}set target(W){this.clear(),this._scope=W}get name(){return this._name}set name(W){if(typeof W!="string")throw(0,t.illegalArgument)("name");this.clear(),this._name=W}get execution(){return this._execution}set execution(W){W===null&&(W=void 0),this.clear(),this._execution=W;const he=this._definition.type;(M.EmptyType===he||M.ProcessType===he||M.ShellType===he||M.ExtensionCallbackType===he)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(W){if(Array.isArray(W))this.clear(),this._problemMatchers=W,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.clear(),this._isBackground=W}get source(){return this._source}set source(W){if(typeof W!="string"||W.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=W}get group(){return this._group}set group(W){W===null&&(W=void 0),this.clear(),this._group=W}get detail(){return this._detail}set detail(W){W===null&&(W=void 0),this._detail=W}get presentationOptions(){return this._presentationOptions}set presentationOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._presentationOptions=W}get runOptions(){return this._runOptions}set runOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._runOptions=W}};_t.ExtensionCallbackType="customExecution",_t.ProcessType="process",_t.ShellType="shell",_t.EmptyType="$empty",_t=M=qe([N],_t),e.Task=_t;var tn;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(tn=e.ProgressLocation||(e.ProgressLocation={}));let bt=U=class{constructor(W,he=$t.None){this.collapsibleState=he,I.URI.isUri(W)?this.resourceUri=W:this.label=W}static isTreeItem(W,he){if(W instanceof U)return!0;const Pe=W;if(Pe.label!==void 0&&!(0,b.isString)(Pe.label)&&!Pe.label?.label)return console.log("INVALID tree item, invalid label",Pe.label),!1;if(Pe.id!==void 0&&!(0,b.isString)(Pe.id))return console.log("INVALID tree item, invalid id",Pe.id),!1;if(Pe.iconPath!==void 0&&!(0,b.isString)(Pe.iconPath)&&!I.URI.isUri(Pe.iconPath)&&(!Pe.iconPath||!(0,b.isString)(Pe.iconPath.id))){const Ge=Pe.iconPath;if(!Ge||!(0,b.isString)(Ge.light)&&!I.URI.isUri(Ge.light)&&!(0,b.isString)(Ge.dark)&&!I.URI.isUri(Ge.dark))return console.log("INVALID tree item, invalid iconPath",Pe.iconPath),!1}return Pe.description!==void 0&&!(0,b.isString)(Pe.description)&&typeof Pe.description!="boolean"?(console.log("INVALID tree item, invalid description",Pe.description),!1):Pe.resourceUri!==void 0&&!I.URI.isUri(Pe.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Pe.resourceUri),!1):Pe.tooltip!==void 0&&!(0,b.isString)(Pe.tooltip)&&!(Pe.tooltip instanceof Qe)?(console.log("INVALID tree item, invalid tooltip",Pe.tooltip),!1):Pe.command!==void 0&&!Pe.command.command?(console.log("INVALID tree item, invalid command",Pe.command),!1):Pe.collapsibleState!==void 0&&Pe.collapsibleState<$t.None&&Pe.collapsibleState>$t.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Pe.collapsibleState),!1):Pe.contextValue!==void 0&&!(0,b.isString)(Pe.contextValue)?(console.log("INVALID tree item, invalid contextValue",Pe.contextValue),!1):Pe.accessibilityInformation!==void 0&&!Pe.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Pe.accessibilityInformation),!1):Pe.checkboxState!==void 0&&((0,E.checkProposedApiEnabled)(he,"treeItemCheckbox"),Pe.checkboxState!==Ht.Checked&&Pe.checkboxState!==Ht.Unchecked)?(console.log("INVALID tree item, invalid checkboxState",Pe.checkboxState),!1):!0}};bt=U=qe([N],bt),e.TreeItem=bt;var $t;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})($t=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var Ht;(function(j){j[j.Unchecked=0]="Unchecked",j[j.Checked=1]="Checked"})(Ht=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let nn=class{constructor(W,he){this.value=W,this.id=he??(0,L.generateUuid)()}async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}};nn=qe([N],nn),e.DataTransferItem=nn;let pn=class{constructor(W){f.set(this,new Map);for(const[he,Pe]of W??[]){const Ge=Ue(this,f,"f").get(he);Ge?Ge.push(Pe):Ue(this,f,"f").set(he,[Pe])}}get(W){return Ue(this,f,"f").get(W)?.[0]}set(W,he){Ue(this,f,"f").set(W,[he])}forEach(W,he){for(const[Pe,Ge]of Ue(this,f,"f"))for(const nt of Ge)W.call(he,nt,Pe,this)}*[(f=new WeakMap,Symbol.iterator)](){for(const[W,he]of Ue(this,f,"f"))for(const Pe of he)yield[W,Pe]}};pn=qe([N],pn),e.DataTransfer=pn;let At=class{constructor(W){this.insertText=W}};At=qe([N],At),e.DocumentDropEdit=At;let rn=class{constructor(W){this.insertText=W}};rn=qe([N],rn),e.DocumentPasteEdit=rn;let xt=class{constructor(W,he){this.id=W,this.color=he}};xt=qe([N],xt),e.ThemeIcon=xt,xt.File=new xt("file"),xt.Folder=new xt("folder");let Yt=class{constructor(W){this.id=W}};Yt=qe([N],Yt),e.ThemeColor=Yt;var sn;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(sn=e.ConfigurationTarget||(e.ConfigurationTarget={}));let dt=class{constructor(W,he){if(typeof W!="string"&&(!W||!I.URI.isUri(W)&&!I.URI.isUri(W.uri)))throw(0,t.illegalArgument)("base");if(typeof he!="string")throw(0,t.illegalArgument)("pattern");typeof W=="string"?this.baseUri=I.URI.file(W):I.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=he}get base(){return this._base}set base(W){this._base=W,this._baseUri=I.URI.file(W)}get baseUri(){return this._baseUri}set baseUri(W){this._baseUri=W,this._base=W.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};dt=qe([N],dt),e.RelativePattern=dt;let Jt=class{constructor(W,he,Pe,Ge){this.enabled=typeof W=="boolean"?W:!0,typeof he=="string"&&(this.condition=he),typeof Pe=="string"&&(this.hitCondition=Pe),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this._id||(this._id=(0,L.generateUuid)()),this._id}};Jt=qe([N],Jt),e.Breakpoint=Jt;let zt=class extends Jt{constructor(W,he,Pe,Ge,nt){if(super(he,Pe,Ge,nt),W===null)throw(0,t.illegalArgument)("location");this.location=W}};zt=qe([N],zt),e.SourceBreakpoint=zt;let Gt=class extends Jt{constructor(W,he,Pe,Ge,nt){super(he,Pe,Ge,nt),this.functionName=W}};Gt=qe([N],Gt),e.FunctionBreakpoint=Gt;let on=class extends Jt{constructor(W,he,Pe,Ge,nt,ut,ht){if(super(Ge,nt,ut,ht),!he)throw(0,t.illegalArgument)("dataId");this.label=W,this.dataId=he,this.canPersist=Pe}};on=qe([N],on),e.DataBreakpoint=on;let vn=class{constructor(W,he,Pe){this.command=W,this.args=he||[],this.options=Pe}};vn=qe([N],vn),e.DebugAdapterExecutable=vn;let an=class{constructor(W,he){this.port=W,this.host=he}};an=qe([N],an),e.DebugAdapterServer=an;let wn=class{constructor(W){this.path=W}};wn=qe([N],wn),e.DebugAdapterNamedPipeServer=wn;let cn=class{constructor(W){this.implementation=W}};cn=qe([N],cn),e.DebugAdapterInlineImplementation=cn;let Zt=class{constructor(W,he){this.range=W,this.expression=he}};Zt=qe([N],Zt),e.EvaluatableExpression=Zt;var Ln;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Ln=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var bn;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(bn=e.InlineCompletionTriggerKindNew||(e.InlineCompletionTriggerKindNew={}));let en=class{constructor(W,he){this.range=W,this.text=he}};en=qe([N],en),e.InlineValueText=en;let En=class{constructor(W,he,Pe=!0){this.range=W,this.variableName=he,this.caseSensitiveLookup=Pe}};En=qe([N],En),e.InlineValueVariableLookup=En;let Sn=class{constructor(W,he){this.range=W,this.expression=he}};Sn=qe([N],Sn),e.InlineValueEvaluatableExpression=Sn;let Kt=class{constructor(W,he){this.frameId=W,this.stoppedLocation=he}};Kt=qe([N],Kt),e.InlineValueContext=Kt;var On;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(On=e.FileChangeType||(e.FileChangeType={}));let _n=A=class extends Error{constructor(W,he=k.FileSystemProviderErrorCode.Unknown,Pe){super(I.URI.isUri(W)?W.toString(!0):W),this.code=Pe?.name??"Unknown",(0,k.markAsFileSystemProviderError)(this,he),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,A.prototype),typeof Error.captureStackTrace=="function"&&typeof Pe=="function"&&Error.captureStackTrace(this,Pe)}static FileExists(W){return new A(W,k.FileSystemProviderErrorCode.FileExists,A.FileExists)}static FileNotFound(W){return new A(W,k.FileSystemProviderErrorCode.FileNotFound,A.FileNotFound)}static FileNotADirectory(W){return new A(W,k.FileSystemProviderErrorCode.FileNotADirectory,A.FileNotADirectory)}static FileIsADirectory(W){return new A(W,k.FileSystemProviderErrorCode.FileIsADirectory,A.FileIsADirectory)}static NoPermissions(W){return new A(W,k.FileSystemProviderErrorCode.NoPermissions,A.NoPermissions)}static Unavailable(W){return new A(W,k.FileSystemProviderErrorCode.Unavailable,A.Unavailable)}};_n=A=qe([N],_n),e.FileSystemError=_n;let yn=class{constructor(W,he,Pe){this.start=W,this.end=he,this.kind=Pe}};yn=qe([N],yn),e.FoldingRange=yn;var Fn;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(Fn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Cn;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(Cn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var kn;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(kn=e.CommentMode||(e.CommentMode={}));var Tn;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(Tn=e.CommentThreadState||(e.CommentThreadState={}));class He{constructor(W,he=[]){this.tokenTypes=W,this.tokenModifiers=he}}e.SemanticTokensLegend=He;function Vt(j){return typeof j>"u"||(0,b.isStringArray)(j)}class ln{constructor(W){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,W){this._hasLegend=!0;for(let he=0,Pe=W.tokenTypes.length;he<Pe;he++)this._tokenTypeStrToInt.set(W.tokenTypes[he],he);for(let he=0,Pe=W.tokenModifiers.length;he<Pe;he++)this._tokenModifierStrToInt.set(W.tokenModifiers[he],he)}}push(W,he,Pe,Ge,nt){if(typeof W=="number"&&typeof he=="number"&&typeof Pe=="number"&&typeof Ge=="number"&&(typeof nt=="number"||typeof nt>"u"))return typeof nt>"u"&&(nt=0),this._pushEncoded(W,he,Pe,Ge,nt);if(O.isRange(W)&&typeof he=="string"&&Vt(Pe))return this._push(W,he,Pe);throw(0,t.illegalArgument)()}_push(W,he,Pe){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(he))throw new Error("`tokenType` is not in the provided legend");const Ge=W.start.line,nt=W.start.character,ut=W.end.character-W.start.character,ht=this._tokenTypeStrToInt.get(he);let Lt=0;if(Pe)for(const Bt of Pe){if(!this._tokenModifierStrToInt.has(Bt))throw new Error("`tokenModifier` is not in the provided legend");const Wt=this._tokenModifierStrToInt.get(Bt);Lt|=1<<Wt>>>0}this._pushEncoded(Ge,nt,ut,ht,Lt)}_pushEncoded(W,he,Pe,Ge,nt){if(this._dataIsSortedAndDeltaEncoded&&(W<this._prevLine||W===this._prevLine&&he<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Lt=this._data.length/5|0;let Bt=0,Wt=0;for(let qt=0;qt<Lt;qt++){let Xt=this._data[5*qt],Dn=this._data[5*qt+1];Xt===0?(Xt=Bt,Dn+=Wt):Xt+=Bt,this._data[5*qt]=Xt,this._data[5*qt+1]=Dn,Bt=Xt,Wt=Dn}}let ut=W,ht=he;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ut-=this._prevLine,ut===0&&(ht-=this._prevChar)),this._data[this._dataLen++]=ut,this._data[this._dataLen++]=ht,this._data[this._dataLen++]=Pe,this._data[this._dataLen++]=Ge,this._data[this._dataLen++]=nt,this._prevLine=W,this._prevChar=he}static _sortAndDeltaEncode(W){const he=[],Pe=W.length/5|0;for(let ht=0;ht<Pe;ht++)he[ht]=ht;he.sort((ht,Lt)=>{const Bt=W[5*ht],Wt=W[5*Lt];if(Bt===Wt){const qt=W[5*ht+1],Xt=W[5*Lt+1];return qt-Xt}return Bt-Wt});const Ge=new Uint32Array(W.length);let nt=0,ut=0;for(let ht=0;ht<Pe;ht++){const Lt=5*he[ht],Bt=W[Lt+0],Wt=W[Lt+1],qt=W[Lt+2],Xt=W[Lt+3],Dn=W[Lt+4],Yn=Bt-nt,yi=Yn===0?Wt-ut:Wt,In=5*ht;Ge[In+0]=Yn,Ge[In+1]=yi,Ge[In+2]=qt,Ge[In+3]=Xt,Ge[In+4]=Dn,nt=Bt,ut=Wt}return Ge}build(W){return this._dataIsSortedAndDeltaEncoded?new gt(new Uint32Array(this._data),W):new gt(ln._sortAndDeltaEncode(this._data),W)}}e.SemanticTokensBuilder=ln;class gt{constructor(W,he){this.resultId=he,this.data=W}}e.SemanticTokens=gt;class Nn{constructor(W,he,Pe){this.start=W,this.deleteCount=he,this.data=Pe}}e.SemanticTokensEdit=Nn;class Mn{constructor(W,he){this.resultId=he,this.edits=W}}e.SemanticTokensEdits=Mn;var Pn;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(Pn=e.DebugConsoleMode||(e.DebugConsoleMode={}));let un=class{constructor(){}};un.Back={iconPath:new xt("arrow-left")},un=qe([N],un),e.QuickInputButtons=un;var dn;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(dn=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Un;(function(j){j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(Un=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Bn;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(Bn=e.ExtensionKind||(e.ExtensionKind={}));class zn{constructor(W,he,Pe){this.badge=W,this.tooltip=he,this.color=Pe}static validate(W){if(W.badge){let he=(0,D.nextCharLength)(W.badge,0);if(he<W.badge.length&&(he+=(0,D.nextCharLength)(W.badge,he)),W.badge.length>he)throw new Error("The 'badge'-property must be undefined or a short character")}if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=zn;let hn=class{constructor(W){this.kind=W}};hn=qe([N],hn),e.ColorTheme=hn;var Wn;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast",j[j.HighContrastLight=4]="HighContrastLight"})(Wn=e.ColorThemeKind||(e.ColorThemeKind={}));class jt{constructor(W,he){if(W<0)throw(0,t.illegalArgument)("start must be positive");if(he<0)throw(0,t.illegalArgument)("end must be positive");W<=he?(this._start=W,this._end=he):(this._start=he,this._end=W)}static isNotebookRange(W){return W instanceof jt?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(W){let he=this._start,Pe=this._end;return W.start!==void 0&&(he=W.start),W.end!==void 0&&(Pe=W.end),he===this._start&&Pe===this._end?this:new jt(he,Pe)}}e.NotebookRange=jt;class fn{constructor(W,he,Pe,Ge,nt,ut,ht){this.kind=W,this.value=he,this.languageId=Pe,this.mime=Ge,this.outputs=nt??[],this.metadata=ut,this.executionSummary=ht,fn.validate(this)}static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(he=>fn.isNotebookCellData(he))}static isNotebookCellData(W){return!0}}e.NotebookCellData=fn;class $n{constructor(W){this.cells=W}}e.NotebookData=$n;class Mt{constructor(W,he){this.data=W,this.mime=he;const Pe=(0,_.normalizeMimeType)(he,!0);if(!Pe)throw new Error(`INVALID mime type: ${he}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Pe}static isNotebookCellOutputItem(W){return W instanceof Mt?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const he={name:W.name,message:W.message,stack:W.stack};return Mt.json(he,"application/vnd.code.notebook.error")}static stdout(W){return Mt.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return Mt.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,he="application/octet-stream"){return new Mt(W,he)}static text(W,he=_.Mimes.text){const Pe=Ue(Mt,v,"f",m).encode(String(W));return new Mt(Pe,he)}static json(W,he="text/x-json"){const Pe=JSON.stringify(W,void 0,"	");return Mt.text(Pe,he)}}e.NotebookCellOutputItem=Mt,v=Mt,m={value:new TextEncoder};class ge{constructor(W,he,Pe){this.items=ge.ensureUniqueMimeTypes(W,!0),typeof he=="string"?(this.id=he,this.metadata=Pe):(this.id=(0,L.generateUuid)(),this.metadata=he??Pe)}static isNotebookCellOutput(W){return W instanceof ge?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,he=!1){const Pe=new Set,Ge=new Set;for(let nt=0;nt<W.length;nt++){const ut=W[nt],ht=(0,_.normalizeMimeType)(ut.mime);if(!Pe.has(ht)||(0,T.isTextStreamMime)(ht)){Pe.add(ht);continue}Ge.add(nt),he&&console.warn(`DUPLICATED mime type '${ut.mime}' will be dropped`)}return Ge.size===0?W:W.filter((nt,ut)=>!Ge.has(ut))}}e.NotebookCellOutput=ge;var Se;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(Se=e.NotebookCellKind||(e.NotebookCellKind={}));var Ne;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(Ne=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var at;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(at=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var yt;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(yt=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Rt{constructor(W,he){this.text=W,this.alignment=he}}e.NotebookCellStatusBarItem=Rt;var ti;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(ti=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class ni{constructor(W,he=[]){this.uri=W,this.provides=(0,l.asArray)(he)}}e.NotebookRendererScript=ni;let Hn=class{constructor(W,he){this.label=W,this.timestamp=he}};Hn=qe([N],Hn),e.TimelineItem=Hn;var ii;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(ii=e.ExtensionMode||(e.ExtensionMode={}));var ri;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(ri=e.ExtensionRuntime||(e.ExtensionRuntime={}));var si;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(si=e.StandardTokenType||(e.StandardTokenType={}));class oi{constructor(W,he){this.ranges=W,this.wordPattern=he}}e.LinkedEditingRanges=oi;class ai{constructor(W,he){this._port=W,this._autoForwardAction=he}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=ai;var ci;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(ci=e.TestResultState||(e.TestResultState={}));var li;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(li=e.TestRunProfileKind||(e.TestRunProfileKind={}));let xn=class{constructor(W=void 0,he=void 0,Pe=void 0){this.include=W,this.exclude=he,this.profile=Pe}};xn=qe([N],xn),e.TestRunRequest=xn;let Vn=z=class{constructor(W){this.message=W}static diff(W,he,Pe){const Ge=new z(W);return Ge.expectedOutput=he,Ge.actualOutput=Pe,Ge}};Vn=z=qe([N],Vn),e.TestMessage=Vn;let jn=class{constructor(W){this.id=W}};jn=qe([N],jn),e.TestTag=jn;let mn=class{constructor(W,he){this.covered=W,this.total=he}};mn=qe([N],mn),e.CoveredCount=mn;let qn=$=class{constructor(W,he,Pe,Ge){this.uri=W,this.statementCoverage=he,this.branchCoverage=Pe,this.functionCoverage=Ge}static fromDetails(W,he){const Pe=new mn(0,0),Ge=new mn(0,0),nt=new mn(0,0);for(const ht of he)if("branches"in ht){Pe.total+=1,Pe.covered+=ht.executionCount>0?1:0;for(const Lt of ht.branches)Ge.total+=1,Ge.covered+=Lt.executionCount>0?1:0}else nt.total+=1,nt.covered+=ht.executionCount>0?1:0;const ut=new $(W,Pe,Ge.total>0?Ge:void 0,nt.total>0?nt:void 0);return ut.detailedCoverage=he,ut}};qn=$=qe([N],qn),e.FileCoverage=qn;let Gn=class{constructor(W,he,Pe=[]){this.executionCount=W,this.location=he,this.branches=Pe}};Gn=qe([N],Gn),e.StatementCoverage=Gn;let Kn=class{constructor(W,he){this.executionCount=W,this.location=he}};Kn=qe([N],Kn),e.BranchCoverage=Kn;let Xn=class{constructor(W,he){this.executionCount=W,this.location=he}};Xn=qe([N],Xn),e.FunctionCoverage=Xn;var ui;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(ui=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var di;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(di=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var hi;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(hi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class fi{constructor(W,he,Pe,Ge,nt,ut){this.kind=W,this.name=he,this.detail=Pe,this.uri=Ge,this.range=nt,this.selectionRange=ut}}e.TypeHierarchyItem=fi;class mi{constructor(W){this.uri=W}}e.TextTabInput=mi;class gi{constructor(W,he){this.original=W,this.modified=he}}e.TextDiffTabInput=gi;class pi{constructor(W,he,Pe,Ge){this.base=W,this.input1=he,this.input2=Pe,this.result=Ge}}e.TextMergeTabInput=pi;class vi{constructor(W,he){this.uri=W,this.viewType=he}}e.CustomEditorTabInput=vi;class wi{constructor(W){this.viewType=W}}e.WebviewEditorTabInput=wi;class bi{constructor(W,he){this.uri=W,this.notebookType=he}}e.NotebookEditorTabInput=bi;class Ei{constructor(W,he,Pe){this.original=W,this.modified=he,this.notebookType=Pe}}e.NotebookDiffEditorTabInput=Ei;class Si{constructor(){}}e.TerminalEditorTabInput=Si;class _i{constructor(W,he){this.uri=W,this.inputBoxUri=he}}e.InteractiveWindowInput=_i}),define(De[131],Ie([1,0,48,12,8,158,99,7,17]),function(J,e,l,t,C,P,_,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const I=new Map;function L(E,p){p?I.set(E,p):I.delete(E)}e.setWordDefinitionFor=L;function k(E){return I.get(E)}e.getWordDefinitionFor=k;class S extends P.MirrorTextModel{constructor(p,w,f,v,m,a,g,n){super(w,f,v,m),this._proxy=p,this._languageId=a,this._isDirty=g,this.notebook=n,this._isDisposed=!1}dispose(){(0,l.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(p){return(0,b.equals)(this._lines,p)}get document(){if(!this._document){const p=this;this._document={get uri(){return p._uri},get fileName(){return p._uri.fsPath},get isUntitled(){return p._uri.scheme===t.Schemas.untitled},get languageId(){return p._languageId},get version(){return p._versionId},get isClosed(){return p._isDisposed},get isDirty(){return p._isDirty},save(){return p._save()},getText(w){return w?p._getTextInRange(w):p.getText()},get eol(){return p._eol===`
`?D.EndOfLine.LF:D.EndOfLine.CRLF},get lineCount(){return p._lines.length},lineAt(w){return p._lineAt(w)},offsetAt(w){return p._offsetAt(w)},positionAt(w){return p._positionAt(w)},validateRange(w){return p._validateRange(w)},validatePosition(w){return p._validatePosition(w)},getWordRangeAtPosition(w,f){return p._getWordRangeAtPosition(w,f)}}}return Object.freeze(this._document)}_acceptLanguageId(p){(0,l.ok)(!this._isDisposed),this._languageId=p}_acceptIsDirty(p){(0,l.ok)(!this._isDisposed),this._isDirty=p}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(p){const w=this._validateRange(p);if(w.isEmpty)return"";if(w.isSingleLine)return this._lines[w.start.line].substring(w.start.character,w.end.character);const f=this._eol,v=w.start.line,m=w.end.line,a=[];a.push(this._lines[v].substring(w.start.character));for(let g=v+1;g<m;g++)a.push(this._lines[g]);return a.push(this._lines[m].substring(0,w.end.character)),a.join(f)}_lineAt(p){let w;if(p instanceof D.Position?w=p.line:typeof p=="number"&&(w=p),typeof w!="number"||w<0||w>=this._lines.length||Math.floor(w)!==w)throw new Error("Illegal value for `line`");return new T(w,this._lines[w],w===this._lines.length-1)}_offsetAt(p){return p=this._validatePosition(p),this._ensureLineStarts(),this._lineStarts.getPrefixSum(p.line-1)+p.character}_positionAt(p){p=Math.floor(p),p=Math.max(0,p),this._ensureLineStarts();const w=this._lineStarts.getIndexOf(p),f=this._lines[w.index].length;return new D.Position(w.index,Math.min(w.remainder,f))}_validateRange(p){if(!(p instanceof D.Range))throw new Error("Invalid argument");const w=this._validatePosition(p.start),f=this._validatePosition(p.end);return w===p.start&&f===p.end?p:new D.Range(w.line,w.character,f.line,f.character)}_validatePosition(p){if(!(p instanceof D.Position))throw new Error("Invalid argument");if(this._lines.length===0)return p.with(0,0);let{line:w,character:f}=p,v=!1;if(w<0)w=0,f=0,v=!0;else if(w>=this._lines.length)w=this._lines.length-1,f=this._lines[w].length,v=!0;else{const m=this._lines[w].length;f<0?(f=0,v=!0):f>m&&(f=m,v=!0)}return v?new D.Position(w,f):p}_getWordRangeAtPosition(p,w){const f=this._validatePosition(p);if(!w)w=k(this._languageId);else if((0,C.regExpLeadsToEndlessLoop)(w))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${w.source}' because it matches the empty string.`);const v=(0,_.getWordAtText)(f.character+1,(0,_.ensureValidWordDefinition)(w),this._lines[f.line],0);if(v)return new D.Range(f.line,v.startColumn-1,f.line,v.endColumn-1)}}e.ExtHostDocumentData=S;class T{constructor(p,w,f){this._line=p,this._text=w,this._isLastLine=f}get lineNumber(){return this._line}get text(){return this._text}get range(){return new D.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new D.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=T}),define(De[224],Ie([1,0,7,16,4]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let P=class{constructor(D){this._actual=new l.ColorTheme(l.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new C.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(D){let b;switch(D){case"light":b=l.ColorThemeKind.Light;break;case"hcDark":b=l.ColorThemeKind.HighContrast;break;case"hcLight":b=l.ColorThemeKind.HighContrastLight;break;default:b=l.ColorThemeKind.Dark}this._actual=new l.ColorTheme(b),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};P=qe([xe(0,t.IExtHostRpcService)],P),e.ExtHostTheming=P}),define(De[13],Ie([1,0,17,23,106,25,144,80,24,14,2,35,62,117,128,126,89,63,64,218,7,59]),function(J,e,l,t,C,P,_,D,b,I,L,k,S,T,E,p,w,f,v,m,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var n;(function(Ae){function Re(te){const{selectionStartLineNumber:Fe,selectionStartColumn:je,positionLineNumber:rt,positionColumn:Je}=te,Xe=new a.Position(Fe-1,je-1),lt=new a.Position(rt-1,Je-1);return new a.Selection(Xe,lt)}Ae.to=Re;function _e(te){const{anchor:Fe,active:je}=te;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:je.line+1,positionColumn:je.character+1}}Ae.from=_e})(n=e.Selection||(e.Selection={}));var d;(function(Ae){function Re(te){if(!te)return;const{start:Fe,end:je}=te;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:je.line+1,endColumn:je.character+1}}Ae.from=Re;function _e(te){if(!te)return;const{startLineNumber:Fe,startColumn:je,endLineNumber:rt,endColumn:Je}=te;return new a.Range(Fe-1,je-1,rt-1,Je-1)}Ae.to=_e})(d=e.Range||(e.Range={}));var s;(function(Ae){function Re(_e){switch(_e){case 1:return a.StandardTokenType.Comment;case 0:return a.StandardTokenType.Other;case 3:return a.StandardTokenType.RegEx;case 2:return a.StandardTokenType.String}}Ae.to=Re})(s=e.TokenType||(e.TokenType={}));var i;(function(Ae){function Re(te){return new a.Position(te.lineNumber-1,te.column-1)}Ae.to=Re;function _e(te){return{lineNumber:te.line+1,column:te.character+1}}Ae.from=_e})(i=e.Position||(e.Position={}));var r;(function(Ae){function Re(Fe,je){return(0,l.coalesce)((0,l.asArray)(Fe).map(rt=>_e(rt,je)))}Ae.from=Re;function _e(Fe,je){if(typeof Fe=="string")return{$serialized:!0,language:Fe};if(Fe)return{$serialized:!0,language:Fe.language,scheme:te(Fe.scheme,je),pattern:Ee.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType}}function te(Fe,je){return je&&typeof Fe=="string"?je.transformOutgoingScheme(Fe):Fe}})(r=e.DocumentSelector||(e.DocumentSelector={}));var c;(function(Ae){function Re(te){switch(te){case a.DiagnosticTag.Unnecessary:return 1;case a.DiagnosticTag.Deprecated:return 2}}Ae.from=Re;function _e(te){switch(te){case 1:return a.DiagnosticTag.Unnecessary;case 2:return a.DiagnosticTag.Deprecated;default:return}}Ae.to=_e})(c=e.DiagnosticTag||(e.DiagnosticTag={}));var o;(function(Ae){function Re(te){let Fe;return te.code&&((0,I.isString)(te.code)||(0,I.isNumber)(te.code)?Fe=String(te.code):Fe={value:String(te.code.value),target:te.code.target}),{...d.from(te.range),message:te.message,source:te.source,code:Fe,severity:h.from(te.severity),relatedInformation:te.relatedInformation&&te.relatedInformation.map(u.from),tags:Array.isArray(te.tags)?(0,l.coalesce)(te.tags.map(c.from)):void 0}}Ae.from=Re;function _e(te){const Fe=new a.Diagnostic(d.to(te),te.message,h.to(te.severity));return Fe.source=te.source,Fe.code=(0,I.isString)(te.code)?te.code:te.code?.value,Fe.relatedInformation=te.relatedInformation&&te.relatedInformation.map(u.to),Fe.tags=te.tags&&(0,l.coalesce)(te.tags.map(c.to)),Fe}Ae.to=_e})(o=e.Diagnostic||(e.Diagnostic={}));var u;(function(Ae){function Re(te){return{...d.from(te.location.range),message:te.message,resource:te.location.uri}}Ae.from=Re;function _e(te){return new a.DiagnosticRelatedInformation(new a.Location(te.resource,d.to(te)),te.message)}Ae.to=_e})(u=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var h;(function(Ae){function Re(te){switch(te){case a.DiagnosticSeverity.Error:return T.MarkerSeverity.Error;case a.DiagnosticSeverity.Warning:return T.MarkerSeverity.Warning;case a.DiagnosticSeverity.Information:return T.MarkerSeverity.Info;case a.DiagnosticSeverity.Hint:return T.MarkerSeverity.Hint}return T.MarkerSeverity.Error}Ae.from=Re;function _e(te){switch(te){case T.MarkerSeverity.Info:return a.DiagnosticSeverity.Information;case T.MarkerSeverity.Warning:return a.DiagnosticSeverity.Warning;case T.MarkerSeverity.Error:return a.DiagnosticSeverity.Error;case T.MarkerSeverity.Hint:return a.DiagnosticSeverity.Hint;default:return a.DiagnosticSeverity.Error}}Ae.to=_e})(h=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var y;(function(Ae){function Re(te){return typeof te=="number"&&te>=a.ViewColumn.One?te-1:te===a.ViewColumn.Beside?m.SIDE_GROUP:m.ACTIVE_GROUP}Ae.from=Re;function _e(te){if(typeof te=="number"&&te>=0)return te+1;throw new Error("invalid 'EditorGroupColumn'")}Ae.to=_e})(y=e.ViewColumn||(e.ViewColumn={}));function R(Ae){return typeof Ae.range<"u"}function M(Ae){return Ae.length===0?!0:!!R(Ae[0])}e.isDecorationOptionsArr=M;var U;(function(Ae){function Re(Je){return Je.map(Ae.from)}Ae.fromMany=Re;function _e(Je){return Je&&typeof Je=="object"&&typeof Je.language=="string"&&typeof Je.value=="string"}function te(Je){let Xe;if(_e(Je)){const{language:Tt,value:St}=Je;Xe={value:"```"+Tt+`
`+St+"\n```\n"}}else a.MarkdownString.isMarkdownString(Je)?Xe={value:Je.value,isTrusted:Je.isTrusted,supportThemeIcons:Je.supportThemeIcons,supportHtml:Je.supportHtml,baseUri:Je.baseUri}:typeof Je=="string"?Xe={value:Je}:Xe={value:""};const lt=Object.create(null);Xe.uris=lt;const kt=Tt=>{try{let St=L.URI.parse(Tt,!0);St=St.with({query:Fe(St.query,lt)}),lt[Tt]=St}catch{}return""},vt=new _.marked.Renderer;return vt.link=kt,vt.image=Tt=>typeof Tt=="string"?kt(C.parseHrefAndDimensions(Tt).href):"",(0,_.marked)(Xe.value,{renderer:vt}),Xe}Ae.from=te;function Fe(Je,Xe){if(!Je)return Je;let lt;try{lt=(0,D.parse)(Je)}catch{}if(!lt)return Je;let kt=!1;return lt=(0,b.cloneAndChange)(lt,vt=>{if(L.URI.isUri(vt)){const Tt=`__uri_${Math.random().toString(16).slice(2,8)}`;return Xe[Tt]=vt,kt=!0,Tt}else return}),kt?JSON.stringify(lt):Je}function je(Je){const Xe=new a.MarkdownString(Je.value,Je.supportThemeIcons);return Xe.isTrusted=Je.isTrusted,Xe.supportHtml=Je.supportHtml,Xe.baseUri=Je.baseUri?L.URI.from(Je.baseUri):void 0,Xe}Ae.to=je;function rt(Je){if(!!Je)return typeof Je=="string"?Je:Ae.from(Je)}Ae.fromStrict=rt})(U=e.MarkdownString||(e.MarkdownString={}));function A(Ae){return M(Ae)?Ae.map(Re=>({range:d.from(Re.range),hoverMessage:Array.isArray(Re.hoverMessage)?U.fromMany(Re.hoverMessage):Re.hoverMessage?U.from(Re.hoverMessage):void 0,renderOptions:Re.renderOptions})):Ae.map(Re=>({range:d.from(Re)}))}e.fromRangeOrRangeWithMessage=A;function z(Ae){return typeof Ae>"u"?Ae:typeof Ae=="string"?L.URI.file(Ae):Ae}e.pathOrURIToURI=z;var $;(function(Ae){function Re(_e){return typeof _e>"u"?_e:{contentText:_e.contentText,contentIconPath:_e.contentIconPath?z(_e.contentIconPath):void 0,border:_e.border,borderColor:_e.borderColor,fontStyle:_e.fontStyle,fontWeight:_e.fontWeight,textDecoration:_e.textDecoration,color:_e.color,backgroundColor:_e.backgroundColor,margin:_e.margin,width:_e.width,height:_e.height}}Ae.from=Re})($=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var N;(function(Ae){function Re(_e){return typeof _e>"u"?_e:{backgroundColor:_e.backgroundColor,outline:_e.outline,outlineColor:_e.outlineColor,outlineStyle:_e.outlineStyle,outlineWidth:_e.outlineWidth,border:_e.border,borderColor:_e.borderColor,borderRadius:_e.borderRadius,borderSpacing:_e.borderSpacing,borderStyle:_e.borderStyle,borderWidth:_e.borderWidth,fontStyle:_e.fontStyle,fontWeight:_e.fontWeight,textDecoration:_e.textDecoration,cursor:_e.cursor,color:_e.color,opacity:_e.opacity,letterSpacing:_e.letterSpacing,gutterIconPath:_e.gutterIconPath?z(_e.gutterIconPath):void 0,gutterIconSize:_e.gutterIconSize,overviewRulerColor:_e.overviewRulerColor,before:_e.before?$.from(_e.before):void 0,after:_e.after?$.from(_e.after):void 0}}Ae.from=Re})(N=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var K;(function(Ae){function Re(_e){if(typeof _e>"u")return _e;switch(_e){case a.DecorationRangeBehavior.OpenOpen:return 0;case a.DecorationRangeBehavior.ClosedClosed:return 1;case a.DecorationRangeBehavior.OpenClosed:return 2;case a.DecorationRangeBehavior.ClosedOpen:return 3}}Ae.from=Re})(K=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var B;(function(Ae){function Re(_e){return{isWholeLine:_e.isWholeLine,rangeBehavior:_e.rangeBehavior?K.from(_e.rangeBehavior):void 0,overviewRulerLane:_e.overviewRulerLane,light:_e.light?N.from(_e.light):void 0,dark:_e.dark?N.from(_e.dark):void 0,backgroundColor:_e.backgroundColor,outline:_e.outline,outlineColor:_e.outlineColor,outlineStyle:_e.outlineStyle,outlineWidth:_e.outlineWidth,border:_e.border,borderColor:_e.borderColor,borderRadius:_e.borderRadius,borderSpacing:_e.borderSpacing,borderStyle:_e.borderStyle,borderWidth:_e.borderWidth,fontStyle:_e.fontStyle,fontWeight:_e.fontWeight,textDecoration:_e.textDecoration,cursor:_e.cursor,color:_e.color,opacity:_e.opacity,letterSpacing:_e.letterSpacing,gutterIconPath:_e.gutterIconPath?z(_e.gutterIconPath):void 0,gutterIconSize:_e.gutterIconSize,overviewRulerColor:_e.overviewRulerColor,before:_e.before?$.from(_e.before):void 0,after:_e.after?$.from(_e.after):void 0}}Ae.from=Re})(B=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var O;(function(Ae){function Re(te){return{text:te.newText,eol:te.newEol&&Qe.from(te.newEol),range:d.from(te.range)}}Ae.from=Re;function _e(te){const Fe=new a.TextEdit(d.to(te.range),te.text);return Fe.newEol=typeof te.eol>"u"?void 0:Qe.to(te.eol),Fe}Ae.to=_e})(O=e.TextEdit||(e.TextEdit={}));var x;(function(Ae){function Re(te,Fe,je){const rt={edits:[]};if(te instanceof a.WorkspaceEdit){const Je=new P.ResourceSet;for(const Xe of te._allEntries())Xe._type===1&&L.URI.isUri(Xe.to)&&Xe.from===void 0&&Je.add(Xe.to);for(const Xe of te._allEntries())if(Xe._type===1)rt.edits.push({oldResource:Xe.from,newResource:Xe.to,options:{...Xe.options,contentsBase64:Xe.options?.contents&&(0,t.encodeBase64)(t.VSBuffer.wrap(Xe.options.contents))},metadata:Xe.metadata});else if(Xe._type===2)rt.edits.push({resource:Xe.uri,textEdit:O.from(Xe.edit),versionId:Je.has(Xe.uri)?void 0:Fe?.getTextDocumentVersion(Xe.uri),metadata:Xe.metadata});else if(Xe._type===6){if(!je){console.warn("DROPPING snippet text edit because proposal IS NOT ENABLED",Xe);continue}rt.edits.push({resource:Xe.uri,textEdit:{range:d.from(Xe.range),text:Xe.edit.value,insertAsSnippet:!0},versionId:Je.has(Xe.uri)?void 0:Fe?.getTextDocumentVersion(Xe.uri),metadata:Xe.metadata})}else Xe._type===3?rt.edits.push({metadata:Xe.metadata,resource:Xe.uri,cellEdit:Xe.edit,notebookMetadata:Xe.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(Xe.uri)}):Xe._type===5&&rt.edits.push({metadata:Xe.metadata,resource:Xe.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(Xe.uri),cellEdit:{editType:1,index:Xe.index,count:Xe.count,cells:Xe.cells.map(it.from)}})}return rt}Ae.from=Re;function _e(te){const Fe=new a.WorkspaceEdit;for(const je of te.edits)je.textEdit?Fe.replace(L.URI.revive(je.resource),d.to(je.textEdit.range),je.textEdit.text):Fe.renameFile(L.URI.revive(je.oldResource),L.URI.revive(je.newResource),je.options);return Fe}Ae.to=_e})(x=e.WorkspaceEdit||(e.WorkspaceEdit={}));var V;(function(Ae){const Re=Object.create(null);Re[a.SymbolKind.File]=0,Re[a.SymbolKind.Module]=1,Re[a.SymbolKind.Namespace]=2,Re[a.SymbolKind.Package]=3,Re[a.SymbolKind.Class]=4,Re[a.SymbolKind.Method]=5,Re[a.SymbolKind.Property]=6,Re[a.SymbolKind.Field]=7,Re[a.SymbolKind.Constructor]=8,Re[a.SymbolKind.Enum]=9,Re[a.SymbolKind.Interface]=10,Re[a.SymbolKind.Function]=11,Re[a.SymbolKind.Variable]=12,Re[a.SymbolKind.Constant]=13,Re[a.SymbolKind.String]=14,Re[a.SymbolKind.Number]=15,Re[a.SymbolKind.Boolean]=16,Re[a.SymbolKind.Array]=17,Re[a.SymbolKind.Object]=18,Re[a.SymbolKind.Key]=19,Re[a.SymbolKind.Null]=20,Re[a.SymbolKind.EnumMember]=21,Re[a.SymbolKind.Struct]=22,Re[a.SymbolKind.Event]=23,Re[a.SymbolKind.Operator]=24,Re[a.SymbolKind.TypeParameter]=25;function _e(Fe){return typeof Re[Fe]=="number"?Re[Fe]:6}Ae.from=_e;function te(Fe){for(const je in Re)if(Re[je]===Fe)return Number(je);return a.SymbolKind.Property}Ae.to=te})(V=e.SymbolKind||(e.SymbolKind={}));var q;(function(Ae){function Re(te){switch(te){case a.SymbolTag.Deprecated:return 1}}Ae.from=Re;function _e(te){switch(te){case 1:return a.SymbolTag.Deprecated}}Ae.to=_e})(q=e.SymbolTag||(e.SymbolTag={}));var Y;(function(Ae){function Re(te){return{name:te.name,kind:V.from(te.kind),tags:te.tags&&te.tags.map(q.from),containerName:te.containerName,location:pe.from(te.location)}}Ae.from=Re;function _e(te){const Fe=new a.SymbolInformation(te.name,V.to(te.kind),te.containerName,pe.to(te.location));return Fe.tags=te.tags&&te.tags.map(q.to),Fe}Ae.to=_e})(Y=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var Q;(function(Ae){function Re(te){const Fe={name:te.name||"!!MISSING: name!!",detail:te.detail,range:d.from(te.range),selectionRange:d.from(te.selectionRange),kind:V.from(te.kind),tags:te.tags?.map(q.from)??[]};return te.children&&(Fe.children=te.children.map(Re)),Fe}Ae.from=Re;function _e(te){const Fe=new a.DocumentSymbol(te.name,te.detail,V.to(te.kind),d.to(te.range),d.to(te.selectionRange));return(0,l.isNonEmptyArray)(te.tags)&&(Fe.tags=te.tags.map(q.to)),te.children&&(Fe.children=te.children.map(_e)),Fe}Ae.to=_e})(Q=e.DocumentSymbol||(e.DocumentSymbol={}));var de;(function(Ae){function Re(te){const Fe=new a.CallHierarchyItem(V.to(te.kind),te.name,te.detail||"",L.URI.revive(te.uri),d.to(te.range),d.to(te.selectionRange));return Fe._sessionId=te._sessionId,Fe._itemId=te._itemId,Fe}Ae.to=Re;function _e(te,Fe,je){if(Fe=Fe??te._sessionId,je=je??te._itemId,Fe===void 0||je===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:je,name:te.name,detail:te.detail,kind:V.from(te.kind),uri:te.uri,range:d.from(te.range),selectionRange:d.from(te.selectionRange),tags:te.tags?.map(q.from)}}Ae.from=_e})(de=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ve;(function(Ae){function Re(_e){return new a.CallHierarchyIncomingCall(de.to(_e.from),_e.fromRanges.map(te=>d.to(te)))}Ae.to=Re})(ve=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ne;(function(Ae){function Re(_e){return new a.CallHierarchyOutgoingCall(de.to(_e.to),_e.fromRanges.map(te=>d.to(te)))}Ae.to=Re})(ne=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var pe;(function(Ae){function Re(te){return{range:te.range&&d.from(te.range),uri:te.uri}}Ae.from=Re;function _e(te){return new a.Location(L.URI.revive(te.uri),d.to(te.range))}Ae.to=_e})(pe=e.location||(e.location={}));var be;(function(Ae){function Re(te){const Fe=te,je=te;return{originSelectionRange:Fe.originSelectionRange?d.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:je.uri,range:d.from(Fe.targetRange?Fe.targetRange:je.range),targetSelectionRange:Fe.targetSelectionRange?d.from(Fe.targetSelectionRange):void 0}}Ae.from=Re;function _e(te){return{targetUri:L.URI.revive(te.uri),targetRange:d.to(te.range),targetSelectionRange:te.targetSelectionRange?d.to(te.targetSelectionRange):void 0,originSelectionRange:te.originSelectionRange?d.to(te.originSelectionRange):void 0}}Ae.to=_e})(be=e.DefinitionLink||(e.DefinitionLink={}));var ke;(function(Ae){function Re(te){return{range:d.from(te.range),contents:U.fromMany(te.contents)}}Ae.from=Re;function _e(te){return new a.Hover(te.contents.map(U.to),d.to(te.range))}Ae.to=_e})(ke=e.Hover||(e.Hover={}));var Oe;(function(Ae){function Re(te){return{range:d.from(te.range),expression:te.expression}}Ae.from=Re;function _e(te){return new a.EvaluatableExpression(d.to(te.range),te.expression)}Ae.to=_e})(Oe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var We;(function(Ae){function Re(te){if(te instanceof a.InlineValueText)return{type:"text",range:d.from(te.range),text:te.text};if(te instanceof a.InlineValueVariableLookup)return{type:"variable",range:d.from(te.range),variableName:te.variableName,caseSensitiveLookup:te.caseSensitiveLookup};if(te instanceof a.InlineValueEvaluatableExpression)return{type:"expression",range:d.from(te.range),expression:te.expression};throw new Error("Unknown 'InlineValue' type")}Ae.from=Re;function _e(te){switch(te.type){case"text":return{range:d.to(te.range),text:te.text};case"variable":return{range:d.to(te.range),variableName:te.variableName,caseSensitiveLookup:te.caseSensitiveLookup};case"expression":return{range:d.to(te.range),expression:te.expression}}}Ae.to=_e})(We=e.InlineValue||(e.InlineValue={}));var oe;(function(Ae){function Re(te){return{frameId:te.frameId,stoppedLocation:d.from(te.stoppedLocation)}}Ae.from=Re;function _e(te){return new a.InlineValueContext(te.frameId,d.to(te.stoppedLocation))}Ae.to=_e})(oe=e.InlineValueContext||(e.InlineValueContext={}));var le;(function(Ae){function Re(te){return{range:d.from(te.range),kind:te.kind}}Ae.from=Re;function _e(te){return new a.DocumentHighlight(d.to(te.range),te.kind)}Ae.to=_e})(le=e.DocumentHighlight||(e.DocumentHighlight={}));var fe;(function(Ae){function Re(_e){switch(_e){case 1:return a.CompletionTriggerKind.TriggerCharacter;case 2:return a.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return a.CompletionTriggerKind.Invoke}}Ae.to=Re})(fe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Z;(function(Ae){function Re(_e){return{triggerKind:fe.to(_e.triggerKind),triggerCharacter:_e.triggerCharacter}}Ae.to=Re})(Z=e.CompletionContext||(e.CompletionContext={}));var ae;(function(Ae){function Re(te){switch(te){case a.CompletionItemTag.Deprecated:return 1}}Ae.from=Re;function _e(te){switch(te){case 1:return a.CompletionItemTag.Deprecated}}Ae.to=_e})(ae=e.CompletionItemTag||(e.CompletionItemTag={}));var ee;(function(Ae){const Re=new Map([[a.CompletionItemKind.Method,0],[a.CompletionItemKind.Function,1],[a.CompletionItemKind.Constructor,2],[a.CompletionItemKind.Field,3],[a.CompletionItemKind.Variable,4],[a.CompletionItemKind.Class,5],[a.CompletionItemKind.Interface,7],[a.CompletionItemKind.Struct,6],[a.CompletionItemKind.Module,8],[a.CompletionItemKind.Property,9],[a.CompletionItemKind.Unit,12],[a.CompletionItemKind.Value,13],[a.CompletionItemKind.Constant,14],[a.CompletionItemKind.Enum,15],[a.CompletionItemKind.EnumMember,16],[a.CompletionItemKind.Keyword,17],[a.CompletionItemKind.Snippet,27],[a.CompletionItemKind.Text,18],[a.CompletionItemKind.Color,19],[a.CompletionItemKind.File,20],[a.CompletionItemKind.Reference,21],[a.CompletionItemKind.Folder,23],[a.CompletionItemKind.Event,10],[a.CompletionItemKind.Operator,11],[a.CompletionItemKind.TypeParameter,24],[a.CompletionItemKind.Issue,26],[a.CompletionItemKind.User,25]]);function _e(je){return Re.get(je)??9}Ae.from=_e;const te=new Map([[0,a.CompletionItemKind.Method],[1,a.CompletionItemKind.Function],[2,a.CompletionItemKind.Constructor],[3,a.CompletionItemKind.Field],[4,a.CompletionItemKind.Variable],[5,a.CompletionItemKind.Class],[7,a.CompletionItemKind.Interface],[6,a.CompletionItemKind.Struct],[8,a.CompletionItemKind.Module],[9,a.CompletionItemKind.Property],[12,a.CompletionItemKind.Unit],[13,a.CompletionItemKind.Value],[14,a.CompletionItemKind.Constant],[15,a.CompletionItemKind.Enum],[16,a.CompletionItemKind.EnumMember],[17,a.CompletionItemKind.Keyword],[27,a.CompletionItemKind.Snippet],[18,a.CompletionItemKind.Text],[19,a.CompletionItemKind.Color],[20,a.CompletionItemKind.File],[21,a.CompletionItemKind.Reference],[23,a.CompletionItemKind.Folder],[10,a.CompletionItemKind.Event],[11,a.CompletionItemKind.Operator],[24,a.CompletionItemKind.TypeParameter],[25,a.CompletionItemKind.User],[26,a.CompletionItemKind.Issue]]);function Fe(je){return te.get(je)??a.CompletionItemKind.Property}Ae.to=Fe})(ee=e.CompletionItemKind||(e.CompletionItemKind={}));var ie;(function(Ae){function Re(_e,te){const Fe=new a.CompletionItem(_e.label);return Fe.insertText=_e.insertText,Fe.kind=ee.to(_e.kind),Fe.tags=_e.tags?.map(ae.to),Fe.detail=_e.detail,Fe.documentation=C.isMarkdownString(_e.documentation)?U.to(_e.documentation):_e.documentation,Fe.sortText=_e.sortText,Fe.filterText=_e.filterText,Fe.preselect=_e.preselect,Fe.commitCharacters=_e.commitCharacters,k.Range.isIRange(_e.range)?Fe.range=d.to(_e.range):typeof _e.range=="object"&&(Fe.range={inserting:d.to(_e.range.insert),replacing:d.to(_e.range.replace)}),Fe.keepWhitespace=typeof _e.insertTextRules>"u"?!1:Boolean(_e.insertTextRules&1),typeof _e.insertTextRules<"u"&&_e.insertTextRules&4?Fe.insertText=new a.SnippetString(_e.insertText):(Fe.insertText=_e.insertText,Fe.textEdit=Fe.range instanceof a.Range?new a.TextEdit(Fe.range,Fe.insertText):void 0),_e.additionalTextEdits&&_e.additionalTextEdits.length>0&&(Fe.additionalTextEdits=_e.additionalTextEdits.map(je=>O.to(je))),Fe.command=te&&_e.command?te.fromInternal(_e.command):void 0,Fe}Ae.to=Re})(ie=e.CompletionItem||(e.CompletionItem={}));var F;(function(Ae){function Re(te){return{label:te.label,documentation:U.fromStrict(te.documentation)}}Ae.from=Re;function _e(te){return{label:te.label,documentation:C.isMarkdownString(te.documentation)?U.to(te.documentation):te.documentation}}Ae.to=_e})(F=e.ParameterInformation||(e.ParameterInformation={}));var H;(function(Ae){function Re(te){return{label:te.label,documentation:U.fromStrict(te.documentation),parameters:Array.isArray(te.parameters)?te.parameters.map(F.from):[],activeParameter:te.activeParameter}}Ae.from=Re;function _e(te){return{label:te.label,documentation:C.isMarkdownString(te.documentation)?U.to(te.documentation):te.documentation,parameters:Array.isArray(te.parameters)?te.parameters.map(F.to):[],activeParameter:te.activeParameter}}Ae.to=_e})(H=e.SignatureInformation||(e.SignatureInformation={}));var G;(function(Ae){function Re(te){return{activeSignature:te.activeSignature,activeParameter:te.activeParameter,signatures:Array.isArray(te.signatures)?te.signatures.map(H.from):[]}}Ae.from=Re;function _e(te){return{activeSignature:te.activeSignature,activeParameter:te.activeParameter,signatures:Array.isArray(te.signatures)?te.signatures.map(H.to):[]}}Ae.to=_e})(G=e.SignatureHelp||(e.SignatureHelp={}));var X;(function(Ae){function Re(_e,te){const Fe=new a.InlayHint(i.to(te.position),typeof te.label=="string"?te.label:te.label.map(me.to.bind(void 0,_e)),te.kind&&we.to(te.kind));return Fe.textEdits=te.textEdits&&te.textEdits.map(O.to),Fe.tooltip=C.isMarkdownString(te.tooltip)?U.to(te.tooltip):te.tooltip,Fe.paddingLeft=te.paddingLeft,Fe.paddingRight=te.paddingRight,Fe}Ae.to=Re})(X=e.InlayHint||(e.InlayHint={}));var me;(function(Ae){function Re(_e,te){const Fe=new a.InlayHintLabelPart(te.label);return Fe.tooltip=C.isMarkdownString(te.tooltip)?U.to(te.tooltip):te.tooltip,S.Command.is(te.command)&&(Fe.command=_e.fromInternal(te.command)),te.location&&(Fe.location=pe.to(te.location)),Fe}Ae.to=Re})(me=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var we;(function(Ae){function Re(te){return te}Ae.from=Re;function _e(te){return te}Ae.to=_e})(we=e.InlayHintKind||(e.InlayHintKind={}));var ce;(function(Ae){function Re(te){return{range:d.from(te.range),url:te.target,tooltip:te.tooltip}}Ae.from=Re;function _e(te){let Fe;if(te.url)try{Fe=typeof te.url=="string"?L.URI.parse(te.url,!0):L.URI.revive(te.url)}catch{}return new a.DocumentLink(d.to(te.range),Fe)}Ae.to=_e})(ce=e.DocumentLink||(e.DocumentLink={}));var Ce;(function(Ae){function Re(te){const Fe=new a.ColorPresentation(te.label);return te.textEdit&&(Fe.textEdit=O.to(te.textEdit)),te.additionalTextEdits&&(Fe.additionalTextEdits=te.additionalTextEdits.map(je=>O.to(je))),Fe}Ae.to=Re;function _e(te){return{label:te.label,textEdit:te.textEdit?O.from(te.textEdit):void 0,additionalTextEdits:te.additionalTextEdits?te.additionalTextEdits.map(Fe=>O.from(Fe)):void 0}}Ae.from=_e})(Ce=e.ColorPresentation||(e.ColorPresentation={}));var ye;(function(Ae){function Re(te){return new a.Color(te[0],te[1],te[2],te[3])}Ae.to=Re;function _e(te){return[te.red,te.green,te.blue,te.alpha]}Ae.from=_e})(ye=e.Color||(e.Color={}));var $e;(function(Ae){function Re(te){return{range:d.from(te.range)}}Ae.from=Re;function _e(te){return new a.SelectionRange(d.to(te.range))}Ae.to=_e})($e=e.SelectionRange||(e.SelectionRange={}));var Ve;(function(Ae){function Re(_e){switch(_e){case 2:return a.TextDocumentSaveReason.AfterDelay;case 1:return a.TextDocumentSaveReason.Manual;case 3:case 4:return a.TextDocumentSaveReason.FocusOut}}Ae.to=Re})(Ve=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ze;(function(Ae){function Re(te){switch(te){case a.TextEditorLineNumbersStyle.Off:return 0;case a.TextEditorLineNumbersStyle.Relative:return 2;case a.TextEditorLineNumbersStyle.On:default:return 1}}Ae.from=Re;function _e(te){switch(te){case 0:return a.TextEditorLineNumbersStyle.Off;case 2:return a.TextEditorLineNumbersStyle.Relative;case 1:default:return a.TextEditorLineNumbersStyle.On}}Ae.to=_e})(Ze=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Qe;(function(Ae){function Re(te){if(te===a.EndOfLine.CRLF)return 1;if(te===a.EndOfLine.LF)return 0}Ae.from=Re;function _e(te){if(te===1)return a.EndOfLine.CRLF;if(te===0)return a.EndOfLine.LF}Ae.to=_e})(Qe=e.EndOfLine||(e.EndOfLine={}));var Le;(function(Ae){function Re(_e){if(typeof _e=="object")return _e.viewId;switch(_e){case a.ProgressLocation.SourceControl:return 3;case a.ProgressLocation.Window:return 10;case a.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ae.from=Re})(Le=e.ProgressLocation||(e.ProgressLocation={}));var ot;(function(Ae){function Re(_e){const te={start:_e.start+1,end:_e.end+1};return _e.kind&&(te.kind=re.from(_e.kind)),te}Ae.from=Re})(ot=e.FoldingRange||(e.FoldingRange={}));var re;(function(Ae){function Re(_e){if(_e)switch(_e){case a.FoldingRangeKind.Comment:return S.FoldingRangeKind.Comment;case a.FoldingRangeKind.Imports:return S.FoldingRangeKind.Imports;case a.FoldingRangeKind.Region:return S.FoldingRangeKind.Region}}Ae.from=Re})(re=e.FoldingRangeKind||(e.FoldingRangeKind={}));var se;(function(Ae){function Re(_e){if(_e)return{pinned:typeof _e.preview=="boolean"?!_e.preview:void 0,inactive:_e.background,preserveFocus:_e.preserveFocus,selection:typeof _e.selection=="object"?d.from(_e.selection):void 0,override:typeof _e.override=="boolean"?p.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Ae.from=Re})(se=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ee;(function(Ae){function Re(je){return je instanceof a.RelativePattern?je.toJSON():typeof je=="string"?je:_e(je)||te(je)?new a.RelativePattern(je.baseUri??je.base,je.pattern).toJSON():je}Ae.from=Re;function _e(je){const rt=je;return rt?L.URI.isUri(rt.baseUri)&&typeof rt.pattern=="string":!1}function te(je){const rt=je;return rt?typeof rt.base=="string"&&typeof rt.pattern=="string":!1}function Fe(je){return typeof je=="string"?je:new a.RelativePattern(L.URI.revive(je.baseUri),je.pattern)}Ae.to=Fe})(Ee=e.GlobPattern||(e.GlobPattern={}));var ue;(function(Ae){function Re(_e){if(_e){if(Array.isArray(_e))return _e.map(Re);if(typeof _e=="string")return _e;{const te=_e;return{language:te.language,scheme:te.scheme,pattern:Ee.from(te.pattern),exclusive:te.exclusive,notebookType:te.notebookType}}}else return}Ae.from=Re})(ue=e.LanguageSelector||(e.LanguageSelector={}));var Te;(function(Ae){function Re(te){return{start:te.start,end:te.end}}Ae.from=Re;function _e(te){return new a.NotebookRange(te.start,te.end)}Ae.to=_e})(Te=e.NotebookRange||(e.NotebookRange={}));var Me;(function(Ae){function Re(te){return{timing:typeof te.runStartTime=="number"&&typeof te.runEndTime=="number"?{startTime:te.runStartTime,endTime:te.runEndTime}:void 0,executionOrder:te.executionOrder,success:te.lastRunSuccess}}Ae.to=Re;function _e(te){return{lastRunSuccess:te.success,runStartTime:te.timing?.startTime,runEndTime:te.timing?.endTime,executionOrder:te.executionOrder}}Ae.from=_e})(Me=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Be;(function(Ae){function Re(_e){if(_e===w.NotebookCellExecutionState.Unconfirmed)return a.NotebookCellExecutionState.Pending;if(_e===w.NotebookCellExecutionState.Pending)return;if(_e===w.NotebookCellExecutionState.Executing)return a.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${_e}`)}Ae.to=Re})(Be=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ze;(function(Ae){function Re(te){switch(te){case a.NotebookCellKind.Markup:return w.CellKind.Markup;case a.NotebookCellKind.Code:default:return w.CellKind.Code}}Ae.from=Re;function _e(te){switch(te){case w.CellKind.Markup:return a.NotebookCellKind.Markup;case w.CellKind.Code:default:return a.NotebookCellKind.Code}}Ae.to=_e})(ze=e.NotebookCellKind||(e.NotebookCellKind={}));var Ye;(function(Ae){function Re(te){const Fe={metadata:te.metadata??Object.create(null),cells:[]};for(const je of te.cells)a.NotebookCellData.validate(je),Fe.cells.push(it.from(je));return Fe}Ae.from=Re;function _e(te){const Fe=new a.NotebookData(te.cells.map(it.to));return(0,I.isEmptyObject)(te.metadata)||(Fe.metadata=te.metadata),Fe}Ae.to=_e})(Ye=e.NotebookData||(e.NotebookData={}));var it;(function(Ae){function Re(te){return{cellKind:ze.from(te.kind),language:te.languageId,mime:te.mime,source:te.value,metadata:te.metadata,internalMetadata:Me.from(te.executionSummary??{}),outputs:te.outputs?te.outputs.map(st.from):[]}}Ae.from=Re;function _e(te){return new a.NotebookCellData(ze.to(te.cellKind),te.source,te.language,te.mime,te.outputs?te.outputs.map(st.to):void 0,te.metadata,te.internalMetadata?Me.to(te.internalMetadata):void 0)}Ae.to=_e})(it=e.NotebookCellData||(e.NotebookCellData={}));var ct;(function(Ae){function Re(te){return{mime:te.mime,valueBytes:t.VSBuffer.wrap(te.data)}}Ae.from=Re;function _e(te){return new a.NotebookCellOutputItem(te.valueBytes.buffer,te.mime)}Ae.to=_e})(ct=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var st;(function(Ae){function Re(te){return{outputId:te.id,items:te.items.map(ct.from),metadata:te.metadata}}Ae.from=Re;function _e(te){const Fe=te.items.map(ct.to);return new a.NotebookCellOutput(Fe,te.outputId,te.metadata)}Ae.to=_e})(st=e.NotebookCellOutput||(e.NotebookCellOutput={}));var et;(function(Ae){function Re(Fe){return te(Fe)?{include:(0,I.withNullAsUndefined)(Ee.from(Fe.include)),exclude:(0,I.withNullAsUndefined)(Ee.from(Fe.exclude))}:(0,I.withNullAsUndefined)(Ee.from(Fe))}Ae.from=Re;function _e(Fe){return te(Fe)?{include:Ee.to(Fe.include),exclude:Ee.to(Fe.exclude)}:Ee.to(Fe)}Ae.to=_e;function te(Fe){const je=Fe;return je?!(0,I.isUndefinedOrNull)(je.include)&&!(0,I.isUndefinedOrNull)(je.exclude):!1}})(et=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ft;(function(Ae){function Re(_e,te,Fe){const je=typeof _e.command=="string"?{title:"",command:_e.command}:_e.command;return{alignment:_e.alignment===a.NotebookCellStatusBarAlignment.Left?1:2,command:te.toInternal(je,Fe),text:_e.text,tooltip:_e.tooltip,accessibilityInformation:_e.accessibilityInformation,priority:_e.priority}}Ae.from=Re})(ft=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Et;(function(Ae){function Re(_e){return{transientOutputs:_e?.transientOutputs??!1,transientCellMetadata:_e?.transientCellMetadata??{},transientDocumentMetadata:_e?.transientDocumentMetadata??{}}}Ae.from=Re})(Et=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Dt;(function(Ae){function Re(te){return{uri:te.uri,provides:te.provides}}Ae.from=Re;function _e(te){return new a.NotebookRendererScript(L.URI.revive(te.uri),te.provides)}Ae.to=_e})(Dt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var mt;(function(Ae){function Re(te){return{message:U.fromStrict(te.message)||"",type:0,expected:te.expectedOutput,actual:te.actualOutput,location:te.location&&{range:d.from(te.location.range),uri:te.location.uri}}}Ae.from=Re;function _e(te){const Fe=new a.TestMessage(typeof te.message=="string"?te.message:U.to(te.message));return Fe.actualOutput=te.actual,Fe.expectedOutput=te.expected,Fe.location=te.location?pe.to(te.location):void 0,Fe}Ae.to=_e})(mt=e.TestMessage||(e.TestMessage={}));var It;(function(Ae){Ae.namespace=v.namespaceTestTag,Ae.denamespace=v.denamespaceTestTag})(It=e.TestTag||(e.TestTag={}));var Ft;(function(Ae){function Re(te){const Fe=(0,E.getPrivateApiFor)(te).controllerId;return{extId:f.TestId.fromExtHostTestItem(te,Fe).toString(),label:te.label,uri:L.URI.revive(te.uri),busy:te.busy,tags:te.tags.map(je=>It.namespace(Fe,je.id)),range:k.Range.lift(d.from(te.range)),description:te.description||null,sortText:te.sortText||null,error:te.error&&U.fromStrict(te.error)||null}}Ae.from=Re;function _e(te){return{parent:void 0,error:void 0,id:f.TestId.fromString(te.extId).localId,label:te.label,uri:L.URI.revive(te.uri),tags:(te.tags||[]).map(Fe=>{const{tagId:je}=It.denamespace(Fe);return new a.TestTag(je)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:d.to(te.range||void 0),canResolveChildren:!1,busy:te.busy,description:te.description||void 0,sortText:te.sortText||void 0}}Ae.toPlain=_e})(Ft=e.TestItem||(e.TestItem={})),function(Ae){function Re(te){return{id:te.id}}Ae.from=Re;function _e(te){return new a.TestTag(te.id)}Ae.to=_e}(It=e.TestTag||(e.TestTag={}));var Nt;(function(Ae){const Re=(te,Fe)=>{const je=[];for(const[Je,Xe]of Fe)f.TestId.compare(Xe.item.extId,Je)===2&&(Fe.delete(Je),je.push(Xe));const rt={...Ft.toPlain(te.item),parent:void 0,taskStates:te.tasks.map(Je=>({state:Je.state,duration:Je.duration,messages:Je.messages.filter(Xe=>Xe.type===0).map(mt.to)})),children:je.map(Je=>Re(Je,Fe))};for(const Je of rt.children)Je.parent=rt;return rt};function _e(te){const Fe=[],je=new Map;for(const rt of te.items)je.set(rt.item.extId,rt),te.request.targets.some(Je=>Je.controllerId===rt.controllerId&&Je.testIds.includes(rt.item.extId))&&Fe.push(rt);return{completedAt:te.completedAt,results:Fe.map(rt=>Re(rt,je))}}Ae.to=_e})(Nt=e.TestResults||(e.TestResults={}));var Ke;(function(Ae){function Re(je){return{covered:je.covered,total:je.covered}}function _e(je){return"line"in je?i.from(je):d.from(je)}function te(je){return"branches"in je?{count:je.executionCount,location:_e(je.location),type:1,branches:je.branches.length?je.branches.map(rt=>({count:rt.executionCount,location:rt.location&&_e(rt.location)})):void 0}:{type:0,count:je.executionCount,location:_e(je.location)}}Ae.fromDetailed=te;function Fe(je){return{uri:je.uri,statement:Re(je.statementCoverage),branch:je.branchCoverage&&Re(je.branchCoverage),function:je.functionCoverage&&Re(je.functionCoverage),details:je.detailedCoverage?.map(te)}}Ae.fromFile=Fe})(Ke=e.TestCoverage||(e.TestCoverage={}));var Ut;(function(Ae){function Re(_e){switch(_e){case 1:return a.CodeActionTriggerKind.Invoke;case 2:return a.CodeActionTriggerKind.Automatic}}Ae.to=Re})(Ut=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ot;(function(Ae){function Re(te){const Fe=new a.TypeHierarchyItem(V.to(te.kind),te.name,te.detail||"",L.URI.revive(te.uri),d.to(te.range),d.to(te.selectionRange));return Fe._sessionId=te._sessionId,Fe._itemId=te._itemId,Fe}Ae.to=Re;function _e(te,Fe,je){if(Fe=Fe??te._sessionId,je=je??te._itemId,Fe===void 0||je===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:je,kind:V.from(te.kind),name:te.name,detail:te.detail??"",uri:te.uri,range:d.from(te.range),selectionRange:d.from(te.selectionRange),tags:te.tags?.map(q.from)}}Ae.from=_e})(Ot=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Pt;(function(Ae){function Re(_e){if(!!_e)return{value:_e.value,tooltip:_e.tooltip}}Ae.from=Re})(Pt=e.ViewBadge||(e.ViewBadge={}));var pt;(function(Ae){function Re(_e,te){const Fe=_e.fileData;return Fe?new class extends a.DataTransferItem{asFile(){return{name:Fe.name,uri:L.URI.revive(Fe.uri),data:(0,g.once)(()=>te())}}}("",_e.id):new a.DataTransferItem(_e.asString)}Ae.toDataTransferItem=Re})(pt=e.DataTransferItem||(e.DataTransferItem={}));var Ct;(function(Ae){function Re(te,Fe){const je=te.items.map(([rt,Je])=>[rt,pt.toDataTransferItem(Je,()=>Fe(Je.id))]);return new a.DataTransfer(je)}Ae.toDataTransfer=Re;async function _e(te){const Fe={items:[]},je=[];return te.forEach((rt,Je)=>{je.push((async()=>{const Xe=await rt.asString(),lt=rt.asFile();Fe.items.push([Je,{id:rt.id,asString:Xe,fileData:lt?{name:lt.name,uri:lt.uri}:void 0}])})())}),await Promise.all(je),Fe}Ae.toDataTransferDTO=_e})(Ct=e.DataTransfer||(e.DataTransfer={}))}),define(De[225],Ie([1,0,2,10,7,13,77]),function(J,e,l,t,C,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class D{constructor(I,L,k,S={timeout:1500,errors:3}){this._logService=I,this._documents=L,this._mainThreadBulkEdits=k,this._thresholds=S,this._callbacks=new _.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(I){return(L,k,S)=>{const E={dispose:this._callbacks.push([L,k,I])};return Array.isArray(S)&&S.push(E),E}}async $participateInSave(I,L){const k=l.URI.revive(I);let S=!1;const T=setTimeout(()=>S=!0,this._thresholds.timeout),E=[];try{for(const p of[...this._callbacks]){if(S)break;const w=this._documents.getDocument(k),f=await this._deliverEventAsyncAndBlameBadListeners(p,{document:w,reason:P.TextDocumentSaveReason.to(L)});E.push(f)}}finally{clearTimeout(T)}return E}_deliverEventAsyncAndBlameBadListeners([I,L,k],S){const T=this._badListeners.get(I);return typeof T=="number"&&T>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(k,I,L,S).then(()=>!0,E=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this._logService.error(E),!(E instanceof Error)||E.message!=="concurrent_edits"){const p=this._badListeners.get(I);this._badListeners.set(I,p?p+1:1),typeof p=="number"&&p>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(I,L,k,S){const T=[],E=Date.now(),{document:p,reason:w}=S,{version:f}=p,v=Object.freeze({document:p,reason:w,waitUntil(m){if(Object.isFrozen(T))throw(0,t.illegalState)("waitUntil can not be called async");T.push(Promise.resolve(m))}});try{L.apply(k,[v])}catch(m){return Promise.reject(m)}return Object.freeze(T),new Promise((m,a)=>{const g=setTimeout(()=>a(new Error("timeout")),this._thresholds.timeout);return Promise.all(T).then(n=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-E}ms`),clearTimeout(g),m(n)}).catch(n=>{clearTimeout(g),a(n)})}).then(m=>{const a={edits:[]};for(const g of m)if(Array.isArray(g)&&g.every(n=>n instanceof C.TextEdit))for(const{newText:n,newEol:d,range:s}of g)a.edits.push({resource:p.uri,versionId:void 0,textEdit:{range:s&&P.Range.from(s),text:n,eol:d&&P.EndOfLine.from(d)}});if(a.edits.length!==0)return f===p.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(a):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=D}),define(De[226],Ie([1,0,12,2,13,7,89]),function(J,e,l,t,C,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class D{constructor(k,S,T,E){this.start=k,this.deletedCount=S,this.deletedItems=T,this.items=E}asApiEvent(){return{range:new P.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class b{constructor(k,S,T){this.notebook=k,this._extHostDocument=S,this._cellData=T,this.handle=T.handle,this.uri=t.URI.revive(T.uri),this.cellKind=T.cellKind,this._outputs=T.outputs.map(C.NotebookCellOutput.to),this._internalMetadata=T.internalMetadata??{},this._metadata=Object.freeze(T.metadata??{}),this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(T.internalMetadata??{}))}static asModelAddData(k,S){return{EOL:S.eol,lines:S.source,languageId:S.language,uri:S.uri,isDirty:!1,versionId:1,notebook:k}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const k=this,S=this._extHostDocument.getDocument(this.uri);if(!S)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const T={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:C.NotebookCellKind.to(this._cellData.cellKind),document:S.document,get mime(){return k._mime},set mime(E){k._mime=E},get outputs(){return k._outputs.slice(0)},get metadata(){return k._metadata},get executionSummary(){return k._previousResult}};this._apiCell=Object.freeze(T)}return this._apiCell}setOutputs(k){this._outputs=k.map(C.NotebookCellOutput.to)}setOutputItems(k,S,T){const E=T.map(C.NotebookCellOutputItem.to),p=this._outputs.find(w=>w.id===k);p&&(S||(p.items.length=0),p.items.push(...E))}setMetadata(k){this._metadata=Object.freeze(k)}setInternalMetadata(k){this._internalMetadata=k,this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.ExtHostCell=b;class I{constructor(k,S,T,E,p){this._proxy=k,this._textDocumentsAndEditors=S,this._textDocuments=T,this.uri=E,this.handle=I._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=p.viewType,this._metadata=Object.freeze(p.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,p.cells]],!0,void 0),this._versionId=p.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const k=this,S={get uri(){return k.uri},get version(){return k._versionId},get notebookType(){return k._notebookType},get isDirty(){return k._isDirty},get isUntitled(){return k.uri.scheme===l.Schemas.untitled},get isClosed(){return k._disposed},get metadata(){return k._metadata},get cellCount(){return k._cells.length},cellAt(T){return T=k._validateIndex(T),k._cells[T].apiCell},getCells(T){return(T?k._getCells(T):k._cells).map(p=>p.apiCell)},save(){return k._save()}};this._notebook=Object.freeze(S)}return this._notebook}acceptDocumentPropertiesChanged(k){k.metadata&&(this._metadata=Object.freeze({...this._metadata,...k.metadata}))}acceptDirty(k){this._isDirty=k}acceptModelChanged(k,S,T){this._versionId=k.versionId,this._isDirty=S,this.acceptDocumentPropertiesChanged({metadata:T});const E={notebook:this.apiNotebook,metadata:T,cellChanges:[],contentChanges:[]},p=[];for(const f of k.rawEvents)f.kind===_.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(f.changes,!1,E.contentChanges):f.kind===_.NotebookCellsChangeType.Move?this._moveCell(f.index,f.newIdx,E.contentChanges):f.kind===_.NotebookCellsChangeType.Output?(this._setCellOutputs(f.index,f.outputs),p.push({cell:this._cells[f.index].apiCell,outputs:this._cells[f.index].apiCell.outputs})):f.kind===_.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(f.index,f.outputId,f.append,f.outputItems),p.push({cell:this._cells[f.index].apiCell,outputs:this._cells[f.index].apiCell.outputs})):f.kind===_.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(f.index,f.language),p.push({cell:this._cells[f.index].apiCell,document:this._cells[f.index].apiCell.document})):f.kind===_.NotebookCellsChangeType.ChangeCellContent?p.push({cell:this._cells[f.index].apiCell,document:this._cells[f.index].apiCell.document}):f.kind===_.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(f.index,f.mime):f.kind===_.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(f.index,f.metadata),p.push({cell:this._cells[f.index].apiCell,metadata:this._cells[f.index].apiCell.metadata})):f.kind===_.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(f.index,f.internalMetadata),p.push({cell:this._cells[f.index].apiCell,executionSummary:this._cells[f.index].apiCell.executionSummary}));const w=new Map;for(let f=0;f<p.length;f++){const v=p[f],m=w.get(v.cell);if(m===void 0){const a=E.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...v});w.set(v.cell,a-1)}else E.cellChanges[m]={...E.cellChanges[m],...v}}return Object.freeze(E),Object.freeze(E.cellChanges),Object.freeze(E.contentChanges),E}_validateIndex(k){return k=k|0,k<0?0:k>=this._cells.length?this._cells.length-1:k}_validateRange(k){let S=k.start|0,T=k.end|0;return S<0&&(S=0),T>this._cells.length&&(T=this._cells.length),k.with({start:S,end:T})}_getCells(k){k=this._validateRange(k);const S=[];for(let T=k.start;T<k.end;T++)S.push(this._cells[T]);return S}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(k,S,T){if(this._disposed)return;const E=[],p=[],w=[];if(k.reverse().forEach(f=>{const m=f[2].map(n=>{const d=new b(this,this._textDocumentsAndEditors,n);return S||p.push(b.asModelAddData(this.apiNotebook,n)),d}),a=new D(f[0],f[1],[],m),g=this._cells.splice(f[0],f[1],...m);for(const n of g)w.push(n.uri),a.deletedItems.push(n.apiCell);E.push(a)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:p,removedDocuments:w}),T)for(const f of E)T.push(f.asApiEvent())}_moveCell(k,S,T){const E=this._cells.splice(k,1);this._cells.splice(S,0,...E);const p=[new D(k,1,E.map(w=>w.apiCell),[]),new D(S,0,[],E)];for(const w of p)T.push(w.asApiEvent())}_setCellOutputs(k,S){this._cells[k].setOutputs(S)}_setCellOutputItems(k,S,T,E){this._cells[k].setOutputItems(S,T,E)}_changeCellLanguage(k,S){const T=this._cells[k];T.apiCell.document.languageId!==S&&this._textDocuments.$acceptModelLanguageChanged(T.uri,S)}_changeCellMime(k,S){const T=this._cells[k];T.apiCell.mime=S}_changeCellMetadata(k,S){this._cells[k].setMetadata(S)}_changeCellInternalMetadata(k,S){this._cells[k].setInternalMetadata(S)}getCellFromApiCell(k){return this._cells.find(S=>S.apiCell===k)}getCellFromIndex(k){return this._cells[k]}getCell(k){return this._cells.find(S=>S.handle===k)}getCellIndex(k){return this._cells.indexOf(k)}}e.ExtHostNotebookDocument=I,I._handlePool=0}),define(De[132],Ie([1,0,10,13,7]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class P{constructor(D,b,I,L,k,S){this.id=D,this._proxy=b,this.notebookData=I,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=k,this._visibleRanges=L,this._viewColumn=S}get apiEditor(){if(!this._editor){const D=this;this._editor={get document(){return D.notebookData.apiNotebook},get notebook(){return D.notebookData.apiNotebook},get selection(){return D._selections[0]},set selection(b){this.selections=[b]},get selections(){return D._selections},set selections(b){if(!Array.isArray(b)||!b.every(C.NotebookRange.isNotebookRange))throw(0,l.illegalArgument)("selections");D._selections=b,D._trySetSelections(b)},get visibleRanges(){return D._visibleRanges},revealRange(b,I){D._proxy.$tryRevealRange(D.id,t.NotebookRange.from(b),I??C.NotebookEditorRevealType.Default)},get viewColumn(){return D._viewColumn}},P.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(D){this._visible=D}_acceptVisibleRanges(D){this._visibleRanges=D}_acceptSelections(D){this._selections=D}_trySetSelections(D){this._proxy.$trySetSelections(this.id,D.map(t.NotebookRange.from))}_acceptViewColumn(D){this._viewColumn=D}}e.ExtHostNotebookEditor=P,P.apiEditorsToExtHost=new WeakMap}),define(De[227],Ie([1,0,4,15,13]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let P=class{constructor(D,b){this._logService=D,this._notebooksAndEditors=b,this._onDidChangeNotebookEditorSelection=new l.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new l.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(D,b){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",D,b);const I=this._notebooksAndEditors.getEditorById(D);b.visibleRanges&&I._acceptVisibleRanges(b.visibleRanges.ranges.map(C.NotebookRange.to)),b.selections&&I._acceptSelections(b.selections.selections.map(C.NotebookRange.to)),b.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:I.apiEditor,visibleRanges:I.apiEditor.visibleRanges}),b.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:I.apiEditor,selections:I.apiEditor.selections}))}$acceptEditorViewColumns(D){for(const b in D)this._notebooksAndEditors.getEditorById(b)._acceptViewColumn(C.ViewColumn.to(D[b]))}};P=qe([xe(0,t.ILogService)],P),e.ExtHostNotebookEditors=P}),define(De[228],Ie([1,0,13,119,171,21,58,10]),function(J,e,l,t,C,P,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class b{constructor(S){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=S}async withProgress(S,T,E){const p=this._handles++,{title:w,location:f,cancellable:v}=T,m={label:(0,C.localize)(0,null,S.displayName||S.name),id:S.identifier.value};return this._proxy.$startProgress(p,{location:l.ProgressLocation.from(f),title:w,source:m,cancellable:v},S.isUnderDevelopment?void 0:S.identifier.value).catch(D.onUnexpectedExternalError),this._withProgress(p,E,!!v)}_withProgress(S,T,E){let p;E&&(p=new P.CancellationTokenSource,this._mapHandleToCancellationSource.set(S,p));const w=v=>{this._proxy.$progressEnd(v),this._mapHandleToCancellationSource.delete(v),p?.dispose()};let f;try{f=T(new L(this._proxy,S),E&&p?p.token:P.CancellationToken.None)}catch(v){throw w(S),v}return f.then(v=>w(S),v=>w(S)),f}$acceptProgressCanceled(S){const T=this._mapHandleToCancellationSource.get(S);T&&(T.cancel(),this._mapHandleToCancellationSource.delete(S))}}e.ExtHostProgress=b;function I(k,S){return k.message=S.message,typeof S.increment=="number"&&(typeof k.increment=="number"?k.increment+=S.increment:k.increment=S.increment),k}class L extends t.Progress{constructor(S,T){super(E=>this.throttledReport(E)),this._proxy=S,this._handle=T}throttledReport(S){this._proxy.$progressReport(this._handle,S)}}qe([(0,_.throttle)(100,(k,S)=>I(k,S),()=>Object.create(null))],L.prototype,"throttledReport",null)}),define(De[133],Ie([1,0,35,128,63,90,64,13,2]),function(J,e,l,t,C,P,_,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const I=(m,a,g,n)=>{let d=a;return{enumerable:!0,configurable:!1,get(){return d},set(s){if(!g(d,s)){const i=d;d=s,m.listener?.(n(s,i))}}}},L=(m,a)=>m===a,k={range:(m,a)=>m===a?!0:!m||!a?!1:m.isEqual(a),label:L,description:L,sortText:L,busy:L,error:L,canResolveChildren:L,tags:(m,a)=>!(m.length!==a.length||m.some(g=>!a.find(n=>g.id===n.id)))},S=m=>a=>({op:4,update:m(a)}),T=(m,a)=>({range:I(m,void 0,k.range,S(g=>({range:l.Range.lift(D.Range.from(g))}))),label:I(m,a,k.label,S(g=>({label:g}))),description:I(m,void 0,k.description,S(g=>({description:g}))),sortText:I(m,void 0,k.sortText,S(g=>({sortText:g}))),canResolveChildren:I(m,!1,k.canResolveChildren,g=>({op:2,state:g})),busy:I(m,!1,k.busy,S(g=>({busy:g}))),error:I(m,void 0,k.error,S(g=>({error:D.MarkdownString.fromStrict(g)||null}))),tags:I(m,[],k.tags,(g,n)=>({op:1,new:g.map(D.TestTag.from),old:n.map(D.TestTag.from)}))}),E=m=>{const a=C.TestId.fromString(m.extId),g=new w(a.controllerId,a.localId,m.label,b.URI.revive(m.uri)||void 0);return g.range=D.Range.to(m.range||void 0),g.description=m.description||void 0,g.sortText=m.sortText||void 0,g.tags=m.tags.map(n=>D.TestTag.to({id:(0,_.denamespaceTestTag)(n).tagId})),g},p=m=>{let a;for(const g of m.tests){const n=E(g.item);(0,t.getPrivateApiFor)(n).parent=a,a=n}return a};e.toItemFromContext=p;class w{constructor(a,g,n,d){if(g.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(g)} symbol`);const s=(0,t.createPrivateApiFor)(this,a);Object.defineProperties(this,{id:{value:g,enumerable:!0,writable:!1},uri:{value:d,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof f?void 0:s.parent}},children:{value:(0,P.createTestItemChildren)(s,t.getPrivateApiFor,w),enumerable:!0,writable:!1},...T(s,n)})}}e.TestItemImpl=w;class f extends w{constructor(a,g){super(a,a,g,void 0)}}e.TestItemRootImpl=f;class v extends P.TestItemCollection{constructor(a,g,n){super({controllerId:a,getDocumentVersion:d=>n.getDocument(d)?.version,getApiFor:t.getPrivateApiFor,getChildren:d=>d.children,root:new f(a,g),toITestItem:D.TestItem.from})}}e.ExtHostTestItemCollection=v}),define(De[134],Ie([1,0,48,10,94,13,7]),function(J,e,l,t,C,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class D{constructor(S,T,E){const p=D._Keys.nextId();S.$registerTextEditorDecorationType(T.identifier,p,P.DecorationRenderOptions.from(E)),this.value=Object.freeze({key:p,dispose(){S.$removeTextEditorDecorationType(p)}})}}e.TextEditorDecorationType=D,D._Keys=new C.IdGenerator("TextEditorDecorationType");class b{constructor(S,T){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=S,this._documentVersionId=S.version,this._undoStopBefore=T.undoStopBefore,this._undoStopAfter=T.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(S,T){this._throwIfFinalized();let E=null;if(S instanceof _.Position)E=new _.Range(S,S);else if(S instanceof _.Range)E=S;else throw new Error("Unrecognized location");this._pushEdit(E,T,!1)}insert(S,T){this._throwIfFinalized(),this._pushEdit(new _.Range(S,S),T,!0)}delete(S){this._throwIfFinalized();let T=null;if(S instanceof _.Range)T=S;else throw new Error("Unrecognized location");this._pushEdit(T,null,!0)}_pushEdit(S,T,E){const p=this._document.validateRange(S);this._collectedEdits.push({range:p,text:T,forceMoveMarkers:E})}setEndOfLine(S){if(this._throwIfFinalized(),S!==_.EndOfLine.LF&&S!==_.EndOfLine.CRLF)throw(0,t.illegalArgument)("endOfLine");this._setEndOfLine=S}}e.TextEditorEdit=b;class I{constructor(S,T,E,p){this._proxy=S,this._id=T,this._accept(E),this._logService=p;const w=this;this.value={get tabSize(){return w._tabSize},set tabSize(f){w._setTabSize(f)},get insertSpaces(){return w._insertSpaces},set insertSpaces(f){w._setInsertSpaces(f)},get cursorStyle(){return w._cursorStyle},set cursorStyle(f){w._setCursorStyle(f)},get lineNumbers(){return w._lineNumbers},set lineNumbers(f){w._setLineNumbers(f)}}}_accept(S){this._tabSize=S.tabSize,this._insertSpaces=S.insertSpaces,this._cursorStyle=S.cursorStyle,this._lineNumbers=P.TextEditorLineNumbersStyle.to(S.lineNumbers)}_validateTabSize(S){if(S==="auto")return"auto";if(typeof S=="number"){const T=Math.floor(S);return T>0?T:null}if(typeof S=="string"){const T=parseInt(S,10);return isNaN(T)?null:T>0?T:null}return null}_setTabSize(S){const T=this._validateTabSize(S);if(T!==null){if(typeof T=="number"){if(this._tabSize===T)return;this._tabSize=T}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:T}))}}_validateInsertSpaces(S){return S==="auto"?"auto":S==="false"?!1:Boolean(S)}_setInsertSpaces(S){const T=this._validateInsertSpaces(S);if(typeof T=="boolean"){if(this._insertSpaces===T)return;this._insertSpaces=T}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:T}))}_setCursorStyle(S){this._cursorStyle!==S&&(this._cursorStyle=S,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:S})))}_setLineNumbers(S){this._lineNumbers!==S&&(this._lineNumbers=S,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:P.TextEditorLineNumbersStyle.from(S)})))}assign(S){const T={};let E=!1;if(typeof S.tabSize<"u"){const p=this._validateTabSize(S.tabSize);p==="auto"?(E=!0,T.tabSize=p):typeof p=="number"&&this._tabSize!==p&&(this._tabSize=p,E=!0,T.tabSize=p)}if(typeof S.insertSpaces<"u"){const p=this._validateInsertSpaces(S.insertSpaces);p==="auto"?(E=!0,T.insertSpaces=p):this._insertSpaces!==p&&(this._insertSpaces=p,E=!0,T.insertSpaces=p)}typeof S.cursorStyle<"u"&&this._cursorStyle!==S.cursorStyle&&(this._cursorStyle=S.cursorStyle,E=!0,T.cursorStyle=S.cursorStyle),typeof S.lineNumbers<"u"&&this._lineNumbers!==S.lineNumbers&&(this._lineNumbers=S.lineNumbers,E=!0,T.lineNumbers=P.TextEditorLineNumbersStyle.from(S.lineNumbers)),E&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,T))}_warnOnError(S,T){T.catch(E=>{this._logService.warn(`ExtHostTextEditorOptions '${S}' failed:'`),this._logService.warn(E)})}}e.ExtHostTextEditorOptions=I;class L{constructor(S,T,E,p,w,f,v,m){this.id=S,this._proxy=T,this._logService=E,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=w,this._options=new I(this._proxy,this.id,f,E),this._visibleRanges=v,this._viewColumn=m;const a=this;this.value=Object.freeze({get document(){return p.getValue()},set document(g){throw(0,t.readonly)("document")},get selection(){return a._selections&&a._selections[0]},set selection(g){if(!(g instanceof _.Selection))throw(0,t.illegalArgument)("selection");a._selections=[g],a._trySetSelection()},get selections(){return a._selections},set selections(g){if(!Array.isArray(g)||g.some(n=>!(n instanceof _.Selection)))throw(0,t.illegalArgument)("selections");a._selections=g,a._trySetSelection()},get visibleRanges(){return a._visibleRanges},set visibleRanges(g){throw(0,t.readonly)("visibleRanges")},get options(){return a._options.value},set options(g){a._disposed||a._options.assign(g)},get viewColumn(){return a._viewColumn},set viewColumn(g){throw(0,t.readonly)("viewColumn")},edit(g,n={undoStopBefore:!0,undoStopAfter:!0}){if(a._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const d=new b(p.getValue(),n);return g(d),a._applyEdit(d)},insertSnippet(g,n,d={undoStopBefore:!0,undoStopAfter:!0}){if(a._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!n||Array.isArray(n)&&n.length===0)s=a._selections.map(i=>P.Range.from(i));else if(n instanceof _.Position){const{lineNumber:i,column:r}=P.Position.from(n);s=[{startLineNumber:i,startColumn:r,endLineNumber:i,endColumn:r}]}else if(n instanceof _.Range)s=[P.Range.from(n)];else{s=[];for(const i of n)if(i instanceof _.Range)s.push(P.Range.from(i));else{const{lineNumber:r,column:c}=P.Position.from(i);s.push({startLineNumber:r,startColumn:c,endLineNumber:r,endColumn:c})}}return T.$tryInsertSnippet(S,p.getValue().version,g.value,s,d)},setDecorations(g,n){const d=n.length===0;d&&!a._hasDecorationsForKey.has(g.key)||(d?a._hasDecorationsForKey.delete(g.key):a._hasDecorationsForKey.add(g.key),a._runOnProxy(()=>{if(P.isDecorationOptionsArr(n))return T.$trySetDecorations(S,g.key,P.fromRangeOrRangeWithMessage(n));{const s=new Array(4*n.length);for(let i=0,r=n.length;i<r;i++){const c=n[i];s[4*i]=c.start.line+1,s[4*i+1]=c.start.character+1,s[4*i+2]=c.end.line+1,s[4*i+3]=c.end.character+1}return T.$trySetDecorationsFast(S,g.key,s)}}))},revealRange(g,n){a._runOnProxy(()=>T.$tryRevealRange(S,P.Range.from(g),n||_.TextEditorRevealType.Default))},show(g){T.$tryShowEditor(S,P.ViewColumn.from(g))},hide(){T.$tryHideEditor(S)}})}dispose(){(0,l.ok)(!this._disposed),this._disposed=!0}_acceptOptions(S){(0,l.ok)(!this._disposed),this._options._accept(S)}_acceptVisibleRanges(S){(0,l.ok)(!this._disposed),this._visibleRanges=S}_acceptViewColumn(S){(0,l.ok)(!this._disposed),this._viewColumn=S}_acceptSelections(S){(0,l.ok)(!this._disposed),this._selections=S}async _trySetSelection(){const S=this._selections.map(P.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,S)),this.value}_applyEdit(S){const T=S.finalize();if(T.edits.length===0&&!T.setEndOfLine)return Promise.resolve(!0);const E=T.edits.map(w=>w.range);E.sort((w,f)=>w.end.line===f.end.line?w.end.character===f.end.character?w.start.line===f.start.line?w.start.character-f.start.character:w.start.line-f.start.line:w.end.character-f.end.character:w.end.line-f.end.line);for(let w=0,f=E.length-1;w<f;w++){const v=E[w].end;if(E[w+1].start.isBefore(v))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const p=T.edits.map(w=>({range:P.Range.from(w.range),text:w.text,forceMoveMarkers:w.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,T.documentVersionId,p,{setEndOfLine:typeof T.setEndOfLine=="number"?P.EndOfLine.from(T.setEndOfLine):void 0,undoStopBefore:T.undoStopBefore,undoStopAfter:T.undoStopAfter})}_runOnProxy(S){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):S().then(()=>this,T=>(T instanceof Error&&T.name==="DISPOSED"||this._logService.warn(T),null))}}e.ExtHostTextEditor=L}),define(De[229],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewSize.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineCompletionsNew:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsNew.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookContentProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookContentProvider.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDebugOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDebugOptions.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditor.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",snippetWorkspaceEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.snippetWorkspaceEdit.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLog:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLog.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceEditIsRefactoring:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceEditIsRefactoring.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(De[230],Ie([1,0,185,10,41,84,120,43,28,229,196]),function(J,e,l,t,C,P,_,D,b,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const k=D.Registry.as(_.Extensions.JSONContribution);class S{constructor(a,g,n){this._messageHandler=a,this._extension=g,this._extensionPointId=n}_msg(a,g){this._messageHandler({type:a,message:g,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(a){this._msg(C.default.Error,a)}warn(a){this._msg(C.default.Warning,a)}info(a){this._msg(C.default.Info,a)}}e.ExtensionMessageCollector=S;class T{constructor(a,g){this.added=a,this.removed=g}static _toSet(a){const g=new Set;for(let n=0,d=a.length;n<d;n++)g.add(b.ExtensionIdentifier.toKey(a[n].description.identifier));return g}static compute(a,g){if(!a||!a.length)return new T(g,[]);if(!g||!g.length)return new T([],a);const n=this._toSet(a),d=this._toSet(g),s=g.filter(r=>!n.has(b.ExtensionIdentifier.toKey(r.description.identifier))),i=a.filter(r=>!d.has(b.ExtensionIdentifier.toKey(r.description.identifier)));return new T(s,i)}}e.ExtensionPointUserDelta=T;class E{constructor(a,g){this.name=a,this.defaultExtensionKind=g,this._handler=null,this._users=null,this._delta=null}setHandler(a){if(this._handler!==null)throw new Error("Handler already set!");this._handler=a,this._handle()}acceptUsers(a){this._delta=T.compute(this._users,a),this._users=a,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(a){(0,t.onUnexpectedError)(a)}}}e.ExtensionPoint=E;const p={type:"string",enum:["ui","workspace"],enumDescriptions:[l.localize(0,null),l.localize(1,null)]},w="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:l.localize(2,null),properties:{vscode:{type:"string",description:l.localize(3,null),default:"^1.22.0"}}},publisher:{description:l.localize(4,null),type:"string"},displayName:{description:l.localize(5,null),type:"string"},categories:{description:l.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:b.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:l.localize(7,null)}]}},galleryBanner:{type:"object",description:l.localize(8,null),properties:{color:{description:l.localize(9,null),type:"string"},theme:{description:l.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:l.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:l.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:l.localize(13,null)},enabledApiProposals:{markdownDescription:l.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(I.allApiProposals),markdownEnumDescriptions:Object.values(I.allApiProposals)}},activationEvents:{description:l.localize(15,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:l.localize(16,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:l.localize(17,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:l.localize(18,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:l.localize(19,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:l.localize(20,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:l.localize(21,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:l.localize(22,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:l.localize(23,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:l.localize(24,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:l.localize(25,null),body:"onStartupFinished"},{label:"onTaskType",description:l.localize(26,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:l.localize(27,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:l.localize(28,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:l.localize(29,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:l.localize(30,null)},{label:"onIdentity",body:"onIdentity:${8:identity}",description:l.localize(31,null)},{label:"onUri",body:"onUri",description:l.localize(32,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:l.localize(33,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:l.localize(34,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:l.localize(35,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:l.localize(36,null)},{label:"onRenderer",description:l.localize(37,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:l.localize(38,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:l.localize(39,null)},{label:"*",description:l.localize(40,null),body:"*"}]}},badges:{type:"array",description:l.localize(41,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:l.localize(42,null)},href:{type:"string",description:l.localize(43,null)},description:{type:"string",description:l.localize(44,null)}}}},markdown:{type:"string",description:l.localize(45,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:l.localize(46,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:l.localize(47,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:l.localize(48,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:l.localize(49,null),type:"array",items:p,default:["workspace"],defaultSnippets:[{body:["ui"],description:l.localize(50,null)},{body:["workspace"],description:l.localize(51,null)},{body:["ui","workspace"],description:l.localize(52,null)},{body:["workspace","ui"],description:l.localize(53,null)},{body:[],description:l.localize(54,null)}]},capabilities:{description:l.localize(55,null),type:"object",properties:{virtualWorkspaces:{description:l.localize(56,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:l.localize(57,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[l.localize(58,null),l.localize(59,null),l.localize(60,null)]},description:{type:"string",markdownDescription:l.localize(61,null)}}},untrustedWorkspaces:{description:l.localize(62,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:l.localize(63,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[l.localize(64,null),l.localize(65,null),l.localize(66,null)]},restrictedConfigurations:{description:l.localize(67,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:l.localize(68,null)}}}}},sponsor:{description:l.localize(69,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:l.localize(70,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:l.localize(71,null),type:"string"},"vscode:uninstall":{description:l.localize(72,null),type:"string"}}},icon:{type:"string",description:l.localize(73,null)}}};class f{constructor(){this._extensionPoints=new Map}registerExtensionPoint(a){if(this._extensionPoints.has(a.extensionPoint))throw new Error("Duplicate extension point: "+a.extensionPoint);const g=new E(a.extensionPoint,a.defaultExtensionKind);return this._extensionPoints.set(a.extensionPoint,g),e.schema.properties.contributes.properties[a.extensionPoint]=a.jsonSchema,k.registerSchema(w,e.schema),g}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=f;const v={ExtensionsRegistry:"ExtensionsRegistry"};D.Registry.add(v.ExtensionsRegistry,new f),e.ExtensionsRegistry=D.Registry.as(v.ExtensionsRegistry),k.registerSchema(w,e.schema),k.registerSchema(L.productSchemaId,{properties:{extensionEnabledApiProposals:{description:l.localize(74,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(I.allApiProposals),markdownEnumDescriptions:Object.values(I.allApiProposals)}}]}}}})}),define(De[231],Ie([1,0,182,14,24,230,52,4]),function(J,e,l,t,C,P,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=e.TaskDefinitionRegistryImpl=void 0;const b={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:l.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:l.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:l.localize(2,null),default:""}}};var I;(function(S){function T(E,p,w){if(!E)return;const f=t.isString(E.type)?E.type:void 0;if(!f||f.length===0){w.error(l.localize(3,null));return}const v=[];if(Array.isArray(E.required))for(const m of E.required)t.isString(m)&&v.push(m);return{extensionId:p.value,taskType:f,required:v,properties:E.properties?C.deepClone(E.properties):{},when:E.when?_.ContextKeyExpr.deserialize(E.when):void 0}}S.from=T})(I||(I={}));const L=P.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:l.localize(4,null),type:"array",items:b}});class k{constructor(){this._onDefinitionsChanged=new D.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((T,E)=>{L.setHandler((p,w)=>{this._schema=void 0;try{for(const f of w.removed){const v=f.value;for(const m of v)this.taskTypes&&m.type&&this.taskTypes[m.type]&&delete this.taskTypes[m.type]}for(const f of w.added){const v=f.value;for(const m of v){const a=I.from(m,f.description.identifier,f.collector);a&&(this.taskTypes[a.taskType]=a)}}(w.removed.length>0||w.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}T(void 0)})})}onReady(){return this.readyPromise}get(T){return this.taskTypes[T]}all(){return Object.keys(this.taskTypes).map(T=>this.taskTypes[T])}getJsonSchema(){if(this._schema===void 0){const T=[];for(const E of this.all()){const p={type:"object",additionalProperties:!1};E.required.length>0&&(p.required=E.required.slice(0)),E.properties!==void 0?p.properties=C.deepClone(E.properties):p.properties=Object.create(null),p.properties.type={type:"string",enum:[E.taskType]},T.push(p)}this._schema={oneOf:T}}return this._schema}}e.TaskDefinitionRegistryImpl=k,e.TaskDefinitionRegistry=new k}),define(De[232],Ie([1,0,183,14,22,24,52,231]),function(J,e,l,t,C,P,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new _.RawContextKey("taskRunning",!1,l.localize(0,null)),e.TASKS_CATEGORY={value:l.localize(1,null),original:"Tasks"};var b;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(b=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(N){function K(B){if(!B)return N.Strong;switch(B.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=K}(b=e.ShellQuoting||(e.ShellQuoting={}));var I;(function(N){N.defaults={cwd:"${workspaceFolder}"}})(I=e.CommandOptions||(e.CommandOptions={}));var L;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(L=e.RevealKind||(e.RevealKind={})),function(N){function K(B){switch(B.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=K}(L=e.RevealKind||(e.RevealKind={}));var k;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(k=e.RevealProblemKind||(e.RevealProblemKind={})),function(N){function K(B){switch(B.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=K}(k=e.RevealProblemKind||(e.RevealProblemKind={}));var S;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(S=e.PanelKind||(e.PanelKind={})),function(N){function K(B){switch(B.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=K}(S=e.PanelKind||(e.PanelKind={}));var T;(function(N){N.defaults={echo:!0,reveal:L.Always,revealProblems:k.Never,focus:!1,panel:S.Shared,showReuseMessage:!0,clear:!1}})(T=e.PresentationOptions||(e.PresentationOptions={}));var E;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})(E=e.RuntimeType||(e.RuntimeType={})),function(N){function K(O){switch(O.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=K;function B(O){switch(O){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=B}(E=e.RuntimeType||(e.RuntimeType={}));var p;(function(N){function K(B){return t.isString(B)?B:B.value}N.value=K})(p=e.CommandString||(e.CommandString={}));var w;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function K(O){return O===N.Clean._id||O===N.Build._id||O===N.Rebuild._id||O===N.Test._id}N.is=K;function B(O){if(O!==void 0)return t.isString(O)?K(O)?{_id:O,isDefault:!1}:void 0:O}N.from=B})(w=e.TaskGroup||(e.TaskGroup={}));var f;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(f=e.TaskScope||(e.TaskScope={}));var v;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function K(B){switch(B){case N.User:return 2;case N.WorkspaceFile:return 5;default:return 6}}N.toConfigurationTarget=K})(v=e.TaskSourceKind||(e.TaskSourceKind={}));var m;(function(N){N.parallel="parallel",N.sequence="sequence"})(m=e.DependsOrder||(e.DependsOrder={}));var a;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(a=e.RunOnOptions||(e.RunOnOptions={}));var g;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:a.default,instanceLimit:1}})(g=e.RunOptions||(e.RunOptions={}));class n{constructor(K,B,O,x,V,q){this._label="",this._id=K,B&&(this._label=B),O&&(this.type=O),this.runOptions=x,this.configurationProperties=V,this._source=q}getDefinition(K){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const K={folder:this.getFolderId(),id:this._id};return JSON.stringify(K)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(K,B=!1){if(K===void 0)return!1;if(t.isString(K))return K===this._label||K===this.configurationProperties.identifier||B&&K===this._id;const O=this.getDefinition(!0);return O!==void 0&&O._key===K._key}getQualifiedLabel(){const K=this.getWorkspaceFolder();return K?`${this._label} (${K.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(K){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),K&&(this._taskLoadMessages=this._taskLoadMessages.concat(K))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=n;class d extends n{constructor(K,B,O,x,V,q,Y,Q){super(K,O,void 0,Y,Q,B),this.command={},this._source=B,this.hasDefinedMatchers=q,V&&(this.command=V)}clone(){return new d(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(K=!1){if(K&&this._source.customizes!==void 0)return this._source.customizes;{let B;switch(this.command?this.command.runtime:void 0){case E.Shell:B="shell";break;case E.Process:B="process";break;case E.CustomExecution:B="customExecution";break;case void 0:B="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:B,_key:this._id,id:this._id}}}static is(K){return K instanceof d}getMapKey(){const K=this._source.config.workspaceFolder;return K?`${K.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===v.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const K=this.getFolderId();if(!K)return;let B=this.configurationProperties.identifier;this._source.kind!==v.Workspace&&(B+=this._source.kind);const O={type:e.CUSTOMIZED_TASK_TYPE,folder:K,id:B};return JSON.stringify(O)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(K){return new d(K._id,K._source,K._label,K.type,K.command,K.hasDefinedMatchers,K.runOptions,K.configurationProperties)}}e.CustomTask=d;class s extends n{constructor(K,B,O,x,V,q,Y){super(K,O,x,q,Y,B),this._source=B,this.configures=V}static is(K){return K instanceof s}fromObject(K){return K}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===v.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const K=this.getFolderId();if(!K)return;let B=this.configurationProperties.identifier;this._source.kind!==v.Workspace&&(B+=this._source.kind);const O={type:e.CUSTOMIZED_TASK_TYPE,folder:K,id:B};return JSON.stringify(O)}}e.ConfiguringTask=s;class i extends n{constructor(K,B,O,x,V,q,Y,Q,de){super(K,O,x,Q,de,B),this.defines=V,this.hasDefinedMatchers=Y,this.command=q,this.icon=de.icon,this.hide=de.hide}clone(){return new i(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(K){return K instanceof i}getMapKey(){const K=this._source.workspaceFolder;return K?`${this._source.scope.toString()}|${K.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const K={type:"contributed",scope:this._source.scope,id:this._id};return K.folder=this.getFolderId(),JSON.stringify(K)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(K){return new i(K._id,K._source,K._label,K.type,K.defines,K.command,K.hasDefinedMatchers,K.runOptions,K.configurationProperties)}}e.ContributedTask=i;class r extends n{constructor(K,B,O,x,V,q){super(K,O,x,V,q,B),this._source=B}clone(){return new r(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(K){return K instanceof r}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(K){return new r(K._id,K._source,K._label,K.type,K.runOptions,K.configurationProperties)}}e.InMemoryTask=r;var c;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})(c=e.ExecutionEngine||(e.ExecutionEngine={})),function(N){N._default=N.Terminal}(c=e.ExecutionEngine||(e.ExecutionEngine={}));var o;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(o=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class u{constructor(K){this._order=new Map;for(let B=0;B<K.length;B++)this._order.set(K[B].uri.toString(),B)}compare(K,B){const O=K.getWorkspaceFolder(),x=B.getWorkspaceFolder();if(O&&x){let V=this._order.get(O.uri.toString());V=V===void 0?0:V+1;let q=this._order.get(x.uri.toString());return q=q===void 0?0:q+1,V===q?K._label.localeCompare(B._label):V-q}else return!O&&x?-1:O&&!x?1:0}}e.TaskSorter=u;var h;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(h=e.TaskEventKind||(e.TaskEventKind={}));var y;(function(N){N.SingleRun="singleRun",N.Background="background"})(y=e.TaskRunType||(e.TaskRunType={}));var R;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(R=e.TaskRunSource||(e.TaskRunSource={}));var M;(function(N){function K(B,O,x,V,q){if(O){const Y={kind:B,taskId:O._id,taskName:O.configurationProperties.name,runType:O.configurationProperties.isBackground?"background":"singleRun",group:O.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:void 0,__task:O};return B==="start"?(Y.terminalId=x,Y.resolvedVariables=V):B==="processStarted"?Y.processId=x:B==="processEnded"&&(Y.exitCode=x),Object.freeze(Y)}else return Object.freeze({kind:"changed"})}N.create=K})(M=e.TaskEvent||(e.TaskEvent={}));var U;(function(N){function K(O){const x=Object.keys(O).sort();let V="";for(const q of x){let Y=O[q];Y instanceof Object?Y=K(Y):typeof Y=="string"&&(Y=Y.replace(/,/g,",,")),V+=q+","+Y+","}return V}function B(O){const V={_key:K(O),type:O.taskType};return Object.assign(V,O),V}N.create=B})(U=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var A;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.reconnection"})(A=e.TaskSettingId||(e.TaskSettingId={}));var z;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})(z=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var $;(function(N){function K(B,O){const x=D.TaskDefinitionRegistry.get(B.type);if(x===void 0){const Q=P.deepClone(B);return delete Q._key,U.create(Q)}const V=Object.create(null);V.type=x.taskType;const q=new Set;x.required.forEach(Q=>q.add(Q));const Y=x.properties;for(const Q of Object.keys(Y)){const de=B[Q];if(de!=null)V[Q]=de;else if(q.has(Q)){const ve=Y[Q];if(ve.default!==void 0)V[Q]=P.deepClone(ve.default);else switch(ve.type){case"boolean":V[Q]=!1;break;case"number":case"integer":V[Q]=0;break;case"string":V[Q]="";break;default:O.error(l.localize(2,null,JSON.stringify(B,void 0,0),Q));return}}}return U.create(V)}N.createTaskIdentifier=K})($=e.TaskDefinition||(e.TaskDefinition={}))}),define(De[233],Ie([1,0,10]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class t{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((_,D)=>{this._actualOk=_,this._actualErr=D,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(_){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=_,this._actual&&this._actualOk(_))}resolveErr(_){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=_,this._actual?this._actualErr(_):(0,l.onUnexpectedError)(_))}then(_,D){return this._ensureActual().then(_,D)}catch(_){return this._ensureActual().then(void 0,_)}finally(_){return this._ensureActual().finally(_)}}e.LazyPromise=t;class C extends t{constructor(){super(),this._hasErr=!0,this._err=new l.CancellationError}}e.CanceledLazyPromise=C}),define(De[55],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class l{constructor(b){this._proxyIdentifierBrand=void 0,this.sid=b,this.nid=++l.count}}e.ProxyIdentifier=l,l.count=0;const t=[];function C(D){const b=new l(D);return t[b.nid]=b,b}e.createProxyIdentifier=C;function P(D){return t[D].sid}e.getStringIdentifierForProxy=P;class _{constructor(b){this.value=b}}e.SerializableObjectWithBuffers=_}),define(De[5],Ie([1,0,55]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var t;(function(p){p[p.Default=0]="Default",p[p.InCenter=1]="InCenter",p[p.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",p[p.AtTop=3]="AtTop"})(t=e.TextEditorRevealType||(e.TextEditorRevealType={}));var C;(function(p){p[p.UnknownInput=0]="UnknownInput",p[p.TextInput=1]="TextInput",p[p.TextDiffInput=2]="TextDiffInput",p[p.TextMergeInput=3]="TextMergeInput",p[p.NotebookInput=4]="NotebookInput",p[p.NotebookDiffInput=5]="NotebookDiffInput",p[p.CustomEditorInput=6]="CustomEditorInput",p[p.WebviewEditorInput=7]="WebviewEditorInput",p[p.TerminalEditorInput=8]="TerminalEditorInput",p[p.InteractiveEditorInput=9]="InteractiveEditorInput"})(C=e.TabInputKind||(e.TabInputKind={}));var P;(function(p){p[p.TAB_OPEN=0]="TAB_OPEN",p[p.TAB_CLOSE=1]="TAB_CLOSE",p[p.TAB_UPDATE=2]="TAB_UPDATE",p[p.TAB_MOVE=3]="TAB_MOVE"})(P=e.TabModelOperationKind||(e.TabModelOperationKind={}));var _;(function(p){p[p.Editable=0]="Editable",p[p.SupportsHotExit=1]="SupportsHotExit"})(_=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var D;(function(p){p[p.Int8Array=1]="Int8Array",p[p.Uint8Array=2]="Uint8Array",p[p.Uint8ClampedArray=3]="Uint8ClampedArray",p[p.Int16Array=4]="Int16Array",p[p.Uint16Array=5]="Uint16Array",p[p.Int32Array=6]="Int32Array",p[p.Uint32Array=7]="Uint32Array",p[p.Float32Array=8]="Float32Array",p[p.Float64Array=9]="Float64Array",p[p.BigInt64Array=10]="BigInt64Array",p[p.BigUint64Array=11]="BigUint64Array"})(D=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var b;(function(p){p[p.Text=1]="Text",p[p.Error=2]="Error",p[p.Rich=3]="Rich"})(b=e.CellOutputKind||(e.CellOutputKind={}));var I;(function(p){p[p.Default=0]="Default",p[p.InCenter=1]="InCenter",p[p.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",p[p.AtTop=3]="AtTop"})(I=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var L;(function(p){p[p.None=0]="None",p[p.Process=1]="Process",p[p.Output=2]="Output"})(L=e.CandidatePortSource||(e.CandidatePortSource={}));class k{static mixin(w){return w._id=k._n++,w}}e.IdObject=k,k._n=0;var S;(function(p){p.label="a",p.kind="b",p.detail="c",p.documentation="d",p.sortText="e",p.filterText="f",p.preselect="g",p.insertText="h",p.insertTextRules="i",p.range="j",p.commitCharacters="k",p.additionalTextEdits="l",p.command="m",p.kindModifier="n"})(S=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var T;(function(p){p.defaultRanges="a",p.completions="b",p.isIncomplete="c",p.duration="d"})(T=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var E;(function(p){p[p.Workspace=0]="Workspace",p[p.TextDocument=1]="TextDocument"})(E=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,l.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,l.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,l.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,l.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,l.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,l.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,l.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,l.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,l.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,l.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,l.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,l.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,l.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,l.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,l.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,l.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,l.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,l.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,l.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,l.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,l.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,l.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,l.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,l.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,l.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,l.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,l.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,l.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,l.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,l.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,l.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,l.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,l.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,l.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,l.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,l.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,l.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,l.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,l.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,l.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,l.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,l.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,l.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,l.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,l.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,l.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,l.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,l.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,l.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,l.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,l.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,l.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,l.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,l.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,l.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,l.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,l.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,l.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,l.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,l.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,l.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,l.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,l.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,l.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,l.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,l.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,l.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,l.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,l.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,l.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,l.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,l.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,l.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,l.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,l.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,l.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,l.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,l.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,l.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,l.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,l.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,l.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,l.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,l.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,l.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,l.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,l.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,l.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,l.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,l.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,l.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,l.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,l.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,l.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,l.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,l.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,l.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,l.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,l.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,l.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,l.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,l.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,l.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,l.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,l.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,l.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,l.createProxyIdentifier)("ExtHostTelemetry")}}),define(De[65],Ie([1,0,3,15,5,16]),function(J,e,l,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,l.createDecorator)("IExtHostApiDeprecationService");let _=class{constructor(b,I){this._extHostLogService=I,this._reportedUsages=new Set,this._telemetryShape=b.getProxy(C.MainContext.MainThreadTelemetry)}report(b,I,L){const k=this.getUsageKey(b,I);this._reportedUsages.has(k)||(this._reportedUsages.add(k),I.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${b}' is deprecated. ${L}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:I.identifier.value,apiId:b}))}getUsageKey(b,I){return`${b}-${I.identifier.value}`}};_=qe([xe(0,P.IExtHostRpcService),xe(1,t.ILogService)],_),e.ExtHostApiDeprecationService=_,e.NullApiDeprecationService=Object.freeze(new class{report(D,b,I){}})}),define(De[234],Ie([1,0,4,5,7,28]),function(J,e,l,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class _{constructor(b){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new l.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=b.getProxy(t.MainContext.MainThreadAuthentication)}$setProviders(b){return this._providers=b,Promise.resolve()}async getSession(b,I,L,k={}){const S=P.ExtensionIdentifier.toKey(b.identifier),T=this._inFlightRequests.get(S)||[],E=[...L].sort().join(" ");let p=T.find(w=>w.providerId===I&&w.scopes===E);if(p)return p.result;{const w=this._getSession(b,S,I,L,k);p={providerId:I,scopes:E,result:w},T.push(p),this._inFlightRequests.set(S,T);try{await w}finally{const f=T.findIndex(v=>v.providerId===I&&v.scopes===E);f>-1&&(T.splice(f),this._inFlightRequests.set(S,T))}return w}}async _getSession(b,I,L,k,S={}){await this._proxy.$ensureProvider(L);const T=b.displayName||b.name;return this._proxy.$getSession(L,k,I,T,S)}async removeSession(b,I){const L=this._authenticationProviders.get(b);return L?L.provider.removeSession(I):this._proxy.$removeSession(b,I)}registerAuthenticationProvider(b,I,L,k){if(this._authenticationProviders.get(b))throw new Error(`An authentication provider with id '${b}' is already registered.`);this._authenticationProviders.set(b,{label:I,provider:L,options:k??{supportsMultipleAccounts:!1}}),this._providers.find(T=>T.id===b)||this._providers.push({id:b,label:I});const S=L.onDidChangeSessions(T=>{this._proxy.$sendDidChangeSessions(b,{added:T.added??[],changed:T.changed??[],removed:T.removed??[]})});return this._proxy.$registerAuthenticationProvider(b,I,k?.supportsMultipleAccounts??!1),new C.Disposable(()=>{S.dispose(),this._authenticationProviders.delete(b);const T=this._providers.findIndex(E=>E.id===b);T>-1&&this._providers.splice(T),this._proxy.$unregisterAuthenticationProvider(b)})}$createSession(b,I){const L=this._authenticationProviders.get(b);if(L)return Promise.resolve(L.provider.createSession(I));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$removeSession(b,I){const L=this._authenticationProviders.get(b);if(L)return Promise.resolve(L.provider.removeSession(I));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$getSessions(b,I){const L=this._authenticationProviders.get(b);if(L)return Promise.resolve(L.provider.getSessions(I));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$onDidChangeAuthenticationSessions(b,I){return this._onDidChangeSessions.fire({provider:{id:b,label:I}}),Promise.resolve()}}e.ExtHostAuthentication=_}),define(De[235],Ie([1,0,5,16,13,27]),function(J,e,l,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let _=class{constructor(b,I){this._proxy=b.getProxy(l.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:L=>I.getDocument(L)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(b,I,L){const k=(0,P.isProposedApiEnabled)(I,"snippetWorkspaceEdit"),S=(0,P.isProposedApiEnabled)(I,"workspaceEditIsRefactoring");L&&!S&&(console.warn(`Extension '${I.identifier.value}' uses a proposed API 'workspaceEditIsRefactoring' which is NOT enabled for it`),L=void 0);const T=C.WorkspaceEdit.from(b,this._versionInformationProvider,k);return this._proxy.$tryApplyWorkspaceEdit(T,void 0,L)}};_=qe([xe(0,t.IExtHostRpcService)],_),e.ExtHostBulkEdits=_}),define(De[236],Ie([1,0,5]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class t{constructor(P){const _=P.getProxy(l.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return _.$readText()},writeText(D){return _.$writeText(D)}})}}e.ExtHostClipboard=t});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,C){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?C.call(J,l):C?C.value=l:e.set(J,l),l},Ue=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[37],Ie([1,0,14,7,13,24,5,17,15,80,35,49,2,6,3,16,133,23,55,50]),function(J,e,l,t,C,P,_,D,b,I,L,k,S,T,E,p,w,f,v,m){"use strict";var a,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let n=class{constructor(o,u){a.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,g.set(this,void 0),tt(this,a,o.getProxy(_.MainContext.MainThreadCommands),"f"),this._logService=u,tt(this,g,o.getProxy(_.MainContext.MainThreadTelemetry),"f"),this.converter=new d(this,h=>{const y=this._apiCommands.get(h);return y?.result===i.Void?y:void 0},u),this._argumentProcessors=[{processArgument(h){return(0,I.revive)(h)}},{processArgument(h){return(0,P.cloneAndChange)(h,function(y){if(L.Range.isIRange(y))return C.Range.to(y);if(k.Position.isIPosition(y))return C.Position.to(y);if(L.Range.isIRange(y.range)&&S.URI.isUri(y.uri))return C.location.to(y);if(y instanceof f.VSBuffer)return y.buffer.buffer;if(!Array.isArray(y))return y})}}]}registerArgumentProcessor(o){this._argumentProcessors.push(o)}registerApiCommand(o){const u=this.registerCommand(!1,o.id,async(...h)=>{const y=o.args.map((M,U)=>{if(!M.validate(h[U]))throw new Error(`Invalid argument '${M.name}' when running '${o.id}', received: ${h[U]}`);return M.convert(h[U])}),R=await this.executeCommand(o.internalId,...y);return o.result.convert(R,h,this.converter)},void 0,{description:o.description,args:o.args,returns:o.result.description});return this._apiCommands.set(o.id,o),new t.Disposable(()=>{u.dispose(),this._apiCommands.delete(o.id)})}registerCommand(o,u,h,y,R,M){if(this._logService.trace("ExtHostCommands#registerCommand",u),!u.trim().length)throw new Error("invalid id");if(this._commands.has(u))throw new Error(`command '${u}' already exists`);return this._commands.set(u,{callback:h,thisArg:y,description:R,extension:M}),o&&Ue(this,a,"f").$registerCommand(u),new t.Disposable(()=>{this._commands.delete(u)&&o&&Ue(this,a,"f").$unregisterCommand(u)})}executeCommand(o,...u){return this._logService.trace("ExtHostCommands#executeCommand",o),this._doExecuteCommand(o,u,!0)}async _doExecuteCommand(o,u,h){if(this._commands.has(o))return Ue(this,a,"f").$fireCommandActivationEvent(o),this._executeContributedCommand(o,u,!1);{let y=!1;const R=(0,P.cloneAndChange)(u,function(M){if(M instanceof t.Position)return C.Position.from(M);if(M instanceof t.Range)return C.Range.from(M);if(M instanceof t.Location)return C.location.from(M);if(t.NotebookRange.isNotebookRange(M))return C.NotebookRange.from(M);if(M instanceof ArrayBuffer)return y=!0,f.VSBuffer.wrap(new Uint8Array(M));if(M instanceof Uint8Array)return y=!0,f.VSBuffer.wrap(M);if(M instanceof f.VSBuffer)return y=!0,M;if(!Array.isArray(M))return M});try{const M=await Ue(this,a,"f").$executeCommand(o,y?new v.SerializableObjectWithBuffers(R):R,h);return(0,I.revive)(M)}catch(M){if(M instanceof Error&&M.message==="$executeCommand:retry")return this._doExecuteCommand(o,u,!1);throw M}}}async _executeContributedCommand(o,u,h){const y=this._commands.get(o);if(!y)throw new Error("Unknown command");this._reportTelemetry(y,o);const{callback:R,thisArg:M,description:U}=y;if(U)for(let A=0;A<U.args.length;A++)try{(0,l.validateConstraint)(u[A],U.args[A].constraint)}catch{throw new Error(`Running the contributed command: '${o}' failed. Illegal argument '${U.args[A].name}' - ${U.args[A].description}`)}try{return await R.apply(M,u)}catch(A){if(o===this.converter.delegatingCommandId){const z=this.converter.getActualCommand(...u);z&&(o=z.command)}throw this._logService.error(A,o,y.extension?.identifier),h?new class extends Error{constructor(){super((0,m.toErrorMessage)(A)),this.id=o,this.source=y.extension?.displayName??y.extension?.name}}:A}}_reportTelemetry(o,u){!o.extension||o.extension.isBuiltin||Ue(this,g,"f").$publicLog2("Extension:ActionExecuted",{extensionId:o.extension.identifier.value,id:u})}$executeContributedCommand(o,...u){return this._logService.trace("ExtHostCommands#$executeContributedCommand",o),this._commands.has(o)?(u=u.map(h=>this._argumentProcessors.reduce((y,R)=>R.processArgument(y),h)),this._executeContributedCommand(o,u,!0)):Promise.reject(new Error(`Contributed command '${o}' does not exist.`))}getCommands(o=!1){return this._logService.trace("ExtHostCommands#getCommands",o),Ue(this,a,"f").$getCommands().then(u=>(o&&(u=u.filter(h=>h[0]!=="_")),u))}$getContributedCommandHandlerDescriptions(){const o=Object.create(null);for(const[u,h]of this._commands){const{description:y}=h;y&&(o[u]=y)}return Promise.resolve(o)}};a=new WeakMap,g=new WeakMap,n=qe([xe(0,p.IExtHostRpcService),xe(1,b.ILogService)],n),e.ExtHostCommands=n,e.IExtHostCommands=(0,E.createDecorator)("IExtHostCommands");class d{constructor(o,u,h){this._commands=o,this._lookupApiCommand=u,this._logService=h,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(o,u){if(!o)return;const h={$ident:void 0,id:o.command,title:o.title,tooltip:o.tooltip};if(!o.command)return h;const y=this._lookupApiCommand(o.command);if(y)h.id=y.internalId,h.arguments=y.args.map((R,M)=>R.convert(o.arguments&&o.arguments[M]));else if((0,D.isNonEmptyArray)(o.arguments)){const R=++this._cachIdPool;this._cache.set(R,o),u.add((0,T.toDisposable)(()=>{this._cache.delete(R),this._logService.trace("CommandsConverter#DISPOSE",R)})),h.$ident=R,h.id=this.delegatingCommandId,h.arguments=[R],this._logService.trace("CommandsConverter#CREATE",o.command,R)}return h}fromInternal(o){return typeof o.$ident=="number"?this._cache.get(o.$ident):{command:o.id,title:o.title,arguments:o.arguments}}getActualCommand(...o){return this._cache.get(o[0])}_executeConvertedCommand(...o){const u=this.getActualCommand(...o);return this._logService.trace("CommandsConverter#EXECUTE",o[0],u?u.command:"MISSING"),u?this._commands.executeCommand(u.command,...u.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=d;class s{constructor(o,u,h,y){this.name=o,this.description=u,this.validate=h,this.convert=y}optional(){return new s(this.name,`(optional) ${this.description}`,o=>o==null||this.validate(o),o=>o===void 0?void 0:o===null?null:this.convert(o))}with(o,u){return new s(o??this.name,u??this.description,this.validate,this.convert)}}e.ApiCommandArgument=s,s.Uri=new s("uri","Uri of a text document",c=>S.URI.isUri(c),c=>c),s.Position=new s("position","A position in a text document",c=>t.Position.isPosition(c),C.Position.from),s.Range=new s("range","A range in a text document",c=>t.Range.isRange(c),C.Range.from),s.Selection=new s("selection","A selection in a text document",c=>t.Selection.isSelection(c),C.Selection.from),s.Number=new s("number","",c=>typeof c=="number",c=>c),s.String=new s("string","",c=>typeof c=="string",c=>c),s.CallHierarchyItem=new s("item","A call hierarchy item",c=>c instanceof t.CallHierarchyItem,C.CallHierarchyItem.from),s.TypeHierarchyItem=new s("item","A type hierarchy item",c=>c instanceof t.TypeHierarchyItem,C.TypeHierarchyItem.from),s.TestItem=new s("testItem","A VS Code TestItem",c=>c instanceof w.TestItemImpl,C.TestItem.from);class i{constructor(o,u){this.description=o,this.convert=u}}e.ApiCommandResult=i,i.Void=new i("no result",c=>c);class r{constructor(o,u,h,y,R){this.id=o,this.internalId=u,this.description=h,this.args=y,this.result=R}}e.ApiCommand=r}),define(De[237],Ie([1,0,2,13,7,62,37,17,114,118,12]),function(J,e,l,t,C,P,_,D,b,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const k=[new _.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",T(t.DocumentHighlight.to))),new _.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(p,w)=>{if((0,D.isFalsyOrEmpty)(p))return;class f extends C.SymbolInformation{static to(m){const a=new f(m.name,t.SymbolKind.to(m.kind),m.containerName||"",new C.Location(w[0],t.Range.to(m.range)));return a.detail=m.detail,a.range=a.location.range,a.selectionRange=t.Range.to(m.selectionRange),a.children=m.children?m.children.map(f.to):[],a}}return p.map(f.to)})),new _.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("options","Formatting options",p=>!0,p=>p)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(t.TextEdit.to))),new _.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range,new _.ApiCommandArgument("options","Formatting options",p=>!0,p=>p)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(t.TextEdit.to))),new _.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,new _.ApiCommandArgument("ch","Trigger character",p=>typeof p=="string",p=>p),new _.ApiCommandArgument("options","Formatting options",p=>!0,p=>p)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(t.TextEdit.to))),new _.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new _.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new _.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new _.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new _.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location-instances.",T(t.location.to))),new _.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Hover-instances.",T(t.Hover.to))),new _.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("position","A position in a text document",p=>Array.isArray(p)&&p.every(w=>C.Position.isPosition(w)),p=>p.map(t.Position.from))],new _.ApiCommandResult("A promise that resolves to an array of ranges.",p=>p.map(w=>{let f;for(const v of w.reverse())f=new C.SelectionRange(t.Range.to(v),f);return f}))),new _.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[_.ApiCommandArgument.String.with("query","Search string")],new _.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",p=>p.map(t.WorkspaceSymbol.to))),new _.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A CallHierarchyItem or undefined",p=>p.map(t.CallHierarchyItem.to))),new _.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[_.ApiCommandArgument.CallHierarchyItem],new _.ApiCommandResult("A CallHierarchyItem or undefined",p=>p.map(t.CallHierarchyIncomingCall.to))),new _.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[_.ApiCommandArgument.CallHierarchyItem],new _.ApiCommandResult("A CallHierarchyItem or undefined",p=>p.map(t.CallHierarchyOutgoingCall.to))),new _.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to a range and placeholder text.",p=>{if(!!p)return{range:t.Range.to(p.range),placeholder:p.text}})),new _.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("newName","The new symbol name")],new _.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",p=>{if(!!p){if(p.rejectReason)throw new Error(p.rejectReason);return t.WorkspaceEdit.to(p)}})),new _.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new _.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",p=>p.map(t.DocumentLink.to))),new _.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",p=>{if(!!p)return new C.SemanticTokensLegend(p.tokenTypes,p.tokenModifiers)})),new _.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to SemanticTokens.",p=>{if(!p)return;const w=(0,b.decodeSemanticTokensDto)(p);if(w.type==="full")return new C.SemanticTokens(w.data,void 0)})),new _.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range.optional()],new _.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",p=>{if(!!p)return new C.SemanticTokensLegend(p.tokenTypes,p.tokenModifiers)})),new _.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to SemanticTokens.",p=>{if(!p)return;const w=(0,b.decodeSemanticTokensDto)(p);if(w.type==="full")return new C.SemanticTokens(w.data,void 0)})),new _.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),_.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new _.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(p,w,f)=>{if(!p)return new C.CompletionList([]);const v=p.suggestions.map(m=>t.CompletionItem.to(m,f));return new C.CompletionList(v,p.incomplete)})),new _.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new _.ApiCommandResult("A promise that resolves to SignatureHelp.",p=>{if(p)return t.SignatureHelp.to(p)})),new _.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new _.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(p,w,f)=>T(v=>new C.CodeLens(t.Range.to(v.range),v.command&&f.fromInternal(v.command)))(p))),new _.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",p=>C.Range.isRange(p),p=>C.Selection.isSelection(p)?t.Selection.from(p):t.Range.from(p)),_.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),_.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new _.ApiCommandResult("A promise that resolves to an array of Command-instances.",(p,w,f)=>T(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return f.fromInternal(v.command)}else{const m=new C.CodeAction(v.title,v.kind?new C.CodeActionKind(v.kind):void 0);return v.edit&&(m.edit=t.WorkspaceEdit.to(v.edit)),v.command&&(m.command=f.fromInternal(v.command)),m.isPreferred=v.isPreferred,m}})(p))),new _.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",p=>p?p.map(w=>new C.ColorInformation(t.Range.to(w.range),t.Color.to(w.color))):[])),new _.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new _.ApiCommandArgument("color","The color to show and insert",p=>p instanceof C.Color,t.Color.from),new _.ApiCommandArgument("context","Context object with uri and range",p=>!0,p=>({uri:p.uri,range:t.Range.from(p.range)}))],new _.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",p=>p?p.map(t.ColorPresentation.to):[])),new _.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to an array of Inlay objects",(p,w,f)=>p.map(t.InlayHint.to.bind(void 0,f)))),new _.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new _.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",T(p=>({viewType:p.viewType,displayName:p.displayName,options:{transientOutputs:p.options.transientOutputs,transientCellMetadata:p.options.transientCellMetadata,transientDocumentMetadata:p.options.transientDocumentMetadata},filenamePattern:p.filenamePattern.map(w=>t.NotebookExclusiveDocumentPattern.to(w))})))),new _.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to an array of InlineValue objects",p=>p.map(t.InlineValue.to))),new _.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new _.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",p=>l.URI.isUri(p)||typeof p=="string"&&(0,I.matchesSomeScheme)(p,L.Schemas.http,L.Schemas.https),p=>p),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",p=>p===void 0||typeof p=="number"||typeof p=="object",p=>p&&(typeof p=="number"?[t.ViewColumn.from(p),void 0]:[t.ViewColumn.from(p.viewColumn),t.TextEditorOpenOptions.from(p)])).optional(),_.ApiCommandArgument.String.with("label","").optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[_.ApiCommandArgument.Uri.with("resource","Resource to open"),_.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",p=>p===void 0||typeof p=="number"||typeof p=="object",p=>p&&(typeof p=="number"?[t.ViewColumn.from(p),void 0]:[t.ViewColumn.from(p.viewColumn),t.TextEditorOpenOptions.from(p)])).optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[_.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),_.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),_.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",p=>p===void 0||typeof p=="object",p=>p&&[t.ViewColumn.from(p.viewColumn),t.TextEditorOpenOptions.from(p)]).optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A TypeHierarchyItem or undefined",p=>p.map(t.TypeHierarchyItem.to))),new _.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[_.ApiCommandArgument.TypeHierarchyItem],new _.ApiCommandResult("A TypeHierarchyItem or undefined",p=>p.map(t.TypeHierarchyItem.to))),new _.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[_.ApiCommandArgument.TypeHierarchyItem],new _.ApiCommandResult("A TypeHierarchyItem or undefined",p=>p.map(t.TypeHierarchyItem.to))),new _.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[_.ApiCommandArgument.TestItem],_.ApiCommandResult.Void),new _.ApiCommand("vscode.experimental.editSession.continue","_workbench.experimental.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[_.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],_.ApiCommandResult.Void)];class S{static register(w){k.forEach(w.registerApiCommand,w)}}e.ExtHostApiCommands=S;function T(p){return w=>{if(Array.isArray(w))return w.map(p)}}function E(p){if(!Array.isArray(p))return;const w=[];for(const f of p)P.isLocationLink(f)?w.push(t.DefinitionLink.to(f)):w.push(t.location.to(f));return w}}),define(De[238],Ie([1,0,18,58,4,6,2,62,28,13,7,27,5]),function(J,e,l,t,C,P,_,D,b,I,L,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function T(E,p,w){const f=E.getProxy(S.MainContext.MainThreadComments);class v{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,p.registerArgumentProcessor({processArgument:c=>{if(c&&c.$mid===6){const o=this._commentControllers.get(c.handle);return o?o.value:c}else if(c&&c.$mid===7){const o=this._commentControllers.get(c.commentControlHandle);if(!o)return c;const u=o.getCommentThread(c.commentThreadHandle);return u?u.value:c}else if(c&&c.$mid===8){const o=this._commentControllers.get(c.thread.commentControlHandle);if(!o)return c;const u=o.getCommentThread(c.thread.commentThreadHandle);return u?{thread:u.value,text:c.text}:c}else if(c&&c.$mid===9){const o=this._commentControllers.get(c.thread.commentControlHandle);if(!o)return c;const u=o.getCommentThread(c.thread.commentThreadHandle);if(!u)return c;const h=c.commentUniqueId,y=u.getCommentByUniqueId(h);return y||c}else if(c&&c.$mid===10){const o=this._commentControllers.get(c.thread.commentControlHandle);if(!o)return c;const u=o.getCommentThread(c.thread.commentThreadHandle);if(!u)return c;const h=c.text,y=c.commentUniqueId,R=u.getCommentByUniqueId(y);return R?(typeof R.body=="string"?R.body=h:R.body.value=h,R):c}return c}})}createCommentController(c,o,u){const h=v.handlePool++,y=new a(c,h,o,u);this._commentControllers.set(y.handle,y);const R=this._commentControllersByExtension.get(b.ExtensionIdentifier.toKey(c.identifier))||[];return R.push(y),this._commentControllersByExtension.set(b.ExtensionIdentifier.toKey(c.identifier),R),y.value}$createCommentThreadTemplate(c,o,u){const h=this._commentControllers.get(c);!h||h.$createCommentThreadTemplate(o,u)}async $updateCommentThreadTemplate(c,o,u){const h=this._commentControllers.get(c);!h||h.$updateCommentThreadTemplate(o,u)}$deleteCommentThread(c,o){this._commentControllers.get(c)?.$deleteCommentThread(o)}$provideCommentingRanges(c,o,u){const h=this._commentControllers.get(c);if(!h||!h.commentingRangeProvider)return Promise.resolve(void 0);const y=w.getDocument(_.URI.revive(o));return(0,l.asPromise)(()=>h.commentingRangeProvider.provideCommentingRanges(y,u)).then(R=>R?R.map(M=>I.Range.from(M)):void 0)}$toggleReaction(c,o,u,h,y){const R=this._commentControllers.get(c);return!R||!R.reactionHandler?Promise.resolve(void 0):(0,l.asPromise)(()=>{const M=R.getCommentThread(o);if(M){const U=M.getCommentByUniqueId(h.uniqueIdInThread);if(R!==void 0&&U&&R.reactionHandler)return R.reactionHandler(U,d(y))}return Promise.resolve(void 0)})}dispose(){}}v.handlePool=0;class m{constructor(c,o,u,h,y,R,M,U){this._commentControllerHandle=o,this._id=u,this._uri=h,this._range=y,this._comments=R,this.extensionDescription=M,this._isTemplate=U,this.handle=m._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new C.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputDisposables.value=new P.DisposableStore,this._id===void 0&&(this._id=`${c}.${this.handle}`),f.$createCommentThread(o,this.handle,this._id,this._uri,I.Range.from(this._range),M.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=R,this._localDisposables.push({dispose:()=>{f.$deleteCommentThread(o,this.handle)}});const A=this;this.value={get uri(){return A.uri},get range(){return A.range},set range(z){A.range=z},get comments(){return A.comments},set comments(z){A.comments=z},get collapsibleState(){return A.collapsibleState},set collapsibleState(z){A.collapsibleState=z},get canReply(){return A.canReply},set canReply(z){A.canReply=z},get contextValue(){return A.contextValue},set contextValue(z){A.contextValue=z},get label(){return A.label},set label(z){A.label=z},get state(){return A.state},set state(z){A.state=z},dispose:()=>{A.dispose()}}}set threadId(c){this._id=c}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(c){c.isEqual(this._range)||(this._range=c,this.modifications.range=c,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(c){this._canReply!==c&&(this._canReply=c,this.modifications.canReply=c,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(c){this._label=c,this.modifications.label=c,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(c){this._contextValue=c,this.modifications.contextValue=c,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(c){this._comments=c,this.modifications.comments=c,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(c){this._collapseState=c,this.modifications.collapsibleState=c,this._onDidUpdateCommentThread.fire()}get state(){return(0,k.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state}set state(c){(0,k.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state=c,this.modifications.state=c,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new P.DisposableStore);const c=u=>Object.prototype.hasOwnProperty.call(this.modifications,u),o={};c("range")&&(o.range=I.Range.from(this._range)),c("label")&&(o.label=this.label),c("contextValue")&&(o.contextValue=this.contextValue??null),c("comments")&&(o.comments=this._comments.map(u=>g(this,u,this._commentsMap))),c("collapsibleState")&&(o.collapseState=s(this._collapseState)),c("canReply")&&(o.canReply=this.canReply),c("state")&&(o.state=i(this._state)),c("isTemplate")&&(o.isTemplate=this._isTemplate),this.modifications={},f.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,o)}getCommentByUniqueId(c){for(const o of this._commentsMap){const u=o[0],h=o[1];if(c===h)return u}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(c=>c.dispose())}}m._handlePool=0,qe([(0,t.debounce)(100)],m.prototype,"eventuallyUpdateCommentThread",null);class a{constructor(c,o,u,h){this._extension=c,this._handle=o,this._id=u,this._label=h,this._threads=new Map,f.$registerCommentController(this.handle,u,h);const y=this;this.value=Object.freeze({id:y.id,label:y.label,get options(){return y.options},set options(R){y.options=R},get commentingRangeProvider(){return y.commentingRangeProvider},set commentingRangeProvider(R){y.commentingRangeProvider=R},get reactionHandler(){return y.reactionHandler},set reactionHandler(R){y.reactionHandler=R},createCommentThread(R,M,U){return y.createCommentThread(R,M,U).value},dispose:()=>{y.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{f.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(c){this._commentingRangeProvider=c,f.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(c){this._reactionHandler=c,f.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!c})}get options(){return this._options}set options(c){this._options=c,f.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(c,o,u,h){if(typeof c=="string"){const y=new m(this.id,this.handle,c,o,u,h,this._extension,!1);return this._threads.set(y.handle,y),y}else{const y=new m(this.id,this.handle,void 0,c,o,u,this._extension,!1);return this._threads.set(y.handle,y),y}}$createCommentThreadTemplate(c,o){const u=new m(this.id,this.handle,void 0,_.URI.revive(c),I.Range.to(o),[],this._extension,!0);return u.collapsibleState=D.CommentThreadCollapsibleState.Expanded,this._threads.set(u.handle,u),u}$updateCommentThreadTemplate(c,o){const u=this._threads.get(c);u&&(u.range=I.Range.to(o))}$deleteCommentThread(c){this._threads.get(c)?.dispose(),this._threads.delete(c)}getCommentThread(c){return this._threads.get(c)}dispose(){this._threads.forEach(c=>{c.dispose()}),this._localDisposables.forEach(c=>c.dispose())}}function g(r,c,o){let u=o.get(c);u||(u=++r.commentHandle,o.set(c,u));const h=c.author&&c.author.iconPath?c.author.iconPath.toString():void 0;return{mode:c.mode,contextValue:c.contextValue,uniqueIdInThread:u,body:typeof c.body=="string"?c.body:I.MarkdownString.from(c.body),userName:c.author.name,userIconPath:h,label:c.label,commentReactions:c.reactions?c.reactions.map(y=>n(y)):void 0,timestamp:c.timestamp?.toJSON()}}function n(r){return{label:r.label,iconPath:r.iconPath?I.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function d(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?_.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function s(r){if(r!==void 0)switch(r){case L.CommentThreadCollapsibleState.Expanded:return D.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return D.CommentThreadCollapsibleState.Collapsed}return D.CommentThreadCollapsibleState.Collapsed}function i(r){if(r!==void 0)switch(r){case L.CommentThreadState.Unresolved:return D.CommentThreadState.Unresolved;case L.CommentThreadState.Resolved:return D.CommentThreadState.Resolved}return D.CommentThreadState.Unresolved}return new v}e.createExtHostComments=T}),define(De[239],Ie([1,0,24,5,26,16]),function(J,e,l,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let _=class{constructor(L,k){this._mainThreadConsole=L.getProxy(t.MainContext.MainThreadConsole),this._includeStack=k.consoleForward.includeStack,this._logNative=k.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(L,k){const S=this,T=console[L];Object.defineProperty(console,L,{set:()=>{},get:()=>function(){S._handleConsoleCall(L,k,T,arguments)}})}_handleConsoleCall(L,k,S,T){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:k,arguments:b(T,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(L,S,T)}};_=qe([xe(0,P.IExtHostRpcService),xe(1,C.IExtHostInitDataService)],_),e.AbstractExtHostConsoleForwarder=_;const D=1e5;function b(I,L){const k=[];if(I.length)for(let S=0;S<I.length;S++){let T=I[S];if(typeof T>"u")T="undefined";else if(T instanceof Error){const E=T;E.stack?T=E.stack:T=E.toString()}k.push(T)}if(L){const S=new Error().stack;S&&k.push({__$stack:S.split(`
`).slice(3).join(`
`)})}try{const S=(0,l.safeStringify)(k);return S.length>D?"Output omitted for a large object that exceeds the limits":S}catch(S){return`Output omitted for an object that cannot be inspected ('${S.toString()}')`}}}),define(De[135],Ie([1,0,2,5,7,3,16,15,17,8,9]),function(J,e,l,t,C,P,_,D,b,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let k=class An{constructor(T,E){this._logService=E,this._provider=new Map,this._proxy=T.getProxy(t.MainContext.MainThreadDecorations)}registerFileDecorationProvider(T,E){const p=An._handlePool++;this._provider.set(p,{provider:T,extensionId:E}),this._proxy.$registerDecorationProvider(p,E.value);const w=T.onDidChangeFileDecorations&&T.onDidChangeFileDecorations(f=>{if(!f){this._proxy.$onDidChange(p,null);return}const v=(0,b.asArray)(f);if(v.length<=An._maxEventSize){this._proxy.$onDidChange(p,v);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",E.value,v.length);const m=v.map(n=>({uri:n,rank:(0,I.count)(n.path,"/")})),a=(0,b.groupBy)(m,(n,d)=>n.rank-d.rank||(0,I.compare)(n.uri.path,d.uri.path)),g=[];e:for(const n of a){let d;for(const s of n){const i=(0,L.dirname)(s.uri.path);if(d!==i&&(d=i,g.push(s.uri)>=An._maxEventSize))break e}}this._proxy.$onDidChange(p,g)});return new C.Disposable(()=>{w?.dispose(),this._proxy.$unregisterDecorationProvider(p),this._provider.delete(p)})}async $provideDecorations(T,E,p){if(!this._provider.has(T))return Object.create(null);const w=Object.create(null),{provider:f,extensionId:v}=this._provider.get(T);return await Promise.all(E.map(async m=>{try{const{uri:a,id:g}=m,n=await Promise.resolve(f.provideFileDecoration(l.URI.revive(a),p));if(!n)return;try{C.FileDecoration.validate(n),w[g]=[n.propagate,n.tooltip,n.badge,n.color]}catch(d){this._logService.warn(`INVALID decoration from extension '${v.value}': ${d}`)}}catch(a){this._logService.error(a)}})),w}};k._handlePool=0,k._maxEventSize=250,k=qe([xe(0,_.IExtHostRpcService),xe(1,D.ILogService)],k),e.ExtHostDecorations=k,e.IExtHostDecorations=(0,P.createDecorator)("IExtHostDecorations")});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,C){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?C.call(J,l):C?C.value=l:e.set(J,l),l},Ue=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[240],Ie([1,0,169,117,2,5,7,13,4,15,25,46]),function(J,e,l,t,C,P,_,D,b,I,L,k){"use strict";var S,T,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class p{constructor(v,m,a,g,n,d){this._name=v,this._owner=m,this._maxDiagnosticsPerFile=a,S.set(this,void 0),T.set(this,void 0),E.set(this,void 0),this._isDisposed=!1,tt(this,E,new L.ResourceMap(s=>g.getComparisonKey(s)),"f"),tt(this,S,n,"f"),tt(this,T,d,"f")}dispose(){this._isDisposed||(Ue(this,T,"f").fire([...Ue(this,E,"f").keys()]),Ue(this,S,"f")?.$clear(this._owner),Ue(this,E,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(v,m){if(!v){this.clear();return}this._checkDisposed();let a=[];if(C.URI.isUri(v)){if(!m){this.delete(v);return}Ue(this,E,"f").set(v,m.slice()),a=[v]}else if(Array.isArray(v)){a=[];let n;v=[...v].sort(p._compareIndexedTuplesByUri);for(const d of v){const[s,i]=d;if((!n||s.toString()!==n.toString())&&(n&&Ue(this,E,"f").get(n).length===0&&Ue(this,E,"f").delete(n),n=s,a.push(s),Ue(this,E,"f").set(s,[])),i)Ue(this,E,"f").get(s)?.push(...i);else{const r=Ue(this,E,"f").get(s);r&&(r.length=0)}}}if(Ue(this,T,"f").fire(a),!Ue(this,S,"f"))return;const g=[];for(const n of a){let d=[];const s=Ue(this,E,"f").get(n);if(s)if(s.length>this._maxDiagnosticsPerFile){d=[];const i=[_.DiagnosticSeverity.Error,_.DiagnosticSeverity.Warning,_.DiagnosticSeverity.Information,_.DiagnosticSeverity.Hint];e:for(let r=0;r<4;r++)for(const c of s)if(c.severity===i[r]&&d.push(D.Diagnostic.from(c))===this._maxDiagnosticsPerFile)break e;d.push({severity:t.MarkerSeverity.Info,message:(0,l.localize)(0,null,s.length-this._maxDiagnosticsPerFile),startLineNumber:d[d.length-1].startLineNumber,startColumn:d[d.length-1].startColumn,endLineNumber:d[d.length-1].endLineNumber,endColumn:d[d.length-1].endColumn})}else d=s.map(i=>D.Diagnostic.from(i));g.push([n,d])}Ue(this,S,"f").$changeMany(this._owner,g)}delete(v){this._checkDisposed(),Ue(this,T,"f").fire([v]),Ue(this,E,"f").delete(v),Ue(this,S,"f")?.$changeMany(this._owner,[[v,void 0]])}clear(){this._checkDisposed(),Ue(this,T,"f").fire([...Ue(this,E,"f").keys()]),Ue(this,E,"f").clear(),Ue(this,S,"f")?.$clear(this._owner)}forEach(v,m){this._checkDisposed();for(const[a,g]of this)v.call(m,a,g,this)}*[(S=new WeakMap,T=new WeakMap,E=new WeakMap,Symbol.iterator)](){this._checkDisposed();for(const v of Ue(this,E,"f").keys())yield[v,this.get(v)]}get(v){this._checkDisposed();const m=Ue(this,E,"f").get(v);return Array.isArray(m)?Object.freeze(m.slice(0)):[]}has(v){return this._checkDisposed(),Array.isArray(Ue(this,E,"f").get(v))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(v,m){return v[0].toString()<m[0].toString()?-1:v[0].toString()>m[0].toString()?1:0}}e.DiagnosticCollection=p;let w=class gn{constructor(v,m,a){this._logService=m,this._fileSystemInfoService=a,this._collections=new Map,this._onDidChangeDiagnostics=new b.DebounceEmitter({merge:g=>g.flat(),delay:50}),this.onDidChangeDiagnostics=b.Event.map(this._onDidChangeDiagnostics.event,gn._mapper),this._proxy=v.getProxy(P.MainContext.MainThreadDiagnostics)}static _mapper(v){const m=new L.ResourceMap;for(const a of v)m.set(a,a);return{uris:Object.freeze(Array.from(m.values()))}}createDiagnosticCollection(v,m){const{_collections:a,_proxy:g,_onDidChangeDiagnostics:n,_logService:d,_fileSystemInfoService:s}=this,i=new class{$changeMany(o,u){g.$changeMany(o,u),d.trace("[DiagnosticCollection] change many (extension, owner, uris)",v.value,o,u.length===0?"CLEARING":u)}$clear(o){g.$clear(o),d.trace("[DiagnosticCollection] remove all (extension, owner)",v.value,o)}dispose(){g.dispose()}};let r;if(!m)m="_generated_diagnostic_collection_name_#"+gn._idPool++,r=m;else if(!a.has(m))r=m;else{this._logService.warn(`DiagnosticCollection with name '${m}' does already exist.`);do r=m+gn._idPool++;while(a.has(r))}return new class extends p{constructor(){super(m,r,gn._maxDiagnosticsPerFile,s.extUri,i,n),a.set(r,this)}dispose(){super.dispose(),a.delete(r)}}}getDiagnostics(v){if(v)return this._getDiagnostics(v);{const m=new Map,a=[];for(const g of this._collections.values())g.forEach((n,d)=>{let s=m.get(n.toString());typeof s>"u"&&(s=a.length,m.set(n.toString(),s),a.push([n,[]])),a[s][1]=a[s][1].concat(...d)});return a}}_getDiagnostics(v){let m=[];for(const a of this._collections.values())a.has(v)&&(m=m.concat(a.get(v)));return m}$acceptMarkersChange(v){if(!this._mirrorCollection){const m="_generated_mirror",a=new p(m,m,gn._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(m,a),this._mirrorCollection=a}for(const[m,a]of v)this._mirrorCollection.set(C.URI.revive(m),a.map(D.Diagnostic.to))}};w._idPool=0,w._maxDiagnosticsPerFile=1e3,w=qe([xe(1,I.ILogService),xe(2,k.IExtHostFileSystemInfo)],w),e.ExtHostDiagnostics=w}),define(De[241],Ie([1,0,2,5]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class C{constructor(_){this._proxy=_.getProxy(t.MainContext.MainThreadDialogs)}showOpenDialog(_){return this._proxy.$showOpenDialog(_).then(D=>D?D.map(b=>l.URI.revive(b)):void 0)}showSaveDialog(_){return this._proxy.$showSaveDialog(_).then(D=>D?l.URI.revive(D):void 0)}}e.ExtHostDialogs=C}),define(De[242],Ie([1,0,10,2,7,5,12,21,8]),function(J,e,l,t,C,P,_,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class I{constructor(k,S,T){this._documentsAndEditors=S,this._logService=T,this._documentContentProviders=new Map,this._proxy=k.getProxy(P.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,S){if(Object.keys(_.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const T=I._handlePool++;this._documentContentProviders.set(T,S),this._proxy.$registerTextContentProvider(T,k);let E;return typeof S.onDidChange=="function"&&(E=S.onDidChange(p=>{if(p.scheme!==k){this._logService.warn(`Provider for scheme '${k}' is firing event for schema '${p.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(p)&&this.$provideTextDocumentContent(T,p).then(w=>{if(!w&&typeof w!="string")return;const f=this._documentsAndEditors.getDocument(p);if(!f)return;const v=(0,b.splitLines)(w);if(!f.equalLines(v))return this._proxy.$onVirtualDocumentChange(p,w)},l.onUnexpectedError)})),new C.Disposable(()=>{this._documentContentProviders.delete(T)&&this._proxy.$unregisterTextContentProvider(T),E&&(E.dispose(),E=void 0)})}$provideTextDocumentContent(k,S){const T=this._documentContentProviders.get(k);return T?Promise.resolve(T.provideTextDocumentContent(t.URI.revive(S),D.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${S.scheme}`))}}e.ExtHostDocumentContentProvider=I,I._handlePool=0}),define(De[243],Ie([1,0,4,6,2,5,131,13,14,24,7]),function(J,e,l,t,C,P,_,D,b,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class k{constructor(T,E){this._onDidAddDocument=new l.Emitter,this._onDidRemoveDocument=new l.Emitter,this._onDidChangeDocument=new l.Emitter,this._onDidSaveDocument=new l.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new t.DisposableStore,this._documentLoader=new Map,this._proxy=T.getProxy(P.MainContext.MainThreadDocuments),this._documentsAndEditors=E,this._documentsAndEditors.onDidRemoveDocuments(p=>{for(const w of p)this._onDidRemoveDocument.fire(w.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(p=>{for(const w of p)this._onDidAddDocument.fire(w.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(T){if(!T)return;const E=this._documentsAndEditors.getDocument(T);if(E)return E}getDocument(T){const E=this.getDocumentData(T);if(!E?.document)throw new Error(`Unable to retrieve document from URI '${T}'`);return E.document}ensureDocumentData(T){const E=this._documentsAndEditors.getDocument(T);if(E)return Promise.resolve(E);let p=this._documentLoader.get(T.toString());return p||(p=this._proxy.$tryOpenDocument(T).then(w=>{this._documentLoader.delete(T.toString());const f=C.URI.revive(w);return(0,b.assertIsDefined)(this._documentsAndEditors.getDocument(f))},w=>(this._documentLoader.delete(T.toString()),Promise.reject(w))),this._documentLoader.set(T.toString(),p)),p}createDocumentData(T){return this._proxy.$tryCreateDocument(T).then(E=>C.URI.revive(E))}$acceptModelLanguageChanged(T,E){const p=C.URI.revive(T),w=this._documentsAndEditors.getDocument(p);if(!w)throw new Error("unknown document");this._onDidRemoveDocument.fire(w.document),w._acceptLanguageId(E),this._onDidAddDocument.fire(w.document)}$acceptModelSaved(T){const E=C.URI.revive(T),p=this._documentsAndEditors.getDocument(E);if(!p)throw new Error("unknown document");this.$acceptDirtyStateChanged(T,!1),this._onDidSaveDocument.fire(p.document)}$acceptDirtyStateChanged(T,E){const p=C.URI.revive(T),w=this._documentsAndEditors.getDocument(p);if(!w)throw new Error("unknown document");w._acceptIsDirty(E),this._onDidChangeDocument.fire({document:w.document,contentChanges:[],reason:void 0})}$acceptModelChanged(T,E,p){const w=C.URI.revive(T),f=this._documentsAndEditors.getDocument(w);if(!f)throw new Error("unknown document");f._acceptIsDirty(p),f.onEvents(E);let v;E.isUndoing?v=L.TextDocumentChangeReason.Undo:E.isRedoing&&(v=L.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,I.deepFreeze)({document:f.document,contentChanges:E.changes.map(m=>({range:D.Range.to(m.range),rangeOffset:m.rangeOffset,rangeLength:m.rangeLength,text:m.text})),reason:v}))}setWordDefinitionFor(T,E){(0,_.setWordDefinitionFor)(T,E)}}e.ExtHostDocuments=k}),define(De[56],Ie([1,0,48,4,6,2,3,5,131,16,134,13,15,25,12,60,76]),function(J,e,l,t,C,P,_,D,b,I,L,k,S,T,E,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class f{constructor(a){this.value=a,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let v=class{constructor(a,g){this._extHostRpc=a,this._logService=g,this._activeEditorId=null,this._editors=new Map,this._documents=new T.ResourceMap,this._onDidAddDocuments=new t.Emitter,this._onDidRemoveDocuments=new t.Emitter,this._onDidChangeVisibleTextEditors=new t.Emitter,this._onDidChangeActiveTextEditor=new t.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(a){this.acceptDocumentsAndEditorsDelta(a)}acceptDocumentsAndEditorsDelta(a){const g=[],n=[],d=[];if(a.removedDocuments)for(const s of a.removedDocuments){const i=P.URI.revive(s),r=this._documents.get(i);r?.unref()&&(this._documents.delete(i),g.push(r.value))}if(a.addedDocuments)for(const s of a.addedDocuments){const i=P.URI.revive(s.uri);let r=this._documents.get(i);if(r&&i.scheme!==E.Schemas.vscodeNotebookCell&&i.scheme!==E.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);r||(r=new f(new b.ExtHostDocumentData(this._extHostRpc.getProxy(D.MainContext.MainThreadDocuments),i,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this._documents.set(i,r),n.push(r.value)),r.ref()}if(a.removedEditors)for(const s of a.removedEditors){const i=this._editors.get(s);this._editors.delete(s),i&&d.push(i)}if(a.addedEditors)for(const s of a.addedEditors){const i=P.URI.revive(s.documentUri);l.ok(this._documents.has(i),`document '${i}' does not exist`),l.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const r=this._documents.get(i).value,c=new L.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(D.MainContext.MainThreadTextEditors),this._logService,new w.Lazy(()=>r.document),s.selections.map(k.Selection.to),s.options,s.visibleRanges.map(o=>k.Range.to(o)),typeof s.editorPosition=="number"?k.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,c)}a.newActiveEditor!==void 0&&(l.ok(a.newActiveEditor===null||this._editors.has(a.newActiveEditor),`active editor '${a.newActiveEditor}' does not exist`),this._activeEditorId=a.newActiveEditor),(0,C.dispose)(g),(0,C.dispose)(d),a.removedDocuments&&this._onDidRemoveDocuments.fire(g),a.addedDocuments&&this._onDidAddDocuments.fire(n),(a.removedEditors||a.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),a.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(a){return this._documents.get(a)?.value}allDocuments(){return p.Iterable.map(this._documents.values(),a=>a.value)}getEditor(a){return this._editors.get(a)}activeEditor(a){if(!this._activeEditorId)return;const g=this._editors.get(this._activeEditorId);return a?g:g?.value}allEditors(){return[...this._editors.values()]}};v=qe([xe(0,I.IExtHostRpcService),xe(1,S.ILogService)],v),e.ExtHostDocumentsAndEditors=v,e.IExtHostDocumentsAndEditors=(0,_.createDecorator)("IExtHostDocumentsAndEditors")}),define(De[57],Ie([1,0,13,5,2,4,3,7,16,14,75]),function(J,e,l,t,C,P,_,D,b,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,_.createDecorator)("IExtHostEditorTabs");class k{constructor(w,f,v){this._activeTabIdGetter=v,this._parentGroup=f,this.acceptDtoUpdate(w)}get apiObject(){if(!this._apiObject){const w=this,f={get isActive(){return w._dto.id===w._activeTabIdGetter()},get label(){return w._dto.label},get input(){return w._input},get isDirty(){return w._dto.isDirty},get isPinned(){return w._dto.isPinned},get isPreview(){return w._dto.isPreview},get group(){return w._parentGroup.apiObject}};this._apiObject=Object.freeze(f)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(w){this._dto=w,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new D.TextTabInput(C.URI.revive(this._dto.input.uri));case 2:return new D.TextDiffTabInput(C.URI.revive(this._dto.input.original),C.URI.revive(this._dto.input.modified));case 3:return new D.TextMergeTabInput(C.URI.revive(this._dto.input.base),C.URI.revive(this._dto.input.input1),C.URI.revive(this._dto.input.input2),C.URI.revive(this._dto.input.result));case 6:return new D.CustomEditorTabInput(C.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new D.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new D.NotebookEditorTabInput(C.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new D.NotebookDiffEditorTabInput(C.URI.revive(this._dto.input.original),C.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new D.TerminalEditorTabInput;case 9:return new D.InteractiveWindowInput(C.URI.revive(this._dto.input.uri),C.URI.revive(this._dto.input.inputBoxUri));default:return}}}class S{constructor(w,f){this._tabs=[],this._activeTabId="",this._dto=w,this._activeGroupIdGetter=f;for(const v of w.tabs)v.isActive&&(this._activeTabId=v.id),this._tabs.push(new k(v,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const w=this,f={get isActive(){return w._dto.groupId===w._activeGroupIdGetter()},get viewColumn(){return l.ViewColumn.to(w._dto.viewColumn)},get activeTab(){return w._tabs.find(v=>v.tabId===w._activeTabId)?.apiObject},get tabs(){return Object.freeze(w._tabs.map(v=>v.apiObject))}};this._apiObject=Object.freeze(f)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(w){this._dto=w}acceptTabOperation(w){if(w.kind===0){const v=new k(w.tabDto,this,()=>this.activeTabId());return this._tabs.splice(w.index,0,v),w.tabDto.isActive&&(this._activeTabId=v.tabId),v}else if(w.kind===1){const v=this._tabs.splice(w.index,1)[0];if(!v)throw new Error(`Tab close updated received for index ${w.index} which does not exist`);return v.tabId===this._activeTabId&&(this._activeTabId=""),v}else if(w.kind===3){if(w.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const v=this._tabs.splice(w.oldIndex,1)[0];if(!v)throw new Error(`Tab move updated received for index ${w.oldIndex} which does not exist`);return this._tabs.splice(w.index,0,v),v}const f=this._tabs.find(v=>v.tabId===w.tabDto.id);if(!f)throw new Error("INVALID tab");return w.tabDto.isActive?this._activeTabId=w.tabDto.id:this._activeTabId===w.tabDto.id&&!w.tabDto.isActive&&(this._activeTabId=""),f.acceptDtoUpdate(w.tabDto),f}activeTabId(){return this._activeTabId}}let T=class{constructor(w){this._onDidChangeTabs=new P.Emitter,this._onDidChangeTabGroups=new P.Emitter,this._extHostTabGroups=[],this._proxy=w.getProxy(t.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const w=this,f={onDidChangeTabGroups:w._onDidChangeTabGroups.event,onDidChangeTabs:w._onDidChangeTabs.event,get all(){return Object.freeze(w._extHostTabGroups.map(v=>v.apiObject))},get activeTabGroup(){const v=w._activeGroupId;return(0,I.assertIsDefined)(w._extHostTabGroups.find(a=>a.groupId===v)?.apiObject)},close:async(v,m)=>{const a=Array.isArray(v)?v:[v];return a.length?E(a[0])?this._closeGroups(a,m):this._closeTabs(a,m):!0}};this._apiObject=Object.freeze(f)}return this._apiObject}$acceptEditorTabModel(w){const f=new Set(this._extHostTabGroups.map(s=>s.groupId)),v=new Set(w.map(s=>s.groupId)),m=(0,L.diffSets)(f,v),a=this._extHostTabGroups.filter(s=>m.removed.includes(s.groupId)).map(s=>s.apiObject),g=[],n=[];this._extHostTabGroups=w.map(s=>{const i=new S(s,()=>this._activeGroupId);return m.added.includes(i.groupId)?g.push(i.apiObject):n.push(i.apiObject),i});const d=(0,I.assertIsDefined)(w.find(s=>s.isActive===!0)?.groupId);d!==void 0&&this._activeGroupId!==d&&(this._activeGroupId=d),this._onDidChangeTabGroups.fire(Object.freeze({opened:g,closed:a,changed:n}))}$acceptTabGroupUpdate(w){const f=this._extHostTabGroups.find(v=>v.groupId===w.groupId);if(!f)throw new Error("Update Group IPC call received before group creation.");f.acceptGroupDtoUpdate(w),w.isActive&&(this._activeGroupId=w.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[f.apiObject],opened:[],closed:[]}))}$acceptTabOperation(w){const f=this._extHostTabGroups.find(m=>m.groupId===w.groupId);if(!f)throw new Error("Update Tabs IPC call received before group creation.");const v=f.acceptTabOperation(w);switch(w.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[v.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[v.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[v.apiObject]}));return}}_findExtHostTabFromApi(w){for(const f of this._extHostTabGroups)for(const v of f.tabs)if(v.apiObject===w)return v}_findExtHostTabGroupFromApi(w){return this._extHostTabGroups.find(f=>f.apiObject===w)}async _closeTabs(w,f){const v=[];for(const m of w){const a=this._findExtHostTabFromApi(m);if(!a)throw new Error("Tab close: Invalid tab not found!");v.push(a.tabId)}return this._proxy.$closeTab(v,f)}async _closeGroups(w,f){const v=[];for(const m of w){const a=this._findExtHostTabGroupFromApi(m);if(!a)throw new Error("Group close: Invalid group not found!");v.push(a.groupId)}return this._proxy.$closeGroup(v,f)}};T=qe([xe(0,b.IExtHostRpcService)],T),e.ExtHostEditorTabs=T;function E(p){return p.tabs!==void 0}}),define(De[244],Ie([1,0,2,5,6,7,13,149,8,23,27]),function(J,e,l,t,C,P,_,D,b,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class k{constructor(){this._schemes=[]}add(E){this._stateMachine=void 0,this._schemes.push(E)}delete(E){const p=this._schemes.indexOf(E);p>=0&&(this._schemes.splice(p,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const E=this._schemes.sort(),p=[];let w,f,v=14,m=14;for(const a of E){let g=w?(0,b.commonPrefixLength)(w,a):0;for(g===0?f=1:f=m;g<a.length;g++)g+1===a.length?(v=m,m=9):m+=1,p.push([f,a.toUpperCase().charCodeAt(g),m]),p.push([f,a.toLowerCase().charCodeAt(g),m]),f=m;w=a,m=v}p.push([9,58,10]),p.push([10,47,12]),this._stateMachine=new D.StateMachine(p)}}provideDocumentLinks(E){this._initStateMachine();const p=[],w=D.LinkComputer.computeLinks({getLineContent(f){return E.lineAt(f-1).text},getLineCount(){return E.lineCount}},this._stateMachine);for(const f of w){const v=_.DocumentLink.to(f);v.target&&p.push(v)}return p}}class S{constructor(E,p){this._extHostLanguageFeatures=p,this._linkProvider=new k,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=E.getProxy(t.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(E,p,w,f={}){if(this._registeredSchemes.has(p))throw new Error(`a provider for the scheme '${p}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(E,"*",this._linkProvider));const v=this._handlePool++;this._linkProvider.add(p),this._registeredSchemes.add(p),this._fsProvider.set(v,w);let m=2;f.isCaseSensitive&&(m+=1024),f.isReadonly&&(m+=2048),typeof w.copy=="function"&&(m+=8),typeof w.open=="function"&&typeof w.close=="function"&&typeof w.read=="function"&&typeof w.write=="function"&&((0,L.checkProposedApiEnabled)(E,"fsChunks"),m+=4),this._proxy.$registerFileSystemProvider(v,p,m).catch(g=>{console.error(`FAILED to register filesystem provider of ${E.identifier.value}-extension for the scheme ${p}`),console.error(g)});const a=w.onDidChangeFile(g=>{const n=[];for(const d of g){const{uri:s,type:i}=d;if(s.scheme!==p)continue;let r;switch(i){case P.FileChangeType.Changed:r=0;break;case P.FileChangeType.Created:r=1;break;case P.FileChangeType.Deleted:r=2;break;default:throw new Error("Unknown FileChangeType")}n.push({resource:s,type:r})}this._proxy.$onFileSystemChange(v,n)});return(0,C.toDisposable)(()=>{a.dispose(),this._linkProvider.delete(p),this._registeredSchemes.delete(p),this._fsProvider.delete(v),this._proxy.$unregisterProvider(v)})}static _asIStat(E){const{type:p,ctime:w,mtime:f,size:v,permissions:m}=E;return{type:p,ctime:w,mtime:f,size:v,permissions:m}}$stat(E,p){return Promise.resolve(this._getFsProvider(E).stat(l.URI.revive(p))).then(w=>S._asIStat(w))}$readdir(E,p){return Promise.resolve(this._getFsProvider(E).readDirectory(l.URI.revive(p)))}$readFile(E,p){return Promise.resolve(this._getFsProvider(E).readFile(l.URI.revive(p))).then(w=>I.VSBuffer.wrap(w))}$writeFile(E,p,w,f){return Promise.resolve(this._getFsProvider(E).writeFile(l.URI.revive(p),w.buffer,f))}$delete(E,p,w){return Promise.resolve(this._getFsProvider(E).delete(l.URI.revive(p),w))}$rename(E,p,w,f){return Promise.resolve(this._getFsProvider(E).rename(l.URI.revive(p),l.URI.revive(w),f))}$copy(E,p,w,f){const v=this._getFsProvider(E);if(!v.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(v.copy(l.URI.revive(p),l.URI.revive(w),f))}$mkdir(E,p){return Promise.resolve(this._getFsProvider(E).createDirectory(l.URI.revive(p)))}$watch(E,p,w,f){const v=this._getFsProvider(E).watch(l.URI.revive(w),f);this._watches.set(p,v)}$unwatch(E,p){const w=this._watches.get(p);w&&(w.dispose(),this._watches.delete(p))}$open(E,p,w){const f=this._getFsProvider(E);if(!f.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(f.open(l.URI.revive(p),w))}$close(E,p){const w=this._getFsProvider(E);if(!w.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(w.close(p))}$read(E,p,w,f){const v=this._getFsProvider(E);if(!v.read)throw new Error('FileSystemProvider does not implement "read"');const m=I.VSBuffer.alloc(f);return Promise.resolve(v.read(p,w,m.buffer,0,f)).then(a=>m.slice(0,a))}$write(E,p,w,f){const v=this._getFsProvider(E);if(!v.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(v.write(p,w,f.buffer,0,f.byteLength))}_getFsProvider(E){const p=this._fsProvider.get(E);if(!p){const w=new Error;throw w.name="ENOPRO",w.message="no provider",w}return p}}e.ExtHostFileSystem=S}),define(De[66],Ie([1,0,5,42,7,23,3,16,46,6]),function(J,e,l,t,C,P,_,D,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let L=class Qt{constructor(S,T){this._fileSystemProvider=new Map,this._proxy=S.getProxy(l.MainContext.MainThreadFileSystem);const E=this;this.value=Object.freeze({async stat(p){try{const w=E._fileSystemProvider.get(p.scheme);if(!w)return await E._proxy.$stat(p);await E._proxy.$ensureActivation(p.scheme);const f=await w.stat(p);return{type:f.type,ctime:f.ctime,mtime:f.mtime,size:f.size,permissions:f.permissions}}catch(w){Qt._handleError(w)}},async readDirectory(p){try{const w=E._fileSystemProvider.get(p.scheme);return w?(await E._proxy.$ensureActivation(p.scheme),(await w.readDirectory(p)).slice()):await E._proxy.$readdir(p)}catch(w){return Qt._handleError(w)}},async createDirectory(p){try{return await E._proxy.$mkdir(p)}catch(w){return Qt._handleError(w)}},async readFile(p){try{const w=E._fileSystemProvider.get(p.scheme);return w?(await E._proxy.$ensureActivation(p.scheme),(await w.readFile(p)).slice()):(await E._proxy.$readFile(p)).buffer}catch(w){return Qt._handleError(w)}},async writeFile(p,w){try{return await E._proxy.$writeFile(p,P.VSBuffer.wrap(w))}catch(f){return Qt._handleError(f)}},async delete(p,w){try{const f=E._fileSystemProvider.get(p.scheme);return f?(await E._proxy.$ensureActivation(p.scheme),await f.delete(p,{recursive:!1,...w})):await E._proxy.$delete(p,{recursive:!1,useTrash:!1,...w})}catch(f){return Qt._handleError(f)}},async rename(p,w,f){try{return await E._proxy.$rename(p,w,{overwrite:!1,...f})}catch(v){return Qt._handleError(v)}},async copy(p,w,f){try{return await E._proxy.$copy(p,w,{overwrite:!1,...f})}catch(v){return Qt._handleError(v)}},isWritableFileSystem(p){const w=T.getCapabilities(p);if(typeof w=="number")return!(w&2048)}})}static _handleError(S){if(S instanceof C.FileSystemError)throw S;if(!(S instanceof Error))throw new C.FileSystemError(String(S));if(S.name==="ENOPRO")throw C.FileSystemError.Unavailable(S.message);switch(S.name){case t.FileSystemProviderErrorCode.FileExists:throw C.FileSystemError.FileExists(S.message);case t.FileSystemProviderErrorCode.FileNotFound:throw C.FileSystemError.FileNotFound(S.message);case t.FileSystemProviderErrorCode.FileNotADirectory:throw C.FileSystemError.FileNotADirectory(S.message);case t.FileSystemProviderErrorCode.FileIsADirectory:throw C.FileSystemError.FileIsADirectory(S.message);case t.FileSystemProviderErrorCode.NoPermissions:throw C.FileSystemError.NoPermissions(S.message);case t.FileSystemProviderErrorCode.Unavailable:throw C.FileSystemError.Unavailable(S.message);default:throw new C.FileSystemError(S.message,S.name)}}addFileSystemProvider(S,T){return this._fileSystemProvider.set(S,T),(0,I.toDisposable)(()=>this._fileSystemProvider.delete(S))}};L=qe([xe(0,D.IExtHostRpcService),xe(1,b.IExtHostFileSystemInfo)],L),e.ExtHostConsumerFileSystem=L,e.IExtHostConsumerFileSystem=(0,_.createDecorator)("IExtHostConsumerFileSystem")}),define(De[245],Ie([1,0,4,36,2,5,13,7,27]),function(J,e,l,t,C,P,_,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class I{constructor(S,T,E,p,w,f,v,m){this._onDidCreate=new l.Emitter,this._onDidChange=new l.Emitter,this._onDidDelete=new l.Emitter;const a=this.ensureWatching(S,E,w);this._config=0,f&&(this._config+=1),v&&(this._config+=2),m&&(this._config+=4);const g=(0,t.parse)(w),n=typeof w=="string",d=p(s=>{if(!f)for(const i of s.created){const r=C.URI.revive(i);g(r.fsPath)&&(!n||T.getWorkspaceFolder(r))&&this._onDidCreate.fire(r)}if(!v)for(const i of s.changed){const r=C.URI.revive(i);g(r.fsPath)&&(!n||T.getWorkspaceFolder(r))&&this._onDidChange.fire(r)}if(!m)for(const i of s.deleted){const r=C.URI.revive(i);g(r.fsPath)&&(!n||T.getWorkspaceFolder(r))&&this._onDidDelete.fire(r)}});this._disposable=D.Disposable.from(a,this._onDidCreate,this._onDidChange,this._onDidDelete,d)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(S,T,E){const p=D.Disposable.from();if(typeof E=="string")return p;const w=S.getProxy(P.MainContext.MainThreadFileSystem);let f=!1;(E.pattern.includes(t.GLOBSTAR)||E.pattern.includes(t.GLOB_SPLIT))&&(f=!0);const v=Math.random();return w.$watch(T.identifier.value,v,E.baseUri,{recursive:f,excludes:[]}),D.Disposable.from({dispose:()=>w.$unwatch(v)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class L{constructor(S,T,E){this._mainContext=S,this._logService=T,this._extHostDocumentsAndEditors=E,this._onFileSystemEvent=new l.Emitter,this._onDidRenameFile=new l.Emitter,this._onDidCreateFile=new l.Emitter,this._onDidDeleteFile=new l.Emitter,this._onWillRenameFile=new l.AsyncEmitter,this._onWillCreateFile=new l.AsyncEmitter,this._onWillDeleteFile=new l.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(S,T,E,p,w,f){return new I(this._mainContext,S,T,this._onFileSystemEvent.event,_.GlobPattern.from(E),p,w,f)}$onFileEvent(S){this._onFileSystemEvent.fire(S)}$onDidRunFileOperation(S,T){switch(S){case 2:this._onDidRenameFile.fire(Object.freeze({files:T.map(E=>({oldUri:C.URI.revive(E.source),newUri:C.URI.revive(E.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:T.map(E=>C.URI.revive(E.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:T.map(E=>C.URI.revive(E.target))}));break;default:}}getOnWillRenameFileEvent(S){return this._createWillExecuteEvent(S,this._onWillRenameFile)}getOnWillCreateFileEvent(S){return this._createWillExecuteEvent(S,this._onWillCreateFile)}getOnWillDeleteFileEvent(S){return this._createWillExecuteEvent(S,this._onWillDeleteFile)}_createWillExecuteEvent(S,T){return(E,p,w)=>{const f=function(m){E.call(p,m)};return f.extension=S,T.event(f,void 0,w)}}async $onWillRunFileOperation(S,T,E,p){switch(S){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:T.map(w=>({oldUri:C.URI.revive(w.source),newUri:C.URI.revive(w.target)}))},E,p);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:T.map(w=>C.URI.revive(w.target))},E,p);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:T.map(w=>C.URI.revive(w.target))},E,p)}}async _fireWillEvent(S,T,E,p){const w=new Set,f=[];if(await S.fireAsync(T,p,async(m,a)=>{const g=Date.now(),n=await Promise.resolve(m);n instanceof D.WorkspaceEdit&&(f.push([a.extension,n]),w.add(a.extension.displayName??a.extension.identifier.value)),Date.now()-g>E&&this._logService.warn("SLOW file-participant",a.extension.identifier)}),p.isCancellationRequested||f.length===0)return;const v={edits:[]};for(const[m,a]of f){const{edits:g}=_.WorkspaceEdit.from(a,{getTextDocumentVersion:n=>this._extHostDocumentsAndEditors.getDocument(n)?.version,getNotebookDocumentVersion:()=>{}},(0,b.isProposedApiEnabled)(m,"snippetWorkspaceEdit"));v.edits=v.edits.concat(g)}return{edit:v,extensionNames:Array.from(w)}}}e.ExtHostFileSystemEventService=L}),define(De[246],Ie([1,0,2,37]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class C{constructor(_,D,b,I,L){this._extHostNotebooks=D,this._textDocumentsAndEditors=b,this._commands=I;const k=new t.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new t.ApiCommandArgument("showOptions","Show Options",S=>!0,S=>S),new t.ApiCommandArgument("resource","Interactive resource Uri",S=>!0,S=>S),new t.ApiCommandArgument("controllerId","Notebook controller Id",S=>!0,S=>S),new t.ApiCommandArgument("title","Interactive editor title",S=>!0,S=>S)],new t.ApiCommandResult("Notebook and input URI",S=>{if(L.debug("[ExtHostInteractive] open iw with notebook editor id",S.notebookEditorId),S.notebookEditorId!==void 0){const T=this._extHostNotebooks.getEditorById(S.notebookEditorId);return L.debug("[ExtHostInteractive] notebook editor found",T.id),{notebookUri:l.URI.revive(S.notebookUri),inputUri:l.URI.revive(S.inputUri),notebookEditor:T.apiEditor}}return L.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",S.notebookUri,S.inputUri),{notebookUri:l.URI.revive(S.notebookUri),inputUri:l.URI.revive(S.inputUri)}}));this._commands.registerApiCommand(k)}$willAddInteractiveDocument(_,D,b,I){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:D,lines:[""],languageId:b,uri:_,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(l.URI.revive(I))?.apiNotebook}]})}$willRemoveInteractiveDocument(_,D){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[_]})}}e.ExtHostInteractive=C}),define(De[247],Ie([1,0,6,5]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class C{constructor(_){this._handlePool=0,this._proxy=_.getProxy(t.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(_){const D=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(D,_),(0,l.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(D)})}}e.ExtHostLabelService=C}),define(De[248],Ie([1,0,2,24,13,7,62,5,8,35,17,14,145,21,6,114,94,87,51,10,18,27]),function(J,e,l,t,C,P,_,D,b,I,L,k,S,T,E,p,w,f,v,m,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class n{constructor(F,H){this._documents=F,this._provider=H}async provideDocumentSymbols(F,H){const G=this._documents.getDocument(F),X=await this._provider.provideDocumentSymbols(G,H);if(!(0,L.isFalsyOrEmpty)(X))return X[0]instanceof P.DocumentSymbol?X.map(C.DocumentSymbol.from):n._asDocumentSymbolTree(X)}static _asDocumentSymbolTree(F){F=F.slice(0).sort((X,me)=>{let we=X.location.range.start.compareTo(me.location.range.start);return we===0&&(we=me.location.range.end.compareTo(X.location.range.end)),we});const H=[],G=[];for(const X of F){const me={name:X.name||"!!MISSING: name!!",kind:C.SymbolKind.from(X.kind),tags:X.tags?.map(C.SymbolTag.from)||[],detail:"",containerName:X.containerName,range:C.Range.from(X.location.range),selectionRange:C.Range.from(X.location.range),children:[]};for(;;){if(G.length===0){G.push(me),H.push(me);break}const we=G[G.length-1];if(I.Range.containsRange(we.range,me.range)&&!I.Range.equalsRange(we.range,me.range)){we.children?.push(me),G.push(me);break}G.pop()}}return H}}class d{constructor(F,H,G){this._documents=F,this._commands=H,this._provider=G,this._cache=new f.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(F,H){const G=this._documents.getDocument(F),X=await this._provider.provideCodeLenses(G,H);if(!X||H.isCancellationRequested)return;const me=this._cache.add(X),we=new E.DisposableStore;this._disposables.set(me,we);const ce={cacheId:me,lenses:[]};for(let Ce=0;Ce<X.length;Ce++)ce.lenses.push({cacheId:[me,Ce],range:C.Range.from(X[Ce].range),command:this._commands.toInternal(X[Ce].command,we)});return ce}async resolveCodeLens(F,H){const G=F.cacheId&&this._cache.get(...F.cacheId);if(!G)return;let X;if(typeof this._provider.resolveCodeLens!="function"||G.isResolved?X=G:X=await this._provider.resolveCodeLens(G,H),X||(X=G),H.isCancellationRequested)return;const me=F.cacheId&&this._disposables.get(F.cacheId[0]);if(!!me)return F.command=this._commands.toInternal(X.command??d._badCmd,me),F}releaseCodeLenses(F){this._disposables.get(F)?.dispose(),this._disposables.delete(F),this._cache.delete(F)}}d._badCmd={command:"missing",title:"!!MISSING: command!!"};function s(ie){return Array.isArray(ie)?ie.map(C.DefinitionLink.from):ie?[C.DefinitionLink.from(ie)]:[]}class i{constructor(F,H){this._documents=F,this._provider=H}async provideDefinition(F,H,G){const X=this._documents.getDocument(F),me=C.Position.to(H),we=await this._provider.provideDefinition(X,me,G);return s(we)}}class r{constructor(F,H){this._documents=F,this._provider=H}async provideDeclaration(F,H,G){const X=this._documents.getDocument(F),me=C.Position.to(H),we=await this._provider.provideDeclaration(X,me,G);return s(we)}}class c{constructor(F,H){this._documents=F,this._provider=H}async provideImplementation(F,H,G){const X=this._documents.getDocument(F),me=C.Position.to(H),we=await this._provider.provideImplementation(X,me,G);return s(we)}}class o{constructor(F,H){this._documents=F,this._provider=H}async provideTypeDefinition(F,H,G){const X=this._documents.getDocument(F),me=C.Position.to(H),we=await this._provider.provideTypeDefinition(X,me,G);return s(we)}}class u{constructor(F,H){this._documents=F,this._provider=H}async provideHover(F,H,G){const X=this._documents.getDocument(F),me=C.Position.to(H),we=await this._provider.provideHover(X,me,G);if(!(!we||(0,L.isFalsyOrEmpty)(we.contents)))return we.range||(we.range=X.getWordRangeAtPosition(me)),we.range||(we.range=new P.Range(me,me)),C.Hover.from(we)}}class h{constructor(F,H){this._documents=F,this._provider=H}async provideEvaluatableExpression(F,H,G){const X=this._documents.getDocument(F),me=C.Position.to(H),we=await this._provider.provideEvaluatableExpression(X,me,G);if(we)return C.EvaluatableExpression.from(we)}}class y{constructor(F,H){this._documents=F,this._provider=H}async provideInlineValues(F,H,G,X){const me=this._documents.getDocument(F),we=await this._provider.provideInlineValues(me,C.Range.to(H),C.InlineValueContext.to(G),X);if(Array.isArray(we))return we.map(ce=>C.InlineValue.from(ce))}}class R{constructor(F,H){this._documents=F,this._provider=H}async provideDocumentHighlights(F,H,G){const X=this._documents.getDocument(F),me=C.Position.to(H),we=await this._provider.provideDocumentHighlights(X,me,G);if(Array.isArray(we))return we.map(C.DocumentHighlight.from)}}class M{constructor(F,H){this._documents=F,this._provider=H}async provideLinkedEditingRanges(F,H,G){const X=this._documents.getDocument(F),me=C.Position.to(H),we=await this._provider.provideLinkedEditingRanges(X,me,G);if(we&&Array.isArray(we.ranges))return{ranges:(0,L.coalesce)(we.ranges.map(C.Range.from)),wordPattern:we.wordPattern}}}class U{constructor(F,H){this._documents=F,this._provider=H}async provideReferences(F,H,G,X){const me=this._documents.getDocument(F),we=C.Position.to(H),ce=await this._provider.provideReferences(me,we,G,X);if(Array.isArray(ce))return ce.map(C.location.from)}}class A{constructor(F,H,G,X,me,we,ce){this._documents=F,this._commands=H,this._diagnostics=G,this._provider=X,this._logService=me,this._extension=we,this._apiDeprecation=ce,this._cache=new f.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(F,H,G,X){const me=this._documents.getDocument(F),we=S.Selection.isISelection(H)?C.Selection.to(H):C.Range.to(H),ce=[];for(const Qe of this._diagnostics.getDiagnostics(F))if(we.intersection(Qe.range)&&ce.push(Qe)>A._maxCodeActionsPerFile)break;const Ce={diagnostics:ce,only:G.only?new P.CodeActionKind(G.only):void 0,triggerKind:C.CodeActionTriggerKind.to(G.trigger)},ye=await this._provider.provideCodeActions(me,we,Ce,X);if(!(0,L.isNonEmptyArray)(ye)||X.isCancellationRequested)return;const $e=this._cache.add(ye),Ve=new E.DisposableStore;this._disposables.set($e,Ve);const Ze=[];for(let Qe=0;Qe<ye.length;Qe++){const Le=ye[Qe];!Le||(A._isCommand(Le)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ze.push({_isSynthetic:!0,title:Le.title,command:this._commands.toInternal(Le,Ve)})):(Ce.only&&(Le.kind?Ce.only.contains(Le.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ce.only.value} 'requested but returned code action is of kind '${Le.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ce.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ze.push({cacheId:[$e,Qe],title:Le.title,command:Le.command&&this._commands.toInternal(Le.command,Ve),diagnostics:Le.diagnostics&&Le.diagnostics.map(C.Diagnostic.from),edit:Le.edit&&C.WorkspaceEdit.from(Le.edit,void 0,(0,g.isProposedApiEnabled)(this._extension,"snippetWorkspaceEdit")),kind:Le.kind&&Le.kind.value,isPreferred:Le.isPreferred,disabled:Le.disabled?.reason})))}return{cacheId:$e,actions:Ze}}async resolveCodeAction(F,H){const[G,X]=F,me=this._cache.get(G,X);if(!me||A._isCommand(me)||!this._provider.resolveCodeAction)return;const we=await this._provider.resolveCodeAction(me,H)??me;return we?.edit?C.WorkspaceEdit.from(we.edit,void 0,(0,g.isProposedApiEnabled)(this._extension,"snippetWorkspaceEdit")):void 0}releaseCodeActions(F){this._disposables.get(F)?.dispose(),this._disposables.delete(F),this._cache.delete(F)}static _isCommand(F){return typeof F.command=="string"&&typeof F.title=="string"}}A._maxCodeActionsPerFile=1e3;class z{constructor(F,H,G,X){this._proxy=F,this._documents=H,this._provider=G,this._handle=X}async prepareDocumentPaste(F,H,G,X){if(!this._provider.prepareDocumentPaste)return;const me=this._documents.getDocument(F),we=H.map(Ce=>C.Range.to(Ce)),ce=C.DataTransfer.toDataTransfer(G,()=>{throw new m.NotImplementedError});return await this._provider.prepareDocumentPaste(me,we,ce,X),C.DataTransfer.toDataTransferDTO(ce)}async providePasteEdits(F,H,G,X,me){const we=this._documents.getDocument(H),ce=G.map($e=>C.Range.to($e)),Ce=C.DataTransfer.toDataTransfer(X,async $e=>(await this._proxy.$resolvePasteFileData(this._handle,F,$e)).buffer),ye=await this._provider.provideDocumentPasteEdits(we,ce,Ce,me);if(!!ye)return{insertText:typeof ye.insertText=="string"?ye.insertText:{snippet:ye.insertText.value},additionalEdit:ye.additionalEdit?C.WorkspaceEdit.from(ye.additionalEdit,void 0,!0):void 0}}}class ${constructor(F,H){this._documents=F,this._provider=H}async provideDocumentFormattingEdits(F,H,G){const X=this._documents.getDocument(F),me=await this._provider.provideDocumentFormattingEdits(X,H,G);if(Array.isArray(me))return me.map(C.TextEdit.from)}}class N{constructor(F,H){this._documents=F,this._provider=H}async provideDocumentRangeFormattingEdits(F,H,G,X){const me=this._documents.getDocument(F),we=C.Range.to(H),ce=await this._provider.provideDocumentRangeFormattingEdits(me,we,G,X);if(Array.isArray(ce))return ce.map(C.TextEdit.from)}}class K{constructor(F,H){this._documents=F,this._provider=H,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(F,H,G,X,me){const we=this._documents.getDocument(F),ce=C.Position.to(H),Ce=await this._provider.provideOnTypeFormattingEdits(we,ce,G,X,me);if(Array.isArray(Ce))return Ce.map(C.TextEdit.from)}}class B{constructor(F,H){this._provider=F,this._logService=H,this._cache=new f.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(F,H){const G=await this._provider.provideWorkspaceSymbols(F,H);if(!(0,L.isNonEmptyArray)(G))return{symbols:[]};const X=this._cache.add(G),me={cacheId:X,symbols:[]};for(let we=0;we<G.length;we++){const ce=G[we];if(!ce||!ce.name){this._logService.warn("INVALID SymbolInformation",ce);continue}me.symbols.push({...C.WorkspaceSymbol.from(ce),cacheId:[X,we]})}return me}async resolveWorkspaceSymbol(F,H){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!F.cacheId)return F;const G=this._cache.get(...F.cacheId);if(G){const X=await this._provider.resolveWorkspaceSymbol(G,H);return X&&(0,t.mixin)(F,C.WorkspaceSymbol.from(X),!0)}}releaseWorkspaceSymbols(F){this._cache.delete(F)}}class O{constructor(F,H,G){this._documents=F,this._provider=H,this._logService=G}static supportsResolving(F){return typeof F.prepareRename=="function"}async provideRenameEdits(F,H,G,X){const me=this._documents.getDocument(F),we=C.Position.to(H);try{const ce=await this._provider.provideRenameEdits(me,we,G,X);return ce?C.WorkspaceEdit.from(ce):void 0}catch(ce){const Ce=O._asMessage(ce);return Ce?{rejectReason:Ce,edits:void 0}:Promise.reject(ce)}}async resolveRenameLocation(F,H,G){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const X=this._documents.getDocument(F),me=C.Position.to(H);try{const we=await this._provider.prepareRename(X,me,G);let ce,Ce;if(P.Range.isRange(we)?(ce=we,Ce=X.getText(we)):(0,k.isObject)(we)&&(ce=we.range,Ce=we.placeholder),!ce||!Ce)return;if(ce.start.line>me.line||ce.end.line<me.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:C.Range.from(ce),text:Ce}}catch(we){const ce=O._asMessage(we);return ce?{rejectReason:ce,range:void 0,text:void 0}:Promise.reject(we)}}static _asMessage(F){return typeof F=="string"?F:F instanceof Error&&typeof F.message=="string"?F.message:void 0}}class x{constructor(F,H){this.resultId=F,this.tokens=H}}class V{constructor(F,H){this._documents=F,this._provider=H,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(F,H,G){const X=this._documents.getDocument(F),me=H!==0?this._previousResults.get(H):null;let we=typeof me?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(X,me.resultId,G):await this._provider.provideDocumentSemanticTokens(X,G);return me&&this._previousResults.delete(H),we?(we=V._fixProvidedSemanticTokens(we),this._send(V._convertToEdits(me,we),we)):null}async releaseDocumentSemanticColoring(F){this._previousResults.delete(F)}static _fixProvidedSemanticTokens(F){return V._isSemanticTokens(F)?V._isCorrectSemanticTokens(F)?F:new P.SemanticTokens(new Uint32Array(F.data),F.resultId):V._isSemanticTokensEdits(F)?V._isCorrectSemanticTokensEdits(F)?F:new P.SemanticTokensEdits(F.edits.map(H=>new P.SemanticTokensEdit(H.start,H.deleteCount,H.data?new Uint32Array(H.data):H.data)),F.resultId):F}static _isSemanticTokens(F){return F&&!!F.data}static _isCorrectSemanticTokens(F){return F.data instanceof Uint32Array}static _isSemanticTokensEdits(F){return F&&Array.isArray(F.edits)}static _isCorrectSemanticTokensEdits(F){for(const H of F.edits)if(!(H.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(F,H){if(!V._isSemanticTokens(H)||!F||!F.tokens)return H;const G=F.tokens,X=G.length,me=H.data,we=me.length;let ce=0;const Ce=Math.min(X,we);for(;ce<Ce&&G[ce]===me[ce];)ce++;if(ce===X&&ce===we)return new P.SemanticTokensEdits([],H.resultId);let ye=0;const $e=Ce-ce;for(;ye<$e&&G[X-ye-1]===me[we-ye-1];)ye++;return new P.SemanticTokensEdits([{start:ce,deleteCount:X-ce-ye,data:me.subarray(ce,we-ye)}],H.resultId)}_send(F,H){if(V._isSemanticTokens(F)){const G=this._nextResultId++;return this._previousResults.set(G,new x(F.resultId,F.data)),(0,p.encodeSemanticTokensDto)({id:G,type:"full",data:F.data})}if(V._isSemanticTokensEdits(F)){const G=this._nextResultId++;return V._isSemanticTokens(H)?this._previousResults.set(G,new x(H.resultId,H.data)):this._previousResults.set(G,new x(F.resultId)),(0,p.encodeSemanticTokensDto)({id:G,type:"delta",deltas:(F.edits||[]).map(X=>({start:X.start,deleteCount:X.deleteCount,data:X.data}))})}return null}}e.DocumentSemanticTokensAdapter=V;class q{constructor(F,H){this._documents=F,this._provider=H}async provideDocumentRangeSemanticTokens(F,H,G){const X=this._documents.getDocument(F),me=await this._provider.provideDocumentRangeSemanticTokens(X,C.Range.to(H),G);return me?this._send(me):null}_send(F){return(0,p.encodeSemanticTokensDto)({id:0,type:"full",data:F.data})}}e.DocumentRangeSemanticTokensAdapter=q;class Y{constructor(F,H,G,X,me){this._documents=F,this._commands=H,this._provider=G,this._apiDeprecation=X,this._extension=me,this._cache=new f.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(F){return typeof F.resolveCompletionItem=="function"}async provideCompletionItems(F,H,G,X){const me=this._documents.getDocument(F),we=C.Position.to(H),ce=me.getWordRangeAtPosition(we)||new P.Range(we,we),Ce=ce.with({end:we}),ye=new v.StopWatch(!0),$e=await this._provider.provideCompletionItems(me,we,X,C.CompletionContext.to(G));if(!$e||X.isCancellationRequested)return;const Ve=Array.isArray($e)?new P.CompletionList($e):$e,Ze=Y.supportsResolving(this._provider)?this._cache.add(Ve.items):this._cache.add([]),Qe=new E.DisposableStore;this._disposables.set(Ze,Qe);const Le=[],ot={x:Ze,b:Le,a:{replace:C.Range.from(ce),insert:C.Range.from(Ce)},c:Ve.isIncomplete||void 0,d:ye.elapsed()};for(let re=0;re<Ve.items.length;re++){const se=Ve.items[re],Ee=this._convertCompletionItem(se,[Ze,re],Ce,ce);Le.push(Ee)}return ot}async resolveCompletionItem(F,H){if(typeof this._provider.resolveCompletionItem!="function")return;const G=this._cache.get(...F);if(!G)return;const X=await this._provider.resolveCompletionItem(G,H);if(!!X)return this._convertCompletionItem(X,F)}releaseCompletionItems(F){this._disposables.get(F)?.dispose(),this._disposables.delete(F),this._cache.delete(F)}_convertCompletionItem(F,H,G,X){const me=this._disposables.get(H[0]);if(!me)throw Error("DisposableStore is missing...");const we={x:H,a:F.label,b:F.kind!==void 0?C.CompletionItemKind.from(F.kind):void 0,n:F.tags&&F.tags.map(C.CompletionItemTag.from),c:F.detail,d:typeof F.documentation>"u"?void 0:C.MarkdownString.fromStrict(F.documentation),e:F.sortText!==F.label?F.sortText:void 0,f:F.filterText!==F.label?F.filterText:void 0,g:F.preselect||void 0,i:F.keepWhitespace?1:0,k:F.commitCharacters,l:F.additionalTextEdits&&F.additionalTextEdits.map(C.TextEdit.from),m:this._commands.toInternal(F.command,me)};F.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),we.h=F.textEdit.newText):typeof F.insertText=="string"?we.h=F.insertText:F.insertText instanceof P.SnippetString&&(we.h=F.insertText.value,we.i|=4);let ce;return F.textEdit?ce=F.textEdit.range:F.range&&(ce=F.range),P.Range.isRange(ce)?we.j=C.Range.from(ce):ce&&(!G?.isEqual(ce.inserting)||!X?.isEqual(ce.replacing))&&(we.j={insert:C.Range.from(ce.inserting),replace:C.Range.from(ce.replacing)}),we}}class Q{async provideInlineCompletions(F,H,G,X){}disposeCompletions(F){}handleDidShowCompletionItem(F,H){}}class de extends Q{constructor(F,H,G,X){super(),this._extension=F,this._documents=H,this._provider=G,this._commands=X,this._references=new ne,this._isAdditionsProposedApiEnabled=(0,g.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[_.InlineCompletionTriggerKind.Automatic]:P.InlineCompletionTriggerKind.Automatic,[_.InlineCompletionTriggerKind.Explicit]:P.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,g.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&typeof this._provider.handleDidShowCompletionItem=="function"}async provideInlineCompletions(F,H,G,X){const me=this._documents.getDocument(F),we=C.Position.to(H),ce=await this._provider.provideInlineCompletionItems(me,we,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:C.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[G.triggerKind]},X);if(!ce||X.isCancellationRequested)return;const Ce=Array.isArray(ce)?ce:ce.items,ye=this._isAdditionsProposedApiEnabled?Array.isArray(ce)?[]:ce.commands||[]:[];let $e;return{pid:this._references.createReferenceId({dispose(){$e?.dispose()},items:Ce}),items:Ce.map((Ze,Qe)=>{let Le;Ze.command&&($e||($e=new E.DisposableStore),Le=this._commands.toInternal(Ze.command,$e));const ot=Ze.insertText;return{insertText:typeof ot=="string"?ot:{snippet:ot.value},filterText:Ze.filterText,range:Ze.range?C.Range.from(Ze.range):void 0,command:Le,idx:Qe,completeBracketPairs:this._isAdditionsProposedApiEnabled?Ze.completeBracketPairs:!1}}),commands:ye.map(Ze=>($e||($e=new E.DisposableStore),this._commands.toInternal(Ze,$e)))}}disposeCompletions(F){this._references.disposeReferenceId(F)?.dispose()}handleDidShowCompletionItem(F,H){const G=this._references.get(F)?.items[H];G&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(G)}}class ve extends Q{constructor(F,H,G,X){super(),this.extension=F,this._documents=H,this._provider=G,this._commands=X,this._references=new ne,this.isAdditionProposedApiEnabled=(0,g.isProposedApiEnabled)(this.extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[_.InlineCompletionTriggerKind.Automatic]:P.InlineCompletionTriggerKindNew.Automatic,[_.InlineCompletionTriggerKind.Explicit]:P.InlineCompletionTriggerKindNew.Invoke}}async provideInlineCompletions(F,H,G,X){const me=this._documents.getDocument(F),we=C.Position.to(H),ce=await this._provider.provideInlineCompletionItems(me,we,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:C.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[G.triggerKind]},X);if(!ce||X.isCancellationRequested)return;const Ce=Array.isArray(ce)?ce:ce.items,ye=Array.isArray(ce)?[]:ce.commands||[];let $e;return{pid:this._references.createReferenceId({dispose(){$e?.dispose()},items:Ce}),items:Ce.map((Ze,Qe)=>{let Le;Ze.command&&($e||($e=new E.DisposableStore),Le=this._commands.toInternal(Ze.command,$e));const ot=Ze.insertText;return{insertText:typeof ot=="string"?ot:{snippet:ot.value},filterText:Ze.filterText,range:Ze.range?C.Range.from(Ze.range):void 0,command:Le,idx:Qe,completeBracketPairs:this.isAdditionProposedApiEnabled?Ze.completeBracketPairs:!1}}),commands:ye.map(Ze=>($e||($e=new E.DisposableStore),this._commands.toInternal(Ze,$e)))}}disposeCompletions(F){this._references.disposeReferenceId(F)?.dispose()}handleDidShowCompletionItem(F,H){const G=this._references.get(F)?.items[H];G&&this._provider.handleDidShowCompletionItem&&this.isAdditionProposedApiEnabled&&this._provider.handleDidShowCompletionItem(G)}}class ne{constructor(){this._references=new Map,this._idPool=1}createReferenceId(F){const H=this._idPool++;return this._references.set(H,F),H}disposeReferenceId(F){const H=this._references.get(F);return this._references.delete(F),H}get(F){return this._references.get(F)}}class pe{constructor(F,H){this._documents=F,this._provider=H,this._cache=new f.Cache("SignatureHelp")}async provideSignatureHelp(F,H,G,X){const me=this._documents.getDocument(F),we=C.Position.to(H),ce=this.reviveContext(G),Ce=await this._provider.provideSignatureHelp(me,we,X,ce);if(Ce){const ye=this._cache.add([Ce]);return{...C.SignatureHelp.from(Ce),id:ye}}}reviveContext(F){let H;if(F.activeSignatureHelp){const G=C.SignatureHelp.to(F.activeSignatureHelp),X=this._cache.get(F.activeSignatureHelp.id,0);X?(H=X,H.activeSignature=G.activeSignature,H.activeParameter=G.activeParameter):H=G}return{...F,activeSignatureHelp:H}}releaseSignatureHelp(F){this._cache.delete(F)}}class be{constructor(F,H,G,X,me){this._documents=F,this._commands=H,this._provider=G,this._logService=X,this._extension=me,this._cache=new f.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(F,H,G){const X=this._documents.getDocument(F),me=C.Range.to(H),we=await this._provider.provideInlayHints(X,me,G);if(!Array.isArray(we)||we.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${H}`);return}if(G.isCancellationRequested)return;const ce=this._cache.add(we);this._disposables.set(ce,new E.DisposableStore);const Ce={hints:[],cacheId:ce};for(let ye=0;ye<we.length;ye++)this._isValidInlayHint(we[ye],me)&&Ce.hints.push(this._convertInlayHint(we[ye],[ce,ye]));return this._logService.trace(`[InlayHints] ${Ce.hints.length} inlay hints from '${this._extension.identifier.value}' for ${H}`),Ce}async resolveInlayHint(F,H){if(typeof this._provider.resolveInlayHint!="function")return;const G=this._cache.get(...F);if(!G)return;const X=await this._provider.resolveInlayHint(G,H);if(!!X&&!!this._isValidInlayHint(X))return this._convertInlayHint(X,F)}releaseHints(F){this._disposables.get(F)?.dispose(),this._disposables.delete(F),this._cache.delete(F)}_isValidInlayHint(F,H){return F.label.length===0||Array.isArray(F.label)&&F.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",F),!1):!(H&&!H.contains(F.position))}_convertInlayHint(F,H){const G=this._disposables.get(H[0]);if(!G)throw Error("DisposableStore is missing...");const X={label:"",cacheId:H,tooltip:C.MarkdownString.fromStrict(F.tooltip),position:C.Position.from(F.position),textEdits:F.textEdits&&F.textEdits.map(C.TextEdit.from),kind:F.kind&&C.InlayHintKind.from(F.kind),paddingLeft:F.paddingLeft,paddingRight:F.paddingRight};return typeof F.label=="string"?X.label=F.label:X.label=F.label.map(me=>{const we={label:me.value};return we.tooltip=C.MarkdownString.fromStrict(me.tooltip),P.Location.isLocation(me.location)&&(we.location=C.location.from(me.location)),me.command&&(we.command=this._commands.toInternal(me.command,G)),we}),X}}class ke{constructor(F,H){this._documents=F,this._provider=H,this._cache=new f.Cache("DocumentLink")}async provideLinks(F,H){const G=this._documents.getDocument(F),X=await this._provider.provideDocumentLinks(G,H);if(!(!Array.isArray(X)||X.length===0)&&!H.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:X.filter(ke._validateLink).map(C.DocumentLink.from)};{const me=this._cache.add(X),we={links:[],cacheId:me};for(let ce=0;ce<X.length;ce++){if(!ke._validateLink(X[ce]))continue;const Ce=C.DocumentLink.from(X[ce]);Ce.cacheId=[me,ce],we.links.push(Ce)}return we}}}static _validateLink(F){return F.target&&F.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(F,H){if(typeof this._provider.resolveDocumentLink!="function")return;const G=this._cache.get(...F);if(!G)return;const X=await this._provider.resolveDocumentLink(G,H);if(!(!X||!ke._validateLink(X)))return C.DocumentLink.from(X)}releaseLinks(F){this._cache.delete(F)}}class Oe{constructor(F,H){this._documents=F,this._provider=H}async provideColors(F,H){const G=this._documents.getDocument(F),X=await this._provider.provideDocumentColors(G,H);return Array.isArray(X)?X.map(we=>({color:C.Color.from(we.color),range:C.Range.from(we.range)})):[]}async provideColorPresentations(F,H,G){const X=this._documents.getDocument(F),me=C.Range.to(H.range),we=C.Color.to(H.color),ce=await this._provider.provideColorPresentations(we,{document:X,range:me},G);if(!!Array.isArray(ce))return ce.map(C.ColorPresentation.from)}}class We{constructor(F,H){this._documents=F,this._provider=H}async provideFoldingRanges(F,H,G){const X=this._documents.getDocument(F),me=await this._provider.provideFoldingRanges(X,H,G);if(!!Array.isArray(me))return me.map(C.FoldingRange.from)}}class oe{constructor(F,H,G){this._documents=F,this._provider=H,this._logService=G}async provideSelectionRanges(F,H,G){const X=this._documents.getDocument(F),me=H.map(C.Position.to),we=await this._provider.provideSelectionRanges(X,me,G);if(!(0,L.isNonEmptyArray)(we))return[];if(we.length!==me.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ce=[];for(let Ce=0;Ce<me.length;Ce++){const ye=[];ce.push(ye);let $e=me[Ce],Ve=we[Ce];for(;;){if(!Ve.range.contains($e))throw new Error("INVALID selection range, must contain the previous range");if(ye.push(C.SelectionRange.from(Ve)),!Ve.parent)break;$e=Ve.range,Ve=Ve.parent}}return ce}}class le{constructor(F,H){this._documents=F,this._provider=H,this._idPool=new w.IdGenerator(""),this._cache=new Map}async prepareSession(F,H,G){const X=this._documents.getDocument(F),me=C.Position.to(H),we=await this._provider.prepareCallHierarchy(X,me,G);if(!we)return;const ce=this._idPool.nextId();return this._cache.set(ce,new Map),Array.isArray(we)?we.map(Ce=>this._cacheAndConvertItem(ce,Ce)):[this._cacheAndConvertItem(ce,we)]}async provideCallsTo(F,H,G){const X=this._itemFromCache(F,H);if(!X)throw new Error("missing call hierarchy item");const me=await this._provider.provideCallHierarchyIncomingCalls(X,G);if(!!me)return me.map(we=>({from:this._cacheAndConvertItem(F,we.from),fromRanges:we.fromRanges.map(ce=>C.Range.from(ce))}))}async provideCallsFrom(F,H,G){const X=this._itemFromCache(F,H);if(!X)throw new Error("missing call hierarchy item");const me=await this._provider.provideCallHierarchyOutgoingCalls(X,G);if(!!me)return me.map(we=>({to:this._cacheAndConvertItem(F,we.to),fromRanges:we.fromRanges.map(ce=>C.Range.from(ce))}))}releaseSession(F){this._cache.delete(F)}_cacheAndConvertItem(F,H){const G=this._cache.get(F),X=C.CallHierarchyItem.from(H,F,G.size.toString(36));return G.set(X._itemId,H),X}_itemFromCache(F,H){return this._cache.get(F)?.get(H)}}class fe{constructor(F,H){this._documents=F,this._provider=H,this._idPool=new w.IdGenerator(""),this._cache=new Map}async prepareSession(F,H,G){const X=this._documents.getDocument(F),me=C.Position.to(H),we=await this._provider.prepareTypeHierarchy(X,me,G);if(!we)return;const ce=this._idPool.nextId();return this._cache.set(ce,new Map),Array.isArray(we)?we.map(Ce=>this._cacheAndConvertItem(ce,Ce)):[this._cacheAndConvertItem(ce,we)]}async provideSupertypes(F,H,G){const X=this._itemFromCache(F,H);if(!X)throw new Error("missing type hierarchy item");const me=await this._provider.provideTypeHierarchySupertypes(X,G);if(!!me)return me.map(we=>this._cacheAndConvertItem(F,we))}async provideSubtypes(F,H,G){const X=this._itemFromCache(F,H);if(!X)throw new Error("missing type hierarchy item");const me=await this._provider.provideTypeHierarchySubtypes(X,G);if(!!me)return me.map(we=>this._cacheAndConvertItem(F,we))}releaseSession(F){this._cache.delete(F)}_cacheAndConvertItem(F,H){const G=this._cache.get(F),X=C.TypeHierarchyItem.from(H,F,G.size.toString(36));return G.set(X._itemId,H),X}_itemFromCache(F,H){return this._cache.get(F)?.get(H)}}class Z{constructor(F,H,G,X){this._proxy=F,this._documents=H,this._provider=G,this._handle=X}async provideDocumentOnDropEdits(F,H,G,X,me){const we=this._documents.getDocument(H),ce=C.Position.to(G),Ce=C.DataTransfer.toDataTransfer(X,async $e=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,F,$e)).buffer),ye=await this._provider.provideDocumentDropEdits(we,ce,Ce,me);if(!!ye)return{insertText:typeof ye.insertText=="string"?ye.insertText:{snippet:ye.insertText.value},additionalEdit:ye.additionalEdit?C.WorkspaceEdit.from(ye.additionalEdit,void 0,!0):void 0}}}class ae{constructor(F,H){this.adapter=F,this.extension=H}}class ee{constructor(F,H,G,X,me,we,ce){this._adapter=new Map,this._uriTransformer=H,this._proxy=F.getProxy(D.MainContext.MainThreadLanguageFeatures),this._documents=G,this._commands=X,this._diagnostics=me,this._logService=we,this._apiDeprecation=ce}_transformDocumentSelector(F){return C.DocumentSelector.from(F,this._uriTransformer)}_createDisposable(F){return new P.Disposable(()=>{this._adapter.delete(F),this._proxy.$unregister(F)})}_nextHandle(){return ee._handlePool++}async _withAdapter(F,H,G,X,me,we=!1){const ce=this._adapter.get(F);if(!ce||!(ce.adapter instanceof H))return X;const Ce=Date.now();we||this._logService.trace(`[${ce.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const ye=G(ce.adapter,ce.extension);return Promise.resolve(ye).catch($e=>{(0,m.isCancellationError)($e)||(this._logService.error(`[${ce.extension.identifier.value}] provider FAILED`),this._logService.error($e))}).finally(()=>{we||this._logService.trace(`[${ce.extension.identifier.value}] provider DONE after ${Date.now()-Ce}ms`)}),T.CancellationToken.isCancellationToken(me)?(0,a.raceCancellationError)(ye,me):ye}_addNewAdapter(F,H){const G=this._nextHandle();return this._adapter.set(G,new ae(F,H)),G}static _extLabel(F){return F.displayName||F.name}registerDocumentSymbolProvider(F,H,G,X){const me=this._addNewAdapter(new n(this._documents,G),F),we=X&&X.label||ee._extLabel(F);return this._proxy.$registerDocumentSymbolProvider(me,this._transformDocumentSelector(H),we),this._createDisposable(me)}$provideDocumentSymbols(F,H,G){return this._withAdapter(F,n,X=>X.provideDocumentSymbols(l.URI.revive(H),G),void 0,G)}registerCodeLensProvider(F,H,G){const X=this._nextHandle(),me=typeof G.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(X,new ae(new d(this._documents,this._commands.converter,G),F)),this._proxy.$registerCodeLensSupport(X,this._transformDocumentSelector(H),me);let we=this._createDisposable(X);if(me!==void 0){const ce=G.onDidChangeCodeLenses(Ce=>this._proxy.$emitCodeLensEvent(me));we=P.Disposable.from(we,ce)}return we}$provideCodeLenses(F,H,G){return this._withAdapter(F,d,X=>X.provideCodeLenses(l.URI.revive(H),G),void 0,G)}$resolveCodeLens(F,H,G){return this._withAdapter(F,d,X=>X.resolveCodeLens(H,G),void 0,void 0)}$releaseCodeLenses(F,H){this._withAdapter(F,d,G=>Promise.resolve(G.releaseCodeLenses(H)),void 0,void 0)}registerDefinitionProvider(F,H,G){const X=this._addNewAdapter(new i(this._documents,G),F);return this._proxy.$registerDefinitionSupport(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$provideDefinition(F,H,G,X){return this._withAdapter(F,i,me=>me.provideDefinition(l.URI.revive(H),G,X),[],X)}registerDeclarationProvider(F,H,G){const X=this._addNewAdapter(new r(this._documents,G),F);return this._proxy.$registerDeclarationSupport(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$provideDeclaration(F,H,G,X){return this._withAdapter(F,r,me=>me.provideDeclaration(l.URI.revive(H),G,X),[],X)}registerImplementationProvider(F,H,G){const X=this._addNewAdapter(new c(this._documents,G),F);return this._proxy.$registerImplementationSupport(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$provideImplementation(F,H,G,X){return this._withAdapter(F,c,me=>me.provideImplementation(l.URI.revive(H),G,X),[],X)}registerTypeDefinitionProvider(F,H,G){const X=this._addNewAdapter(new o(this._documents,G),F);return this._proxy.$registerTypeDefinitionSupport(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$provideTypeDefinition(F,H,G,X){return this._withAdapter(F,o,me=>me.provideTypeDefinition(l.URI.revive(H),G,X),[],X)}registerHoverProvider(F,H,G,X){const me=this._addNewAdapter(new u(this._documents,G),F);return this._proxy.$registerHoverProvider(me,this._transformDocumentSelector(H)),this._createDisposable(me)}$provideHover(F,H,G,X){return this._withAdapter(F,u,me=>me.provideHover(l.URI.revive(H),G,X),void 0,X)}registerEvaluatableExpressionProvider(F,H,G,X){const me=this._addNewAdapter(new h(this._documents,G),F);return this._proxy.$registerEvaluatableExpressionProvider(me,this._transformDocumentSelector(H)),this._createDisposable(me)}$provideEvaluatableExpression(F,H,G,X){return this._withAdapter(F,h,me=>me.provideEvaluatableExpression(l.URI.revive(H),G,X),void 0,X)}registerInlineValuesProvider(F,H,G,X){const me=typeof G.onDidChangeInlineValues=="function"?this._nextHandle():void 0,we=this._addNewAdapter(new y(this._documents,G),F);this._proxy.$registerInlineValuesProvider(we,this._transformDocumentSelector(H),me);let ce=this._createDisposable(we);if(me!==void 0){const Ce=G.onDidChangeInlineValues(ye=>this._proxy.$emitInlineValuesEvent(me));ce=P.Disposable.from(ce,Ce)}return ce}$provideInlineValues(F,H,G,X,me){return this._withAdapter(F,y,we=>we.provideInlineValues(l.URI.revive(H),G,X,me),void 0,me)}registerDocumentHighlightProvider(F,H,G){const X=this._addNewAdapter(new R(this._documents,G),F);return this._proxy.$registerDocumentHighlightProvider(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$provideDocumentHighlights(F,H,G,X){return this._withAdapter(F,R,me=>me.provideDocumentHighlights(l.URI.revive(H),G,X),void 0,X)}registerLinkedEditingRangeProvider(F,H,G){const X=this._addNewAdapter(new M(this._documents,G),F);return this._proxy.$registerLinkedEditingRangeProvider(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$provideLinkedEditingRanges(F,H,G,X){return this._withAdapter(F,M,async me=>{const we=await me.provideLinkedEditingRanges(l.URI.revive(H),G,X);if(we)return{ranges:we.ranges,wordPattern:we.wordPattern?ee._serializeRegExp(we.wordPattern):void 0}},void 0,X)}registerReferenceProvider(F,H,G){const X=this._addNewAdapter(new U(this._documents,G),F);return this._proxy.$registerReferenceSupport(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$provideReferences(F,H,G,X,me){return this._withAdapter(F,U,we=>we.provideReferences(l.URI.revive(H),G,X,me),void 0,me)}registerCodeActionProvider(F,H,G,X){const me=new E.DisposableStore,we=this._addNewAdapter(new A(this._documents,this._commands.converter,this._diagnostics,G,this._logService,F,this._apiDeprecation),F);return this._proxy.$registerQuickFixSupport(we,this._transformDocumentSelector(H),{providedKinds:X?.providedCodeActionKinds?.map(ce=>ce.value),documentation:X?.documentation?.map(ce=>({kind:ce.kind.value,command:this._commands.converter.toInternal(ce.command,me)}))},ee._extLabel(F),Boolean(G.resolveCodeAction)),me.add(this._createDisposable(we)),me}$provideCodeActions(F,H,G,X,me){return this._withAdapter(F,A,we=>we.provideCodeActions(l.URI.revive(H),G,X,me),void 0,me)}$resolveCodeAction(F,H,G){return this._withAdapter(F,A,X=>X.resolveCodeAction(H,G),void 0,void 0)}$releaseCodeActions(F,H){this._withAdapter(F,A,G=>Promise.resolve(G.releaseCodeActions(H)),void 0,void 0)}registerDocumentFormattingEditProvider(F,H,G){const X=this._addNewAdapter(new $(this._documents,G),F);return this._proxy.$registerDocumentFormattingSupport(X,this._transformDocumentSelector(H),F.identifier,F.displayName||F.name),this._createDisposable(X)}$provideDocumentFormattingEdits(F,H,G,X){return this._withAdapter(F,$,me=>me.provideDocumentFormattingEdits(l.URI.revive(H),G,X),void 0,X)}registerDocumentRangeFormattingEditProvider(F,H,G){const X=this._addNewAdapter(new N(this._documents,G),F);return this._proxy.$registerRangeFormattingSupport(X,this._transformDocumentSelector(H),F.identifier,F.displayName||F.name),this._createDisposable(X)}$provideDocumentRangeFormattingEdits(F,H,G,X,me){return this._withAdapter(F,N,we=>we.provideDocumentRangeFormattingEdits(l.URI.revive(H),G,X,me),void 0,me)}registerOnTypeFormattingEditProvider(F,H,G,X){const me=this._addNewAdapter(new K(this._documents,G),F);return this._proxy.$registerOnTypeFormattingSupport(me,this._transformDocumentSelector(H),X,F.identifier),this._createDisposable(me)}$provideOnTypeFormattingEdits(F,H,G,X,me,we){return this._withAdapter(F,K,ce=>ce.provideOnTypeFormattingEdits(l.URI.revive(H),G,X,me,we),void 0,we)}registerWorkspaceSymbolProvider(F,H){const G=this._addNewAdapter(new B(H,this._logService),F);return this._proxy.$registerNavigateTypeSupport(G,typeof H.resolveWorkspaceSymbol=="function"),this._createDisposable(G)}$provideWorkspaceSymbols(F,H,G){return this._withAdapter(F,B,X=>X.provideWorkspaceSymbols(H,G),{symbols:[]},G)}$resolveWorkspaceSymbol(F,H,G){return this._withAdapter(F,B,X=>X.resolveWorkspaceSymbol(H,G),void 0,void 0)}$releaseWorkspaceSymbols(F,H){this._withAdapter(F,B,G=>G.releaseWorkspaceSymbols(H),void 0,void 0)}registerRenameProvider(F,H,G){const X=this._addNewAdapter(new O(this._documents,G,this._logService),F);return this._proxy.$registerRenameSupport(X,this._transformDocumentSelector(H),O.supportsResolving(G)),this._createDisposable(X)}$provideRenameEdits(F,H,G,X,me){return this._withAdapter(F,O,we=>we.provideRenameEdits(l.URI.revive(H),G,X,me),void 0,me)}$resolveRenameLocation(F,H,G,X){return this._withAdapter(F,O,me=>me.resolveRenameLocation(l.URI.revive(H),G,X),void 0,X)}registerDocumentSemanticTokensProvider(F,H,G,X){const me=this._addNewAdapter(new V(this._documents,G),F),we=typeof G.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(me,this._transformDocumentSelector(H),X,we);let ce=this._createDisposable(me);if(we){const Ce=G.onDidChangeSemanticTokens(ye=>this._proxy.$emitDocumentSemanticTokensEvent(we));ce=P.Disposable.from(ce,Ce)}return ce}$provideDocumentSemanticTokens(F,H,G,X){return this._withAdapter(F,V,me=>me.provideDocumentSemanticTokens(l.URI.revive(H),G,X),null,X)}$releaseDocumentSemanticTokens(F,H){this._withAdapter(F,V,G=>G.releaseDocumentSemanticColoring(H),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(F,H,G,X){const me=this._addNewAdapter(new q(this._documents,G),F);return this._proxy.$registerDocumentRangeSemanticTokensProvider(me,this._transformDocumentSelector(H),X),this._createDisposable(me)}$provideDocumentRangeSemanticTokens(F,H,G,X){return this._withAdapter(F,q,me=>me.provideDocumentRangeSemanticTokens(l.URI.revive(H),G,X),null,X)}registerCompletionItemProvider(F,H,G,X){const me=this._addNewAdapter(new Y(this._documents,this._commands.converter,G,this._apiDeprecation,F),F);return this._proxy.$registerCompletionsProvider(me,this._transformDocumentSelector(H),X,Y.supportsResolving(G),`${F.identifier.value}(${X.join("")})`),this._createDisposable(me)}$provideCompletionItems(F,H,G,X,me){return this._withAdapter(F,Y,we=>we.provideCompletionItems(l.URI.revive(H),G,X,me),void 0,me)}$resolveCompletionItem(F,H,G){return this._withAdapter(F,Y,X=>X.resolveCompletionItem(H,G),void 0,G)}$releaseCompletionItems(F,H){this._withAdapter(F,Y,G=>G.releaseCompletionItems(H),void 0,void 0)}registerInlineCompletionsProvider(F,H,G){const X=new de(F,this._documents,G,this._commands.converter),me=this._addNewAdapter(X,F);return this._proxy.$registerInlineCompletionsSupport(me,this._transformDocumentSelector(H),X.supportsHandleDidShowCompletionItem),this._createDisposable(me)}registerInlineCompletionsProviderNew(F,H,G){const X=this._addNewAdapter(new ve(F,this._documents,G,this._commands.converter),F);return this._proxy.$registerInlineCompletionsSupport(X,this._transformDocumentSelector(H),!0),this._createDisposable(X)}$provideInlineCompletions(F,H,G,X,me){return this._withAdapter(F,Q,we=>we.provideInlineCompletions(l.URI.revive(H),G,X,me),void 0,me)}$handleInlineCompletionDidShow(F,H,G){this._withAdapter(F,Q,async X=>{X.handleDidShowCompletionItem(H,G)},void 0,void 0)}$freeInlineCompletionsList(F,H){this._withAdapter(F,Q,async G=>{G.disposeCompletions(H)},void 0,void 0)}registerSignatureHelpProvider(F,H,G,X){const me=Array.isArray(X)?{triggerCharacters:X,retriggerCharacters:[]}:X,we=this._addNewAdapter(new pe(this._documents,G),F);return this._proxy.$registerSignatureHelpProvider(we,this._transformDocumentSelector(H),me),this._createDisposable(we)}$provideSignatureHelp(F,H,G,X,me){return this._withAdapter(F,pe,we=>we.provideSignatureHelp(l.URI.revive(H),G,X,me),void 0,me)}$releaseSignatureHelp(F,H){this._withAdapter(F,pe,G=>G.releaseSignatureHelp(H),void 0,void 0)}registerInlayHintsProvider(F,H,G){const X=typeof G.onDidChangeInlayHints=="function"?this._nextHandle():void 0,me=this._addNewAdapter(new be(this._documents,this._commands.converter,G,this._logService,F),F);this._proxy.$registerInlayHintsProvider(me,this._transformDocumentSelector(H),typeof G.resolveInlayHint=="function",X,ee._extLabel(F));let we=this._createDisposable(me);if(X!==void 0){const ce=G.onDidChangeInlayHints(Ce=>this._proxy.$emitInlayHintsEvent(X));we=P.Disposable.from(we,ce)}return we}$provideInlayHints(F,H,G,X){return this._withAdapter(F,be,me=>me.provideInlayHints(l.URI.revive(H),G,X),void 0,X)}$resolveInlayHint(F,H,G){return this._withAdapter(F,be,X=>X.resolveInlayHint(H,G),void 0,G)}$releaseInlayHints(F,H){this._withAdapter(F,be,G=>G.releaseHints(H),void 0,void 0)}registerDocumentLinkProvider(F,H,G){const X=this._addNewAdapter(new ke(this._documents,G),F);return this._proxy.$registerDocumentLinkProvider(X,this._transformDocumentSelector(H),typeof G.resolveDocumentLink=="function"),this._createDisposable(X)}$provideDocumentLinks(F,H,G){return this._withAdapter(F,ke,X=>X.provideLinks(l.URI.revive(H),G),void 0,G,H.scheme==="output")}$resolveDocumentLink(F,H,G){return this._withAdapter(F,ke,X=>X.resolveLink(H,G),void 0,void 0,!0)}$releaseDocumentLinks(F,H){this._withAdapter(F,ke,G=>G.releaseLinks(H),void 0,void 0,!0)}registerColorProvider(F,H,G){const X=this._addNewAdapter(new Oe(this._documents,G),F);return this._proxy.$registerDocumentColorProvider(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$provideDocumentColors(F,H,G){return this._withAdapter(F,Oe,X=>X.provideColors(l.URI.revive(H),G),[],G)}$provideColorPresentations(F,H,G,X){return this._withAdapter(F,Oe,me=>me.provideColorPresentations(l.URI.revive(H),G,X),void 0,X)}registerFoldingRangeProvider(F,H,G){const X=this._nextHandle(),me=typeof G.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(X,new ae(new We(this._documents,G),F)),this._proxy.$registerFoldingRangeProvider(X,this._transformDocumentSelector(H),me);let we=this._createDisposable(X);if(me!==void 0){const ce=G.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(me));we=P.Disposable.from(we,ce)}return we}$provideFoldingRanges(F,H,G,X){return this._withAdapter(F,We,me=>me.provideFoldingRanges(l.URI.revive(H),G,X),void 0,X)}registerSelectionRangeProvider(F,H,G){const X=this._addNewAdapter(new oe(this._documents,G,this._logService),F);return this._proxy.$registerSelectionRangeProvider(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$provideSelectionRanges(F,H,G,X){return this._withAdapter(F,oe,me=>me.provideSelectionRanges(l.URI.revive(H),G,X),[],X)}registerCallHierarchyProvider(F,H,G){const X=this._addNewAdapter(new le(this._documents,G),F);return this._proxy.$registerCallHierarchyProvider(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$prepareCallHierarchy(F,H,G,X){return this._withAdapter(F,le,me=>Promise.resolve(me.prepareSession(l.URI.revive(H),G,X)),void 0,X)}$provideCallHierarchyIncomingCalls(F,H,G,X){return this._withAdapter(F,le,me=>me.provideCallsTo(H,G,X),void 0,X)}$provideCallHierarchyOutgoingCalls(F,H,G,X){return this._withAdapter(F,le,me=>me.provideCallsFrom(H,G,X),void 0,X)}$releaseCallHierarchy(F,H){this._withAdapter(F,le,G=>Promise.resolve(G.releaseSession(H)),void 0,void 0)}registerTypeHierarchyProvider(F,H,G){const X=this._addNewAdapter(new fe(this._documents,G),F);return this._proxy.$registerTypeHierarchyProvider(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$prepareTypeHierarchy(F,H,G,X){return this._withAdapter(F,fe,me=>Promise.resolve(me.prepareSession(l.URI.revive(H),G,X)),void 0,X)}$provideTypeHierarchySupertypes(F,H,G,X){return this._withAdapter(F,fe,me=>me.provideSupertypes(H,G,X),void 0,X)}$provideTypeHierarchySubtypes(F,H,G,X){return this._withAdapter(F,fe,me=>me.provideSubtypes(H,G,X),void 0,X)}$releaseTypeHierarchy(F,H){this._withAdapter(F,fe,G=>Promise.resolve(G.releaseSession(H)),void 0,void 0)}registerDocumentOnDropEditProvider(F,H,G){const X=this._nextHandle();return this._adapter.set(X,new ae(new Z(this._proxy,this._documents,G,X),F)),this._proxy.$registerDocumentOnDropEditProvider(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$provideDocumentOnDropEdits(F,H,G,X,me,we){return this._withAdapter(F,Z,ce=>Promise.resolve(ce.provideDocumentOnDropEdits(H,l.URI.revive(G),X,me,we)),void 0,void 0)}registerDocumentPasteEditProvider(F,H,G,X){const me=this._nextHandle();return this._adapter.set(me,new ae(new z(this._proxy,this._documents,G,me),F)),this._proxy.$registerPasteEditProvider(me,this._transformDocumentSelector(H),!!G.prepareDocumentPaste,X.pasteMimeTypes),this._createDisposable(me)}$prepareDocumentPaste(F,H,G,X,me){return this._withAdapter(F,z,we=>we.prepareDocumentPaste(l.URI.revive(H),G,X,me),void 0,me)}$providePasteEdits(F,H,G,X,me,we){return this._withAdapter(F,z,ce=>ce.providePasteEdits(H,l.URI.revive(G),X,me,we),void 0,we)}static _serializeRegExp(F){return{pattern:F.source,flags:(0,b.regExpFlags)(F)}}static _serializeIndentationRule(F){return{decreaseIndentPattern:ee._serializeRegExp(F.decreaseIndentPattern),increaseIndentPattern:ee._serializeRegExp(F.increaseIndentPattern),indentNextLinePattern:F.indentNextLinePattern?ee._serializeRegExp(F.indentNextLinePattern):void 0,unIndentedLinePattern:F.unIndentedLinePattern?ee._serializeRegExp(F.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(F){return{beforeText:ee._serializeRegExp(F.beforeText),afterText:F.afterText?ee._serializeRegExp(F.afterText):void 0,previousLineText:F.previousLineText?ee._serializeRegExp(F.previousLineText):void 0,action:F.action}}static _serializeOnEnterRules(F){return F.map(ee._serializeOnEnterRule)}setLanguageConfiguration(F,H,G){const{wordPattern:X}=G;if(X&&(0,b.regExpLeadsToEndlessLoop)(X))throw new Error(`Invalid language configuration: wordPattern '${X}' is not allowed to match the empty string.`);X?this._documents.setWordDefinitionFor(H,X):this._documents.setWordDefinitionFor(H,void 0),G.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",F,"Do not use."),G.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",F,"Do not use.");const me=this._nextHandle(),we={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?ee._serializeRegExp(G.wordPattern):void 0,indentationRules:G.indentationRules?ee._serializeIndentationRule(G.indentationRules):void 0,onEnterRules:G.onEnterRules?ee._serializeOnEnterRules(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport};return this._proxy.$setLanguageConfiguration(me,H,we),this._createDisposable(me)}$setWordDefinitions(F){for(const H of F)this._documents.setWordDefinitionFor(H.languageId,new RegExp(H.regexSource,H.regexFlags))}}e.ExtHostLanguageFeatures=ee,ee._handlePool=0}),define(De[249],Ie([1,0,5,13,7,41,18,6]),function(J,e,l,t,C,P,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class b{constructor(L,k,S,T){this._documents=k,this._commands=S,this._uriTransformer=T,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=L.getProxy(l.MainContext.MainThreadLanguages)}$acceptLanguageIds(L){this._languageIds=L}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(L,k){await this._proxy.$changeLanguage(L,k);const S=this._documents.getDocumentData(L);if(!S)throw new Error(`document '${L.toString()}' NOT found`);return S.document}async tokenAtPosition(L,k){const S=L.version,T=t.Position.from(k),E=await this._proxy.$tokensAtPosition(L.uri,T),p={type:C.StandardTokenType.Other,range:L.getWordRangeAtPosition(k)??new C.Range(k.line,k.character,k.line,k.character)};if(!E)return p;const w={range:t.Range.to(E.range),type:t.TokenType.to(E.type)};return!w.range.contains(k)||S!==L.version?p:w}createLanguageStatusItem(L,k,S){const T=this._handlePool++,E=this._proxy,p=this._ids,w=`${L.identifier.value}/${k}`;if(p.has(w))throw new Error(`LanguageStatusItem with id '${k}' ALREADY exists`);p.add(w);const f={selector:S,id:k,name:L.displayName??L.name,severity:C.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let v;const m=new D.DisposableStore,a=()=>{v?.dispose(),v=(0,_.disposableTimeout)(()=>{m.clear(),this._proxy.$setLanguageStatus(T,{id:w,name:f.name??L.displayName??L.name,source:L.displayName??L.name,selector:t.DocumentSelector.from(f.selector,this._uriTransformer),label:f.text,detail:f.detail??"",severity:f.severity===C.LanguageStatusSeverity.Error?P.default.Error:f.severity===C.LanguageStatusSeverity.Warning?P.default.Warning:P.default.Info,command:f.command&&this._commands.toInternal(f.command,m),accessibilityInfo:f.accessibilityInformation,busy:f.busy})},0)},g={dispose(){m.dispose(),v?.dispose(),E.$removeLanguageStatus(T),p.delete(w)},get id(){return f.id},get name(){return f.name},set name(n){f.name=n,a()},get selector(){return f.selector},set selector(n){f.selector=n,a()},get text(){return f.text},set text(n){f.text=n,a()},get detail(){return f.detail},set detail(n){f.detail=n,a()},get severity(){return f.severity},set severity(n){f.severity=n,a()},get accessibilityInformation(){return f.accessibilityInformation},set accessibilityInformation(n){f.accessibilityInformation=n,a()},get command(){return f.command},set command(n){f.command=n,a()},get busy(){return f.busy},set busy(n){f.busy=n,a()}};return a(),g}}e.ExtHostLanguages=b}),define(De[136],Ie([1,0,15,5,26,16,4]),function(J,e,l,t,C,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let D=class extends l.AbstractLoggerService{constructor(L,k){const S=new _.Emitter;super(k.logLevel,S.event),this._proxy=L.getProxy(t.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(S)}$setLevel(L){this._onDidChangeLogLevel.fire(L)}doCreateLogger(L,k,S){return new b(this._proxy,L,k,S)}};D=qe([xe(0,P.IExtHostRpcService),xe(1,C.IExtHostInitDataService)],D),e.ExtHostLoggerService=D;class b extends l.AbstractMessageLogger{constructor(L,k,S,T){super(T?.always),this.proxy=L,this.file=k,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(S),this.proxy.$createLogger(k,T).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(L,k){const S=[[L,k]];this.isLoggerCreated?this.doLog(S):this.buffer.push(...S)}doLog(L){this.proxy.$log(this.file,L)}}}),define(De[250],Ie([1,0,5,15,27]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function P(D){return D&&D.title}let _=class{constructor(b,I){this._logService=I,this._proxy=b.getProxy(l.MainContext.MainThreadMessageService)}showMessage(b,I,L,k,S){const T={source:{identifier:b.identifier,label:b.displayName||b.name}};let E;typeof k=="string"||P(k)?E=[k,...S]:(T.modal=k?.modal,T.useCustom=k?.useCustom,T.detail=k?.detail,E=S),T.useCustom&&(0,C.checkProposedApiEnabled)(b,"resolvers");const p=[];for(let w=0;w<E.length;w++){const f=E[w];if(typeof f=="string")p.push({title:f,handle:w,isCloseAffordance:!1});else if(typeof f=="object"){const{title:v,isCloseAffordance:m}=f;p.push({title:v,isCloseAffordance:!!m,handle:w})}else this._logService.warn("Invalid message item:",f)}return this._proxy.$showMessage(I,L,T,p).then(w=>{if(typeof w=="number")return E[w]})}};_=qe([xe(1,t.ILogService)],_),e.ExtHostMessageService=_}),define(De[251],Ie([1,0,23,4,6,25,8,14,2,87,5,37,13,7,55,226,132]),function(J,e,l,t,C,P,_,D,b,I,L,k,S,T,E,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class f{constructor(m,a,g,n){this._textDocumentsAndEditors=g,this._textDocuments=n,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new P.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new t.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new t.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new t.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new t.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new I.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=m.getProxy(L.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=m.getProxy(L.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=m.getProxy(L.MainContext.MainThreadNotebookEditors),this._commandsConverter=a.converter,a.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===12){const s=d.notebookEditor?.notebookUri,i=d.cell.handle,c=this._documents.get(s)?.getCell(i);if(c)return c.apiCell}return d}}),f._registerApiCommands(a)}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(m=>m.apiEditor)}getEditorById(m){const a=this._editors.get(m);if(!a)throw new Error(`unknown text editor: ${m}. known editors: ${[...this._editors.keys()]} `);return a}getIdByEditor(m){for(const[a,g]of this._editors)if(g.apiEditor===m)return a}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(m,a){const g=this._documents.get(m);if(!g&&!a)throw new Error(`NO notebook document for '${m}'`);return g}_getProviderData(m){const a=this._notebookContentProviders.get(m);if(!a)throw new Error(`NO provider for '${m}'`);return a}registerNotebookContentProvider(m,a,g,n,d){if((0,_.isFalsyOrWhitespace)(a))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(a))throw new Error(`Notebook provider for '${a}' already registered`);return this._notebookContentProviders.set(a,{extension:m,provider:g}),this._notebookProxy.$registerNotebookProvider({id:m.identifier,location:m.extensionLocation},a,S.NotebookDocumentContentOptions.from(n),f._convertNotebookRegistrationData(m,d)),new T.Disposable(()=>{this._notebookContentProviders.delete(a),this._notebookProxy.$unregisterNotebookProvider(a)})}static _convertNotebookRegistrationData(m,a){if(!a)return;const g=a.filenamePattern.map(n=>S.NotebookExclusiveDocumentPattern.from(n)).filter(n=>n!==void 0);if(a.filenamePattern&&!g){console.warn(`Notebook content provider view options file name pattern is invalid ${a.filenamePattern}`);return}return{extension:m.identifier,providerDisplayName:m.displayName||m.name,displayName:a.displayName,filenamePattern:g,exclusive:a.exclusive||!1}}registerNotebookCellStatusBarItemProvider(m,a,g){const n=f._notebookStatusBarItemProviderHandlePool++,d=typeof g.onDidChangeCellStatusBarItems=="function"?f._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(n,g),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(n,d,a);let s;return d!==void 0&&(s=g.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(d))),new T.Disposable(()=>{this._notebookStatusBarItemProviders.delete(n),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(n,d),s?.dispose()})}async createNotebookDocument(m){const a=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:m.viewType,content:m.content&&S.NotebookData.from(m.content)});return b.URI.revive(a)}async openNotebookDocument(m){const a=this._documents.get(m);if(a)return a.apiNotebook;const g=await this._notebookDocumentsProxy.$tryOpenNotebook(m),n=this._documents.get(b.URI.revive(g));return(0,D.assertIsDefined)(n?.apiNotebook)}async showNotebookDocument(m,a){b.URI.isUri(m)&&(m=await this.openNotebookDocument(m));let g;typeof a=="object"?g={position:S.ViewColumn.from(a.viewColumn),preserveFocus:a.preserveFocus,selections:a.selections&&a.selections.map(S.NotebookRange.from),pinned:typeof a.preview=="boolean"?!a.preview:void 0}:g={preserveFocus:!1};const n=await this._notebookEditorsProxy.$tryShowNotebookDocument(m.uri,m.notebookType,g),d=n&&this._editors.get(n)?.apiEditor;if(d)return d;throw n?new Error(`Could NOT open editor for "${m.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${m.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(m,a,g,n){const d=this._notebookStatusBarItemProviders.get(m),s=b.URI.revive(a),i=this._documents.get(s);if(!i||!d)return;const r=i.getCellFromIndex(g);if(!r)return;const c=await d.provideCellStatusBarItems(r.apiCell,n);if(!c)return;const o=new C.DisposableStore,u=this._statusBarCache.add([o]),y=(Array.isArray(c)?c:[c]).map(R=>S.NotebookStatusBarItem.from(R,this._commandsConverter,o));return{cacheId:u,items:y}}$releaseNotebookCellStatusBarItems(m){this._statusBarCache.delete(m)}registerNotebookSerializer(m,a,g,n,d){if((0,_.isFalsyOrWhitespace)(a))throw new Error("viewType cannot be empty or just whitespace");const s=this._handlePool++;return this._notebookSerializer.set(s,g),this._notebookProxy.$registerNotebookSerializer(s,{id:m.identifier,location:m.extensionLocation},a,S.NotebookDocumentContentOptions.from(n),f._convertNotebookRegistrationData(m,d)),(0,C.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(s)})}async $dataToNotebook(m,a,g){const n=this._notebookSerializer.get(m);if(!n)throw new Error("NO serializer found");const d=await n.deserializeNotebook(a.buffer,g);return new E.SerializableObjectWithBuffers(S.NotebookData.from(d))}async $notebookToData(m,a,g){const n=this._notebookSerializer.get(m);if(!n)throw new Error("NO serializer found");const d=await n.serializeNotebook(S.NotebookData.to(a.value),g);return l.VSBuffer.wrap(d)}async $openNotebook(m,a,g,n,d){const{provider:s}=this._getProviderData(m),i=await s.openNotebook(b.URI.revive(a),{backupId:g,untitledDocumentData:n?.buffer},d);return new E.SerializableObjectWithBuffers({metadata:i.metadata??Object.create(null),cells:i.cells.map(S.NotebookCellData.from)})}_createExtHostEditor(m,a,g){if(this._editors.has(a))throw new Error(`editor with id ALREADY EXSIST: ${a}`);const n=new w.ExtHostNotebookEditor(a,this._notebookEditorsProxy,m,g.visibleRanges.map(S.NotebookRange.to),g.selections.map(S.NotebookRange.to),typeof g.viewColumn=="number"?S.ViewColumn.to(g.viewColumn):void 0);this._editors.set(a,n)}$acceptDocumentAndEditorsDelta(m){if(m.value.removedDocuments)for(const g of m.value.removedDocuments){const n=b.URI.revive(g),d=this._documents.get(n);d&&(d.dispose(),this._documents.delete(n),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:d.apiNotebook.getCells().map(s=>s.document.uri)}),this._onDidCloseNotebookDocument.fire(d.apiNotebook));for(const s of this._editors.values())s.notebookData.uri.toString()===n.toString()&&this._editors.delete(s.id)}if(m.value.addedDocuments){const g=[];for(const n of m.value.addedDocuments){const d=b.URI.revive(n.uri);if(this._documents.has(d))throw new Error(`adding EXISTING notebook ${d} `);const s=new p.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,d,n);g.push(...n.cells.map(i=>p.ExtHostCell.asModelAddData(s.apiNotebook,i))),this._documents.get(d)?.dispose(),this._documents.set(d,s),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:g}),this._onDidOpenNotebookDocument.fire(s.apiNotebook)}}if(m.value.addedEditors)for(const g of m.value.addedEditors){if(this._editors.has(g.id))return;const n=b.URI.revive(g.documentUri),d=this._documents.get(n);d&&this._createExtHostEditor(d,g.id,g)}const a=[];if(m.value.removedEditors)for(const g of m.value.removedEditors){const n=this._editors.get(g);n&&(this._editors.delete(g),this._activeNotebookEditor?.id===n.id&&(this._activeNotebookEditor=void 0),a.push(n))}if(m.value.visibleEditors){this._visibleNotebookEditors=m.value.visibleEditors.map(n=>this._editors.get(n)).filter(n=>!!n);const g=new Set;this._visibleNotebookEditors.forEach(n=>g.add(n.id));for(const n of this._editors.values()){const d=g.has(n.id);n._acceptVisibility(d)}this._visibleNotebookEditors=[...this._editors.values()].map(n=>n).filter(n=>n.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}m.value.newActiveEditor===null?this._activeNotebookEditor=void 0:m.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(m.value.newActiveEditor)),m.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(m){const a=k.ApiCommandArgument.String.with("notebookType","A notebook type"),g=new k.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[a,new k.ApiCommandArgument("data","Bytes to convert to data",d=>d instanceof Uint8Array,d=>l.VSBuffer.wrap(d))],new k.ApiCommandResult("Notebook Data",d=>S.NotebookData.to(d.value))),n=new k.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[a,new k.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",d=>!0,d=>new E.SerializableObjectWithBuffers(S.NotebookData.from(d)))],new k.ApiCommandResult("Bytes",d=>d.buffer));m.registerApiCommand(g),m.registerApiCommand(n)}}e.ExtHostNotebookController=f,f._notebookStatusBarItemProviderHandlePool=0}),define(De[252],Ie([1,0,17,18,21,4,6,25,2,28,15,5,37,13,7,88,214,27,55]),function(J,e,l,t,C,P,_,D,b,I,L,k,S,T,E,p,w,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let m=class{constructor(i,r,c,o,u){this._initData=r,this._extHostNotebook=c,this._commands=o,this._logService=u,this._activeExecutions=new D.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new P.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=i.getProxy(k.MainContext.MainThreadNotebookKernels);const h=new S.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new S.ApiCommandArgument("options","Select kernel options",y=>!0,y=>{if(y&&"notebookEditor"in y&&"id"in y){const R=this._extHostNotebook.getIdByEditor(y.notebookEditor);return{id:y.id,extension:y.extension,notebookEditorId:R}}else if(y&&"notebookEditor"in y){const R=this._extHostNotebook.getIdByEditor(y.notebookEditor);if(R===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${y.notebookEditor.document.uri.toString()}`);return{notebookEditorId:R}}return y})],S.ApiCommandResult.Void);this._commands.registerApiCommand(h)}createNotebookController(i,r,c,o,u,h){for(const Y of this._kernelData.values())if(Y.controller.id===r&&I.ExtensionIdentifier.equals(i.identifier,Y.extensionId))throw new Error(`notebook controller with id '${r}' ALREADY exist`);const y=this._handlePool++,R=this;this._logService.trace(`NotebookController[${y}], CREATED by ${i.identifier.value}, ${r}`);const M=()=>console.warn(`NO execute handler from notebook controller '${N.id}' of extension: '${i.identifier}'`);let U=!1;const A=new _.DisposableStore,z=new P.Emitter,$=new P.Emitter,N={id:d(i.identifier,r),notebookType:c,extensionId:i.identifier,extensionLocation:i.extensionLocation,label:o||i.identifier.value,preloads:h?h.map(T.NotebookRendererScript.from):[]};let K=u??M,B;this._proxy.$addKernel(y,N).catch(Y=>{console.log(Y),U=!0});let O=0;const x=()=>{if(U)return;const Y=++O;Promise.resolve().then(()=>{Y===O&&this._proxy.$updateKernel(y,N)})},V=new D.ResourceMap,q={get id(){return r},get notebookType(){return N.notebookType},onDidChangeSelectedNotebooks:z.event,get label(){return N.label},set label(Y){N.label=Y??i.displayName??i.name,x()},get detail(){return N.detail??""},set detail(Y){N.detail=Y,x()},get description(){return N.description??""},set description(Y){N.description=Y,x()},get kind(){return(0,f.checkProposedApiEnabled)(i,"notebookControllerKind"),N.kind??""},set kind(Y){(0,f.checkProposedApiEnabled)(i,"notebookControllerKind"),N.kind=Y,x()},get supportedLanguages(){return N.supportedLanguages},set supportedLanguages(Y){N.supportedLanguages=Y,x()},get supportsExecutionOrder(){return N.supportsExecutionOrder??!1},set supportsExecutionOrder(Y){N.supportsExecutionOrder=Y,x()},get rendererScripts(){return N.preloads?N.preloads.map(T.NotebookRendererScript.to):[]},get executeHandler(){return K},set executeHandler(Y){K=Y??M},get interruptHandler(){return B},set interruptHandler(Y){B=Y,N.supportsInterrupt=Boolean(Y),x()},createNotebookCellExecution(Y){if(U)throw new Error("notebook controller is DISPOSED");if(!V.has(Y.notebook.uri))throw R._logService.trace(`NotebookController[${y}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(V.keys()).map(Q=>Q.toString())),new Error(`notebook controller is NOT associated to notebook: ${Y.notebook.uri.toString()}`);return R._createNotebookCellExecution(Y,d(i.identifier,this.id))},dispose:()=>{U||(this._logService.trace(`NotebookController[${y}], DISPOSED`),U=!0,this._kernelData.delete(y),A.dispose(),z.dispose(),$.dispose(),this._proxy.$removeKernel(y))},updateNotebookAffinity(Y,Q){R._proxy.$updateNotebookPriority(y,Y.uri,Q)},onDidReceiveMessage:$.event,postMessage(Y,Q){return(0,f.checkProposedApiEnabled)(i,"notebookMessaging"),R._proxy.$postMessage(y,Q&&R._extHostNotebook.getIdByEditor(Q),Y)},asWebviewUri(Y){return(0,f.checkProposedApiEnabled)(i,"notebookMessaging"),(0,p.asWebviewUri)(Y,R._initData.remote)}};return this._kernelData.set(y,{extensionId:i.identifier,controller:q,onDidReceiveMessage:$,onDidChangeSelection:z,associatedNotebooks:V}),q}getIdByController(i){for(const[r,c]of this._kernelData)if(c.controller===i)return d(c.extensionId,i.id);return null}$acceptNotebookAssociation(i,r,c){const o=this._kernelData.get(i);if(o){const u=this._extHostNotebook.getNotebookDocument(b.URI.revive(r));c?o.associatedNotebooks.set(u.uri,!0):o.associatedNotebooks.delete(u.uri),this._logService.trace(`NotebookController[${i}] ASSOCIATE notebook`,u.uri.toString(),c),o.onDidChangeSelection.fire({selected:c,notebook:u.apiNotebook})}}async $executeCells(i,r,c){const o=this._kernelData.get(i);if(!o)return;const u=this._extHostNotebook.getNotebookDocument(b.URI.revive(r)),h=[];for(const y of c){const R=u.getCell(y);R&&h.push(R.apiCell)}try{this._logService.trace(`NotebookController[${i}] EXECUTE cells`,u.uri.toString(),h.length),await o.controller.executeHandler.call(o.controller,h,u.apiNotebook,o.controller)}catch(y){this._logService.error(`NotebookController[${i}] execute cells FAILED`,y),console.error(y)}}async $cancelCells(i,r,c){const o=this._kernelData.get(i);if(!o)return;const u=this._extHostNotebook.getNotebookDocument(b.URI.revive(r));if(o.controller.interruptHandler)await o.controller.interruptHandler.call(o.controller,u.apiNotebook);else for(const h of c){const y=u.getCell(h);y&&this._activeExecutions.get(y.uri)?.cancel()}}$acceptKernelMessageFromRenderer(i,r,c){const o=this._kernelData.get(i);if(!o)return;const u=this._extHostNotebook.getEditorById(r);o.onDidReceiveMessage.fire(Object.freeze({editor:u.apiEditor,message:c}))}$cellExecutionChanged(i,r,c){const u=this._extHostNotebook.getNotebookDocument(b.URI.revive(i)).getCell(r);if(u){const h=c?T.NotebookCellExecutionState.to(c):E.NotebookCellExecutionState.Idle;h!==void 0&&this._onDidChangeCellExecutionState.fire({cell:u.apiCell,state:h})}}_createNotebookCellExecution(i,r){if(i.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const o=this._extHostNotebook.getNotebookDocument(i.notebook.uri).getCellFromApiCell(i);if(!o)throw new Error("invalid cell");if(this._activeExecutions.has(o.uri))throw new Error(`duplicate execution for ${o.uri}`);const u=new g(r,o,this._proxy);this._activeExecutions.set(o.uri,u);const h=u.onDidChangeState(()=>{u.state===a.Resolved&&(u.dispose(),h.dispose(),this._activeExecutions.delete(o.uri))});return u.asApiObject()}};m=qe([xe(4,L.ILogService)],m),e.ExtHostNotebookKernels=m;var a;(function(s){s[s.Init=0]="Init",s[s.Started=1]="Started",s[s.Resolved=2]="Resolved"})(a||(a={}));class g extends _.Disposable{constructor(i,r,c){super(),this._cell=r,this._proxy=c,this._handle=g.HANDLE++,this._onDidChangeState=new P.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=a.Init,this._tokenSource=this._register(new C.CancellationTokenSource),this._collector=new n(10,o=>this.update(o)),this._executionOrder=r.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,i,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(i){await this._collector.addItem(i)}async update(i){const r=Array.isArray(i)?i:[i];return this._proxy.$updateExecution(this._handle,new v.SerializableObjectWithBuffers(r))}verifyStateForOutput(){if(this._state===a.Init)throw new Error("Must call start before modifying cell output");if(this._state===a.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(i){let r=this._cell;if(i&&(r=this._cell.notebook.getCellFromApiCell(i)),!r)throw new Error("INVALID cell");return r.handle}validateAndConvertOutputs(i){return i.map(r=>{const c=E.NotebookCellOutput.ensureUniqueMimeTypes(r.items,!0);return c===r.items?T.NotebookCellOutput.from(r):T.NotebookCellOutput.from({items:c,id:r.id,metadata:r.metadata})})}async updateOutputs(i,r,c){const o=this.cellIndexToHandle(r),u=this.validateAndConvertOutputs((0,l.asArray)(i));return this.updateSoon({editType:w.CellExecutionUpdateType.Output,cellHandle:o,append:c,outputs:u})}async updateOutputItems(i,r,c){return i=E.NotebookCellOutput.ensureUniqueMimeTypes((0,l.asArray)(i),!0),this.updateSoon({editType:w.CellExecutionUpdateType.OutputItems,items:i.map(T.NotebookCellOutputItem.from),outputId:r.id,append:c})}asApiObject(){const i=this;return Object.freeze({get token(){return i._tokenSource.token},get cell(){return i._cell.apiCell},get executionOrder(){return i._executionOrder},set executionOrder(c){i._executionOrder=c,i.update([{editType:w.CellExecutionUpdateType.ExecutionState,executionOrder:i._executionOrder}])},start(c){if(i._state===a.Resolved||i._state===a.Started)throw new Error("Cannot call start again");i._state=a.Started,i._onDidChangeState.fire(),i.update({editType:w.CellExecutionUpdateType.ExecutionState,runStartTime:c})},end(c,o){if(i._state===a.Resolved)throw new Error("Cannot call resolve twice");i._state=a.Resolved,i._onDidChangeState.fire(),i._collector.flush(),i._proxy.$completeExecution(i._handle,new v.SerializableObjectWithBuffers({runEndTime:o,lastRunSuccess:c}))},clearOutput(c){return i.verifyStateForOutput(),i.updateOutputs([],c,!1)},appendOutput(c,o){return i.verifyStateForOutput(),i.updateOutputs(c,o,!0)},replaceOutput(c,o){return i.verifyStateForOutput(),i.updateOutputs(c,o,!1)},appendOutputItems(c,o){return i.verifyStateForOutput(),i.updateOutputItems(c,o,!0)},replaceOutputItems(c,o){return i.verifyStateForOutput(),i.updateOutputItems(c,o,!1)}})}}g.HANDLE=0;class n{constructor(i,r){this.delay=i,this.callback=r,this.batch=[],this.startedTimer=Date.now()}addItem(i){return this.batch.push(i),this.currentDeferred||(this.currentDeferred=new t.DeferredPromise,this.startedTimer=Date.now(),(0,t.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const i=this.currentDeferred;this.currentDeferred=void 0;const r=this.batch;return this.batch=[],this.callback(r).finally(()=>i.complete())}}function d(s,i){return`${s.value}/${i}`}e.createKernelId=d}),define(De[253],Ie([1,0,4,5,132]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class P{constructor(D,b){this._extHostNotebook=b,this._rendererMessageEmitters=new Map,this.proxy=D.getProxy(t.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(D,b,I){const L=this._extHostNotebook.getEditorById(D);this._rendererMessageEmitters.get(b)?.fire({editor:L.apiEditor,message:I})}createRendererMessaging(D,b){if(!D.contributes?.notebookRenderer?.some(L=>L.id===b))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${b})`);return{onDidReceiveMessage:(L,k,S)=>this.getOrCreateEmitterFor(b).event(L,k,S),postMessage:(L,k)=>{C.ExtHostNotebookEditor.apiEditorsToExtHost.has(L)&&([L,k]=[k,L]);const S=k&&C.ExtHostNotebookEditor.apiEditorsToExtHost.get(k);return this.proxy.$postMessage(S?.id,b,L)}}}getOrCreateEmitterFor(D){let b=this._rendererMessageEmitters.get(D);return b||(b=new l.Emitter({onLastListenerRemove:()=>{b?.dispose(),this._rendererMessageEmitters.delete(D)}}),this._rendererMessageEmitters.set(D,b),b)}}e.ExtHostNotebookRenderers=P}),define(De[254],Ie([1,0,21,4,6,5,2,7,10,17,41,86]),function(J,e,l,t,C,P,_,D,b,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function S(T,E,p){const w=T.getProxy(P.MainContext.MainThreadQuickOpen);class f{constructor(r,c){this._sessions=new Map,this._instances=0,this._workspace=r,this._commands=c}showQuickPick(r,c,o=l.CancellationToken.None){this._onDidSelectItem=void 0;const u=Promise.resolve(r),h=++this._instances,y=w.$show(h,{title:c?.title,placeHolder:c?.placeHolder,matchOnDescription:c?.matchOnDescription,matchOnDetail:c?.matchOnDetail,ignoreFocusLost:c?.ignoreFocusOut,canPickMany:c?.canPickMany},o),R={},M=y.then(()=>R);return Promise.race([M,u]).then(U=>{if(U!==R)return u.then(A=>{const z=[];for(let $=0;$<A.length;$++){const N=A[$];typeof N=="string"?z.push({label:N,handle:$}):N.kind===D.QuickPickItemKind.Separator?z.push({type:"separator",label:N.label}):z.push({label:N.label,description:N.description,detail:N.detail,picked:N.picked,alwaysShow:N.alwaysShow,handle:$})}return c&&typeof c.onDidSelectItem=="function"&&(this._onDidSelectItem=$=>{c.onDidSelectItem(A[$])}),w.$setItems(h,z),y.then($=>{if(typeof $=="number")return A[$];if(Array.isArray($))return $.map(N=>A[N])})})}).then(void 0,U=>{if(!(0,b.isCancellationError)(U))return w.$setError(h,U),Promise.reject(U)})}$onItemSelected(r){this._onDidSelectItem?.(r)}showInput(r,c=l.CancellationToken.None){return this._validateInput=r?.validateInput,w.$input(r,typeof this._validateInput=="function",c).then(void 0,o=>{if(!(0,b.isCancellationError)(o))return Promise.reject(o)})}async $validateInput(r){if(!this._validateInput)return;const c=await this._validateInput(r);if(!c||typeof c=="string")return c;let o;switch(c.severity){case D.InputBoxValidationSeverity.Info:o=L.default.Info;break;case D.InputBoxValidationSeverity.Warning:o=L.default.Warning;break;case D.InputBoxValidationSeverity.Error:o=L.default.Error;break;default:o=c.message?L.default.Error:L.default.Ignore;break}return{content:c.message,severity:o}}async showWorkspaceFolderPick(r,c=l.CancellationToken.None){const o=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[r]);if(!o)return;const u=await this._workspace.getWorkspaceFolders2();if(!!u)return u.find(h=>h.uri.toString()===o.uri.toString())}createQuickPick(r){const c=new d(r,()=>this._sessions.delete(c._id));return this._sessions.set(c._id,c),c}createInputBox(r){const c=new s(r,()=>this._sessions.delete(c._id));return this._sessions.set(c._id,c),c}$onDidChangeValue(r,c){this._sessions.get(r)?._fireDidChangeValue(c)}$onDidAccept(r){this._sessions.get(r)?._fireDidAccept()}$onDidChangeActive(r,c){const o=this._sessions.get(r);o instanceof d&&o._fireDidChangeActive(c)}$onDidChangeSelection(r,c){const o=this._sessions.get(r);o instanceof d&&o._fireDidChangeSelection(c)}$onDidTriggerButton(r,c){this._sessions.get(r)?._fireDidTriggerButton(c)}$onDidTriggerItemButton(r,c,o){const u=this._sessions.get(r);u instanceof d&&u._fireDidTriggerItemButton(c,o)}$onDidHide(r){this._sessions.get(r)?._fireDidHide()}}class v{constructor(r,c){this._extensionId=r,this._onDidDispose=c,this._id=d._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new t.Emitter,this._onDidChangeValueEmitter=new t.Emitter,this._onDidTriggerButtonEmitter=new t.Emitter,this._onDidHideEmitter=new t.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(r){this._title=r,this.update({title:r})}get step(){return this._steps}set step(r){this._steps=r,this.update({step:r})}get totalSteps(){return this._totalSteps}set totalSteps(r){this._totalSteps=r,this.update({totalSteps:r})}get enabled(){return this._enabled}set enabled(r){this._enabled=r,this.update({enabled:r})}get busy(){return this._busy}set busy(r){this._busy=r,this.update({busy:r})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(r){this._ignoreFocusOut=r,this.update({ignoreFocusOut:r})}get value(){return this._value}set value(r){this._value=r,this.update({value:r})}get placeholder(){return this._placeholder}set placeholder(r){this._placeholder=r,this.update({placeholder:r})}get buttons(){return this._buttons}set buttons(r){this._buttons=r.slice(),this._handlesToButtons.clear(),r.forEach((c,o)=>{const u=c===D.QuickInputButtons.Back?-1:o;this._handlesToButtons.set(u,c)}),this.update({buttons:r.map((c,o)=>({...n(c),tooltip:c.tooltip,handle:c===D.QuickInputButtons.Back?-1:o}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(r){this._value=r,this._onDidChangeValueEmitter.fire(r)}_fireDidTriggerButton(r){const c=this._handlesToButtons.get(r);c&&this._onDidTriggerButtonEmitter.fire(c)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,C.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),w.$dispose(this._id))}update(r){if(!this._disposed){for(const c of Object.keys(r)){const o=r[c];this._pendingUpdate[c]=o===void 0?null:o}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){w.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}v._nextId=1;function m(i){if(i instanceof D.ThemeIcon)return{id:i.id};const r=g(i),c=a(i);return{dark:typeof r=="string"?_.URI.file(r):r,light:typeof c=="string"?_.URI.file(c):c}}function a(i){return typeof i=="object"&&"light"in i?i.light:i}function g(i){return typeof i=="object"&&"dark"in i?i.dark:i}function n(i){const r=m(i.iconPath);let c,o;return"id"in r?o=k.ThemeIcon.asClassName(r):c=r,{iconPath:c,iconClass:o}}class d extends v{constructor(r,c){super(r.identifier,c),this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new t.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new t.Emitter,this._onDidTriggerItemButtonEmitter=new t.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(r){this._items=r.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),r.forEach((o,u)=>{this._handlesToItems.set(u,o),this._itemsToHandles.set(o,u)});const c=[];for(let o=0;o<r.length;o++){const u=r[o];u.kind===D.QuickPickItemKind.Separator?c.push({type:"separator",label:u.label}):c.push({handle:o,label:u.label,description:u.description,detail:u.detail,picked:u.picked,alwaysShow:u.alwaysShow,buttons:u.buttons?.map((h,y)=>({...n(h),tooltip:h.tooltip,handle:y}))})}this.update({items:c})}get canSelectMany(){return this._canSelectMany}set canSelectMany(r){this._canSelectMany=r,this.update({canSelectMany:r})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(r){this._matchOnDescription=r,this.update({matchOnDescription:r})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(r){this._matchOnDetail=r,this.update({matchOnDetail:r})}get sortByLabel(){return this._sortByLabel}set sortByLabel(r){this._sortByLabel=r,this.update({sortByLabel:r})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(r){this._keepScrollPosition=r,this.update({keepScrollPosition:r})}get activeItems(){return this._activeItems}set activeItems(r){this._activeItems=r.filter(c=>this._itemsToHandles.has(c)),this.update({activeItems:this._activeItems.map(c=>this._itemsToHandles.get(c))})}get selectedItems(){return this._selectedItems}set selectedItems(r){this._selectedItems=r.filter(c=>this._itemsToHandles.has(c)),this.update({selectedItems:this._selectedItems.map(c=>this._itemsToHandles.get(c))})}_fireDidChangeActive(r){const c=(0,I.coalesce)(r.map(o=>this._handlesToItems.get(o)));this._activeItems=c,this._onDidChangeActiveEmitter.fire(c)}_fireDidChangeSelection(r){const c=(0,I.coalesce)(r.map(o=>this._handlesToItems.get(o)));this._selectedItems=c,this._onDidChangeSelectionEmitter.fire(c)}_fireDidTriggerItemButton(r,c){const o=this._handlesToItems.get(r);if(!o||!o.buttons||!o.buttons.length)return;const u=o.buttons[c];u&&this._onDidTriggerItemButtonEmitter.fire({button:u,item:o})}}class s extends v{constructor(r,c){super(r.identifier,c),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(r){this._password=r,this.update({password:r})}get prompt(){return this._prompt}set prompt(r){this._prompt=r,this.update({prompt:r})}get validationMessage(){return this._validationMessage}set validationMessage(r){this._validationMessage=r,r?typeof r=="string"?this.update({validationMessage:r,severity:L.default.Error}):this.update({validationMessage:r.message,severity:r.severity??L.default.Error}):this.update({validationMessage:void 0,severity:L.default.Ignore})}}return new f(E,p)}e.createExtHostQuickOpen=S});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,C){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?C.call(J,l):C?C.value=l:e.set(J,l),l},Ue=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[255],Ie([1,0,2,4,58,6,18,5,17,104,15,28,86,13,27]),function(J,e,l,t,C,P,_,D,b,I,L,k,S,T,E){"use strict";var p,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function f(u){if(u)return typeof u.iconPath=="string"?l.URI.file(u.iconPath):l.URI.isUri(u.iconPath)||S.ThemeIcon.isThemeIcon(u.iconPath)?u.iconPath:void 0}function v(u,h){if(!u.iconPath&&!h.iconPath)return 0;if(u.iconPath){if(!h.iconPath)return 1}else return-1;const y=typeof u.iconPath=="string"?u.iconPath:l.URI.isUri(u.iconPath)?u.iconPath.fsPath:u.iconPath.id,R=typeof h.iconPath=="string"?h.iconPath:l.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id;return(0,I.comparePaths)(y,R)}function m(u,h){let y=0;if(u.strikeThrough!==h.strikeThrough)return u.strikeThrough?1:-1;if(u.faded!==h.faded)return u.faded?1:-1;if(u.tooltip!==h.tooltip)return(u.tooltip||"").localeCompare(h.tooltip||"");if(y=v(u,h),y!==0)return y;if(u.light&&h.light)y=v(u.light,h.light);else{if(u.light)return 1;if(h.light)return-1}if(y!==0)return y;if(u.dark&&h.dark)y=v(u.dark,h.dark);else{if(u.dark)return 1;if(h.dark)return-1}return y}function a(u,h){if(u.command!==h.command)return u.command<h.command?-1:1;if(u.title!==h.title)return u.title<h.title?-1:1;if(u.tooltip!==h.tooltip){if(u.tooltip!==void 0&&h.tooltip!==void 0)return u.tooltip<h.tooltip?-1:1;if(u.tooltip!==void 0)return 1;if(h.tooltip!==void 0)return-1}if(u.arguments===h.arguments)return 0;if(u.arguments)if(h.arguments){if(u.arguments.length!==h.arguments.length)return u.arguments.length-h.arguments.length}else return 1;else return-1;for(let y=0;y<u.arguments.length;y++){const R=u.arguments[y],M=h.arguments[y];if(R!==M)return R<M?-1:1}return 0}function g(u,h){let y=(0,I.comparePaths)(u.resourceUri.fsPath,h.resourceUri.fsPath,!0);if(y!==0)return y;if(u.command&&h.command)y=a(u.command,h.command);else{if(u.command)return 1;if(h.command)return-1}if(y!==0)return y;if(u.decorations&&h.decorations)y=m(u.decorations,h.decorations);else{if(u.decorations)return 1;if(h.decorations)return-1}return y}function n(u,h){for(let y=0;y<u.length;y++)if(u[y]!==h[y])return!1;return!0}function d(u,h){return u.command===h.command&&u.title===h.title&&u.tooltip===h.tooltip&&(u.arguments&&h.arguments?n(u.arguments,h.arguments):u.arguments===h.arguments)}function s(u,h){return(0,b.equals)(u,h,d)}class i{constructor(h,y,R){this._extension=h,this._sourceControlHandle=R,p.set(this,void 0),this._value="",this._onDidChange=new t.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,tt(this,p,y,"f")}get value(){return this._value}set value(h){h=h??"",Ue(this,p,"f").$setInputBoxValue(this._sourceControlHandle,h),this.updateValue(h)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(h){Ue(this,p,"f").$setInputBoxPlaceholder(this._sourceControlHandle,h),this._placeholder=h}get validateInput(){return(0,E.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(h){if((0,E.checkProposedApiEnabled)(this._extension,"scmValidation"),h&&typeof h!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=h,Ue(this,p,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!h)}get enabled(){return this._enabled}set enabled(h){h=!!h,this._enabled!==h&&(this._enabled=h,Ue(this,p,"f").$setInputBoxEnablement(this._sourceControlHandle,h))}get visible(){return this._visible}set visible(h){h=!!h,this._visible!==h&&(this._visible=h,Ue(this,p,"f").$setInputBoxVisibility(this._sourceControlHandle,h))}showValidationMessage(h,y){(0,E.checkProposedApiEnabled)(this._extension,"scmValidation"),Ue(this,p,"f").$showValidationMessage(this._sourceControlHandle,h,y)}$onInputBoxValueChange(h){this.updateValue(h)}updateValue(h){this._value=h,this._onDidChange.fire(h)}}e.ExtHostSCMInputBox=i,p=new WeakMap;class r{constructor(h,y,R,M,U){this._proxy=h,this._commands=y,this._sourceControlHandle=R,this._id=M,this._label=U,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new t.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(h){this._label=h,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,h)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(h){this._hideWhenEmpty=h,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(h){this._resourceStates=[...h],this._onDidUpdateResourceStates.fire()}getResourceState(h){return this._resourceStatesMap.get(h)}$executeResourceCommand(h,y){const R=this._resourceStatesCommandsMap.get(h);return R?(0,_.asPromise)(()=>this._commands.executeCommand(R.command,...R.arguments||[],y)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const h=[...this._resourceStates].sort(g),R=(0,b.sortedDiff)(this._resourceSnapshot,h,g).map(A=>{const z=A.toInsert.map($=>{const N=this._resourceHandlePool++;this._resourceStatesMap.set(N,$);const K=$.resourceUri;let B;if($.command)if($.command.command==="vscode.open"||$.command.command==="vscode.diff"){const pe=new P.DisposableStore;B=this._commands.converter.toInternal($.command,pe),this._resourceStatesDisposablesMap.set(N,pe)}else this._resourceStatesCommandsMap.set(N,$.command);const O=f($.decorations),x=$.decorations&&f($.decorations.light)||O,V=$.decorations&&f($.decorations.dark)||O,q=[x,V],Y=$.decorations&&$.decorations.tooltip||"",Q=$.decorations&&!!$.decorations.strikeThrough,de=$.decorations&&!!$.decorations.faded,ve=$.contextValue||"";return{rawResource:[N,K,q,Y,Q,de,ve,B],handle:N}});return{start:A.start,deleteCount:A.deleteCount,toInsert:z}}),M=R.map(({start:A,deleteCount:z,toInsert:$})=>[A,z,$.map(N=>N.rawResource)]),U=R.reverse();for(const{start:A,deleteCount:z,toInsert:$}of U){const N=$.map(B=>B.handle),K=this._handlesSnapshot.splice(A,z,...N);for(const B of K)this._resourceStatesMap.delete(B),this._resourceStatesCommandsMap.delete(B),this._resourceStatesDisposablesMap.get(B)?.dispose(),this._resourceStatesDisposablesMap.delete(B)}return this._resourceSnapshot=h,M}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class c{constructor(h,y,R,M,U,A){this._extension=h,this._commands=R,this._id=M,this._label=U,this._rootUri=A,w.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new P.MutableDisposable,this._statusBarDisposables=new P.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new t.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=c._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,tt(this,w,y,"f"),this._inputBox=new i(h,Ue(this,w,"f"),this.handle),Ue(this,w,"f").$registerSourceControl(this.handle,M,U,A)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(h){this._count!==h&&(this._count=h,Ue(this,w,"f").$updateSourceControl(this.handle,{count:h}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(h){this._quickDiffProvider=h,Ue(this,w,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!h})}get commitTemplate(){return this._commitTemplate}set commitTemplate(h){h!==this._commitTemplate&&(this._commitTemplate=h,Ue(this,w,"f").$updateSourceControl(this.handle,{commitTemplate:h}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(h){this._acceptInputDisposables.value=new P.DisposableStore,this._acceptInputCommand=h;const y=this._commands.converter.toInternal(h,this._acceptInputDisposables.value);Ue(this,w,"f").$updateSourceControl(this.handle,{acceptInputCommand:y})}get actionButton(){return(0,E.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(h){(0,E.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new P.DisposableStore,this._actionButton=h;const y=h!==void 0?{command:this._commands.converter.toInternal(h.command,this._actionButtonDisposables.value),secondaryCommands:h.secondaryCommands?.map(R=>R.map(M=>this._commands.converter.toInternal(M,this._actionButtonDisposables.value))),description:h.description,enabled:h.enabled}:void 0;Ue(this,w,"f").$updateSourceControl(this.handle,{actionButton:y??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(h){if(this._statusBarCommands&&h&&s(this._statusBarCommands,h))return;this._statusBarDisposables.value=new P.DisposableStore,this._statusBarCommands=h;const y=(h||[]).map(R=>this._commands.converter.toInternal(R,this._statusBarDisposables.value));Ue(this,w,"f").$updateSourceControl(this.handle,{statusBarCommands:y})}get selected(){return this._selected}createResourceGroup(h,y){const R=new r(Ue(this,w,"f"),this._commands,this.handle,h,y),M=t.Event.once(R.onDidDispose)(()=>this.createdResourceGroups.delete(R));return this.createdResourceGroups.set(R,M),this.eventuallyAddResourceGroups(),R}eventuallyAddResourceGroups(){const h=[],y=[];for(const[R,M]of this.createdResourceGroups){M.dispose();const U=R.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(R),this.eventuallyUpdateResourceStates()});t.Event.once(R.onDidDispose)(()=>{this.updatedResourceGroups.delete(R),U.dispose(),this._groups.delete(R.handle),Ue(this,w,"f").$unregisterGroup(this.handle,R.handle)}),h.push([R.handle,R.id,R.label,R.features]);const A=R._takeResourceStateSnapshot();A.length>0&&y.push([R.handle,A]),this._groups.set(R.handle,R)}Ue(this,w,"f").$registerGroups(this.handle,h,y),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const h=[];this.updatedResourceGroups.forEach(y=>{const R=y._takeResourceStateSnapshot();R.length!==0&&h.push([y.handle,R])}),h.length>0&&Ue(this,w,"f").$spliceResourceStates(this.handle,h),this.updatedResourceGroups.clear()}getResourceGroup(h){return this._groups.get(h)}setSelectionState(h){this._selected=h,this._onDidChangeSelection.fire(h)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(h=>h.dispose()),Ue(this,w,"f").$unregisterSourceControl(this.handle)}}w=new WeakMap,c._handlePool=0,qe([(0,C.debounce)(100)],c.prototype,"eventuallyAddResourceGroups",null),qe([(0,C.debounce)(100)],c.prototype,"eventuallyUpdateResourceStates",null);let o=class Jn{constructor(h,y,R){this._commands=y,this.logService=R,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new t.Emitter,this._proxy=h.getProxy(D.MainContext.MainThreadSCM),this._telemetry=h.getProxy(D.MainContext.MainThreadTelemetry),y.registerArgumentProcessor({processArgument:M=>{if(M&&M.$mid===3){const U=this._sourceControls.get(M.sourceControlHandle);if(!U)return M;const A=U.getResourceGroup(M.groupHandle);return A?A.getResourceState(M.handle):M}else if(M&&M.$mid===4){const U=this._sourceControls.get(M.sourceControlHandle);return U?U.getResourceGroup(M.groupHandle):M}else if(M&&M.$mid===5){const U=this._sourceControls.get(M.handle);return U||M}return M}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(h,y,R,M){this.logService.trace("ExtHostSCM#createSourceControl",h.identifier.value,y,R,M),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:h.identifier.value});const U=Jn._handlePool++,A=new c(h,this._proxy,this._commands,y,R,M);this._sourceControls.set(U,A);const z=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(h.identifier))||[];return z.push(A),this._sourceControlsByExtension.set(k.ExtensionIdentifier.toKey(h.identifier),z),A}getLastInputBox(h){this.logService.trace("ExtHostSCM#getLastInputBox",h.identifier.value);const y=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(h.identifier)),R=y&&y[y.length-1];return R&&R.inputBox}$provideOriginalResource(h,y,R){const M=l.URI.revive(y);this.logService.trace("ExtHostSCM#$provideOriginalResource",h,M.toString());const U=this._sourceControls.get(h);return!U||!U.quickDiffProvider||!U.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,_.asPromise)(()=>U.quickDiffProvider.provideOriginalResource(M,R)).then(A=>A||null)}$onInputBoxValueChange(h,y){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",h);const R=this._sourceControls.get(h);return R&&R.inputBox.$onInputBoxValueChange(y),Promise.resolve(void 0)}$executeResourceCommand(h,y,R,M){this.logService.trace("ExtHostSCM#$executeResourceCommand",h,y,R);const U=this._sourceControls.get(h);if(!U)return Promise.resolve(void 0);const A=U.getResourceGroup(y);return A?A.$executeResourceCommand(R,M):Promise.resolve(void 0)}$validateInput(h,y,R){this.logService.trace("ExtHostSCM#$validateInput",h);const M=this._sourceControls.get(h);return!M||!M.inputBox.validateInput?Promise.resolve(void 0):(0,_.asPromise)(()=>M.inputBox.validateInput(y,R)).then(U=>{if(!U)return Promise.resolve(void 0);const A=T.MarkdownString.fromStrict(U.message);return A?Promise.resolve([A,U.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(h){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",h),h!==void 0&&this._sourceControls.get(h)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=h,Promise.resolve(void 0)}};o._handlePool=0,o=qe([xe(2,L.ILogService)],o),e.ExtHostSCM=o}),define(De[91],Ie([1,0,5,4,3]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class P{constructor(D){this._onDidChangePassword=new t.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=D.getProxy(l.MainContext.MainThreadSecretState)}async $onDidChangePassword(D){this._onDidChangePassword.fire(D)}get(D,b){return this._proxy.$getPassword(D,b)}store(D,b,I){return this._proxy.$setPassword(D,b,I)}delete(D,b){return this._proxy.$deletePassword(D,b)}}e.ExtHostSecretState=P,e.IExtHostSecretState=(0,C.createDecorator)("IExtHostSecretState")});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,C){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?C.call(J,l):C?C.value=l:e.set(J,l),l},Ue=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[256],Ie([1,0,7,5,172,6,13,14]),function(J,e,l,t,C,P,_,D){"use strict";var b,I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class L{constructor(E,p,w,f,v=l.StatusBarAlignment.Left,m){b.set(this,void 0),I.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new P.DisposableStore,tt(this,b,E,"f"),tt(this,I,p,"f"),this._entryId=L.ID_GEN++,this._extension=w,this._id=f,this._alignment=v,this._priority=this.validatePriority(m)}validatePriority(E){if(!!(0,D.isNumber)(E))return E===Number.POSITIVE_INFINITY?Number.MAX_VALUE:E===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:E}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(E){this._text=E,this.update()}set name(E){this._name=E,this.update()}set tooltip(E){this._tooltip=E,this.update()}set color(E){this._color=E,this.update()}set backgroundColor(E){E&&!L.ALLOWED_BACKGROUND_COLORS.has(E.id)&&(E=void 0),this._backgroundColor=E,this.update()}set command(E){this._command?.fromApi!==E&&(this._internalCommandRegistration.clear(),typeof E=="string"?this._command={fromApi:E,internal:Ue(this,I,"f").toInternal({title:"",command:E},this._internalCommandRegistration)}:E?this._command={fromApi:E,internal:Ue(this,I,"f").toInternal(E,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(E){this._accessibilityInformation=E,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ue(this,b,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let E;this._extension?this._id?E=`${this._extension.identifier.value}.${this._id}`:E=this._extension.identifier.value:E=this._id;let p;this._name?p=this._name:p=(0,C.localize)(0,null,this._extension.displayName||this._extension.name);let w=this._color;this._backgroundColor&&(w=L.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const f=_.MarkdownString.fromStrict(this._tooltip);Ue(this,b,"f").$setEntry(this._entryId,E,p,this._text,f,this._command?.internal,w,this._backgroundColor,this._alignment===l.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=L,b=new WeakMap,I=new WeakMap,L.ID_GEN=0,L.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new l.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new l.ThemeColor("statusBarItem.warningForeground")]]);class k{constructor(E){this._messages=[],this._item=E.createStatusBarEntry(void 0,"status.extensionMessage",l.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,C.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(E){const p={message:E};return this._messages.unshift(p),this._update(),new l.Disposable(()=>{const w=this._messages.indexOf(p);w>=0&&(this._messages.splice(w,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class S{constructor(E,p){this._proxy=E.getProxy(t.MainContext.MainThreadStatusBar),this._commands=p,this._statusMessage=new k(this)}createStatusBarEntry(E,p,w,f){return new L(this._proxy,this._commands,E,p,w,f)}setStatusBarMessage(E,p){const w=this._statusMessage.setMessage(E);let f;return typeof p=="number"?f=setTimeout(()=>w.dispose(),p):typeof p<"u"&&p.then(()=>w.dispose(),()=>w.dispose()),new l.Disposable(()=>{w.dispose(),clearTimeout(f)})}}e.ExtHostStatusBar=S}),define(De[92],Ie([1,0,5,4,3]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class P{constructor(D){this._onDidChangeStorage=new t.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=D.getProxy(l.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(D,b){this._proxy.$registerExtensionStorageKeysToSync(D,b)}initializeExtensionStorage(D,b,I){return this._proxy.$initializeExtensionStorage(D,b).then(L=>L||I)}setValue(D,b,I){return this._proxy.$setValue(D,b,I)}$acceptValue(D,b,I){this._onDidChangeStorage.fire({shared:D,key:b,value:I})}}e.ExtHostStorage=P,e.IExtHostStorage=(0,C.createDecorator)("IExtHostStorage")}),define(De[67],Ie([1,0,3,26,15,66,2]),function(J,e,l,t,C,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,l.createDecorator)("IExtensionStoragePaths");let D=class{constructor(I,L,k){this._logService=L,this._extHostFileSystem=k,this._workspace=I.workspace??void 0,this._environment=I.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(S=>this._value=S)}async _getWorkspaceStorageURI(I){return _.URI.joinPath(this._environment.workspaceStorageHome,I)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const I=this._workspace.id,L=await this._getWorkspaceStorageURI(I);try{return await this._extHostFileSystem.value.stat(L),this._logService.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",L),await this._extHostFileSystem.value.createDirectory(L),await this._extHostFileSystem.value.writeFile(_.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:_.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),L}catch(k){this._logService.error("[ExtHostStorage]",k);return}}workspaceValue(I){if(this._value)return _.URI.joinPath(this._value,I.identifier.value)}globalValue(I){return _.URI.joinPath(this._environment.globalStorageHome,I.identifier.value.toLowerCase())}onWillDeactivateAll(){}};D=qe([xe(0,t.IExtHostInitDataService),xe(1,C.ILogService),xe(2,P.IExtHostConsumerFileSystem)],D),e.ExtensionStoragePaths=D}),define(De[137],Ie([1,0,3,5,16]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTelemetryLogService=e.IExtHostTelemetryLogService=void 0,e.IExtHostTelemetryLogService=(0,l.createDecorator)("IExtHostTelemetryLogService");let P=class{constructor(D){this._telemetryShape=D.getProxy(t.MainContext.MainThreadTelemetry)}logToTelemetryOutputChannel(D,b,I){this._telemetryShape.$logTelemetryToOutputChannel(`${D.identifier.value}/${b}`,I)}};P=qe([xe(0,C.IExtHostRpcService)],P),e.ExtHostTelemetryLogService=P}),define(De[38],Ie([1,0,4,5,3,2,16,6,7,173,10,215,21,34,200,86,14,18,13]),function(J,e,l,t,C,P,_,D,b,I,L,k,S,T,E,p,w,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,C.createDecorator)("IExtHostTerminalService");class m{constructor(o,u,h,y){this._proxy=o,this._id=u,this._creationOptions=h,this._name=y,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(M=>this._pidPromiseComplete=M);const R=this;this.value={get name(){return R._name||""},get processId(){return R._pidPromise},get creationOptions(){return R._creationOptions},get exitStatus(){return R._exitStatus},get state(){return R._state},sendText(M,U=!0){R._checkDisposed(),R._proxy.$sendText(R._id,M,U)},show(M){R._checkDisposed(),R._proxy.$show(R._id,M)},hide(){R._checkDisposed(),R._proxy.$hide(R._id)},dispose(){R._disposed||(R._disposed=!0,R._proxy.$dispose(R._id))},get dimensions(){if(!(R._cols===void 0||R._rows===void 0))return{columns:R._cols,rows:R._rows}}}}async create(o,u){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:o.name,shellPath:(0,w.withNullAsUndefined)(o.shellPath),shellArgs:(0,w.withNullAsUndefined)(o.shellArgs),cwd:(0,w.withNullAsUndefined)(o.cwd),env:(0,w.withNullAsUndefined)(o.env),icon:(0,w.withNullAsUndefined)(i(o.iconPath)),color:p.ThemeColor.isThemeColor(o.color)?o.color.id:void 0,initialText:(0,w.withNullAsUndefined)(o.message),strictEnv:(0,w.withNullAsUndefined)(o.strictEnv),hideFromUser:(0,w.withNullAsUndefined)(o.hideFromUser),isFeatureTerminal:(0,w.withNullAsUndefined)(u?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,w.withNullAsUndefined)(u?.useShellEnvironment),location:u?.location||this._serializeParentTerminal(o.location,u?.resolvedExtHostIdentifier),isTransient:(0,w.withNullAsUndefined)(o.isTransient)})}async createExtensionTerminal(o,u,h,y){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:h,color:p.ThemeColor.isThemeColor(y)?y.id:void 0,location:this._serializeParentTerminal(o,u),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(o,u){return typeof o=="object"?"parentTerminal"in o&&o.parentTerminal&&u?{parentTerminal:u}:"viewColumn"in o?{viewColumn:v.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus}:void 0:o}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(o){this._name=o}setExitStatus(o,u){this._exitStatus=Object.freeze({code:o,reason:u})}setDimensions(o,u){return o===this._cols&&u===this._rows||o===0||u===0?!1:(this._cols=o,this._rows=u,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(o){this._pidPromiseComplete?(this._pidPromiseComplete(o),this._pidPromiseComplete=void 0):this._pidPromise.then(u=>{u!==o&&(this._pidPromise=Promise.resolve(o))})}}e.ExtHostTerminal=m;class a{constructor(o){this._pty=o,this.id=0,this.shouldPersist=!1,this._onProcessData=new l.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new l.Emitter,this._onDidChangeProperty=new l.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new l.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(o){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${o}`)}updateProperty(o,u){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${o}, value: ${u}`)}async start(){}shutdown(){this._pty.close()}input(o){this._pty.handleInput?.(o)}resize(o,u){this._pty.setDimensions?.({columns:o,rows:u})}async processBinary(o){}acknowledgeDataEvent(o){}async setUnicodeVersion(o){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(o){this._pty.onDidWrite(u=>this._onProcessData.fire(u)),this._pty.onDidClose?.((u=void 0)=>{this._onProcessExit.fire(u===void 0?void 0:u)}),this._pty.onDidOverrideDimensions?.(u=>{u&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:u.columns,rows:u.rows}})}),this._pty.onDidChangeName?.(u=>{this._onDidChangeProperty.fire({type:"title",value:u})}),this._pty.open(o||void 0),o&&this._pty.setDimensions?.(o),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=a;let g=1,n=class extends D.Disposable{constructor(o,u){super(),this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new l.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new l.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new l.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new l.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new l.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=u.getProxy(t.MainContext.MainThreadTerminalService),this._bufferer=new E.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new l.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(o),this._register({dispose:()=>{for(const[h,y]of this._terminalProcesses)y.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(o=>o.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(o){return(o?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(o){return(o?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(o,u){const h=new m(this._proxy,(0,T.generateUuid)(),o,o.name),y=new a(o.pty);return h.createExtensionTerminal(o.location,this._serializeParentTerminal(o,u).resolvedExtHostIdentifier,i(o.iconPath),r(o.color)).then(R=>{const M=this._setupExtHostProcessListeners(R,y);this._terminalProcessDisposables[R]=M}),this._terminals.push(h),h.value}_serializeParentTerminal(o,u){if(u=u||{},o.location&&typeof o.location=="object"&&"parentTerminal"in o.location){const h=o.location.parentTerminal;if(h){const y=this._terminals.find(R=>R.value===h);y&&(u.resolvedExtHostIdentifier=y._id)}}else o.location&&typeof o.location!="object"?u.location=o.location:u.location&&typeof u.location=="object"&&"splitActiveTerminal"in u.location&&(u.location={splitActiveTerminal:!0});return u}attachPtyToTerminal(o,u){if(!this._getTerminalById(o))throw new Error(`Cannot resolve terminal with id ${o} for virtual process`);const y=new a(u),R=this._setupExtHostProcessListeners(o,y);this._terminalProcessDisposables[o]=R}async $acceptActiveTerminalChanged(o){const u=this._activeTerminal;if(o===null){this._activeTerminal=void 0,u!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const h=this._getTerminalById(o);h&&(this._activeTerminal=h,u!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(o,u){const h=this._getTerminalById(o);h&&this._onDidWriteTerminalData.fire({terminal:h.value,data:u})}async $acceptTerminalDimensions(o,u,h){const y=this._getTerminalById(o);y&&y.setDimensions(u,h)&&this._onDidChangeTerminalDimensions.fire({terminal:y.value,dimensions:y.value.dimensions})}async $acceptTerminalMaximumDimensions(o,u,h){this._terminalProcesses.get(o)?.resize(u,h)}async $acceptTerminalTitleChange(o,u){const h=this._getTerminalById(o);h&&(h.name=u)}async $acceptTerminalClosed(o,u,h){const y=this._getTerminalObjectIndexById(this._terminals,o);if(y!==null){const R=this._terminals.splice(y,1)[0];R.setExitStatus(u,h),this._onDidCloseTerminal.fire(R.value)}}$acceptTerminalOpened(o,u,h,y){if(u){const U=this._getTerminalObjectIndexById(this._terminals,u);if(U!==null){this._terminals[U]._id=o,this._onDidOpenTerminal.fire(this.terminals[U]),this._terminals[U].isOpen=!0;return}}const R={name:y.name,shellPath:y.executable,shellArgs:y.args,cwd:typeof y.cwd=="string"?y.cwd:P.URI.revive(y.cwd),env:y.env,hideFromUser:y.hideFromUser},M=new m(this._proxy,o,R,h);this._terminals.push(M),this._onDidOpenTerminal.fire(M.value),M.isOpen=!0}async $acceptTerminalProcessId(o,u){this._getTerminalById(o)?._setProcessId(u)}async $startExtensionTerminal(o,u){const h=this._getTerminalById(o);if(!h)return{message:(0,I.localize)(0,null,o)};h.isOpen||await new Promise(R=>{const M=this.onDidOpenTerminal(async U=>{U===h.value&&(M.dispose(),R())})});const y=this._terminalProcesses.get(o);y?y.startSendingEvents(u):this._extensionTerminalAwaitingStart[o]={initialDimensions:u}}_setupExtHostProcessListeners(o,u){const h=new D.DisposableStore;h.add(u.onProcessReady(R=>this._proxy.$sendProcessReady(o,R.pid,R.cwd))),h.add(u.onDidChangeProperty(R=>this._proxy.$sendProcessProperty(o,R))),this._bufferer.startBuffering(o,u.onProcessData),h.add(u.onProcessExit(R=>this._onProcessExit(o,R))),this._terminalProcesses.set(o,u);const y=this._extensionTerminalAwaitingStart[o];return y&&u instanceof a&&(u.startSendingEvents(y.initialDimensions),delete this._extensionTerminalAwaitingStart[o]),h}$acceptProcessAckDataEvent(o,u){this._terminalProcesses.get(o)?.acknowledgeDataEvent(u)}$acceptProcessInput(o,u){this._terminalProcesses.get(o)?.input(u)}$acceptTerminalInteraction(o){const u=this._getTerminalById(o);u?.setInteractedWith()&&this._onDidChangeTerminalState.fire(u.value)}$acceptProcessResize(o,u,h){try{this._terminalProcesses.get(o)?.resize(u,h)}catch(y){if(y.code!=="EPIPE"&&y.code!=="ERR_IPC_CHANNEL_CLOSED")throw y}}$acceptProcessShutdown(o,u){this._terminalProcesses.get(o)?.shutdown(u)}$acceptProcessRequestInitialCwd(o){this._terminalProcesses.get(o)?.getInitialCwd().then(u=>this._proxy.$sendProcessProperty(o,{type:"initialCwd",value:u}))}$acceptProcessRequestCwd(o){this._terminalProcesses.get(o)?.getCwd().then(u=>this._proxy.$sendProcessProperty(o,{type:"cwd",value:u}))}$acceptProcessRequestLatency(o){return Promise.resolve(o)}registerLinkProvider(o){return this._linkProviders.add(o),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new b.Disposable(()=>{this._linkProviders.delete(o),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(o,u,h){if(this._profileProviders.has(u))throw new Error(`Terminal profile provider "${u}" already registered`);return this._profileProviders.set(u,h),this._proxy.$registerProfileProvider(u,o.identifier.value),new b.Disposable(()=>{this._profileProviders.delete(u),this._proxy.$unregisterProfileProvider(u)})}async $createContributedProfileTerminal(o,u){const h=new S.CancellationTokenSource().token;let y=await this._profileProviders.get(o)?.provideTerminalProfile(h);if(!h.isCancellationRequested){if(y&&!("options"in y)&&(y={options:y}),!y||!("options"in y))throw new Error(`No terminal profile options provided for id "${o}"`);if("pty"in y.options){this.createExtensionTerminal(y.options,u);return}this.createTerminalFromOptions(y.options,u)}}async $provideLinks(o,u){const h=this._getTerminalById(o);if(!h)return[];this._terminalLinkCache.delete(o),this._terminalLinkCancellationSource.get(o)?.dispose(!0);const R=new S.CancellationTokenSource;this._terminalLinkCancellationSource.set(o,R);const M=[],U={terminal:h.value,line:u},A=[];for(const N of this._linkProviders)A.push(f.Promises.withAsyncBody(async K=>{R.token.onCancellationRequested(()=>K({provider:N,links:[]}));const B=await N.provideTerminalLinks(U,R.token)||[];R.token.isCancellationRequested||K({provider:N,links:B})}));const z=await Promise.all(A);if(R.token.isCancellationRequested)return[];const $=new Map;for(const N of z)N&&N.links.length>0&&M.push(...N.links.map(K=>{const B={id:g++,startIndex:K.startIndex,length:K.length,label:K.tooltip};return $.set(B.id,{provider:N.provider,link:K}),B}));return this._terminalLinkCache.set(o,$),M}$activateLink(o,u){const h=this._terminalLinkCache.get(o)?.get(u);!h||h.provider.handleTerminalLink(h.link)}_onProcessExit(o,u){this._bufferer.stopBuffering(o),this._terminalProcesses.delete(o),delete this._extensionTerminalAwaitingStart[o];const h=this._terminalProcessDisposables[o];h&&(h.dispose(),delete this._terminalProcessDisposables[o]),this._proxy.$sendProcessExit(o,u)}_getTerminalById(o){return this._getTerminalObjectById(this._terminals,o)}_getTerminalObjectById(o,u){const h=this._getTerminalObjectIndexById(o,u);return h!==null?o[h]:null}_getTerminalObjectIndexById(o,u){let h=null;return o.some((y,R)=>y._id===u?(h=R,!0):!1),h}getEnvironmentVariableCollection(o){let u=this._environmentVariableCollections.get(o.identifier.value);return u||(u=new d,this._setEnvironmentVariableCollection(o.identifier.value,u)),u}_syncEnvironmentVariableCollection(o,u){const h=(0,k.serializeEnvironmentVariableCollection)(u.map);this._proxy.$setEnvironmentVariableCollection(o,u.persistent,h.length===0?void 0:h)}$initEnvironmentVariableCollections(o){o.forEach(u=>{const h=u[0],y=new d(u[1]);this._setEnvironmentVariableCollection(h,y)})}$acceptDefaultProfile(o,u){this._defaultProfile=o,this._defaultAutomationProfile=u}_setEnvironmentVariableCollection(o,u){this._environmentVariableCollections.set(o,u),u.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(o,u)})}};n=qe([xe(1,_.IExtHostRpcService)],n),e.BaseExtHostTerminalService=n;class d{constructor(o){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new l.Emitter,this.map=new Map(o)}get persistent(){return this._persistent}set persistent(o){this._persistent=o,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(o,u){this._setIfDiffers(o,{value:u,type:b.EnvironmentVariableMutatorType.Replace})}append(o,u){this._setIfDiffers(o,{value:u,type:b.EnvironmentVariableMutatorType.Append})}prepend(o,u){this._setIfDiffers(o,{value:u,type:b.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(o,u){const h=this.map.get(o);(!h||h.value!==u.value||h.type!==u.type)&&(this.map.set(o,u),this._onDidChangeCollection.fire())}get(o){return this.map.get(o)}forEach(o,u){this.map.forEach((h,y)=>o.call(u,y,h,this))}[Symbol.iterator](){return this.map.entries()}delete(o){this.map.delete(o),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=d;let s=class extends n{constructor(o){super(!1,o)}createTerminal(o,u,h){throw new L.NotSupportedError}createTerminalFromOptions(o,u){throw new L.NotSupportedError}};s=qe([xe(0,_.IExtHostRpcService)],s),e.WorkerExtHostTerminalService=s;function i(c){if(!(!c||typeof c=="string"))return"id"in c?{id:c.id,color:c.color}:c}function r(c){return p.ThemeColor.isThemeColor(c)?c:void 0}});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,C){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?C.call(J,l):C?C.value=l:e.set(J,l),l},Ue=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[257],Ie([1,0,17,23,21,4,59,78,6,24,14,34,5,16,133,13,7,63,90,64]),function(J,e,l,t,C,P,_,D,b,I,L,k,S,T,E,p,w,f,v,m){"use strict";var a,g;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let n=class{constructor(U,A,z){this.editors=z,this.resultsChangedEmitter=new P.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=U.getProxy(S.MainContext.MainThreadTesting),this.observer=new h(this.proxy),this.runTracker=new s(this.proxy),A.registerArgumentProcessor({processArgument:$=>$?.$mid===13?(0,E.toItemFromContext)($):$})}createTestController(U,A,z){if(this.controllers.has(U))throw new Error(`Attempt to insert a duplicate controller with ID "${U}"`);const $=new b.DisposableStore,N=$.add(new E.ExtHostTestItemCollection(U,A,this.editors));N.root.label=A;const K=new Map,B=this.proxy,O={items:N.root.children,get label(){return A},set label(V){A=V,N.root.label=V,B.$updateController(U,{label:A})},get refreshHandler(){return z},set refreshHandler(V){z=V,B.$updateController(U,{canRefresh:!!V})},get id(){return U},createRunProfile:(V,q,Y,Q,de)=>{let ve=(0,D.hash)(V);for(;K.has(ve);)ve++;return new y(this.proxy,K,U,ve,V,q,Y,Q,de)},createTestItem(V,q,Y){return new E.TestItemImpl(U,V,q,Y)},createTestRun:(V,q,Y=!0)=>this.runTracker.createTestRun(U,N,V,q,Y),set resolveHandler(V){N.resolveHandler=V},get resolveHandler(){return N.resolveHandler},dispose:()=>{$.dispose()}};B.$registerTestController(U,A,!!z),$.add((0,b.toDisposable)(()=>B.$unregisterTestController(U)));const x={controller:O,collection:N,profiles:K};return this.controllers.set(U,x),$.add((0,b.toDisposable)(()=>this.controllers.delete(U))),$.add(N.onDidGenerateDiff(V=>B.$publishDiff(U,V.map(m.TestsDiffOp.serialize)))),O}createTestObserver(){return this.observer.checkout()}async runTests(U,A=C.CancellationToken.None){const z=i(U);if(!z)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const $=this.controllers.get(z.controllerId);if(!$)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(N=>f.TestId.fromExtHostTestItem(N,$.collection.root.id).toString())??[$.collection.root.id],profileGroup:R[z.kind],profileId:z.profileId,controllerId:z.controllerId}],exclude:U.exclude?.map(N=>N.id)},A)}$provideFileCoverage(U,A,z){return(0,l.mapFind)(this.runTracker.trackers,N=>N.id===U?N.getCoverage(A):void 0)?.provideFileCoverage(z)??Promise.resolve([])}$resolveFileCoverage(U,A,z,$){return(0,l.mapFind)(this.runTracker.trackers,K=>K.id===U?K.getCoverage(A):void 0)?.resolveFileCoverage(z,$)??Promise.resolve([])}$configureRunProfile(U,A){this.controllers.get(U)?.profiles.get(A)?.configureHandler?.()}async $refreshTests(U,A){await this.controllers.get(U)?.controller.refreshHandler?.(A)}$publishTestResults(U){this.results=Object.freeze(U.map(A=>(0,I.deepFreeze)(p.TestResults.to(A))).concat(this.results).sort((A,z)=>z.completedAt-A.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(U,A){const z=this.controllers.get(f.TestId.fromString(U).controllerId)?.collection;z&&(await z.expand(U,A<0?1/0:A),z.flushDiff())}$acceptDiff(U){this.observer.applyDiff(U.map(m.TestsDiffOp.deserialize))}async $runControllerTests(U,A){return Promise.all(U.map(z=>this.runControllerTestRequest(z,A)))}async runControllerTestRequest(U,A){const z=this.controllers.get(U.controllerId);if(!z)return{};const{collection:$,profiles:N}=z,K=N.get(U.profileId);if(!K)return{};const B=U.testIds.map(q=>$.tree.get(q)).filter(L.isDefined),O=U.excludeExtIds.map(q=>z.collection.tree.get(q)).filter(L.isDefined).filter(q=>B.some(Y=>Y.fullId.compare(q.fullId)===2));if(!B.length)return{};const x=new w.TestRunRequest(B.some(q=>q.actual instanceof E.TestItemRootImpl)?void 0:B.map(q=>q.actual),O.map(q=>q.actual),K),V=this.runTracker.prepareForMainThreadTestRun(x,r.fromInternal(U,z.collection),A);try{return await K.runHandler(x,A),{}}catch(q){return{error:String(q)}}finally{V.isRunning&&!A.isCancellationRequested&&await P.Event.toPromise(V.onEnd),V.dispose()}}$cancelExtensionTestRun(U){U===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(U)}};n=qe([xe(0,T.IExtHostRpcService)],n),e.ExtHostTesting=n;class d extends b.Disposable{constructor(U,A,z){super(),this.dto=U,this.proxy=A,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new P.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new C.CancellationTokenSource(z)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:$}of this.tasks.values())$.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(U){return this.tasks.get(U)?.coverage}createRun(U){const A=this.dto.id,z=this.dto.controllerId,$=(0,k.generateUuid)(),N=new c(this.proxy,A,$),K=V=>(q,...Y)=>{if(O){console.warn(`Setting the state of test "${q.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(q)||(this.ensureTestIsKnown(q),V(q,...Y))},B=(V,q)=>{const Y=q instanceof Array?q.map(p.TestMessage.from):[p.TestMessage.from(q)];if(V.uri&&V.range){const Q={range:p.Range.from(V.range),uri:V.uri};for(const de of Y)de.location=de.location||Q}this.proxy.$appendTestMessagesInRun(A,$,f.TestId.fromExtHostTestItem(V,z).toString(),Y)};let O=!1;const x={isPersisted:this.dto.isPersisted,token:this.cts.token,name:U,get coverageProvider(){return N.coverageProvider},set coverageProvider(V){N.coverageProvider=V},enqueued:K(V=>{this.proxy.$updateTestStateInRun(A,$,f.TestId.fromExtHostTestItem(V,z).toString(),1)}),skipped:K(V=>{this.proxy.$updateTestStateInRun(A,$,f.TestId.fromExtHostTestItem(V,z).toString(),5)}),started:K(V=>{this.proxy.$updateTestStateInRun(A,$,f.TestId.fromExtHostTestItem(V,z).toString(),2)}),errored:K((V,q,Y)=>{B(V,q),this.proxy.$updateTestStateInRun(A,$,f.TestId.fromExtHostTestItem(V,z).toString(),6,Y)}),failed:K((V,q,Y)=>{B(V,q),this.proxy.$updateTestStateInRun(A,$,f.TestId.fromExtHostTestItem(V,z).toString(),4,Y)}),passed:K((V,q)=>{this.proxy.$updateTestStateInRun(A,$,f.TestId.fromExtHostTestItem(V,this.dto.controllerId).toString(),3,q)}),appendOutput:(V,q,Y)=>{O||(Y&&(this.dto.isIncluded(Y)?this.ensureTestIsKnown(Y):Y=void 0),this.proxy.$appendOutputToRun(A,$,t.VSBuffer.fromString(V),q&&p.location.from(q),Y&&f.TestId.fromExtHostTestItem(Y,z).toString()))},end:()=>{O||(O=!0,this.proxy.$finishedTestRunTask(A,$),this.tasks.delete($),this.isRunning||this.dispose())}};return this.tasks.set($,{run:x,coverage:N}),this.proxy.$startedTestRunTask(A,{id:$,name:U,running:!0}),x}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(U){if(!(U instanceof E.TestItemImpl))throw new v.InvalidTestItemError(U.id);if(this.sharedTestIds.has(f.TestId.fromExtHostTestItem(U,this.dto.controllerId).toString()))return;const A=[],z=this.dto.colllection.root;for(;;){const $=p.TestItem.from(U);if(A.unshift($),this.sharedTestIds.has($.extId)||(this.sharedTestIds.add($.extId),U===z))break;U=U.parent||z}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,A)}}class s{constructor(U){this.proxy=U,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(U,A,z){return this.getTracker(U,A,z)}cancelRunById(U){for(const A of this.tracked.values())if(A.id===U){A.dispose();return}}cancelAllRuns(){for(const U of this.tracked.values())U.dispose()}createTestRun(U,A,z,$,N){const K=this.tracked.get(z);if(K)return K.createRun($);const B=r.fromPublic(U,A,z,N),O=i(z);this.proxy.$startedExtensionTestRun({controllerId:U,profile:O&&{group:R[O.kind],id:O.profileId},exclude:z.exclude?.map(V=>f.TestId.fromExtHostTestItem(V,A.root.id).toString())??[],id:B.id,include:z.include?.map(V=>f.TestId.fromExtHostTestItem(V,A.root.id).toString())??[A.root.id],persist:N});const x=this.getTracker(z,B);return x.onEnd(()=>this.proxy.$finishedExtensionTestRun(B.id)),x.createRun($)}getTracker(U,A,z){const $=new d(A,this.proxy,z);return this.tracked.set(U,$),$.onEnd(()=>this.tracked.delete(U)),$}}e.TestRunCoordinator=s;const i=M=>{if(!!M.profile){if(!(M.profile instanceof y))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return M.profile}};class r{constructor(U,A,z,$,N,K){this.controllerId=U,this.id=A,this.isPersisted=N,this.colllection=K,this.includePrefix=z.map(B=>B+"\0"),this.excludePrefix=$.map(B=>B+"\0")}static fromPublic(U,A,z,$){return new r(U,(0,k.generateUuid)(),z.include?.map(N=>f.TestId.fromExtHostTestItem(N,U).toString())??[U],z.exclude?.map(N=>f.TestId.fromExtHostTestItem(N,U).toString())??[],$,A)}static fromInternal(U,A){return new r(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,A)}isIncluded(U){const A=f.TestId.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const z of this.excludePrefix)if(A===z||A.startsWith(z))return!1;for(const z of this.includePrefix)if(A===z||A.startsWith(z))return!0;return!1}}e.TestRunDto=r;class c{constructor(U,A,z){this.proxy=U,this.runId=A,this.taskId=z}set coverageProvider(U){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!U||(this._coverageProvider=U,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(U){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(U))());try{return(await this.fileCoverage)?.map(p.TestCoverage.fromFile)??[]}catch(A){throw this.fileCoverage=void 0,A}}async resolveFileCoverage(U,A){const z=await this.fileCoverage;let $=z?.[U];return!this._coverageProvider||!z||!$?[]:($.detailedCoverage||($=z[U]=await this._coverageProvider.resolveFileCoverage?.($,A)??$),$.detailedCoverage?.map(p.TestCoverage.fromDetailed)??[])}}class o extends m.IncrementalChangeCollector{constructor(U){super(),this.emitter=U,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(U){this.added.add(U)}update(U){Object.assign(U.revived,p.TestItem.toPlain(U.item)),this.added.has(U)||this.updated.add(U)}remove(U){if(this.added.has(U)){this.added.delete(U);return}if(this.updated.delete(U),U.parent&&this.alreadyRemoved.has(U.parent)){this.alreadyRemoved.add(U.item.extId);return}this.removed.add(U)}getChangeEvent(){const{added:U,updated:A,removed:z}=this;return{get added(){return[...U].map($=>$.revived)},get updated(){return[...A].map($=>$.revived)},get removed(){return[...z].map($=>$.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class u extends m.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new P.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(U){return this.items.get(U)}getMirroredTestDataByReference(U){return this.items.get(U.id)}createItem(U,A){return{...U,revived:p.TestItem.toPlain(U.item),depth:A?A.depth+1:0,children:new Set}}createChangeCollector(){return new o(this.changeEmitter)}}e.MirroredTestCollection=u;class h{constructor(U){this.proxy=U}checkout(){this.current||(this.current=this.createObserverData());const U=this.current;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(A=>A.revived)},dispose:(0,_.once)(()=>{--U.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(U){return this.current?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.current?.tests.apply(U)}createObserverData(){const U=new u;return this.proxy.$subscribeToDiffs(),{observers:0,tests:U}}}class y{constructor(U,A,z,$,N,K,B,O=!1,x=void 0){this.controllerId=z,this.profileId=$,this._label=N,this.kind=K,this.runHandler=B,this._isDefault=O,this._tag=x,a.set(this,void 0),g.set(this,void 0),tt(this,a,U,"f"),tt(this,g,A,"f"),A.set($,this);const V=R[K];if(typeof V!="number")throw new Error(`Unknown TestRunProfile.group ${K}`);Ue(this,a,"f").$publishTestRunProfile({profileId:$,controllerId:z,tag:x?p.TestTag.namespace(this.controllerId,x.id):null,label:N,group:V,isDefault:O,hasConfigurationHandler:!1})}get label(){return this._label}set label(U){U!==this._label&&(this._label=U,Ue(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:U}))}get isDefault(){return this._isDefault}set isDefault(U){U!==this._isDefault&&(this._isDefault=U,Ue(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,Ue(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:U?p.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(U){U!==this._configureHandler&&(this._configureHandler=U,Ue(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!U}))}dispose(){Ue(this,g,"f")?.delete(this.profileId)&&(tt(this,g,void 0,"f"),Ue(this,a,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=y,a=new WeakMap,g=new WeakMap;const R={[w.TestRunProfileKind.Coverage]:8,[w.TestRunProfileKind.Debug]:4,[w.TestRunProfileKind.Run]:2}}),define(De[258],Ie([1,0,17,4,5,134,13,7]),function(J,e,l,t,C,P,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class b{constructor(L,k){this._extHostDocumentsAndEditors=k,this._onDidChangeTextEditorSelection=new t.Emitter,this._onDidChangeTextEditorOptions=new t.Emitter,this._onDidChangeTextEditorVisibleRanges=new t.Emitter,this._onDidChangeTextEditorViewColumn=new t.Emitter,this._onDidChangeActiveTextEditor=new t.Emitter,this._onDidChangeVisibleTextEditors=new t.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=L.getProxy(C.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(S=>this._onDidChangeVisibleTextEditors.fire(S)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(S=>this._onDidChangeActiveTextEditor.fire(S))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(L){const k=this._extHostDocumentsAndEditors.allEditors();return L?k:k.map(S=>S.value)}async showTextDocument(L,k,S){let T;typeof k=="number"?T={position:_.ViewColumn.from(k),preserveFocus:S}:typeof k=="object"?T={position:_.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selection:typeof k.selection=="object"?_.Range.from(k.selection):void 0,pinned:typeof k.preview=="boolean"?!k.preview:void 0}:T={preserveFocus:!1};const E=await this._proxy.$tryShowTextDocument(L.uri,T),p=E&&this._extHostDocumentsAndEditors.getEditor(E);if(p)return p.value;throw E?new Error(`Could NOT open editor for "${L.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${L.uri.toString()}".`)}createTextEditorDecorationType(L,k){return new P.TextEditorDecorationType(this._proxy,L,k).value}$acceptEditorPropertiesChanged(L,k){const S=this._extHostDocumentsAndEditors.getEditor(L);if(!S)throw new Error("unknown text editor");if(k.options&&S._acceptOptions(k.options),k.selections){const T=k.selections.selections.map(_.Selection.to);S._acceptSelections(T)}if(k.visibleRanges){const T=l.coalesce(k.visibleRanges.map(_.Range.to));S._acceptVisibleRanges(T)}if(k.options&&this._onDidChangeTextEditorOptions.fire({textEditor:S.value,options:{...k.options,lineNumbers:_.TextEditorLineNumbersStyle.to(k.options.lineNumbers)}}),k.selections){const T=D.TextEditorSelectionChangeKind.fromValue(k.selections.source),E=k.selections.selections.map(_.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:S.value,selections:E,kind:T})}if(k.visibleRanges){const T=l.coalesce(k.visibleRanges.map(_.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:S.value,visibleRanges:T})}}$acceptEditorPositionData(L){for(const k in L){const S=this._extHostDocumentsAndEditors.getEditor(k);if(!S)throw new Error("Unknown text editor");const T=_.ViewColumn.to(L[k]);S.value.viewColumn!==T&&(S._acceptViewColumn(T),this._onDidChangeTextEditorViewColumn.fire({textEditor:S.value,viewColumn:T}))}}getDiffInformation(L){return Promise.resolve(this._proxy.$getDiffInformation(L))}}e.ExtHostEditors=b}),define(De[259],Ie([1,0,2,3,5,6,7,13,14]),function(J,e,l,t,C,P,_,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,t.createDecorator)("IExtHostTimeline");class I{constructor(S,T){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=S.getProxy(C.MainContext.MainThreadTimeline),T.registerArgumentProcessor({processArgument:E=>{if(E&&E.$mid===11){const p=E.uri===void 0?void 0:l.URI.revive(E.uri);return this._itemsBySourceAndUriMap.get(E.source)?.get(L(p))?.get(E.handle)}return E}})}async $getTimeline(S,T,E,p){return this._providers.get(S)?.provideTimeline(l.URI.revive(T),E,p)}registerTimelineProvider(S,T,E,p){const w=new P.DisposableStore,f=this.convertTimelineItem(T.id,p,w).bind(this);let v;T.onDidChange&&(v=T.onDidChange(a=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...a,id:T.id}),this));const m=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...T,scheme:S,onDidChange:void 0,async provideTimeline(a,g,n){g?.resetCache&&(w.clear(),m.get(T.id)?.clear());const d=await T.provideTimeline(a,g,n);if(d==null)return;const s=f(a,g);return{...d,source:T.id,items:d.items.map(s)}},dispose(){for(const a of m.values())a.get(T.id)?.clear();v?.dispose(),w.dispose()}})}convertTimelineItem(S,T,E){return(p,w)=>{let f;if(w?.cacheResults){let v=this._itemsBySourceAndUriMap.get(S);v===void 0&&(v=new Map,this._itemsBySourceAndUriMap.set(S,v));const m=L(p);f=v.get(m),f===void 0&&(f=new Map,v.set(m,f))}return v=>{const{iconPath:m,...a}=v,g=`${S}|${v.id??v.timestamp}`;f?.set(g,v);let n,d,s;v.iconPath&&(m instanceof _.ThemeIcon?s={id:m.id,color:m.color}:l.URI.isUri(m)?(n=m,d=m):{light:n,dark:d}=m);let i;return _.MarkdownString.isMarkdownString(a.tooltip)?i=D.MarkdownString.from(a.tooltip):(0,b.isString)(a.tooltip)?i=a.tooltip:_.MarkdownString.isMarkdownString(a.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),i=D.MarkdownString.from(a.detail)):(0,b.isString)(a.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),i=a.detail),{...a,id:a.id??void 0,handle:g,source:S,command:v.command?T.toInternal(v.command,E):void 0,icon:n,iconDark:d,themeIcon:s,tooltip:i,accessibilityInformation:v.accessibilityInformation}}}}registerTimelineProviderCore(S){if(this._providers.get(S.id))throw new Error(`Timeline Provider ${S.id} already exists.`);return this._proxy.$registerTimelineProvider({id:S.id,label:S.label,scheme:S.scheme}),this._providers.set(S.id,S),(0,P.toDisposable)(()=>{for(const E of this._itemsBySourceAndUriMap.values())E.get(S.id)?.clear();this._providers.delete(S.id),this._proxy.$unregisterTimelineProvider(S.id),S.dispose()})}}e.ExtHostTimeline=I;function L(k){return k?.toString()}}),define(De[260],Ie([1,0,6,12,2,5]),function(J,e,l,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class _{constructor(b){this._openers=new Map,this._proxy=b.getProxy(P.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(b,I,L,k){if(this._openers.has(I))throw new Error(`Opener with id '${I}' already registered`);const S=k.schemes.find(T=>!_.supportedSchemes.has(T));if(S)throw new Error(`Scheme '${S}' is not supported. Only http and https are currently supported.`);return this._openers.set(I,L),this._proxy.$registerUriOpener(I,k.schemes,b,k.label),(0,l.toDisposable)(()=>{this._openers.delete(I),this._proxy.$unregisterUriOpener(I)})}async $canOpenUri(b,I,L){const k=this._openers.get(b);if(!k)throw new Error(`Unknown opener with id: ${b}`);const S=C.URI.revive(I);return k.canOpenExternalUri(S,L)}async $openUri(b,I,L){const k=this._openers.get(b);if(!k)throw new Error(`Unknown opener id: '${b}'`);return k.openExternalUri(C.URI.revive(I.resolvedUri),{sourceUri:C.URI.revive(I.sourceUri)},L)}}e.ExtHostUriOpeners=_,_.supportedSchemes=new Set([t.Schemas.http,t.Schemas.https])}),define(De[261],Ie([1,0,5,2,6,10,28]),function(J,e,l,t,C,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class D{constructor(I){this.handles=new Set,this.handlers=new Map,this._proxy=I.getProxy(l.MainContext.MainThreadUrls)}registerUriHandler(I,L){if(this.handles.has(_.ExtensionIdentifier.toKey(I)))throw new Error(`Protocol handler already registered for extension ${I}`);const k=D.HandlePool++;return this.handles.add(_.ExtensionIdentifier.toKey(I)),this.handlers.set(k,L),this._proxy.$registerUriHandler(k,I),(0,C.toDisposable)(()=>{this.handles.delete(_.ExtensionIdentifier.toKey(I)),this.handlers.delete(k),this._proxy.$unregisterUriHandler(k)})}$handleExternalUri(I,L){const k=this.handlers.get(I);if(!k)return Promise.resolve(void 0);try{k.handleUri(t.URI.revive(L))}catch(S){(0,P.onUnexpectedError)(S)}return Promise.resolve(void 0)}async createAppUri(I){return t.URI.revive(await this._proxy.$createAppUri(I))}}e.ExtHostUrls=D,D.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,C){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?C.call(J,l):C?C.value=l:e.set(J,l),l},Ue=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[68],Ie([1,0,4,12,2,187,206,88,5]),function(J,e,l,t,C,P,_,D,b){"use strict";var I,L,k,S,T,E,p,w,f,v,m,a;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class g{constructor(u,h,y,R,M,U,A){I.set(this,void 0),L.set(this,void 0),k.set(this,void 0),S.set(this,void 0),T.set(this,void 0),E.set(this,void 0),p.set(this,""),w.set(this,void 0),f.set(this,!1),v.set(this,!1),m.set(this,!1),this._onMessageEmitter=new l.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,a.set(this,new l.Emitter),this._onDidDispose=Ue(this,a,"f").event,tt(this,I,u,"f"),tt(this,L,h,"f"),tt(this,w,y,"f"),tt(this,S,R,"f"),tt(this,T,M,"f"),tt(this,E,U,"f"),tt(this,m,n(U),"f"),tt(this,k,A,"f")}dispose(){tt(this,f,!0,"f"),Ue(this,a,"f").fire(),Ue(this,a,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(u){return tt(this,v,!0,"f"),(0,D.asWebviewUri)(u,Ue(this,S,"f"))}get cspSource(){const u=Ue(this,E,"f").extensionLocation;if(u.scheme===t.Schemas.https||u.scheme===t.Schemas.http){let h=u.toString();return h.endsWith("/")||(h+="/"),h+" "+D.webviewGenericCspSource}return D.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ue(this,p,"f")}set html(u){this.assertNotDisposed(),Ue(this,p,"f")!==u&&(tt(this,p,u,"f"),!Ue(this,v,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(u)&&(tt(this,v,!0,"f"),Ue(this,k,"f").report("Webview vscode-resource: uris",Ue(this,E,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ue(this,L,"f").$setHtml(Ue(this,I,"f"),u))}get options(){return this.assertNotDisposed(),Ue(this,w,"f")}set options(u){this.assertNotDisposed(),Ue(this,L,"f").$setOptions(Ue(this,I,"f"),i(Ue(this,E,"f"),Ue(this,T,"f"),u)),tt(this,w,u,"f")}async postMessage(u){if(Ue(this,f,"f"))return!1;const h=(0,_.serializeWebviewMessage)(u,{serializeBuffersForPostMessage:Ue(this,m,"f")});return Ue(this,L,"f").$postMessage(Ue(this,I,"f"),h.message,...h.buffers)}assertNotDisposed(){if(Ue(this,f,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=g,I=new WeakMap,L=new WeakMap,k=new WeakMap,S=new WeakMap,T=new WeakMap,E=new WeakMap,p=new WeakMap,w=new WeakMap,f=new WeakMap,v=new WeakMap,m=new WeakMap,a=new WeakMap;function n(o){try{const u=(0,P.normalizeVersion)((0,P.parseVersion)(o.engines.vscode));return!!u&&u.majorBase>=1&&u.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=n;class d{constructor(u,h,y,R,M){this.remoteInfo=h,this.workspace=y,this._logService=R,this._deprecationService=M,this._webviews=new Map,this._webviewProxy=u.getProxy(b.MainContext.MainThreadWebviews)}$onMessage(u,h,y){const R=this.getWebview(u);if(R){const{message:M}=(0,_.deserializeWebviewMessage)(h,y.value);R._onMessageEmitter.fire(M)}}$onMissingCsp(u,h){this._logService.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(u,h,y){const R=new g(u,this._webviewProxy,r(h),this.remoteInfo,this.workspace,y,this._deprecationService);return this._webviews.set(u,R),R._onDidDispose(()=>{this._webviews.delete(u)}),R}deleteWebview(u){this._webviews.delete(u)}getWebview(u){return this._webviews.get(u)}}e.ExtHostWebviews=d;function s(o){return{id:o.identifier,location:o.extensionLocation}}e.toExtensionData=s;function i(o,u,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||c(o,u)}}e.serializeWebviewOptions=i;function r(o){return{enableCommandUris:o.enableCommandUris,enableScripts:o.enableScripts,enableForms:o.enableForms,portMapping:o.portMapping,localResourceRoots:o.localResourceRoots?.map(u=>C.URI.from(u))}}e.reviveOptions=r;function c(o,u){return[...(u?.getWorkspaceFolders()||[]).map(h=>h.uri),o.extensionLocation]}}),define(De[262],Ie([1,0,21,78,6,12,22,2,13,68,87,5,7]),function(J,e,l,t,C,P,_,D,b,I,L,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class T{constructor(n,d){this.document=n,this._storagePath=d,this._backupCounter=1,this._edits=new L.Cache("custom documents")}addEdit(n){return this._edits.add([n])}async undo(n,d){await this.getEdit(n).undo(),d||this.disposeBackup()}async redo(n,d){await this.getEdit(n).redo(),d||this.disposeBackup()}disposeEdits(n){for(const d of n)this._edits.delete(d)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const n=a(this.document.uri)+this._backupCounter++;return(0,_.joinPath)(this._storagePath,n)}updateBackup(n){this._backup?.delete(),this._backup=n}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(n){const d=this._edits.get(n,0);if(!d)throw new Error("No edit found");return d}}class E{constructor(){this._documents=new Map}get(n,d){return this._documents.get(this.key(n,d))}add(n,d,s){const i=this.key(n,d.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${n} resource:${d.uri}`);const r=new T(d,s);return this._documents.set(i,r),r}delete(n,d){const s=this.key(n,d.uri);this._documents.delete(s)}key(n,d){return`${n}@@@${d}`}}var p;(function(g){g[g.Text=0]="Text",g[g.Custom=1]="Custom"})(p||(p={}));class w{constructor(){this._providers=new Map}addTextProvider(n,d,s){return this.add(0,n,d,s)}addCustomProvider(n,d,s){return this.add(1,n,d,s)}get(n){return this._providers.get(n)}add(n,d,s,i){if(this._providers.has(d))throw new Error(`Provider for viewType:${d} already registered`);return this._providers.set(d,{type:n,extension:s,provider:i}),new S.Disposable(()=>this._providers.delete(d))}}class f{constructor(n,d,s,i,r){this._extHostDocuments=d,this._extensionStoragePaths=s,this._extHostWebview=i,this._extHostWebviewPanels=r,this._editorProviders=new w,this._documents=new E,this._proxy=n.getProxy(k.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(n,d,s,i){const r=new C.DisposableStore;return v(s)?(r.add(this._editorProviders.addTextProvider(d,n,s)),this._proxy.$registerTextEditorProvider((0,I.toExtensionData)(n),d,i.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,I.shouldSerializeBuffersForPostMessage)(n))):(r.add(this._editorProviders.addCustomProvider(d,n,s)),this.supportEditing(s)&&r.add(s.onDidChangeCustomDocument(c=>{const o=this.getCustomDocumentEntry(d,c.document.uri);if(m(c)){const u=o.addEdit(c);this._proxy.$onDidEdit(c.document.uri,d,u,c.label)}else this._proxy.$onContentChange(c.document.uri,d)})),this._proxy.$registerCustomEditorProvider((0,I.toExtensionData)(n),d,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,I.shouldSerializeBuffersForPostMessage)(n))),S.Disposable.from(r,new S.Disposable(()=>{this._proxy.$unregisterEditorProvider(d)}))}async $createCustomDocument(n,d,s,i,r){const c=this._editorProviders.get(d);if(!c)throw new Error(`No provider found for '${d}'`);if(c.type!==1)throw new Error(`Invalid provide type for '${d}'`);const o=D.URI.revive(n),u=await c.provider.openCustomDocument(o,{backupId:s,untitledDocumentData:i?.buffer},r);let h;return this.supportEditing(c.provider)&&this._extensionStoragePaths&&(h=this._extensionStoragePaths.workspaceValue(c.extension)??this._extensionStoragePaths.globalValue(c.extension)),this._documents.add(d,u,h),{editable:this.supportEditing(c.provider)}}async $disposeCustomDocument(n,d){const s=this._editorProviders.get(d);if(!s)throw new Error(`No provider found for '${d}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${d}'`);const i=D.URI.revive(n),{document:r}=this.getCustomDocumentEntry(d,i);this._documents.delete(d,r),r.dispose()}async $resolveWebviewEditor(n,d,s,i,r,c){const o=this._editorProviders.get(s);if(!o)throw new Error(`No provider found for '${s}'`);const u=b.ViewColumn.to(r),h=this._extHostWebview.createNewWebview(d,i.webviewOptions,o.extension),y=this._extHostWebviewPanels.createNewWebviewPanel(d,s,i.title,u,i.panelOptions,h,!0),R=D.URI.revive(n);switch(o.type){case 1:{const{document:M}=this.getCustomDocumentEntry(s,R);return o.provider.resolveCustomEditor(M,y,c)}case 0:{const M=this._extHostDocuments.getDocument(R);return o.provider.resolveCustomTextEditor(M,y,c)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(n,d,s){this.getCustomDocumentEntry(d,n).disposeEdits(s)}async $onMoveCustomEditor(n,d,s){const i=this._editorProviders.get(s);if(!i)throw new Error(`No provider found for '${s}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const r=this._extHostWebviewPanels.getWebviewPanel(n);if(!r)throw new Error("No webview found");const c=D.URI.revive(d),o=this._extHostDocuments.getDocument(c);await i.provider.moveCustomTextEditor(o,r,l.CancellationToken.None)}async $undo(n,d,s,i){return this.getCustomDocumentEntry(d,n).undo(s,i)}async $redo(n,d,s,i){return this.getCustomDocumentEntry(d,n).redo(s,i)}async $revert(n,d,s){const i=this.getCustomDocumentEntry(d,n);await this.getCustomEditorProvider(d).revertCustomDocument(i.document,s),i.disposeBackup()}async $onSave(n,d,s){const i=this.getCustomDocumentEntry(d,n);await this.getCustomEditorProvider(d).saveCustomDocument(i.document,s),i.disposeBackup()}async $onSaveAs(n,d,s,i){const r=this.getCustomDocumentEntry(d,n);return this.getCustomEditorProvider(d).saveCustomDocumentAs(r.document,D.URI.revive(s),i)}async $backup(n,d,s){const i=this.getCustomDocumentEntry(d,n),c=await this.getCustomEditorProvider(d).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},s);return i.updateBackup(c),c.id}getCustomDocumentEntry(n,d){const s=this._documents.get(n,D.URI.revive(d));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(n){const s=this._editorProviders.get(n)?.provider;if(!s||!this.supportEditing(s))throw new Error("Custom document is not editable");return s}supportEditing(n){return!!n.onDidChangeCustomDocument}}e.ExtHostCustomEditors=f;function v(g){return typeof g.resolveCustomTextEditor=="function"}function m(g){return typeof g.undo=="function"&&typeof g.redo=="function"}function a(g){const n=g.scheme===P.Schemas.file||g.scheme===P.Schemas.untitled?g.fsPath:g.toString();return(0,t.hash)(n)+""}});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,C){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?C.call(J,l):C?C.value=l:e.set(J,l),l},Ue=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[263],Ie([1,0,4,6,2,34,13,68,5,7]),function(J,e,l,t,C,P,_,D,b,I){"use strict";var L,k,S,T,E,p,w,f,v,m,a,g,n;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class d extends t.Disposable{constructor(c,o,u,h){super(),L.set(this,void 0),k.set(this,void 0),S.set(this,void 0),T.set(this,void 0),E.set(this,void 0),p.set(this,void 0),w.set(this,void 0),f.set(this,void 0),v.set(this,!0),m.set(this,void 0),a.set(this,!1),g.set(this,this._register(new l.Emitter)),this.onDidDispose=Ue(this,g,"f").event,n.set(this,this._register(new l.Emitter)),this.onDidChangeViewState=Ue(this,n,"f").event,tt(this,L,c,"f"),tt(this,k,o,"f"),tt(this,T,u,"f"),tt(this,S,h.viewType,"f"),tt(this,E,h.panelOptions,"f"),tt(this,f,h.viewColumn,"f"),tt(this,p,h.title,"f"),tt(this,m,h.active,"f")}dispose(){Ue(this,a,"f")||(tt(this,a,!0,"f"),Ue(this,g,"f").fire(),Ue(this,k,"f").$disposeWebview(Ue(this,L,"f")),Ue(this,T,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ue(this,T,"f")}get viewType(){return this.assertNotDisposed(),Ue(this,S,"f")}get title(){return this.assertNotDisposed(),Ue(this,p,"f")}set title(c){this.assertNotDisposed(),Ue(this,p,"f")!==c&&(tt(this,p,c,"f"),Ue(this,k,"f").$setTitle(Ue(this,L,"f"),c))}get iconPath(){return this.assertNotDisposed(),Ue(this,w,"f")}set iconPath(c){this.assertNotDisposed(),Ue(this,w,"f")!==c&&(tt(this,w,c,"f"),Ue(this,k,"f").$setIconPath(Ue(this,L,"f"),C.URI.isUri(c)?{light:c,dark:c}:c))}get options(){return Ue(this,E,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ue(this,f,"f")=="number"&&Ue(this,f,"f")<0))return Ue(this,f,"f")}get active(){return this.assertNotDisposed(),Ue(this,m,"f")}get visible(){return this.assertNotDisposed(),Ue(this,v,"f")}_updateViewState(c){Ue(this,a,"f")||(this.active!==c.active||this.visible!==c.visible||this.viewColumn!==c.viewColumn)&&(tt(this,m,c.active,"f"),tt(this,v,c.visible,"f"),tt(this,f,c.viewColumn,"f"),Ue(this,n,"f").fire({webviewPanel:this}))}reveal(c,o){this.assertNotDisposed(),Ue(this,k,"f").$reveal(Ue(this,L,"f"),{viewColumn:typeof c>"u"?void 0:_.ViewColumn.from(c),preserveFocus:!!o})}assertNotDisposed(){if(Ue(this,a,"f"))throw new Error("Webview is disposed")}}L=new WeakMap,k=new WeakMap,S=new WeakMap,T=new WeakMap,E=new WeakMap,p=new WeakMap,w=new WeakMap,f=new WeakMap,v=new WeakMap,m=new WeakMap,a=new WeakMap,g=new WeakMap,n=new WeakMap;class s{constructor(c,o,u){this.webviews=o,this.workspace=u,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=c.getProxy(b.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,P.generateUuid)()}createWebviewPanel(c,o,u,h,y={}){const R=typeof h=="object"?h.viewColumn:h,M={viewColumn:_.ViewColumn.from(R),preserveFocus:typeof h=="object"&&!!h.preserveFocus},U=(0,D.shouldSerializeBuffersForPostMessage)(c),A=s.newHandle();this._proxy.$createWebviewPanel((0,D.toExtensionData)(c),A,o,{title:u,panelOptions:i(y),webviewOptions:(0,D.serializeWebviewOptions)(c,this.workspace,y),serializeBuffersForPostMessage:U},M);const z=this.webviews.createNewWebview(A,y,c);return this.createNewWebviewPanel(A,o,u,R,y,z,!0)}$onDidChangeWebviewPanelViewStates(c){const o=Object.keys(c);o.sort((u,h)=>{const y=c[u],R=c[h];return y.active?1:R.active?-1:+y.visible-+R.visible});for(const u of o){const h=this.getWebviewPanel(u);if(!h)continue;const y=c[u];h._updateViewState({active:y.active,visible:y.visible,viewColumn:_.ViewColumn.to(y.position)})}}async $onDidDisposeWebviewPanel(c){this.getWebviewPanel(c)?.dispose(),this._webviewPanels.delete(c),this.webviews.deleteWebview(c)}registerWebviewPanelSerializer(c,o,u){if(this._serializers.has(o))throw new Error(`Serializer for '${o}' already registered`);return this._serializers.set(o,{serializer:u,extension:c}),this._proxy.$registerSerializer(o,{serializeBuffersForPostMessage:(0,D.shouldSerializeBuffersForPostMessage)(c)}),new I.Disposable(()=>{this._serializers.delete(o),this._proxy.$unregisterSerializer(o)})}async $deserializeWebviewPanel(c,o,u,h){const y=this._serializers.get(o);if(!y)throw new Error(`No serializer found for '${o}'`);const{serializer:R,extension:M}=y,U=this.webviews.createNewWebview(c,u.webviewOptions,M),A=this.createNewWebviewPanel(c,o,u.title,h,u.panelOptions,U,u.active);await R.deserializeWebviewPanel(A,u.state)}createNewWebviewPanel(c,o,u,h,y,R,M){const U=new d(c,this._proxy,R,{viewType:o,title:u,viewColumn:h,panelOptions:y,active:M});return this._webviewPanels.set(c,U),U}getWebviewPanel(c){return this._webviewPanels.get(c)}}e.ExtHostWebviewPanels=s;function i(r){return{enableFindWidget:r.enableFindWidget,retainContextWhenHidden:r.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,C){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?C.call(J,l):C?C.value=l:e.set(J,l),l},Ue=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[264],Ie([1,0,4,6,68,13,5,7]),function(J,e,l,t,C,P,_,D){"use strict";var b,I,L,k,S,T,E,p,w,f,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class m extends t.Disposable{constructor(n,d,s,i,r,c,o){super(),b.set(this,void 0),I.set(this,void 0),L.set(this,void 0),k.set(this,void 0),S.set(this,!1),T.set(this,void 0),E.set(this,void 0),p.set(this,void 0),w.set(this,void 0),f.set(this,this._register(new l.Emitter)),this.onDidChangeVisibility=Ue(this,f,"f").event,v.set(this,this._register(new l.Emitter)),this.onDidDispose=Ue(this,v,"f").event,tt(this,L,s,"f"),tt(this,E,i,"f"),tt(this,b,n,"f"),tt(this,I,d,"f"),tt(this,k,r,"f"),tt(this,T,o,"f")}dispose(){Ue(this,S,"f")||(tt(this,S,!0,"f"),Ue(this,v,"f").fire(),Ue(this,k,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ue(this,E,"f")}set title(n){this.assertNotDisposed(),Ue(this,E,"f")!==n&&(tt(this,E,n,"f"),Ue(this,I,"f").$setWebviewViewTitle(Ue(this,b,"f"),n))}get description(){return this.assertNotDisposed(),Ue(this,p,"f")}set description(n){this.assertNotDisposed(),Ue(this,p,"f")!==n&&(tt(this,p,n,"f"),Ue(this,I,"f").$setWebviewViewDescription(Ue(this,b,"f"),n))}get visible(){return Ue(this,T,"f")}get webview(){return Ue(this,k,"f")}get viewType(){return Ue(this,L,"f")}_setVisible(n){n===Ue(this,T,"f")||Ue(this,S,"f")||(tt(this,T,n,"f"),Ue(this,f,"f").fire())}get badge(){return this.assertNotDisposed(),Ue(this,w,"f")}set badge(n){this.assertNotDisposed(),!(n?.value===Ue(this,w,"f")?.value&&n?.tooltip===Ue(this,w,"f")?.tooltip)&&(tt(this,w,P.ViewBadge.from(n),"f"),Ue(this,I,"f").$setWebviewViewBadge(Ue(this,b,"f"),n))}show(n){this.assertNotDisposed(),Ue(this,I,"f").$show(Ue(this,b,"f"),!!n)}assertNotDisposed(){if(Ue(this,S,"f"))throw new Error("Webview is disposed")}}b=new WeakMap,I=new WeakMap,L=new WeakMap,k=new WeakMap,S=new WeakMap,T=new WeakMap,E=new WeakMap,p=new WeakMap,w=new WeakMap,f=new WeakMap,v=new WeakMap;class a{constructor(n,d){this._extHostWebview=d,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=n.getProxy(_.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(n,d,s,i){if(this._viewProviders.has(d))throw new Error(`View provider for '${d}' already registered`);return this._viewProviders.set(d,{provider:s,extension:n}),this._proxy.$registerWebviewViewProvider((0,C.toExtensionData)(n),d,{retainContextWhenHidden:i?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,C.shouldSerializeBuffersForPostMessage)(n)}),new D.Disposable(()=>{this._viewProviders.delete(d),this._proxy.$unregisterWebviewViewProvider(d)})}async $resolveWebviewView(n,d,s,i,r){const c=this._viewProviders.get(d);if(!c)throw new Error(`No view provider found for '${d}'`);const{provider:o,extension:u}=c,h=this._extHostWebview.createNewWebview(n,{},u),y=new m(n,this._proxy,d,s,h,u,!0);this._webviewViews.set(n,y),await o.resolveWebviewView(y,{state:i},r)}async $onDidChangeWebviewViewVisibility(n,d){this.getWebviewView(n)._setVisible(d)}async $disposeWebviewView(n){const d=this.getWebviewView(n);this._webviewViews.delete(n),d.dispose(),this._extHostWebview.deleteWebview(n)}getWebviewView(n){const d=this._webviewViews.get(n);if(!d)throw new Error("No webview found");return d}}e.ExtHostWebviewViews=a}),define(De[138],Ie([1,0,4,5,2,12,8,3,16]),function(J,e,l,t,C,P,_,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let I=class Zn{constructor(k){this._onDidChangeWindowState=new l.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Zn.InitialState,this._proxy=k.getProxy(t.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(S=>this.$onDidChangeWindowFocus(S))}get state(){return this._state}$onDidChangeWindowFocus(k){k!==this._state.focused&&(this._state={...this._state,focused:k},this._onDidChangeWindowState.fire(this._state))}openUri(k,S){let T;if(typeof k=="string"){T=k;try{k=C.URI.parse(k)}catch{return Promise.reject(`Invalid uri - '${k}'`)}}return(0,_.isFalsyOrWhitespace)(k.scheme)?Promise.reject("Invalid scheme - cannot be empty"):k.scheme===P.Schemas.command?Promise.reject(`Invalid scheme '${k.scheme}'`):this._proxy.$openUri(k,T,S)}async asExternalUri(k,S){if((0,_.isFalsyOrWhitespace)(k.scheme))return Promise.reject("Invalid scheme - cannot be empty");const T=await this._proxy.$asExternalUri(k,S);return C.URI.from(T)}};I.InitialState={focused:!0},I=qe([xe(0,b.IExtHostRpcService)],I),e.ExtHostWindow=I,e.IExtHostWindow=(0,D.createDecorator)("IExtHostWindow")}),define(De[265],Ie([1,0,113,266,61,37,2,15,45]),function(J,e,l,t,C,P,_,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class I{constructor(S,T,E){this._commands=S,this.logService=T,this._ipcHandlePath=E,this._server=t.createServer((p,w)=>this.onRequest(p,w)),this.setup().catch(p=>(T.error(p),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",S=>this.logService.error(S))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(S,T){const E=(w,f)=>{T.writeHead(w,{"content-type":"application/json"}),T.end(JSON.stringify(f||null),v=>v&&this.logService.error(v))},p=[];S.setEncoding("utf8"),S.on("data",w=>p.push(w)),S.on("end",async()=>{try{const w=JSON.parse(p.join(""));let f;switch(w.type){case"open":f=await this.open(w);break;case"openExternal":f=await this.openExternal(w);break;case"status":f=await this.getStatus(w);break;case"extensionManagement":f=await this.manageExtensions(w);break;default:E(404,`Unknown message type: ${w.type}`);break}E(200,f)}catch(w){const f=w instanceof Error?w.message:JSON.stringify(w);E(500,f),this.logService.error("Error while processing pipe request",w)}})}async open(S){const{fileURIs:T,folderURIs:E,forceNewWindow:p,diffMode:w,mergeMode:f,addMode:v,forceReuseWindow:m,gotoLineMode:a,waitMarkerFilePath:g,remoteAuthority:n}=S,d=[];if(Array.isArray(E))for(const c of E)try{d.push({folderUri:_.URI.parse(c)})}catch{}if(Array.isArray(T))for(const c of T)try{(0,b.hasWorkspaceFileExtension)(c)?d.push({workspaceUri:_.URI.parse(c)}):d.push({fileUri:_.URI.parse(c)})}catch{}const s=g?_.URI.file(g):void 0,r={forceNewWindow:p,diffMode:w,mergeMode:f,addMode:v,gotoLineMode:a,forceReuseWindow:m,preferNewWindow:!m&&!s&&!v,waitMarkerFileURI:s,remoteAuthority:n};return this._commands.executeCommand("_remoteCLI.windowOpen",d,r),""}async openExternal(S){for(const T of S.uris){const E=_.URI.parse(T),p=E.scheme==="file"?E:T;await this._commands.executeCommand("_remoteCLI.openExternal",p)}}async manageExtensions(S){const T=p=>p?.map(w=>/\.vsix$/i.test(w)?_.URI.parse(w):w),E={list:S.list,install:T(S.install),uninstall:T(S.uninstall),force:S.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",E)}async getStatus(S){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&C.existsSync(this._ipcHandlePath)&&C.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=I;let L=class extends I{constructor(S,T){super(S,T,(0,l.createRandomIPCHandle)())}};L=qe([xe(0,P.IExtHostCommands),xe(1,D.ILogService)],L),e.CLIServer=L}),define(De[267],Ie([1,0,239,26,16]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const P=1024*1024;let _=class extends l.AbstractExtHostConsoleForwarder{constructor(b,I){super(b,I),this._isMakingConsoleCall=!1,this._wrapStream("stderr","error"),this._wrapStream("stdout","log")}_nativeConsoleLogMessage(b,I,L){const k=b==="error"||b==="warn"?process.stderr:process.stdout;this._isMakingConsoleCall=!0,k.write(`
START_NATIVE_LOG
`),I.apply(console,L),k.write(`
END_NATIVE_LOG
`),this._isMakingConsoleCall=!1}_wrapStream(b,I){const L=process[b],k=L.write;let S="";Object.defineProperty(L,"write",{set:()=>{},get:()=>(T,E,p)=>{if(!this._isMakingConsoleCall){S+=T.toString(E);const w=S.length>P?S.length:S.lastIndexOf(`
`);w!==-1&&(console[I](S.slice(0,w)),S=S.slice(w+1))}k.call(L,T,E,p)}})}};_=qe([xe(0,C.IExtHostRpcService),xe(1,t.IExtHostInitDataService)],_),e.ExtHostConsoleForwarder=_}),define(De[268],Ie([1,0,9,81,34,37,6,5,2,16]),function(J,e,l,t,C,P,_,D,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let L=class extends _.Disposable{constructor(S,T){super();const E=S.getProxy(D.MainContext.MainThreadDownloadService);T.registerCommand(!1,"_workbench.downloadResource",async p=>{const w=b.URI.file((0,l.join)((0,t.tmpdir)(),(0,C.generateUuid)()));return await E.$download(p,w),w})}};L=qe([xe(0,I.IExtHostRpcService),xe(1,P.IExtHostCommands)],L),e.ExtHostDownloadService=L}),define(De[269],Ie([1,0,136,12,193,34]),function(J,e,l,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class _ extends l.ExtHostLoggerService{doCreateLogger(b,I,L){return b.scheme===t.Schemas.file?new C.SpdLogLogger(L?.name||(0,P.generateUuid)(),b.fsPath,!L?.donotRotate,!!L?.donotUseFormatters,I):super.doCreateLogger(b,I,L)}}e.ExtHostLoggerService=_}),define(De[270],Ie([1,0,61,9,2,67,6,12,18,29]),function(J,e,l,t,C,P,_,D,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class L extends P.ExtensionStoragePaths{constructor(){super(...arguments),this._workspaceStorageLock=null}async _getWorkspaceStorageURI(n){const d=await super._getWorkspaceStorageURI(n);if(d.scheme!==D.Schemas.file)return d;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${d.fsPath}.`),d;const s=d.fsPath;let i=0;do{let r;i===0?r=s:r=/[/\\]$/.test(s)?`${s.substr(0,s.length-1)}-${i}`:`${s}-${i}`,await k(r);const c=t.join(r,"vscode.lock"),o=await p(this._logService,c,!1);if(o)return this._workspaceStorageLock=o,process.on("exit",()=>{o.dispose()}),C.URI.file(r);i++}while(i<10);return d}onWillDeactivateAll(){this._workspaceStorageLock?.setWillRelease(6e3)}}e.ExtensionStoragePaths=L;async function k(g){try{await I.Promises.stat(g);return}catch{}try{await I.Promises.mkdir(g,{recursive:!0})}catch{}}const S=1e3,T=10*60*1e3;class E extends _.Disposable{constructor(n,d){super(),this.logService=n,this.filename=d,this._timer=this._register(new b.IntervalTimer),this._timer.cancelAndSet(async()=>{const s=await w(n,d);(!s||s.pid!==process.pid)&&(n.info(`Lock '${d}': The lock was lost unexpectedly.`),this._timer.cancel());try{await I.Promises.utimes(d,new Date,new Date)}catch(i){n.error(i),n.info(`Lock '${d}': Could not update mtime.`)}},S)}dispose(){super.dispose();try{l.unlinkSync(this.filename)}catch{}}async setWillRelease(n){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${n} ms.`);try{const d={pid:process.pid,willReleaseAt:Date.now()+n};await I.Promises.writeFile(this.filename,JSON.stringify(d),{flag:"w"})}catch(d){this.logService.error(d)}}}async function p(g,n,d){try{const i={pid:process.pid,willReleaseAt:0};await I.Promises.writeFile(n,JSON.stringify(i),{flag:"wx"})}catch(i){g.error(i)}const s=await w(g,n);return!s||s.pid!==process.pid?d?(g.info(`Lock '${n}': Could not acquire lock, giving up.`),null):(g.info(`Lock '${n}': Could not acquire lock, checking if the file is stale.`),m(g,n)):(g.info(`Lock '${n}': Lock acquired.`),new E(g,n))}async function w(g,n){let d;try{d=await I.Promises.readFile(n)}catch(s){return g.error(s),null}try{return JSON.parse(String(d))}catch(s){return g.error(s),null}}async function f(g,n){let d;try{d=await I.Promises.stat(n)}catch(s){return g.error(s),0}return d.mtime.getTime()}function v(g){try{return process.kill(g,0),!0}catch{return!1}}async function m(g,n){const d=await w(g,n);if(!d)return g.info(`Lock '${n}': Could not read pid of lock holder.`),a(g,n);if(d.willReleaseAt){let o=d.willReleaseAt-Date.now();if(o<5e3){for(o>0?g.info(`Lock '${n}': The lockfile is scheduled to be released in ${o} ms.`):g.info(`Lock '${n}': The lockfile is scheduled to have been released.`);o>0;){if(await(0,b.timeout)(Math.min(100,o)),await f(g,n)===0)return a(g,n);o=d.willReleaseAt-Date.now()}return a(g,n)}}if(!v(d.pid))return g.info(`Lock '${n}': The pid ${d.pid} appears to be gone.`),a(g,n);const s=await f(g,n),i=Date.now()-s;if(i<=T)return g.info(`Lock '${n}': The lock does not look stale, elapsed: ${i} ms, giving up.`),null;g.info(`Lock '${n}': The lock looks stale, waiting for 2s.`),await(0,b.timeout)(2e3);const r=await f(g,n),c=Date.now()-r;return c<=T?(g.info(`Lock '${n}': The lock does not look stale, elapsed: ${c} ms, giving up.`),null):(g.info(`Lock '${n}': The lock looks stale even after waiting for 2s.`),a(g,n))}async function a(g,n){g.info(`Lock '${n}': Deleting a stale lock.`);try{await I.Promises.unlink(n)}catch{}return p(g,n,!0)}}),define(De[271],Ie([1,0,34,16,38]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let P=class extends C.BaseExtHostTerminalService{constructor(D){super(!0,D)}createTerminal(D,b,I){return this.createTerminalFromOptions({name:D,shellPath:b,shellArgs:I})}createTerminalFromOptions(D,b){const I=new C.ExtHostTerminal(this._proxy,(0,l.generateUuid)(),D,D.name);return this._terminals.push(I),I.create(D,this._serializeParentTerminal(D,b)),I.value}};P=qe([xe(0,t.IExtHostRpcService)],P),e.ExtHostTerminalService=P}),define(De[272],Ie([1,0,5,16,177,6,26,2,44,22,29,7,11,53,4,124,95,15]),function(J,e,l,t,C,P,_,D,b,I,L,k,S,T,E,p,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class v extends p.DisposableTunnel{}function m(o){const u=o.trim().split(`
`),h=[];return u.forEach(R=>{const M=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(R);M&&M.length>=3&&h.push({pid:parseInt(M[1],10),socket:parseInt(M[2],10)})}),h.reduce((R,M)=>(R[M.socket]=M,R),{})}e.getSockets=m;function a(...o){const u=[].concat(...o.map(n));return[...new Map(u.filter(h=>h.st==="0A").map(h=>{const y=h.local_address.split(":");return{socket:parseInt(h.inode,10),ip:g(y[0]),port:parseInt(y[1],16)}}).map(h=>[h.ip+":"+h.port,h])).values()]}e.loadListeningPorts=a;function g(o){let u="";if(o.length===8)for(let h=o.length-2;h>=0;h-=2)u+=parseInt(o.substr(h,2),16),h!==0&&(u+=".");else for(let h=o.length-4;h>=0;h-=4)u+=parseInt(o.substr(h,4),16).toString(16),h!==0&&(u+=":");return u}e.parseIpAddress=g;function n(o){const u=o.trim().split(`
`),h=u.shift().trim().split(/\s+/).filter(R=>R!=="rx_queue"&&R!=="tm->when");return u.map(R=>R.trim().split(/\s+/).reduce((M,U,A)=>(M[h[A]||A]=U,M),{}))}e.loadConnectionTable=n;function d(o){return!!o.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||o.indexOf("out/server-main.js")!==-1||o.indexOf("_productName=VSCode")!==-1}function s(o){const u=o.trim().split(`
`),h=[];return u.forEach(y=>{const R=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(y);R&&R.length>=4&&h.push({pid:parseInt(R[1],10),ppid:parseInt(R[2]),cmd:R[3]})}),h}e.getRootProcesses=s;async function i(o,u,h){const y=h.reduce((M,U)=>(M[U.pid]=U,M),{}),R=[];return o.forEach(({socket:M,ip:U,port:A})=>{const z=u[M]?u[M].pid:void 0,$=z?y[z]?.cmd:void 0;z&&$&&!d($)&&R.push({host:U,port:A,detail:$,pid:z})}),R}e.findPorts=i;function r(o,u,h){const y=new Map,R=s(u);for(const M of o){const U=h.get(M.port);if(U){y.set(M.port,U);continue}const A=R.find(z=>z.cmd.includes(`${M.port}`));if(A){let z=A,$;do $=R.find(N=>N.ppid===z.pid),$&&(z=$);while($);y.set(M.port,{host:M.ip,port:M.port,pid:z.pid,detail:z.cmd,ppid:z.ppid})}else y.set(M.port,{host:M.ip,port:M.port,ppid:Number.MAX_VALUE})}return y}e.tryFindRootPorts=r;let c=class extends P.Disposable{constructor(u,h,y){super(),this.logService=y,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new E.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=u.getProxy(l.MainContext.MainThreadTunnelService),S.isLinux&&h.remote.isRemote&&h.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(u,h){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${u.identifier.value} called openTunnel API for ${h.remoteAddress.host}:${h.remoteAddress.port}.`);const y=await this._proxy.$openTunnel(h,u.displayName);if(y){const R=new v(y.remoteAddress,y.localAddress,()=>this._proxy.$closeTunnel(y.remoteAddress));return this._register(R),R}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(u){return Math.max(u*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(u,h){const y=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(y,{selector:u,provider:h}),this._proxy.$registerPortsAttributesProvider(u,y),new k.Disposable(()=>{this._portAttributesProviders.delete(y),this._proxy.$unregisterPortsAttributesProvider(y)})}async $providePortAttributes(u,h,y,R,M){const U=[];for(const z of u){const $=this._portAttributesProviders.get(z);if(!$)return[];U.push(...await Promise.all(h.map(async N=>$.provider.providePortAttributes(N,y,R,M))))}const A=U.filter(z=>!!z);return A.length>0?A.map(z=>({autoForwardAction:z.autoForwardAction,port:z.port})):[]}async $registerCandidateFinder(u){if(u&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=u;const h=new w.MovingAverage;let y;for(;this._candidateFindingEnabled;){const R=new Date().getTime(),M=(await this.findCandidatePorts()).filter(A=>(0,p.isLocalhost)(A.host)||(0,p.isAllInterfaces)(A.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${M.map(A=>A.port).join(", ")}`);const U=new Date().getTime()-R;h.update(U),(!y||JSON.stringify(y)!==JSON.stringify(M))&&(y=M,await this._proxy.$onFoundNewCandidates(y)),await new Promise(A=>setTimeout(()=>A(),this.calculateDelay(h.value)))}}async setTunnelFactory(u){if(u){if(u.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(u.candidatePortSource),u.showCandidatePort&&(this._showCandidatePort=u.showCandidatePort,this._proxy.$setCandidateFilter()),u.tunnelFactory){this._forwardPortProvider=u.tunnelFactory;let h=u.tunnelFeatures?.privacyOptions??[];u.tunnelFeatures?.public&&h.length===0&&(h=[{id:"private",label:C.localize(0,null),themeIcon:"lock"},{id:"public",label:C.localize(1,null),themeIcon:"eye"}]);const y=u.tunnelFeatures?{elevation:!!u.tunnelFeatures?.elevation,public:!!u.tunnelFeatures?.public,privacyOptions:h}:void 0;this._proxy.$setTunnelProvider(y)}}else this._forwardPortProvider=void 0;return(0,P.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(u,h){if(this._extensionTunnels.has(u.host)){const y=this._extensionTunnels.get(u.host);y.has(u.port)&&(h&&y.get(u.port).disposeListener.dispose(),await y.get(u.port).tunnel.dispose(),y.delete(u.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(u,h){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const y=this._forwardPortProvider(u,h);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),y!==void 0){const R=await y;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(u.remoteAddress.host)||this._extensionTunnels.set(u.remoteAddress.host,new Map);const M=this._register(R.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(R.remoteAddress))));return this._extensionTunnels.get(u.remoteAddress.host).set(u.remoteAddress.port,{tunnel:R,disposeListener:M}),T.TunnelDtoConverter.fromApiTunnel(R)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(u){const h=await Promise.all(u.map(R=>this._showCandidatePort(R.host,R.port,R.detail??""))),y=u.filter((R,M)=>h[M]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${u.map(R=>R.port).join(", ")} to ${y.map(R=>R.port).join(", ")}`),y}async findCandidatePorts(){let u="",h="";try{u=await L.Promises.readFile("/proc/net/tcp","utf8"),h=await L.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const y=a(u,h),R=await new Promise(B=>{(0,b.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(O,x,V)=>{B(x)})}),M=m(R),U=await L.Promises.readdir("/proc"),A=[];for(const B of U)try{const O=Number(B),x=I.joinPath(D.URI.file("/proc"),B);if((await L.Promises.stat(x.fsPath)).isDirectory()&&!isNaN(O)){const q=await L.Promises.readlink(I.joinPath(x,"cwd").fsPath),Y=await L.Promises.readFile(I.joinPath(x,"cmdline").fsPath,"utf8");A.push({pid:O,cwd:q,cmd:Y})}}catch{}const z=[],$=y.filter(B=>{const O=M[B.socket];return O||z.push(B),O}),N=i($,M,A);let K;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${z.length}`),z.length>0){const B=await new Promise(O=>{(0,b.exec)("ps -F -A -l | grep root",(x,V,q)=>{O(V)})});this._foundRootPorts=r(z,B,this._foundRootPorts),K=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${K.join(", ")}`)}return N.then(B=>K?B.concat(K):B)}};c=qe([xe(0,t.IExtHostRpcService),xe(1,_.IExtHostInitDataService),xe(2,f.ILogService)],c),e.ExtHostTunnelService=c}),define(De[273],Ie([1,0,18,23,21,10,4,6,108,233,55]),function(J,e,l,t,C,P,_,D,b,I,L){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function S(y,R){try{return JSON.stringify(y,R)}catch{return"null"}}const T="$$ref$$",E={[T]:-1};class p{constructor(R,M){this.jsonString=R,this.referencedBuffers=M}}function w(y,R=null,M=!1){const U=[];return{jsonString:(M?S:JSON.stringify)(y,(z,$)=>{if(typeof $>"u")return E;if(typeof $=="object"){if($ instanceof t.VSBuffer){const N=U.push($)-1;return{[T]:N}}if(R)return R(z,$)}return $}),referencedBuffers:U}}e.stringifyJsonWithBufferRefs=w;function f(y,R,M){return JSON.parse(y,(U,A)=>{if(A){const z=A[T];if(typeof z=="number")return R[z];if(M&&A.$mid===1)return M.transformIncoming(A)}return A})}e.parseJsonAndRestoreBufferRefs=f;function v(y,R){return JSON.stringify(y,R)}function m(y){return y?(R,M)=>M&&M.$mid===1?y.transformOutgoing(M):M:null}var a;(function(y){y[y.LocalSide=0]="LocalSide",y[y.OtherSide=1]="OtherSide"})(a=e.RequestInitiator||(e.RequestInitiator={}));var g;(function(y){y[y.Responsive=0]="Responsive",y[y.Unresponsive=1]="Unresponsive"})(g=e.ResponsiveState||(e.ResponsiveState={}));const n=()=>{},d=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class i extends D.Disposable{constructor(R,M=null,U=null){super(),this[k]=!0,this._onDidChangeResponsiveState=this._register(new _.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=R,this._logger=M,this._uriTransformer=U,this._uriReplacer=m(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let A=0,z=L.ProxyIdentifier.count;A<z;A++)this._locals[A]=null,this._proxies[A]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new l.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(A=>this._receiveOneMessage(A))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(R=>{this._pendingRPCReplies[R].resolveErr(P.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(R){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(R){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(R){this._responsiveState!==R&&(this._responsiveState=R,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(R){return this._uriTransformer?(0,b.transformIncomingURIs)(R,this._uriTransformer):R}getProxy(R){const{nid:M,sid:U}=R;return this._proxies[M]||(this._proxies[M]=this._createProxy(M,U)),this._proxies[M]}_createProxy(R,M){const U={get:(A,z)=>(typeof z=="string"&&!A[z]&&z.charCodeAt(0)===36&&(A[z]=(...$)=>this._remoteCall(R,z,$)),z===s?M:A[z])};return new Proxy(Object.create(null),U)}set(R,M){return this._locals[R.nid]=M,M}assertRegistered(R){for(let M=0,U=R.length;M<U;M++){const A=R[M];if(!this._locals[A.nid])throw new Error(`Missing proxy instance ${A.sid}`)}}_receiveOneMessage(R){if(this._isDisposed)return;const M=R.byteLength,U=r.read(R,0),A=U.readUInt8(),z=U.readUInt32();switch(A){case 1:case 2:{let{rpcId:$,method:N,args:K}=o.deserializeRequestJSONArgs(U);this._uriTransformer&&(K=(0,b.transformIncomingURIs)(K,this._uriTransformer)),this._receiveRequest(M,z,$,N,K,A===2);break}case 3:case 4:{let{rpcId:$,method:N,args:K}=o.deserializeRequestMixedArgs(U);this._uriTransformer&&(K=(0,b.transformIncomingURIs)(K,this._uriTransformer)),this._receiveRequest(M,z,$,N,K,A===4);break}case 5:{this._logger?.logIncoming(M,z,0,"ack"),this._onDidReceiveAcknowledge(z);break}case 6:{this._receiveCancel(M,z);break}case 7:{this._receiveReply(M,z,void 0);break}case 9:{let $=o.deserializeReplyOKJSON(U);this._uriTransformer&&($=(0,b.transformIncomingURIs)($,this._uriTransformer)),this._receiveReply(M,z,$);break}case 10:{const $=o.deserializeReplyOKJSONWithBuffers(U,this._uriTransformer);this._receiveReply(M,z,$);break}case 8:{const $=o.deserializeReplyOKVSBuffer(U);this._receiveReply(M,z,$);break}case 11:{let $=o.deserializeReplyErrError(U);this._uriTransformer&&($=(0,b.transformIncomingURIs)($,this._uriTransformer)),this._receiveReplyErr(M,z,$);break}case 12:{this._receiveReplyErr(M,z,void 0);break}default:console.error("received unexpected message"),console.error(R)}}_receiveRequest(R,M,U,A,z,$){this._logger?.logIncoming(R,M,1,`receiveRequest ${(0,L.getStringIdentifierForProxy)(U)}.${A}(`,z);const N=String(M);let K,B;if($){const x=new C.CancellationTokenSource;z.push(x.token),K=this._invokeHandler(U,A,z),B=()=>x.cancel()}else K=this._invokeHandler(U,A,z),B=n;this._cancelInvokedHandlers[N]=B;const O=o.serializeAcknowledged(M);this._logger?.logOutgoing(O.byteLength,M,1,"ack"),this._protocol.send(O),K.then(x=>{delete this._cancelInvokedHandlers[N];const V=o.serializeReplyOK(M,x,this._uriReplacer);this._logger?.logOutgoing(V.byteLength,M,1,"reply:",x),this._protocol.send(V)},x=>{delete this._cancelInvokedHandlers[N];const V=o.serializeReplyErr(M,x);this._logger?.logOutgoing(V.byteLength,M,1,"replyErr:",x),this._protocol.send(V)})}_receiveCancel(R,M){this._logger?.logIncoming(R,M,1,"receiveCancel");const U=String(M);this._cancelInvokedHandlers[U]?.()}_receiveReply(R,M,U){this._logger?.logIncoming(R,M,0,"receiveReply:",U);const A=String(M);if(!this._pendingRPCReplies.hasOwnProperty(A))return;const z=this._pendingRPCReplies[A];delete this._pendingRPCReplies[A],z.resolveOk(U)}_receiveReplyErr(R,M,U){this._logger?.logIncoming(R,M,0,"receiveReplyErr:",U);const A=String(M);if(!this._pendingRPCReplies.hasOwnProperty(A))return;const z=this._pendingRPCReplies[A];delete this._pendingRPCReplies[A];let $;U&&(U.$isError?($=new Error,$.name=U.name,$.message=U.message,$.stack=U.stack):$=U),z.resolveErr($)}_invokeHandler(R,M,U){try{return Promise.resolve(this._doInvokeHandler(R,M,U))}catch(A){return Promise.reject(A)}}_doInvokeHandler(R,M,U){const A=this._locals[R];if(!A)throw new Error("Unknown actor "+(0,L.getStringIdentifierForProxy)(R));const z=A[M];if(typeof z!="function")throw new Error("Unknown method "+M+" on actor "+(0,L.getStringIdentifierForProxy)(R));return z.apply(A,U)}_remoteCall(R,M,U){if(this._isDisposed)return new I.CanceledLazyPromise;let A=null;if(U.length>0&&C.CancellationToken.isCancellationToken(U[U.length-1])&&(A=U.pop()),A&&A.isCancellationRequested)return Promise.reject(P.canceled());const z=o.serializeRequestArguments(U,this._uriReplacer),$=++this._lastMessageId,N=String($),K=new I.LazyPromise;A&&A.onCancellationRequested(()=>{const O=o.serializeCancel($);this._logger?.logOutgoing(O.byteLength,$,0,"cancel"),this._protocol.send(o.serializeCancel($))}),this._pendingRPCReplies[N]=K,this._onWillSendRequest($);const B=o.serializeRequest($,R,M,z,!!A);return this._logger?.logOutgoing(B.byteLength,$,0,`request: ${(0,L.getStringIdentifierForProxy)(R)}.${M}(`,U),this._protocol.send(B),K}}e.RPCProtocol=i,k=d,i.UNRESPONSIVE_TIME=3*1e3;class r{constructor(R,M){this._buff=R,this._offset=M}static alloc(R,M,U){const A=new r(t.VSBuffer.alloc(U+1+4),0);return A.writeUInt8(R),A.writeUInt32(M),A}static read(R,M){return new r(R,M)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(R){this._buff.writeUInt8(R,this._offset),this._offset+=1}readUInt8(){const R=this._buff.readUInt8(this._offset);return this._offset+=1,R}writeUInt32(R){this._buff.writeUInt32BE(R,this._offset),this._offset+=4}readUInt32(){const R=this._buff.readUInt32BE(this._offset);return this._offset+=4,R}static sizeShortString(R){return 1+R.byteLength}writeShortString(R){this._buff.writeUInt8(R.byteLength,this._offset),this._offset+=1,this._buff.set(R,this._offset),this._offset+=R.byteLength}readShortString(){const R=this._buff.readUInt8(this._offset);this._offset+=1;const U=this._buff.slice(this._offset,this._offset+R).toString();return this._offset+=R,U}static sizeLongString(R){return 4+R.byteLength}writeLongString(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}readLongString(){const R=this._buff.readUInt32BE(this._offset);this._offset+=4;const U=this._buff.slice(this._offset,this._offset+R).toString();return this._offset+=R,U}writeBuffer(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}static sizeVSBuffer(R){return 4+R.byteLength}writeVSBuffer(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}readVSBuffer(){const R=this._buff.readUInt32BE(this._offset);this._offset+=4;const M=this._buff.slice(this._offset,this._offset+R);return this._offset+=R,M}static sizeMixedArray(R){let M=0;M+=1;for(let U=0,A=R.length;U<A;U++){const z=R[U];switch(M+=1,z.type){case 1:M+=this.sizeLongString(z.value);break;case 2:M+=this.sizeVSBuffer(z.value);break;case 3:M+=this.sizeUInt32,M+=this.sizeLongString(z.value);for(let $=0;$<z.buffers.length;++$)M+=this.sizeVSBuffer(z.buffers[$]);break;case 4:break}}return M}writeMixedArray(R){this._buff.writeUInt8(R.length,this._offset),this._offset+=1;for(let M=0,U=R.length;M<U;M++){const A=R[M];switch(A.type){case 1:this.writeUInt8(1),this.writeLongString(A.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(A.value);break;case 3:this.writeUInt8(3),this.writeUInt32(A.buffers.length),this.writeLongString(A.value);for(let z=0;z<A.buffers.length;++z)this.writeBuffer(A.buffers[z]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const R=this._buff.readUInt8(this._offset);this._offset+=1;const M=new Array(R);for(let U=0;U<R;U++)switch(this.readUInt8()){case 1:M[U]=this.readLongString();break;case 2:M[U]=this.readVSBuffer();break;case 3:{const z=this.readUInt32(),$=this.readLongString(),N=[];for(let K=0;K<z;++K)N.push(this.readVSBuffer());M[U]=new L.SerializableObjectWithBuffers(f($,N,null));break}case 4:M[U]=void 0;break}return M}}r.sizeUInt32=4;var c;(function(y){y[y.Simple=0]="Simple",y[y.Mixed=1]="Mixed"})(c||(c={}));class o{static _useMixedArgSerialization(R){for(let M=0,U=R.length;M<U;M++)if(R[M]instanceof t.VSBuffer||R[M]instanceof L.SerializableObjectWithBuffers||typeof R[M]>"u")return!0;return!1}static serializeRequestArguments(R,M){if(this._useMixedArgSerialization(R)){const U=[];for(let A=0,z=R.length;A<z;A++){const $=R[A];if($ instanceof t.VSBuffer)U[A]={type:2,value:$};else if(typeof $>"u")U[A]={type:4};else if($ instanceof L.SerializableObjectWithBuffers){const{jsonString:N,referencedBuffers:K}=w($.value,M);U[A]={type:3,value:t.VSBuffer.fromString(N),buffers:K}}else U[A]={type:1,value:t.VSBuffer.fromString(v($,M))}}return{type:1,args:U}}return{type:0,args:v(R,M)}}static serializeRequest(R,M,U,A,z){switch(A.type){case 0:return this._requestJSONArgs(R,M,U,A.args,z);case 1:return this._requestMixedArgs(R,M,U,A.args,z)}}static _requestJSONArgs(R,M,U,A,z){const $=t.VSBuffer.fromString(U),N=t.VSBuffer.fromString(A);let K=0;K+=r.sizeUInt8(),K+=r.sizeShortString($),K+=r.sizeLongString(N);const B=r.alloc(z?2:1,R,K);return B.writeUInt8(M),B.writeShortString($),B.writeLongString(N),B.buffer}static deserializeRequestJSONArgs(R){const M=R.readUInt8(),U=R.readShortString(),A=R.readLongString();return{rpcId:M,method:U,args:JSON.parse(A)}}static _requestMixedArgs(R,M,U,A,z){const $=t.VSBuffer.fromString(U);let N=0;N+=r.sizeUInt8(),N+=r.sizeShortString($),N+=r.sizeMixedArray(A);const K=r.alloc(z?4:3,R,N);return K.writeUInt8(M),K.writeShortString($),K.writeMixedArray(A),K.buffer}static deserializeRequestMixedArgs(R){const M=R.readUInt8(),U=R.readShortString(),A=R.readMixedArray(),z=new Array(A.length);for(let $=0,N=A.length;$<N;$++){const K=A[$];typeof K=="string"?z[$]=JSON.parse(K):z[$]=K}return{rpcId:M,method:U,args:z}}static serializeAcknowledged(R){return r.alloc(5,R,0).buffer}static serializeCancel(R){return r.alloc(6,R,0).buffer}static serializeReplyOK(R,M,U){if(typeof M>"u")return this._serializeReplyOKEmpty(R);if(M instanceof t.VSBuffer)return this._serializeReplyOKVSBuffer(R,M);if(M instanceof L.SerializableObjectWithBuffers){const{jsonString:A,referencedBuffers:z}=w(M.value,U,!0);return this._serializeReplyOKJSONWithBuffers(R,A,z)}else return this._serializeReplyOKJSON(R,S(M,U))}static _serializeReplyOKEmpty(R){return r.alloc(7,R,0).buffer}static _serializeReplyOKVSBuffer(R,M){let U=0;U+=r.sizeVSBuffer(M);const A=r.alloc(8,R,U);return A.writeVSBuffer(M),A.buffer}static deserializeReplyOKVSBuffer(R){return R.readVSBuffer()}static _serializeReplyOKJSON(R,M){const U=t.VSBuffer.fromString(M);let A=0;A+=r.sizeLongString(U);const z=r.alloc(9,R,A);return z.writeLongString(U),z.buffer}static _serializeReplyOKJSONWithBuffers(R,M,U){const A=t.VSBuffer.fromString(M);let z=0;z+=r.sizeUInt32,z+=r.sizeLongString(A);for(const N of U)z+=r.sizeVSBuffer(N);const $=r.alloc(10,R,z);$.writeUInt32(U.length),$.writeLongString(A);for(const N of U)$.writeBuffer(N);return $.buffer}static deserializeReplyOKJSON(R){const M=R.readLongString();return JSON.parse(M)}static deserializeReplyOKJSONWithBuffers(R,M){const U=R.readUInt32(),A=R.readLongString(),z=[];for(let $=0;$<U;++$)z.push(R.readVSBuffer());return new L.SerializableObjectWithBuffers(f(A,z,M))}static serializeReplyErr(R,M){const U=M?S(P.transformErrorForSerialization(M),null):void 0;if(typeof U!="string")return this._serializeReplyErrEmpty(R);const A=t.VSBuffer.fromString(U);let z=0;z+=r.sizeLongString(A);const $=r.alloc(11,R,z);return $.writeLongString(A),$.buffer}static deserializeReplyErrError(R){const M=R.readLongString();return JSON.parse(M)}static _serializeReplyErrEmpty(R){return r.alloc(12,R,0).buffer}}var u;(function(y){y[y.RequestJSONArgs=1]="RequestJSONArgs",y[y.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",y[y.RequestMixedArgs=3]="RequestMixedArgs",y[y.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",y[y.Acknowledged=5]="Acknowledged",y[y.Cancel=6]="Cancel",y[y.ReplyOKEmpty=7]="ReplyOKEmpty",y[y.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",y[y.ReplyOKJSON=9]="ReplyOKJSON",y[y.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",y[y.ReplyErrError=11]="ReplyErrError",y[y.ReplyErrEmpty=12]="ReplyErrEmpty"})(u||(u={}));var h;(function(y){y[y.String=1]="String",y[y.VSBuffer=2]="VSBuffer",y[y.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",y[y.Undefined=4]="Undefined"})(h||(h={}))}),define(De[274],Ie([1,0,4,43,52,3,42,10,18]),function(J,e,l,t,C,P,_,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new C.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new C.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new C.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,P.createDecorator)(e.OUTPUT_SERVICE_ID);var I;(function(T){T[T.Append=1]="Append",T[T.Replace=2]="Replace",T[T.Clear=3]="Clear"})(I=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class L{constructor(){this.channels=new Map,this._onDidRegisterChannel=new l.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new l.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(E){this.channels.has(E.id)||(this.channels.set(E.id,E),this._onDidRegisterChannel.fire(E.id))}getChannels(){const E=[];return this.channels.forEach(p=>E.push(p)),E}getChannel(E){return this.channels.get(E)}removeChannel(E){this.channels.delete(E),this._onDidRemoveChannel.fire(E)}}t.Registry.add(e.Extensions.OutputChannels,new L);function k(T,E,p,w,f){return(0,b.createCancelablePromise)(async v=>{await(0,_.whenProviderRegistered)(p,w);const m=t.Registry.as(e.Extensions.OutputChannels);try{await S(p,1,w,f,v),m.registerChannel({id:T,label:E,file:p,log:!0})}catch(a){(0,D.isCancellationError)(a)||f.error("Error while registering log channel",p.toString(),(0,D.getErrorMessage)(a))}})}e.registerLogChannel=k;async function S(T,E,p,w,f){if(!await p.exists(T)){if(f.isCancellationRequested)throw new D.CancellationError;if(E>10)throw new Error("Timed out while waiting for file to be created");w.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",T.toString()),await(0,b.timeout)(1e3,f),await S(T,E+1,p,w,f)}}}),define(De[139],Ie([1,0,5,6,3,16,15,274,66,26,46,152,23,14]),function(J,e,l,t,C,P,_,D,b,I,L,k,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class E extends t.Disposable{constructor(f,v,m,a){super(),this.id=f,this.name=v,this.logger=m,this.proxy=a,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(f){this.append(f+`
`)}append(f){this.write(f),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,D.OutputChannelUpdateMode.Append))}clear(){const f=this.offset;this.logger.flush(),this.proxy.$update(this.id,D.OutputChannelUpdateMode.Clear,f)}replace(f){const v=this.offset;this.write(f),this.proxy.$update(this.id,D.OutputChannelUpdateMode.Replace,v),this.visible&&this.logger.flush()}show(f,v){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof f=="boolean"?f:v))}hide(){this.proxy.$close(this.id)}write(f){this.offset+=S.VSBuffer.fromString(f).byteLength,this.logger.info(f)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=E;let p=class{constructor(f,v,m,a,g){this.extHostFileSystem=m,this.extHostFileSystemInfo=a,this.loggerService=g,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=f.getProxy(l.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(v.logsLocation,`output_logging_${(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(f){this.visibleChannelId=f;for(const[v,m]of this.channels)m.visible=v===this.visibleChannelId}createOutputChannel(f,v,m){if(f=f.trim(),!f)throw new Error("illegal argument `name`. must not be falsy");if((0,T.isString)(v)&&!v.trim())throw new Error("illegal argument `languageId`. must not be empty");const a=this.doCreateOutputChannel(f,v,m);return a.then(g=>{this.channels.set(g.id,g),g.visible=g.id===this.visibleChannelId}),this.createExtHostOutputChannel(f,a)}async doCreateOutputChannel(f,v,m){const a=await this.createOutputDirectory(),g=this.extHostFileSystemInfo.extUri.joinPath(a,`${this.namePool++}-${f.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),n=this.loggerService.createLogger(g,{always:!0,donotRotate:!0,donotUseFormatters:!0}),d=await this.proxy.$register(f,!1,g,v,m.identifier.value);return new E(d,f,n,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(f,v){let m=!1;const a=()=>{if(m)throw new Error("Channel has been closed")};return{get name(){return f},append(g){a(),v.then(n=>n.append(g))},appendLine(g){a(),v.then(n=>n.appendLine(g))},clear(){a(),v.then(g=>g.clear())},replace(g){a(),v.then(n=>n.replace(g))},show(g,n){a(),v.then(d=>d.show(g,n))},hide(){a(),v.then(g=>g.hide())},dispose(){m=!0,v.then(g=>g.dispose())}}}};p=qe([xe(0,P.IExtHostRpcService),xe(1,I.IExtHostInitDataService),xe(2,b.IExtHostConsumerFileSystem),xe(3,L.IExtHostFileSystemInfo),xe(4,_.ILoggerService)],p),e.ExtHostOutputService=p,e.IExtHostOutputService=(0,C.createDecorator)("IExtHostOutputService")}),define(De[275],Ie([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,l.createDecorator)("remoteAgentService")}),define(De[276],Ie([1,0,31,12,9,11,22,2,3,202,45,219,275]),function(J,e,l,t,C,P,_,D,b,I,L,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,b.createDecorator)("pathService");let T=class ei{constructor(p,w,f,v){this.localUserHome=p,this.remoteAgentService=w,this.environmentService=f,this.contextService=v,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||P.OS)(),this.resolveUserHome=(async()=>{const m=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=m?.userHome??p})()}hasValidBasename(p,w,f){return typeof w=="string"||typeof w>"u"?this.resolveOS.then(v=>this.doHasValidBasename(p,v,w)):this.doHasValidBasename(p,w,f)}doHasValidBasename(p,w,f){return p.scheme===t.Schemas.file||p.scheme===t.Schemas.vscodeRemote?(0,l.isValidBasename)(f??(0,_.basename)(p),w===1):!0}get defaultUriScheme(){return ei.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(p,w){if(p.remoteAuthority)return t.Schemas.vscodeRemote;const f=(0,I.getVirtualWorkspaceScheme)(w.getWorkspace());if(f)return f;const v=w.getWorkspace().folders[0];if(v)return v.uri.scheme;const m=w.getWorkspace().configuration;return m?m.scheme:t.Schemas.file}userHome(p){return p?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(p=>p===1?C.win32:C.posix)}async fileURI(p){let w="";if(await this.resolveOS===1&&(p=p.replace(/\\/g,"/")),p[0]==="/"&&p[1]==="/"){const v=p.indexOf("/",2);v===-1?(w=p.substring(2),p="/"):(w=p.substring(2,v),p=p.substring(v)||"/")}return D.URI.from({scheme:t.Schemas.file,authority:w,path:p,query:"",fragment:""})}};T=qe([xe(1,S.IRemoteAgentService),xe(2,k.IWorkbenchEnvironmentService),xe(3,L.IWorkspaceContextService)],T),e.AbstractPathService=T}),define(De[69],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class l{constructor(_,D){this.line=_,this.character=D}isBefore(_){return!1}isBeforeOrEqual(_){return!1}isAfter(_){return!1}isAfterOrEqual(_){return!1}isEqual(_){return!1}compareTo(_){return 0}translate(_,D){return new l(0,0)}with(_){return new l(0,0)}}e.Position=l;class t{constructor(_,D,b,I){this.isEmpty=!1,this.isSingleLine=!1,this.start=new l(_,D),this.end=new l(b,I)}contains(_){return!1}isEqual(_){return!1}intersection(_){}union(_){return new t(0,0,0,0)}with(_){return new t(0,0,0,0)}}e.Range=t;var C;(function(P){P[P.Information=1]="Information",P[P.Warning=2]="Warning"})(C=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(De[30],Ie([1,0,17,36,24,31,8,3,9,10,69,18]),function(J,e,l,t,C,P,_,D,b,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const S="\u27EA ",T=" characters skipped \u27EB",E=(S.length+T.length+5)*2;e.ISearchService=(0,D.createDecorator)("searchService");var p;(function(q){q[q.file=0]="file",q[q.text=1]="text"})(p=e.SearchProviderType||(e.SearchProviderType={}));var w;(function(q){q[q.File=1]="File",q[q.Text=2]="Text"})(w=e.QueryType||(e.QueryType={}));function f(q){return!!q.preview}e.resultIsMatch=f;function v(q){return!!q.resource}e.isFileMatch=v;function m(q){return!!q.message}e.isProgressMessage=m;var a;(function(q){q[q.Normal=0]="Normal",q[q.NewSearchStarted=1]="NewSearchStarted"})(a=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class g{constructor(Y){this.resource=Y,this.results=[]}}e.FileMatch=g;class n{constructor(Y,Q,de){this.ranges=Q;const ve=Array.isArray(Q)?Q:[Q];if(de&&de.matchLines===1&&d(ve)){Y=(0,_.getNLines)(Y,de.matchLines);let ne="",pe=0,be=0;const ke=Math.floor(de.charsPerLine/5),Oe=[];for(const We of ve){const oe=Math.max(We.startColumn-ke,0),le=We.startColumn+de.charsPerLine;if(oe>be+ke+E){const fe=S+(oe-be)+T;ne+=fe+Y.slice(oe,le),pe+=oe-(be+fe.length)}else ne+=Y.slice(be,le);Oe.push(new i(0,We.startColumn-pe,We.endColumn-pe)),be=le}this.preview={text:ne,matches:Array.isArray(this.ranges)?Oe:Oe[0]}}else{const ne=Array.isArray(Q)?Q[0].startLineNumber:Q.startLineNumber;this.preview={text:Y,matches:(0,l.mapArrayOrNot)(Q,pe=>new s(pe.startLineNumber-ne,pe.startColumn,pe.endLineNumber-ne,pe.endColumn))}}}}e.TextSearchMatch=n;function d(q){const Y=q[0].startLineNumber;for(const Q of q)if(Q.startLineNumber!==Y||Q.endLineNumber!==Y)return!1;return!0}class s{constructor(Y,Q,de,ve){this.startLineNumber=Y,this.startColumn=Q,this.endLineNumber=de,this.endColumn=ve}}e.SearchRange=s;class i extends s{constructor(Y,Q,de){super(Y,Q,Y,de)}}e.OneLineRange=i;var r;(function(q){q.Default="default",q.FileNames="fileNames",q.Type="type",q.Modified="modified",q.CountDescending="countDescending",q.CountAscending="countAscending"})(r=e.SearchSortOrder||(e.SearchSortOrder={}));function c(q,Y=!0){const Q=q&&q.files&&q.files.exclude,de=Y&&q&&q.search&&q.search.exclude;if(!Q&&!de)return;if(!Q||!de)return Q||de;let ve=Object.create(null);return ve=C.mixin(ve,C.deepClone(Q)),ve=C.mixin(ve,C.deepClone(de),!0),ve}e.getExcludes=c;function o(q,Y){return q.excludePattern&&t.match(q.excludePattern,Y)?!1:q.includePattern||q.usingSearchPaths?q.includePattern&&t.match(q.includePattern,Y)?!0:q.usingSearchPaths?!!q.folderQueries&&q.folderQueries.some(Q=>{const de=Q.folder.fsPath;if(P.isEqualOrParent(Y,de)){const ve=b.relative(de,Y);return!Q.includePattern||!!t.match(Q.includePattern,ve)}else return!1}):!1:!0}e.pathIncludedInQuery=o;var u;(function(q){q[q.unknownEncoding=1]="unknownEncoding",q[q.regexParseError=2]="regexParseError",q[q.globParseError=3]="globParseError",q[q.invalidLiteral=4]="invalidLiteral",q[q.rgProcessError=5]="rgProcessError",q[q.other=6]="other",q[q.canceled=7]="canceled"})(u=e.SearchErrorCode||(e.SearchErrorCode={}));class h extends Error{constructor(Y,Q){super(Y),this.code=Q}}e.SearchError=h;function y(q){const Y=q.message;if((0,I.isCancellationError)(q))return new h(Y,u.canceled);try{const Q=JSON.parse(Y);return new h(Q.message,Q.code)}catch{return new h(Y,u.other)}}e.deserializeSearchError=y;function R(q){const Y={message:q.message,code:q.code};return new Error(JSON.stringify(Y))}e.serializeSearchError=R;function M(q){return q.type==="error"?!0:q.type==="success"}e.isSerializedSearchComplete=M;function U(q){return q.type==="success"}e.isSerializedSearchSuccess=U;function A(q){return!!q.path}e.isSerializedFileMatch=A;function z(q,Y){const Q=q.searchPath?q.searchPath:q.relativePath;return(0,_.fuzzyContains)(Q,Y)}e.isFilePatternMatch=z;class ${constructor(Y){this.path=Y,this.results=[]}addMatch(Y){this.results.push(Y)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=$;function N(q,Y){const Q={...q||{},...Y||{}};return Object.keys(Q).filter(de=>{const ve=Q[de];return typeof ve=="boolean"&&ve})}e.resolvePatternsForProvider=N;class K{constructor(Y,Q){this._parsedIncludeExpression=null,this._excludeExpression={...Y.excludePattern||{},...Q.excludePattern||{}},this._parsedExcludeExpression=t.parse(this._excludeExpression);let de=Y.includePattern;Q.includePattern&&(de?de={...de,...Q.includePattern}:de=Q.includePattern),de&&(this._parsedIncludeExpression=t.parse(de))}matchesExcludesSync(Y,Q,de){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(Y,Q,de))}includedInQuerySync(Y,Q,de){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(Y,Q,de)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(Y,Q,de))}includedInQuery(Y,Q,de){const ve=this._parsedExcludeExpression(Y,Q,de),ne=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(Y,Q,de):!0;return(0,k.isThenable)(ve)?ve.then(pe=>pe?!1:ne()):ne()}hasSiblingExcludeClauses(){return B(this._excludeExpression)}}e.QueryGlobTester=K;function B(q){for(const Y in q)if(typeof q[Y]!="boolean")return!0;return!1}function O(q){if(!q)return;let Y;return Q=>(Y||(Y=(q()||Promise.resolve([])).then(de=>de?V(de):{})),Y.then(de=>!!de[Q]))}e.hasSiblingPromiseFn=O;function x(q){if(!q)return;let Y;return Q=>{if(!Y){const de=q();Y=de?V(de):{}}return!!Y[Q]}}e.hasSiblingFn=x;function V(q){const Y={};for(const Q of q)Y[Q]=!0;return Y}}),define(De[32],Ie([1,0,17,18,21,4,6,25,12,95,22,8,14,2,175,3,15,194,45,46,26,16,13,7,54,30,5]),function(J,e,l,t,C,P,_,D,b,I,L,k,S,T,E,p,w,f,v,m,a,g,n,d,s,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function c(A,z,$){return new L.ExtUri(N=>y(N,$)).isEqual(A,z)}function o(A,z,$){return c(A.uri,z.uri,$)?0:(0,k.compare)(A.uri.toString(),z.uri.toString())}function u(A,z,$){return A.index!==z.index?A.index<z.index?-1:1:c(A.uri,z.uri,$)?(0,k.compare)(A.name,z.name):(0,k.compare)(A.uri.toString(),z.uri.toString())}function h(A,z,$,N){const K=A.slice(0).sort((O,x)=>$(O,x,N)),B=z.slice(0).sort((O,x)=>$(O,x,N));return(0,l.delta)(K,B,(O,x)=>$(O,x,N))}function y(A,z){const $=z.getCapabilities(A.scheme);return!($&&$&1024)}class R extends v.Workspace{constructor(z,$,N,K,B,O,x){super(z,N.map(V=>new v.WorkspaceFolder(V)),K,B,x),this._name=$,this._isUntitled=O,this._workspaceFolders=[],this._structure=D.TernarySearchTree.forUris(x),N.forEach(V=>{this._workspaceFolders.push(V),this._structure.set(V.uri,V)})}static toExtHostWorkspace(z,$,N,K){if(!z)return{workspace:null,added:[],removed:[]};const{id:B,name:O,folders:x,configuration:V,transient:q,isUntitled:Y}=z,Q=[],de=$;$?x.forEach((be,ke)=>{const Oe=T.URI.revive(be.uri),We=R._findFolder(N||$,Oe,K);We?(We.name=be.name,We.index=be.index,Q.push(We)):Q.push({uri:Oe,name:be.name,index:ke})}):Q.push(...x.map(({uri:be,name:ke,index:Oe})=>({uri:T.URI.revive(be),name:ke,index:Oe}))),Q.sort((be,ke)=>be.index<ke.index?-1:1);const ve=new R(B,O,Q,!!q,V?T.URI.revive(V):null,!!Y,be=>y(be,K)),{added:ne,removed:pe}=h(de?de.workspaceFolders:[],ve.workspaceFolders,o,K);return{workspace:ve,added:ne,removed:pe}}static _findFolder(z,$,N){for(let K=0;K<z.folders.length;K++){const B=z.workspaceFolders[K];if(c(B.uri,$,N))return B}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(z,$){return $&&this._structure.get(z)&&(z=(0,L.dirname)(z)),this._structure.findSubstr(z)}resolveWorkspaceFolder(z){return this._structure.get(z)}}let M=class{constructor(z,$,N,K,B){this._onDidChangeWorkspace=new P.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new P.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._logService=K,this._extHostFileSystemInfo=N,this._uriTransformerService=B,this._requestIdProvider=new I.Counter,this._barrier=new t.Barrier,this._proxy=z.getProxy(r.MainContext.MainThreadWorkspace),this._messageService=z.getProxy(r.MainContext.MainThreadMessageService);const O=$.workspace;this._confirmedWorkspace=O?new R(O.id,O.name,[],!!O.transient,O.configuration?T.URI.revive(O.configuration):null,!!O.isUntitled,x=>y(x,N)):void 0}$initializeWorkspace(z,$){this._trusted=$,this.$acceptWorkspaceData(z),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?T.URI.from({scheme:b.Schemas.untitled,path:(0,L.basename)((0,L.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(z,$,N,...K){const B=[];if(Array.isArray(K)&&K.forEach(Y=>{T.URI.isUri(Y.uri)&&!B.some(Q=>c(Q.uri,Y.uri,this._extHostFileSystemInfo))&&B.push({uri:Y.uri,name:Y.name||(0,L.basenameOrAuthority)(Y.uri)})}),this._unconfirmedWorkspace||[$,N].some(Y=>typeof Y!="number"||Y<0)||N===0&&B.length===0)return!1;const O=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if($+N>O.length)return!1;const x=O.slice(0);x.splice($,N,...B.map(Y=>({uri:Y.uri,name:Y.name||(0,L.basenameOrAuthority)(Y.uri),index:void 0})));for(let Y=0;Y<x.length;Y++){const Q=x[Y];if(x.some((de,ve)=>ve!==Y&&c(Q.uri,de.uri,this._extHostFileSystemInfo)))return!1}x.forEach((Y,Q)=>Y.index=Q);const{added:V,removed:q}=h(O,x,u,this._extHostFileSystemInfo);if(V.length===0&&q.length===0)return!1;if(this._proxy){const Y=z.displayName||z.name;this._proxy.$updateWorkspaceFolders(Y,$,N,B).then(void 0,Q=>{this._unconfirmedWorkspace=void 0;const de={source:{identifier:z.identifier,label:z.displayName||z.name}};this._messageService.$showMessage(f.Severity.Error,(0,E.localize)(0,null,Y,Q.toString()),de,[])})}return this.trySetWorkspaceFolders(x),!0}getWorkspaceFolder(z,$){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(z,$)}async getWorkspaceFolder2(z,$){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(z,$)}async resolveWorkspaceFolder(z){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(z)}getPath(){if(!this._actualWorkspace)return;const{folders:z}=this._actualWorkspace;if(z.length!==0)return z[0].uri.fsPath}getRelativePath(z,$){let N,K="";if(typeof z=="string"?(N=T.URI.file(z),K=z):typeof z<"u"&&(N=z,K=z.fsPath),!N)return K;const B=this.getWorkspaceFolder(N,!0);if(!B)return K;typeof $>"u"&&this._actualWorkspace&&($=this._actualWorkspace.folders.length>1);let O=(0,L.relativePath)(B.uri,N);return $&&B.name&&(O=`${B.name}/${O}`),O}trySetWorkspaceFolders(z){this._actualWorkspace&&(this._unconfirmedWorkspace=R.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:z,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(z){const{workspace:$,added:N,removed:K}=R.toExtHostWorkspace(z,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=$||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:N,removed:K}))}findFiles(z,$,N,K,B=C.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${K.value}, entryPoint: findFiles`);let O;if($===null?O=!1:$&&(typeof $=="string"?O=$:O=$.pattern),B&&B.isCancellationRequested)return Promise.resolve([]);const{includePattern:x,folder:V}=U(n.GlobPattern.from(z));return this._proxy.$startFileSearch((0,S.withUndefinedAsNull)(x),(0,S.withUndefinedAsNull)(V),(0,S.withUndefinedAsNull)(O),(0,S.withUndefinedAsNull)(N),B).then(q=>Array.isArray(q)?q.map(Y=>T.URI.revive(Y)):[])}async findTextInFiles(z,$,N,K,B=C.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${K.value}, entryPoint: findTextInFiles`);const O=this._requestIdProvider.getNext(),x=typeof $.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:$.previewOptions,{includePattern:V,folder:q}=U(n.GlobPattern.from($.include)),Y=typeof $.exclude=="string"?$.exclude:$.exclude?$.exclude.pattern:void 0,Q={ignoreSymlinks:typeof $.followSymlinks=="boolean"?!$.followSymlinks:void 0,disregardIgnoreFiles:typeof $.useIgnoreFiles=="boolean"?!$.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof $.useGlobalIgnoreFiles=="boolean"?!$.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof $.useParentIgnoreFiles=="boolean"?!$.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof $.useDefaultExcludes=="boolean"?!$.useDefaultExcludes:!0,fileEncoding:$.encoding,maxResults:$.maxResults,previewOptions:x,afterContext:$.afterContext,beforeContext:$.beforeContext,includePattern:V,excludePattern:Y},de=!1;if(this._activeSearchCallbacks[O]=ve=>{if(de)return;const ne=T.URI.revive(ve.resource);ve.results.forEach(pe=>{(0,i.resultIsMatch)(pe)?N({uri:ne,preview:{text:pe.preview.text,matches:(0,l.mapArrayOrNot)(pe.preview.matches,be=>new d.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))},ranges:(0,l.mapArrayOrNot)(pe.ranges,be=>new d.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))}):N({uri:ne,text:pe.text,lineNumber:pe.lineNumber})})},B.isCancellationRequested)return{};try{const ve=await this._proxy.$startTextSearch(z,(0,S.withUndefinedAsNull)(q),Q,O,B);return delete this._activeSearchCallbacks[O],ve||{}}catch(ve){throw delete this._activeSearchCallbacks[O],ve}}$handleTextSearchResult(z,$){this._activeSearchCallbacks[$]?.(z)}saveAll(z){return this._proxy.$saveAll(z)}resolveProxy(z){return this._proxy.$resolveProxy(z)}get trusted(){return this._trusted}requestWorkspaceTrust(z){return this._proxy.$requestWorkspaceTrust(z)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(z,$){if(this._editSessionIdentityProviders.has(z))throw new Error(`A provider has already been registered for scheme ${z}`);this._editSessionIdentityProviders.set(z,$);const N=this._uriTransformerService.transformOutgoingScheme(z),K=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(K,N),(0,_.toDisposable)(()=>{this._editSessionIdentityProviders.delete(z),this._proxy.$unregisterEditSessionIdentityProvider(K)})}async $getEditSessionIdentifier(z,$){this._logService.info("Getting edit session identifier for workspaceFolder",z);const N=await this.resolveWorkspaceFolder(T.URI.revive(z));if(!N){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const K=this._editSessionIdentityProviders.get(N.uri.scheme);if(this._logService.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!K),!K)return;const B=await K.provideEditSessionIdentity(N,$);if(this._logService.info("Provider returned edit session identifier: ",B),!!B)return B}};M=qe([xe(0,g.IExtHostRpcService),xe(1,a.IExtHostInitDataService),xe(2,m.IExtHostFileSystemInfo),xe(3,w.ILogService),xe(4,s.IURITransformerService)],M),e.ExtHostWorkspace=M,e.IExtHostWorkspace=(0,p.createDecorator)("IExtHostWorkspace");function U(A){let z,$;return A&&(typeof A=="string"?z=A:(z=A.pattern,$=T.URI.revive(A.baseUri))),{includePattern:z,folder:$}}}),define(De[33],Ie([1,0,24,4,32,5,7,197,121,14,18,3,16,15,2]),function(J,e,l,t,C,P,_,D,b,I,L,k,S,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function p(d,s){if(s){const i=s.split(".");let r=d;for(let c=0;r&&c<i.length;c++)r=r[i[c]];return r}}function w(d){return d instanceof E.URI}function f(d){return d&&d.uri instanceof E.URI&&d.languageId&&typeof d.languageId=="string"}function v(d){return d&&!d.uri&&d.languageId&&typeof d.languageId=="string"}function m(d){return d&&d.uri instanceof E.URI&&(!d.name||typeof d.name=="string")&&(!d.index||typeof d.index=="number")}function a(d){if(w(d))return{resource:d};if(f(d))return{resource:d.uri,overrideIdentifier:d.languageId};if(v(d))return{overrideIdentifier:d.languageId};if(m(d))return{resource:d.uri};if(d===null)return{resource:null}}let g=class{constructor(s,i,r){this._proxy=s.getProxy(P.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=r,this._barrier=new L.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new n(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,i){this.getConfigProvider().then(r=>r.$acceptConfigurationChanged(s,i))}};g=qe([xe(0,S.IExtHostRpcService),xe(1,C.IExtHostWorkspace),xe(2,T.ILogService)],g),e.ExtHostConfiguration=g;class n{constructor(s,i,r,c){this._onDidChangeConfiguration=new t.Emitter,this._proxy=s,this._logService=c,this._extHostWorkspace=i,this._configuration=D.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,i){const r={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=D.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,r))}getConfiguration(s,i,r){const c=a(i)||{},o=this._toReadonlyValue(s?p(this._configuration.getValue(void 0,c,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,c,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,c,r?.identifier);function u(y){if(y==null)return null;if(typeof y=="boolean")return y?2:5;switch(y){case _.ConfigurationTarget.Global:return 2;case _.ConfigurationTarget.Workspace:return 5;case _.ConfigurationTarget.WorkspaceFolder:return 6}}const h={has(y){return typeof p(o,y)<"u"},get:(y,R)=>{this._validateConfigurationAccess(s?`${s}.${y}`:y,c,r?.identifier);let M=p(o,y);if(typeof M>"u")M=R;else{let U;const A=(z,$)=>{let N;const K=()=>{U=U||(0,l.deepClone)(o),N=N||p(U,$)};return(0,I.isObject)(z)?new Proxy(z,{get:(B,O)=>{if(typeof O=="string"&&O.toLowerCase()==="tojson")return K(),()=>N;if(U)return N=N||p(U,$),N[O];const x=B[O];return typeof O=="string"?A(x,`${$}.${O}`):x},set:(B,O,x)=>(K(),N&&(N[O]=x),!0),deleteProperty:(B,O)=>(K(),N&&delete N[O],!0),defineProperty:(B,O,x)=>(K(),N&&Object.defineProperty(N,O,x),!0)}):z};M=A(M,y)}return M},update:(y,R,M,U)=>{y=s?`${s}.${y}`:y;const A=u(M);return R!==void 0?this._proxy.$updateConfigurationOption(A,y,R,c,U):this._proxy.$removeConfigurationOption(A,y,c,U)},inspect:y=>{y=s?`${s}.${y}`:y;const R=(0,l.deepClone)(this._configuration.inspect(y,c,this._extHostWorkspace.workspace));if(R)return{key:y,defaultValue:R.policy?.value??R.default?.value,globalValue:R.user?.value??R.application?.value,workspaceValue:R.workspace?.value,workspaceFolderValue:R.workspaceFolder?.value,defaultLanguageValue:R.default?.override,globalLanguageValue:R.user?.override??R.application?.override,workspaceLanguageValue:R.workspace?.override,workspaceFolderLanguageValue:R.workspaceFolder?.override,languageIds:R.overrideIdentifiers}}};return typeof o=="object"&&(0,l.mixin)(h,o,!1),Object.freeze(h)}_toReadonlyValue(s){const i=r=>(0,I.isObject)(r)?new Proxy(r,{get:(c,o)=>i(c[o]),set:(c,o,u)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(o)}' of object`)},deleteProperty:(c,o)=>{throw new Error(`TypeError: Cannot delete read only property '${String(o)}' of object`)},defineProperty:(c,o)=>{throw new Error(`TypeError: Cannot define property '${String(o)}' for a readonly object`)},setPrototypeOf:c=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):r;return i(s)}_validateConfigurationAccess(s,i,r){const c=b.OVERRIDE_PROPERTY_REGEX.test(s)?4:this._configurationScopes.get(s),o=r?`[${r.value}] `:"";if(c===4){typeof i?.resource>"u"&&this._logService.warn(`${o}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(c===3){i?.resource&&this._logService.warn(`${o}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,i){const r=new D.ConfigurationChangeEvent(s,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(c,o)=>r.affectsConfiguration(c,a(o))})}_toMap(s){return s.reduce((i,r)=>(i.set(r[0],r[1]),i),new Map)}}e.ExtHostConfigProvider=n,e.IExtHostConfiguration=(0,k.createDecorator)("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,C){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?C.call(J,l):C?C.value=l:e.set(J,l),l},Ue=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[70],Ie([1,0,2,18,4,5,7,32,56,33,21,38,16,26,3,12,11,15,65,232,10]),function(J,e,l,t,C,P,_,D,b,I,L,k,S,T,E,p,w,f,v,m,a){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var n;(function($){function N(B){if(B!=null)return B}$.from=N;function K(B){if(B!=null)return B}$.to=K})(n=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var d;(function($){function N(B){if(B!=null)return B}$.from=N;function K(B){if(B!=null)return B}$.to=K})(d=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var s;(function($){function N(B){if(B!=null)return B}$.from=N;function K(B){if(B!=null)return B}$.to=K})(s=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function($){function N(O){if(O){const x=O;return x&&!!x.process}else return!1}$.is=N;function K(O){if(O==null)return;const x={process:O.process,args:O.args};return O.options&&(x.options=s.from(O.options)),x}$.from=K;function B(O){if(O!=null)return new _.ProcessExecution(O.process,O.args,O.options)}$.to=B})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var r;(function($){function N(B){if(B!=null)return B}$.from=N;function K(B){if(B!=null)return B}$.to=K})(r=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var c;(function($){function N(O){if(O){const x=O;return x&&(!!x.commandLine||!!x.command)}else return!1}$.is=N;function K(O){if(O==null)return;const x={};return O.commandLine!==void 0?x.commandLine=O.commandLine:(x.command=O.command,x.args=O.args),O.options&&(x.options=r.from(O.options)),x}$.from=K;function B(O){if(!(O==null||O.command===void 0&&O.commandLine===void 0))return O.commandLine?new _.ShellExecution(O.commandLine,O.options):new _.ShellExecution(O.command,O.args?O.args:[],O.options)}$.to=B})(c=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var o;(function($){function N(O){if(O){const x=O;return x&&x.customExecution==="customExecution"}else return!1}$.is=N;function K(O){return{customExecution:"customExecution"}}$.from=K;function B(O,x){return x.get(O)}$.to=B})(o=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var u;(function($){function N(K,B){let O;return K.scope!==void 0&&typeof K.scope!="number"?O=K.scope.uri:K.scope!==void 0&&typeof K.scope=="number"&&(K.scope===_.TaskScope.Workspace&&B&&B.workspaceFile?O=B.workspaceFile:O=m.USER_TASKS_GROUP_KEY),{id:K._id,workspaceFolder:O}}$.from=N})(u=e.TaskHandleDTO||(e.TaskHandleDTO={}));var h;(function($){function N(K){if(K!=null)return{_id:K.id,isDefault:K.isDefault}}$.from=N})(h=e.TaskGroupDTO||(e.TaskGroupDTO={}));var y;(function($){function N(O,x){if(O==null)return[];const V=[];for(const q of O){const Y=K(q,x);Y&&V.push(Y)}return V}$.fromMany=N;function K(O,x){if(O==null)return;let V;O.execution instanceof _.ProcessExecution?V=i.from(O.execution):O.execution instanceof _.ShellExecution?V=c.from(O.execution):O.execution&&O.execution instanceof _.CustomExecution&&(V=o.from(O.execution));const q=n.from(O.definition);let Y;return O.scope?typeof O.scope=="number"?Y=O.scope:Y=O.scope.uri:Y=_.TaskScope.Workspace,!q||!Y?void 0:{_id:O._id,definition:q,name:O.name,source:{extensionId:x.identifier.value,label:O.source,scope:Y},execution:V,isBackground:O.isBackground,group:h.from(O.group),presentationOptions:d.from(O.presentationOptions),problemMatchers:O.problemMatchers,hasDefinedMatchers:O.hasDefinedMatchers,runOptions:O.runOptions?O.runOptions:{reevaluateOnRerun:!0},detail:O.detail}}$.from=K;async function B(O,x,V){if(O==null)return;let q;i.is(O.execution)?q=i.to(O.execution):c.is(O.execution)?q=c.to(O.execution):o.is(O.execution)&&(q=o.to(O._id,V));const Y=n.to(O.definition);let Q;if(O.source&&(O.source.scope!==void 0?typeof O.source.scope=="number"?Q=O.source.scope:Q=await x.resolveWorkspaceFolder(l.URI.revive(O.source.scope)):Q=_.TaskScope.Workspace),!Y||!Q)return;const de=new _.Task(Y,Q,O.name,O.source.label,q,O.problemMatchers);return O.isBackground!==void 0&&(de.isBackground=O.isBackground),O.group!==void 0&&(de.group=_.TaskGroup.from(O.group._id),de.group&&O.group.isDefault&&(de.group=new _.TaskGroup(de.group.id,de.group.label),O.group.isDefault===!0&&(de.group.isDefault=O.group.isDefault))),O.presentationOptions&&(de.presentationOptions=d.to(O.presentationOptions)),O._id&&(de._id=O._id),O.detail&&(de.detail=O.detail),de}$.to=B})(y=e.TaskDTO||(e.TaskDTO={}));var R;(function($){function N(B){return B}$.from=N;function K(B){if(!!B)return Object.assign(Object.create(null),B)}$.to=K})(R=e.TaskFilterDTO||(e.TaskFilterDTO={}));class M{constructor(N,K,B){this._id=K,this._task=B,g.set(this,void 0),tt(this,g,N,"f")}get task(){return this._task}terminate(){Ue(this,g,"f").terminateTask(this)}fireDidStartProcess(N){}fireDidEndProcess(N){}}g=new WeakMap;var U;(function($){function N(K){return{id:K._id,task:void 0}}$.from=N})(U=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let A=class{constructor(N,K,B,O,x,V,q,Y){this._onDidExecuteTask=new C.Emitter,this._onDidTerminateTask=new C.Emitter,this._onDidTaskProcessStarted=new C.Emitter,this._onDidTaskProcessEnded=new C.Emitter,this._proxy=N.getProxy(P.MainContext.MainThreadTask),this._workspaceProvider=B,this._editorService=O,this._configurationService=x,this._terminalService=V,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=q,this._deprecationService=Y,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(N,K,B){if(!B)return new _.Disposable(()=>{});const O=this.nextHandle();return this._handlers.set(O,{type:K,provider:B,extension:N}),this._proxy.$registerTaskProvider(O,K),new _.Disposable(()=>{this._handlers.delete(O),this._proxy.$unregisterTaskProvider(O)})}registerTaskSystem(N,K){this._proxy.$registerTaskSystem(N,K)}fetchTasks(N){return this._proxy.$fetchTasks(R.from(N)).then(async K=>{const B=[];for(const O of K){const x=await y.to(O,this._workspaceProvider,this._providedCustomExecutions2);x&&B.push(x)}return B})}get taskExecutions(){const N=[];return this._taskExecutions.forEach(K=>N.push(K)),N}terminateTask(N){if(!(N instanceof M))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(N._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(N,K,B){const O=this._providedCustomExecutions2.get(N.id);O&&(this._activeCustomExecutions2.set(N.id,O),this._terminalService.attachPtyToTerminal(K,await O.callback(B))),this._lastStartedTask=N.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(N)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(N){const K=await this.getTaskExecution(N);this._taskExecutionPromises.delete(N.id),this._taskExecutions.delete(N.id),this.customExecutionComplete(N),this._onDidTerminateTask.fire({execution:K})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(N){const K=await this.getTaskExecution(N.id);this._onDidTaskProcessStarted.fire({execution:K,processId:N.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(N){const K=await this.getTaskExecution(N.id);this._onDidTaskProcessEnded.fire({execution:K,exitCode:N.exitCode})}$provideTasks(N,K){const B=this._handlers.get(N);if(!B)return Promise.reject(new Error("no handler found"));const O=[],x=(0,t.asPromise)(()=>B.provider.provideTasks(L.CancellationToken.None)).then(V=>this.provideTasksInternal(K,O,B,V));return new Promise(V=>{x.then(q=>{Promise.all(O).then(()=>{V(q)})})})}async $resolveTask(N,K){const B=this._handlers.get(N);if(!B)return Promise.reject(new Error("no handler found"));if(K.definition.type!==B.type)throw new Error(`Unexpected: Task of type [${K.definition.type}] cannot be resolved by provider of type [${B.type}].`);const O=await y.to(K,this._workspaceProvider,this._providedCustomExecutions2);if(!O)throw new Error("Unexpected: Task cannot be resolved.");const x=await B.provider.resolveTask(O,L.CancellationToken.None);if(!x)return;this.checkDeprecation(x,B);const V=y.from(x,B.extension);if(!V)throw new Error("Unexpected: Task cannot be resolved.");if(x.definition!==O.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return o.is(V.execution)&&await this.addCustomExecution(V,x,!0),await this.resolveTaskInternal(V)}nextHandle(){return this._handleCounter++}async addCustomExecution(N,K,B){const O=await this._proxy.$createTaskId(N);!B&&!this._providedCustomExecutions2.has(O)&&(this._notProvidedCustomExecutions.add(O),this._activeCustomExecutions2.set(O,K.execution)),this._providedCustomExecutions2.set(O,K.execution)}async getTaskExecution(N,K){if(typeof N=="string"){const x=this._taskExecutionPromises.get(N);if(!x)throw new Error("Unexpected: The specified task is missing an execution");return x}const B=this._taskExecutionPromises.get(N.id);if(B)return B;const O=new Promise((x,V)=>{function q(Y,Q,de){de?x(new M(Y,Q.id,de)):V("Unexpected: Task does not exist.")}K?q(this,N,K):y.to(N.task,this._workspaceProvider,this._providedCustomExecutions2).then(Y=>q(this,N,Y))});return this._taskExecutionPromises.set(N.id,O),O.then(x=>(this._taskExecutions.set(N.id,x),x),x=>Promise.reject(x))}checkDeprecation(N,K){N._deprecated&&this._deprecationService.report("Task.constructor",K.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(N){this._activeCustomExecutions2.get(N.id)&&this._activeCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.has(N.id)&&this._lastStartedTask!==N.id&&(this._providedCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.delete(N.id));const B=this._notProvidedCustomExecutions.values();let O=B.next();for(;!O.done;)!this._activeCustomExecutions2.has(O.value)&&this._lastStartedTask!==O.value&&(this._providedCustomExecutions2.delete(O.value),this._notProvidedCustomExecutions.delete(O.value)),O=B.next()}};A=qe([xe(0,S.IExtHostRpcService),xe(1,T.IExtHostInitDataService),xe(2,D.IExtHostWorkspace),xe(3,b.IExtHostDocumentsAndEditors),xe(4,I.IExtHostConfiguration),xe(5,k.IExtHostTerminalService),xe(6,f.ILogService),xe(7,v.IExtHostApiDeprecationService)],A),e.ExtHostTaskBase=A;let z=class extends A{constructor(N,K,B,O,x,V,q,Y){super(N,K,B,O,x,V,q,Y),this.registerTaskSystem(p.Schemas.vscodeRemote,{scheme:p.Schemas.vscodeRemote,authority:"",platform:w.PlatformToString(0)})}async executeTask(N,K){if(!K.execution)throw new Error("Tasks to execute must include an execution");const B=y.from(K,N);if(B===void 0)throw new Error("Task is not valid");if(o.is(B.execution))await this.addCustomExecution(B,K,!1);else throw new a.NotSupportedError;const O=await this.getTaskExecution(await this._proxy.$getTaskExecution(B),K);return this._proxy.$executeTask(B).catch(x=>{throw new Error(x)}),O}provideTasksInternal(N,K,B,O){const x=[];if(O)for(const V of O){this.checkDeprecation(V,B),(!V.definition||!N[V.definition.type])&&this._logService.warn(`The task [${V.source}, ${V.name}] uses an undefined task type. The task will be ignored in the future.`);const q=y.from(V,B.extension);q&&o.is(q.execution)?(x.push(q),K.push(this.addCustomExecution(q,V,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:x,extension:B.extension}}async resolveTaskInternal(N){if(o.is(N.execution))return N;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(N,K){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(N,K,B){}};z=qe([xe(0,S.IExtHostRpcService),xe(1,T.IExtHostInitDataService),xe(2,D.IExtHostWorkspace),xe(3,b.IExtHostDocumentsAndEditors),xe(4,I.IExtHostConfiguration),xe(5,k.IExtHostTerminalService),xe(6,f.ILogService),xe(7,v.IExtHostApiDeprecationService)],z),e.WorkerExtHostTask=z,e.IExtHostTask=(0,E.createDecorator)("IExtHostTask")}),define(De[277],Ie([1,0,9,21,50,36,22,51,30]),function(J,e,l,t,C,P,_,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class I{constructor(S,T,E){this.config=S,this.provider=T,this.sessionToken=E,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=S.filePattern,this.includePattern=S.includePattern&&P.parse(S.includePattern),this.maxResults=S.maxResults||void 0,this.exists=S.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=S.excludePattern&&P.parse(S.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(S=>S.cancel()),this.activeCancellationTokens=new Set}search(S){const T=this.config.folderQueries||[];return new Promise((E,p)=>{const w=f=>{this.resultCount++,S(f)};if(this.isCanceled)return E({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(f=>{const v=f.toString(),m=l.basename(v);this.globalExcludePattern&&this.globalExcludePattern(v,m)||this.matchFile(w,{base:f,basename:m})}),Promise.all(T.map(f=>this.searchInFolder(f,w))).then(f=>{E({limitHit:this.isLimitHit,stats:f[0]||void 0})},f=>{p(new Error((0,C.toErrorMessage)(f)))})})}async searchInFolder(S,T){const E=new t.CancellationTokenSource,p=this.getSearchOptionsForFolder(S),w=this.initDirectoryTree(),f=new b.QueryGlobTester(this.config,S),v=!f.hasSiblingExcludeClauses();let m;try{this.activeCancellationTokens.add(E),m=D.StopWatch.create();const a=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},p,E.token),g=m.elapsed(),n=D.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(a&&a.forEach(d=>{const s=l.posix.relative(S.folder.path,d.path);if(v){const i=l.basename(d.path);this.matchFile(T,{base:S.folder,relativePath:s,basename:i});return}this.addDirectoryEntries(w,S.folder,s,T)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(w,f,T),{providerTime:g,postProcessTime:n.elapsed()})}finally{E.dispose(),this.activeCancellationTokens.delete(E)}}getSearchOptionsForFolder(S){const T=(0,b.resolvePatternsForProvider)(this.config.includePattern,S.includePattern),E=(0,b.resolvePatternsForProvider)(this.config.excludePattern,S.excludePattern);return{folder:S.folder,excludes:E,includes:T,useIgnoreFiles:!S.disregardIgnoreFiles,useGlobalIgnoreFiles:!S.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!S.disregardParentIgnoreFiles,followSymlinks:!S.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const S={rootEntries:[],pathToEntries:Object.create(null)};return S.pathToEntries["."]=S.rootEntries,S}addDirectoryEntries({pathToEntries:S},T,E,p){if(E===this.filePattern){const f=l.basename(this.filePattern);this.matchFile(p,{base:T,relativePath:this.filePattern,basename:f})}function w(f){const v=l.basename(f),m=l.dirname(f);let a=S[m];a||(a=S[m]=[],w(m)),a.push({base:T,relativePath:f,basename:v})}w(E)}matchDirectoryTree({rootEntries:S,pathToEntries:T},E,p){const w=this,f=this.filePattern;function v(m){const a=(0,b.hasSiblingFn)(()=>m.map(g=>g.basename));for(let g=0,n=m.length;g<n;g++){const d=m[g],{relativePath:s,basename:i}=d;if(E.matchesExcludesSync(s,i,f!==i?a:void 0))continue;const r=T[s];if(r)v(r);else{if(s===f)continue;w.matchFile(p,d)}if(w.isLimitHit)break}}v(S)}matchFile(S,T){(!this.includePattern||T.relativePath&&this.includePattern(T.relativePath,T.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||S(T))}}class L{constructor(){this.sessions=new Map}fileSearch(S,T,E,p){const w=this.getSessionTokenSource(S.cacheKey),f=new I(S,T,w&&w.token);let v=0;const m=a=>{v+=a.length,E(a.map(g=>this.rawMatchToSearchItem(g)))};return this.doSearch(f,L.BATCH_SIZE,m,p).then(a=>({limitHit:a.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:v,detailStats:a.stats}}))}clearCache(S){this.getSessionTokenSource(S)?.cancel()}getSessionTokenSource(S){if(!!S)return this.sessions.has(S)||this.sessions.set(S,new t.CancellationTokenSource),this.sessions.get(S)}rawMatchToSearchItem(S){return S.relativePath?{resource:_.joinPath(S.base,S.relativePath)}:{resource:S.base}}doSearch(S,T,E,p){p.onCancellationRequested(()=>{S.cancel()});const w=v=>{v&&(f.push(v),T>0&&f.length>=T&&(E(f),f=[]))};let f=[];return S.search(w).then(v=>(f.length&&E(f),v),v=>(f.length&&E(f),Promise.reject(v)))}}e.FileSearchManager=L,L.BATCH_SIZE=512}),define(De[278],Ie([1,0,17,75,36,107,25,12,9,22,8,14,2,159,186,83,15,45,129,276,30]),function(J,e,l,t,C,P,_,D,b,I,L,k,S,T,E,p,w,f,v,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let g=class{constructor(h,y,R,M,U){this.configurationService=h,this.workspaceContextService=y,this.editorGroupsService=R,this.logService=M,this.pathService=U}text(h,y,R={}){h=this.getContentPattern(h,R);const M=this.configurationService.getValue(),U=y&&y.some(z=>!this.configurationService.getValue({resource:z}).search.useRipgrep);return{...this.commonQuery(y?.map(f.toWorkspaceFolder),R),type:2,contentPattern:h,previewOptions:R.previewOptions,maxFileSize:R.maxFileSize,usePCRE2:M.search.usePCRE2||U||!1,beforeContext:R.beforeContext,afterContext:R.afterContext,userDisabledExcludesAndIgnoreFiles:R.disregardExcludeSettings&&R.disregardIgnoreFiles}}getContentPattern(h,y){const R=this.configurationService.getValue();h.isRegExp&&(h.pattern=h.pattern.replace(/\r?\n/g,"\\n"));const M={...h,wordSeparators:R.editor.wordSeparators};return this.isCaseSensitive(h,y)&&(M.isCaseSensitive=!0),this.isMultiline(h)&&(M.isMultiline=!0),M}file(h,y={}){return{...this.commonQuery(h,y),type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey}}handleIncludeExclude(h,y){return h?(h=Array.isArray(h)?h.map(r):r(h),y?this.parseSearchPaths(h):{pattern:d(...Array.isArray(h)?h:[h])}):{}}commonQuery(h=[],y={}){const R=this.handleIncludeExclude(y.includePattern,y.expandPatterns),M=this.handleIncludeExclude(y.excludePattern,y.expandPatterns),U=h.length>1,A=(R.searchPaths&&R.searchPaths.length?R.searchPaths.map(N=>this.getFolderQueryForSearchPath(N,y,M)):h.map(N=>this.getFolderQueryForRoot(N,y,M,U))).filter(N=>!!N),z={_reason:y._reason,folderQueries:A,usingSearchPaths:!!(R.searchPaths&&R.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:M.pattern,includePattern:R.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const N=l.coalesce(l.flatten(this.editorGroupsService.groups.map(O=>O.editors.map(x=>x.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(N));const K=N.filter(O=>(0,a.pathIncludedInQuery)(z,O.fsPath)),B=this.commonQueryFromFileList(K);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(B)),{...z,...B}}const $=y.extraFileResources&&y.extraFileResources.filter(N=>(0,a.pathIncludedInQuery)(z,N.fsPath));return z.extraFileResources=$&&$.length?$:void 0,z}commonQueryFromFileList(h){const y=[],R=new _.ResourceMap,M={};let U=!1;return h.forEach(A=>{if(A.scheme===D.Schemas.walkThrough)return;if((0,I.isAbsolutePath)(A)){const $=this.workspaceContextService.getWorkspaceFolder(A)?.uri??A.with({path:b.dirname(A.fsPath)});let N=R.get($);N||(U=!0,N={folder:$,includePattern:{}},y.push(N),R.set($,N));const K=b.relative($.fsPath,A.fsPath);(0,k.assertIsDefined)(N.includePattern)[K.replace(/\\/g,"/")]=!0}else A.fsPath&&(U=!0,M[A.fsPath]=!0)}),{folderQueries:y,includePattern:M,usingSearchPaths:!0,excludePattern:U?void 0:{"**/*":!0}}}isCaseSensitive(h,y){if(y.isSmartCase){if(h.isRegExp){if(L.containsUppercaseCharacter(h.pattern,!0))return!0}else if(L.containsUppercaseCharacter(h.pattern))return!0}return!!h.isCaseSensitive}isMultiline(h){return h.isMultiline||h.isRegExp&&(0,T.isMultilineRegexSource)(h.pattern)||h.pattern.indexOf(`
`)>=0?!0:!!h.isMultiline}parseSearchPaths(h){const y=B=>b.isAbsolute(B)||/^\.\.?([\/\\]|$)/.test(B),M=(Array.isArray(h)?h:s(h)).map(B=>{const O=this.pathService.resolvedUserHome;return O?(0,P.untildify)(B,O.scheme===D.Schemas.file?O.fsPath:O.path):B}),U=t.groupBy(M,B=>y(B)?"searchPaths":"exprSegments"),A=(U.exprSegments||[]).map(B=>L.rtrim(B,"/")).map(B=>L.rtrim(B,"\\")).map(B=>(B[0]==="."&&(B="*"+B),i(B))),z={},$=this.expandSearchPathPatterns(U.searchPaths||[]);$&&$.length&&(z.searchPaths=$);const N=l.flatten(A),K=d(...N);return K&&(z.pattern=K),z}getExcludesForFolder(h,y){return y.disregardExcludeSettings?void 0:(0,a.getExcludes)(h,!y.disregardSearchExcludeSettings)}expandSearchPathPatterns(h){if(!h||!h.length)return[];const y=l.flatten(h.map(M=>{let{pathPortion:U,globPortion:A}=n(M);A&&(A=c(A));const z=this.expandOneSearchPath(U);return l.flatten(z.map($=>this.resolveOneSearchPathPattern($,A)))})),R=new Map;return y.forEach(M=>{const U=M.searchPath.toString(),A=R.get(U);A?M.pattern&&(A.pattern=A.pattern||{},A.pattern[M.pattern]=!0):R.set(U,{searchPath:M.searchPath,pattern:M.pattern?d(M.pattern):void 0})}),Array.from(R.values())}expandOneSearchPath(h){if(b.isAbsolute(h)){const y=this.workspaceContextService.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==D.Schemas.file?[{searchPath:y[0].uri.with({path:h})}]:[{searchPath:S.URI.file(b.normalize(h))}]}if(this.workspaceContextService.getWorkbenchState()===2){const y=this.workspaceContextService.getWorkspace().folders[0].uri;if(h=r(h),h.startsWith("../")||h===".."){const M=b.posix.resolve(y.path,h);return[{searchPath:y.with({path:M})}]}const R=c(h);return[{searchPath:y,pattern:R}]}else{if(h==="./"||h===".\\")return[];{const y=h.replace(/^\.[\/\\]/,""),M=this.workspaceContextService.getWorkspace().folders.map(U=>{const A=y.match(new RegExp(`^${L.escapeRegExpCharacters(U.name)}(?:/(.*)|$)`));return A?{match:A,folder:U}:null}).filter(k.isDefined);if(M.length)return M.map(U=>{const A=U.match[1];return{searchPath:U.folder.uri,pattern:A&&c(A)}});{const U=h.match(/\.[\/\\](.+)[\/\\]?/),A=U?U[1]:h,z=E.localize(0,null,A);throw new Error(z)}}}}resolveOneSearchPathPattern(h,y){const R=h.pattern&&y?`${h.pattern}/${y}`:h.pattern||y,M=[{searchPath:h.searchPath,pattern:R}];return R&&!R.endsWith("**")&&M.push({searchPath:h.searchPath,pattern:R+"/**"}),M}getFolderQueryForSearchPath(h,y,R){const M=this.getFolderQueryForRoot((0,f.toWorkspaceFolder)(h.searchPath),y,R,!1);return M?{...M,includePattern:h.pattern}:null}getFolderQueryForRoot(h,y,R,M){let U;const A=S.URI.isUri(h)?h:h.uri;if(R.searchPaths){const B=R.searchPaths.filter(O=>(0,I.isEqual)(O.searchPath,A))[0];if(B&&!B.pattern)return null;B&&(U=B.pattern)}const z=this.configurationService.getValue({resource:A}),N={...this.getExcludesForFolder(z,y)||{},...U||{}},K=S.URI.isUri(h)?(0,I.basename)(h):h.name;return{folder:A,folderName:M?K:void 0,excludePattern:Object.keys(N).length>0?N:void 0,fileEncoding:z.files&&z.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!z.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!z.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof y.disregardParentIgnoreFiles=="boolean"?y.disregardParentIgnoreFiles:!z.search.useParentIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!z.search.followSymlinks}}};g=qe([xe(0,p.IConfigurationService),xe(1,f.IWorkspaceContextService),xe(2,v.IEditorGroupsService),xe(3,w.ILogService),xe(4,m.IPathService)],g),e.QueryBuilder=g;function n(u){const h=u.match(/[\*\{\}\(\)\[\]\?]/);if(h){const y=h.index,R=u.substr(0,y).match(/[/|\\][^/\\]*$/);if(R){let M=u.substr(0,R.index);return M.match(/[/\\]/)||(M+="/"),{pathPortion:M,globPortion:u.substr((R.index||0)+1)}}}return{pathPortion:u}}function d(...u){return u.length?u.reduce((h,y)=>(h[y]=!0,h),Object.create(null)):void 0}function s(u){return C.splitGlobAware(u,",").map(h=>h.trim()).filter(h=>!!h.length)}function i(u){return[`**/${u}/**`,`**/${u}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function r(u){return u.replace(/\\/g,"/")}function c(u){return r(u).replace(/^\.\//,"").replace(/\/+$/g,"")}function o(u,h){u=l.distinct(u,M=>M.toString());const y=[],R=h.getWorkspace();return u&&u.forEach(M=>{let U;if(h.getWorkbenchState()===2)U=(0,I.relativePath)(R.folders[0].uri,M),U&&U!=="."&&(U="./"+U);else{const A=h.getWorkspaceFolder(M);if(A){const z=A.name;if(R.folders.filter(N=>N.name===z).length===1){const N=(0,I.relativePath)(A.uri,M);N===""?U=`./${A.name}`:U=`./${A.name}/${N}`}else U=M.fsPath}}U&&y.push(U)}),y}e.resolveResourcesForSearchIncludes=o}),define(De[279],Ie([1,0,22,2,21,10,3,278,30,45]),function(J,e,l,t,C,P,_,D,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const L=7e3;function k(p,w){const f=w.activationEvents;if(!f)return Promise.resolve(void 0);const v=[],m=[];for(const i of f)if(/^workspaceContains:/.test(i)){const r=i.substr(18);r.indexOf("*")>=0||r.indexOf("?")>=0||p.forceUsingSearch?m.push(r):v.push(r)}if(v.length===0&&m.length===0)return Promise.resolve(void 0);let a;const g=new Promise((i,r)=>{a=i}),n=i=>a({activationEvent:i}),d=Promise.all(v.map(i=>S(p,i,n))).then(()=>{}),s=T(p,w.identifier,m,n);return Promise.all([d,s]).then(()=>{a(void 0)}),g}e.checkActivateWorkspaceContainsExtension=k;async function S(p,w,f){for(const v of p.folders)if(await p.exists(l.joinPath(t.URI.revive(v),w))){f(`workspaceContains:${w}`);return}}async function T(p,w,f,v){if(f.length===0)return Promise.resolve(void 0);const m=new C.CancellationTokenSource,a=p.checkExists(p.folders,f,m.token),g=setTimeout(async()=>{m.cancel(),p.logService.info(`Not activating extension '${w.value}': Timed out while searching for 'workspaceContains' pattern ${f.join(",")}`)},L);let n=!1;try{n=await a}catch(d){P.isCancellationError(d)||P.onUnexpectedError(d)}m.dispose(),clearTimeout(g),n&&v(`workspaceContains:${f.join(",")}`)}function E(p,w,f,v){const m=p.get(_.IInstantiationService),a=p.get(b.ISearchService),n=m.createInstance(D.QueryBuilder).file(w.map(d=>(0,I.toWorkspaceFolder)(t.URI.revive(d))),{_reason:"checkExists",includePattern:f,exists:!0});return a.fileSearch(n,v).then(d=>!!d.limitHit,d=>P.isCancellationError(d)?!1:Promise.reject(d))}e.checkGlobFileExists=E});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,C){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?C.call(J,l):C?C.value=l:e.set(J,l),l},Ue=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[39],Ie([1,0,170,9,71,22,18,6,25,2,15,5,33,222,92,32,27,220,10,28,23,203,7,122,3,26,67,16,85,53,38,4,279,91,205,12]),function(J,e,l,t,C,P,_,D,b,I,L,k,S,T,E,p,w,f,v,m,a,g,n,d,s,i,r,c,o,u,h,y,R,M,U,A){"use strict";var z,$,N;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let K=class Rn extends D.Disposable{constructor(Q,de,ve,ne,pe,be,ke,Oe,We,oe){super(),this._onDidChangeRemoteConnectionData=this._register(new y.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=de,this._extHostContext=ve,this._initData=ke,this._extHostWorkspace=ne,this._extHostConfiguration=pe,this._logService=be,this._extHostTunnelService=We,this._extHostTerminalService=oe,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(k.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(k.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(k.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new _.Barrier,this._readyToStartExtensionHost=new _.Barrier,this._readyToRunExtensions=new _.Barrier,this._eagerExtensionsActivated=new _.Barrier,this._globalRegistry=new f.ExtensionDescriptionRegistry(this._initData.allExtensions);const le=(0,w.extensionIdentifiersArrayToSet)(this._initData.myExtensions);this._myRegistry=new f.ExtensionDescriptionRegistry(x(this._globalRegistry,le)),this._storage=new E.ExtHostStorage(this._extHostContext),this._secretState=new M.ExtHostSecretState(this._extHostContext),this._storagePath=Oe,this._instaService=Q.createChild(new o.ServiceCollection([E.IExtHostStorage,this._storage],[M.IExtHostSecretState,this._secretState]));let fe=[],Z=[];this._initData.remote.isRemote&&(fe=this._initData.allExtensions.filter(ee=>!ee.main&&!ee.browser).map(ee=>ee.identifier),Z=this._initData.allExtensions.filter(ee=>!le.has(m.ExtensionIdentifier.toKey(ee.identifier.value))).filter(ee=>(ee.main||ee.browser)&&ee.api==="none").map(ee=>ee.identifier));const ae=(0,w.extensionIdentifiersArrayToSet)(Z);this._activator=this._register(new T.ExtensionsActivator(this._myRegistry,fe,Z,{onExtensionActivationError:(ee,ie,F)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ee,v.transformErrorForSerialization(ie),F)},actualActivateExtension:async(ee,ie)=>{if(ae.has(m.ExtensionIdentifier.toKey(ee)))return await this._mainThreadExtensionsProxy.$activateExtension(ee,ie),new T.HostExtension;const F=this._myRegistry.getExtensionDescription(ee);return this._activateExtension(F,ie)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),C.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(Q){v.onUnexpectedError(Q)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let Q=[];try{Q=this._myRegistry.getAllExtensionDescriptions().map(pe=>pe.identifier).filter(pe=>this.isActivated(pe)).map(pe=>this._deactivate(pe))}catch{}await Promise.all(Q)}terminate(Q,de=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${Q}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),v.setUnexpectedErrorHandler(ne=>{this._logService.error(ne)}),this._extHostContext.dispose();const ve=this._deactivateAll();Promise.race([(0,_.timeout)(5e3),ve]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${de}`):this._logService.info(`Extension host exiting with code ${de}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(de)})}isActivated(Q){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(Q):!1}async getExtension(Q){const de=await this._mainThreadExtensionsProxy.$getExtension(Q);let ve;if(de?.browserNlsBundleUris){ve={};for(const ne of Object.keys(de.browserNlsBundleUris))ve[ne]=I.URI.revive(de.browserNlsBundleUris[ne])}return de&&{...de,identifier:new m.ExtensionIdentifier(de.identifier.value),extensionLocation:I.URI.revive(de.extensionLocation),browserNlsBundleUris:ve}}_activateByEvent(Q,de){return this._activator.activateByEvent(Q,de)}_activateById(Q,de){return this._activator.activateById(Q,de)}activateByIdWithErrors(Q,de){return this._activateById(Q,de).then(()=>{const ve=this._activator.getActivatedExtension(Q);if(ve.activationFailed)return Promise.reject(ve.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(Q=>this._myRegistry)}getExtensionExports(Q){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(Q).exports:null}async _realPathExtensionUri(Q){if(Q.scheme!==A.Schemas.file)return Q;const de=await this._hostUtils.realpath(Q.fsPath);return I.URI.file(de)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(Q=>new q(Q))),this._extensionPathIndex}async _createExtensionPathIndex(Q){const de=b.TernarySearchTree.forUris(ve=>P.extUriBiasedIgnorePathCase.ignorePathCasing(ve));return await Promise.all(Q.map(async ve=>{if(this._getEntryPoint(ve)){const ne=await this._realPathExtensionUri(ve.extensionLocation);de.set(ne,ve)}})),de}_deactivate(Q){let de=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(Q))return de;const ve=this._activator.getActivatedExtension(Q);if(!ve)return de;try{typeof ve.module.deactivate=="function"&&(de=Promise.resolve(ve.module.deactivate()).then(void 0,ne=>(this._logService.error(ne),Promise.resolve(void 0))))}catch(ne){this._logService.error(`An error occurred when deactivating the extension '${Q.value}':`),this._logService.error(ne)}try{(0,D.dispose)(ve.subscriptions)}catch(ne){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${Q.value}':`),this._logService.error(ne)}return de}async _activateExtension(Q,de){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(Q.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(Q.identifier),this._doActivateExtension(Q,de).then(ve=>{const ne=ve.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(Q.identifier,ne.codeLoadingTime,ne.activateCallTime,ne.activateResolvedTime,de),this._logExtensionActivationTimes(Q,de,"success",ne),ve},ve=>{throw this._logExtensionActivationTimes(Q,de,"failure"),ve})}_logExtensionActivationTimes(Q,de,ve,ne){const pe=B(Q,de);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...pe,...ne||{},outcome:ve})}_doActivateExtension(Q,de){const ve=B(Q,de);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ve);const ne=this._getEntryPoint(Q);if(!ne)return Promise.resolve(new T.EmptyExtension(T.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${Q.identifier.value}, startup: ${de.startup}, activationEvent: '${de.activationEvent}'${Q.identifier.value!==de.extensionId.value?`, root cause: ${de.extensionId.value}`:""}`),this._logService.flush();const pe=new T.ExtensionActivationTimesBuilder(de.startup);return Promise.all([this._loadCommonJSModule(Q,(0,P.joinPath)(Q.extensionLocation,ne),pe),this._loadExtensionContext(Q)]).then(be=>(C.mark(`code/extHost/willActivateExtension/${Q.identifier.value}`),Rn._callActivate(this._logService,Q.identifier,be[0],be[1],pe))).then(be=>(C.mark(`code/extHost/didActivateExtension/${Q.identifier.value}`),be))}_loadExtensionContext(Q){const de=new g.ExtensionGlobalMemento(Q,this._storage),ve=new g.ExtensionMemento(Q.identifier.value,!1,this._storage),ne=new U.ExtensionSecrets(Q,this._secretState),pe=Q.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?n.ExtensionMode.Test:n.ExtensionMode.Development:n.ExtensionMode.Production,be=this._initData.remote.isRemote?n.ExtensionKind.Workspace:n.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${Q.identifier.value}`),Promise.all([de.whenReady,ve.whenReady,this._storagePath.whenReady]).then(()=>{const ke=this;let Oe,We;const oe=(0,w.isProposedApiEnabled)(Q,"ipc")?this._initData.messagePorts?.get(m.ExtensionIdentifier.toKey(Q.identifier)):void 0;return Object.freeze({globalState:de,workspaceState:ve,secrets:ne,subscriptions:[],get extensionUri(){return Q.extensionLocation},get extensionPath(){return Q.extensionLocation.fsPath},asAbsolutePath(le){return t.join(Q.extensionLocation.fsPath,le)},get storagePath(){return ke._storagePath.workspaceValue(Q)?.fsPath},get globalStoragePath(){return ke._storagePath.globalValue(Q).fsPath},get logPath(){return t.join(ke._initData.logsLocation.fsPath,Q.identifier.value)},get logUri(){return I.URI.joinPath(ke._initData.logsLocation,Q.identifier.value)},get storageUri(){return ke._storagePath.workspaceValue(Q)},get globalStorageUri(){return ke._storagePath.globalValue(Q)},get extensionMode(){return pe},get extension(){return Oe===void 0&&(Oe=new O(ke,Q.identifier,Q,be,!1)),Oe},get extensionRuntime(){return(0,w.checkProposedApiEnabled)(Q,"extensionRuntime"),ke.extensionRuntime},get environmentVariableCollection(){return ke._extHostTerminalService.getEnvironmentVariableCollection(Q)},get messagePassingProtocol(){if(!We){if(!oe)return;const le=y.Event.buffer(y.Event.fromDOMEventEmitter(oe,"message",fe=>fe.data));oe.start(),We={onDidReceiveMessage:le,postMessage:oe.postMessage.bind(oe)}}return We}})})}static _callActivate(Q,de,ve,ne,pe){return ve=ve||{activate:void 0,deactivate:void 0},this._callActivateOptional(Q,de,ve,ne,pe).then(be=>new T.ActivatedExtension(!1,null,pe.build(),ve,be,ne.subscriptions))}static _callActivateOptional(Q,de,ve,ne,pe){if(typeof ve.activate=="function")try{pe.activateCallStart(),Q.trace(`ExtensionService#_callActivateOptional ${de.value}`);const be=typeof global=="object"?global:self,ke=ve.activate.apply(be,[ne]);return pe.activateCallStop(),pe.activateResolveStart(),Promise.resolve(ke).then(Oe=>(pe.activateResolveStop(),Oe))}catch(be){return Promise.reject(be)}else return Promise.resolve(ve)}_activateOneStartupFinished(Q,de){this._activateById(Q.identifier,{startup:!1,extensionId:Q.identifier,activationEvent:de}).then(void 0,ve=>{this._logService.error(ve)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(C.getMarks());for(const Q of this._myRegistry.getAllExtensionDescriptions())if(Q.activationEvents)for(const de of Q.activationEvents)de==="onStartupFinished"&&this._activateOneStartupFinished(Q,de)}_handleEagerExtensions(){const Q=this._activateByEvent("*",!0).then(void 0,pe=>{this._logService.error(pe)});this._register(this._extHostWorkspace.onDidChangeWorkspace(pe=>this._handleWorkspaceContainsEagerExtensions(pe.added)));const de=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ve=this._handleWorkspaceContainsEagerExtensions(de),ne=Promise.all([Q,ve]).then(()=>{});return Promise.race([ne,(0,_.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),ne}_handleWorkspaceContainsEagerExtensions(Q){return Q.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(de=>this._handleWorkspaceContainsEagerExtension(Q,de))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(Q,de){if(this.isActivated(de.identifier))return;const ve=!this._initData.remote.isRemote&&!!this._initData.remote.authority,ne={logService:this._logService,folders:Q.map(be=>be.uri),forceUsingSearch:ve,exists:be=>this._hostUtils.exists(be.fsPath),checkExists:(be,ke,Oe)=>this._mainThreadWorkspaceProxy.$checkExists(be,ke,Oe)},pe=await(0,R.checkActivateWorkspaceContainsExtension)(ne,de);if(!!pe)return this._activateById(de.identifier,{startup:!0,extensionId:de.identifier,activationEvent:pe.activationEvent}).then(void 0,be=>this._logService.error(be))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(Q){throw console.error(Q),Q}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:Q,extensionTestsLocationURI:de}=this._initData.environment;if(!Q||!de)throw new Error(l.localize(0,null));const ve=await this._loadCommonJSModule(null,de,new T.ExtensionActivationTimesBuilder(!1));if(!ve||typeof ve.run!="function")throw new Error(l.localize(1,null,de.toString()));return new Promise((ne,pe)=>{const be=(We,oe)=>{We?pe(We):ne(typeof oe=="number"&&oe>0?1:0)},ke=(0,P.originalFSPath)(de),Oe=ve.run(ke,be);Oe&&Oe.then&&Oe.then(()=>{ne(0)}).catch(We=>{pe(We instanceof Error&&We.stack?We.stack:String(We))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Q,de){return this._resolvers[Q]=de,(0,D.toDisposable)(()=>{delete this._resolvers[Q]})}async _activateAndGetResolver(Q){const de=Q.indexOf("+");if(de===-1)throw new Error("Not an authority that can be resolved!");const ve=Q.substr(0,de);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ve}`,!1),{authorityPrefix:ve,resolver:this._resolvers[ve]}}async $resolveAuthority(Q,de){this._logService.info(`$resolveAuthority invoked for authority (${V(Q)})`);const{authorityPrefix:ve,resolver:ne}=await this._activateAndGetResolver(Q);if(!ne)return{type:"error",error:{code:d.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ve}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(ne)),C.mark(`code/extHost/willResolveAuthority/${ve}`);const pe=await ne.resolve(Q,{resolveAttempt:de});C.mark(`code/extHost/didResolveAuthorityOK/${ve}`);const be={authority:Q,host:pe.host,port:pe.port,connectionToken:pe.connectionToken},ke={extensionHostEnv:pe.extensionHostEnv,isTrusted:pe.isTrusted,authenticationSession:pe.authenticationSessionForInitializingExtensions?{id:pe.authenticationSessionForInitializingExtensions.id,providerId:pe.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:be,options:ke,tunnelInformation:{environmentTunnels:pe.environmentTunnels,features:pe.tunnelFeatures}}}}catch(pe){if(C.mark(`code/extHost/didResolveAuthorityError/${ve}`),pe instanceof n.RemoteAuthorityResolverError)return{type:"error",error:{code:pe._code,message:pe._message,detail:pe._detail}};throw pe}}async $getCanonicalURI(Q,de){this._logService.info(`$getCanonicalURI invoked for authority (${V(Q)})`);const{resolver:ve}=await this._activateAndGetResolver(Q);if(!ve)return null;const ne=I.URI.revive(de);if(typeof ve.getCanonicalURI>"u")return ne;const pe=await(0,_.asPromise)(()=>ve.getCanonicalURI(ne));return pe||ne}static _applyExtensionsDelta(Q,de,ve){const ne=new f.ExtensionDescriptionRegistry(Q.getAllExtensionDescriptions());ne.deltaExtensions(ve.toAdd,ve.toRemove);const pe=(0,w.extensionIdentifiersArrayToSet)(de.getAllExtensionDescriptions().map(ke=>ke.identifier));for(const ke of ve.myToRemove)pe.delete(m.ExtensionIdentifier.toKey(ke));for(const ke of ve.myToAdd)pe.add(m.ExtensionIdentifier.toKey(ke));const be=x(ne,pe);return{globalRegistry:ne,myExtensions:be}}$startExtensionHost(Q){Q.toAdd.forEach(ne=>ne.extensionLocation=I.URI.revive(ne.extensionLocation));const{globalRegistry:de,myExtensions:ve}=Rn._applyExtensionsDelta(this._globalRegistry,this._myRegistry,Q);return this._globalRegistry.set(de.getAllExtensionDescriptions()),this._myRegistry.set(ve),this._startExtensionHost()}$activateByEvent(Q,de){return de===1?this._activateByEvent(Q,!1):this._readyToRunExtensions.wait().then(ve=>this._activateByEvent(Q,!1))}async $activate(Q,de){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(Q)?(await this._activateById(Q,de),!0):!1}async $deltaExtensions(Q){Q.toAdd.forEach(be=>be.extensionLocation=I.URI.revive(be.extensionLocation));const{globalRegistry:de,myExtensions:ve}=Rn._applyExtensionsDelta(this._globalRegistry,this._myRegistry,Q),ne=await this._createExtensionPathIndex(ve);return(await this.getExtensionPathIndex()).setSearchTree(ne),this._globalRegistry.set(de.getAllExtensionDescriptions()),this._myRegistry.set(ve),Promise.resolve(void 0)}async $test_latency(Q){return Q}async $test_up(Q){return Q.byteLength}async $test_down(Q){const de=a.VSBuffer.alloc(Q),ve=Math.random()%256;for(let ne=0;ne<Q;ne++)de.writeUInt8(ve,ne);return de}async $updateRemoteConnectionData(Q){this._remoteConnectionData=Q,this._onDidChangeRemoteConnectionData.fire()}};K=qe([xe(0,s.IInstantiationService),xe(1,e.IHostUtils),xe(2,c.IExtHostRpcService),xe(3,p.IExtHostWorkspace),xe(4,S.IExtHostConfiguration),xe(5,L.ILogService),xe(6,i.IExtHostInitDataService),xe(7,r.IExtensionStoragePaths),xe(8,u.IExtHostTunnelService),xe(9,h.IExtHostTerminalService)],K),e.AbstractExtHostExtensionService=K;function B(Y,Q){return{id:Y.identifier.value,name:Y.name,extensionVersion:Y.version,publisherDisplayName:Y.publisher,activationEvents:Y.activationEvents?Y.activationEvents.join(","):null,isBuiltin:Y.isBuiltin,reason:Q.activationEvent,reasonId:Q.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class O{constructor(Q,de,ve,ne,pe){z.set(this,void 0),$.set(this,void 0),N.set(this,void 0),tt(this,z,Q,"f"),tt(this,$,de,"f"),tt(this,N,ve.identifier,"f"),this.id=ve.identifier.value,this.extensionUri=ve.extensionLocation,this.extensionPath=t.normalize((0,P.originalFSPath)(ve.extensionLocation)),this.packageJSON=ve,this.extensionKind=ne,this.isFromDifferentExtensionHost=pe}get isActive(){return Ue(this,z,"f").isActivated(Ue(this,N,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Ue(this,z,"f").getExtensionExports(Ue(this,N,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Ue(this,z,"f").activateByIdWithErrors(Ue(this,N,"f"),{startup:!1,extensionId:Ue(this,$,"f"),activationEvent:"api"}),this.exports}}e.Extension=O,z=new WeakMap,$=new WeakMap,N=new WeakMap;function x(Y,Q){return Y.getAllExtensionDescriptions().filter(de=>Q.has(m.ExtensionIdentifier.toKey(de.identifier)))}function V(Y){const Q=Y.indexOf("+");return Q===-1?Y:Y.substring(0,Q)}class q{constructor(Q){this._searchTree=Q}setSearchTree(Q){this._searchTree=Q}findSubstr(Q){return this._searchTree.findSubstr(Q)}forEach(Q){return this._searchTree.forEach(Q)}}e.ExtensionPaths=q}),define(De[280],Ie([1,0,71,2,5,33,27,28,16,26,3,39,40,15,8]),function(J,e,l,t,C,P,_,D,b,I,L,k,S,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let p=class{constructor(g,n,d,s,i,r,c){this._apiFactory=g,this._extensionRegistry=n,this._instaService=d,this._extHostConfiguration=s,this._extHostExtensionService=i,this._initData=r,this._logService=c,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),l.mark("code/extHost/willWaitForConfig");const g=await this._extHostConfiguration.getConfigProvider();l.mark("code/extHost/didWaitForConfig");const n=await this._extHostExtensionService.getExtensionPathIndex();this.register(new f(this._apiFactory,n,this._extensionRegistry,g,this._logService)),this.register(this._instaService.createInstance(v,n)),this.register(this._instaService.createInstance(w)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(m,n,this._initData.environment.appUriScheme))}register(g){if("nodeModuleName"in g)if(Array.isArray(g.nodeModuleName))for(const n of g.nodeModuleName)this._factories.set(n,g);else this._factories.set(g.nodeModuleName,g);typeof g.alternativeModuleName=="function"&&this._alternatives.push(n=>g.alternativeModuleName(n))}};p=qe([xe(2,L.IInstantiationService),xe(3,P.IExtHostConfiguration),xe(4,k.IExtHostExtensionService),xe(5,I.IExtHostInitDataService),xe(6,T.ILogService)],p),e.RequireInterceptor=p;let w=class Qn{constructor(g){if(g.environment.appRoot&&Qn.aliased.size){const n=(0,E.escapeRegExpCharacters)(this.forceForwardSlashes(g.environment.appRoot.fsPath)),d="[a-z0-9_.-]",s=`@${d}+\\/${d}+|${d}+`,i="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${n}/${i}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(g){if(!this.re)return;const n=this.re.exec(this.forceForwardSlashes(g));if(!n)return;const[,d,s,i]=n,r=Qn.aliased.get(s);if(r!==void 0)return console.warn(`${s} as been renamed to ${r}, please update your imports`),d+r+i}forceForwardSlashes(g){return g.replace(/\\/g,"/")}};w.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),w=qe([xe(0,I.IExtHostInitDataService)],w);class f{constructor(g,n,d,s,i){this._apiFactory=g,this._extensionPaths=n,this._extensionRegistry=d,this._configProvider=s,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(g,n){const d=this._extensionPaths.findSubstr(n);if(d){let s=this._extApiImpl.get(D.ExtensionIdentifier.toKey(d.identifier));return s||(s=this._apiFactory(d,this._extensionRegistry,this._configProvider),this._extApiImpl.set(D.ExtensionIdentifier.toKey(d.identifier),s)),s}if(!this._defaultApiImpl){let s="";this._extensionPaths.forEach((i,r)=>s+=`	${r} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${n}. These are the extension path mappings: 
${s}`),this._defaultApiImpl=this._apiFactory(_.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let v=class{constructor(g,n,d){this._extensionPaths=g,this.nodeModuleName="keytar",this._mainThreadTelemetry=n.getProxy(C.MainContext.MainThreadTelemetry);const{environment:s}=d,i=n.getProxy(C.MainContext.MainThreadKeytar);if(s.appRoot){let r=s.appRoot.fsPath;S.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,c)=>i.$getPassword(r,c),setPassword:(r,c,o)=>i.$setPassword(r,c,o),deletePassword:(r,c)=>i.$deletePassword(r,c),findPassword:r=>i.$findPassword(r),findCredentials(r){return i.$findCredentials(r)}}}load(g,n){const d=this._extensionPaths.findSubstr(n);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:d?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(g){const n=g.length;if(n<=7||!this.alternativeNames)return;const d=n-7;if((g.charAt(d)==="/"||g.charAt(d)==="\\")&&g.endsWith("keytar")&&(g=g.replace(/\\/g,"/"),this.alternativeNames.has(g)))return"keytar"}};v=qe([xe(1,b.IExtHostRpcService),xe(2,I.IExtHostInitDataService)],v);let m=class{constructor(g,n,d){this._extensionPaths=g,this._appUriScheme=n,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=d.getProxy(C.MainContext.MainThreadTelemetry);const s=d.getProxy(C.MainContext.MainThreadWindow);this._impl=(i,r)=>{const c=t.URI.parse(i);return r?this.callOriginal(i,r):c.scheme==="http"||c.scheme==="https"?s.$openUri(c,i,{allowTunneling:!0}):c.scheme==="mailto"||c.scheme===this._appUriScheme?s.$openUri(c,i,{}):this.callOriginal(i,r)}}load(g,n,d){const s=this._extensionPaths.findSubstr(n);return s&&(this._extensionId=s.identifier.value,this.sendShimmingTelemetry()),this._original=d(g),this._impl}callOriginal(g,n){return this.sendNoForwardTelemetry(),this._original(g,n)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};m=qe([xe(2,b.IExtHostRpcService)],m)}),define(De[47],Ie([1,0,76,6,9,40,3,56,57,39,7,32,217,33]),function(J,e,l,t,C,P,_,D,b,I,L,k,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,_.createDecorator)("IExtHostVariableResolverProvider");class E extends S.AbstractVariableResolverService{constructor(f,v,m,a,g,n,d){function s(){if(m){const i=m.activeEditor();if(i)return i.document.uri;const r=a.tabGroups.all.find(c=>c.isActive)?.activeTab;if(r!==void 0){if(r.input instanceof L.TextDiffTabInput||r.input instanceof L.NotebookDiffEditorTabInput)return r.input.modified;if(r.input instanceof L.TextTabInput||r.input instanceof L.NotebookEditorTabInput||r.input instanceof L.CustomEditorTabInput)return r.input.uri}}}super({getFolderUri:i=>{const r=n.folders.filter(c=>c.name===i);if(r&&r.length>0)return r[0].uri},getWorkspaceFolderCount:()=>n.folders.length,getConfigurationValue:(i,r)=>g.getConfiguration(void 0,i).get(r),getAppRoot:()=>P.cwd(),getExecPath:()=>P.env.VSCODE_EXEC_PATH,getFilePath:()=>{const i=s();if(i)return C.normalize(i.fsPath)},getWorkspaceFolderPathForFile:()=>{if(v){const i=s();if(i){const r=v.getWorkspaceFolder(i);if(r)return C.normalize(r.uri.fsPath)}}},getSelectedText:()=>{if(m){const i=m.activeEditor();if(i&&!i.selection.isEmpty)return i.document.getText(i.selection)}},getLineNumber:()=>{if(m){const i=m.activeEditor();if(i)return String(i.selection.end.line+1)}},getExtension:i=>f.getExtension(i)},void 0,d?Promise.resolve(d):void 0,Promise.resolve(P.env))}}let p=class extends t.Disposable{constructor(f,v,m,a,g){super(),this.extensionService=f,this.workspaceService=v,this.editorService=m,this.configurationService=a,this.editorTabs=g,this._resolver=new l.Lazy(async()=>{const n=await this.configurationService.getConfigProvider(),s={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async i=>{s.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new E(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,n,s,this.homeDir())})}getResolver(){return this._resolver.getValue()}homeDir(){}};p=qe([xe(0,I.IExtHostExtensionService),xe(1,k.IExtHostWorkspace),xe(2,D.IExtHostDocumentsAndEditors),xe(3,T.IExtHostConfiguration),xe(4,b.IExtHostEditorTabs)],p),e.ExtHostVariableResolverProviderService=p}),define(De[72],Ie([1,0,18,4,14,2,3,5,57,39,16,7,32,127,210,33,47]),function(J,e,l,t,C,P,_,D,b,I,L,k,S,T,E,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,_.createDecorator)("IExtHostDebugService");let f=class{constructor(s,i,r,c,o,u){this._workspaceService=i,this._extensionService=r,this._configurationService=c,this._editorTabs=o,this._variableResolver=u,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new t.Emitter,this._onDidTerminateDebugSession=new t.Emitter,this._onDidChangeActiveDebugSession=new t.Emitter,this._onDidReceiveDebugSessionCustomEvent=new t.Emitter,this._debugServiceProxy=s.getProxy(D.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new t.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new m(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(h=>{h.onDidChange(y=>{this.registerAllDebugTypes(h)}),this.registerAllDebugTypes(h)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(s,i){const r=s;if(typeof r.sourceReference=="number"&&r.sourceReference>0){let c=`debug:${encodeURIComponent(r.path||"")}`,o="?";return i&&(c+=`${o}session=${encodeURIComponent(i.id)}`,o="&"),c+=`${o}ref=${r.sourceReference}`,P.URI.parse(c)}else{if(r.path)return P.URI.file(r.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(s){const i=[];for(const r of s.getAllExtensionDescriptions())if(r.contributes){const c=r.contributes.debuggers;if(c&&c.length>0)for(const o of c)(0,E.isDebuggerMainContribution)(o)&&i.push(o.type)}this._debugServiceProxy.$registerDebugTypes(i)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const s=[];return this._breakpoints.forEach(i=>s.push(i)),s}addBreakpoints(s){this.startBreakpoints();const i=s.filter(o=>{const u=o.id;return this._breakpoints.has(u)?!1:(this._breakpoints.set(u,o),!0)});this.fireBreakpointChanges(i,[],[]);const r=[],c=new Map;for(const o of i)if(o instanceof k.SourceBreakpoint){let u=c.get(o.location.uri.toString());u||(u={type:"sourceMulti",uri:o.location.uri,lines:[]},c.set(o.location.uri.toString(),u),r.push(u)),u.lines.push({id:o.id,enabled:o.enabled,condition:o.condition,hitCondition:o.hitCondition,logMessage:o.logMessage,line:o.location.range.start.line,character:o.location.range.start.character})}else o instanceof k.FunctionBreakpoint&&r.push({type:"function",id:o.id,enabled:o.enabled,hitCondition:o.hitCondition,logMessage:o.logMessage,condition:o.condition,functionName:o.functionName});return this._debugServiceProxy.$registerBreakpoints(r)}removeBreakpoints(s){this.startBreakpoints();const i=s.filter(u=>this._breakpoints.delete(u.id));this.fireBreakpointChanges([],i,[]);const r=i.filter(u=>u instanceof k.SourceBreakpoint).map(u=>u.id),c=i.filter(u=>u instanceof k.FunctionBreakpoint).map(u=>u.id),o=i.filter(u=>u instanceof k.DataBreakpoint).map(u=>u.id);return this._debugServiceProxy.$unregisterBreakpoints(r,c,o)}startDebugging(s,i,r){return this._debugServiceProxy.$startDebugging(s?s.uri:void 0,i,{parentSessionID:r.parentSession?r.parentSession.id:void 0,lifecycleManagedByParent:r.lifecycleManagedByParent,repl:r.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:r.noDebug,compact:r.compact,debugUI:r.debugUI,suppressSaveBeforeStart:r.suppressSaveBeforeStart})}stopDebugging(s){return this._debugServiceProxy.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,i,r){if(!i)return new k.Disposable(()=>{});const c=this._configProviderHandleCounter++;return this._configProviders.push({type:s,handle:c,provider:i}),this._debugServiceProxy.$registerDebugConfigurationProvider(s,r,!!i.provideDebugConfigurations,!!i.resolveDebugConfiguration,!!i.resolveDebugConfigurationWithSubstitutedVariables,c),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(o=>o.provider!==i),this._debugServiceProxy.$unregisterDebugConfigurationProvider(c)})}registerDebugAdapterDescriptorFactory(s,i,r){if(!r)return new k.Disposable(()=>{});if(!this.definesDebugType(s,i))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${i}' debugger.`);if(this.getAdapterDescriptorFactoryByType(i))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const c=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:i,handle:c,factory:r}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(i,c),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(o=>o.factory!==r),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(c)})}registerDebugAdapterTrackerFactory(s,i){if(!i)return new k.Disposable(()=>{});const r=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:s,handle:r,factory:i}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(c=>c.factory!==i)})}async $runInTerminal(s,i){return Promise.resolve(void 0)}async $substituteVariables(s,i){let r;const c=await this.getFolder(s);return c&&(r={uri:c.uri,name:c.name,index:c.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(r,i)}createDebugAdapter(s,i){if(s.type==="implementation")return new g(s.implementation)}createSignService(){}async $startDASession(s,i){const r=this,c=await this.getSession(i);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(c.type),c).then(o=>{if(!o)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${c.type}' (extension might have failed to activate)`);const u=this.convertToDto(o),h=this.createDebugAdapter(u,c);if(!h)throw new Error(`Couldn't create a debug adapter for type '${c.type}'.`);const y=h;return this._debugAdapters.set(s,y),this.getDebugAdapterTrackers(c).then(R=>(R&&this._debugAdaptersTrackers.set(s,R),y.onMessage(async M=>{if(M.type==="request"&&M.command==="handshake"){const U=M,A={type:"response",seq:0,command:U.command,request_seq:U.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const z=await this._signService.sign(U.arguments.value);A.body={signature:z},y.sendResponse(A)}else throw new Error("no signer")}catch(z){A.success=!1,A.message=z.message,y.sendResponse(A)}}else R&&R.onDidSendMessage&&R.onDidSendMessage(M),M=(0,E.convertToVSCPaths)(M,!0),r._debugServiceProxy.$acceptDAMessage(s,M)}),y.onError(M=>{R&&R.onError&&R.onError(M),this._debugServiceProxy.$acceptDAError(s,M.name,M.message,M.stack)}),y.onExit(M=>{R&&R.onExit&&R.onExit((0,C.withNullAsUndefined)(M),void 0),this._debugServiceProxy.$acceptDAExit(s,(0,C.withNullAsUndefined)(M),void 0)}),R&&R.onWillStartSession&&R.onWillStartSession(),y.startSession()))})}$sendDAMessage(s,i){i=(0,E.convertToDAPaths)(i,!1);const r=this._debugAdaptersTrackers.get(s);r&&r.onWillReceiveMessage&&r.onWillReceiveMessage(i),this._debugAdapters.get(s)?.sendMessage(i)}$stopDASession(s){const i=this._debugAdaptersTrackers.get(s);this._debugAdaptersTrackers.delete(s),i&&i.onWillStopSession&&i.onWillStopSession();const r=this._debugAdapters.get(s);return this._debugAdapters.delete(s),r?r.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const i=[],r=[],c=[];if(s.added)for(const o of s.added){const u=o.id;if(u&&!this._breakpoints.has(u)){let h;if(o.type==="function")h=new k.FunctionBreakpoint(o.functionName,o.enabled,o.condition,o.hitCondition,o.logMessage);else if(o.type==="data")h=new k.DataBreakpoint(o.label,o.dataId,o.canPersist,o.enabled,o.hitCondition,o.condition,o.logMessage);else{const y=P.URI.revive(o.uri);h=new k.SourceBreakpoint(new k.Location(y,new k.Position(o.line,o.character)),o.enabled,o.condition,o.hitCondition,o.logMessage)}h._id=u,this._breakpoints.set(u,h),i.push(h)}}if(s.removed)for(const o of s.removed){const u=this._breakpoints.get(o);u&&(this._breakpoints.delete(o),r.push(u))}if(s.changed){for(const o of s.changed)if(o.id){const u=this._breakpoints.get(o.id);if(u){if(u instanceof k.FunctionBreakpoint&&o.type==="function"){const h=u;h.enabled=o.enabled,h.condition=o.condition,h.hitCondition=o.hitCondition,h.logMessage=o.logMessage,h.functionName=o.functionName}else if(u instanceof k.SourceBreakpoint&&o.type==="source"){const h=u;h.enabled=o.enabled,h.condition=o.condition,h.hitCondition=o.hitCondition,h.logMessage=o.logMessage,h.location=new k.Location(P.URI.revive(o.uri),new k.Position(o.line,o.character))}c.push(u)}}}this.fireBreakpointChanges(i,r,c)}$provideDebugConfigurations(s,i,r){return(0,l.asPromise)(async()=>{const c=this.getConfigProviderByHandle(s);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const o=await this.getFolder(i);return c.provideDebugConfigurations(o,r)}).then(c=>{if(!c)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return c})}$resolveDebugConfiguration(s,i,r,c){return(0,l.asPromise)(async()=>{const o=this.getConfigProviderByHandle(s);if(!o)throw new Error("no DebugConfigurationProvider found");if(!o.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const u=await this.getFolder(i);return o.resolveDebugConfiguration(u,r,c)})}$resolveDebugConfigurationWithSubstitutedVariables(s,i,r,c){return(0,l.asPromise)(async()=>{const o=this.getConfigProviderByHandle(s);if(!o)throw new Error("no DebugConfigurationProvider found");if(!o.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const u=await this.getFolder(i);return o.resolveDebugConfigurationWithSubstitutedVariables(u,r,c)})}async $provideDebugAdapter(s,i){const r=this.getAdapterDescriptorFactoryByHandle(s);if(!r)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const c=await this.getSession(i);return this.getAdapterDescriptor(r,c).then(o=>{if(!o)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${c.type}'`);return this.convertToDto(o)})}async $acceptDebugSessionStarted(s){const i=await this.getSession(s);this._onDidStartDebugSession.fire(i)}async $acceptDebugSessionTerminated(s){const i=await this.getSession(s);i&&(this._onDidTerminateDebugSession.fire(i),this._debugSessions.delete(i.id))}async $acceptDebugSessionActiveChanged(s){this._activeDebugSession=s?await this.getSession(s):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(s,i){(await this.getSession(s))?._acceptNameChanged(i)}async $acceptDebugSessionCustomEvent(s,i){const c={session:await this.getSession(s),event:i.event,body:i.body};this._onDidReceiveDebugSessionCustomEvent.fire(c)}convertToDto(s){if(s instanceof k.DebugAdapterExecutable)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof k.DebugAdapterServer)return{type:"server",port:s.port,host:s.host};if(s instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:s.path};if(s instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(s){const i=this._adapterFactories.filter(r=>r.type===s);if(i.length>0)return i[0].factory}getAdapterDescriptorFactoryByHandle(s){const i=this._adapterFactories.filter(r=>r.handle===s);if(i.length>0)return i[0].factory}getConfigProviderByHandle(s){const i=this._configProviders.filter(r=>r.handle===s);if(i.length>0)return i[0].provider}definesDebugType(s,i){if(s.contributes){const r=s.contributes.debuggers;if(r&&r.length>0){for(const c of r)if(c.label&&c.type&&c.type===i)return!0}}return!1}getDebugAdapterTrackers(s){const r=s.configuration.type,c=this._trackerFactories.filter(o=>o.type===r||o.type==="*").map(o=>(0,l.asPromise)(()=>o.factory.createDebugAdapterTracker(s)).then(u=>u,u=>null));return Promise.race([Promise.all(c).then(o=>{const u=o.filter(h=>!!h);if(u.length>0)return new a(u)}),new Promise((o,u)=>{const h=setTimeout(()=>{clearTimeout(h),u(new Error("timeout"))},1e3)})]).catch(o=>{})}async getAdapterDescriptor(s,i){const r=i.configuration.debugServer;if(typeof r=="number")return Promise.resolve(new k.DebugAdapterServer(r));if(s){const o=await this._extensionService.getExtensionRegistry();return(0,l.asPromise)(()=>s.createDebugAdapterDescriptor(i,this.daExecutableFromPackage(i,o))).then(u=>{if(u)return u})}const c=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(i,c))}daExecutableFromPackage(s,i){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(s,i,r){(s.length>0||i.length>0||r.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:s,removed:i,changed:r}))}async getSession(s){if(s)if(typeof s=="string"){const i=this._debugSessions.get(s);if(i)return i}else{let i=this._debugSessions.get(s.id);if(!i){const r=await this.getFolder(s.folderUri),c=s.parent?this._debugSessions.get(s.parent):void 0;i=new v(this._debugServiceProxy,s.id,s.type,s.name,r,s.configuration,c),this._debugSessions.set(i.id,i),this._debugServiceProxy.$sessionCached(i.id)}return i}throw new Error("cannot find session")}getFolder(s){if(s){const i=P.URI.revive(s);return this._workspaceService.resolveWorkspaceFolder(i)}return Promise.resolve(void 0)}};f=qe([xe(0,L.IExtHostRpcService),xe(1,S.IExtHostWorkspace),xe(2,I.IExtHostExtensionService),xe(3,p.IExtHostConfiguration),xe(4,b.IExtHostEditorTabs),xe(5,w.IExtHostVariableResolverProvider)],f),e.ExtHostDebugServiceBase=f;class v{constructor(s,i,r,c,o,u,h){this._debugServiceProxy=s,this._id=i,this._type=r,this._name=c,this._workspaceFolder=o,this._configuration=u,this._parentSession=h}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(s){this._name=s,this._debugServiceProxy.$setDebugSessionName(this._id,s)}get parentSession(){return this._parentSession}_acceptNameChanged(s){this._name=s}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(s,i){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,s,i)}getDebugProtocolBreakpoint(s){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,s.id)}}e.ExtHostDebugSession=v;class m{constructor(s){this.value=Object.freeze({append(i){s.$appendDebugConsole(i)},appendLine(i){this.append(i+`
`)}})}}e.ExtHostDebugConsole=m;class a{constructor(s){this.trackers=s}onWillStartSession(){this.trackers.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.trackers.forEach(i=>i.onWillReceiveMessage?i.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.trackers.forEach(i=>i.onDidSendMessage?i.onDidSendMessage(s):void 0)}onWillStopSession(){this.trackers.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.trackers.forEach(i=>i.onError?i.onError(s):void 0)}onExit(s,i){this.trackers.forEach(r=>r.onExit?r.onExit(s,i):void 0)}}class g extends T.AbstractDebugAdapter{constructor(s){super(),this.implementation=s,s.onDidSendMessage(i=>{this.acceptMessage(i)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.implementation.handleMessage(s)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let n=class extends f{constructor(s,i,r,c,o,u){super(s,i,r,c,o,u)}};n=qe([xe(0,L.IExtHostRpcService),xe(1,S.IExtHostWorkspace),xe(2,I.IExtHostExtensionService),xe(3,p.IExtHostConfiguration),xe(4,b.IExtHostEditorTabs),xe(5,w.IExtHostVariableResolverProvider)],n),e.WorkerExtHostDebugService=n}),define(De[281],Ie([1,0,10,71,2,5,273,15,82,85,26,192,16,54,39]),function(J,e,l,t,C,P,_,D,b,I,L,k,S,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class p{constructor(f,v,m,a,g){this._hostUtils=m,this._rpcProtocol=new _.RPCProtocol(f,null,a),v=p._transform(v,this._rpcProtocol);const n=new I.ServiceCollection(...(0,b.getSingletonServiceDescriptors)());n.set(L.IExtHostInitDataService,{_serviceBrand:void 0,...v,messagePorts:g}),n.set(S.IExtHostRpcService,new S.ExtHostRpcService(this._rpcProtocol)),n.set(T.IURITransformerService,new T.URITransformerService(a)),n.set(E.IHostUtils,m);const d=new k.InstantiationService(n,!0);this._logService=d.invokeFunction(c=>c.get(D.ILogService)),t.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",v),this._extensionService=d.invokeFunction(c=>c.get(E.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const s=new WeakMap;this._extensionService.getExtensionPathIndex().then(c=>{Error.prepareStackTrace=(o,u)=>{let h="",y,R;for(const M of u)h+=`
	at ${M.toString()}`,R=M.getFileName(),!y&&R&&(y=c.findSubstr(C.URI.file(R)));return s.set(o,y),`${o.name||"Error"}: ${o.message||""}${h}`}});const i=this._rpcProtocol.getProxy(P.MainContext.MainThreadExtensionService),r=this._rpcProtocol.getProxy(P.MainContext.MainThreadErrors);l.setUnexpectedErrorHandler(c=>{const o=l.transformErrorForSerialization(c),u=s.get(c);u?i.$onExtensionRuntimeError(u.identifier,o):r.$onUnexpectedError(o)})}async asBrowserUri(f){const v=this._rpcProtocol.getProxy(P.MainContext.MainThreadExtensionService);return C.URI.revive(await v.$asBrowserUri(f))}terminate(f){this._extensionService.terminate(f)}static _transform(f,v){f.allExtensions.forEach(a=>{a.extensionLocation=C.URI.revive(v.transformIncomingURIs(a.extensionLocation));const g={};a.browserNlsBundleUris&&(Object.keys(a.browserNlsBundleUris).forEach(n=>g[n]=C.URI.revive(v.transformIncomingURIs(a.browserNlsBundleUris[n]))),a.browserNlsBundleUris=g)}),f.environment.appRoot=C.URI.revive(v.transformIncomingURIs(f.environment.appRoot));const m=f.environment.extensionDevelopmentLocationURI;return m&&(f.environment.extensionDevelopmentLocationURI=m.map(a=>C.URI.revive(v.transformIncomingURIs(a)))),f.environment.extensionTestsLocationURI=C.URI.revive(v.transformIncomingURIs(f.environment.extensionTestsLocationURI)),f.environment.globalStorageHome=C.URI.revive(v.transformIncomingURIs(f.environment.globalStorageHome)),f.environment.workspaceStorageHome=C.URI.revive(v.transformIncomingURIs(f.environment.workspaceStorageHome)),f.logsLocation=C.URI.revive(v.transformIncomingURIs(f.logsLocation)),f.logFile=C.URI.revive(v.transformIncomingURIs(f.logFile)),f.workspace=v.transformIncomingURIs(f.workspace),f}}e.ExtensionHostMain=p}),define(De[282],Ie([1,0,18,11,176,191,199,72,57,39,16,38,7,47,32,211,213,33]),function(J,e,l,t,C,P,_,D,b,I,L,k,S,T,E,p,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.runInExternalTerminal=e.ExtHostDebugService=void 0;let v=class extends D.ExtHostDebugServiceBase{constructor(d,s,i,r,c,o,u){super(d,s,i,r,o,u),this._terminalService=c,this._integratedTerminalInstances=new g}createDebugAdapter(d,s){switch(d.type){case"server":return new p.SocketDebugAdapter(d);case"pipeServer":return new p.NamedPipeDebugAdapter(d);case"executable":return new p.ExecutableDebugAdapter(d,s.type)}return super.createDebugAdapter(d,s)}daExecutableFromPackage(d,s){const i=p.ExecutableDebugAdapter.platformAdapterExecutable(s.getAllExtensionDescriptions(),d.type);if(i)return new S.DebugAdapterExecutable(i.command,i.args,i.options)}createSignService(){return new _.SignService}async $runInTerminal(d,s){if(d.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(z=>{this._integratedTerminalInstances.onTerminalClosed(z)}));const i=await this._configurationService.getConfigProvider(),r=this._terminalService.getDefaultShell(!0),c=this._terminalService.getDefaultShellArgs(!0),o=d.title||C.localize(0,null),u=JSON.stringify({shell:r,shellArgs:c});let h=await this._integratedTerminalInstances.checkout(u,o),y,R=!1;if(h)y=d.cwd;else{const z={shellPath:r,shellArgs:c,cwd:d.cwd,name:o,iconPath:new S.ThemeIcon("debug")};R=!0,h=this._terminalService.createTerminalFromOptions(z,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(h,u)}h.show(!0);const M=await h.processId;R?await new Promise(z=>setTimeout(z,1e3)):i.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(r.indexOf("powershell")>=0||r.indexOf("pwsh")>=0||r.indexOf("cmd.exe")>=0?h.sendText("cls"):r.indexOf("bash")>=0?h.sendText("clear"):t.isWindows?h.sendText("cls"):h.sendText("clear"));const U=(0,w.prepareCommand)(r,d.args,!!d.argsCanBeInterpretedByShell,y,d.env);h.sendText(U);const A=this.onDidTerminateDebugSession(z=>{z.id===s&&(this._integratedTerminalInstances.free(h),A.dispose())});return M}else if(d.kind==="external")return a(d,await this._configurationService.getConfigProvider());return super.$runInTerminal(d,s)}};v=qe([xe(0,L.IExtHostRpcService),xe(1,E.IExtHostWorkspace),xe(2,I.IExtHostExtensionService),xe(3,f.IExtHostConfiguration),xe(4,k.IExtHostTerminalService),xe(5,b.IExtHostEditorTabs),xe(6,T.IExtHostVariableResolverProvider)],v),e.ExtHostDebugService=v;let m;function a(n,d){if(!m)if(t.isWindows)m=new P.WindowsExternalTerminalService;else if(t.isMacintosh)m=new P.MacExternalTerminalService;else if(t.isLinux)m=new P.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const s=d.getConfiguration("terminal");return m.runInTerminal(n.title,n.cwd,n.args,n.env||{},s.external||{})}e.runInExternalTerminal=a;class g{constructor(){this._terminalInstances=new Map}async checkout(d,s){const r=[...this._terminalInstances.entries()].map(([c,o])=>(0,l.createCancelablePromise)(async u=>{if(c.name!==s||o.lastUsedAt!==-1&&await(0,w.hasChildProcesses)(await c.processId))return null;const h=Date.now();return o.lastUsedAt+g.minUseDelay>h||u.isCancellationRequested||o.config!==d?null:(o.lastUsedAt=h,c)}));return await(0,l.firstParallel)(r,c=>!!c)}insert(d,s){this._terminalInstances.set(d,{lastUsedAt:Date.now(),config:s})}free(d){const s=this._terminalInstances.get(d);s&&(s.lastUsedAt=-1)}onTerminalClosed(d){this._terminalInstances.delete(d)}}g.minUseDelay=1e3}),define(De[283],Ie([1,0,9,2,110,32,56,33,45,38,16,26,70,12,15,65,22,81,47]),function(J,e,l,t,C,P,_,D,b,I,L,k,S,T,E,p,w,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let m=class extends S.ExtHostTaskBase{constructor(g,n,d,s,i,r,c,o,u){super(g,n,d,s,i,r,c,o),this.workspaceService=d,this.variableResolver=u,n.remote.isRemote&&n.remote.authority?this.registerTaskSystem(T.Schemas.vscodeRemote,{scheme:T.Schemas.vscodeRemote,authority:n.remote.authority,platform:process.platform}):this.registerTaskSystem(T.Schemas.file,{scheme:T.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(g,n){const d=n;if(!n.execution&&d._id===void 0)throw new Error("Tasks to execute must include an execution");if(d._id!==void 0){const s=S.TaskHandleDTO.from(d,this.workspaceService),i=await this._proxy.$getTaskExecution(s);if(i.task===void 0)throw new Error("Task from execution DTO is undefined");const r=await this.getTaskExecution(i,n);return this._proxy.$executeTask(s).catch(()=>{}),r}else{const s=S.TaskDTO.from(n,g);if(s===void 0)return Promise.reject(new Error("Task is not valid"));S.CustomExecutionDTO.is(s.execution)&&await this.addCustomExecution(s,n,!1);const i=await this.getTaskExecution(await this._proxy.$getTaskExecution(s),n);return this._proxy.$executeTask(s).catch(()=>{}),i}}provideTasksInternal(g,n,d,s){const i=[];if(s)for(const r of s){this.checkDeprecation(r,d),(!r.definition||!g[r.definition.type])&&this._logService.warn(`The task [${r.source}, ${r.name}] uses an undefined task type. The task will be ignored in the future.`);const c=S.TaskDTO.from(r,d.extension);c&&(i.push(c),S.CustomExecutionDTO.is(c.execution)&&n.push(this.addCustomExecution(c,r,!0)))}return{tasks:i,extension:d.extension}}async resolveTaskInternal(g){return g}async getAFolder(g){let n=g&&g.length>0?g[0]:void 0;if(!n){const d=t.URI.file((0,f.homedir)());n=new b.WorkspaceFolder({uri:d,name:w.basename(d),index:0})}return{uri:n.uri,name:n.name,index:n.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(g,n){const d=t.URI.revive(g),s={process:void 0,variables:Object.create(null)},i=await this._workspaceProvider.resolveWorkspaceFolder(d),r=await this._workspaceProvider.getWorkspaceFolders2()??[],c=await this.variableResolver.getResolver(),o=i?{uri:i.uri,name:i.name,index:i.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(r);for(const u of n.variables)s.variables[u]=await c.resolveAsync(o,u);if(n.process!==void 0){let u;if(n.process.path!==void 0){u=n.process.path.split(l.delimiter);for(let h=0;h<u.length;h++)u[h]=await c.resolveAsync(o,u[h])}s.process=await C.win32.findExecutable(await c.resolveAsync(o,n.process.name),n.process.cwd!==void 0?await c.resolveAsync(o,n.process.cwd):void 0,u)}return s}async $jsonTasksSupported(){return!0}async $findExecutable(g,n,d){return C.win32.findExecutable(g,n,d)}};m=qe([xe(0,L.IExtHostRpcService),xe(1,k.IExtHostInitDataService),xe(2,P.IExtHostWorkspace),xe(3,_.IExtHostDocumentsAndEditors),xe(4,D.IExtHostConfiguration),xe(5,I.IExtHostTerminalService),xe(6,E.ILogService),xe(7,p.IExtHostApiDeprecationService),xe(8,v.IExtHostVariableResolverProvider)],m),e.ExtHostTask=m}),define(De[284],Ie([1,0,81,47]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class C extends t.ExtHostVariableResolverProviderService{homeDir(){return(0,l.homedir)()}}e.NodeExtHostVariableResolverProviderService=C}),define(De[140],Ie([1,0,17,18,21,50,12,9,22,2,30]),function(J,e,l,t,C,P,_,D,b,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class k{constructor(v,m,a,g){this.query=v,this.provider=m,this.fileUtils=a,this.processType=g,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(v,m){const a=this.query.folderQueries||[],g=new C.CancellationTokenSource;return m.onCancellationRequested(()=>g.cancel()),new Promise((n,d)=>{this.collector=new T(v);let s=!1;const i=(r,c)=>{if(!s&&!this.isLimitHit){const o=this.resultSize(r);p(r)&&typeof this.query.maxResults=="number"&&this.resultCount+o>this.query.maxResults&&(this.isLimitHit=!0,s=!0,g.cancel(),r=this.trimResultToSize(r,this.query.maxResults-this.resultCount));const u=this.resultSize(r);this.resultCount+=u,(u>0||!p(r))&&this.collector.add(r,c)}};Promise.all(a.map((r,c)=>this.searchInFolder(r,o=>i(o,c),g.token))).then(r=>{g.dispose(),this.collector.flush();const c=r.some(o=>!!o&&!!o.limitHit);n({limitHit:this.isLimitHit||c,messages:(0,l.flatten)(r.map(o=>o?.message?Array.isArray(o.message)?o.message:[o.message]:[])),stats:{type:this.processType}})},r=>{g.dispose();const c=(0,P.toErrorMessage)(r);d(new Error(c))})})}resultSize(v){return p(v)?Array.isArray(v.ranges)?v.ranges.length:1:0}trimResultToSize(v,m){const a=Array.isArray(v.ranges)?v.ranges:[v.ranges],g=Array.isArray(v.preview.matches)?v.preview.matches:[v.preview.matches];return{ranges:a.slice(0,m),preview:{matches:g.slice(0,m),text:v.preview.text},uri:v.uri}}async searchInFolder(v,m,a){const g=new L.QueryGlobTester(this.query,v),n=[],d={report:r=>{if(!this.validateProviderResult(r))return;const c=v.folder.scheme===_.Schemas.file?(0,L.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(b.dirname(r.uri))):void 0,o=b.relativePath(v.folder,r.uri);if(o){const u=g.includedInQuery(o,D.basename(o),c);(0,t.isThenable)(u)?n.push(u.then(h=>{h&&m(r)})):u&&m(r)}}},s=this.getSearchOptionsForFolder(v),i=await this.provider.provideTextSearchResults(S(this.query.contentPattern),s,d,a);return n.length&&await Promise.all(n),i}validateProviderResult(v){if(p(v)){if(Array.isArray(v.ranges)){if(!Array.isArray(v.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(v.preview.matches.length!==v.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(v.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(v){const m=(0,L.resolvePatternsForProvider)(this.query.includePattern,v.includePattern),a=(0,L.resolvePatternsForProvider)(this.query.excludePattern,v.excludePattern),g={folder:I.URI.from(v.folder),excludes:a,includes:m,useIgnoreFiles:!v.disregardIgnoreFiles,useGlobalIgnoreFiles:!v.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!v.disregardParentIgnoreFiles,followSymlinks:!v.ignoreSymlinks,encoding:v.fileEncoding&&this.fileUtils.toCanonicalName(v.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return g.usePCRE2=this.query.usePCRE2,g}}e.TextSearchManager=k;function S(f){return{isCaseSensitive:f.isCaseSensitive||!1,isRegExp:f.isRegExp||!1,isWordMatch:f.isWordMatch||!1,isMultiline:f.isMultiline||!1,pattern:f.pattern}}class T{constructor(v){this._onResult=v,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new w(512,m=>this.sendItems(m))}add(v,m){this._currentFileMatch&&(this._currentFolderIdx!==m||!b.isEqual(this._currentUri,v.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=m,this._currentFileMatch={resource:v.uri,results:[]}),this._currentFileMatch.results.push(E(v))}pushToCollector(){const v=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,v)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(v){this._onResult(v)}}e.TextSearchResultsCollector=T;function E(f){return p(f)?{preview:{matches:(0,l.mapArrayOrNot)(f.preview.matches,v=>({startLineNumber:v.start.line,startColumn:v.start.character,endLineNumber:v.end.line,endColumn:v.end.character})),text:f.preview.text},ranges:(0,l.mapArrayOrNot)(f.ranges,v=>({startLineNumber:v.start.line,startColumn:v.start.character,endLineNumber:v.end.line,endColumn:v.end.character}))}:{text:f.text,lineNumber:f.lineNumber}}function p(f){return!!f.preview}e.extensionResultIsMatch=p;class w{constructor(v,m){this.maxBatchSize=v,this.cb=m,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(v,m){!v||this.addItemToBatch(v,m)}addItems(v,m){!v||this.addItemsToBatch(v,m)}addItemToBatch(v,m){this.batch.push(v),this.batchSize+=m,this.onUpdate()}addItemsToBatch(v,m){this.batch=this.batch.concat(v),this.batchSize+=m,this.onUpdate()}onUpdate(){this.totalNumberCompleted<w.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},w.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=w,w.TIMEOUT=4e3,w.START_BATCH_AFTER_COUNT=50}),define(De[73],Ie([1,0,6,5,3,277,16,54,15,2,140]),function(J,e,l,t,C,P,_,D,b,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,C.createDecorator)("IExtHostSearch");let k=class{constructor(p,w,f){this.extHostRpc=p,this._uriTransformer=w,this._logService=f,this._proxy=this.extHostRpc.getProxy(t.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new P.FileSearchManager}_transformScheme(p){return this._uriTransformer.transformOutgoingScheme(p)}registerTextSearchProvider(p,w){if(this._textSearchUsedSchemes.has(p))throw new Error(`a text search provider for the scheme '${p}' is already registered`);this._textSearchUsedSchemes.add(p);const f=this._handlePool++;return this._textSearchProvider.set(f,w),this._proxy.$registerTextSearchProvider(f,this._transformScheme(p)),(0,l.toDisposable)(()=>{this._textSearchUsedSchemes.delete(p),this._textSearchProvider.delete(f),this._proxy.$unregisterProvider(f)})}registerFileSearchProvider(p,w){if(this._fileSearchUsedSchemes.has(p))throw new Error(`a file search provider for the scheme '${p}' is already registered`);this._fileSearchUsedSchemes.add(p);const f=this._handlePool++;return this._fileSearchProvider.set(f,w),this._proxy.$registerFileSearchProvider(f,this._transformScheme(p)),(0,l.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(p),this._fileSearchProvider.delete(f),this._proxy.$unregisterProvider(f)})}$provideFileSearchResults(p,w,f,v){const m=S(f),a=this._fileSearchProvider.get(p);if(a)return this._fileSearchManager.fileSearch(m,a,g=>{this._proxy.$handleFileMatch(p,w,g.map(n=>n.resource))},v);throw new Error("unknown provider: "+p)}$clearCache(p){return this._fileSearchManager.clearCache(p),Promise.resolve(void 0)}$provideTextSearchResults(p,w,f,v){const m=this._textSearchProvider.get(p);if(!m||!m.provideTextSearchResults)throw new Error(`Unknown provider ${p}`);const a=S(f);return this.createTextSearchManager(a,m).search(n=>this._proxy.$handleTextMatch(p,w,n),v)}$enableExtensionHostSearch(){}createTextSearchManager(p,w){return new L.TextSearchManager(p,w,{readdir:f=>Promise.resolve([]),toCanonicalName:f=>f},"textSearchProvider")}};k=qe([xe(0,_.IExtHostRpcService),xe(1,D.IURITransformerService),xe(2,b.ILogService)],k),e.ExtHostSearch=k;function S(E){return{...E,folderQueries:E.folderQueries&&E.folderQueries.map(T),extraFileResources:E.extraFileResources&&E.extraFileResources.map(p=>I.URI.revive(p))}}e.reviveQuery=S;function T(E){return{...E,folder:I.URI.revive(E.folder)}}}),define(De[285],Ie([1,0,82,139,32,135,33,37,56,38,70,72,73,92,53,65,138,66,46,91,125,57,136,15,223,47,137]),function(J,e,l,t,C,P,_,D,b,I,L,k,S,T,E,p,w,f,v,m,a,g,n,d,s,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,l.registerSingleton)(d.ILoggerService,n.ExtHostLoggerService,!0),(0,l.registerSingleton)(d.ILogService,s.ExtHostLogService,!0),(0,l.registerSingleton)(p.IExtHostApiDeprecationService,p.ExtHostApiDeprecationService,!1),(0,l.registerSingleton)(D.IExtHostCommands,D.ExtHostCommands,!1),(0,l.registerSingleton)(_.IExtHostConfiguration,_.ExtHostConfiguration,!1),(0,l.registerSingleton)(f.IExtHostConsumerFileSystem,f.ExtHostConsumerFileSystem,!1),(0,l.registerSingleton)(k.IExtHostDebugService,k.WorkerExtHostDebugService,!1),(0,l.registerSingleton)(P.IExtHostDecorations,P.ExtHostDecorations,!1),(0,l.registerSingleton)(b.IExtHostDocumentsAndEditors,b.ExtHostDocumentsAndEditors,!1),(0,l.registerSingleton)(v.IExtHostFileSystemInfo,v.ExtHostFileSystemInfo,!1),(0,l.registerSingleton)(t.IExtHostOutputService,t.ExtHostOutputService,!0),(0,l.registerSingleton)(S.IExtHostSearch,S.ExtHostSearch,!1),(0,l.registerSingleton)(T.IExtHostStorage,T.ExtHostStorage,!1),(0,l.registerSingleton)(L.IExtHostTask,L.WorkerExtHostTask,!1),(0,l.registerSingleton)(I.IExtHostTerminalService,I.WorkerExtHostTerminalService,!1),(0,l.registerSingleton)(E.IExtHostTunnelService,E.ExtHostTunnelService,!1),(0,l.registerSingleton)(w.IExtHostWindow,w.ExtHostWindow,!1),(0,l.registerSingleton)(C.IExtHostWorkspace,C.ExtHostWorkspace,!1),(0,l.registerSingleton)(m.IExtHostSecretState,m.ExtHostSecretState,!1),(0,l.registerSingleton)(a.IExtHostTelemetry,a.ExtHostTelemetry,!1),(0,l.registerSingleton)(r.IExtHostTelemetryLogService,r.ExtHostTelemetryLogService,!1),(0,l.registerSingleton)(g.IExtHostEditorTabs,g.ExtHostEditorTabs,!1),(0,l.registerSingleton)(i.IExtHostVariableResolverProvider,i.ExtHostVariableResolverProviderService,!1)}),define(De[93],Ie([1,0,17,15,30,69]),function(J,e,l,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function _(k){return k.startsWith("**")||k.startsWith("/")?k:`/${k}`}e.anchorGlob=_;function D(k,S,T,E){const p=(0,l.mapArrayOrNot)(T,b),w=new C.TextSearchMatch(S,p,E),f=w.preview.matches;return{ranges:(0,l.mapArrayOrNot)(p,I),uri:k,preview:{text:w.preview.text,matches:(0,l.mapArrayOrNot)(f,I)}}}e.createTextSearchResult=D;function b(k){return new C.SearchRange(k.start.line,k.start.character,k.end.line,k.end.character)}function I(k){return new P.Range(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn)}let L=class{constructor(S,T){this.prefix=S,this.logService=T}appendLine(S){this.logService.debug(`${this.prefix}#search`,S)}};L=qe([xe(1,t.ILogService)],L),e.OutputChannel=L}),define(De[286],Ie([1,0,44,9,79,31,11,8,93,287]),function(J,e,l,t,C,P,_,D,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const L=I.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function k(m,a,g,n){const d=S(m,a,g,n),s=a.folder.fsPath;return{cmd:l.spawn(L,d.args,{cwd:s}),rgDiskPath:L,siblingClauses:d.siblingClauses,rgArgs:d,cwd:s}}e.spawnRipgrepCmd=k;function S(m,a,g,n){const d=["--files","--hidden","--case-sensitive"];E([a],g,!1).forEach(i=>{const r=(0,b.anchorGlob)(i);if(d.push("-g",r),_.isMacintosh){const c=(0,C.normalizeNFD)(r);c!==r&&d.push("-g",c)}});const s=T([a],n,void 0,!1);return s.globArgs.forEach(i=>{const r=`!${(0,b.anchorGlob)(i)}`;if(d.push("-g",r),_.isMacintosh){const c=(0,C.normalizeNFD)(r);c!==r&&d.push("-g",c)}}),a.disregardIgnoreFiles!==!1?d.push("--no-ignore"):a.disregardParentIgnoreFiles!==!1&&d.push("--no-ignore-parent"),a.ignoreSymlinks||d.push("--follow"),m.exists&&d.push("--quiet"),d.push("--no-config"),a.disregardGlobalIgnoreFiles&&d.push("--no-ignore-global"),{args:d,siblingClauses:s.siblingClauses}}function T(m,a,g,n=!0){const d=[];let s={};return m.forEach(i=>{const r=Object.assign({},i.excludePattern||{},a||{}),c=p(r,n?i.folder.fsPath:void 0,g);d.push(...c.globArgs),c.siblingClauses&&(s=Object.assign(s,c.siblingClauses))}),{globArgs:d,siblingClauses:s}}e.foldersToRgExcludeGlobs=T;function E(m,a,g=!0){const n=[];return m.forEach(d=>{const s=Object.assign({},a||{},d.includePattern||{}),i=p(s,g?d.folder.fsPath:void 0);n.push(...i.globArgs)}),n}e.foldersToIncludeGlobs=E;function p(m,a,g){const n=[],d={};return Object.keys(m).forEach(s=>{if(g&&g.has(s)||!s)return;const i=m[s];s=f(a?w(a,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof i=="boolean"&&i?(s.startsWith("\\\\")&&(s+="**"),n.push(v(s))):i&&i.when&&(d[s]=i)}),{globArgs:n,siblingClauses:d}}function w(m,a){return t.isAbsolute(a)?a:t.join(m,a)}e.getAbsoluteGlob=w;function f(m){return m=D.rtrim(m,"\\"),D.rtrim(m,"/")}function v(m){return P.getRoot(m).toLowerCase()==="c:/"?m.replace(/^c:[/\\]/i,"/"):m}e.fixDriveC=v}),define(De[288],Ie([1,0,44,61,9,289,17,50,36,79,31,11,51,8,14,29,30,286,105]),function(J,e,l,t,C,P,_,D,b,I,L,k,S,T,E,p,w,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const m=new Set;process.on("exit",()=>{m.forEach(s=>s())});class a{constructor(i){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=i,this.filePattern=i.filePattern||"",this.includePattern=i.includePattern&&b.parse(i.includePattern),this.maxResults=i.maxResults||null,this.exists=!!i.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,v.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=i.excludePattern&&b.parse(i.excludePattern),this.folderExcludePatterns=new Map,i.folderQueries.forEach(r=>{const c=Object.assign({},r.excludePattern||{},this.config.excludePattern||{}),o=r.folder.fsPath;i.folderQueries.map(u=>u.folder.fsPath).filter(u=>u!==o).forEach(u=>{(0,L.isEqualOrParent)(u,o)&&(c[C.relative(o,u)]=!0)}),this.folderExcludePatterns.set(o,new n(c,o))})}cancel(){this.isCanceled=!0,m.forEach(i=>i())}walk(i,r,c,o,u){if(this.fileWalkSW=S.StopWatch.create(!1),this.isCanceled)return u(null,this.isLimitHit);r.forEach(h=>{const y=C.basename(h.fsPath);this.globalExcludePattern&&this.globalExcludePattern(h.fsPath,y)||this.matchFile(c,{relativePath:h.fsPath,searchPath:void 0})}),this.cmdSW=S.StopWatch.create(!1),this.parallel(i,(h,y)=>{this.call(this.cmdTraversal,this,h,c,o,R=>{if(R){const M=(0,D.toErrorMessage)(R);console.error(M),this.errors.push(M),y(R,void 0)}else y(null,void 0)})},(h,y)=>{this.fileWalkSW.stop();const R=h?_.coalesce(h)[0]:null;u(R,this.isLimitHit)})}parallel(i,r,c){const o=new Array(i.length),u=new Array(i.length);let h=!1,y=0;if(i.length===0)return c(null,[]);i.forEach((R,M)=>{r(R,(U,A)=>{if(U?(h=!0,o[M]=null,u[M]=U):(o[M]=A,u[M]=null),++y===i.length)return c(h?u:null,o)})})}call(i,r,...c){try{i.apply(r,c)}catch(o){c[c.length-1](o)}}cmdTraversal(i,r,c,o){const u=i.folder.fsPath,h=k.isMacintosh,y=()=>z&&z.kill();m.add(y);let R=B=>{m.delete(y),R=()=>{},o(B)},M="";const U=this.initDirectoryTree(),A=(0,f.spawnRipgrepCmd)(this.config,i,this.config.includePattern,this.folderExcludePatterns.get(i.folder.fsPath).expression),z=A.cmd,$=!Object.keys(A.siblingClauses).length,N=A.rgArgs.args.map(B=>B.match(/^-/)?B:`'${B}'`).join(" ");let K=`${A.rgDiskPath} ${N}
 - cwd: ${A.cwd}`;A.rgArgs.siblingClauses&&(K+=`
 - Sibling clauses: ${JSON.stringify(A.rgArgs.siblingClauses)}`),c({message:K}),this.cmdResultCount=0,this.collectStdout(z,"utf8",c,(B,O,x)=>{if(B){R(B);return}if(this.isLimitHit){R();return}const q=(M+(h?I.normalizeNFC(O||""):O)).split(`
`);if(x){const Y=q.length;q[Y-1]=q[Y-1].trim(),q[Y-1]||q.pop()}else M=q.pop()||"";if(q.length&&q[0].indexOf(`
`)!==-1){R(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=q.length,$){for(const Y of q)if(this.matchFile(r,{base:u,relativePath:Y,searchPath:this.getSearchPath(i,Y)}),this.isLimitHit){y();break}(x||this.isLimitHit)&&R();return}this.addDirectoryEntries(i,U,u,q,r),x&&(this.matchDirectoryTree(U,u,r),R())})}spawnFindCmd(i){const r=this.folderExcludePatterns.get(i.folder.fsPath),c=r.getBasenameTerms(),o=r.getPathTerms(),u=["-L","."];if(c.length||o.length){u.push("-not","(","(");for(const h of c)u.push("-name",h),u.push("-o");for(const h of o)u.push("-path",h),u.push("-o");u.pop(),u.push(")","-prune",")")}return u.push("-type","f"),l.spawn("find",u,{cwd:i.folder.fsPath})}readStdout(i,r,c){let o="";this.collectStdout(i,r,()=>{},(u,h,y)=>{if(u){c(u);return}o+=h,y&&c(null,o)})}collectStdout(i,r,c,o){let u=(R,M,U)=>{(R||U)&&(u=()=>{},this.cmdSW?.stop()),o(R,M,U)},h=!1;i.stdout?(this.forwardData(i.stdout,r,u),i.stdout.once("data",()=>h=!0)):c({message:"stdout is null"});let y;i.stderr?y=this.collectData(i.stderr):c({message:"stderr is null"}),i.on("error",R=>{u(R)}),i.on("close",R=>{let M;!h&&(M=this.decodeData(y,r))&&d(M)?u(new Error(`command failed with error code ${R}: ${this.decodeData(y,r)}`)):(this.exists&&R===0&&(this.isLimitHit=!0),u(null,"",!0))})}forwardData(i,r,c){const o=new P.StringDecoder(r);return i.on("data",u=>{c(null,o.write(u))}),o}collectData(i){const r=[];return i.on("data",c=>{r.push(c)}),r}decodeData(i,r){const c=new P.StringDecoder(r);return i.map(o=>c.write(o)).join("")}initDirectoryTree(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}addDirectoryEntries(i,{pathToEntries:r},c,o,u){o.indexOf(this.filePattern)!==-1&&this.matchFile(u,{base:c,relativePath:this.filePattern,searchPath:this.getSearchPath(i,this.filePattern)});const h=y=>{const R=C.basename(y),M=C.dirname(y);let U=r[M];U||(U=r[M]=[],h(M)),U.push({base:c,relativePath:y,basename:R,searchPath:this.getSearchPath(i,y)})};o.forEach(h)}matchDirectoryTree({rootEntries:i,pathToEntries:r},c,o){const u=this,h=this.folderExcludePatterns.get(c),y=this.filePattern;function R(M){u.directoriesWalked++;const U=(0,w.hasSiblingFn)(()=>M.map(A=>A.basename));for(let A=0,z=M.length;A<z;A++){const $=M[A],{relativePath:N,basename:K}=$;if(h.test(N,K,y!==K?U:void 0))continue;const B=r[N];if(B)R(B);else{if(u.filesWalked++,N===y)continue;u.matchFile(o,$)}if(u.isLimitHit)break}}R(i)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(i,r,c,o,u){const h=i.folder,y=(0,w.hasSiblingFn)(()=>c);this.parallel(c,(R,M)=>{if(this.isCanceled||this.isLimitHit)return M(null);const U=r?[r,R].join(C.sep):R;if(this.folderExcludePatterns.get(i.folder.fsPath).test(U,R,this.config.filePattern!==R?y:void 0))return M(null);const A=[h.fsPath,U].join(C.sep);t.lstat(A,(z,$)=>{if(z||this.isCanceled||this.isLimitHit)return M(null);this.statLinkIfNeeded(A,$,(N,K)=>N||this.isCanceled||this.isLimitHit?M(null):K.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(A,$,(B,O)=>B||this.isCanceled||this.isLimitHit||(O=O||"",this.walkedPaths[O])?M(null):(this.walkedPaths[O]=!0,p.Promises.readdir(A).then(x=>{if(this.isCanceled||this.isLimitHit)return M(null);this.doWalk(i,U,x,o,V=>M(V||null))},x=>{M(null)})))):(this.filesWalked++,U===this.filePattern||this.maxFilesize&&E.isNumber(K.size)&&K.size>this.maxFilesize||this.matchFile(o,{base:h.fsPath,relativePath:U,searchPath:this.getSearchPath(i,U)}),M(null,void 0)))})},R=>{const M=R&&_.coalesce(R);return u(M&&M.length>0?M[0]:void 0)})}matchFile(i,r){this.isFileMatch(r)&&(!this.includePattern||this.includePattern(r.relativePath,C.basename(r.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||i(r))}isFileMatch(i){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,w.isFilePatternMatch)(i,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(i,r,c){return r.isSymbolicLink()?t.stat(i,c):c(null,r)}realPathIfNeeded(i,r,c){return r.isSymbolicLink()?t.realpath(i,(o,u)=>o?c(o):c(null,u)):c(null,i)}getSearchPath(i,r){return i.folderName?C.join(i.folderName,r):r}}e.FileWalker=a;class g{constructor(i){this.folderQueries=i.folderQueries,this.extraFiles=i.extraFileResources||[],this.walker=new a(i)}search(i,r,c){this.walker.walk(this.folderQueries,this.extraFiles,i,r,(o,u)=>{c(o,{limitHit:u,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=g;class n{constructor(i,r){this.expression=i,this.root=r,this.init(i)}init(i){let r,c;Object.keys(i).filter(o=>i[o]).forEach(o=>{C.isAbsolute(o)?(r=r||b.getEmptyExpression(),r[o]=i[o]):(c=c||b.getEmptyExpression(),c[o]=i[o])}),this.absoluteParsedExpr=r&&b.parse(r,{trimForExclusions:!0}),this.relativeParsedExpr=c&&b.parse(c,{trimForExclusions:!0})}test(i,r,c){return this.relativeParsedExpr&&this.relativeParsedExpr(i,r,c)||this.absoluteParsedExpr&&this.absoluteParsedExpr(C.join(this.root,i),r,c)}getBasenameTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...b.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...b.getBasenameTerms(this.relativeParsedExpr)),i}getPathTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...b.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...b.getPathTerms(this.relativeParsedExpr)),i}}function d(s){const i=s.trim().split(`
`),r=i[0].trim();if(r.startsWith("Error parsing regex"))return r;if(r.startsWith("regex parse error"))return T.uppercaseFirstLetter(i[i.length-1].trim());if(r.startsWith("error parsing glob")||r.startsWith("unsupported encoding"))return r.charAt(0).toUpperCase()+r.substr(1);if(r==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(r.startsWith("Literal "))return r}e.rgErrorMsgForDisplay=d}),define(De[290],Ie([1,0,96,23]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function C(s){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(i=>i===s)}e.isUTFEncoding=C,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const P=512,_=512,D=512*8,b=512*128;var I;(function(s){s[s.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(I=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class L extends Error{constructor(i,r){super(i),this.decodeStreamErrorKind=r}}e.DecodeStreamError=L;class k{constructor(i){this.iconvLiteDecoder=i}static async create(i){let r;if(i!==e.UTF8)r=(await new Promise((o,u)=>{J(["@vscode/iconv-lite-umd"],o,u)})).getDecoder(p(i));else{const c=new TextDecoder;r={write(o){return c.decode(o,{stream:!0})},end(){return c.decode()}}}return new k(r)}write(i){return this.iconvLiteDecoder.write(i)}end(){return this.iconvLiteDecoder.end()}}function S(s,i){const r=i.minBytesRequiredForDetection??i.guessEncoding?D:_;return new Promise((c,o)=>{const u=(0,l.newWriteableStream)(A=>A.join("")),h=[];let y=0,R,M;const U=async()=>{try{const A=await d({buffer:t.VSBuffer.concat(h),bytesRead:y},i.guessEncoding);if(A.seemsBinary&&i.acceptTextOnly)throw new L("Stream is binary but only text is accepted for decoding",1);A.encoding=await i.overwriteEncoding(A.encoding),R=await k.create(A.encoding);const z=R.write(t.VSBuffer.concat(h).buffer);u.write(z),h.length=0,y=0,c({stream:u,detected:A})}catch(A){M?.dispose(),u.destroy(),o(A)}};M=(0,l.listenStream)(s,{onData:async A=>{R?u.write(R.write(A.buffer)):(h.push(A),y+=A.byteLength,y>=r&&(s.pause(),await U(),setTimeout(()=>s.resume())))},onError:A=>u.error(A),onEnd:async()=>{R||await U(),u.end(R?.end())}})})}e.toDecodeStream=S;async function T(s,i,r){const o=(await new Promise((y,R)=>{J(["@vscode/iconv-lite-umd"],y,R)})).getEncoder(p(i),r);let u=!1,h=!1;return{read(){if(h)return null;const y=s.read();if(typeof y!="string"){if(h=!0,!u&&r?.addBOM)switch(i){case e.UTF8:case e.UTF8_with_bom:return t.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const R=o.end();return R&&R.length>0?(u=!0,t.VSBuffer.wrap(R)):null}return u=!0,t.VSBuffer.wrap(o.write(y))}}}e.toEncodeReadable=T;async function E(s){return(await new Promise((r,c)=>{J(["@vscode/iconv-lite-umd"],r,c)})).encodingExists(p(s))}e.encodingExists=E;function p(s){return s===e.UTF8_with_bom||s===null?e.UTF8:s}e.toNodeEncoding=p;function w(s,i){if(!s||i<e.UTF16be_BOM.length)return null;const r=s.readUInt8(0),c=s.readUInt8(1);if(r===e.UTF16be_BOM[0]&&c===e.UTF16be_BOM[1])return e.UTF16be;if(r===e.UTF16le_BOM[0]&&c===e.UTF16le_BOM[1])return e.UTF16le;if(i<e.UTF8_BOM.length)return null;const o=s.readUInt8(2);return r===e.UTF8_BOM[0]&&c===e.UTF8_BOM[1]&&o===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=w;const f=["ascii","utf-16","utf-32"];async function v(s){const i=await new Promise((h,y)=>{J(["jschardet"],h,y)}),r=s.slice(0,b),c=g(r.buffer),o=i.detect(c);if(!o||!o.encoding)return null;const u=o.encoding.toLowerCase();return 0<=f.indexOf(u)?null:a(o.encoding)}const m={ibm866:"cp866",big5:"cp950"};function a(s){const i=s.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return m[i]||i}function g(s){let i="";for(let r=0;r<s.length;r++)i+=String.fromCharCode(s[r]);return i}function n(s){switch(s){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const i=s.match(/windows(\d+)/);return i?"windows-"+i[1]:s}}}e.toCanonicalName=n;function d({buffer:s,bytesRead:i},r){let c=w(s,i),o=!1;if(c!==e.UTF16be&&c!==e.UTF16le&&s){let u=!0,h=!0,y=!1;for(let R=0;R<i&&R<P;R++){const M=R%2===1,U=s.readUInt8(R)===0;if(U&&(y=!0),u&&(M&&!U||!M&&U)&&(u=!1),h&&(M&&U||!M&&!U)&&(h=!1),U&&!u&&!h)break}y&&(u?c=e.UTF16le:h?c=e.UTF16be:o=!0)}return r&&!o&&!c&&s?v(s.slice(0,i)).then(u=>({seemsBinary:!1,encoding:u})):{seemsBinary:o,encoding:c}}e.detectEncodingFromBuffer=d,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(De[141],Ie([1,0,290,29,140]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class P extends C.TextSearchManager{constructor(D,b,I=t,L="searchProcess"){super(D,b,{readdir:k=>I.Promises.readdir(k.fsPath),toCanonicalName:k=>(0,l.toCanonicalName)(k)},L)}}e.NativeTextSearchManager=P}),define(De[291],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class l{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(C){if(C&&this._dragOperations.has(C)){const P=this._dragOperations.get(C);return this._dragOperations.delete(C),P}}addDragOperationTransfer(C,P){this._dragOperations.set(C,P)}getRenderedTreeElement(C){if(this._renderedElements.has(C))return this._renderedElements.get(C)}addRenderedTreeItemElement(C,P){this._renderedElements.set(C,P)}removeRenderedTreeItemElement(C){this._renderedElements.has(C)&&this._renderedElements.delete(C)}}e.TreeviewsService=l}),define(De[292],Ie([1,0,174,7,22,2,4,6,18,7,14,17,13,21,291,27]),function(J,e,l,t,C,P,_,D,b,I,L,k,S,T,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function w(m,a){if((0,L.isString)(m))return{label:m};if(m&&typeof m=="object"&&typeof m.label=="string"){let g;return Array.isArray(m.highlights)&&(g=m.highlights.filter(n=>n.length===2&&typeof n[0]=="number"&&typeof n[1]=="number"),g=g.length?g:void 0),{label:m.label,highlights:g}}}class f{constructor(a,g,n){this._proxy=a,this.commands=g,this.logService=n,this.treeViews=new Map,this.treeDragAndDropService=new E.TreeviewsService;function d(s){return s&&s.$treeViewId&&(s.$treeItemHandle||s.$selectedTreeItems||s.$focusedTreeItem)}g.registerArgumentProcessor({processArgument:s=>d(s)?this.convertArgument(s):Array.isArray(s)&&s.length>0?s.map(i=>d(i)?this.convertArgument(i):i):s})}registerTreeDataProvider(a,g,n){const d=this.createTreeView(a,{treeDataProvider:g},n);return{dispose:()=>d.dispose()}}createTreeView(a,g,n){if(!g||!g.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=g.dragAndDropController?.dropMimeTypes??[],s=g.dragAndDropController?.dragMimeTypes??[],i=!!g.dragAndDropController?.handleDrag,r=!!g.dragAndDropController?.handleDrop,c=this._proxy.$registerTreeViewDataProvider(a,{showCollapseAll:!!g.showCollapseAll,canSelectMany:!!g.canSelectMany,dropMimeTypes:d,dragMimeTypes:s,hasHandleDrag:i,hasHandleDrop:r}),o=this.createExtHostTreeView(a,g,n);return{get onDidCollapseElement(){return o.onDidCollapseElement},get onDidExpandElement(){return o.onDidExpandElement},get selection(){return o.selectedElements},get onDidChangeSelection(){return o.onDidChangeSelection},get visible(){return o.visible},get onDidChangeVisibility(){return o.onDidChangeVisibility},get onDidChangeTreeCheckbox(){return(0,p.checkProposedApiEnabled)(n,"treeItemCheckbox"),o.onDidChangeTreeCheckbox},get message(){return o.message},set message(u){o.message=u},get title(){return o.title},set title(u){o.title=u},get description(){return o.description},set description(u){o.description=u},get badge(){return o.badge},set badge(u){o.badge=u},reveal:(u,h)=>o.reveal(u,h),dispose:async()=>{await c,this.treeViews.delete(a),o.dispose()}}}$getChildren(a,g){const n=this.treeViews.get(a);return n?n.getChildren(g):Promise.reject(new Error((0,l.localize)(0,null,a)))}async $handleDrop(a,g,n,d,s,i,r,c){const o=this.treeViews.get(a);if(!o)return Promise.reject(new Error((0,l.localize)(1,null,a)));const u=S.DataTransfer.toDataTransfer(n,async h=>(await this._proxy.$resolveDropFileData(a,g,h)).buffer);return r===a&&c&&await this.addAdditionalTransferItems(u,o,c,s,i),o.onDrop(u,d,s)}async addAdditionalTransferItems(a,g,n,d,s){const i=this.treeDragAndDropService.removeDragOperationTransfer(s);if(i)(await i)?.forEach((r,c)=>{r&&a.set(c,r)});else if(s&&g.handleDrag){const r=g.handleDrag(n,a,d);this.treeDragAndDropService.addDragOperationTransfer(s,r),await r}return a}async $handleDrag(a,g,n,d){const s=this.treeViews.get(a);if(!s)return Promise.reject(new Error((0,l.localize)(2,null,a)));const i=await this.addAdditionalTransferItems(new t.DataTransfer,s,g,d,n);if(!!i)return S.DataTransfer.toDataTransferDTO(i)}async $hasResolve(a){const g=this.treeViews.get(a);if(!g)throw new Error((0,l.localize)(3,null,a));return g.hasResolve}$resolve(a,g,n){const d=this.treeViews.get(a);if(!d)throw new Error((0,l.localize)(4,null,a));return d.resolveTreeItem(g,n)}$setExpanded(a,g,n){const d=this.treeViews.get(a);if(!d)throw new Error((0,l.localize)(5,null,a));d.setExpanded(g,n)}$setSelection(a,g){const n=this.treeViews.get(a);if(!n)throw new Error((0,l.localize)(6,null,a));n.setSelection(g)}$setFocus(a,g){const n=this.treeViews.get(a);if(!n)throw new Error((0,l.localize)(7,null,a));n.setFocus(g)}$setVisible(a,g){const n=this.treeViews.get(a);if(!n)throw new Error((0,l.localize)(8,null,a));n.setVisible(g)}$changeCheckboxState(a,g){const n=this.treeViews.get(a);if(!n)throw new Error((0,l.localize)(9,null,a));n.setCheckboxState(g)}createExtHostTreeView(a,g,n){const d=new v(a,g,this._proxy,this.commands.converter,this.logService,n);return this.treeViews.set(a,d),d}convertArgument(a){const g=this.treeViews.get(a.$treeViewId);return g&&"$treeItemHandle"in a?g.getExtensionElement(a.$treeItemHandle):g&&"$focusedTreeItem"in a&&a.$focusedTreeItem?g.focusedElement:null}}e.ExtHostTreeViews=f;class v extends D.Disposable{constructor(a,g,n,d,s,i){if(super(),this.viewId=a,this.proxy=n,this.commands=d,this.logService=s,this.extension=i,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new _.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new _.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new _.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new _.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeTreeCheckbox=this._register(new _.Emitter),this.onDidChangeTreeCheckbox=this._onDidChangeTreeCheckbox.event,this._onDidChangeData=this._register(new _.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new T.CancellationTokenSource,i.contributes&&i.contributes.views)for(const o in i.contributes.views)for(const u of i.contributes.views[o])u.id===a&&(this._title=u.name);this.dataProvider=g.treeDataProvider,this.dndController=g.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(o=>this._onDidChangeData.fire({message:!1,element:o})));let r,c;this._register(_.Event.debounce(this._onDidChangeData.event,(o,u)=>(o||(o={message:!1,elements:[]}),u.element!==!1&&(r||(r=new Promise(h=>c=h),this.refreshPromise=this.refreshPromise.then(()=>r)),Array.isArray(u.element)?o.elements.push(...u.element):o.elements.push(u.element)),u.message&&(o.message=!0),o),200,!0)(({message:o,elements:u})=>{u.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const h=c;return r=null,this.refresh(u).then(()=>h())})),o&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(a=>this.getExtensionElement(a)).filter(a=>!(0,L.isUndefinedOrNull)(a))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}async getChildren(a){const g=a?this.getExtensionElement(a):void 0;if(a&&!g)return this.logService.error(`No tree item with id '${a}' found.`),Promise.resolve([]);let n=this.getChildrenNodes(a);return n||(n=await this.fetchChildrenNodes(g)),n?n.map(d=>d.item):void 0}getExtensionElement(a){return this.elements.get(a)}reveal(a,g){g=g||{select:!0,focus:!1};const n=(0,L.isUndefinedOrNull)(g.select)?!0:g.select,d=(0,L.isUndefinedOrNull)(g.focus)?!1:g.focus,s=(0,L.isUndefinedOrNull)(g.expand)?!1:g.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.refreshPromise.then(()=>this.resolveUnknownParentChain(a)).then(i=>this.resolveTreeNode(a,i[i.length-1]).then(r=>this.proxy.$reveal(this.viewId,{item:r.item,parentChain:i.map(c=>c.item)},{select:n,focus:d,expand:s})),i=>this.logService.error(i)):this.proxy.$reveal(this.viewId,void 0,{select:n,focus:d,expand:s})}get message(){return this._message}set message(a){this._message=a,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(a){this._title=a,this.proxy.$setTitle(this.viewId,a,this._description)}get description(){return this._description}set description(a){this._description=a,this.proxy.$setTitle(this.viewId,this._title,a)}get badge(){return this._badge}set badge(a){this._badge?.value===a?.value&&this._badge?.tooltip===a?.tooltip||(this._badge=S.ViewBadge.from(a),this.proxy.$setBadge(this.viewId,a))}setExpanded(a,g){const n=this.getExtensionElement(a);n&&(g?this._onDidExpandElement.fire(Object.freeze({element:n})):this._onDidCollapseElement.fire(Object.freeze({element:n})))}setSelection(a){(0,k.equals)(this._selectedHandles,a)||(this._selectedHandles=a,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setFocus(a){this._focusedHandle=a}setVisible(a){a!==this._visible&&(this._visible=a,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(a){const g=(await Promise.all(a.map(async n=>{const d=this.getExtensionElement(n.treeItemHandle);return d?{extensionItem:d,treeItem:await this.dataProvider.getTreeItem(d),newState:n.newState?I.TreeItemCheckboxState.Checked:I.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(n=>n!==void 0);g.forEach(n=>{n.treeItem.checkboxState=n.newState?I.TreeItemCheckboxState.Checked:I.TreeItemCheckboxState.Unchecked}),this._onDidChangeTreeCheckbox.fire({items:g.map(n=>[n.extensionItem,n.newState])})}async handleDrag(a,g,n){const d=[];for(const s of a){const i=this.getExtensionElement(s);i&&d.push(i)}if(!(!this.dndController?.handleDrag||d.length===0))return await this.dndController.handleDrag(d,g,n),g}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(a,g,n){const d=g?this.getExtensionElement(g):void 0;if(!(!d&&g||!this.dndController?.handleDrop))return(0,b.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(d,a,n):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(a,g){if(!this.dataProvider.resolveTreeItem)return;const n=this.elements.get(a);if(n){const d=this.nodes.get(n);if(d){const s=await this.dataProvider.resolveTreeItem(d.extensionItem,n,g)??d.extensionItem;return this.validateTreeItem(s),d.item.tooltip=this.getTooltip(s.tooltip),d.item.command=this.getCommand(d.disposableStore,s.command),d.item}}}resolveUnknownParentChain(a){return this.resolveParent(a).then(g=>g?this.resolveUnknownParentChain(g).then(n=>this.resolveTreeNode(g,n[n.length-1]).then(d=>(n.push(d),n))):Promise.resolve([]))}resolveParent(a){const g=this.nodes.get(a);return g?Promise.resolve(g.parent?this.elements.get(g.parent.item.handle):void 0):(0,b.asPromise)(()=>this.dataProvider.getParent(a))}resolveTreeNode(a,g){const n=this.nodes.get(a);return n?Promise.resolve(n):(0,b.asPromise)(()=>this.dataProvider.getTreeItem(a)).then(d=>this.createHandle(a,d,g,!0)).then(d=>this.getChildren(g?g.item.handle:void 0).then(()=>{const s=this.getExtensionElement(d);if(s){const i=this.nodes.get(s);if(i)return Promise.resolve(i)}throw new Error(`Cannot resolve tree item for element ${d}`)}))}getChildrenNodes(a){if(a){let g;if(typeof a=="string"){const n=this.getExtensionElement(a);g=n?this.nodes.get(n):void 0}else g=a;return g&&g.children||void 0}return this.roots}async fetchChildrenNodes(a){this.clearChildren(a);const g=new T.CancellationTokenSource(this._refreshCancellationSource.token);try{const n=a?this.nodes.get(a):void 0,d=await this.dataProvider.getChildren(a);if(g.token.isCancellationRequested)return;const s=await Promise.all((0,k.coalesce)(d||[]).map(async i=>{const r=await this.dataProvider.getTreeItem(i);return r&&!g.token.isCancellationRequested?this.createAndRegisterTreeNode(i,r,n):null}));return g.token.isCancellationRequested?void 0:(0,k.coalesce)(s)}finally{g.dispose()}}refresh(a){if(a.some(n=>!n))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new T.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const n=this.getHandlesToRefresh(a);if(n.length)return this.refreshHandles(n)}return Promise.resolve(void 0)}getHandlesToRefresh(a){const g=new Set,n=a.map(s=>this.nodes.get(s));for(const s of n)if(s&&!g.has(s.item.handle)){let i=s;for(;i&&i.parent&&n.findIndex(r=>i&&i.parent&&r&&r.item.handle===i.parent.item.handle)===-1;){const r=this.elements.get(i.parent.item.handle);i=r?this.nodes.get(r):void 0}i&&!i.parent&&g.add(s.item.handle)}const d=[];return g.forEach(s=>{const i=this.elements.get(s);if(i){const r=this.nodes.get(i);r&&(!r.parent||!g.has(r.parent.item.handle))&&d.push(s)}}),d}refreshHandles(a){const g={};return Promise.all(a.map(n=>this.refreshNode(n).then(d=>{d&&(g[n]=d.item)}))).then(()=>Object.keys(g).length?this.proxy.$refresh(this.viewId,g):void 0)}refreshNode(a){const g=this.getExtensionElement(a);if(g){const n=this.nodes.get(g);if(n)return this.clearChildren(g),(0,b.asPromise)(()=>this.dataProvider.getTreeItem(g)).then(d=>{if(d){const s=this.createTreeNode(g,d,n.parent);return this.updateNodeCache(g,s,n,n.parent),n.dispose(),s}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(a,g,n){const d=this.createTreeNode(a,g,n);if(g.id&&this.elements.has(d.item.handle))throw new Error((0,l.localize)(10,null,g.id));return this.addNodeToCache(a,d),this.addNodeToParentCache(d,n),d}getTooltip(a){return I.MarkdownString.isMarkdownString(a)?S.MarkdownString.from(a):a}getCommand(a,g){return g?{...this.commands.toInternal(g,a),originalId:g.command}:void 0}getCheckbox(a){return a.checkboxState!==void 0?a.checkboxState===I.TreeItemCheckboxState.Checked:void 0}validateTreeItem(a){if(!I.TreeItem.isTreeItem(a,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(a,g,n){this.validateTreeItem(g);const d=new D.DisposableStore,s=this.createHandle(a,g,n),i=this.getLightIconPath(g);return{item:{handle:s,parentHandle:n?n.item.handle:void 0,label:w(g.label,this.extension),description:g.description,resourceUri:g.resourceUri,tooltip:this.getTooltip(g.tooltip),command:this.getCommand(d,g.command),contextValue:g.contextValue,icon:i,iconDark:this.getDarkIconPath(g)||i,themeIcon:this.getThemeIcon(g),collapsibleState:(0,L.isUndefinedOrNull)(g.collapsibleState)?I.TreeItemCollapsibleState.None:g.collapsibleState,accessibilityInformation:g.accessibilityInformation,checkboxChecked:this.getCheckbox(g)},extensionItem:g,parent:n,children:void 0,disposableStore:d,dispose(){d.dispose()}}}getThemeIcon(a){return a.iconPath instanceof I.ThemeIcon?a.iconPath:void 0}createHandle(a,{id:g,label:n,resourceUri:d},s,i){if(g)return`${v.ID_HANDLE_PREFIX}/${g}`;const r=w(n,this.extension),c=s?s.item.handle:v.LABEL_HANDLE_PREFIX;let o=r?r.label:d?(0,C.basename)(d):"";o=o.indexOf("/")!==-1?o.replace("/","//"):o;const u=this.nodes.has(a)?this.nodes.get(a).item.handle:void 0,h=this.getChildrenNodes(s)||[];let y,R=0;do{if(y=`${c}/${R}:${o}`,i||!this.elements.has(y)||u===y)break;R++}while(R<=h.length);return y}getLightIconPath(a){if(a.iconPath&&!(a.iconPath instanceof I.ThemeIcon))return typeof a.iconPath=="string"||P.URI.isUri(a.iconPath)?this.getIconPath(a.iconPath):this.getIconPath(a.iconPath.light)}getDarkIconPath(a){if(a.iconPath&&!(a.iconPath instanceof I.ThemeIcon)&&a.iconPath.dark)return this.getIconPath(a.iconPath.dark)}getIconPath(a){return P.URI.isUri(a)?a:P.URI.file(a)}addNodeToCache(a,g){this.elements.set(g.item.handle,a),this.nodes.set(a,g)}updateNodeCache(a,g,n,d){this.elements.delete(g.item.handle),this.nodes.delete(a),g.item.handle!==n.item.handle&&this.elements.delete(n.item.handle),this.addNodeToCache(a,g);const s=this.getChildrenNodes(d)||[],i=s.filter(r=>r.item.handle===n.item.handle)[0];i&&s.splice(s.indexOf(i),1,g)}addNodeToParentCache(a,g){g?(g.children||(g.children=[]),g.children.push(a)):(this.roots||(this.roots=[]),this.roots.push(a))}clearChildren(a){if(a){const g=this.nodes.get(a);if(g){if(g.children)for(const n of g.children){const d=this.elements.get(n.item.handle);d&&this.clear(d)}g.children=void 0}}else this.clearAll()}clear(a){const g=this.nodes.get(a);if(g){if(g.children)for(const n of g.children){const d=this.elements.get(n.item.handle);d&&this.clear(d)}this.nodes.delete(a),this.elements.delete(g.item.handle),g.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(a=>a.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}v.LABEL_HANDLE_PREFIX="0",v.ID_HANDLE_PREFIX="1"}),define(De[293],Ie([1,0,21,10,4,41,2,115,100,148,157,42,5,130,237,236,37,238,33,240,241,242,225,243,56,39,244,245,248,249,250,139,228,254,255,256,92,38,258,292,13,7,261,68,138,32,208,247,123,135,70,72,73,15,54,16,26,251,224,53,65,234,259,67,66,264,262,263,235,46,257,260,91,57,125,252,69,253,12,118,227,204,246,6,27,209,137]),function(J,e,l,t,C,P,_,D,b,I,L,k,S,T,E,p,w,f,v,m,a,g,n,d,s,i,r,c,o,u,h,y,R,M,U,A,z,$,N,K,B,O,x,V,q,Y,Q,de,ve,ne,pe,be,ke,Oe,We,oe,le,fe,Z,ae,ee,ie,F,H,G,X,me,we,ce,Ce,ye,$e,Ve,Ze,Qe,Le,ot,re,se,Ee,ue,Te,Me,Be,ze,Ye,it){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function ct(st){const et=st.get(le.IExtHostInitDataService),ft=st.get(Ce.IExtHostFileSystemInfo),Et=st.get(G.IExtHostConsumerFileSystem),Dt=st.get(i.IExtHostExtensionService),mt=st.get(Y.IExtHostWorkspace),It=st.get(Qe.IExtHostTelemetry),Ft=st.get(v.IExtHostConfiguration),Nt=st.get(We.IURITransformerService),Ke=st.get(oe.IExtHostRpcService),Ut=st.get(z.IExtHostStorage),Ot=st.get(H.IExtensionStoragePaths),Pt=st.get(Oe.ILoggerService),pt=st.get(Oe.ILogService),Ct=st.get(ae.IExtHostTunnelService),Ae=st.get(it.IExtHostTelemetryLogService),Re=st.get(ee.IExtHostApiDeprecationService),_e=st.get(q.IExtHostWindow),te=st.get(Ve.IExtHostSecretState),Fe=st.get(Ze.IExtHostEditorTabs);Ke.set(S.ExtHostContext.ExtHostFileSystemInfo,ft),Ke.set(S.ExtHostContext.ExtHostLogLevelServiceShape,Pt),Ke.set(S.ExtHostContext.ExtHostWorkspace,mt),Ke.set(S.ExtHostContext.ExtHostConfiguration,Ft),Ke.set(S.ExtHostContext.ExtHostExtensionService,Dt),Ke.set(S.ExtHostContext.ExtHostStorage,Ut),Ke.set(S.ExtHostContext.ExtHostTunnelService,Ct),Ke.set(S.ExtHostContext.ExtHostWindow,_e),Ke.set(S.ExtHostContext.ExtHostSecretState,te),Ke.set(S.ExtHostContext.ExtHostTelemetry,It),Ke.set(S.ExtHostContext.ExtHostEditorTabs,Fe);const je=Ke.set(S.ExtHostContext.ExtHostDecorations,st.get(ne.IExtHostDecorations)),rt=Ke.set(S.ExtHostContext.ExtHostDocumentsAndEditors,st.get(s.IExtHostDocumentsAndEditors)),Je=Ke.set(S.ExtHostContext.ExtHostCommands,st.get(w.IExtHostCommands)),Xe=Ke.set(S.ExtHostContext.ExtHostTerminalService,st.get($.IExtHostTerminalService)),lt=Ke.set(S.ExtHostContext.ExtHostDebugService,st.get(be.IExtHostDebugService)),kt=Ke.set(S.ExtHostContext.ExtHostSearch,st.get(ke.IExtHostSearch)),vt=Ke.set(S.ExtHostContext.ExtHostTask,st.get(pe.IExtHostTask)),Tt=Ke.set(S.ExtHostContext.ExtHostOutputService,st.get(y.IExtHostOutputService)),St=Ke.set(S.ExtHostContext.ExtHostUrls,new x.ExtHostUrls(Ke)),wt=Ke.set(S.ExtHostContext.ExtHostDocuments,new d.ExtHostDocuments(Ke,rt)),_t=Ke.set(S.ExtHostContext.ExtHostDocumentContentProviders,new g.ExtHostDocumentContentProvider(Ke,rt,pt)),tn=Ke.set(S.ExtHostContext.ExtHostDocumentSaveParticipant,new n.ExtHostDocumentSaveParticipant(pt,wt,Ke.getProxy(S.MainContext.MainThreadBulkEdits))),bt=Ke.set(S.ExtHostContext.ExtHostNotebook,new fe.ExtHostNotebookController(Ke,Je,rt,wt)),$t=Ke.set(S.ExtHostContext.ExtHostNotebookDocuments,new Te.ExtHostNotebookDocuments(bt)),Ht=Ke.set(S.ExtHostContext.ExtHostNotebookEditors,new ue.ExtHostNotebookEditors(pt,bt)),nn=Ke.set(S.ExtHostContext.ExtHostNotebookKernels,new Le.ExtHostNotebookKernels(Ke,et,bt,Je,pt)),pn=Ke.set(S.ExtHostContext.ExtHostNotebookRenderers,new re.ExtHostNotebookRenderers(Ke,bt)),At=Ke.set(S.ExtHostContext.ExtHostEditors,new N.ExtHostEditors(Ke,rt)),rn=Ke.set(S.ExtHostContext.ExtHostTreeViews,new K.ExtHostTreeViews(Ke.getProxy(S.MainContext.MainThreadTreeViews),Je,pt)),xt=Ke.set(S.ExtHostContext.ExtHostEditorInsets,new Q.ExtHostEditorInsets(Ke.getProxy(S.MainContext.MainThreadEditorInsets),At,et.remote)),Yt=Ke.set(S.ExtHostContext.ExtHostDiagnostics,new m.ExtHostDiagnostics(Ke,pt,ft)),sn=Ke.set(S.ExtHostContext.ExtHostLanguages,new u.ExtHostLanguages(Ke,wt,Je.converter,Nt)),dt=Ke.set(S.ExtHostContext.ExtHostLanguageFeatures,new o.ExtHostLanguageFeatures(Ke,Nt,wt,Je,Yt,pt,Re)),Jt=Ke.set(S.ExtHostContext.ExtHostFileSystem,new r.ExtHostFileSystem(Ke,dt)),zt=Ke.set(S.ExtHostContext.ExtHostFileSystemEventService,new c.ExtHostFileSystemEventService(Ke,pt,rt)),Gt=Ke.set(S.ExtHostContext.ExtHostQuickOpen,(0,M.createExtHostQuickOpen)(Ke,mt,Je)),on=Ke.set(S.ExtHostContext.ExtHostSCM,new U.ExtHostSCM(Ke,Je,pt)),vn=Ke.set(S.ExtHostContext.ExtHostComments,(0,f.createExtHostComments)(Ke,Je,wt)),an=Ke.set(S.ExtHostContext.ExtHostProgress,new R.ExtHostProgress(Ke.getProxy(S.MainContext.MainThreadProgress))),wn=Ke.set(S.ExtHostContext.ExtHosLabelService,new de.ExtHostLabelService(Ke)),cn=Ke.set(S.ExtHostContext.ExtHostTheming,new Z.ExtHostTheming(Ke)),Zt=Ke.set(S.ExtHostContext.ExtHostAuthentication,new ie.ExtHostAuthentication(Ke)),Ln=Ke.set(S.ExtHostContext.ExtHostTimeline,new F.ExtHostTimeline(Ke,Je)),bn=Ke.set(S.ExtHostContext.ExtHostWebviews,new V.ExtHostWebviews(Ke,et.remote,mt,pt,Re)),en=Ke.set(S.ExtHostContext.ExtHostWebviewPanels,new we.ExtHostWebviewPanels(Ke,bn,mt)),En=Ke.set(S.ExtHostContext.ExtHostCustomEditors,new me.ExtHostCustomEditors(Ke,wt,Ot,bn,en)),Sn=Ke.set(S.ExtHostContext.ExtHostWebviewViews,new X.ExtHostWebviewViews(Ke,bn)),Kt=Ke.set(S.ExtHostContext.ExtHostTesting,new ye.ExtHostTesting(Ke,Je,rt)),On=Ke.set(S.ExtHostContext.ExtHostUriOpeners,new $e.ExtHostUriOpeners(Ke));Ke.set(S.ExtHostContext.ExtHostInteractive,new Me.ExtHostInteractive(Ke,bt,rt,Je,pt));const _n=Object.values(S.ExtHostContext);Ke.assertRegistered(_n);const yn=new ce.ExtHostBulkEdits(Ke,rt),Fn=new p.ExtHostClipboard(Ke),Cn=new h.ExtHostMessageService(Ke,pt),kn=new a.ExtHostDialogs(Ke),Tn=new A.ExtHostStatusBar(Ke,Je.converter);return E.ExtHostApiCommands.register(Je),function(He,Vt,ln){const gt=function(){let ge=!He.isUnderDevelopment;function Se(){ge||(pt.info(`Extension '${He.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ge=!0)}return function Ne(at){if(Array.isArray(at))at.forEach(Ne);else if(typeof at=="string")Se();else{const yt=at;typeof yt.scheme>"u"&&Se(),typeof yt.exclusive=="boolean"&&(0,ze.checkProposedApiEnabled)(He,"documentFiltersExclusive")}return at}}(),Nn={getSession(ge,Se,Ne){return Zt.getSession(He,ge,Se,Ne)},async hasSession(ge,Se){return(0,ze.checkProposedApiEnabled)(He,"authSession"),!!await Zt.getSession(He,ge,Se,{silent:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(ge,Se,Ne,at){return Zt.registerAuthenticationProvider(ge,Se,Ne,at)}},Mn={registerCommand(ge,Se,Ne){return Je.registerCommand(!0,ge,Se,Ne,void 0,He)},registerTextEditorCommand(ge,Se,Ne){return Je.registerCommand(!0,ge,(...at)=>{const yt=At.getActiveTextEditor();if(!yt){pt.warn("Cannot execute "+ge+" because there is no active text editor.");return}return yt.edit(Rt=>{Se.apply(Ne,[yt,Rt,...at])}).then(Rt=>{Rt||pt.warn("Edits from command "+ge+" were not applied.")},Rt=>{pt.warn("An error occurred while running command "+ge,Rt)})},void 0,void 0,He)},registerDiffInformationCommand:(ge,Se,Ne)=>((0,ze.checkProposedApiEnabled)(He,"diffCommand"),Je.registerCommand(!0,ge,async(...at)=>{const yt=rt.activeEditor(!0);if(!yt){pt.warn("Cannot execute "+ge+" because there is no active text editor.");return}const Rt=await At.getDiffInformation(yt.id);Se.apply(Ne,[Rt,...at])},void 0,void 0,He)),executeCommand(ge,...Se){return Je.executeCommand(ge,...Se)},getCommands(ge=!1){return Je.getCommands(ge)}},Pn={get machineId(){return et.telemetryInfo.machineId},get sessionId(){return et.telemetryInfo.sessionId},get language(){return et.environment.appLanguage},get appName(){return et.environment.appName},get appRoot(){return et.environment.appRoot?.fsPath??""},get appHost(){return et.environment.appHost},get uriScheme(){return et.environment.appUriScheme},get clipboard(){return Fn.value},get shell(){return Xe.getDefaultShell(!1)},get isTelemetryEnabled(){return It.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return It.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,ze.checkProposedApiEnabled)(He,"telemetry"),It.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,ze.checkProposedApiEnabled)(He,"telemetry"),It.onDidChangeTelemetryConfiguration},get isNewAppInstall(){const ge=Date.now()-new Date(et.telemetryInfo.firstSessionDate).getTime();return isNaN(ge)?!1:ge<1e3*60*60*24},openExternal(ge,Se){return _e.openUri(ge,{allowTunneling:!!et.remote.authority,allowContributedOpeners:Se?.allowContributedOpeners})},async asExternalUri(ge){if(ge.scheme===et.environment.appUriScheme)return St.createAppUri(ge);try{return await _e.asExternalUri(ge,{allowTunneling:!!et.remote.authority})}catch(Se){if((0,Ee.matchesScheme)(ge,se.Schemas.http)||(0,Ee.matchesScheme)(ge,se.Schemas.https))return ge;throw Se}},get remoteName(){return(0,ve.getRemoteName)(et.remote.authority)},get remoteAuthority(){return(0,ze.checkProposedApiEnabled)(He,"resolvers"),et.remote.authority},get uiKind(){return et.uiKind}};et.environment.extensionTestsLocationURI||Object.freeze(Pn);const un={createTestController(ge,Se,Ne){return Kt.createTestController(ge,Se,Ne)},createTestObserver(){return(0,ze.checkProposedApiEnabled)(He,"testObserver"),Kt.createTestObserver()},runTests(ge){return(0,ze.checkProposedApiEnabled)(He,"testObserver"),Kt.runTests(ge)},get onDidChangeTestResults(){return(0,ze.checkProposedApiEnabled)(He,"testObserver"),Kt.onResultsChanged},get testResults(){return(0,ze.checkProposedApiEnabled)(He,"testObserver"),Kt.results}},dn=et.remote.isRemote?O.ExtensionKind.Workspace:O.ExtensionKind.UI,Un={getExtension(ge,Se){(0,ze.isProposedApiEnabled)(He,"extensionsAny")||(Se=!1);const Ne=Vt.mine.getExtensionDescription(ge);if(Ne)return new i.Extension(Dt,He.identifier,Ne,dn,!1);if(Se){const at=Vt.all.getExtensionDescription(ge);if(at)return new i.Extension(Dt,He.identifier,at,dn,!0)}},get all(){const ge=[];for(const Se of Vt.mine.getAllExtensionDescriptions())ge.push(new i.Extension(Dt,He.identifier,Se,dn,!1));return ge},get allAcrossExtensionHosts(){(0,ze.checkProposedApiEnabled)(He,"extensionsAny");const ge=new ze.ExtensionIdentifierSet(Vt.mine.getAllExtensionDescriptions().map(Ne=>Ne.identifier)),Se=[];for(const Ne of Vt.all.getAllExtensionDescriptions()){const at=!ge.has(Ne.identifier);Se.push(new i.Extension(Dt,He.identifier,Ne,dn,at))}return Se},get onDidChange(){return(0,ze.isProposedApiEnabled)(He,"extensionsAny")?C.Event.any(Vt.mine.onDidChange,Vt.all.onDidChange):Vt.mine.onDidChange}},Bn={createDiagnosticCollection(ge){return Yt.createDiagnosticCollection(He.identifier,ge)},get onDidChangeDiagnostics(){return Yt.onDidChangeDiagnostics},getDiagnostics:ge=>Yt.getDiagnostics(ge),getLanguages(){return sn.getLanguages()},setTextDocumentLanguage(ge,Se){return sn.changeLanguage(ge.uri,Se)},match(ge,Se){const Ne=wt.getDocumentData(Se.uri)?.notebook;return(0,L.score)(B.LanguageSelector.from(ge),Se.uri,Se.languageId,!0,Ne?.uri,Ne?.notebookType)},registerCodeActionsProvider(ge,Se,Ne){return dt.registerCodeActionProvider(He,gt(ge),Se,Ne)},registerDocumentPasteEditProvider(ge,Se,Ne){return(0,ze.checkProposedApiEnabled)(He,"documentPaste"),dt.registerDocumentPasteEditProvider(He,gt(ge),Se,Ne)},registerCodeLensProvider(ge,Se){return dt.registerCodeLensProvider(He,gt(ge),Se)},registerDefinitionProvider(ge,Se){return dt.registerDefinitionProvider(He,gt(ge),Se)},registerDeclarationProvider(ge,Se){return dt.registerDeclarationProvider(He,gt(ge),Se)},registerImplementationProvider(ge,Se){return dt.registerImplementationProvider(He,gt(ge),Se)},registerTypeDefinitionProvider(ge,Se){return dt.registerTypeDefinitionProvider(He,gt(ge),Se)},registerHoverProvider(ge,Se){return dt.registerHoverProvider(He,gt(ge),Se,He.identifier)},registerEvaluatableExpressionProvider(ge,Se){return dt.registerEvaluatableExpressionProvider(He,gt(ge),Se,He.identifier)},registerInlineValuesProvider(ge,Se){return dt.registerInlineValuesProvider(He,gt(ge),Se,He.identifier)},registerDocumentHighlightProvider(ge,Se){return dt.registerDocumentHighlightProvider(He,gt(ge),Se)},registerLinkedEditingRangeProvider(ge,Se){return dt.registerLinkedEditingRangeProvider(He,gt(ge),Se)},registerReferenceProvider(ge,Se){return dt.registerReferenceProvider(He,gt(ge),Se)},registerRenameProvider(ge,Se){return dt.registerRenameProvider(He,gt(ge),Se)},registerDocumentSymbolProvider(ge,Se,Ne){return dt.registerDocumentSymbolProvider(He,gt(ge),Se,Ne)},registerWorkspaceSymbolProvider(ge){return dt.registerWorkspaceSymbolProvider(He,ge)},registerDocumentFormattingEditProvider(ge,Se){return dt.registerDocumentFormattingEditProvider(He,gt(ge),Se)},registerDocumentRangeFormattingEditProvider(ge,Se){return dt.registerDocumentRangeFormattingEditProvider(He,gt(ge),Se)},registerOnTypeFormattingEditProvider(ge,Se,Ne,...at){return dt.registerOnTypeFormattingEditProvider(He,gt(ge),Se,[Ne].concat(at))},registerDocumentSemanticTokensProvider(ge,Se,Ne){return dt.registerDocumentSemanticTokensProvider(He,gt(ge),Se,Ne)},registerDocumentRangeSemanticTokensProvider(ge,Se,Ne){return dt.registerDocumentRangeSemanticTokensProvider(He,gt(ge),Se,Ne)},registerSignatureHelpProvider(ge,Se,Ne,...at){return typeof Ne=="object"?dt.registerSignatureHelpProvider(He,gt(ge),Se,Ne):dt.registerSignatureHelpProvider(He,gt(ge),Se,typeof Ne>"u"?[]:[Ne,...at])},registerCompletionItemProvider(ge,Se,...Ne){return dt.registerCompletionItemProvider(He,gt(ge),Se,Ne)},registerInlineCompletionItemProvider(ge,Se){return Se.handleDidShowCompletionItem&&(0,ze.checkProposedApiEnabled)(He,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider(He,gt(ge),Se)},registerInlineCompletionItemProviderNew(ge,Se){if((0,ze.checkProposedApiEnabled)(He,"inlineCompletionsNew"),Se.handleDidShowCompletionItem&&!(0,ze.isProposedApiEnabled)(He,"inlineCompletionsAdditions"))throw new Error(`When the method "handleDidShowCompletionItem" is implemented on a provider, the usage of the proposed api 'inlineCompletionsAdditions' must be declared!`);return dt.registerInlineCompletionsProviderNew(He,gt(ge),Se)},registerDocumentLinkProvider(ge,Se){return dt.registerDocumentLinkProvider(He,gt(ge),Se)},registerColorProvider(ge,Se){return dt.registerColorProvider(He,gt(ge),Se)},registerFoldingRangeProvider(ge,Se){return dt.registerFoldingRangeProvider(He,gt(ge),Se)},registerSelectionRangeProvider(ge,Se){return dt.registerSelectionRangeProvider(He,ge,Se)},registerCallHierarchyProvider(ge,Se){return dt.registerCallHierarchyProvider(He,ge,Se)},registerTypeHierarchyProvider(ge,Se){return dt.registerTypeHierarchyProvider(He,ge,Se)},setLanguageConfiguration:(ge,Se)=>dt.setLanguageConfiguration(He,ge,Se),getTokenInformationAtPosition(ge,Se){return(0,ze.checkProposedApiEnabled)(He,"tokenInformation"),sn.tokenAtPosition(ge,Se)},registerInlayHintsProvider(ge,Se){return dt.registerInlayHintsProvider(He,ge,Se)},createLanguageStatusItem(ge,Se){return sn.createLanguageStatusItem(He,ge,Se)},registerDocumentDropEditProvider(ge,Se){return dt.registerDocumentOnDropEditProvider(He,ge,Se)}},zn={get activeTextEditor(){return At.getActiveTextEditor()},get visibleTextEditors(){return At.getVisibleTextEditors()},get activeTerminal(){return Xe.activeTerminal},get terminals(){return Xe.terminals},async showTextDocument(ge,Se,Ne){const at=await(_.URI.isUri(ge)?Promise.resolve(hn.openTextDocument(ge)):Promise.resolve(ge));return At.showTextDocument(at,Se,Ne)},createTextEditorDecorationType(ge){return At.createTextEditorDecorationType(He,ge)},onDidChangeActiveTextEditor(ge,Se,Ne){return At.onDidChangeActiveTextEditor(ge,Se,Ne)},onDidChangeVisibleTextEditors(ge,Se,Ne){return At.onDidChangeVisibleTextEditors(ge,Se,Ne)},onDidChangeTextEditorSelection(ge,Se,Ne){return At.onDidChangeTextEditorSelection(ge,Se,Ne)},onDidChangeTextEditorOptions(ge,Se,Ne){return At.onDidChangeTextEditorOptions(ge,Se,Ne)},onDidChangeTextEditorVisibleRanges(ge,Se,Ne){return At.onDidChangeTextEditorVisibleRanges(ge,Se,Ne)},onDidChangeTextEditorViewColumn(ge,Se,Ne){return At.onDidChangeTextEditorViewColumn(ge,Se,Ne)},onDidCloseTerminal(ge,Se,Ne){return Xe.onDidCloseTerminal(ge,Se,Ne)},onDidOpenTerminal(ge,Se,Ne){return Xe.onDidOpenTerminal(ge,Se,Ne)},onDidChangeActiveTerminal(ge,Se,Ne){return Xe.onDidChangeActiveTerminal(ge,Se,Ne)},onDidChangeTerminalDimensions(ge,Se,Ne){return(0,ze.checkProposedApiEnabled)(He,"terminalDimensions"),Xe.onDidChangeTerminalDimensions(ge,Se,Ne)},onDidChangeTerminalState(ge,Se,Ne){return Xe.onDidChangeTerminalState(ge,Se,Ne)},onDidWriteTerminalData(ge,Se,Ne){return(0,ze.checkProposedApiEnabled)(He,"terminalDataWriteEvent"),Xe.onDidWriteTerminalData(ge,Se,Ne)},get state(){return _e.state},onDidChangeWindowState(ge,Se,Ne){return _e.onDidChangeWindowState(ge,Se,Ne)},showInformationMessage(ge,...Se){return Cn.showMessage(He,P.default.Info,ge,Se[0],Se.slice(1))},showWarningMessage(ge,...Se){return Cn.showMessage(He,P.default.Warning,ge,Se[0],Se.slice(1))},showErrorMessage(ge,...Se){return Cn.showMessage(He,P.default.Error,ge,Se[0],Se.slice(1))},showQuickPick(ge,Se,Ne){return Gt.showQuickPick(ge,Se,Ne)},showWorkspaceFolderPick(ge){return Gt.showWorkspaceFolderPick(ge)},showInputBox(ge,Se){return Gt.showInput(ge,Se)},showOpenDialog(ge){return kn.showOpenDialog(ge)},showSaveDialog(ge){return kn.showSaveDialog(ge)},createStatusBarItem(ge,Se,Ne){let at,yt,Rt;return typeof ge=="string"?(at=ge,yt=Se,Rt=Ne):(yt=ge,Rt=Se),Tn.createStatusBarEntry(He,at,yt,Rt)},setStatusBarMessage(ge,Se){return Tn.setStatusBarMessage(ge,Se)},withScmProgress(ge){return Re.report("window.withScmProgress",He,"Use 'withProgress' instead."),an.withProgress(He,{location:O.ProgressLocation.SourceControl},(Se,Ne)=>ge({report(at){}}))},withProgress(ge,Se){return an.withProgress(He,ge,Se)},createOutputChannel(ge,Se){return Tt.createOutputChannel(ge,Se,He)},createWebviewPanel(ge,Se,Ne,at){return en.createWebviewPanel(He,ge,Se,Ne,at)},createWebviewTextEditorInset(ge,Se,Ne,at){return(0,ze.checkProposedApiEnabled)(He,"editorInsets"),xt.createWebviewEditorInset(ge,Se,Ne,at,He)},createTerminal(ge,Se,Ne){return typeof ge=="object"?"pty"in ge?Xe.createExtensionTerminal(ge):Xe.createTerminalFromOptions(ge):Xe.createTerminal(ge,Se,Ne)},registerTerminalLinkProvider(ge){return Xe.registerLinkProvider(ge)},registerTerminalProfileProvider(ge,Se){return Xe.registerProfileProvider(He,ge,Se)},registerTreeDataProvider(ge,Se){return rn.registerTreeDataProvider(ge,Se,He)},createTreeView(ge,Se){return rn.createTreeView(ge,Se,He)},registerWebviewPanelSerializer:(ge,Se)=>en.registerWebviewPanelSerializer(He,ge,Se),registerCustomEditorProvider:(ge,Se,Ne={})=>En.registerCustomEditorProvider(He,ge,Se,Ne),registerFileDecorationProvider(ge){return je.registerFileDecorationProvider(ge,He.identifier)},registerUriHandler(ge){return St.registerUriHandler(He.identifier,ge)},createQuickPick(){return Gt.createQuickPick(He)},createInputBox(){return Gt.createInputBox(He)},get activeColorTheme(){return cn.activeColorTheme},onDidChangeActiveColorTheme(ge,Se,Ne){return cn.onDidChangeActiveColorTheme(ge,Se,Ne)},registerWebviewViewProvider(ge,Se,Ne){return Sn.registerWebviewViewProvider(He,ge,Se,Ne?.webviewOptions)},get activeNotebookEditor(){return bt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ge,Se,Ne){return bt.onDidChangeActiveNotebookEditor(ge,Se,Ne)},get visibleNotebookEditors(){return bt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return bt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ge,Se,Ne){return Ht.onDidChangeNotebookEditorSelection(ge,Se,Ne)},onDidChangeNotebookEditorVisibleRanges(ge,Se,Ne){return Ht.onDidChangeNotebookEditorVisibleRanges(ge,Se,Ne)},showNotebookDocument(ge,Se){return _.URI.isUri(ge)&&Re.report("window.showNotebookDocument(uri)",He,"Please use 'workspace.openNotebookDocument' and 'window.showNotebookDocument'"),bt.showNotebookDocument(ge,Se)},registerExternalUriOpener(ge,Se,Ne){return(0,ze.checkProposedApiEnabled)(He,"externalUriOpener"),On.registerExternalUriOpener(He.identifier,ge,Se,Ne)},get tabGroups(){return Fe.tabGroups},logTelemetryToOutputChannel(ge,Se){(0,ze.checkProposedApiEnabled)(He,"telemetryLog"),Ae.logToTelemetryOutputChannel(He,ge,Se)}},hn={get rootPath(){return Re.report("workspace.rootPath",He,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),mt.getPath()},set rootPath(ge){throw t.readonly()},getWorkspaceFolder(ge){return mt.getWorkspaceFolder(ge)},get workspaceFolders(){return mt.getWorkspaceFolders()},get name(){return mt.name},set name(ge){throw t.readonly()},get workspaceFile(){return mt.workspaceFile},set workspaceFile(ge){throw t.readonly()},updateWorkspaceFolders:(ge,Se,...Ne)=>mt.updateWorkspaceFolders(He,ge,Se||0,...Ne),onDidChangeWorkspaceFolders:function(ge,Se,Ne){return mt.onDidChangeWorkspace(ge,Se,Ne)},asRelativePath:(ge,Se)=>mt.getRelativePath(ge,Se),findFiles:(ge,Se,Ne,at)=>mt.findFiles(ge,Se,Ne,He.identifier,at),findTextInFiles:(ge,Se,Ne,at)=>{(0,ze.checkProposedApiEnabled)(He,"findTextInFiles");let yt,Rt;return typeof Se=="object"?(yt=Se,Rt=Ne):(yt={},Rt=Se,at=Ne),mt.findTextInFiles(ge,yt||{},Rt,He.identifier,at)},saveAll:ge=>mt.saveAll(ge),applyEdit(ge,Se){return yn.applyWorkspaceEdit(ge,He,Se)},createFileSystemWatcher:(ge,Se,Ne,at)=>zt.createFileSystemWatcher(mt,He,ge,Se,Ne,at),get textDocuments(){return wt.getAllDocumentData().map(ge=>ge.document)},set textDocuments(ge){throw t.readonly()},openTextDocument(ge){let Se;const Ne=ge;if(typeof ge=="string")Se=Promise.resolve(_.URI.file(ge));else if(_.URI.isUri(ge))Se=Promise.resolve(ge);else if(!Ne||typeof Ne=="object")Se=wt.createDocumentData(Ne);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Se.then(at=>wt.ensureDocumentData(at).then(yt=>yt.document))},onDidOpenTextDocument:(ge,Se,Ne)=>wt.onDidAddDocument(ge,Se,Ne),onDidCloseTextDocument:(ge,Se,Ne)=>wt.onDidRemoveDocument(ge,Se,Ne),onDidChangeTextDocument:(ge,Se,Ne)=>wt.onDidChangeDocument(ge,Se,Ne),onDidSaveTextDocument:(ge,Se,Ne)=>wt.onDidSaveDocument(ge,Se,Ne),onWillSaveTextDocument:(ge,Se,Ne)=>tn.getOnWillSaveTextDocumentEvent(He)(ge,Se,Ne),get notebookDocuments(){return bt.notebookDocuments.map(ge=>ge.apiNotebook)},async openNotebookDocument(ge,Se){let Ne;if(_.URI.isUri(ge))Ne=ge,await bt.openNotebookDocument(ge);else if(typeof ge=="string")Ne=_.URI.revive(await bt.createNotebookDocument({viewType:ge,content:Se}));else throw new Error("Invalid arguments");return bt.getNotebookDocument(Ne).apiNotebook},onDidSaveNotebookDocument(ge,Se,Ne){return $t.onDidSaveNotebookDocument(ge,Se,Ne)},onDidChangeNotebookDocument(ge,Se,Ne){return $t.onDidChangeNotebookDocument(ge,Se,Ne)},get onDidOpenNotebookDocument(){return bt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return bt.onDidCloseNotebookDocument},registerNotebookSerializer(ge,Se,Ne,at){return bt.registerNotebookSerializer(He,ge,Se,Ne,(0,ze.isProposedApiEnabled)(He,"notebookLiveShare")?at:void 0)},registerNotebookContentProvider:(ge,Se,Ne,at)=>((0,ze.checkProposedApiEnabled)(He,"notebookContentProvider"),Re.report("workspace.registerNotebookContentProvider",He,"The notebookContentProvider API is not on track for finalization and will be removed."),bt.registerNotebookContentProvider(He,ge,Se,Ne,(0,ze.isProposedApiEnabled)(He,"notebookLiveShare")?at:void 0)),onDidChangeConfiguration:(ge,Se,Ne)=>ln.onDidChangeConfiguration(ge,Se,Ne),getConfiguration(ge,Se){return Se=arguments.length===1?void 0:Se,ln.getConfiguration(ge,Se,He)},registerTextDocumentContentProvider(ge,Se){return _t.registerTextDocumentContentProvider(ge,Se)},registerTaskProvider:(ge,Se)=>(Re.report("window.registerTaskProvider",He,"Use the corresponding function on the 'tasks' namespace instead"),vt.registerTaskProvider(He,ge,Se)),registerFileSystemProvider(ge,Se,Ne){return(0,Be.combinedDisposable)(Jt.registerFileSystemProvider(He,ge,Se,Ne),Et.addFileSystemProvider(ge,Se))},get fs(){return Et.value},registerFileSearchProvider:(ge,Se)=>((0,ze.checkProposedApiEnabled)(He,"fileSearchProvider"),kt.registerFileSearchProvider(ge,Se)),registerTextSearchProvider:(ge,Se)=>((0,ze.checkProposedApiEnabled)(He,"textSearchProvider"),kt.registerTextSearchProvider(ge,Se)),registerRemoteAuthorityResolver:(ge,Se)=>((0,ze.checkProposedApiEnabled)(He,"resolvers"),Dt.registerRemoteAuthorityResolver(ge,Se)),registerResourceLabelFormatter:ge=>((0,ze.checkProposedApiEnabled)(He,"resolvers"),wn.$registerResourceLabelFormatter(ge)),onDidCreateFiles:(ge,Se,Ne)=>zt.onDidCreateFile(ge,Se,Ne),onDidDeleteFiles:(ge,Se,Ne)=>zt.onDidDeleteFile(ge,Se,Ne),onDidRenameFiles:(ge,Se,Ne)=>zt.onDidRenameFile(ge,Se,Ne),onWillCreateFiles:(ge,Se,Ne)=>zt.getOnWillCreateFileEvent(He)(ge,Se,Ne),onWillDeleteFiles:(ge,Se,Ne)=>zt.getOnWillDeleteFileEvent(He)(ge,Se,Ne),onWillRenameFiles:(ge,Se,Ne)=>zt.getOnWillRenameFileEvent(He)(ge,Se,Ne),openTunnel:ge=>((0,ze.checkProposedApiEnabled)(He,"resolvers"),Ct.openTunnel(He,ge).then(Se=>{if(!Se)throw new Error("cannot open tunnel");return Se})),get tunnels(){return(0,ze.checkProposedApiEnabled)(He,"resolvers"),Ct.getTunnels()},onDidChangeTunnels:(ge,Se,Ne)=>((0,ze.checkProposedApiEnabled)(He,"resolvers"),Ct.onDidChangeTunnels(ge,Se,Ne)),registerPortAttributesProvider:(ge,Se)=>((0,ze.checkProposedApiEnabled)(He,"portsAttributes"),Ct.registerPortsAttributesProvider(ge,Se)),registerTimelineProvider:(ge,Se)=>((0,ze.checkProposedApiEnabled)(He,"timeline"),Ln.registerTimelineProvider(ge,Se,He.identifier,Je.converter)),get isTrusted(){return mt.trusted},requestWorkspaceTrust:ge=>((0,ze.checkProposedApiEnabled)(He,"workspaceTrust"),mt.requestWorkspaceTrust(ge)),onDidGrantWorkspaceTrust:(ge,Se,Ne)=>mt.onDidGrantWorkspaceTrust(ge,Se,Ne),registerEditSessionIdentityProvider:(ge,Se)=>((0,ze.checkProposedApiEnabled)(He,"editSessionIdentityProvider"),mt.registerEditSessionIdentityProvider(ge,Se))},Wn={get inputBox(){return Re.report("scm.inputBox",He,"Use 'SourceControl.inputBox' instead"),on.getLastInputBox(He)},createSourceControl(ge,Se,Ne){return on.createSourceControl(He,ge,Se,Ne)}},jt={createCommentController(ge,Se){return vn.createCommentController(He,ge,Se)}},fn={get activeDebugSession(){return lt.activeDebugSession},get activeDebugConsole(){return lt.activeDebugConsole},get breakpoints(){return lt.breakpoints},onDidStartDebugSession(ge,Se,Ne){return lt.onDidStartDebugSession(ge,Se,Ne)},onDidTerminateDebugSession(ge,Se,Ne){return lt.onDidTerminateDebugSession(ge,Se,Ne)},onDidChangeActiveDebugSession(ge,Se,Ne){return lt.onDidChangeActiveDebugSession(ge,Se,Ne)},onDidReceiveDebugSessionCustomEvent(ge,Se,Ne){return lt.onDidReceiveDebugSessionCustomEvent(ge,Se,Ne)},onDidChangeBreakpoints(ge,Se,Ne){return lt.onDidChangeBreakpoints(ge,Se,Ne)},registerDebugConfigurationProvider(ge,Se,Ne){return lt.registerDebugConfigurationProvider(ge,Se,Ne||Ye.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ge,Se){return lt.registerDebugAdapterDescriptorFactory(He,ge,Se)},registerDebugAdapterTrackerFactory(ge,Se){return lt.registerDebugAdapterTrackerFactory(ge,Se)},startDebugging(ge,Se,Ne){return!Ne||typeof Ne=="object"&&"configuration"in Ne?lt.startDebugging(ge,Se,{parentSession:Ne}):lt.startDebugging(ge,Se,Ne||{})},stopDebugging(ge){return lt.stopDebugging(ge)},addBreakpoints(ge){return lt.addBreakpoints(ge)},removeBreakpoints(ge){return lt.removeBreakpoints(ge)},asDebugSourceUri(ge,Se){return lt.asDebugSourceUri(ge,Se)}},$n={registerTaskProvider:(ge,Se)=>vt.registerTaskProvider(He,ge,Se),fetchTasks:ge=>vt.fetchTasks(ge),executeTask:ge=>vt.executeTask(He,ge),get taskExecutions(){return vt.taskExecutions},onDidStartTask:(ge,Se,Ne)=>vt.onDidStartTask(ge,Se,Ne),onDidEndTask:(ge,Se,Ne)=>vt.onDidEndTask(ge,Se,Ne),onDidStartTaskProcess:(ge,Se,Ne)=>vt.onDidStartTaskProcess(ge,Se,Ne),onDidEndTaskProcess:(ge,Se,Ne)=>vt.onDidEndTaskProcess(ge,Se,Ne)},Mt={createNotebookController(ge,Se,Ne,at,yt){return nn.createNotebookController(He,ge,Se,Ne,at,(0,ze.isProposedApiEnabled)(He,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(ge,Se)=>bt.registerNotebookCellStatusBarItemProvider(He,ge,Se),createRendererMessaging(ge){return pn.createRendererMessaging(He,ge)},onDidChangeNotebookCellExecutionState(ge,Se,Ne){return(0,ze.checkProposedApiEnabled)(He,"notebookCellExecutionState"),nn.onDidChangeNotebookCellExecutionState(ge,Se,Ne)}};return{version:et.version,authentication:Nn,commands:Mn,comments:jt,debug:fn,env:Pn,extensions:Un,languages:Bn,notebooks:Mt,scm:Wn,tasks:$n,tests:un,window:zn,workspace:hn,Breakpoint:O.Breakpoint,CallHierarchyIncomingCall:O.CallHierarchyIncomingCall,CallHierarchyItem:O.CallHierarchyItem,CallHierarchyOutgoingCall:O.CallHierarchyOutgoingCall,CancellationError:t.CancellationError,CancellationTokenSource:l.CancellationTokenSource,CandidatePortSource:S.CandidatePortSource,CodeAction:O.CodeAction,CodeActionKind:O.CodeActionKind,CodeActionTriggerKind:O.CodeActionTriggerKind,CodeLens:O.CodeLens,Color:O.Color,ColorInformation:O.ColorInformation,ColorPresentation:O.ColorPresentation,ColorThemeKind:O.ColorThemeKind,CommentMode:O.CommentMode,CommentThreadCollapsibleState:O.CommentThreadCollapsibleState,CommentThreadState:O.CommentThreadState,CompletionItem:O.CompletionItem,CompletionItemKind:O.CompletionItemKind,CompletionItemTag:O.CompletionItemTag,CompletionList:O.CompletionList,CompletionTriggerKind:O.CompletionTriggerKind,ConfigurationTarget:O.ConfigurationTarget,CustomExecution:O.CustomExecution,DebugAdapterExecutable:O.DebugAdapterExecutable,DebugAdapterInlineImplementation:O.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:O.DebugAdapterNamedPipeServer,DebugAdapterServer:O.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Ye.DebugConfigurationProviderTriggerKind,DebugConsoleMode:O.DebugConsoleMode,DecorationRangeBehavior:O.DecorationRangeBehavior,Diagnostic:O.Diagnostic,DiagnosticRelatedInformation:O.DiagnosticRelatedInformation,DiagnosticSeverity:O.DiagnosticSeverity,DiagnosticTag:O.DiagnosticTag,Disposable:O.Disposable,DocumentHighlight:O.DocumentHighlight,DocumentHighlightKind:O.DocumentHighlightKind,DocumentLink:O.DocumentLink,DocumentSymbol:O.DocumentSymbol,EndOfLine:O.EndOfLine,EnvironmentVariableMutatorType:O.EnvironmentVariableMutatorType,EvaluatableExpression:O.EvaluatableExpression,InlineValueText:O.InlineValueText,InlineValueVariableLookup:O.InlineValueVariableLookup,InlineValueEvaluatableExpression:O.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:O.InlineCompletionTriggerKind,InlineCompletionTriggerKindNew:O.InlineCompletionTriggerKindNew,EventEmitter:C.Emitter,ExtensionKind:O.ExtensionKind,ExtensionMode:O.ExtensionMode,ExternalUriOpenerPriority:O.ExternalUriOpenerPriority,FileChangeType:O.FileChangeType,FileDecoration:O.FileDecoration,FileSystemError:O.FileSystemError,FileType:k.FileType,FilePermission:k.FilePermission,FoldingRange:O.FoldingRange,FoldingRangeKind:O.FoldingRangeKind,FunctionBreakpoint:O.FunctionBreakpoint,InlineCompletionItem:O.InlineSuggestion,InlineCompletionItemNew:O.InlineSuggestionNew,InlineCompletionList:O.InlineSuggestionList,InlineCompletionListNew:O.InlineSuggestionsNew,Hover:O.Hover,IndentAction:I.IndentAction,Location:O.Location,MarkdownString:O.MarkdownString,OverviewRulerLane:b.OverviewRulerLane,ParameterInformation:O.ParameterInformation,PortAutoForwardAction:O.PortAutoForwardAction,Position:O.Position,ProcessExecution:O.ProcessExecution,ProgressLocation:O.ProgressLocation,QuickInputButtons:O.QuickInputButtons,Range:O.Range,RelativePattern:O.RelativePattern,Selection:O.Selection,SelectionRange:O.SelectionRange,SemanticTokens:O.SemanticTokens,SemanticTokensBuilder:O.SemanticTokensBuilder,SemanticTokensEdit:O.SemanticTokensEdit,SemanticTokensEdits:O.SemanticTokensEdits,SemanticTokensLegend:O.SemanticTokensLegend,ShellExecution:O.ShellExecution,ShellQuoting:O.ShellQuoting,SignatureHelp:O.SignatureHelp,SignatureHelpTriggerKind:O.SignatureHelpTriggerKind,SignatureInformation:O.SignatureInformation,SnippetString:O.SnippetString,SourceBreakpoint:O.SourceBreakpoint,StandardTokenType:O.StandardTokenType,StatusBarAlignment:O.StatusBarAlignment,SymbolInformation:O.SymbolInformation,SymbolKind:O.SymbolKind,SymbolTag:O.SymbolTag,Task:O.Task,TaskGroup:O.TaskGroup,TaskPanelKind:O.TaskPanelKind,TaskRevealKind:O.TaskRevealKind,TaskScope:O.TaskScope,TerminalLink:O.TerminalLink,TerminalLocation:O.TerminalLocation,TerminalProfile:O.TerminalProfile,TextDocumentSaveReason:O.TextDocumentSaveReason,TextEdit:O.TextEdit,SnippetTextEdit:O.SnippetTextEdit,TextEditorCursorStyle:D.TextEditorCursorStyle,TextEditorLineNumbersStyle:O.TextEditorLineNumbersStyle,TextEditorRevealType:O.TextEditorRevealType,TextEditorSelectionChangeKind:O.TextEditorSelectionChangeKind,TextDocumentChangeReason:O.TextDocumentChangeReason,ThemeColor:O.ThemeColor,ThemeIcon:O.ThemeIcon,TreeItem:O.TreeItem,TreeItem2:O.TreeItem,TreeItemCheckboxState:O.TreeItemCheckboxState,TreeItemCollapsibleState:O.TreeItemCollapsibleState,TypeHierarchyItem:O.TypeHierarchyItem,UIKind:T.UIKind,Uri:_.URI,ViewColumn:O.ViewColumn,WorkspaceEdit:O.WorkspaceEdit,DocumentDropEdit:O.DocumentDropEdit,DocumentPasteEdit:O.DocumentPasteEdit,InlayHint:O.InlayHint,InlayHintLabelPart:O.InlayHintLabelPart,InlayHintKind:O.InlayHintKind,RemoteAuthorityResolverError:O.RemoteAuthorityResolverError,ResolvedAuthority:O.ResolvedAuthority,SourceControlInputBoxValidationType:O.SourceControlInputBoxValidationType,ExtensionRuntime:O.ExtensionRuntime,TimelineItem:O.TimelineItem,NotebookRange:O.NotebookRange,NotebookCellKind:O.NotebookCellKind,NotebookCellExecutionState:O.NotebookCellExecutionState,NotebookCellData:O.NotebookCellData,NotebookData:O.NotebookData,NotebookRendererScript:O.NotebookRendererScript,NotebookCellStatusBarAlignment:O.NotebookCellStatusBarAlignment,NotebookEditorRevealType:O.NotebookEditorRevealType,NotebookCellOutput:O.NotebookCellOutput,NotebookCellOutputItem:O.NotebookCellOutputItem,NotebookCellStatusBarItem:O.NotebookCellStatusBarItem,NotebookControllerAffinity:O.NotebookControllerAffinity,NotebookEdit:O.NotebookEdit,PortAttributes:O.PortAttributes,LinkedEditingRanges:O.LinkedEditingRanges,TestResultState:O.TestResultState,TestRunRequest:O.TestRunRequest,TestMessage:O.TestMessage,TestTag:O.TestTag,TestRunProfileKind:O.TestRunProfileKind,TextSearchCompleteMessageType:ot.TextSearchCompleteMessageType,DataTransfer:O.DataTransfer,DataTransferItem:O.DataTransferItem,CoveredCount:O.CoveredCount,FileCoverage:O.FileCoverage,StatementCoverage:O.StatementCoverage,BranchCoverage:O.BranchCoverage,FunctionCoverage:O.FunctionCoverage,WorkspaceTrustState:O.WorkspaceTrustState,LanguageStatusSeverity:O.LanguageStatusSeverity,QuickPickItemKind:O.QuickPickItemKind,InputBoxValidationSeverity:O.InputBoxValidationSeverity,TabInputText:O.TextTabInput,TabInputTextDiff:O.TextDiffTabInput,TabInputTextMerge:O.TextMergeTabInput,TabInputCustom:O.CustomEditorTabInput,TabInputNotebook:O.NotebookEditorTabInput,TabInputNotebookDiff:O.NotebookDiffEditorTabInput,TabInputWebview:O.WebviewEditorTabInput,TabInputTerminal:O.TerminalEditorTabInput,TabInputInteractiveWindow:O.InteractiveWindowInput,TerminalExitReason:O.TerminalExitReason}}}e.createApiFactoryAndRegisterActors=ct}),define(De[294],Ie([1,0,266,303,304,2,305]),function(J,e,l,t,C,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function D(k,S,T,E,p,w){const f=w.environment.useHostProxy,v=typeof f=="boolean"?f:!w.remote.isRemote,m=(0,_.createProxyResolver)({resolveProxy:g=>k.resolveProxy(g),getHttpProxySetting:()=>S.getConfiguration("http").get("proxy"),log:(g,n,...d)=>{switch(g){case _.LogLevel.Trace:E.trace(n,...d);break;case _.LogLevel.Debug:E.debug(n,...d);break;case _.LogLevel.Info:E.info(n,...d);break;case _.LogLevel.Warning:E.warn(n,...d);break;case _.LogLevel.Error:E.error(n,...d);break;case _.LogLevel.Critical:E.critical(n,...d);break;case _.LogLevel.Off:break;default:s(g,n,d);break}function s(i,r,...c){E.error("Unknown log level",i),E.error(r,...c)}},getLogLevel:()=>E.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:v,env:process.env}),a=b(S,m);return L(T,a)}e.connectProxyResolver=D;function b(k,S){const T={config:k.getConfiguration("http").get("proxySupport")||"off"};k.onDidChangeConfiguration(p=>{T.config=k.getConfiguration("http").get("proxySupport")||"off"});const E={config:!!k.getConfiguration("http").get("systemCertificates")};return k.onDidChangeConfiguration(p=>{E.config=!!k.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},l,(0,_.createHttpPatch)(l,S,{config:"off"},E,!0)),on:Object.assign({},l,(0,_.createHttpPatch)(l,S,{config:"on"},E,!0)),override:Object.assign({},l,(0,_.createHttpPatch)(l,S,{config:"override"},E,!0)),onRequest:Object.assign({},l,(0,_.createHttpPatch)(l,S,T,E,!0)),default:Object.assign(l,(0,_.createHttpPatch)(l,S,T,E,!1))},https:{off:Object.assign({},t,(0,_.createHttpPatch)(t,S,{config:"off"},E,!0)),on:Object.assign({},t,(0,_.createHttpPatch)(t,S,{config:"on"},E,!0)),override:Object.assign({},t,(0,_.createHttpPatch)(t,S,{config:"override"},E,!0)),onRequest:Object.assign({},t,(0,_.createHttpPatch)(t,S,T,E,!0)),default:Object.assign(t,(0,_.createHttpPatch)(t,S,T,E,!1))},tls:Object.assign(C,(0,_.createTlsPatch)(C))}}const I=new Map;function L(k,S){return k.getExtensionPathIndex().then(T=>{const E=J.__$__nodeRequire("module"),p=E._load;E._load=function(f,v,m){if(f==="tls")return S.tls;if(f!=="http"&&f!=="https")return p.apply(this,arguments);const a=S[f],g=T.findSubstr(P.URI.file(v.filename));let n=I.get(g);if(n||I.set(g,n={}),!n[f]){const d=a.default;n[f]={...d}}return n[f]}})}}),define(De[295],Ie([1,0,71,293,280,294,39,268,2,12,7,265,109,267]),function(J,e,l,t,C,P,_,D,b,I,L,k,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class E extends C.RequireInterceptor{_installInterceptor(){const f=this,v=J.__$__nodeRequire("module"),m=v._load;v._load=function(d,s,i){return d=g(d),f._factories.has(d)?f._factories.get(d).load(d,b.URI.file((0,S.realpathSync)(s.filename)),r=>m.apply(this,[r,s,i])):m.apply(this,arguments)};const a=v._resolveLookupPaths;v._resolveLookupPaths=(n,d)=>a.call(this,g(n),d);const g=n=>{for(const d of f._alternatives){const s=d(n);if(s){n=s;break}}return n}}}class p extends _.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=L.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(T.ExtHostConsoleForwarder);const f=this._instaService.invokeFunction(t.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(D.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const a=this._instaService.createInstance(k.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=a.ipcHandlePath}await this._instaService.createInstance(E,f,{mine:this._myRegistry,all:this._globalRegistry}).install(),l.mark("code/extHost/didInitAPI");const m=await this._extHostConfiguration.getConfigProvider();await(0,P.connectProxyResolver)(this._extHostWorkspace,m,this,this._logService,this._mainThreadTelemetryProxy,this._initData),l.mark("code/extHost/didInitProxyResolver")}_getEntryPoint(f){return f.main}_loadCommonJSModule(f,v,m){if(v.scheme!==I.Schemas.file)throw new Error(`Cannot load URI: '${v}', must be of file-scheme`);let a=null;m.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${v.toString(!0)}`),this._logService.flush();const g=f?.identifier.value;try{g&&l.mark(`code/extHost/willLoadExtensionCode/${g}`),a=J.__$__nodeRequire(v.fsPath)}catch(n){return Promise.reject(n)}finally{g&&l.mark(`code/extHost/didLoadExtensionCode/${g}`),m.codeLoadingStop()}return Promise.resolve(a)}async $setRemoteEnvironment(f){if(!!this._initData.remote.isRemote)for(const v in f){const m=f[v];m===null?delete process.env[v]:process.env[v]=m}}}e.ExtHostExtensionService=p}),define(De[142],Ie([1,0,44,306,289,17,75,36,9,8,2,30,69,307,287,93]),function(J,e,l,t,C,P,_,D,b,I,L,k,S,T,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const w=E.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class f{constructor(h){this.outputChannel=h}provideTextSearchResults(h,y,R,M){return this.outputChannel.appendLine(`provideTextSearchResults ${h.pattern}, ${JSON.stringify({...y,folder:y.folder.toString()})}`),new Promise((U,A)=>{M.onCancellationRequested(()=>V());const z=d(h,y),$=y.folder.fsPath,N=z.map(ve=>ve.match(/^-/)?ve:`'${ve}'`).join(" ");this.outputChannel.appendLine(`${w} ${N}
 - cwd: ${$}`);let K=l.spawn(w,z,{cwd:$});K.on("error",ve=>{console.error(ve),this.outputChannel.appendLine("Error: "+(ve&&ve.message)),A((0,k.serializeSearchError)(new k.SearchError(ve&&ve.message,k.SearchErrorCode.rgProcessError)))});let B=!1;const O=new a(y.maxResults,$,y.previewOptions);O.on("result",ve=>{B=!0,Y="",R.report(ve)});let x=!1;const V=()=>{x=!0,K?.kill(),O?.cancel()};let q=!1;O.on("hitLimit",()=>{q=!0,V()});let Y="";K.stdout.on("data",ve=>{O.handleData(ve),B||(Y+=ve)});let Q=!1;K.stdout.once("data",()=>Q=!0);let de="";K.stderr.on("data",ve=>{const ne=ve.toString();this.outputChannel.appendLine(ne),de.length+ne.length<1e6&&(de+=ne)}),K.on("close",()=>{if(this.outputChannel.appendLine(Q?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(B?"Got result from parser":"No result from parser"),Y&&this.outputChannel.appendLine(`Got data without result: ${Y}`),this.outputChannel.appendLine(""),x)U({limitHit:q});else{O.flush(),K=null;let ve;de&&!Q&&(ve=v(de))?A((0,k.serializeSearchError)(new k.SearchError(ve.message,ve.code))):U({limitHit:q})}})})}}e.RipgrepTextSearchEngine=f;function v(u){const h=u.split(`
`),y=h[0].trim();if(h.some(M=>M.startsWith("regex parse error")))return new k.SearchError(m(h),k.SearchErrorCode.regexParseError);const R=y.match(/grep config error: unknown encoding: (.*)/);if(R)return new k.SearchError(`Unknown encoding: ${R[1]}`,k.SearchErrorCode.unknownEncoding);if(y.startsWith("error parsing glob"))return new k.SearchError(y.charAt(0).toUpperCase()+y.substr(1),k.SearchErrorCode.globParseError);if(y.startsWith("the literal"))return new k.SearchError(y.charAt(0).toUpperCase()+y.substr(1),k.SearchErrorCode.invalidLiteral);if(y.startsWith("PCRE2: error compiling pattern"))return new k.SearchError(y,k.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=v;function m(u){const h=["Regex parse error"],y=u.filter(R=>R.startsWith("PCRE2:"));if(y.length>=1){const R=y[0].replace("PCRE2:","");if(R.indexOf(":")!==-1&&R.split(":").length>=2){const M=R.split(":")[1];h.push(":"+M)}}return h.join("")}e.buildRegexParseError=m;class a extends t.EventEmitter{constructor(h,y,R){super(),this.maxResults=h,this.rootFolder=y,this.previewOptions=R,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new C.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(h,y){return super.on(h,y),this}handleData(h){if(this.isDone)return;const y=typeof h=="string"?h:this.stringDecoder.write(h);this.handleDecodedData(y)}handleDecodedData(h){let y=h.indexOf(`
`);const R=this.remainder+h;if(y>=0)y+=this.remainder.length;else{this.remainder=R;return}let M=0;for(;y>=0;)this.handleLine(R.substring(M,y).trim()),M=y+1,y=R.indexOf(`
`,M);this.remainder=R.substring(M)}handleLine(h){if(this.isDone||!h)return;let y;try{y=JSON.parse(h)}catch{throw new Error(`malformed line from rg: ${h}`)}if(y.type==="match"){const R=g(y.data.path),M=L.URI.file(b.join(this.rootFolder,R)),U=this.createTextSearchMatch(y.data,M);this.onResult(U),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(y.type==="context"){const R=g(y.data.path),M=L.URI.file(b.join(this.rootFolder,R));this.createTextSearchContext(y.data,M).forEach(A=>this.onResult(A))}}createTextSearchMatch(h,y){const R=h.line_number-1,M=g(h.lines),U=Buffer.from(M);let A=0,z=0,$=R;h.submatches.length===0&&h.submatches.push(M.length?{start:0,end:1,match:{text:M[0]}}:{start:0,end:0,match:{text:""}});const N=(0,P.coalesce)(h.submatches.map((K,B)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const O=g(K.match),x=U.slice(A,K.start).toString().length,V=z+x,q=n(O),Y=$,Q=q.numLines+Y,de=q.numLines>0?q.lastLineLength:q.lastLineLength+V;return A=K.end,z=de,$=Q,new S.Range(Y,V,Q,de)}));return(0,p.createTextSearchResult)(y,M,N,this.previewOptions)}createTextSearchContext(h,y){const R=g(h.lines),M=h.line_number;return R.replace(/\r?\n$/,"").split(`
`).map((U,A)=>({text:U,uri:y,lineNumber:M+A}))}onResult(h){this.emit("result",h)}}e.RipgrepParser=a;function g(u){return u.bytes?Buffer.from(u.bytes,"base64").toString():u.text}function n(u){const h=/\n/g;let y=0,R=-1,M;for(;M=h.exec(u);)y++,R=M.index;const U=R>=0?u.length-R-1:u.length;return{numLines:y,lastLineLength:U}}function d(u,h){const y=["--hidden"];y.push(u.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:R,otherIncludes:M}=(0,_.groupBy)(h.includes,A=>A.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(M&&M.length){const A=new Set;M.forEach(z=>{A.add(z)}),y.push("-g","!*"),A.forEach(z=>{s(z).map(p.anchorGlob).forEach($=>{y.push("-g",$)})})}R&&R.length&&R.forEach(A=>{y.push("-g",A)}),h.excludes.map(p.anchorGlob).forEach(A=>y.push("-g",`!${A}`)),h.maxFileSize&&y.push("--max-filesize",h.maxFileSize+""),h.useIgnoreFiles?h.useParentIgnoreFiles||y.push("--no-ignore-parent"):y.push("--no-ignore"),h.followSymlinks&&y.push("--follow"),h.encoding&&h.encoding!=="utf8"&&y.push("--encoding",h.encoding),u.pattern==="--"&&(u.isRegExp=!0,u.pattern="\\-\\-"),u.isMultiline&&!u.isRegExp&&(u.pattern=(0,I.escapeRegExpCharacters)(u.pattern),u.isRegExp=!0),h.usePCRE2&&y.push("--pcre2"),y.push("--crlf"),u.isRegExp&&(u.pattern=i(u.pattern),y.push("--engine","auto"));let U;if(u.isWordMatch){const z=(0,I.createRegExp)(u.pattern,!!u.isRegExp,{wholeWord:u.isWordMatch}).source.replace(/\\\//g,"/");y.push("--regexp",z)}else if(u.isRegExp){let A=c(u.pattern);A=o(A),y.push("--regexp",A)}else U=u.pattern,y.push("--fixed-strings");return y.push("--no-config"),h.useGlobalIgnoreFiles||y.push("--no-ignore-global"),y.push("--json"),u.isMultiline&&y.push("--multiline"),h.beforeContext&&y.push("--before-context",h.beforeContext+""),h.afterContext&&y.push("--after-context",h.afterContext+""),y.push("--"),U&&y.push(U),y.push("."),y}function s(u){const h=(0,D.splitGlobAware)(u,"/");return h.map((y,R)=>h.slice(0,R+1).join("/"))}e.spreadGlobComponents=s;function i(u){const h=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;u.match(h);)u=u.replace(h,"$1\\x{$2}");const y=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;u.match(y);)u=u.replace(y,"$1\\x{$2}");return u}e.unicodeEscapesToPCRE2=i;const r=u=>u.type==="Assertion"&&u.kind==="lookbehind";function c(u){let h;try{h=new T.RegExpParser().parsePattern(u)}catch{return u}let y="",R=0;const M=(z,$,N)=>{y+=u.slice(R,z)+N,R=$},U=[];return new T.RegExpVisitor({onCharacterEnter(z){if(z.raw!=="\\n")return;const $=U[0];if(!$)M(z.start,z.end,"\\r?\\n");else if(!U.some(r))if($.type==="CharacterClass")if($.negate){const N=u.slice($.start+2,z.start)+u.slice(z.end,$.end-1);$.parent?.type==="Quantifier"?M($.start,$.end,N?`[^${N}]`:"."):M($.start,$.end,"(?!\\r?\\n"+(N?`|[${N}]`:"")+")")}else{const N=u.slice($.start+1,z.start)+u.slice(z.end,$.end-1);M($.start,$.end,N===""?"\\r?\\n":`(?:[${N}]|\\r?\\n)`)}else $.type==="Quantifier"&&M(z.start,z.end,"(?:\\r?\\n)")},onQuantifierEnter(z){U.unshift(z)},onQuantifierLeave(){U.shift()},onCharacterClassRangeEnter(z){U.unshift(z)},onCharacterClassRangeLeave(){U.shift()},onCharacterClassEnter(z){U.unshift(z)},onCharacterClassLeave(){U.shift()},onAssertionEnter(z){r(z)&&U.push(z)},onAssertionLeave(z){U[0]===z&&U.shift()}}).visit(h),y+=u.slice(R),y}e.fixRegexNewline=c;function o(u){return u.replace(/\n/g,"\\r?\\n")}e.fixNewline=o}),define(De[296],Ie([1,0,21,142,119,12]),function(J,e,l,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class _{constructor(I){this.outputChannel=I,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(I,L,k,S){const T=new t.RipgrepTextSearchEngine(this.outputChannel);if(L.folder.scheme===P.Schemas.vscodeUserData){const E={...L,folder:L.folder.with({scheme:P.Schemas.file})},p=new C.Progress(w=>k.report({...w,uri:w.uri.with({scheme:L.folder.scheme})}));return this.withToken(S,w=>T.provideTextSearchResults(I,E,p,w))}else return this.withToken(S,E=>T.provideTextSearchResults(I,L,k,E))}async withToken(I,L){const k=D(I);this.inProgress.add(k);const S=await L(k.token);return this.inProgress.delete(k),S}dispose(){this.inProgress.forEach(I=>I.cancel())}}e.RipgrepSearchProvider=_;function D(b){const I=new l.CancellationTokenSource;return b.onCancellationRequested(()=>I.cancel()),I}}),define(De[297],Ie([1,0,29,142,141]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class P{constructor(b){this.query=b}search(b,I,L){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const k={appendLine(T){L({message:T})}},S=new C.NativeTextSearchManager(this.query,new t.RipgrepTextSearchEngine(k),l);return new Promise((T,E)=>S.search(p=>{I(p.map(_))},b).then(p=>T({limitHit:p.limitHit,type:"success",stats:p.stats}),E))}}e.TextSearchEngineAdapter=P;function _(D){return{path:D.resource&&D.resource.fsPath,results:D.results,numMatches:(D.results||[]).reduce((b,I)=>{if(I.ranges){const L=I;return b+(Array.isArray(L.ranges)?L.ranges.length:1)}else return b+1},0)}}}),define(De[298],Ie([1,0,17,18,10,4,105,9,51,2,42,30,288,297]),function(J,e,l,t,C,P,_,D,b,I,L,k,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class E{constructor(a="searchProcess"){this.processType=a,this.caches=Object.create(null)}fileSearch(a){let g;const n=f(a),d=new P.Emitter({onFirstListenerDidAdd:()=>{g=(0,t.createCancelablePromise)(s=>this.doFileSearchWithEngine(S.Engine,n,i=>d.fire(i),s)),g.then(s=>d.fire(s),s=>d.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onLastListenerRemove:()=>{g.cancel()}});return d.event}textSearch(a){let g;const n=f(a),d=new P.Emitter({onFirstListenerDidAdd:()=>{g=(0,t.createCancelablePromise)(s=>this.ripgrepTextSearch(n,i=>d.fire(i),s)),g.then(s=>d.fire(s),s=>d.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onLastListenerRemove:()=>{g.cancel()}});return d.event}ripgrepTextSearch(a,g,n){return a.maxFileSize=(0,L.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new T.TextSearchEngineAdapter(a).search(n,g,g)}doFileSearch(a,g,n){return this.doFileSearchWithEngine(S.Engine,a,g,n)}doFileSearchWithEngine(a,g,n,d,s=E.BATCH_SIZE){let i=0;const r=o=>{Array.isArray(o)?(i+=o.length,n(o.map(u=>this.rawMatchToSearchItem(u)))):o.relativePath?(i++,n(this.rawMatchToSearchItem(o))):n(o)};if(g.sortByScore){let o=this.trySortedSearchFromCache(g,r,d);if(!o){const u=g.maxResults?Object.assign({},g,{maxResults:null}):g,h=new a(u);o=this.doSortedSearch(h,g,n,r,d)}return new Promise((u,h)=>{o.then(([y,R])=>{const M=R.map(U=>this.rawMatchToSearchItem(U));this.sendProgress(M,n,s),u(y)},h)})}const c=new a(g);return this.doSearch(c,r,s,d).then(o=>({limitHit:o.limitHit,type:"success",stats:{detailStats:o.stats,type:this.processType,fromCache:!1,resultCount:i,sortingTime:void 0}}))}rawMatchToSearchItem(a){return{path:a.base?(0,D.join)(a.base,a.relativePath):a.relativePath}}doSortedSearch(a,g,n,d,s){const i=new P.Emitter;let r=(0,t.createCancelablePromise)(o=>{let u=[];const h=y=>{Array.isArray(y)?u=y:(d(y),i.fire(y))};return this.doSearch(a,h,-1,o).then(y=>[y,u])}),c;if(g.cacheKey){c=this.getOrCreateCache(g.cacheKey);const o={promise:r,event:i.event,resolved:!1};c.resultsToSearchCache[g.filePattern||""]=o,r.then(()=>{o.resolved=!0},u=>{delete c.resultsToSearchCache[g.filePattern||""]}),r=this.preventCancellation(r)}return r.then(([o,u])=>{const h=c?c.scorerCache:Object.create(null),y=(typeof g.maxResults!="number"||g.maxResults>0)&&b.StopWatch.create(!1);return this.sortResults(g,u,h,s).then(R=>{const M=y?y.elapsed():-1;return[{type:"success",stats:{detailStats:o.stats,sortingTime:M,fromCache:!1,type:this.processType,workspaceFolderCount:g.folderQueries.length,resultCount:R.length},messages:o.messages,limitHit:o.limitHit||typeof g.maxResults=="number"&&u.length>g.maxResults},R]})})}getOrCreateCache(a){const g=this.caches[a];return g||(this.caches[a]=new p)}trySortedSearchFromCache(a,g,n){const d=a.cacheKey&&this.caches[a.cacheKey];if(!d)return;const s=this.getResultsFromCache(d,a.filePattern||"",g,n);if(s)return s.then(([i,r,c])=>{const o=b.StopWatch.create(!1);return this.sortResults(a,r,d.scorerCache,n).then(u=>{const h=o.elapsed(),y={fromCache:!0,detailStats:c,type:this.processType,resultCount:r.length,sortingTime:h};return[{type:"success",limitHit:i.limitHit||typeof a.maxResults=="number"&&r.length>a.maxResults,stats:y},u]})})}sortResults(a,g,n,d){const s=(0,_.prepareQuery)(a.filePattern||""),i=(c,o)=>(0,_.compareItemsByFuzzyScore)(c,o,s,!0,w,n),r=typeof a.maxResults=="number"?a.maxResults:Number.MAX_VALUE;return l.topAsync(g,i,r,1e4,d)}sendProgress(a,g,n){if(n&&n>0)for(let d=0;d<a.length;d+=n)g(a.slice(d,d+n));else g(a)}getResultsFromCache(a,g,n,d){const s=b.StopWatch.create(!1),i=g.indexOf(D.sep)>=0;let r;for(const h in a.resultsToSearchCache)if(g.startsWith(h)){if(i&&h.indexOf(D.sep)<0&&h!=="")continue;const y=a.resultsToSearchCache[h];r={promise:this.preventCancellation(y.promise),event:y.event,resolved:y.resolved};break}if(!r)return null;const c=s.elapsed(),o=b.StopWatch.create(!1),u=r.event(n);return d&&d.onCancellationRequested(()=>{u.dispose()}),r.promise.then(([h,y])=>{if(d&&d.isCancellationRequested)throw(0,C.canceled)();const R=[],M=(0,_.prepareQuery)(g).normalizedLowercase;for(const U of y)!(0,k.isFilePatternMatch)(U,M)||R.push(U);return[h,R,{cacheWasResolved:r.resolved,cacheLookupTime:c,cacheFilterTime:o.elapsed(),cacheEntryCount:y.length}]})}doSearch(a,g,n,d){return new Promise((s,i)=>{let r=[];d?.onCancellationRequested(()=>a.cancel()),a.search(c=>{c&&(n?(r.push(c),n>0&&r.length>=n&&(g(r),r=[])):g(c))},c=>{g(c)},(c,o)=>{r.length&&g(r),c?i(c):s(o)})})}clearCache(a){return delete this.caches[a],Promise.resolve(void 0)}preventCancellation(a){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(g,n){return a.then(g,n)}catch(g){return this.then(void 0,g)}finally(g){return a.finally(g)}}}}e.SearchService=E,E.BATCH_SIZE=512;class p{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const w=new class{getItemLabel(m){return(0,D.basename)(m.relativePath)}getItemDescription(m){return(0,D.dirname)(m.relativePath)}getItemPath(m){return m.relativePath}};function f(m){return{...m,folderQueries:m.folderQueries&&m.folderQueries.map(v),extraFileResources:m.extraFileResources&&m.extraFileResources.map(a=>I.URI.revive(a))}}function v(m){return{...m,folder:I.URI.revive(m.folder)}}}),define(De[299],Ie([1,0,6,12,2,29,15,26,16,73,54,30,298,296,93,141]),function(J,e,l,t,C,P,_,D,b,I,L,k,S,T,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let w=class extends I.ExtHostSearch{constructor(v,m,a,g){super(v,a,g),this._pfs=P,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const n=new E.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(t.Schemas.vscodeUserData,new T.RipgrepSearchProvider(n)),m.remote.isRemote&&m.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const v=new E.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(t.Schemas.file,new T.RipgrepSearchProvider(v)),this.registerInternalFileSearchProvider(t.Schemas.file,new S.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(v,m){const a=this._handlePool++;return this._internalFileSearchProvider=m,this._internalFileSearchHandle=a,this._proxy.$registerFileSearchProvider(a,this._transformScheme(v)),(0,l.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(a)})}$provideFileSearchResults(v,m,a,g){const n=(0,I.reviveQuery)(a);return v===this._internalFileSearchHandle?this.doInternalFileSearch(v,m,n,g):super.$provideFileSearchResults(v,m,a,g)}doInternalFileSearch(v,m,a,g){const n=d=>{if((0,k.isSerializedFileMatch)(d)&&(d=[d]),Array.isArray(d)){this._proxy.$handleFileMatch(v,m,d.map(s=>C.URI.file(s.path)));return}d.message&&this._logService.debug("ExtHostSearch",d.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(a,n,g)}$clearCache(v){return this._internalFileSearchProvider?.clearCache(v),super.$clearCache(v)}createTextSearchManager(v,m){return new p.NativeTextSearchManager(v,m,void 0,"textSearchProvider")}};w=qe([xe(0,b.IExtHostRpcService),xe(1,D.IExtHostInitDataService),xe(2,L.IURITransformerService),xe(3,_.ILogService)],w),e.NativeExtHostSearch=w}),define(De[300],Ie([1,0,82,271,283,282,299,295,272,72,39,73,70,38,53,67,270,269,15,284,47]),function(J,e,l,t,C,P,_,D,b,I,L,k,S,T,E,p,w,f,v,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,l.registerSingleton)(L.IExtHostExtensionService,D.ExtHostExtensionService,!1),(0,l.registerSingleton)(v.ILoggerService,f.ExtHostLoggerService,!0),(0,l.registerSingleton)(p.IExtensionStoragePaths,w.ExtensionStoragePaths,!1),(0,l.registerSingleton)(I.IExtHostDebugService,P.ExtHostDebugService,!1),(0,l.registerSingleton)(k.IExtHostSearch,_.NativeExtHostSearch,!1),(0,l.registerSingleton)(S.IExtHostTask,C.ExtHostTask,!1),(0,l.registerSingleton)(T.IExtHostTerminalService,t.ExtHostTerminalService,!1),(0,l.registerSingleton)(E.IExtHostTunnelService,b.ExtHostTunnelService,!1),(0,l.registerSingleton)(a.IExtHostVariableResolverProvider,m.NodeExtHostVariableResolverProviderService,!1)}),define(De[308],Ie([1,0,212,309,71,10,112,113,195,130,281,23,29,109,18,115,207,221,285,300]),function(J,e,l,t,C,P,_,D,b,I,L,k,S,T,E,p,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let c=0;c<process.execArgv.length;c++)process.execArgv[c]==="--inspect-port=0"&&(process.execArgv.splice(c,1),c--)}();const v=t(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const r=J.__$__nodeRequire("module"),c=r._load;r._load=function(o){if(o==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return c.apply(this,arguments)}})();const m=process.exit.bind(process);function a(r){process.exit=function(c){if(r)m(c);else{const o=new Error("An extension called process.exit() and this was prevented.");console.warn(o.stack)}},process.crash=function(){const c=new Error("An extension called process.crash() and this was prevented.");console.warn(c.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let g=function(r){m()};function n(){const r=(0,f.readExtHostConnection)(process.env);if(r.type===3)return new Promise((c,o)=>{const u=h=>{const y=h[0],R=new _.BufferedEmitter;y.on("message",M=>R.fire(k.VSBuffer.wrap(M.data))),y.on("close",()=>{g("renderer closed the MessagePort")}),y.start(),c({onMessage:R.event,send:M=>y.postMessage(M.buffer)})};if(global.vscodePorts){const h=global.vscodePorts;delete global.vscodePorts,u(h)}else global.vscodePortsCallback=u});if(r.type===2)return new Promise((c,o)=>{let u=null;const h=setTimeout(()=>{g("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),y=108e5,R=3e5,M=new E.ProcessTimeRunOnceScheduler(()=>g("renderer disconnected for too long (1)"),y),U=new E.ProcessTimeRunOnceScheduler(()=>g("renderer disconnected for too long (2)"),R);process.on("message",(z,$)=>{if(z&&z.type==="VSCODE_EXTHOST_IPC_SOCKET"){$.setNoDelay(!0);const N=k.VSBuffer.wrap(Buffer.from(z.initialDataChunk,"base64"));let K;if(z.skipWebSocketFrames)K=new D.NodeSocket($,"extHost-socket");else{const B=k.VSBuffer.wrap(Buffer.from(z.inflateBytes,"base64"));K=new D.WebSocketNodeSocket(new D.NodeSocket($,"extHost-socket"),z.permessageDeflate,B,!1)}u?(M.cancel(),U.cancel(),u.beginAcceptReconnection(K,N),u.endAcceptReconnection(),u.sendResume()):(clearTimeout(h),u=new _.PersistentProtocol(K,N),u.sendResume(),u.onDidDispose(()=>g("renderer disconnected")),c(u),u.onSocketClose(()=>{M.schedule()}))}if(z&&z.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(U.isScheduled())return;M.isScheduled()&&U.schedule()}});const A={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(A)});{const c=r.pipeName;return new Promise((o,u)=>{const h=l.createConnection(c,()=>{h.removeListener("error",u);const y=new _.PersistentProtocol(new D.NodeSocket(h,"extHost-renderer"));y.sendResume(),o(y)});h.once("error",u),h.on("close",()=>{g("renderer closed the socket")})})}}async function d(){const r=await n();return new class{constructor(){this._onMessage=new _.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,r.onMessage(c=>{(0,I.isMessageOfType)(c,2)?(this._terminating=!0,g("received terminate message from renderer")):this._onMessage.fire(c)})}send(c){this._terminating||r.send(c)}async drain(){if(r.drain)return r.drain()}}}function s(r){return new Promise(c=>{const o=r.onMessage(u=>{o.dispose();const h=JSON.parse(u.toString()),y=h.commit,R=b.default.commit;if(y&&R&&y!==R&&m(55),h.parentPid){let M=0;setInterval(function(){try{process.kill(h.parentPid,0),M=0}catch(A){A&&A.code==="EPERM"?(M++,M>=3&&g(`parent process ${h.parentPid} does not exist anymore (3 x EPERM): ${A.message} (code: ${A.code}) (errno: ${A.errno})`)):g(`parent process ${h.parentPid} does not exist anymore: ${A.message} (code: ${A.code}) (errno: ${A.errno})`)}},1e3);let U;try{U=J.__$__nodeRequire("native-watchdog"),U.start(h.parentPid)}catch(A){(0,P.onUnexpectedError)(A)}}r.send((0,I.createMessageOfType)(0)),c({protocol:r,initData:h})});r.send((0,I.createMessageOfType)(1))})}async function i(){const r=[];process.on("unhandledRejection",(M,U)=>{r.push(U),setTimeout(()=>{const A=r.indexOf(U);A>=0&&U.catch(z=>{r.splice(A,1),(0,P.isCancellationError)(z)||(console.warn(`rejected promise not handled within 1 second: ${z}`),z&&z.stack&&console.warn(`stack trace: ${z.stack}`),M&&(0,P.onUnexpectedError)(M))})},1e3)}),process.on("rejectionHandled",M=>{const U=r.indexOf(M);U>=0&&r.splice(U,1)}),process.on("uncaughtException",function(M){(0,P.onUnexpectedError)(M)}),C.mark("code/extHost/willConnectToRenderer");const c=await d();C.mark("code/extHost/didConnectToRenderer");const o=await s(c);C.mark("code/extHost/didWaitForInitData");const{initData:u}=o;a(!!u.environment.extensionTestsLocationURI),u.environment.useHostProxy=v.useHostProxy!==void 0?v.useHostProxy!=="false":void 0,u.environment.skipWorkspaceStorageLock=(0,p.boolean)(v.skipWorkspaceStorageLock,!1);const h=new class{constructor(){this.pid=process.pid}exit(U){m(U)}exists(U){return S.Promises.exists(U)}realpath(U){return(0,T.realpath)(U)}};let y=null;u.remote.authority&&v.transformURIs&&(y=(0,w.createURITransformer)(u.remote.authority));const R=new L.ExtensionHostMain(o.protocol,u,h,y);g=M=>R.terminate(M)}e.startExtensionHostProcess=i,i().catch(r=>console.log(r))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/1a55beb2aaee64eb8d0cbe5b61b10088bbc6c895/core/vs/workbench/api/node/extensionHostProcess.js.map
