/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ce=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/types","vs/base/common/errors","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/async","vs/platform/log/common/log","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/path","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/resources","vs/base/common/buffer","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/glob","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/base/common/errorMessage","vs/base/common/assert","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/editor/common/core/range","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/platform/instantiation/common/extensions","vs/platform/configuration/common/configuration","vs/platform/instantiation/common/serviceCollection","vs/base/common/process","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/common/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/idGenerator","vs/base/common/mime","vs/base/common/marshalling","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostTelemetryLogService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/codicons","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/lazy","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/base/common/hash","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/base/common/linkedList","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Ie=function(te){for(var e=[],r=0,y=te.length;r<y;r++)e[r]=Ce[te[r]];return e};define(Ce[72],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function r(_,A){const E=Object.create(null);for(const k of _){const F=A(k);let S=E[F];S||(S=E[F]=[]),S.push(k)}return E}e.groupBy=r;function y(_,A){const E=[],k=[];for(const F of _)A.has(F)||E.push(F);for(const F of A)_.has(F)||k.push(F);return{removed:E,added:k}}e.diffSets=y;function w(_,A){const E=[],k=[];for(const[F,S]of _)A.has(F)||E.push(S);for(const[F,S]of A)_.has(F)||k.push(S);return{removed:E,added:k}}e.diffMaps=w;class L{constructor(){this.map=new Map}add(A,E){let k=this.map.get(A);k||(k=new Set,this.map.set(A,k)),k.add(E)}delete(A,E){const k=this.map.get(A);!k||(k.delete(E),k.size===0&&this.map.delete(A))}forEach(A,E){const k=this.map.get(A);!k||k.forEach(E)}}e.SetMap=L}),define(Ce[55],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function r(_){return(A,E,k)=>{let F=null,S=null;if(typeof k.value=="function"?(F="value",S=k.value):typeof k.get=="function"&&(F="get",S=k.get),!S)throw new Error("not supported");k[F]=_(S,E)}}e.createDecorator=r;function y(_,A,E){let k=null,F=null;if(typeof E.value=="function"?(k="value",F=E.value,F.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(k="get",F=E.get),!F)throw new Error("not supported");const S=`$memoize$${A}`;E[k]=function(...m){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:F.apply(this,m)}),this[S]}}e.memoize=y;function w(_,A,E){return r((k,F)=>{const S=`$debounce$${F}`,m=`$debounce$result$${F}`;return function(...T){this[m]||(this[m]=E?E():void 0),clearTimeout(this[S]),A&&(this[m]=A(this[m],...T),T=[this[m]]),this[S]=setTimeout(()=>{k.apply(this,T),this[m]=E?E():void 0},_)}})}e.debounce=w;function L(_,A,E){return r((k,F)=>{const S=`$throttle$timer$${F}`,m=`$throttle$result$${F}`,T=`$throttle$lastRun$${F}`,f=`$throttle$pending$${F}`;return function(...c){if(this[m]||(this[m]=E?E():void 0),(this[T]===null||this[T]===void 0)&&(this[T]=-Number.MAX_VALUE),A&&(this[m]=A(this[m],...c)),this[f])return;const h=this[T]+_;h<=Date.now()?(this[T]=Date.now(),k.apply(this,[this[m]]),this[m]=E?E():void 0):(this[f]=!0,this[S]=setTimeout(()=>{this[f]=!1,this[T]=Date.now(),k.apply(this,[this[m]]),this[m]=E?E():void 0},h-Date.now()))}})}e.throttle=L}),define(Ce[73],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class r{constructor(w){this._prefix=w,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=r,e.defaultGenerator=new r("id#")}),define(Ce[105],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var r;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(r=e.ScanError||(e.ScanError={}));var y;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(y=e.SyntaxKind||(e.SyntaxKind={}));var w;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(w=e.ParseErrorCode||(e.ParseErrorCode={}));var L;(function(t){t.DEFAULT={allowTrailingComma:!0}})(L=e.ParseOptions||(e.ParseOptions={}));function _(t,d=!1){let n=0;const i=t.length;let s="",a=0,o=16,g=0;function p(U){let R=0,K=0;for(;R<U;){const W=t.charCodeAt(n);if(W>=48&&W<=57)K=K*16+W-48;else if(W>=65&&W<=70)K=K*16+W-65+10;else if(W>=97&&W<=102)K=K*16+W-97+10;else break;n++,R++}return R<U&&(K=-1),K}function P(U){n=U,s="",a=0,o=16,g=0}function M(){const U=n;if(t.charCodeAt(n)===48)n++;else for(n++;n<t.length&&k(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===46)if(n++,n<t.length&&k(t.charCodeAt(n)))for(n++;n<t.length&&k(t.charCodeAt(n));)n++;else return g=3,t.substring(U,n);let R=n;if(n<t.length&&(t.charCodeAt(n)===69||t.charCodeAt(n)===101))if(n++,(n<t.length&&t.charCodeAt(n)===43||t.charCodeAt(n)===45)&&n++,n<t.length&&k(t.charCodeAt(n))){for(n++;n<t.length&&k(t.charCodeAt(n));)n++;R=n}else g=3;return t.substring(U,R)}function V(){let U="",R=n;for(;;){if(n>=i){U+=t.substring(R,n),g=2;break}const K=t.charCodeAt(n);if(K===34){U+=t.substring(R,n),n++;break}if(K===92){if(U+=t.substring(R,n),n++,n>=i){g=2;break}switch(t.charCodeAt(n++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const O=p(4);O>=0?U+=String.fromCharCode(O):g=4;break}default:g=5}R=n;continue}if(K>=0&&K<=31)if(E(K)){U+=t.substring(R,n),g=2;break}else g=6;n++}return U}function B(){if(s="",g=0,a=n,n>=i)return a=i,o=17;let U=t.charCodeAt(n);if(A(U)){do n++,s+=String.fromCharCode(U),U=t.charCodeAt(n);while(A(U));return o=15}if(E(U))return n++,s+=String.fromCharCode(U),U===13&&t.charCodeAt(n)===10&&(n++,s+=`
`),o=14;switch(U){case 123:return n++,o=1;case 125:return n++,o=2;case 91:return n++,o=3;case 93:return n++,o=4;case 58:return n++,o=6;case 44:return n++,o=5;case 34:return n++,s=V(),o=10;case 47:{const R=n-1;if(t.charCodeAt(n+1)===47){for(n+=2;n<i&&!E(t.charCodeAt(n));)n++;return s=t.substring(R,n),o=12}if(t.charCodeAt(n+1)===42){n+=2;const K=i-1;let W=!1;for(;n<K;){if(t.charCodeAt(n)===42&&t.charCodeAt(n+1)===47){n+=2,W=!0;break}n++}return W||(n++,g=1),s=t.substring(R,n),o=13}return s+=String.fromCharCode(U),n++,o=16}case 45:if(s+=String.fromCharCode(U),n++,n===i||!k(t.charCodeAt(n)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=M(),o=11;default:for(;n<i&&D(U);)n++,U=t.charCodeAt(n);if(a!==n){switch(s=t.substring(a,n),s){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return s+=String.fromCharCode(U),n++,o=16}}function D(U){if(A(U)||E(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function x(){let U;do U=B();while(U>=12&&U<=15);return U}return{setPosition:P,getPosition:()=>n,scan:d?x:B,getToken:()=>o,getTokenValue:()=>s,getTokenOffset:()=>a,getTokenLength:()=>n-a,getTokenError:()=>g}}e.createScanner=_;function A(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function E(t){return t===10||t===13||t===8232||t===8233}function k(t){return t>=48&&t<=57}var F;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(F||(F={}));function S(t,d){const n=[],i=new Object;let s;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function g(p,P,M,V){a.value=p,a.offset=P,a.length=M,a.type=V,a.colonOffset=void 0,s=a}try{I(t,{onObjectBegin:(p,P)=>{if(d<=p)throw i;s=void 0,o=d>p,n.push("")},onObjectProperty:(p,P,M)=>{if(d<P||(g(p,P,M,"property"),n[n.length-1]=p,d<=P+M))throw i},onObjectEnd:(p,P)=>{if(d<=p)throw i;s=void 0,n.pop()},onArrayBegin:(p,P)=>{if(d<=p)throw i;s=void 0,n.push(0)},onArrayEnd:(p,P)=>{if(d<=p)throw i;s=void 0,n.pop()},onLiteralValue:(p,P,M)=>{if(d<P||(g(p,P,M,b(p)),d<=P+M))throw i},onSeparator:(p,P,M)=>{if(d<=P)throw i;if(p===":"&&s&&s.type==="property")s.colonOffset=P,o=!1,s=void 0;else if(p===","){const V=n[n.length-1];typeof V=="number"?n[n.length-1]=V+1:(o=!0,n[n.length-1]=""),s=void 0}}})}catch(p){if(p!==i)throw p}return{path:n,previousNode:s,isAtPropertyKey:o,matches:p=>{let P=0;for(let M=0;P<p.length&&M<n.length;M++)if(p[P]===n[M]||p[P]==="*")P++;else if(p[P]!=="**")return!1;return P===p.length}}}e.getLocation=S;function m(t,d=[],n=L.DEFAULT){let i=null,s=[];const a=[];function o(p){Array.isArray(s)?s.push(p):i!==null&&(s[i]=p)}return I(t,{onObjectBegin:()=>{const p={};o(p),a.push(s),s=p,i=null},onObjectProperty:p=>{i=p},onObjectEnd:()=>{s=a.pop()},onArrayBegin:()=>{const p=[];o(p),a.push(s),s=p,i=null},onArrayEnd:()=>{s=a.pop()},onLiteralValue:o,onError:(p,P,M)=>{d.push({error:p,offset:P,length:M})}},n),s[0]}e.parse=m;function T(t,d=[],n=L.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(p){i.type==="property"&&(i.length=p-i.offset,i=i.parent)}function a(p){return i.children.push(p),p}I(t,{onObjectBegin:p=>{i=a({type:"object",offset:p,length:-1,parent:i,children:[]})},onObjectProperty:(p,P,M)=>{i=a({type:"property",offset:P,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:p,offset:P,length:M,parent:i})},onObjectEnd:(p,P)=>{i.length=p+P-i.offset,i=i.parent,s(p+P)},onArrayBegin:(p,P)=>{i=a({type:"array",offset:p,length:-1,parent:i,children:[]})},onArrayEnd:(p,P)=>{i.length=p+P-i.offset,i=i.parent,s(p+P)},onLiteralValue:(p,P,M)=>{a({type:b(p),offset:P,length:M,parent:i,value:p}),s(P+M)},onSeparator:(p,P,M)=>{i.type==="property"&&(p===":"?i.colonOffset=P:p===","&&s(P))},onError:(p,P,M)=>{d.push({error:p,offset:P,length:M})}},n);const g=i.children[0];return g&&delete g.parent,g}e.parseTree=T;function f(t,d){if(!t)return;let n=t;for(const i of d)if(typeof i=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let s=!1;for(const a of n.children)if(Array.isArray(a.children)&&a.children[0].value===i){n=a.children[1],s=!0;break}if(!s)return}else{const s=i;if(n.type!=="array"||s<0||!Array.isArray(n.children)||s>=n.children.length)return;n=n.children[s]}return n}e.findNodeAtLocation=f;function c(t){if(!t.parent||!t.parent.children)return[];const d=c(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;d.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&d.push(n)}return d}e.getNodePath=c;function h(t){switch(t.type){case"array":return t.children.map(h);case"object":{const d=Object.create(null);for(const n of t.children){const i=n.children[1];i&&(d[n.children[0].value]=h(i))}return d}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=h;function u(t,d,n=!1){return d>=t.offset&&d<t.offset+t.length||n&&d===t.offset+t.length}e.contains=u;function v(t,d,n=!1){if(u(t,d,n)){const i=t.children;if(Array.isArray(i))for(let s=0;s<i.length&&i[s].offset<=d;s++){const a=v(i[s],d,n);if(a)return a}return t}}e.findNodeAtOffset=v;function I(t,d,n=L.DEFAULT){const i=_(t,!1);function s(ve){return ve?()=>ve(i.getTokenOffset(),i.getTokenLength()):()=>!0}function a(ve){return ve?be=>ve(be,i.getTokenOffset(),i.getTokenLength()):()=>!0}const o=s(d.onObjectBegin),g=a(d.onObjectProperty),p=s(d.onObjectEnd),P=s(d.onArrayBegin),M=s(d.onArrayEnd),V=a(d.onLiteralValue),B=a(d.onSeparator),D=s(d.onComment),x=a(d.onError),U=n&&n.disallowComments,R=n&&n.allowTrailingComma;function K(){for(;;){const ve=i.scan();switch(i.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:U||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(ve){case 12:case 13:U?W(10):D();break;case 16:W(1);break;case 15:case 14:break;default:return ve}}}function W(ve,be=[],ne=[]){if(x(ve),be.length+ne.length>0){let Ee=i.getToken();for(;Ee!==17;){if(be.indexOf(Ee)!==-1){K();break}else if(ne.indexOf(Ee)!==-1)break;Ee=K()}}}function O(ve){const be=i.getTokenValue();return ve?V(be):g(be),K(),!0}function Z(){switch(i.getToken()){case 11:{let ve=0;try{ve=JSON.parse(i.getTokenValue()),typeof ve!="number"&&(W(2),ve=0)}catch{W(2)}V(ve);break}case 7:V(null);break;case 8:V(!0);break;case 9:V(!1);break;default:return!1}return K(),!0}function ue(){return i.getToken()!==10?(W(3,[],[2,5]),!1):(O(!1),i.getToken()===6?(B(":"),K(),ie()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function oe(){o(),K();let ve=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(ve||W(4,[],[]),B(","),K(),i.getToken()===2&&R)break}else ve&&W(6,[],[]);ue()||W(4,[],[2,5]),ve=!0}return p(),i.getToken()!==2?W(7,[2],[]):K(),!0}function de(){P(),K();let ve=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(ve||W(4,[],[]),B(","),K(),i.getToken()===4&&R)break}else ve&&W(6,[],[]);ie()||W(4,[],[4,5]),ve=!0}return M(),i.getToken()!==4?W(8,[4],[]):K(),!0}function ie(){switch(i.getToken()){case 3:return de();case 1:return oe();case 10:return O(!0);default:return Z()}}return K(),i.getToken()===17?n.allowEmptyContent?!0:(W(4,[],[]),!1):ie()?(i.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.visit=I;function l(t,d){const n=_(t),i=[];let s,a=0,o;do switch(o=n.getPosition(),s=n.scan(),s){case 12:case 13:case 17:a!==o&&i.push(t.substring(a,o)),d!==void 0&&i.push(n.getTokenValue().replace(/[^\r\n]/g,d)),a=n.getPosition();break}while(s!==17);return i.join("")}e.stripComments=l;function b(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=b}),function(te,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(Ce[106],Ie([0]),e):(te=typeof globalThis<"u"?globalThis:te||self,e(te.marked={}))}(this,function(te){"use strict";function e(Te,_e){for(var ye=0;ye<_e.length;ye++){var ae=_e[ye];ae.enumerable=ae.enumerable||!1,ae.configurable=!0,"value"in ae&&(ae.writable=!0),Object.defineProperty(Te,ae.key,ae)}}function r(Te,_e,ye){return _e&&e(Te.prototype,_e),ye&&e(Te,ye),Object.defineProperty(Te,"prototype",{writable:!1}),Te}function y(Te,_e){if(!!Te){if(typeof Te=="string")return w(Te,_e);var ye=Object.prototype.toString.call(Te).slice(8,-1);if(ye==="Object"&&Te.constructor&&(ye=Te.constructor.name),ye==="Map"||ye==="Set")return Array.from(Te);if(ye==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ye))return w(Te,_e)}}function w(Te,_e){(_e==null||_e>Te.length)&&(_e=Te.length);for(var ye=0,ae=new Array(_e);ye<_e;ye++)ae[ye]=Te[ye];return ae}function L(Te,_e){var ye=typeof Symbol<"u"&&Te[Symbol.iterator]||Te["@@iterator"];if(ye)return(ye=ye.call(Te)).next.bind(ye);if(Array.isArray(Te)||(ye=y(Te))||_e&&Te&&typeof Te.length=="number"){ye&&(Te=ye);var ae=0;return function(){return ae>=Te.length?{done:!0}:{done:!1,value:Te[ae++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function _(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}te.defaults=_();function A(Te){te.defaults=Te}var E=/[&<>"']/,k=/[&<>"']/g,F=/[<>"']|&(?!#?\w+;)/,S=/[<>"']|&(?!#?\w+;)/g,m={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},T=function(_e){return m[_e]};function f(Te,_e){if(_e){if(E.test(Te))return Te.replace(k,T)}else if(F.test(Te))return Te.replace(S,T);return Te}var c=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function h(Te){return Te.replace(c,function(_e,ye){return ye=ye.toLowerCase(),ye==="colon"?":":ye.charAt(0)==="#"?ye.charAt(1)==="x"?String.fromCharCode(parseInt(ye.substring(2),16)):String.fromCharCode(+ye.substring(1)):""})}var u=/(^|[^\[])\^/g;function v(Te,_e){Te=typeof Te=="string"?Te:Te.source,_e=_e||"";var ye={replace:function(le,Q){return Q=Q.source||Q,Q=Q.replace(u,"$1"),Te=Te.replace(le,Q),ye},getRegex:function(){return new RegExp(Te,_e)}};return ye}var I=/[^\w:]/g,l=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function b(Te,_e,ye){if(Te){var ae;try{ae=decodeURIComponent(h(ye)).replace(I,"").toLowerCase()}catch{return null}if(ae.indexOf("javascript:")===0||ae.indexOf("vbscript:")===0||ae.indexOf("data:")===0)return null}_e&&!l.test(ye)&&(ye=s(_e,ye));try{ye=encodeURI(ye).replace(/%25/g,"%")}catch{return null}return ye}var t={},d=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(Te,_e){t[" "+Te]||(d.test(Te)?t[" "+Te]=Te+"/":t[" "+Te]=p(Te,"/",!0)),Te=t[" "+Te];var ye=Te.indexOf(":")===-1;return _e.substring(0,2)==="//"?ye?_e:Te.replace(n,"$1")+_e:_e.charAt(0)==="/"?ye?_e:Te.replace(i,"$1")+_e:Te+_e}var a={exec:function(){}};function o(Te){for(var _e=1,ye,ae;_e<arguments.length;_e++){ye=arguments[_e];for(ae in ye)Object.prototype.hasOwnProperty.call(ye,ae)&&(Te[ae]=ye[ae])}return Te}function g(Te,_e){var ye=Te.replace(/\|/g,function(Q,J,C){for(var z=!1,H=J;--H>=0&&C[H]==="\\";)z=!z;return z?"|":" |"}),ae=ye.split(/ \|/),le=0;if(ae[0].trim()||ae.shift(),ae.length>0&&!ae[ae.length-1].trim()&&ae.pop(),ae.length>_e)ae.splice(_e);else for(;ae.length<_e;)ae.push("");for(;le<ae.length;le++)ae[le]=ae[le].trim().replace(/\\\|/g,"|");return ae}function p(Te,_e,ye){var ae=Te.length;if(ae===0)return"";for(var le=0;le<ae;){var Q=Te.charAt(ae-le-1);if(Q===_e&&!ye)le++;else if(Q!==_e&&ye)le++;else break}return Te.slice(0,ae-le)}function P(Te,_e){if(Te.indexOf(_e[1])===-1)return-1;for(var ye=Te.length,ae=0,le=0;le<ye;le++)if(Te[le]==="\\")le++;else if(Te[le]===_e[0])ae++;else if(Te[le]===_e[1]&&(ae--,ae<0))return le;return-1}function M(Te){Te&&Te.sanitize&&!Te.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function V(Te,_e){if(_e<1)return"";for(var ye="";_e>1;)_e&1&&(ye+=Te),_e>>=1,Te+=Te;return ye+Te}function B(Te,_e,ye,ae){var le=_e.href,Q=_e.title?f(_e.title):null,J=Te[1].replace(/\\([\[\]])/g,"$1");if(Te[0].charAt(0)!=="!"){ae.state.inLink=!0;var C={type:"link",raw:ye,href:le,title:Q,text:J,tokens:ae.inlineTokens(J)};return ae.state.inLink=!1,C}return{type:"image",raw:ye,href:le,title:Q,text:f(J)}}function D(Te,_e){var ye=Te.match(/^(\s+)(?:```)/);if(ye===null)return _e;var ae=ye[1];return _e.split(`
`).map(function(le){var Q=le.match(/^\s+/);if(Q===null)return le;var J=Q[0];return J.length>=ae.length?le.slice(ae.length):le}).join(`
`)}var x=function(){function Te(ye){this.options=ye||te.defaults}var _e=Te.prototype;return _e.space=function(ae){var le=this.rules.block.newline.exec(ae);if(le&&le[0].length>0)return{type:"space",raw:le[0]}},_e.code=function(ae){var le=this.rules.block.code.exec(ae);if(le){var Q=le[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:le[0],codeBlockStyle:"indented",text:this.options.pedantic?Q:p(Q,`
`)}}},_e.fences=function(ae){var le=this.rules.block.fences.exec(ae);if(le){var Q=le[0],J=D(Q,le[3]||"");return{type:"code",raw:Q,lang:le[2]?le[2].trim():le[2],text:J}}},_e.heading=function(ae){var le=this.rules.block.heading.exec(ae);if(le){var Q=le[2].trim();if(/#$/.test(Q)){var J=p(Q,"#");(this.options.pedantic||!J||/ $/.test(J))&&(Q=J.trim())}return{type:"heading",raw:le[0],depth:le[1].length,text:Q,tokens:this.lexer.inline(Q)}}},_e.hr=function(ae){var le=this.rules.block.hr.exec(ae);if(le)return{type:"hr",raw:le[0]}},_e.blockquote=function(ae){var le=this.rules.block.blockquote.exec(ae);if(le){var Q=le[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:le[0],tokens:this.lexer.blockTokens(Q,[]),text:Q}}},_e.list=function(ae){var le=this.rules.block.list.exec(ae);if(le){var Q,J,C,z,H,j,se,ce,Y,pe,ge,Ne,Be=le[1].trim(),Ye=Be.length>1,Xe={type:"list",raw:"",ordered:Ye,start:Ye?+Be.slice(0,-1):"",loose:!1,items:[]};Be=Ye?"\\d{1,9}\\"+Be.slice(-1):"\\"+Be,this.options.pedantic&&(Be=Ye?Be:"[*+-]");for(var ke=new RegExp("^( {0,3}"+Be+")((?:[	 ][^\\n]*)?(?:\\n|$))");ae&&(Ne=!1,!(!(le=ke.exec(ae))||this.rules.block.hr.test(ae)));){if(Q=le[0],ae=ae.substring(Q.length),ce=le[2].split(`
`,1)[0],Y=ae.split(`
`,1)[0],this.options.pedantic?(z=2,ge=ce.trimLeft()):(z=le[2].search(/[^ ]/),z=z>4?1:z,ge=ce.slice(z),z+=le[1].length),j=!1,!ce&&/^ *$/.test(Y)&&(Q+=Y+`
`,ae=ae.substring(Y.length+1),Ne=!0),!Ne)for(var nt=new RegExp("^ {0,"+Math.min(3,z-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),G=new RegExp("^ {0,"+Math.min(3,z-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),X=new RegExp("^ {0,"+Math.min(3,z-1)+"}(?:```|~~~)"),fe=new RegExp("^ {0,"+Math.min(3,z-1)+"}#");ae&&(pe=ae.split(`
`,1)[0],ce=pe,this.options.pedantic&&(ce=ce.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(X.test(ce)||fe.test(ce)||nt.test(ce)||G.test(ae)));){if(ce.search(/[^ ]/)>=z||!ce.trim())ge+=`
`+ce.slice(z);else if(!j)ge+=`
`+ce;else break;!j&&!ce.trim()&&(j=!0),Q+=pe+`
`,ae=ae.substring(pe.length+1)}Xe.loose||(se?Xe.loose=!0:/\n *\n *$/.test(Q)&&(se=!0)),this.options.gfm&&(J=/^\[[ xX]\] /.exec(ge),J&&(C=J[0]!=="[ ] ",ge=ge.replace(/^\[[ xX]\] +/,""))),Xe.items.push({type:"list_item",raw:Q,task:!!J,checked:C,loose:!1,text:ge}),Xe.raw+=Q}Xe.items[Xe.items.length-1].raw=Q.trimRight(),Xe.items[Xe.items.length-1].text=ge.trimRight(),Xe.raw=Xe.raw.trimRight();var Ue=Xe.items.length;for(H=0;H<Ue;H++){this.lexer.state.top=!1,Xe.items[H].tokens=this.lexer.blockTokens(Xe.items[H].text,[]);var We=Xe.items[H].tokens.filter(function(qe){return qe.type==="space"}),et=We.every(function(qe){for(var Ve=qe.raw.split(""),it=0,st=L(Ve),dt;!(dt=st()).done;){var at=dt.value;if(at===`
`&&(it+=1),it>1)return!0}return!1});!Xe.loose&&We.length&&et&&(Xe.loose=!0,Xe.items[H].loose=!0)}return Xe}},_e.html=function(ae){var le=this.rules.block.html.exec(ae);if(le){var Q={type:"html",raw:le[0],pre:!this.options.sanitizer&&(le[1]==="pre"||le[1]==="script"||le[1]==="style"),text:le[0]};if(this.options.sanitize){var J=this.options.sanitizer?this.options.sanitizer(le[0]):f(le[0]);Q.type="paragraph",Q.text=J,Q.tokens=this.lexer.inline(J)}return Q}},_e.def=function(ae){var le=this.rules.block.def.exec(ae);if(le){le[3]&&(le[3]=le[3].substring(1,le[3].length-1));var Q=le[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:Q,raw:le[0],href:le[2],title:le[3]}}},_e.table=function(ae){var le=this.rules.block.table.exec(ae);if(le){var Q={type:"table",header:g(le[1]).map(function(se){return{text:se}}),align:le[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:le[3]&&le[3].trim()?le[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(Q.header.length===Q.align.length){Q.raw=le[0];var J=Q.align.length,C,z,H,j;for(C=0;C<J;C++)/^ *-+: *$/.test(Q.align[C])?Q.align[C]="right":/^ *:-+: *$/.test(Q.align[C])?Q.align[C]="center":/^ *:-+ *$/.test(Q.align[C])?Q.align[C]="left":Q.align[C]=null;for(J=Q.rows.length,C=0;C<J;C++)Q.rows[C]=g(Q.rows[C],Q.header.length).map(function(se){return{text:se}});for(J=Q.header.length,z=0;z<J;z++)Q.header[z].tokens=this.lexer.inline(Q.header[z].text);for(J=Q.rows.length,z=0;z<J;z++)for(j=Q.rows[z],H=0;H<j.length;H++)j[H].tokens=this.lexer.inline(j[H].text);return Q}}},_e.lheading=function(ae){var le=this.rules.block.lheading.exec(ae);if(le)return{type:"heading",raw:le[0],depth:le[2].charAt(0)==="="?1:2,text:le[1],tokens:this.lexer.inline(le[1])}},_e.paragraph=function(ae){var le=this.rules.block.paragraph.exec(ae);if(le){var Q=le[1].charAt(le[1].length-1)===`
`?le[1].slice(0,-1):le[1];return{type:"paragraph",raw:le[0],text:Q,tokens:this.lexer.inline(Q)}}},_e.text=function(ae){var le=this.rules.block.text.exec(ae);if(le)return{type:"text",raw:le[0],text:le[0],tokens:this.lexer.inline(le[0])}},_e.escape=function(ae){var le=this.rules.inline.escape.exec(ae);if(le)return{type:"escape",raw:le[0],text:f(le[1])}},_e.tag=function(ae){var le=this.rules.inline.tag.exec(ae);if(le)return!this.lexer.state.inLink&&/^<a /i.test(le[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(le[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(le[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(le[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:le[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):f(le[0]):le[0]}},_e.link=function(ae){var le=this.rules.inline.link.exec(ae);if(le){var Q=le[2].trim();if(!this.options.pedantic&&/^</.test(Q)){if(!/>$/.test(Q))return;var J=p(Q.slice(0,-1),"\\");if((Q.length-J.length)%2===0)return}else{var C=P(le[2],"()");if(C>-1){var z=le[0].indexOf("!")===0?5:4,H=z+le[1].length+C;le[2]=le[2].substring(0,C),le[0]=le[0].substring(0,H).trim(),le[3]=""}}var j=le[2],se="";if(this.options.pedantic){var ce=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(j);ce&&(j=ce[1],se=ce[3])}else se=le[3]?le[3].slice(1,-1):"";return j=j.trim(),/^</.test(j)&&(this.options.pedantic&&!/>$/.test(Q)?j=j.slice(1):j=j.slice(1,-1)),B(le,{href:j&&j.replace(this.rules.inline._escapes,"$1"),title:se&&se.replace(this.rules.inline._escapes,"$1")},le[0],this.lexer)}},_e.reflink=function(ae,le){var Q;if((Q=this.rules.inline.reflink.exec(ae))||(Q=this.rules.inline.nolink.exec(ae))){var J=(Q[2]||Q[1]).replace(/\s+/g," ");if(J=le[J.toLowerCase()],!J||!J.href){var C=Q[0].charAt(0);return{type:"text",raw:C,text:C}}return B(Q,J,Q[0],this.lexer)}},_e.emStrong=function(ae,le,Q){Q===void 0&&(Q="");var J=this.rules.inline.emStrong.lDelim.exec(ae);if(!!J&&!(J[3]&&Q.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var C=J[1]||J[2]||"";if(!C||C&&(Q===""||this.rules.inline.punctuation.exec(Q))){var z=J[0].length-1,H,j,se=z,ce=0,Y=J[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Y.lastIndex=0,le=le.slice(-1*ae.length+z);(J=Y.exec(le))!=null;)if(H=J[1]||J[2]||J[3]||J[4]||J[5]||J[6],!!H){if(j=H.length,J[3]||J[4]){se+=j;continue}else if((J[5]||J[6])&&z%3&&!((z+j)%3)){ce+=j;continue}if(se-=j,!(se>0)){if(j=Math.min(j,j+se+ce),Math.min(z,j)%2){var pe=ae.slice(1,z+J.index+j);return{type:"em",raw:ae.slice(0,z+J.index+j+1),text:pe,tokens:this.lexer.inlineTokens(pe)}}var ge=ae.slice(2,z+J.index+j-1);return{type:"strong",raw:ae.slice(0,z+J.index+j+1),text:ge,tokens:this.lexer.inlineTokens(ge)}}}}}},_e.codespan=function(ae){var le=this.rules.inline.code.exec(ae);if(le){var Q=le[2].replace(/\n/g," "),J=/[^ ]/.test(Q),C=/^ /.test(Q)&&/ $/.test(Q);return J&&C&&(Q=Q.substring(1,Q.length-1)),Q=f(Q,!0),{type:"codespan",raw:le[0],text:Q}}},_e.br=function(ae){var le=this.rules.inline.br.exec(ae);if(le)return{type:"br",raw:le[0]}},_e.del=function(ae){var le=this.rules.inline.del.exec(ae);if(le)return{type:"del",raw:le[0],text:le[2],tokens:this.lexer.inlineTokens(le[2])}},_e.autolink=function(ae,le){var Q=this.rules.inline.autolink.exec(ae);if(Q){var J,C;return Q[2]==="@"?(J=f(this.options.mangle?le(Q[1]):Q[1]),C="mailto:"+J):(J=f(Q[1]),C=J),{type:"link",raw:Q[0],text:J,href:C,tokens:[{type:"text",raw:J,text:J}]}}},_e.url=function(ae,le){var Q;if(Q=this.rules.inline.url.exec(ae)){var J,C;if(Q[2]==="@")J=f(this.options.mangle?le(Q[0]):Q[0]),C="mailto:"+J;else{var z;do z=Q[0],Q[0]=this.rules.inline._backpedal.exec(Q[0])[0];while(z!==Q[0]);J=f(Q[0]),Q[1]==="www."?C="http://"+J:C=J}return{type:"link",raw:Q[0],text:J,href:C,tokens:[{type:"text",raw:J,text:J}]}}},_e.inlineText=function(ae,le){var Q=this.rules.inline.text.exec(ae);if(Q){var J;return this.lexer.state.inRawBlock?J=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Q[0]):f(Q[0]):Q[0]:J=f(this.options.smartypants?le(Q[0]):Q[0]),{type:"text",raw:Q[0],text:J}}},Te}(),U={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:a,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};U._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,U._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,U.def=v(U.def).replace("label",U._label).replace("title",U._title).getRegex(),U.bullet=/(?:[*+-]|\d{1,9}[.)])/,U.listItemStart=v(/^( *)(bull) */).replace("bull",U.bullet).getRegex(),U.list=v(U.list).replace(/bull/g,U.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+U.def.source+")").getRegex(),U._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",U._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,U.html=v(U.html,"i").replace("comment",U._comment).replace("tag",U._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),U.paragraph=v(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.blockquote=v(U.blockquote).replace("paragraph",U.paragraph).getRegex(),U.normal=o({},U),U.gfm=o({},U.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),U.gfm.table=v(U.gfm.table).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.gfm.paragraph=v(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",U.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.pedantic=o({},U.normal,{html:v(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",U._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:a,paragraph:v(U.normal._paragraph).replace("hr",U.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",U.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var R={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:a,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:a,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};R._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",R.punctuation=v(R.punctuation).replace(/punctuation/g,R._punctuation).getRegex(),R.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,R.escapedEmSt=/\\\*|\\_/g,R._comment=v(U._comment).replace("(?:-->|$)","-->").getRegex(),R.emStrong.lDelim=v(R.emStrong.lDelim).replace(/punct/g,R._punctuation).getRegex(),R.emStrong.rDelimAst=v(R.emStrong.rDelimAst,"g").replace(/punct/g,R._punctuation).getRegex(),R.emStrong.rDelimUnd=v(R.emStrong.rDelimUnd,"g").replace(/punct/g,R._punctuation).getRegex(),R._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,R._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,R._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,R.autolink=v(R.autolink).replace("scheme",R._scheme).replace("email",R._email).getRegex(),R._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,R.tag=v(R.tag).replace("comment",R._comment).replace("attribute",R._attribute).getRegex(),R._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,R._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,R._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,R.link=v(R.link).replace("label",R._label).replace("href",R._href).replace("title",R._title).getRegex(),R.reflink=v(R.reflink).replace("label",R._label).replace("ref",U._label).getRegex(),R.nolink=v(R.nolink).replace("ref",U._label).getRegex(),R.reflinkSearch=v(R.reflinkSearch,"g").replace("reflink",R.reflink).replace("nolink",R.nolink).getRegex(),R.normal=o({},R),R.pedantic=o({},R.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:v(/^!?\[(label)\]\((.*?)\)/).replace("label",R._label).getRegex(),reflink:v(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",R._label).getRegex()}),R.gfm=o({},R.normal,{escape:v(R.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),R.gfm.url=v(R.gfm.url,"i").replace("email",R.gfm._extended_email).getRegex(),R.breaks=o({},R.gfm,{br:v(R.br).replace("{2,}","*").getRegex(),text:v(R.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function K(Te){return Te.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function W(Te){var _e="",ye,ae,le=Te.length;for(ye=0;ye<le;ye++)ae=Te.charCodeAt(ye),Math.random()>.5&&(ae="x"+ae.toString(16)),_e+="&#"+ae+";";return _e}var O=function(){function Te(ye){this.tokens=[],this.tokens.links=Object.create(null),this.options=ye||te.defaults,this.options.tokenizer=this.options.tokenizer||new x,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ae={block:U.normal,inline:R.normal};this.options.pedantic?(ae.block=U.pedantic,ae.inline=R.pedantic):this.options.gfm&&(ae.block=U.gfm,this.options.breaks?ae.inline=R.breaks:ae.inline=R.gfm),this.tokenizer.rules=ae}Te.lex=function(ae,le){var Q=new Te(le);return Q.lex(ae)},Te.lexInline=function(ae,le){var Q=new Te(le);return Q.inlineTokens(ae)};var _e=Te.prototype;return _e.lex=function(ae){ae=ae.replace(/\r\n|\r/g,`
`),this.blockTokens(ae,this.tokens);for(var le;le=this.inlineQueue.shift();)this.inlineTokens(le.src,le.tokens);return this.tokens},_e.blockTokens=function(ae,le){var Q=this;le===void 0&&(le=[]),this.options.pedantic?ae=ae.replace(/\t/g,"    ").replace(/^ +$/gm,""):ae=ae.replace(/^( *)(\t+)/gm,function(se,ce,Y){return ce+"    ".repeat(Y.length)});for(var J,C,z,H;ae;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(se){return(J=se.call({lexer:Q},ae,le))?(ae=ae.substring(J.raw.length),le.push(J),!0):!1}))){if(J=this.tokenizer.space(ae)){ae=ae.substring(J.raw.length),J.raw.length===1&&le.length>0?le[le.length-1].raw+=`
`:le.push(J);continue}if(J=this.tokenizer.code(ae)){ae=ae.substring(J.raw.length),C=le[le.length-1],C&&(C.type==="paragraph"||C.type==="text")?(C.raw+=`
`+J.raw,C.text+=`
`+J.text,this.inlineQueue[this.inlineQueue.length-1].src=C.text):le.push(J);continue}if(J=this.tokenizer.fences(ae)){ae=ae.substring(J.raw.length),le.push(J);continue}if(J=this.tokenizer.heading(ae)){ae=ae.substring(J.raw.length),le.push(J);continue}if(J=this.tokenizer.hr(ae)){ae=ae.substring(J.raw.length),le.push(J);continue}if(J=this.tokenizer.blockquote(ae)){ae=ae.substring(J.raw.length),le.push(J);continue}if(J=this.tokenizer.list(ae)){ae=ae.substring(J.raw.length),le.push(J);continue}if(J=this.tokenizer.html(ae)){ae=ae.substring(J.raw.length),le.push(J);continue}if(J=this.tokenizer.def(ae)){ae=ae.substring(J.raw.length),C=le[le.length-1],C&&(C.type==="paragraph"||C.type==="text")?(C.raw+=`
`+J.raw,C.text+=`
`+J.raw,this.inlineQueue[this.inlineQueue.length-1].src=C.text):this.tokens.links[J.tag]||(this.tokens.links[J.tag]={href:J.href,title:J.title});continue}if(J=this.tokenizer.table(ae)){ae=ae.substring(J.raw.length),le.push(J);continue}if(J=this.tokenizer.lheading(ae)){ae=ae.substring(J.raw.length),le.push(J);continue}if(z=ae,this.options.extensions&&this.options.extensions.startBlock&&function(){var se=1/0,ce=ae.slice(1),Y=void 0;Q.options.extensions.startBlock.forEach(function(pe){Y=pe.call({lexer:this},ce),typeof Y=="number"&&Y>=0&&(se=Math.min(se,Y))}),se<1/0&&se>=0&&(z=ae.substring(0,se+1))}(),this.state.top&&(J=this.tokenizer.paragraph(z))){C=le[le.length-1],H&&C.type==="paragraph"?(C.raw+=`
`+J.raw,C.text+=`
`+J.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=C.text):le.push(J),H=z.length!==ae.length,ae=ae.substring(J.raw.length);continue}if(J=this.tokenizer.text(ae)){ae=ae.substring(J.raw.length),C=le[le.length-1],C&&C.type==="text"?(C.raw+=`
`+J.raw,C.text+=`
`+J.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=C.text):le.push(J);continue}if(ae){var j="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(j);break}else throw new Error(j)}}return this.state.top=!0,le},_e.inline=function(ae,le){return le===void 0&&(le=[]),this.inlineQueue.push({src:ae,tokens:le}),le},_e.inlineTokens=function(ae,le){var Q=this;le===void 0&&(le=[]);var J,C,z,H=ae,j,se,ce;if(this.tokens.links){var Y=Object.keys(this.tokens.links);if(Y.length>0)for(;(j=this.tokenizer.rules.inline.reflinkSearch.exec(H))!=null;)Y.includes(j[0].slice(j[0].lastIndexOf("[")+1,-1))&&(H=H.slice(0,j.index)+"["+V("a",j[0].length-2)+"]"+H.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(j=this.tokenizer.rules.inline.blockSkip.exec(H))!=null;)H=H.slice(0,j.index)+"["+V("a",j[0].length-2)+"]"+H.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(j=this.tokenizer.rules.inline.escapedEmSt.exec(H))!=null;)H=H.slice(0,j.index)+"++"+H.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ae;)if(se||(ce=""),se=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ge){return(J=ge.call({lexer:Q},ae,le))?(ae=ae.substring(J.raw.length),le.push(J),!0):!1}))){if(J=this.tokenizer.escape(ae)){ae=ae.substring(J.raw.length),le.push(J);continue}if(J=this.tokenizer.tag(ae)){ae=ae.substring(J.raw.length),C=le[le.length-1],C&&J.type==="text"&&C.type==="text"?(C.raw+=J.raw,C.text+=J.text):le.push(J);continue}if(J=this.tokenizer.link(ae)){ae=ae.substring(J.raw.length),le.push(J);continue}if(J=this.tokenizer.reflink(ae,this.tokens.links)){ae=ae.substring(J.raw.length),C=le[le.length-1],C&&J.type==="text"&&C.type==="text"?(C.raw+=J.raw,C.text+=J.text):le.push(J);continue}if(J=this.tokenizer.emStrong(ae,H,ce)){ae=ae.substring(J.raw.length),le.push(J);continue}if(J=this.tokenizer.codespan(ae)){ae=ae.substring(J.raw.length),le.push(J);continue}if(J=this.tokenizer.br(ae)){ae=ae.substring(J.raw.length),le.push(J);continue}if(J=this.tokenizer.del(ae)){ae=ae.substring(J.raw.length),le.push(J);continue}if(J=this.tokenizer.autolink(ae,W)){ae=ae.substring(J.raw.length),le.push(J);continue}if(!this.state.inLink&&(J=this.tokenizer.url(ae,W))){ae=ae.substring(J.raw.length),le.push(J);continue}if(z=ae,this.options.extensions&&this.options.extensions.startInline&&function(){var ge=1/0,Ne=ae.slice(1),Be=void 0;Q.options.extensions.startInline.forEach(function(Ye){Be=Ye.call({lexer:this},Ne),typeof Be=="number"&&Be>=0&&(ge=Math.min(ge,Be))}),ge<1/0&&ge>=0&&(z=ae.substring(0,ge+1))}(),J=this.tokenizer.inlineText(z,K)){ae=ae.substring(J.raw.length),J.raw.slice(-1)!=="_"&&(ce=J.raw.slice(-1)),se=!0,C=le[le.length-1],C&&C.type==="text"?(C.raw+=J.raw,C.text+=J.text):le.push(J);continue}if(ae){var pe="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(pe);break}else throw new Error(pe)}}return le},r(Te,null,[{key:"rules",get:function(){return{block:U,inline:R}}}]),Te}(),Z=function(){function Te(ye){this.options=ye||te.defaults}var _e=Te.prototype;return _e.code=function(ae,le,Q){var J=(le||"").match(/\S*/)[0];if(this.options.highlight){var C=this.options.highlight(ae,J);C!=null&&C!==ae&&(Q=!0,ae=C)}return ae=ae.replace(/\n$/,"")+`
`,J?'<pre><code class="'+this.options.langPrefix+f(J,!0)+'">'+(Q?ae:f(ae,!0))+`</code></pre>
`:"<pre><code>"+(Q?ae:f(ae,!0))+`</code></pre>
`},_e.blockquote=function(ae){return`<blockquote>
`+ae+`</blockquote>
`},_e.html=function(ae){return ae},_e.heading=function(ae,le,Q,J){if(this.options.headerIds){var C=this.options.headerPrefix+J.slug(Q);return"<h"+le+' id="'+C+'">'+ae+"</h"+le+`>
`}return"<h"+le+">"+ae+"</h"+le+`>
`},_e.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},_e.list=function(ae,le,Q){var J=le?"ol":"ul",C=le&&Q!==1?' start="'+Q+'"':"";return"<"+J+C+`>
`+ae+"</"+J+`>
`},_e.listitem=function(ae){return"<li>"+ae+`</li>
`},_e.checkbox=function(ae){return"<input "+(ae?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},_e.paragraph=function(ae){return"<p>"+ae+`</p>
`},_e.table=function(ae,le){return le&&(le="<tbody>"+le+"</tbody>"),`<table>
<thead>
`+ae+`</thead>
`+le+`</table>
`},_e.tablerow=function(ae){return`<tr>
`+ae+`</tr>
`},_e.tablecell=function(ae,le){var Q=le.header?"th":"td",J=le.align?"<"+Q+' align="'+le.align+'">':"<"+Q+">";return J+ae+("</"+Q+`>
`)},_e.strong=function(ae){return"<strong>"+ae+"</strong>"},_e.em=function(ae){return"<em>"+ae+"</em>"},_e.codespan=function(ae){return"<code>"+ae+"</code>"},_e.br=function(){return this.options.xhtml?"<br/>":"<br>"},_e.del=function(ae){return"<del>"+ae+"</del>"},_e.link=function(ae,le,Q){if(ae=b(this.options.sanitize,this.options.baseUrl,ae),ae===null)return Q;var J='<a href="'+f(ae)+'"';return le&&(J+=' title="'+le+'"'),J+=">"+Q+"</a>",J},_e.image=function(ae,le,Q){if(ae=b(this.options.sanitize,this.options.baseUrl,ae),ae===null)return Q;var J='<img src="'+ae+'" alt="'+Q+'"';return le&&(J+=' title="'+le+'"'),J+=this.options.xhtml?"/>":">",J},_e.text=function(ae){return ae},Te}(),ue=function(){function Te(){}var _e=Te.prototype;return _e.strong=function(ae){return ae},_e.em=function(ae){return ae},_e.codespan=function(ae){return ae},_e.del=function(ae){return ae},_e.html=function(ae){return ae},_e.text=function(ae){return ae},_e.link=function(ae,le,Q){return""+Q},_e.image=function(ae,le,Q){return""+Q},_e.br=function(){return""},Te}(),oe=function(){function Te(){this.seen={}}var _e=Te.prototype;return _e.serialize=function(ae){return ae.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},_e.getNextSafeSlug=function(ae,le){var Q=ae,J=0;if(this.seen.hasOwnProperty(Q)){J=this.seen[ae];do J++,Q=ae+"-"+J;while(this.seen.hasOwnProperty(Q))}return le||(this.seen[ae]=J,this.seen[Q]=0),Q},_e.slug=function(ae,le){le===void 0&&(le={});var Q=this.serialize(ae);return this.getNextSafeSlug(Q,le.dryrun)},Te}(),de=function(){function Te(ye){this.options=ye||te.defaults,this.options.renderer=this.options.renderer||new Z,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ue,this.slugger=new oe}Te.parse=function(ae,le){var Q=new Te(le);return Q.parse(ae)},Te.parseInline=function(ae,le){var Q=new Te(le);return Q.parseInline(ae)};var _e=Te.prototype;return _e.parse=function(ae,le){le===void 0&&(le=!0);var Q="",J,C,z,H,j,se,ce,Y,pe,ge,Ne,Be,Ye,Xe,ke,nt,G,X,fe,Ue=ae.length;for(J=0;J<Ue;J++){if(ge=ae[J],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ge.type]&&(fe=this.options.extensions.renderers[ge.type].call({parser:this},ge),fe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ge.type))){Q+=fe||"";continue}switch(ge.type){case"space":continue;case"hr":{Q+=this.renderer.hr();continue}case"heading":{Q+=this.renderer.heading(this.parseInline(ge.tokens),ge.depth,h(this.parseInline(ge.tokens,this.textRenderer)),this.slugger);continue}case"code":{Q+=this.renderer.code(ge.text,ge.lang,ge.escaped);continue}case"table":{for(Y="",ce="",H=ge.header.length,C=0;C<H;C++)ce+=this.renderer.tablecell(this.parseInline(ge.header[C].tokens),{header:!0,align:ge.align[C]});for(Y+=this.renderer.tablerow(ce),pe="",H=ge.rows.length,C=0;C<H;C++){for(se=ge.rows[C],ce="",j=se.length,z=0;z<j;z++)ce+=this.renderer.tablecell(this.parseInline(se[z].tokens),{header:!1,align:ge.align[z]});pe+=this.renderer.tablerow(ce)}Q+=this.renderer.table(Y,pe);continue}case"blockquote":{pe=this.parse(ge.tokens),Q+=this.renderer.blockquote(pe);continue}case"list":{for(Ne=ge.ordered,Be=ge.start,Ye=ge.loose,H=ge.items.length,pe="",C=0;C<H;C++)ke=ge.items[C],nt=ke.checked,G=ke.task,Xe="",ke.task&&(X=this.renderer.checkbox(nt),Ye?ke.tokens.length>0&&ke.tokens[0].type==="paragraph"?(ke.tokens[0].text=X+" "+ke.tokens[0].text,ke.tokens[0].tokens&&ke.tokens[0].tokens.length>0&&ke.tokens[0].tokens[0].type==="text"&&(ke.tokens[0].tokens[0].text=X+" "+ke.tokens[0].tokens[0].text)):ke.tokens.unshift({type:"text",text:X}):Xe+=X),Xe+=this.parse(ke.tokens,Ye),pe+=this.renderer.listitem(Xe,G,nt);Q+=this.renderer.list(pe,Ne,Be);continue}case"html":{Q+=this.renderer.html(ge.text);continue}case"paragraph":{Q+=this.renderer.paragraph(this.parseInline(ge.tokens));continue}case"text":{for(pe=ge.tokens?this.parseInline(ge.tokens):ge.text;J+1<Ue&&ae[J+1].type==="text";)ge=ae[++J],pe+=`
`+(ge.tokens?this.parseInline(ge.tokens):ge.text);Q+=le?this.renderer.paragraph(pe):pe;continue}default:{var We='Token with "'+ge.type+'" type was not found.';if(this.options.silent){console.error(We);return}else throw new Error(We)}}}return Q},_e.parseInline=function(ae,le){le=le||this.renderer;var Q="",J,C,z,H=ae.length;for(J=0;J<H;J++){if(C=ae[J],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[C.type]&&(z=this.options.extensions.renderers[C.type].call({parser:this},C),z!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(C.type))){Q+=z||"";continue}switch(C.type){case"escape":{Q+=le.text(C.text);break}case"html":{Q+=le.html(C.text);break}case"link":{Q+=le.link(C.href,C.title,this.parseInline(C.tokens,le));break}case"image":{Q+=le.image(C.href,C.title,C.text);break}case"strong":{Q+=le.strong(this.parseInline(C.tokens,le));break}case"em":{Q+=le.em(this.parseInline(C.tokens,le));break}case"codespan":{Q+=le.codespan(C.text);break}case"br":{Q+=le.br();break}case"del":{Q+=le.del(this.parseInline(C.tokens,le));break}case"text":{Q+=le.text(C.text);break}default:{var j='Token with "'+C.type+'" type was not found.';if(this.options.silent){console.error(j);return}else throw new Error(j)}}}return Q},Te}();function ie(Te,_e,ye){if(typeof Te>"u"||Te===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");if(typeof _e=="function"&&(ye=_e,_e=null),_e=o({},ie.defaults,_e||{}),M(_e),ye){var ae=_e.highlight,le;try{le=O.lex(Te,_e)}catch(H){return ye(H)}var Q=function(j){var se;if(!j)try{_e.walkTokens&&ie.walkTokens(le,_e.walkTokens),se=de.parse(le,_e)}catch(ce){j=ce}return _e.highlight=ae,j?ye(j):ye(null,se)};if(!ae||ae.length<3||(delete _e.highlight,!le.length))return Q();var J=0;ie.walkTokens(le,function(H){H.type==="code"&&(J++,setTimeout(function(){ae(H.text,H.lang,function(j,se){if(j)return Q(j);se!=null&&se!==H.text&&(H.text=se,H.escaped=!0),J--,J===0&&Q()})},0))}),J===0&&Q();return}function C(H){if(H.message+=`
Please report this to https://github.com/markedjs/marked.`,_e.silent)return"<p>An error occurred:</p><pre>"+f(H.message+"",!0)+"</pre>";throw H}try{var z=O.lex(Te,_e);if(_e.walkTokens){if(_e.async)return Promise.all(ie.walkTokens(z,_e.walkTokens)).then(function(){return de.parse(z,_e)}).catch(C);ie.walkTokens(z,_e.walkTokens)}return de.parse(z,_e)}catch(H){C(H)}}ie.options=ie.setOptions=function(Te){return o(ie.defaults,Te),A(ie.defaults),ie},ie.getDefaults=_,ie.defaults=te.defaults,ie.use=function(){for(var Te=arguments.length,_e=new Array(Te),ye=0;ye<Te;ye++)_e[ye]=arguments[ye];var ae=o.apply(void 0,[{}].concat(_e)),le=ie.defaults.extensions||{renderers:{},childTokens:{}},Q;_e.forEach(function(J){if(J.extensions&&(Q=!0,J.extensions.forEach(function(z){if(!z.name)throw new Error("extension name required");if(z.renderer){var H=le.renderers?le.renderers[z.name]:null;H?le.renderers[z.name]=function(){for(var j=arguments.length,se=new Array(j),ce=0;ce<j;ce++)se[ce]=arguments[ce];var Y=z.renderer.apply(this,se);return Y===!1&&(Y=H.apply(this,se)),Y}:le.renderers[z.name]=z.renderer}if(z.tokenizer){if(!z.level||z.level!=="block"&&z.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");le[z.level]?le[z.level].unshift(z.tokenizer):le[z.level]=[z.tokenizer],z.start&&(z.level==="block"?le.startBlock?le.startBlock.push(z.start):le.startBlock=[z.start]:z.level==="inline"&&(le.startInline?le.startInline.push(z.start):le.startInline=[z.start]))}z.childTokens&&(le.childTokens[z.name]=z.childTokens)})),J.renderer&&function(){var z=ie.defaults.renderer||new Z,H=function(ce){var Y=z[ce];z[ce]=function(){for(var pe=arguments.length,ge=new Array(pe),Ne=0;Ne<pe;Ne++)ge[Ne]=arguments[Ne];var Be=J.renderer[ce].apply(z,ge);return Be===!1&&(Be=Y.apply(z,ge)),Be}};for(var j in J.renderer)H(j);ae.renderer=z}(),J.tokenizer&&function(){var z=ie.defaults.tokenizer||new x,H=function(ce){var Y=z[ce];z[ce]=function(){for(var pe=arguments.length,ge=new Array(pe),Ne=0;Ne<pe;Ne++)ge[Ne]=arguments[Ne];var Be=J.tokenizer[ce].apply(z,ge);return Be===!1&&(Be=Y.apply(z,ge)),Be}};for(var j in J.tokenizer)H(j);ae.tokenizer=z}(),J.walkTokens){var C=ie.defaults.walkTokens;ae.walkTokens=function(z){var H=[];return H.push(J.walkTokens.call(this,z)),C&&(H=H.concat(C.call(this,z))),H}}Q&&(ae.extensions=le),ie.setOptions(ae)})},ie.walkTokens=function(Te,_e){for(var ye=[],ae=function(){var C=Q.value;switch(ye=ye.concat(_e.call(ie,C)),C.type){case"table":{for(var z=L(C.header),H;!(H=z()).done;){var j=H.value;ye=ye.concat(ie.walkTokens(j.tokens,_e))}for(var se=L(C.rows),ce;!(ce=se()).done;)for(var Y=ce.value,pe=L(Y),ge;!(ge=pe()).done;){var Ne=ge.value;ye=ye.concat(ie.walkTokens(Ne.tokens,_e))}break}case"list":{ye=ye.concat(ie.walkTokens(C.items,_e));break}default:ie.defaults.extensions&&ie.defaults.extensions.childTokens&&ie.defaults.extensions.childTokens[C.type]?ie.defaults.extensions.childTokens[C.type].forEach(function(Be){ye=ye.concat(ie.walkTokens(C[Be],_e))}):C.tokens&&(ye=ye.concat(ie.walkTokens(C.tokens,_e)))}},le=L(Te),Q;!(Q=le()).done;)ae();return ye},ie.parseInline=function(Te,_e){if(typeof Te>"u"||Te===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");_e=o({},ie.defaults,_e||{}),M(_e);try{var ye=O.lexInline(Te,_e);return _e.walkTokens&&ie.walkTokens(ye,_e.walkTokens),de.parseInline(ye,_e)}catch(ae){if(ae.message+=`
Please report this to https://github.com/markedjs/marked.`,_e.silent)return"<p>An error occurred:</p><pre>"+f(ae.message+"",!0)+"</pre>";throw ae}},ie.Parser=de,ie.parser=de.parse,ie.Renderer=Z,ie.TextRenderer=ue,ie.Lexer=O,ie.lexer=O.lex,ie.Tokenizer=x,ie.Slugger=oe,ie.parse=ie;var ve=ie.options,be=ie.setOptions,ne=ie.use,Ee=ie.walkTokens,Pe=ie.parseInline,Fe=ie,$e=de.parse,Qe=O.lex;te.Lexer=O,te.Parser=de,te.Renderer=Z,te.Slugger=oe,te.TextRenderer=ue,te.Tokenizer=x,te.getDefaults=_,te.lexer=Qe,te.marked=ie,te.options=ve,te.parse=Fe,te.parseInline=Pe,te.parser=$e,te.setOptions=be,te.use=ne,te.walkTokens=Ee,Object.defineProperty(te,"__esModule",{value:!0})}),define(Ce[107],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function r(A,E,k){return Math.min(Math.max(A,E),k)}e.clamp=r;function y(A,E){return(E+A%E)%E}e.rot=y;class w{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=w;class L{constructor(){this._n=1,this._val=0}update(E){return this._val=this._val+(E-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=L;class _{constructor(E){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(E),this._values.fill(0,0,E)}update(E){const k=this._values[this._index];return this._values[this._index]=E,this._index=(this._index+1)%this._values.length,this._sum-=k,this._sum+=E,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=_}),function(){function te(w){const L=[];typeof w=="number"&&L.push("code/timeOrigin",w);function _(E){L.push(E,Date.now())}function A(){const E=[];for(let k=0;k<L.length;k+=2)E.push({name:L[k],startTime:L[k+1]});return E}return{mark:_,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(w){performance.mark(w)},getMarks(){let w=performance.timeOrigin;typeof w!="number"&&(w=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(w)}];for(const _ of performance.getEntriesByType("mark"))L.push({name:_.name,startTime:Math.round(w+_.startTime)});return L}};if(typeof process=="object"){const w=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(w)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function r(w){return w.MonacoPerformanceMarks||(w.MonacoPerformanceMarks=e()),w.MonacoPerformanceMarks}var y;typeof global=="object"?y=global:typeof self=="object"?y=self:y={},typeof define=="function"?define("vs/base/common/performance",[],function(){return r(y)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=r(y):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),y.perf=r(y))}(),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var r=e();for(var y in r)(typeof exports=="object"?exports:te)[y]=r[y]}}(typeof self<"u"?self:this,function(){return function(te){var e={};function r(y){if(e[y])return e[y].exports;var w=e[y]={i:y,l:!1,exports:{}};return te[y].call(w.exports,w,w.exports,r),w.l=!0,w.exports}return r.m=te,r.c=e,r.d=function(y,w,L){r.o(y,w)||Object.defineProperty(y,w,{enumerable:!0,get:L})},r.r=function(y){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(y,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(y,"__esModule",{value:!0})},r.t=function(y,w){if(1&w&&(y=r(y)),8&w||4&w&&typeof y=="object"&&y&&y.__esModule)return y;var L=Object.create(null);if(r.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:y}),2&w&&typeof y!="string")for(var _ in y)r.d(L,_,function(A){return y[A]}.bind(null,_));return L},r.n=function(y){var w=y&&y.__esModule?function(){return y.default}:function(){return y};return r.d(w,"a",w),w},r.o=function(y,w){return Object.prototype.hasOwnProperty.call(y,w)},r.p="",r(r.s=0)}([function(te,e,r){(function(y){var w;e=te.exports=ne,w=typeof y=="object"&&y.env&&y.env.NODE_DEBUG&&/\bsemver\b/i.test(y.env.NODE_DEBUG)?function(){var Y=Array.prototype.slice.call(arguments,0);Y.unshift("SEMVER"),console.log.apply(console,Y)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,_=Number.MAX_SAFE_INTEGER||9007199254740991,A=e.re=[],E=e.src=[],k=0,F=k++;E[F]="0|[1-9]\\d*";var S=k++;E[S]="[0-9]+";var m=k++;E[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var T=k++;E[T]="("+E[F]+")\\.("+E[F]+")\\.("+E[F]+")";var f=k++;E[f]="("+E[S]+")\\.("+E[S]+")\\.("+E[S]+")";var c=k++;E[c]="(?:"+E[F]+"|"+E[m]+")";var h=k++;E[h]="(?:"+E[S]+"|"+E[m]+")";var u=k++;E[u]="(?:-("+E[c]+"(?:\\."+E[c]+")*))";var v=k++;E[v]="(?:-?("+E[h]+"(?:\\."+E[h]+")*))";var I=k++;E[I]="[0-9A-Za-z-]+";var l=k++;E[l]="(?:\\+("+E[I]+"(?:\\."+E[I]+")*))";var b=k++,t="v?"+E[T]+E[u]+"?"+E[l]+"?";E[b]="^"+t+"$";var d="[v=\\s]*"+E[f]+E[v]+"?"+E[l]+"?",n=k++;E[n]="^"+d+"$";var i=k++;E[i]="((?:<|>)?=?)";var s=k++;E[s]=E[S]+"|x|X|\\*";var a=k++;E[a]=E[F]+"|x|X|\\*";var o=k++;E[o]="[v=\\s]*("+E[a]+")(?:\\.("+E[a]+")(?:\\.("+E[a]+")(?:"+E[u]+")?"+E[l]+"?)?)?";var g=k++;E[g]="[v=\\s]*("+E[s]+")(?:\\.("+E[s]+")(?:\\.("+E[s]+")(?:"+E[v]+")?"+E[l]+"?)?)?";var p=k++;E[p]="^"+E[i]+"\\s*"+E[o]+"$";var P=k++;E[P]="^"+E[i]+"\\s*"+E[g]+"$";var M=k++;E[M]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var V=k++;E[V]="(?:~>?)";var B=k++;E[B]="(\\s*)"+E[V]+"\\s+",A[B]=new RegExp(E[B],"g");var D=k++;E[D]="^"+E[V]+E[o]+"$";var x=k++;E[x]="^"+E[V]+E[g]+"$";var U=k++;E[U]="(?:\\^)";var R=k++;E[R]="(\\s*)"+E[U]+"\\s+",A[R]=new RegExp(E[R],"g");var K=k++;E[K]="^"+E[U]+E[o]+"$";var W=k++;E[W]="^"+E[U]+E[g]+"$";var O=k++;E[O]="^"+E[i]+"\\s*("+d+")$|^$";var Z=k++;E[Z]="^"+E[i]+"\\s*("+t+")$|^$";var ue=k++;E[ue]="(\\s*)"+E[i]+"\\s*("+d+"|"+E[o]+")",A[ue]=new RegExp(E[ue],"g");var oe=k++;E[oe]="^\\s*("+E[o]+")\\s+-\\s+("+E[o]+")\\s*$";var de=k++;E[de]="^\\s*("+E[g]+")\\s+-\\s+("+E[g]+")\\s*$";var ie=k++;E[ie]="(<|>)?=?\\s*\\*";for(var ve=0;ve<35;ve++)w(ve,E[ve]),A[ve]||(A[ve]=new RegExp(E[ve]));function be(Y,pe){if(Y instanceof ne)return Y;if(typeof Y!="string"||Y.length>L||!(pe?A[n]:A[b]).test(Y))return null;try{return new ne(Y,pe)}catch{return null}}function ne(Y,pe){if(Y instanceof ne){if(Y.loose===pe)return Y;Y=Y.version}else if(typeof Y!="string")throw new TypeError("Invalid Version: "+Y);if(Y.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof ne))return new ne(Y,pe);w("SemVer",Y,pe),this.loose=pe;var ge=Y.trim().match(pe?A[n]:A[b]);if(!ge)throw new TypeError("Invalid Version: "+Y);if(this.raw=Y,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>_||this.major<0)throw new TypeError("Invalid major version");if(this.minor>_||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>_||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Ne){if(/^[0-9]+$/.test(Ne)){var Be=+Ne;if(Be>=0&&Be<_)return Be}return Ne}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=be,e.valid=function(Y,pe){var ge=be(Y,pe);return ge?ge.version:null},e.clean=function(Y,pe){var ge=be(Y.trim().replace(/^[=v]+/,""),pe);return ge?ge.version:null},e.SemVer=ne,ne.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ne.prototype.toString=function(){return this.version},ne.prototype.compare=function(Y){return w("SemVer.compare",this.version,this.loose,Y),Y instanceof ne||(Y=new ne(Y,this.loose)),this.compareMain(Y)||this.comparePre(Y)},ne.prototype.compareMain=function(Y){return Y instanceof ne||(Y=new ne(Y,this.loose)),Pe(this.major,Y.major)||Pe(this.minor,Y.minor)||Pe(this.patch,Y.patch)},ne.prototype.comparePre=function(Y){if(Y instanceof ne||(Y=new ne(Y,this.loose)),this.prerelease.length&&!Y.prerelease.length)return-1;if(!this.prerelease.length&&Y.prerelease.length)return 1;if(!this.prerelease.length&&!Y.prerelease.length)return 0;var pe=0;do{var ge=this.prerelease[pe],Ne=Y.prerelease[pe];if(w("prerelease compare",pe,ge,Ne),ge===void 0&&Ne===void 0)return 0;if(Ne===void 0)return 1;if(ge===void 0)return-1;if(ge!==Ne)return Pe(ge,Ne)}while(++pe)},ne.prototype.inc=function(Y,pe){switch(Y){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",pe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",pe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",pe),this.inc("pre",pe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",pe),this.inc("pre",pe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}pe&&(this.prerelease[0]===pe?isNaN(this.prerelease[1])&&(this.prerelease=[pe,0]):this.prerelease=[pe,0]);break;default:throw new Error("invalid increment argument: "+Y)}return this.format(),this.raw=this.version,this},e.inc=function(Y,pe,ge,Ne){typeof ge=="string"&&(Ne=ge,ge=void 0);try{return new ne(Y,ge).inc(pe,Ne).version}catch{return null}},e.diff=function(Y,pe){if(Te(Y,pe))return null;var ge=be(Y),Ne=be(pe);if(ge.prerelease.length||Ne.prerelease.length){for(var Be in ge)if((Be==="major"||Be==="minor"||Be==="patch")&&ge[Be]!==Ne[Be])return"pre"+Be;return"prerelease"}for(var Be in ge)if((Be==="major"||Be==="minor"||Be==="patch")&&ge[Be]!==Ne[Be])return Be},e.compareIdentifiers=Pe;var Ee=/^[0-9]+$/;function Pe(Y,pe){var ge=Ee.test(Y),Ne=Ee.test(pe);return ge&&Ne&&(Y=+Y,pe=+pe),ge&&!Ne?-1:Ne&&!ge?1:Y<pe?-1:Y>pe?1:0}function Fe(Y,pe,ge){return new ne(Y,ge).compare(new ne(pe,ge))}function $e(Y,pe,ge){return Fe(Y,pe,ge)>0}function Qe(Y,pe,ge){return Fe(Y,pe,ge)<0}function Te(Y,pe,ge){return Fe(Y,pe,ge)===0}function _e(Y,pe,ge){return Fe(Y,pe,ge)!==0}function ye(Y,pe,ge){return Fe(Y,pe,ge)>=0}function ae(Y,pe,ge){return Fe(Y,pe,ge)<=0}function le(Y,pe,ge,Ne){var Be;switch(pe){case"===":typeof Y=="object"&&(Y=Y.version),typeof ge=="object"&&(ge=ge.version),Be=Y===ge;break;case"!==":typeof Y=="object"&&(Y=Y.version),typeof ge=="object"&&(ge=ge.version),Be=Y!==ge;break;case"":case"=":case"==":Be=Te(Y,ge,Ne);break;case"!=":Be=_e(Y,ge,Ne);break;case">":Be=$e(Y,ge,Ne);break;case">=":Be=ye(Y,ge,Ne);break;case"<":Be=Qe(Y,ge,Ne);break;case"<=":Be=ae(Y,ge,Ne);break;default:throw new TypeError("Invalid operator: "+pe)}return Be}function Q(Y,pe){if(Y instanceof Q){if(Y.loose===pe)return Y;Y=Y.value}if(!(this instanceof Q))return new Q(Y,pe);w("comparator",Y,pe),this.loose=pe,this.parse(Y),this.semver===J?this.value="":this.value=this.operator+this.semver.version,w("comp",this)}e.rcompareIdentifiers=function(Y,pe){return Pe(pe,Y)},e.major=function(Y,pe){return new ne(Y,pe).major},e.minor=function(Y,pe){return new ne(Y,pe).minor},e.patch=function(Y,pe){return new ne(Y,pe).patch},e.compare=Fe,e.compareLoose=function(Y,pe){return Fe(Y,pe,!0)},e.rcompare=function(Y,pe,ge){return Fe(pe,Y,ge)},e.sort=function(Y,pe){return Y.sort(function(ge,Ne){return e.compare(ge,Ne,pe)})},e.rsort=function(Y,pe){return Y.sort(function(ge,Ne){return e.rcompare(ge,Ne,pe)})},e.gt=$e,e.lt=Qe,e.eq=Te,e.neq=_e,e.gte=ye,e.lte=ae,e.cmp=le,e.Comparator=Q;var J={};function C(Y,pe){if(Y instanceof C)return Y.loose===pe?Y:new C(Y.raw,pe);if(Y instanceof Q)return new C(Y.value,pe);if(!(this instanceof C))return new C(Y,pe);if(this.loose=pe,this.raw=Y,this.set=Y.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Y);this.format()}function z(Y){return!Y||Y.toLowerCase()==="x"||Y==="*"}function H(Y,pe,ge,Ne,Be,Ye,Xe,ke,nt,G,X,fe,Ue){return((pe=z(ge)?"":z(Ne)?">="+ge+".0.0":z(Be)?">="+ge+"."+Ne+".0":">="+pe)+" "+(ke=z(nt)?"":z(G)?"<"+(+nt+1)+".0.0":z(X)?"<"+nt+"."+(+G+1)+".0":fe?"<="+nt+"."+G+"."+X+"-"+fe:"<="+ke)).trim()}function j(Y,pe){for(var ge=0;ge<Y.length;ge++)if(!Y[ge].test(pe))return!1;if(pe.prerelease.length){for(ge=0;ge<Y.length;ge++)if(w(Y[ge].semver),Y[ge].semver!==J&&Y[ge].semver.prerelease.length>0){var Ne=Y[ge].semver;if(Ne.major===pe.major&&Ne.minor===pe.minor&&Ne.patch===pe.patch)return!0}return!1}return!0}function se(Y,pe,ge){try{pe=new C(pe,ge)}catch{return!1}return pe.test(Y)}function ce(Y,pe,ge,Ne){var Be,Ye,Xe,ke,nt;switch(Y=new ne(Y,Ne),pe=new C(pe,Ne),ge){case">":Be=$e,Ye=ae,Xe=Qe,ke=">",nt=">=";break;case"<":Be=Qe,Ye=ye,Xe=$e,ke="<",nt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(se(Y,pe,Ne))return!1;for(var G=0;G<pe.set.length;++G){var X=pe.set[G],fe=null,Ue=null;if(X.forEach(function(We){We.semver===J&&(We=new Q(">=0.0.0")),fe=fe||We,Ue=Ue||We,Be(We.semver,fe.semver,Ne)?fe=We:Xe(We.semver,Ue.semver,Ne)&&(Ue=We)}),fe.operator===ke||fe.operator===nt||(!Ue.operator||Ue.operator===ke)&&Ye(Y,Ue.semver)||Ue.operator===nt&&Xe(Y,Ue.semver))return!1}return!0}Q.prototype.parse=function(Y){var pe=this.loose?A[O]:A[Z],ge=Y.match(pe);if(!ge)throw new TypeError("Invalid comparator: "+Y);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new ne(ge[2],this.loose):this.semver=J},Q.prototype.toString=function(){return this.value},Q.prototype.test=function(Y){return w("Comparator.test",Y,this.loose),this.semver===J||(typeof Y=="string"&&(Y=new ne(Y,this.loose)),le(Y,this.operator,this.semver,this.loose))},Q.prototype.intersects=function(Y,pe){if(!(Y instanceof Q))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new C(Y.value,pe),se(this.value,ge,pe);if(Y.operator==="")return ge=new C(this.value,pe),se(Y.semver,ge,pe);var Ne=!(this.operator!==">="&&this.operator!==">"||Y.operator!==">="&&Y.operator!==">"),Be=!(this.operator!=="<="&&this.operator!=="<"||Y.operator!=="<="&&Y.operator!=="<"),Ye=this.semver.version===Y.semver.version,Xe=!(this.operator!==">="&&this.operator!=="<="||Y.operator!==">="&&Y.operator!=="<="),ke=le(this.semver,"<",Y.semver,pe)&&(this.operator===">="||this.operator===">")&&(Y.operator==="<="||Y.operator==="<"),nt=le(this.semver,">",Y.semver,pe)&&(this.operator==="<="||this.operator==="<")&&(Y.operator===">="||Y.operator===">");return Ne||Be||Ye&&Xe||ke||nt},e.Range=C,C.prototype.format=function(){return this.range=this.set.map(function(Y){return Y.join(" ").trim()}).join("||").trim(),this.range},C.prototype.toString=function(){return this.range},C.prototype.parseRange=function(Y){var pe=this.loose;Y=Y.trim(),w("range",Y,pe);var ge=pe?A[de]:A[oe];Y=Y.replace(ge,H),w("hyphen replace",Y),Y=Y.replace(A[ue],"$1$2$3"),w("comparator trim",Y,A[ue]),Y=(Y=(Y=Y.replace(A[B],"$1~")).replace(A[R],"$1^")).split(/\s+/).join(" ");var Ne=pe?A[O]:A[Z],Be=Y.split(" ").map(function(Ye){return function(Xe,ke){return w("comp",Xe),Xe=function(nt,G){return nt.trim().split(/\s+/).map(function(X){return function(fe,Ue){w("caret",fe,Ue);var We=Ue?A[W]:A[K];return fe.replace(We,function(et,qe,Ve,it,st){var dt;return w("caret",fe,et,qe,Ve,it,st),z(qe)?dt="":z(Ve)?dt=">="+qe+".0.0 <"+(+qe+1)+".0.0":z(it)?dt=qe==="0"?">="+qe+"."+Ve+".0 <"+qe+"."+(+Ve+1)+".0":">="+qe+"."+Ve+".0 <"+(+qe+1)+".0.0":st?(w("replaceCaret pr",st),st.charAt(0)!=="-"&&(st="-"+st),dt=qe==="0"?Ve==="0"?">="+qe+"."+Ve+"."+it+st+" <"+qe+"."+Ve+"."+(+it+1):">="+qe+"."+Ve+"."+it+st+" <"+qe+"."+(+Ve+1)+".0":">="+qe+"."+Ve+"."+it+st+" <"+(+qe+1)+".0.0"):(w("no pr"),dt=qe==="0"?Ve==="0"?">="+qe+"."+Ve+"."+it+" <"+qe+"."+Ve+"."+(+it+1):">="+qe+"."+Ve+"."+it+" <"+qe+"."+(+Ve+1)+".0":">="+qe+"."+Ve+"."+it+" <"+(+qe+1)+".0.0"),w("caret return",dt),dt})}(X,G)}).join(" ")}(Xe,ke),w("caret",Xe),Xe=function(nt,G){return nt.trim().split(/\s+/).map(function(X){return function(fe,Ue){var We=Ue?A[x]:A[D];return fe.replace(We,function(et,qe,Ve,it,st){var dt;return w("tilde",fe,et,qe,Ve,it,st),z(qe)?dt="":z(Ve)?dt=">="+qe+".0.0 <"+(+qe+1)+".0.0":z(it)?dt=">="+qe+"."+Ve+".0 <"+qe+"."+(+Ve+1)+".0":st?(w("replaceTilde pr",st),st.charAt(0)!=="-"&&(st="-"+st),dt=">="+qe+"."+Ve+"."+it+st+" <"+qe+"."+(+Ve+1)+".0"):dt=">="+qe+"."+Ve+"."+it+" <"+qe+"."+(+Ve+1)+".0",w("tilde return",dt),dt})}(X,G)}).join(" ")}(Xe,ke),w("tildes",Xe),Xe=function(nt,G){return w("replaceXRanges",nt,G),nt.split(/\s+/).map(function(X){return function(fe,Ue){fe=fe.trim();var We=Ue?A[P]:A[p];return fe.replace(We,function(et,qe,Ve,it,st,dt){w("xRange",fe,et,qe,Ve,it,st,dt);var at=z(Ve),rt=at||z(it),_t=rt||z(st);return qe==="="&&_t&&(qe=""),at?et=qe===">"||qe==="<"?"<0.0.0":"*":qe&&_t?(rt&&(it=0),_t&&(st=0),qe===">"?(qe=">=",rt?(Ve=+Ve+1,it=0,st=0):_t&&(it=+it+1,st=0)):qe==="<="&&(qe="<",rt?Ve=+Ve+1:it=+it+1),et=qe+Ve+"."+it+"."+st):rt?et=">="+Ve+".0.0 <"+(+Ve+1)+".0.0":_t&&(et=">="+Ve+"."+it+".0 <"+Ve+"."+(+it+1)+".0"),w("xRange return",et),et})}(X,G)}).join(" ")}(Xe,ke),w("xrange",Xe),Xe=function(nt,G){return w("replaceStars",nt,G),nt.trim().replace(A[ie],"")}(Xe,ke),w("stars",Xe),Xe}(Ye,pe)}).join(" ").split(/\s+/);return this.loose&&(Be=Be.filter(function(Ye){return!!Ye.match(Ne)})),Be=Be.map(function(Ye){return new Q(Ye,pe)})},C.prototype.intersects=function(Y,pe){if(!(Y instanceof C))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Ne){return Y.set.some(function(Be){return Be.every(function(Ye){return Ne.intersects(Ye,pe)})})})})},e.toComparators=function(Y,pe){return new C(Y,pe).set.map(function(ge){return ge.map(function(Ne){return Ne.value}).join(" ").trim().split(" ")})},C.prototype.test=function(Y){if(!Y)return!1;typeof Y=="string"&&(Y=new ne(Y,this.loose));for(var pe=0;pe<this.set.length;pe++)if(j(this.set[pe],Y))return!0;return!1},e.satisfies=se,e.maxSatisfying=function(Y,pe,ge){var Ne=null,Be=null;try{var Ye=new C(pe,ge)}catch{return null}return Y.forEach(function(Xe){Ye.test(Xe)&&(Ne&&Be.compare(Xe)!==-1||(Be=new ne(Ne=Xe,ge)))}),Ne},e.minSatisfying=function(Y,pe,ge){var Ne=null,Be=null;try{var Ye=new C(pe,ge)}catch{return null}return Y.forEach(function(Xe){Ye.test(Xe)&&(Ne&&Be.compare(Xe)!==1||(Be=new ne(Ne=Xe,ge)))}),Ne},e.validRange=function(Y,pe){try{return new C(Y,pe).range||"*"}catch{return null}},e.ltr=function(Y,pe,ge){return ce(Y,pe,"<",ge)},e.gtr=function(Y,pe,ge){return ce(Y,pe,">",ge)},e.outside=ce,e.prerelease=function(Y,pe){var ge=be(Y,pe);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(Y,pe,ge){return Y=new C(Y,ge),pe=new C(pe,ge),Y.intersects(pe)},e.coerce=function(Y){if(Y instanceof ne)return Y;if(typeof Y!="string")return null;var pe=Y.match(A[M]);return pe==null?null:be((pe[1]||"0")+"."+(pe[2]||"0")+"."+(pe[3]||"0"))}}).call(this,r(1))},function(te,e){var r,y,w=te.exports={};function L(){throw new Error("setTimeout has not been defined")}function _(){throw new Error("clearTimeout has not been defined")}function A(h){if(r===setTimeout)return setTimeout(h,0);if((r===L||!r)&&setTimeout)return r=setTimeout,setTimeout(h,0);try{return r(h,0)}catch{try{return r.call(null,h,0)}catch{return r.call(this,h,0)}}}(function(){try{r=typeof setTimeout=="function"?setTimeout:L}catch{r=L}try{y=typeof clearTimeout=="function"?clearTimeout:_}catch{y=_}})();var E,k=[],F=!1,S=-1;function m(){F&&E&&(F=!1,E.length?k=E.concat(k):S=-1,k.length&&T())}function T(){if(!F){var h=A(m);F=!0;for(var u=k.length;u;){for(E=k,k=[];++S<u;)E&&E[S].run();S=-1,u=k.length}E=null,F=!1,function(v){if(y===clearTimeout)return clearTimeout(v);if((y===_||!y)&&clearTimeout)return y=clearTimeout,clearTimeout(v);try{y(v)}catch{try{return y.call(null,v)}catch{return y.call(this,v)}}}(h)}}function f(h,u){this.fun=h,this.array=u}function c(){}w.nextTick=function(h){var u=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)u[v-1]=arguments[v];k.push(new f(h,u)),k.length!==1||F||A(T)},f.prototype.run=function(){this.fun.apply(null,this.array)},w.title="browser",w.browser=!0,w.env={},w.argv=[],w.version="",w.versions={},w.on=c,w.addListener=c,w.once=c,w.off=c,w.removeListener=c,w.removeAllListeners=c,w.emit=c,w.prependListener=c,w.prependOnceListener=c,w.listeners=function(h){return[]},w.binding=function(h){throw new Error("process.binding is not supported")},w.cwd=function(){return"/"},w.chdir=function(h){throw new Error("process.chdir is not supported")},w.umask=function(){return 0}}])}),define(Ce[108],Ie([1,0,11,7]),function(te,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function w(l){const b=l;return b?typeof b.read=="function":!1}e.isReadable=w;function L(l){const b=l;return b?[b.on,b.pause,b.resume,b.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=L;function _(l){const b=l;return b?L(b.stream)&&Array.isArray(b.buffer)&&typeof b.ended=="boolean":!1}e.isReadableBufferedStream=_;function A(l,b){return new E(l,b)}e.newWriteableStream=A;class E{constructor(b,t){this.reducer=b,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(b){if(!this.state.destroyed){if(this.state.flowing)this.emitData(b);else if(this.buffer.data.push(b),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(b){this.state.destroyed||(this.state.flowing?this.emitError(b):this.buffer.error.push(b))}end(b){this.state.destroyed||(typeof b<"u"&&this.write(b),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(b){this.listeners.data.slice(0).forEach(t=>t(b))}emitError(b){this.listeners.error.length===0?(0,r.onUnexpectedError)(b):this.listeners.error.slice(0).forEach(t=>t(b))}emitEnd(){this.listeners.end.slice(0).forEach(b=>b())}on(b,t){if(!this.state.destroyed)switch(b){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(b,t){if(this.state.destroyed)return;let d;switch(b){case"data":d=this.listeners.data;break;case"end":d=this.listeners.end;break;case"error":d=this.listeners.error;break}if(d){const n=d.indexOf(t);n>=0&&d.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const b=this.reducer(this.buffer.data);this.emitData(b),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(d=>d())}}flowErrors(){if(this.listeners.error.length>0){for(const b of this.buffer.error)this.emitError(b);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function k(l,b){const t=[];let d;for(;(d=l.read())!==null;)t.push(d);return b(t)}e.consumeReadable=k;function F(l,b,t){const d=[];let n;for(;(n=l.read())!==null&&d.length<t;)d.push(n);return n===null&&d.length>0?b(d):{read:()=>{if(d.length>0)return d.shift();if(typeof n<"u"){const i=n;return n=void 0,i}return l.read()}}}e.peekReadable=F;function S(l,b){return new Promise((t,d)=>{const n=[];m(l,{onData:i=>{b&&n.push(i)},onError:i=>{b?d(i):t(void 0)},onEnd:()=>{t(b?b(n):void 0)}})})}e.consumeStream=S;function m(l,b){let t=!1;return l.on("error",d=>{t||b.onError(d)}),l.on("end",()=>{t||b.onEnd()}),l.on("data",d=>{t||b.onData(d)}),(0,y.toDisposable)(()=>t=!0)}e.listenStream=m;function T(l,b){return new Promise((t,d)=>{const n=new y.DisposableStore,i=[],s=g=>{if(i.push(g),i.length>b)return n.dispose(),l.pause(),t({stream:l,buffer:i,ended:!1})},a=g=>d(g),o=()=>t({stream:l,buffer:i,ended:!0});n.add((0,y.toDisposable)(()=>l.removeListener("error",a))),l.on("error",a),n.add((0,y.toDisposable)(()=>l.removeListener("end",o))),l.on("end",o),n.add((0,y.toDisposable)(()=>l.removeListener("data",s))),l.on("data",s)})}e.peekStream=T;function f(l,b){const t=A(b);return t.end(l),t}e.toStream=f;function c(){const l=A(()=>{throw new Error("not supported")});return l.end(),l}e.emptyStream=c;function h(l){let b=!1;return{read:()=>b?null:(b=!0,l)}}e.toReadable=h;function u(l,b,t){const d=A(t);return m(l,{onData:n=>d.write(b.data(n)),onError:n=>d.error(b.error?b.error(n):n),onEnd:()=>d.end()}),d}e.transform=u;function v(l,b,t){let d=!1;return{read:()=>{const n=b.read();return d?n:(d=!0,n!==null?t([l,n]):l)}}}e.prefixedReadable=v;function I(l,b,t){let d=!1;const n=A(t);return m(b,{onData:i=>d?n.write(i):(d=!0,n.write(t([l,i]))),onError:i=>n.error(i),onEnd:()=>{d||(d=!0,n.write(l)),n.end()}}),n}e.prefixedStream=I}),define(Ce[23],Ie([1,0,108]),function(te,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const y=typeof Buffer<"u";let w,L;class _{constructor(g){this.buffer=g,this.byteLength=this.buffer.byteLength}static alloc(g){return y?new _(Buffer.allocUnsafe(g)):new _(new Uint8Array(g))}static wrap(g){return y&&!Buffer.isBuffer(g)&&(g=Buffer.from(g.buffer,g.byteOffset,g.byteLength)),new _(g)}static fromString(g,p){return!(p?.dontUseNodeBuffer||!1)&&y?new _(Buffer.from(g)):(w||(w=new TextEncoder),new _(w.encode(g)))}static fromByteArray(g){const p=_.alloc(g.length);for(let P=0,M=g.length;P<M;P++)p.buffer[P]=g[P];return p}static concat(g,p){if(typeof p>"u"){p=0;for(let V=0,B=g.length;V<B;V++)p+=g[V].byteLength}const P=_.alloc(p);let M=0;for(let V=0,B=g.length;V<B;V++){const D=g[V];P.set(D,M),M+=D.byteLength}return P}clone(){const g=_.alloc(this.byteLength);return g.set(this),g}toString(){return y?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(g,p){return new _(this.buffer.subarray(g,p))}set(g,p){if(g instanceof _)this.buffer.set(g.buffer,p);else if(g instanceof Uint8Array)this.buffer.set(g,p);else if(g instanceof ArrayBuffer)this.buffer.set(new Uint8Array(g),p);else if(ArrayBuffer.isView(g))this.buffer.set(new Uint8Array(g.buffer,g.byteOffset,g.byteLength),p);else throw new Error("Unknown argument 'array'")}readUInt32BE(g){return k(this.buffer,g)}writeUInt32BE(g,p){F(this.buffer,g,p)}readUInt32LE(g){return S(this.buffer,g)}writeUInt32LE(g,p){m(this.buffer,g,p)}readUInt8(g){return T(this.buffer,g)}writeUInt8(g,p){f(this.buffer,g,p)}}e.VSBuffer=_;function A(o,g){return o[g+0]<<0>>>0|o[g+1]<<8>>>0}e.readUInt16LE=A;function E(o,g,p){o[p+0]=g&255,g=g>>>8,o[p+1]=g&255}e.writeUInt16LE=E;function k(o,g){return o[g]*2**24+o[g+1]*2**16+o[g+2]*2**8+o[g+3]}e.readUInt32BE=k;function F(o,g,p){o[p+3]=g,g=g>>>8,o[p+2]=g,g=g>>>8,o[p+1]=g,g=g>>>8,o[p]=g}e.writeUInt32BE=F;function S(o,g){return o[g+0]<<0>>>0|o[g+1]<<8>>>0|o[g+2]<<16>>>0|o[g+3]<<24>>>0}e.readUInt32LE=S;function m(o,g,p){o[p+0]=g&255,g=g>>>8,o[p+1]=g&255,g=g>>>8,o[p+2]=g&255,g=g>>>8,o[p+3]=g&255}e.writeUInt32LE=m;function T(o,g){return o[g]}e.readUInt8=T;function f(o,g,p){o[p]=g}e.writeUInt8=f;function c(o){return r.consumeReadable(o,g=>_.concat(g))}e.readableToBuffer=c;function h(o){return r.toReadable(o)}e.bufferToReadable=h;function u(o){return r.consumeStream(o,g=>_.concat(g))}e.streamToBuffer=u;async function v(o){return o.ended?_.concat(o.buffer):_.concat([...o.buffer,await u(o.stream)])}e.bufferedStreamToBuffer=v;function I(o){return r.toStream(o,g=>_.concat(g))}e.bufferToStream=I;function l(o){return r.transform(o,{data:g=>typeof g=="string"?_.fromString(g):_.wrap(g)},g=>_.concat(g))}e.streamToBufferReadableStream=l;function b(o){return r.newWriteableStream(g=>_.concat(g),o)}e.newWriteableBufferStream=b;function t(o,g){return r.prefixedReadable(o,g,p=>_.concat(p))}e.prefixedBufferReadable=t;function d(o,g){return r.prefixedStream(o,g,p=>_.concat(p))}e.prefixedBufferStream=d;function n(o){let g=0,p=0,P=0;const M=new Uint8Array(Math.floor(o.length/4*3)),V=D=>{switch(p){case 3:M[P++]=g|D,p=0;break;case 2:M[P++]=g|D>>>2,g=D<<6,p=3;break;case 1:M[P++]=g|D>>>4,g=D<<4,p=2;break;default:g=D<<2,p=1}};for(let D=0;D<o.length;D++){const x=o.charCodeAt(D);if(x>=65&&x<=90)V(x-65);else if(x>=97&&x<=122)V(x-97+26);else if(x>=48&&x<=57)V(x-48+52);else if(x===43||x===45)V(62);else if(x===47||x===95)V(63);else{if(x===61)break;throw new SyntaxError(`Unexpected base64 character ${o[D]}`)}}const B=P;for(;p>0;)V(0);return _.wrap(M).slice(0,B)}e.decodeBase64=n;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:o},g=!0,p=!1){const P=p?s:i;let M="";const V=o.byteLength%3;let B=0;for(;B<o.byteLength-V;B+=3){const D=o[B+0],x=o[B+1],U=o[B+2];M+=P[D>>>2],M+=P[(D<<4|x>>>4)&63],M+=P[(x<<2|U>>>6)&63],M+=P[U&63]}if(V===1){const D=o[B+0];M+=P[D>>>2],M+=P[D<<4&63],g&&(M+="==")}else if(V===2){const D=o[B+0],x=o[B+1];M+=P[D>>>2],M+=P[(D<<4|x>>>4)&63],M+=P[x<<2&63],g&&(M+="=")}return M}e.encodeBase64=a}),define(Ce[42],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const r=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function y(w){return r.test(w)}e.isUUID=y,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let w;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?w=crypto.getRandomValues.bind(crypto):w=function(A){for(let E=0;E<A.length;E++)A[E]=Math.floor(Math.random()*256);return A};const L=new Uint8Array(16),_=[];for(let A=0;A<256;A++)_.push(A.toString(16).padStart(2,"0"));return function(){w(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let E=0,k="";return k+=_[L[E++]],k+=_[L[E++]],k+=_[L[E++]],k+=_[L[E++]],k+="-",k+=_[L[E++]],k+=_[L[E++]],k+="-",k+=_[L[E++]],k+=_[L[E++]],k+="-",k+=_[L[E++]],k+=_[L[E++]],k+="-",k+=_[L[E++]],k+=_[L[E++]],k+=_[L[E++]],k+=_[L[E++]],k+=_[L[E++]],k+=_[L[E++]],k}}()}),define(Ce[109],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ce[110],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var r;(function(_){_[_.None=0]="None",_[_.Indent=1]="Indent",_[_.IndentOutdent=2]="IndentOutdent",_[_.Outdent=3]="Outdent"})(r=e.IndentAction||(e.IndentAction={}));class y{constructor(A){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=A.open,this.close=A.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(A.notIn))for(let E=0,k=A.notIn.length;E<k;E++)switch(A.notIn[E]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(A){switch(A){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(A,E){if(A.getTokenCount()===0)return!0;const k=A.findTokenIndexAtOffset(E-2),F=A.getStandardTokenType(k);return this.isOK(F)}_findNeutralCharacterInRange(A,E){for(let k=A;k<=E;k++){const F=String.fromCharCode(k);if(!this.open.includes(F)&&!this.close.includes(F))return F}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=y;class w{constructor(A){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const E of A)L(this.autoClosingPairsOpenByStart,E.open.charAt(0),E),L(this.autoClosingPairsOpenByEnd,E.open.charAt(E.open.length-1),E),L(this.autoClosingPairsCloseByStart,E.close.charAt(0),E),L(this.autoClosingPairsCloseByEnd,E.close.charAt(E.close.length-1),E),E.close.length===1&&E.open.length===1&&L(this.autoClosingPairsCloseSingleChar,E.close,E)}}e.AutoClosingPairs=w;function L(_,A,E){_.has(A)?_.get(A).push(E):_.set(A,[E])}}),define(Ce[111],Ie([17,18]),function(te,e){return te.create("vs/base/common/date",e)}),define(Ce[112],Ie([1,0,111]),function(te,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const y=60,w=y*60,L=w*24,_=L*7,A=L*30,E=L*365;function k(S,m,T){typeof S!="number"&&(S=S.getTime());const f=Math.round((new Date().getTime()-S)/1e3);if(f<-30)return(0,r.localize)(0,null,k(new Date().getTime()+f*1e3,!1));if(f<30)return(0,r.localize)(1,null);let c;return f<y?(c=f,m?c===1?T?(0,r.localize)(2,null,c):(0,r.localize)(3,null,c):T?(0,r.localize)(4,null,c):(0,r.localize)(5,null,c):c===1?T?(0,r.localize)(6,null,c):(0,r.localize)(7,null,c):T?(0,r.localize)(8,null,c):(0,r.localize)(9,null,c)):f<w?(c=Math.floor(f/y),m?c===1?T?(0,r.localize)(10,null,c):(0,r.localize)(11,null,c):T?(0,r.localize)(12,null,c):(0,r.localize)(13,null,c):c===1?T?(0,r.localize)(14,null,c):(0,r.localize)(15,null,c):T?(0,r.localize)(16,null,c):(0,r.localize)(17,null,c)):f<L?(c=Math.floor(f/w),m?c===1?T?(0,r.localize)(18,null,c):(0,r.localize)(19,null,c):T?(0,r.localize)(20,null,c):(0,r.localize)(21,null,c):c===1?T?(0,r.localize)(22,null,c):(0,r.localize)(23,null,c):T?(0,r.localize)(24,null,c):(0,r.localize)(25,null,c)):f<_?(c=Math.floor(f/L),m?c===1?(0,r.localize)(26,null,c):(0,r.localize)(27,null,c):c===1?(0,r.localize)(28,null,c):(0,r.localize)(29,null,c)):f<A?(c=Math.floor(f/_),m?c===1?T?(0,r.localize)(30,null,c):(0,r.localize)(31,null,c):T?(0,r.localize)(32,null,c):(0,r.localize)(33,null,c):c===1?T?(0,r.localize)(34,null,c):(0,r.localize)(35,null,c):T?(0,r.localize)(36,null,c):(0,r.localize)(37,null,c)):f<E?(c=Math.floor(f/A),m?c===1?T?(0,r.localize)(38,null,c):(0,r.localize)(39,null,c):T?(0,r.localize)(40,null,c):(0,r.localize)(41,null,c):c===1?T?(0,r.localize)(42,null,c):(0,r.localize)(43,null,c):T?(0,r.localize)(44,null,c):(0,r.localize)(45,null,c)):(c=Math.floor(f/E),m?c===1?T?(0,r.localize)(46,null,c):(0,r.localize)(47,null,c):T?(0,r.localize)(48,null,c):(0,r.localize)(49,null,c):c===1?T?(0,r.localize)(50,null,c):(0,r.localize)(51,null,c):T?(0,r.localize)(52,null,c):(0,r.localize)(53,null,c))}e.fromNow=k;function F(S){return S.getFullYear()+"-"+String(S.getMonth()+1).padStart(2,"0")+"-"+String(S.getDate()).padStart(2,"0")+"T"+String(S.getHours()).padStart(2,"0")+":"+String(S.getMinutes()).padStart(2,"0")+":"+String(S.getSeconds()).padStart(2,"0")+"."+(S.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=F}),define(Ce[113],Ie([17,18]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(Ce[43],Ie([1,0,16,10,113]),function(te,e,r,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function L(S,m){return m&&(S.stack||S.stacktrace)?w.localize(0,null,A(S),_(S.stack)||_(S.stacktrace)):A(S)}function _(S){return Array.isArray(S)?S.join(`
`):S}function A(S){return typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?w.localize(1,null,S.message):S.message||w.localize(2,null)}function E(S=null,m=!1){if(!S)return w.localize(3,null);if(Array.isArray(S)){const T=r.coalesce(S),f=E(T[0],m);return T.length>1?w.localize(4,null,f,T.length):f}if(y.isString(S))return S;if(S.detail){const T=S.detail;if(T.error)return L(T.error,m);if(T.exception)return L(T.exception,m)}return S.stack?L(S,m):S.message?S.message:w.localize(5,null)}e.toErrorMessage=E;function k(S){const m=S;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=k;function F(S,m){let T;return typeof S=="string"?T=new Error(S):T=S,T.actions=m,T}e.createErrorWithActions=F}),define(Ce[74],Ie([1,0,19]),function(te,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const y={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},w={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(F){const S=(0,r.extname)(F),m=y[S.toLowerCase()];return m!==void 0?m:_(F)}e.getMediaOrTextMime=L;function _(F){const S=(0,r.extname)(F);return w[S.toLowerCase()]}e.getMediaMime=_;function A(F){for(const S in w)if(w[S]===F)return S}e.getExtensionForMimeType=A;const E=/^(.+)\/(.+?)(;.+)?$/;function k(F,S){const m=E.exec(F);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:S?void 0:F}e.normalizeMimeType=k}),define(Ce[37],Ie([1,0,19,21,9,10]),function(te,e,r,y,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function _(s){return s===47||s===92}e.isPathSeparator=_;function A(s){return s.replace(/[\\/]/g,r.posix.sep)}e.toSlashes=A;function E(s){return s.indexOf("/")===-1&&(s=A(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=E;function k(s,a=r.posix.sep){if(!s)return"";const o=s.length,g=s.charCodeAt(0);if(_(g)){if(_(s.charCodeAt(1))&&!_(s.charCodeAt(2))){let P=3;const M=P;for(;P<o&&!_(s.charCodeAt(P));P++);if(M!==P&&!_(s.charCodeAt(P+1))){for(P+=1;P<o;P++)if(_(s.charCodeAt(P)))return s.slice(0,P+1).replace(/[\\/]/g,a)}}return a}else if(u(g)&&s.charCodeAt(1)===58)return _(s.charCodeAt(2))?s.slice(0,2)+a:s.slice(0,2);let p=s.indexOf("://");if(p!==-1){for(p+=3;p<o;p++)if(_(s.charCodeAt(p)))return s.slice(0,p+1)}return""}e.getRoot=k;function F(s){if(!y.isWindows||!s||s.length<5)return!1;let a=s.charCodeAt(0);if(a!==92||(a=s.charCodeAt(1),a!==92))return!1;let o=2;const g=o;for(;o<s.length&&(a=s.charCodeAt(o),a!==92);o++);return!(g===o||(a=s.charCodeAt(o+1),isNaN(a)||a===92))}e.isUNC=F;const S=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,T=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(s,a=y.isWindows){const o=a?S:m;return!(!s||s.length===0||/^\s+$/.test(s)||(o.lastIndex=0,o.test(s))||a&&T.test(s)||s==="."||s===".."||a&&s[s.length-1]==="."||a&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=f;function c(s,a,o){const g=s===a;return!o||g?g:!s||!a?!1:(0,w.equalsIgnoreCase)(s,a)}e.isEqual=c;function h(s,a,o,g=r.sep){if(s===a)return!0;if(!s||!a||a.length>s.length)return!1;if(o){if(!(0,w.startsWithIgnoreCase)(s,a))return!1;if(a.length===s.length)return!0;let P=a.length;return a.charAt(a.length-1)===g&&P--,s.charAt(P)===g}return a.charAt(a.length-1)!==g&&(a+=g),s.indexOf(a)===0}e.isEqualOrParent=h;function u(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=u;function v(s,a){return y.isWindows&&s.endsWith(":")&&(s+=r.sep),(0,r.isAbsolute)(s)||(s=(0,r.join)(a,s)),s=(0,r.normalize)(s),y.isWindows?(s=(0,w.rtrim)(s,r.sep),s.endsWith(":")&&(s+=r.sep)):(s=(0,w.rtrim)(s,r.sep),s||(s=r.sep)),s}e.sanitizeFilePath=v;function I(s){const a=(0,r.normalize)(s);return y.isWindows?s.length>3?!1:l(a)&&(s.length===2||a.charCodeAt(2)===92):a===r.posix.sep}e.isRootOrDriveLetter=I;function l(s,a=y.isWindows){return a?u(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=l;function b(s){return l(s)?s[0]:void 0}e.getDriveLetter=b;function t(s,a,o){return a.length>s.length?-1:s===a?0:(o&&(s=s.toLowerCase(),a=a.toLowerCase()),s.indexOf(a))}e.indexOfPath=t;function d(s){const a=s.split(":");let o,g,p;for(const P of a){const M=Number(P);(0,L.isNumber)(M)?g===void 0?g=M:p===void 0&&(p=M):o=o?[o,P].join(":"):P}if(!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:g!==void 0?g:void 0,column:p!==void 0?p:g!==void 0?1:void 0}}e.parseLineAndColumnAware=d;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(s,a,o=8){let g="";for(let P=0;P<o;P++)g+=n.charAt(Math.floor(Math.random()*n.length));let p;return a?p=`${a}-${g}`:p=g,s?(0,r.join)(s,p):p}e.randomPath=i}),define(Ce[25],Ie([1,0,16,9]),function(te,e,r,y){"use strict";var w,L,_;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function A(n,i,s){let a=n.get(i);return a===void 0&&(a=s,n.set(i,a)),a}e.getOrSet=A;function E(n){const i=[];return n.forEach((s,a)=>{i.push(`${a} => ${s}`)}),`Map(${n.size}) {${i.join(", ")}}`}e.mapToString=E;function k(n){const i=[];return n.forEach(s=>{i.push(s)}),`Set(${n.size}) {${i.join(", ")}}`}e.setToString=k;class F{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const s=i.charCodeAt(0),a=this._value.charCodeAt(this._pos);return s-a}value(){return this._value[this._pos]}}e.StringIterator=F;class S{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,y.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,y.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=S;class m{constructor(i=!0,s=!0){this._splitOnBackslash=i,this._caseSensitive=s}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let s=i.length-1;s>=0;s--,this._valueLen--){const a=this._value.charCodeAt(s);if(!(a===47||this._splitOnBackslash&&a===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,y.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,y.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=m;var T;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(T||(T={}));class f{constructor(i,s){this._ignorePathCasing=i,this._ignoreQueryAndFragment=s,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new m(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(i)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,y.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,y.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,y.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,y.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=f;class c{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var h;(function(n){n[n.Left=-1]="Left",n[n.Mid=0]="Mid",n[n.Right=1]="Right"})(h||(h={}));class u{constructor(i){this._iter=i}static forUris(i=()=>!1,s=()=>!1){return new u(new f(i,s))}static forPaths(i=!1){return new u(new m(void 0,!i))}static forStrings(){return new u(new F)}static forConfigKeys(){return new u(new S)}clear(){this._root=void 0}fill(i,s){if(s){const a=s.slice(0);(0,r.shuffle)(a);for(const o of a)this.set(o,i)}else{const a=i.slice(0);(0,r.shuffle)(a);for(const o of a)this.set(o[0],o[1])}}set(i,s){const a=this._iter.reset(i);let o;this._root||(this._root=new c,this._root.segment=a.value());const g=[];for(o=this._root;;){const P=a.cmp(o.segment);if(P>0)o.left||(o.left=new c,o.left.segment=a.value()),g.push([-1,o]),o=o.left;else if(P<0)o.right||(o.right=new c,o.right.segment=a.value()),g.push([1,o]),o=o.right;else if(a.hasNext())a.next(),o.mid||(o.mid=new c,o.mid.segment=a.value()),g.push([0,o]),o=o.mid;else break}const p=o.value;o.value=s,o.key=i;for(let P=g.length-1;P>=0;P--){const M=g[P][1];M.updateHeight();const V=M.balanceFactor();if(V<-1||V>1){const B=g[P][0],D=g[P+1][0];if(B===1&&D===1)g[P][1]=M.rotateLeft();else if(B===-1&&D===-1)g[P][1]=M.rotateRight();else if(B===1&&D===-1)M.right=g[P+1][1]=g[P+1][1].rotateRight(),g[P][1]=M.rotateLeft();else if(B===-1&&D===1)M.left=g[P+1][1]=g[P+1][1].rotateLeft(),g[P][1]=M.rotateRight();else throw new Error;if(P>0)switch(g[P-1][0]){case-1:g[P-1][1].left=g[P][1];break;case 1:g[P-1][1].right=g[P][1];break;case 0:g[P-1][1].mid=g[P][1];break}else this._root=g[0][1]}}return p}get(i){return this._getNode(i)?.value}_getNode(i){const s=this._iter.reset(i);let a=this._root;for(;a;){const o=s.cmp(a.segment);if(o>0)a=a.left;else if(o<0)a=a.right;else if(s.hasNext())s.next(),a=a.mid;else break}return a}has(i){const s=this._getNode(i);return!(s?.value===void 0&&s?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,s){const a=this._iter.reset(i),o=[];let g=this._root;for(;g;){const p=a.cmp(g.segment);if(p>0)o.push([-1,g]),g=g.left;else if(p<0)o.push([1,g]),g=g.right;else if(a.hasNext())a.next(),o.push([0,g]),g=g.mid;else break}if(!!g){if(s?(g.left=void 0,g.mid=void 0,g.right=void 0,g.height=1):(g.key=void 0,g.value=void 0),!g.mid&&!g.value)if(g.left&&g.right){const p=this._min(g.right),{key:P,value:M,segment:V}=p;this._delete(p.key,!1),g.key=P,g.value=M,g.segment=V}else{const p=g.left??g.right;if(o.length>0){const[P,M]=o[o.length-1];switch(P){case-1:M.left=p;break;case 0:M.mid=p;break;case 1:M.right=p;break}}else this._root=p}for(let p=o.length-1;p>=0;p--){const P=o[p][1];P.updateHeight();const M=P.balanceFactor();if(M>1?(P.right.balanceFactor()>=0||(P.right=P.right.rotateRight()),o[p][1]=P.rotateLeft()):M<-1&&(P.left.balanceFactor()<=0||(P.left=P.left.rotateLeft()),o[p][1]=P.rotateRight()),p>0)switch(o[p-1][0]){case-1:o[p-1][1].left=o[p][1];break;case 1:o[p-1][1].right=o[p][1];break;case 0:o[p-1][1].mid=o[p][1];break}else this._root=o[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const s=this._iter.reset(i);let a=this._root,o;for(;a;){const g=s.cmp(a.segment);if(g>0)a=a.left;else if(g<0)a=a.right;else if(s.hasNext())s.next(),o=a.value||o,a=a.mid;else break}return a&&a.value||o}findSuperstr(i){const s=this._iter.reset(i);let a=this._root;for(;a;){const o=s.cmp(a.segment);if(o>0)a=a.left;else if(o<0)a=a.right;else if(s.hasNext())s.next(),a=a.mid;else return a.mid?this._entries(a.mid):void 0}}forEach(i){for(const[s,a]of this)i(a,s)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(i){const s=[];return this._dfsEntries(i,s),s[Symbol.iterator]()}_dfsEntries(i,s){!i||(i.left&&this._dfsEntries(i.left,s),i.value&&s.push([i.key,i.value]),i.mid&&this._dfsEntries(i.mid,s),i.right&&this._dfsEntries(i.right,s))}_isBalanced(){const i=s=>{if(!s)return!0;const a=s.balanceFactor();return a<-1||a>1?!1:i(s.left)&&i(s.right)};return i(this._root)}}e.TernarySearchTree=u;class v{constructor(i,s){this.uri=i,this.value=s}}class I{constructor(i,s){this[w]="ResourceMap",i instanceof I?(this.map=new Map(i.map),this.toKey=s??I.defaultToKey):(this.map=new Map,this.toKey=i??I.defaultToKey)}set(i,s){return this.map.set(this.toKey(i),new v(i,s)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,s){typeof s<"u"&&(i=i.bind(s));for(const[a,o]of this.map)i(o.value,o.uri,this)}*values(){for(const i of this.map.values())yield i.value}*keys(){for(const i of this.map.values())yield i.uri}*entries(){for(const i of this.map.values())yield[i.uri,i.value]}*[(w=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=I,I.defaultToKey=n=>n.toString();class l{constructor(i,s){this[L]="ResourceSet",!i||typeof i=="function"?this._map=new I(i):(this._map=new I(s),i.forEach(this.add,this))}get size(){return this._map.size}add(i){return this._map.set(i,i),this}clear(){this._map.clear()}delete(i){return this._map.delete(i)}forEach(i,s){this._map.forEach((a,o)=>i.call(s,o,o,this))}has(i){return this._map.has(i)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=l;var b;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(b=e.Touch||(e.Touch={}));class t{constructor(){this[_]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,s=0){const a=this._map.get(i);if(!!a)return s!==0&&this.touch(a,s),a.value}set(i,s,a=0){let o=this._map.get(i);if(o)o.value=s,a!==0&&this.touch(o,a);else{switch(o={key:i,value:s,next:void 0,previous:void 0},a){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(i,o),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const s=this._map.get(i);if(!!s)return this._map.delete(i),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,s){const a=this._state;let o=this._head;for(;o;){if(s?i.bind(s)(o.value,o.key,this):i(o.value,o.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const i=this,s=this._state;let a=this._head;const o={[Symbol.iterator](){return o},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const g={value:a.key,done:!1};return a=a.next,g}else return{value:void 0,done:!0}}};return o}values(){const i=this,s=this._state;let a=this._head;const o={[Symbol.iterator](){return o},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const g={value:a.value,done:!1};return a=a.next,g}else return{value:void 0,done:!0}}};return o}entries(){const i=this,s=this._state;let a=this._head;const o={[Symbol.iterator](){return o},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const g={value:[a.key,a.value],done:!1};return a=a.next,g}else return{value:void 0,done:!0}}};return o}[(_=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let s=this._head,a=this.size;for(;s&&a>i;)this._map.delete(s.key),s=s.next,a--;this._head=s,this._size=a,s&&(s.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const s=i.next,a=i.previous;if(!s||!a)throw new Error("Invalid list");s.previous=a,a.next=s}i.next=void 0,i.previous=void 0,this._state++}touch(i,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(i===this._head)return;const a=i.next,o=i.previous;i===this._tail?(o.next=void 0,this._tail=o):(a.previous=o,o.next=a),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(s===2){if(i===this._tail)return;const a=i.next,o=i.previous;i===this._head?(a.previous=void 0,this._head=a):(a.previous=o,o.next=a),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((s,a)=>{i.push([a,s])}),i}fromJSON(i){this.clear();for(const[s,a]of i)this.set(s,a)}}e.LinkedMap=t;class d extends t{constructor(i,s=1){super(),this._limit=i,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,s=2){return super.get(i,s)}peek(i){return super.get(i,0)}set(i,s){return super.set(i,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=d}),define(Ce[114],Ie([1,0,25,9]),function(te,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function w(...Q){return function(J,C){for(let z=0,H=Q.length;z<H;z++){const j=Q[z](J,C);if(j)return j}return null}}e.or=w,e.matchesStrictPrefix=L.bind(void 0,!1),e.matchesPrefix=L.bind(void 0,!0);function L(Q,J,C){if(!C||C.length<J.length)return null;let z;return Q?z=y.startsWithIgnoreCase(C,J):z=C.indexOf(J)===0,z?J.length>0?[{start:0,end:J.length}]:[]:null}function _(Q,J){const C=J.toLowerCase().indexOf(Q.toLowerCase());return C===-1?null:[{start:C,end:C+Q.length}]}e.matchesContiguousSubString=_;function A(Q,J){return E(Q.toLowerCase(),J.toLowerCase(),0,0)}e.matchesSubString=A;function E(Q,J,C,z){if(C===Q.length)return[];if(z===J.length)return null;if(Q[C]===J[z]){let H=null;return(H=E(Q,J,C+1,z+1))?u({start:z,end:z+1},H):null}return E(Q,J,C,z+1)}function k(Q){return 97<=Q&&Q<=122}function F(Q){return 65<=Q&&Q<=90}e.isUpper=F;function S(Q){return 48<=Q&&Q<=57}function m(Q){return Q===32||Q===9||Q===10||Q===13}const T=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Q=>T.add(Q.charCodeAt(0)));function f(Q){return m(Q)||T.has(Q)}function c(Q,J){return Q===J||f(Q)&&f(J)}function h(Q){return k(Q)||F(Q)||S(Q)}function u(Q,J){return J.length===0?J=[Q]:Q.end===J[0].start?J[0].start=Q.start:J.unshift(Q),J}function v(Q,J){for(let C=J;C<Q.length;C++){const z=Q.charCodeAt(C);if(F(z)||S(z)||C>0&&!h(Q.charCodeAt(C-1)))return C}return Q.length}function I(Q,J,C,z){if(C===Q.length)return[];if(z===J.length)return null;if(Q[C]!==J[z].toLowerCase())return null;{let H=null,j=z+1;for(H=I(Q,J,C+1,z+1);!H&&(j=v(J,j))<J.length;)H=I(Q,J,C+1,j),j++;return H===null?null:u({start:z,end:z+1},H)}}function l(Q){let J=0,C=0,z=0,H=0,j=0;for(let ge=0;ge<Q.length;ge++)j=Q.charCodeAt(ge),F(j)&&J++,k(j)&&C++,h(j)&&z++,S(j)&&H++;const se=J/Q.length,ce=C/Q.length,Y=z/Q.length,pe=H/Q.length;return{upperPercent:se,lowerPercent:ce,alphaPercent:Y,numericPercent:pe}}function b(Q){const{upperPercent:J,lowerPercent:C}=Q;return C===0&&J>.6}function t(Q){const{upperPercent:J,lowerPercent:C,alphaPercent:z,numericPercent:H}=Q;return C>.2&&J<.8&&z>.6&&H<.2}function d(Q){let J=0,C=0,z=0,H=0;for(let j=0;j<Q.length;j++)z=Q.charCodeAt(j),F(z)&&J++,k(z)&&C++,m(z)&&H++;return(J===0||C===0)&&H===0?Q.length<=30:J<=5}function n(Q,J){if(!J||(J=J.trim(),J.length===0)||!d(Q)||J.length>60)return null;const C=l(J);if(!t(C)){if(!b(C))return null;J=J.toLowerCase()}let z=null,H=0;for(Q=Q.toLowerCase();H<J.length&&(z=I(Q,J,0,H))===null;)H=v(J,H+1);return z}e.matchesCamelCase=n;function i(Q,J,C=!1){if(!J||J.length===0)return null;let z=null,H=0;for(Q=Q.toLowerCase(),J=J.toLowerCase();H<J.length&&(z=s(Q,J,0,H,C))===null;)H=a(J,H+1);return z}e.matchesWords=i;function s(Q,J,C,z,H){if(C===Q.length)return[];if(z===J.length)return null;if(c(Q.charCodeAt(C),J.charCodeAt(z))){let j=null,se=z+1;if(j=s(Q,J,C+1,z+1,H),!H)for(;!j&&(se=a(J,se))<J.length;)j=s(Q,J,C+1,se,H),se++;return j?Q.charCodeAt(C)!==J.charCodeAt(z)?j:u({start:z,end:z+1},j):null}else return null}function a(Q,J){for(let C=J;C<Q.length;C++)if(f(Q.charCodeAt(C))||C>0&&f(Q.charCodeAt(C-1)))return C;return Q.length}const o=w(e.matchesPrefix,n,_),g=w(e.matchesPrefix,n,A),p=new r.LRUCache(1e4);function P(Q,J,C=!1){if(typeof Q!="string"||typeof J!="string")return null;let z=p.get(Q);z||(z=new RegExp(y.convertSimple2RegExpPattern(Q),"i"),p.set(Q,z));const H=z.exec(J);return H?[{start:H.index,end:H.index+H[0].length}]:C?g(Q,J):o(Q,J)}e.matchesFuzzy=P;function M(Q,J){const C=$e(Q,Q.toLowerCase(),0,J,J.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return C?B(C):null}e.matchesFuzzy2=M;function V(Q,J,C,z,H,j){const se=Math.min(13,Q.length);for(;C<se;C++){const ce=$e(Q,J,C,z,H,j,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(ce)return ce}return[0,j]}e.anyScore=V;function B(Q){if(typeof Q>"u")return[];const J=[],C=Q[1];for(let z=Q.length-1;z>1;z--){const H=Q[z]+C,j=J[J.length-1];j&&j.end===H?j.end=H+1:J.push({start:H,end:H+1})}return J}e.createMatches=B;const D=128;function x(){const Q=[],J=[];for(let C=0;C<=D;C++)J[C]=0;for(let C=0;C<=D;C++)Q.push(J.slice(0));return Q}function U(Q){const J=[];for(let C=0;C<=Q;C++)J[C]=0;return J}const R=U(2*D),K=U(2*D),W=x(),O=x(),Z=x(),ue=!1;function oe(Q,J,C,z,H){function j(ce,Y,pe=" "){for(;ce.length<Y;)ce=pe+ce;return ce}let se=` |   |${z.split("").map(ce=>j(ce,3)).join("|")}
`;for(let ce=0;ce<=C;ce++)ce===0?se+=" |":se+=`${J[ce-1]}|`,se+=Q[ce].slice(0,H+1).map(Y=>j(Y.toString(),3)).join("|")+`
`;return se}function de(Q,J,C,z){Q=Q.substr(J),C=C.substr(z),console.log(oe(O,Q,Q.length,C,C.length)),console.log(oe(Z,Q,Q.length,C,C.length)),console.log(oe(W,Q,Q.length,C,C.length))}function ie(Q,J){if(J<0||J>=Q.length)return!1;const C=Q.codePointAt(J);switch(C){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!y.isEmojiImprecise(C)}}function ve(Q,J){if(J<0||J>=Q.length)return!1;switch(Q.charCodeAt(J)){case 32:case 9:return!0;default:return!1}}function be(Q,J,C){return J[Q]!==C[Q]}function ne(Q,J,C,z,H,j,se=!1){for(;J<C&&H<j;)Q[J]===z[H]&&(se&&(R[J]=H),J+=1),H+=1;return J===C}e.isPatternInWord=ne;var Ee;(function(Q){Q[Q.Diag=1]="Diag",Q[Q.Left=2]="Left",Q[Q.LeftLeft=3]="LeftLeft"})(Ee||(Ee={}));var Pe;(function(Q){Q.Default=[-100,0];function J(C){return!C||C.length===2&&C[0]===-100&&C[1]===0}Q.isDefault=J})(Pe=e.FuzzyScore||(e.FuzzyScore={}));class Fe{constructor(J,C){this.firstMatchCanBeWeak=J,this.boostFullMatch=C}}e.FuzzyScoreOptions=Fe,Fe.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function $e(Q,J,C,z,H,j,se=Fe.default){const ce=Q.length>D?D:Q.length,Y=z.length>D?D:z.length;if(C>=ce||j>=Y||ce-C>Y-j||!ne(J,C,ce,H,j,Y,!0))return;Qe(ce,Y,C,j,J,H);let pe=1,ge=1,Ne=C,Be=j;const Ye=[!1];for(pe=1,Ne=C;Ne<ce;pe++,Ne++){const X=R[Ne],fe=K[Ne],Ue=Ne+1<ce?K[Ne+1]:Y;for(ge=X-j+1,Be=X;Be<Ue;ge++,Be++){let We=Number.MIN_SAFE_INTEGER,et=!1;Be<=fe&&(We=Te(Q,J,Ne,C,z,H,Be,Y,j,W[pe-1][ge-1]===0,Ye));let qe=0;We!==Number.MAX_SAFE_INTEGER&&(et=!0,qe=We+O[pe-1][ge-1]);const Ve=Be>X,it=Ve?O[pe][ge-1]+(W[pe][ge-1]>0?-5:0):0,st=Be>X+1&&W[pe][ge-1]>0,dt=st?O[pe][ge-2]+(W[pe][ge-2]>0?-5:0):0;if(st&&(!Ve||dt>=it)&&(!et||dt>=qe))O[pe][ge]=dt,Z[pe][ge]=3,W[pe][ge]=0;else if(Ve&&(!et||it>=qe))O[pe][ge]=it,Z[pe][ge]=2,W[pe][ge]=0;else if(et)O[pe][ge]=qe,Z[pe][ge]=1,W[pe][ge]=W[pe-1][ge-1]+1;else throw new Error("not possible")}}if(ue&&de(Q,C,z,j),!Ye[0]&&!se.firstMatchCanBeWeak)return;pe--,ge--;const Xe=[O[pe][ge],j];let ke=0,nt=0;for(;pe>=1;){let X=ge;do{const fe=Z[pe][X];if(fe===3)X=X-2;else if(fe===2)X=X-1;else break}while(X>=1);ke>1&&J[C+pe-1]===H[j+ge-1]&&!be(X+j-1,z,H)&&ke+1>W[pe][X]&&(X=ge),X===ge?ke++:ke=1,nt||(nt=X),pe--,ge=X-1,Xe.push(ge)}Y===ce&&se.boostFullMatch&&(Xe[0]+=2);const G=nt-ce;return Xe[0]-=G,Xe}e.fuzzyScore=$e;function Qe(Q,J,C,z,H,j){let se=Q-1,ce=J-1;for(;se>=C&&ce>=z;)H[se]===j[ce]&&(K[se]=ce,se--),ce--}function Te(Q,J,C,z,H,j,se,ce,Y,pe,ge){if(J[C]!==j[se])return Number.MIN_SAFE_INTEGER;let Ne=1,Be=!1;return se===C-z?Ne=Q[C]===H[se]?7:5:be(se,H,j)&&(se===0||!be(se-1,H,j))?(Ne=Q[C]===H[se]?7:5,Be=!0):ie(j,se)&&(se===0||!ie(j,se-1))?Ne=5:(ie(j,se-1)||ve(j,se-1))&&(Ne=5,Be=!0),Ne>1&&C===z&&(ge[0]=!0),Be||(Be=be(se,H,j)||ie(j,se-1)||ve(j,se-1)),C===z?se>Y&&(Ne-=Be?3:5):pe?Ne+=Be?2:0:Ne+=Be?0:1,se+1===ce&&(Ne-=Be?3:5),Ne}function _e(Q,J,C,z,H,j,se){return ae(Q,J,C,z,H,j,!0,se)}e.fuzzyScoreGracefulAggressive=_e;function ye(Q,J,C,z,H,j,se){return ae(Q,J,C,z,H,j,!1,se)}e.fuzzyScoreGraceful=ye;function ae(Q,J,C,z,H,j,se,ce){let Y=$e(Q,J,C,z,H,j,ce);if(Y&&!se)return Y;if(Q.length>=3){const pe=Math.min(7,Q.length-1);for(let ge=C+1;ge<pe;ge++){const Ne=le(Q,ge);if(Ne){const Be=$e(Ne,Ne.toLowerCase(),C,z,H,j,ce);Be&&(Be[0]-=3,(!Y||Be[0]>Y[0])&&(Y=Be))}}}return Y}function le(Q,J){if(J+1>=Q.length)return;const C=Q[J],z=Q[J+1];if(C!==z)return Q.slice(0,J)+z+C+Q.slice(J+2)}}),define(Ce[115],Ie([1,0,116,114,9]),function(te,e,r,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const L=new RegExp(`\\$\\(${r.CSSIcon.iconNameExpression}(?:${r.CSSIcon.iconModifierExpression})?\\)`,"g"),_=new RegExp(r.CSSIcon.iconNameCharacter),A=new RegExp(`(\\\\)?${L.source}`,"g");function E(h){return h.replace(A,(u,v)=>v?u:`\\${u}`)}e.escapeIcons=E;const k=new RegExp(`\\\\${L.source}`,"g");function F(h){return h.replace(k,u=>`\\${u}`)}e.markdownEscapeEscapedIcons=F;const S=new RegExp(`(\\s)?(\\\\)?${L.source}(\\s)?`,"g");function m(h){return h.indexOf(e.iconStartMarker)===-1?h:h.replace(S,(u,v,I,l)=>I?u:v||l||"")}e.stripIcons=m;function T(h){const u=h.indexOf(e.iconStartMarker);return u===-1?{text:h}:f(h,u)}e.parseLabelWithIcons=T;function f(h,u){const v=[];let I="";function l(o){if(o){I+=o;for(const g of o)v.push(d)}}let b=-1,t="",d=0,n,i,s=u;const a=h.length;for(l(h.substr(0,u));s<a;)n=h[s],i=h[s+1],n===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(b=s,l(t),t=e.iconStartMarker,s++):n===")"&&b!==-1?(d+=s-b+1,b=-1,t=""):b!==-1?_.test(n)?t+=n:(l(t),b=-1,t=""):l(n),s++;return l(t),{text:I,iconOffsets:v}}function c(h,u,v=!1){const{text:I,iconOffsets:l}=u;if(!l||l.length===0)return(0,y.matchesFuzzy)(h,I,v);const b=(0,w.ltrim)(I," "),t=I.length-b.length,d=(0,y.matchesFuzzy)(h,b,v);if(d)for(const n of d){const i=l[n.start+t]+t;n.start+=i,n.end+=i}return d}e.matchesFuzzyIconAware=c}),define(Ce[29],Ie([1,0,9]),function(te,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var y;(function(w){w[w.Ignore=0]="Ignore",w[w.Info=1]="Info",w[w.Warning=2]="Warning",w[w.Error=3]="Error"})(y||(y={})),function(w){const L="error",_="warning",A="warn",E="info",k="ignore";function F(m){return m?r.equalsIgnoreCase(L,m)?w.Error:r.equalsIgnoreCase(_,m)||r.equalsIgnoreCase(A,m)?w.Warning:r.equalsIgnoreCase(E,m)?w.Info:w.Ignore:w.Ignore}w.fromValue=F;function S(m){switch(m){case w.Error:return L;case w.Warning:return _;case w.Info:return E;default:return k}}w.toString=S}(y||(y={})),e.default=y}),define(Ce[75],Ie([1,0,23,9,2]),function(te,e,r,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function L(k){return JSON.stringify(k,A)}e.stringify=L;function _(k){let F=JSON.parse(k);return F=E(F),F}e.parse=_;function A(k,F){return F instanceof RegExp?{$mid:2,source:F.source,flags:(0,y.regExpFlags)(F)}:F}function E(k,F=0){if(!k||F>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return w.URI.revive(k);case 2:return new RegExp(k.source,k.flags);case 14:return new Date(k.source)}if(k instanceof r.VSBuffer||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let S=0;S<k.length;++S)k[S]=E(k[S],F+1);else for(const S in k)Object.hasOwnProperty.call(k,S)&&(k[S]=E(k[S],F+1))}return k}e.revive=E}),define(Ce[12],Ie([1,0,21,2]),function(te,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var w;(function(E){E.inMemory="inmemory",E.vscode="vscode",E.internal="private",E.walkThrough="walkThrough",E.walkThroughSnippet="walkThroughSnippet",E.http="http",E.https="https",E.file="file",E.mailto="mailto",E.untitled="untitled",E.data="data",E.command="command",E.vscodeRemote="vscode-remote",E.vscodeRemoteResource="vscode-remote-resource",E.vscodeUserData="vscode-userdata",E.vscodeCustomEditor="vscode-custom-editor",E.vscodeNotebook="vscode-notebook",E.vscodeNotebookCell="vscode-notebook-cell",E.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",E.vscodeNotebookCellOutput="vscode-notebook-cell-output",E.vscodeInteractive="vscode-interactive",E.vscodeInteractiveInput="vscode-interactive-input",E.vscodeSettings="vscode-settings",E.vscodeWorkspaceTrust="vscode-workspace-trust",E.vscodeTerminal="vscode-terminal",E.webviewPanel="webview-panel",E.vscodeWebview="vscode-webview",E.extension="extension",E.vscodeFileResource="vscode-file",E.tmp="tmp",E.vsls="vsls",E.vscodeSourceControl="vscode-scm"})(w=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class L{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${w.vscodeRemoteResource}`}setPreferredWebSchema(k){this._preferredWebSchema=k}setDelegate(k){this._delegate=k}setServerRootPath(k){this._remoteResourcesPath=`${k}/${w.vscodeRemoteResource}`}set(k,F,S){this._hosts[k]=F,this._ports[k]=S}setConnectionToken(k,F){this._connectionTokens[k]=F}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(k){if(this._delegate)return this._delegate(k);const F=k.authority;let S=this._hosts[F];S&&S.indexOf(":")!==-1&&(S=`[${S}]`);const m=this._ports[F],T=this._connectionTokens[F];let f=`path=${encodeURIComponent(k.path)}`;return typeof T=="string"&&(f+=`&${e.connectionTokenQueryName}=${encodeURIComponent(T)}`),y.URI.from({scheme:r.isWeb?this._preferredWebSchema:w.vscodeRemoteResource,authority:`${S}:${m}`,path:this._remoteResourcesPath,query:f})}}e.RemoteAuthorities=new L;class _{asBrowserUri(k,F){const S=this.toUri(k,F);return S.scheme===w.vscodeRemote?e.RemoteAuthorities.rewrite(S):S.scheme===w.file&&(r.isNative||r.isWebWorker&&r.globals.origin===`${w.vscodeFileResource}://${_.FALLBACK_AUTHORITY}`)?S.with({scheme:w.vscodeFileResource,authority:S.authority||_.FALLBACK_AUTHORITY,query:null,fragment:null}):S}asFileUri(k,F){const S=this.toUri(k,F);return S.scheme===w.vscodeFileResource?S.with({scheme:w.file,authority:S.authority!==_.FALLBACK_AUTHORITY?S.authority:null,query:null,fragment:null}):S}toUri(k,F){return y.URI.isUri(k)?k:y.URI.parse(F.toUrl(k))}}_.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new _;var A;(function(E){const k=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);E.CoopAndCoep=Object.freeze(k.get("3"));const F="vscode-coi";function S(T){let f;typeof T=="string"?f=new URL(T).searchParams:T instanceof URL?f=T.searchParams:y.URI.isUri(T)&&(f=new URL(T.toString(!0)).searchParams);const c=f?.get(F);if(!!c)return k.get(c)}E.getHeadersFromQuery=S;function m(T,f,c){if(!globalThis.crossOriginIsolated)return;const h=f&&c?"3":c?"2":"1";T instanceof URLSearchParams?T.set(F,h):T[F]=h}E.addSearchParam=m})(A=e.COI||(e.COI={}))}),define(Ce[22],Ie([1,0,37,12,19,21,9,2]),function(te,e,r,y,w,L,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function E(T){return(0,A.uriToFsPath)(T,!0)}e.originalFSPath=E;class k{constructor(f){this._ignorePathCasing=f}compare(f,c,h=!1){return f===c?0:(0,_.compare)(this.getComparisonKey(f,h),this.getComparisonKey(c,h))}isEqual(f,c,h=!1){return f===c?!0:!f||!c?!1:this.getComparisonKey(f,h)===this.getComparisonKey(c,h)}getComparisonKey(f,c=!1){return f.with({path:this._ignorePathCasing(f)?f.path.toLowerCase():void 0,fragment:c?null:void 0}).toString()}ignorePathCasing(f){return this._ignorePathCasing(f)}isEqualOrParent(f,c,h=!1){if(f.scheme===c.scheme){if(f.scheme===y.Schemas.file)return r.isEqualOrParent(E(f),E(c),this._ignorePathCasing(f))&&f.query===c.query&&(h||f.fragment===c.fragment);if((0,e.isEqualAuthority)(f.authority,c.authority))return r.isEqualOrParent(f.path,c.path,this._ignorePathCasing(f),"/")&&f.query===c.query&&(h||f.fragment===c.fragment)}return!1}joinPath(f,...c){return A.URI.joinPath(f,...c)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return w.posix.basename(f.path)}extname(f){return w.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let c;return f.scheme===y.Schemas.file?c=A.URI.file(w.dirname(E(f))).path:(c=w.posix.dirname(f.path),f.authority&&c.length&&c.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),c="/")),f.with({path:c})}normalizePath(f){if(!f.path.length)return f;let c;return f.scheme===y.Schemas.file?c=A.URI.file(w.normalize(E(f))).path:c=w.posix.normalize(f.path),f.with({path:c})}relativePath(f,c){if(f.scheme!==c.scheme||!(0,e.isEqualAuthority)(f.authority,c.authority))return;if(f.scheme===y.Schemas.file){const v=w.relative(E(f),E(c));return L.isWindows?r.toSlashes(v):v}let h=f.path||"/";const u=c.path||"/";if(this._ignorePathCasing(f)){let v=0;for(const I=Math.min(h.length,u.length);v<I&&!(h.charCodeAt(v)!==u.charCodeAt(v)&&h.charAt(v).toLowerCase()!==u.charAt(v).toLowerCase());v++);h=u.substr(0,v)+h.substr(v)}return w.posix.relative(h,u)}resolvePath(f,c){if(f.scheme===y.Schemas.file){const h=A.URI.file(w.resolve(E(f),c));return f.with({authority:h.authority,path:h.path})}return c=r.toPosixPath(c),f.with({path:w.posix.resolve(f.path,c)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,c){return f===c||f!==void 0&&c!==void 0&&(0,_.equalsIgnoreCase)(f,c)}hasTrailingPathSeparator(f,c=w.sep){if(f.scheme===y.Schemas.file){const h=E(f);return h.length>r.getRoot(h).length&&h[h.length-1]===c}else{const h=f.path;return h.length>1&&h.charCodeAt(h.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,c=w.sep){return(0,e.hasTrailingPathSeparator)(f,c)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,c=w.sep){let h=!1;if(f.scheme===y.Schemas.file){const u=E(f);h=u!==void 0&&u.length===r.getRoot(u).length&&u[u.length-1]===c}else{c="/";const u=f.path;h=u.length===1&&u.charCodeAt(u.length-1)===47}return!h&&!(0,e.hasTrailingPathSeparator)(f,c)?f.with({path:f.path+"/"}):f}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(T=>T.scheme===y.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new k(T=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function F(T,f){const c=[];for(let h=0;h<T.length;h++){const u=f(T[h]);T.some((v,I)=>I===h?!1:(0,e.isEqualOrParent)(u,f(v)))||c.push(T[h])}return c}e.distinctParents=F;var S;(function(T){T.META_DATA_LABEL="label",T.META_DATA_DESCRIPTION="description",T.META_DATA_SIZE="size",T.META_DATA_MIME="mime";function f(c){const h=new Map;c.path.substring(c.path.indexOf(";")+1,c.path.lastIndexOf(";")).split(";").forEach(I=>{const[l,b]=I.split(":");l&&b&&h.set(l,b)});const v=c.path.substring(0,c.path.indexOf(";"));return v&&h.set(T.META_DATA_MIME,v),h}T.parseMetaData=f})(S=e.DataUri||(e.DataUri={}));function m(T,f,c){if(f){let h=T.path;return h&&h[0]!==w.posix.sep&&(h=w.posix.sep+h),T.with({scheme:c,authority:f,path:h})}return T.with({scheme:c})}e.toLocalResource=m}),define(Ce[14],Ie([1,0,20,11,5,7,22,21]),function(te,e,r,y,w,L,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function E(be){return!!be&&typeof be.then=="function"}e.isThenable=E;function k(be){const ne=new r.CancellationTokenSource,Ee=be(ne.token),Pe=new Promise((Fe,$e)=>{const Qe=ne.token.onCancellationRequested(()=>{Qe.dispose(),ne.dispose(),$e(new y.CancellationError)});Promise.resolve(Ee).then(Te=>{Qe.dispose(),ne.dispose(),Fe(Te)},Te=>{Qe.dispose(),ne.dispose(),$e(Te)})});return new class{cancel(){ne.cancel()}then(Fe,$e){return Pe.then(Fe,$e)}catch(Fe){return this.then(void 0,Fe)}finally(Fe){return Pe.finally(Fe)}}}e.createCancelablePromise=k;function F(be,ne,Ee){return new Promise((Pe,Fe)=>{const $e=ne.onCancellationRequested(()=>{$e.dispose(),Pe(Ee)});be.then(Pe,Fe).finally(()=>$e.dispose())})}e.raceCancellation=F;function S(be,ne){return new Promise((Ee,Pe)=>{const Fe=ne.onCancellationRequested(()=>{Fe.dispose(),Pe(new y.CancellationError)});be.then(Ee,Pe).finally(()=>Fe.dispose())})}e.raceCancellationError=S;async function m(be){let ne=-1;const Ee=be.map((Fe,$e)=>Fe.then(Qe=>(ne=$e,Qe))),Pe=await Promise.race(Ee);return be.forEach((Fe,$e)=>{$e!==ne&&Fe.cancel()}),Pe}e.raceCancellablePromises=m;function T(be,ne,Ee){let Pe;const Fe=setTimeout(()=>{Pe?.(void 0),Ee?.()},ne);return Promise.race([be.finally(()=>clearTimeout(Fe)),new Promise($e=>Pe=$e)])}e.raceTimeout=T;function f(be){return new Promise((ne,Ee)=>{const Pe=be();E(Pe)?Pe.then(ne,Ee):ne(Pe)})}e.asPromise=f;class c{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(ne){if(this.activePromise){if(this.queuedPromiseFactory=ne,!this.queuedPromise){const Ee=()=>{this.queuedPromise=null;const Pe=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Pe};this.queuedPromise=new Promise(Pe=>{this.activePromise.then(Ee,Ee).then(Pe)})}return new Promise((Ee,Pe)=>{this.queuedPromise.then(Ee,Pe)})}return this.activePromise=ne(),new Promise((Ee,Pe)=>{this.activePromise.then(Fe=>{this.activePromise=null,Ee(Fe)},Fe=>{this.activePromise=null,Pe(Fe)})})}}e.Throttler=c;class h{constructor(){this.current=Promise.resolve(null)}queue(ne){return this.current=this.current.then(()=>ne(),()=>ne())}}e.Sequencer=h;class u{constructor(){this.promiseMap=new Map}queue(ne,Ee){const Fe=(this.promiseMap.get(ne)??Promise.resolve()).catch(()=>{}).then(Ee).finally(()=>{this.promiseMap.get(ne)===Fe&&this.promiseMap.delete(ne)});return this.promiseMap.set(ne,Fe),Fe}}e.SequencerByKey=u;const v=(be,ne)=>{let Ee=!0;const Pe=setTimeout(()=>{Ee=!1,ne()},be);return{isTriggered:()=>Ee,dispose:()=>{clearTimeout(Pe),Ee=!1}}},I=be=>{let ne=!0;return queueMicrotask(()=>{ne&&(ne=!1,be())}),{isTriggered:()=>ne,dispose:()=>{ne=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class l{constructor(ne){this.defaultDelay=ne,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(ne,Ee=this.defaultDelay){this.task=ne,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Fe,$e)=>{this.doResolve=Fe,this.doReject=$e}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Fe=this.task;return this.task=null,Fe()}}));const Pe=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=Ee===e.MicrotaskDelay?I(Pe):v(Ee,Pe),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new y.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=l;class b{constructor(ne){this.delayer=new l(ne),this.throttler=new c}trigger(ne,Ee){return this.delayer.trigger(()=>this.throttler.queue(ne),Ee)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=b;class t{constructor(){this._isOpen=!1,this._promise=new Promise((ne,Ee)=>{this._completePromise=ne})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=t;class d extends t{constructor(ne){super(),this._timeout=setTimeout(()=>this.open(),ne)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=d;function n(be,ne){return ne?new Promise((Ee,Pe)=>{const Fe=setTimeout(()=>{$e.dispose(),Ee()},be),$e=ne.onCancellationRequested(()=>{clearTimeout(Fe),$e.dispose(),Pe(new y.CancellationError)})}):k(Ee=>n(be,Ee))}e.timeout=n;function i(be,ne=0){const Ee=setTimeout(be,ne);return(0,L.toDisposable)(()=>clearTimeout(Ee))}e.disposableTimeout=i;function s(be){const ne=[];let Ee=0;const Pe=be.length;function Fe(){return Ee<Pe?be[Ee++]():null}function $e(Qe){Qe!=null&&ne.push(Qe);const Te=Fe();return Te?Te.then($e):Promise.resolve(ne)}return Promise.resolve(null).then($e)}e.sequence=s;function a(be,ne=Pe=>!!Pe,Ee=null){let Pe=0;const Fe=be.length,$e=()=>{if(Pe>=Fe)return Promise.resolve(Ee);const Qe=be[Pe++];return Promise.resolve(Qe()).then(_e=>ne(_e)?Promise.resolve(_e):$e())};return $e()}e.first=a;function o(be,ne=Pe=>!!Pe,Ee=null){if(be.length===0)return Promise.resolve(Ee);let Pe=be.length;const Fe=()=>{Pe=-1;for(const $e of be)$e.cancel?.()};return new Promise(($e,Qe)=>{for(const Te of be)Te.then(_e=>{--Pe>=0&&ne(_e)?(Fe(),$e(_e)):Pe===0&&$e(Ee)}).catch(_e=>{--Pe>=0&&(Fe(),Qe(_e))})})}e.firstParallel=o;class g{constructor(ne){this._size=0,this.maxDegreeOfParalellism=ne,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new w.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(ne){return this._size++,new Promise((Ee,Pe)=>{this.outstandingPromises.push({factory:ne,c:Ee,e:Pe}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const ne=this.outstandingPromises.shift();this.runningPromises++;const Ee=ne.factory();Ee.then(ne.c,ne.e),Ee.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=g;class p extends g{constructor(){super(1)}}e.Queue=p;class P{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const ne=new Z;return this.drainers.add(ne),ne.p}isDrained(){for(const[,ne]of this.queues)if(ne.size>0)return!1;return!0}queueFor(ne,Ee=_.extUri){const Pe=Ee.getComparisonKey(ne);let Fe=this.queues.get(Pe);return Fe||(Fe=new p,w.Event.once(Fe.onDrained)(()=>{Fe?.dispose(),this.queues.delete(Pe),this.onDidQueueDrain()}),this.queues.set(Pe,Fe)),Fe}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const ne of this.drainers)ne.complete();this.drainers.clear()}dispose(){for(const[,ne]of this.queues)ne.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=P;class M{constructor(ne,Ee){this._token=-1,typeof ne=="function"&&typeof Ee=="number"&&this.setIfNotSet(ne,Ee)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(ne,Ee){this.cancel(),this._token=setTimeout(()=>{this._token=-1,ne()},Ee)}setIfNotSet(ne,Ee){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,ne()},Ee))}}e.TimeoutTimer=M;class V{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(ne,Ee){this.cancel(),this._token=setInterval(()=>{ne()},Ee)}}e.IntervalTimer=V;class B{constructor(ne,Ee){this.timeoutToken=-1,this.runner=ne,this.timeout=Ee,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(ne=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,ne)}get delay(){return this.timeout}set delay(ne){this.timeout=ne}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=B;class D{constructor(ne,Ee){Ee%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Ee}ms is not a multiple of 1000ms.`),this.runner=ne,this.timeout=Ee,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(ne=this.timeout){ne%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ne}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(ne/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=D;class x extends B{constructor(ne,Ee){super(ne,Ee),this.units=[]}work(ne){this.units.push(ne),this.isScheduled()||this.schedule()}doRun(){const ne=this.units;this.units=[],this.runner?.(ne)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=x;class U extends L.Disposable{constructor(ne,Ee){super(),this.options=ne,this.handler=Ee,this.pendingWork=[],this.throttler=this._register(new L.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(ne){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+ne.length>this.options.maxBufferedWork)return!1}else if(this.pending+ne.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...ne),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new B(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=U,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=be=>{(0,A.setTimeout0)(()=>{if(ne)return;const Ee=Date.now()+15;be(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,Ee-Date.now())}}))});let ne=!1;return{dispose(){ne||(ne=!0)}}}:e.runWhenIdle=(be,ne)=>{const Ee=requestIdleCallback(be,typeof ne=="number"?{timeout:ne}:void 0);let Pe=!1;return{dispose(){Pe||(Pe=!0,cancelIdleCallback(Ee))}}}}();class R{constructor(ne){this._didRun=!1,this._executor=()=>{try{this._value=ne()}catch(Ee){this._error=Ee}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=R;async function K(be,ne,Ee){let Pe;for(let Fe=0;Fe<Ee;Fe++)try{return await be()}catch($e){Pe=$e,await n(ne)}throw Pe}e.retry=K;class W{hasPending(ne){return this._pending?typeof ne=="number"?this._pending.taskId===ne:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(ne,Ee,Pe){return this._pending={taskId:ne,cancel:()=>Pe?.(),promise:Ee},Ee.then(()=>this.donePending(ne),()=>this.donePending(ne)),Ee}donePending(ne){this._pending&&ne===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const ne=this._next;this._next=void 0,ne.run().then(ne.promiseResolve,ne.promiseReject)}}setNext(ne){if(this._next)this._next.run=ne;else{let Ee,Pe;const Fe=new Promise(($e,Qe)=>{Ee=$e,Pe=Qe});this._next={run:ne,promise:Fe,promiseResolve:Ee,promiseReject:Pe}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=W;class O{constructor(ne,Ee=()=>Date.now()){this.interval=ne,this.nowFn=Ee,this.lastIncrementTime=0,this.value=0}increment(){const ne=this.nowFn();return ne-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=ne,this.value=0),this.value++,this.value}}e.IntervalCounter=O;class Z{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((ne,Ee)=>{this.completeCallback=ne,this.errorCallback=Ee})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(ne){return new Promise(Ee=>{this.completeCallback(ne),this.resolved=!0,Ee()})}error(ne){return new Promise(Ee=>{this.errorCallback(ne),this.rejected=!0,Ee()})}cancel(){new Promise(ne=>{this.errorCallback(new y.CancellationError),this.rejected=!0,ne()})}}e.DeferredPromise=Z;var ue;(function(be){async function ne(Pe){let Fe;const $e=await Promise.all(Pe.map(Qe=>Qe.then(Te=>Te,Te=>{Fe||(Fe=Te)})));if(typeof Fe<"u")throw Fe;return $e}be.settled=ne;function Ee(Pe){return new Promise(async(Fe,$e)=>{try{await Pe(Fe,$e)}catch(Qe){$e(Qe)}})}be.withAsyncBody=Ee})(ue=e.Promises||(e.Promises={}));var oe;(function(be){be[be.Initial=0]="Initial",be[be.DoneOK=1]="DoneOK",be[be.DoneError=2]="DoneError"})(oe||(oe={}));class de{constructor(ne){this._state=0,this._results=[],this._error=null,this._onStateChanged=new w.Emitter,queueMicrotask(async()=>{const Ee={emitOne:Pe=>this.emitOne(Pe),emitMany:Pe=>this.emitMany(Pe),reject:Pe=>this.reject(Pe)};try{await Promise.resolve(ne(Ee)),this.resolve()}catch(Pe){this.reject(Pe)}finally{Ee.emitOne=void 0,Ee.emitMany=void 0,Ee.reject=void 0}})}static fromArray(ne){return new de(Ee=>{Ee.emitMany(ne)})}static fromPromise(ne){return new de(async Ee=>{Ee.emitMany(await ne)})}static fromPromises(ne){return new de(async Ee=>{await Promise.all(ne.map(async Pe=>Ee.emitOne(await Pe)))})}static merge(ne){return new de(async Ee=>{await Promise.all(ne.map(async Pe=>{for await(const Fe of Pe)Ee.emitOne(Fe)}))})}[Symbol.asyncIterator](){let ne=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(ne<this._results.length)return{done:!1,value:this._results[ne++]};if(this._state===1)return{done:!0,value:void 0};await w.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(ne,Ee){return new de(async Pe=>{for await(const Fe of ne)Pe.emitOne(Ee(Fe))})}map(ne){return de.map(this,ne)}static filter(ne,Ee){return new de(async Pe=>{for await(const Fe of ne)Ee(Fe)&&Pe.emitOne(Fe)})}filter(ne){return de.filter(this,ne)}static coalesce(ne){return de.filter(ne,Ee=>!!Ee)}coalesce(){return de.coalesce(this)}static async toPromise(ne){const Ee=[];for await(const Pe of ne)Ee.push(Pe);return Ee}toPromise(){return de.toPromise(this)}emitOne(ne){this._state===0&&(this._results.push(ne),this._onStateChanged.fire())}emitMany(ne){this._state===0&&(this._results=this._results.concat(ne),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(ne){this._state===0&&(this._state=2,this._error=ne,this._onStateChanged.fire())}}e.AsyncIterableObject=de,de.EMPTY=de.fromArray([]);class ie extends de{constructor(ne,Ee){super(Ee),this._source=ne}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ie;function ve(be){const ne=new r.CancellationTokenSource,Ee=be(ne.token);return new ie(ne,async Pe=>{const Fe=ne.token.onCancellationRequested(()=>{Fe.dispose(),ne.dispose(),Pe.reject(new y.CancellationError)});try{for await(const $e of Ee){if(ne.token.isCancellationRequested)return;Pe.emitOne($e)}Fe.dispose(),ne.dispose()}catch($e){Fe.dispose(),ne.dispose(),Pe.reject($e)}})}e.createCancelableAsyncIterable=ve}),define(Ce[117],Ie([1,0,14,19]),function(te,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const w=new r.IdleValue(()=>{const p=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:p,collatorIsNumeric:p.resolvedOptions().numeric}}),L=new r.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),_=new r.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function A(p,P,M=!1){const V=p||"",B=P||"",D=w.value.collator.compare(V,B);return w.value.collatorIsNumeric&&D===0&&V!==B?V<B?-1:1:D}e.compareFileNames=A;function E(p,P){const M=L.value.collator;return p=p||"",P=P||"",b(M,p,P)}e.compareFileNamesDefault=E;function k(p,P){const M=L.value.collator;return p=p||"",P=P||"",i(p,P)||b(M,p,P)}e.compareFileNamesUpper=k;function F(p,P){const M=L.value.collator;return p=p||"",P=P||"",n(p,P)||b(M,p,P)}e.compareFileNamesLower=F;function S(p,P){return p=p||"",P=P||"",p===P?0:p<P?-1:1}e.compareFileNamesUnicode=S;function m(p,P,M=!1){M||(p=p&&p.toLowerCase(),P=P&&P.toLowerCase());const[V,B]=I(p),[D,x]=I(P);return V!==D?V<D?-1:1:B===x?0:B<x?-1:1}e.noIntlCompareFileNames=m;function T(p,P){const[M,V]=I(p),[B,D]=I(P);let x=w.value.collator.compare(V,D);if(x===0){if(w.value.collatorIsNumeric&&V!==D)return V<D?-1:1;if(x=w.value.collator.compare(M,B),w.value.collatorIsNumeric&&x===0&&M!==B)return M<B?-1:1}return x}e.compareFileExtensions=T;function f(p,P){p=p||"",P=P||"";const M=l(p),V=l(P),B=L.value.collator,D=_.value.collator;return b(D,M,V)||b(B,p,P)}e.compareFileExtensionsDefault=f;function c(p,P){p=p||"",P=P||"";const M=l(p),V=l(P),B=L.value.collator,D=_.value.collator;return b(D,M,V)||i(p,P)||b(B,p,P)}e.compareFileExtensionsUpper=c;function h(p,P){p=p||"",P=P||"";const M=l(p),V=l(P),B=L.value.collator,D=_.value.collator;return b(D,M,V)||n(p,P)||b(B,p,P)}e.compareFileExtensionsLower=h;function u(p,P){p=p||"",P=P||"";const M=l(p).toLowerCase(),V=l(P).toLowerCase();return M!==V?M<V?-1:1:p!==P?p<P?-1:1:0}e.compareFileExtensionsUnicode=u;const v=/^(.*?)(\.([^.]*))?$/;function I(p,P=!1){const M=p?v.exec(p):[];let V=[M&&M[1]||"",M&&M[3]||""];return P&&(!V[0]&&V[1]||V[0]&&V[0].charAt(0)===".")&&(V=[V[0]+"."+V[1],""]),V}function l(p){const P=p?v.exec(p):[];return P&&P[1]&&P[1].charAt(0)!=="."&&P[3]||""}function b(p,P,M){const V=p.compare(P,M);return V!==0?V:P.length!==M.length?P.length<M.length?-1:1:0}function t(p){const P=p.charAt(0);return P.toLocaleUpperCase()!==P}function d(p){const P=p.charAt(0);return P.toLocaleLowerCase()!==P}function n(p,P){return t(p)&&d(P)?-1:d(p)&&t(P)?1:0}function i(p,P){return d(p)&&t(P)?-1:t(p)&&d(P)?1:0}function s(p,P,M=!1){return M||(p=p&&p.toLowerCase(),P=P&&P.toLowerCase()),p===P?0:p<P?-1:1}function a(p,P,M=!1){const V=p.split(y.sep),B=P.split(y.sep),D=V.length-1,x=B.length-1;let U,R;for(let K=0;;K++){if(U=D===K,R=x===K,U&&R)return A(V[K],B[K],M);if(U)return-1;if(R)return 1;const W=s(V[K],B[K],M);if(W!==0)return W}}e.comparePaths=a;function o(p,P,M){const V=p.toLowerCase(),B=P.toLowerCase(),D=g(p,P,M);if(D)return D;const x=V.endsWith(M),U=B.endsWith(M);if(x!==U)return x?-1:1;const R=A(V,B);return R!==0?R:V.localeCompare(B)}e.compareAnything=o;function g(p,P,M){const V=p.toLowerCase(),B=P.toLowerCase(),D=V.startsWith(M),x=B.startsWith(M);if(D!==x)return D?-1:1;if(D&&x){if(V.length<B.length)return-1;if(V.length>B.length)return 1}return 0}e.compareByPrefix=g}),define(Ce[34],Ie([1,0,16,14,37,25,19,21,9]),function(te,e,r,y,w,L,_,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const F="[/\\\\]",S="[^/\\\\]",m=/\//g;function T(Z,ue){switch(Z){case 0:return"";case 1:return`${S}*?`;default:return`(?:${F}|${S}+${F}${ue?`|${F}${S}+`:""})*?`}}function f(Z,ue){if(!Z)return[];const oe=[];let de=!1,ie=!1,ve="";for(const be of Z){switch(be){case ue:if(!de&&!ie){oe.push(ve),ve="";continue}break;case"{":de=!0;break;case"}":de=!1;break;case"[":ie=!0;break;case"]":ie=!1;break}ve+=be}return ve&&oe.push(ve),oe}e.splitGlobAware=f;function c(Z){if(!Z)return"";let ue="";const oe=f(Z,e.GLOB_SPLIT);if(oe.every(de=>de===e.GLOBSTAR))ue=".*";else{let de=!1;oe.forEach((ie,ve)=>{if(ie===e.GLOBSTAR){if(de)return;ue+=T(2,ve===oe.length-1)}else{let be=!1,ne="",Ee=!1,Pe="";for(const Fe of ie){if(Fe!=="}"&&be){ne+=Fe;continue}if(Ee&&(Fe!=="]"||!Pe)){let $e;Fe==="-"?$e=Fe:(Fe==="^"||Fe==="!")&&!Pe?$e="^":Fe===e.GLOB_SPLIT?$e="":$e=(0,E.escapeRegExpCharacters)(Fe),Pe+=$e;continue}switch(Fe){case"{":be=!0;continue;case"[":Ee=!0;continue;case"}":{ue+=`(?:${f(ne,",").map(Te=>c(Te)).join("|")})`,be=!1,ne="";break}case"]":{ue+="["+Pe+"]",Ee=!1,Pe="";break}case"?":ue+=S;continue;case"*":ue+=T(1);continue;default:ue+=(0,E.escapeRegExpCharacters)(Fe)}}ve<oe.length-1&&(oe[ve+1]!==e.GLOBSTAR||ve+2<oe.length)&&(ue+=F)}de=ie===e.GLOBSTAR})}return ue}const h=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,I=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,b=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new L.LRUCache(1e4),d=function(){return!1},n=function(){return null};function i(Z,ue){if(!Z)return n;let oe;typeof Z!="string"?oe=Z.pattern:oe=Z,oe=oe.trim();const de=`${oe}_${!!ue.trimForExclusions}`;let ie=t.get(de);if(ie)return s(ie,Z);let ve;return h.test(oe)?ie=o(oe.substr(4),oe):(ve=u.exec(a(oe,ue)))?ie=g(ve[1],oe):(ue.trimForExclusions?I:v).test(oe)?ie=p(oe,ue):(ve=l.exec(a(oe,ue)))?ie=P(ve[1].substr(1),oe,!0):(ve=b.exec(a(oe,ue)))?ie=P(ve[1],oe,!1):ie=M(oe),t.set(de,ie),s(ie,Z)}function s(Z,ue){if(typeof ue=="string")return Z;const oe=function(de,ie){return(0,w.isEqualOrParent)(de,ue.base,!A.isLinux)?Z(de.substr(ue.base.length+1),ie):null};return oe.allBasenames=Z.allBasenames,oe.allPaths=Z.allPaths,oe.basenames=Z.basenames,oe.patterns=Z.patterns,oe}function a(Z,ue){return ue.trimForExclusions&&Z.endsWith("/**")?Z.substr(0,Z.length-2):Z}function o(Z,ue){return function(oe,de){return typeof oe=="string"&&oe.endsWith(Z)?ue:null}}function g(Z,ue){const oe=`/${Z}`,de=`\\${Z}`,ie=function(be,ne){return typeof be!="string"?null:ne?ne===Z?ue:null:be===Z||be.endsWith(oe)||be.endsWith(de)?ue:null},ve=[Z];return ie.basenames=ve,ie.patterns=[ue],ie.allBasenames=ve,ie}function p(Z,ue){const oe=W(Z.slice(1,-1).split(",").map(ne=>i(ne,ue)).filter(ne=>ne!==n),Z),de=oe.length;if(!de)return n;if(de===1)return oe[0];const ie=function(ne,Ee){for(let Pe=0,Fe=oe.length;Pe<Fe;Pe++)if(oe[Pe](ne,Ee))return Z;return null},ve=oe.find(ne=>!!ne.allBasenames);ve&&(ie.allBasenames=ve.allBasenames);const be=oe.reduce((ne,Ee)=>Ee.allPaths?ne.concat(Ee.allPaths):ne,[]);return be.length&&(ie.allPaths=be),ie}function P(Z,ue,oe){const de=_.sep===_.posix.sep,ie=de?Z:Z.replace(m,_.sep),ve=_.sep+ie,be=_.posix.sep+Z;let ne;return oe?ne=function(Ee,Pe){return typeof Ee=="string"&&(Ee===ie||Ee.endsWith(ve)||!de&&(Ee===Z||Ee.endsWith(be)))?ue:null}:ne=function(Ee,Pe){return typeof Ee=="string"&&(Ee===ie||!de&&Ee===Z)?ue:null},ne.allPaths=[(oe?"*/":"./")+Z],ne}function M(Z){try{const ue=new RegExp(`^${c(Z)}$`);return function(oe){return ue.lastIndex=0,typeof oe=="string"&&ue.test(oe)?Z:null}}catch{return n}}function V(Z,ue,oe){return!Z||typeof ue!="string"?!1:B(Z)(ue,void 0,oe)}e.match=V;function B(Z,ue={}){if(!Z)return d;if(typeof Z=="string"||D(Z)){const oe=i(Z,ue);if(oe===n)return d;const de=function(ie,ve){return!!oe(ie,ve)};return oe.allBasenames&&(de.allBasenames=oe.allBasenames),oe.allPaths&&(de.allPaths=oe.allPaths),de}return R(Z,ue)}e.parse=B;function D(Z){const ue=Z;return ue?typeof ue.base=="string"&&typeof ue.pattern=="string":!1}e.isRelativePattern=D;function x(Z){return Z.allBasenames||[]}e.getBasenameTerms=x;function U(Z){return Z.allPaths||[]}e.getPathTerms=U;function R(Z,ue){const oe=W(Object.getOwnPropertyNames(Z).map(ne=>K(ne,Z[ne],ue)).filter(ne=>ne!==n)),de=oe.length;if(!de)return n;if(!oe.some(ne=>!!ne.requiresSiblings)){if(de===1)return oe[0];const ne=function(Fe,$e){let Qe;for(let Te=0,_e=oe.length;Te<_e;Te++){const ye=oe[Te](Fe,$e);if(typeof ye=="string")return ye;(0,y.isThenable)(ye)&&(Qe||(Qe=[]),Qe.push(ye))}return Qe?(async()=>{for(const Te of Qe){const _e=await Te;if(typeof _e=="string")return _e}return null})():null},Ee=oe.find(Fe=>!!Fe.allBasenames);Ee&&(ne.allBasenames=Ee.allBasenames);const Pe=oe.reduce((Fe,$e)=>$e.allPaths?Fe.concat($e.allPaths):Fe,[]);return Pe.length&&(ne.allPaths=Pe),ne}const ie=function(ne,Ee,Pe){let Fe,$e;for(let Qe=0,Te=oe.length;Qe<Te;Qe++){const _e=oe[Qe];_e.requiresSiblings&&Pe&&(Ee||(Ee=(0,_.basename)(ne)),Fe||(Fe=Ee.substr(0,Ee.length-(0,_.extname)(ne).length)));const ye=_e(ne,Ee,Fe,Pe);if(typeof ye=="string")return ye;(0,y.isThenable)(ye)&&($e||($e=[]),$e.push(ye))}return $e?(async()=>{for(const Qe of $e){const Te=await Qe;if(typeof Te=="string")return Te}return null})():null},ve=oe.find(ne=>!!ne.allBasenames);ve&&(ie.allBasenames=ve.allBasenames);const be=oe.reduce((ne,Ee)=>Ee.allPaths?ne.concat(Ee.allPaths):ne,[]);return be.length&&(ie.allPaths=be),ie}function K(Z,ue,oe){if(ue===!1)return n;const de=i(Z,oe);if(de===n)return n;if(typeof ue=="boolean")return de;if(ue){const ie=ue.when;if(typeof ie=="string"){const ve=(be,ne,Ee,Pe)=>{if(!Pe||!de(be,ne))return null;const Fe=ie.replace("$(basename)",Ee),$e=Pe(Fe);return(0,y.isThenable)($e)?$e.then(Qe=>Qe?Z:null):$e?Z:null};return ve.requiresSiblings=!0,ve}}return de}function W(Z,ue){const oe=Z.filter(ne=>!!ne.basenames);if(oe.length<2)return Z;const de=oe.reduce((ne,Ee)=>{const Pe=Ee.basenames;return Pe?ne.concat(Pe):ne},[]);let ie;if(ue){ie=[];for(let ne=0,Ee=de.length;ne<Ee;ne++)ie.push(ue)}else ie=oe.reduce((ne,Ee)=>{const Pe=Ee.patterns;return Pe?ne.concat(Pe):ne},[]);const ve=function(ne,Ee){if(typeof ne!="string")return null;if(!Ee){let Fe;for(Fe=ne.length;Fe>0;Fe--){const $e=ne.charCodeAt(Fe-1);if($e===47||$e===92)break}Ee=ne.substr(Fe)}const Pe=de.indexOf(Ee);return Pe!==-1?ie[Pe]:null};ve.basenames=de,ve.patterns=ie,ve.allBasenames=de;const be=Z.filter(ne=>!ne.basenames);return be.push(ve),be}function O(Z,ue){return(0,r.equals)(Z,ue,(oe,de)=>typeof oe=="string"&&typeof de=="string"?oe===de:typeof oe!="string"&&typeof de!="string"?oe.base===de.base&&oe.pattern===de.pattern:!1)}e.patternsEquals=O}),define(Ce[76],Ie([1,0,11,115,22,9,2]),function(te,e,r,y,w,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(h){h[h.Paragraph=0]="Paragraph",h[h.Break=1]="Break"})(A=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class E{constructor(u="",v=!1){if(this.value=u,typeof this.value!="string")throw(0,r.illegalArgument)("value");typeof v=="boolean"?(this.isTrusted=v,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=v.isTrusted??void 0,this.supportThemeIcons=v.supportThemeIcons??!1,this.supportHtml=v.supportHtml??!1)}appendText(u,v=0){return this.value+=m(this.supportThemeIcons?(0,y.escapeIcons)(u):u).replace(/([ \t]+)/g,(I,l)=>"&nbsp;".repeat(l.length)).replace(/\>/gm,"\\>").replace(/\n/g,v===1?`\\
`:`

`),this}appendMarkdown(u){return this.value+=u,this}appendCodeblock(u,v){return this.value+="\n```",this.value+=u,this.value+=`
`,this.value+=v,this.value+="\n```\n",this}appendLink(u,v,I){return this.value+="[",this.value+=this._escape(v,"]"),this.value+="](",this.value+=this._escape(String(u),")"),I&&(this.value+=` "${this._escape(this._escape(I,'"'),")")}"`),this.value+=")",this}_escape(u,v){const I=new RegExp((0,L.escapeRegExpCharacters)(v),"g");return u.replace(I,(l,b)=>u.charAt(b-1)!=="\\"?`\\${l}`:l)}}e.MarkdownString=E;function k(h){return F(h)?!h.value:Array.isArray(h)?h.every(k):!0}e.isEmptyMarkdownString=k;function F(h){return h instanceof E?!0:h&&typeof h=="object"?typeof h.value=="string"&&(typeof h.isTrusted=="boolean"||h.isTrusted===void 0)&&(typeof h.supportThemeIcons=="boolean"||h.supportThemeIcons===void 0):!1}e.isMarkdownString=F;function S(h,u){return h===u?!0:!h||!u?!1:h.value===u.value&&h.isTrusted===u.isTrusted&&h.supportThemeIcons===u.supportThemeIcons&&h.supportHtml===u.supportHtml&&(h.baseUri===u.baseUri||!!h.baseUri&&!!u.baseUri&&(0,w.isEqual)(_.URI.from(h.baseUri),_.URI.from(u.baseUri)))}e.markdownStringEqual=S;function m(h){return h.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=m;function T(h){return h.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=T;function f(h){return h&&h.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=f;function c(h){const u=[],v=h.split("|").map(l=>l.trim());h=v[0];const I=v[1];if(I){const l=/height=(\d+)/.exec(I),b=/width=(\d+)/.exec(I),t=l?l[1]:"",d=b?b[1]:"",n=isFinite(parseInt(d)),i=isFinite(parseInt(t));n&&u.push(`width="${d}"`),i&&u.push(`height="${t}"`)}return{href:h,dimensions:u}}e.parseHrefAndDimensions=c}),define(Ce[77],Ie([1,0,16,37,19,21,22,9]),function(te,e,r,y,w,L,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function E(n,i){const{os:s,tildify:a,relative:o}=i;if(o){const P=k(n,o,s);if(typeof P=="string")return P}let g=n.fsPath;if(s===1&&!L.isWindows?g=g.replace(/\//g,"\\"):s!==1&&L.isWindows&&(g=g.replace(/\\/g,"/")),s!==1&&a?.userHome){const P=a.userHome.fsPath;let M;n.scheme!==a.userHome.scheme&&n.path.startsWith(w.posix.sep)?M=a.userHome.with({path:n.path}).fsPath:M=n.fsPath,g=m(M,P,s)}return(s===1?w.win32:w.posix).normalize(F(g,s===1))}e.getPathLabel=E;function k(n,i,s){const a=s===1?w.win32:w.posix,o=s===3?_.extUri:_.extUriIgnorePathCase,g=i.getWorkspace(),p=(0,r.firstOrDefault)(g.folders);if(!p)return;n.scheme!==p.uri.scheme&&n.path.startsWith(w.posix.sep)&&(n=p.uri.with({path:n.path}));const P=i.getWorkspaceFolder(n);if(!P)return;let M;if(o.isEqual(P.uri,n)?M="":M=o.relativePath(P.uri,n)??"",M&&(M=a.normalize(M)),g.folders.length>1&&!i.noPrefix){const V=P.name?P.name:o.basenameOrAuthority(P.uri);M=M?`${V} \u2022 ${M}`:V}return M}function F(n,i=L.isWindows){return(0,y.hasDriveLetter)(n,i)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=F;let S=Object.create(null);function m(n,i,s=L.OS){if(s===1||!n||!i)return n;let a=S.original===i?S.normalized:void 0;a||(a=i,L.isWindows&&(a=(0,y.toSlashes)(a)),a=`${(0,A.rtrim)(a,w.posix.sep)}${w.posix.sep}`,S={original:i,normalized:a});let o=n;return L.isWindows&&(o=(0,y.toSlashes)(o)),(s===3?o.startsWith(a):(0,A.startsWithIgnoreCase)(o,a))?`~/${o.substr(a.length)}`:n}e.tildify=m;function T(n,i){return n.replace(/^~($|\/|\\)/,`${i}$1`)}e.untildify=T;const f="\u2026",c="\\\\",h="~";function u(n,i=w.sep){const s=new Array(n.length);let a=!1;for(let o=0;o<n.length;o++){const g=n[o];if(g===""){s[o]=`.${i}`;continue}if(!g){s[o]=g;continue}a=!0;let p="",P=g;P.indexOf(c)===0?(p=P.substr(0,P.indexOf(c)+c.length),P=P.substr(P.indexOf(c)+c.length)):P.indexOf(i)===0?(p=P.substr(0,P.indexOf(i)+i.length),P=P.substr(P.indexOf(i)+i.length)):P.indexOf(h)===0&&(p=P.substr(0,P.indexOf(h)+h.length),P=P.substr(P.indexOf(h)+h.length));const M=P.split(i);for(let V=1;a&&V<=M.length;V++)for(let B=M.length-V;a&&B>=0;B--){a=!1;let D=M.slice(B,B+V).join(i);for(let x=0;!a&&x<n.length;x++)if(x!==o&&n[x]&&n[x].indexOf(D)>-1){const U=B+V===M.length,R=B>0&&n[x].indexOf(i)>-1?i+D:D,K=n[x].endsWith(R);a=!U||K}if(!a){let x="";(M[0].endsWith(":")||p!=="")&&(B===1&&(B=0,V++,D=M[0]+i+D),B>0&&(x=M[0]+i),x=p+x),B>0&&(x=x+f+i),x=x+D,B+V<M.length&&(x=x+i+f),s[o]=x}}a&&(s[o]=g)}return s}e.shorten=u;var v;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(v||(v={}));function I(n,i=Object.create(null)){const s=[];let a=!1,o="";for(const g of n)if(g==="$"||a&&g==="{")o&&s.push({value:o,type:v.TEXT}),o="",a=!0;else if(g==="}"&&a){const p=i[o];if(typeof p=="string")p.length&&s.push({value:p,type:v.VARIABLE});else if(p){const P=s[s.length-1];(!P||P.type!==v.SEPARATOR)&&s.push({value:p.label,type:v.SEPARATOR})}o="",a=!1}else o+=g;return o&&!a&&s.push({value:o,type:v.TEXT}),s.filter((g,p)=>{if(g.type===v.SEPARATOR){const P=s[p-1],M=s[p+1];return[P,M].every(V=>V&&(V.type===v.VARIABLE||V.type===v.TEXT)&&V.value.length>0)}return!0}).map(g=>g.value).join("")}e.template=I;function l(n,i){return L.isMacintosh||i?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.isMacintosh?"&":"&&"):n.replace(/&&|&/g,s=>s==="&"?"&&":"&")}e.mnemonicMenuLabel=l;function b(n,i){return L.isMacintosh||i?n.replace(/\(&&\w\)|&&/g,""):L.isWindows?n.replace(/&&|&/g,s=>s==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=b;function t(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=t;function d(n){const i=n.indexOf("/")!==-1?w.posix:w.win32,s=i.basename(n),a=i.dirname(n);return s.length?{name:s,parentPath:a}:{name:a,parentPath:""}}e.splitName=d}),define(Ce[118],Ie([1,0,2]),function(te,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function y(F){return F.toJSON()}class w{constructor(S){this._uriTransformer=S}transformIncoming(S){const m=this._uriTransformer.transformIncoming(S);return m===S?S:y(r.URI.from(m))}transformOutgoing(S){const m=this._uriTransformer.transformOutgoing(S);return m===S?S:y(r.URI.from(m))}transformOutgoingURI(S){const m=this._uriTransformer.transformOutgoing(S);return m===S?S:r.URI.from(m)}transformOutgoingScheme(S){return this._uriTransformer.transformOutgoingScheme(S)}}e.URITransformer=w,e.DefaultURITransformer=new class{transformIncoming(F){return F}transformOutgoing(F){return F}transformOutgoingURI(F){return F}transformOutgoingScheme(F){return F}};function L(F,S,m){if(!F||m>200)return null;if(typeof F=="object"){if(F instanceof r.URI)return S.transformOutgoing(F);for(const T in F)if(Object.hasOwnProperty.call(F,T)){const f=L(F[T],S,m+1);f!==null&&(F[T]=f)}}return null}function _(F,S){const m=L(F,S,0);return m===null?F:m}e.transformOutgoingURIs=_;function A(F,S,m,T){if(!F||T>200)return null;if(typeof F=="object"){if(F.$mid===1)return m?r.URI.revive(S.transformIncoming(F)):S.transformIncoming(F);for(const f in F)if(Object.hasOwnProperty.call(F,f)){const c=A(F[f],S,m,T+1);c!==null&&(F[f]=c)}}return null}function E(F,S){const m=A(F,S,!1,0);return m===null?F:m}e.transformIncomingURIs=E;function k(F,S){const m=A(F,S,!0,0);return m===null?F:m}e.transformAndReviveIncomingURIs=k}),define(Ce[119],Ie([1,0,34,19]),function(te,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function w(L,_,A,E,k,F){if(Array.isArray(L)){let S=0;for(const m of L){const T=w(m,_,A,E,k,F);if(T===10)return T;T>S&&(S=T)}return S}else{if(typeof L=="string")return E?L==="*"?5:L===A?10:0:0;if(L){const{language:S,pattern:m,scheme:T,hasAccessToAllModels:f,notebookType:c}=L;if(!E&&!f)return 0;c&&k&&(_=k);let h=0;if(T)if(T===_.scheme)h=10;else if(T==="*")h=5;else return 0;if(S)if(S===A)h=10;else if(S==="*")h=Math.max(h,5);else return 0;if(c)if(c===F)h=10;else if(c==="*"&&F!==void 0)h=Math.max(h,5);else return 0;if(m){let u;if(typeof m=="string"?u=m:u={...m,base:(0,y.normalize)(m.base)},u===_.fsPath||(0,r.match)(u,_.fsPath))h=10;else return 0}return h}else return 0}}e.score=w}),define(Ce[78],Ie([1,0,23,21]),function(te,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var w;(function(S){S[S.Full=1]="Full",S[S.Delta=2]="Delta"})(w||(w={}));function L(S){for(let m=0,T=S.length;m<T;m+=4){const f=S[m+0],c=S[m+1],h=S[m+2],u=S[m+3];S[m+0]=u,S[m+1]=h,S[m+2]=c,S[m+3]=f}}function _(S){const m=new Uint8Array(S.buffer,S.byteOffset,S.length*4);return y.isLittleEndian()||L(m),r.VSBuffer.wrap(m)}function A(S){const m=S.buffer;if(y.isLittleEndian()||L(m),m.byteOffset%4===0)return new Uint32Array(m.buffer,m.byteOffset,m.length/4);{const T=new Uint8Array(m.byteLength);return T.set(m),new Uint32Array(T.buffer,T.byteOffset,T.length/4)}}function E(S){const m=new Uint32Array(k(S));let T=0;if(m[T++]=S.id,S.type==="full")m[T++]=1,m[T++]=S.data.length,m.set(S.data,T),T+=S.data.length;else{m[T++]=2,m[T++]=S.deltas.length;for(const f of S.deltas)m[T++]=f.start,m[T++]=f.deleteCount,f.data?(m[T++]=f.data.length,m.set(f.data,T),T+=f.data.length):m[T++]=0}return _(m)}e.encodeSemanticTokensDto=E;function k(S){let m=0;if(m+=1+1,S.type==="full")m+=1+S.data.length;else{m+=1,m+=(1+1+1)*S.deltas.length;for(const T of S.deltas)T.data&&(m+=T.data.length)}return m}function F(S){const m=A(S);let T=0;const f=m[T++];if(m[T++]===1){const v=m[T++],I=m.subarray(T,T+v);return T+=v,{id:f,type:"full",data:I}}const h=m[T++],u=[];for(let v=0;v<h;v++){const I=m[T++],l=m[T++],b=m[T++];let t;b>0&&(t=m.subarray(T,T+b),T+=b),u[v]={start:I,deleteCount:l,data:t}}return{id:f,type:"delta",deltas:u}}e.decodeSemanticTokensDto=F}),define(Ce[120],Ie([17,18]),function(te,e){return te.create("vs/editor/common/config/editorOptions",e)}),define(Ce[121],Ie([1,0,120,21,122,16,26,109]),function(te,e,r,y,w,L,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var E;(function(G){G[G.None=0]="None",G[G.Keep=1]="Keep",G[G.Brackets=2]="Brackets",G[G.Advanced=3]="Advanced",G[G.Full=4]="Full"})(E=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(X){this._values=X}hasChanged(X){return this._values[X]}}e.ConfigurationChangedEvent=k;class F{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=F;class S{constructor(X,fe,Ue,We){this.id=X,this.name=fe,this.defaultValue=Ue,this.schema=We}applyUpdate(X,fe){return T(X,fe)}compute(X,fe,Ue){return Ue}}class m{constructor(X,fe){this.newValue=X,this.didChange=fe}}e.ApplyUpdateResult=m;function T(G,X){if(typeof G!="object"||typeof X!="object"||!G||!X)return new m(X,G!==X);if(Array.isArray(G)||Array.isArray(X)){const Ue=Array.isArray(G)&&Array.isArray(X)&&L.equals(G,X);return new m(X,!Ue)}let fe=!1;for(const Ue in X)if(X.hasOwnProperty(Ue)){const We=T(G[Ue],X[Ue]);We.didChange&&(G[Ue]=We.newValue,fe=!0)}return new m(G,fe)}class f{constructor(X){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0}applyUpdate(X,fe){return T(X,fe)}validate(X){return this.defaultValue}}class c{constructor(X,fe,Ue,We){this.id=X,this.name=fe,this.defaultValue=Ue,this.schema=We}applyUpdate(X,fe){return T(X,fe)}validate(X){return typeof X>"u"?this.defaultValue:X}compute(X,fe,Ue){return Ue}}function h(G,X){return typeof G>"u"?X:G==="false"?!1:Boolean(G)}e.boolean=h;class u extends c{constructor(X,fe,Ue,We=void 0){typeof We<"u"&&(We.type="boolean",We.default=Ue),super(X,fe,Ue,We)}validate(X){return h(X,this.defaultValue)}}function v(G,X,fe,Ue){if(typeof G>"u")return X;let We=parseInt(G,10);return isNaN(We)?X:(We=Math.max(fe,We),We=Math.min(Ue,We),We|0)}e.clampedInt=v;class I extends c{constructor(X,fe,Ue,We,et,qe=void 0){typeof qe<"u"&&(qe.type="integer",qe.default=Ue,qe.minimum=We,qe.maximum=et),super(X,fe,Ue,qe),this.minimum=We,this.maximum=et}static clampedInt(X,fe,Ue,We){return v(X,fe,Ue,We)}validate(X){return I.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}class l extends c{constructor(X,fe,Ue,We,et){typeof et<"u"&&(et.type="number",et.default=Ue),super(X,fe,Ue,et),this.validationFn=We}static clamp(X,fe,Ue){return X<fe?fe:X>Ue?Ue:X}static float(X,fe){if(typeof X=="number")return X;if(typeof X>"u")return fe;const Ue=parseFloat(X);return isNaN(Ue)?fe:Ue}validate(X){return this.validationFn(l.float(X,this.defaultValue))}}class b extends c{static string(X,fe){return typeof X!="string"?fe:X}constructor(X,fe,Ue,We=void 0){typeof We<"u"&&(We.type="string",We.default=Ue),super(X,fe,Ue,We)}validate(X){return b.string(X,this.defaultValue)}}function t(G,X,fe){return typeof G!="string"||fe.indexOf(G)===-1?X:G}e.stringSet=t;class d extends c{constructor(X,fe,Ue,We,et=void 0){typeof et<"u"&&(et.type="string",et.enum=We,et.default=Ue),super(X,fe,Ue,et),this._allowedValues=We}validate(X){return t(X,this.defaultValue,this._allowedValues)}}class n extends S{constructor(X,fe,Ue,We,et,qe,Ve=void 0){typeof Ve<"u"&&(Ve.type="string",Ve.enum=et,Ve.default=We),super(X,fe,Ue,Ve),this._allowedValues=et,this._convert=qe}validate(X){return typeof X!="string"?this.defaultValue:this._allowedValues.indexOf(X)===-1?this.defaultValue:this._convert(X)}}function i(G){switch(G){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class s extends S{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[r.localize(0,null),r.localize(1,null),r.localize(2,null)],default:"auto",description:r.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,fe,Ue){return Ue===0?X.accessibilitySupport:Ue}}class a extends S{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:r.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:r.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{insertSpace:h(fe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:h(fe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var o;(function(G){G[G.Hidden=0]="Hidden",G[G.Blink=1]="Blink",G[G.Smooth=2]="Smooth",G[G.Phase=3]="Phase",G[G.Expand=4]="Expand",G[G.Solid=5]="Solid"})(o=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function g(G){switch(G){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var p;(function(G){G[G.Line=1]="Line",G[G.Block=2]="Block",G[G.Underline=3]="Underline",G[G.LineThin=4]="LineThin",G[G.BlockOutline=5]="BlockOutline",G[G.UnderlineThin=6]="UnderlineThin"})(p=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function P(G){switch(G){case p.Line:return"line";case p.Block:return"block";case p.Underline:return"underline";case p.LineThin:return"line-thin";case p.BlockOutline:return"block-outline";case p.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=P;function M(G){switch(G){case"line":return p.Line;case"block":return p.Block;case"underline":return p.Underline;case"line-thin":return p.LineThin;case"block-outline":return p.BlockOutline;case"underline-thin":return p.UnderlineThin}}class V extends f{constructor(){super(130)}compute(X,fe,Ue){const We=["monaco-editor"];return fe.get(34)&&We.push(fe.get(34)),X.extraEditorClassName&&We.push(X.extraEditorClassName),fe.get(67)==="default"?We.push("mouse-default"):fe.get(67)==="copy"&&We.push("mouse-copy"),fe.get(101)&&We.push("showUnused"),fe.get(128)&&We.push("showDeprecated"),We.join(" ")}}class B extends u{constructor(){super(33,"emptySelectionClipboard",!0,{description:r.localize(6,null)})}compute(X,fe,Ue){return Ue&&X.emptySelectionClipboard}}class D extends S{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(36,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:r.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[r.localize(8,null),r.localize(9,null),r.localize(10,null)],description:r.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[r.localize(12,null),r.localize(13,null),r.localize(14,null)],description:r.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:r.localize(16,null),included:y.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:r.localize(17,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:r.localize(18,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{cursorMoveOnType:h(fe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":t(fe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":t(fe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:h(fe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:h(fe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:h(fe.loop,this.defaultValue.loop)}}}class x extends S{constructor(){super(46,"fontLigatures",x.OFF,{anyOf:[{type:"boolean",description:r.localize(19,null)},{type:"string",description:r.localize(20,null)}],description:r.localize(21,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?x.OFF:X==="true"?x.ON:X:Boolean(X)?x.ON:x.OFF}}e.EditorFontLigatures=x,x.OFF='"liga" off, "calt" off',x.ON='"liga" on, "calt" on';class U extends f{constructor(){super(45)}compute(X,fe,Ue){return X.fontInfo}}class R extends c{constructor(){super(47,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:r.localize(22,null)})}validate(X){const fe=l.float(X,this.defaultValue);return fe===0?e.EDITOR_FONT_DEFAULTS.fontSize:l.clamp(fe,6,100)}compute(X,fe,Ue){return X.fontInfo.fontSize}}class K extends S{constructor(){super(48,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:K.MINIMUM_VALUE,maximum:K.MAXIMUM_VALUE,errorMessage:r.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:K.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:r.localize(24,null)})}validate(X){return X==="normal"||X==="bold"?X:String(I.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,K.MINIMUM_VALUE,K.MAXIMUM_VALUE))}}K.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],K.MINIMUM_VALUE=1,K.MAXIMUM_VALUE=1e3;class W extends S{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},fe={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[r.localize(25,null),r.localize(26,null),r.localize(27,null)]},Ue=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(52,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:r.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:r.localize(29,null),...fe},"editor.gotoLocation.multipleTypeDefinitions":{description:r.localize(30,null),...fe},"editor.gotoLocation.multipleDeclarations":{description:r.localize(31,null),...fe},"editor.gotoLocation.multipleImplementations":{description:r.localize(32,null),...fe},"editor.gotoLocation.multipleReferences":{description:r.localize(33,null),...fe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:Ue,description:r.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:Ue,description:r.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:Ue,description:r.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:Ue,description:r.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:Ue,description:r.localize(38,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{multiple:t(fe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:fe.multipleDefinitions??t(fe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:fe.multipleTypeDefinitions??t(fe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:fe.multipleDeclarations??t(fe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:fe.multipleImplementations??t(fe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:fe.multipleReferences??t(fe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:b.string(fe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:b.string(fe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:b.string(fe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:b.string(fe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:b.string(fe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class O extends S{constructor(){const X={enabled:!0,delay:300,sticky:!0,above:!0};super(54,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:r.localize(39,null)},"editor.hover.delay":{type:"number",default:X.delay,minimum:0,maximum:1e4,description:r.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:r.localize(41,null)},"editor.hover.above":{type:"boolean",default:X.above,description:r.localize(42,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{enabled:h(fe.enabled,this.defaultValue.enabled),delay:I.clampedInt(fe.delay,this.defaultValue.delay,0,1e4),sticky:h(fe.sticky,this.defaultValue.sticky),above:h(fe.above,this.defaultValue.above)}}}var Z;(function(G){G[G.None=0]="None",G[G.Text=1]="Text",G[G.Blocks=2]="Blocks"})(Z=e.RenderMinimap||(e.RenderMinimap={}));class ue extends f{constructor(){super(133)}compute(X,fe,Ue){return ue.computeLayout(fe,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio})}static computeContainedMinimapLineCount(X){const fe=X.height/X.lineHeight,Ue=X.scrollBeyondLastLine?fe-1:0,We=(X.viewLineCount+Ue)/(X.pixelRatio*X.height),et=Math.floor(X.viewLineCount/We);return{typicalViewportLineCount:fe,extraLinesBeyondLastLine:Ue,desiredRatio:We,minimapLineCount:et}}static _computeMinimapLayout(X,fe){const Ue=X.outerWidth,We=X.outerHeight,et=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(et*We),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:We};const qe=fe.stableMinimapLayoutInput,Ve=qe&&X.outerHeight===qe.outerHeight&&X.lineHeight===qe.lineHeight&&X.typicalHalfwidthCharacterWidth===qe.typicalHalfwidthCharacterWidth&&X.pixelRatio===qe.pixelRatio&&X.scrollBeyondLastLine===qe.scrollBeyondLastLine&&X.minimap.enabled===qe.minimap.enabled&&X.minimap.side===qe.minimap.side&&X.minimap.size===qe.minimap.size&&X.minimap.showSlider===qe.minimap.showSlider&&X.minimap.renderCharacters===qe.minimap.renderCharacters&&X.minimap.maxColumn===qe.minimap.maxColumn&&X.minimap.scale===qe.minimap.scale&&X.verticalScrollbarWidth===qe.verticalScrollbarWidth&&X.isViewportWrapping===qe.isViewportWrapping,it=X.lineHeight,st=X.typicalHalfwidthCharacterWidth,dt=X.scrollBeyondLastLine,at=X.minimap.renderCharacters;let rt=et>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const _t=X.minimap.maxColumn,Rt=X.minimap.size,Ot=X.minimap.side,mt=X.verticalScrollbarWidth,Dt=X.viewLineCount,Nt=X.remainingWidth,Mt=X.isViewportWrapping,je=at?2:3;let Ut=Math.floor(et*We);const Ft=Ut/et;let Tt=!1,gt=!1,yt=je*rt,Se=rt/et,De=1;if(Rt==="fill"||Rt==="fit"){const{typicalViewportLineCount:Ke,extraLinesBeyondLastLine:ct,desiredRatio:Ct,minimapLineCount:pt}=ue.computeContainedMinimapLineCount({viewLineCount:Dt,scrollBeyondLastLine:dt,height:We,lineHeight:it,pixelRatio:et});if(Dt/pt>1)Tt=!0,gt=!0,rt=1,yt=1,Se=rt/et;else{let bt=!1,vt=rt+1;if(Rt==="fit"){const wt=Math.ceil((Dt+ct)*yt);Mt&&Ve&&Nt<=fe.stableFitRemainingWidth?(bt=!0,vt=fe.stableFitMaxMinimapScale):bt=wt>Ut}if(Rt==="fill"||bt){Tt=!0;const wt=rt;yt=Math.min(it*et,Math.max(1,Math.floor(1/Ct))),Mt&&Ve&&Nt<=fe.stableFitRemainingWidth&&(vt=fe.stableFitMaxMinimapScale),rt=Math.min(vt,Math.max(1,Math.floor(yt/je))),rt>wt&&(De=Math.min(2,rt/wt)),Se=rt/et/De,Ut=Math.ceil(Math.max(Ke,Dt+ct)*yt),Mt?(fe.stableMinimapLayoutInput=X,fe.stableFitRemainingWidth=Nt,fe.stableFitMaxMinimapScale=rt):(fe.stableMinimapLayoutInput=null,fe.stableFitRemainingWidth=0)}}}const me=Math.floor(_t*Se),q=Math.min(me,Math.max(0,Math.floor((Nt-mt-2)*Se/(st+Se)))+e.MINIMAP_GUTTER_WIDTH);let Ae=Math.floor(et*q);const Le=Ae/et;Ae=Math.floor(Ae*De);const tt=at?1:2,Ge=Ot==="left"?0:Ue-q-mt;return{renderMinimap:tt,minimapLeft:Ge,minimapWidth:q,minimapHeightIsEditorHeight:Tt,minimapIsSampling:gt,minimapScale:rt,minimapLineHeight:yt,minimapCanvasInnerWidth:Ae,minimapCanvasInnerHeight:Ut,minimapCanvasOuterWidth:Le,minimapCanvasOuterHeight:Ft}}static computeLayout(X,fe){const Ue=fe.outerWidth|0,We=fe.outerHeight|0,et=fe.lineHeight|0,qe=fe.lineNumbersDigitCount|0,Ve=fe.typicalHalfwidthCharacterWidth,it=fe.maxDigitWidth,st=fe.pixelRatio,dt=fe.viewLineCount,at=X.get(125),rt=at==="inherit"?X.get(124):at,_t=rt==="inherit"?X.get(120):rt,Rt=X.get(123),Ot=X.get(2),mt=fe.isDominatedByLongLines,Dt=X.get(51),Nt=X.get(61).renderType!==0,Mt=X.get(62),je=X.get(95),Ut=X.get(66),Ft=X.get(93),Tt=Ft.verticalScrollbarSize,gt=Ft.verticalHasArrows,yt=Ft.arrowSize,Se=Ft.horizontalScrollbarSize,De=X.get(59),me=X.get(38),q=X.get(100)!=="never";let Ae;if(typeof De=="string"&&/^\d+(\.\d+)?ch$/.test(De)){const Wt=parseFloat(De.substr(0,De.length-2));Ae=I.clampedInt(Wt*Ve,0,0,1e3)}else Ae=I.clampedInt(De,0,0,1e3);me&&q&&(Ae+=16);let Le=0;if(Nt){const Wt=Math.max(qe,Mt);Le=Math.round(Wt*it)}let tt=0;Dt&&(tt=et);let Ge=0,Ke=Ge+tt,ct=Ke+Le,Ct=ct+Ae;const pt=Ue-tt-Le-Ae;let It=!1,bt=!1,vt=-1;Ot!==2&&(rt==="inherit"&&mt?(It=!0,bt=!0):_t==="on"||_t==="bounded"?bt=!0:_t==="wordWrapColumn"&&(vt=Rt));const wt=ue._computeMinimapLayout({outerWidth:Ue,outerHeight:We,lineHeight:et,typicalHalfwidthCharacterWidth:Ve,pixelRatio:st,scrollBeyondLastLine:je,minimap:Ut,verticalScrollbarWidth:Tt,viewLineCount:dt,remainingWidth:pt,isViewportWrapping:bt},fe.memory||new F);wt.renderMinimap!==0&&wt.minimapLeft===0&&(Ge+=wt.minimapWidth,Ke+=wt.minimapWidth,ct+=wt.minimapWidth,Ct+=wt.minimapWidth);const ti=pt-wt.minimapWidth,Et=Math.max(1,Math.floor((ti-Tt-2)/Ve)),$t=gt?yt:0;return bt&&(vt=Math.max(1,Et),_t==="bounded"&&(vt=Math.min(vt,Rt))),{width:Ue,height:We,glyphMarginLeft:Ge,glyphMarginWidth:tt,lineNumbersLeft:Ke,lineNumbersWidth:Le,decorationsLeft:ct,decorationsWidth:Ae,contentLeft:Ct,contentWidth:ti,minimap:wt,viewportColumn:Et,isWordWrapMinified:It,isViewportWrapping:bt,wrappingColumn:vt,verticalScrollbarWidth:Tt,horizontalScrollbarHeight:Se,overviewRuler:{top:$t,width:Tt,height:We-2*$t,right:0}}}}e.EditorLayoutInfoComputer=ue;class oe extends S{constructor(){const X={enabled:!0};super(58,"lightbulb",X,{"editor.lightbulb.enabled":{type:"boolean",default:X.enabled,description:r.localize(43,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:h(X.enabled,this.defaultValue.enabled)}}}class de extends S{constructor(){const X={enabled:!1,maxLineCount:5};super(105,"stickyScroll",X,{"editor.stickyScroll.enabled":{type:"boolean",default:X.enabled,description:r.localize(44,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:X.maxLineCount,minimum:1,maximum:10,description:r.localize(45,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{enabled:h(fe.enabled,this.defaultValue.enabled),maxLineCount:I.clampedInt(fe.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class ie extends S{constructor(){const X={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(129,"inlayHints",X,{"editor.inlayHints.enabled":{type:"string",default:X.enabled,description:r.localize(46,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[r.localize(47,null),r.localize(48,null,y.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),r.localize(49,null,y.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),r.localize(50,null)]},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:r.localize(51,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,markdownDescription:r.localize(52,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:X.padding,description:r.localize(53,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return typeof fe.enabled=="boolean"&&(fe.enabled=fe.enabled?"on":"off"),{enabled:t(fe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:I.clampedInt(fe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:b.string(fe.fontFamily,this.defaultValue.fontFamily),padding:h(fe.padding,this.defaultValue.padding)}}}class ve extends l{constructor(){super(60,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>l.clamp(X,0,150),{markdownDescription:r.localize(54,null)})}compute(X,fe,Ue){return X.fontInfo.lineHeight}}class be extends S{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(66,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:r.localize(55,null)},"editor.minimap.autohide":{type:"boolean",default:X.autohide,description:r.localize(56,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[r.localize(57,null),r.localize(58,null),r.localize(59,null)],default:X.size,description:r.localize(60,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:r.localize(61,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:r.localize(62,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:r.localize(63,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:r.localize(64,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:r.localize(65,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{enabled:h(fe.enabled,this.defaultValue.enabled),autohide:h(fe.autohide,this.defaultValue.autohide),size:t(fe.size,this.defaultValue.size,["proportional","fill","fit"]),side:t(fe.side,this.defaultValue.side,["right","left"]),showSlider:t(fe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:h(fe.renderCharacters,this.defaultValue.renderCharacters),scale:I.clampedInt(fe.scale,1,1,3),maxColumn:I.clampedInt(fe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ne(G){return G==="ctrlCmd"?y.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Ee extends S{constructor(){super(76,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:r.localize(66,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:r.localize(67,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{top:I.clampedInt(fe.top,0,0,1e3),bottom:I.clampedInt(fe.bottom,0,0,1e3)}}}class Pe extends S{constructor(){const X={enabled:!0,cycle:!1};super(77,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:r.localize(68,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:r.localize(69,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{enabled:h(fe.enabled,this.defaultValue.enabled),cycle:h(fe.cycle,this.defaultValue.cycle)}}}class Fe extends f{constructor(){super(131)}compute(X,fe,Ue){return X.pixelRatio}}class $e extends S{constructor(){const X={other:"on",comments:"off",strings:"off"},fe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[r.localize(70,null),r.localize(71,null),r.localize(72,null)]}];super(80,"quickSuggestions",X,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:fe,default:X.strings,description:r.localize(73,null)},comments:{anyOf:fe,default:X.comments,description:r.localize(74,null)},other:{anyOf:fe,default:X.other,description:r.localize(75,null)}},default:X,markdownDescription:r.localize(76,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=X}validate(X){if(typeof X=="boolean"){const st=X?"on":"off";return{comments:st,strings:st,other:st}}if(!X||typeof X!="object")return this.defaultValue;const{other:fe,comments:Ue,strings:We}=X,et=["on","inline","off"];let qe,Ve,it;return typeof fe=="boolean"?qe=fe?"on":"off":qe=t(fe,this.defaultValue.other,et),typeof Ue=="boolean"?Ve=Ue?"on":"off":Ve=t(Ue,this.defaultValue.comments,et),typeof We=="boolean"?it=We?"on":"off":it=t(We,this.defaultValue.strings,et),{other:qe,comments:Ve,strings:it}}}var Qe;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative",G[G.Interval=3]="Interval",G[G.Custom=4]="Custom"})(Qe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Te extends S{constructor(){super(61,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[r.localize(77,null),r.localize(78,null),r.localize(79,null),r.localize(80,null)],default:"on",description:r.localize(81,null)})}validate(X){let fe=this.defaultValue.renderType,Ue=this.defaultValue.renderFn;return typeof X<"u"&&(typeof X=="function"?(fe=4,Ue=X):X==="interval"?fe=3:X==="relative"?fe=2:X==="on"?fe=1:fe=0),{renderType:fe,renderFn:Ue}}}function _e(G){const X=G.get(88);return X==="editable"?G.get(82):X!=="on"}e.filterValidationDecorations=_e;class ye extends S{constructor(){const X=[],fe={type:"number",description:r.localize(82,null)};super(92,"rulers",X,{type:"array",items:{anyOf:[fe,{type:["object"],properties:{column:fe,color:{type:"string",description:r.localize(83,null),format:"color-hex"}}}]},default:X,description:r.localize(84,null)})}validate(X){if(Array.isArray(X)){const fe=[];for(const Ue of X)if(typeof Ue=="number")fe.push({column:I.clampedInt(Ue,0,0,1e4),color:null});else if(Ue&&typeof Ue=="object"){const We=Ue;fe.push({column:I.clampedInt(We.column,0,0,1e4),color:We.color})}return fe.sort((Ue,We)=>Ue.column-We.column),fe}return this.defaultValue}}function ae(G,X){if(typeof G!="string")return X;switch(G){case"hidden":return 2;case"visible":return 3;default:return 1}}class le extends S{constructor(){const X={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(93,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[r.localize(85,null),r.localize(86,null),r.localize(87,null)],default:"auto",description:r.localize(88,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[r.localize(89,null),r.localize(90,null),r.localize(91,null)],default:"auto",description:r.localize(92,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:r.localize(93,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:r.localize(94,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:r.localize(95,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X,Ue=I.clampedInt(fe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),We=I.clampedInt(fe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:I.clampedInt(fe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:ae(fe.vertical,this.defaultValue.vertical),horizontal:ae(fe.horizontal,this.defaultValue.horizontal),useShadows:h(fe.useShadows,this.defaultValue.useShadows),verticalHasArrows:h(fe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:h(fe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:h(fe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:h(fe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ue,horizontalSliderSize:I.clampedInt(fe.horizontalSliderSize,Ue,0,1e3),verticalScrollbarSize:We,verticalSliderSize:I.clampedInt(fe.verticalSliderSize,We,0,1e3),scrollByPage:h(fe.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Q extends S{constructor(){const X={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(115,"unicodeHighlight",X,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.nonBasicASCII,description:r.localize(96,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:X.invisibleCharacters,description:r.localize(97,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:X.ambiguousCharacters,description:r.localize(98,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeComments,description:r.localize(99,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeStrings,description:r.localize(100,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:X.allowedCharacters,description:r.localize(101,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:X.allowedLocales,description:r.localize(102,null)}})}applyUpdate(X,fe){let Ue=!1;fe.allowedCharacters&&X&&(_.equals(X.allowedCharacters,fe.allowedCharacters)||(X={...X,allowedCharacters:fe.allowedCharacters},Ue=!0)),fe.allowedLocales&&X&&(_.equals(X.allowedLocales,fe.allowedLocales)||(X={...X,allowedLocales:fe.allowedLocales},Ue=!0));const We=super.applyUpdate(X,fe);return Ue?new m(We.newValue,!0):We}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{nonBasicASCII:H(fe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:h(fe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:h(fe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:H(fe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:H(fe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(X.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(X.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(X,fe){if(typeof X!="object"||!X)return fe;const Ue={};for(const[We,et]of Object.entries(X))et===!0&&(Ue[We]=!0);return Ue}}class J extends S{constructor(){const X={enabled:!0,mode:"subwordSmart"};super(56,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:r.localize(103,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{enabled:h(fe.enabled,this.defaultValue.enabled),mode:t(fe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class C extends S{constructor(){const X={enabled:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",X,{"editor.bracketPairColorization.enabled":{type:"boolean",default:X.enabled,markdownDescription:r.localize(104,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:X.independentColorPoolPerBracketType,description:r.localize(105,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{enabled:h(fe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:h(fe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class z extends S{constructor(){const X={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",X,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[r.localize(106,null),r.localize(107,null),r.localize(108,null)],default:X.bracketPairs,description:r.localize(109,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[r.localize(110,null),r.localize(111,null),r.localize(112,null)],default:X.bracketPairsHorizontal,description:r.localize(113,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:X.highlightActiveBracketPair,description:r.localize(114,null)},"editor.guides.indentation":{type:"boolean",default:X.indentation,description:r.localize(115,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[r.localize(116,null),r.localize(117,null),r.localize(118,null)],default:X.highlightActiveIndentation,description:r.localize(119,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{bracketPairs:H(fe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:H(fe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:h(fe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:h(fe.indentation,this.defaultValue.indentation),highlightActiveIndentation:H(fe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function H(G,X,fe){const Ue=fe.indexOf(G);return Ue===-1?X:fe[Ue]}class j extends S{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(108,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[r.localize(120,null),r.localize(121,null)],default:X.insertMode,description:r.localize(122,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:r.localize(123,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:r.localize(124,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:r.localize(125,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:r.localize(126,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:r.localize(127,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:r.localize(128,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:r.localize(129,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:r.localize(130,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:r.localize(131,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:r.localize(132,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:r.localize(133,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:r.localize(134,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:r.localize(135,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:r.localize(136,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:r.localize(137,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:r.localize(138,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:r.localize(139,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:r.localize(140,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:r.localize(141,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:r.localize(142,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:r.localize(143,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:r.localize(144,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:r.localize(145,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:r.localize(146,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:r.localize(147,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:r.localize(148,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:r.localize(149,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:r.localize(150,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:r.localize(151,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:r.localize(152,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:r.localize(153,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:r.localize(154,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:r.localize(155,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:r.localize(156,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:r.localize(157,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:r.localize(158,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:r.localize(159,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:r.localize(160,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:r.localize(161,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:r.localize(162,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{insertMode:t(fe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:h(fe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:h(fe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:h(fe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:h(fe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:h(fe.showIcons,this.defaultValue.showIcons),showStatusBar:h(fe.showStatusBar,this.defaultValue.showStatusBar),preview:h(fe.preview,this.defaultValue.preview),previewMode:t(fe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:h(fe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:h(fe.showMethods,this.defaultValue.showMethods),showFunctions:h(fe.showFunctions,this.defaultValue.showFunctions),showConstructors:h(fe.showConstructors,this.defaultValue.showConstructors),showDeprecated:h(fe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:h(fe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:h(fe.showFields,this.defaultValue.showFields),showVariables:h(fe.showVariables,this.defaultValue.showVariables),showClasses:h(fe.showClasses,this.defaultValue.showClasses),showStructs:h(fe.showStructs,this.defaultValue.showStructs),showInterfaces:h(fe.showInterfaces,this.defaultValue.showInterfaces),showModules:h(fe.showModules,this.defaultValue.showModules),showProperties:h(fe.showProperties,this.defaultValue.showProperties),showEvents:h(fe.showEvents,this.defaultValue.showEvents),showOperators:h(fe.showOperators,this.defaultValue.showOperators),showUnits:h(fe.showUnits,this.defaultValue.showUnits),showValues:h(fe.showValues,this.defaultValue.showValues),showConstants:h(fe.showConstants,this.defaultValue.showConstants),showEnums:h(fe.showEnums,this.defaultValue.showEnums),showEnumMembers:h(fe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:h(fe.showKeywords,this.defaultValue.showKeywords),showWords:h(fe.showWords,this.defaultValue.showWords),showColors:h(fe.showColors,this.defaultValue.showColors),showFiles:h(fe.showFiles,this.defaultValue.showFiles),showReferences:h(fe.showReferences,this.defaultValue.showReferences),showFolders:h(fe.showFolders,this.defaultValue.showFolders),showTypeParameters:h(fe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:h(fe.showSnippets,this.defaultValue.showSnippets),showUsers:h(fe.showUsers,this.defaultValue.showUsers),showIssues:h(fe.showIssues,this.defaultValue.showIssues)}}}class se extends S{constructor(){super(103,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:r.localize(163,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:h(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ce extends f{constructor(){super(132)}compute(X,fe,Ue){return fe.get(82)?!0:X.tabFocusMode}}var Y;(function(G){G[G.None=0]="None",G[G.Same=1]="Same",G[G.Indent=2]="Indent",G[G.DeepIndent=3]="DeepIndent"})(Y=e.WrappingIndent||(e.WrappingIndent={}));function pe(G){switch(G){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ge extends f{constructor(){super(134)}compute(X,fe,Ue){const We=fe.get(133);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:We.isWordWrapMinified,isViewportWrapping:We.isViewportWrapping,wrappingColumn:We.wrappingColumn}}}class Ne extends S{constructor(){const X={enabled:!0};super(32,"dropIntoEditor",X,{"editor.dropIntoEditor.enabled":{type:"boolean",default:X.enabled,markdownDescription:r.localize(164,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:h(X.enabled,this.defaultValue.enabled)}}}const Be="Consolas, 'Courier New', monospace",Ye="Menlo, Monaco, 'Courier New', monospace",Xe="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:y.isMacintosh?Ye:y.isLinux?Xe:Be,fontWeight:"normal",fontSize:y.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ke(G){return e.editorOptionsRegistry[G.id]=G,G}var nt;(function(G){G[G.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",G[G.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",G[G.accessibilitySupport=2]="accessibilitySupport",G[G.accessibilityPageSize=3]="accessibilityPageSize",G[G.ariaLabel=4]="ariaLabel",G[G.autoClosingBrackets=5]="autoClosingBrackets",G[G.autoClosingDelete=6]="autoClosingDelete",G[G.autoClosingOvertype=7]="autoClosingOvertype",G[G.autoClosingQuotes=8]="autoClosingQuotes",G[G.autoIndent=9]="autoIndent",G[G.automaticLayout=10]="automaticLayout",G[G.autoSurround=11]="autoSurround",G[G.bracketPairColorization=12]="bracketPairColorization",G[G.guides=13]="guides",G[G.codeLens=14]="codeLens",G[G.codeLensFontFamily=15]="codeLensFontFamily",G[G.codeLensFontSize=16]="codeLensFontSize",G[G.colorDecorators=17]="colorDecorators",G[G.columnSelection=18]="columnSelection",G[G.comments=19]="comments",G[G.contextmenu=20]="contextmenu",G[G.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",G[G.cursorBlinking=22]="cursorBlinking",G[G.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",G[G.cursorStyle=24]="cursorStyle",G[G.cursorSurroundingLines=25]="cursorSurroundingLines",G[G.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",G[G.cursorWidth=27]="cursorWidth",G[G.disableLayerHinting=28]="disableLayerHinting",G[G.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",G[G.domReadOnly=30]="domReadOnly",G[G.dragAndDrop=31]="dragAndDrop",G[G.dropIntoEditor=32]="dropIntoEditor",G[G.emptySelectionClipboard=33]="emptySelectionClipboard",G[G.extraEditorClassName=34]="extraEditorClassName",G[G.fastScrollSensitivity=35]="fastScrollSensitivity",G[G.find=36]="find",G[G.fixedOverflowWidgets=37]="fixedOverflowWidgets",G[G.folding=38]="folding",G[G.foldingStrategy=39]="foldingStrategy",G[G.foldingHighlight=40]="foldingHighlight",G[G.foldingImportsByDefault=41]="foldingImportsByDefault",G[G.foldingMaximumRegions=42]="foldingMaximumRegions",G[G.unfoldOnClickAfterEndOfLine=43]="unfoldOnClickAfterEndOfLine",G[G.fontFamily=44]="fontFamily",G[G.fontInfo=45]="fontInfo",G[G.fontLigatures=46]="fontLigatures",G[G.fontSize=47]="fontSize",G[G.fontWeight=48]="fontWeight",G[G.formatOnPaste=49]="formatOnPaste",G[G.formatOnType=50]="formatOnType",G[G.glyphMargin=51]="glyphMargin",G[G.gotoLocation=52]="gotoLocation",G[G.hideCursorInOverviewRuler=53]="hideCursorInOverviewRuler",G[G.hover=54]="hover",G[G.inDiffEditor=55]="inDiffEditor",G[G.inlineSuggest=56]="inlineSuggest",G[G.letterSpacing=57]="letterSpacing",G[G.lightbulb=58]="lightbulb",G[G.lineDecorationsWidth=59]="lineDecorationsWidth",G[G.lineHeight=60]="lineHeight",G[G.lineNumbers=61]="lineNumbers",G[G.lineNumbersMinChars=62]="lineNumbersMinChars",G[G.linkedEditing=63]="linkedEditing",G[G.links=64]="links",G[G.matchBrackets=65]="matchBrackets",G[G.minimap=66]="minimap",G[G.mouseStyle=67]="mouseStyle",G[G.mouseWheelScrollSensitivity=68]="mouseWheelScrollSensitivity",G[G.mouseWheelZoom=69]="mouseWheelZoom",G[G.multiCursorMergeOverlapping=70]="multiCursorMergeOverlapping",G[G.multiCursorModifier=71]="multiCursorModifier",G[G.multiCursorPaste=72]="multiCursorPaste",G[G.occurrencesHighlight=73]="occurrencesHighlight",G[G.overviewRulerBorder=74]="overviewRulerBorder",G[G.overviewRulerLanes=75]="overviewRulerLanes",G[G.padding=76]="padding",G[G.parameterHints=77]="parameterHints",G[G.peekWidgetDefaultFocus=78]="peekWidgetDefaultFocus",G[G.definitionLinkOpensInPeek=79]="definitionLinkOpensInPeek",G[G.quickSuggestions=80]="quickSuggestions",G[G.quickSuggestionsDelay=81]="quickSuggestionsDelay",G[G.readOnly=82]="readOnly",G[G.renameOnType=83]="renameOnType",G[G.renderControlCharacters=84]="renderControlCharacters",G[G.renderFinalNewline=85]="renderFinalNewline",G[G.renderLineHighlight=86]="renderLineHighlight",G[G.renderLineHighlightOnlyWhenFocus=87]="renderLineHighlightOnlyWhenFocus",G[G.renderValidationDecorations=88]="renderValidationDecorations",G[G.renderWhitespace=89]="renderWhitespace",G[G.revealHorizontalRightPadding=90]="revealHorizontalRightPadding",G[G.roundedSelection=91]="roundedSelection",G[G.rulers=92]="rulers",G[G.scrollbar=93]="scrollbar",G[G.scrollBeyondLastColumn=94]="scrollBeyondLastColumn",G[G.scrollBeyondLastLine=95]="scrollBeyondLastLine",G[G.scrollPredominantAxis=96]="scrollPredominantAxis",G[G.selectionClipboard=97]="selectionClipboard",G[G.selectionHighlight=98]="selectionHighlight",G[G.selectOnLineNumbers=99]="selectOnLineNumbers",G[G.showFoldingControls=100]="showFoldingControls",G[G.showUnused=101]="showUnused",G[G.snippetSuggestions=102]="snippetSuggestions",G[G.smartSelect=103]="smartSelect",G[G.smoothScrolling=104]="smoothScrolling",G[G.stickyScroll=105]="stickyScroll",G[G.stickyTabStops=106]="stickyTabStops",G[G.stopRenderingLineAfter=107]="stopRenderingLineAfter",G[G.suggest=108]="suggest",G[G.suggestFontSize=109]="suggestFontSize",G[G.suggestLineHeight=110]="suggestLineHeight",G[G.suggestOnTriggerCharacters=111]="suggestOnTriggerCharacters",G[G.suggestSelection=112]="suggestSelection",G[G.tabCompletion=113]="tabCompletion",G[G.tabIndex=114]="tabIndex",G[G.unicodeHighlighting=115]="unicodeHighlighting",G[G.unusualLineTerminators=116]="unusualLineTerminators",G[G.useShadowDOM=117]="useShadowDOM",G[G.useTabStops=118]="useTabStops",G[G.wordSeparators=119]="wordSeparators",G[G.wordWrap=120]="wordWrap",G[G.wordWrapBreakAfterCharacters=121]="wordWrapBreakAfterCharacters",G[G.wordWrapBreakBeforeCharacters=122]="wordWrapBreakBeforeCharacters",G[G.wordWrapColumn=123]="wordWrapColumn",G[G.wordWrapOverride1=124]="wordWrapOverride1",G[G.wordWrapOverride2=125]="wordWrapOverride2",G[G.wrappingIndent=126]="wrappingIndent",G[G.wrappingStrategy=127]="wrappingStrategy",G[G.showDeprecated=128]="showDeprecated",G[G.inlayHints=129]="inlayHints",G[G.editorClassName=130]="editorClassName",G[G.pixelRatio=131]="pixelRatio",G[G.tabFocusMode=132]="tabFocusMode",G[G.layoutInfo=133]="layoutInfo",G[G.wrappingInfo=134]="wrappingInfo"})(nt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ke(new u(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:r.localize(165,null)})),acceptSuggestionOnEnter:ke(new d(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",r.localize(166,null),""],markdownDescription:r.localize(167,null)})),accessibilitySupport:ke(new s),accessibilityPageSize:ke(new I(3,"accessibilityPageSize",10,1,1073741824,{description:r.localize(168,null)})),ariaLabel:ke(new b(4,"ariaLabel",r.localize(169,null))),autoClosingBrackets:ke(new d(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",r.localize(170,null),r.localize(171,null),""],description:r.localize(172,null)})),autoClosingDelete:ke(new d(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",r.localize(173,null),""],description:r.localize(174,null)})),autoClosingOvertype:ke(new d(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",r.localize(175,null),""],description:r.localize(176,null)})),autoClosingQuotes:ke(new d(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",r.localize(177,null),r.localize(178,null),""],description:r.localize(179,null)})),autoIndent:ke(new n(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],i,{enumDescriptions:[r.localize(180,null),r.localize(181,null),r.localize(182,null),r.localize(183,null),r.localize(184,null)],description:r.localize(185,null)})),automaticLayout:ke(new u(10,"automaticLayout",!1)),autoSurround:ke(new d(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[r.localize(186,null),r.localize(187,null),r.localize(188,null),""],description:r.localize(189,null)})),bracketPairColorization:ke(new C),bracketPairGuides:ke(new z),stickyTabStops:ke(new u(106,"stickyTabStops",!1,{description:r.localize(190,null)})),codeLens:ke(new u(14,"codeLens",!0,{description:r.localize(191,null)})),codeLensFontFamily:ke(new b(15,"codeLensFontFamily","",{description:r.localize(192,null)})),codeLensFontSize:ke(new I(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:r.localize(193,null)})),colorDecorators:ke(new u(17,"colorDecorators",!0,{description:r.localize(194,null)})),columnSelection:ke(new u(18,"columnSelection",!1,{description:r.localize(195,null)})),comments:ke(new a),contextmenu:ke(new u(20,"contextmenu",!0)),copyWithSyntaxHighlighting:ke(new u(21,"copyWithSyntaxHighlighting",!0,{description:r.localize(196,null)})),cursorBlinking:ke(new n(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],g,{description:r.localize(197,null)})),cursorSmoothCaretAnimation:ke(new u(23,"cursorSmoothCaretAnimation",!1,{description:r.localize(198,null)})),cursorStyle:ke(new n(24,"cursorStyle",p.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],M,{description:r.localize(199,null)})),cursorSurroundingLines:ke(new I(25,"cursorSurroundingLines",0,0,1073741824,{description:r.localize(200,null)})),cursorSurroundingLinesStyle:ke(new d(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[r.localize(201,null),r.localize(202,null)],description:r.localize(203,null)})),cursorWidth:ke(new I(27,"cursorWidth",0,0,1073741824,{markdownDescription:r.localize(204,null)})),disableLayerHinting:ke(new u(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:ke(new u(29,"disableMonospaceOptimizations",!1)),domReadOnly:ke(new u(30,"domReadOnly",!1)),dragAndDrop:ke(new u(31,"dragAndDrop",!0,{description:r.localize(205,null)})),emptySelectionClipboard:ke(new B),dropIntoEditor:ke(new Ne),stickyScroll:ke(new de),extraEditorClassName:ke(new b(34,"extraEditorClassName","")),fastScrollSensitivity:ke(new l(35,"fastScrollSensitivity",5,G=>G<=0?5:G,{markdownDescription:r.localize(206,null)})),find:ke(new D),fixedOverflowWidgets:ke(new u(37,"fixedOverflowWidgets",!1)),folding:ke(new u(38,"folding",!0,{description:r.localize(207,null)})),foldingStrategy:ke(new d(39,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[r.localize(208,null),r.localize(209,null)],description:r.localize(210,null)})),foldingHighlight:ke(new u(40,"foldingHighlight",!0,{description:r.localize(211,null)})),foldingImportsByDefault:ke(new u(41,"foldingImportsByDefault",!1,{description:r.localize(212,null)})),foldingMaximumRegions:ke(new I(42,"foldingMaximumRegions",5e3,10,65e3,{description:r.localize(213,null)})),unfoldOnClickAfterEndOfLine:ke(new u(43,"unfoldOnClickAfterEndOfLine",!1,{description:r.localize(214,null)})),fontFamily:ke(new b(44,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:r.localize(215,null)})),fontInfo:ke(new U),fontLigatures2:ke(new x),fontSize:ke(new R),fontWeight:ke(new K),formatOnPaste:ke(new u(49,"formatOnPaste",!1,{description:r.localize(216,null)})),formatOnType:ke(new u(50,"formatOnType",!1,{description:r.localize(217,null)})),glyphMargin:ke(new u(51,"glyphMargin",!0,{description:r.localize(218,null)})),gotoLocation:ke(new W),hideCursorInOverviewRuler:ke(new u(53,"hideCursorInOverviewRuler",!1,{description:r.localize(219,null)})),hover:ke(new O),inDiffEditor:ke(new u(55,"inDiffEditor",!1)),letterSpacing:ke(new l(57,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,G=>l.clamp(G,-5,20),{description:r.localize(220,null)})),lightbulb:ke(new oe),lineDecorationsWidth:ke(new c(59,"lineDecorationsWidth",10)),lineHeight:ke(new ve),lineNumbers:ke(new Te),lineNumbersMinChars:ke(new I(62,"lineNumbersMinChars",5,1,300)),linkedEditing:ke(new u(63,"linkedEditing",!1,{description:r.localize(221,null)})),links:ke(new u(64,"links",!0,{description:r.localize(222,null)})),matchBrackets:ke(new d(65,"matchBrackets","always",["always","near","never"],{description:r.localize(223,null)})),minimap:ke(new be),mouseStyle:ke(new d(67,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ke(new l(68,"mouseWheelScrollSensitivity",1,G=>G===0?1:G,{markdownDescription:r.localize(224,null)})),mouseWheelZoom:ke(new u(69,"mouseWheelZoom",!1,{markdownDescription:r.localize(225,null)})),multiCursorMergeOverlapping:ke(new u(70,"multiCursorMergeOverlapping",!0,{description:r.localize(226,null)})),multiCursorModifier:ke(new n(71,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ne,{markdownEnumDescriptions:[r.localize(227,null),r.localize(228,null)],markdownDescription:r.localize(229,null)})),multiCursorPaste:ke(new d(72,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[r.localize(230,null),r.localize(231,null)],markdownDescription:r.localize(232,null)})),occurrencesHighlight:ke(new u(73,"occurrencesHighlight",!0,{description:r.localize(233,null)})),overviewRulerBorder:ke(new u(74,"overviewRulerBorder",!0,{description:r.localize(234,null)})),overviewRulerLanes:ke(new I(75,"overviewRulerLanes",3,0,3)),padding:ke(new Ee),parameterHints:ke(new Pe),peekWidgetDefaultFocus:ke(new d(78,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[r.localize(235,null),r.localize(236,null)],description:r.localize(237,null)})),definitionLinkOpensInPeek:ke(new u(79,"definitionLinkOpensInPeek",!1,{description:r.localize(238,null)})),quickSuggestions:ke(new $e),quickSuggestionsDelay:ke(new I(81,"quickSuggestionsDelay",10,0,1073741824,{description:r.localize(239,null)})),readOnly:ke(new u(82,"readOnly",!1)),renameOnType:ke(new u(83,"renameOnType",!1,{description:r.localize(240,null),markdownDeprecationMessage:r.localize(241,null)})),renderControlCharacters:ke(new u(84,"renderControlCharacters",!0,{description:r.localize(242,null),restricted:!0})),renderFinalNewline:ke(new u(85,"renderFinalNewline",!0,{description:r.localize(243,null)})),renderLineHighlight:ke(new d(86,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",r.localize(244,null)],description:r.localize(245,null)})),renderLineHighlightOnlyWhenFocus:ke(new u(87,"renderLineHighlightOnlyWhenFocus",!1,{description:r.localize(246,null)})),renderValidationDecorations:ke(new d(88,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ke(new d(89,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",r.localize(247,null),r.localize(248,null),r.localize(249,null),""],description:r.localize(250,null)})),revealHorizontalRightPadding:ke(new I(90,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:ke(new u(91,"roundedSelection",!0,{description:r.localize(251,null)})),rulers:ke(new ye),scrollbar:ke(new le),scrollBeyondLastColumn:ke(new I(94,"scrollBeyondLastColumn",4,0,1073741824,{description:r.localize(252,null)})),scrollBeyondLastLine:ke(new u(95,"scrollBeyondLastLine",!0,{description:r.localize(253,null)})),scrollPredominantAxis:ke(new u(96,"scrollPredominantAxis",!0,{description:r.localize(254,null)})),selectionClipboard:ke(new u(97,"selectionClipboard",!0,{description:r.localize(255,null),included:y.isLinux})),selectionHighlight:ke(new u(98,"selectionHighlight",!0,{description:r.localize(256,null)})),selectOnLineNumbers:ke(new u(99,"selectOnLineNumbers",!0)),showFoldingControls:ke(new d(100,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[r.localize(257,null),r.localize(258,null),r.localize(259,null)],description:r.localize(260,null)})),showUnused:ke(new u(101,"showUnused",!0,{description:r.localize(261,null)})),showDeprecated:ke(new u(128,"showDeprecated",!0,{description:r.localize(262,null)})),inlayHints:ke(new ie),snippetSuggestions:ke(new d(102,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[r.localize(263,null),r.localize(264,null),r.localize(265,null),r.localize(266,null)],description:r.localize(267,null)})),smartSelect:ke(new se),smoothScrolling:ke(new u(104,"smoothScrolling",!1,{description:r.localize(268,null)})),stopRenderingLineAfter:ke(new I(107,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ke(new j),inlineSuggest:ke(new J),suggestFontSize:ke(new I(109,"suggestFontSize",0,0,1e3,{markdownDescription:r.localize(269,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:ke(new I(110,"suggestLineHeight",0,0,1e3,{markdownDescription:r.localize(270,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:ke(new u(111,"suggestOnTriggerCharacters",!0,{description:r.localize(271,null)})),suggestSelection:ke(new d(112,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[r.localize(272,null),r.localize(273,null),r.localize(274,null)],description:r.localize(275,null)})),tabCompletion:ke(new d(113,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[r.localize(276,null),r.localize(277,null),r.localize(278,null)],description:r.localize(279,null)})),tabIndex:ke(new I(114,"tabIndex",0,-1,1073741824)),unicodeHighlight:ke(new Q),unusualLineTerminators:ke(new d(116,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[r.localize(280,null),r.localize(281,null),r.localize(282,null)],description:r.localize(283,null)})),useShadowDOM:ke(new u(117,"useShadowDOM",!0)),useTabStops:ke(new u(118,"useTabStops",!0,{description:r.localize(284,null)})),wordSeparators:ke(new b(119,"wordSeparators",w.USUAL_WORD_SEPARATORS,{description:r.localize(285,null)})),wordWrap:ke(new d(120,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[r.localize(286,null),r.localize(287,null),r.localize(288,null),r.localize(289,null)],description:r.localize(290,null)})),wordWrapBreakAfterCharacters:ke(new b(121,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ke(new b(122,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ke(new I(123,"wordWrapColumn",80,1,1073741824,{markdownDescription:r.localize(291,null)})),wordWrapOverride1:ke(new d(124,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ke(new d(125,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ke(new n(126,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],pe,{enumDescriptions:[r.localize(292,null),r.localize(293,null),r.localize(294,null),r.localize(295,null)],description:r.localize(296,null)})),wrappingStrategy:ke(new d(127,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[r.localize(297,null),r.localize(298,null)],description:r.localize(299,null)})),editorClassName:ke(new V),pixelRatio:ke(new Fe),tabFocusMode:ke(new ce),layoutInfo:ke(new ue),wrappingInfo:ke(new ge)}}),define(Ce[123],Ie([17,18]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ce[124],Ie([17,18]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ce[125],Ie([17,18]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ce[126],Ie([17,18]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(Ce[127],Ie([17,18]),function(te,e){return te.create("vs/platform/markers/common/markers",e)}),define(Ce[128],Ie([17,18]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(Ce[129],Ie([17,18]),function(te,e){return te.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ce[130],Ie([17,18]),function(te,e){return te.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ce[131],Ie([17,18]),function(te,e){return te.create("vs/workbench/api/common/extHostProgress",e)}),define(Ce[132],Ie([17,18]),function(te,e){return te.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ce[133],Ie([17,18]),function(te,e){return te.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ce[134],Ie([17,18]),function(te,e){return te.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ce[135],Ie([17,18]),function(te,e){return te.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ce[136],Ie([17,18]),function(te,e){return te.create("vs/workbench/common/editor",e)}),define(Ce[137],Ie([17,18]),function(te,e){return te.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ce[138],Ie([17,18]),function(te,e){return te.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ce[139],Ie([17,18]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ce[140],Ie([17,18]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ce[141],Ie([17,18]),function(te,e){return te.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ce[142],Ie([17,18]),function(te,e){return te.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ce[143],Ie([17,18]),function(te,e){return te.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ce[144],Ie([1,0,22,29,125,239]),function(te,e,r,y,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const _=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,A=/^-(\d{4})(\d{2})(\d{2})$/;function E(u){return u=u.trim(),u==="*"||_.test(u)}e.isValidVersionStr=E;function k(u){if(!E(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const v=u.match(_);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=k;function F(u){if(!u)return null;const v=u.majorBase,I=u.majorMustEqual,l=u.minorBase;let b=u.minorMustEqual;const t=u.patchBase;let d=u.patchMustEqual;u.hasCaret&&(v===0||(b=!1),d=!1);let n=0;if(u.preRelease){const i=A.exec(u.preRelease);if(i){const[,s,a,o]=i;n=Date.UTC(Number(s),Number(a)-1,Number(o))}}return{majorBase:v,majorMustEqual:I,minorBase:l,minorMustEqual:b,patchBase:t,patchMustEqual:d,isMinimum:u.hasGreaterEquals,notBefore:n}}e.normalizeVersion=F;function S(u,v,I){let l;typeof u=="string"?l=F(k(u)):l=u;let b;v instanceof Date?b=v.getTime():typeof v=="string"&&(b=new Date(v).getTime());let t;if(typeof I=="string"?t=F(k(I)):t=I,!l||!t)return!1;const d=l.majorBase,n=l.minorBase,i=l.patchBase;let s=t.majorBase,a=t.minorBase,o=t.patchBase;const g=t.notBefore;let p=t.majorMustEqual,P=t.minorMustEqual,M=t.patchMustEqual;return t.isMinimum?d>s?!0:d<s?!1:n>a?!0:n<a||b&&b<g?!1:i>=o:(d===1&&s===0&&(!p||!P||!M)&&(s=1,a=0,o=0,p=!0,P=!1,M=!1),d<s?!1:d>s?!p:n<a?!1:n>a?!P:i<o?!1:i>o?!M:!(b&&b<g))}e.isValidVersion=S;function m(u,v,I,l,b){const t=[];if(typeof l.publisher<"u"&&typeof l.publisher!="string")return t.push([y.default.Error,w.localize(0,null)]),t;if(typeof l.name!="string")return t.push([y.default.Error,w.localize(1,null,"name")]),t;if(typeof l.version!="string")return t.push([y.default.Error,w.localize(2,null,"version")]),t;if(!l.engines)return t.push([y.default.Error,w.localize(3,null,"engines")]),t;if(typeof l.engines.vscode!="string")return t.push([y.default.Error,w.localize(4,null,"engines.vscode")]),t;if(typeof l.extensionDependencies<"u"&&!h(l.extensionDependencies))return t.push([y.default.Error,w.localize(5,null,"extensionDependencies")]),t;if(typeof l.activationEvents<"u"){if(!h(l.activationEvents))return t.push([y.default.Error,w.localize(6,null,"activationEvents")]),t;if(typeof l.main>"u"&&typeof l.browser>"u")return t.push([y.default.Error,w.localize(7,null,"activationEvents","main")]),t}if(typeof l.extensionKind<"u"&&typeof l.main>"u"&&t.push([y.default.Warning,w.localize(8,null,"extensionKind")]),typeof l.main<"u"){if(typeof l.main!="string")return t.push([y.default.Error,w.localize(9,null,"main")]),t;{const i=(0,r.joinPath)(I,l.main);(0,r.isEqualOrParent)(i,I)||t.push([y.default.Warning,w.localize(10,null,i.path,I.path)])}if(typeof l.activationEvents>"u")return t.push([y.default.Error,w.localize(11,null,"activationEvents","main")]),t}if(typeof l.browser<"u"){if(typeof l.browser!="string")return t.push([y.default.Error,w.localize(12,null,"browser")]),t;{const i=(0,r.joinPath)(I,l.browser);(0,r.isEqualOrParent)(i,I)||t.push([y.default.Warning,w.localize(13,null,i.path,I.path)])}if(typeof l.activationEvents>"u")return t.push([y.default.Error,w.localize(14,null,"activationEvents","browser")]),t}if(!L.valid(l.version))return t.push([y.default.Error,w.localize(15,null)]),t;const d=[];if(!T(u,v,l,b,d))for(const i of d)t.push([y.default.Error,i]);return t}e.validateExtensionManifest=m;function T(u,v,I,l,b){return l||typeof I.main>"u"&&typeof I.browser>"u"?!0:c(u,v,I.engines.vscode,b)}e.isValidExtensionVersion=T;function f(u,v,I){return u==="*"||c(v,I,u)}e.isEngineValid=f;function c(u,v,I,l=[]){const b=F(k(I));if(!b)return l.push(w.localize(16,null,I)),!1;if(b.majorBase===0){if(!b.majorMustEqual||!b.minorMustEqual)return l.push(w.localize(17,null,I)),!1}else if(!b.majorMustEqual)return l.push(w.localize(18,null,I)),!1;return S(u,v,b)?!0:(l.push(w.localize(19,null,u,I)),!1)}function h(u){if(!Array.isArray(u))return!1;for(let v=0,I=u.length;v<I;v++)if(typeof u[v]!="string")return!1;return!0}}),define(Ce[79],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class r{constructor(w,L=[],_=!1){this.ctor=w,this.staticArguments=L,this.supportsDelayedInstantiation=_}}e.SyncDescriptor=r}),define(Ce[56],Ie([1,0,79]),function(te,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const y=[];var w;(function(A){A[A.Eager=0]="Eager",A[A.Delayed=1]="Delayed"})(w=e.InstantiationType||(e.InstantiationType={}));function L(A,E,k){E instanceof r.SyncDescriptor||(E=new r.SyncDescriptor(E,[],Boolean(k))),y.push([A,E])}e.registerSingleton=L;function _(){return y}e.getSingletonServiceDescriptors=_}),define(Ce[145],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class r{constructor(L,_){this.key=L,this.data=_,this.incoming=new Map,this.outgoing=new Map}}e.Node=r;class y{constructor(L){this._hashFn=L,this._nodes=new Map}roots(){const L=[];for(const _ of this._nodes.values())_.outgoing.size===0&&L.push(_);return L}insertEdge(L,_){const A=this.lookupOrInsertNode(L),E=this.lookupOrInsertNode(_);A.outgoing.set(E.key,E),E.incoming.set(A.key,A)}removeNode(L){const _=this._hashFn(L);this._nodes.delete(_);for(const A of this._nodes.values())A.outgoing.delete(_),A.incoming.delete(_)}lookupOrInsertNode(L){const _=this._hashFn(L);let A=this._nodes.get(_);return A||(A=new r(_,L),this._nodes.set(_,A)),A}lookup(L){return this._nodes.get(this._hashFn(L))}isEmpty(){return this._nodes.size===0}toString(){const L=[];for(const[_,A]of this._nodes)L.push(`${_}
	(-> incoming)[${[...A.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...A.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,_]of this._nodes){const A=new Set([L]),E=this._findCycle(_,A);if(E)return E}}_findCycle(L,_){for(const[A,E]of L.outgoing){if(_.has(A))return[..._,A].join(" -> ");_.add(A);const k=this._findCycle(E,_);if(k)return k;_.delete(A)}}}e.Graph=y}),define(Ce[3],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var r;(function(_){_.serviceIds=new Map,_.DI_TARGET="$di$target",_.DI_DEPENDENCIES="$di$dependencies";function A(E){return E[_.DI_DEPENDENCIES]||[]}_.getServiceDependencies=A})(r=e._util||(e._util={})),e.IInstantiationService=w("instantiationService");function y(_,A,E){A[r.DI_TARGET]===A?A[r.DI_DEPENDENCIES].push({id:_,index:E}):(A[r.DI_DEPENDENCIES]=[{id:_,index:E}],A[r.DI_TARGET]=A)}function w(_){if(r.serviceIds.has(_))return r.serviceIds.get(_);const A=function(E,k,F){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");y(A,E,F)};return A.toString=()=>_,r.serviceIds.set(_,A),A}e.createDecorator=w;function L(_){return _}e.refineServiceDecorator=L}),define(Ce[57],Ie([1,0,10,2,3]),function(te,e,r,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,w.createDecorator)("configurationService");function L(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof y.URI)}e.isConfigurationOverrides=L;function _(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof y.URI)}e.isConfigurationUpdateOverrides=_;var A;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(A=e.ConfigurationTarget||(e.ConfigurationTarget={}));function E(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=E;function k(u,v){const I=Object.create(null);for(const l in u)F(I,l,u[l],v);return I}e.toValuesTree=k;function F(u,v,I,l){const b=v.split("."),t=b.pop();let d=u;for(let n=0;n<b.length;n++){const i=b[n];let s=d[i];switch(typeof s){case"undefined":s=d[i]=Object.create(null);break;case"object":break;default:l(`Ignoring ${v} as ${b.slice(0,n+1).join(".")} is ${JSON.stringify(s)}`);return}d=s}if(typeof d=="object"&&d!==null)try{d[t]=I}catch{l(`Ignoring ${v} as ${b.join(".")} is ${JSON.stringify(d)}`)}else l(`Ignoring ${v} as ${b.join(".")} is ${JSON.stringify(d)}`)}e.addToValueTree=F;function S(u,v){const I=v.split(".");m(u,I)}e.removeFromValueTree=S;function m(u,v){const I=v.shift();if(v.length===0){delete u[I];return}if(Object.keys(u).indexOf(I)!==-1){const l=u[I];typeof l=="object"&&!Array.isArray(l)&&(m(l,v),Object.keys(l).length===0&&delete u[I])}}function T(u,v,I){function l(d,n){let i=d;for(const s of n){if(typeof i!="object"||i===null)return;i=i[s]}return i}const b=v.split("."),t=l(u,b);return typeof t>"u"?I:t}e.getConfigurationValue=T;function f(u,v,I){Object.keys(v).forEach(l=>{l!=="__proto__"&&(l in u?r.isObject(u[l])&&r.isObject(v[l])?f(u[l],v[l],I):I&&(u[l]=v[l]):u[l]=v[l])})}e.merge=f;function c(u,v,I){const l=u.inspect(v),b=u.inspect(I);return typeof l.userValue<"u"||typeof l.workspaceValue<"u"||typeof l.workspaceFolderValue<"u"?l.value:typeof b.userValue<"u"||typeof b.workspaceValue<"u"||typeof b.workspaceFolderValue<"u"?b.value:l.defaultValue}e.getMigratedSettingValue=c;function h(u){return u.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=h}),define(Ce[38],Ie([1,0,21,9,3]),function(te,e,r,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const L=new Map;L.set("false",!1),L.set("true",!0),L.set("isMac",r.isMacintosh),L.set("isLinux",r.isLinux),L.set("isWindows",r.isWindows),L.set("isWeb",r.isWeb),L.set("isMacNative",r.isMacintosh&&!r.isWeb),L.set("isEdge",r.isEdge),L.set("isFirefox",r.isFirefox),L.set("isChrome",r.isChrome),L.set("isSafari",r.isSafari);const _=Object.prototype.hasOwnProperty;var A;(function(B){B[B.False=0]="False",B[B.True=1]="True",B[B.Defined=2]="Defined",B[B.Not=3]="Not",B[B.Equals=4]="Equals",B[B.NotEquals=5]="NotEquals",B[B.And=6]="And",B[B.Regex=7]="Regex",B[B.NotRegex=8]="NotRegex",B[B.Or=9]="Or",B[B.In=10]="In",B[B.NotIn=11]="NotIn",B[B.Greater=12]="Greater",B[B.GreaterEquals=13]="GreaterEquals",B[B.Smaller=14]="Smaller",B[B.SmallerEquals=15]="SmallerEquals"})(A=e.ContextKeyExprType||(e.ContextKeyExprType={}));class E{static false(){return S.INSTANCE}static true(){return m.INSTANCE}static has(D){return T.create(D)}static equals(D,x){return f.create(D,x)}static notEquals(D,x){return u.create(D,x)}static regex(D,x){return n.create(D,x)}static in(D,x){return c.create(D,x)}static notIn(D,x){return h.create(D,x)}static not(D){return v.create(D)}static and(...D){return a.create(D,null)}static or(...D){return o.create(D,null,!0)}static greater(D,x){return l.create(D,x)}static greaterEquals(D,x){return b.create(D,x)}static smaller(D,x){return t.create(D,x)}static smallerEquals(D,x){return d.create(D,x)}static deserialize(D,x=!1){if(!!D)return this._deserializeOrExpression(D,x)}static _deserializeOrExpression(D,x){const U=D.split("||");return o.create(U.map(R=>this._deserializeAndExpression(R,x)),null,!0)}static _deserializeAndExpression(D,x){const U=D.split("&&");return a.create(U.map(R=>this._deserializeOne(R,x)),null)}static _deserializeOne(D,x){if(D=D.trim(),D.indexOf("!=")>=0){const U=D.split("!=");return u.create(U[0].trim(),this._deserializeValue(U[1],x))}if(D.indexOf("==")>=0){const U=D.split("==");return f.create(U[0].trim(),this._deserializeValue(U[1],x))}if(D.indexOf("=~")>=0){const U=D.split("=~");return n.create(U[0].trim(),this._deserializeRegexValue(U[1],x))}if(D.indexOf(" not in ")>=0){const U=D.split(" not in ");return h.create(U[0].trim(),U[1].trim())}if(D.indexOf(" in ")>=0){const U=D.split(" in ");return c.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(D)){const U=D.split(">=");return b.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(D)){const U=D.split(">");return l.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(D)){const U=D.split("<=");return d.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(D)){const U=D.split("<");return t.create(U[0].trim(),U[1].trim())}return/^\!\s*/.test(D)?v.create(D.substr(1).trim()):T.create(D)}static _deserializeValue(D,x){if(D=D.trim(),D==="true")return!0;if(D==="false")return!1;const U=/^'([^']*)'$/.exec(D);return U?U[1].trim():D}static _deserializeRegexValue(D,x){if((0,y.isFalsyOrWhitespace)(D)){if(x)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const U=D.indexOf("/"),R=D.lastIndexOf("/");if(U===R||U<0){if(x)throw new Error(`bad regexp-value '${D}', missing /-enclosure`);return console.warn(`bad regexp-value '${D}', missing /-enclosure`),null}const K=D.slice(U+1,R),W=D[R+1]==="i"?"i":"";try{return new RegExp(K,W)}catch(O){if(x)throw new Error(`bad regexp-value '${D}', parse error: ${O}`);return console.warn(`bad regexp-value '${D}', parse error: ${O}`),null}}}e.ContextKeyExpr=E;function k(B,D){const x=B?B.substituteConstants():void 0,U=D?D.substituteConstants():void 0;return!x&&!U?!0:!x||!U?!1:x.equals(U)}e.expressionsAreEqualWithConstantSubstitution=k;function F(B,D){return B.cmp(D)}class S{constructor(){this.type=0}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!1}serialize(){return"false"}keys(){return[]}map(D){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=S,S.INSTANCE=new S;class m{constructor(){this.type=1}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!0}serialize(){return"true"}keys(){return[]}map(D){return this}negate(){return S.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class T{constructor(D,x){this.key=D,this.negated=x,this.type=2}static create(D,x=null){const U=L.get(D);return typeof U=="boolean"?U?m.INSTANCE:S.INSTANCE:new T(D,x)}cmp(D){return D.type!==this.type?this.type-D.type:p(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=L.get(this.key);return typeof D=="boolean"?D?m.INSTANCE:S.INSTANCE:this}evaluate(D){return!!D.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(D){return D.mapDefined(this.key)}negate(){return this.negated||(this.negated=v.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=T;class f{constructor(D,x,U){this.key=D,this.value=x,this.negated=U,this.type=4}static create(D,x,U=null){if(typeof x=="boolean")return x?T.create(D,U):v.create(D,U);const R=L.get(D);return typeof R=="boolean"?x===(R?"true":"false")?m.INSTANCE:S.INSTANCE:new f(D,x,U)}cmp(D){return D.type!==this.type?this.type-D.type:P(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){const D=L.get(this.key);if(typeof D=="boolean"){const x=D?"true":"false";return this.value===x?m.INSTANCE:S.INSTANCE}return this}evaluate(D){return D.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(D){return D.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=f;class c{constructor(D,x){this.key=D,this.valueKey=x,this.type=10,this.negated=null}static create(D,x){return new c(D,x)}cmp(D){return D.type!==this.type?this.type-D.type:P(this.key,this.valueKey,D.key,D.valueKey)}equals(D){return D.type===this.type?this.key===D.key&&this.valueKey===D.valueKey:!1}substituteConstants(){return this}evaluate(D){const x=D.getValue(this.valueKey),U=D.getValue(this.key);return Array.isArray(x)?x.includes(U):typeof U=="string"&&typeof x=="object"&&x!==null?_.call(x,U):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(D){return D.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=h.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=c;class h{constructor(D,x){this.key=D,this.valueKey=x,this.type=11,this._negated=c.create(D,x)}static create(D,x){return new h(D,x)}cmp(D){return D.type!==this.type?this.type-D.type:this._negated.cmp(D._negated)}equals(D){return D.type===this.type?this._negated.equals(D._negated):!1}substituteConstants(){return this}evaluate(D){return!this._negated.evaluate(D)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(D){return D.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=h;class u{constructor(D,x,U){this.key=D,this.value=x,this.negated=U,this.type=5}static create(D,x,U=null){if(typeof x=="boolean")return x?v.create(D,U):T.create(D,U);const R=L.get(D);return typeof R=="boolean"?x===(R?"true":"false")?S.INSTANCE:m.INSTANCE:new u(D,x,U)}cmp(D){return D.type!==this.type?this.type-D.type:P(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){const D=L.get(this.key);if(typeof D=="boolean"){const x=D?"true":"false";return this.value===x?S.INSTANCE:m.INSTANCE}return this}evaluate(D){return D.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(D){return D.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=u;class v{constructor(D,x){this.key=D,this.negated=x,this.type=3}static create(D,x=null){const U=L.get(D);return typeof U=="boolean"?U?S.INSTANCE:m.INSTANCE:new v(D,x)}cmp(D){return D.type!==this.type?this.type-D.type:p(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=L.get(this.key);return typeof D=="boolean"?D?S.INSTANCE:m.INSTANCE:this}evaluate(D){return!D.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(D){return D.mapNot(this.key)}negate(){return this.negated||(this.negated=T.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=v;function I(B,D){if(typeof B=="string"){const x=parseFloat(B);isNaN(x)||(B=x)}return typeof B=="string"||typeof B=="number"?D(B):S.INSTANCE}class l{constructor(D,x,U){this.key=D,this.value=x,this.negated=U,this.type=12}static create(D,x,U=null){return I(x,R=>new l(D,R,U))}cmp(D){return D.type!==this.type?this.type-D.type:P(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(D){return D.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=l;class b{constructor(D,x,U){this.key=D,this.value=x,this.negated=U,this.type=13}static create(D,x,U=null){return I(x,R=>new b(D,R,U))}cmp(D){return D.type!==this.type?this.type-D.type:P(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(D){return D.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=t.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=b;class t{constructor(D,x,U){this.key=D,this.value=x,this.negated=U,this.type=14}static create(D,x,U=null){return I(x,R=>new t(D,R,U))}cmp(D){return D.type!==this.type?this.type-D.type:P(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(D){return D.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=b.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=t;class d{constructor(D,x,U){this.key=D,this.value=x,this.negated=U,this.type=15}static create(D,x,U=null){return I(x,R=>new d(D,R,U))}cmp(D){return D.type!==this.type?this.type-D.type:P(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(D){return D.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=d;class n{constructor(D,x){this.key=D,this.regexp=x,this.type=7,this.negated=null}static create(D,x){return new n(D,x)}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.key<D.key)return-1;if(this.key>D.key)return 1;const x=this.regexp?this.regexp.source:"",U=D.regexp?D.regexp.source:"";return x<U?-1:x>U?1:0}equals(D){if(D.type===this.type){const x=this.regexp?this.regexp.source:"",U=D.regexp?D.regexp.source:"";return this.key===D.key&&x===U}return!1}substituteConstants(){return this}evaluate(D){const x=D.getValue(this.key);return this.regexp?this.regexp.test(x):!1}serialize(){const D=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${D}`}keys(){return[this.key]}map(D){return D.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=i.create(this)),this.negated}}e.ContextKeyRegexExpr=n;class i{constructor(D){this._actual=D,this.type=8}static create(D){return new i(D)}cmp(D){return D.type!==this.type?this.type-D.type:this._actual.cmp(D._actual)}equals(D){return D.type===this.type?this._actual.equals(D._actual):!1}substituteConstants(){return this}evaluate(D){return!this._actual.evaluate(D)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(D){return new i(this._actual.map(D))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;function s(B){let D=null;for(let x=0,U=B.length;x<U;x++){const R=B[x].substituteConstants();if(B[x]!==R&&D===null){D=[];for(let K=0;K<x;K++)D[K]=B[K]}D!==null&&(D[x]=R)}return D===null?B:D}class a{constructor(D,x){this.expr=D,this.negated=x,this.type=6}static create(D,x){return a._normalizeArr(D,x)}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let x=0,U=this.expr.length;x<U;x++){const R=F(this.expr[x],D.expr[x]);if(R!==0)return R}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let x=0,U=this.expr.length;x<U;x++)if(!this.expr[x].equals(D.expr[x]))return!1;return!0}return!1}substituteConstants(){const D=s(this.expr);return D===this.expr?this:a.create(D,this.negated)}evaluate(D){for(let x=0,U=this.expr.length;x<U;x++)if(!this.expr[x].evaluate(D))return!1;return!0}static _normalizeArr(D,x){const U=[];let R=!1;for(const K of D)if(!!K){if(K.type===1){R=!0;continue}if(K.type===0)return S.INSTANCE;if(K.type===6){U.push(...K.expr);continue}U.push(K)}if(U.length===0&&R)return m.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];U.sort(F);for(let K=1;K<U.length;K++)U[K-1].equals(U[K])&&(U.splice(K,1),K--);if(U.length===1)return U[0];for(;U.length>1;){const K=U[U.length-1];if(K.type!==9)break;U.pop();const W=U.pop(),O=U.length===0,Z=o.create(K.expr.map(ue=>a.create([ue,W],null)),null,O);Z&&(U.push(Z),U.sort(F))}return U.length===1?U[0]:new a(U,x)}}serialize(){return this.expr.map(D=>D.serialize()).join(" && ")}keys(){const D=[];for(const x of this.expr)D.push(...x.keys());return D}map(D){return new a(this.expr.map(x=>x.map(D)),null)}negate(){if(!this.negated){const D=[];for(const x of this.expr)D.push(x.negate());this.negated=o.create(D,this,!0)}return this.negated}}class o{constructor(D,x){this.expr=D,this.negated=x,this.type=9}static create(D,x,U){return o._normalizeArr(D,x,U)}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let x=0,U=this.expr.length;x<U;x++){const R=F(this.expr[x],D.expr[x]);if(R!==0)return R}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let x=0,U=this.expr.length;x<U;x++)if(!this.expr[x].equals(D.expr[x]))return!1;return!0}return!1}substituteConstants(){const D=s(this.expr);return D===this.expr?this:o.create(D,this.negated,!1)}evaluate(D){for(let x=0,U=this.expr.length;x<U;x++)if(this.expr[x].evaluate(D))return!0;return!1}static _normalizeArr(D,x,U){let R=[],K=!1;if(D){for(let W=0,O=D.length;W<O;W++){const Z=D[W];if(!!Z){if(Z.type===0){K=!0;continue}if(Z.type===1)return m.INSTANCE;if(Z.type===9){R=R.concat(Z.expr);continue}R.push(Z)}}if(R.length===0&&K)return S.INSTANCE;R.sort(F)}if(R.length!==0){if(R.length===1)return R[0];for(let W=1;W<R.length;W++)R[W-1].equals(R[W])&&(R.splice(W,1),W--);if(R.length===1)return R[0];if(U){for(let W=0;W<R.length;W++)for(let O=W+1;O<R.length;O++)M(R[W],R[O])&&(R.splice(O,1),O--);if(R.length===1)return R[0]}return new o(R,x)}}serialize(){return this.expr.map(D=>D.serialize()).join(" || ")}keys(){const D=[];for(const x of this.expr)D.push(...x.keys());return D}map(D){return new o(this.expr.map(x=>x.map(D)),null)}negate(){if(!this.negated){const D=[];for(const x of this.expr)D.push(x.negate());for(;D.length>1;){const x=D.shift(),U=D.shift(),R=[];for(const W of V(x))for(const O of V(U))R.push(a.create([W,O],null));const K=D.length===0;D.unshift(o.create(R,null,K))}this.negated=D[0]}return this.negated}}class g extends T{constructor(D,x,U){super(D,null),this._defaultValue=x,typeof U=="object"?g._info.push({...U,key:D}):U!==!0&&g._info.push({key:D,description:U,type:x!=null?typeof x:void 0})}static all(){return g._info.values()}bindTo(D){return D.createKey(this.key,this._defaultValue)}getValue(D){return D.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(D){return f.create(this.key,D)}notEqualsTo(D){return u.create(this.key,D)}}e.RawContextKey=g,g._info=[],e.IContextKeyService=(0,w.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function p(B,D){return B<D?-1:B>D?1:0}function P(B,D,x,U){return B<x?-1:B>x?1:D<U?-1:D>U?1:0}function M(B,D){if(D.type===6&&B.type!==9&&B.type!==6){for(const R of D.expr)if(B.equals(R))return!0}const x=B.negate(),U=V(x).concat(V(D));U.sort(F);for(let R=0;R<U.length;R++){const W=U[R].negate();for(let O=R+1;O<U.length;O++){const Z=U[O];if(W.equals(Z))return!0}}return!1}e.implies=M;function V(B){return B.type===9?B.expr:[B]}}),define(Ce[146],Ie([1,0,3]),function(te,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,r.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,r.refineServiceDecorator)(e.IEnvironmentService)}),define(Ce[80],Ie([1,0,124,3]),function(te,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function w(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=w;function L(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=L;function _(u,v){switch(u){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=_;function A(u,v){return v==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=A;function E(u,v,I){return A(v,I)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===I?!0:k(I).includes(u)}e.isTargetPlatformCompatible=E;function k(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=k;function F(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=F;var S;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(S=e.SortBy||(e.SortBy={}));var m;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(m=e.SortOrder||(e.SortOrder={}));var T;(function(u){u.Install="install",u.Uninstall="uninstall"})(T=e.StatisticType||(e.StatisticType={}));var f;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(f=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,y.createDecorator)("extensionGalleryService");var c;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal"})(c=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class h extends Error{constructor(v,I){super(v),this.code=I,this.name=I}}e.ExtensionManagementError=h,e.IExtensionManagementService=(0,y.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,y.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,y.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,r.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,r.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Ce[39],Ie([1,0,25,19,9,10,2,126,3]),function(te,e,r,y,w,L,_,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,E.createDecorator)("fileService");function k(W){return W.create===!0}e.isFileOpenForWriteOptions=k;var F;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(F=e.FileType||(e.FileType={}));var S;(function(W){W[W.Readonly=1]="Readonly"})(S=e.FilePermission||(e.FilePermission={}));var m;(function(W){W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock",W[W.FileAtomicRead=16384]="FileAtomicRead",W[W.FileClone=32768]="FileClone"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function T(W){return!!(W.capabilities&2)}e.hasReadWriteCapability=T;function f(W){return!!(W.capabilities&8)}e.hasFileFolderCopyCapability=f;function c(W){return!!(W.capabilities&32768)}e.hasFileCloneCapability=c;function h(W){return!!(W.capabilities&4)}e.hasOpenReadWriteCloseCapability=h;function u(W){return!!(W.capabilities&16)}e.hasFileReadStreamCapability=u;function v(W){return T(W)?!!(W.capabilities&16384):!1}e.hasFileAtomicReadCapability=v;var I;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(I=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class l extends Error{constructor(O,Z){super(O),this.code=Z}}e.FileSystemProviderError=l;function b(W,O){const Z=new l(W.toString(),O);return d(Z,O),Z}e.createFileSystemProviderError=b;function t(W){return W||b((0,A.localize)(0,null),I.Unknown)}e.ensureFileSystemProviderError=t;function d(W,O){return W.name=O?`${O} (FileSystemError)`:"FileSystemError",W}e.markAsFileSystemProviderError=d;function n(W){if(!W)return I.Unknown;if(W instanceof l)return W.code;const O=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!O)return I.Unknown;switch(O[1]){case I.FileExists:return I.FileExists;case I.FileIsADirectory:return I.FileIsADirectory;case I.FileNotADirectory:return I.FileNotADirectory;case I.FileNotFound:return I.FileNotFound;case I.FileExceedsMemoryLimit:return I.FileExceedsMemoryLimit;case I.FileTooLarge:return I.FileTooLarge;case I.FileWriteLocked:return I.FileWriteLocked;case I.NoPermissions:return I.NoPermissions;case I.Unavailable:return I.Unavailable}return I.Unknown}e.toFileSystemProviderErrorCode=n;function i(W){if(W instanceof P)return W.fileOperationResult;switch(n(W)){case I.FileNotFound:return 1;case I.FileIsADirectory:return 0;case I.FileNotADirectory:return 10;case I.FileWriteLocked:return 5;case I.NoPermissions:return 6;case I.FileExists:return 4;case I.FileExceedsMemoryLimit:return 9;case I.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=i;var s;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY",W[W.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class a{constructor(O,Z,ue){this.resource=O,this.operation=Z,this.target=ue}isOperation(O){return this.operation===O}}e.FileOperationEvent=a;var o;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class g{constructor(O,Z){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=O;const ue=new Map;for(const oe of O){const de=ue.get(oe.type);switch(de?de.push([oe.resource,oe]):ue.set(oe.type,[[oe.resource,oe]]),oe.type){case 1:this.rawAdded.push(oe.resource);break;case 0:this.rawUpdated.push(oe.resource);break;case 2:this.rawDeleted.push(oe.resource);break}}for(const[oe,de]of ue)switch(oe){case 1:this.added=r.TernarySearchTree.forUris(()=>Z),this.added.fill(de);break;case 0:this.updated=r.TernarySearchTree.forUris(()=>Z),this.updated.fill(de);break;case 2:this.deleted=r.TernarySearchTree.forUris(()=>Z),this.deleted.fill(de);break}}contains(O,...Z){return this.doContains(O,{includeChildren:!1},...Z)}affects(O,...Z){return this.doContains(O,{includeChildren:!0},...Z)}doContains(O,Z,...ue){if(!O)return!1;const oe=ue.length>0;return!!((!oe||ue.includes(1))&&(this.added?.get(O)||Z.includeChildren&&this.added?.findSuperstr(O))||(!oe||ue.includes(0))&&(this.updated?.get(O)||Z.includeChildren&&this.updated?.findSuperstr(O))||(!oe||ue.includes(2))&&(this.deleted?.findSubstr(O)||Z.includeChildren&&this.deleted?.findSuperstr(O)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=g;function p(W,O,Z){return!W||!O||W===O||O.length>W.length?!1:(O.charAt(O.length-1)!==y.sep&&(O+=y.sep),Z?(0,w.startsWithIgnoreCase)(W,O):W.indexOf(O)===0)}e.isParent=p;class P extends Error{constructor(O,Z,ue){super(O),this.fileOperationResult=Z,this.options=ue}}e.FileOperationError=P;class M extends P{constructor(O,Z,ue){super(O,2,ue),this.stat=Z}}e.NotModifiedSinceFileOperationError=M;var V;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",W[W.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(V=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var B;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(B=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function D(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}e.etag=D;async function x(W,O){if(!O.hasProvider(_.URI.from({scheme:W.scheme})))return new Promise(Z=>{const ue=O.onDidChangeFileSystemProviderRegistrations(oe=>{oe.scheme===W.scheme&&oe.added&&(ue.dispose(),Z())})})}e.whenProviderRegistered=x,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class U{static formatSize(O){return(0,L.isNumber)(O)||(O=0),O<U.KB?(0,A.localize)(1,null,O.toFixed(0)):O<U.MB?(0,A.localize)(2,null,(O/U.KB).toFixed(2)):O<U.GB?(0,A.localize)(3,null,(O/U.MB).toFixed(2)):O<U.TB?(0,A.localize)(4,null,(O/U.GB).toFixed(2)):(0,A.localize)(5,null,(O/U.TB).toFixed(2))}}e.ByteSize=U,U.KB=1024,U.MB=U.KB*U.KB,U.GB=U.MB*U.KB,U.TB=U.GB*U.KB;var R;(function(W){W[W.IA32=0]="IA32",W[W.OTHER=1]="OTHER"})(R=e.Arch||(e.Arch={}));function K(W){return{maxFileSize:W===0?300*U.MB:16*U.GB,maxHeapSize:W===0?700*U.MB:2*700*U.MB}}e.getPlatformLimits=K}),define(Ce[58],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class r{constructor(...w){this._entries=new Map;for(const[L,_]of w)this.set(L,_)}set(w,L){const _=this._entries.get(w);return this._entries.set(w,L),_}has(w){return this._entries.has(w)}get(w){return this._entries.get(w)}}e.ServiceCollection=r}),define(Ce[147],Ie([1,0,14,11,79,145,3,58]),function(te,e,r,y,w,L,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const E=!1;class k extends Error{constructor(f){super("cyclic dependency between services"),this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class F{constructor(f=new A.ServiceCollection,c=!1,h){this._activeInstantiations=new Set,this._services=f,this._strict=c,this._parent=h,this._services.set(_.IInstantiationService,this)}createChild(f){return new F(f,this._strict,this)}invokeFunction(f,...c){const h=m.traceInvocation(f);let u=!1;try{return f({get:I=>{if(u)throw(0,y.illegalState)("service accessor is only valid during the invocation of its target method");const l=this._getOrCreateServiceInstance(I,h);if(!l)throw new Error(`[invokeFunction] unknown service '${I}'`);return l}},...c)}finally{u=!0,h.stop()}}createInstance(f,...c){let h,u;return f instanceof w.SyncDescriptor?(h=m.traceCreation(f.ctor),u=this._createInstance(f.ctor,f.staticArguments.concat(c),h)):(h=m.traceCreation(f),u=this._createInstance(f,c,h)),h.stop(),u}_createInstance(f,c=[],h){const u=_._util.getServiceDependencies(f).sort((l,b)=>l.index-b.index),v=[];for(const l of u){const b=this._getOrCreateServiceInstance(l.id,h);b||this._throwIfStrict(`[createInstance] ${f.name} depends on UNKNOWN service ${l.id}.`,!1),v.push(b)}const I=u.length>0?u[0].index:c.length;if(c.length!==I){console.trace(`[createInstance] First service dependency of ${f.name} at position ${I+1} conflicts with ${c.length} static arguments`);const l=I-c.length;l>0?c=c.concat(new Array(l)):c=c.slice(0,I)}return new f(...c,...v)}_setServiceInstance(f,c){if(this._services.get(f)instanceof w.SyncDescriptor)this._services.set(f,c);else if(this._parent)this._parent._setServiceInstance(f,c);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(f){const c=this._services.get(f);return!c&&this._parent?this._parent._getServiceInstanceOrDescriptor(f):c}_getOrCreateServiceInstance(f,c){const h=this._getServiceInstanceOrDescriptor(f);return h instanceof w.SyncDescriptor?this._safeCreateAndCacheServiceInstance(f,h,c.branch(f,!0)):(c.branch(f,!1),h)}_safeCreateAndCacheServiceInstance(f,c,h){if(this._activeInstantiations.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this._activeInstantiations.add(f);try{return this._createAndCacheServiceInstance(f,c,h)}finally{this._activeInstantiations.delete(f)}}_createAndCacheServiceInstance(f,c,h){const u=new L.Graph(l=>l.id.toString());let v=0;const I=[{id:f,desc:c,_trace:h}];for(;I.length;){const l=I.pop();if(u.lookupOrInsertNode(l),v++>1e3)throw new k(u);for(const b of _._util.getServiceDependencies(l.desc.ctor)){const t=this._getServiceInstanceOrDescriptor(b.id);if(t||this._throwIfStrict(`[createInstance] ${f} depends on ${b.id} which is NOT registered.`,!0),t instanceof w.SyncDescriptor){const d={id:b.id,desc:t,_trace:l._trace.branch(b.id,!0)};u.insertEdge(l,d),I.push(d)}}}for(;;){const l=u.roots();if(l.length===0){if(!u.isEmpty())throw new k(u);break}for(const{data:b}of l){if(this._getServiceInstanceOrDescriptor(b.id)instanceof w.SyncDescriptor){const d=this._createServiceInstanceWithOwner(b.id,b.desc.ctor,b.desc.staticArguments,b.desc.supportsDelayedInstantiation,b._trace);this._setServiceInstance(b.id,d)}u.removeNode(b)}}return this._getServiceInstanceOrDescriptor(f)}_createServiceInstanceWithOwner(f,c,h=[],u,v){if(this._services.get(f)instanceof w.SyncDescriptor)return this._createServiceInstance(c,h,u,v);if(this._parent)return this._parent._createServiceInstanceWithOwner(f,c,h,u,v);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}_createServiceInstance(f,c=[],h,u){if(h){const v=new r.IdleValue(()=>this._createInstance(f,c,u));return new Proxy(Object.create(null),{get(I,l){if(l in I)return I[l];const b=v.value;let t=b[l];return typeof t!="function"||(t=t.bind(b),I[l]=t),t},set(I,l,b){return v.value[l]=b,!0}})}else return this._createInstance(f,c,u)}_throwIfStrict(f,c){if(c&&console.warn(f),this._strict)throw new Error(f)}}e.InstantiationService=F;var S;(function(T){T[T.Creation=0]="Creation",T[T.Invocation=1]="Invocation",T[T.Branch=2]="Branch"})(S||(S={}));class m{constructor(f,c){this.type=f,this.name=c,this._start=Date.now(),this._dep=[]}static traceInvocation(f){return E?new m(1,f.name||f.toString().substring(0,42).replace(/\n/g,"")):m._None}static traceCreation(f){return E?new m(0,f.name):m._None}branch(f,c){const h=new m(2,f.toString());return this._dep.push([f,c,h]),h}stop(){const f=Date.now()-this._start;m._totals+=f;let c=!1;function h(v,I){const l=[],b=new Array(v+1).join("	");for(const[t,d,n]of I._dep)if(d&&n){c=!0,l.push(`${b}CREATES -> ${t}`);const i=h(v+1,n);i&&l.push(i)}else l.push(`${b}uses -> ${t}`);return l.join(`
`)}const u=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${m._totals.toFixed(2)}ms)`];(f>2||c)&&console.log(u.join(`
`))}}e.Trace=m,m._None=new class extends m{constructor(){super(-1,null)}stop(){}branch(){return this}},m._totals=0}),define(Ce[15],Ie([1,0,43,5,7,21,3]),function(te,e,r,y,w,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,_.createDecorator)("logService"),e.ILoggerService=(0,_.createDecorator)("loggerService");function A(){return new Date().toISOString()}var E;(function(d){d[d.Trace=0]="Trace",d[d.Debug=1]="Debug",d[d.Info=2]="Info",d[d.Warning=3]="Warning",d[d.Error=4]="Error",d[d.Critical=5]="Critical",d[d.Off=6]="Off"})(E=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=E.Info;function k(d,n,i){switch(n){case E.Trace:d.trace(i);break;case E.Debug:d.debug(i);break;case E.Info:d.info(i);break;case E.Warning:d.warn(i);break;case E.Error:d.error(i);break;case E.Critical:d.critical(i);break;default:throw new Error("Invalid log level")}}e.log=k;function F(d){let n="";for(let i=0;i<d.length;i++){let s=d[i];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}n+=(i>0?" ":"")+s}return n}e.format=F;class S extends w.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new y.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=S;class m extends S{constructor(n){super(),this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...i){this.checkLogLevel(E.Trace)&&this.log(E.Trace,F([n,...i]))}debug(n,...i){this.checkLogLevel(E.Debug)&&this.log(E.Debug,F([n,...i]))}info(n,...i){this.checkLogLevel(E.Info)&&this.log(E.Info,F([n,...i]))}warn(n,...i){this.checkLogLevel(E.Warning)&&this.log(E.Warning,F([n,...i]))}error(n,...i){if(this.checkLogLevel(E.Error))if(n instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=n.stack,this.log(E.Error,F(s))}else this.log(E.Error,F([n,...i]))}critical(n,...i){this.checkLogLevel(E.Critical)&&this.log(E.Critical,F([n,...i]))}flush(){}}e.AbstractMessageLogger=m;class T extends S{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n),this.useColors=!L.isWindows}trace(n,...i){this.getLevel()<=E.Trace&&(this.useColors?console.log(`\x1B[90m[main ${A()}]\x1B[0m`,n,...i):console.log(`[main ${A()}]`,n,...i))}debug(n,...i){this.getLevel()<=E.Debug&&(this.useColors?console.log(`\x1B[90m[main ${A()}]\x1B[0m`,n,...i):console.log(`[main ${A()}]`,n,...i))}info(n,...i){this.getLevel()<=E.Info&&(this.useColors?console.log(`\x1B[90m[main ${A()}]\x1B[0m`,n,...i):console.log(`[main ${A()}]`,n,...i))}warn(n,...i){this.getLevel()<=E.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${A()}]\x1B[0m`,n,...i):console.warn(`[main ${A()}]`,n,...i))}error(n,...i){this.getLevel()<=E.Error&&(this.useColors?console.error(`\x1B[91m[main ${A()}]\x1B[0m`,n,...i):console.error(`[main ${A()}]`,n,...i))}critical(n,...i){this.getLevel()<=E.Critical&&(this.useColors?console.error(`\x1B[90m[main ${A()}]\x1B[0m`,n,...i):console.error(`[main ${A()}]`,n,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=T;class f extends S{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n)}trace(n,...i){this.getLevel()<=E.Trace&&console.log("%cTRACE","color: #888",n,...i)}debug(n,...i){this.getLevel()<=E.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...i)}info(n,...i){this.getLevel()<=E.Info&&console.log("%c INFO","color: #33f",n,...i)}warn(n,...i){this.getLevel()<=E.Warning&&console.log("%c WARN","color: #993",n,...i)}error(n,...i){this.getLevel()<=E.Error&&console.log("%c  ERR","color: #f33",n,...i)}critical(n,...i){this.getLevel()<=E.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...i)}dispose(){}flush(){}}e.ConsoleLogger=f;class c extends S{constructor(n,i=e.DEFAULT_LOG_LEVEL){super(),this.adapter=n,this.setLevel(i)}trace(n,...i){this.getLevel()<=E.Trace&&this.adapter.log(E.Trace,[this.extractMessage(n),...i])}debug(n,...i){this.getLevel()<=E.Debug&&this.adapter.log(E.Debug,[this.extractMessage(n),...i])}info(n,...i){this.getLevel()<=E.Info&&this.adapter.log(E.Info,[this.extractMessage(n),...i])}warn(n,...i){this.getLevel()<=E.Warning&&this.adapter.log(E.Warning,[this.extractMessage(n),...i])}error(n,...i){this.getLevel()<=E.Error&&this.adapter.log(E.Error,[this.extractMessage(n),...i])}critical(n,...i){this.getLevel()<=E.Critical&&this.adapter.log(E.Critical,[this.extractMessage(n),...i])}extractMessage(n){return typeof n=="string"?n:(0,r.toErrorMessage)(n,this.getLevel()<=E.Trace)}dispose(){}flush(){}}e.AdapterLogger=c;class h extends S{constructor(n){super(),this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const i of this.logServices)i.setLevel(n);super.setLevel(n)}trace(n,...i){for(const s of this.logServices)s.trace(n,...i)}debug(n,...i){for(const s of this.logServices)s.debug(n,...i)}info(n,...i){for(const s of this.logServices)s.info(n,...i)}warn(n,...i){for(const s of this.logServices)s.warn(n,...i)}error(n,...i){for(const s of this.logServices)s.error(n,...i)}critical(n,...i){for(const s of this.logServices)s.critical(n,...i)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=h;class u extends w.Disposable{constructor(n){super(),this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...i){this.logger.trace(n,...i)}debug(n,...i){this.logger.debug(n,...i)}info(n,...i){this.logger.info(n,...i)}warn(n,...i){this.logger.warn(n,...i)}error(n,...i){this.logger.error(n,...i)}critical(n,...i){this.logger.critical(n,...i)}flush(){this.logger.flush()}}e.LogService=u;class v extends w.Disposable{constructor(n,i){super(),this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(s))}))}getLogger(n){return this.loggers.get(n.toString())}createLogger(n,i){let s=this.loggers.get(n.toString());return s||(s=this.doCreateLogger(n,i?.always?E.Trace:this.logLevel,i),this.loggers.set(n.toString(),s),i?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=v;class I{constructor(){this.onDidChangeLogLevel=new y.Emitter().event}setLevel(n){}getLevel(){return E.Info}trace(n,...i){}debug(n,...i){}info(n,...i){}warn(n,...i){}error(n,...i){}critical(n,...i){}dispose(){}flush(){}}e.NullLogService=I;function l(d){if(d.verbose)return E.Trace;if(typeof d.logLevel=="string"){const n=b(d.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=l;function b(d){switch(d){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Critical;case"off":return E.Off}}e.parseLogLevel=b;function t(d){switch(d){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Critical:return"critical";case E.Off:return"off"}}e.LogLevelToString=t}),define(Ce[81],Ie([1,0,29,127,3]),function(te,e,r,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var L;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(L=e.MarkerTag||(e.MarkerTag={}));var _;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(_=e.MarkerSeverity||(e.MarkerSeverity={})),function(E){function k(f,c){return c-f}E.compare=k;const F=Object.create(null);F[E.Error]=(0,y.localize)(0,null),F[E.Warning]=(0,y.localize)(1,null),F[E.Info]=(0,y.localize)(2,null);function S(f){return F[f]||""}E.toString=S;function m(f){switch(f){case r.default.Error:return E.Error;case r.default.Warning:return E.Warning;case r.default.Info:return E.Info;case r.default.Ignore:return E.Hint}}E.fromSeverity=m;function T(f){switch(f){case E.Error:return r.default.Error;case E.Warning:return r.default.Warning;case E.Info:return r.default.Info;case E.Hint:return r.default.Ignore}}E.toSeverity=T}(_=e.MarkerSeverity||(e.MarkerSeverity={}));var A;(function(E){const k="";function F(m){return S(m,!0)}E.makeKey=F;function S(m,T){const f=[k];return m.source?f.push(m.source.replace("\xA6","\\\xA6")):f.push(k),m.code?typeof m.code=="string"?f.push(m.code.replace("\xA6","\\\xA6")):f.push(m.code.value.replace("\xA6","\\\xA6")):f.push(k),m.severity!==void 0&&m.severity!==null?f.push(_.toString(m.severity)):f.push(k),m.message&&T?f.push(m.message.replace("\xA6","\\\xA6")):f.push(k),m.startLineNumber!==void 0&&m.startLineNumber!==null?f.push(m.startLineNumber.toString()):f.push(k),m.startColumn!==void 0&&m.startColumn!==null?f.push(m.startColumn.toString()):f.push(k),m.endLineNumber!==void 0&&m.endLineNumber!==null?f.push(m.endLineNumber.toString()):f.push(k),m.endColumn!==void 0&&m.endColumn!==null?f.push(m.endColumn.toString()):f.push(k),f.push(k),f.join("\xA6")}E.makeKeyOptionalMessage=S})(A=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,w.createDecorator)("markerService")}),define(Ce[148],Ie([1,0,5,29,3]),function(te,e,r,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=y.default,e.INotificationService=(0,w.createDecorator)("notificationService");var L;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.PROFILE=1]="PROFILE",k[k.APPLICATION=2]="APPLICATION"})(L=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var _;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(_=e.NotificationsFilter||(e.NotificationsFilter={}));class A{constructor(){this.progress=new E,this.onDidClose=r.Event.None,this.onDidChangeVisibility=r.Event.None}updateSeverity(F){}updateMessage(F){}updateActions(F){}close(){}}e.NoOpNotification=A;class E{infinite(){}done(){}total(F){}worked(F){}}e.NoOpProgress=E}),define(Ce[82],Ie([1,0,7,9,2,3]),function(te,e,r,y,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,L.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return r.Disposable.None},registerValidator(){return r.Disposable.None},registerExternalUriResolver(){return r.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return r.Disposable.None},async open(){return!1},async resolveExternalUri(F){return{resolved:F,dispose(){}}}});function _(F,S){return w.URI.isUri(F)?(0,y.equalsIgnoreCase)(F.scheme,S):(0,y.startsWithIgnoreCase)(F,S+":")}e.matchesScheme=_;function A(F,...S){return S.some(m=>_(F,m))}e.matchesSomeScheme=A;function E(F,S){return F.with({fragment:`${S.startLineNumber},${S.startColumn}${S.endLineNumber?`-${S.endLineNumber}${S.endColumn?`,${S.endColumn}`:""}`:""}`})}e.withSelection=E;function k(F){let S;const m=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(F.fragment);return m&&(S={startLineNumber:parseInt(m[1]),startColumn:m[2]?parseInt(m[2]):1,endLineNumber:m[4]?parseInt(m[4]):void 0,endColumn:m[4]?m[5]?parseInt(m[5]):1:void 0},F=F.with({fragment:""})),{selection:S,uri:F}}e.extractSelection=k}),define(Ce[149],Ie([1,0,3]),function(te,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,r.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var ze=this&&this.__decorate||function(te,e,r,y){var w=arguments.length,L=w<3?e:y===null?y=Object.getOwnPropertyDescriptor(e,r):y,_;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(te,e,r,y);else for(var A=te.length-1;A>=0;A--)(_=te[A])&&(L=(w<3?_(L):w>3?_(e,r,L):_(e,r))||L);return w>3&&L&&Object.defineProperty(e,r,L),L},xe=this&&this.__param||function(te,e){return function(r,y){e(r,y,te)}};define(Ce[150],Ie([1,0,14,20,7,3]),function(te,e,r,y,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,L.createDecorator)("progressService");var _;(function(F){F[F.Explorer=1]="Explorer",F[F.Scm=3]="Scm",F[F.Extensions=5]="Extensions",F[F.Window=10]="Window",F[F.Notification=15]="Notification",F[F.Dialog=20]="Dialog"})(_=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class A{constructor(S){this.callback=S}get value(){return this._value}report(S){this._value=S,this.callback(this._value)}}e.Progress=A,A.None=Object.freeze({report(){}});let E=class extends w.Disposable{constructor(S,m){super(),this.deferred=new r.DeferredPromise,m.withProgress(S,T=>(this.reporter=T,this.lastStep&&T.report(this.lastStep),this.deferred.p)),this._register((0,w.toDisposable)(()=>this.deferred.complete()))}report(S){this.reporter?this.reporter.report(S):this.lastStep=S}};E=ze([xe(1,e.IProgressService)],E),e.UnmanagedProgress=E;class k extends w.Disposable{constructor(S){super(),this.progressIndicator=S,this.currentOperationId=0,this.currentOperationDisposables=this._register(new w.DisposableStore)}start(S){this.stop();const m=++this.currentOperationId,T=new y.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{m===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},S),this.currentOperationDisposables.add((0,w.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,w.toDisposable)(()=>T.cancel())),this.currentOperationDisposables.add((0,w.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:m,token:T.token,stop:()=>this.doStop(m),isCurrent:()=>this.currentOperationId===m}}stop(){this.doStop(this.currentOperationId)}doStop(S){this.currentOperationId===S&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,L.createDecorator)("editorProgressService")}),define(Ce[30],Ie([1,0,44,10]),function(te,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class w{constructor(){this.data=new Map}add(_,A){r.ok(y.isString(_)),r.ok(y.isObject(A)),r.ok(!this.data.has(_),"There is already an extension with this id"),this.data.set(_,A)}knows(_){return this.data.has(_)}as(_){return this.data.get(_)||null}}e.Registry=new w}),define(Ce[83],Ie([1,0,5,30]),function(te,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function w(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class L{constructor(){this._onDidChangeSchema=new r.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(E,k){this.schemasById[w(E)]=k,this._onDidChangeSchema.fire(E)}notifySchemaChanged(E){this._onDidChangeSchema.fire(E)}getSchemaContributions(){return{schemas:this.schemasById}}}const _=new L;y.Registry.add(e.Extensions.JSONContribution,_)}),define(Ce[84],Ie([1,0,16,5,10,123,57,83,30]),function(te,e,r,y,w,L,_,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var k;(function(b){b.Multiline="multilineText",b.Singleline="singlelineText"})(k=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var F;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(F=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const S=E.Registry.as(A.Extensions.JSONContribution);class m{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new y.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new y.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,d=!0){this.registerConfigurations([t],d)}registerConfigurations(t,d=!0){const n=this.doRegisterConfigurations(t,d);S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}deregisterConfigurations(t){const d=this.doDeregisterConfigurations(t);S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d})}updateConfigurations({add:t,remove:d}){const n=[];n.push(...this.doDeregisterConfigurations(d)),n.push(...this.doRegisterConfigurations(t,!1)),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,r.distinct)(n)})}registerDefaultConfigurations(t){const d=[],n=[];for(const{overrides:i,source:s}of t)for(const a in i)if(d.push(a),e.OVERRIDE_PROPERTY_REGEX.test(a)){const o=this.configurationDefaultsOverrides.get(a),g=o?.valuesSources??new Map;if(s)for(const V of Object.keys(i[a]))g.set(V,s);const p={...o?.value||{},...i[a]};this.configurationDefaultsOverrides.set(a,{source:s,value:p,valuesSources:g});const P=(0,_.getLanguageTagSettingPlainKey)(a),M={type:"object",default:p,description:L.localize(1,null,P),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:p,source:w.isString(s)?void 0:s,defaultValueSource:s};n.push(...c(a)),this.configurationProperties[a]=M,this.defaultLanguageConfigurationOverridesNode.properties[a]=M}else{this.configurationDefaultsOverrides.set(a,{value:i[a],source:s});const o=this.configurationProperties[a];o&&(this.updatePropertyDefaultValue(a,o),this.updateSchema(a,o))}this.registerOverrideIdentifiers(n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d,defaultsOverrides:!0})}deregisterDefaultConfigurations(t){const d=[];for(const{overrides:n,source:i}of t)for(const s in n){const a=this.configurationDefaultsOverrides.get(s),o=w.isString(i)?i:i?.id,g=w.isString(a?.source)?a?.source:a?.source?.id;if(o===g)if(d.push(s),this.configurationDefaultsOverrides.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const p=this.configurationProperties[s];p&&(this.updatePropertyDefaultValue(s,p),this.updateSchema(s,p))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){for(const d of t)this.overrideIdentifiers.add(d);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,d){const n=[];return t.forEach(i=>{n.push(...this.validateAndRegisterProperties(i,d,i.extensionInfo,i.restrictedProperties)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),n}doDeregisterConfigurations(t){const d=[],n=i=>{if(i.properties)for(const s in i.properties){d.push(s);const a=this.configurationProperties[s];a?.policy?.name&&this.policyConfigurations.delete(a.policy.name),delete this.configurationProperties[s],this.removeFromSchema(s,i.properties[s])}i.allOf?.forEach(s=>n(s))};for(const i of t){n(i);const s=this.configurationContributors.indexOf(i);s!==-1&&this.configurationContributors.splice(s,1)}return d}validateAndRegisterProperties(t,d=!0,n,i,s=3){s=w.isUndefinedOrNull(t.scope)?s:t.scope;const a=[],o=t.properties;if(o)for(const p in o){const P=o[p];if(d&&I(p,P)){delete o[p];continue}if(P.source=n,P.defaultDefaultValue=o[p].default,this.updatePropertyDefaultValue(p,P),e.OVERRIDE_PROPERTY_REGEX.test(p)?P.scope=void 0:(P.scope=w.isUndefinedOrNull(P.scope)?s:P.scope,P.restricted=w.isUndefinedOrNull(P.restricted)?!!i?.includes(p):P.restricted),o[p].hasOwnProperty("included")&&!o[p].included){this.excludedConfigurationProperties[p]=o[p],delete o[p];continue}else this.configurationProperties[p]=o[p],o[p].policy?.name&&this.policyConfigurations.set(o[p].policy.name,p);!o[p].deprecationMessage&&o[p].markdownDeprecationMessage&&(o[p].deprecationMessage=o[p].markdownDeprecationMessage),a.push(p)}const g=t.allOf;if(g)for(const p of g)a.push(...this.validateAndRegisterProperties(p,d,n,i,s));return a}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const d=n=>{const i=n.properties;if(i)for(const a in i)this.updateSchema(a,i[a]);n.allOf?.forEach(d)};d(t)}updateSchema(t,d){switch(e.allSettings.properties[t]=d,d.scope){case 1:e.applicationSettings.properties[t]=d;break;case 2:e.machineSettings.properties[t]=d;break;case 6:e.machineOverridableSettings.properties[t]=d;break;case 3:e.windowSettings.properties[t]=d;break;case 4:e.resourceSettings.properties[t]=d;break;case 5:e.resourceSettings.properties[t]=d,this.resourceLanguageSettingsSchema.properties[t]=d;break}}removeFromSchema(t,d){switch(delete e.allSettings.properties[t],d.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const d=`[${t}]`,n={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(d,n),e.allSettings.properties[d]=n,e.applicationSettings.properties[d]=n,e.machineSettings.properties[d]=n,e.machineOverridableSettings.properties[d]=n,e.windowSettings.properties[d]=n,e.resourceSettings.properties[d]=n}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const t={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,d){const n=this.configurationDefaultsOverrides.get(t);let i=n?.value,s=n?.source;w.isUndefined(i)&&(i=d.defaultDefaultValue,s=void 0),w.isUndefined(i)&&(i=u(d.type)),d.default=i,d.defaultValueSource=s}}const T="\\[([^\\]]+)\\]",f=new RegExp(T,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${T})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function c(b){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(b)){let d=f.exec(b);for(;d?.length;){const n=d[1].trim();n&&t.push(n),d=f.exec(b)}}return(0,r.distinct)(t)}e.overrideIdentifiersFromKey=c;function h(b){return b.reduce((t,d)=>`${t}[${d}]`,"")}e.keyFromOverrideIdentifiers=h;function u(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const v=new m;E.Registry.add(e.Extensions.Configuration,v);function I(b,t){return b.trim()?e.OVERRIDE_PROPERTY_REGEX.test(b)?L.localize(7,null,b):v.getConfigurationProperties()[b]!==void 0?L.localize(8,null,b):t.policy?.name&&v.getPolicyConfigurations().get(t.policy?.name)!==void 0?L.localize(9,null,b,t.policy?.name,v.getPolicyConfigurations().get(t.policy?.name)):null:L.localize(6,null)}e.validateProperty=I;function l(){const b=[],t=v.getConfigurationProperties();for(const d of Object.keys(t))b.push([d,t[d].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.getScopes=l}),define(Ce[151],Ie([1,0,16,5,105,7,25,26,10,2,57,84,30]),function(te,e,r,y,w,L,_,A,E,k,F,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class T{constructor(t={},d=[],n=[]){this._contents=t,this._keys=d,this._overrides=n,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(t){return t?(0,F.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,d){const n=this.getContentsForOverrideIdentifer(d);return n?t?(0,F.getConfigurationValue)(n,t):n:void 0}getKeysForOverrideIdentifier(t){const d=[];for(const n of this.overrides)n.identifiers.includes(t)&&d.push(...n.keys);return r.distinct(d)}getAllOverrideIdentifiers(){const t=[];for(const d of this.overrides)t.push(...d.identifiers);return r.distinct(t)}override(t){let d=this.overrideConfigurations.get(t);return d||(d=this.createOverrideConfigurationModel(t),this.overrideConfigurations.set(t,d)),d}merge(...t){const d=A.deepClone(this.contents),n=A.deepClone(this.overrides),i=[...this.keys];for(const s of t)if(!s.isEmpty()){this.mergeContents(d,s.contents);for(const a of s.overrides){const[o]=n.filter(g=>r.equals(g.identifiers,a.identifiers));o?(this.mergeContents(o.contents,a.contents),o.keys.push(...a.keys),o.keys=r.distinct(o.keys)):n.push(A.deepClone(a))}for(const a of s.keys)i.indexOf(a)===-1&&i.push(a)}return new T(d,i,n)}freeze(){return this.frozen=!0,this}clone(){return new T(A.deepClone(this.contents),[...this.keys],A.deepClone(this.overrides))}createOverrideConfigurationModel(t){const d=this.getContentsForOverrideIdentifer(t);if(!d||typeof d!="object"||!Object.keys(d).length)return this;const n={};for(const i of r.distinct([...Object.keys(this.contents),...Object.keys(d)])){let s=this.contents[i];const a=d[i];a&&(typeof s=="object"&&typeof a=="object"?(s=A.deepClone(s),this.mergeContents(s,a)):s=a),n[i]=s}return new T(n,this.keys,this.overrides)}mergeContents(t,d){for(const n of Object.keys(d)){if(n in t&&E.isObject(t[n])&&E.isObject(d[n])){this.mergeContents(t[n],d[n]);continue}t[n]=A.deepClone(d[n])}}checkAndFreeze(t){return this.frozen&&!Object.isFrozen(t)?A.deepFreeze(t):t}getContentsForOverrideIdentifer(t){let d=null,n=null;const i=s=>{s&&(n?this.mergeContents(n,s):n=A.deepClone(s))};for(const s of this.overrides)r.equals(s.identifiers,[t])?d=s.contents:s.identifiers.includes(t)&&i(s.contents);return i(d),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,d){this.addKey(t),(0,F.addToValueTree)(this.contents,t,d,n=>{throw new Error(n)})}removeValue(t){this.removeKey(t)&&(0,F.removeFromValueTree)(this.contents,t)}addKey(t){let d=this.keys.length;for(let n=0;n<d;n++)t.indexOf(this.keys[n])===0&&(d=n);this.keys.splice(d,1,t)}removeKey(t){const d=this.keys.indexOf(t);return d!==-1?(this.keys.splice(d,1),!0):!1}}e.ConfigurationModel=T;class f{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new T}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,d){if(!E.isUndefinedOrNull(t)){const n=this.doParseContent(t);this.parseRaw(n,d)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,d){this._raw=t;const{contents:n,keys:i,overrides:s,restricted:a}=this.doParseRaw(t,d);this._configurationModel=new T(n,i,s),this._restrictedConfigurations=a||[]}doParseContent(t){let d={},n=null,i=[];const s=[],a=[];function o(p){Array.isArray(i)?i.push(p):n!==null&&(i[n]=p)}const g={onObjectBegin:()=>{const p={};o(p),s.push(i),i=p,n=null},onObjectProperty:p=>{n=p},onObjectEnd:()=>{i=s.pop()},onArrayBegin:()=>{const p=[];o(p),s.push(i),i=p,n=null},onArrayEnd:()=>{i=s.pop()},onLiteralValue:o,onError:(p,P,M)=>{a.push({error:p,offset:P,length:M})}};if(t)try{w.visit(t,g),d=i[0]||{}}catch(p){console.error(`Error while parsing settings file ${this._name}: ${p}`),this._parseErrors=[p]}return d}doParseRaw(t,d){const n=m.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),i=this.filter(t,n,!0,d);t=i.raw;const s=(0,F.toValuesTree)(t,g=>console.error(`Conflict in settings file ${this._name}: ${g}`)),a=Object.keys(t),o=this.toOverrides(t,g=>console.error(`Conflict in settings file ${this._name}: ${g}`));return{contents:s,keys:a,overrides:o,restricted:i.restricted}}filter(t,d,n,i){if(!i?.scopes&&!i?.skipRestricted)return{raw:t,restricted:[]};const s={},a=[];for(const o in t)if(S.OVERRIDE_PROPERTY_REGEX.test(o)&&n){const g=this.filter(t[o],d,!1,i);s[o]=g.raw,a.push(...g.restricted)}else{const g=d[o],p=g?typeof g.scope<"u"?g.scope:3:void 0;g?.restricted&&a.push(o),(p===void 0||i.scopes===void 0||i.scopes.includes(p))&&(i.skipRestricted&&g?.restricted||(s[o]=t[o]))}return{raw:s,restricted:a}}toOverrides(t,d){const n=[];for(const i of Object.keys(t))if(S.OVERRIDE_PROPERTY_REGEX.test(i)){const s={};for(const a in t[i])s[a]=t[i][a];n.push({identifiers:(0,S.overrideIdentifiersFromKey)(i),keys:Object.keys(s),contents:(0,F.toValuesTree)(s,d)})}return n}}e.ConfigurationModelParser=f;class c extends L.Disposable{constructor(t,d,n,i){super(),this.userSettingsResource=t,this.scopes=d,this.fileService=i,this._onDidChange=this._register(new y.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(y.Event.any(y.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource)),y.Event.filter(this.fileService.onDidRunOperation,s=>(s.isOperation(0)||s.isOperation(3)||s.isOperation(1)||s.isOperation(4))&&n.isEqual(s.resource,t)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new T}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=c;class h{constructor(t,d,n,i,s=new T,a=new T,o=new _.ResourceMap,g=new T,p=new _.ResourceMap,P=!0){this._defaultConfiguration=t,this._policyConfiguration=d,this._applicationConfiguration=n,this._localUserConfiguration=i,this._remoteUserConfiguration=s,this._workspaceConfiguration=a,this._folderConfigurations=o,this._memoryConfiguration=g,this._memoryConfigurationByResource=p,this._freeze=P,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new _.ResourceMap,this._userConfiguration=null}getValue(t,d,n){return this.getConsolidatedConfigurationModel(t,d,n).getValue(t)}updateValue(t,d,n={}){let i;n.resource?(i=this._memoryConfigurationByResource.get(n.resource),i||(i=new T,this._memoryConfigurationByResource.set(n.resource,i))):i=this._memoryConfiguration,d===void 0?i.removeValue(t):i.setValue(t,d),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,d,n){const i=this.getConsolidatedConfigurationModel(t,d,n),s=this.getFolderConfigurationModelForResource(d.resource,n),a=d.resource?this._memoryConfigurationByResource.get(d.resource)||this._memoryConfiguration:this._memoryConfiguration,o=d.overrideIdentifier?this._defaultConfiguration.freeze().override(d.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),g=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(t),p=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(t),P=d.overrideIdentifier?this.userConfiguration.freeze().override(d.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),M=d.overrideIdentifier?this.localUserConfiguration.freeze().override(d.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),V=d.overrideIdentifier?this.remoteUserConfiguration.freeze().override(d.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),B=n?d.overrideIdentifier?this._workspaceConfiguration.freeze().override(d.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,D=s?d.overrideIdentifier?s.freeze().override(d.overrideIdentifier).getValue(t):s.freeze().getValue(t):void 0,x=d.overrideIdentifier?a.override(d.overrideIdentifier).getValue(t):a.getValue(t),U=i.getValue(t),R=r.distinct(i.overrides.map(K=>K.identifiers).flat()).filter(K=>i.getOverrideValue(t,K)!==void 0);return{defaultValue:o,policyValue:g,applicationValue:p,userValue:P,userLocalValue:M,userRemoteValue:V,workspaceValue:B,workspaceFolderValue:D,memoryValue:x,value:U,default:o!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:d.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,d.overrideIdentifier):void 0}:void 0,policy:g!==void 0?{value:g}:void 0,application:p!==void 0?{value:p,override:d.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(t,d.overrideIdentifier):void 0}:void 0,user:P!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:d.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,d.overrideIdentifier):void 0}:void 0,userLocal:M!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:d.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,d.overrideIdentifier):void 0}:void 0,userRemote:V!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:d.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,d.overrideIdentifier):void 0}:void 0,workspace:B!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:d.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,d.overrideIdentifier):void 0}:void 0,workspaceFolder:D!==void 0?{value:s?.freeze().getValue(t),override:d.overrideIdentifier?s?.freeze().getOverrideValue(t,d.overrideIdentifier):void 0}:void 0,memory:x!==void 0?{value:a.getValue(t),override:d.overrideIdentifier?a.getOverrideValue(t,d.overrideIdentifier):void 0}:void 0,overrideIdentifiers:R.length?R:void 0}}keys(t){const d=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:d?d.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(t){this._policyConfiguration=t}updateApplicationConfiguration(t){this._applicationConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,d){this._folderConfigurations.set(t,d),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,d){const n=[];if(!d){const{added:i,updated:s,removed:a}=I(this._defaultConfiguration,t);d=[...i,...s,...a]}for(const i of d)for(const s of(0,S.overrideIdentifiersFromKey)(i)){const a=this._defaultConfiguration.getKeysForOverrideIdentifier(s),o=t.getKeysForOverrideIdentifier(s),g=[...o.filter(p=>a.indexOf(p)===-1),...a.filter(p=>o.indexOf(p)===-1),...a.filter(p=>!A.equals(this._defaultConfiguration.override(s).getValue(p),t.override(s).getValue(p)))];n.push([s,g])}return this.updateDefaultConfiguration(t),{keys:d,overrides:n}}compareAndUpdatePolicyConfiguration(t){const{added:d,updated:n,removed:i}=I(this._policyConfiguration,t),s=[...d,...n,...i];return s.length&&this.updatePolicyConfiguration(t),{keys:s,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:d,updated:n,removed:i,overrides:s}=I(this.applicationConfiguration,t),a=[...d,...n,...i];return a.length&&this.updateApplicationConfiguration(t),{keys:a,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:d,updated:n,removed:i,overrides:s}=I(this.localUserConfiguration,t),a=[...d,...n,...i];return a.length&&this.updateLocalUserConfiguration(t),{keys:a,overrides:s}}compareAndUpdateRemoteUserConfiguration(t){const{added:d,updated:n,removed:i,overrides:s}=I(this.remoteUserConfiguration,t),a=[...d,...n,...i];return a.length&&this.updateRemoteUserConfiguration(t),{keys:a,overrides:s}}compareAndUpdateWorkspaceConfiguration(t){const{added:d,updated:n,removed:i,overrides:s}=I(this.workspaceConfiguration,t),a=[...d,...n,...i];return a.length&&this.updateWorkspaceConfiguration(t),{keys:a,overrides:s}}compareAndUpdateFolderConfiguration(t,d){const n=this.folderConfigurations.get(t),{added:i,updated:s,removed:a,overrides:o}=I(n,d),g=[...i,...s,...a];return(g.length||!n)&&this.updateFolderConfiguration(t,d),{keys:g,overrides:o}}compareAndDeleteFolderConfiguration(t){const d=this.folderConfigurations.get(t);if(!d)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:n,updated:i,removed:s,overrides:a}=I(d,void 0);return{keys:[...n,...i,...s],overrides:a}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(t,d,n){let i=this.getConsolidatedConfigurationModelForResource(d,n);return d.overrideIdentifier&&(i=i.override(d.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(t)!==void 0&&(i=i.merge(this._policyConfiguration)),i}getConsolidatedConfigurationModelForResource({resource:t},d){let n=this.getWorkspaceConsolidatedConfiguration();if(d&&t){const i=d.getFolder(t);i&&(n=this.getFolderConsolidatedConfiguration(i.uri)||n);const s=this._memoryConfigurationByResource.get(t);s&&(n=n.merge(s))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let d=this._foldersConsolidatedConfigurations.get(t);if(!d){const n=this.getWorkspaceConsolidatedConfiguration(),i=this._folderConfigurations.get(t);i?(d=n.merge(i),this._freeze&&(d=d.freeze()),this._foldersConsolidatedConfigurations.set(t,d)):d=n}return d}getFolderConfigurationModelForResource(t,d){if(d&&t){const n=d.getFolder(t);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,d)=>{const{contents:n,overrides:i,keys:s}=this._folderConfigurations.get(d);return t.push([d,{contents:n,overrides:i,keys:s}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(d=>t.add(d)),this.userConfiguration.freeze().keys.forEach(d=>t.add(d)),this._workspaceConfiguration.freeze().keys.forEach(d=>t.add(d)),this._folderConfigurations.forEach(d=>d.freeze().keys.forEach(n=>t.add(n))),[...t.values()]}allOverrideIdentifiers(){const t=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(d=>t.add(d)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(d=>t.add(d)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(d=>t.add(d)),this._folderConfigurations.forEach(d=>d.freeze().getAllOverrideIdentifiers().forEach(n=>t.add(n))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const d=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>d.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>d.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>d.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(t).forEach(i=>d.add(i))),[...d.values()]}static parse(t){const d=this.parseConfigurationModel(t.defaults),n=this.parseConfigurationModel(t.policy),i=this.parseConfigurationModel(t.application),s=this.parseConfigurationModel(t.user),a=this.parseConfigurationModel(t.workspace),o=t.folders.reduce((g,p)=>(g.set(k.URI.revive(p[0]),this.parseConfigurationModel(p[1])),g),new _.ResourceMap);return new h(d,n,i,s,new T,a,o,new T,new _.ResourceMap,!1)}static parseConfigurationModel(t){return new T(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=h;function u(...b){if(b.length===0)return{keys:[],overrides:[]};if(b.length===1)return b[0];const t=new Set,d=new Map;for(const i of b)i.keys.forEach(s=>t.add(s)),i.overrides.forEach(([s,a])=>{const o=(0,_.getOrSet)(d,s,new Set);a.forEach(g=>o.add(g))});const n=[];return d.forEach((i,s)=>n.push([s,[...i.values()]])),{keys:[...t.values()],overrides:n}}e.mergeChanges=u;class v{constructor(t,d,n,i){this.change=t,this.previous=d,this.currentConfiguraiton=n,this.currentWorkspace=i,this._previousConfiguration=void 0;const s=new Set;t.keys.forEach(o=>s.add(o)),t.overrides.forEach(([,o])=>o.forEach(g=>s.add(g))),this.affectedKeys=[...s.values()];const a=new T;this.affectedKeys.forEach(o=>a.setValue(o,{})),this.affectedKeysTree=a.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=h.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,d){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(d){const n=this.previousConfiguration?this.previousConfiguration.getValue(t,d,this.previous?.workspace):void 0,i=this.currentConfiguraiton.getValue(t,d,this.currentWorkspace);return!A.equals(n,i)}return!0}return!1}doesAffectedKeysTreeContains(t,d){let n=(0,F.toValuesTree)({[d]:!0},()=>{}),i;for(;typeof n=="object"&&(i=Object.keys(n)[0]);){if(t=t[i],!t)return!1;n=n[i]}return!0}}e.ConfigurationChangeEvent=v;function I(b,t){const{added:d,removed:n,updated:i}=l(t,b),s=[],a=b?.getAllOverrideIdentifiers()||[],o=t?.getAllOverrideIdentifiers()||[];if(t){const g=o.filter(p=>!a.includes(p));for(const p of g)s.push([p,t.getKeysForOverrideIdentifier(p)])}if(b){const g=a.filter(p=>!o.includes(p));for(const p of g)s.push([p,b.getKeysForOverrideIdentifier(p)])}if(t&&b){for(const g of a)if(o.includes(g)){const p=l({contents:b.getOverrideValue(void 0,g)||{},keys:b.getKeysForOverrideIdentifier(g)},{contents:t.getOverrideValue(void 0,g)||{},keys:t.getKeysForOverrideIdentifier(g)});s.push([g,[...p.added,...p.removed,...p.updated]])}}return{added:d,removed:n,updated:i,overrides:s}}function l(b,t){const d=b?t?b.keys.filter(s=>t.keys.indexOf(s)===-1):[...b.keys]:[],n=t?b?t.keys.filter(s=>b.keys.indexOf(s)===-1):[...t.keys]:[],i=[];if(b&&t){for(const s of t.keys)if(b.keys.indexOf(s)!==-1){const a=(0,F.getConfigurationValue)(t.contents,s),o=(0,F.getConfigurationValue)(b.contents,s);A.equals(a,o)||i.push(s)}}return{added:d,removed:n,updated:i}}}),define(Ce[85],Ie([1,0,11,3]),function(te,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,y.createDecorator)("remoteAuthorityResolverService");var w;(function(_){_.Unknown="Unknown",_.NotAvailable="NotAvailable",_.TemporarilyNotAvailable="TemporarilyNotAvailable",_.NoResolverFound="NoResolverFound"})(w=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class L extends r.ErrorNoTelemetry{constructor(A,E=w.Unknown,k){super(A),this._message=A,this._code=E,this._detail=k,this.isHandled=E===w.NotAvailable&&k===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,L.prototype)}static isTemporarilyNotAvailable(A){return A instanceof L&&A._code===w.TemporarilyNotAvailable}static isNoResolverFound(A){return A instanceof L&&A._code===w.NoResolverFound}static isHandled(A){return A instanceof L&&A.isHandled}}e.RemoteAuthorityResolverError=L}),define(Ce[86],Ie([1,0,12]),function(te,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function y(k){return k.scheme===r.Schemas.vscodeRemote?k.authority:void 0}e.getRemoteAuthority=y;function w(k){if(!k)return;const F=k.indexOf("+");return F<0?k:k.substr(0,F)}e.getRemoteName=w;function L(k){return`/${k.quality??"oss"}-${k.commit??"dev"}`}e.getRemoteServerRootPath=L;function _(k){const{host:F,port:S}=E(k);if(typeof S>"u")throw new Error("Remote authority doesn't contain a port!");return{host:F,port:S}}e.parseAuthorityWithPort=_;function A(k,F){let{host:S,port:m}=E(k);return typeof m>"u"&&(m=F),{host:S,port:m}}e.parseAuthorityWithOptionalPort=A;function E(k){const F=k.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(F)return{host:F[1],port:parseInt(F[2],10)};const S=k.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const m=k.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:k,port:void 0}}}),define(Ce[27],Ie([1,0,9,3,86]),function(te,e,r,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function L(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=L;function _(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=_,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));var E;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(E=e.TargetPlatform||(e.TargetPlatform={}));class k{constructor(c){this.value=c,this._lower=c.toLowerCase()}static equals(c,h){if(typeof c>"u"||c===null)return typeof h>"u"||h===null;if(typeof h>"u"||h===null)return!1;if(typeof c=="string"||typeof h=="string"){const u=typeof c=="string"?c:c.value,v=typeof h=="string"?h:h.value;return r.equalsIgnoreCase(u,v)}return c._lower===h._lower}static toKey(c){return typeof c=="string"?c.toLowerCase():c._lower}}e.ExtensionIdentifier=k;function F(f){return S(f)}e.isApplicationScopedExtension=F;function S(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=S;function m(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=m;function T(f,c){if(c){const h=`onResolveRemoteAuthority:${(0,w.getRemoteName)(c)}`;return f.activationEvents?.indexOf(h)!==-1}return!1}e.isResolverExtension=T,e.IBuiltinExtensionsScannerService=(0,y.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ce[152],Ie([1,0,9,80,27,21,2,11,59]),function(te,e,r,y,w,L,_,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function k(d,n){return d.uuid&&n.uuid?d.uuid===n.uuid:d.id===n.id?!0:(0,r.compareIgnoreCase)(d.id,n.id)===0}e.areSameExtensions=k;const F=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class S{constructor(n,i,s="undefined"){this.version=i,this.targetPlatform=s,this.id=n.id}static create(n){const i=n.manifest?n.manifest.version:n.version,s=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new S(n.identifier,i,s)}static parse(n){const i=F.exec(n);return i&&i[1]&&i[2]?new S({id:i[1]},i[2],i[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof S?k(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=S;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function T(d){const n=m.exec(d);return n&&n[1]?[c(n[1]),n[2]]:[c(d),void 0]}e.getIdAndVersion=T;function f(d,n){return`${d}.${n}`}e.getExtensionId=f;function c(d){return d.toLocaleLowerCase()}e.adoptToGalleryExtensionId=c;function h(d,n){return c(f(d,n))}e.getGalleryExtensionId=h;function u(d,n){const i=[],s=a=>{for(const o of i)if(o.some(g=>k(n(g),n(a))))return o;return null};for(const a of d){const o=s(a);o?o.push(a):i.push([a])}return i}e.groupByExtension=u;function v(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=v;function I(d){return{id:d.identifier.id,name:d.name,galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,isPreReleaseVersion:d.properties.isPreReleaseVersion,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),...d.telemetryData}}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new w.ExtensionIdentifier("pprice.better-merge");function l(d,n){const i=[],s=n.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const a=s.shift();if(a&&i.every(o=>!k(o.identifier,{id:a}))){const o=d.filter(g=>k(g.identifier,{id:a}));o.length===1&&(i.push(o[0]),s.push(...o[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}e.getExtensionDependencies=l;async function b(d,n){if(!L.isLinux)return!1;let i;try{i=(await d.readFile(_.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await d.readFile(_.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){n.debug("Error while getting the os-release file.",(0,A.getErrorMessage)(a))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=b;async function t(d,n){const i=await b(d,n),s=(0,y.getTargetPlatform)(i?"alpine":L.platform,E.arch);return n.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=t}),define(Ce[153],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class r{constructor(w){this._callback=w,this._terminalBufferMap=new Map}dispose(){for(const w of this._terminalBufferMap.values())w.dispose()}startBuffering(w,L,_=5){const A=L(E=>{const k=typeof E=="string"?E:E.data;let F=this._terminalBufferMap.get(w);if(F){F.data.push(k);return}const S=setTimeout(()=>this.flushBuffer(w),_);F={data:[k],timeoutId:S,dispose:()=>{clearTimeout(S),this.flushBuffer(w),A.dispose()}},this._terminalBufferMap.set(w,F)});return A}stopBuffering(w){this._terminalBufferMap.get(w)?.dispose()}flushBuffer(w){const L=this._terminalBufferMap.get(w);L&&(this._terminalBufferMap.delete(w),this._callback(w,L.data.join("")))}}e.TerminalDataBufferer=r}),define(Ce[154],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var r;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST_DARK="hcDark",L.HIGH_CONTRAST_LIGHT="hcLight"})(r=e.ColorScheme||(e.ColorScheme={}));function y(L){return L===r.HIGH_CONTRAST_DARK||L===r.HIGH_CONTRAST_LIGHT}e.isHighContrast=y;function w(L){return L===r.DARK||L===r.HIGH_CONTRAST_DARK}e.isDark=w}),define(Ce[60],Ie([1,0,116,5,7,3,30,154]),function(te,e,r,y,w,L,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,L.createDecorator)("themeService");var E;(function(h){function u(v){return v&&typeof v=="object"&&typeof v.id=="string"}h.isThemeColor=u})(E=e.ThemeColor||(e.ThemeColor={}));function k(h){return{id:h}}e.themeColorFromId=k;var F;(function(h){function u(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||E.isThemeColor(i.color))}h.isThemeIcon=u;const v=new RegExp(`^\\$\\((${r.CSSIcon.iconNameExpression}(?:${r.CSSIcon.iconModifierExpression})?)\\)$`);function I(i){const s=v.exec(i);if(!s)return;const[,a]=s;return{id:a}}h.fromString=I;function l(i){return{id:i}}h.fromId=l;function b(i,s){let a=i.id;const o=a.lastIndexOf("~");return o!==-1&&(a=a.substring(0,o)),s&&(a=`${a}~${s}`),{id:a}}h.modify=b;function t(i){const s=i.id.lastIndexOf("~");if(s!==-1)return i.id.substring(s+1)}h.getModifier=t;function d(i,s){return i.id===s.id&&i.color?.id===s.color?.id}h.isEqual=d;function n(i,s){return{id:i.id,color:s?k(s):void 0}}h.asThemeIcon=n,h.asClassNameArray=r.CSSIcon.asClassNameArray,h.asClassName=r.CSSIcon.asClassName,h.asCSSSelector=r.CSSIcon.asCSSSelector})(F=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=r.Codicon.file,e.FolderThemeIcon=r.Codicon.folder;function S(h){switch(h){case A.ColorScheme.DARK:return"vs-dark";case A.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case A.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=S,e.Extensions={ThemingContribution:"base.contributions.theming"};class m{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new y.Emitter}onColorThemeChange(u){return this.themingParticipants.push(u),this.onThemingParticipantAddedEmitter.fire(u),(0,w.toDisposable)(()=>{const v=this.themingParticipants.indexOf(u);this.themingParticipants.splice(v,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const T=new m;_.Registry.add(e.Extensions.ThemingContribution,T);function f(h){return T.onColorThemeChange(h)}e.registerThemingParticipant=f;class c extends w.Disposable{constructor(u){super(),this.themeService=u,this.theme=u.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(v=>this.onThemeChange(v)))}onThemeChange(u){this.theme=u,this.updateStyles()}updateStyles(){}getColor(u,v){let I=this.theme.getColor(u);return I&&v&&(I=v(I,this.theme)),I?I.toString():null}}e.Themable=c}),define(Ce[155],Ie([1,0,5,21,3,15]),function(te,e,r,y,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,w.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,w.createDecorator)("sharedTunnelsService");var _;(function(c){c.Http="http",c.Https="https"})(_=e.TunnelProtocol||(e.TunnelProtocol={}));var A;(function(c){c.ConstantPrivate="constantPrivate",c.Private="private",c.Public="public"})(A=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var E;(function(c){c[c.Notify=1]="Notify",c[c.OpenBrowser=2]="OpenBrowser",c[c.OpenPreview=3]="OpenPreview",c[c.Silent=4]="Silent",c[c.Ignore=5]="Ignore",c[c.OpenBrowserOnce=6]="OpenBrowserOnce"})(E=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function k(c){if(c.scheme!=="http"&&c.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(c.authority);if(!!h)return{address:h[1],port:+h[2]}}e.extractLocalHostUriMetaDataForPortMapping=k,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function F(c){return e.LOCALHOST_ADDRESSES.indexOf(c)>=0}e.isLocalhost=F,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function S(c){return e.ALL_INTERFACES_ADDRESSES.indexOf(c)>=0}e.isAllInterfaces=S;function m(c,h){return h?h!==1&&c<1024:!y.isWindows&&c<1024}e.isPortPrivileged=m;class T{constructor(h,u,v){this.remoteAddress=h,this.localAddress=u,this._dispose=v,this._onDispose=new r.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=T;let f=class{constructor(h){this.logService=h,this._onTunnelOpened=new r.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new r.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new r.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(h){return this._tunnelProvider=h,h?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(h){this._canElevate=h.elevation,this._privacyOptions=h.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const h=[],u=Array.from(this._tunnels.values());for(const v of u){const I=Array.from(v.values());for(const l of I){const b=await l.value;b&&h.push(b)}}return h}async dispose(){for(const h of this._tunnels.values()){for(const{value:u}of h.values())await u.then(v=>v?.dispose());h.clear()}this._tunnels.clear()}openTunnel(h,u,v,I,l=!1,b,t){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${v} on local port ${I}.`),!h)return;if(u||(u="localhost"),this._tunnelProvider&&this._factoryInProgress.has(v)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const d=this.retainOrCreateTunnel(h,u,v,I,l,b,t);return d?d.then(n=>{if(!n){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(u,v);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.makeTunnel(n);return(n.tunnelRemoteHost!==u||n.tunnelRemotePort!==v)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(i),i}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),d)}makeTunnel(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,privacy:h.privacy,protocol:h.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const u=this._tunnels.get(h.tunnelRemoteHost);if(u){const v=u.get(h.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(h.tunnelRemoteHost,h.tunnelRemotePort,v))}}}}async tryDisposeTunnel(h,u,v){if(v.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${u}.`);const I=v.value.then(async l=>{l&&(await l.dispose(!0),this._onTunnelClosed.fire({host:l.tunnelRemoteHost,port:l.tunnelRemotePort}))});return this._tunnels.has(h)&&this._tunnels.get(h).delete(u),I}}async closeTunnel(h,u){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${u} `);const v=this._tunnels.get(h);if(v&&v.has(u)){const I=v.get(u);I.refcount=0,await this.tryDisposeTunnel(h,u,I)}}addTunnelToMap(h,u,v){this._tunnels.has(h)||this._tunnels.set(h,new Map),this._tunnels.get(h).set(u,{refcount:1,value:v})}async removeEmptyTunnelFromMap(h,u){const v=this._tunnels.get(h);v&&(await v.get(u)||v.delete(u),v.size===0&&this._tunnels.delete(h))}getTunnelFromMap(h,u){const v=[h];F(h)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):S(h)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const I=v.map(l=>this._tunnels.get(l));for(const l of I){const b=l?.get(u);if(b)return b}}canTunnel(h){return!!k(h)}createWithProvider(h,u,v,I,l,b,t){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${v} on local port ${I}.`);const d=v;this._factoryInProgress.add(d);const i={elevationRequired:l?m(I===void 0?v:I):!1},s={remoteAddress:{host:u,port:v},localAddressPort:I,privacy:b,public:b?b!==A.Private:void 0,protocol:t},a=h.forwardPort(s,i);return a?(this.addTunnelToMap(u,v,a),a.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(d)})):this._factoryInProgress.delete(d),a}};f=ze([xe(0,L.ILogService)],f),e.AbstractTunnelService=f}),define(Ce[156],Ie([1,0,12]),function(te,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function y(E){return E.scheme!==r.Schemas.file&&E.scheme!==r.Schemas.vscodeRemote}e.isVirtualResource=y;function w(E){if(E.folders.length)return E.folders.every(k=>y(k.uri))?E.folders[0].uri:void 0;if(E.configuration&&y(E.configuration))return E.configuration}e.getVirtualWorkspaceLocation=w;function L(E){return w(E)?.scheme}e.getVirtualWorkspaceScheme=L;function _(E){return w(E)?.authority}e.getVirtualWorkspaceAuthority=_;function A(E){return w(E)!==void 0}e.isVirtualWorkspace=A}),define(Ce[45],Ie([1,0,128,19,25,22,2,3,12]),function(te,e,r,y,w,L,_,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");function k(d){const n=d;return typeof n?.id=="string"&&_.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=k,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function F(d,n){if(typeof d=="string"||typeof d>"u")return typeof d=="string"?{id:(0,y.basename)(d)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const i=d;if(i.configuration)return{id:i.id,configPath:i.configuration};if(i.folders.length===1)return{id:i.id,uri:i.folders[0].uri}}e.toWorkspaceIdentifier=F;function S(d){const n=d;return typeof n?.id=="string"&&_.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=S;function m(d){const n=d;if(n?.uri)return{id:n.id,uri:_.URI.revive(n.uri)};const i=d;if(i?.configPath)return{id:i.id,configPath:_.URI.revive(i.configPath)};if(d?.id)return{id:d.id}}e.reviveIdentifier=m;var T;(function(d){d[d.EMPTY=1]="EMPTY",d[d.FOLDER=2]="FOLDER",d[d.WORKSPACE=3]="WORKSPACE"})(T=e.WorkbenchState||(e.WorkbenchState={}));function f(d){const n=d;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=f;function c(d){const n=d;return!!(n&&typeof n=="object"&&_.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=c;class h{constructor(n,i,s,a,o){this._id=n,this._transient=s,this._configuration=a,this._ignorePathCasing=o,this._foldersMap=w.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=i}update(n){this._id=n.id,this._configuration=n.configuration,this._transient=n.transient,this._ignorePathCasing=n._ignorePathCasing,this.folders=n.folders}get folders(){return this._folders}set folders(n){this._folders=n,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(n){this._configuration=n}getFolder(n){return n&&this._foldersMap.findSubstr(n)||null}updateFoldersMap(){this._foldersMap=w.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const n of this.folders)this._foldersMap.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=h;class u{constructor(n,i){this.raw=i,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,L.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=u;function v(d){return new u({uri:d,index:0,name:(0,L.basenameOrAuthority)(d)},{uri:d.toString()})}e.toWorkspaceFolder=v,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,r.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function I(d,n){return L.extUriBiasedIgnorePathCase.isEqualOrParent(d,n.untitledWorkspacesHome)}e.isUntitledWorkspace=I;function l(d){let n;return _.URI.isUri(d)?n=d:n=d.configuration,n?.scheme===E.Schemas.tmp}e.isTemporaryWorkspace=l;function b(d,n){return!I(d,n)&&!l(d)}e.isSavedWorkspace=b;function t(d){return(typeof d=="string"?(0,y.extname)(d):(0,L.extname)(d))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=t}),define(Ce[61],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class r{constructor(w){this.id=w,this._data=new Map,this._idPool=1}add(w){const L=this._idPool++;return this._data.set(L,w),this.logDebugInfo(),L}get(w,L){return this._data.has(w)?this._data.get(w)[L]:void 0}delete(w){this._data.delete(w),this.logDebugInfo()}logDebugInfo(){!r.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=r,r.enableDebugLogging=!1}),define(Ce[35],Ie([1,0,12,22,3]),function(te,e,r,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class L{constructor(){this._systemSchemes=new Set(Object.keys(r.Schemas)),this._providerInfo=new Map,this.extUri=new y.ExtUri(A=>{const E=this._providerInfo.get(A.scheme);return!(E===void 0||E&1024)})}$acceptProviderInfos(A,E){E===null?this._providerInfo.delete(A.scheme):this._providerInfo.set(A.scheme,E)}isFreeScheme(A){return!this._providerInfo.has(A)&&!this._systemSchemes.has(A)}getCapabilities(A){return this._providerInfo.get(A)}}e.ExtHostFileSystemInfo=L,e.IExtHostFileSystemInfo=(0,w.createDecorator)("IExtHostFileSystemInfo")}),define(Ce[28],Ie([1,0,3]),function(te,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,r.createDecorator)("IExtHostInitDataService")}),define(Ce[157],Ie([1,0,14]),function(te,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class y{constructor(_,A,E){this._deferredPromises=new Map,this._id=_,this._shared=A,this._storage=E,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(k=>(this._value=k,this)),this._storageListener=this._storage.onDidChangeStorage(k=>{k.shared===this._shared&&k.key===this._id&&(this._value=k.value)}),this._scheduler=new r.RunOnceScheduler(()=>{const k=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const F of k.values())F.complete()}catch(F){for(const S of k.values())S.error(F)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,_])=>_!==void 0).map(([_])=>_)}get whenReady(){return this._init}get(_,A){let E=this._value[_];return typeof E>"u"&&(E=A),E}update(_,A){this._value[_]=A;const E=this._deferredPromises.get(_);if(E!==void 0)return E.p;const k=new r.DeferredPromise;return this._deferredPromises.set(_,k),this._scheduler.isScheduled()||this._scheduler.schedule(),k.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=y;class w extends y{constructor(_,A){super(_.identifier.value,!0,A),this._extension=_}setKeysForSync(_){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},_)}}e.ExtensionGlobalMemento=w}),define(Ce[158],Ie([1,0,5,2]),function(te,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class w{constructor(_){this._notebooksAndEditors=_,this._onDidSaveNotebookDocument=new r.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new r.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(_,A,E,k){const S=this._notebooksAndEditors.getNotebookDocument(y.URI.revive(_)).acceptModelChanged(A.value,E,k);this._onDidChangeNotebookDocument.fire(S)}$acceptDirtyStateChanged(_,A){this._notebooksAndEditors.getNotebookDocument(y.URI.revive(_)).acceptDirty(A)}$acceptModelSaved(_){const A=this._notebooksAndEditors.getNotebookDocument(y.URI.revive(_));this._onDidSaveNotebookDocument.fire(A.apiNotebook)}}e.ExtHostNotebookDocuments=w}),define(Ce[13],Ie([1,0,3]),function(te,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,r.createDecorator)("IExtHostRpcService");class y{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.ExtHostRpcService=y});var Je=this&&this.__classPrivateFieldSet||function(te,e,r,y,w){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!w:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?w.call(te,r):w?w.value=r:e.set(te,r),r},Oe=this&&this.__classPrivateFieldGet||function(te,e,r,y){if(r==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?y:r==="a"?y.call(te):y?y.value:e.get(te)};define(Ce[159],Ie([1,0,27,5]),function(te,e,r,y){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class L{constructor(A,E){w.set(this,void 0),this._onDidChange=new y.Emitter,this.onDidChange=this._onDidChange.event,this._id=r.ExtensionIdentifier.toKey(A.identifier),Je(this,w,E,"f"),Oe(this,w,"f").onDidChangePassword(k=>{k.extensionId===this._id&&this._onDidChange.fire({key:k.key})})}get(A){return Oe(this,w,"f").get(this._id,A)}store(A,E){return Oe(this,w,"f").store(this._id,A,E)}delete(A){return Oe(this,w,"f").delete(this._id,A)}}e.ExtensionSecrets=L,w=new WeakMap}),define(Ce[87],Ie([1,0,3,5]),function(te,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class w{constructor(){this._onDidChangeTelemetryEnabled=new y.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new y.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}$initializeTelemetryLevel(_,A){this._level=_,this._productConfig=A||{usage:!0,error:!0}}$onDidChangeTelemetryLevel(_){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=_,this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}}e.ExtHostTelemetry=w,e.IExtHostTelemetry=(0,r.createDecorator)("IExtHostTelemetry")}),define(Ce[62],Ie([1,0,3,155,5,13]),function(te,e,r,y,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var _;(function(E){function k(S){return{remoteAddress:S.remoteAddress,localAddress:S.localAddress,public:!!S.public,privacy:S.privacy??(S.public?y.TunnelPrivacyId.Public:y.TunnelPrivacyId.Private),protocol:S.protocol}}E.fromApiTunnel=k;function F(S){return{remoteAddress:{host:S.tunnelRemoteHost,port:S.tunnelRemotePort},localAddress:S.localAddress,public:S.privacy!==y.TunnelPrivacyId.ConstantPrivate&&S.privacy!==y.TunnelPrivacyId.ConstantPrivate,privacy:S.privacy,protocol:S.protocol}}E.fromServiceTunnel=F})(_=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,r.createDecorator)("IExtHostTunnelService");let A=class{constructor(k){this.onDidChangeTunnels=new w.Emitter().event}async $applyCandidateFilter(k){return k}async openTunnel(k,F){}async getTunnels(){return[]}async setTunnelFactory(k){return{dispose:()=>{}}}registerPortsAttributesProvider(k,F){return{dispose:()=>{}}}async $providePortAttributes(k,F,S,m,T){return[]}async $forwardPort(k,F){}async $closeTunnel(k){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=ze([xe(0,L.IExtHostRpcService)],A),e.ExtHostTunnelService=A}),define(Ce[46],Ie([1,0,3]),function(te,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,r.createDecorator)("IURITransformerService");class y{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=_=>_,this.transformOutgoing=_=>_,this.transformOutgoingURI=_=>_,this.transformOutgoingScheme=_=>_)}}e.URITransformerService=y}),define(Ce[160],Ie([1,0,23]),function(te,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class y{constructor(){this.buffers=[]}add(E){let k=this.buffers.indexOf(E);return k<0&&(k=this.buffers.length,this.buffers.push(E)),k}}function w(A,E){if(E.serializeBuffersForPostMessage){const k=new y,F=(T,f)=>{if(f instanceof ArrayBuffer){const c=k.add(f);return{$$vscode_array_buffer_reference$$:!0,index:c}}else if(ArrayBuffer.isView(f)){const c=L(f);if(c){const h=k.add(f.buffer);return{$$vscode_array_buffer_reference$$:!0,index:h,view:{type:c,byteLength:f.byteLength,byteOffset:f.byteOffset}}}}return f},S=JSON.stringify(A,F),m=k.buffers.map(T=>{const f=new Uint8Array(T);return r.VSBuffer.wrap(f)});return{message:S,buffers:m}}else return{message:JSON.stringify(A),buffers:[]}}e.serializeWebviewMessage=w;function L(A){switch(A.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function _(A,E){const k=E.map(m=>{const T=new ArrayBuffer(m.byteLength);return new Uint8Array(T).set(m.buffer),T}),F=E.length?(m,T)=>{if(T&&typeof T=="object"&&T.$$vscode_array_buffer_reference$$){const f=T,{index:c}=f,h=k[c];if(f.view)switch(f.view.type){case 1:return new Int8Array(h,f.view.byteOffset,f.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(h,f.view.byteOffset,f.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(h,f.view.byteOffset,f.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(h,f.view.byteOffset,f.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(h,f.view.byteOffset,f.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(h,f.view.byteOffset,f.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(h,f.view.byteOffset,f.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(h,f.view.byteOffset,f.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(h,f.view.byteOffset,f.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(h,f.view.byteOffset,f.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(h,f.view.byteOffset,f.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return h}return T}:void 0;return{message:JSON.parse(A,F),arrayBuffers:k}}e.deserializeWebviewMessage=_}),define(Ce[88],Ie([1,0,136,10,2,7,3,30,39,16,12]),function(te,e,r,y,w,L,_,A,E,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,r.localize)(0,null),providerDisplayName:(0,r.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var S;(function(O){O[O.PROGRAMMATIC=1]="PROGRAMMATIC",O[O.USER=2]="USER",O[O.EDIT=3]="EDIT",O[O.NAVIGATION=4]="NAVIGATION",O[O.JUMP=5]="JUMP"})(S=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var m;(function(O){O[O.IDENTICAL=1]="IDENTICAL",O[O.SIMILAR=2]="SIMILAR",O[O.DIFFERENT=3]="DIFFERENT"})(m=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function T(O){const Z=O;return!!Z&&typeof Z.getSelection=="function"&&!!Z.onDidChangeSelection}e.isEditorPaneWithSelection=T;function f(O,Z,ue){for(const oe of ue.visibleEditorPanes)if(oe.group.id===Z&&O.matches(oe.input))return oe.getViewState()}e.findViewStateForEditor=f;function c(O){if(i(O))return!1;const Z=O;return w.URI.isUri(Z?.resource)}e.isResourceEditorInput=c;function h(O){if(i(O))return!1;const Z=O;return Z?.original!==void 0&&Z.modified!==void 0}e.isResourceDiffEditorInput=h;function u(O){if(i(O)||h(O))return!1;const Z=O;return Z?.primary!==void 0&&Z.secondary!==void 0}e.isResourceSideBySideEditorInput=u;function v(O){if(i(O))return!1;const Z=O;return Z?Z.resource===void 0||Z.resource.scheme===F.Schemas.untitled||Z.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=v;function I(O){if(i(O))return!1;const Z=O;return w.URI.isUri(Z?.base?.resource)&&w.URI.isUri(Z?.input1?.resource)&&w.URI.isUri(Z?.input2?.resource)&&w.URI.isUri(Z?.result?.resource)}e.isResourceMergeEditorInput=I;var l;(function(O){O[O.SHORT=0]="SHORT",O[O.MEDIUM=1]="MEDIUM",O[O.LONG=2]="LONG"})(l=e.Verbosity||(e.Verbosity={}));var b;(function(O){O[O.EXPLICIT=1]="EXPLICIT",O[O.AUTO=2]="AUTO",O[O.FOCUS_CHANGE=3]="FOCUS_CHANGE",O[O.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(b=e.SaveReason||(e.SaveReason={}));class t{constructor(){this.mapIdToSaveSource=new Map}registerSource(Z,ue){let oe=this.mapIdToSaveSource.get(Z);return oe||(oe={source:Z,label:ue},this.mapIdToSaveSource.set(Z,oe)),oe.source}getSourceLabel(Z){return this.mapIdToSaveSource.get(Z)?.label??Z}}e.SaveSourceRegistry=new t;var d;(function(O){O[O.None=0]="None",O[O.Readonly=2]="Readonly",O[O.Untitled=4]="Untitled",O[O.Singleton=8]="Singleton",O[O.RequiresTrust=16]="RequiresTrust",O[O.CanSplitInGroup=32]="CanSplitInGroup",O[O.ForceDescription=64]="ForceDescription",O[O.CanDropIntoEditor=128]="CanDropIntoEditor",O[O.MultipleEditors=256]="MultipleEditors"})(d=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class n extends L.Disposable{}e.AbstractEditorInput=n;function i(O){return O instanceof n}e.isEditorInput=i;function s(O){const Z=O;return w.URI.isUri(Z?.preferredResource)}function a(O){const Z=O;return i(Z?.primary)&&i(Z?.secondary)}e.isSideBySideEditorInput=a;function o(O){const Z=O;return i(Z?.modified)&&i(Z?.original)}e.isDiffEditorInput=o;function g(O){return i(O?.editor)}e.isEditorInputWithOptions=g;function p(O){const Z=O;return g(O)&&Z?.group!==void 0}e.isEditorInputWithOptionsAndGroup=p;function P(O){const Z=O;return typeof Z?.groupId=="number"&&i(Z.editor)}e.isEditorIdentifier=P;var M;(function(O){O[O.UNKNOWN=0]="UNKNOWN",O[O.REPLACE=1]="REPLACE",O[O.MOVE=2]="MOVE",O[O.UNPIN=3]="UNPIN"})(M=e.EditorCloseContext||(e.EditorCloseContext={}));var V;(function(O){O[O.GROUP_ACTIVE=0]="GROUP_ACTIVE",O[O.GROUP_INDEX=1]="GROUP_INDEX",O[O.GROUP_LOCKED=2]="GROUP_LOCKED",O[O.EDITOR_OPEN=3]="EDITOR_OPEN",O[O.EDITOR_CLOSE=4]="EDITOR_CLOSE",O[O.EDITOR_MOVE=5]="EDITOR_MOVE",O[O.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",O[O.EDITOR_LABEL=7]="EDITOR_LABEL",O[O.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",O[O.EDITOR_PIN=9]="EDITOR_PIN",O[O.EDITOR_STICKY=10]="EDITOR_STICKY",O[O.EDITOR_DIRTY=11]="EDITOR_DIRTY",O[O.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(V=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var B;(function(O){O[O.PRIMARY=1]="PRIMARY",O[O.SECONDARY=2]="SECONDARY",O[O.BOTH=3]="BOTH",O[O.ANY=4]="ANY"})(B=e.SideBySideEditor||(e.SideBySideEditor={}));class D{getOriginalUri(Z,ue){if(!Z)return;if(I(Z))return e.EditorResourceAccessor.getOriginalUri(Z.result,ue);if(ue?.supportSideBySide){const{primary:de,secondary:ie}=this.getSideEditors(Z);if(de&&ie){if(ue?.supportSideBySide===B.BOTH)return{primary:this.getOriginalUri(de,{filterByScheme:ue.filterByScheme}),secondary:this.getOriginalUri(ie,{filterByScheme:ue.filterByScheme})};if(ue?.supportSideBySide===B.ANY)return this.getOriginalUri(de,{filterByScheme:ue.filterByScheme})??this.getOriginalUri(ie,{filterByScheme:ue.filterByScheme});Z=ue.supportSideBySide===B.PRIMARY?de:ie}}if(h(Z)||u(Z)||I(Z))return;const oe=s(Z)?Z.preferredResource:Z.resource;return!oe||!ue||!ue.filterByScheme?oe:this.filterUri(oe,ue.filterByScheme)}getSideEditors(Z){return a(Z)||u(Z)?{primary:Z.primary,secondary:Z.secondary}:o(Z)||h(Z)?{primary:Z.modified,secondary:Z.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(Z,ue){if(!Z)return;if(I(Z))return e.EditorResourceAccessor.getCanonicalUri(Z.result,ue);if(ue?.supportSideBySide){const{primary:de,secondary:ie}=this.getSideEditors(Z);if(de&&ie){if(ue?.supportSideBySide===B.BOTH)return{primary:this.getCanonicalUri(de,{filterByScheme:ue.filterByScheme}),secondary:this.getCanonicalUri(ie,{filterByScheme:ue.filterByScheme})};if(ue?.supportSideBySide===B.ANY)return this.getCanonicalUri(de,{filterByScheme:ue.filterByScheme})??this.getCanonicalUri(ie,{filterByScheme:ue.filterByScheme});Z=ue.supportSideBySide===B.PRIMARY?de:ie}}if(h(Z)||u(Z)||I(Z))return;const oe=Z.resource;return!oe||!ue||!ue.filterByScheme?oe:this.filterUri(oe,ue.filterByScheme)}filterUri(Z,ue){if(Array.isArray(ue)){if(ue.some(oe=>Z.scheme===oe))return Z}else if(ue===Z.scheme)return Z}}e.EditorResourceAccessor=new D;var x;(function(O){O[O.LEFT=0]="LEFT",O[O.RIGHT=1]="RIGHT"})(x=e.CloseDirection||(e.CloseDirection={}));class U{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(Z){const ue=this.instantiationService=Z.get(_.IInstantiationService);for(const[oe,de]of this.editorSerializerConstructors)this.createEditorSerializer(oe,de,ue);this.editorSerializerConstructors.clear()}createEditorSerializer(Z,ue,oe){const de=oe.createInstance(ue);this.editorSerializerInstances.set(Z,de)}registerFileEditorFactory(Z){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=Z}getFileEditorFactory(){return(0,y.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(Z,ue){if(this.editorSerializerConstructors.has(Z)||this.editorSerializerInstances.has(Z))throw new Error(`A editor serializer with type ID '${Z}' was already registered.`);return this.instantiationService?this.createEditorSerializer(Z,ue,this.instantiationService):this.editorSerializerConstructors.set(Z,ue),(0,L.toDisposable)(()=>{this.editorSerializerConstructors.delete(Z),this.editorSerializerInstances.delete(Z)})}getEditorSerializer(Z){return this.editorSerializerInstances.get(typeof Z=="string"?Z:Z.typeId)}}A.Registry.add(e.EditorExtensions.EditorFactory,new U);async function R(O,Z){if(!O||!O.length)return[];const ue=await Promise.all(O.map(async oe=>{const de=w.URI.revive(oe.fileUri);if(!de||!await Z.canHandleResource(de))return;let ve=oe.exists,be=oe.type;if(typeof ve!="boolean"||typeof be!="number")try{be=(await Z.stat(de)).isDirectory?E.FileType.Directory:E.FileType.Unknown,ve=!0}catch{ve=!1}if(!ve&&oe.openOnlyIfExists||be===E.FileType.Directory)return;const ne={...oe.options,pinned:!0};let Ee;return ve?Ee={resource:de,options:ne}:Ee={resource:de,options:ne,forceUntitled:!0},Ee}));return(0,k.coalesce)(ue)}e.pathsToEditors=R;var K;(function(O){O[O.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",O[O.SEQUENTIAL=1]="SEQUENTIAL"})(K=e.EditorsOrder||(e.EditorsOrder={}));function W(O){const Z=O;if(!Z)return!1;const ue=Z;if(ue.modified)return W(ue.modified);const oe=Z;return!!(oe.contributionsState&&oe.viewState&&Array.isArray(oe.cursorState))}e.isTextEditorViewState=W}),define(Ce[63],Ie([1,0,12,2]),function(te,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function w(A,E){return A.scheme===r.Schemas.http||A.scheme===r.Schemas.https?A:(E&&E.authority&&E.isRemote&&A.scheme===r.Schemas.file&&(A=y.URI.from({scheme:r.Schemas.vscodeRemote,authority:E.authority,path:A.path})),y.URI.from({scheme:r.Schemas.https,authority:`${A.scheme}+${L(A.authority)}.${e.webviewRootResourceAuthority}`,path:A.path,fragment:A.fragment,query:A.query}))}e.asWebviewUri=w;function L(A){return A.replace(/./g,E=>{const k=E.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?E:"-"+k.toString(16).padStart(4,"0")})}function _(A){return A.replace(/-([0-9a-f]{4})/g,(E,k)=>String.fromCharCode(parseInt(k,16)))}e.decodeAuthority=_}),define(Ce[161],Ie([1,0,5,7,63]),function(te,e,r,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class L{constructor(A,E,k){this._proxy=A,this._editors=E,this._remoteInfo=k,this._handlePool=0,this._disposables=new y.DisposableStore,this._insets=new Map,this._disposables.add(E.onDidChangeVisibleTextEditors(()=>{const F=E.getVisibleTextEditors();for(const S of this._insets.values())F.indexOf(S.editor)<0&&S.inset.dispose()}))}dispose(){this._insets.forEach(A=>A.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(A,E,k,F,S){let m;for(const I of this._editors.getVisibleTextEditors(!0))if(I.value===A){m=I;break}if(!m)throw new Error("not a visible editor");const T=this,f=this._handlePool++,c=new r.Emitter,h=new r.Emitter,u=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(I){return(0,w.asWebviewUri)(I,T._remoteInfo)}get cspSource(){return w.webviewGenericCspSource}set options(I){this._options=I,T._proxy.$setOptions(f,I)}get options(){return this._options}set html(I){this._html=I,T._proxy.$setHtml(f,I)}get html(){return this._html}get onDidReceiveMessage(){return c.event}postMessage(I){return T._proxy.$postMessage(f,I)}},v=new class{constructor(){this.editor=A,this.line=E,this.height=k,this.webview=u,this.onDidDispose=h.event}dispose(){T._insets.has(f)&&(T._insets.delete(f),T._proxy.$disposeEditorInset(f),h.fire(),h.dispose(),c.dispose())}};return this._proxy.$createEditorInset(f,m.id,m.value.document.uri,E+1,k,F||{},S.identifier,S.extensionLocation),this._insets.set(f,{editor:A,inset:v,onDidReceiveMessage:c}),v}$onDidDispose(A){const E=this._insets.get(A);E&&E.inset.dispose()}$onDidReceiveMessage(A,E){this._insets.get(A)?.onDidReceiveMessage.fire(E)}}e.ExtHostEditorInsets=L}),define(Ce[162],Ie([1,0,5,14,137]),function(te,e,r,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class L{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new r.Emitter,this._onExit=new r.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(A){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=A}onEvent(A){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=A}onRequest(A){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=A}sendResponse(A){A.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${A.command}`)):this.internalSend("response",A)}sendRequest(A,E,k,F){const S={command:A};if(E&&Object.keys(E).length>0&&(S.arguments=E),this.internalSend("request",S),typeof F=="number"){const m=setTimeout(()=>{clearTimeout(m);const T=this.pendingRequests.get(S.seq);if(T){this.pendingRequests.delete(S.seq);const f={type:"response",seq:0,request_seq:S.seq,success:!1,command:A,message:(0,w.localize)(0,null,F,A)};T(f)}},F)}return k&&this.pendingRequests.set(S.seq,k),S.seq}acceptMessage(A){this.messageCallback?this.messageCallback(A):(this.queue.push(A),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(A,E){return A.type!=="event"||E.type!=="event"}async processQueue(){let A;for(;this.queue.length;){if((!A||this.needsTaskBoundaryBetween(this.queue[0],A))&&await(0,y.timeout)(0),A=this.queue.shift(),!A)return;switch(A.type){case"event":this.eventCallback?.(A);break;case"request":this.requestCallback?.(A);break;case"response":{const E=A,k=this.pendingRequests.get(E.request_seq);k&&(this.pendingRequests.delete(E.request_seq),k(E));break}}}}internalSend(A,E){E.type=A,E.seq=this.sequence++,this.sendMessage(E)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const A=new Map;this.pendingRequests.forEach((E,k)=>A.set(k,E)),await(0,y.timeout)(500),A.forEach((E,k)=>{E({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(k)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=L}),define(Ce[163],Ie([1,0,138,38,3]),function(te,e,r,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerUiMessage=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new y.RawContextKey("debugType",void 0,{type:"string",description:r.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new y.RawContextKey("debugConfigurationType",void 0,{type:"string",description:r.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new y.RawContextKey("debugState","inactive",{type:"string",description:r.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new y.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:r.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new y.RawContextKey("inDebugMode",!1,{type:"boolean",description:r.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new y.RawContextKey("inDebugRepl",!1,{type:"boolean",description:r.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new y.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:r.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new y.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:r.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new y.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:r.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new y.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:r.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new y.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:r.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new y.RawContextKey("variablesFocused",!0,{type:"boolean",description:r.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new y.RawContextKey("expressionSelected",!1,{type:"boolean",description:r.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new y.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:r.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new y.RawContextKey("callStackItemType",void 0,{type:"string",description:r.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new y.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:r.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new y.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:r.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new y.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:r.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new y.RawContextKey("watchItemType",void 0,{type:"string",description:r.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new y.RawContextKey("canViewMemory",void 0,{type:"boolean",description:r.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new y.RawContextKey("breakpointItemType",void 0,{type:"string",description:r.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new y.RawContextKey("breakpointAccessType",void 0,{type:"string",description:r.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new y.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:r.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new y.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:r.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new y.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:r.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new y.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:r.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new y.RawContextKey("stepBackSupported",!1,{type:"boolean",description:r.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new y.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:r.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new y.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:r.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new y.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:r.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new y.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:r.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new y.RawContextKey("breakpointsExist",!1,{type:"boolean",description:r.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new y.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:r.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new y.RawContextKey("debugExtensionAvailable",!1,{type:"boolean",description:r.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new y.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:r.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new y.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:r.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new y.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:r.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new y.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:r.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new y.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:r.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new y.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:r.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new y.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:r.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new y.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:r.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new y.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:r.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new y.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:r.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new y.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:r.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new y.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:r.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new y.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:r.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new y.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:r.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new y.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:r.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new y.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:r.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new y.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:r.localize(50,null)});const L=m=>r.localize(51,null,m);e.debuggerDisabledMessage=L,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:r.localize(52,null)};var _;(function(m){m[m.Inactive=0]="Inactive",m[m.Initializing=1]="Initializing",m[m.Stopped=2]="Stopped",m[m.Running=3]="Running"})(_=e.State||(e.State={}));function A(m){switch(m){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=A;var E;(function(m){m[m.Valid=0]="Valid",m[m.Unreadable=1]="Unreadable",m[m.Error=2]="Error"})(E=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var k;(function(m){m[m.Initial=1]="Initial",m[m.Dynamic=2]="Dynamic"})(k=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var F;(function(m){m.UnverifiedBreakpoints="unverifiedBreakpoints"})(F=e.DebuggerUiMessage||(e.DebuggerUiMessage={})),e.IDebugService=(0,w.createDecorator)(e.DEBUG_SERVICE_ID);var S;(function(m){m[m.CONDITION=0]="CONDITION",m[m.HIT_COUNT=1]="HIT_COUNT",m[m.LOG_MESSAGE=2]="LOG_MESSAGE"})(S=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Ce[164],Ie([1,0,9,2,19,26,12]),function(te,e,r,y,w,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const A=/{([^}]+)}/g;function E(n,i,s){return n.replace(A,function(a,o){return i&&o.length>0&&o[0]!=="_"?a:s&&s.hasOwnProperty(o)?s[o]:a})}e.formatPII=E;function k(n){const i={};for(const s of Object.keys(n))s.startsWith("!")||(i[s]=n[s]);return i}e.filterExceptionsFromTelemetry=k;function F(n){return n.configuration.request==="attach"&&!S(n)&&(!n.parentSession||F(n.parentSession))}e.isSessionAttach=F;function S(n){let i=n.configuration.type;if(!!i)return i==="vslsShare"&&(i=n.configuration.adapterProxy.configuration.type),(0,r.equalsIgnoreCase)(i,"extensionhost")||(0,r.equalsIgnoreCase)(i,"pwa-extensionhost")?n:n.parentSession?S(n.parentSession):void 0}e.getExtensionHostDebugSession=S;function m(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=m;function T(n,i,s){let a,o=0;const g=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let p=null;for(;p=g.exec(n);){const P=p.index+1,M=P+p[0].length;if(P<=i&&M>=s){a=p[0],o=P;break}}if(a){const P=/\w+/g;let M=null;for(;(M=P.exec(a))&&!(M.index+1+o+M[0].length>=s););M&&(a=a.substring(0,P.lastIndex))}return a?{start:o,end:o+a.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=T;const f=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function c(n){return!!(n&&n.match(f))}e.isUri=c;function h(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(c(n.path))return y.URI.parse(n.path);if((0,w.isAbsolute)(n.path))return y.URI.file(n.path)}return n.path}function u(n){if(typeof n.path=="object"){const i=y.URI.revive(n.path);if(i)return i.scheme===_.Schemas.file?i.fsPath:i.toString()}return n.path}function v(n,i){const s=i?h:u,a=(0,L.deepClone)(n);return l(a,(o,g)=>{o&&g&&(g.path=s(g))}),a}e.convertToDAPaths=v;function I(n,i){const s=i?h:u,a=(0,L.deepClone)(n);return l(a,(o,g)=>{!o&&g&&(g.path=s(g))}),a}e.convertToVSCPaths=I;function l(n,i){switch(n.type){case"event":{const s=n;switch(s.event){case"output":i(!1,s.body.source);break;case"loadedSource":i(!1,s.body.source);break;case"breakpoint":i(!1,s.body.breakpoint.source);break;default:break}break}case"request":{const s=n;switch(s.command){case"setBreakpoints":i(!0,s.arguments.source);break;case"breakpointLocations":i(!0,s.arguments.source);break;case"source":i(!0,s.arguments.source);break;case"gotoTargets":i(!0,s.arguments.source);break;case"launchVSCode":s.arguments.args.forEach(a=>i(!1,a));break;default:break}break}case"response":{const s=n;if(s.success&&s.body)switch(s.command){case"stackTrace":s.body.stackFrames.forEach(a=>i(!1,a.source));break;case"loadedSources":s.body.sources.forEach(a=>i(!1,a));break;case"scopes":s.body.scopes.forEach(a=>i(!1,a.source));break;case"setFunctionBreakpoints":s.body.breakpoints.forEach(a=>i(!1,a.source));break;case"setBreakpoints":s.body.breakpoints.forEach(a=>i(!1,a.source));break;case"disassemble":s.body?.instructions.forEach(o=>i(!1,o.location));break;default:break}break}}}function b(n){return n.filter(i=>!i.presentation?.hidden).sort((i,s)=>i.presentation?s.presentation?i.presentation.group?s.presentation.group?i.presentation.group!==s.presentation.group?i.presentation.group.localeCompare(s.presentation.group):t(i.presentation.order,s.presentation.order):-1:s.presentation.group?1:t(i.presentation.order,s.presentation.order):-1:s.presentation?1:0)}e.getVisibleAndSorted=b;function t(n,i){return typeof n!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:n-i}async function d(n,i){const s=n.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorLanguageId});if(s!=="none"&&(await i.saveAll(),s==="allEditorsInActiveGroup")){const a=i.activeEditorPane;a&&a.input.resource?.scheme===_.Schemas.untitled&&await i.save({editor:a.input,groupId:a.group.id})}await n.reloadConfiguration()}e.saveAllBeforeDebugStart=d}),define(Ce[64],Ie([1,0,23,34,165,74,12,19,21,38]),function(te,e,r,y,w,L,_,A,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var F;(function(o){o[o.Markup=1]="Markup",o[o.Code=2]="Code"})(F=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",L.Mimes.latex,L.Mimes.markdown,"image/png","image/jpeg",L.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[L.Mimes.latex,L.Mimes.markdown,"application/json",L.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var S;(function(o){o[o.Running=1]="Running",o[o.Idle=2]="Idle"})(S=e.NotebookRunState||(e.NotebookRunState={}));var m;(function(o){o[o.Unconfirmed=1]="Unconfirmed",o[o.Pending=2]="Pending",o[o.Executing=3]="Executing"})(m=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var T;(function(o){o[o.WithHardKernelDependency=0]="WithHardKernelDependency",o[o.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",o[o.Pure=2]="Pure",o[o.Never=3]="Never"})(T=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var f;(function(o){o.Always="always",o.Never="never",o.Optional="optional"})(f=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var c;(function(o){o[o.ModelChange=1]="ModelChange",o[o.Move=2]="Move",o[o.ChangeCellLanguage=5]="ChangeCellLanguage",o[o.Initialize=6]="Initialize",o[o.ChangeCellMetadata=7]="ChangeCellMetadata",o[o.Output=8]="Output",o[o.OutputItem=9]="OutputItem",o[o.ChangeCellContent=10]="ChangeCellContent",o[o.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",o[o.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",o[o.ChangeCellMime=13]="ChangeCellMime",o[o.Unknown=100]="Unknown"})(c=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var h;(function(o){o[o.Handle=0]="Handle",o[o.Index=1]="Index"})(h=e.SelectionStateType||(e.SelectionStateType={}));var u;(function(o){o[o.Replace=1]="Replace",o[o.Output=2]="Output",o[o.Metadata=3]="Metadata",o[o.CellLanguage=4]="CellLanguage",o[o.DocumentMetadata=5]="DocumentMetadata",o[o.Move=6]="Move",o[o.OutputItems=7]="OutputItems",o[o.PartialMetadata=8]="PartialMetadata",o[o.PartialInternalMetadata=9]="PartialInternalMetadata"})(u=e.CellEditType||(e.CellEditType={}));var v;(function(o){o.scheme=_.Schemas.vscodeNotebookCell;const g=["W","X","Y","Z","a","b","c","d","e","f"],p=new RegExp(`^[${g.join("")}]+`),P=7;function M(R,K){const W=K.toString(P),Z=`${W.length<g.length?g[W.length-1]:"z"}${W}s${(0,r.encodeBase64)(r.VSBuffer.fromString(R.scheme),!0,!0)}`;return R.with({scheme:o.scheme,fragment:Z})}o.generate=M;function V(R){if(R.scheme!==o.scheme)return;const K=R.fragment.indexOf("s");if(K<0)return;const W=parseInt(R.fragment.substring(0,K).replace(p,""),P),O=(0,r.decodeBase64)(R.fragment.substring(K+1)).toString();if(!isNaN(W))return{handle:W,notebook:R.with({scheme:O,fragment:null})}}o.parse=V;function B(R,K){return R.with({scheme:_.Schemas.vscodeNotebookCellOutput,fragment:`op${K??""},${R.scheme!==_.Schemas.file?R.scheme:""}`})}o.generateCellOutputUri=B;function D(R){if(R.scheme!==_.Schemas.vscodeNotebookCellOutput)return;const K=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(R.fragment);if(!K)return;const W=K[1]&&K[1]!==""?K[1]:void 0,O=K[2];return{outputId:W,notebook:R.with({scheme:O||_.Schemas.file,fragment:null})}}o.parseCellOutputUri=D;function x(R,K,W){return o.generate(R,K).with({scheme:W})}o.generateCellPropertyUri=x;function U(R,K){if(R.scheme===K)return o.parse(R.with({scheme:o.scheme}))}o.parseCellPropertyUri=U})(v=e.CellUri||(e.CellUri={}));const I=o=>E.isWindows?o.replace(/\//g,"\\"):o;class l{constructor(g=[],p=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=p,this.order=[...new Set(g)].map(P=>({pattern:P,matches:y.parse(I(P))}))}sort(g){const p=new Map(w.Iterable.map(g,M=>[M,I(M)]));let P=[];for(const{matches:M}of this.order)for(const[V,B]of p)if(M(B)){P.push(V),p.delete(V);break}return p.size&&(P=P.concat([...p.keys()].sort((M,V)=>this.defaultOrder.indexOf(M)-this.defaultOrder.indexOf(V)))),P}prioritize(g,p){const P=this.findIndex(g);if(P===-1){this.order.unshift({pattern:g,matches:y.parse(I(g))});return}const M=new Set(p.map(B=>this.findIndex(B,P)));M.delete(-1);const V=Array.from(M).sort();this.order.splice(P+1,0,...V.map(B=>this.order[B]));for(let B=V.length-1;B>=0;B--)this.order.splice(V[B],1)}toArray(){return this.order.map(g=>g.pattern)}findIndex(g,p=this.order.length){const P=I(g);for(let M=0;M<p;M++)if(this.order[M].matches(P))return M;return-1}}e.MimeTypeDisplayOrder=l;function b(o,g,p,P=(M,V)=>M===V){const M=[];function V(x,U,R){if(U===0&&R.length===0)return;const K=M[M.length-1];K&&K.start+K.deleteCount===x?(K.deleteCount+=U,K.toInsert.push(...R)):M.push({start:x,deleteCount:U,toInsert:R})}let B=0,D=0;for(;;){if(B===o.length){V(B,0,g.slice(D));break}if(D===g.length){V(B,o.length-B,[]);break}const x=o[B],U=g[D];if(P(x,U)){B+=1,D+=1;continue}p(U)?(V(B,1,[]),B+=1):(V(B,0,[U]),D+=1)}return M}e.diff=b,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new k.RawContextKey("notebookEditorCursorAtBoundary","none");var t;(function(o){o.default="default",o.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function d(o){const g=o;return!!((typeof g.include=="string"||y.isRelativePattern(g.include))&&(typeof g.exclude=="string"||y.isRelativePattern(g.exclude)))}e.isDocumentExcludePattern=d;function n(o,g,p){if(Array.isArray(o.viewType)&&o.viewType.indexOf(g)>=0||o.viewType===g)return!0;if(o.filenamePattern){const P=d(o.filenamePattern)?o.filenamePattern.include:o.filenamePattern,M=d(o.filenamePattern)?o.filenamePattern.exclude:void 0;if(y.match(P,(0,A.basename)(p.fsPath).toLowerCase()))return!(M&&y.match(M,(0,A.basename)(p.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=n,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily"};var i;(function(o){o[o.Left=1]="Left",o[o.Right=2]="Right"})(i=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class s{static create(g){return`${s._prefix}${g}`}static parse(g){if(g.startsWith(s._prefix))return g.substring(s._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=s,s._prefix="notebook/";function a(o){return["application/vnd.code.notebook.stdout","application/x.notebook.stdout","application/x.notebook.stream","application/vnd.code.notebook.stderr","application/x.notebook.stderr"].includes(o)}e.isTextStreamMime=a}),define(Ce[166],Ie([1,0,3]),function(te,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var y;(function(w){w[w.Output=1]="Output",w[w.OutputItems=2]="OutputItems",w[w.ExecutionState=3]="ExecutionState"})(y=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,r.createDecorator)("INotebookExecutionService")}),define(Ce[167],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function r(_){return[..._.entries()]}e.serializeEnvironmentVariableCollection=r;function y(_){return new Map(_)}e.deserializeEnvironmentVariableCollection=y;function w(_){return Array.from(_.entries()).map(A=>[A[0],r(A[1].map)])}e.serializeEnvironmentVariableCollections=w;function L(_){return new Map(_.map(A=>[A[0],{map:y(A[1])}]))}e.deserializeEnvironmentVariableCollections=L}),define(Ce[47],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var r;(function(L){L.Delimiter="\0"})(r=e.TestIdPathParts||(e.TestIdPathParts={}));var y;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(y=e.TestPosition||(e.TestPosition={}));class w{constructor(_,A=_.length){if(this.path=_,this.viewEnd=A,_.length===0||A<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(_,A,E=_.parent){if(_.id===A)return new w([A]);const k=[_.id];for(let F=E;F&&F.id!==A;F=F.parent)k.push(F.id);return k.push(A),new w(k.reverse())}static isRoot(_){return!_.includes("\0")}static root(_){const A=_.indexOf("\0");return A===-1?_:_.slice(0,A)}static fromString(_){return new w(_.split("\0"))}static join(_,A){return new w([..._.path,A])}static joinToString(_,A){return _.toString()+"\0"+A}static compare(_,A){return _===A?0:A.startsWith(_+"\0")?2:_.startsWith(A+"\0")?3:1}get parentId(){return this.viewEnd>1?new w(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let _=1;_<=this.viewEnd;_++)yield new w(this.path,_)}compare(_){if(typeof _=="string")return w.compare(this.toString(),_);for(let A=0;A<_.viewEnd&&A<this.viewEnd;A++)if(_.path[A]!==this.path[A])return 1;return _.viewEnd>this.viewEnd?2:_.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let _=1;_<this.viewEnd;_++)this.stringifed+="\0",this.stringifed+=this.path[_]}return this.stringifed}}e.TestId=w}),define(Ce[48],Ie([1,0,2,49]),function(te,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var w;(function(s){s[s.Unset=0]="Unset",s[s.Queued=1]="Queued",s[s.Running=2]="Running",s[s.Passed=3]="Passed",s[s.Failed=4]="Failed",s[s.Skipped=5]="Skipped",s[s.Errored=6]="Errored"})(w=e.TestResultState||(e.TestResultState={}));var L;(function(s){s[s.Run=2]="Run",s[s.Debug=4]="Debug",s[s.Coverage=8]="Coverage",s[s.HasNonDefaultProfile=16]="HasNonDefaultProfile",s[s.HasConfigurable=32]="HasConfigurable"})(L=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var _;(function(s){s.serialize=a=>({range:a.range.toJSON(),uri:a.uri.toJSON()}),s.deserialize=a=>({range:y.Range.lift(a.range),uri:r.URI.revive(a.uri)})})(_=e.IRichLocation||(e.IRichLocation={}));var A;(function(s){s[s.Error=0]="Error",s[s.Output=1]="Output"})(A=e.TestMessageType||(e.TestMessageType={}));var E;(function(s){s.serialize=a=>({message:a.message,type:0,expected:a.expected,actual:a.actual,location:a.location&&_.serialize(a.location)}),s.deserialize=a=>({message:a.message,type:0,expected:a.expected,actual:a.actual,location:a.location&&_.deserialize(a.location)})})(E=e.ITestErrorMessage||(e.ITestErrorMessage={}));var k;(function(s){s.serialize=a=>({message:a.message,type:1,offset:a.offset,length:a.length,location:a.location&&_.serialize(a.location)}),s.deserialize=a=>({message:a.message,type:1,offset:a.offset,length:a.length,location:a.location&&_.deserialize(a.location)})})(k=e.ITestOutputMessage||(e.ITestOutputMessage={}));var F;(function(s){s.serialize=a=>a.type===0?E.serialize(a):k.serialize(a),s.deserialize=a=>a.type===0?E.deserialize(a):k.deserialize(a)})(F=e.ITestMessage||(e.ITestMessage={}));var S;(function(s){s.serializeWithoutMessages=a=>({state:a.state,duration:a.duration,messages:[]}),s.serialize=a=>({state:a.state,duration:a.duration,messages:a.messages.map(F.serialize)}),s.deserialize=a=>({state:a.state,duration:a.duration,messages:a.messages.map(F.deserialize)})})(S=e.ITestTaskState||(e.ITestTaskState={}));const m="\0",T=(s,a)=>s+m+a;e.namespaceTestTag=T;const f=s=>{const a=s.indexOf(m);return{ctrlId:s.slice(0,a),tagId:s.slice(a+1)}};e.denamespaceTestTag=f;var c;(function(s){s.serialize=a=>({extId:a.extId,label:a.label,tags:a.tags,busy:a.busy,children:void 0,uri:a.uri?.toJSON(),range:a.range?.toJSON()||null,description:a.description,error:a.error,sortText:a.sortText}),s.deserialize=a=>({extId:a.extId,label:a.label,tags:a.tags,busy:a.busy,children:void 0,uri:a.uri?r.URI.revive(a.uri):void 0,range:a.range?y.Range.lift(a.range):null,description:a.description,error:a.error,sortText:a.sortText})})(c=e.ITestItem||(e.ITestItem={}));var h;(function(s){s[s.NotExpandable=0]="NotExpandable",s[s.Expandable=1]="Expandable",s[s.BusyExpanding=2]="BusyExpanding",s[s.Expanded=3]="Expanded"})(h=e.TestItemExpandState||(e.TestItemExpandState={}));var u;(function(s){s.serialize=a=>({controllerId:a.controllerId,expand:a.expand,parent:a.parent,item:c.serialize(a.item)}),s.deserialize=a=>({controllerId:a.controllerId,expand:a.expand,parent:a.parent,item:c.deserialize(a.item)})})(u=e.InternalTestItem||(e.InternalTestItem={}));var v;(function(s){s.serialize=a=>{let o;return a.item&&(o={},a.item.label!==void 0&&(o.label=a.item.label),a.item.tags!==void 0&&(o.tags=a.item.tags),a.item.busy!==void 0&&(o.busy=a.item.busy),a.item.uri!==void 0&&(o.uri=a.item.uri?.toJSON()),a.item.range!==void 0&&(o.range=a.item.range?.toJSON()),a.item.description!==void 0&&(o.description=a.item.description),a.item.error!==void 0&&(o.error=a.item.error),a.item.sortText!==void 0&&(o.sortText=a.item.sortText)),{extId:a.extId,expand:a.expand,item:o,docv:a.docv}},s.deserialize=a=>{let o;return a.item&&(o={},a.item.label!==void 0&&(o.label=a.item.label),a.item.tags!==void 0&&(o.tags=a.item.tags),a.item.busy!==void 0&&(o.busy=a.item.busy),a.item.range!==void 0&&(o.range=a.item.range?y.Range.lift(a.item.range):null),a.item.description!==void 0&&(o.description=a.item.description),a.item.error!==void 0&&(o.error=a.item.error),a.item.sortText!==void 0&&(o.sortText=a.item.sortText)),{extId:a.extId,expand:a.expand,item:o,docv:a.docv}}})(v=e.ITestItemUpdate||(e.ITestItemUpdate={}));const I=(s,a)=>{a.expand!==void 0&&(s.expand=a.expand),a.item!==void 0&&(s.item=s.item?Object.assign(s.item,a.item):a.item)};e.applyTestItemUpdate=I;var l;(function(s){s.serializeWithoutMessages=a=>({...u.serialize(a),ownComputedState:a.ownComputedState,computedState:a.computedState,tasks:a.tasks.map(S.serializeWithoutMessages),retired:a.retired}),s.serialize=a=>({...u.serialize(a),ownComputedState:a.ownComputedState,computedState:a.computedState,tasks:a.tasks.map(S.serialize),retired:a.retired})})(l=e.TestResultItem||(e.TestResultItem={}));var b;(function(s){s[s.Function=0]="Function",s[s.Statement=1]="Statement"})(b=e.DetailType||(e.DetailType={}));var t;(function(s){s[s.Add=0]="Add",s[s.Update=1]="Update",s[s.Remove=2]="Remove",s[s.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",s[s.Retire=4]="Retire",s[s.AddTag=5]="AddTag",s[s.RemoveTag=6]="RemoveTag"})(t=e.TestDiffOpType||(e.TestDiffOpType={}));var d;(function(s){s.deserialize=a=>a.op===0?{op:a.op,item:u.deserialize(a.item)}:a.op===1?{op:a.op,item:v.deserialize(a.item)}:a,s.serialize=a=>a.op===0?{op:a.op,item:u.serialize(a.item)}:a.op===1?{op:a.op,item:v.serialize(a.item)}:a})(d=e.TestsDiffOp||(e.TestsDiffOp={}));class n{add(a){}update(a){}remove(a,o){}complete(){}}e.IncrementalChangeCollector=n;class i{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(a){const o=this.createChangeCollector();for(const g of a)switch(g.op){case 0:{const p=u.deserialize(g.item);if(p.parent){if(this.items.has(p.parent)){const P=this.items.get(p.parent);P.children.add(p.item.extId);const M=this.createItem(p,P);this.items.set(p.item.extId,M),o.add(M)}}else{const P=this.createItem(p);this.roots.add(P),this.items.set(p.item.extId,P),o.add(P)}p.expand===2&&this.busyControllerCount++;break}case 1:{const p=v.deserialize(g.item),P=this.items.get(p.extId);if(!P)break;p.expand!==void 0&&(P.expand===2&&this.busyControllerCount--,p.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(P,p),o.update(P);break}case 2:{const p=this.items.get(g.itemId);if(!p)break;p.parent?this.items.get(p.parent).children.delete(p.item.extId):this.roots.delete(p);const P=[[g.itemId]];for(;P.length;)for(const M of P.pop()){const V=this.items.get(M);V&&(P.push(V.children),this.items.delete(M),o.remove(V,V!==p),V.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(g.itemId);break;case 3:this.updatePendingRoots(g.amount);break;case 5:this._tags.set(g.tag.id,g.tag);break;case 6:this._tags.delete(g.id);break}o.complete()}retireTest(a){}updatePendingRoots(a){this.pendingRootCount+=a}createChangeCollector(){return new n}}e.AbstractIncrementalTestCollection=i}),define(Ce[65],Ie([1,0,14,5,7,44,48,47]),function(te,e,r,y,w,L,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var E;(function(u){u[u.Upsert=0]="Upsert",u[u.SetTags=1]="SetTags",u[u.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",u[u.RemoveChild=3]="RemoveChild",u[u.SetProp=4]="SetProp",u[u.Bulk=5]="Bulk"})(E=e.TestItemEventOp||(e.TestItemEventOp={}));const k=(u,v)=>u===v,F={range:(u,v)=>u===v?!0:!u||!v?!1:u.equalsRange(v),busy:k,label:k,description:k,error:k,tags:(u,v)=>!(u.length!==v.length||u.some(I=>!v.includes(I)))},S=(u,v)=>{let I;for(const[l,b]of Object.entries(F))b(u[l],v[l])||(I?I[l]=v[l]:I={[l]:v[l]});return I};class m extends w.Disposable{constructor(v){super(),this.options=v,this.debounceSendDiff=this._register(new r.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new y.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}get root(){return this.options.root}set resolveHandler(v){this._resolveHandler=v;for(const I of this.tree.values())this.updateExpandability(I)}collectDiff(){const v=this.diff;return this.diff=[],v}pushDiff(v){const I=this.diff[this.diff.length-1];if(I&&v.op===1){if(I.op===1&&I.item.extId===v.item.extId){(0,_.applyTestItemUpdate)(I.item,v.item);return}if(I.op===0&&I.item.item.extId===v.item.extId){(0,_.applyTestItemUpdate)(I.item,v.item);return}}this.diff.push(v),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(v,I){const l=this.tree.get(v);if(!!l){if((l.expandLevels===void 0||I>l.expandLevels)&&(l.expandLevels=I),l.expand===1){const b=this.resolveChildren(l);return b.isOpen()?this.expandChildren(l,I-1):b.wait().then(()=>this.expandChildren(l,I-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.expandChildren(l,I-1)):this.expandChildren(l,I-1)}}dispose(){for(const v of this.tree.values())this.options.getApiFor(v.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(v,I){switch(I.op){case 3:this.removeItem(A.TestId.joinToString(v.fullId,I.id));break;case 0:this.upsertItem(I.item,v);break;case 5:for(const l of I.ops)this.onTestItemEvent(v,l);break;case 1:this.diffTagRefs(I.new,I.old,v.fullId.toString());break;case 2:this.updateExpandability(v);break;case 4:this.pushDiff({op:1,item:{extId:v.fullId.toString(),item:I.update,docv:this.options.getDocumentVersion(v.actual.uri)}});break;default:(0,L.assertNever)(I)}}upsertItem(v,I){const l=A.TestId.fromExtHostTestItem(v,this.root.id,I?.actual),b=this.options.getApiFor(v);b.parent&&b.parent!==I?.actual&&this.options.getChildren(b.parent).delete(v.id);let t=this.tree.get(l.toString());if(!t){t={fullId:l,actual:v,parent:I?l.parentId:null,expandLevels:I?.expandLevels?I.expandLevels-1:void 0,expand:0},v.tags.forEach(this.incrementTagRefs,this),this.tree.set(t.fullId.toString(),t),this.setItemParent(v,I),this.pushDiff({op:0,item:{parent:t.parent&&t.parent.toString(),controllerId:this.options.controllerId,expand:t.expand,item:this.options.toITestItem(v)}}),this.connectItemAndChildren(v,t,I);return}if(t.actual===v){this.connectItem(v,t,I);return}const d=this.options.getChildren(t.actual),n=t.actual,i=S(this.options.toITestItem(n),this.options.toITestItem(v));this.options.getApiFor(n).listener=void 0,t.actual=v,t.expand=0,i&&(i.hasOwnProperty("tags")&&(this.diffTagRefs(v.tags,n.tags,l.toString()),delete i.tags),this.onTestItemEvent(t,{op:4,update:i})),this.connectItemAndChildren(v,t,I);for(const[s,a]of d)this.options.getChildren(v).get(a.id)||this.removeItem(A.TestId.joinToString(l,a.id))}diffTagRefs(v,I,l){const b=new Set(I.map(t=>t.id));for(const t of v)b.delete(t.id)||this.incrementTagRefs(t);this.pushDiff({op:1,item:{extId:l,item:{tags:v.map(t=>(0,_.namespaceTestTag)(this.options.controllerId,t.id))}}}),b.forEach(this.decrementTagRefs,this)}incrementTagRefs(v){const I=this.tags.get(v.id);I?I.refCount++:(this.tags.set(v.id,{refCount:1}),this.pushDiff({op:5,tag:{id:(0,_.namespaceTestTag)(this.options.controllerId,v.id)}}))}decrementTagRefs(v){const I=this.tags.get(v);I&&!--I.refCount&&(this.tags.delete(v),this.pushDiff({op:6,id:(0,_.namespaceTestTag)(this.options.controllerId,v)}))}setItemParent(v,I){this.options.getApiFor(v).parent=I&&I.actual!==this.root?I.actual:void 0}connectItem(v,I,l){this.setItemParent(v,l);const b=this.options.getApiFor(v);b.parent=l?.actual,b.listener=t=>this.onTestItemEvent(I,t),this.updateExpandability(I)}connectItemAndChildren(v,I,l){this.connectItem(v,I,l);for(const[b,t]of this.options.getChildren(v))this.upsertItem(t,I)}updateExpandability(v){let I;this._resolveHandler?v.resolveBarrier?I=v.resolveBarrier.isOpen()?3:2:I=v.actual.canResolveChildren?1:0:I=0,I!==v.expand&&(v.expand=I,this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:I}}),I===1&&v.expandLevels!==void 0&&this.resolveChildren(v))}expandChildren(v,I){if(I<0)return;const l=[];for(const[b,t]of this.options.getChildren(v.actual)){const d=this.expand(A.TestId.joinToString(v.fullId,t.id),I);(0,r.isThenable)(d)&&l.push(d)}if(l.length)return Promise.all(l).then(()=>{})}resolveChildren(v){if(v.resolveBarrier)return v.resolveBarrier;if(!this._resolveHandler){const t=new r.Barrier;return t.open(),t}v.expand=2,this.pushExpandStateUpdate(v);const I=v.resolveBarrier=new r.Barrier,l=t=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,t)};let b;try{b=this._resolveHandler(v.actual===this.root?void 0:v.actual)}catch(t){l(t)}return(0,r.isThenable)(b)?b.catch(l).then(()=>{I.open(),this.updateExpandability(v)}):(I.open(),this.updateExpandability(v)),v.resolveBarrier}pushExpandStateUpdate(v){this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:v.expand}})}removeItem(v){const I=this.tree.get(v);if(!I)throw new Error("attempting to remove non-existent child");this.pushDiff({op:2,itemId:v});const l=[I];for(;l.length;){const b=l.pop();if(!!b){this.options.getApiFor(b.actual).listener=void 0;for(const t of b.actual.tags)this.decrementTagRefs(t.id);this.tree.delete(b.fullId.toString());for(const[t,d]of this.options.getChildren(b.actual))l.push(this.tree.get(A.TestId.joinToString(b.fullId,d.id)))}}}flushDiff(){const v=this.collectDiff();v.length&&this.diffOpEmitter.fire(v)}}e.TestItemCollection=m;class T extends Error{constructor(v){super(`Attempted to insert a duplicate test item ID ${v}`)}}e.DuplicateTestItemError=T;class f extends Error{constructor(v){super(`TestItem with ID "${v}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=f;class c extends Error{constructor(v,I,l){super(`TestItem with ID "${v}" is from controller "${I}" and cannot be added as a child of an item from controller "${l}".`)}}e.MixedTestItemController=c;const h=(u,v,I)=>{let l=new Map;return{get size(){return l.size},forEach(b,t){for(const d of l.values())b.call(t,d,this)},[Symbol.iterator](){return l.entries()},replace(b){const t=new Map,d=new Set(l.keys()),n={op:5,ops:[]};for(const i of b){if(!(i instanceof I))throw new f(i.id);const s=v(i).controllerId;if(s!==u.controllerId)throw new c(i.id,s,u.controllerId);if(t.has(i.id))throw new T(i.id);t.set(i.id,i),d.delete(i.id),n.ops.push({op:0,item:i})}for(const i of d.keys())n.ops.push({op:3,id:i});u.listener?.(n),l=t},add(b){if(!(b instanceof I))throw new f(b.id);l.set(b.id,b),u.listener?.({op:0,item:b})},delete(b){l.delete(b)&&u.listener?.({op:3,id:b})},get(b){return l.get(b)},toJSON(){return Array.from(l.values())}}};e.createTestItemChildren=h}),define(Ce[89],Ie([1,0,65]),function(te,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const y=new WeakMap,w=(_,A)=>{const E={controllerId:A};return y.set(_,E),E};e.createPrivateApiFor=w;const L=_=>{const A=y.get(_);if(!A)throw new r.InvalidTestItemError(_?.id||"<unknown>");return A};e.getPrivateApiFor=L}),define(Ce[168],Ie([1,0,3]),function(te,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,r.createDecorator)("configurationResolverService");var y;(function(L){L.Unknown="unknown",L.Env="env",L.Config="config",L.Command="command",L.Input="input",L.ExtensionInstallFolder="extensionInstallFolder",L.WorkspaceFolder="workspaceFolder",L.Cwd="cwd",L.WorkspaceFolderBasename="workspaceFolderBasename",L.UserHome="userHome",L.LineNumber="lineNumber",L.SelectedText="selectedText",L.File="file",L.FileWorkspaceFolder="fileWorkspaceFolder",L.RelativeFile="relativeFile",L.RelativeFileDirname="relativeFileDirname",L.FileDirname="fileDirname",L.FileExtname="fileExtname",L.FileBasename="fileBasename",L.FileBasenameNoExtension="fileBasenameNoExtension",L.FileDirnameBasename="fileDirnameBasename",L.ExecPath="execPath",L.ExecInstallFolder="execInstallFolder",L.PathSeparator="pathSeparator"})(y=e.VariableKind||(e.VariableKind={}));class w extends Error{constructor(_,A){super(A),this.variable=_}}e.VariableError=w}),define(Ce[169],Ie([1,0,19,59,10,26,21,77,141,168,9]),function(te,e,r,y,w,L,_,A,E,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class S{constructor(T,f,c,h){this._contributedVariables=new Map,this._context=T,this._labelService=f,this._userHomePromise=c,h&&(this._envVariablesPromise=h.then(u=>this.prepareEnv(u)))}prepareEnv(T){if(_.isWindows){const f=Object.create(null);return Object.keys(T).forEach(c=>{f[c.toLowerCase()]=T[c]}),f}return T}resolveWithEnvironment(T,f,c){return this.recursiveResolve({env:this.prepareEnv(T),userHome:void 0},f?f.uri:void 0,c)}async resolveAsync(T,f){const c={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(c,T?T.uri:void 0,f)}async resolveAnyBase(T,f,c,h){const u=L.deepClone(f);_.isWindows&&u.windows?Object.keys(u.windows).forEach(I=>u[I]=u.windows[I]):_.isMacintosh&&u.osx?Object.keys(u.osx).forEach(I=>u[I]=u.osx[I]):_.isLinux&&u.linux&&Object.keys(u.linux).forEach(I=>u[I]=u.linux[I]),delete u.windows,delete u.osx,delete u.linux;const v={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(v,T?T.uri:void 0,u,c,h)}async resolveAnyAsync(T,f,c){return this.resolveAnyBase(T,f,c)}async resolveAnyMap(T,f,c){const h=new Map;return{newConfig:await this.resolveAnyBase(T,f,c,h),resolvedVariables:h}}resolveWithInteractionReplace(T,f,c,h){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(T,f,c,h){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(T,f){if(this._contributedVariables.has(T))throw new Error("Variable "+T+" is contributed twice.");this._contributedVariables.set(T,f)}async recursiveResolve(T,f,c,h,u){if(w.isString(c))return this.resolveString(T,f,c,h,u);if(Array.isArray(c))return Promise.all(c.map(v=>this.recursiveResolve(T,f,v,h,u)));if(w.isObject(c)){const v=Object.create(null),I=await Promise.all(Object.keys(c).map(async l=>[await this.resolveString(T,f,l,h,u),await this.recursiveResolve(T,f,c[l],h,u)]));for(const[l,b]of I)v[l]=b;return v}return c}resolveString(T,f,c,h,u){return(0,F.replaceAsync)(c,S.VARIABLE_REGEXP,async(v,I)=>{if(I.includes(S.VARIABLE_LHS))return v;let l=await this.evaluateSingleVariable(T,v,I,f,h);return u?.set(I,l),l!==v&&w.isString(l)&&l.match(S.VARIABLE_REGEXP)&&(l=await this.resolveString(T,f,l,h,u)),l})}fsPath(T){return this._labelService?this._labelService.getUriLabel(T,{noPrefix:!0}):T.fsPath}async evaluateSingleVariable(T,f,c,h,u){let v;const I=c.split(":");I.length>1&&(c=I[0],v=I[1]);const l=d=>{const n=this._context.getFilePath();if(n)return n;throw new k.VariableError(d,(0,E.localize)(0,null,f))},b=d=>{const n=l(d);if(this._context.getWorkspaceFolderPathForFile){const i=this._context.getWorkspaceFolderPathForFile();if(i)return i}throw new k.VariableError(d,(0,E.localize)(1,null,f,r.basename(n)))},t=d=>{if(v){const n=this._context.getFolderUri(v);if(n)return n;throw new k.VariableError(d,(0,E.localize)(2,null,f,v))}if(h)return h;throw this._context.getWorkspaceFolderCount()>1?new k.VariableError(d,(0,E.localize)(3,null,f)):new k.VariableError(d,(0,E.localize)(4,null,f))};switch(c){case"env":if(v){if(T.env){const d=T.env[_.isWindows?v.toLowerCase():v];if(w.isString(d))return d}return""}throw new k.VariableError(k.VariableKind.Env,(0,E.localize)(5,null,f));case"config":if(v){const d=this._context.getConfigurationValue(h,v);if(w.isUndefinedOrNull(d))throw new k.VariableError(k.VariableKind.Config,(0,E.localize)(6,null,f,v));if(w.isObject(d))throw new k.VariableError(k.VariableKind.Config,(0,E.localize)(7,null,f,v));return d}throw new k.VariableError(k.VariableKind.Config,(0,E.localize)(8,null,f));case"command":return this.resolveFromMap(k.VariableKind.Command,f,v,u,"command");case"input":return this.resolveFromMap(k.VariableKind.Input,f,v,u,"input");case"extensionInstallFolder":if(v){const d=await this._context.getExtension(v);if(!d)throw new k.VariableError(k.VariableKind.ExtensionInstallFolder,(0,E.localize)(9,null,f,v));return this.fsPath(d.extensionLocation)}throw new k.VariableError(k.VariableKind.ExtensionInstallFolder,(0,E.localize)(10,null,f));default:switch(c){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.fsPath(t(k.VariableKind.WorkspaceFolder)));case"cwd":return h||v?(0,A.normalizeDriveLetter)(this.fsPath(t(k.VariableKind.Cwd))):y.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return r.basename(this.fsPath(t(k.VariableKind.WorkspaceFolderBasename)));case"userHome":{if(T.userHome)return T.userHome;throw new k.VariableError(k.VariableKind.UserHome,(0,E.localize)(11,null,f))}case"lineNumber":{const d=this._context.getLineNumber();if(d)return d;throw new k.VariableError(k.VariableKind.LineNumber,(0,E.localize)(12,null,f))}case"selectedText":{const d=this._context.getSelectedText();if(d)return d;throw new k.VariableError(k.VariableKind.SelectedText,(0,E.localize)(13,null,f))}case"file":return l(k.VariableKind.File);case"fileWorkspaceFolder":return b(k.VariableKind.FileWorkspaceFolder);case"relativeFile":return h||v?r.relative(this.fsPath(t(k.VariableKind.RelativeFile)),l(k.VariableKind.RelativeFile)):l(k.VariableKind.RelativeFile);case"relativeFileDirname":{const d=r.dirname(l(k.VariableKind.RelativeFileDirname));if(h||v){const n=r.relative(this.fsPath(t(k.VariableKind.RelativeFileDirname)),d);return n.length===0?".":n}return d}case"fileDirname":return r.dirname(l(k.VariableKind.FileDirname));case"fileExtname":return r.extname(l(k.VariableKind.FileExtname));case"fileBasename":return r.basename(l(k.VariableKind.FileBasename));case"fileBasenameNoExtension":{const d=r.basename(l(k.VariableKind.FileBasenameNoExtension));return d.slice(0,d.length-r.extname(d).length)}case"fileDirnameBasename":return r.basename(r.dirname(l(k.VariableKind.FileDirnameBasename)));case"execPath":{const d=this._context.getExecPath();return d||f}case"execInstallFolder":{const d=this._context.getAppRoot();return d||f}case"pathSeparator":return r.sep;default:try{const d=v?`${c}:${v}`:c;return this.resolveFromMap(k.VariableKind.Unknown,f,d,u,void 0)}catch{return f}}}}resolveFromMap(T,f,c,h,u){if(c&&h){const v=u===void 0?h[c]:h[u+":"+c];if(typeof v=="string")return v;throw new k.VariableError(T,(0,E.localize)(14,null,f))}return f}}e.AbstractVariableResolverService=S,S.VARIABLE_LHS="${",S.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ce[90],Ie([1,0,3,88]),function(te,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,r.createDecorator)("editorGroupsService");var w;(function(f){f[f.UP=0]="UP",f[f.DOWN=1]="DOWN",f[f.LEFT=2]="LEFT",f[f.RIGHT=3]="RIGHT"})(w=e.GroupDirection||(e.GroupDirection={}));var L;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(L=e.GroupOrientation||(e.GroupOrientation={}));var _;(function(f){f[f.FIRST=0]="FIRST",f[f.LAST=1]="LAST",f[f.NEXT=2]="NEXT",f[f.PREVIOUS=3]="PREVIOUS"})(_=e.GroupLocation||(e.GroupLocation={}));var A;(function(f){f[f.MAXIMIZE=0]="MAXIMIZE",f[f.EVEN=1]="EVEN",f[f.TOGGLE=2]="TOGGLE"})(A=e.GroupsArrangement||(e.GroupsArrangement={}));var E;(function(f){f[f.COPY_EDITORS=0]="COPY_EDITORS",f[f.MOVE_EDITORS=1]="MOVE_EDITORS"})(E=e.MergeGroupMode||(e.MergeGroupMode={}));function k(f){const c=f;return(0,y.isEditorInput)(c?.editor)&&(0,y.isEditorInput)(c?.replacement)}e.isEditorReplacement=k;var F;(function(f){f[f.CREATION_TIME=0]="CREATION_TIME",f[f.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",f[f.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(F=e.GroupsOrder||(e.GroupsOrder={}));var S;(function(f){f[f.NEW_EDITOR=1]="NEW_EDITOR",f[f.MOVE_EDITOR=2]="MOVE_EDITOR",f[f.COPY_EDITOR=3]="COPY_EDITOR"})(S=e.OpenEditorContext||(e.OpenEditorContext={}));function m(f){const c=f;return!!c&&typeof c.id=="number"&&Array.isArray(c.editors)}e.isEditorGroup=m;function T(f){return f.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=T}),define(Ce[170],Ie([1,0,3,90]),function(te,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,r.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function w(L){const _=L;return typeof L=="number"||(0,y.isEditorGroup)(_)}e.isPreferredGroup=w}),define(Ce[171],Ie([1,0,3,146]),function(te,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,r.refineServiceDecorator)(y.IEnvironmentService)}),define(Ce[172],Ie([1,0,27,5,19]),function(te,e,r,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class L{constructor(S){this.removedDueToLooping=S}}e.DeltaExtensionsResult=L;class _{constructor(S){this._onDidChange=new y.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=S,this._initialize()}_initialize(){this._extensionDescriptions.sort(E),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const S of this._extensionDescriptions){if(this._extensionsMap.has(r.ExtensionIdentifier.toKey(S.identifier))){console.error("Extension `"+S.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(r.ExtensionIdentifier.toKey(S.identifier),S),this._extensionsArr.push(S),Array.isArray(S.activationEvents))for(let m of S.activationEvents)m==="onUri"&&(m=`onUri:${r.ExtensionIdentifier.toKey(S.identifier)}`),this._activationMap.has(m)||this._activationMap.set(m,[]),this._activationMap.get(m).push(S)}}set(S){this._extensionDescriptions=S,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(S,m){this._extensionDescriptions=k(this._extensionDescriptions,m),this._extensionDescriptions=this._extensionDescriptions.concat(S);const T=_._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=k(this._extensionDescriptions,T.map(f=>f.identifier)),this._initialize(),this._onDidChange.fire(void 0),new L(T)}static _findLoopingExtensions(S){const m=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(u){this._nodesSet.has(u)||(this._nodesSet.add(u),this._nodesArr.push(u))}addArc(u,v){this.addNode(u),this.addNode(v),this._arcs.has(u)?this._arcs.get(u).push(v):this._arcs.set(u,[v])}getArcs(u){return this._arcs.has(u)?this._arcs.get(u):[]}hasOnlyGoodArcs(u,v){const I=m.getArcs(u);for(let l=0;l<I.length;l++)if(!v.has(I[l]))return!1;return!0}getNodes(){return this._nodesArr}},T=new Map;for(const u of S){const v=r.ExtensionIdentifier.toKey(u.identifier);if(T.set(v,u),u.extensionDependencies)for(const I of u.extensionDependencies){const l=r.ExtensionIdentifier.toKey(I);m.addArc(v,l)}}const f=new Set;m.getNodes().filter(u=>m.getArcs(u).length===0).forEach(u=>f.add(u));const c=m.getNodes().filter(u=>!f.has(u));let h;do{h=!1;for(let u=0;u<c.length;u++){const v=c[u];m.hasOnlyGoodArcs(v,f)&&(c.splice(u,1),u--,f.add(v),h=!0)}}while(h);return c.map(u=>T.get(u))}containsActivationEvent(S){return this._activationMap.has(S)}containsExtension(S){return this._extensionsMap.has(r.ExtensionIdentifier.toKey(S))}getExtensionDescriptionsForActivationEvent(S){const m=this._activationMap.get(S);return m?m.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(S){const m=this._extensionsMap.get(r.ExtensionIdentifier.toKey(S));return m||void 0}getExtensionDescriptionByUUID(S){for(const m of this._extensionsArr)if(m.uuid===S)return m}getExtensionDescriptionByIdOrUUID(S,m){return this.getExtensionDescription(S)??(m?this.getExtensionDescriptionByUUID(m):void 0)}}e.ExtensionDescriptionRegistry=_;var A;(function(F){F[F.Builtin=0]="Builtin",F[F.User=1]="User",F[F.Dev=2]="Dev"})(A||(A={}));function E(F,S){const m=F.isBuiltin?0:F.isUnderDevelopment?2:1,T=S.isBuiltin?0:S.isUnderDevelopment?2:1;if(m!==T)return m-T;const f=w.posix.basename(F.extensionLocation.path),c=w.posix.basename(S.extensionLocation.path);return f<c?-1:f>c?1:0}function k(F,S){const m=new Set;return S.forEach(T=>m.add(r.ExtensionIdentifier.toKey(T))),F.filter(T=>!m.has(r.ExtensionIdentifier.toKey(T.identifier)))}}),define(Ce[91],Ie([1,0,23]),function(te,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var y;(function(k){k[k.Desktop=1]="Desktop",k[k.Web=2]="Web"})(y=e.UIKind||(e.UIKind={}));var w;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(w=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var L;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(L=e.MessageType||(e.MessageType={}));function _(k){const F=r.VSBuffer.alloc(1);switch(k){case 0:F.writeUInt8(1,0);break;case 1:F.writeUInt8(2,0);break;case 2:F.writeUInt8(3,0);break}return F}e.createMessageOfType=_;function A(k,F){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return F===0;case 2:return F===1;case 3:return F===2;default:return!1}}e.isMessageOfType=A;var E;(function(k){k.Start="START_NATIVE_LOG",k.End="END_NATIVE_LOG"})(E=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(Ce[24],Ie([1,0,5,2,3,27,152]),function(te,e,r,y,w,L,_){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new L.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:y.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,w.createDecorator)("extensionService");class E{constructor(a){this.affinity=a,this.kind=1}equals(a){return this.kind===a.kind&&this.affinity===a.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=E;class k{constructor(){this.kind=2,this.affinity=0}equals(a){return this.kind===a.kind}asString(){return"LocalWebWorker"}}e.LocalWebWorkerRunningLocation=k;class F{constructor(){this.kind=3,this.affinity=0}equals(a){return this.kind===a.kind}asString(){return"Remote"}}e.RemoteRunningLocation=F;class S{constructor(a){this.dependency=a}}e.MissingExtensionDependency=S;var m;(function(s){s[s.LocalProcess=1]="LocalProcess",s[s.LocalWebWorker=2]="LocalWebWorker",s[s.Remote=3]="Remote"})(m=e.ExtensionHostKind||(e.ExtensionHostKind={}));function T(s){if(s===null)return"None";switch(s){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=T;class f{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(a,o){const g=[],p=[],P=[],M=[],V=u(this._allExtensions),B=u(a),D=(K,W)=>K.extensionLocation.toString()===W.extensionLocation.toString()||K.isBuiltin===W.isBuiltin||K.isUserBuiltin===W.isUserBuiltin||K.isUnderDevelopment===W.isUnderDevelopment;for(const K of this._allExtensions){const W=B.get(L.ExtensionIdentifier.toKey(K.identifier));if(!W){g.push(K.identifier),V.delete(L.ExtensionIdentifier.toKey(K.identifier));continue}if(!D(K,W)){g.push(K.identifier),V.delete(L.ExtensionIdentifier.toKey(K.identifier));continue}}for(const K of a){const W=V.get(L.ExtensionIdentifier.toKey(K.identifier));if(!W){p.push(K);continue}if(!D(W,K)){g.push(W.identifier),V.delete(L.ExtensionIdentifier.toKey(W.identifier));continue}}const x=h(this._myExtensions),U=h(o);for(const K of this._myExtensions)U.has(L.ExtensionIdentifier.toKey(K))||P.push(K);for(const K of o)x.has(L.ExtensionIdentifier.toKey(K))||M.push(K);const R={toRemove:g,toAdd:p,myToRemove:P,myToAdd:M};return this.delta(R),R}delta(a){const{toRemove:o,toAdd:g,myToRemove:p,myToAdd:P}=a,M=h(o),V=h(p);for(let B=0;B<this._allExtensions.length;B++)M.has(L.ExtensionIdentifier.toKey(this._allExtensions[B].identifier))&&(this._allExtensions.splice(B,1),B--);for(let B=0;B<this._myExtensions.length;B++)V.has(L.ExtensionIdentifier.toKey(this._myExtensions[B]))&&(this._myExtensions.splice(B,1),B--);for(const B of g)this._allExtensions.push(B);for(const B of P)this._myExtensions.push(B)}containsExtension(a){for(const o of this._myExtensions)if(L.ExtensionIdentifier.equals(o,a))return!0;return!1}}e.ExtensionHostExtensions=f;class c{constructor(a){if(this[A]="ExtensionIdentifierSet",this._map=new Map,this._toKey=L.ExtensionIdentifier.toKey,a)for(const o of a)this.add(o)}get size(){return this._map.size}add(a){return this._map.set(this._toKey(a),a),this}clear(){this._map.clear()}delete(a){return this._map.delete(this._toKey(a))}has(a){return this._map.has(this._toKey(a))}forEach(a,o){this._map.forEach(g=>a.call(o,g,g,this))}*entries(){for(const[a,o]of this._map)yield[o,o]}keys(){return this._map.values()}values(){return this._map.values()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=c;function h(s){const a=new Set;for(const o of s)a.add(L.ExtensionIdentifier.toKey(o));return a}e.extensionIdentifiersArrayToSet=h;function u(s){const a=new Map;for(const o of s)a.set(L.ExtensionIdentifier.toKey(o.identifier),o);return a}function v(s,a){return s.enabledApiProposals?s.enabledApiProposals.includes(a):!1}e.isProposedApiEnabled=v;function I(s,a){if(!v(s,a))throw new Error(`Extension '${s.identifier.value}' CANNOT use API proposal: ${a}.
Its package.json#enabledApiProposals-property declares: ${s.enabledApiProposals?.join(", ")??"[]"} but NOT ${a}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${s.identifier.value}`)}e.checkProposedApiEnabled=I;class l{constructor(a,o,g,p){this.codeLoadingTime=a,this.activateCallTime=o,this.activateResolvedTime=g,this.activationReason=p}}e.ActivationTimes=l;class b{constructor(a,o){this.description=a,this.value=o}}e.ExtensionPointContribution=b,e.ExtensionHostLogFileName="exthost";var t;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(t=e.ActivationKind||(e.ActivationKind={}));function d(s){return{type:s.isBuiltin?0:1,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,_.getGalleryExtensionId)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation,targetPlatform:s.targetPlatform,validations:[],isValid:!0}}e.toExtension=d;function n(s,a){return{identifier:new L.ExtensionIdentifier((0,_.getExtensionId)(s.manifest.publisher,s.manifest.name)),isBuiltin:s.type===0,isUserBuiltin:s.type===1&&s.isBuiltin,isUnderDevelopment:!!a,extensionLocation:s.location,...s.manifest,uuid:s.identifier.uuid,targetPlatform:s.targetPlatform,browserNlsBundleUris:s.browserNlsBundleUris}}e.toExtensionDescription=n;class i{constructor(){this.onDidRegisterExtensions=r.Event.None,this.onDidChangeExtensionsStatus=r.Event.None,this.onDidChangeExtensions=r.Event.None,this.onWillActivateByEvent=r.Event.None,this.onDidChangeResponsiveChange=r.Event.None}activateByEvent(a){return Promise.resolve(void 0)}activationEventIsDone(a){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(a){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(a,o){return Promise.resolve(0)}getInspectPorts(a,o){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(a){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(a,o){return Promise.resolve()}}e.NullExtensionService=i}),define(Ce[173],Ie([1,0,11,27,24,15,14]),function(te,e,r,y,w,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class A{constructor(h,u,v,I){this.startup=h,this.codeLoadingTime=u,this.activateCallTime=v,this.activateResolvedTime=I}}e.ExtensionActivationTimes=A,A.NONE=new A(!1,-1,-1,-1);class E{constructor(h){this._startup=h,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(h,u){return h===-1||u===-1?-1:u-h}build(){return new A(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=E;class k{constructor(h,u,v,I,l,b){this.activationFailed=h,this.activationFailedError=u,this.activationTimes=v,this.module=I,this.exports=l,this.subscriptions=b}}e.ActivatedExtension=k;class F extends k{constructor(h){super(!1,null,h,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=F;class S extends k{constructor(){super(!1,null,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=S;class m extends k{constructor(h){super(!0,h,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=m;let T=class{constructor(h,u,v,I,l){this._logService=l,this._registry=h,this._resolvedExtensionsSet=new Set,u.forEach(b=>this._resolvedExtensionsSet.add(y.ExtensionIdentifier.toKey(b))),this._externalExtensionsMap=new Map,v.forEach(b=>this._externalExtensionsMap.set(y.ExtensionIdentifier.toKey(b),b)),this._host=I,this._operations=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[h,u]of this._operations)u.dispose()}isActivated(h){const u=this._operations.get(y.ExtensionIdentifier.toKey(h));return Boolean(u&&u.value)}getActivatedExtension(h){const u=this._operations.get(y.ExtensionIdentifier.toKey(h));if(!u||!u.value)throw new Error(`Extension '${h.value}' is not known or not activated`);return u.value}async activateByEvent(h,u){if(this._alreadyActivatedEvents[h])return;const v=this._registry.getExtensionDescriptionsForActivationEvent(h);await this._activateExtensions(v.map(I=>({id:I.identifier,reason:{startup:u,extensionId:I.identifier,activationEvent:h}}))),this._alreadyActivatedEvents[h]=!0}activateById(h,u){const v=this._registry.getExtensionDescription(h);if(!v)throw new Error(`Extension '${h}' is not known`);return this._activateExtensions([{id:v.identifier,reason:u}])}async _activateExtensions(h){const u=h.filter(v=>!this.isActivated(v.id)).map(v=>this._handleActivationRequest(v));await Promise.all(u.map(v=>v.wait()))}_handleActivationRequest(h){if(this._operations.has(y.ExtensionIdentifier.toKey(h.id)))return this._operations.get(y.ExtensionIdentifier.toKey(h.id));if(this._externalExtensionsMap.has(y.ExtensionIdentifier.toKey(h.id)))return this._createAndSaveOperation(h,null,[],null);const u=this._registry.getExtensionDescription(h.id);if(!u){const l=new Error(`Cannot activate unknown extension '${h.id.value}'`),b=this._createAndSaveOperation(h,null,[],new m(l));return this._host.onExtensionActivationError(h.id,l,new w.MissingExtensionDependency(h.id.value)),b}const v=[],I=typeof u.extensionDependencies>"u"?[]:u.extensionDependencies;for(const l of I){if(this._resolvedExtensionsSet.has(y.ExtensionIdentifier.toKey(l)))continue;const b=this._operations.get(y.ExtensionIdentifier.toKey(l));if(b){v.push(b);continue}if(this._externalExtensionsMap.has(y.ExtensionIdentifier.toKey(l))){v.push(this._handleActivationRequest({id:this._externalExtensionsMap.get(y.ExtensionIdentifier.toKey(l)),reason:h.reason}));continue}const t=this._registry.getExtensionDescription(l);if(t){if(!t.main&&!t.browser)continue;v.push(this._handleActivationRequest({id:t.identifier,reason:h.reason}));continue}const d=u.displayName||u.identifier.value,n=new Error(`Cannot activate the '${d}' extension because it depends on unknown extension '${l}'`),i=this._createAndSaveOperation(h,u.displayName,[],new m(n));return this._host.onExtensionActivationError(u.identifier,n,new w.MissingExtensionDependency(l)),i}return this._createAndSaveOperation(h,u.displayName,v,null)}_createAndSaveOperation(h,u,v,I){const l=new f(h.id,u,h.reason,v,I,this._host,this._logService);return this._operations.set(y.ExtensionIdentifier.toKey(h.id),l),l}};T=ze([xe(4,L.ILogService)],T),e.ExtensionsActivator=T;let f=class{constructor(h,u,v,I,l,b,t){this._id=h,this._displayName=u,this._reason=v,this._deps=I,this._value=l,this._host=b,this._logService=t,this._barrier=new _.Barrier,this._isDisposed=!1,this._initialize()}get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let h=0;h<this._deps.length;h++){const u=this._deps[h];if(u.value&&!u.value.activationFailed){this._deps.splice(h,1),h--;continue}if(u.value&&u.value.activationFailed){const v=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${u.friendlyName}' failed to activate`);v.detail=u.value.activationFailedError,this._value=new m(v),this._host.onExtensionActivationError(this._id,v,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(h=>h.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(h){const u=new Error;if(h&&h.name&&(u.name=h.name),h&&h.message?u.message=`Activating extension '${this._id.value}' failed: ${h.message}.`:u.message=`Activating extension '${this._id.value}' failed: ${h}.`,h&&h.stack&&(u.stack=h.stack),this._value=new m(u),this._isDisposed&&r.isCancellationError(h))return;this._host.onExtensionActivationError(this._id,u,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(h)}}};f=ze([xe(6,L.ILogService)],f)}),define(Ce[174],Ie([1,0,15,28,24]),function(te,e,r,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let L=class extends r.LogService{constructor(A,E){super(A.createLogger(E.logFile,{name:w.ExtensionHostLogFileName}))}};L=ze([xe(0,r.ILoggerService),xe(1,y.IExtHostInitDataService)],L),e.ExtHostLogService=L});var Je=this&&this.__classPrivateFieldSet||function(te,e,r,y,w){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!w:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?w.call(te,r):w?w.value=r:e.set(te,r),r},Oe=this&&this.__classPrivateFieldGet||function(te,e,r,y){if(r==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?y:r==="a"?y.call(te):y?y.value:e.get(te)};define(Ce[6],Ie([1,0,16,11,76,25,74,9,10,2,42,39,85,64,24]),function(te,e,r,y,w,L,_,A,E,k,F,S,m,T,f){"use strict";var c,h,u,v,I,l,b,t,d,n,i,s,a,o,g,p,P,M,V,B,D,x,U;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function R($){function N(){return Reflect.construct($,arguments,this.constructor)}return Object.defineProperty(N,"name",Object.getOwnPropertyDescriptor($,"name")),Object.setPrototypeOf(N,$),Object.setPrototypeOf(N.prototype,$.prototype),N}let K=l=class{constructor(N){c.set(this,void 0),Je(this,c,N,"f")}static from(...N){let ee=N;return new l(function(){if(ee){for(const we of ee)we&&typeof we.dispose=="function"&&we.dispose();ee=void 0}})}dispose(){typeof Oe(this,c,"f")=="function"&&(Oe(this,c,"f").call(this),Je(this,c,void 0,"f"))}};c=new WeakMap,K=l=ze([R],K),e.Disposable=K;let W=b=class{constructor(N,ee){if(N<0)throw(0,y.illegalArgument)("line must be non-negative");if(ee<0)throw(0,y.illegalArgument)("character must be non-negative");this._line=N,this._character=ee}static Min(...N){if(N.length===0)throw new TypeError;let ee=N[0];for(let we=1;we<N.length;we++){const He=N[we];He.isBefore(ee)&&(ee=He)}return ee}static Max(...N){if(N.length===0)throw new TypeError;let ee=N[0];for(let we=1;we<N.length;we++){const He=N[we];He.isAfter(ee)&&(ee=He)}return ee}static isPosition(N){if(!N)return!1;if(N instanceof b)return!0;const{line:ee,character:we}=N;return typeof ee=="number"&&typeof we=="number"}static of(N){if(N instanceof b)return N;if(this.isPosition(N))return new b(N.line,N.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}isBefore(N){return this._line<N._line?!0:N._line<this._line?!1:this._character<N._character}isBeforeOrEqual(N){return this._line<N._line?!0:N._line<this._line?!1:this._character<=N._character}isAfter(N){return!this.isBeforeOrEqual(N)}isAfterOrEqual(N){return!this.isBefore(N)}isEqual(N){return this._line===N._line&&this._character===N._character}compareTo(N){return this._line<N._line?-1:this._line>N.line?1:this._character<N._character?-1:this._character>N._character?1:0}translate(N,ee=0){if(N===null||ee===null)throw(0,y.illegalArgument)();let we;return typeof N>"u"?we=0:typeof N=="number"?we=N:(we=typeof N.lineDelta=="number"?N.lineDelta:0,ee=typeof N.characterDelta=="number"?N.characterDelta:0),we===0&&ee===0?this:new b(this.line+we,this.character+ee)}with(N,ee=this.character){if(N===null||ee===null)throw(0,y.illegalArgument)();let we;return typeof N>"u"?we=this.line:typeof N=="number"?we=N:(we=typeof N.line=="number"?N.line:this.line,ee=typeof N.character=="number"?N.character:this.character),we===this.line&&ee===this.character?this:new b(we,ee)}toJSON(){return{line:this.line,character:this.character}}};W=b=ze([R],W),e.Position=W;let O=t=class{constructor(N,ee,we,He){let Ze,lt;if(typeof N=="number"&&typeof ee=="number"&&typeof we=="number"&&typeof He=="number"?(Ze=new W(N,ee),lt=new W(we,He)):W.isPosition(N)&&W.isPosition(ee)&&(Ze=W.of(N),lt=W.of(ee)),!Ze||!lt)throw new Error("Invalid arguments");Ze.isBefore(lt)?(this._start=Ze,this._end=lt):(this._start=lt,this._end=Ze)}static isRange(N){return N instanceof t?!0:N?W.isPosition(N.start)&&W.isPosition(N.end):!1}static of(N){if(N instanceof t)return N;if(this.isRange(N))return new t(N.start,N.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}contains(N){return t.isRange(N)?this.contains(N.start)&&this.contains(N.end):W.isPosition(N)?!(W.of(N).isBefore(this._start)||this._end.isBefore(N)):!1}isEqual(N){return this._start.isEqual(N._start)&&this._end.isEqual(N._end)}intersection(N){const ee=W.Max(N.start,this._start),we=W.Min(N.end,this._end);if(!ee.isAfter(we))return new t(ee,we)}union(N){if(this.contains(N))return this;if(N.contains(this))return N;const ee=W.Min(N.start,this._start),we=W.Max(N.end,this.end);return new t(ee,we)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(N,ee=this.end){if(N===null||ee===null)throw(0,y.illegalArgument)();let we;return N?W.isPosition(N)?we=N:(we=N.start||this.start,ee=N.end||this.end):we=this.start,we.isEqual(this._start)&&ee.isEqual(this.end)?this:new t(we,ee)}toJSON(){return[this.start,this.end]}};O=t=ze([R],O),e.Range=O;let Z=d=class extends O{constructor(N,ee,we,He){let Ze,lt;if(typeof N=="number"&&typeof ee=="number"&&typeof we=="number"&&typeof He=="number"?(Ze=new W(N,ee),lt=new W(we,He)):W.isPosition(N)&&W.isPosition(ee)&&(Ze=W.of(N),lt=W.of(ee)),!Ze||!lt)throw new Error("Invalid arguments");super(Ze,lt),this._anchor=Ze,this._active=lt}static isSelection(N){return N instanceof d?!0:N?O.isRange(N)&&W.isPosition(N.anchor)&&W.isPosition(N.active)&&typeof N.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};Z=d=ze([R],Z),e.Selection=Z;class ue{constructor(N,ee,we){if(typeof N!="string"||N.length===0)throw(0,y.illegalArgument)("host");if(typeof ee!="number"||ee===0||Math.round(ee)!==ee)throw(0,y.illegalArgument)("port");if(typeof we<"u"&&(typeof we!="string"||we.length===0||!/^[0-9A-Za-z\-]+$/.test(we)))throw(0,y.illegalArgument)("connectionToken");this.host=N,this.port=Math.round(ee),this.connectionToken=we}}e.ResolvedAuthority=ue;class oe extends Error{constructor(N,ee=m.RemoteAuthorityResolverErrorCode.Unknown,we){super(N),this._message=N,this._code=ee,this._detail=we,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,oe.prototype)}static NotAvailable(N,ee){return new oe(N,m.RemoteAuthorityResolverErrorCode.NotAvailable,ee)}static TemporarilyNotAvailable(N){return new oe(N,m.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=oe;var de;(function($){$[$.LF=1]="LF",$[$.CRLF=2]="CRLF"})(de=e.EndOfLine||(e.EndOfLine={}));var ie;(function($){$[$.Replace=1]="Replace",$[$.Append=2]="Append",$[$.Prepend=3]="Prepend"})(ie=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let ve=n=class{constructor(N,ee){this._range=N,this._newText=ee}static isTextEdit(N){return N instanceof n?!0:N?O.isRange(N)&&typeof N.newText=="string":!1}static replace(N,ee){return new n(N,ee)}static insert(N,ee){return n.replace(new O(N,N),ee)}static delete(N){return n.replace(N,"")}static setEndOfLine(N){const ee=new n(new O(new W(0,0),new W(0,0)),"");return ee.newEol=N,ee}get range(){return this._range}set range(N){if(N&&!O.isRange(N))throw(0,y.illegalArgument)("range");this._range=N}get newText(){return this._newText||""}set newText(N){if(N&&typeof N!="string")throw(0,y.illegalArgument)("newText");this._newText=N}get newEol(){return this._newEol}set newEol(N){if(N&&typeof N!="number")throw(0,y.illegalArgument)("newEol");this._newEol=N}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};ve=n=ze([R],ve),e.TextEdit=ve;let be=i=class{constructor(N,ee){this.range=N,this.newCells=ee}static isNotebookCellEdit(N){return N instanceof i?!0:N?jt.isNotebookRange(N)&&Array.isArray(N.newCells):!1}static replaceCells(N,ee){return new i(N,ee)}static insertCells(N,ee){return new i(new jt(N,N),ee)}static deleteCells(N){return new i(N,[])}static updateCellMetadata(N,ee){const we=new i(new jt(N,N),[]);return we.newCellMetadata=ee,we}static updateNotebookMetadata(N){const ee=new i(new jt(0,0),[]);return ee.newNotebookMetadata=N,ee}};be=i=ze([R],be),e.NotebookEdit=be;class ne{constructor(N,ee){this.range=N,this.snippet=ee}static isSnippetTextEdit(N){return N instanceof ne?!0:N?O.isRange(N.range)&&Fe.isSnippetString(N.snippet):!1}static replace(N,ee){return new ne(N,ee)}static insert(N,ee){return ne.replace(new O(N,N),ee)}}e.SnippetTextEdit=ne;var Ee;(function($){$[$.File=1]="File",$[$.Text=2]="Text",$[$.Cell=3]="Cell",$[$.CellReplace=5]="CellReplace",$[$.Snippet=6]="Snippet"})(Ee=e.FileEditType||(e.FileEditType={}));let Pe=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(N,ee,we,He){this._edits.push({_type:1,from:N,to:ee,options:we,metadata:He})}createFile(N,ee,we){this._edits.push({_type:1,from:void 0,to:N,options:ee,metadata:we})}deleteFile(N,ee,we){this._edits.push({_type:1,from:N,to:void 0,options:ee,metadata:we})}replaceNotebookMetadata(N,ee,we){this._edits.push({_type:3,metadata:we,uri:N,edit:{editType:5,metadata:ee},notebookMetadata:ee})}replaceNotebookCells(N,ee,we,He){const Ze=ee.start,lt=ee.end;(Ze!==lt||we.length>0)&&this._edits.push({_type:5,uri:N,index:Ze,count:lt-Ze,cells:we,metadata:He})}replaceNotebookCellMetadata(N,ee,we,He){this._edits.push({_type:3,metadata:He,uri:N,edit:{editType:8,index:ee,metadata:we}})}replace(N,ee,we,He){this._edits.push({_type:2,uri:N,edit:new ve(ee,we),metadata:He})}insert(N,ee,we,He){this.replace(N,new O(ee,ee),we,He)}delete(N,ee,we){this.replace(N,ee,"",we)}has(N){return this._edits.some(ee=>ee._type===2&&ee.uri.toString()===N.toString())}set(N,ee){if(ee)for(const we of ee){if(!we)continue;let He,Ze;Array.isArray(we)?(He=we[0],Ze=we[1]):He=we,be.isNotebookCellEdit(He)?He.newCellMetadata?this.replaceNotebookCellMetadata(N,He.range.start,He.newCellMetadata,Ze):He.newNotebookMetadata?this.replaceNotebookMetadata(N,He.newNotebookMetadata,Ze):this.replaceNotebookCells(N,He.range,He.newCells,Ze):ne.isSnippetTextEdit(He)?this._edits.push({_type:6,uri:N,range:He.range,edit:He.snippet,metadata:Ze}):this._edits.push({_type:2,uri:N,edit:He,metadata:Ze})}else{for(let we=0;we<this._edits.length;we++){const He=this._edits[we];switch(He._type){case 2:case 6:case 3:case 5:He.uri.toString()===N.toString()&&(this._edits[we]=void 0);break}}(0,r.coalesceInPlace)(this._edits)}}get(N){const ee=[];for(const we of this._edits)we._type===2&&we.uri.toString()===N.toString()&&ee.push(we.edit);return ee}entries(){const N=new L.ResourceMap;for(const ee of this._edits)if(ee._type===2){let we=N.get(ee.uri);we||(we=[ee.uri,[]],N.set(ee.uri,we)),we[1].push(ee.edit)}return[...N.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Pe=ze([R],Pe),e.WorkspaceEdit=Pe;let Fe=s=class{constructor(N){this._tabstop=1,this.value=N||""}static isSnippetString(N){return N instanceof s?!0:N?typeof N.value=="string":!1}static _escape(N){return N.replace(/\$|}|\\/g,"\\$&")}appendText(N){return this.value+=s._escape(N),this}appendTabstop(N=this._tabstop++){return this.value+="$",this.value+=N,this}appendPlaceholder(N,ee=this._tabstop++){if(typeof N=="function"){const we=new s;we._tabstop=this._tabstop,N(we),this._tabstop=we._tabstop,N=we.value}else N=s._escape(N);return this.value+="${",this.value+=ee,this.value+=":",this.value+=N,this.value+="}",this}appendChoice(N,ee=this._tabstop++){const we=N.map(He=>He.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ee,this.value+="|",this.value+=we,this.value+="|}",this}appendVariable(N,ee){if(typeof ee=="function"){const we=new s;we._tabstop=this._tabstop,ee(we),this._tabstop=we._tabstop,ee=we.value}else typeof ee=="string"&&(ee=ee.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=N,ee&&(this.value+=":",this.value+=ee),this.value+="}",this}};Fe=s=ze([R],Fe),e.SnippetString=Fe;var $e;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})($e=e.DiagnosticTag||(e.DiagnosticTag={}));var Qe;(function($){$[$.Hint=3]="Hint",$[$.Information=2]="Information",$[$.Warning=1]="Warning",$[$.Error=0]="Error"})(Qe=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Te=a=class{constructor(N,ee){if(this.uri=N,ee)if(O.isRange(ee))this.range=O.of(ee);else if(W.isPosition(ee))this.range=new O(ee,ee);else throw new Error("Illegal argument")}static isLocation(N){return N instanceof a?!0:N?O.isRange(N.range)&&k.URI.isUri(N.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Te=a=ze([R],Te),e.Location=Te;let _e=class{constructor(N,ee){this.location=N,this.message=ee}static is(N){return N?typeof N.message=="string"&&N.location&&O.isRange(N.location.range)&&k.URI.isUri(N.location.uri):!1}static isEqual(N,ee){return N===ee?!0:!N||!ee?!1:N.message===ee.message&&N.location.range.isEqual(ee.location.range)&&N.location.uri.toString()===ee.location.uri.toString()}};_e=ze([R],_e),e.DiagnosticRelatedInformation=_e;let ye=class{constructor(N,ee,we=Qe.Error){if(!O.isRange(N))throw new TypeError("range must be set");if(!ee)throw new TypeError("message must be set");this.range=N,this.message=ee,this.severity=we}toJSON(){return{severity:Qe[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(N,ee){return N===ee?!0:!N||!ee?!1:N.message===ee.message&&N.severity===ee.severity&&N.code===ee.code&&N.severity===ee.severity&&N.source===ee.source&&N.range.isEqual(ee.range)&&(0,r.equals)(N.tags,ee.tags)&&(0,r.equals)(N.relatedInformation,ee.relatedInformation,_e.isEqual)}};ye=ze([R],ye),e.Diagnostic=ye;let ae=class{constructor(N,ee){if(!N)throw new Error("Illegal argument, contents must be defined");Array.isArray(N)?this.contents=N:this.contents=[N],this.range=ee}};ae=ze([R],ae),e.Hover=ae;var le;(function($){$[$.Text=0]="Text",$[$.Read=1]="Read",$[$.Write=2]="Write"})(le=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Q=class{constructor(N,ee=le.Text){this.range=N,this.kind=ee}toJSON(){return{range:this.range,kind:le[this.kind]}}};Q=ze([R],Q),e.DocumentHighlight=Q;var J;(function($){$[$.File=0]="File",$[$.Module=1]="Module",$[$.Namespace=2]="Namespace",$[$.Package=3]="Package",$[$.Class=4]="Class",$[$.Method=5]="Method",$[$.Property=6]="Property",$[$.Field=7]="Field",$[$.Constructor=8]="Constructor",$[$.Enum=9]="Enum",$[$.Interface=10]="Interface",$[$.Function=11]="Function",$[$.Variable=12]="Variable",$[$.Constant=13]="Constant",$[$.String=14]="String",$[$.Number=15]="Number",$[$.Boolean=16]="Boolean",$[$.Array=17]="Array",$[$.Object=18]="Object",$[$.Key=19]="Key",$[$.Null=20]="Null",$[$.EnumMember=21]="EnumMember",$[$.Struct=22]="Struct",$[$.Event=23]="Event",$[$.Operator=24]="Operator",$[$.TypeParameter=25]="TypeParameter"})(J=e.SymbolKind||(e.SymbolKind={}));var C;(function($){$[$.Deprecated=1]="Deprecated"})(C=e.SymbolTag||(e.SymbolTag={}));let z=o=class{constructor(N,ee,we,He,Ze){this.name=N,this.kind=ee,this.containerName=Ze,typeof we=="string"&&(this.containerName=we),He instanceof Te?this.location=He:we instanceof O&&(this.location=new Te(He,we)),o.validate(this)}static validate(N){if(!N.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:J[this.kind],location:this.location,containerName:this.containerName}}};z=o=ze([R],z),e.SymbolInformation=z;let H=g=class{constructor(N,ee,we,He,Ze){this.name=N,this.detail=ee,this.kind=we,this.range=He,this.selectionRange=Ze,this.children=[],g.validate(this)}static validate(N){if(!N.name)throw new Error("name must not be falsy");if(!N.range.contains(N.selectionRange))throw new Error("selectionRange must be contained in fullRange");N.children?.forEach(g.validate)}};H=g=ze([R],H),e.DocumentSymbol=H;var j;(function($){$[$.Invoke=1]="Invoke",$[$.Automatic=2]="Automatic"})(j=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let se=class{constructor(N,ee){this.title=N,this.kind=ee}};se=ze([R],se),e.CodeAction=se;let ce=p=class{constructor(N){this.value=N}append(N){return new p(this.value?this.value+p.sep+N:N)}intersects(N){return this.contains(N)||N.contains(this)}contains(N){return this.value===N.value||N.value.startsWith(this.value+p.sep)}};ce.sep=".",ce=p=ze([R],ce),e.CodeActionKind=ce,ce.Empty=new ce(""),ce.QuickFix=ce.Empty.append("quickfix"),ce.Refactor=ce.Empty.append("refactor"),ce.RefactorExtract=ce.Refactor.append("extract"),ce.RefactorInline=ce.Refactor.append("inline"),ce.RefactorMove=ce.Refactor.append("move"),ce.RefactorRewrite=ce.Refactor.append("rewrite"),ce.Source=ce.Empty.append("source"),ce.SourceOrganizeImports=ce.Source.append("organizeImports"),ce.SourceFixAll=ce.Source.append("fixAll");let Y=class{constructor(N,ee){if(this.range=N,this.parent=ee,ee&&!ee.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Y=ze([R],Y),e.SelectionRange=Y;class pe{constructor(N,ee,we,He,Ze,lt){this.kind=N,this.name=ee,this.detail=we,this.uri=He,this.range=Ze,this.selectionRange=lt}}e.CallHierarchyItem=pe;class ge{constructor(N,ee){this.fromRanges=ee,this.from=N}}e.CallHierarchyIncomingCall=ge;class Ne{constructor(N,ee){this.fromRanges=ee,this.to=N}}e.CallHierarchyOutgoingCall=Ne;var Be;(function($){$[$.Information=0]="Information",$[$.Warning=1]="Warning",$[$.Error=2]="Error"})(Be=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Ye=class{constructor(N,ee){this.range=N,this.command=ee}get isResolved(){return!!this.command}};Ye=ze([R],Ye),e.CodeLens=Ye;let Xe=P=class{constructor(N,ee=!1){h.set(this,void 0),Je(this,h,new w.MarkdownString(N,{supportThemeIcons:ee}),"f")}static isMarkdownString(N){return N instanceof P?!0:N&&N.appendCodeblock&&N.appendMarkdown&&N.appendText&&N.value!==void 0}get value(){return Oe(this,h,"f").value}set value(N){Oe(this,h,"f").value=N}get isTrusted(){return Oe(this,h,"f").isTrusted}set isTrusted(N){Oe(this,h,"f").isTrusted=N}get supportThemeIcons(){return Oe(this,h,"f").supportThemeIcons}set supportThemeIcons(N){Oe(this,h,"f").supportThemeIcons=N}get supportHtml(){return Oe(this,h,"f").supportHtml}set supportHtml(N){Oe(this,h,"f").supportHtml=N}get baseUri(){return Oe(this,h,"f").baseUri}set baseUri(N){Oe(this,h,"f").baseUri=N}appendText(N){return Oe(this,h,"f").appendText(N),this}appendMarkdown(N){return Oe(this,h,"f").appendMarkdown(N),this}appendCodeblock(N,ee){return Oe(this,h,"f").appendCodeblock(ee??"",N),this}};h=new WeakMap,Xe=P=ze([R],Xe),e.MarkdownString=Xe;let ke=class{constructor(N,ee){this.label=N,this.documentation=ee}};ke=ze([R],ke),e.ParameterInformation=ke;let nt=class{constructor(N,ee){this.label=N,this.documentation=ee,this.parameters=[]}};nt=ze([R],nt),e.SignatureInformation=nt;let G=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};G=ze([R],G),e.SignatureHelp=G;var X;(function($){$[$.Invoke=1]="Invoke",$[$.TriggerCharacter=2]="TriggerCharacter",$[$.ContentChange=3]="ContentChange"})(X=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var fe;(function($){$[$.Type=1]="Type",$[$.Parameter=2]="Parameter"})(fe=e.InlayHintKind||(e.InlayHintKind={}));let Ue=class{constructor(N){this.value=N}};Ue=ze([R],Ue),e.InlayHintLabelPart=Ue;let We=class{constructor(N,ee,we){this.position=N,this.label=ee,this.kind=we}};We=ze([R],We),e.InlayHint=We;var et;(function($){$[$.Invoke=0]="Invoke",$[$.TriggerCharacter=1]="TriggerCharacter",$[$.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(et=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var qe;(function($){$[$.Text=0]="Text",$[$.Method=1]="Method",$[$.Function=2]="Function",$[$.Constructor=3]="Constructor",$[$.Field=4]="Field",$[$.Variable=5]="Variable",$[$.Class=6]="Class",$[$.Interface=7]="Interface",$[$.Module=8]="Module",$[$.Property=9]="Property",$[$.Unit=10]="Unit",$[$.Value=11]="Value",$[$.Enum=12]="Enum",$[$.Keyword=13]="Keyword",$[$.Snippet=14]="Snippet",$[$.Color=15]="Color",$[$.File=16]="File",$[$.Reference=17]="Reference",$[$.Folder=18]="Folder",$[$.EnumMember=19]="EnumMember",$[$.Constant=20]="Constant",$[$.Struct=21]="Struct",$[$.Event=22]="Event",$[$.Operator=23]="Operator",$[$.TypeParameter=24]="TypeParameter",$[$.User=25]="User",$[$.Issue=26]="Issue"})(qe=e.CompletionItemKind||(e.CompletionItemKind={}));var Ve;(function($){$[$.Deprecated=1]="Deprecated"})(Ve=e.CompletionItemTag||(e.CompletionItemTag={}));let it=class{constructor(N,ee){this.label=N,this.kind=ee}toJSON(){return{label:this.label,kind:this.kind&&qe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};it=ze([R],it),e.CompletionItem=it;let st=class{constructor(N=[],ee=!1){this.items=N,this.isIncomplete=ee}};st=ze([R],st),e.CompletionList=st;let dt=class{constructor(N,ee,we){this.insertText=N,this.range=ee,this.command=we}};dt=ze([R],dt),e.InlineSuggestion=dt;let at=class{constructor(N){this.commands=void 0,this.items=N}};at=ze([R],at),e.InlineSuggestionList=at;let rt=class{constructor(N,ee,we){this.insertText=N,this.range=ee,this.command=we}};rt=ze([R],rt),e.InlineSuggestionNew=rt;let _t=class{constructor(N,ee){this.items=N,this.commands=ee}};_t=ze([R],_t),e.InlineSuggestionsNew=_t;var Rt;(function($){$[$.Active=-1]="Active",$[$.Beside=-2]="Beside",$[$.One=1]="One",$[$.Two=2]="Two",$[$.Three=3]="Three",$[$.Four=4]="Four",$[$.Five=5]="Five",$[$.Six=6]="Six",$[$.Seven=7]="Seven",$[$.Eight=8]="Eight",$[$.Nine=9]="Nine"})(Rt=e.ViewColumn||(e.ViewColumn={}));var Ot;(function($){$[$.Left=1]="Left",$[$.Right=2]="Right"})(Ot=e.StatusBarAlignment||(e.StatusBarAlignment={}));var mt;(function($){$[$.Off=0]="Off",$[$.On=1]="On",$[$.Relative=2]="Relative"})(mt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Dt;(function($){$[$.Manual=1]="Manual",$[$.AfterDelay=2]="AfterDelay",$[$.FocusOut=3]="FocusOut"})(Dt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Nt;(function($){$[$.Default=0]="Default",$[$.InCenter=1]="InCenter",$[$.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",$[$.AtTop=3]="AtTop"})(Nt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Mt;(function($){$[$.Keyboard=1]="Keyboard",$[$.Mouse=2]="Mouse",$[$.Command=3]="Command"})(Mt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var je;(function($){$[$.Undo=1]="Undo",$[$.Redo=2]="Redo"})(je=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Ut;(function($){$[$.OpenOpen=0]="OpenOpen",$[$.ClosedClosed=1]="ClosedClosed",$[$.OpenClosed=2]="OpenClosed",$[$.ClosedOpen=3]="ClosedOpen"})(Ut=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function($){function N(ee){switch(ee){case"keyboard":return $.Keyboard;case"mouse":return $.Mouse;case"api":return $.Command}}$.fromValue=N}(Mt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ft=class{constructor(N,ee){if(ee&&!k.URI.isUri(ee))throw(0,y.illegalArgument)("target");if(!O.isRange(N)||N.isEmpty)throw(0,y.illegalArgument)("range");this.range=N,this.target=ee}};Ft=ze([R],Ft),e.DocumentLink=Ft;let Tt=class{constructor(N,ee,we,He){this.red=N,this.green=ee,this.blue=we,this.alpha=He}};Tt=ze([R],Tt),e.Color=Tt;let gt=class{constructor(N,ee){if(ee&&!(ee instanceof Tt))throw(0,y.illegalArgument)("color");if(!O.isRange(N)||N.isEmpty)throw(0,y.illegalArgument)("range");this.range=N,this.color=ee}};gt=ze([R],gt),e.ColorInformation=gt;let yt=class{constructor(N){if(!N||typeof N!="string")throw(0,y.illegalArgument)("label");this.label=N}};yt=ze([R],yt),e.ColorPresentation=yt;var Se;(function($){$[$.RGB=0]="RGB",$[$.HEX=1]="HEX",$[$.HSL=2]="HSL"})(Se=e.ColorFormat||(e.ColorFormat={}));var De;(function($){$[$.Error=0]="Error",$[$.Warning=1]="Warning",$[$.Information=2]="Information"})(De=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var me;(function($){$[$.Unknown=0]="Unknown",$[$.Shutdown=1]="Shutdown",$[$.Process=2]="Process",$[$.User=3]="User",$[$.Extension=4]="Extension"})(me=e.TerminalExitReason||(e.TerminalExitReason={}));class q{constructor(N,ee,we){if(this.startIndex=N,this.length=ee,this.tooltip=we,typeof N!="number"||N<0)throw(0,y.illegalArgument)("startIndex");if(typeof ee!="number"||ee<1)throw(0,y.illegalArgument)("length");if(we!==void 0&&typeof we!="string")throw(0,y.illegalArgument)("tooltip")}}e.TerminalLink=q;var Ae;(function($){$[$.Panel=1]="Panel",$[$.Editor=2]="Editor"})(Ae=e.TerminalLocation||(e.TerminalLocation={}));class Le{constructor(N){if(this.options=N,typeof N!="object")throw(0,y.illegalArgument)("options")}}e.TerminalProfile=Le;var tt;(function($){$[$.Always=1]="Always",$[$.Silent=2]="Silent",$[$.Never=3]="Never"})(tt=e.TaskRevealKind||(e.TaskRevealKind={}));var Ge;(function($){$[$.Shared=1]="Shared",$[$.Dedicated=2]="Dedicated",$[$.New=3]="New"})(Ge=e.TaskPanelKind||(e.TaskPanelKind={}));let Ke=M=class{constructor(N,ee){if(this.label=ee,typeof N!="string"||typeof ee!="string")throw(0,y.illegalArgument)("name");this._id=N}static from(N){switch(N){case"clean":return M.Clean;case"build":return M.Build;case"rebuild":return M.Rebuild;case"test":return M.Test;default:return}}get id(){return this._id}};Ke.Clean=new M("clean","Clean"),Ke.Build=new M("build","Build"),Ke.Rebuild=new M("rebuild","Rebuild"),Ke.Test=new M("test","Test"),Ke=M=ze([R],Ke),e.TaskGroup=Ke;function ct($){let N="";for(let ee=0;ee<$.length;ee++)N+=$[ee].replace(/,/g,",,")+",";return N}let Ct=class{constructor(N,ee,we){if(typeof N!="string")throw(0,y.illegalArgument)("process");this._args=[],this._process=N,ee!==void 0&&(Array.isArray(ee)?(this._args=ee,this._options=we):this._options=ee)}get process(){return this._process}set process(N){if(typeof N!="string")throw(0,y.illegalArgument)("process");this._process=N}get args(){return this._args}set args(N){Array.isArray(N)||(N=[]),this._args=N}get options(){return this._options}set options(N){this._options=N}computeId(){const N=[];if(N.push("process"),this._process!==void 0&&N.push(this._process),this._args&&this._args.length>0)for(const ee of this._args)N.push(ee);return ct(N)}};Ct=ze([R],Ct),e.ProcessExecution=Ct;let pt=class{constructor(N,ee,we){if(this._args=[],Array.isArray(ee)){if(!N)throw(0,y.illegalArgument)("command can't be undefined or null");if(typeof N!="string"&&typeof N.value!="string")throw(0,y.illegalArgument)("command");this._command=N,this._args=ee,this._options=we}else{if(typeof N!="string")throw(0,y.illegalArgument)("commandLine");this._commandLine=N,this._options=ee}}get commandLine(){return this._commandLine}set commandLine(N){if(typeof N!="string")throw(0,y.illegalArgument)("commandLine");this._commandLine=N}get command(){return this._command?this._command:""}set command(N){if(typeof N!="string"&&typeof N.value!="string")throw(0,y.illegalArgument)("command");this._command=N}get args(){return this._args}set args(N){this._args=N||[]}get options(){return this._options}set options(N){this._options=N}computeId(){const N=[];if(N.push("shell"),this._commandLine!==void 0&&N.push(this._commandLine),this._command!==void 0&&N.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const ee of this._args)N.push(typeof ee=="string"?ee:ee.value);return ct(N)}};pt=ze([R],pt),e.ShellExecution=pt;var It;(function($){$[$.Escape=1]="Escape",$[$.Strong=2]="Strong",$[$.Weak=3]="Weak"})(It=e.ShellQuoting||(e.ShellQuoting={}));var bt;(function($){$[$.Global=1]="Global",$[$.Workspace=2]="Workspace"})(bt=e.TaskScope||(e.TaskScope={}));class vt{constructor(N){this._callback=N}computeId(){return"customExecution"+(0,F.generateUuid)()}set callback(N){this._callback=N}get callback(){return this._callback}}e.CustomExecution=vt;let wt=V=class{constructor(N,ee,we,He,Ze,lt){this.__deprecated=!1,this._definition=this.definition=N;let ht;typeof ee=="string"?(this._name=this.name=ee,this._source=this.source=we,this.execution=He,ht=Ze,this.__deprecated=!0):ee===bt.Global||ee===bt.Workspace?(this.target=ee,this._name=this.name=we,this._source=this.source=He,this.execution=Ze,ht=lt):(this.target=ee,this._name=this.name=we,this._source=this.source=He,this.execution=Ze,ht=lt),typeof ht=="string"?(this._problemMatchers=[ht],this._hasDefinedMatchers=!0):Array.isArray(ht)?(this._problemMatchers=ht,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(N){this.__id=N}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ct?this._definition={type:V.ProcessType,id:this._execution.computeId()}:this._execution instanceof pt?this._definition={type:V.ShellType,id:this._execution.computeId()}:this._execution instanceof vt?this._definition={type:V.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:V.EmptyType,id:(0,F.generateUuid)()}}get definition(){return this._definition}set definition(N){if(N==null)throw(0,y.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=N}get scope(){return this._scope}set target(N){this.clear(),this._scope=N}get name(){return this._name}set name(N){if(typeof N!="string")throw(0,y.illegalArgument)("name");this.clear(),this._name=N}get execution(){return this._execution}set execution(N){N===null&&(N=void 0),this.clear(),this._execution=N;const ee=this._definition.type;(V.EmptyType===ee||V.ProcessType===ee||V.ShellType===ee||V.ExtensionCallbackType===ee)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(N){if(Array.isArray(N))this.clear(),this._problemMatchers=N,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(N){N!==!0&&N!==!1&&(N=!1),this.clear(),this._isBackground=N}get source(){return this._source}set source(N){if(typeof N!="string"||N.length===0)throw(0,y.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=N}get group(){return this._group}set group(N){N===null&&(N=void 0),this.clear(),this._group=N}get detail(){return this._detail}set detail(N){N===null&&(N=void 0),this._detail=N}get presentationOptions(){return this._presentationOptions}set presentationOptions(N){N==null&&(N=Object.create(null)),this.clear(),this._presentationOptions=N}get runOptions(){return this._runOptions}set runOptions(N){N==null&&(N=Object.create(null)),this.clear(),this._runOptions=N}};wt.ExtensionCallbackType="customExecution",wt.ProcessType="process",wt.ShellType="shell",wt.EmptyType="$empty",wt=V=ze([R],wt),e.Task=wt;var ti;(function($){$[$.SourceControl=1]="SourceControl",$[$.Window=10]="Window",$[$.Notification=15]="Notification"})(ti=e.ProgressLocation||(e.ProgressLocation={}));let Et=B=class{constructor(N,ee=$t.None){this.collapsibleState=ee,k.URI.isUri(N)?this.resourceUri=N:this.label=N}static isTreeItem(N,ee){if(N instanceof B)return!0;const we=N;if(we.label!==void 0&&!(0,E.isString)(we.label)&&!we.label?.label)return console.log("INVALID tree item, invalid label",we.label),!1;if(we.id!==void 0&&!(0,E.isString)(we.id))return console.log("INVALID tree item, invalid id",we.id),!1;if(we.iconPath!==void 0&&!(0,E.isString)(we.iconPath)&&!k.URI.isUri(we.iconPath)&&(!we.iconPath||!(0,E.isString)(we.iconPath.id))){const He=we.iconPath;if(!He||!(0,E.isString)(He.light)&&!k.URI.isUri(He.light)&&!(0,E.isString)(He.dark)&&!k.URI.isUri(He.dark))return console.log("INVALID tree item, invalid iconPath",we.iconPath),!1}return we.description!==void 0&&!(0,E.isString)(we.description)&&typeof we.description!="boolean"?(console.log("INVALID tree item, invalid description",we.description),!1):we.resourceUri!==void 0&&!k.URI.isUri(we.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",we.resourceUri),!1):we.tooltip!==void 0&&!(0,E.isString)(we.tooltip)&&!(we.tooltip instanceof Xe)?(console.log("INVALID tree item, invalid tooltip",we.tooltip),!1):we.command!==void 0&&!we.command.command?(console.log("INVALID tree item, invalid command",we.command),!1):we.collapsibleState!==void 0&&we.collapsibleState<$t.None&&we.collapsibleState>$t.Expanded?(console.log("INVALID tree item, invalid collapsibleState",we.collapsibleState),!1):we.contextValue!==void 0&&!(0,E.isString)(we.contextValue)?(console.log("INVALID tree item, invalid contextValue",we.contextValue),!1):we.accessibilityInformation!==void 0&&!we.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",we.accessibilityInformation),!1):we.checkboxState!==void 0&&((0,f.checkProposedApiEnabled)(ee,"treeItemCheckbox"),we.checkboxState!==Wt.Checked&&we.checkboxState!==Wt.Unchecked)?(console.log("INVALID tree item, invalid checkboxState",we.checkboxState),!1):!0}};Et=B=ze([R],Et),e.TreeItem=Et;var $t;(function($){$[$.None=0]="None",$[$.Collapsed=1]="Collapsed",$[$.Expanded=2]="Expanded"})($t=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var Wt;(function($){$[$.Unchecked=0]="Unchecked",$[$.Checked=1]="Checked"})(Wt=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let ii=class{constructor(N,ee){this.value=N,this.id=ee??(0,F.generateUuid)()}async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}};ii=ze([R],ii),e.DataTransferItem=ii;let gi=class{constructor(N){u.set(this,new Map);for(const[ee,we]of N??[]){const He=Oe(this,u,"f").get(ee);He?He.push(we):Oe(this,u,"f").set(ee,[we])}}get(N){return Oe(this,u,"f").get(N)?.[0]}set(N,ee){Oe(this,u,"f").set(N,[ee])}forEach(N,ee){for(const[we,He]of Oe(this,u,"f"))for(const Ze of He)N.call(ee,Ze,we,this)}*[(u=new WeakMap,Symbol.iterator)](){for(const[N,ee]of Oe(this,u,"f"))for(const we of ee)yield[N,we]}};gi=ze([R],gi),e.DataTransfer=gi;let kt=class{constructor(N){this.insertText=N}};kt=ze([R],kt),e.DocumentDropEdit=kt;let ni=class{constructor(N){this.insertText=N}};ni=ze([R],ni),e.DocumentPasteEdit=ni;let Ht=class{constructor(N,ee){this.id=N,this.color=ee}};Ht=ze([R],Ht),e.ThemeIcon=Ht,Ht.File=new Ht("file"),Ht.Folder=new Ht("folder");let Yt=class{constructor(N){this.id=N}};Yt=ze([R],Yt),e.ThemeColor=Yt;var ri;(function($){$[$.Global=1]="Global",$[$.Workspace=2]="Workspace",$[$.WorkspaceFolder=3]="WorkspaceFolder"})(ri=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ut=class{constructor(N,ee){if(typeof N!="string"&&(!N||!k.URI.isUri(N)&&!k.URI.isUri(N.uri)))throw(0,y.illegalArgument)("base");if(typeof ee!="string")throw(0,y.illegalArgument)("pattern");typeof N=="string"?this.baseUri=k.URI.file(N):k.URI.isUri(N)?this.baseUri=N:this.baseUri=N.uri,this.pattern=ee}get base(){return this._base}set base(N){this._base=N,this._baseUri=k.URI.file(N)}get baseUri(){return this._baseUri}set baseUri(N){this._baseUri=N,this._base=N.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};ut=ze([R],ut),e.RelativePattern=ut;let Jt=class{constructor(N,ee,we,He){this.enabled=typeof N=="boolean"?N:!0,typeof ee=="string"&&(this.condition=ee),typeof we=="string"&&(this.hitCondition=we),typeof He=="string"&&(this.logMessage=He)}get id(){return this._id||(this._id=(0,F.generateUuid)()),this._id}};Jt=ze([R],Jt),e.Breakpoint=Jt;let zt=class extends Jt{constructor(N,ee,we,He,Ze){if(super(ee,we,He,Ze),N===null)throw(0,y.illegalArgument)("location");this.location=N}};zt=ze([R],zt),e.SourceBreakpoint=zt;let Kt=class extends Jt{constructor(N,ee,we,He,Ze){super(ee,we,He,Ze),this.functionName=N}};Kt=ze([R],Kt),e.FunctionBreakpoint=Kt;let si=class extends Jt{constructor(N,ee,we,He,Ze,lt,ht){if(super(He,Ze,lt,ht),!ee)throw(0,y.illegalArgument)("dataId");this.label=N,this.dataId=ee,this.canPersist=we}};si=ze([R],si),e.DataBreakpoint=si;let pi=class{constructor(N,ee,we){this.command=N,this.args=ee||[],this.options=we}};pi=ze([R],pi),e.DebugAdapterExecutable=pi;let oi=class{constructor(N,ee){this.port=N,this.host=ee}};oi=ze([R],oi),e.DebugAdapterServer=oi;let vi=class{constructor(N){this.path=N}};vi=ze([R],vi),e.DebugAdapterNamedPipeServer=vi;let ai=class{constructor(N){this.implementation=N}};ai=ze([R],ai),e.DebugAdapterInlineImplementation=ai;let Zt=class{constructor(N,ee){this.range=N,this.expression=ee}};Zt=ze([R],Zt),e.EvaluatableExpression=Zt;var Ri;(function($){$[$.Invoke=0]="Invoke",$[$.Automatic=1]="Automatic"})(Ri=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var Ei;(function($){$[$.Invoke=0]="Invoke",$[$.Automatic=1]="Automatic"})(Ei=e.InlineCompletionTriggerKindNew||(e.InlineCompletionTriggerKindNew={}));let ei=class{constructor(N,ee){this.range=N,this.text=ee}};ei=ze([R],ei),e.InlineValueText=ei;let bi=class{constructor(N,ee,we=!0){this.range=N,this.variableName=ee,this.caseSensitiveLookup=we}};bi=ze([R],bi),e.InlineValueVariableLookup=bi;let wi=class{constructor(N,ee){this.range=N,this.expression=ee}};wi=ze([R],wi),e.InlineValueEvaluatableExpression=wi;let Gt=class{constructor(N,ee){this.frameId=N,this.stoppedLocation=ee}};Gt=ze([R],Gt),e.InlineValueContext=Gt;var Oi;(function($){$[$.Changed=1]="Changed",$[$.Created=2]="Created",$[$.Deleted=3]="Deleted"})(Oi=e.FileChangeType||(e.FileChangeType={}));let Si=D=class extends Error{constructor(N,ee=S.FileSystemProviderErrorCode.Unknown,we){super(k.URI.isUri(N)?N.toString(!0):N),this.code=we?.name??"Unknown",(0,S.markAsFileSystemProviderError)(this,ee),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype),typeof Error.captureStackTrace=="function"&&typeof we=="function"&&Error.captureStackTrace(this,we)}static FileExists(N){return new D(N,S.FileSystemProviderErrorCode.FileExists,D.FileExists)}static FileNotFound(N){return new D(N,S.FileSystemProviderErrorCode.FileNotFound,D.FileNotFound)}static FileNotADirectory(N){return new D(N,S.FileSystemProviderErrorCode.FileNotADirectory,D.FileNotADirectory)}static FileIsADirectory(N){return new D(N,S.FileSystemProviderErrorCode.FileIsADirectory,D.FileIsADirectory)}static NoPermissions(N){return new D(N,S.FileSystemProviderErrorCode.NoPermissions,D.NoPermissions)}static Unavailable(N){return new D(N,S.FileSystemProviderErrorCode.Unavailable,D.Unavailable)}};Si=D=ze([R],Si),e.FileSystemError=Si;let _i=class{constructor(N,ee,we){this.start=N,this.end=ee,this.kind=we}};_i=ze([R],_i),e.FoldingRange=_i;var Fi;(function($){$[$.Comment=1]="Comment",$[$.Imports=2]="Imports",$[$.Region=3]="Region"})(Fi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var yi;(function($){$[$.Collapsed=0]="Collapsed",$[$.Expanded=1]="Expanded"})(yi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Ii;(function($){$[$.Editing=0]="Editing",$[$.Preview=1]="Preview"})(Ii=e.CommentMode||(e.CommentMode={}));var Ti;(function($){$[$.Unresolved=0]="Unresolved",$[$.Resolved=1]="Resolved"})(Ti=e.CommentThreadState||(e.CommentThreadState={}));class Me{constructor(N,ee=[]){this.tokenTypes=N,this.tokenModifiers=ee}}e.SemanticTokensLegend=Me;function Vt($){return typeof $>"u"||(0,E.isStringArray)($)}class ci{constructor(N){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,N){this._hasLegend=!0;for(let ee=0,we=N.tokenTypes.length;ee<we;ee++)this._tokenTypeStrToInt.set(N.tokenTypes[ee],ee);for(let ee=0,we=N.tokenModifiers.length;ee<we;ee++)this._tokenModifierStrToInt.set(N.tokenModifiers[ee],ee)}}push(N,ee,we,He,Ze){if(typeof N=="number"&&typeof ee=="number"&&typeof we=="number"&&typeof He=="number"&&(typeof Ze=="number"||typeof Ze>"u"))return typeof Ze>"u"&&(Ze=0),this._pushEncoded(N,ee,we,He,Ze);if(O.isRange(N)&&typeof ee=="string"&&Vt(we))return this._push(N,ee,we);throw(0,y.illegalArgument)()}_push(N,ee,we){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(N.start.line!==N.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ee))throw new Error("`tokenType` is not in the provided legend");const He=N.start.line,Ze=N.start.character,lt=N.end.character-N.start.character,ht=this._tokenTypeStrToInt.get(ee);let At=0;if(we)for(const Bt of we){if(!this._tokenModifierStrToInt.has(Bt))throw new Error("`tokenModifier` is not in the provided legend");const xt=this._tokenModifierStrToInt.get(Bt);At|=1<<xt>>>0}this._pushEncoded(He,Ze,lt,ht,At)}_pushEncoded(N,ee,we,He,Ze){if(this._dataIsSortedAndDeltaEncoded&&(N<this._prevLine||N===this._prevLine&&ee<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const At=this._data.length/5|0;let Bt=0,xt=0;for(let qt=0;qt<At;qt++){let Xt=this._data[5*qt],Di=this._data[5*qt+1];Xt===0?(Xt=Bt,Di+=xt):Xt+=Bt,this._data[5*qt]=Xt,this._data[5*qt+1]=Di,Bt=Xt,xt=Di}}let lt=N,ht=ee;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(lt-=this._prevLine,lt===0&&(ht-=this._prevChar)),this._data[this._dataLen++]=lt,this._data[this._dataLen++]=ht,this._data[this._dataLen++]=we,this._data[this._dataLen++]=He,this._data[this._dataLen++]=Ze,this._prevLine=N,this._prevChar=ee}static _sortAndDeltaEncode(N){const ee=[],we=N.length/5|0;for(let ht=0;ht<we;ht++)ee[ht]=ht;ee.sort((ht,At)=>{const Bt=N[5*ht],xt=N[5*At];if(Bt===xt){const qt=N[5*ht+1],Xt=N[5*At+1];return qt-Xt}return Bt-xt});const He=new Uint32Array(N.length);let Ze=0,lt=0;for(let ht=0;ht<we;ht++){const At=5*ee[ht],Bt=N[At+0],xt=N[At+1],qt=N[At+2],Xt=N[At+3],Di=N[At+4],Qi=Bt-Ze,yn=Qi===0?xt-lt:xt,Ci=5*ht;He[Ci+0]=Qi,He[Ci+1]=yn,He[Ci+2]=qt,He[Ci+3]=Xt,He[Ci+4]=Di,Ze=Bt,lt=xt}return He}build(N){return this._dataIsSortedAndDeltaEncoded?new ft(new Uint32Array(this._data),N):new ft(ci._sortAndDeltaEncode(this._data),N)}}e.SemanticTokensBuilder=ci;class ft{constructor(N,ee){this.resultId=ee,this.data=N}}e.SemanticTokens=ft;class Ni{constructor(N,ee,we){this.start=N,this.deleteCount=ee,this.data=we}}e.SemanticTokensEdit=Ni;class Mi{constructor(N,ee){this.resultId=ee,this.edits=N}}e.SemanticTokensEdits=Mi;var ki;(function($){$[$.Separate=0]="Separate",$[$.MergeWithParent=1]="MergeWithParent"})(ki=e.DebugConsoleMode||(e.DebugConsoleMode={}));let li=class{constructor(){}};li.Back={iconPath:new Ht("arrow-left")},li=ze([R],li),e.QuickInputButtons=li;var ui;(function($){$[$.Separator=-1]="Separator",$[$.Default=0]="Default"})(ui=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Li;(function($){$[$.Info=1]="Info",$[$.Warning=2]="Warning",$[$.Error=3]="Error"})(Li=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Ui;(function($){$[$.UI=1]="UI",$[$.Workspace=2]="Workspace"})(Ui=e.ExtensionKind||(e.ExtensionKind={}));class Bi{constructor(N,ee,we){this.badge=N,this.tooltip=ee,this.color=we}static validate(N){if(N.badge){let ee=(0,A.nextCharLength)(N.badge,0);if(ee<N.badge.length&&(ee+=(0,A.nextCharLength)(N.badge,ee)),N.badge.length>ee)throw new Error("The 'badge'-property must be undefined or a short character")}if(!N.color&&!N.badge&&!N.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Bi;let di=class{constructor(N){this.kind=N}};di=ze([R],di),e.ColorTheme=di;var zi;(function($){$[$.Light=1]="Light",$[$.Dark=2]="Dark",$[$.HighContrast=3]="HighContrast",$[$.HighContrastLight=4]="HighContrastLight"})(zi=e.ColorThemeKind||(e.ColorThemeKind={}));class jt{constructor(N,ee){if(N<0)throw(0,y.illegalArgument)("start must be positive");if(ee<0)throw(0,y.illegalArgument)("end must be positive");N<=ee?(this._start=N,this._end=ee):(this._start=ee,this._end=N)}static isNotebookRange(N){return N instanceof jt?!0:N?typeof N.start=="number"&&typeof N.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(N){let ee=this._start,we=this._end;return N.start!==void 0&&(ee=N.start),N.end!==void 0&&(we=N.end),ee===this._start&&we===this._end?this:new jt(ee,we)}}e.NotebookRange=jt;class hi{constructor(N,ee,we,He,Ze,lt,ht){this.kind=N,this.value=ee,this.languageId=we,this.mime=He,this.outputs=Ze??[],this.metadata=lt,this.executionSummary=ht,hi.validate(this)}static validate(N){if(typeof N.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof N.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof N.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(N){return Array.isArray(N)&&N.every(ee=>hi.isNotebookCellData(ee))}static isNotebookCellData(N){return!0}}e.NotebookCellData=hi;class xi{constructor(N){this.cells=N}}e.NotebookData=xi;class Lt{constructor(N,ee){this.data=N,this.mime=ee;const we=(0,_.normalizeMimeType)(ee,!0);if(!we)throw new Error(`INVALID mime type: ${ee}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=we}static isNotebookCellOutputItem(N){return N instanceof Lt?!0:N?typeof N.mime=="string"&&N.data instanceof Uint8Array:!1}static error(N){const ee={name:N.name,message:N.message,stack:N.stack};return Lt.json(ee,"application/vnd.code.notebook.error")}static stdout(N){return Lt.text(N,"application/vnd.code.notebook.stdout")}static stderr(N){return Lt.text(N,"application/vnd.code.notebook.stderr")}static bytes(N,ee="application/octet-stream"){return new Lt(N,ee)}static text(N,ee=_.Mimes.text){const we=Oe(Lt,v,"f",I).encode(String(N));return new Lt(we,ee)}static json(N,ee="text/x-json"){const we=JSON.stringify(N,void 0,"	");return Lt.text(we,ee)}}e.NotebookCellOutputItem=Lt,v=Lt,I={value:new TextEncoder};class re{constructor(N,ee,we){this.items=re.ensureUniqueMimeTypes(N,!0),typeof ee=="string"?(this.id=ee,this.metadata=we):(this.id=(0,F.generateUuid)(),this.metadata=ee??we)}static isNotebookCellOutput(N){return N instanceof re?!0:!N||typeof N!="object"?!1:typeof N.id=="string"&&Array.isArray(N.items)}static ensureUniqueMimeTypes(N,ee=!1){const we=new Set,He=new Set;for(let Ze=0;Ze<N.length;Ze++){const lt=N[Ze],ht=(0,_.normalizeMimeType)(lt.mime);if(!we.has(ht)||(0,T.isTextStreamMime)(ht)){we.add(ht);continue}He.add(Ze),ee&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return He.size===0?N:N.filter((Ze,lt)=>!He.has(lt))}}e.NotebookCellOutput=re;var he;(function($){$[$.Markup=1]="Markup",$[$.Code=2]="Code"})(he=e.NotebookCellKind||(e.NotebookCellKind={}));var Re;(function($){$[$.Idle=1]="Idle",$[$.Pending=2]="Pending",$[$.Executing=3]="Executing"})(Re=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ot;(function($){$[$.Left=1]="Left",$[$.Right=2]="Right"})(ot=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var St;(function($){$[$.Default=0]="Default",$[$.InCenter=1]="InCenter",$[$.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",$[$.AtTop=3]="AtTop"})(St=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Pt{constructor(N,ee){this.text=N,this.alignment=ee}}e.NotebookCellStatusBarItem=Pt;var en;(function($){$[$.Default=1]="Default",$[$.Preferred=2]="Preferred"})(en=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class tn{constructor(N,ee=[]){this.uri=N,this.provides=(0,r.asArray)(ee)}}e.NotebookRendererScript=tn;let $i=class{constructor(N,ee){this.label=N,this.timestamp=ee}};$i=ze([R],$i),e.TimelineItem=$i;var nn;(function($){$[$.Production=1]="Production",$[$.Development=2]="Development",$[$.Test=3]="Test"})(nn=e.ExtensionMode||(e.ExtensionMode={}));var rn;(function($){$[$.Node=1]="Node",$[$.Webworker=2]="Webworker"})(rn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var sn;(function($){$[$.Other=0]="Other",$[$.Comment=1]="Comment",$[$.String=2]="String",$[$.RegEx=3]="RegEx"})(sn=e.StandardTokenType||(e.StandardTokenType={}));class on{constructor(N,ee){this.ranges=N,this.wordPattern=ee}}e.LinkedEditingRanges=on;class an{constructor(N,ee){this._port=N,this._autoForwardAction=ee}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=an;var cn;(function($){$[$.Queued=1]="Queued",$[$.Running=2]="Running",$[$.Passed=3]="Passed",$[$.Failed=4]="Failed",$[$.Skipped=5]="Skipped",$[$.Errored=6]="Errored"})(cn=e.TestResultState||(e.TestResultState={}));var ln;(function($){$[$.Run=1]="Run",$[$.Debug=2]="Debug",$[$.Coverage=3]="Coverage"})(ln=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Wi=class{constructor(N=void 0,ee=void 0,we=void 0){this.include=N,this.exclude=ee,this.profile=we}};Wi=ze([R],Wi),e.TestRunRequest=Wi;let Hi=x=class{constructor(N){this.message=N}static diff(N,ee,we){const He=new x(N);return He.expectedOutput=ee,He.actualOutput=we,He}};Hi=x=ze([R],Hi),e.TestMessage=Hi;let Vi=class{constructor(N){this.id=N}};Vi=ze([R],Vi),e.TestTag=Vi;let fi=class{constructor(N,ee){this.covered=N,this.total=ee}};fi=ze([R],fi),e.CoveredCount=fi;let ji=U=class{constructor(N,ee,we,He){this.uri=N,this.statementCoverage=ee,this.branchCoverage=we,this.functionCoverage=He}static fromDetails(N,ee){const we=new fi(0,0),He=new fi(0,0),Ze=new fi(0,0);for(const ht of ee)if("branches"in ht){we.total+=1,we.covered+=ht.executionCount>0?1:0;for(const At of ht.branches)He.total+=1,He.covered+=At.executionCount>0?1:0}else Ze.total+=1,Ze.covered+=ht.executionCount>0?1:0;const lt=new U(N,we,He.total>0?He:void 0,Ze.total>0?Ze:void 0);return lt.detailedCoverage=ee,lt}};ji=U=ze([R],ji),e.FileCoverage=ji;let qi=class{constructor(N,ee,we=[]){this.executionCount=N,this.location=ee,this.branches=we}};qi=ze([R],qi),e.StatementCoverage=qi;let Ki=class{constructor(N,ee){this.executionCount=N,this.location=ee}};Ki=ze([R],Ki),e.BranchCoverage=Ki;let Gi=class{constructor(N,ee){this.executionCount=N,this.location=ee}};Gi=ze([R],Gi),e.FunctionCoverage=Gi;var un;(function($){$[$.None=0]="None",$[$.Option=1]="Option",$[$.Default=2]="Default",$[$.Preferred=3]="Preferred"})(un=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var dn;(function($){$[$.Untrusted=0]="Untrusted",$[$.Trusted=1]="Trusted",$[$.Unspecified=2]="Unspecified"})(dn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var hn;(function($){$[$.Notify=1]="Notify",$[$.OpenBrowser=2]="OpenBrowser",$[$.OpenPreview=3]="OpenPreview",$[$.Silent=4]="Silent",$[$.Ignore=5]="Ignore",$[$.OpenBrowserOnce=6]="OpenBrowserOnce"})(hn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class fn{constructor(N,ee,we,He,Ze,lt){this.kind=N,this.name=ee,this.detail=we,this.uri=He,this.range=Ze,this.selectionRange=lt}}e.TypeHierarchyItem=fn;class mn{constructor(N){this.uri=N}}e.TextTabInput=mn;class gn{constructor(N,ee){this.original=N,this.modified=ee}}e.TextDiffTabInput=gn;class pn{constructor(N,ee,we,He){this.base=N,this.input1=ee,this.input2=we,this.result=He}}e.TextMergeTabInput=pn;class vn{constructor(N,ee){this.uri=N,this.viewType=ee}}e.CustomEditorTabInput=vn;class En{constructor(N){this.viewType=N}}e.WebviewEditorTabInput=En;class bn{constructor(N,ee){this.uri=N,this.notebookType=ee}}e.NotebookEditorTabInput=bn;class wn{constructor(N,ee,we){this.original=N,this.modified=ee,this.notebookType=we}}e.NotebookDiffEditorTabInput=wn;class Sn{constructor(){}}e.TerminalEditorTabInput=Sn;class _n{constructor(N,ee){this.uri=N,this.inputBoxUri=ee}}e.InteractiveWindowInput=_n}),define(Ce[92],Ie([1,0,44,12,9,240,122,6,16]),function(te,e,r,y,w,L,_,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const k=new Map;function F(f,c){c?k.set(f,c):k.delete(f)}e.setWordDefinitionFor=F;function S(f){return k.get(f)}e.getWordDefinitionFor=S;class m extends L.MirrorTextModel{constructor(c,h,u,v,I,l,b,t){super(h,u,v,I),this._proxy=c,this._languageId=l,this._isDirty=b,this.notebook=t,this._isDisposed=!1}dispose(){(0,r.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(c){return(0,E.equals)(this._lines,c)}get document(){if(!this._document){const c=this;this._document={get uri(){return c._uri},get fileName(){return c._uri.fsPath},get isUntitled(){return c._uri.scheme===y.Schemas.untitled},get languageId(){return c._languageId},get version(){return c._versionId},get isClosed(){return c._isDisposed},get isDirty(){return c._isDirty},save(){return c._save()},getText(h){return h?c._getTextInRange(h):c.getText()},get eol(){return c._eol===`
`?A.EndOfLine.LF:A.EndOfLine.CRLF},get lineCount(){return c._lines.length},lineAt(h){return c._lineAt(h)},offsetAt(h){return c._offsetAt(h)},positionAt(h){return c._positionAt(h)},validateRange(h){return c._validateRange(h)},validatePosition(h){return c._validatePosition(h)},getWordRangeAtPosition(h,u){return c._getWordRangeAtPosition(h,u)}}}return Object.freeze(this._document)}_acceptLanguageId(c){(0,r.ok)(!this._isDisposed),this._languageId=c}_acceptIsDirty(c){(0,r.ok)(!this._isDisposed),this._isDirty=c}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(c){const h=this._validateRange(c);if(h.isEmpty)return"";if(h.isSingleLine)return this._lines[h.start.line].substring(h.start.character,h.end.character);const u=this._eol,v=h.start.line,I=h.end.line,l=[];l.push(this._lines[v].substring(h.start.character));for(let b=v+1;b<I;b++)l.push(this._lines[b]);return l.push(this._lines[I].substring(0,h.end.character)),l.join(u)}_lineAt(c){let h;if(c instanceof A.Position?h=c.line:typeof c=="number"&&(h=c),typeof h!="number"||h<0||h>=this._lines.length||Math.floor(h)!==h)throw new Error("Illegal value for `line`");return new T(h,this._lines[h],h===this._lines.length-1)}_offsetAt(c){return c=this._validatePosition(c),this._ensureLineStarts(),this._lineStarts.getPrefixSum(c.line-1)+c.character}_positionAt(c){c=Math.floor(c),c=Math.max(0,c),this._ensureLineStarts();const h=this._lineStarts.getIndexOf(c),u=this._lines[h.index].length;return new A.Position(h.index,Math.min(h.remainder,u))}_validateRange(c){if(!(c instanceof A.Range))throw new Error("Invalid argument");const h=this._validatePosition(c.start),u=this._validatePosition(c.end);return h===c.start&&u===c.end?c:new A.Range(h.line,h.character,u.line,u.character)}_validatePosition(c){if(!(c instanceof A.Position))throw new Error("Invalid argument");if(this._lines.length===0)return c.with(0,0);let{line:h,character:u}=c,v=!1;if(h<0)h=0,u=0,v=!0;else if(h>=this._lines.length)h=this._lines.length-1,u=this._lines[h].length,v=!0;else{const I=this._lines[h].length;u<0?(u=0,v=!0):u>I&&(u=I,v=!0)}return v?new A.Position(h,u):c}_getWordRangeAtPosition(c,h){const u=this._validatePosition(c);if(!h)h=S(this._languageId);else if((0,w.regExpLeadsToEndlessLoop)(h))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${h.source}' because it matches the empty string.`);const v=(0,_.getWordAtText)(u.character+1,(0,_.ensureValidWordDefinition)(h),this._lines[u.line],0);if(v)return new A.Range(u.line,v.startColumn-1,u.line,v.endColumn-1)}}e.ExtHostDocumentData=m;class T{constructor(c,h,u){this._line=c,this._text=h,this._isLastLine=u}get lineNumber(){return this._line}get text(){return this._text}get range(){return new A.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new A.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=T}),define(Ce[175],Ie([1,0,6,13,5]),function(te,e,r,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let L=class{constructor(A){this._actual=new r.ColorTheme(r.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new w.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(A){let E;switch(A){case"light":E=r.ColorThemeKind.Light;break;case"hcDark":E=r.ColorThemeKind.HighContrast;break;case"hcLight":E=r.ColorThemeKind.HighContrastLight;break;default:E=r.ColorThemeKind.Dark}this._actual=new r.ColorTheme(E),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};L=ze([xe(0,y.IExtHostRpcService)],L),e.ExtHostTheming=L}),define(Ce[8],Ie([1,0,16,23,76,25,106,75,26,10,2,49,66,81,89,88,64,47,48,170,6,176]),function(te,e,r,y,w,L,_,A,E,k,F,S,m,T,f,c,h,u,v,I,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var t;(function(Se){function De(q){const{selectionStartLineNumber:Ae,selectionStartColumn:Le,positionLineNumber:tt,positionColumn:Ge}=q,Ke=new l.Position(Ae-1,Le-1),ct=new l.Position(tt-1,Ge-1);return new l.Selection(Ke,ct)}Se.to=De;function me(q){const{anchor:Ae,active:Le}=q;return{selectionStartLineNumber:Ae.line+1,selectionStartColumn:Ae.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}Se.from=me})(t=e.Selection||(e.Selection={}));var d;(function(Se){function De(q){if(!q)return;const{start:Ae,end:Le}=q;return{startLineNumber:Ae.line+1,startColumn:Ae.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}Se.from=De;function me(q){if(!q)return;const{startLineNumber:Ae,startColumn:Le,endLineNumber:tt,endColumn:Ge}=q;return new l.Range(Ae-1,Le-1,tt-1,Ge-1)}Se.to=me})(d=e.Range||(e.Range={}));var n;(function(Se){function De(me){switch(me){case 1:return l.StandardTokenType.Comment;case 0:return l.StandardTokenType.Other;case 3:return l.StandardTokenType.RegEx;case 2:return l.StandardTokenType.String}}Se.to=De})(n=e.TokenType||(e.TokenType={}));var i;(function(Se){function De(q){return new l.Position(q.lineNumber-1,q.column-1)}Se.to=De;function me(q){return{lineNumber:q.line+1,column:q.character+1}}Se.from=me})(i=e.Position||(e.Position={}));var s;(function(Se){function De(Ae,Le){return(0,r.coalesce)((0,r.asArray)(Ae).map(tt=>me(tt,Le)))}Se.from=De;function me(Ae,Le){if(typeof Ae=="string")return{$serialized:!0,language:Ae};if(Ae)return{$serialized:!0,language:Ae.language,scheme:q(Ae.scheme,Le),pattern:fe.from(Ae.pattern)??void 0,exclusive:Ae.exclusive,notebookType:Ae.notebookType}}function q(Ae,Le){return Le&&typeof Ae=="string"?Le.transformOutgoingScheme(Ae):Ae}})(s=e.DocumentSelector||(e.DocumentSelector={}));var a;(function(Se){function De(q){switch(q){case l.DiagnosticTag.Unnecessary:return 1;case l.DiagnosticTag.Deprecated:return 2}}Se.from=De;function me(q){switch(q){case 1:return l.DiagnosticTag.Unnecessary;case 2:return l.DiagnosticTag.Deprecated;default:return}}Se.to=me})(a=e.DiagnosticTag||(e.DiagnosticTag={}));var o;(function(Se){function De(q){let Ae;return q.code&&((0,k.isString)(q.code)||(0,k.isNumber)(q.code)?Ae=String(q.code):Ae={value:String(q.code.value),target:q.code.target}),{...d.from(q.range),message:q.message,source:q.source,code:Ae,severity:p.from(q.severity),relatedInformation:q.relatedInformation&&q.relatedInformation.map(g.from),tags:Array.isArray(q.tags)?(0,r.coalesce)(q.tags.map(a.from)):void 0}}Se.from=De;function me(q){const Ae=new l.Diagnostic(d.to(q),q.message,p.to(q.severity));return Ae.source=q.source,Ae.code=(0,k.isString)(q.code)?q.code:q.code?.value,Ae.relatedInformation=q.relatedInformation&&q.relatedInformation.map(g.to),Ae.tags=q.tags&&(0,r.coalesce)(q.tags.map(a.to)),Ae}Se.to=me})(o=e.Diagnostic||(e.Diagnostic={}));var g;(function(Se){function De(q){return{...d.from(q.location.range),message:q.message,resource:q.location.uri}}Se.from=De;function me(q){return new l.DiagnosticRelatedInformation(new l.Location(q.resource,d.to(q)),q.message)}Se.to=me})(g=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var p;(function(Se){function De(q){switch(q){case l.DiagnosticSeverity.Error:return T.MarkerSeverity.Error;case l.DiagnosticSeverity.Warning:return T.MarkerSeverity.Warning;case l.DiagnosticSeverity.Information:return T.MarkerSeverity.Info;case l.DiagnosticSeverity.Hint:return T.MarkerSeverity.Hint}return T.MarkerSeverity.Error}Se.from=De;function me(q){switch(q){case T.MarkerSeverity.Info:return l.DiagnosticSeverity.Information;case T.MarkerSeverity.Warning:return l.DiagnosticSeverity.Warning;case T.MarkerSeverity.Error:return l.DiagnosticSeverity.Error;case T.MarkerSeverity.Hint:return l.DiagnosticSeverity.Hint;default:return l.DiagnosticSeverity.Error}}Se.to=me})(p=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var P;(function(Se){function De(q){return typeof q=="number"&&q>=l.ViewColumn.One?q-1:q===l.ViewColumn.Beside?I.SIDE_GROUP:I.ACTIVE_GROUP}Se.from=De;function me(q){if(typeof q=="number"&&q>=0)return q+1;throw new Error("invalid 'EditorGroupColumn'")}Se.to=me})(P=e.ViewColumn||(e.ViewColumn={}));function M(Se){return typeof Se.range<"u"}function V(Se){return Se.length===0?!0:!!M(Se[0])}e.isDecorationOptionsArr=V;var B;(function(Se){function De(Ge){return Ge.map(Se.from)}Se.fromMany=De;function me(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function q(Ge){let Ke;if(me(Ge)){const{language:It,value:bt}=Ge;Ke={value:"```"+It+`
`+bt+"\n```\n"}}else l.MarkdownString.isMarkdownString(Ge)?Ke={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml,baseUri:Ge.baseUri}:typeof Ge=="string"?Ke={value:Ge}:Ke={value:""};const ct=Object.create(null);Ke.uris=ct;const Ct=It=>{try{let bt=F.URI.parse(It,!0);bt=bt.with({query:Ae(bt.query,ct)}),ct[It]=bt}catch{}return""},pt=new _.marked.Renderer;return pt.link=Ct,pt.image=It=>typeof It=="string"?Ct(w.parseHrefAndDimensions(It).href):"",(0,_.marked)(Ke.value,{renderer:pt}),Ke}Se.from=q;function Ae(Ge,Ke){if(!Ge)return Ge;let ct;try{ct=(0,A.parse)(Ge)}catch{}if(!ct)return Ge;let Ct=!1;return ct=(0,E.cloneAndChange)(ct,pt=>{if(F.URI.isUri(pt)){const It=`__uri_${Math.random().toString(16).slice(2,8)}`;return Ke[It]=pt,Ct=!0,It}else return}),Ct?JSON.stringify(ct):Ge}function Le(Ge){const Ke=new l.MarkdownString(Ge.value,Ge.supportThemeIcons);return Ke.isTrusted=Ge.isTrusted,Ke.supportHtml=Ge.supportHtml,Ke.baseUri=Ge.baseUri?F.URI.from(Ge.baseUri):void 0,Ke}Se.to=Le;function tt(Ge){if(!!Ge)return typeof Ge=="string"?Ge:Se.from(Ge)}Se.fromStrict=tt})(B=e.MarkdownString||(e.MarkdownString={}));function D(Se){return V(Se)?Se.map(De=>({range:d.from(De.range),hoverMessage:Array.isArray(De.hoverMessage)?B.fromMany(De.hoverMessage):De.hoverMessage?B.from(De.hoverMessage):void 0,renderOptions:De.renderOptions})):Se.map(De=>({range:d.from(De)}))}e.fromRangeOrRangeWithMessage=D;function x(Se){return typeof Se>"u"?Se:typeof Se=="string"?F.URI.file(Se):Se}e.pathOrURIToURI=x;var U;(function(Se){function De(me){return typeof me>"u"?me:{contentText:me.contentText,contentIconPath:me.contentIconPath?x(me.contentIconPath):void 0,border:me.border,borderColor:me.borderColor,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,color:me.color,backgroundColor:me.backgroundColor,margin:me.margin,width:me.width,height:me.height}}Se.from=De})(U=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var R;(function(Se){function De(me){return typeof me>"u"?me:{backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?x(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?U.from(me.before):void 0,after:me.after?U.from(me.after):void 0}}Se.from=De})(R=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var K;(function(Se){function De(me){if(typeof me>"u")return me;switch(me){case l.DecorationRangeBehavior.OpenOpen:return 0;case l.DecorationRangeBehavior.ClosedClosed:return 1;case l.DecorationRangeBehavior.OpenClosed:return 2;case l.DecorationRangeBehavior.ClosedOpen:return 3}}Se.from=De})(K=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var W;(function(Se){function De(me){return{isWholeLine:me.isWholeLine,rangeBehavior:me.rangeBehavior?K.from(me.rangeBehavior):void 0,overviewRulerLane:me.overviewRulerLane,light:me.light?R.from(me.light):void 0,dark:me.dark?R.from(me.dark):void 0,backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?x(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?U.from(me.before):void 0,after:me.after?U.from(me.after):void 0}}Se.from=De})(W=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var O;(function(Se){function De(q){return{text:q.newText,eol:q.newEol&&Xe.from(q.newEol),range:d.from(q.range)}}Se.from=De;function me(q){const Ae=new l.TextEdit(d.to(q.range),q.text);return Ae.newEol=typeof q.eol>"u"?void 0:Xe.to(q.eol),Ae}Se.to=me})(O=e.TextEdit||(e.TextEdit={}));var Z;(function(Se){function De(q,Ae,Le){const tt={edits:[]};if(q instanceof l.WorkspaceEdit){const Ge=new L.ResourceSet;for(const Ke of q._allEntries())Ke._type===1&&F.URI.isUri(Ke.to)&&Ke.from===void 0&&Ge.add(Ke.to);for(const Ke of q._allEntries())if(Ke._type===1)tt.edits.push({oldResource:Ke.from,newResource:Ke.to,options:{...Ke.options,contentsBase64:Ke.options?.contents&&(0,y.encodeBase64)(y.VSBuffer.wrap(Ke.options.contents))},metadata:Ke.metadata});else if(Ke._type===2)tt.edits.push({resource:Ke.uri,textEdit:O.from(Ke.edit),versionId:Ge.has(Ke.uri)?void 0:Ae?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata});else if(Ke._type===6){if(!Le){console.warn("DROPPING snippet text edit because proposal IS NOT ENABLED",Ke);continue}tt.edits.push({resource:Ke.uri,textEdit:{range:d.from(Ke.range),text:Ke.edit.value,insertAsSnippet:!0},versionId:Ge.has(Ke.uri)?void 0:Ae?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata})}else Ke._type===3?tt.edits.push({metadata:Ke.metadata,resource:Ke.uri,cellEdit:Ke.edit,notebookMetadata:Ke.notebookMetadata,notebookVersionId:Ae?.getNotebookDocumentVersion(Ke.uri)}):Ke._type===5&&tt.edits.push({metadata:Ke.metadata,resource:Ke.uri,notebookVersionId:Ae?.getNotebookDocumentVersion(Ke.uri),cellEdit:{editType:1,index:Ke.index,count:Ke.count,cells:Ke.cells.map(st.from)}})}return tt}Se.from=De;function me(q){const Ae=new l.WorkspaceEdit;for(const Le of q.edits)Le.textEdit?Ae.replace(F.URI.revive(Le.resource),d.to(Le.textEdit.range),Le.textEdit.text):Ae.renameFile(F.URI.revive(Le.oldResource),F.URI.revive(Le.newResource),Le.options);return Ae}Se.to=me})(Z=e.WorkspaceEdit||(e.WorkspaceEdit={}));var ue;(function(Se){const De=Object.create(null);De[l.SymbolKind.File]=0,De[l.SymbolKind.Module]=1,De[l.SymbolKind.Namespace]=2,De[l.SymbolKind.Package]=3,De[l.SymbolKind.Class]=4,De[l.SymbolKind.Method]=5,De[l.SymbolKind.Property]=6,De[l.SymbolKind.Field]=7,De[l.SymbolKind.Constructor]=8,De[l.SymbolKind.Enum]=9,De[l.SymbolKind.Interface]=10,De[l.SymbolKind.Function]=11,De[l.SymbolKind.Variable]=12,De[l.SymbolKind.Constant]=13,De[l.SymbolKind.String]=14,De[l.SymbolKind.Number]=15,De[l.SymbolKind.Boolean]=16,De[l.SymbolKind.Array]=17,De[l.SymbolKind.Object]=18,De[l.SymbolKind.Key]=19,De[l.SymbolKind.Null]=20,De[l.SymbolKind.EnumMember]=21,De[l.SymbolKind.Struct]=22,De[l.SymbolKind.Event]=23,De[l.SymbolKind.Operator]=24,De[l.SymbolKind.TypeParameter]=25;function me(Ae){return typeof De[Ae]=="number"?De[Ae]:6}Se.from=me;function q(Ae){for(const Le in De)if(De[Le]===Ae)return Number(Le);return l.SymbolKind.Property}Se.to=q})(ue=e.SymbolKind||(e.SymbolKind={}));var oe;(function(Se){function De(q){switch(q){case l.SymbolTag.Deprecated:return 1}}Se.from=De;function me(q){switch(q){case 1:return l.SymbolTag.Deprecated}}Se.to=me})(oe=e.SymbolTag||(e.SymbolTag={}));var de;(function(Se){function De(q){return{name:q.name,kind:ue.from(q.kind),tags:q.tags&&q.tags.map(oe.from),containerName:q.containerName,location:Ee.from(q.location)}}Se.from=De;function me(q){const Ae=new l.SymbolInformation(q.name,ue.to(q.kind),q.containerName,Ee.to(q.location));return Ae.tags=q.tags&&q.tags.map(oe.to),Ae}Se.to=me})(de=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var ie;(function(Se){function De(q){const Ae={name:q.name||"!!MISSING: name!!",detail:q.detail,range:d.from(q.range),selectionRange:d.from(q.selectionRange),kind:ue.from(q.kind),tags:q.tags?.map(oe.from)??[]};return q.children&&(Ae.children=q.children.map(De)),Ae}Se.from=De;function me(q){const Ae=new l.DocumentSymbol(q.name,q.detail,ue.to(q.kind),d.to(q.range),d.to(q.selectionRange));return(0,r.isNonEmptyArray)(q.tags)&&(Ae.tags=q.tags.map(oe.to)),q.children&&(Ae.children=q.children.map(me)),Ae}Se.to=me})(ie=e.DocumentSymbol||(e.DocumentSymbol={}));var ve;(function(Se){function De(q){const Ae=new l.CallHierarchyItem(ue.to(q.kind),q.name,q.detail||"",F.URI.revive(q.uri),d.to(q.range),d.to(q.selectionRange));return Ae._sessionId=q._sessionId,Ae._itemId=q._itemId,Ae}Se.to=De;function me(q,Ae,Le){if(Ae=Ae??q._sessionId,Le=Le??q._itemId,Ae===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Le,name:q.name,detail:q.detail,kind:ue.from(q.kind),uri:q.uri,range:d.from(q.range),selectionRange:d.from(q.selectionRange),tags:q.tags?.map(oe.from)}}Se.from=me})(ve=e.CallHierarchyItem||(e.CallHierarchyItem={}));var be;(function(Se){function De(me){return new l.CallHierarchyIncomingCall(ve.to(me.from),me.fromRanges.map(q=>d.to(q)))}Se.to=De})(be=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ne;(function(Se){function De(me){return new l.CallHierarchyOutgoingCall(ve.to(me.to),me.fromRanges.map(q=>d.to(q)))}Se.to=De})(ne=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Ee;(function(Se){function De(q){return{range:q.range&&d.from(q.range),uri:q.uri}}Se.from=De;function me(q){return new l.Location(F.URI.revive(q.uri),d.to(q.range))}Se.to=me})(Ee=e.location||(e.location={}));var Pe;(function(Se){function De(q){const Ae=q,Le=q;return{originSelectionRange:Ae.originSelectionRange?d.from(Ae.originSelectionRange):void 0,uri:Ae.targetUri?Ae.targetUri:Le.uri,range:d.from(Ae.targetRange?Ae.targetRange:Le.range),targetSelectionRange:Ae.targetSelectionRange?d.from(Ae.targetSelectionRange):void 0}}Se.from=De;function me(q){return{targetUri:F.URI.revive(q.uri),targetRange:d.to(q.range),targetSelectionRange:q.targetSelectionRange?d.to(q.targetSelectionRange):void 0,originSelectionRange:q.originSelectionRange?d.to(q.originSelectionRange):void 0}}Se.to=me})(Pe=e.DefinitionLink||(e.DefinitionLink={}));var Fe;(function(Se){function De(q){return{range:d.from(q.range),contents:B.fromMany(q.contents)}}Se.from=De;function me(q){return new l.Hover(q.contents.map(B.to),d.to(q.range))}Se.to=me})(Fe=e.Hover||(e.Hover={}));var $e;(function(Se){function De(q){return{range:d.from(q.range),expression:q.expression}}Se.from=De;function me(q){return new l.EvaluatableExpression(d.to(q.range),q.expression)}Se.to=me})($e=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Qe;(function(Se){function De(q){if(q instanceof l.InlineValueText)return{type:"text",range:d.from(q.range),text:q.text};if(q instanceof l.InlineValueVariableLookup)return{type:"variable",range:d.from(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};if(q instanceof l.InlineValueEvaluatableExpression)return{type:"expression",range:d.from(q.range),expression:q.expression};throw new Error("Unknown 'InlineValue' type")}Se.from=De;function me(q){switch(q.type){case"text":return{range:d.to(q.range),text:q.text};case"variable":return{range:d.to(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};case"expression":return{range:d.to(q.range),expression:q.expression}}}Se.to=me})(Qe=e.InlineValue||(e.InlineValue={}));var Te;(function(Se){function De(q){return{frameId:q.frameId,stoppedLocation:d.from(q.stoppedLocation)}}Se.from=De;function me(q){return new l.InlineValueContext(q.frameId,d.to(q.stoppedLocation))}Se.to=me})(Te=e.InlineValueContext||(e.InlineValueContext={}));var _e;(function(Se){function De(q){return{range:d.from(q.range),kind:q.kind}}Se.from=De;function me(q){return new l.DocumentHighlight(d.to(q.range),q.kind)}Se.to=me})(_e=e.DocumentHighlight||(e.DocumentHighlight={}));var ye;(function(Se){function De(me){switch(me){case 1:return l.CompletionTriggerKind.TriggerCharacter;case 2:return l.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return l.CompletionTriggerKind.Invoke}}Se.to=De})(ye=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ae;(function(Se){function De(me){return{triggerKind:ye.to(me.triggerKind),triggerCharacter:me.triggerCharacter}}Se.to=De})(ae=e.CompletionContext||(e.CompletionContext={}));var le;(function(Se){function De(q){switch(q){case l.CompletionItemTag.Deprecated:return 1}}Se.from=De;function me(q){switch(q){case 1:return l.CompletionItemTag.Deprecated}}Se.to=me})(le=e.CompletionItemTag||(e.CompletionItemTag={}));var Q;(function(Se){const De=new Map([[l.CompletionItemKind.Method,0],[l.CompletionItemKind.Function,1],[l.CompletionItemKind.Constructor,2],[l.CompletionItemKind.Field,3],[l.CompletionItemKind.Variable,4],[l.CompletionItemKind.Class,5],[l.CompletionItemKind.Interface,7],[l.CompletionItemKind.Struct,6],[l.CompletionItemKind.Module,8],[l.CompletionItemKind.Property,9],[l.CompletionItemKind.Unit,12],[l.CompletionItemKind.Value,13],[l.CompletionItemKind.Constant,14],[l.CompletionItemKind.Enum,15],[l.CompletionItemKind.EnumMember,16],[l.CompletionItemKind.Keyword,17],[l.CompletionItemKind.Snippet,27],[l.CompletionItemKind.Text,18],[l.CompletionItemKind.Color,19],[l.CompletionItemKind.File,20],[l.CompletionItemKind.Reference,21],[l.CompletionItemKind.Folder,23],[l.CompletionItemKind.Event,10],[l.CompletionItemKind.Operator,11],[l.CompletionItemKind.TypeParameter,24],[l.CompletionItemKind.Issue,26],[l.CompletionItemKind.User,25]]);function me(Le){return De.get(Le)??9}Se.from=me;const q=new Map([[0,l.CompletionItemKind.Method],[1,l.CompletionItemKind.Function],[2,l.CompletionItemKind.Constructor],[3,l.CompletionItemKind.Field],[4,l.CompletionItemKind.Variable],[5,l.CompletionItemKind.Class],[7,l.CompletionItemKind.Interface],[6,l.CompletionItemKind.Struct],[8,l.CompletionItemKind.Module],[9,l.CompletionItemKind.Property],[12,l.CompletionItemKind.Unit],[13,l.CompletionItemKind.Value],[14,l.CompletionItemKind.Constant],[15,l.CompletionItemKind.Enum],[16,l.CompletionItemKind.EnumMember],[17,l.CompletionItemKind.Keyword],[27,l.CompletionItemKind.Snippet],[18,l.CompletionItemKind.Text],[19,l.CompletionItemKind.Color],[20,l.CompletionItemKind.File],[21,l.CompletionItemKind.Reference],[23,l.CompletionItemKind.Folder],[10,l.CompletionItemKind.Event],[11,l.CompletionItemKind.Operator],[24,l.CompletionItemKind.TypeParameter],[25,l.CompletionItemKind.User],[26,l.CompletionItemKind.Issue]]);function Ae(Le){return q.get(Le)??l.CompletionItemKind.Property}Se.to=Ae})(Q=e.CompletionItemKind||(e.CompletionItemKind={}));var J;(function(Se){function De(me,q){const Ae=new l.CompletionItem(me.label);return Ae.insertText=me.insertText,Ae.kind=Q.to(me.kind),Ae.tags=me.tags?.map(le.to),Ae.detail=me.detail,Ae.documentation=w.isMarkdownString(me.documentation)?B.to(me.documentation):me.documentation,Ae.sortText=me.sortText,Ae.filterText=me.filterText,Ae.preselect=me.preselect,Ae.commitCharacters=me.commitCharacters,S.Range.isIRange(me.range)?Ae.range=d.to(me.range):typeof me.range=="object"&&(Ae.range={inserting:d.to(me.range.insert),replacing:d.to(me.range.replace)}),Ae.keepWhitespace=typeof me.insertTextRules>"u"?!1:Boolean(me.insertTextRules&1),typeof me.insertTextRules<"u"&&me.insertTextRules&4?Ae.insertText=new l.SnippetString(me.insertText):(Ae.insertText=me.insertText,Ae.textEdit=Ae.range instanceof l.Range?new l.TextEdit(Ae.range,Ae.insertText):void 0),me.additionalTextEdits&&me.additionalTextEdits.length>0&&(Ae.additionalTextEdits=me.additionalTextEdits.map(Le=>O.to(Le))),Ae.command=q&&me.command?q.fromInternal(me.command):void 0,Ae}Se.to=De})(J=e.CompletionItem||(e.CompletionItem={}));var C;(function(Se){function De(q){return{label:q.label,documentation:B.fromStrict(q.documentation)}}Se.from=De;function me(q){return{label:q.label,documentation:w.isMarkdownString(q.documentation)?B.to(q.documentation):q.documentation}}Se.to=me})(C=e.ParameterInformation||(e.ParameterInformation={}));var z;(function(Se){function De(q){return{label:q.label,documentation:B.fromStrict(q.documentation),parameters:Array.isArray(q.parameters)?q.parameters.map(C.from):[],activeParameter:q.activeParameter}}Se.from=De;function me(q){return{label:q.label,documentation:w.isMarkdownString(q.documentation)?B.to(q.documentation):q.documentation,parameters:Array.isArray(q.parameters)?q.parameters.map(C.to):[],activeParameter:q.activeParameter}}Se.to=me})(z=e.SignatureInformation||(e.SignatureInformation={}));var H;(function(Se){function De(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(z.from):[]}}Se.from=De;function me(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(z.to):[]}}Se.to=me})(H=e.SignatureHelp||(e.SignatureHelp={}));var j;(function(Se){function De(me,q){const Ae=new l.InlayHint(i.to(q.position),typeof q.label=="string"?q.label:q.label.map(se.to.bind(void 0,me)),q.kind&&ce.to(q.kind));return Ae.textEdits=q.textEdits&&q.textEdits.map(O.to),Ae.tooltip=w.isMarkdownString(q.tooltip)?B.to(q.tooltip):q.tooltip,Ae.paddingLeft=q.paddingLeft,Ae.paddingRight=q.paddingRight,Ae}Se.to=De})(j=e.InlayHint||(e.InlayHint={}));var se;(function(Se){function De(me,q){const Ae=new l.InlayHintLabelPart(q.label);return Ae.tooltip=w.isMarkdownString(q.tooltip)?B.to(q.tooltip):q.tooltip,m.Command.is(q.command)&&(Ae.command=me.fromInternal(q.command)),q.location&&(Ae.location=Ee.to(q.location)),Ae}Se.to=De})(se=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var ce;(function(Se){function De(q){return q}Se.from=De;function me(q){return q}Se.to=me})(ce=e.InlayHintKind||(e.InlayHintKind={}));var Y;(function(Se){function De(q){return{range:d.from(q.range),url:q.target,tooltip:q.tooltip}}Se.from=De;function me(q){let Ae;if(q.url)try{Ae=typeof q.url=="string"?F.URI.parse(q.url,!0):F.URI.revive(q.url)}catch{}return new l.DocumentLink(d.to(q.range),Ae)}Se.to=me})(Y=e.DocumentLink||(e.DocumentLink={}));var pe;(function(Se){function De(q){const Ae=new l.ColorPresentation(q.label);return q.textEdit&&(Ae.textEdit=O.to(q.textEdit)),q.additionalTextEdits&&(Ae.additionalTextEdits=q.additionalTextEdits.map(Le=>O.to(Le))),Ae}Se.to=De;function me(q){return{label:q.label,textEdit:q.textEdit?O.from(q.textEdit):void 0,additionalTextEdits:q.additionalTextEdits?q.additionalTextEdits.map(Ae=>O.from(Ae)):void 0}}Se.from=me})(pe=e.ColorPresentation||(e.ColorPresentation={}));var ge;(function(Se){function De(q){return new l.Color(q[0],q[1],q[2],q[3])}Se.to=De;function me(q){return[q.red,q.green,q.blue,q.alpha]}Se.from=me})(ge=e.Color||(e.Color={}));var Ne;(function(Se){function De(q){return{range:d.from(q.range)}}Se.from=De;function me(q){return new l.SelectionRange(d.to(q.range))}Se.to=me})(Ne=e.SelectionRange||(e.SelectionRange={}));var Be;(function(Se){function De(me){switch(me){case 2:return l.TextDocumentSaveReason.AfterDelay;case 1:return l.TextDocumentSaveReason.Manual;case 3:case 4:return l.TextDocumentSaveReason.FocusOut}}Se.to=De})(Be=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ye;(function(Se){function De(q){switch(q){case l.TextEditorLineNumbersStyle.Off:return 0;case l.TextEditorLineNumbersStyle.Relative:return 2;case l.TextEditorLineNumbersStyle.On:default:return 1}}Se.from=De;function me(q){switch(q){case 0:return l.TextEditorLineNumbersStyle.Off;case 2:return l.TextEditorLineNumbersStyle.Relative;case 1:default:return l.TextEditorLineNumbersStyle.On}}Se.to=me})(Ye=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Xe;(function(Se){function De(q){if(q===l.EndOfLine.CRLF)return 1;if(q===l.EndOfLine.LF)return 0}Se.from=De;function me(q){if(q===1)return l.EndOfLine.CRLF;if(q===0)return l.EndOfLine.LF}Se.to=me})(Xe=e.EndOfLine||(e.EndOfLine={}));var ke;(function(Se){function De(me){if(typeof me=="object")return me.viewId;switch(me){case l.ProgressLocation.SourceControl:return 3;case l.ProgressLocation.Window:return 10;case l.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Se.from=De})(ke=e.ProgressLocation||(e.ProgressLocation={}));var nt;(function(Se){function De(me){const q={start:me.start+1,end:me.end+1};return me.kind&&(q.kind=G.from(me.kind)),q}Se.from=De})(nt=e.FoldingRange||(e.FoldingRange={}));var G;(function(Se){function De(me){if(me)switch(me){case l.FoldingRangeKind.Comment:return m.FoldingRangeKind.Comment;case l.FoldingRangeKind.Imports:return m.FoldingRangeKind.Imports;case l.FoldingRangeKind.Region:return m.FoldingRangeKind.Region}}Se.from=De})(G=e.FoldingRangeKind||(e.FoldingRangeKind={}));var X;(function(Se){function De(me){if(me)return{pinned:typeof me.preview=="boolean"?!me.preview:void 0,inactive:me.background,preserveFocus:me.preserveFocus,selection:typeof me.selection=="object"?d.from(me.selection):void 0,override:typeof me.override=="boolean"?c.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Se.from=De})(X=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var fe;(function(Se){function De(Le){return Le instanceof l.RelativePattern?Le.toJSON():typeof Le=="string"?Le:me(Le)||q(Le)?new l.RelativePattern(Le.baseUri??Le.base,Le.pattern).toJSON():Le}Se.from=De;function me(Le){const tt=Le;return tt?F.URI.isUri(tt.baseUri)&&typeof tt.pattern=="string":!1}function q(Le){const tt=Le;return tt?typeof tt.base=="string"&&typeof tt.pattern=="string":!1}function Ae(Le){return typeof Le=="string"?Le:new l.RelativePattern(F.URI.revive(Le.baseUri),Le.pattern)}Se.to=Ae})(fe=e.GlobPattern||(e.GlobPattern={}));var Ue;(function(Se){function De(me){if(me){if(Array.isArray(me))return me.map(De);if(typeof me=="string")return me;{const q=me;return{language:q.language,scheme:q.scheme,pattern:fe.from(q.pattern),exclusive:q.exclusive,notebookType:q.notebookType}}}else return}Se.from=De})(Ue=e.LanguageSelector||(e.LanguageSelector={}));var We;(function(Se){function De(q){return{start:q.start,end:q.end}}Se.from=De;function me(q){return new l.NotebookRange(q.start,q.end)}Se.to=me})(We=e.NotebookRange||(e.NotebookRange={}));var et;(function(Se){function De(q){return{timing:typeof q.runStartTime=="number"&&typeof q.runEndTime=="number"?{startTime:q.runStartTime,endTime:q.runEndTime}:void 0,executionOrder:q.executionOrder,success:q.lastRunSuccess}}Se.to=De;function me(q){return{lastRunSuccess:q.success,runStartTime:q.timing?.startTime,runEndTime:q.timing?.endTime,executionOrder:q.executionOrder}}Se.from=me})(et=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var qe;(function(Se){function De(me){if(me===h.NotebookCellExecutionState.Unconfirmed)return l.NotebookCellExecutionState.Pending;if(me===h.NotebookCellExecutionState.Pending)return;if(me===h.NotebookCellExecutionState.Executing)return l.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${me}`)}Se.to=De})(qe=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ve;(function(Se){function De(q){switch(q){case l.NotebookCellKind.Markup:return h.CellKind.Markup;case l.NotebookCellKind.Code:default:return h.CellKind.Code}}Se.from=De;function me(q){switch(q){case h.CellKind.Markup:return l.NotebookCellKind.Markup;case h.CellKind.Code:default:return l.NotebookCellKind.Code}}Se.to=me})(Ve=e.NotebookCellKind||(e.NotebookCellKind={}));var it;(function(Se){function De(q){const Ae={metadata:q.metadata??Object.create(null),cells:[]};for(const Le of q.cells)l.NotebookCellData.validate(Le),Ae.cells.push(st.from(Le));return Ae}Se.from=De;function me(q){const Ae=new l.NotebookData(q.cells.map(st.to));return(0,k.isEmptyObject)(q.metadata)||(Ae.metadata=q.metadata),Ae}Se.to=me})(it=e.NotebookData||(e.NotebookData={}));var st;(function(Se){function De(q){return{cellKind:Ve.from(q.kind),language:q.languageId,mime:q.mime,source:q.value,metadata:q.metadata,internalMetadata:et.from(q.executionSummary??{}),outputs:q.outputs?q.outputs.map(at.from):[]}}Se.from=De;function me(q){return new l.NotebookCellData(Ve.to(q.cellKind),q.source,q.language,q.mime,q.outputs?q.outputs.map(at.to):void 0,q.metadata,q.internalMetadata?et.to(q.internalMetadata):void 0)}Se.to=me})(st=e.NotebookCellData||(e.NotebookCellData={}));var dt;(function(Se){function De(q){return{mime:q.mime,valueBytes:y.VSBuffer.wrap(q.data)}}Se.from=De;function me(q){return new l.NotebookCellOutputItem(q.valueBytes.buffer,q.mime)}Se.to=me})(dt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var at;(function(Se){function De(q){return{outputId:q.id,items:q.items.map(dt.from),metadata:q.metadata}}Se.from=De;function me(q){const Ae=q.items.map(dt.to);return new l.NotebookCellOutput(Ae,q.outputId,q.metadata)}Se.to=me})(at=e.NotebookCellOutput||(e.NotebookCellOutput={}));var rt;(function(Se){function De(Ae){return q(Ae)?{include:(0,k.withNullAsUndefined)(fe.from(Ae.include)),exclude:(0,k.withNullAsUndefined)(fe.from(Ae.exclude))}:(0,k.withNullAsUndefined)(fe.from(Ae))}Se.from=De;function me(Ae){return q(Ae)?{include:fe.to(Ae.include),exclude:fe.to(Ae.exclude)}:fe.to(Ae)}Se.to=me;function q(Ae){const Le=Ae;return Le?!(0,k.isUndefinedOrNull)(Le.include)&&!(0,k.isUndefinedOrNull)(Le.exclude):!1}})(rt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var _t;(function(Se){function De(me,q,Ae){const Le=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{alignment:me.alignment===l.NotebookCellStatusBarAlignment.Left?1:2,command:q.toInternal(Le,Ae),text:me.text,tooltip:me.tooltip,accessibilityInformation:me.accessibilityInformation,priority:me.priority}}Se.from=De})(_t=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Rt;(function(Se){function De(me){return{transientOutputs:me?.transientOutputs??!1,transientCellMetadata:me?.transientCellMetadata??{},transientDocumentMetadata:me?.transientDocumentMetadata??{}}}Se.from=De})(Rt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ot;(function(Se){function De(q){return{uri:q.uri,provides:q.provides}}Se.from=De;function me(q){return new l.NotebookRendererScript(F.URI.revive(q.uri),q.provides)}Se.to=me})(Ot=e.NotebookRendererScript||(e.NotebookRendererScript={}));var mt;(function(Se){function De(q){return{message:B.fromStrict(q.message)||"",type:0,expected:q.expectedOutput,actual:q.actualOutput,location:q.location&&{range:d.from(q.location.range),uri:q.location.uri}}}Se.from=De;function me(q){const Ae=new l.TestMessage(typeof q.message=="string"?q.message:B.to(q.message));return Ae.actualOutput=q.actual,Ae.expectedOutput=q.expected,Ae.location=q.location?Ee.to(q.location):void 0,Ae}Se.to=me})(mt=e.TestMessage||(e.TestMessage={}));var Dt;(function(Se){Se.namespace=v.namespaceTestTag,Se.denamespace=v.denamespaceTestTag})(Dt=e.TestTag||(e.TestTag={}));var Nt;(function(Se){function De(q){const Ae=(0,f.getPrivateApiFor)(q).controllerId;return{extId:u.TestId.fromExtHostTestItem(q,Ae).toString(),label:q.label,uri:F.URI.revive(q.uri),busy:q.busy,tags:q.tags.map(Le=>Dt.namespace(Ae,Le.id)),range:S.Range.lift(d.from(q.range)),description:q.description||null,sortText:q.sortText||null,error:q.error&&B.fromStrict(q.error)||null}}Se.from=De;function me(q){return{parent:void 0,error:void 0,id:u.TestId.fromString(q.extId).localId,label:q.label,uri:F.URI.revive(q.uri),tags:(q.tags||[]).map(Ae=>{const{tagId:Le}=Dt.denamespace(Ae);return new l.TestTag(Le)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:d.to(q.range||void 0),canResolveChildren:!1,busy:q.busy,description:q.description||void 0,sortText:q.sortText||void 0}}Se.toPlain=me})(Nt=e.TestItem||(e.TestItem={})),function(Se){function De(q){return{id:q.id}}Se.from=De;function me(q){return new l.TestTag(q.id)}Se.to=me}(Dt=e.TestTag||(e.TestTag={}));var Mt;(function(Se){const De=(q,Ae)=>{const Le=[];for(const[Ge,Ke]of Ae)u.TestId.compare(Ke.item.extId,Ge)===2&&(Ae.delete(Ge),Le.push(Ke));const tt={...Nt.toPlain(q.item),parent:void 0,taskStates:q.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.filter(Ke=>Ke.type===0).map(mt.to)})),children:Le.map(Ge=>De(Ge,Ae))};for(const Ge of tt.children)Ge.parent=tt;return tt};function me(q){const Ae=[],Le=new Map;for(const tt of q.items)Le.set(tt.item.extId,tt),q.request.targets.some(Ge=>Ge.controllerId===tt.controllerId&&Ge.testIds.includes(tt.item.extId))&&Ae.push(tt);return{completedAt:q.completedAt,results:Ae.map(tt=>De(tt,Le))}}Se.to=me})(Mt=e.TestResults||(e.TestResults={}));var je;(function(Se){function De(Le){return{covered:Le.covered,total:Le.covered}}function me(Le){return"line"in Le?i.from(Le):d.from(Le)}function q(Le){return"branches"in Le?{count:Le.executionCount,location:me(Le.location),type:1,branches:Le.branches.length?Le.branches.map(tt=>({count:tt.executionCount,location:tt.location&&me(tt.location)})):void 0}:{type:0,count:Le.executionCount,location:me(Le.location)}}Se.fromDetailed=q;function Ae(Le){return{uri:Le.uri,statement:De(Le.statementCoverage),branch:Le.branchCoverage&&De(Le.branchCoverage),function:Le.functionCoverage&&De(Le.functionCoverage),details:Le.detailedCoverage?.map(q)}}Se.fromFile=Ae})(je=e.TestCoverage||(e.TestCoverage={}));var Ut;(function(Se){function De(me){switch(me){case 1:return l.CodeActionTriggerKind.Invoke;case 2:return l.CodeActionTriggerKind.Automatic}}Se.to=De})(Ut=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ft;(function(Se){function De(q){const Ae=new l.TypeHierarchyItem(ue.to(q.kind),q.name,q.detail||"",F.URI.revive(q.uri),d.to(q.range),d.to(q.selectionRange));return Ae._sessionId=q._sessionId,Ae._itemId=q._itemId,Ae}Se.to=De;function me(q,Ae,Le){if(Ae=Ae??q._sessionId,Le=Le??q._itemId,Ae===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Le,kind:ue.from(q.kind),name:q.name,detail:q.detail??"",uri:q.uri,range:d.from(q.range),selectionRange:d.from(q.selectionRange),tags:q.tags?.map(oe.from)}}Se.from=me})(Ft=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Tt;(function(Se){function De(me){if(!!me)return{value:me.value,tooltip:me.tooltip}}Se.from=De})(Tt=e.ViewBadge||(e.ViewBadge={}));var gt;(function(Se){function De(me,q){const Ae=me.fileData;return Ae?new class extends l.DataTransferItem{asFile(){return{name:Ae.name,uri:F.URI.revive(Ae.uri),data:(0,b.once)(()=>q())}}}("",me.id):new l.DataTransferItem(me.asString)}Se.toDataTransferItem=De})(gt=e.DataTransferItem||(e.DataTransferItem={}));var yt;(function(Se){function De(q,Ae){const Le=q.items.map(([tt,Ge])=>[tt,gt.toDataTransferItem(Ge,()=>Ae(Ge.id))]);return new l.DataTransfer(Le)}Se.toDataTransfer=De;async function me(q){const Ae={items:[]},Le=[];return q.forEach((tt,Ge)=>{Le.push((async()=>{const Ke=await tt.asString(),ct=tt.asFile();Ae.items.push([Ge,{id:tt.id,asString:Ke,fileData:ct?{name:ct.name,uri:ct.uri}:void 0}])})())}),await Promise.all(Le),Ae}Se.toDataTransferDTO=me})(yt=e.DataTransfer||(e.DataTransfer={}))}),define(Ce[177],Ie([1,0,2,11,6,8,241]),function(te,e,r,y,w,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class A{constructor(k,F,S,m={timeout:1500,errors:3}){this._logService=k,this._documents=F,this._mainThreadBulkEdits=S,this._thresholds=m,this._callbacks=new _.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(k){return(F,S,m)=>{const f={dispose:this._callbacks.push([F,S,k])};return Array.isArray(m)&&m.push(f),f}}async $participateInSave(k,F){const S=r.URI.revive(k);let m=!1;const T=setTimeout(()=>m=!0,this._thresholds.timeout),f=[];try{for(const c of[...this._callbacks]){if(m)break;const h=this._documents.getDocument(S),u=await this._deliverEventAsyncAndBlameBadListeners(c,{document:h,reason:L.TextDocumentSaveReason.to(F)});f.push(u)}}finally{clearTimeout(T)}return f}_deliverEventAsyncAndBlameBadListeners([k,F,S],m){const T=this._badListeners.get(k);return typeof T=="number"&&T>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(S,k,F,m).then(()=>!0,f=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' threw ERROR`),this._logService.error(f),!(f instanceof Error)||f.message!=="concurrent_edits"){const c=this._badListeners.get(k);this._badListeners.set(k,c?c+1:1),typeof c=="number"&&c>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(k,F,S,m){const T=[],f=Date.now(),{document:c,reason:h}=m,{version:u}=c,v=Object.freeze({document:c,reason:h,waitUntil(I){if(Object.isFrozen(T))throw(0,y.illegalState)("waitUntil can not be called async");T.push(Promise.resolve(I))}});try{F.apply(S,[v])}catch(I){return Promise.reject(I)}return Object.freeze(T),new Promise((I,l)=>{const b=setTimeout(()=>l(new Error("timeout")),this._thresholds.timeout);return Promise.all(T).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-f}ms`),clearTimeout(b),I(t)}).catch(t=>{clearTimeout(b),l(t)})}).then(I=>{const l={edits:[]};for(const b of I)if(Array.isArray(b)&&b.every(t=>t instanceof w.TextEdit))for(const{newText:t,newEol:d,range:n}of b)l.edits.push({resource:c.uri,versionId:void 0,textEdit:{range:n&&L.Range.from(n),text:t,eol:d&&L.EndOfLine.from(d)}});if(l.edits.length!==0)return u===c.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(l):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=A}),define(Ce[178],Ie([1,0,12,2,8,6,64]),function(te,e,r,y,w,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class A{constructor(S,m,T,f){this.start=S,this.deletedCount=m,this.deletedItems=T,this.items=f}asApiEvent(){return{range:new L.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(S=>S.apiCell),removedCells:this.deletedItems}}}class E{constructor(S,m,T){this.notebook=S,this._extHostDocument=m,this._cellData=T,this.handle=T.handle,this.uri=y.URI.revive(T.uri),this.cellKind=T.cellKind,this._outputs=T.outputs.map(w.NotebookCellOutput.to),this._internalMetadata=T.internalMetadata??{},this._metadata=Object.freeze(T.metadata??{}),this._previousResult=Object.freeze(w.NotebookCellExecutionSummary.to(T.internalMetadata??{}))}static asModelAddData(S,m){return{EOL:m.eol,lines:m.source,languageId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:S}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const S=this,m=this._extHostDocument.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const T={get index(){return S.notebook.getCellIndex(S)},notebook:S.notebook.apiNotebook,kind:w.NotebookCellKind.to(this._cellData.cellKind),document:m.document,get mime(){return S._mime},set mime(f){S._mime=f},get outputs(){return S._outputs.slice(0)},get metadata(){return S._metadata},get executionSummary(){return S._previousResult}};this._apiCell=Object.freeze(T)}return this._apiCell}setOutputs(S){this._outputs=S.map(w.NotebookCellOutput.to)}setOutputItems(S,m,T){const f=T.map(w.NotebookCellOutputItem.to),c=this._outputs.find(h=>h.id===S);c&&(m||(c.items.length=0),c.items.push(...f))}setMetadata(S){this._metadata=Object.freeze(S)}setInternalMetadata(S){this._internalMetadata=S,this._previousResult=Object.freeze(w.NotebookCellExecutionSummary.to(S))}setMime(S){}}e.ExtHostCell=E;class k{constructor(S,m,T,f,c){this._proxy=S,this._textDocumentsAndEditors=m,this._textDocuments=T,this.uri=f,this.handle=k._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=c.viewType,this._metadata=Object.freeze(c.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,c.cells]],!0,void 0),this._versionId=c.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const S=this,m={get uri(){return S.uri},get version(){return S._versionId},get notebookType(){return S._notebookType},get isDirty(){return S._isDirty},get isUntitled(){return S.uri.scheme===r.Schemas.untitled},get isClosed(){return S._disposed},get metadata(){return S._metadata},get cellCount(){return S._cells.length},cellAt(T){return T=S._validateIndex(T),S._cells[T].apiCell},getCells(T){return(T?S._getCells(T):S._cells).map(c=>c.apiCell)},save(){return S._save()}};this._notebook=Object.freeze(m)}return this._notebook}acceptDocumentPropertiesChanged(S){S.metadata&&(this._metadata=Object.freeze({...this._metadata,...S.metadata}))}acceptDirty(S){this._isDirty=S}acceptModelChanged(S,m,T){this._versionId=S.versionId,this._isDirty=m,this.acceptDocumentPropertiesChanged({metadata:T});const f={notebook:this.apiNotebook,metadata:T,cellChanges:[],contentChanges:[]},c=[];for(const u of S.rawEvents)u.kind===_.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(u.changes,!1,f.contentChanges):u.kind===_.NotebookCellsChangeType.Move?this._moveCell(u.index,u.newIdx,f.contentChanges):u.kind===_.NotebookCellsChangeType.Output?(this._setCellOutputs(u.index,u.outputs),c.push({cell:this._cells[u.index].apiCell,outputs:this._cells[u.index].apiCell.outputs})):u.kind===_.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(u.index,u.outputId,u.append,u.outputItems),c.push({cell:this._cells[u.index].apiCell,outputs:this._cells[u.index].apiCell.outputs})):u.kind===_.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(u.index,u.language),c.push({cell:this._cells[u.index].apiCell,document:this._cells[u.index].apiCell.document})):u.kind===_.NotebookCellsChangeType.ChangeCellContent?c.push({cell:this._cells[u.index].apiCell,document:this._cells[u.index].apiCell.document}):u.kind===_.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(u.index,u.mime):u.kind===_.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(u.index,u.metadata),c.push({cell:this._cells[u.index].apiCell,metadata:this._cells[u.index].apiCell.metadata})):u.kind===_.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(u.index,u.internalMetadata),c.push({cell:this._cells[u.index].apiCell,executionSummary:this._cells[u.index].apiCell.executionSummary}));const h=new Map;for(let u=0;u<c.length;u++){const v=c[u],I=h.get(v.cell);if(I===void 0){const l=f.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...v});h.set(v.cell,l-1)}else f.cellChanges[I]={...f.cellChanges[I],...v}}return Object.freeze(f),Object.freeze(f.cellChanges),Object.freeze(f.contentChanges),f}_validateIndex(S){return S=S|0,S<0?0:S>=this._cells.length?this._cells.length-1:S}_validateRange(S){let m=S.start|0,T=S.end|0;return m<0&&(m=0),T>this._cells.length&&(T=this._cells.length),S.with({start:m,end:T})}_getCells(S){S=this._validateRange(S);const m=[];for(let T=S.start;T<S.end;T++)m.push(this._cells[T]);return m}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(S,m,T){if(this._disposed)return;const f=[],c=[],h=[];if(S.reverse().forEach(u=>{const I=u[2].map(t=>{const d=new E(this,this._textDocumentsAndEditors,t);return m||c.push(E.asModelAddData(this.apiNotebook,t)),d}),l=new A(u[0],u[1],[],I),b=this._cells.splice(u[0],u[1],...I);for(const t of b)h.push(t.uri),l.deletedItems.push(t.apiCell);f.push(l)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:c,removedDocuments:h}),T)for(const u of f)T.push(u.asApiEvent())}_moveCell(S,m,T){const f=this._cells.splice(S,1);this._cells.splice(m,0,...f);const c=[new A(S,1,f.map(h=>h.apiCell),[]),new A(m,0,[],f)];for(const h of c)T.push(h.asApiEvent())}_setCellOutputs(S,m){this._cells[S].setOutputs(m)}_setCellOutputItems(S,m,T,f){this._cells[S].setOutputItems(m,T,f)}_changeCellLanguage(S,m){const T=this._cells[S];T.apiCell.document.languageId!==m&&this._textDocuments.$acceptModelLanguageChanged(T.uri,m)}_changeCellMime(S,m){const T=this._cells[S];T.apiCell.mime=m}_changeCellMetadata(S,m){this._cells[S].setMetadata(m)}_changeCellInternalMetadata(S,m){this._cells[S].setInternalMetadata(m)}getCellFromApiCell(S){return this._cells.find(m=>m.apiCell===S)}getCellFromIndex(S){return this._cells[S]}getCell(S){return this._cells.find(m=>m.handle===S)}getCellIndex(S){return this._cells.indexOf(S)}}e.ExtHostNotebookDocument=k,k._handlePool=0}),define(Ce[93],Ie([1,0,11,8,6]),function(te,e,r,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class L{constructor(A,E,k,F,S,m){this.id=A,this._proxy=E,this.notebookData=k,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=S,this._visibleRanges=F,this._viewColumn=m}get apiEditor(){if(!this._editor){const A=this;this._editor={get document(){return A.notebookData.apiNotebook},get notebook(){return A.notebookData.apiNotebook},get selection(){return A._selections[0]},set selection(E){this.selections=[E]},get selections(){return A._selections},set selections(E){if(!Array.isArray(E)||!E.every(w.NotebookRange.isNotebookRange))throw(0,r.illegalArgument)("selections");A._selections=E,A._trySetSelections(E)},get visibleRanges(){return A._visibleRanges},revealRange(E,k){A._proxy.$tryRevealRange(A.id,y.NotebookRange.from(E),k??w.NotebookEditorRevealType.Default)},get viewColumn(){return A._viewColumn}},L.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(A){this._visible=A}_acceptVisibleRanges(A){this._visibleRanges=A}_acceptSelections(A){this._selections=A}_trySetSelections(A){this._proxy.$trySetSelections(this.id,A.map(y.NotebookRange.from))}_acceptViewColumn(A){this._viewColumn=A}}e.ExtHostNotebookEditor=L,L.apiEditorsToExtHost=new WeakMap}),define(Ce[179],Ie([1,0,5,15,8]),function(te,e,r,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let L=class{constructor(A,E){this._logService=A,this._notebooksAndEditors=E,this._onDidChangeNotebookEditorSelection=new r.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new r.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(A,E){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",A,E);const k=this._notebooksAndEditors.getEditorById(A);E.visibleRanges&&k._acceptVisibleRanges(E.visibleRanges.ranges.map(w.NotebookRange.to)),E.selections&&k._acceptSelections(E.selections.selections.map(w.NotebookRange.to)),E.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:k.apiEditor,visibleRanges:k.apiEditor.visibleRanges}),E.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:k.apiEditor,selections:k.apiEditor.selections}))}$acceptEditorViewColumns(A){for(const E in A)this._notebooksAndEditors.getEditorById(E)._acceptViewColumn(w.ViewColumn.to(A[E]))}};L=ze([xe(0,y.ILogService)],L),e.ExtHostNotebookEditors=L}),define(Ce[180],Ie([1,0,8,150,131,20,55,11]),function(te,e,r,y,w,L,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class E{constructor(m){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=m}async withProgress(m,T,f){const c=this._handles++,{title:h,location:u,cancellable:v}=T,I={label:(0,w.localize)(0,null,m.displayName||m.name),id:m.identifier.value};return this._proxy.$startProgress(c,{location:r.ProgressLocation.from(u),title:h,source:I,cancellable:v},m.isUnderDevelopment?void 0:m.identifier.value).catch(A.onUnexpectedExternalError),this._withProgress(c,f,!!v)}_withProgress(m,T,f){let c;f&&(c=new L.CancellationTokenSource,this._mapHandleToCancellationSource.set(m,c));const h=v=>{this._proxy.$progressEnd(v),this._mapHandleToCancellationSource.delete(v),c?.dispose()};let u;try{u=T(new F(this._proxy,m),f&&c?c.token:L.CancellationToken.None)}catch(v){throw h(m),v}return u.then(v=>h(m),v=>h(m)),u}$acceptProgressCanceled(m){const T=this._mapHandleToCancellationSource.get(m);T&&(T.cancel(),this._mapHandleToCancellationSource.delete(m))}}e.ExtHostProgress=E;function k(S,m){return S.message=m.message,typeof m.increment=="number"&&(typeof S.increment=="number"?S.increment+=m.increment:S.increment=m.increment),S}class F extends y.Progress{constructor(m,T){super(f=>this.throttledReport(f)),this._proxy=m,this._handle=T}throttledReport(m){this._proxy.$progressReport(this._handle,m)}}ze([(0,_.throttle)(100,(S,m)=>k(S,m),()=>Object.create(null))],F.prototype,"throttledReport",null)}),define(Ce[94],Ie([1,0,49,89,47,65,48,8,2]),function(te,e,r,y,w,L,_,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const k=(I,l,b,t)=>{let d=l;return{enumerable:!0,configurable:!1,get(){return d},set(n){if(!b(d,n)){const i=d;d=n,I.listener?.(t(n,i))}}}},F=(I,l)=>I===l,S={range:(I,l)=>I===l?!0:!I||!l?!1:I.isEqual(l),label:F,description:F,sortText:F,busy:F,error:F,canResolveChildren:F,tags:(I,l)=>!(I.length!==l.length||I.some(b=>!l.find(t=>b.id===t.id)))},m=I=>l=>({op:4,update:I(l)}),T=(I,l)=>({range:k(I,void 0,S.range,m(b=>({range:r.Range.lift(A.Range.from(b))}))),label:k(I,l,S.label,m(b=>({label:b}))),description:k(I,void 0,S.description,m(b=>({description:b}))),sortText:k(I,void 0,S.sortText,m(b=>({sortText:b}))),canResolveChildren:k(I,!1,S.canResolveChildren,b=>({op:2,state:b})),busy:k(I,!1,S.busy,m(b=>({busy:b}))),error:k(I,void 0,S.error,m(b=>({error:A.MarkdownString.fromStrict(b)||null}))),tags:k(I,[],S.tags,(b,t)=>({op:1,new:b.map(A.TestTag.from),old:t.map(A.TestTag.from)}))}),f=I=>{const l=w.TestId.fromString(I.extId),b=new h(l.controllerId,l.localId,I.label,E.URI.revive(I.uri)||void 0);return b.range=A.Range.to(I.range||void 0),b.description=I.description||void 0,b.sortText=I.sortText||void 0,b.tags=I.tags.map(t=>A.TestTag.to({id:(0,_.denamespaceTestTag)(t).tagId})),b},c=I=>{let l;for(const b of I.tests){const t=f(b.item);(0,y.getPrivateApiFor)(t).parent=l,l=t}return l};e.toItemFromContext=c;class h{constructor(l,b,t,d){if(b.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(b)} symbol`);const n=(0,y.createPrivateApiFor)(this,l);Object.defineProperties(this,{id:{value:b,enumerable:!0,writable:!1},uri:{value:d,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return n.parent instanceof u?void 0:n.parent}},children:{value:(0,L.createTestItemChildren)(n,y.getPrivateApiFor,h),enumerable:!0,writable:!1},...T(n,t)})}}e.TestItemImpl=h;class u extends h{constructor(l,b){super(l,l,b,void 0)}}e.TestItemRootImpl=u;class v extends L.TestItemCollection{constructor(l,b,t){super({controllerId:l,getDocumentVersion:d=>t.getDocument(d)?.version,getApiFor:y.getPrivateApiFor,getChildren:d=>d.children,root:new u(l,b),toITestItem:A.TestItem.from})}}e.ExtHostTestItemCollection=v}),define(Ce[95],Ie([1,0,44,11,73,8,6]),function(te,e,r,y,w,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class A{constructor(m,T,f){const c=A._Keys.nextId();m.$registerTextEditorDecorationType(T.identifier,c,L.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:c,dispose(){m.$removeTextEditorDecorationType(c)}})}}e.TextEditorDecorationType=A,A._Keys=new w.IdGenerator("TextEditorDecorationType");class E{constructor(m,T){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=m,this._documentVersionId=m.version,this._undoStopBefore=T.undoStopBefore,this._undoStopAfter=T.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(m,T){this._throwIfFinalized();let f=null;if(m instanceof _.Position)f=new _.Range(m,m);else if(m instanceof _.Range)f=m;else throw new Error("Unrecognized location");this._pushEdit(f,T,!1)}insert(m,T){this._throwIfFinalized(),this._pushEdit(new _.Range(m,m),T,!0)}delete(m){this._throwIfFinalized();let T=null;if(m instanceof _.Range)T=m;else throw new Error("Unrecognized location");this._pushEdit(T,null,!0)}_pushEdit(m,T,f){const c=this._document.validateRange(m);this._collectedEdits.push({range:c,text:T,forceMoveMarkers:f})}setEndOfLine(m){if(this._throwIfFinalized(),m!==_.EndOfLine.LF&&m!==_.EndOfLine.CRLF)throw(0,y.illegalArgument)("endOfLine");this._setEndOfLine=m}}e.TextEditorEdit=E;class k{constructor(m,T,f,c){this._proxy=m,this._id=T,this._accept(f),this._logService=c;const h=this;this.value={get tabSize(){return h._tabSize},set tabSize(u){h._setTabSize(u)},get insertSpaces(){return h._insertSpaces},set insertSpaces(u){h._setInsertSpaces(u)},get cursorStyle(){return h._cursorStyle},set cursorStyle(u){h._setCursorStyle(u)},get lineNumbers(){return h._lineNumbers},set lineNumbers(u){h._setLineNumbers(u)}}}_accept(m){this._tabSize=m.tabSize,this._insertSpaces=m.insertSpaces,this._cursorStyle=m.cursorStyle,this._lineNumbers=L.TextEditorLineNumbersStyle.to(m.lineNumbers)}_validateTabSize(m){if(m==="auto")return"auto";if(typeof m=="number"){const T=Math.floor(m);return T>0?T:null}if(typeof m=="string"){const T=parseInt(m,10);return isNaN(T)?null:T>0?T:null}return null}_setTabSize(m){const T=this._validateTabSize(m);if(T!==null){if(typeof T=="number"){if(this._tabSize===T)return;this._tabSize=T}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:T}))}}_validateInsertSpaces(m){return m==="auto"?"auto":m==="false"?!1:Boolean(m)}_setInsertSpaces(m){const T=this._validateInsertSpaces(m);if(typeof T=="boolean"){if(this._insertSpaces===T)return;this._insertSpaces=T}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:T}))}_setCursorStyle(m){this._cursorStyle!==m&&(this._cursorStyle=m,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:m})))}_setLineNumbers(m){this._lineNumbers!==m&&(this._lineNumbers=m,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:L.TextEditorLineNumbersStyle.from(m)})))}assign(m){const T={};let f=!1;if(typeof m.tabSize<"u"){const c=this._validateTabSize(m.tabSize);c==="auto"?(f=!0,T.tabSize=c):typeof c=="number"&&this._tabSize!==c&&(this._tabSize=c,f=!0,T.tabSize=c)}if(typeof m.insertSpaces<"u"){const c=this._validateInsertSpaces(m.insertSpaces);c==="auto"?(f=!0,T.insertSpaces=c):this._insertSpaces!==c&&(this._insertSpaces=c,f=!0,T.insertSpaces=c)}typeof m.cursorStyle<"u"&&this._cursorStyle!==m.cursorStyle&&(this._cursorStyle=m.cursorStyle,f=!0,T.cursorStyle=m.cursorStyle),typeof m.lineNumbers<"u"&&this._lineNumbers!==m.lineNumbers&&(this._lineNumbers=m.lineNumbers,f=!0,T.lineNumbers=L.TextEditorLineNumbersStyle.from(m.lineNumbers)),f&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,T))}_warnOnError(m,T){T.catch(f=>{this._logService.warn(`ExtHostTextEditorOptions '${m}' failed:'`),this._logService.warn(f)})}}e.ExtHostTextEditorOptions=k;class F{constructor(m,T,f,c,h,u,v,I){this.id=m,this._proxy=T,this._logService=f,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=h,this._options=new k(this._proxy,this.id,u,f),this._visibleRanges=v,this._viewColumn=I;const l=this;this.value=Object.freeze({get document(){return c.getValue()},set document(b){throw(0,y.readonly)("document")},get selection(){return l._selections&&l._selections[0]},set selection(b){if(!(b instanceof _.Selection))throw(0,y.illegalArgument)("selection");l._selections=[b],l._trySetSelection()},get selections(){return l._selections},set selections(b){if(!Array.isArray(b)||b.some(t=>!(t instanceof _.Selection)))throw(0,y.illegalArgument)("selections");l._selections=b,l._trySetSelection()},get visibleRanges(){return l._visibleRanges},set visibleRanges(b){throw(0,y.readonly)("visibleRanges")},get options(){return l._options.value},set options(b){l._disposed||l._options.assign(b)},get viewColumn(){return l._viewColumn},set viewColumn(b){throw(0,y.readonly)("viewColumn")},edit(b,t={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const d=new E(c.getValue(),t);return b(d),l._applyEdit(d)},insertSnippet(b,t,d={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let n;if(!t||Array.isArray(t)&&t.length===0)n=l._selections.map(i=>L.Range.from(i));else if(t instanceof _.Position){const{lineNumber:i,column:s}=L.Position.from(t);n=[{startLineNumber:i,startColumn:s,endLineNumber:i,endColumn:s}]}else if(t instanceof _.Range)n=[L.Range.from(t)];else{n=[];for(const i of t)if(i instanceof _.Range)n.push(L.Range.from(i));else{const{lineNumber:s,column:a}=L.Position.from(i);n.push({startLineNumber:s,startColumn:a,endLineNumber:s,endColumn:a})}}return T.$tryInsertSnippet(m,c.getValue().version,b.value,n,d)},setDecorations(b,t){const d=t.length===0;d&&!l._hasDecorationsForKey.has(b.key)||(d?l._hasDecorationsForKey.delete(b.key):l._hasDecorationsForKey.add(b.key),l._runOnProxy(()=>{if(L.isDecorationOptionsArr(t))return T.$trySetDecorations(m,b.key,L.fromRangeOrRangeWithMessage(t));{const n=new Array(4*t.length);for(let i=0,s=t.length;i<s;i++){const a=t[i];n[4*i]=a.start.line+1,n[4*i+1]=a.start.character+1,n[4*i+2]=a.end.line+1,n[4*i+3]=a.end.character+1}return T.$trySetDecorationsFast(m,b.key,n)}}))},revealRange(b,t){l._runOnProxy(()=>T.$tryRevealRange(m,L.Range.from(b),t||_.TextEditorRevealType.Default))},show(b){T.$tryShowEditor(m,L.ViewColumn.from(b))},hide(){T.$tryHideEditor(m)}})}dispose(){(0,r.ok)(!this._disposed),this._disposed=!0}_acceptOptions(m){(0,r.ok)(!this._disposed),this._options._accept(m)}_acceptVisibleRanges(m){(0,r.ok)(!this._disposed),this._visibleRanges=m}_acceptViewColumn(m){(0,r.ok)(!this._disposed),this._viewColumn=m}_acceptSelections(m){(0,r.ok)(!this._disposed),this._selections=m}async _trySetSelection(){const m=this._selections.map(L.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,m)),this.value}_applyEdit(m){const T=m.finalize();if(T.edits.length===0&&!T.setEndOfLine)return Promise.resolve(!0);const f=T.edits.map(h=>h.range);f.sort((h,u)=>h.end.line===u.end.line?h.end.character===u.end.character?h.start.line===u.start.line?h.start.character-u.start.character:h.start.line-u.start.line:h.end.character-u.end.character:h.end.line-u.end.line);for(let h=0,u=f.length-1;h<u;h++){const v=f[h].end;if(f[h+1].start.isBefore(v))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const c=T.edits.map(h=>({range:L.Range.from(h.range),text:h.text,forceMoveMarkers:h.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,T.documentVersionId,c,{setEndOfLine:typeof T.setEndOfLine=="number"?L.EndOfLine.from(T.setEndOfLine):void 0,undoStopBefore:T.undoStopBefore,undoStopAfter:T.undoStopAfter})}_runOnProxy(m){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):m().then(()=>this,T=>(T instanceof Error&&T.name==="DISPOSED"||this._logService.warn(T),null))}}e.ExtHostTextEditor=F}),define(Ce[181],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewSize.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineCompletionsNew:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsNew.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookContentProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookContentProvider.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDebugOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDebugOptions.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditor.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",snippetWorkspaceEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.snippetWorkspaceEdit.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLog:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLog.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceEditIsRefactoring:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceEditIsRefactoring.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ce[182],Ie([1,0,142,11,29,80,83,30,27,181,149]),function(te,e,r,y,w,L,_,A,E,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const S=A.Registry.as(_.Extensions.JSONContribution);class m{constructor(l,b,t){this._messageHandler=l,this._extension=b,this._extensionPointId=t}_msg(l,b){this._messageHandler({type:l,message:b,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(l){this._msg(w.default.Error,l)}warn(l){this._msg(w.default.Warning,l)}info(l){this._msg(w.default.Info,l)}}e.ExtensionMessageCollector=m;class T{constructor(l,b){this.added=l,this.removed=b}static _toSet(l){const b=new Set;for(let t=0,d=l.length;t<d;t++)b.add(E.ExtensionIdentifier.toKey(l[t].description.identifier));return b}static compute(l,b){if(!l||!l.length)return new T(b,[]);if(!b||!b.length)return new T([],l);const t=this._toSet(l),d=this._toSet(b),n=b.filter(s=>!t.has(E.ExtensionIdentifier.toKey(s.description.identifier))),i=l.filter(s=>!d.has(E.ExtensionIdentifier.toKey(s.description.identifier)));return new T(n,i)}}e.ExtensionPointUserDelta=T;class f{constructor(l,b){this.name=l,this.defaultExtensionKind=b,this._handler=null,this._users=null,this._delta=null}setHandler(l){if(this._handler!==null)throw new Error("Handler already set!");this._handler=l,this._handle()}acceptUsers(l){this._delta=T.compute(this._users,l),this._users=l,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(l){(0,y.onUnexpectedError)(l)}}}e.ExtensionPoint=f;const c={type:"string",enum:["ui","workspace"],enumDescriptions:[r.localize(0,null),r.localize(1,null)]},h="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:r.localize(2,null),properties:{vscode:{type:"string",description:r.localize(3,null),default:"^1.22.0"}}},publisher:{description:r.localize(4,null),type:"string"},displayName:{description:r.localize(5,null),type:"string"},categories:{description:r.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:E.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:r.localize(7,null)}]}},galleryBanner:{type:"object",description:r.localize(8,null),properties:{color:{description:r.localize(9,null),type:"string"},theme:{description:r.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:r.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:r.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:r.localize(13,null)},enabledApiProposals:{markdownDescription:r.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}},activationEvents:{description:r.localize(15,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:r.localize(16,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:r.localize(17,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:r.localize(18,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:r.localize(19,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:r.localize(20,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:r.localize(21,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:r.localize(22,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:r.localize(23,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:r.localize(24,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:r.localize(25,null),body:"onStartupFinished"},{label:"onTaskType",description:r.localize(26,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:r.localize(27,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:r.localize(28,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:r.localize(29,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:r.localize(30,null)},{label:"onIdentity",body:"onIdentity:${8:identity}",description:r.localize(31,null)},{label:"onUri",body:"onUri",description:r.localize(32,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:r.localize(33,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:r.localize(34,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:r.localize(35,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:r.localize(36,null)},{label:"onRenderer",description:r.localize(37,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:r.localize(38,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:r.localize(39,null)},{label:"*",description:r.localize(40,null),body:"*"}]}},badges:{type:"array",description:r.localize(41,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:r.localize(42,null)},href:{type:"string",description:r.localize(43,null)},description:{type:"string",description:r.localize(44,null)}}}},markdown:{type:"string",description:r.localize(45,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:r.localize(46,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:r.localize(47,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:r.localize(48,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:r.localize(49,null),type:"array",items:c,default:["workspace"],defaultSnippets:[{body:["ui"],description:r.localize(50,null)},{body:["workspace"],description:r.localize(51,null)},{body:["ui","workspace"],description:r.localize(52,null)},{body:["workspace","ui"],description:r.localize(53,null)},{body:[],description:r.localize(54,null)}]},capabilities:{description:r.localize(55,null),type:"object",properties:{virtualWorkspaces:{description:r.localize(56,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:r.localize(57,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(58,null),r.localize(59,null),r.localize(60,null)]},description:{type:"string",markdownDescription:r.localize(61,null)}}},untrustedWorkspaces:{description:r.localize(62,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:r.localize(63,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(64,null),r.localize(65,null),r.localize(66,null)]},restrictedConfigurations:{description:r.localize(67,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:r.localize(68,null)}}}}},sponsor:{description:r.localize(69,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:r.localize(70,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:r.localize(71,null),type:"string"},"vscode:uninstall":{description:r.localize(72,null),type:"string"}}},icon:{type:"string",description:r.localize(73,null)}}};class u{constructor(){this._extensionPoints=new Map}registerExtensionPoint(l){if(this._extensionPoints.has(l.extensionPoint))throw new Error("Duplicate extension point: "+l.extensionPoint);const b=new f(l.extensionPoint,l.defaultExtensionKind);return this._extensionPoints.set(l.extensionPoint,b),e.schema.properties.contributes.properties[l.extensionPoint]=l.jsonSchema,S.registerSchema(h,e.schema),b}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=u;const v={ExtensionsRegistry:"ExtensionsRegistry"};A.Registry.add(v.ExtensionsRegistry,new u),e.ExtensionsRegistry=A.Registry.as(v.ExtensionsRegistry),S.registerSchema(h,e.schema),S.registerSchema(F.productSchemaId,{properties:{extensionEnabledApiProposals:{description:r.localize(74,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}}]}}}})}),define(Ce[183],Ie([1,0,139,10,26,182,38,5]),function(te,e,r,y,w,L,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=e.TaskDefinitionRegistryImpl=void 0;const E={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:r.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:r.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:r.localize(2,null),default:""}}};var k;(function(m){function T(f,c,h){if(!f)return;const u=y.isString(f.type)?f.type:void 0;if(!u||u.length===0){h.error(r.localize(3,null));return}const v=[];if(Array.isArray(f.required))for(const I of f.required)y.isString(I)&&v.push(I);return{extensionId:c.value,taskType:u,required:v,properties:f.properties?w.deepClone(f.properties):{},when:f.when?_.ContextKeyExpr.deserialize(f.when):void 0}}m.from=T})(k||(k={}));const F=L.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:r.localize(4,null),type:"array",items:E}});class S{constructor(){this._onDefinitionsChanged=new A.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((T,f)=>{F.setHandler((c,h)=>{this._schema=void 0;try{for(const u of h.removed){const v=u.value;for(const I of v)this.taskTypes&&I.type&&this.taskTypes[I.type]&&delete this.taskTypes[I.type]}for(const u of h.added){const v=u.value;for(const I of v){const l=k.from(I,u.description.identifier,u.collector);l&&(this.taskTypes[l.taskType]=l)}}(h.removed.length>0||h.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}T(void 0)})})}onReady(){return this.readyPromise}get(T){return this.taskTypes[T]}all(){return Object.keys(this.taskTypes).map(T=>this.taskTypes[T])}getJsonSchema(){if(this._schema===void 0){const T=[];for(const f of this.all()){const c={type:"object",additionalProperties:!1};f.required.length>0&&(c.required=f.required.slice(0)),f.properties!==void 0?c.properties=w.deepClone(f.properties):c.properties=Object.create(null),c.properties.type={type:"string",enum:[f.taskType]},T.push(c)}this._schema={oneOf:T}}return this._schema}}e.TaskDefinitionRegistryImpl=S,e.TaskDefinitionRegistry=new S}),define(Ce[184],Ie([1,0,140,10,22,26,38,183]),function(te,e,r,y,w,L,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new _.RawContextKey("taskRunning",!1,r.localize(0,null)),e.TASKS_CATEGORY={value:r.localize(1,null),original:"Tasks"};var E;(function(R){R[R.Escape=1]="Escape",R[R.Strong=2]="Strong",R[R.Weak=3]="Weak"})(E=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(R){function K(W){if(!W)return R.Strong;switch(W.toLowerCase()){case"escape":return R.Escape;case"strong":return R.Strong;case"weak":return R.Weak;default:return R.Strong}}R.from=K}(E=e.ShellQuoting||(e.ShellQuoting={}));var k;(function(R){R.defaults={cwd:"${workspaceFolder}"}})(k=e.CommandOptions||(e.CommandOptions={}));var F;(function(R){R[R.Always=1]="Always",R[R.Silent=2]="Silent",R[R.Never=3]="Never"})(F=e.RevealKind||(e.RevealKind={})),function(R){function K(W){switch(W.toLowerCase()){case"always":return R.Always;case"silent":return R.Silent;case"never":return R.Never;default:return R.Always}}R.fromString=K}(F=e.RevealKind||(e.RevealKind={}));var S;(function(R){R[R.Never=1]="Never",R[R.OnProblem=2]="OnProblem",R[R.Always=3]="Always"})(S=e.RevealProblemKind||(e.RevealProblemKind={})),function(R){function K(W){switch(W.toLowerCase()){case"always":return R.Always;case"never":return R.Never;case"onproblem":return R.OnProblem;default:return R.OnProblem}}R.fromString=K}(S=e.RevealProblemKind||(e.RevealProblemKind={}));var m;(function(R){R[R.Shared=1]="Shared",R[R.Dedicated=2]="Dedicated",R[R.New=3]="New"})(m=e.PanelKind||(e.PanelKind={})),function(R){function K(W){switch(W.toLowerCase()){case"shared":return R.Shared;case"dedicated":return R.Dedicated;case"new":return R.New;default:return R.Shared}}R.fromString=K}(m=e.PanelKind||(e.PanelKind={}));var T;(function(R){R.defaults={echo:!0,reveal:F.Always,revealProblems:S.Never,focus:!1,panel:m.Shared,showReuseMessage:!0,clear:!1}})(T=e.PresentationOptions||(e.PresentationOptions={}));var f;(function(R){R[R.Shell=1]="Shell",R[R.Process=2]="Process",R[R.CustomExecution=3]="CustomExecution"})(f=e.RuntimeType||(e.RuntimeType={})),function(R){function K(O){switch(O.toLowerCase()){case"shell":return R.Shell;case"process":return R.Process;case"customExecution":return R.CustomExecution;default:return R.Process}}R.fromString=K;function W(O){switch(O){case R.Shell:return"shell";case R.Process:return"process";case R.CustomExecution:return"customExecution";default:return"process"}}R.toString=W}(f=e.RuntimeType||(e.RuntimeType={}));var c;(function(R){function K(W){return y.isString(W)?W:W.value}R.value=K})(c=e.CommandString||(e.CommandString={}));var h;(function(R){R.Clean={_id:"clean",isDefault:!1},R.Build={_id:"build",isDefault:!1},R.Rebuild={_id:"rebuild",isDefault:!1},R.Test={_id:"test",isDefault:!1};function K(O){return O===R.Clean._id||O===R.Build._id||O===R.Rebuild._id||O===R.Test._id}R.is=K;function W(O){if(O!==void 0)return y.isString(O)?K(O)?{_id:O,isDefault:!1}:void 0:O}R.from=W})(h=e.TaskGroup||(e.TaskGroup={}));var u;(function(R){R[R.Global=1]="Global",R[R.Workspace=2]="Workspace",R[R.Folder=3]="Folder"})(u=e.TaskScope||(e.TaskScope={}));var v;(function(R){R.Workspace="workspace",R.Extension="extension",R.InMemory="inMemory",R.WorkspaceFile="workspaceFile",R.User="user";function K(W){switch(W){case R.User:return 2;case R.WorkspaceFile:return 5;default:return 6}}R.toConfigurationTarget=K})(v=e.TaskSourceKind||(e.TaskSourceKind={}));var I;(function(R){R.parallel="parallel",R.sequence="sequence"})(I=e.DependsOrder||(e.DependsOrder={}));var l;(function(R){R[R.default=1]="default",R[R.folderOpen=2]="folderOpen"})(l=e.RunOnOptions||(e.RunOnOptions={}));var b;(function(R){R.defaults={reevaluateOnRerun:!0,runOn:l.default,instanceLimit:1}})(b=e.RunOptions||(e.RunOptions={}));class t{constructor(K,W,O,Z,ue,oe){this._label="",this._id=K,W&&(this._label=W),O&&(this.type=O),this.runOptions=Z,this.configurationProperties=ue,this._source=oe}getDefinition(K){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const K={folder:this.getFolderId(),id:this._id};return JSON.stringify(K)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(K,W=!1){if(K===void 0)return!1;if(y.isString(K))return K===this._label||K===this.configurationProperties.identifier||W&&K===this._id;const O=this.getDefinition(!0);return O!==void 0&&O._key===K._key}getQualifiedLabel(){const K=this.getWorkspaceFolder();return K?`${this._label} (${K.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(K){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),K&&(this._taskLoadMessages=this._taskLoadMessages.concat(K))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=t;class d extends t{constructor(K,W,O,Z,ue,oe,de,ie){super(K,O,void 0,de,ie,W),this.command={},this._source=W,this.hasDefinedMatchers=oe,ue&&(this.command=ue)}clone(){return new d(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(K=!1){if(K&&this._source.customizes!==void 0)return this._source.customizes;{let W;switch(this.command?this.command.runtime:void 0){case f.Shell:W="shell";break;case f.Process:W="process";break;case f.CustomExecution:W="customExecution";break;case void 0:W="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:W,_key:this._id,id:this._id}}}static is(K){return K instanceof d}getMapKey(){const K=this._source.config.workspaceFolder;return K?`${K.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===v.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const K=this.getFolderId();if(!K)return;let W=this.configurationProperties.identifier;this._source.kind!==v.Workspace&&(W+=this._source.kind);const O={type:e.CUSTOMIZED_TASK_TYPE,folder:K,id:W};return JSON.stringify(O)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?w.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(K){return new d(K._id,K._source,K._label,K.type,K.command,K.hasDefinedMatchers,K.runOptions,K.configurationProperties)}}e.CustomTask=d;class n extends t{constructor(K,W,O,Z,ue,oe,de){super(K,O,Z,oe,de,W),this._source=W,this.configures=ue}static is(K){return K instanceof n}fromObject(K){return K}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?w.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===v.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const K=this.getFolderId();if(!K)return;let W=this.configurationProperties.identifier;this._source.kind!==v.Workspace&&(W+=this._source.kind);const O={type:e.CUSTOMIZED_TASK_TYPE,folder:K,id:W};return JSON.stringify(O)}}e.ConfiguringTask=n;class i extends t{constructor(K,W,O,Z,ue,oe,de,ie,ve){super(K,O,Z,ie,ve,W),this.defines=ue,this.hasDefinedMatchers=de,this.command=oe,this.icon=ve.icon,this.hide=ve.hide}clone(){return new i(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(K){return K instanceof i}getMapKey(){const K=this._source.workspaceFolder;return K?`${this._source.scope.toString()}|${K.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const K={type:"contributed",scope:this._source.scope,id:this._id};return K.folder=this.getFolderId(),JSON.stringify(K)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(K){return new i(K._id,K._source,K._label,K.type,K.defines,K.command,K.hasDefinedMatchers,K.runOptions,K.configurationProperties)}}e.ContributedTask=i;class s extends t{constructor(K,W,O,Z,ue,oe){super(K,O,Z,ue,oe,W),this._source=W}clone(){return new s(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(K){return K instanceof s}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(K){return new s(K._id,K._source,K._label,K.type,K.runOptions,K.configurationProperties)}}e.InMemoryTask=s;var a;(function(R){R[R.Process=1]="Process",R[R.Terminal=2]="Terminal"})(a=e.ExecutionEngine||(e.ExecutionEngine={})),function(R){R._default=R.Terminal}(a=e.ExecutionEngine||(e.ExecutionEngine={}));var o;(function(R){R[R.V0_1_0=1]="V0_1_0",R[R.V2_0_0=2]="V2_0_0"})(o=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class g{constructor(K){this._order=new Map;for(let W=0;W<K.length;W++)this._order.set(K[W].uri.toString(),W)}compare(K,W){const O=K.getWorkspaceFolder(),Z=W.getWorkspaceFolder();if(O&&Z){let ue=this._order.get(O.uri.toString());ue=ue===void 0?0:ue+1;let oe=this._order.get(Z.uri.toString());return oe=oe===void 0?0:oe+1,ue===oe?K._label.localeCompare(W._label):ue-oe}else return!O&&Z?-1:O&&!Z?1:0}}e.TaskSorter=g;var p;(function(R){R.DependsOnStarted="dependsOnStarted",R.AcquiredInput="acquiredInput",R.Start="start",R.ProcessStarted="processStarted",R.Active="active",R.Inactive="inactive",R.Changed="changed",R.Terminated="terminated",R.ProcessEnded="processEnded",R.End="end"})(p=e.TaskEventKind||(e.TaskEventKind={}));var P;(function(R){R.SingleRun="singleRun",R.Background="background"})(P=e.TaskRunType||(e.TaskRunType={}));var M;(function(R){R[R.System=0]="System",R[R.User=1]="User",R[R.FolderOpen=2]="FolderOpen",R[R.ConfigurationChange=3]="ConfigurationChange",R[R.Reconnect=4]="Reconnect"})(M=e.TaskRunSource||(e.TaskRunSource={}));var V;(function(R){function K(W,O,Z,ue,oe){if(O){const de={kind:W,taskId:O._id,taskName:O.configurationProperties.name,runType:O.configurationProperties.isBackground?"background":"singleRun",group:O.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:void 0,__task:O};return W==="start"?(de.terminalId=Z,de.resolvedVariables=ue):W==="processStarted"?de.processId=Z:W==="processEnded"&&(de.exitCode=Z),Object.freeze(de)}else return Object.freeze({kind:"changed"})}R.create=K})(V=e.TaskEvent||(e.TaskEvent={}));var B;(function(R){function K(O){const Z=Object.keys(O).sort();let ue="";for(const oe of Z){let de=O[oe];de instanceof Object?de=K(de):typeof de=="string"&&(de=de.replace(/,/g,",,")),ue+=oe+","+de+","}return ue}function W(O){const ue={_key:K(O),type:O.taskType};return Object.assign(ue,O),ue}R.create=W})(B=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var D;(function(R){R.AutoDetect="task.autoDetect",R.SaveBeforeRun="task.saveBeforeRun",R.ShowDecorations="task.showDecorations",R.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",R.SlowProviderWarning="task.slowProviderWarning",R.QuickOpenHistory="task.quickOpen.history",R.QuickOpenDetail="task.quickOpen.detail",R.QuickOpenSkip="task.quickOpen.skip",R.QuickOpenShowAll="task.quickOpen.showAll",R.AllowAutomaticTasks="task.allowAutomaticTasks",R.Reconnection="task.reconnection"})(D=e.TaskSettingId||(e.TaskSettingId={}));var x;(function(R){R.Tasks="tasks",R.SuppressTaskName="tasks.suppressTaskName",R.Windows="tasks.windows",R.Osx="tasks.osx",R.Linux="tasks.linux",R.ShowOutput="tasks.showOutput",R.IsShellCommand="tasks.isShellCommand",R.ServiceTestSetting="tasks.service.testSetting"})(x=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var U;(function(R){function K(W,O){const Z=A.TaskDefinitionRegistry.get(W.type);if(Z===void 0){const ie=L.deepClone(W);return delete ie._key,B.create(ie)}const ue=Object.create(null);ue.type=Z.taskType;const oe=new Set;Z.required.forEach(ie=>oe.add(ie));const de=Z.properties;for(const ie of Object.keys(de)){const ve=W[ie];if(ve!=null)ue[ie]=ve;else if(oe.has(ie)){const be=de[ie];if(be.default!==void 0)ue[ie]=L.deepClone(be.default);else switch(be.type){case"boolean":ue[ie]=!1;break;case"number":case"integer":ue[ie]=0;break;case"string":ue[ie]="";break;default:O.error(r.localize(2,null,JSON.stringify(W,void 0,0),ie));return}}}return B.create(ue)}R.createTaskIdentifier=K})(U=e.TaskDefinition||(e.TaskDefinition={}))}),define(Ce[185],Ie([1,0,11]),function(te,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class y{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((_,A)=>{this._actualOk=_,this._actualErr=A,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(_){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=_,this._actual&&this._actualOk(_))}resolveErr(_){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=_,this._actual?this._actualErr(_):(0,r.onUnexpectedError)(_))}then(_,A){return this._ensureActual().then(_,A)}catch(_){return this._ensureActual().then(void 0,_)}finally(_){return this._ensureActual().finally(_)}}e.LazyPromise=y;class w extends y{constructor(){super(),this._hasErr=!0,this._err=new r.CancellationError}}e.CanceledLazyPromise=w}),define(Ce[40],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class r{constructor(E){this._proxyIdentifierBrand=void 0,this.sid=E,this.nid=++r.count}}e.ProxyIdentifier=r,r.count=0;const y=[];function w(A){const E=new r(A);return y[E.nid]=E,E}e.createProxyIdentifier=w;function L(A){return y[A].sid}e.getStringIdentifierForProxy=L;class _{constructor(E){this.value=E}}e.SerializableObjectWithBuffers=_}),define(Ce[4],Ie([1,0,40]),function(te,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var y;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(y=e.TextEditorRevealType||(e.TextEditorRevealType={}));var w;(function(c){c[c.UnknownInput=0]="UnknownInput",c[c.TextInput=1]="TextInput",c[c.TextDiffInput=2]="TextDiffInput",c[c.TextMergeInput=3]="TextMergeInput",c[c.NotebookInput=4]="NotebookInput",c[c.NotebookDiffInput=5]="NotebookDiffInput",c[c.CustomEditorInput=6]="CustomEditorInput",c[c.WebviewEditorInput=7]="WebviewEditorInput",c[c.TerminalEditorInput=8]="TerminalEditorInput",c[c.InteractiveEditorInput=9]="InteractiveEditorInput"})(w=e.TabInputKind||(e.TabInputKind={}));var L;(function(c){c[c.TAB_OPEN=0]="TAB_OPEN",c[c.TAB_CLOSE=1]="TAB_CLOSE",c[c.TAB_UPDATE=2]="TAB_UPDATE",c[c.TAB_MOVE=3]="TAB_MOVE"})(L=e.TabModelOperationKind||(e.TabModelOperationKind={}));var _;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(_=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var A;(function(c){c[c.Int8Array=1]="Int8Array",c[c.Uint8Array=2]="Uint8Array",c[c.Uint8ClampedArray=3]="Uint8ClampedArray",c[c.Int16Array=4]="Int16Array",c[c.Uint16Array=5]="Uint16Array",c[c.Int32Array=6]="Int32Array",c[c.Uint32Array=7]="Uint32Array",c[c.Float32Array=8]="Float32Array",c[c.Float64Array=9]="Float64Array",c[c.BigInt64Array=10]="BigInt64Array",c[c.BigUint64Array=11]="BigUint64Array"})(A=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var E;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})(E=e.CellOutputKind||(e.CellOutputKind={}));var k;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(k=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var F;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output"})(F=e.CandidatePortSource||(e.CandidatePortSource={}));class S{static mixin(h){return h._id=S._n++,h}}e.IdObject=S,S._n=0;var m;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.command="m",c.kindModifier="n"})(m=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var T;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(T=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var f;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(f=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,r.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,r.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,r.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,r.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,r.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,r.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,r.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,r.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,r.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,r.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,r.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,r.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,r.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,r.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,r.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,r.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,r.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,r.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,r.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,r.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,r.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,r.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,r.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,r.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,r.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,r.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,r.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,r.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,r.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,r.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,r.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,r.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,r.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,r.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,r.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,r.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,r.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,r.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,r.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,r.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,r.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,r.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,r.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,r.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,r.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,r.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,r.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,r.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,r.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,r.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,r.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,r.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,r.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,r.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,r.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,r.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,r.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,r.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,r.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,r.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,r.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,r.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,r.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,r.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,r.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,r.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,r.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,r.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,r.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,r.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,r.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,r.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,r.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,r.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,r.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,r.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,r.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,r.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,r.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,r.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,r.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,r.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,r.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,r.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,r.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,r.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,r.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,r.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,r.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,r.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,r.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,r.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,r.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,r.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,r.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,r.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,r.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,r.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,r.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,r.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,r.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,r.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,r.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,r.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,r.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,r.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,r.createProxyIdentifier)("ExtHostTelemetry")}}),define(Ce[67],Ie([1,0,3,15,4,13]),function(te,e,r,y,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,r.createDecorator)("IExtHostApiDeprecationService");let _=class{constructor(E,k){this._extHostLogService=k,this._reportedUsages=new Set,this._telemetryShape=E.getProxy(w.MainContext.MainThreadTelemetry)}report(E,k,F){const S=this.getUsageKey(E,k);this._reportedUsages.has(S)||(this._reportedUsages.add(S),k.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${E}' is deprecated. ${F}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:E}))}getUsageKey(E,k){return`${E}-${k.identifier.value}`}};_=ze([xe(0,L.IExtHostRpcService),xe(1,y.ILogService)],_),e.ExtHostApiDeprecationService=_,e.NullApiDeprecationService=Object.freeze(new class{report(A,E,k){}})}),define(Ce[186],Ie([1,0,5,4,6,27]),function(te,e,r,y,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class _{constructor(E){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new r.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=E.getProxy(y.MainContext.MainThreadAuthentication)}$setProviders(E){return this._providers=E,Promise.resolve()}async getSession(E,k,F,S={}){const m=L.ExtensionIdentifier.toKey(E.identifier),T=this._inFlightRequests.get(m)||[],f=[...F].sort().join(" ");let c=T.find(h=>h.providerId===k&&h.scopes===f);if(c)return c.result;{const h=this._getSession(E,m,k,F,S);c={providerId:k,scopes:f,result:h},T.push(c),this._inFlightRequests.set(m,T);try{await h}finally{const u=T.findIndex(v=>v.providerId===k&&v.scopes===f);u>-1&&(T.splice(u),this._inFlightRequests.set(m,T))}return h}}async _getSession(E,k,F,S,m={}){await this._proxy.$ensureProvider(F);const T=E.displayName||E.name;return this._proxy.$getSession(F,S,k,T,m)}async removeSession(E,k){const F=this._authenticationProviders.get(E);return F?F.provider.removeSession(k):this._proxy.$removeSession(E,k)}registerAuthenticationProvider(E,k,F,S){if(this._authenticationProviders.get(E))throw new Error(`An authentication provider with id '${E}' is already registered.`);this._authenticationProviders.set(E,{label:k,provider:F,options:S??{supportsMultipleAccounts:!1}}),this._providers.find(T=>T.id===E)||this._providers.push({id:E,label:k});const m=F.onDidChangeSessions(T=>{this._proxy.$sendDidChangeSessions(E,{added:T.added??[],changed:T.changed??[],removed:T.removed??[]})});return this._proxy.$registerAuthenticationProvider(E,k,S?.supportsMultipleAccounts??!1),new w.Disposable(()=>{m.dispose(),this._authenticationProviders.delete(E);const T=this._providers.findIndex(f=>f.id===E);T>-1&&this._providers.splice(T),this._proxy.$unregisterAuthenticationProvider(E)})}$createSession(E,k){const F=this._authenticationProviders.get(E);if(F)return Promise.resolve(F.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$removeSession(E,k){const F=this._authenticationProviders.get(E);if(F)return Promise.resolve(F.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$getSessions(E,k){const F=this._authenticationProviders.get(E);if(F)return Promise.resolve(F.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$onDidChangeAuthenticationSessions(E,k){return this._onDidChangeSessions.fire({provider:{id:E,label:k}}),Promise.resolve()}}e.ExtHostAuthentication=_}),define(Ce[187],Ie([1,0,4,13,8,24]),function(te,e,r,y,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let _=class{constructor(E,k){this._proxy=E.getProxy(r.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:F=>k.getDocument(F)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(E,k,F){const S=(0,L.isProposedApiEnabled)(k,"snippetWorkspaceEdit"),m=(0,L.isProposedApiEnabled)(k,"workspaceEditIsRefactoring");F&&!m&&(console.warn(`Extension '${k.identifier.value}' uses a proposed API 'workspaceEditIsRefactoring' which is NOT enabled for it`),F=void 0);const T=w.WorkspaceEdit.from(E,this._versionInformationProvider,S);return this._proxy.$tryApplyWorkspaceEdit(T,void 0,F)}};_=ze([xe(0,y.IExtHostRpcService)],_),e.ExtHostBulkEdits=_}),define(Ce[188],Ie([1,0,4]),function(te,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class y{constructor(L){const _=L.getProxy(r.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return _.$readText()},writeText(A){return _.$writeText(A)}})}}e.ExtHostClipboard=y});var Je=this&&this.__classPrivateFieldSet||function(te,e,r,y,w){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!w:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?w.call(te,r):w?w.value=r:e.set(te,r),r},Oe=this&&this.__classPrivateFieldGet||function(te,e,r,y){if(r==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?y:r==="a"?y.call(te):y?y.value:e.get(te)};define(Ce[36],Ie([1,0,10,6,8,26,4,16,15,75,49,242,2,7,3,13,94,23,40,43]),function(te,e,r,y,w,L,_,A,E,k,F,S,m,T,f,c,h,u,v,I){"use strict";var l,b;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let t=class{constructor(o,g){l.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,b.set(this,void 0),Je(this,l,o.getProxy(_.MainContext.MainThreadCommands),"f"),this._logService=g,Je(this,b,o.getProxy(_.MainContext.MainThreadTelemetry),"f"),this.converter=new d(this,p=>{const P=this._apiCommands.get(p);return P?.result===i.Void?P:void 0},g),this._argumentProcessors=[{processArgument(p){return(0,k.revive)(p)}},{processArgument(p){return(0,L.cloneAndChange)(p,function(P){if(F.Range.isIRange(P))return w.Range.to(P);if(S.Position.isIPosition(P))return w.Position.to(P);if(F.Range.isIRange(P.range)&&m.URI.isUri(P.uri))return w.location.to(P);if(P instanceof u.VSBuffer)return P.buffer.buffer;if(!Array.isArray(P))return P})}}]}registerArgumentProcessor(o){this._argumentProcessors.push(o)}registerApiCommand(o){const g=this.registerCommand(!1,o.id,async(...p)=>{const P=o.args.map((V,B)=>{if(!V.validate(p[B]))throw new Error(`Invalid argument '${V.name}' when running '${o.id}', received: ${p[B]}`);return V.convert(p[B])}),M=await this.executeCommand(o.internalId,...P);return o.result.convert(M,p,this.converter)},void 0,{description:o.description,args:o.args,returns:o.result.description});return this._apiCommands.set(o.id,o),new y.Disposable(()=>{g.dispose(),this._apiCommands.delete(o.id)})}registerCommand(o,g,p,P,M,V){if(this._logService.trace("ExtHostCommands#registerCommand",g),!g.trim().length)throw new Error("invalid id");if(this._commands.has(g))throw new Error(`command '${g}' already exists`);return this._commands.set(g,{callback:p,thisArg:P,description:M,extension:V}),o&&Oe(this,l,"f").$registerCommand(g),new y.Disposable(()=>{this._commands.delete(g)&&o&&Oe(this,l,"f").$unregisterCommand(g)})}executeCommand(o,...g){return this._logService.trace("ExtHostCommands#executeCommand",o),this._doExecuteCommand(o,g,!0)}async _doExecuteCommand(o,g,p){if(this._commands.has(o))return Oe(this,l,"f").$fireCommandActivationEvent(o),this._executeContributedCommand(o,g,!1);{let P=!1;const M=(0,L.cloneAndChange)(g,function(V){if(V instanceof y.Position)return w.Position.from(V);if(V instanceof y.Range)return w.Range.from(V);if(V instanceof y.Location)return w.location.from(V);if(y.NotebookRange.isNotebookRange(V))return w.NotebookRange.from(V);if(V instanceof ArrayBuffer)return P=!0,u.VSBuffer.wrap(new Uint8Array(V));if(V instanceof Uint8Array)return P=!0,u.VSBuffer.wrap(V);if(V instanceof u.VSBuffer)return P=!0,V;if(!Array.isArray(V))return V});try{const V=await Oe(this,l,"f").$executeCommand(o,P?new v.SerializableObjectWithBuffers(M):M,p);return(0,k.revive)(V)}catch(V){if(V instanceof Error&&V.message==="$executeCommand:retry")return this._doExecuteCommand(o,g,!1);throw V}}}async _executeContributedCommand(o,g,p){const P=this._commands.get(o);if(!P)throw new Error("Unknown command");this._reportTelemetry(P,o);const{callback:M,thisArg:V,description:B}=P;if(B)for(let D=0;D<B.args.length;D++)try{(0,r.validateConstraint)(g[D],B.args[D].constraint)}catch{throw new Error(`Running the contributed command: '${o}' failed. Illegal argument '${B.args[D].name}' - ${B.args[D].description}`)}try{return await M.apply(V,g)}catch(D){if(o===this.converter.delegatingCommandId){const x=this.converter.getActualCommand(...g);x&&(o=x.command)}throw this._logService.error(D,o,P.extension?.identifier),p?new class extends Error{constructor(){super((0,I.toErrorMessage)(D)),this.id=o,this.source=P.extension?.displayName??P.extension?.name}}:D}}_reportTelemetry(o,g){!o.extension||o.extension.isBuiltin||Oe(this,b,"f").$publicLog2("Extension:ActionExecuted",{extensionId:o.extension.identifier.value,id:g})}$executeContributedCommand(o,...g){return this._logService.trace("ExtHostCommands#$executeContributedCommand",o),this._commands.has(o)?(g=g.map(p=>this._argumentProcessors.reduce((P,M)=>M.processArgument(P),p)),this._executeContributedCommand(o,g,!0)):Promise.reject(new Error(`Contributed command '${o}' does not exist.`))}getCommands(o=!1){return this._logService.trace("ExtHostCommands#getCommands",o),Oe(this,l,"f").$getCommands().then(g=>(o&&(g=g.filter(p=>p[0]!=="_")),g))}$getContributedCommandHandlerDescriptions(){const o=Object.create(null);for(const[g,p]of this._commands){const{description:P}=p;P&&(o[g]=P)}return Promise.resolve(o)}};l=new WeakMap,b=new WeakMap,t=ze([xe(0,c.IExtHostRpcService),xe(1,E.ILogService)],t),e.ExtHostCommands=t,e.IExtHostCommands=(0,f.createDecorator)("IExtHostCommands");class d{constructor(o,g,p){this._commands=o,this._lookupApiCommand=g,this._logService=p,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(o,g){if(!o)return;const p={$ident:void 0,id:o.command,title:o.title,tooltip:o.tooltip};if(!o.command)return p;const P=this._lookupApiCommand(o.command);if(P)p.id=P.internalId,p.arguments=P.args.map((M,V)=>M.convert(o.arguments&&o.arguments[V]));else if((0,A.isNonEmptyArray)(o.arguments)){const M=++this._cachIdPool;this._cache.set(M,o),g.add((0,T.toDisposable)(()=>{this._cache.delete(M),this._logService.trace("CommandsConverter#DISPOSE",M)})),p.$ident=M,p.id=this.delegatingCommandId,p.arguments=[M],this._logService.trace("CommandsConverter#CREATE",o.command,M)}return p}fromInternal(o){return typeof o.$ident=="number"?this._cache.get(o.$ident):{command:o.id,title:o.title,arguments:o.arguments}}getActualCommand(...o){return this._cache.get(o[0])}_executeConvertedCommand(...o){const g=this.getActualCommand(...o);return this._logService.trace("CommandsConverter#EXECUTE",o[0],g?g.command:"MISSING"),g?this._commands.executeCommand(g.command,...g.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=d;class n{constructor(o,g,p,P){this.name=o,this.description=g,this.validate=p,this.convert=P}optional(){return new n(this.name,`(optional) ${this.description}`,o=>o==null||this.validate(o),o=>o===void 0?void 0:o===null?null:this.convert(o))}with(o,g){return new n(o??this.name,g??this.description,this.validate,this.convert)}}e.ApiCommandArgument=n,n.Uri=new n("uri","Uri of a text document",a=>m.URI.isUri(a),a=>a),n.Position=new n("position","A position in a text document",a=>y.Position.isPosition(a),w.Position.from),n.Range=new n("range","A range in a text document",a=>y.Range.isRange(a),w.Range.from),n.Selection=new n("selection","A selection in a text document",a=>y.Selection.isSelection(a),w.Selection.from),n.Number=new n("number","",a=>typeof a=="number",a=>a),n.String=new n("string","",a=>typeof a=="string",a=>a),n.CallHierarchyItem=new n("item","A call hierarchy item",a=>a instanceof y.CallHierarchyItem,w.CallHierarchyItem.from),n.TypeHierarchyItem=new n("item","A type hierarchy item",a=>a instanceof y.TypeHierarchyItem,w.TypeHierarchyItem.from),n.TestItem=new n("testItem","A VS Code TestItem",a=>a instanceof h.TestItemImpl,w.TestItem.from);class i{constructor(o,g){this.description=o,this.convert=g}}e.ApiCommandResult=i,i.Void=new i("no result",a=>a);class s{constructor(o,g,p,P,M){this.id=o,this.internalId=g,this.description=p,this.args=P,this.result=M}}e.ApiCommand=s}),define(Ce[189],Ie([1,0,2,8,6,66,36,16,78,82,12]),function(te,e,r,y,w,L,_,A,E,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const S=[new _.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",T(y.DocumentHighlight.to))),new _.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(c,h)=>{if((0,A.isFalsyOrEmpty)(c))return;class u extends w.SymbolInformation{static to(I){const l=new u(I.name,y.SymbolKind.to(I.kind),I.containerName||"",new w.Location(h[0],y.Range.to(I.range)));return l.detail=I.detail,l.range=l.location.range,l.selectionRange=y.Range.to(I.selectionRange),l.children=I.children?I.children.map(u.to):[],l}}return c.map(u.to)})),new _.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(y.TextEdit.to))),new _.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range,new _.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(y.TextEdit.to))),new _.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,new _.ApiCommandArgument("ch","Trigger character",c=>typeof c=="string",c=>c),new _.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(y.TextEdit.to))),new _.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new _.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new _.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new _.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new _.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location-instances.",T(y.location.to))),new _.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Hover-instances.",T(y.Hover.to))),new _.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("position","A position in a text document",c=>Array.isArray(c)&&c.every(h=>w.Position.isPosition(h)),c=>c.map(y.Position.from))],new _.ApiCommandResult("A promise that resolves to an array of ranges.",c=>c.map(h=>{let u;for(const v of h.reverse())u=new w.SelectionRange(y.Range.to(v),u);return u}))),new _.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[_.ApiCommandArgument.String.with("query","Search string")],new _.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",c=>c.map(y.WorkspaceSymbol.to))),new _.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(y.CallHierarchyItem.to))),new _.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[_.ApiCommandArgument.CallHierarchyItem],new _.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(y.CallHierarchyIncomingCall.to))),new _.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[_.ApiCommandArgument.CallHierarchyItem],new _.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(y.CallHierarchyOutgoingCall.to))),new _.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to a range and placeholder text.",c=>{if(!!c)return{range:y.Range.to(c.range),placeholder:c.text}})),new _.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("newName","The new symbol name")],new _.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",c=>{if(!!c){if(c.rejectReason)throw new Error(c.rejectReason);return y.WorkspaceEdit.to(c)}})),new _.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new _.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",c=>c.map(y.DocumentLink.to))),new _.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",c=>{if(!!c)return new w.SemanticTokensLegend(c.tokenTypes,c.tokenModifiers)})),new _.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const h=(0,E.decodeSemanticTokensDto)(c);if(h.type==="full")return new w.SemanticTokens(h.data,void 0)})),new _.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range.optional()],new _.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",c=>{if(!!c)return new w.SemanticTokensLegend(c.tokenTypes,c.tokenModifiers)})),new _.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const h=(0,E.decodeSemanticTokensDto)(c);if(h.type==="full")return new w.SemanticTokens(h.data,void 0)})),new _.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),_.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new _.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(c,h,u)=>{if(!c)return new w.CompletionList([]);const v=c.suggestions.map(I=>y.CompletionItem.to(I,u));return new w.CompletionList(v,c.incomplete)})),new _.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new _.ApiCommandResult("A promise that resolves to SignatureHelp.",c=>{if(c)return y.SignatureHelp.to(c)})),new _.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new _.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(c,h,u)=>T(v=>new w.CodeLens(y.Range.to(v.range),v.command&&u.fromInternal(v.command)))(c))),new _.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",c=>w.Range.isRange(c),c=>w.Selection.isSelection(c)?y.Selection.from(c):y.Range.from(c)),_.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),_.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new _.ApiCommandResult("A promise that resolves to an array of Command-instances.",(c,h,u)=>T(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return u.fromInternal(v.command)}else{const I=new w.CodeAction(v.title,v.kind?new w.CodeActionKind(v.kind):void 0);return v.edit&&(I.edit=y.WorkspaceEdit.to(v.edit)),v.command&&(I.command=u.fromInternal(v.command)),I.isPreferred=v.isPreferred,I}})(c))),new _.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",c=>c?c.map(h=>new w.ColorInformation(y.Range.to(h.range),y.Color.to(h.color))):[])),new _.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new _.ApiCommandArgument("color","The color to show and insert",c=>c instanceof w.Color,y.Color.from),new _.ApiCommandArgument("context","Context object with uri and range",c=>!0,c=>({uri:c.uri,range:y.Range.from(c.range)}))],new _.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",c=>c?c.map(y.ColorPresentation.to):[])),new _.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to an array of Inlay objects",(c,h,u)=>c.map(y.InlayHint.to.bind(void 0,u)))),new _.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new _.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",T(c=>({viewType:c.viewType,displayName:c.displayName,options:{transientOutputs:c.options.transientOutputs,transientCellMetadata:c.options.transientCellMetadata,transientDocumentMetadata:c.options.transientDocumentMetadata},filenamePattern:c.filenamePattern.map(h=>y.NotebookExclusiveDocumentPattern.to(h))})))),new _.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to an array of InlineValue objects",c=>c.map(y.InlineValue.to))),new _.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new _.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",c=>r.URI.isUri(c)||typeof c=="string"&&(0,k.matchesSomeScheme)(c,F.Schemas.http,F.Schemas.https),c=>c),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[y.ViewColumn.from(c),void 0]:[y.ViewColumn.from(c.viewColumn),y.TextEditorOpenOptions.from(c)])).optional(),_.ApiCommandArgument.String.with("label","").optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[_.ApiCommandArgument.Uri.with("resource","Resource to open"),_.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[y.ViewColumn.from(c),void 0]:[y.ViewColumn.from(c.viewColumn),y.TextEditorOpenOptions.from(c)])).optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[_.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),_.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),_.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="object",c=>c&&[y.ViewColumn.from(c.viewColumn),y.TextEditorOpenOptions.from(c)]).optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(y.TypeHierarchyItem.to))),new _.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[_.ApiCommandArgument.TypeHierarchyItem],new _.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(y.TypeHierarchyItem.to))),new _.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[_.ApiCommandArgument.TypeHierarchyItem],new _.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(y.TypeHierarchyItem.to))),new _.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[_.ApiCommandArgument.TestItem],_.ApiCommandResult.Void),new _.ApiCommand("vscode.experimental.editSession.continue","_workbench.experimental.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[_.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],_.ApiCommandResult.Void)];class m{static register(h){S.forEach(h.registerApiCommand,h)}}e.ExtHostApiCommands=m;function T(c){return h=>{if(Array.isArray(h))return h.map(c)}}function f(c){if(!Array.isArray(c))return;const h=[];for(const u of c)L.isLocationLink(u)?h.push(y.DefinitionLink.to(u)):h.push(y.location.to(u));return h}}),define(Ce[190],Ie([1,0,14,55,5,7,2,66,27,8,6,24,4]),function(te,e,r,y,w,L,_,A,E,k,F,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function T(f,c,h){const u=f.getProxy(m.MainContext.MainThreadComments);class v{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,c.registerArgumentProcessor({processArgument:a=>{if(a&&a.$mid===6){const o=this._commentControllers.get(a.handle);return o?o.value:a}else if(a&&a.$mid===7){const o=this._commentControllers.get(a.commentControlHandle);if(!o)return a;const g=o.getCommentThread(a.commentThreadHandle);return g?g.value:a}else if(a&&a.$mid===8){const o=this._commentControllers.get(a.thread.commentControlHandle);if(!o)return a;const g=o.getCommentThread(a.thread.commentThreadHandle);return g?{thread:g.value,text:a.text}:a}else if(a&&a.$mid===9){const o=this._commentControllers.get(a.thread.commentControlHandle);if(!o)return a;const g=o.getCommentThread(a.thread.commentThreadHandle);if(!g)return a;const p=a.commentUniqueId,P=g.getCommentByUniqueId(p);return P||a}else if(a&&a.$mid===10){const o=this._commentControllers.get(a.thread.commentControlHandle);if(!o)return a;const g=o.getCommentThread(a.thread.commentThreadHandle);if(!g)return a;const p=a.text,P=a.commentUniqueId,M=g.getCommentByUniqueId(P);return M?(typeof M.body=="string"?M.body=p:M.body.value=p,M):a}return a}})}createCommentController(a,o,g){const p=v.handlePool++,P=new l(a,p,o,g);this._commentControllers.set(P.handle,P);const M=this._commentControllersByExtension.get(E.ExtensionIdentifier.toKey(a.identifier))||[];return M.push(P),this._commentControllersByExtension.set(E.ExtensionIdentifier.toKey(a.identifier),M),P.value}$createCommentThreadTemplate(a,o,g){const p=this._commentControllers.get(a);!p||p.$createCommentThreadTemplate(o,g)}async $updateCommentThreadTemplate(a,o,g){const p=this._commentControllers.get(a);!p||p.$updateCommentThreadTemplate(o,g)}$deleteCommentThread(a,o){this._commentControllers.get(a)?.$deleteCommentThread(o)}$provideCommentingRanges(a,o,g){const p=this._commentControllers.get(a);if(!p||!p.commentingRangeProvider)return Promise.resolve(void 0);const P=h.getDocument(_.URI.revive(o));return(0,r.asPromise)(()=>p.commentingRangeProvider.provideCommentingRanges(P,g)).then(M=>M?M.map(V=>k.Range.from(V)):void 0)}$toggleReaction(a,o,g,p,P){const M=this._commentControllers.get(a);return!M||!M.reactionHandler?Promise.resolve(void 0):(0,r.asPromise)(()=>{const V=M.getCommentThread(o);if(V){const B=V.getCommentByUniqueId(p.uniqueIdInThread);if(M!==void 0&&B&&M.reactionHandler)return M.reactionHandler(B,d(P))}return Promise.resolve(void 0)})}dispose(){}}v.handlePool=0;class I{constructor(a,o,g,p,P,M,V,B){this._commentControllerHandle=o,this._id=g,this._uri=p,this._range=P,this._comments=M,this.extensionDescription=V,this._isTemplate=B,this.handle=I._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new w.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new L.MutableDisposable,this._acceptInputDisposables.value=new L.DisposableStore,this._id===void 0&&(this._id=`${a}.${this.handle}`),u.$createCommentThread(o,this.handle,this._id,this._uri,k.Range.from(this._range),V.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=M,this._localDisposables.push({dispose:()=>{u.$deleteCommentThread(o,this.handle)}});const D=this;this.value={get uri(){return D.uri},get range(){return D.range},set range(x){D.range=x},get comments(){return D.comments},set comments(x){D.comments=x},get collapsibleState(){return D.collapsibleState},set collapsibleState(x){D.collapsibleState=x},get canReply(){return D.canReply},set canReply(x){D.canReply=x},get contextValue(){return D.contextValue},set contextValue(x){D.contextValue=x},get label(){return D.label},set label(x){D.label=x},get state(){return D.state},set state(x){D.state=x},dispose:()=>{D.dispose()}}}set threadId(a){this._id=a}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(a){a.isEqual(this._range)||(this._range=a,this.modifications.range=a,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(a){this._canReply!==a&&(this._canReply=a,this.modifications.canReply=a,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(a){this._label=a,this.modifications.label=a,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(a){this._contextValue=a,this.modifications.contextValue=a,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(a){this._comments=a,this.modifications.comments=a,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(a){this._collapseState=a,this.modifications.collapsibleState=a,this._onDidUpdateCommentThread.fire()}get state(){return(0,S.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state}set state(a){(0,S.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state=a,this.modifications.state=a,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new L.DisposableStore);const a=g=>Object.prototype.hasOwnProperty.call(this.modifications,g),o={};a("range")&&(o.range=k.Range.from(this._range)),a("label")&&(o.label=this.label),a("contextValue")&&(o.contextValue=this.contextValue??null),a("comments")&&(o.comments=this._comments.map(g=>b(this,g,this._commentsMap))),a("collapsibleState")&&(o.collapseState=n(this._collapseState)),a("canReply")&&(o.canReply=this.canReply),a("state")&&(o.state=i(this._state)),a("isTemplate")&&(o.isTemplate=this._isTemplate),this.modifications={},u.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,o)}getCommentByUniqueId(a){for(const o of this._commentsMap){const g=o[0],p=o[1];if(a===p)return g}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(a=>a.dispose())}}I._handlePool=0,ze([(0,y.debounce)(100)],I.prototype,"eventuallyUpdateCommentThread",null);class l{constructor(a,o,g,p){this._extension=a,this._handle=o,this._id=g,this._label=p,this._threads=new Map,u.$registerCommentController(this.handle,g,p);const P=this;this.value=Object.freeze({id:P.id,label:P.label,get options(){return P.options},set options(M){P.options=M},get commentingRangeProvider(){return P.commentingRangeProvider},set commentingRangeProvider(M){P.commentingRangeProvider=M},get reactionHandler(){return P.reactionHandler},set reactionHandler(M){P.reactionHandler=M},createCommentThread(M,V,B){return P.createCommentThread(M,V,B).value},dispose:()=>{P.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{u.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(a){this._commentingRangeProvider=a,u.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(a){this._reactionHandler=a,u.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!a})}get options(){return this._options}set options(a){this._options=a,u.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(a,o,g,p){if(typeof a=="string"){const P=new I(this.id,this.handle,a,o,g,p,this._extension,!1);return this._threads.set(P.handle,P),P}else{const P=new I(this.id,this.handle,void 0,a,o,g,this._extension,!1);return this._threads.set(P.handle,P),P}}$createCommentThreadTemplate(a,o){const g=new I(this.id,this.handle,void 0,_.URI.revive(a),k.Range.to(o),[],this._extension,!0);return g.collapsibleState=A.CommentThreadCollapsibleState.Expanded,this._threads.set(g.handle,g),g}$updateCommentThreadTemplate(a,o){const g=this._threads.get(a);g&&(g.range=k.Range.to(o))}$deleteCommentThread(a){this._threads.get(a)?.dispose(),this._threads.delete(a)}getCommentThread(a){return this._threads.get(a)}dispose(){this._threads.forEach(a=>{a.dispose()}),this._localDisposables.forEach(a=>a.dispose())}}function b(s,a,o){let g=o.get(a);g||(g=++s.commentHandle,o.set(a,g));const p=a.author&&a.author.iconPath?a.author.iconPath.toString():void 0;return{mode:a.mode,contextValue:a.contextValue,uniqueIdInThread:g,body:typeof a.body=="string"?a.body:k.MarkdownString.from(a.body),userName:a.author.name,userIconPath:p,label:a.label,commentReactions:a.reactions?a.reactions.map(P=>t(P)):void 0,timestamp:a.timestamp?.toJSON()}}function t(s){return{label:s.label,iconPath:s.iconPath?k.pathOrURIToURI(s.iconPath):void 0,count:s.count,hasReacted:s.authorHasReacted}}function d(s){return{label:s.label||"",count:s.count||0,iconPath:s.iconPath?_.URI.revive(s.iconPath):"",authorHasReacted:s.hasReacted||!1}}function n(s){if(s!==void 0)switch(s){case F.CommentThreadCollapsibleState.Expanded:return A.CommentThreadCollapsibleState.Expanded;case F.CommentThreadCollapsibleState.Collapsed:return A.CommentThreadCollapsibleState.Collapsed}return A.CommentThreadCollapsibleState.Collapsed}function i(s){if(s!==void 0)switch(s){case F.CommentThreadState.Unresolved:return A.CommentThreadState.Unresolved;case F.CommentThreadState.Resolved:return A.CommentThreadState.Resolved}return A.CommentThreadState.Unresolved}return new v}e.createExtHostComments=T}),define(Ce[191],Ie([1,0,26,4,28,13]),function(te,e,r,y,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let _=class{constructor(F,S){this._mainThreadConsole=F.getProxy(y.MainContext.MainThreadConsole),this._includeStack=S.consoleForward.includeStack,this._logNative=S.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(F,S){const m=this,T=console[F];Object.defineProperty(console,F,{set:()=>{},get:()=>function(){m._handleConsoleCall(F,S,T,arguments)}})}_handleConsoleCall(F,S,m,T){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:S,arguments:E(T,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(F,m,T)}};_=ze([xe(0,L.IExtHostRpcService),xe(1,w.IExtHostInitDataService)],_),e.AbstractExtHostConsoleForwarder=_;const A=1e5;function E(k,F){const S=[];if(k.length)for(let m=0;m<k.length;m++){let T=k[m];if(typeof T>"u")T="undefined";else if(T instanceof Error){const f=T;f.stack?T=f.stack:T=f.toString()}S.push(T)}if(F){const m=new Error().stack;m&&S.push({__$stack:m.split(`
`).slice(3).join(`
`)})}try{const m=(0,r.safeStringify)(S);return m.length>A?"Output omitted for a large object that exceeds the limits":m}catch(m){return`Output omitted for an object that cannot be inspected ('${m.toString()}')`}}}),define(Ce[96],Ie([1,0,2,4,6,3,13,15,16,9,19]),function(te,e,r,y,w,L,_,A,E,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let S=class Pi{constructor(T,f){this._logService=f,this._provider=new Map,this._proxy=T.getProxy(y.MainContext.MainThreadDecorations)}registerFileDecorationProvider(T,f){const c=Pi._handlePool++;this._provider.set(c,{provider:T,extensionId:f}),this._proxy.$registerDecorationProvider(c,f.value);const h=T.onDidChangeFileDecorations&&T.onDidChangeFileDecorations(u=>{if(!u){this._proxy.$onDidChange(c,null);return}const v=(0,E.asArray)(u);if(v.length<=Pi._maxEventSize){this._proxy.$onDidChange(c,v);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",f.value,v.length);const I=v.map(t=>({uri:t,rank:(0,k.count)(t.path,"/")})),l=(0,E.groupBy)(I,(t,d)=>t.rank-d.rank||(0,k.compare)(t.uri.path,d.uri.path)),b=[];e:for(const t of l){let d;for(const n of t){const i=(0,F.dirname)(n.uri.path);if(d!==i&&(d=i,b.push(n.uri)>=Pi._maxEventSize))break e}}this._proxy.$onDidChange(c,b)});return new w.Disposable(()=>{h?.dispose(),this._proxy.$unregisterDecorationProvider(c),this._provider.delete(c)})}async $provideDecorations(T,f,c){if(!this._provider.has(T))return Object.create(null);const h=Object.create(null),{provider:u,extensionId:v}=this._provider.get(T);return await Promise.all(f.map(async I=>{try{const{uri:l,id:b}=I,t=await Promise.resolve(u.provideFileDecoration(r.URI.revive(l),c));if(!t)return;try{w.FileDecoration.validate(t),h[b]=[t.propagate,t.tooltip,t.badge,t.color]}catch(d){this._logService.warn(`INVALID decoration from extension '${v.value}': ${d}`)}}catch(l){this._logService.error(l)}})),h}};S._handlePool=0,S._maxEventSize=250,S=ze([xe(0,_.IExtHostRpcService),xe(1,A.ILogService)],S),e.ExtHostDecorations=S,e.IExtHostDecorations=(0,L.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(te,e,r,y,w){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!w:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?w.call(te,r):w?w.value=r:e.set(te,r),r},Oe=this&&this.__classPrivateFieldGet||function(te,e,r,y){if(r==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?y:r==="a"?y.call(te):y?y.value:e.get(te)};define(Ce[192],Ie([1,0,129,81,2,4,6,8,5,15,25,35]),function(te,e,r,y,w,L,_,A,E,k,F,S){"use strict";var m,T,f;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class c{constructor(v,I,l,b,t,d){this._name=v,this._owner=I,this._maxDiagnosticsPerFile=l,m.set(this,void 0),T.set(this,void 0),f.set(this,void 0),this._isDisposed=!1,Je(this,f,new F.ResourceMap(n=>b.getComparisonKey(n)),"f"),Je(this,m,t,"f"),Je(this,T,d,"f")}dispose(){this._isDisposed||(Oe(this,T,"f").fire([...Oe(this,f,"f").keys()]),Oe(this,m,"f")?.$clear(this._owner),Oe(this,f,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(v,I){if(!v){this.clear();return}this._checkDisposed();let l=[];if(w.URI.isUri(v)){if(!I){this.delete(v);return}Oe(this,f,"f").set(v,I.slice()),l=[v]}else if(Array.isArray(v)){l=[];let t;v=[...v].sort(c._compareIndexedTuplesByUri);for(const d of v){const[n,i]=d;if((!t||n.toString()!==t.toString())&&(t&&Oe(this,f,"f").get(t).length===0&&Oe(this,f,"f").delete(t),t=n,l.push(n),Oe(this,f,"f").set(n,[])),i)Oe(this,f,"f").get(n)?.push(...i);else{const s=Oe(this,f,"f").get(n);s&&(s.length=0)}}}if(Oe(this,T,"f").fire(l),!Oe(this,m,"f"))return;const b=[];for(const t of l){let d=[];const n=Oe(this,f,"f").get(t);if(n)if(n.length>this._maxDiagnosticsPerFile){d=[];const i=[_.DiagnosticSeverity.Error,_.DiagnosticSeverity.Warning,_.DiagnosticSeverity.Information,_.DiagnosticSeverity.Hint];e:for(let s=0;s<4;s++)for(const a of n)if(a.severity===i[s]&&d.push(A.Diagnostic.from(a))===this._maxDiagnosticsPerFile)break e;d.push({severity:y.MarkerSeverity.Info,message:(0,r.localize)(0,null,n.length-this._maxDiagnosticsPerFile),startLineNumber:d[d.length-1].startLineNumber,startColumn:d[d.length-1].startColumn,endLineNumber:d[d.length-1].endLineNumber,endColumn:d[d.length-1].endColumn})}else d=n.map(i=>A.Diagnostic.from(i));b.push([t,d])}Oe(this,m,"f").$changeMany(this._owner,b)}delete(v){this._checkDisposed(),Oe(this,T,"f").fire([v]),Oe(this,f,"f").delete(v),Oe(this,m,"f")?.$changeMany(this._owner,[[v,void 0]])}clear(){this._checkDisposed(),Oe(this,T,"f").fire([...Oe(this,f,"f").keys()]),Oe(this,f,"f").clear(),Oe(this,m,"f")?.$clear(this._owner)}forEach(v,I){this._checkDisposed();for(const[l,b]of this)v.call(I,l,b,this)}*[(m=new WeakMap,T=new WeakMap,f=new WeakMap,Symbol.iterator)](){this._checkDisposed();for(const v of Oe(this,f,"f").keys())yield[v,this.get(v)]}get(v){this._checkDisposed();const I=Oe(this,f,"f").get(v);return Array.isArray(I)?Object.freeze(I.slice(0)):[]}has(v){return this._checkDisposed(),Array.isArray(Oe(this,f,"f").get(v))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(v,I){return v[0].toString()<I[0].toString()?-1:v[0].toString()>I[0].toString()?1:0}}e.DiagnosticCollection=c;let h=class mi{constructor(v,I,l){this._logService=I,this._fileSystemInfoService=l,this._collections=new Map,this._onDidChangeDiagnostics=new E.DebounceEmitter({merge:b=>b.flat(),delay:50}),this.onDidChangeDiagnostics=E.Event.map(this._onDidChangeDiagnostics.event,mi._mapper),this._proxy=v.getProxy(L.MainContext.MainThreadDiagnostics)}static _mapper(v){const I=new F.ResourceMap;for(const l of v)I.set(l,l);return{uris:Object.freeze(Array.from(I.values()))}}createDiagnosticCollection(v,I){const{_collections:l,_proxy:b,_onDidChangeDiagnostics:t,_logService:d,_fileSystemInfoService:n}=this,i=new class{$changeMany(o,g){b.$changeMany(o,g),d.trace("[DiagnosticCollection] change many (extension, owner, uris)",v.value,o,g.length===0?"CLEARING":g)}$clear(o){b.$clear(o),d.trace("[DiagnosticCollection] remove all (extension, owner)",v.value,o)}dispose(){b.dispose()}};let s;if(!I)I="_generated_diagnostic_collection_name_#"+mi._idPool++,s=I;else if(!l.has(I))s=I;else{this._logService.warn(`DiagnosticCollection with name '${I}' does already exist.`);do s=I+mi._idPool++;while(l.has(s))}return new class extends c{constructor(){super(I,s,mi._maxDiagnosticsPerFile,n.extUri,i,t),l.set(s,this)}dispose(){super.dispose(),l.delete(s)}}}getDiagnostics(v){if(v)return this._getDiagnostics(v);{const I=new Map,l=[];for(const b of this._collections.values())b.forEach((t,d)=>{let n=I.get(t.toString());typeof n>"u"&&(n=l.length,I.set(t.toString(),n),l.push([t,[]])),l[n][1]=l[n][1].concat(...d)});return l}}_getDiagnostics(v){let I=[];for(const l of this._collections.values())l.has(v)&&(I=I.concat(l.get(v)));return I}$acceptMarkersChange(v){if(!this._mirrorCollection){const I="_generated_mirror",l=new c(I,I,mi._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(I,l),this._mirrorCollection=l}for(const[I,l]of v)this._mirrorCollection.set(w.URI.revive(I),l.map(A.Diagnostic.to))}};h._idPool=0,h._maxDiagnosticsPerFile=1e3,h=ze([xe(1,k.ILogService),xe(2,S.IExtHostFileSystemInfo)],h),e.ExtHostDiagnostics=h}),define(Ce[193],Ie([1,0,2,4]),function(te,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class w{constructor(_){this._proxy=_.getProxy(y.MainContext.MainThreadDialogs)}showOpenDialog(_){return this._proxy.$showOpenDialog(_).then(A=>A?A.map(E=>r.URI.revive(E)):void 0)}showSaveDialog(_){return this._proxy.$showSaveDialog(_).then(A=>A?r.URI.revive(A):void 0)}}e.ExtHostDialogs=w}),define(Ce[194],Ie([1,0,11,2,6,4,12,20,9]),function(te,e,r,y,w,L,_,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(S,m,T){this._documentsAndEditors=m,this._logService=T,this._documentContentProviders=new Map,this._proxy=S.getProxy(L.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(S,m){if(Object.keys(_.Schemas).indexOf(S)>=0)throw new Error(`scheme '${S}' already registered`);const T=k._handlePool++;this._documentContentProviders.set(T,m),this._proxy.$registerTextContentProvider(T,S);let f;return typeof m.onDidChange=="function"&&(f=m.onDidChange(c=>{if(c.scheme!==S){this._logService.warn(`Provider for scheme '${S}' is firing event for schema '${c.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(c)&&this.$provideTextDocumentContent(T,c).then(h=>{if(!h&&typeof h!="string")return;const u=this._documentsAndEditors.getDocument(c);if(!u)return;const v=(0,E.splitLines)(h);if(!u.equalLines(v))return this._proxy.$onVirtualDocumentChange(c,h)},r.onUnexpectedError)})),new w.Disposable(()=>{this._documentContentProviders.delete(T)&&this._proxy.$unregisterTextContentProvider(T),f&&(f.dispose(),f=void 0)})}$provideTextDocumentContent(S,m){const T=this._documentContentProviders.get(S);return T?Promise.resolve(T.provideTextDocumentContent(y.URI.revive(m),A.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${m.scheme}`))}}e.ExtHostDocumentContentProvider=k,k._handlePool=0}),define(Ce[195],Ie([1,0,5,7,2,4,92,8,10,26,6]),function(te,e,r,y,w,L,_,A,E,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class S{constructor(T,f){this._onDidAddDocument=new r.Emitter,this._onDidRemoveDocument=new r.Emitter,this._onDidChangeDocument=new r.Emitter,this._onDidSaveDocument=new r.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new y.DisposableStore,this._documentLoader=new Map,this._proxy=T.getProxy(L.MainContext.MainThreadDocuments),this._documentsAndEditors=f,this._documentsAndEditors.onDidRemoveDocuments(c=>{for(const h of c)this._onDidRemoveDocument.fire(h.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(c=>{for(const h of c)this._onDidAddDocument.fire(h.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(T){if(!T)return;const f=this._documentsAndEditors.getDocument(T);if(f)return f}getDocument(T){const f=this.getDocumentData(T);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${T}'`);return f.document}ensureDocumentData(T){const f=this._documentsAndEditors.getDocument(T);if(f)return Promise.resolve(f);let c=this._documentLoader.get(T.toString());return c||(c=this._proxy.$tryOpenDocument(T).then(h=>{this._documentLoader.delete(T.toString());const u=w.URI.revive(h);return(0,E.assertIsDefined)(this._documentsAndEditors.getDocument(u))},h=>(this._documentLoader.delete(T.toString()),Promise.reject(h))),this._documentLoader.set(T.toString(),c)),c}createDocumentData(T){return this._proxy.$tryCreateDocument(T).then(f=>w.URI.revive(f))}$acceptModelLanguageChanged(T,f){const c=w.URI.revive(T),h=this._documentsAndEditors.getDocument(c);if(!h)throw new Error("unknown document");this._onDidRemoveDocument.fire(h.document),h._acceptLanguageId(f),this._onDidAddDocument.fire(h.document)}$acceptModelSaved(T){const f=w.URI.revive(T),c=this._documentsAndEditors.getDocument(f);if(!c)throw new Error("unknown document");this.$acceptDirtyStateChanged(T,!1),this._onDidSaveDocument.fire(c.document)}$acceptDirtyStateChanged(T,f){const c=w.URI.revive(T),h=this._documentsAndEditors.getDocument(c);if(!h)throw new Error("unknown document");h._acceptIsDirty(f),this._onDidChangeDocument.fire({document:h.document,contentChanges:[],reason:void 0})}$acceptModelChanged(T,f,c){const h=w.URI.revive(T),u=this._documentsAndEditors.getDocument(h);if(!u)throw new Error("unknown document");u._acceptIsDirty(c),u.onEvents(f);let v;f.isUndoing?v=F.TextDocumentChangeReason.Undo:f.isRedoing&&(v=F.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,k.deepFreeze)({document:u.document,contentChanges:f.changes.map(I=>({range:A.Range.to(I.range),rangeOffset:I.rangeOffset,rangeLength:I.rangeLength,text:I.text})),reason:v}))}setWordDefinitionFor(T,f){(0,_.setWordDefinitionFor)(T,f)}}e.ExtHostDocuments=S}),define(Ce[50],Ie([1,0,44,5,7,2,3,4,92,13,95,8,15,25,12,165,196]),function(te,e,r,y,w,L,_,A,E,k,F,S,m,T,f,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class u{constructor(l){this.value=l,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let v=class{constructor(l,b){this._extHostRpc=l,this._logService=b,this._activeEditorId=null,this._editors=new Map,this._documents=new T.ResourceMap,this._onDidAddDocuments=new y.Emitter,this._onDidRemoveDocuments=new y.Emitter,this._onDidChangeVisibleTextEditors=new y.Emitter,this._onDidChangeActiveTextEditor=new y.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(l){this.acceptDocumentsAndEditorsDelta(l)}acceptDocumentsAndEditorsDelta(l){const b=[],t=[],d=[];if(l.removedDocuments)for(const n of l.removedDocuments){const i=L.URI.revive(n),s=this._documents.get(i);s?.unref()&&(this._documents.delete(i),b.push(s.value))}if(l.addedDocuments)for(const n of l.addedDocuments){const i=L.URI.revive(n.uri);let s=this._documents.get(i);if(s&&i.scheme!==f.Schemas.vscodeNotebookCell&&i.scheme!==f.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);s||(s=new u(new E.ExtHostDocumentData(this._extHostRpc.getProxy(A.MainContext.MainThreadDocuments),i,n.lines,n.EOL,n.versionId,n.languageId,n.isDirty,n.notebook)),this._documents.set(i,s),t.push(s.value)),s.ref()}if(l.removedEditors)for(const n of l.removedEditors){const i=this._editors.get(n);this._editors.delete(n),i&&d.push(i)}if(l.addedEditors)for(const n of l.addedEditors){const i=L.URI.revive(n.documentUri);r.ok(this._documents.has(i),`document '${i}' does not exist`),r.ok(!this._editors.has(n.id),`editor '${n.id}' already exists!`);const s=this._documents.get(i).value,a=new F.ExtHostTextEditor(n.id,this._extHostRpc.getProxy(A.MainContext.MainThreadTextEditors),this._logService,new h.Lazy(()=>s.document),n.selections.map(S.Selection.to),n.options,n.visibleRanges.map(o=>S.Range.to(o)),typeof n.editorPosition=="number"?S.ViewColumn.to(n.editorPosition):void 0);this._editors.set(n.id,a)}l.newActiveEditor!==void 0&&(r.ok(l.newActiveEditor===null||this._editors.has(l.newActiveEditor),`active editor '${l.newActiveEditor}' does not exist`),this._activeEditorId=l.newActiveEditor),(0,w.dispose)(b),(0,w.dispose)(d),l.removedDocuments&&this._onDidRemoveDocuments.fire(b),l.addedDocuments&&this._onDidAddDocuments.fire(t),(l.removedEditors||l.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(n=>n.value)),l.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(l){return this._documents.get(l)?.value}allDocuments(){return c.Iterable.map(this._documents.values(),l=>l.value)}getEditor(l){return this._editors.get(l)}activeEditor(l){if(!this._activeEditorId)return;const b=this._editors.get(this._activeEditorId);return l?b:b?.value}allEditors(){return[...this._editors.values()]}};v=ze([xe(0,k.IExtHostRpcService),xe(1,m.ILogService)],v),e.ExtHostDocumentsAndEditors=v,e.IExtHostDocumentsAndEditors=(0,_.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ce[51],Ie([1,0,8,4,2,5,3,6,13,10,72]),function(te,e,r,y,w,L,_,A,E,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,_.createDecorator)("IExtHostEditorTabs");class S{constructor(h,u,v){this._activeTabIdGetter=v,this._parentGroup=u,this.acceptDtoUpdate(h)}get apiObject(){if(!this._apiObject){const h=this,u={get isActive(){return h._dto.id===h._activeTabIdGetter()},get label(){return h._dto.label},get input(){return h._input},get isDirty(){return h._dto.isDirty},get isPinned(){return h._dto.isPinned},get isPreview(){return h._dto.isPreview},get group(){return h._parentGroup.apiObject}};this._apiObject=Object.freeze(u)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(h){this._dto=h,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new A.TextTabInput(w.URI.revive(this._dto.input.uri));case 2:return new A.TextDiffTabInput(w.URI.revive(this._dto.input.original),w.URI.revive(this._dto.input.modified));case 3:return new A.TextMergeTabInput(w.URI.revive(this._dto.input.base),w.URI.revive(this._dto.input.input1),w.URI.revive(this._dto.input.input2),w.URI.revive(this._dto.input.result));case 6:return new A.CustomEditorTabInput(w.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new A.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new A.NotebookEditorTabInput(w.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new A.NotebookDiffEditorTabInput(w.URI.revive(this._dto.input.original),w.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new A.TerminalEditorTabInput;case 9:return new A.InteractiveWindowInput(w.URI.revive(this._dto.input.uri),w.URI.revive(this._dto.input.inputBoxUri));default:return}}}class m{constructor(h,u){this._tabs=[],this._activeTabId="",this._dto=h,this._activeGroupIdGetter=u;for(const v of h.tabs)v.isActive&&(this._activeTabId=v.id),this._tabs.push(new S(v,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const h=this,u={get isActive(){return h._dto.groupId===h._activeGroupIdGetter()},get viewColumn(){return r.ViewColumn.to(h._dto.viewColumn)},get activeTab(){return h._tabs.find(v=>v.tabId===h._activeTabId)?.apiObject},get tabs(){return Object.freeze(h._tabs.map(v=>v.apiObject))}};this._apiObject=Object.freeze(u)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(h){this._dto=h}acceptTabOperation(h){if(h.kind===0){const v=new S(h.tabDto,this,()=>this.activeTabId());return this._tabs.splice(h.index,0,v),h.tabDto.isActive&&(this._activeTabId=v.tabId),v}else if(h.kind===1){const v=this._tabs.splice(h.index,1)[0];if(!v)throw new Error(`Tab close updated received for index ${h.index} which does not exist`);return v.tabId===this._activeTabId&&(this._activeTabId=""),v}else if(h.kind===3){if(h.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const v=this._tabs.splice(h.oldIndex,1)[0];if(!v)throw new Error(`Tab move updated received for index ${h.oldIndex} which does not exist`);return this._tabs.splice(h.index,0,v),v}const u=this._tabs.find(v=>v.tabId===h.tabDto.id);if(!u)throw new Error("INVALID tab");return h.tabDto.isActive?this._activeTabId=h.tabDto.id:this._activeTabId===h.tabDto.id&&!h.tabDto.isActive&&(this._activeTabId=""),u.acceptDtoUpdate(h.tabDto),u}activeTabId(){return this._activeTabId}}let T=class{constructor(h){this._onDidChangeTabs=new L.Emitter,this._onDidChangeTabGroups=new L.Emitter,this._extHostTabGroups=[],this._proxy=h.getProxy(y.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const h=this,u={onDidChangeTabGroups:h._onDidChangeTabGroups.event,onDidChangeTabs:h._onDidChangeTabs.event,get all(){return Object.freeze(h._extHostTabGroups.map(v=>v.apiObject))},get activeTabGroup(){const v=h._activeGroupId;return(0,k.assertIsDefined)(h._extHostTabGroups.find(l=>l.groupId===v)?.apiObject)},close:async(v,I)=>{const l=Array.isArray(v)?v:[v];return l.length?f(l[0])?this._closeGroups(l,I):this._closeTabs(l,I):!0}};this._apiObject=Object.freeze(u)}return this._apiObject}$acceptEditorTabModel(h){const u=new Set(this._extHostTabGroups.map(n=>n.groupId)),v=new Set(h.map(n=>n.groupId)),I=(0,F.diffSets)(u,v),l=this._extHostTabGroups.filter(n=>I.removed.includes(n.groupId)).map(n=>n.apiObject),b=[],t=[];this._extHostTabGroups=h.map(n=>{const i=new m(n,()=>this._activeGroupId);return I.added.includes(i.groupId)?b.push(i.apiObject):t.push(i.apiObject),i});const d=(0,k.assertIsDefined)(h.find(n=>n.isActive===!0)?.groupId);d!==void 0&&this._activeGroupId!==d&&(this._activeGroupId=d),this._onDidChangeTabGroups.fire(Object.freeze({opened:b,closed:l,changed:t}))}$acceptTabGroupUpdate(h){const u=this._extHostTabGroups.find(v=>v.groupId===h.groupId);if(!u)throw new Error("Update Group IPC call received before group creation.");u.acceptGroupDtoUpdate(h),h.isActive&&(this._activeGroupId=h.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[u.apiObject],opened:[],closed:[]}))}$acceptTabOperation(h){const u=this._extHostTabGroups.find(I=>I.groupId===h.groupId);if(!u)throw new Error("Update Tabs IPC call received before group creation.");const v=u.acceptTabOperation(h);switch(h.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[v.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[v.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[v.apiObject]}));return}}_findExtHostTabFromApi(h){for(const u of this._extHostTabGroups)for(const v of u.tabs)if(v.apiObject===h)return v}_findExtHostTabGroupFromApi(h){return this._extHostTabGroups.find(u=>u.apiObject===h)}async _closeTabs(h,u){const v=[];for(const I of h){const l=this._findExtHostTabFromApi(I);if(!l)throw new Error("Tab close: Invalid tab not found!");v.push(l.tabId)}return this._proxy.$closeTab(v,u)}async _closeGroups(h,u){const v=[];for(const I of h){const l=this._findExtHostTabGroupFromApi(I);if(!l)throw new Error("Group close: Invalid group not found!");v.push(l.groupId)}return this._proxy.$closeGroup(v,u)}};T=ze([xe(0,E.IExtHostRpcService)],T),e.ExtHostEditorTabs=T;function f(c){return c.tabs!==void 0}}),define(Ce[197],Ie([1,0,2,4,7,6,8,243,9,23,24]),function(te,e,r,y,w,L,_,A,E,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class S{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const c=this._schemes.indexOf(f);c>=0&&(this._schemes.splice(c,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),c=[];let h,u,v=14,I=14;for(const l of f){let b=h?(0,E.commonPrefixLength)(h,l):0;for(b===0?u=1:u=I;b<l.length;b++)b+1===l.length?(v=I,I=9):I+=1,c.push([u,l.toUpperCase().charCodeAt(b),I]),c.push([u,l.toLowerCase().charCodeAt(b),I]),u=I;h=l,I=v}c.push([9,58,10]),c.push([10,47,12]),this._stateMachine=new A.StateMachine(c)}}provideDocumentLinks(f){this._initStateMachine();const c=[],h=A.LinkComputer.computeLinks({getLineContent(u){return f.lineAt(u-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const u of h){const v=_.DocumentLink.to(u);v.target&&c.push(v)}return c}}class m{constructor(f,c){this._extHostLanguageFeatures=c,this._linkProvider=new S,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=f.getProxy(y.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(f,c,h,u={}){if(this._registeredSchemes.has(c))throw new Error(`a provider for the scheme '${c}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(f,"*",this._linkProvider));const v=this._handlePool++;this._linkProvider.add(c),this._registeredSchemes.add(c),this._fsProvider.set(v,h);let I=2;u.isCaseSensitive&&(I+=1024),u.isReadonly&&(I+=2048),typeof h.copy=="function"&&(I+=8),typeof h.open=="function"&&typeof h.close=="function"&&typeof h.read=="function"&&typeof h.write=="function"&&((0,F.checkProposedApiEnabled)(f,"fsChunks"),I+=4),this._proxy.$registerFileSystemProvider(v,c,I).catch(b=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${c}`),console.error(b)});const l=h.onDidChangeFile(b=>{const t=[];for(const d of b){const{uri:n,type:i}=d;if(n.scheme!==c)continue;let s;switch(i){case L.FileChangeType.Changed:s=0;break;case L.FileChangeType.Created:s=1;break;case L.FileChangeType.Deleted:s=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:n,type:s})}this._proxy.$onFileSystemChange(v,t)});return(0,w.toDisposable)(()=>{l.dispose(),this._linkProvider.delete(c),this._registeredSchemes.delete(c),this._fsProvider.delete(v),this._proxy.$unregisterProvider(v)})}static _asIStat(f){const{type:c,ctime:h,mtime:u,size:v,permissions:I}=f;return{type:c,ctime:h,mtime:u,size:v,permissions:I}}$stat(f,c){return Promise.resolve(this._getFsProvider(f).stat(r.URI.revive(c))).then(h=>m._asIStat(h))}$readdir(f,c){return Promise.resolve(this._getFsProvider(f).readDirectory(r.URI.revive(c)))}$readFile(f,c){return Promise.resolve(this._getFsProvider(f).readFile(r.URI.revive(c))).then(h=>k.VSBuffer.wrap(h))}$writeFile(f,c,h,u){return Promise.resolve(this._getFsProvider(f).writeFile(r.URI.revive(c),h.buffer,u))}$delete(f,c,h){return Promise.resolve(this._getFsProvider(f).delete(r.URI.revive(c),h))}$rename(f,c,h,u){return Promise.resolve(this._getFsProvider(f).rename(r.URI.revive(c),r.URI.revive(h),u))}$copy(f,c,h,u){const v=this._getFsProvider(f);if(!v.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(v.copy(r.URI.revive(c),r.URI.revive(h),u))}$mkdir(f,c){return Promise.resolve(this._getFsProvider(f).createDirectory(r.URI.revive(c)))}$watch(f,c,h,u){const v=this._getFsProvider(f).watch(r.URI.revive(h),u);this._watches.set(c,v)}$unwatch(f,c){const h=this._watches.get(c);h&&(h.dispose(),this._watches.delete(c))}$open(f,c,h){const u=this._getFsProvider(f);if(!u.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(u.open(r.URI.revive(c),h))}$close(f,c){const h=this._getFsProvider(f);if(!h.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(h.close(c))}$read(f,c,h,u){const v=this._getFsProvider(f);if(!v.read)throw new Error('FileSystemProvider does not implement "read"');const I=k.VSBuffer.alloc(u);return Promise.resolve(v.read(c,h,I.buffer,0,u)).then(l=>I.slice(0,l))}$write(f,c,h,u){const v=this._getFsProvider(f);if(!v.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(v.write(c,h,u.buffer,0,u.byteLength))}_getFsProvider(f){const c=this._fsProvider.get(f);if(!c){const h=new Error;throw h.name="ENOPRO",h.message="no provider",h}return c}}e.ExtHostFileSystem=m}),define(Ce[52],Ie([1,0,4,39,6,23,3,13,35,7]),function(te,e,r,y,w,L,_,A,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let F=class Qt{constructor(m,T){this._fileSystemProvider=new Map,this._proxy=m.getProxy(r.MainContext.MainThreadFileSystem);const f=this;this.value=Object.freeze({async stat(c){try{const h=f._fileSystemProvider.get(c.scheme);if(!h)return await f._proxy.$stat(c);await f._proxy.$ensureActivation(c.scheme);const u=await h.stat(c);return{type:u.type,ctime:u.ctime,mtime:u.mtime,size:u.size,permissions:u.permissions}}catch(h){Qt._handleError(h)}},async readDirectory(c){try{const h=f._fileSystemProvider.get(c.scheme);return h?(await f._proxy.$ensureActivation(c.scheme),(await h.readDirectory(c)).slice()):await f._proxy.$readdir(c)}catch(h){return Qt._handleError(h)}},async createDirectory(c){try{return await f._proxy.$mkdir(c)}catch(h){return Qt._handleError(h)}},async readFile(c){try{const h=f._fileSystemProvider.get(c.scheme);return h?(await f._proxy.$ensureActivation(c.scheme),(await h.readFile(c)).slice()):(await f._proxy.$readFile(c)).buffer}catch(h){return Qt._handleError(h)}},async writeFile(c,h){try{return await f._proxy.$writeFile(c,L.VSBuffer.wrap(h))}catch(u){return Qt._handleError(u)}},async delete(c,h){try{const u=f._fileSystemProvider.get(c.scheme);return u?(await f._proxy.$ensureActivation(c.scheme),await u.delete(c,{recursive:!1,...h})):await f._proxy.$delete(c,{recursive:!1,useTrash:!1,...h})}catch(u){return Qt._handleError(u)}},async rename(c,h,u){try{return await f._proxy.$rename(c,h,{overwrite:!1,...u})}catch(v){return Qt._handleError(v)}},async copy(c,h,u){try{return await f._proxy.$copy(c,h,{overwrite:!1,...u})}catch(v){return Qt._handleError(v)}},isWritableFileSystem(c){const h=T.getCapabilities(c);if(typeof h=="number")return!(h&2048)}})}static _handleError(m){if(m instanceof w.FileSystemError)throw m;if(!(m instanceof Error))throw new w.FileSystemError(String(m));if(m.name==="ENOPRO")throw w.FileSystemError.Unavailable(m.message);switch(m.name){case y.FileSystemProviderErrorCode.FileExists:throw w.FileSystemError.FileExists(m.message);case y.FileSystemProviderErrorCode.FileNotFound:throw w.FileSystemError.FileNotFound(m.message);case y.FileSystemProviderErrorCode.FileNotADirectory:throw w.FileSystemError.FileNotADirectory(m.message);case y.FileSystemProviderErrorCode.FileIsADirectory:throw w.FileSystemError.FileIsADirectory(m.message);case y.FileSystemProviderErrorCode.NoPermissions:throw w.FileSystemError.NoPermissions(m.message);case y.FileSystemProviderErrorCode.Unavailable:throw w.FileSystemError.Unavailable(m.message);default:throw new w.FileSystemError(m.message,m.name)}}addFileSystemProvider(m,T){return this._fileSystemProvider.set(m,T),(0,k.toDisposable)(()=>this._fileSystemProvider.delete(m))}};F=ze([xe(0,A.IExtHostRpcService),xe(1,E.IExtHostFileSystemInfo)],F),e.ExtHostConsumerFileSystem=F,e.IExtHostConsumerFileSystem=(0,_.createDecorator)("IExtHostConsumerFileSystem")}),define(Ce[198],Ie([1,0,5,34,2,4,8,6,24]),function(te,e,r,y,w,L,_,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class k{constructor(m,T,f,c,h,u,v,I){this._onDidCreate=new r.Emitter,this._onDidChange=new r.Emitter,this._onDidDelete=new r.Emitter;const l=this.ensureWatching(m,f,h);this._config=0,u&&(this._config+=1),v&&(this._config+=2),I&&(this._config+=4);const b=(0,y.parse)(h),t=typeof h=="string",d=c(n=>{if(!u)for(const i of n.created){const s=w.URI.revive(i);b(s.fsPath)&&(!t||T.getWorkspaceFolder(s))&&this._onDidCreate.fire(s)}if(!v)for(const i of n.changed){const s=w.URI.revive(i);b(s.fsPath)&&(!t||T.getWorkspaceFolder(s))&&this._onDidChange.fire(s)}if(!I)for(const i of n.deleted){const s=w.URI.revive(i);b(s.fsPath)&&(!t||T.getWorkspaceFolder(s))&&this._onDidDelete.fire(s)}});this._disposable=A.Disposable.from(l,this._onDidCreate,this._onDidChange,this._onDidDelete,d)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(m,T,f){const c=A.Disposable.from();if(typeof f=="string")return c;const h=m.getProxy(L.MainContext.MainThreadFileSystem);let u=!1;(f.pattern.includes(y.GLOBSTAR)||f.pattern.includes(y.GLOB_SPLIT))&&(u=!0);const v=Math.random();return h.$watch(T.identifier.value,v,f.baseUri,{recursive:u,excludes:[]}),A.Disposable.from({dispose:()=>h.$unwatch(v)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class F{constructor(m,T,f){this._mainContext=m,this._logService=T,this._extHostDocumentsAndEditors=f,this._onFileSystemEvent=new r.Emitter,this._onDidRenameFile=new r.Emitter,this._onDidCreateFile=new r.Emitter,this._onDidDeleteFile=new r.Emitter,this._onWillRenameFile=new r.AsyncEmitter,this._onWillCreateFile=new r.AsyncEmitter,this._onWillDeleteFile=new r.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(m,T,f,c,h,u){return new k(this._mainContext,m,T,this._onFileSystemEvent.event,_.GlobPattern.from(f),c,h,u)}$onFileEvent(m){this._onFileSystemEvent.fire(m)}$onDidRunFileOperation(m,T){switch(m){case 2:this._onDidRenameFile.fire(Object.freeze({files:T.map(f=>({oldUri:w.URI.revive(f.source),newUri:w.URI.revive(f.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:T.map(f=>w.URI.revive(f.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:T.map(f=>w.URI.revive(f.target))}));break;default:}}getOnWillRenameFileEvent(m){return this._createWillExecuteEvent(m,this._onWillRenameFile)}getOnWillCreateFileEvent(m){return this._createWillExecuteEvent(m,this._onWillCreateFile)}getOnWillDeleteFileEvent(m){return this._createWillExecuteEvent(m,this._onWillDeleteFile)}_createWillExecuteEvent(m,T){return(f,c,h)=>{const u=function(I){f.call(c,I)};return u.extension=m,T.event(u,void 0,h)}}async $onWillRunFileOperation(m,T,f,c){switch(m){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:T.map(h=>({oldUri:w.URI.revive(h.source),newUri:w.URI.revive(h.target)}))},f,c);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:T.map(h=>w.URI.revive(h.target))},f,c);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:T.map(h=>w.URI.revive(h.target))},f,c)}}async _fireWillEvent(m,T,f,c){const h=new Set,u=[];if(await m.fireAsync(T,c,async(I,l)=>{const b=Date.now(),t=await Promise.resolve(I);t instanceof A.WorkspaceEdit&&(u.push([l.extension,t]),h.add(l.extension.displayName??l.extension.identifier.value)),Date.now()-b>f&&this._logService.warn("SLOW file-participant",l.extension.identifier)}),c.isCancellationRequested||u.length===0)return;const v={edits:[]};for(const[I,l]of u){const{edits:b}=_.WorkspaceEdit.from(l,{getTextDocumentVersion:t=>this._extHostDocumentsAndEditors.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}},(0,E.isProposedApiEnabled)(I,"snippetWorkspaceEdit"));v.edits=v.edits.concat(b)}return{edit:v,extensionNames:Array.from(h)}}}e.ExtHostFileSystemEventService=F}),define(Ce[199],Ie([1,0,2,36]),function(te,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class w{constructor(_,A,E,k,F){this._extHostNotebooks=A,this._textDocumentsAndEditors=E,this._commands=k;const S=new y.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new y.ApiCommandArgument("showOptions","Show Options",m=>!0,m=>m),new y.ApiCommandArgument("resource","Interactive resource Uri",m=>!0,m=>m),new y.ApiCommandArgument("controllerId","Notebook controller Id",m=>!0,m=>m),new y.ApiCommandArgument("title","Interactive editor title",m=>!0,m=>m)],new y.ApiCommandResult("Notebook and input URI",m=>{if(F.debug("[ExtHostInteractive] open iw with notebook editor id",m.notebookEditorId),m.notebookEditorId!==void 0){const T=this._extHostNotebooks.getEditorById(m.notebookEditorId);return F.debug("[ExtHostInteractive] notebook editor found",T.id),{notebookUri:r.URI.revive(m.notebookUri),inputUri:r.URI.revive(m.inputUri),notebookEditor:T.apiEditor}}return F.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",m.notebookUri,m.inputUri),{notebookUri:r.URI.revive(m.notebookUri),inputUri:r.URI.revive(m.inputUri)}}));this._commands.registerApiCommand(S)}$willAddInteractiveDocument(_,A,E,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:A,lines:[""],languageId:E,uri:_,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(r.URI.revive(k))?.apiNotebook}]})}$willRemoveInteractiveDocument(_,A){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[_]})}}e.ExtHostInteractive=w}),define(Ce[200],Ie([1,0,7,4]),function(te,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class w{constructor(_){this._handlePool=0,this._proxy=_.getProxy(y.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(_){const A=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(A,_),(0,r.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(A)})}}e.ExtHostLabelService=w}),define(Ce[201],Ie([1,0,2,26,8,6,66,4,9,49,16,10,244,20,7,78,73,61,202,11,14,24]),function(te,e,r,y,w,L,_,A,E,k,F,S,m,T,f,c,h,u,v,I,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class t{constructor(C,z){this._documents=C,this._provider=z}async provideDocumentSymbols(C,z){const H=this._documents.getDocument(C),j=await this._provider.provideDocumentSymbols(H,z);if(!(0,F.isFalsyOrEmpty)(j))return j[0]instanceof L.DocumentSymbol?j.map(w.DocumentSymbol.from):t._asDocumentSymbolTree(j)}static _asDocumentSymbolTree(C){C=C.slice(0).sort((j,se)=>{let ce=j.location.range.start.compareTo(se.location.range.start);return ce===0&&(ce=se.location.range.end.compareTo(j.location.range.end)),ce});const z=[],H=[];for(const j of C){const se={name:j.name||"!!MISSING: name!!",kind:w.SymbolKind.from(j.kind),tags:j.tags?.map(w.SymbolTag.from)||[],detail:"",containerName:j.containerName,range:w.Range.from(j.location.range),selectionRange:w.Range.from(j.location.range),children:[]};for(;;){if(H.length===0){H.push(se),z.push(se);break}const ce=H[H.length-1];if(k.Range.containsRange(ce.range,se.range)&&!k.Range.equalsRange(ce.range,se.range)){ce.children?.push(se),H.push(se);break}H.pop()}}return z}}class d{constructor(C,z,H){this._documents=C,this._commands=z,this._provider=H,this._cache=new u.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(C,z){const H=this._documents.getDocument(C),j=await this._provider.provideCodeLenses(H,z);if(!j||z.isCancellationRequested)return;const se=this._cache.add(j),ce=new f.DisposableStore;this._disposables.set(se,ce);const Y={cacheId:se,lenses:[]};for(let pe=0;pe<j.length;pe++)Y.lenses.push({cacheId:[se,pe],range:w.Range.from(j[pe].range),command:this._commands.toInternal(j[pe].command,ce)});return Y}async resolveCodeLens(C,z){const H=C.cacheId&&this._cache.get(...C.cacheId);if(!H)return;let j;if(typeof this._provider.resolveCodeLens!="function"||H.isResolved?j=H:j=await this._provider.resolveCodeLens(H,z),j||(j=H),z.isCancellationRequested)return;const se=C.cacheId&&this._disposables.get(C.cacheId[0]);if(!!se)return C.command=this._commands.toInternal(j.command??d._badCmd,se),C}releaseCodeLenses(C){this._disposables.get(C)?.dispose(),this._disposables.delete(C),this._cache.delete(C)}}d._badCmd={command:"missing",title:"!!MISSING: command!!"};function n(J){return Array.isArray(J)?J.map(w.DefinitionLink.from):J?[w.DefinitionLink.from(J)]:[]}class i{constructor(C,z){this._documents=C,this._provider=z}async provideDefinition(C,z,H){const j=this._documents.getDocument(C),se=w.Position.to(z),ce=await this._provider.provideDefinition(j,se,H);return n(ce)}}class s{constructor(C,z){this._documents=C,this._provider=z}async provideDeclaration(C,z,H){const j=this._documents.getDocument(C),se=w.Position.to(z),ce=await this._provider.provideDeclaration(j,se,H);return n(ce)}}class a{constructor(C,z){this._documents=C,this._provider=z}async provideImplementation(C,z,H){const j=this._documents.getDocument(C),se=w.Position.to(z),ce=await this._provider.provideImplementation(j,se,H);return n(ce)}}class o{constructor(C,z){this._documents=C,this._provider=z}async provideTypeDefinition(C,z,H){const j=this._documents.getDocument(C),se=w.Position.to(z),ce=await this._provider.provideTypeDefinition(j,se,H);return n(ce)}}class g{constructor(C,z){this._documents=C,this._provider=z}async provideHover(C,z,H){const j=this._documents.getDocument(C),se=w.Position.to(z),ce=await this._provider.provideHover(j,se,H);if(!(!ce||(0,F.isFalsyOrEmpty)(ce.contents)))return ce.range||(ce.range=j.getWordRangeAtPosition(se)),ce.range||(ce.range=new L.Range(se,se)),w.Hover.from(ce)}}class p{constructor(C,z){this._documents=C,this._provider=z}async provideEvaluatableExpression(C,z,H){const j=this._documents.getDocument(C),se=w.Position.to(z),ce=await this._provider.provideEvaluatableExpression(j,se,H);if(ce)return w.EvaluatableExpression.from(ce)}}class P{constructor(C,z){this._documents=C,this._provider=z}async provideInlineValues(C,z,H,j){const se=this._documents.getDocument(C),ce=await this._provider.provideInlineValues(se,w.Range.to(z),w.InlineValueContext.to(H),j);if(Array.isArray(ce))return ce.map(Y=>w.InlineValue.from(Y))}}class M{constructor(C,z){this._documents=C,this._provider=z}async provideDocumentHighlights(C,z,H){const j=this._documents.getDocument(C),se=w.Position.to(z),ce=await this._provider.provideDocumentHighlights(j,se,H);if(Array.isArray(ce))return ce.map(w.DocumentHighlight.from)}}class V{constructor(C,z){this._documents=C,this._provider=z}async provideLinkedEditingRanges(C,z,H){const j=this._documents.getDocument(C),se=w.Position.to(z),ce=await this._provider.provideLinkedEditingRanges(j,se,H);if(ce&&Array.isArray(ce.ranges))return{ranges:(0,F.coalesce)(ce.ranges.map(w.Range.from)),wordPattern:ce.wordPattern}}}class B{constructor(C,z){this._documents=C,this._provider=z}async provideReferences(C,z,H,j){const se=this._documents.getDocument(C),ce=w.Position.to(z),Y=await this._provider.provideReferences(se,ce,H,j);if(Array.isArray(Y))return Y.map(w.location.from)}}class D{constructor(C,z,H,j,se,ce,Y){this._documents=C,this._commands=z,this._diagnostics=H,this._provider=j,this._logService=se,this._extension=ce,this._apiDeprecation=Y,this._cache=new u.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(C,z,H,j){const se=this._documents.getDocument(C),ce=m.Selection.isISelection(z)?w.Selection.to(z):w.Range.to(z),Y=[];for(const Xe of this._diagnostics.getDiagnostics(C))if(ce.intersection(Xe.range)&&Y.push(Xe)>D._maxCodeActionsPerFile)break;const pe={diagnostics:Y,only:H.only?new L.CodeActionKind(H.only):void 0,triggerKind:w.CodeActionTriggerKind.to(H.trigger)},ge=await this._provider.provideCodeActions(se,ce,pe,j);if(!(0,F.isNonEmptyArray)(ge)||j.isCancellationRequested)return;const Ne=this._cache.add(ge),Be=new f.DisposableStore;this._disposables.set(Ne,Be);const Ye=[];for(let Xe=0;Xe<ge.length;Xe++){const ke=ge[Xe];!ke||(D._isCommand(ke)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ye.push({_isSynthetic:!0,title:ke.title,command:this._commands.toInternal(ke,Be)})):(pe.only&&(ke.kind?pe.only.contains(ke.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action is of kind '${ke.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ye.push({cacheId:[Ne,Xe],title:ke.title,command:ke.command&&this._commands.toInternal(ke.command,Be),diagnostics:ke.diagnostics&&ke.diagnostics.map(w.Diagnostic.from),edit:ke.edit&&w.WorkspaceEdit.from(ke.edit,void 0,(0,b.isProposedApiEnabled)(this._extension,"snippetWorkspaceEdit")),kind:ke.kind&&ke.kind.value,isPreferred:ke.isPreferred,disabled:ke.disabled?.reason})))}return{cacheId:Ne,actions:Ye}}async resolveCodeAction(C,z){const[H,j]=C,se=this._cache.get(H,j);if(!se||D._isCommand(se)||!this._provider.resolveCodeAction)return;const ce=await this._provider.resolveCodeAction(se,z)??se;return ce?.edit?w.WorkspaceEdit.from(ce.edit,void 0,(0,b.isProposedApiEnabled)(this._extension,"snippetWorkspaceEdit")):void 0}releaseCodeActions(C){this._disposables.get(C)?.dispose(),this._disposables.delete(C),this._cache.delete(C)}static _isCommand(C){return typeof C.command=="string"&&typeof C.title=="string"}}D._maxCodeActionsPerFile=1e3;class x{constructor(C,z,H,j){this._proxy=C,this._documents=z,this._provider=H,this._handle=j}async prepareDocumentPaste(C,z,H,j){if(!this._provider.prepareDocumentPaste)return;const se=this._documents.getDocument(C),ce=z.map(pe=>w.Range.to(pe)),Y=w.DataTransfer.toDataTransfer(H,()=>{throw new I.NotImplementedError});return await this._provider.prepareDocumentPaste(se,ce,Y,j),w.DataTransfer.toDataTransferDTO(Y)}async providePasteEdits(C,z,H,j,se){const ce=this._documents.getDocument(z),Y=H.map(Ne=>w.Range.to(Ne)),pe=w.DataTransfer.toDataTransfer(j,async Ne=>(await this._proxy.$resolvePasteFileData(this._handle,C,Ne)).buffer),ge=await this._provider.provideDocumentPasteEdits(ce,Y,pe,se);if(!!ge)return{insertText:typeof ge.insertText=="string"?ge.insertText:{snippet:ge.insertText.value},additionalEdit:ge.additionalEdit?w.WorkspaceEdit.from(ge.additionalEdit,void 0,!0):void 0}}}class U{constructor(C,z){this._documents=C,this._provider=z}async provideDocumentFormattingEdits(C,z,H){const j=this._documents.getDocument(C),se=await this._provider.provideDocumentFormattingEdits(j,z,H);if(Array.isArray(se))return se.map(w.TextEdit.from)}}class R{constructor(C,z){this._documents=C,this._provider=z}async provideDocumentRangeFormattingEdits(C,z,H,j){const se=this._documents.getDocument(C),ce=w.Range.to(z),Y=await this._provider.provideDocumentRangeFormattingEdits(se,ce,H,j);if(Array.isArray(Y))return Y.map(w.TextEdit.from)}}class K{constructor(C,z){this._documents=C,this._provider=z,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(C,z,H,j,se){const ce=this._documents.getDocument(C),Y=w.Position.to(z),pe=await this._provider.provideOnTypeFormattingEdits(ce,Y,H,j,se);if(Array.isArray(pe))return pe.map(w.TextEdit.from)}}class W{constructor(C,z){this._provider=C,this._logService=z,this._cache=new u.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(C,z){const H=await this._provider.provideWorkspaceSymbols(C,z);if(!(0,F.isNonEmptyArray)(H))return{symbols:[]};const j=this._cache.add(H),se={cacheId:j,symbols:[]};for(let ce=0;ce<H.length;ce++){const Y=H[ce];if(!Y||!Y.name){this._logService.warn("INVALID SymbolInformation",Y);continue}se.symbols.push({...w.WorkspaceSymbol.from(Y),cacheId:[j,ce]})}return se}async resolveWorkspaceSymbol(C,z){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!C.cacheId)return C;const H=this._cache.get(...C.cacheId);if(H){const j=await this._provider.resolveWorkspaceSymbol(H,z);return j&&(0,y.mixin)(C,w.WorkspaceSymbol.from(j),!0)}}releaseWorkspaceSymbols(C){this._cache.delete(C)}}class O{constructor(C,z,H){this._documents=C,this._provider=z,this._logService=H}static supportsResolving(C){return typeof C.prepareRename=="function"}async provideRenameEdits(C,z,H,j){const se=this._documents.getDocument(C),ce=w.Position.to(z);try{const Y=await this._provider.provideRenameEdits(se,ce,H,j);return Y?w.WorkspaceEdit.from(Y):void 0}catch(Y){const pe=O._asMessage(Y);return pe?{rejectReason:pe,edits:void 0}:Promise.reject(Y)}}async resolveRenameLocation(C,z,H){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const j=this._documents.getDocument(C),se=w.Position.to(z);try{const ce=await this._provider.prepareRename(j,se,H);let Y,pe;if(L.Range.isRange(ce)?(Y=ce,pe=j.getText(ce)):(0,S.isObject)(ce)&&(Y=ce.range,pe=ce.placeholder),!Y||!pe)return;if(Y.start.line>se.line||Y.end.line<se.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:w.Range.from(Y),text:pe}}catch(ce){const Y=O._asMessage(ce);return Y?{rejectReason:Y,range:void 0,text:void 0}:Promise.reject(ce)}}static _asMessage(C){return typeof C=="string"?C:C instanceof Error&&typeof C.message=="string"?C.message:void 0}}class Z{constructor(C,z){this.resultId=C,this.tokens=z}}class ue{constructor(C,z){this._documents=C,this._provider=z,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(C,z,H){const j=this._documents.getDocument(C),se=z!==0?this._previousResults.get(z):null;let ce=typeof se?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(j,se.resultId,H):await this._provider.provideDocumentSemanticTokens(j,H);return se&&this._previousResults.delete(z),ce?(ce=ue._fixProvidedSemanticTokens(ce),this._send(ue._convertToEdits(se,ce),ce)):null}async releaseDocumentSemanticColoring(C){this._previousResults.delete(C)}static _fixProvidedSemanticTokens(C){return ue._isSemanticTokens(C)?ue._isCorrectSemanticTokens(C)?C:new L.SemanticTokens(new Uint32Array(C.data),C.resultId):ue._isSemanticTokensEdits(C)?ue._isCorrectSemanticTokensEdits(C)?C:new L.SemanticTokensEdits(C.edits.map(z=>new L.SemanticTokensEdit(z.start,z.deleteCount,z.data?new Uint32Array(z.data):z.data)),C.resultId):C}static _isSemanticTokens(C){return C&&!!C.data}static _isCorrectSemanticTokens(C){return C.data instanceof Uint32Array}static _isSemanticTokensEdits(C){return C&&Array.isArray(C.edits)}static _isCorrectSemanticTokensEdits(C){for(const z of C.edits)if(!(z.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(C,z){if(!ue._isSemanticTokens(z)||!C||!C.tokens)return z;const H=C.tokens,j=H.length,se=z.data,ce=se.length;let Y=0;const pe=Math.min(j,ce);for(;Y<pe&&H[Y]===se[Y];)Y++;if(Y===j&&Y===ce)return new L.SemanticTokensEdits([],z.resultId);let ge=0;const Ne=pe-Y;for(;ge<Ne&&H[j-ge-1]===se[ce-ge-1];)ge++;return new L.SemanticTokensEdits([{start:Y,deleteCount:j-Y-ge,data:se.subarray(Y,ce-ge)}],z.resultId)}_send(C,z){if(ue._isSemanticTokens(C)){const H=this._nextResultId++;return this._previousResults.set(H,new Z(C.resultId,C.data)),(0,c.encodeSemanticTokensDto)({id:H,type:"full",data:C.data})}if(ue._isSemanticTokensEdits(C)){const H=this._nextResultId++;return ue._isSemanticTokens(z)?this._previousResults.set(H,new Z(z.resultId,z.data)):this._previousResults.set(H,new Z(C.resultId)),(0,c.encodeSemanticTokensDto)({id:H,type:"delta",deltas:(C.edits||[]).map(j=>({start:j.start,deleteCount:j.deleteCount,data:j.data}))})}return null}}e.DocumentSemanticTokensAdapter=ue;class oe{constructor(C,z){this._documents=C,this._provider=z}async provideDocumentRangeSemanticTokens(C,z,H){const j=this._documents.getDocument(C),se=await this._provider.provideDocumentRangeSemanticTokens(j,w.Range.to(z),H);return se?this._send(se):null}_send(C){return(0,c.encodeSemanticTokensDto)({id:0,type:"full",data:C.data})}}e.DocumentRangeSemanticTokensAdapter=oe;class de{constructor(C,z,H,j,se){this._documents=C,this._commands=z,this._provider=H,this._apiDeprecation=j,this._extension=se,this._cache=new u.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(C){return typeof C.resolveCompletionItem=="function"}async provideCompletionItems(C,z,H,j){const se=this._documents.getDocument(C),ce=w.Position.to(z),Y=se.getWordRangeAtPosition(ce)||new L.Range(ce,ce),pe=Y.with({end:ce}),ge=new v.StopWatch(!0),Ne=await this._provider.provideCompletionItems(se,ce,j,w.CompletionContext.to(H));if(!Ne||j.isCancellationRequested)return;const Be=Array.isArray(Ne)?new L.CompletionList(Ne):Ne,Ye=de.supportsResolving(this._provider)?this._cache.add(Be.items):this._cache.add([]),Xe=new f.DisposableStore;this._disposables.set(Ye,Xe);const ke=[],nt={x:Ye,b:ke,a:{replace:w.Range.from(Y),insert:w.Range.from(pe)},c:Be.isIncomplete||void 0,d:ge.elapsed()};for(let G=0;G<Be.items.length;G++){const X=Be.items[G],fe=this._convertCompletionItem(X,[Ye,G],pe,Y);ke.push(fe)}return nt}async resolveCompletionItem(C,z){if(typeof this._provider.resolveCompletionItem!="function")return;const H=this._cache.get(...C);if(!H)return;const j=await this._provider.resolveCompletionItem(H,z);if(!!j)return this._convertCompletionItem(j,C)}releaseCompletionItems(C){this._disposables.get(C)?.dispose(),this._disposables.delete(C),this._cache.delete(C)}_convertCompletionItem(C,z,H,j){const se=this._disposables.get(z[0]);if(!se)throw Error("DisposableStore is missing...");const ce={x:z,a:C.label,b:C.kind!==void 0?w.CompletionItemKind.from(C.kind):void 0,n:C.tags&&C.tags.map(w.CompletionItemTag.from),c:C.detail,d:typeof C.documentation>"u"?void 0:w.MarkdownString.fromStrict(C.documentation),e:C.sortText!==C.label?C.sortText:void 0,f:C.filterText!==C.label?C.filterText:void 0,g:C.preselect||void 0,i:C.keepWhitespace?1:0,k:C.commitCharacters,l:C.additionalTextEdits&&C.additionalTextEdits.map(w.TextEdit.from),m:this._commands.toInternal(C.command,se)};C.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ce.h=C.textEdit.newText):typeof C.insertText=="string"?ce.h=C.insertText:C.insertText instanceof L.SnippetString&&(ce.h=C.insertText.value,ce.i|=4);let Y;return C.textEdit?Y=C.textEdit.range:C.range&&(Y=C.range),L.Range.isRange(Y)?ce.j=w.Range.from(Y):Y&&(!H?.isEqual(Y.inserting)||!j?.isEqual(Y.replacing))&&(ce.j={insert:w.Range.from(Y.inserting),replace:w.Range.from(Y.replacing)}),ce}}class ie{async provideInlineCompletions(C,z,H,j){}disposeCompletions(C){}handleDidShowCompletionItem(C,z){}}class ve extends ie{constructor(C,z,H,j){super(),this._extension=C,this._documents=z,this._provider=H,this._commands=j,this._references=new ne,this._isAdditionsProposedApiEnabled=(0,b.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[_.InlineCompletionTriggerKind.Automatic]:L.InlineCompletionTriggerKind.Automatic,[_.InlineCompletionTriggerKind.Explicit]:L.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,b.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&typeof this._provider.handleDidShowCompletionItem=="function"}async provideInlineCompletions(C,z,H,j){const se=this._documents.getDocument(C),ce=w.Position.to(z),Y=await this._provider.provideInlineCompletionItems(se,ce,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:w.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[H.triggerKind]},j);if(!Y||j.isCancellationRequested)return;const pe=Array.isArray(Y)?Y:Y.items,ge=this._isAdditionsProposedApiEnabled?Array.isArray(Y)?[]:Y.commands||[]:[];let Ne;return{pid:this._references.createReferenceId({dispose(){Ne?.dispose()},items:pe}),items:pe.map((Ye,Xe)=>{let ke;Ye.command&&(Ne||(Ne=new f.DisposableStore),ke=this._commands.toInternal(Ye.command,Ne));const nt=Ye.insertText;return{insertText:typeof nt=="string"?nt:{snippet:nt.value},filterText:Ye.filterText,range:Ye.range?w.Range.from(Ye.range):void 0,command:ke,idx:Xe,completeBracketPairs:this._isAdditionsProposedApiEnabled?Ye.completeBracketPairs:!1}}),commands:ge.map(Ye=>(Ne||(Ne=new f.DisposableStore),this._commands.toInternal(Ye,Ne)))}}disposeCompletions(C){this._references.disposeReferenceId(C)?.dispose()}handleDidShowCompletionItem(C,z){const H=this._references.get(C)?.items[z];H&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(H)}}class be extends ie{constructor(C,z,H,j){super(),this.extension=C,this._documents=z,this._provider=H,this._commands=j,this._references=new ne,this.isAdditionProposedApiEnabled=(0,b.isProposedApiEnabled)(this.extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[_.InlineCompletionTriggerKind.Automatic]:L.InlineCompletionTriggerKindNew.Automatic,[_.InlineCompletionTriggerKind.Explicit]:L.InlineCompletionTriggerKindNew.Invoke}}async provideInlineCompletions(C,z,H,j){const se=this._documents.getDocument(C),ce=w.Position.to(z),Y=await this._provider.provideInlineCompletionItems(se,ce,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:w.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[H.triggerKind]},j);if(!Y||j.isCancellationRequested)return;const pe=Array.isArray(Y)?Y:Y.items,ge=Array.isArray(Y)?[]:Y.commands||[];let Ne;return{pid:this._references.createReferenceId({dispose(){Ne?.dispose()},items:pe}),items:pe.map((Ye,Xe)=>{let ke;Ye.command&&(Ne||(Ne=new f.DisposableStore),ke=this._commands.toInternal(Ye.command,Ne));const nt=Ye.insertText;return{insertText:typeof nt=="string"?nt:{snippet:nt.value},filterText:Ye.filterText,range:Ye.range?w.Range.from(Ye.range):void 0,command:ke,idx:Xe,completeBracketPairs:this.isAdditionProposedApiEnabled?Ye.completeBracketPairs:!1}}),commands:ge.map(Ye=>(Ne||(Ne=new f.DisposableStore),this._commands.toInternal(Ye,Ne)))}}disposeCompletions(C){this._references.disposeReferenceId(C)?.dispose()}handleDidShowCompletionItem(C,z){const H=this._references.get(C)?.items[z];H&&this._provider.handleDidShowCompletionItem&&this.isAdditionProposedApiEnabled&&this._provider.handleDidShowCompletionItem(H)}}class ne{constructor(){this._references=new Map,this._idPool=1}createReferenceId(C){const z=this._idPool++;return this._references.set(z,C),z}disposeReferenceId(C){const z=this._references.get(C);return this._references.delete(C),z}get(C){return this._references.get(C)}}class Ee{constructor(C,z){this._documents=C,this._provider=z,this._cache=new u.Cache("SignatureHelp")}async provideSignatureHelp(C,z,H,j){const se=this._documents.getDocument(C),ce=w.Position.to(z),Y=this.reviveContext(H),pe=await this._provider.provideSignatureHelp(se,ce,j,Y);if(pe){const ge=this._cache.add([pe]);return{...w.SignatureHelp.from(pe),id:ge}}}reviveContext(C){let z;if(C.activeSignatureHelp){const H=w.SignatureHelp.to(C.activeSignatureHelp),j=this._cache.get(C.activeSignatureHelp.id,0);j?(z=j,z.activeSignature=H.activeSignature,z.activeParameter=H.activeParameter):z=H}return{...C,activeSignatureHelp:z}}releaseSignatureHelp(C){this._cache.delete(C)}}class Pe{constructor(C,z,H,j,se){this._documents=C,this._commands=z,this._provider=H,this._logService=j,this._extension=se,this._cache=new u.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(C,z,H){const j=this._documents.getDocument(C),se=w.Range.to(z),ce=await this._provider.provideInlayHints(j,se,H);if(!Array.isArray(ce)||ce.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${z}`);return}if(H.isCancellationRequested)return;const Y=this._cache.add(ce);this._disposables.set(Y,new f.DisposableStore);const pe={hints:[],cacheId:Y};for(let ge=0;ge<ce.length;ge++)this._isValidInlayHint(ce[ge],se)&&pe.hints.push(this._convertInlayHint(ce[ge],[Y,ge]));return this._logService.trace(`[InlayHints] ${pe.hints.length} inlay hints from '${this._extension.identifier.value}' for ${z}`),pe}async resolveInlayHint(C,z){if(typeof this._provider.resolveInlayHint!="function")return;const H=this._cache.get(...C);if(!H)return;const j=await this._provider.resolveInlayHint(H,z);if(!!j&&!!this._isValidInlayHint(j))return this._convertInlayHint(j,C)}releaseHints(C){this._disposables.get(C)?.dispose(),this._disposables.delete(C),this._cache.delete(C)}_isValidInlayHint(C,z){return C.label.length===0||Array.isArray(C.label)&&C.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",C),!1):!(z&&!z.contains(C.position))}_convertInlayHint(C,z){const H=this._disposables.get(z[0]);if(!H)throw Error("DisposableStore is missing...");const j={label:"",cacheId:z,tooltip:w.MarkdownString.fromStrict(C.tooltip),position:w.Position.from(C.position),textEdits:C.textEdits&&C.textEdits.map(w.TextEdit.from),kind:C.kind&&w.InlayHintKind.from(C.kind),paddingLeft:C.paddingLeft,paddingRight:C.paddingRight};return typeof C.label=="string"?j.label=C.label:j.label=C.label.map(se=>{const ce={label:se.value};return ce.tooltip=w.MarkdownString.fromStrict(se.tooltip),L.Location.isLocation(se.location)&&(ce.location=w.location.from(se.location)),se.command&&(ce.command=this._commands.toInternal(se.command,H)),ce}),j}}class Fe{constructor(C,z){this._documents=C,this._provider=z,this._cache=new u.Cache("DocumentLink")}async provideLinks(C,z){const H=this._documents.getDocument(C),j=await this._provider.provideDocumentLinks(H,z);if(!(!Array.isArray(j)||j.length===0)&&!z.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:j.filter(Fe._validateLink).map(w.DocumentLink.from)};{const se=this._cache.add(j),ce={links:[],cacheId:se};for(let Y=0;Y<j.length;Y++){if(!Fe._validateLink(j[Y]))continue;const pe=w.DocumentLink.from(j[Y]);pe.cacheId=[se,Y],ce.links.push(pe)}return ce}}}static _validateLink(C){return C.target&&C.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(C,z){if(typeof this._provider.resolveDocumentLink!="function")return;const H=this._cache.get(...C);if(!H)return;const j=await this._provider.resolveDocumentLink(H,z);if(!(!j||!Fe._validateLink(j)))return w.DocumentLink.from(j)}releaseLinks(C){this._cache.delete(C)}}class $e{constructor(C,z){this._documents=C,this._provider=z}async provideColors(C,z){const H=this._documents.getDocument(C),j=await this._provider.provideDocumentColors(H,z);return Array.isArray(j)?j.map(ce=>({color:w.Color.from(ce.color),range:w.Range.from(ce.range)})):[]}async provideColorPresentations(C,z,H){const j=this._documents.getDocument(C),se=w.Range.to(z.range),ce=w.Color.to(z.color),Y=await this._provider.provideColorPresentations(ce,{document:j,range:se},H);if(!!Array.isArray(Y))return Y.map(w.ColorPresentation.from)}}class Qe{constructor(C,z){this._documents=C,this._provider=z}async provideFoldingRanges(C,z,H){const j=this._documents.getDocument(C),se=await this._provider.provideFoldingRanges(j,z,H);if(!!Array.isArray(se))return se.map(w.FoldingRange.from)}}class Te{constructor(C,z,H){this._documents=C,this._provider=z,this._logService=H}async provideSelectionRanges(C,z,H){const j=this._documents.getDocument(C),se=z.map(w.Position.to),ce=await this._provider.provideSelectionRanges(j,se,H);if(!(0,F.isNonEmptyArray)(ce))return[];if(ce.length!==se.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Y=[];for(let pe=0;pe<se.length;pe++){const ge=[];Y.push(ge);let Ne=se[pe],Be=ce[pe];for(;;){if(!Be.range.contains(Ne))throw new Error("INVALID selection range, must contain the previous range");if(ge.push(w.SelectionRange.from(Be)),!Be.parent)break;Ne=Be.range,Be=Be.parent}}return Y}}class _e{constructor(C,z){this._documents=C,this._provider=z,this._idPool=new h.IdGenerator(""),this._cache=new Map}async prepareSession(C,z,H){const j=this._documents.getDocument(C),se=w.Position.to(z),ce=await this._provider.prepareCallHierarchy(j,se,H);if(!ce)return;const Y=this._idPool.nextId();return this._cache.set(Y,new Map),Array.isArray(ce)?ce.map(pe=>this._cacheAndConvertItem(Y,pe)):[this._cacheAndConvertItem(Y,ce)]}async provideCallsTo(C,z,H){const j=this._itemFromCache(C,z);if(!j)throw new Error("missing call hierarchy item");const se=await this._provider.provideCallHierarchyIncomingCalls(j,H);if(!!se)return se.map(ce=>({from:this._cacheAndConvertItem(C,ce.from),fromRanges:ce.fromRanges.map(Y=>w.Range.from(Y))}))}async provideCallsFrom(C,z,H){const j=this._itemFromCache(C,z);if(!j)throw new Error("missing call hierarchy item");const se=await this._provider.provideCallHierarchyOutgoingCalls(j,H);if(!!se)return se.map(ce=>({to:this._cacheAndConvertItem(C,ce.to),fromRanges:ce.fromRanges.map(Y=>w.Range.from(Y))}))}releaseSession(C){this._cache.delete(C)}_cacheAndConvertItem(C,z){const H=this._cache.get(C),j=w.CallHierarchyItem.from(z,C,H.size.toString(36));return H.set(j._itemId,z),j}_itemFromCache(C,z){return this._cache.get(C)?.get(z)}}class ye{constructor(C,z){this._documents=C,this._provider=z,this._idPool=new h.IdGenerator(""),this._cache=new Map}async prepareSession(C,z,H){const j=this._documents.getDocument(C),se=w.Position.to(z),ce=await this._provider.prepareTypeHierarchy(j,se,H);if(!ce)return;const Y=this._idPool.nextId();return this._cache.set(Y,new Map),Array.isArray(ce)?ce.map(pe=>this._cacheAndConvertItem(Y,pe)):[this._cacheAndConvertItem(Y,ce)]}async provideSupertypes(C,z,H){const j=this._itemFromCache(C,z);if(!j)throw new Error("missing type hierarchy item");const se=await this._provider.provideTypeHierarchySupertypes(j,H);if(!!se)return se.map(ce=>this._cacheAndConvertItem(C,ce))}async provideSubtypes(C,z,H){const j=this._itemFromCache(C,z);if(!j)throw new Error("missing type hierarchy item");const se=await this._provider.provideTypeHierarchySubtypes(j,H);if(!!se)return se.map(ce=>this._cacheAndConvertItem(C,ce))}releaseSession(C){this._cache.delete(C)}_cacheAndConvertItem(C,z){const H=this._cache.get(C),j=w.TypeHierarchyItem.from(z,C,H.size.toString(36));return H.set(j._itemId,z),j}_itemFromCache(C,z){return this._cache.get(C)?.get(z)}}class ae{constructor(C,z,H,j){this._proxy=C,this._documents=z,this._provider=H,this._handle=j}async provideDocumentOnDropEdits(C,z,H,j,se){const ce=this._documents.getDocument(z),Y=w.Position.to(H),pe=w.DataTransfer.toDataTransfer(j,async Ne=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,C,Ne)).buffer),ge=await this._provider.provideDocumentDropEdits(ce,Y,pe,se);if(!!ge)return{insertText:typeof ge.insertText=="string"?ge.insertText:{snippet:ge.insertText.value},additionalEdit:ge.additionalEdit?w.WorkspaceEdit.from(ge.additionalEdit,void 0,!0):void 0}}}class le{constructor(C,z){this.adapter=C,this.extension=z}}class Q{constructor(C,z,H,j,se,ce,Y){this._adapter=new Map,this._uriTransformer=z,this._proxy=C.getProxy(A.MainContext.MainThreadLanguageFeatures),this._documents=H,this._commands=j,this._diagnostics=se,this._logService=ce,this._apiDeprecation=Y}_transformDocumentSelector(C){return w.DocumentSelector.from(C,this._uriTransformer)}_createDisposable(C){return new L.Disposable(()=>{this._adapter.delete(C),this._proxy.$unregister(C)})}_nextHandle(){return Q._handlePool++}async _withAdapter(C,z,H,j,se,ce=!1){const Y=this._adapter.get(C);if(!Y||!(Y.adapter instanceof z))return j;const pe=Date.now();ce||this._logService.trace(`[${Y.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const ge=H(Y.adapter,Y.extension);return Promise.resolve(ge).catch(Ne=>{(0,I.isCancellationError)(Ne)||(this._logService.error(`[${Y.extension.identifier.value}] provider FAILED`),this._logService.error(Ne))}).finally(()=>{ce||this._logService.trace(`[${Y.extension.identifier.value}] provider DONE after ${Date.now()-pe}ms`)}),T.CancellationToken.isCancellationToken(se)?(0,l.raceCancellationError)(ge,se):ge}_addNewAdapter(C,z){const H=this._nextHandle();return this._adapter.set(H,new le(C,z)),H}static _extLabel(C){return C.displayName||C.name}registerDocumentSymbolProvider(C,z,H,j){const se=this._addNewAdapter(new t(this._documents,H),C),ce=j&&j.label||Q._extLabel(C);return this._proxy.$registerDocumentSymbolProvider(se,this._transformDocumentSelector(z),ce),this._createDisposable(se)}$provideDocumentSymbols(C,z,H){return this._withAdapter(C,t,j=>j.provideDocumentSymbols(r.URI.revive(z),H),void 0,H)}registerCodeLensProvider(C,z,H){const j=this._nextHandle(),se=typeof H.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(j,new le(new d(this._documents,this._commands.converter,H),C)),this._proxy.$registerCodeLensSupport(j,this._transformDocumentSelector(z),se);let ce=this._createDisposable(j);if(se!==void 0){const Y=H.onDidChangeCodeLenses(pe=>this._proxy.$emitCodeLensEvent(se));ce=L.Disposable.from(ce,Y)}return ce}$provideCodeLenses(C,z,H){return this._withAdapter(C,d,j=>j.provideCodeLenses(r.URI.revive(z),H),void 0,H)}$resolveCodeLens(C,z,H){return this._withAdapter(C,d,j=>j.resolveCodeLens(z,H),void 0,void 0)}$releaseCodeLenses(C,z){this._withAdapter(C,d,H=>Promise.resolve(H.releaseCodeLenses(z)),void 0,void 0)}registerDefinitionProvider(C,z,H){const j=this._addNewAdapter(new i(this._documents,H),C);return this._proxy.$registerDefinitionSupport(j,this._transformDocumentSelector(z)),this._createDisposable(j)}$provideDefinition(C,z,H,j){return this._withAdapter(C,i,se=>se.provideDefinition(r.URI.revive(z),H,j),[],j)}registerDeclarationProvider(C,z,H){const j=this._addNewAdapter(new s(this._documents,H),C);return this._proxy.$registerDeclarationSupport(j,this._transformDocumentSelector(z)),this._createDisposable(j)}$provideDeclaration(C,z,H,j){return this._withAdapter(C,s,se=>se.provideDeclaration(r.URI.revive(z),H,j),[],j)}registerImplementationProvider(C,z,H){const j=this._addNewAdapter(new a(this._documents,H),C);return this._proxy.$registerImplementationSupport(j,this._transformDocumentSelector(z)),this._createDisposable(j)}$provideImplementation(C,z,H,j){return this._withAdapter(C,a,se=>se.provideImplementation(r.URI.revive(z),H,j),[],j)}registerTypeDefinitionProvider(C,z,H){const j=this._addNewAdapter(new o(this._documents,H),C);return this._proxy.$registerTypeDefinitionSupport(j,this._transformDocumentSelector(z)),this._createDisposable(j)}$provideTypeDefinition(C,z,H,j){return this._withAdapter(C,o,se=>se.provideTypeDefinition(r.URI.revive(z),H,j),[],j)}registerHoverProvider(C,z,H,j){const se=this._addNewAdapter(new g(this._documents,H),C);return this._proxy.$registerHoverProvider(se,this._transformDocumentSelector(z)),this._createDisposable(se)}$provideHover(C,z,H,j){return this._withAdapter(C,g,se=>se.provideHover(r.URI.revive(z),H,j),void 0,j)}registerEvaluatableExpressionProvider(C,z,H,j){const se=this._addNewAdapter(new p(this._documents,H),C);return this._proxy.$registerEvaluatableExpressionProvider(se,this._transformDocumentSelector(z)),this._createDisposable(se)}$provideEvaluatableExpression(C,z,H,j){return this._withAdapter(C,p,se=>se.provideEvaluatableExpression(r.URI.revive(z),H,j),void 0,j)}registerInlineValuesProvider(C,z,H,j){const se=typeof H.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ce=this._addNewAdapter(new P(this._documents,H),C);this._proxy.$registerInlineValuesProvider(ce,this._transformDocumentSelector(z),se);let Y=this._createDisposable(ce);if(se!==void 0){const pe=H.onDidChangeInlineValues(ge=>this._proxy.$emitInlineValuesEvent(se));Y=L.Disposable.from(Y,pe)}return Y}$provideInlineValues(C,z,H,j,se){return this._withAdapter(C,P,ce=>ce.provideInlineValues(r.URI.revive(z),H,j,se),void 0,se)}registerDocumentHighlightProvider(C,z,H){const j=this._addNewAdapter(new M(this._documents,H),C);return this._proxy.$registerDocumentHighlightProvider(j,this._transformDocumentSelector(z)),this._createDisposable(j)}$provideDocumentHighlights(C,z,H,j){return this._withAdapter(C,M,se=>se.provideDocumentHighlights(r.URI.revive(z),H,j),void 0,j)}registerLinkedEditingRangeProvider(C,z,H){const j=this._addNewAdapter(new V(this._documents,H),C);return this._proxy.$registerLinkedEditingRangeProvider(j,this._transformDocumentSelector(z)),this._createDisposable(j)}$provideLinkedEditingRanges(C,z,H,j){return this._withAdapter(C,V,async se=>{const ce=await se.provideLinkedEditingRanges(r.URI.revive(z),H,j);if(ce)return{ranges:ce.ranges,wordPattern:ce.wordPattern?Q._serializeRegExp(ce.wordPattern):void 0}},void 0,j)}registerReferenceProvider(C,z,H){const j=this._addNewAdapter(new B(this._documents,H),C);return this._proxy.$registerReferenceSupport(j,this._transformDocumentSelector(z)),this._createDisposable(j)}$provideReferences(C,z,H,j,se){return this._withAdapter(C,B,ce=>ce.provideReferences(r.URI.revive(z),H,j,se),void 0,se)}registerCodeActionProvider(C,z,H,j){const se=new f.DisposableStore,ce=this._addNewAdapter(new D(this._documents,this._commands.converter,this._diagnostics,H,this._logService,C,this._apiDeprecation),C);return this._proxy.$registerQuickFixSupport(ce,this._transformDocumentSelector(z),{providedKinds:j?.providedCodeActionKinds?.map(Y=>Y.value),documentation:j?.documentation?.map(Y=>({kind:Y.kind.value,command:this._commands.converter.toInternal(Y.command,se)}))},Q._extLabel(C),Boolean(H.resolveCodeAction)),se.add(this._createDisposable(ce)),se}$provideCodeActions(C,z,H,j,se){return this._withAdapter(C,D,ce=>ce.provideCodeActions(r.URI.revive(z),H,j,se),void 0,se)}$resolveCodeAction(C,z,H){return this._withAdapter(C,D,j=>j.resolveCodeAction(z,H),void 0,void 0)}$releaseCodeActions(C,z){this._withAdapter(C,D,H=>Promise.resolve(H.releaseCodeActions(z)),void 0,void 0)}registerDocumentFormattingEditProvider(C,z,H){const j=this._addNewAdapter(new U(this._documents,H),C);return this._proxy.$registerDocumentFormattingSupport(j,this._transformDocumentSelector(z),C.identifier,C.displayName||C.name),this._createDisposable(j)}$provideDocumentFormattingEdits(C,z,H,j){return this._withAdapter(C,U,se=>se.provideDocumentFormattingEdits(r.URI.revive(z),H,j),void 0,j)}registerDocumentRangeFormattingEditProvider(C,z,H){const j=this._addNewAdapter(new R(this._documents,H),C);return this._proxy.$registerRangeFormattingSupport(j,this._transformDocumentSelector(z),C.identifier,C.displayName||C.name),this._createDisposable(j)}$provideDocumentRangeFormattingEdits(C,z,H,j,se){return this._withAdapter(C,R,ce=>ce.provideDocumentRangeFormattingEdits(r.URI.revive(z),H,j,se),void 0,se)}registerOnTypeFormattingEditProvider(C,z,H,j){const se=this._addNewAdapter(new K(this._documents,H),C);return this._proxy.$registerOnTypeFormattingSupport(se,this._transformDocumentSelector(z),j,C.identifier),this._createDisposable(se)}$provideOnTypeFormattingEdits(C,z,H,j,se,ce){return this._withAdapter(C,K,Y=>Y.provideOnTypeFormattingEdits(r.URI.revive(z),H,j,se,ce),void 0,ce)}registerWorkspaceSymbolProvider(C,z){const H=this._addNewAdapter(new W(z,this._logService),C);return this._proxy.$registerNavigateTypeSupport(H,typeof z.resolveWorkspaceSymbol=="function"),this._createDisposable(H)}$provideWorkspaceSymbols(C,z,H){return this._withAdapter(C,W,j=>j.provideWorkspaceSymbols(z,H),{symbols:[]},H)}$resolveWorkspaceSymbol(C,z,H){return this._withAdapter(C,W,j=>j.resolveWorkspaceSymbol(z,H),void 0,void 0)}$releaseWorkspaceSymbols(C,z){this._withAdapter(C,W,H=>H.releaseWorkspaceSymbols(z),void 0,void 0)}registerRenameProvider(C,z,H){const j=this._addNewAdapter(new O(this._documents,H,this._logService),C);return this._proxy.$registerRenameSupport(j,this._transformDocumentSelector(z),O.supportsResolving(H)),this._createDisposable(j)}$provideRenameEdits(C,z,H,j,se){return this._withAdapter(C,O,ce=>ce.provideRenameEdits(r.URI.revive(z),H,j,se),void 0,se)}$resolveRenameLocation(C,z,H,j){return this._withAdapter(C,O,se=>se.resolveRenameLocation(r.URI.revive(z),H,j),void 0,j)}registerDocumentSemanticTokensProvider(C,z,H,j){const se=this._addNewAdapter(new ue(this._documents,H),C),ce=typeof H.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(se,this._transformDocumentSelector(z),j,ce);let Y=this._createDisposable(se);if(ce){const pe=H.onDidChangeSemanticTokens(ge=>this._proxy.$emitDocumentSemanticTokensEvent(ce));Y=L.Disposable.from(Y,pe)}return Y}$provideDocumentSemanticTokens(C,z,H,j){return this._withAdapter(C,ue,se=>se.provideDocumentSemanticTokens(r.URI.revive(z),H,j),null,j)}$releaseDocumentSemanticTokens(C,z){this._withAdapter(C,ue,H=>H.releaseDocumentSemanticColoring(z),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(C,z,H,j){const se=this._addNewAdapter(new oe(this._documents,H),C);return this._proxy.$registerDocumentRangeSemanticTokensProvider(se,this._transformDocumentSelector(z),j),this._createDisposable(se)}$provideDocumentRangeSemanticTokens(C,z,H,j){return this._withAdapter(C,oe,se=>se.provideDocumentRangeSemanticTokens(r.URI.revive(z),H,j),null,j)}registerCompletionItemProvider(C,z,H,j){const se=this._addNewAdapter(new de(this._documents,this._commands.converter,H,this._apiDeprecation,C),C);return this._proxy.$registerCompletionsProvider(se,this._transformDocumentSelector(z),j,de.supportsResolving(H),`${C.identifier.value}(${j.join("")})`),this._createDisposable(se)}$provideCompletionItems(C,z,H,j,se){return this._withAdapter(C,de,ce=>ce.provideCompletionItems(r.URI.revive(z),H,j,se),void 0,se)}$resolveCompletionItem(C,z,H){return this._withAdapter(C,de,j=>j.resolveCompletionItem(z,H),void 0,H)}$releaseCompletionItems(C,z){this._withAdapter(C,de,H=>H.releaseCompletionItems(z),void 0,void 0)}registerInlineCompletionsProvider(C,z,H){const j=new ve(C,this._documents,H,this._commands.converter),se=this._addNewAdapter(j,C);return this._proxy.$registerInlineCompletionsSupport(se,this._transformDocumentSelector(z),j.supportsHandleDidShowCompletionItem),this._createDisposable(se)}registerInlineCompletionsProviderNew(C,z,H){const j=this._addNewAdapter(new be(C,this._documents,H,this._commands.converter),C);return this._proxy.$registerInlineCompletionsSupport(j,this._transformDocumentSelector(z),!0),this._createDisposable(j)}$provideInlineCompletions(C,z,H,j,se){return this._withAdapter(C,ie,ce=>ce.provideInlineCompletions(r.URI.revive(z),H,j,se),void 0,se)}$handleInlineCompletionDidShow(C,z,H){this._withAdapter(C,ie,async j=>{j.handleDidShowCompletionItem(z,H)},void 0,void 0)}$freeInlineCompletionsList(C,z){this._withAdapter(C,ie,async H=>{H.disposeCompletions(z)},void 0,void 0)}registerSignatureHelpProvider(C,z,H,j){const se=Array.isArray(j)?{triggerCharacters:j,retriggerCharacters:[]}:j,ce=this._addNewAdapter(new Ee(this._documents,H),C);return this._proxy.$registerSignatureHelpProvider(ce,this._transformDocumentSelector(z),se),this._createDisposable(ce)}$provideSignatureHelp(C,z,H,j,se){return this._withAdapter(C,Ee,ce=>ce.provideSignatureHelp(r.URI.revive(z),H,j,se),void 0,se)}$releaseSignatureHelp(C,z){this._withAdapter(C,Ee,H=>H.releaseSignatureHelp(z),void 0,void 0)}registerInlayHintsProvider(C,z,H){const j=typeof H.onDidChangeInlayHints=="function"?this._nextHandle():void 0,se=this._addNewAdapter(new Pe(this._documents,this._commands.converter,H,this._logService,C),C);this._proxy.$registerInlayHintsProvider(se,this._transformDocumentSelector(z),typeof H.resolveInlayHint=="function",j,Q._extLabel(C));let ce=this._createDisposable(se);if(j!==void 0){const Y=H.onDidChangeInlayHints(pe=>this._proxy.$emitInlayHintsEvent(j));ce=L.Disposable.from(ce,Y)}return ce}$provideInlayHints(C,z,H,j){return this._withAdapter(C,Pe,se=>se.provideInlayHints(r.URI.revive(z),H,j),void 0,j)}$resolveInlayHint(C,z,H){return this._withAdapter(C,Pe,j=>j.resolveInlayHint(z,H),void 0,H)}$releaseInlayHints(C,z){this._withAdapter(C,Pe,H=>H.releaseHints(z),void 0,void 0)}registerDocumentLinkProvider(C,z,H){const j=this._addNewAdapter(new Fe(this._documents,H),C);return this._proxy.$registerDocumentLinkProvider(j,this._transformDocumentSelector(z),typeof H.resolveDocumentLink=="function"),this._createDisposable(j)}$provideDocumentLinks(C,z,H){return this._withAdapter(C,Fe,j=>j.provideLinks(r.URI.revive(z),H),void 0,H,z.scheme==="output")}$resolveDocumentLink(C,z,H){return this._withAdapter(C,Fe,j=>j.resolveLink(z,H),void 0,void 0,!0)}$releaseDocumentLinks(C,z){this._withAdapter(C,Fe,H=>H.releaseLinks(z),void 0,void 0,!0)}registerColorProvider(C,z,H){const j=this._addNewAdapter(new $e(this._documents,H),C);return this._proxy.$registerDocumentColorProvider(j,this._transformDocumentSelector(z)),this._createDisposable(j)}$provideDocumentColors(C,z,H){return this._withAdapter(C,$e,j=>j.provideColors(r.URI.revive(z),H),[],H)}$provideColorPresentations(C,z,H,j){return this._withAdapter(C,$e,se=>se.provideColorPresentations(r.URI.revive(z),H,j),void 0,j)}registerFoldingRangeProvider(C,z,H){const j=this._nextHandle(),se=typeof H.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(j,new le(new Qe(this._documents,H),C)),this._proxy.$registerFoldingRangeProvider(j,this._transformDocumentSelector(z),se);let ce=this._createDisposable(j);if(se!==void 0){const Y=H.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(se));ce=L.Disposable.from(ce,Y)}return ce}$provideFoldingRanges(C,z,H,j){return this._withAdapter(C,Qe,se=>se.provideFoldingRanges(r.URI.revive(z),H,j),void 0,j)}registerSelectionRangeProvider(C,z,H){const j=this._addNewAdapter(new Te(this._documents,H,this._logService),C);return this._proxy.$registerSelectionRangeProvider(j,this._transformDocumentSelector(z)),this._createDisposable(j)}$provideSelectionRanges(C,z,H,j){return this._withAdapter(C,Te,se=>se.provideSelectionRanges(r.URI.revive(z),H,j),[],j)}registerCallHierarchyProvider(C,z,H){const j=this._addNewAdapter(new _e(this._documents,H),C);return this._proxy.$registerCallHierarchyProvider(j,this._transformDocumentSelector(z)),this._createDisposable(j)}$prepareCallHierarchy(C,z,H,j){return this._withAdapter(C,_e,se=>Promise.resolve(se.prepareSession(r.URI.revive(z),H,j)),void 0,j)}$provideCallHierarchyIncomingCalls(C,z,H,j){return this._withAdapter(C,_e,se=>se.provideCallsTo(z,H,j),void 0,j)}$provideCallHierarchyOutgoingCalls(C,z,H,j){return this._withAdapter(C,_e,se=>se.provideCallsFrom(z,H,j),void 0,j)}$releaseCallHierarchy(C,z){this._withAdapter(C,_e,H=>Promise.resolve(H.releaseSession(z)),void 0,void 0)}registerTypeHierarchyProvider(C,z,H){const j=this._addNewAdapter(new ye(this._documents,H),C);return this._proxy.$registerTypeHierarchyProvider(j,this._transformDocumentSelector(z)),this._createDisposable(j)}$prepareTypeHierarchy(C,z,H,j){return this._withAdapter(C,ye,se=>Promise.resolve(se.prepareSession(r.URI.revive(z),H,j)),void 0,j)}$provideTypeHierarchySupertypes(C,z,H,j){return this._withAdapter(C,ye,se=>se.provideSupertypes(z,H,j),void 0,j)}$provideTypeHierarchySubtypes(C,z,H,j){return this._withAdapter(C,ye,se=>se.provideSubtypes(z,H,j),void 0,j)}$releaseTypeHierarchy(C,z){this._withAdapter(C,ye,H=>Promise.resolve(H.releaseSession(z)),void 0,void 0)}registerDocumentOnDropEditProvider(C,z,H){const j=this._nextHandle();return this._adapter.set(j,new le(new ae(this._proxy,this._documents,H,j),C)),this._proxy.$registerDocumentOnDropEditProvider(j,this._transformDocumentSelector(z)),this._createDisposable(j)}$provideDocumentOnDropEdits(C,z,H,j,se,ce){return this._withAdapter(C,ae,Y=>Promise.resolve(Y.provideDocumentOnDropEdits(z,r.URI.revive(H),j,se,ce)),void 0,void 0)}registerDocumentPasteEditProvider(C,z,H,j){const se=this._nextHandle();return this._adapter.set(se,new le(new x(this._proxy,this._documents,H,se),C)),this._proxy.$registerPasteEditProvider(se,this._transformDocumentSelector(z),!!H.prepareDocumentPaste,j.pasteMimeTypes),this._createDisposable(se)}$prepareDocumentPaste(C,z,H,j,se){return this._withAdapter(C,x,ce=>ce.prepareDocumentPaste(r.URI.revive(z),H,j,se),void 0,se)}$providePasteEdits(C,z,H,j,se,ce){return this._withAdapter(C,x,Y=>Y.providePasteEdits(z,r.URI.revive(H),j,se,ce),void 0,ce)}static _serializeRegExp(C){return{pattern:C.source,flags:(0,E.regExpFlags)(C)}}static _serializeIndentationRule(C){return{decreaseIndentPattern:Q._serializeRegExp(C.decreaseIndentPattern),increaseIndentPattern:Q._serializeRegExp(C.increaseIndentPattern),indentNextLinePattern:C.indentNextLinePattern?Q._serializeRegExp(C.indentNextLinePattern):void 0,unIndentedLinePattern:C.unIndentedLinePattern?Q._serializeRegExp(C.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(C){return{beforeText:Q._serializeRegExp(C.beforeText),afterText:C.afterText?Q._serializeRegExp(C.afterText):void 0,previousLineText:C.previousLineText?Q._serializeRegExp(C.previousLineText):void 0,action:C.action}}static _serializeOnEnterRules(C){return C.map(Q._serializeOnEnterRule)}setLanguageConfiguration(C,z,H){const{wordPattern:j}=H;if(j&&(0,E.regExpLeadsToEndlessLoop)(j))throw new Error(`Invalid language configuration: wordPattern '${j}' is not allowed to match the empty string.`);j?this._documents.setWordDefinitionFor(z,j):this._documents.setWordDefinitionFor(z,void 0),H.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",C,"Do not use."),H.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",C,"Do not use.");const se=this._nextHandle(),ce={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?Q._serializeRegExp(H.wordPattern):void 0,indentationRules:H.indentationRules?Q._serializeIndentationRule(H.indentationRules):void 0,onEnterRules:H.onEnterRules?Q._serializeOnEnterRules(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport};return this._proxy.$setLanguageConfiguration(se,z,ce),this._createDisposable(se)}$setWordDefinitions(C){for(const z of C)this._documents.setWordDefinitionFor(z.languageId,new RegExp(z.regexSource,z.regexFlags))}}e.ExtHostLanguageFeatures=Q,Q._handlePool=0}),define(Ce[203],Ie([1,0,4,8,6,29,14,7]),function(te,e,r,y,w,L,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class E{constructor(F,S,m,T){this._documents=S,this._commands=m,this._uriTransformer=T,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=F.getProxy(r.MainContext.MainThreadLanguages)}$acceptLanguageIds(F){this._languageIds=F}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(F,S){await this._proxy.$changeLanguage(F,S);const m=this._documents.getDocumentData(F);if(!m)throw new Error(`document '${F.toString()}' NOT found`);return m.document}async tokenAtPosition(F,S){const m=F.version,T=y.Position.from(S),f=await this._proxy.$tokensAtPosition(F.uri,T),c={type:w.StandardTokenType.Other,range:F.getWordRangeAtPosition(S)??new w.Range(S.line,S.character,S.line,S.character)};if(!f)return c;const h={range:y.Range.to(f.range),type:y.TokenType.to(f.type)};return!h.range.contains(S)||m!==F.version?c:h}createLanguageStatusItem(F,S,m){const T=this._handlePool++,f=this._proxy,c=this._ids,h=`${F.identifier.value}/${S}`;if(c.has(h))throw new Error(`LanguageStatusItem with id '${S}' ALREADY exists`);c.add(h);const u={selector:m,id:S,name:F.displayName??F.name,severity:w.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let v;const I=new A.DisposableStore,l=()=>{v?.dispose(),v=(0,_.disposableTimeout)(()=>{I.clear(),this._proxy.$setLanguageStatus(T,{id:h,name:u.name??F.displayName??F.name,source:F.displayName??F.name,selector:y.DocumentSelector.from(u.selector,this._uriTransformer),label:u.text,detail:u.detail??"",severity:u.severity===w.LanguageStatusSeverity.Error?L.default.Error:u.severity===w.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:u.command&&this._commands.toInternal(u.command,I),accessibilityInfo:u.accessibilityInformation,busy:u.busy})},0)},b={dispose(){I.dispose(),v?.dispose(),f.$removeLanguageStatus(T),c.delete(h)},get id(){return u.id},get name(){return u.name},set name(t){u.name=t,l()},get selector(){return u.selector},set selector(t){u.selector=t,l()},get text(){return u.text},set text(t){u.text=t,l()},get detail(){return u.detail},set detail(t){u.detail=t,l()},get severity(){return u.severity},set severity(t){u.severity=t,l()},get accessibilityInformation(){return u.accessibilityInformation},set accessibilityInformation(t){u.accessibilityInformation=t,l()},get command(){return u.command},set command(t){u.command=t,l()},get busy(){return u.busy},set busy(t){u.busy=t,l()}};return l(),b}}e.ExtHostLanguages=E}),define(Ce[204],Ie([1,0,15,4,28,13,5]),function(te,e,r,y,w,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let A=class extends r.AbstractLoggerService{constructor(F,S){const m=new _.Emitter;super(S.logLevel,m.event),this._proxy=F.getProxy(y.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(m)}$setLevel(F){this._onDidChangeLogLevel.fire(F)}doCreateLogger(F,S,m){return new E(this._proxy,F,S,m)}};A=ze([xe(0,L.IExtHostRpcService),xe(1,w.IExtHostInitDataService)],A),e.ExtHostLoggerService=A;class E extends r.AbstractMessageLogger{constructor(F,S,m,T){super(T?.always),this.proxy=F,this.file=S,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(m),this.proxy.$createLogger(S,T).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(F,S){const m=[[F,S]];this.isLoggerCreated?this.doLog(m):this.buffer.push(...m)}doLog(F){this.proxy.$log(this.file,F)}}}),define(Ce[205],Ie([1,0,4,15,24]),function(te,e,r,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function L(A){return A&&A.title}let _=class{constructor(E,k){this._logService=k,this._proxy=E.getProxy(r.MainContext.MainThreadMessageService)}showMessage(E,k,F,S,m){const T={source:{identifier:E.identifier,label:E.displayName||E.name}};let f;typeof S=="string"||L(S)?f=[S,...m]:(T.modal=S?.modal,T.useCustom=S?.useCustom,T.detail=S?.detail,f=m),T.useCustom&&(0,w.checkProposedApiEnabled)(E,"resolvers");const c=[];for(let h=0;h<f.length;h++){const u=f[h];if(typeof u=="string")c.push({title:u,handle:h,isCloseAffordance:!1});else if(typeof u=="object"){const{title:v,isCloseAffordance:I}=u;c.push({title:v,isCloseAffordance:!!I,handle:h})}else this._logService.warn("Invalid message item:",u)}return this._proxy.$showMessage(k,F,T,c).then(h=>{if(typeof h=="number")return f[h]})}};_=ze([xe(1,y.ILogService)],_),e.ExtHostMessageService=_}),define(Ce[206],Ie([1,0,23,5,7,25,9,10,2,61,4,36,8,6,40,178,93]),function(te,e,r,y,w,L,_,A,E,k,F,S,m,T,f,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class u{constructor(I,l,b,t){this._textDocumentsAndEditors=b,this._textDocuments=t,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new L.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new y.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new y.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new y.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new y.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new k.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=I.getProxy(F.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=I.getProxy(F.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=I.getProxy(F.MainContext.MainThreadNotebookEditors),this._commandsConverter=l.converter,l.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===12){const n=d.notebookEditor?.notebookUri,i=d.cell.handle,a=this._documents.get(n)?.getCell(i);if(a)return a.apiCell}return d}}),u._registerApiCommands(l)}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(I=>I.apiEditor)}getEditorById(I){const l=this._editors.get(I);if(!l)throw new Error(`unknown text editor: ${I}. known editors: ${[...this._editors.keys()]} `);return l}getIdByEditor(I){for(const[l,b]of this._editors)if(b.apiEditor===I)return l}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(I,l){const b=this._documents.get(I);if(!b&&!l)throw new Error(`NO notebook document for '${I}'`);return b}_getProviderData(I){const l=this._notebookContentProviders.get(I);if(!l)throw new Error(`NO provider for '${I}'`);return l}registerNotebookContentProvider(I,l,b,t,d){if((0,_.isFalsyOrWhitespace)(l))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(l))throw new Error(`Notebook provider for '${l}' already registered`);return this._notebookContentProviders.set(l,{extension:I,provider:b}),this._notebookProxy.$registerNotebookProvider({id:I.identifier,location:I.extensionLocation},l,m.NotebookDocumentContentOptions.from(t),u._convertNotebookRegistrationData(I,d)),new T.Disposable(()=>{this._notebookContentProviders.delete(l),this._notebookProxy.$unregisterNotebookProvider(l)})}static _convertNotebookRegistrationData(I,l){if(!l)return;const b=l.filenamePattern.map(t=>m.NotebookExclusiveDocumentPattern.from(t)).filter(t=>t!==void 0);if(l.filenamePattern&&!b){console.warn(`Notebook content provider view options file name pattern is invalid ${l.filenamePattern}`);return}return{extension:I.identifier,providerDisplayName:I.displayName||I.name,displayName:l.displayName,filenamePattern:b,exclusive:l.exclusive||!1}}registerNotebookCellStatusBarItemProvider(I,l,b){const t=u._notebookStatusBarItemProviderHandlePool++,d=typeof b.onDidChangeCellStatusBarItems=="function"?u._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(t,b),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(t,d,l);let n;return d!==void 0&&(n=b.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(d))),new T.Disposable(()=>{this._notebookStatusBarItemProviders.delete(t),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(t,d),n?.dispose()})}async createNotebookDocument(I){const l=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:I.viewType,content:I.content&&m.NotebookData.from(I.content)});return E.URI.revive(l)}async openNotebookDocument(I){const l=this._documents.get(I);if(l)return l.apiNotebook;const b=await this._notebookDocumentsProxy.$tryOpenNotebook(I),t=this._documents.get(E.URI.revive(b));return(0,A.assertIsDefined)(t?.apiNotebook)}async showNotebookDocument(I,l){E.URI.isUri(I)&&(I=await this.openNotebookDocument(I));let b;typeof l=="object"?b={position:m.ViewColumn.from(l.viewColumn),preserveFocus:l.preserveFocus,selections:l.selections&&l.selections.map(m.NotebookRange.from),pinned:typeof l.preview=="boolean"?!l.preview:void 0}:b={preserveFocus:!1};const t=await this._notebookEditorsProxy.$tryShowNotebookDocument(I.uri,I.notebookType,b),d=t&&this._editors.get(t)?.apiEditor;if(d)return d;throw t?new Error(`Could NOT open editor for "${I.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${I.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(I,l,b,t){const d=this._notebookStatusBarItemProviders.get(I),n=E.URI.revive(l),i=this._documents.get(n);if(!i||!d)return;const s=i.getCellFromIndex(b);if(!s)return;const a=await d.provideCellStatusBarItems(s.apiCell,t);if(!a)return;const o=new w.DisposableStore,g=this._statusBarCache.add([o]),P=(Array.isArray(a)?a:[a]).map(M=>m.NotebookStatusBarItem.from(M,this._commandsConverter,o));return{cacheId:g,items:P}}$releaseNotebookCellStatusBarItems(I){this._statusBarCache.delete(I)}registerNotebookSerializer(I,l,b,t,d){if((0,_.isFalsyOrWhitespace)(l))throw new Error("viewType cannot be empty or just whitespace");const n=this._handlePool++;return this._notebookSerializer.set(n,b),this._notebookProxy.$registerNotebookSerializer(n,{id:I.identifier,location:I.extensionLocation},l,m.NotebookDocumentContentOptions.from(t),u._convertNotebookRegistrationData(I,d)),(0,w.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(n)})}async $dataToNotebook(I,l,b){const t=this._notebookSerializer.get(I);if(!t)throw new Error("NO serializer found");const d=await t.deserializeNotebook(l.buffer,b);return new f.SerializableObjectWithBuffers(m.NotebookData.from(d))}async $notebookToData(I,l,b){const t=this._notebookSerializer.get(I);if(!t)throw new Error("NO serializer found");const d=await t.serializeNotebook(m.NotebookData.to(l.value),b);return r.VSBuffer.wrap(d)}async $openNotebook(I,l,b,t,d){const{provider:n}=this._getProviderData(I),i=await n.openNotebook(E.URI.revive(l),{backupId:b,untitledDocumentData:t?.buffer},d);return new f.SerializableObjectWithBuffers({metadata:i.metadata??Object.create(null),cells:i.cells.map(m.NotebookCellData.from)})}_createExtHostEditor(I,l,b){if(this._editors.has(l))throw new Error(`editor with id ALREADY EXSIST: ${l}`);const t=new h.ExtHostNotebookEditor(l,this._notebookEditorsProxy,I,b.visibleRanges.map(m.NotebookRange.to),b.selections.map(m.NotebookRange.to),typeof b.viewColumn=="number"?m.ViewColumn.to(b.viewColumn):void 0);this._editors.set(l,t)}$acceptDocumentAndEditorsDelta(I){if(I.value.removedDocuments)for(const b of I.value.removedDocuments){const t=E.URI.revive(b),d=this._documents.get(t);d&&(d.dispose(),this._documents.delete(t),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:d.apiNotebook.getCells().map(n=>n.document.uri)}),this._onDidCloseNotebookDocument.fire(d.apiNotebook));for(const n of this._editors.values())n.notebookData.uri.toString()===t.toString()&&this._editors.delete(n.id)}if(I.value.addedDocuments){const b=[];for(const t of I.value.addedDocuments){const d=E.URI.revive(t.uri);if(this._documents.has(d))throw new Error(`adding EXISTING notebook ${d} `);const n=new c.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,d,t);b.push(...t.cells.map(i=>c.ExtHostCell.asModelAddData(n.apiNotebook,i))),this._documents.get(d)?.dispose(),this._documents.set(d,n),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:b}),this._onDidOpenNotebookDocument.fire(n.apiNotebook)}}if(I.value.addedEditors)for(const b of I.value.addedEditors){if(this._editors.has(b.id))return;const t=E.URI.revive(b.documentUri),d=this._documents.get(t);d&&this._createExtHostEditor(d,b.id,b)}const l=[];if(I.value.removedEditors)for(const b of I.value.removedEditors){const t=this._editors.get(b);t&&(this._editors.delete(b),this._activeNotebookEditor?.id===t.id&&(this._activeNotebookEditor=void 0),l.push(t))}if(I.value.visibleEditors){this._visibleNotebookEditors=I.value.visibleEditors.map(t=>this._editors.get(t)).filter(t=>!!t);const b=new Set;this._visibleNotebookEditors.forEach(t=>b.add(t.id));for(const t of this._editors.values()){const d=b.has(t.id);t._acceptVisibility(d)}this._visibleNotebookEditors=[...this._editors.values()].map(t=>t).filter(t=>t.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}I.value.newActiveEditor===null?this._activeNotebookEditor=void 0:I.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(I.value.newActiveEditor)),I.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(I){const l=S.ApiCommandArgument.String.with("notebookType","A notebook type"),b=new S.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[l,new S.ApiCommandArgument("data","Bytes to convert to data",d=>d instanceof Uint8Array,d=>r.VSBuffer.wrap(d))],new S.ApiCommandResult("Notebook Data",d=>m.NotebookData.to(d.value))),t=new S.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[l,new S.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",d=>!0,d=>new f.SerializableObjectWithBuffers(m.NotebookData.from(d)))],new S.ApiCommandResult("Bytes",d=>d.buffer));I.registerApiCommand(b),I.registerApiCommand(t)}}e.ExtHostNotebookController=u,u._notebookStatusBarItemProviderHandlePool=0}),define(Ce[207],Ie([1,0,16,14,20,5,7,25,2,27,15,4,36,8,6,63,166,24,40]),function(te,e,r,y,w,L,_,A,E,k,F,S,m,T,f,c,h,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let I=class{constructor(i,s,a,o,g){this._initData=s,this._extHostNotebook=a,this._commands=o,this._logService=g,this._activeExecutions=new A.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new L.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=i.getProxy(S.MainContext.MainThreadNotebookKernels);const p=new m.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new m.ApiCommandArgument("options","Select kernel options",P=>!0,P=>{if(P&&"notebookEditor"in P&&"id"in P){const M=this._extHostNotebook.getIdByEditor(P.notebookEditor);return{id:P.id,extension:P.extension,notebookEditorId:M}}else if(P&&"notebookEditor"in P){const M=this._extHostNotebook.getIdByEditor(P.notebookEditor);if(M===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${P.notebookEditor.document.uri.toString()}`);return{notebookEditorId:M}}return P})],m.ApiCommandResult.Void);this._commands.registerApiCommand(p)}createNotebookController(i,s,a,o,g,p){for(const de of this._kernelData.values())if(de.controller.id===s&&k.ExtensionIdentifier.equals(i.identifier,de.extensionId))throw new Error(`notebook controller with id '${s}' ALREADY exist`);const P=this._handlePool++,M=this;this._logService.trace(`NotebookController[${P}], CREATED by ${i.identifier.value}, ${s}`);const V=()=>console.warn(`NO execute handler from notebook controller '${R.id}' of extension: '${i.identifier}'`);let B=!1;const D=new _.DisposableStore,x=new L.Emitter,U=new L.Emitter,R={id:d(i.identifier,s),notebookType:a,extensionId:i.identifier,extensionLocation:i.extensionLocation,label:o||i.identifier.value,preloads:p?p.map(T.NotebookRendererScript.from):[]};let K=g??V,W;this._proxy.$addKernel(P,R).catch(de=>{console.log(de),B=!0});let O=0;const Z=()=>{if(B)return;const de=++O;Promise.resolve().then(()=>{de===O&&this._proxy.$updateKernel(P,R)})},ue=new A.ResourceMap,oe={get id(){return s},get notebookType(){return R.notebookType},onDidChangeSelectedNotebooks:x.event,get label(){return R.label},set label(de){R.label=de??i.displayName??i.name,Z()},get detail(){return R.detail??""},set detail(de){R.detail=de,Z()},get description(){return R.description??""},set description(de){R.description=de,Z()},get kind(){return(0,u.checkProposedApiEnabled)(i,"notebookControllerKind"),R.kind??""},set kind(de){(0,u.checkProposedApiEnabled)(i,"notebookControllerKind"),R.kind=de,Z()},get supportedLanguages(){return R.supportedLanguages},set supportedLanguages(de){R.supportedLanguages=de,Z()},get supportsExecutionOrder(){return R.supportsExecutionOrder??!1},set supportsExecutionOrder(de){R.supportsExecutionOrder=de,Z()},get rendererScripts(){return R.preloads?R.preloads.map(T.NotebookRendererScript.to):[]},get executeHandler(){return K},set executeHandler(de){K=de??V},get interruptHandler(){return W},set interruptHandler(de){W=de,R.supportsInterrupt=Boolean(de),Z()},createNotebookCellExecution(de){if(B)throw new Error("notebook controller is DISPOSED");if(!ue.has(de.notebook.uri))throw M._logService.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ue.keys()).map(ie=>ie.toString())),new Error(`notebook controller is NOT associated to notebook: ${de.notebook.uri.toString()}`);return M._createNotebookCellExecution(de,d(i.identifier,this.id))},dispose:()=>{B||(this._logService.trace(`NotebookController[${P}], DISPOSED`),B=!0,this._kernelData.delete(P),D.dispose(),x.dispose(),U.dispose(),this._proxy.$removeKernel(P))},updateNotebookAffinity(de,ie){M._proxy.$updateNotebookPriority(P,de.uri,ie)},onDidReceiveMessage:U.event,postMessage(de,ie){return(0,u.checkProposedApiEnabled)(i,"notebookMessaging"),M._proxy.$postMessage(P,ie&&M._extHostNotebook.getIdByEditor(ie),de)},asWebviewUri(de){return(0,u.checkProposedApiEnabled)(i,"notebookMessaging"),(0,c.asWebviewUri)(de,M._initData.remote)}};return this._kernelData.set(P,{extensionId:i.identifier,controller:oe,onDidReceiveMessage:U,onDidChangeSelection:x,associatedNotebooks:ue}),oe}getIdByController(i){for(const[s,a]of this._kernelData)if(a.controller===i)return d(a.extensionId,i.id);return null}$acceptNotebookAssociation(i,s,a){const o=this._kernelData.get(i);if(o){const g=this._extHostNotebook.getNotebookDocument(E.URI.revive(s));a?o.associatedNotebooks.set(g.uri,!0):o.associatedNotebooks.delete(g.uri),this._logService.trace(`NotebookController[${i}] ASSOCIATE notebook`,g.uri.toString(),a),o.onDidChangeSelection.fire({selected:a,notebook:g.apiNotebook})}}async $executeCells(i,s,a){const o=this._kernelData.get(i);if(!o)return;const g=this._extHostNotebook.getNotebookDocument(E.URI.revive(s)),p=[];for(const P of a){const M=g.getCell(P);M&&p.push(M.apiCell)}try{this._logService.trace(`NotebookController[${i}] EXECUTE cells`,g.uri.toString(),p.length),await o.controller.executeHandler.call(o.controller,p,g.apiNotebook,o.controller)}catch(P){this._logService.error(`NotebookController[${i}] execute cells FAILED`,P),console.error(P)}}async $cancelCells(i,s,a){const o=this._kernelData.get(i);if(!o)return;const g=this._extHostNotebook.getNotebookDocument(E.URI.revive(s));if(o.controller.interruptHandler)await o.controller.interruptHandler.call(o.controller,g.apiNotebook);else for(const p of a){const P=g.getCell(p);P&&this._activeExecutions.get(P.uri)?.cancel()}}$acceptKernelMessageFromRenderer(i,s,a){const o=this._kernelData.get(i);if(!o)return;const g=this._extHostNotebook.getEditorById(s);o.onDidReceiveMessage.fire(Object.freeze({editor:g.apiEditor,message:a}))}$cellExecutionChanged(i,s,a){const g=this._extHostNotebook.getNotebookDocument(E.URI.revive(i)).getCell(s);if(g){const p=a?T.NotebookCellExecutionState.to(a):f.NotebookCellExecutionState.Idle;p!==void 0&&this._onDidChangeCellExecutionState.fire({cell:g.apiCell,state:p})}}_createNotebookCellExecution(i,s){if(i.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const o=this._extHostNotebook.getNotebookDocument(i.notebook.uri).getCellFromApiCell(i);if(!o)throw new Error("invalid cell");if(this._activeExecutions.has(o.uri))throw new Error(`duplicate execution for ${o.uri}`);const g=new b(s,o,this._proxy);this._activeExecutions.set(o.uri,g);const p=g.onDidChangeState(()=>{g.state===l.Resolved&&(g.dispose(),p.dispose(),this._activeExecutions.delete(o.uri))});return g.asApiObject()}};I=ze([xe(4,F.ILogService)],I),e.ExtHostNotebookKernels=I;var l;(function(n){n[n.Init=0]="Init",n[n.Started=1]="Started",n[n.Resolved=2]="Resolved"})(l||(l={}));class b extends _.Disposable{constructor(i,s,a){super(),this._cell=s,this._proxy=a,this._handle=b.HANDLE++,this._onDidChangeState=new L.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=l.Init,this._tokenSource=this._register(new w.CancellationTokenSource),this._collector=new t(10,o=>this.update(o)),this._executionOrder=s.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,i,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(i){await this._collector.addItem(i)}async update(i){const s=Array.isArray(i)?i:[i];return this._proxy.$updateExecution(this._handle,new v.SerializableObjectWithBuffers(s))}verifyStateForOutput(){if(this._state===l.Init)throw new Error("Must call start before modifying cell output");if(this._state===l.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(i){let s=this._cell;if(i&&(s=this._cell.notebook.getCellFromApiCell(i)),!s)throw new Error("INVALID cell");return s.handle}validateAndConvertOutputs(i){return i.map(s=>{const a=f.NotebookCellOutput.ensureUniqueMimeTypes(s.items,!0);return a===s.items?T.NotebookCellOutput.from(s):T.NotebookCellOutput.from({items:a,id:s.id,metadata:s.metadata})})}async updateOutputs(i,s,a){const o=this.cellIndexToHandle(s),g=this.validateAndConvertOutputs((0,r.asArray)(i));return this.updateSoon({editType:h.CellExecutionUpdateType.Output,cellHandle:o,append:a,outputs:g})}async updateOutputItems(i,s,a){return i=f.NotebookCellOutput.ensureUniqueMimeTypes((0,r.asArray)(i),!0),this.updateSoon({editType:h.CellExecutionUpdateType.OutputItems,items:i.map(T.NotebookCellOutputItem.from),outputId:s.id,append:a})}asApiObject(){const i=this;return Object.freeze({get token(){return i._tokenSource.token},get cell(){return i._cell.apiCell},get executionOrder(){return i._executionOrder},set executionOrder(a){i._executionOrder=a,i.update([{editType:h.CellExecutionUpdateType.ExecutionState,executionOrder:i._executionOrder}])},start(a){if(i._state===l.Resolved||i._state===l.Started)throw new Error("Cannot call start again");i._state=l.Started,i._onDidChangeState.fire(),i.update({editType:h.CellExecutionUpdateType.ExecutionState,runStartTime:a})},end(a,o){if(i._state===l.Resolved)throw new Error("Cannot call resolve twice");i._state=l.Resolved,i._onDidChangeState.fire(),i._collector.flush(),i._proxy.$completeExecution(i._handle,new v.SerializableObjectWithBuffers({runEndTime:o,lastRunSuccess:a}))},clearOutput(a){return i.verifyStateForOutput(),i.updateOutputs([],a,!1)},appendOutput(a,o){return i.verifyStateForOutput(),i.updateOutputs(a,o,!0)},replaceOutput(a,o){return i.verifyStateForOutput(),i.updateOutputs(a,o,!1)},appendOutputItems(a,o){return i.verifyStateForOutput(),i.updateOutputItems(a,o,!0)},replaceOutputItems(a,o){return i.verifyStateForOutput(),i.updateOutputItems(a,o,!1)}})}}b.HANDLE=0;class t{constructor(i,s){this.delay=i,this.callback=s,this.batch=[],this.startedTimer=Date.now()}addItem(i){return this.batch.push(i),this.currentDeferred||(this.currentDeferred=new y.DeferredPromise,this.startedTimer=Date.now(),(0,y.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const i=this.currentDeferred;this.currentDeferred=void 0;const s=this.batch;return this.batch=[],this.callback(s).finally(()=>i.complete())}}function d(n,i){return`${n.value}/${i}`}e.createKernelId=d}),define(Ce[208],Ie([1,0,5,4,93]),function(te,e,r,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class L{constructor(A,E){this._extHostNotebook=E,this._rendererMessageEmitters=new Map,this.proxy=A.getProxy(y.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(A,E,k){const F=this._extHostNotebook.getEditorById(A);this._rendererMessageEmitters.get(E)?.fire({editor:F.apiEditor,message:k})}createRendererMessaging(A,E){if(!A.contributes?.notebookRenderer?.some(F=>F.id===E))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${E})`);return{onDidReceiveMessage:(F,S,m)=>this.getOrCreateEmitterFor(E).event(F,S,m),postMessage:(F,S)=>{w.ExtHostNotebookEditor.apiEditorsToExtHost.has(F)&&([F,S]=[S,F]);const m=S&&w.ExtHostNotebookEditor.apiEditorsToExtHost.get(S);return this.proxy.$postMessage(m?.id,E,F)}}}getOrCreateEmitterFor(A){let E=this._rendererMessageEmitters.get(A);return E||(E=new r.Emitter({onLastListenerRemove:()=>{E?.dispose(),this._rendererMessageEmitters.delete(A)}}),this._rendererMessageEmitters.set(A,E),E)}}e.ExtHostNotebookRenderers=L}),define(Ce[209],Ie([1,0,20,5,7,4,2,6,11,16,29,60]),function(te,e,r,y,w,L,_,A,E,k,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function m(T,f,c){const h=T.getProxy(L.MainContext.MainThreadQuickOpen);class u{constructor(s,a){this._sessions=new Map,this._instances=0,this._workspace=s,this._commands=a}showQuickPick(s,a,o=r.CancellationToken.None){this._onDidSelectItem=void 0;const g=Promise.resolve(s),p=++this._instances,P=h.$show(p,{title:a?.title,placeHolder:a?.placeHolder,matchOnDescription:a?.matchOnDescription,matchOnDetail:a?.matchOnDetail,ignoreFocusLost:a?.ignoreFocusOut,canPickMany:a?.canPickMany},o),M={},V=P.then(()=>M);return Promise.race([V,g]).then(B=>{if(B!==M)return g.then(D=>{const x=[];for(let U=0;U<D.length;U++){const R=D[U];typeof R=="string"?x.push({label:R,handle:U}):R.kind===A.QuickPickItemKind.Separator?x.push({type:"separator",label:R.label}):x.push({label:R.label,description:R.description,detail:R.detail,picked:R.picked,alwaysShow:R.alwaysShow,handle:U})}return a&&typeof a.onDidSelectItem=="function"&&(this._onDidSelectItem=U=>{a.onDidSelectItem(D[U])}),h.$setItems(p,x),P.then(U=>{if(typeof U=="number")return D[U];if(Array.isArray(U))return U.map(R=>D[R])})})}).then(void 0,B=>{if(!(0,E.isCancellationError)(B))return h.$setError(p,B),Promise.reject(B)})}$onItemSelected(s){this._onDidSelectItem?.(s)}showInput(s,a=r.CancellationToken.None){return this._validateInput=s?.validateInput,h.$input(s,typeof this._validateInput=="function",a).then(void 0,o=>{if(!(0,E.isCancellationError)(o))return Promise.reject(o)})}async $validateInput(s){if(!this._validateInput)return;const a=await this._validateInput(s);if(!a||typeof a=="string")return a;let o;switch(a.severity){case A.InputBoxValidationSeverity.Info:o=F.default.Info;break;case A.InputBoxValidationSeverity.Warning:o=F.default.Warning;break;case A.InputBoxValidationSeverity.Error:o=F.default.Error;break;default:o=a.message?F.default.Error:F.default.Ignore;break}return{content:a.message,severity:o}}async showWorkspaceFolderPick(s,a=r.CancellationToken.None){const o=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[s]);if(!o)return;const g=await this._workspace.getWorkspaceFolders2();if(!!g)return g.find(p=>p.uri.toString()===o.uri.toString())}createQuickPick(s){const a=new d(s,()=>this._sessions.delete(a._id));return this._sessions.set(a._id,a),a}createInputBox(s){const a=new n(s,()=>this._sessions.delete(a._id));return this._sessions.set(a._id,a),a}$onDidChangeValue(s,a){this._sessions.get(s)?._fireDidChangeValue(a)}$onDidAccept(s){this._sessions.get(s)?._fireDidAccept()}$onDidChangeActive(s,a){const o=this._sessions.get(s);o instanceof d&&o._fireDidChangeActive(a)}$onDidChangeSelection(s,a){const o=this._sessions.get(s);o instanceof d&&o._fireDidChangeSelection(a)}$onDidTriggerButton(s,a){this._sessions.get(s)?._fireDidTriggerButton(a)}$onDidTriggerItemButton(s,a,o){const g=this._sessions.get(s);g instanceof d&&g._fireDidTriggerItemButton(a,o)}$onDidHide(s){this._sessions.get(s)?._fireDidHide()}}class v{constructor(s,a){this._extensionId=s,this._onDidDispose=a,this._id=d._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new y.Emitter,this._onDidChangeValueEmitter=new y.Emitter,this._onDidTriggerButtonEmitter=new y.Emitter,this._onDidHideEmitter=new y.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(s){this._title=s,this.update({title:s})}get step(){return this._steps}set step(s){this._steps=s,this.update({step:s})}get totalSteps(){return this._totalSteps}set totalSteps(s){this._totalSteps=s,this.update({totalSteps:s})}get enabled(){return this._enabled}set enabled(s){this._enabled=s,this.update({enabled:s})}get busy(){return this._busy}set busy(s){this._busy=s,this.update({busy:s})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(s){this._ignoreFocusOut=s,this.update({ignoreFocusOut:s})}get value(){return this._value}set value(s){this._value=s,this.update({value:s})}get placeholder(){return this._placeholder}set placeholder(s){this._placeholder=s,this.update({placeholder:s})}get buttons(){return this._buttons}set buttons(s){this._buttons=s.slice(),this._handlesToButtons.clear(),s.forEach((a,o)=>{const g=a===A.QuickInputButtons.Back?-1:o;this._handlesToButtons.set(g,a)}),this.update({buttons:s.map((a,o)=>({...t(a),tooltip:a.tooltip,handle:a===A.QuickInputButtons.Back?-1:o}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(s){this._value=s,this._onDidChangeValueEmitter.fire(s)}_fireDidTriggerButton(s){const a=this._handlesToButtons.get(s);a&&this._onDidTriggerButtonEmitter.fire(a)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,w.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),h.$dispose(this._id))}update(s){if(!this._disposed){for(const a of Object.keys(s)){const o=s[a];this._pendingUpdate[a]=o===void 0?null:o}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){h.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}v._nextId=1;function I(i){if(i instanceof A.ThemeIcon)return{id:i.id};const s=b(i),a=l(i);return{dark:typeof s=="string"?_.URI.file(s):s,light:typeof a=="string"?_.URI.file(a):a}}function l(i){return typeof i=="object"&&"light"in i?i.light:i}function b(i){return typeof i=="object"&&"dark"in i?i.dark:i}function t(i){const s=I(i.iconPath);let a,o;return"id"in s?o=S.ThemeIcon.asClassName(s):a=s,{iconPath:a,iconClass:o}}class d extends v{constructor(s,a){super(s.identifier,a),this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new y.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new y.Emitter,this._onDidTriggerItemButtonEmitter=new y.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(s){this._items=s.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),s.forEach((o,g)=>{this._handlesToItems.set(g,o),this._itemsToHandles.set(o,g)});const a=[];for(let o=0;o<s.length;o++){const g=s[o];g.kind===A.QuickPickItemKind.Separator?a.push({type:"separator",label:g.label}):a.push({handle:o,label:g.label,description:g.description,detail:g.detail,picked:g.picked,alwaysShow:g.alwaysShow,buttons:g.buttons?.map((p,P)=>({...t(p),tooltip:p.tooltip,handle:P}))})}this.update({items:a})}get canSelectMany(){return this._canSelectMany}set canSelectMany(s){this._canSelectMany=s,this.update({canSelectMany:s})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(s){this._matchOnDescription=s,this.update({matchOnDescription:s})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(s){this._matchOnDetail=s,this.update({matchOnDetail:s})}get sortByLabel(){return this._sortByLabel}set sortByLabel(s){this._sortByLabel=s,this.update({sortByLabel:s})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(s){this._keepScrollPosition=s,this.update({keepScrollPosition:s})}get activeItems(){return this._activeItems}set activeItems(s){this._activeItems=s.filter(a=>this._itemsToHandles.has(a)),this.update({activeItems:this._activeItems.map(a=>this._itemsToHandles.get(a))})}get selectedItems(){return this._selectedItems}set selectedItems(s){this._selectedItems=s.filter(a=>this._itemsToHandles.has(a)),this.update({selectedItems:this._selectedItems.map(a=>this._itemsToHandles.get(a))})}_fireDidChangeActive(s){const a=(0,k.coalesce)(s.map(o=>this._handlesToItems.get(o)));this._activeItems=a,this._onDidChangeActiveEmitter.fire(a)}_fireDidChangeSelection(s){const a=(0,k.coalesce)(s.map(o=>this._handlesToItems.get(o)));this._selectedItems=a,this._onDidChangeSelectionEmitter.fire(a)}_fireDidTriggerItemButton(s,a){const o=this._handlesToItems.get(s);if(!o||!o.buttons||!o.buttons.length)return;const g=o.buttons[a];g&&this._onDidTriggerItemButtonEmitter.fire({button:g,item:o})}}class n extends v{constructor(s,a){super(s.identifier,a),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(s){this._password=s,this.update({password:s})}get prompt(){return this._prompt}set prompt(s){this._prompt=s,this.update({prompt:s})}get validationMessage(){return this._validationMessage}set validationMessage(s){this._validationMessage=s,s?typeof s=="string"?this.update({validationMessage:s,severity:F.default.Error}):this.update({validationMessage:s.message,severity:s.severity??F.default.Error}):this.update({validationMessage:void 0,severity:F.default.Ignore})}}return new u(f,c)}e.createExtHostQuickOpen=m});var Je=this&&this.__classPrivateFieldSet||function(te,e,r,y,w){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!w:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?w.call(te,r):w?w.value=r:e.set(te,r),r},Oe=this&&this.__classPrivateFieldGet||function(te,e,r,y){if(r==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?y:r==="a"?y.call(te):y?y.value:e.get(te)};define(Ce[210],Ie([1,0,2,5,55,7,14,4,16,117,15,27,60,8,24]),function(te,e,r,y,w,L,_,A,E,k,F,S,m,T,f){"use strict";var c,h;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function u(g){if(g)return typeof g.iconPath=="string"?r.URI.file(g.iconPath):r.URI.isUri(g.iconPath)||m.ThemeIcon.isThemeIcon(g.iconPath)?g.iconPath:void 0}function v(g,p){if(!g.iconPath&&!p.iconPath)return 0;if(g.iconPath){if(!p.iconPath)return 1}else return-1;const P=typeof g.iconPath=="string"?g.iconPath:r.URI.isUri(g.iconPath)?g.iconPath.fsPath:g.iconPath.id,M=typeof p.iconPath=="string"?p.iconPath:r.URI.isUri(p.iconPath)?p.iconPath.fsPath:p.iconPath.id;return(0,k.comparePaths)(P,M)}function I(g,p){let P=0;if(g.strikeThrough!==p.strikeThrough)return g.strikeThrough?1:-1;if(g.faded!==p.faded)return g.faded?1:-1;if(g.tooltip!==p.tooltip)return(g.tooltip||"").localeCompare(p.tooltip||"");if(P=v(g,p),P!==0)return P;if(g.light&&p.light)P=v(g.light,p.light);else{if(g.light)return 1;if(p.light)return-1}if(P!==0)return P;if(g.dark&&p.dark)P=v(g.dark,p.dark);else{if(g.dark)return 1;if(p.dark)return-1}return P}function l(g,p){if(g.command!==p.command)return g.command<p.command?-1:1;if(g.title!==p.title)return g.title<p.title?-1:1;if(g.tooltip!==p.tooltip){if(g.tooltip!==void 0&&p.tooltip!==void 0)return g.tooltip<p.tooltip?-1:1;if(g.tooltip!==void 0)return 1;if(p.tooltip!==void 0)return-1}if(g.arguments===p.arguments)return 0;if(g.arguments)if(p.arguments){if(g.arguments.length!==p.arguments.length)return g.arguments.length-p.arguments.length}else return 1;else return-1;for(let P=0;P<g.arguments.length;P++){const M=g.arguments[P],V=p.arguments[P];if(M!==V)return M<V?-1:1}return 0}function b(g,p){let P=(0,k.comparePaths)(g.resourceUri.fsPath,p.resourceUri.fsPath,!0);if(P!==0)return P;if(g.command&&p.command)P=l(g.command,p.command);else{if(g.command)return 1;if(p.command)return-1}if(P!==0)return P;if(g.decorations&&p.decorations)P=I(g.decorations,p.decorations);else{if(g.decorations)return 1;if(p.decorations)return-1}return P}function t(g,p){for(let P=0;P<g.length;P++)if(g[P]!==p[P])return!1;return!0}function d(g,p){return g.command===p.command&&g.title===p.title&&g.tooltip===p.tooltip&&(g.arguments&&p.arguments?t(g.arguments,p.arguments):g.arguments===p.arguments)}function n(g,p){return(0,E.equals)(g,p,d)}class i{constructor(p,P,M){this._extension=p,this._sourceControlHandle=M,c.set(this,void 0),this._value="",this._onDidChange=new y.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,Je(this,c,P,"f")}get value(){return this._value}set value(p){p=p??"",Oe(this,c,"f").$setInputBoxValue(this._sourceControlHandle,p),this.updateValue(p)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(p){Oe(this,c,"f").$setInputBoxPlaceholder(this._sourceControlHandle,p),this._placeholder=p}get validateInput(){return(0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(p){if((0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),p&&typeof p!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=p,Oe(this,c,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!p)}get enabled(){return this._enabled}set enabled(p){p=!!p,this._enabled!==p&&(this._enabled=p,Oe(this,c,"f").$setInputBoxEnablement(this._sourceControlHandle,p))}get visible(){return this._visible}set visible(p){p=!!p,this._visible!==p&&(this._visible=p,Oe(this,c,"f").$setInputBoxVisibility(this._sourceControlHandle,p))}showValidationMessage(p,P){(0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),Oe(this,c,"f").$showValidationMessage(this._sourceControlHandle,p,P)}$onInputBoxValueChange(p){this.updateValue(p)}updateValue(p){this._value=p,this._onDidChange.fire(p)}}e.ExtHostSCMInputBox=i,c=new WeakMap;class s{constructor(p,P,M,V,B){this._proxy=p,this._commands=P,this._sourceControlHandle=M,this._id=V,this._label=B,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new y.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new y.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=s._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(p){this._label=p,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,p)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(p){this._hideWhenEmpty=p,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(p){this._resourceStates=[...p],this._onDidUpdateResourceStates.fire()}getResourceState(p){return this._resourceStatesMap.get(p)}$executeResourceCommand(p,P){const M=this._resourceStatesCommandsMap.get(p);return M?(0,_.asPromise)(()=>this._commands.executeCommand(M.command,...M.arguments||[],P)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const p=[...this._resourceStates].sort(b),M=(0,E.sortedDiff)(this._resourceSnapshot,p,b).map(D=>{const x=D.toInsert.map(U=>{const R=this._resourceHandlePool++;this._resourceStatesMap.set(R,U);const K=U.resourceUri;let W;if(U.command)if(U.command.command==="vscode.open"||U.command.command==="vscode.diff"){const Ee=new L.DisposableStore;W=this._commands.converter.toInternal(U.command,Ee),this._resourceStatesDisposablesMap.set(R,Ee)}else this._resourceStatesCommandsMap.set(R,U.command);const O=u(U.decorations),Z=U.decorations&&u(U.decorations.light)||O,ue=U.decorations&&u(U.decorations.dark)||O,oe=[Z,ue],de=U.decorations&&U.decorations.tooltip||"",ie=U.decorations&&!!U.decorations.strikeThrough,ve=U.decorations&&!!U.decorations.faded,be=U.contextValue||"";return{rawResource:[R,K,oe,de,ie,ve,be,W],handle:R}});return{start:D.start,deleteCount:D.deleteCount,toInsert:x}}),V=M.map(({start:D,deleteCount:x,toInsert:U})=>[D,x,U.map(R=>R.rawResource)]),B=M.reverse();for(const{start:D,deleteCount:x,toInsert:U}of B){const R=U.map(W=>W.handle),K=this._handlesSnapshot.splice(D,x,...R);for(const W of K)this._resourceStatesMap.delete(W),this._resourceStatesCommandsMap.delete(W),this._resourceStatesDisposablesMap.get(W)?.dispose(),this._resourceStatesDisposablesMap.delete(W)}return this._resourceSnapshot=p,V}dispose(){this._disposed=!0,this._onDidDispose.fire()}}s._handlePool=0;class a{constructor(p,P,M,V,B,D){this._extension=p,this._commands=M,this._id=V,this._label=B,this._rootUri=D,h.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new L.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new L.MutableDisposable,this._statusBarDisposables=new L.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new y.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=a._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Je(this,h,P,"f"),this._inputBox=new i(p,Oe(this,h,"f"),this.handle),Oe(this,h,"f").$registerSourceControl(this.handle,V,B,D)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(p){this._count!==p&&(this._count=p,Oe(this,h,"f").$updateSourceControl(this.handle,{count:p}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(p){this._quickDiffProvider=p,Oe(this,h,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!p})}get commitTemplate(){return this._commitTemplate}set commitTemplate(p){p!==this._commitTemplate&&(this._commitTemplate=p,Oe(this,h,"f").$updateSourceControl(this.handle,{commitTemplate:p}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(p){this._acceptInputDisposables.value=new L.DisposableStore,this._acceptInputCommand=p;const P=this._commands.converter.toInternal(p,this._acceptInputDisposables.value);Oe(this,h,"f").$updateSourceControl(this.handle,{acceptInputCommand:P})}get actionButton(){return(0,f.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(p){(0,f.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new L.DisposableStore,this._actionButton=p;const P=p!==void 0?{command:this._commands.converter.toInternal(p.command,this._actionButtonDisposables.value),secondaryCommands:p.secondaryCommands?.map(M=>M.map(V=>this._commands.converter.toInternal(V,this._actionButtonDisposables.value))),description:p.description,enabled:p.enabled}:void 0;Oe(this,h,"f").$updateSourceControl(this.handle,{actionButton:P??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(p){if(this._statusBarCommands&&p&&n(this._statusBarCommands,p))return;this._statusBarDisposables.value=new L.DisposableStore,this._statusBarCommands=p;const P=(p||[]).map(M=>this._commands.converter.toInternal(M,this._statusBarDisposables.value));Oe(this,h,"f").$updateSourceControl(this.handle,{statusBarCommands:P})}get selected(){return this._selected}createResourceGroup(p,P){const M=new s(Oe(this,h,"f"),this._commands,this.handle,p,P),V=y.Event.once(M.onDidDispose)(()=>this.createdResourceGroups.delete(M));return this.createdResourceGroups.set(M,V),this.eventuallyAddResourceGroups(),M}eventuallyAddResourceGroups(){const p=[],P=[];for(const[M,V]of this.createdResourceGroups){V.dispose();const B=M.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(M),this.eventuallyUpdateResourceStates()});y.Event.once(M.onDidDispose)(()=>{this.updatedResourceGroups.delete(M),B.dispose(),this._groups.delete(M.handle),Oe(this,h,"f").$unregisterGroup(this.handle,M.handle)}),p.push([M.handle,M.id,M.label,M.features]);const D=M._takeResourceStateSnapshot();D.length>0&&P.push([M.handle,D]),this._groups.set(M.handle,M)}Oe(this,h,"f").$registerGroups(this.handle,p,P),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const p=[];this.updatedResourceGroups.forEach(P=>{const M=P._takeResourceStateSnapshot();M.length!==0&&p.push([P.handle,M])}),p.length>0&&Oe(this,h,"f").$spliceResourceStates(this.handle,p),this.updatedResourceGroups.clear()}getResourceGroup(p){return this._groups.get(p)}setSelectionState(p){this._selected=p,this._onDidChangeSelection.fire(p)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(p=>p.dispose()),Oe(this,h,"f").$unregisterSourceControl(this.handle)}}h=new WeakMap,a._handlePool=0,ze([(0,w.debounce)(100)],a.prototype,"eventuallyAddResourceGroups",null),ze([(0,w.debounce)(100)],a.prototype,"eventuallyUpdateResourceStates",null);let o=class Yi{constructor(p,P,M){this._commands=P,this.logService=M,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new y.Emitter,this._proxy=p.getProxy(A.MainContext.MainThreadSCM),this._telemetry=p.getProxy(A.MainContext.MainThreadTelemetry),P.registerArgumentProcessor({processArgument:V=>{if(V&&V.$mid===3){const B=this._sourceControls.get(V.sourceControlHandle);if(!B)return V;const D=B.getResourceGroup(V.groupHandle);return D?D.getResourceState(V.handle):V}else if(V&&V.$mid===4){const B=this._sourceControls.get(V.sourceControlHandle);return B?B.getResourceGroup(V.groupHandle):V}else if(V&&V.$mid===5){const B=this._sourceControls.get(V.handle);return B||V}return V}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(p,P,M,V){this.logService.trace("ExtHostSCM#createSourceControl",p.identifier.value,P,M,V),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:p.identifier.value});const B=Yi._handlePool++,D=new a(p,this._proxy,this._commands,P,M,V);this._sourceControls.set(B,D);const x=this._sourceControlsByExtension.get(S.ExtensionIdentifier.toKey(p.identifier))||[];return x.push(D),this._sourceControlsByExtension.set(S.ExtensionIdentifier.toKey(p.identifier),x),D}getLastInputBox(p){this.logService.trace("ExtHostSCM#getLastInputBox",p.identifier.value);const P=this._sourceControlsByExtension.get(S.ExtensionIdentifier.toKey(p.identifier)),M=P&&P[P.length-1];return M&&M.inputBox}$provideOriginalResource(p,P,M){const V=r.URI.revive(P);this.logService.trace("ExtHostSCM#$provideOriginalResource",p,V.toString());const B=this._sourceControls.get(p);return!B||!B.quickDiffProvider||!B.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,_.asPromise)(()=>B.quickDiffProvider.provideOriginalResource(V,M)).then(D=>D||null)}$onInputBoxValueChange(p,P){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",p);const M=this._sourceControls.get(p);return M&&M.inputBox.$onInputBoxValueChange(P),Promise.resolve(void 0)}$executeResourceCommand(p,P,M,V){this.logService.trace("ExtHostSCM#$executeResourceCommand",p,P,M);const B=this._sourceControls.get(p);if(!B)return Promise.resolve(void 0);const D=B.getResourceGroup(P);return D?D.$executeResourceCommand(M,V):Promise.resolve(void 0)}$validateInput(p,P,M){this.logService.trace("ExtHostSCM#$validateInput",p);const V=this._sourceControls.get(p);return!V||!V.inputBox.validateInput?Promise.resolve(void 0):(0,_.asPromise)(()=>V.inputBox.validateInput(P,M)).then(B=>{if(!B)return Promise.resolve(void 0);const D=T.MarkdownString.fromStrict(B.message);return D?Promise.resolve([D,B.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(p){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",p),p!==void 0&&this._sourceControls.get(p)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=p,Promise.resolve(void 0)}};o._handlePool=0,o=ze([xe(2,F.ILogService)],o),e.ExtHostSCM=o}),define(Ce[68],Ie([1,0,4,5,3]),function(te,e,r,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class L{constructor(A){this._onDidChangePassword=new y.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=A.getProxy(r.MainContext.MainThreadSecretState)}async $onDidChangePassword(A){this._onDidChangePassword.fire(A)}get(A,E){return this._proxy.$getPassword(A,E)}store(A,E,k){return this._proxy.$setPassword(A,E,k)}delete(A,E){return this._proxy.$deletePassword(A,E)}}e.ExtHostSecretState=L,e.IExtHostSecretState=(0,w.createDecorator)("IExtHostSecretState")});var Je=this&&this.__classPrivateFieldSet||function(te,e,r,y,w){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!w:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?w.call(te,r):w?w.value=r:e.set(te,r),r},Oe=this&&this.__classPrivateFieldGet||function(te,e,r,y){if(r==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?y:r==="a"?y.call(te):y?y.value:e.get(te)};define(Ce[211],Ie([1,0,6,4,132,7,8,10]),function(te,e,r,y,w,L,_,A){"use strict";var E,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class F{constructor(f,c,h,u,v=r.StatusBarAlignment.Left,I){E.set(this,void 0),k.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new L.DisposableStore,Je(this,E,f,"f"),Je(this,k,c,"f"),this._entryId=F.ID_GEN++,this._extension=h,this._id=u,this._alignment=v,this._priority=this.validatePriority(I)}validatePriority(f){if(!!(0,A.isNumber)(f))return f===Number.POSITIVE_INFINITY?Number.MAX_VALUE:f===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:f}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(f){this._text=f,this.update()}set name(f){this._name=f,this.update()}set tooltip(f){this._tooltip=f,this.update()}set color(f){this._color=f,this.update()}set backgroundColor(f){f&&!F.ALLOWED_BACKGROUND_COLORS.has(f.id)&&(f=void 0),this._backgroundColor=f,this.update()}set command(f){this._command?.fromApi!==f&&(this._internalCommandRegistration.clear(),typeof f=="string"?this._command={fromApi:f,internal:Oe(this,k,"f").toInternal({title:"",command:f},this._internalCommandRegistration)}:f?this._command={fromApi:f,internal:Oe(this,k,"f").toInternal(f,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(f){this._accessibilityInformation=f,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Oe(this,E,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let f;this._extension?this._id?f=`${this._extension.identifier.value}.${this._id}`:f=this._extension.identifier.value:f=this._id;let c;this._name?c=this._name:c=(0,w.localize)(0,null,this._extension.displayName||this._extension.name);let h=this._color;this._backgroundColor&&(h=F.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const u=_.MarkdownString.fromStrict(this._tooltip);Oe(this,E,"f").$setEntry(this._entryId,f,c,this._text,u,this._command?.internal,h,this._backgroundColor,this._alignment===r.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=F,E=new WeakMap,k=new WeakMap,F.ID_GEN=0,F.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new r.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new r.ThemeColor("statusBarItem.warningForeground")]]);class S{constructor(f){this._messages=[],this._item=f.createStatusBarEntry(void 0,"status.extensionMessage",r.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,w.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(f){const c={message:f};return this._messages.unshift(c),this._update(),new r.Disposable(()=>{const h=this._messages.indexOf(c);h>=0&&(this._messages.splice(h,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class m{constructor(f,c){this._proxy=f.getProxy(y.MainContext.MainThreadStatusBar),this._commands=c,this._statusMessage=new S(this)}createStatusBarEntry(f,c,h,u){return new F(this._proxy,this._commands,f,c,h,u)}setStatusBarMessage(f,c){const h=this._statusMessage.setMessage(f);let u;return typeof c=="number"?u=setTimeout(()=>h.dispose(),c):typeof c<"u"&&c.then(()=>h.dispose(),()=>h.dispose()),new r.Disposable(()=>{h.dispose(),clearTimeout(u)})}}e.ExtHostStatusBar=m}),define(Ce[69],Ie([1,0,4,5,3]),function(te,e,r,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class L{constructor(A){this._onDidChangeStorage=new y.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=A.getProxy(r.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(A,E){this._proxy.$registerExtensionStorageKeysToSync(A,E)}initializeExtensionStorage(A,E,k){return this._proxy.$initializeExtensionStorage(A,E).then(F=>F||k)}setValue(A,E,k){return this._proxy.$setValue(A,E,k)}$acceptValue(A,E,k){this._onDidChangeStorage.fire({shared:A,key:E,value:k})}}e.ExtHostStorage=L,e.IExtHostStorage=(0,w.createDecorator)("IExtHostStorage")}),define(Ce[70],Ie([1,0,3,28,15,52,2]),function(te,e,r,y,w,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,r.createDecorator)("IExtensionStoragePaths");let A=class{constructor(k,F,S){this._logService=F,this._extHostFileSystem=S,this._workspace=k.workspace??void 0,this._environment=k.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(m=>this._value=m)}async _getWorkspaceStorageURI(k){return _.URI.joinPath(this._environment.workspaceStorageHome,k)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const k=this._workspace.id,F=await this._getWorkspaceStorageURI(k);try{return await this._extHostFileSystem.value.stat(F),this._logService.trace("[ExtHostStorage] storage dir already exists",F),F}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",F),await this._extHostFileSystem.value.createDirectory(F),await this._extHostFileSystem.value.writeFile(_.URI.joinPath(F,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:_.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),F}catch(S){this._logService.error("[ExtHostStorage]",S);return}}workspaceValue(k){if(this._value)return _.URI.joinPath(this._value,k.identifier.value)}globalValue(k){return _.URI.joinPath(this._environment.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};A=ze([xe(0,y.IExtHostInitDataService),xe(1,w.ILogService),xe(2,L.IExtHostConsumerFileSystem)],A),e.ExtensionStoragePaths=A}),define(Ce[97],Ie([1,0,3,4,13]),function(te,e,r,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTelemetryLogService=e.IExtHostTelemetryLogService=void 0,e.IExtHostTelemetryLogService=(0,r.createDecorator)("IExtHostTelemetryLogService");let L=class{constructor(A){this._telemetryShape=A.getProxy(y.MainContext.MainThreadTelemetry)}logToTelemetryOutputChannel(A,E,k){this._telemetryShape.$logTelemetryToOutputChannel(`${A.identifier.value}/${E}`,k)}};L=ze([xe(0,w.IExtHostRpcService)],L),e.ExtHostTelemetryLogService=L}),define(Ce[53],Ie([1,0,5,4,3,2,13,7,6,133,11,167,20,42,153,60,10,14,8]),function(te,e,r,y,w,L,_,A,E,k,F,S,m,T,f,c,h,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,w.createDecorator)("IExtHostTerminalService");class I{constructor(o,g,p,P){this._proxy=o,this._id=g,this._creationOptions=p,this._name=P,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(V=>this._pidPromiseComplete=V);const M=this;this.value={get name(){return M._name||""},get processId(){return M._pidPromise},get creationOptions(){return M._creationOptions},get exitStatus(){return M._exitStatus},get state(){return M._state},sendText(V,B=!0){M._checkDisposed(),M._proxy.$sendText(M._id,V,B)},show(V){M._checkDisposed(),M._proxy.$show(M._id,V)},hide(){M._checkDisposed(),M._proxy.$hide(M._id)},dispose(){M._disposed||(M._disposed=!0,M._proxy.$dispose(M._id))},get dimensions(){if(!(M._cols===void 0||M._rows===void 0))return{columns:M._cols,rows:M._rows}}}}async create(o,g){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:o.name,shellPath:(0,h.withNullAsUndefined)(o.shellPath),shellArgs:(0,h.withNullAsUndefined)(o.shellArgs),cwd:(0,h.withNullAsUndefined)(o.cwd),env:(0,h.withNullAsUndefined)(o.env),icon:(0,h.withNullAsUndefined)(i(o.iconPath)),color:c.ThemeColor.isThemeColor(o.color)?o.color.id:void 0,initialText:(0,h.withNullAsUndefined)(o.message),strictEnv:(0,h.withNullAsUndefined)(o.strictEnv),hideFromUser:(0,h.withNullAsUndefined)(o.hideFromUser),isFeatureTerminal:(0,h.withNullAsUndefined)(g?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,h.withNullAsUndefined)(g?.useShellEnvironment),location:g?.location||this._serializeParentTerminal(o.location,g?.resolvedExtHostIdentifier),isTransient:(0,h.withNullAsUndefined)(o.isTransient)})}async createExtensionTerminal(o,g,p,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:p,color:c.ThemeColor.isThemeColor(P)?P.id:void 0,location:this._serializeParentTerminal(o,g),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(o,g){return typeof o=="object"?"parentTerminal"in o&&o.parentTerminal&&g?{parentTerminal:g}:"viewColumn"in o?{viewColumn:v.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus}:void 0:o}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(o){this._name=o}setExitStatus(o,g){this._exitStatus=Object.freeze({code:o,reason:g})}setDimensions(o,g){return o===this._cols&&g===this._rows||o===0||g===0?!1:(this._cols=o,this._rows=g,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(o){this._pidPromiseComplete?(this._pidPromiseComplete(o),this._pidPromiseComplete=void 0):this._pidPromise.then(g=>{g!==o&&(this._pidPromise=Promise.resolve(o))})}}e.ExtHostTerminal=I;class l{constructor(o){this._pty=o,this.id=0,this.shouldPersist=!1,this._onProcessData=new r.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new r.Emitter,this._onDidChangeProperty=new r.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new r.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(o){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${o}`)}updateProperty(o,g){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${o}, value: ${g}`)}async start(){}shutdown(){this._pty.close()}input(o){this._pty.handleInput?.(o)}resize(o,g){this._pty.setDimensions?.({columns:o,rows:g})}async processBinary(o){}acknowledgeDataEvent(o){}async setUnicodeVersion(o){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(o){this._pty.onDidWrite(g=>this._onProcessData.fire(g)),this._pty.onDidClose?.((g=void 0)=>{this._onProcessExit.fire(g===void 0?void 0:g)}),this._pty.onDidOverrideDimensions?.(g=>{g&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:g.columns,rows:g.rows}})}),this._pty.onDidChangeName?.(g=>{this._onDidChangeProperty.fire({type:"title",value:g})}),this._pty.open(o||void 0),o&&this._pty.setDimensions?.(o),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=l;let b=1,t=class extends A.Disposable{constructor(o,g){super(),this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new r.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new r.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new r.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new r.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new r.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=g.getProxy(y.MainContext.MainThreadTerminalService),this._bufferer=new f.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new r.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(o),this._register({dispose:()=>{for(const[p,P]of this._terminalProcesses)P.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(o=>o.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(o){return(o?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(o){return(o?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(o,g){const p=new I(this._proxy,(0,T.generateUuid)(),o,o.name),P=new l(o.pty);return p.createExtensionTerminal(o.location,this._serializeParentTerminal(o,g).resolvedExtHostIdentifier,i(o.iconPath),s(o.color)).then(M=>{const V=this._setupExtHostProcessListeners(M,P);this._terminalProcessDisposables[M]=V}),this._terminals.push(p),p.value}_serializeParentTerminal(o,g){if(g=g||{},o.location&&typeof o.location=="object"&&"parentTerminal"in o.location){const p=o.location.parentTerminal;if(p){const P=this._terminals.find(M=>M.value===p);P&&(g.resolvedExtHostIdentifier=P._id)}}else o.location&&typeof o.location!="object"?g.location=o.location:g.location&&typeof g.location=="object"&&"splitActiveTerminal"in g.location&&(g.location={splitActiveTerminal:!0});return g}attachPtyToTerminal(o,g){if(!this._getTerminalById(o))throw new Error(`Cannot resolve terminal with id ${o} for virtual process`);const P=new l(g),M=this._setupExtHostProcessListeners(o,P);this._terminalProcessDisposables[o]=M}async $acceptActiveTerminalChanged(o){const g=this._activeTerminal;if(o===null){this._activeTerminal=void 0,g!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const p=this._getTerminalById(o);p&&(this._activeTerminal=p,g!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(o,g){const p=this._getTerminalById(o);p&&this._onDidWriteTerminalData.fire({terminal:p.value,data:g})}async $acceptTerminalDimensions(o,g,p){const P=this._getTerminalById(o);P&&P.setDimensions(g,p)&&this._onDidChangeTerminalDimensions.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptTerminalMaximumDimensions(o,g,p){this._terminalProcesses.get(o)?.resize(g,p)}async $acceptTerminalTitleChange(o,g){const p=this._getTerminalById(o);p&&(p.name=g)}async $acceptTerminalClosed(o,g,p){const P=this._getTerminalObjectIndexById(this._terminals,o);if(P!==null){const M=this._terminals.splice(P,1)[0];M.setExitStatus(g,p),this._onDidCloseTerminal.fire(M.value)}}$acceptTerminalOpened(o,g,p,P){if(g){const B=this._getTerminalObjectIndexById(this._terminals,g);if(B!==null){this._terminals[B]._id=o,this._onDidOpenTerminal.fire(this.terminals[B]),this._terminals[B].isOpen=!0;return}}const M={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:L.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},V=new I(this._proxy,o,M,p);this._terminals.push(V),this._onDidOpenTerminal.fire(V.value),V.isOpen=!0}async $acceptTerminalProcessId(o,g){this._getTerminalById(o)?._setProcessId(g)}async $startExtensionTerminal(o,g){const p=this._getTerminalById(o);if(!p)return{message:(0,k.localize)(0,null,o)};p.isOpen||await new Promise(M=>{const V=this.onDidOpenTerminal(async B=>{B===p.value&&(V.dispose(),M())})});const P=this._terminalProcesses.get(o);P?P.startSendingEvents(g):this._extensionTerminalAwaitingStart[o]={initialDimensions:g}}_setupExtHostProcessListeners(o,g){const p=new A.DisposableStore;p.add(g.onProcessReady(M=>this._proxy.$sendProcessReady(o,M.pid,M.cwd))),p.add(g.onDidChangeProperty(M=>this._proxy.$sendProcessProperty(o,M))),this._bufferer.startBuffering(o,g.onProcessData),p.add(g.onProcessExit(M=>this._onProcessExit(o,M))),this._terminalProcesses.set(o,g);const P=this._extensionTerminalAwaitingStart[o];return P&&g instanceof l&&(g.startSendingEvents(P.initialDimensions),delete this._extensionTerminalAwaitingStart[o]),p}$acceptProcessAckDataEvent(o,g){this._terminalProcesses.get(o)?.acknowledgeDataEvent(g)}$acceptProcessInput(o,g){this._terminalProcesses.get(o)?.input(g)}$acceptTerminalInteraction(o){const g=this._getTerminalById(o);g?.setInteractedWith()&&this._onDidChangeTerminalState.fire(g.value)}$acceptProcessResize(o,g,p){try{this._terminalProcesses.get(o)?.resize(g,p)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(o,g){this._terminalProcesses.get(o)?.shutdown(g)}$acceptProcessRequestInitialCwd(o){this._terminalProcesses.get(o)?.getInitialCwd().then(g=>this._proxy.$sendProcessProperty(o,{type:"initialCwd",value:g}))}$acceptProcessRequestCwd(o){this._terminalProcesses.get(o)?.getCwd().then(g=>this._proxy.$sendProcessProperty(o,{type:"cwd",value:g}))}$acceptProcessRequestLatency(o){return Promise.resolve(o)}registerLinkProvider(o){return this._linkProviders.add(o),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new E.Disposable(()=>{this._linkProviders.delete(o),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(o,g,p){if(this._profileProviders.has(g))throw new Error(`Terminal profile provider "${g}" already registered`);return this._profileProviders.set(g,p),this._proxy.$registerProfileProvider(g,o.identifier.value),new E.Disposable(()=>{this._profileProviders.delete(g),this._proxy.$unregisterProfileProvider(g)})}async $createContributedProfileTerminal(o,g){const p=new m.CancellationTokenSource().token;let P=await this._profileProviders.get(o)?.provideTerminalProfile(p);if(!p.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${o}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,g);return}this.createTerminalFromOptions(P.options,g)}}async $provideLinks(o,g){const p=this._getTerminalById(o);if(!p)return[];this._terminalLinkCache.delete(o),this._terminalLinkCancellationSource.get(o)?.dispose(!0);const M=new m.CancellationTokenSource;this._terminalLinkCancellationSource.set(o,M);const V=[],B={terminal:p.value,line:g},D=[];for(const R of this._linkProviders)D.push(u.Promises.withAsyncBody(async K=>{M.token.onCancellationRequested(()=>K({provider:R,links:[]}));const W=await R.provideTerminalLinks(B,M.token)||[];M.token.isCancellationRequested||K({provider:R,links:W})}));const x=await Promise.all(D);if(M.token.isCancellationRequested)return[];const U=new Map;for(const R of x)R&&R.links.length>0&&V.push(...R.links.map(K=>{const W={id:b++,startIndex:K.startIndex,length:K.length,label:K.tooltip};return U.set(W.id,{provider:R.provider,link:K}),W}));return this._terminalLinkCache.set(o,U),V}$activateLink(o,g){const p=this._terminalLinkCache.get(o)?.get(g);!p||p.provider.handleTerminalLink(p.link)}_onProcessExit(o,g){this._bufferer.stopBuffering(o),this._terminalProcesses.delete(o),delete this._extensionTerminalAwaitingStart[o];const p=this._terminalProcessDisposables[o];p&&(p.dispose(),delete this._terminalProcessDisposables[o]),this._proxy.$sendProcessExit(o,g)}_getTerminalById(o){return this._getTerminalObjectById(this._terminals,o)}_getTerminalObjectById(o,g){const p=this._getTerminalObjectIndexById(o,g);return p!==null?o[p]:null}_getTerminalObjectIndexById(o,g){let p=null;return o.some((P,M)=>P._id===g?(p=M,!0):!1),p}getEnvironmentVariableCollection(o){let g=this._environmentVariableCollections.get(o.identifier.value);return g||(g=new d,this._setEnvironmentVariableCollection(o.identifier.value,g)),g}_syncEnvironmentVariableCollection(o,g){const p=(0,S.serializeEnvironmentVariableCollection)(g.map);this._proxy.$setEnvironmentVariableCollection(o,g.persistent,p.length===0?void 0:p)}$initEnvironmentVariableCollections(o){o.forEach(g=>{const p=g[0],P=new d(g[1]);this._setEnvironmentVariableCollection(p,P)})}$acceptDefaultProfile(o,g){this._defaultProfile=o,this._defaultAutomationProfile=g}_setEnvironmentVariableCollection(o,g){this._environmentVariableCollections.set(o,g),g.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(o,g)})}};t=ze([xe(1,_.IExtHostRpcService)],t),e.BaseExtHostTerminalService=t;class d{constructor(o){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new r.Emitter,this.map=new Map(o)}get persistent(){return this._persistent}set persistent(o){this._persistent=o,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(o,g){this._setIfDiffers(o,{value:g,type:E.EnvironmentVariableMutatorType.Replace})}append(o,g){this._setIfDiffers(o,{value:g,type:E.EnvironmentVariableMutatorType.Append})}prepend(o,g){this._setIfDiffers(o,{value:g,type:E.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(o,g){const p=this.map.get(o);(!p||p.value!==g.value||p.type!==g.type)&&(this.map.set(o,g),this._onDidChangeCollection.fire())}get(o){return this.map.get(o)}forEach(o,g){this.map.forEach((p,P)=>o.call(g,P,p,this))}[Symbol.iterator](){return this.map.entries()}delete(o){this.map.delete(o),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=d;let n=class extends t{constructor(o){super(!1,o)}createTerminal(o,g,p){throw new F.NotSupportedError}createTerminalFromOptions(o,g){throw new F.NotSupportedError}};n=ze([xe(0,_.IExtHostRpcService)],n),e.WorkerExtHostTerminalService=n;function i(a){if(!(!a||typeof a=="string"))return"id"in a?{id:a.id,color:a.color}:a}function s(a){return c.ThemeColor.isThemeColor(a)?a:void 0}});var Je=this&&this.__classPrivateFieldSet||function(te,e,r,y,w){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!w:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?w.call(te,r):w?w.value=r:e.set(te,r),r},Oe=this&&this.__classPrivateFieldGet||function(te,e,r,y){if(r==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?y:r==="a"?y.call(te):y?y.value:e.get(te)};define(Ce[212],Ie([1,0,16,23,20,5,176,213,7,26,10,42,4,13,94,8,6,47,65,48]),function(te,e,r,y,w,L,_,A,E,k,F,S,m,T,f,c,h,u,v,I){"use strict";var l,b;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let t=class{constructor(B,D,x){this.editors=x,this.resultsChangedEmitter=new L.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=B.getProxy(m.MainContext.MainThreadTesting),this.observer=new p(this.proxy),this.runTracker=new n(this.proxy),D.registerArgumentProcessor({processArgument:U=>U?.$mid===13?(0,f.toItemFromContext)(U):U})}createTestController(B,D,x){if(this.controllers.has(B))throw new Error(`Attempt to insert a duplicate controller with ID "${B}"`);const U=new E.DisposableStore,R=U.add(new f.ExtHostTestItemCollection(B,D,this.editors));R.root.label=D;const K=new Map,W=this.proxy,O={items:R.root.children,get label(){return D},set label(ue){D=ue,R.root.label=ue,W.$updateController(B,{label:D})},get refreshHandler(){return x},set refreshHandler(ue){x=ue,W.$updateController(B,{canRefresh:!!ue})},get id(){return B},createRunProfile:(ue,oe,de,ie,ve)=>{let be=(0,A.hash)(ue);for(;K.has(be);)be++;return new P(this.proxy,K,B,be,ue,oe,de,ie,ve)},createTestItem(ue,oe,de){return new f.TestItemImpl(B,ue,oe,de)},createTestRun:(ue,oe,de=!0)=>this.runTracker.createTestRun(B,R,ue,oe,de),set resolveHandler(ue){R.resolveHandler=ue},get resolveHandler(){return R.resolveHandler},dispose:()=>{U.dispose()}};W.$registerTestController(B,D,!!x),U.add((0,E.toDisposable)(()=>W.$unregisterTestController(B)));const Z={controller:O,collection:R,profiles:K};return this.controllers.set(B,Z),U.add((0,E.toDisposable)(()=>this.controllers.delete(B))),U.add(R.onDidGenerateDiff(ue=>W.$publishDiff(B,ue.map(I.TestsDiffOp.serialize)))),O}createTestObserver(){return this.observer.checkout()}async runTests(B,D=w.CancellationToken.None){const x=i(B);if(!x)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const U=this.controllers.get(x.controllerId);if(!U)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:B.include?.map(R=>u.TestId.fromExtHostTestItem(R,U.collection.root.id).toString())??[U.collection.root.id],profileGroup:M[x.kind],profileId:x.profileId,controllerId:x.controllerId}],exclude:B.exclude?.map(R=>R.id)},D)}$provideFileCoverage(B,D,x){return(0,r.mapFind)(this.runTracker.trackers,R=>R.id===B?R.getCoverage(D):void 0)?.provideFileCoverage(x)??Promise.resolve([])}$resolveFileCoverage(B,D,x,U){return(0,r.mapFind)(this.runTracker.trackers,K=>K.id===B?K.getCoverage(D):void 0)?.resolveFileCoverage(x,U)??Promise.resolve([])}$configureRunProfile(B,D){this.controllers.get(B)?.profiles.get(D)?.configureHandler?.()}async $refreshTests(B,D){await this.controllers.get(B)?.controller.refreshHandler?.(D)}$publishTestResults(B){this.results=Object.freeze(B.map(D=>(0,k.deepFreeze)(c.TestResults.to(D))).concat(this.results).sort((D,x)=>x.completedAt-D.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(B,D){const x=this.controllers.get(u.TestId.fromString(B).controllerId)?.collection;x&&(await x.expand(B,D<0?1/0:D),x.flushDiff())}$acceptDiff(B){this.observer.applyDiff(B.map(I.TestsDiffOp.deserialize))}async $runControllerTests(B,D){return Promise.all(B.map(x=>this.runControllerTestRequest(x,D)))}async runControllerTestRequest(B,D){const x=this.controllers.get(B.controllerId);if(!x)return{};const{collection:U,profiles:R}=x,K=R.get(B.profileId);if(!K)return{};const W=B.testIds.map(oe=>U.tree.get(oe)).filter(F.isDefined),O=B.excludeExtIds.map(oe=>x.collection.tree.get(oe)).filter(F.isDefined).filter(oe=>W.some(de=>de.fullId.compare(oe.fullId)===2));if(!W.length)return{};const Z=new h.TestRunRequest(W.some(oe=>oe.actual instanceof f.TestItemRootImpl)?void 0:W.map(oe=>oe.actual),O.map(oe=>oe.actual),K),ue=this.runTracker.prepareForMainThreadTestRun(Z,s.fromInternal(B,x.collection),D);try{return await K.runHandler(Z,D),{}}catch(oe){return{error:String(oe)}}finally{ue.isRunning&&!D.isCancellationRequested&&await L.Event.toPromise(ue.onEnd),ue.dispose()}}$cancelExtensionTestRun(B){B===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(B)}};t=ze([xe(0,T.IExtHostRpcService)],t),e.ExtHostTesting=t;class d extends E.Disposable{constructor(B,D,x){super(),this.dto=B,this.proxy=D,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new L.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new w.CancellationTokenSource(x)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:U}of this.tasks.values())U.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(B){return this.tasks.get(B)?.coverage}createRun(B){const D=this.dto.id,x=this.dto.controllerId,U=(0,S.generateUuid)(),R=new a(this.proxy,D,U),K=ue=>(oe,...de)=>{if(O){console.warn(`Setting the state of test "${oe.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(oe)||(this.ensureTestIsKnown(oe),ue(oe,...de))},W=(ue,oe)=>{const de=oe instanceof Array?oe.map(c.TestMessage.from):[c.TestMessage.from(oe)];if(ue.uri&&ue.range){const ie={range:c.Range.from(ue.range),uri:ue.uri};for(const ve of de)ve.location=ve.location||ie}this.proxy.$appendTestMessagesInRun(D,U,u.TestId.fromExtHostTestItem(ue,x).toString(),de)};let O=!1;const Z={isPersisted:this.dto.isPersisted,token:this.cts.token,name:B,get coverageProvider(){return R.coverageProvider},set coverageProvider(ue){R.coverageProvider=ue},enqueued:K(ue=>{this.proxy.$updateTestStateInRun(D,U,u.TestId.fromExtHostTestItem(ue,x).toString(),1)}),skipped:K(ue=>{this.proxy.$updateTestStateInRun(D,U,u.TestId.fromExtHostTestItem(ue,x).toString(),5)}),started:K(ue=>{this.proxy.$updateTestStateInRun(D,U,u.TestId.fromExtHostTestItem(ue,x).toString(),2)}),errored:K((ue,oe,de)=>{W(ue,oe),this.proxy.$updateTestStateInRun(D,U,u.TestId.fromExtHostTestItem(ue,x).toString(),6,de)}),failed:K((ue,oe,de)=>{W(ue,oe),this.proxy.$updateTestStateInRun(D,U,u.TestId.fromExtHostTestItem(ue,x).toString(),4,de)}),passed:K((ue,oe)=>{this.proxy.$updateTestStateInRun(D,U,u.TestId.fromExtHostTestItem(ue,this.dto.controllerId).toString(),3,oe)}),appendOutput:(ue,oe,de)=>{O||(de&&(this.dto.isIncluded(de)?this.ensureTestIsKnown(de):de=void 0),this.proxy.$appendOutputToRun(D,U,y.VSBuffer.fromString(ue),oe&&c.location.from(oe),de&&u.TestId.fromExtHostTestItem(de,x).toString()))},end:()=>{O||(O=!0,this.proxy.$finishedTestRunTask(D,U),this.tasks.delete(U),this.isRunning||this.dispose())}};return this.tasks.set(U,{run:Z,coverage:R}),this.proxy.$startedTestRunTask(D,{id:U,name:B,running:!0}),Z}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(B){if(!(B instanceof f.TestItemImpl))throw new v.InvalidTestItemError(B.id);if(this.sharedTestIds.has(u.TestId.fromExtHostTestItem(B,this.dto.controllerId).toString()))return;const D=[],x=this.dto.colllection.root;for(;;){const U=c.TestItem.from(B);if(D.unshift(U),this.sharedTestIds.has(U.extId)||(this.sharedTestIds.add(U.extId),B===x))break;B=B.parent||x}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,D)}}class n{constructor(B){this.proxy=B,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(B,D,x){return this.getTracker(B,D,x)}cancelRunById(B){for(const D of this.tracked.values())if(D.id===B){D.dispose();return}}cancelAllRuns(){for(const B of this.tracked.values())B.dispose()}createTestRun(B,D,x,U,R){const K=this.tracked.get(x);if(K)return K.createRun(U);const W=s.fromPublic(B,D,x,R),O=i(x);this.proxy.$startedExtensionTestRun({controllerId:B,profile:O&&{group:M[O.kind],id:O.profileId},exclude:x.exclude?.map(ue=>u.TestId.fromExtHostTestItem(ue,D.root.id).toString())??[],id:W.id,include:x.include?.map(ue=>u.TestId.fromExtHostTestItem(ue,D.root.id).toString())??[D.root.id],persist:R});const Z=this.getTracker(x,W);return Z.onEnd(()=>this.proxy.$finishedExtensionTestRun(W.id)),Z.createRun(U)}getTracker(B,D,x){const U=new d(D,this.proxy,x);return this.tracked.set(B,U),U.onEnd(()=>this.tracked.delete(B)),U}}e.TestRunCoordinator=n;const i=V=>{if(!!V.profile){if(!(V.profile instanceof P))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return V.profile}};class s{constructor(B,D,x,U,R,K){this.controllerId=B,this.id=D,this.isPersisted=R,this.colllection=K,this.includePrefix=x.map(W=>W+"\0"),this.excludePrefix=U.map(W=>W+"\0")}static fromPublic(B,D,x,U){return new s(B,(0,S.generateUuid)(),x.include?.map(R=>u.TestId.fromExtHostTestItem(R,B).toString())??[B],x.exclude?.map(R=>u.TestId.fromExtHostTestItem(R,B).toString())??[],U,D)}static fromInternal(B,D){return new s(B.controllerId,B.runId,B.testIds,B.excludeExtIds,!0,D)}isIncluded(B){const D=u.TestId.fromExtHostTestItem(B,this.controllerId).toString()+"\0";for(const x of this.excludePrefix)if(D===x||D.startsWith(x))return!1;for(const x of this.includePrefix)if(D===x||D.startsWith(x))return!0;return!1}}e.TestRunDto=s;class a{constructor(B,D,x){this.proxy=B,this.runId=D,this.taskId=x}set coverageProvider(B){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!B||(this._coverageProvider=B,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(B){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(B))());try{return(await this.fileCoverage)?.map(c.TestCoverage.fromFile)??[]}catch(D){throw this.fileCoverage=void 0,D}}async resolveFileCoverage(B,D){const x=await this.fileCoverage;let U=x?.[B];return!this._coverageProvider||!x||!U?[]:(U.detailedCoverage||(U=x[B]=await this._coverageProvider.resolveFileCoverage?.(U,D)??U),U.detailedCoverage?.map(c.TestCoverage.fromDetailed)??[])}}class o extends I.IncrementalChangeCollector{constructor(B){super(),this.emitter=B,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(B){this.added.add(B)}update(B){Object.assign(B.revived,c.TestItem.toPlain(B.item)),this.added.has(B)||this.updated.add(B)}remove(B){if(this.added.has(B)){this.added.delete(B);return}if(this.updated.delete(B),B.parent&&this.alreadyRemoved.has(B.parent)){this.alreadyRemoved.add(B.item.extId);return}this.removed.add(B)}getChangeEvent(){const{added:B,updated:D,removed:x}=this;return{get added(){return[...B].map(U=>U.revived)},get updated(){return[...D].map(U=>U.revived)},get removed(){return[...x].map(U=>U.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class g extends I.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new L.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(B){return this.items.get(B)}getMirroredTestDataByReference(B){return this.items.get(B.id)}createItem(B,D){return{...B,revived:c.TestItem.toPlain(B.item),depth:D?D.depth+1:0,children:new Set}}createChangeCollector(){return new o(this.changeEmitter)}}e.MirroredTestCollection=g;class p{constructor(B){this.proxy=B}checkout(){this.current||(this.current=this.createObserverData());const B=this.current;return B.observers++,{onDidChangeTest:B.tests.onDidChangeTests,get tests(){return[...B.tests.rootTests].map(D=>D.revived)},dispose:(0,_.once)(()=>{--B.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(B){return this.current?.tests.getMirroredTestDataByReference(B)}applyDiff(B){this.current?.tests.apply(B)}createObserverData(){const B=new g;return this.proxy.$subscribeToDiffs(),{observers:0,tests:B}}}class P{constructor(B,D,x,U,R,K,W,O=!1,Z=void 0){this.controllerId=x,this.profileId=U,this._label=R,this.kind=K,this.runHandler=W,this._isDefault=O,this._tag=Z,l.set(this,void 0),b.set(this,void 0),Je(this,l,B,"f"),Je(this,b,D,"f"),D.set(U,this);const ue=M[K];if(typeof ue!="number")throw new Error(`Unknown TestRunProfile.group ${K}`);Oe(this,l,"f").$publishTestRunProfile({profileId:U,controllerId:x,tag:Z?c.TestTag.namespace(this.controllerId,Z.id):null,label:R,group:ue,isDefault:O,hasConfigurationHandler:!1})}get label(){return this._label}set label(B){B!==this._label&&(this._label=B,Oe(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:B}))}get isDefault(){return this._isDefault}set isDefault(B){B!==this._isDefault&&(this._isDefault=B,Oe(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:B}))}get tag(){return this._tag}set tag(B){B?.id!==this._tag?.id&&(this._tag=B,Oe(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:B?c.TestTag.namespace(this.controllerId,B.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(B){B!==this._configureHandler&&(this._configureHandler=B,Oe(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!B}))}dispose(){Oe(this,b,"f")?.delete(this.profileId)&&(Je(this,b,void 0,"f"),Oe(this,l,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=P,l=new WeakMap,b=new WeakMap;const M={[h.TestRunProfileKind.Coverage]:8,[h.TestRunProfileKind.Debug]:4,[h.TestRunProfileKind.Run]:2}}),define(Ce[214],Ie([1,0,16,5,4,95,8,6]),function(te,e,r,y,w,L,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class E{constructor(F,S){this._extHostDocumentsAndEditors=S,this._onDidChangeTextEditorSelection=new y.Emitter,this._onDidChangeTextEditorOptions=new y.Emitter,this._onDidChangeTextEditorVisibleRanges=new y.Emitter,this._onDidChangeTextEditorViewColumn=new y.Emitter,this._onDidChangeActiveTextEditor=new y.Emitter,this._onDidChangeVisibleTextEditors=new y.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=F.getProxy(w.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(m=>this._onDidChangeVisibleTextEditors.fire(m)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(m=>this._onDidChangeActiveTextEditor.fire(m))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(F){const S=this._extHostDocumentsAndEditors.allEditors();return F?S:S.map(m=>m.value)}async showTextDocument(F,S,m){let T;typeof S=="number"?T={position:_.ViewColumn.from(S),preserveFocus:m}:typeof S=="object"?T={position:_.ViewColumn.from(S.viewColumn),preserveFocus:S.preserveFocus,selection:typeof S.selection=="object"?_.Range.from(S.selection):void 0,pinned:typeof S.preview=="boolean"?!S.preview:void 0}:T={preserveFocus:!1};const f=await this._proxy.$tryShowTextDocument(F.uri,T),c=f&&this._extHostDocumentsAndEditors.getEditor(f);if(c)return c.value;throw f?new Error(`Could NOT open editor for "${F.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${F.uri.toString()}".`)}createTextEditorDecorationType(F,S){return new L.TextEditorDecorationType(this._proxy,F,S).value}$acceptEditorPropertiesChanged(F,S){const m=this._extHostDocumentsAndEditors.getEditor(F);if(!m)throw new Error("unknown text editor");if(S.options&&m._acceptOptions(S.options),S.selections){const T=S.selections.selections.map(_.Selection.to);m._acceptSelections(T)}if(S.visibleRanges){const T=r.coalesce(S.visibleRanges.map(_.Range.to));m._acceptVisibleRanges(T)}if(S.options&&this._onDidChangeTextEditorOptions.fire({textEditor:m.value,options:{...S.options,lineNumbers:_.TextEditorLineNumbersStyle.to(S.options.lineNumbers)}}),S.selections){const T=A.TextEditorSelectionChangeKind.fromValue(S.selections.source),f=S.selections.selections.map(_.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:m.value,selections:f,kind:T})}if(S.visibleRanges){const T=r.coalesce(S.visibleRanges.map(_.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:m.value,visibleRanges:T})}}$acceptEditorPositionData(F){for(const S in F){const m=this._extHostDocumentsAndEditors.getEditor(S);if(!m)throw new Error("Unknown text editor");const T=_.ViewColumn.to(F[S]);m.value.viewColumn!==T&&(m._acceptViewColumn(T),this._onDidChangeTextEditorViewColumn.fire({textEditor:m.value,viewColumn:T}))}}getDiffInformation(F){return Promise.resolve(this._proxy.$getDiffInformation(F))}}e.ExtHostEditors=E}),define(Ce[215],Ie([1,0,2,3,4,7,6,8,10]),function(te,e,r,y,w,L,_,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,y.createDecorator)("IExtHostTimeline");class k{constructor(m,T){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=m.getProxy(w.MainContext.MainThreadTimeline),T.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===11){const c=f.uri===void 0?void 0:r.URI.revive(f.uri);return this._itemsBySourceAndUriMap.get(f.source)?.get(F(c))?.get(f.handle)}return f}})}async $getTimeline(m,T,f,c){return this._providers.get(m)?.provideTimeline(r.URI.revive(T),f,c)}registerTimelineProvider(m,T,f,c){const h=new L.DisposableStore,u=this.convertTimelineItem(T.id,c,h).bind(this);let v;T.onDidChange&&(v=T.onDidChange(l=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...l,id:T.id}),this));const I=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...T,scheme:m,onDidChange:void 0,async provideTimeline(l,b,t){b?.resetCache&&(h.clear(),I.get(T.id)?.clear());const d=await T.provideTimeline(l,b,t);if(d==null)return;const n=u(l,b);return{...d,source:T.id,items:d.items.map(n)}},dispose(){for(const l of I.values())l.get(T.id)?.clear();v?.dispose(),h.dispose()}})}convertTimelineItem(m,T,f){return(c,h)=>{let u;if(h?.cacheResults){let v=this._itemsBySourceAndUriMap.get(m);v===void 0&&(v=new Map,this._itemsBySourceAndUriMap.set(m,v));const I=F(c);u=v.get(I),u===void 0&&(u=new Map,v.set(I,u))}return v=>{const{iconPath:I,...l}=v,b=`${m}|${v.id??v.timestamp}`;u?.set(b,v);let t,d,n;v.iconPath&&(I instanceof _.ThemeIcon?n={id:I.id,color:I.color}:r.URI.isUri(I)?(t=I,d=I):{light:t,dark:d}=I);let i;return _.MarkdownString.isMarkdownString(l.tooltip)?i=A.MarkdownString.from(l.tooltip):(0,E.isString)(l.tooltip)?i=l.tooltip:_.MarkdownString.isMarkdownString(l.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),i=A.MarkdownString.from(l.detail)):(0,E.isString)(l.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),i=l.detail),{...l,id:l.id??void 0,handle:b,source:m,command:v.command?T.toInternal(v.command,f):void 0,icon:t,iconDark:d,themeIcon:n,tooltip:i,accessibilityInformation:v.accessibilityInformation}}}}registerTimelineProviderCore(m){if(this._providers.get(m.id))throw new Error(`Timeline Provider ${m.id} already exists.`);return this._proxy.$registerTimelineProvider({id:m.id,label:m.label,scheme:m.scheme}),this._providers.set(m.id,m),(0,L.toDisposable)(()=>{for(const f of this._itemsBySourceAndUriMap.values())f.get(m.id)?.clear();this._providers.delete(m.id),this._proxy.$unregisterTimelineProvider(m.id),m.dispose()})}}e.ExtHostTimeline=k;function F(S){return S?.toString()}}),define(Ce[216],Ie([1,0,7,12,2,4]),function(te,e,r,y,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class _{constructor(E){this._openers=new Map,this._proxy=E.getProxy(L.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(E,k,F,S){if(this._openers.has(k))throw new Error(`Opener with id '${k}' already registered`);const m=S.schemes.find(T=>!_.supportedSchemes.has(T));if(m)throw new Error(`Scheme '${m}' is not supported. Only http and https are currently supported.`);return this._openers.set(k,F),this._proxy.$registerUriOpener(k,S.schemes,E,S.label),(0,r.toDisposable)(()=>{this._openers.delete(k),this._proxy.$unregisterUriOpener(k)})}async $canOpenUri(E,k,F){const S=this._openers.get(E);if(!S)throw new Error(`Unknown opener with id: ${E}`);const m=w.URI.revive(k);return S.canOpenExternalUri(m,F)}async $openUri(E,k,F){const S=this._openers.get(E);if(!S)throw new Error(`Unknown opener id: '${E}'`);return S.openExternalUri(w.URI.revive(k.resolvedUri),{sourceUri:w.URI.revive(k.sourceUri)},F)}}e.ExtHostUriOpeners=_,_.supportedSchemes=new Set([y.Schemas.http,y.Schemas.https])}),define(Ce[217],Ie([1,0,4,2,7,11,27]),function(te,e,r,y,w,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class A{constructor(k){this.handles=new Set,this.handlers=new Map,this._proxy=k.getProxy(r.MainContext.MainThreadUrls)}registerUriHandler(k,F){if(this.handles.has(_.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const S=A.HandlePool++;return this.handles.add(_.ExtensionIdentifier.toKey(k)),this.handlers.set(S,F),this._proxy.$registerUriHandler(S,k),(0,w.toDisposable)(()=>{this.handles.delete(_.ExtensionIdentifier.toKey(k)),this.handlers.delete(S),this._proxy.$unregisterUriHandler(S)})}$handleExternalUri(k,F){const S=this.handlers.get(k);if(!S)return Promise.resolve(void 0);try{S.handleUri(y.URI.revive(F))}catch(m){(0,L.onUnexpectedError)(m)}return Promise.resolve(void 0)}async createAppUri(k){return y.URI.revive(await this._proxy.$createAppUri(k))}}e.ExtHostUrls=A,A.HandlePool=0});var Je=this&&this.__classPrivateFieldSet||function(te,e,r,y,w){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!w:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?w.call(te,r):w?w.value=r:e.set(te,r),r},Oe=this&&this.__classPrivateFieldGet||function(te,e,r,y){if(r==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?y:r==="a"?y.call(te):y?y.value:e.get(te)};define(Ce[54],Ie([1,0,5,12,2,144,160,63,4]),function(te,e,r,y,w,L,_,A,E){"use strict";var k,F,S,m,T,f,c,h,u,v,I,l;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class b{constructor(g,p,P,M,V,B,D){k.set(this,void 0),F.set(this,void 0),S.set(this,void 0),m.set(this,void 0),T.set(this,void 0),f.set(this,void 0),c.set(this,""),h.set(this,void 0),u.set(this,!1),v.set(this,!1),I.set(this,!1),this._onMessageEmitter=new r.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,l.set(this,new r.Emitter),this._onDidDispose=Oe(this,l,"f").event,Je(this,k,g,"f"),Je(this,F,p,"f"),Je(this,h,P,"f"),Je(this,m,M,"f"),Je(this,T,V,"f"),Je(this,f,B,"f"),Je(this,I,t(B),"f"),Je(this,S,D,"f")}dispose(){Je(this,u,!0,"f"),Oe(this,l,"f").fire(),Oe(this,l,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(g){return Je(this,v,!0,"f"),(0,A.asWebviewUri)(g,Oe(this,m,"f"))}get cspSource(){const g=Oe(this,f,"f").extensionLocation;if(g.scheme===y.Schemas.https||g.scheme===y.Schemas.http){let p=g.toString();return p.endsWith("/")||(p+="/"),p+" "+A.webviewGenericCspSource}return A.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Oe(this,c,"f")}set html(g){this.assertNotDisposed(),Oe(this,c,"f")!==g&&(Je(this,c,g,"f"),!Oe(this,v,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(g)&&(Je(this,v,!0,"f"),Oe(this,S,"f").report("Webview vscode-resource: uris",Oe(this,f,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Oe(this,F,"f").$setHtml(Oe(this,k,"f"),g))}get options(){return this.assertNotDisposed(),Oe(this,h,"f")}set options(g){this.assertNotDisposed(),Oe(this,F,"f").$setOptions(Oe(this,k,"f"),i(Oe(this,f,"f"),Oe(this,T,"f"),g)),Je(this,h,g,"f")}async postMessage(g){if(Oe(this,u,"f"))return!1;const p=(0,_.serializeWebviewMessage)(g,{serializeBuffersForPostMessage:Oe(this,I,"f")});return Oe(this,F,"f").$postMessage(Oe(this,k,"f"),p.message,...p.buffers)}assertNotDisposed(){if(Oe(this,u,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=b,k=new WeakMap,F=new WeakMap,S=new WeakMap,m=new WeakMap,T=new WeakMap,f=new WeakMap,c=new WeakMap,h=new WeakMap,u=new WeakMap,v=new WeakMap,I=new WeakMap,l=new WeakMap;function t(o){try{const g=(0,L.normalizeVersion)((0,L.parseVersion)(o.engines.vscode));return!!g&&g.majorBase>=1&&g.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=t;class d{constructor(g,p,P,M,V){this.remoteInfo=p,this.workspace=P,this._logService=M,this._deprecationService=V,this._webviews=new Map,this._webviewProxy=g.getProxy(E.MainContext.MainThreadWebviews)}$onMessage(g,p,P){const M=this.getWebview(g);if(M){const{message:V}=(0,_.deserializeWebviewMessage)(p,P.value);M._onMessageEmitter.fire(V)}}$onMissingCsp(g,p){this._logService.warn(`${p} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(g,p,P){const M=new b(g,this._webviewProxy,s(p),this.remoteInfo,this.workspace,P,this._deprecationService);return this._webviews.set(g,M),M._onDidDispose(()=>{this._webviews.delete(g)}),M}deleteWebview(g){this._webviews.delete(g)}getWebview(g){return this._webviews.get(g)}}e.ExtHostWebviews=d;function n(o){return{id:o.identifier,location:o.extensionLocation}}e.toExtensionData=n;function i(o,g,p){return{enableCommandUris:p.enableCommandUris,enableScripts:p.enableScripts,enableForms:p.enableForms,portMapping:p.portMapping,localResourceRoots:p.localResourceRoots||a(o,g)}}e.serializeWebviewOptions=i;function s(o){return{enableCommandUris:o.enableCommandUris,enableScripts:o.enableScripts,enableForms:o.enableForms,portMapping:o.portMapping,localResourceRoots:o.localResourceRoots?.map(g=>w.URI.from(g))}}e.reviveOptions=s;function a(o,g){return[...(g?.getWorkspaceFolders()||[]).map(p=>p.uri),o.extensionLocation]}}),define(Ce[218],Ie([1,0,20,213,7,12,22,2,8,54,61,4,6]),function(te,e,r,y,w,L,_,A,E,k,F,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class T{constructor(t,d){this.document=t,this._storagePath=d,this._backupCounter=1,this._edits=new F.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,d){await this.getEdit(t).undo(),d||this.disposeBackup()}async redo(t,d){await this.getEdit(t).redo(),d||this.disposeBackup()}disposeEdits(t){for(const d of t)this._edits.delete(d)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=l(this.document.uri)+this._backupCounter++;return(0,_.joinPath)(this._storagePath,t)}updateBackup(t){this._backup?.delete(),this._backup=t}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(t){const d=this._edits.get(t,0);if(!d)throw new Error("No edit found");return d}}class f{constructor(){this._documents=new Map}get(t,d){return this._documents.get(this.key(t,d))}add(t,d,n){const i=this.key(t,d.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${t} resource:${d.uri}`);const s=new T(d,n);return this._documents.set(i,s),s}delete(t,d){const n=this.key(t,d.uri);this._documents.delete(n)}key(t,d){return`${t}@@@${d}`}}var c;(function(b){b[b.Text=0]="Text",b[b.Custom=1]="Custom"})(c||(c={}));class h{constructor(){this._providers=new Map}addTextProvider(t,d,n){return this.add(0,t,d,n)}addCustomProvider(t,d,n){return this.add(1,t,d,n)}get(t){return this._providers.get(t)}add(t,d,n,i){if(this._providers.has(d))throw new Error(`Provider for viewType:${d} already registered`);return this._providers.set(d,{type:t,extension:n,provider:i}),new m.Disposable(()=>this._providers.delete(d))}}class u{constructor(t,d,n,i,s){this._extHostDocuments=d,this._extensionStoragePaths=n,this._extHostWebview=i,this._extHostWebviewPanels=s,this._editorProviders=new h,this._documents=new f,this._proxy=t.getProxy(S.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,d,n,i){const s=new w.DisposableStore;return v(n)?(s.add(this._editorProviders.addTextProvider(d,t,n)),this._proxy.$registerTextEditorProvider((0,k.toExtensionData)(t),d,i.webviewOptions||{},{supportsMove:!!n.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(t))):(s.add(this._editorProviders.addCustomProvider(d,t,n)),this.supportEditing(n)&&s.add(n.onDidChangeCustomDocument(a=>{const o=this.getCustomDocumentEntry(d,a.document.uri);if(I(a)){const g=o.addEdit(a);this._proxy.$onDidEdit(a.document.uri,d,g,a.label)}else this._proxy.$onContentChange(a.document.uri,d)})),this._proxy.$registerCustomEditorProvider((0,k.toExtensionData)(t),d,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(t))),m.Disposable.from(s,new m.Disposable(()=>{this._proxy.$unregisterEditorProvider(d)}))}async $createCustomDocument(t,d,n,i,s){const a=this._editorProviders.get(d);if(!a)throw new Error(`No provider found for '${d}'`);if(a.type!==1)throw new Error(`Invalid provide type for '${d}'`);const o=A.URI.revive(t),g=await a.provider.openCustomDocument(o,{backupId:n,untitledDocumentData:i?.buffer},s);let p;return this.supportEditing(a.provider)&&this._extensionStoragePaths&&(p=this._extensionStoragePaths.workspaceValue(a.extension)??this._extensionStoragePaths.globalValue(a.extension)),this._documents.add(d,g,p),{editable:this.supportEditing(a.provider)}}async $disposeCustomDocument(t,d){const n=this._editorProviders.get(d);if(!n)throw new Error(`No provider found for '${d}'`);if(n.type!==1)throw new Error(`Invalid provider type for '${d}'`);const i=A.URI.revive(t),{document:s}=this.getCustomDocumentEntry(d,i);this._documents.delete(d,s),s.dispose()}async $resolveWebviewEditor(t,d,n,i,s,a){const o=this._editorProviders.get(n);if(!o)throw new Error(`No provider found for '${n}'`);const g=E.ViewColumn.to(s),p=this._extHostWebview.createNewWebview(d,i.webviewOptions,o.extension),P=this._extHostWebviewPanels.createNewWebviewPanel(d,n,i.title,g,i.panelOptions,p,!0),M=A.URI.revive(t);switch(o.type){case 1:{const{document:V}=this.getCustomDocumentEntry(n,M);return o.provider.resolveCustomEditor(V,P,a)}case 0:{const V=this._extHostDocuments.getDocument(M);return o.provider.resolveCustomTextEditor(V,P,a)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,d,n){this.getCustomDocumentEntry(d,t).disposeEdits(n)}async $onMoveCustomEditor(t,d,n){const i=this._editorProviders.get(n);if(!i)throw new Error(`No provider found for '${n}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${n}'`);const s=this._extHostWebviewPanels.getWebviewPanel(t);if(!s)throw new Error("No webview found");const a=A.URI.revive(d),o=this._extHostDocuments.getDocument(a);await i.provider.moveCustomTextEditor(o,s,r.CancellationToken.None)}async $undo(t,d,n,i){return this.getCustomDocumentEntry(d,t).undo(n,i)}async $redo(t,d,n,i){return this.getCustomDocumentEntry(d,t).redo(n,i)}async $revert(t,d,n){const i=this.getCustomDocumentEntry(d,t);await this.getCustomEditorProvider(d).revertCustomDocument(i.document,n),i.disposeBackup()}async $onSave(t,d,n){const i=this.getCustomDocumentEntry(d,t);await this.getCustomEditorProvider(d).saveCustomDocument(i.document,n),i.disposeBackup()}async $onSaveAs(t,d,n,i){const s=this.getCustomDocumentEntry(d,t);return this.getCustomEditorProvider(d).saveCustomDocumentAs(s.document,A.URI.revive(n),i)}async $backup(t,d,n){const i=this.getCustomDocumentEntry(d,t),a=await this.getCustomEditorProvider(d).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},n);return i.updateBackup(a),a.id}getCustomDocumentEntry(t,d){const n=this._documents.get(t,A.URI.revive(d));if(!n)throw new Error("No custom document found");return n}getCustomEditorProvider(t){const n=this._editorProviders.get(t)?.provider;if(!n||!this.supportEditing(n))throw new Error("Custom document is not editable");return n}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=u;function v(b){return typeof b.resolveCustomTextEditor=="function"}function I(b){return typeof b.undo=="function"&&typeof b.redo=="function"}function l(b){const t=b.scheme===L.Schemas.file||b.scheme===L.Schemas.untitled?b.fsPath:b.toString();return(0,y.hash)(t)+""}});var Je=this&&this.__classPrivateFieldSet||function(te,e,r,y,w){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!w:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?w.call(te,r):w?w.value=r:e.set(te,r),r},Oe=this&&this.__classPrivateFieldGet||function(te,e,r,y){if(r==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?y:r==="a"?y.call(te):y?y.value:e.get(te)};define(Ce[219],Ie([1,0,5,7,2,42,8,54,4,6]),function(te,e,r,y,w,L,_,A,E,k){"use strict";var F,S,m,T,f,c,h,u,v,I,l,b,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class d extends y.Disposable{constructor(a,o,g,p){super(),F.set(this,void 0),S.set(this,void 0),m.set(this,void 0),T.set(this,void 0),f.set(this,void 0),c.set(this,void 0),h.set(this,void 0),u.set(this,void 0),v.set(this,!0),I.set(this,void 0),l.set(this,!1),b.set(this,this._register(new r.Emitter)),this.onDidDispose=Oe(this,b,"f").event,t.set(this,this._register(new r.Emitter)),this.onDidChangeViewState=Oe(this,t,"f").event,Je(this,F,a,"f"),Je(this,S,o,"f"),Je(this,T,g,"f"),Je(this,m,p.viewType,"f"),Je(this,f,p.panelOptions,"f"),Je(this,u,p.viewColumn,"f"),Je(this,c,p.title,"f"),Je(this,I,p.active,"f")}dispose(){Oe(this,l,"f")||(Je(this,l,!0,"f"),Oe(this,b,"f").fire(),Oe(this,S,"f").$disposeWebview(Oe(this,F,"f")),Oe(this,T,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Oe(this,T,"f")}get viewType(){return this.assertNotDisposed(),Oe(this,m,"f")}get title(){return this.assertNotDisposed(),Oe(this,c,"f")}set title(a){this.assertNotDisposed(),Oe(this,c,"f")!==a&&(Je(this,c,a,"f"),Oe(this,S,"f").$setTitle(Oe(this,F,"f"),a))}get iconPath(){return this.assertNotDisposed(),Oe(this,h,"f")}set iconPath(a){this.assertNotDisposed(),Oe(this,h,"f")!==a&&(Je(this,h,a,"f"),Oe(this,S,"f").$setIconPath(Oe(this,F,"f"),w.URI.isUri(a)?{light:a,dark:a}:a))}get options(){return Oe(this,f,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Oe(this,u,"f")=="number"&&Oe(this,u,"f")<0))return Oe(this,u,"f")}get active(){return this.assertNotDisposed(),Oe(this,I,"f")}get visible(){return this.assertNotDisposed(),Oe(this,v,"f")}_updateViewState(a){Oe(this,l,"f")||(this.active!==a.active||this.visible!==a.visible||this.viewColumn!==a.viewColumn)&&(Je(this,I,a.active,"f"),Je(this,v,a.visible,"f"),Je(this,u,a.viewColumn,"f"),Oe(this,t,"f").fire({webviewPanel:this}))}reveal(a,o){this.assertNotDisposed(),Oe(this,S,"f").$reveal(Oe(this,F,"f"),{viewColumn:typeof a>"u"?void 0:_.ViewColumn.from(a),preserveFocus:!!o})}assertNotDisposed(){if(Oe(this,l,"f"))throw new Error("Webview is disposed")}}F=new WeakMap,S=new WeakMap,m=new WeakMap,T=new WeakMap,f=new WeakMap,c=new WeakMap,h=new WeakMap,u=new WeakMap,v=new WeakMap,I=new WeakMap,l=new WeakMap,b=new WeakMap,t=new WeakMap;class n{constructor(a,o,g){this.webviews=o,this.workspace=g,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=a.getProxy(E.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,L.generateUuid)()}createWebviewPanel(a,o,g,p,P={}){const M=typeof p=="object"?p.viewColumn:p,V={viewColumn:_.ViewColumn.from(M),preserveFocus:typeof p=="object"&&!!p.preserveFocus},B=(0,A.shouldSerializeBuffersForPostMessage)(a),D=n.newHandle();this._proxy.$createWebviewPanel((0,A.toExtensionData)(a),D,o,{title:g,panelOptions:i(P),webviewOptions:(0,A.serializeWebviewOptions)(a,this.workspace,P),serializeBuffersForPostMessage:B},V);const x=this.webviews.createNewWebview(D,P,a);return this.createNewWebviewPanel(D,o,g,M,P,x,!0)}$onDidChangeWebviewPanelViewStates(a){const o=Object.keys(a);o.sort((g,p)=>{const P=a[g],M=a[p];return P.active?1:M.active?-1:+P.visible-+M.visible});for(const g of o){const p=this.getWebviewPanel(g);if(!p)continue;const P=a[g];p._updateViewState({active:P.active,visible:P.visible,viewColumn:_.ViewColumn.to(P.position)})}}async $onDidDisposeWebviewPanel(a){this.getWebviewPanel(a)?.dispose(),this._webviewPanels.delete(a),this.webviews.deleteWebview(a)}registerWebviewPanelSerializer(a,o,g){if(this._serializers.has(o))throw new Error(`Serializer for '${o}' already registered`);return this._serializers.set(o,{serializer:g,extension:a}),this._proxy.$registerSerializer(o,{serializeBuffersForPostMessage:(0,A.shouldSerializeBuffersForPostMessage)(a)}),new k.Disposable(()=>{this._serializers.delete(o),this._proxy.$unregisterSerializer(o)})}async $deserializeWebviewPanel(a,o,g,p){const P=this._serializers.get(o);if(!P)throw new Error(`No serializer found for '${o}'`);const{serializer:M,extension:V}=P,B=this.webviews.createNewWebview(a,g.webviewOptions,V),D=this.createNewWebviewPanel(a,o,g.title,p,g.panelOptions,B,g.active);await M.deserializeWebviewPanel(D,g.state)}createNewWebviewPanel(a,o,g,p,P,M,V){const B=new d(a,this._proxy,M,{viewType:o,title:g,viewColumn:p,panelOptions:P,active:V});return this._webviewPanels.set(a,B),B}getWebviewPanel(a){return this._webviewPanels.get(a)}}e.ExtHostWebviewPanels=n;function i(s){return{enableFindWidget:s.enableFindWidget,retainContextWhenHidden:s.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(te,e,r,y,w){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!w:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?w.call(te,r):w?w.value=r:e.set(te,r),r},Oe=this&&this.__classPrivateFieldGet||function(te,e,r,y){if(r==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?y:r==="a"?y.call(te):y?y.value:e.get(te)};define(Ce[220],Ie([1,0,5,7,54,8,4,6]),function(te,e,r,y,w,L,_,A){"use strict";var E,k,F,S,m,T,f,c,h,u,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class I extends y.Disposable{constructor(t,d,n,i,s,a,o){super(),E.set(this,void 0),k.set(this,void 0),F.set(this,void 0),S.set(this,void 0),m.set(this,!1),T.set(this,void 0),f.set(this,void 0),c.set(this,void 0),h.set(this,void 0),u.set(this,this._register(new r.Emitter)),this.onDidChangeVisibility=Oe(this,u,"f").event,v.set(this,this._register(new r.Emitter)),this.onDidDispose=Oe(this,v,"f").event,Je(this,F,n,"f"),Je(this,f,i,"f"),Je(this,E,t,"f"),Je(this,k,d,"f"),Je(this,S,s,"f"),Je(this,T,o,"f")}dispose(){Oe(this,m,"f")||(Je(this,m,!0,"f"),Oe(this,v,"f").fire(),Oe(this,S,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Oe(this,f,"f")}set title(t){this.assertNotDisposed(),Oe(this,f,"f")!==t&&(Je(this,f,t,"f"),Oe(this,k,"f").$setWebviewViewTitle(Oe(this,E,"f"),t))}get description(){return this.assertNotDisposed(),Oe(this,c,"f")}set description(t){this.assertNotDisposed(),Oe(this,c,"f")!==t&&(Je(this,c,t,"f"),Oe(this,k,"f").$setWebviewViewDescription(Oe(this,E,"f"),t))}get visible(){return Oe(this,T,"f")}get webview(){return Oe(this,S,"f")}get viewType(){return Oe(this,F,"f")}_setVisible(t){t===Oe(this,T,"f")||Oe(this,m,"f")||(Je(this,T,t,"f"),Oe(this,u,"f").fire())}get badge(){return this.assertNotDisposed(),Oe(this,h,"f")}set badge(t){this.assertNotDisposed(),!(t?.value===Oe(this,h,"f")?.value&&t?.tooltip===Oe(this,h,"f")?.tooltip)&&(Je(this,h,L.ViewBadge.from(t),"f"),Oe(this,k,"f").$setWebviewViewBadge(Oe(this,E,"f"),t))}show(t){this.assertNotDisposed(),Oe(this,k,"f").$show(Oe(this,E,"f"),!!t)}assertNotDisposed(){if(Oe(this,m,"f"))throw new Error("Webview is disposed")}}E=new WeakMap,k=new WeakMap,F=new WeakMap,S=new WeakMap,m=new WeakMap,T=new WeakMap,f=new WeakMap,c=new WeakMap,h=new WeakMap,u=new WeakMap,v=new WeakMap;class l{constructor(t,d){this._extHostWebview=d,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=t.getProxy(_.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(t,d,n,i){if(this._viewProviders.has(d))throw new Error(`View provider for '${d}' already registered`);return this._viewProviders.set(d,{provider:n,extension:t}),this._proxy.$registerWebviewViewProvider((0,w.toExtensionData)(t),d,{retainContextWhenHidden:i?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,w.shouldSerializeBuffersForPostMessage)(t)}),new A.Disposable(()=>{this._viewProviders.delete(d),this._proxy.$unregisterWebviewViewProvider(d)})}async $resolveWebviewView(t,d,n,i,s){const a=this._viewProviders.get(d);if(!a)throw new Error(`No view provider found for '${d}'`);const{provider:o,extension:g}=a,p=this._extHostWebview.createNewWebview(t,{},g),P=new I(t,this._proxy,d,n,p,g,!0);this._webviewViews.set(t,P),await o.resolveWebviewView(P,{state:i},s)}async $onDidChangeWebviewViewVisibility(t,d){this.getWebviewView(t)._setVisible(d)}async $disposeWebviewView(t){const d=this.getWebviewView(t);this._webviewViews.delete(t),d.dispose(),this._extHostWebview.deleteWebview(t)}getWebviewView(t){const d=this._webviewViews.get(t);if(!d)throw new Error("No webview found");return d}}e.ExtHostWebviewViews=l}),define(Ce[98],Ie([1,0,5,4,2,12,9,3,13]),function(te,e,r,y,w,L,_,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class Ji{constructor(S){this._onDidChangeWindowState=new r.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Ji.InitialState,this._proxy=S.getProxy(y.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(m=>this.$onDidChangeWindowFocus(m))}get state(){return this._state}$onDidChangeWindowFocus(S){S!==this._state.focused&&(this._state={...this._state,focused:S},this._onDidChangeWindowState.fire(this._state))}openUri(S,m){let T;if(typeof S=="string"){T=S;try{S=w.URI.parse(S)}catch{return Promise.reject(`Invalid uri - '${S}'`)}}return(0,_.isFalsyOrWhitespace)(S.scheme)?Promise.reject("Invalid scheme - cannot be empty"):S.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${S.scheme}'`):this._proxy.$openUri(S,T,m)}async asExternalUri(S,m){if((0,_.isFalsyOrWhitespace)(S.scheme))return Promise.reject("Invalid scheme - cannot be empty");const T=await this._proxy.$asExternalUri(S,m);return w.URI.from(T)}};k.InitialState={focused:!0},k=ze([xe(0,E.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,A.createDecorator)("IExtHostWindow")}),define(Ce[221],Ie([1,0,191,28,13]),function(te,e,r,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let L=class extends r.AbstractExtHostConsoleForwarder{constructor(A,E){super(A,E)}_nativeConsoleLogMessage(A,E,k){E.apply(console,k)}};L=ze([xe(0,w.IExtHostRpcService),xe(1,y.IExtHostInitDataService)],L),e.ExtHostConsoleForwarder=L}),define(Ce[222],Ie([1,0,14,23,20,11,5,7,118,185,40]),function(te,e,r,y,w,L,_,A,E,k,F){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function m(P,M){try{return JSON.stringify(P,M)}catch{return"null"}}const T="$$ref$$",f={[T]:-1};class c{constructor(M,V){this.jsonString=M,this.referencedBuffers=V}}function h(P,M=null,V=!1){const B=[];return{jsonString:(V?m:JSON.stringify)(P,(x,U)=>{if(typeof U>"u")return f;if(typeof U=="object"){if(U instanceof y.VSBuffer){const R=B.push(U)-1;return{[T]:R}}if(M)return M(x,U)}return U}),referencedBuffers:B}}e.stringifyJsonWithBufferRefs=h;function u(P,M,V){return JSON.parse(P,(B,D)=>{if(D){const x=D[T];if(typeof x=="number")return M[x];if(V&&D.$mid===1)return V.transformIncoming(D)}return D})}e.parseJsonAndRestoreBufferRefs=u;function v(P,M){return JSON.stringify(P,M)}function I(P){return P?(M,V)=>V&&V.$mid===1?P.transformOutgoing(V):V:null}var l;(function(P){P[P.LocalSide=0]="LocalSide",P[P.OtherSide=1]="OtherSide"})(l=e.RequestInitiator||(e.RequestInitiator={}));var b;(function(P){P[P.Responsive=0]="Responsive",P[P.Unresponsive=1]="Unresponsive"})(b=e.ResponsiveState||(e.ResponsiveState={}));const t=()=>{},d=Symbol.for("rpcProtocol"),n=Symbol.for("rpcProxy");class i extends A.Disposable{constructor(M,V=null,B=null){super(),this[S]=!0,this._onDidChangeResponsiveState=this._register(new _.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=M,this._logger=V,this._uriTransformer=B,this._uriReplacer=I(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let D=0,x=F.ProxyIdentifier.count;D<x;D++)this._locals[D]=null,this._proxies[D]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new r.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(D=>this._receiveOneMessage(D))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(M=>{this._pendingRPCReplies[M].resolveErr(L.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(M){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(M){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(M){this._responsiveState!==M&&(this._responsiveState=M,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(M){return this._uriTransformer?(0,E.transformIncomingURIs)(M,this._uriTransformer):M}getProxy(M){const{nid:V,sid:B}=M;return this._proxies[V]||(this._proxies[V]=this._createProxy(V,B)),this._proxies[V]}_createProxy(M,V){const B={get:(D,x)=>(typeof x=="string"&&!D[x]&&x.charCodeAt(0)===36&&(D[x]=(...U)=>this._remoteCall(M,x,U)),x===n?V:D[x])};return new Proxy(Object.create(null),B)}set(M,V){return this._locals[M.nid]=V,V}assertRegistered(M){for(let V=0,B=M.length;V<B;V++){const D=M[V];if(!this._locals[D.nid])throw new Error(`Missing proxy instance ${D.sid}`)}}_receiveOneMessage(M){if(this._isDisposed)return;const V=M.byteLength,B=s.read(M,0),D=B.readUInt8(),x=B.readUInt32();switch(D){case 1:case 2:{let{rpcId:U,method:R,args:K}=o.deserializeRequestJSONArgs(B);this._uriTransformer&&(K=(0,E.transformIncomingURIs)(K,this._uriTransformer)),this._receiveRequest(V,x,U,R,K,D===2);break}case 3:case 4:{let{rpcId:U,method:R,args:K}=o.deserializeRequestMixedArgs(B);this._uriTransformer&&(K=(0,E.transformIncomingURIs)(K,this._uriTransformer)),this._receiveRequest(V,x,U,R,K,D===4);break}case 5:{this._logger?.logIncoming(V,x,0,"ack"),this._onDidReceiveAcknowledge(x);break}case 6:{this._receiveCancel(V,x);break}case 7:{this._receiveReply(V,x,void 0);break}case 9:{let U=o.deserializeReplyOKJSON(B);this._uriTransformer&&(U=(0,E.transformIncomingURIs)(U,this._uriTransformer)),this._receiveReply(V,x,U);break}case 10:{const U=o.deserializeReplyOKJSONWithBuffers(B,this._uriTransformer);this._receiveReply(V,x,U);break}case 8:{const U=o.deserializeReplyOKVSBuffer(B);this._receiveReply(V,x,U);break}case 11:{let U=o.deserializeReplyErrError(B);this._uriTransformer&&(U=(0,E.transformIncomingURIs)(U,this._uriTransformer)),this._receiveReplyErr(V,x,U);break}case 12:{this._receiveReplyErr(V,x,void 0);break}default:console.error("received unexpected message"),console.error(M)}}_receiveRequest(M,V,B,D,x,U){this._logger?.logIncoming(M,V,1,`receiveRequest ${(0,F.getStringIdentifierForProxy)(B)}.${D}(`,x);const R=String(V);let K,W;if(U){const Z=new w.CancellationTokenSource;x.push(Z.token),K=this._invokeHandler(B,D,x),W=()=>Z.cancel()}else K=this._invokeHandler(B,D,x),W=t;this._cancelInvokedHandlers[R]=W;const O=o.serializeAcknowledged(V);this._logger?.logOutgoing(O.byteLength,V,1,"ack"),this._protocol.send(O),K.then(Z=>{delete this._cancelInvokedHandlers[R];const ue=o.serializeReplyOK(V,Z,this._uriReplacer);this._logger?.logOutgoing(ue.byteLength,V,1,"reply:",Z),this._protocol.send(ue)},Z=>{delete this._cancelInvokedHandlers[R];const ue=o.serializeReplyErr(V,Z);this._logger?.logOutgoing(ue.byteLength,V,1,"replyErr:",Z),this._protocol.send(ue)})}_receiveCancel(M,V){this._logger?.logIncoming(M,V,1,"receiveCancel");const B=String(V);this._cancelInvokedHandlers[B]?.()}_receiveReply(M,V,B){this._logger?.logIncoming(M,V,0,"receiveReply:",B);const D=String(V);if(!this._pendingRPCReplies.hasOwnProperty(D))return;const x=this._pendingRPCReplies[D];delete this._pendingRPCReplies[D],x.resolveOk(B)}_receiveReplyErr(M,V,B){this._logger?.logIncoming(M,V,0,"receiveReplyErr:",B);const D=String(V);if(!this._pendingRPCReplies.hasOwnProperty(D))return;const x=this._pendingRPCReplies[D];delete this._pendingRPCReplies[D];let U;B&&(B.$isError?(U=new Error,U.name=B.name,U.message=B.message,U.stack=B.stack):U=B),x.resolveErr(U)}_invokeHandler(M,V,B){try{return Promise.resolve(this._doInvokeHandler(M,V,B))}catch(D){return Promise.reject(D)}}_doInvokeHandler(M,V,B){const D=this._locals[M];if(!D)throw new Error("Unknown actor "+(0,F.getStringIdentifierForProxy)(M));const x=D[V];if(typeof x!="function")throw new Error("Unknown method "+V+" on actor "+(0,F.getStringIdentifierForProxy)(M));return x.apply(D,B)}_remoteCall(M,V,B){if(this._isDisposed)return new k.CanceledLazyPromise;let D=null;if(B.length>0&&w.CancellationToken.isCancellationToken(B[B.length-1])&&(D=B.pop()),D&&D.isCancellationRequested)return Promise.reject(L.canceled());const x=o.serializeRequestArguments(B,this._uriReplacer),U=++this._lastMessageId,R=String(U),K=new k.LazyPromise;D&&D.onCancellationRequested(()=>{const O=o.serializeCancel(U);this._logger?.logOutgoing(O.byteLength,U,0,"cancel"),this._protocol.send(o.serializeCancel(U))}),this._pendingRPCReplies[R]=K,this._onWillSendRequest(U);const W=o.serializeRequest(U,M,V,x,!!D);return this._logger?.logOutgoing(W.byteLength,U,0,`request: ${(0,F.getStringIdentifierForProxy)(M)}.${V}(`,B),this._protocol.send(W),K}}e.RPCProtocol=i,S=d,i.UNRESPONSIVE_TIME=3*1e3;class s{constructor(M,V){this._buff=M,this._offset=V}static alloc(M,V,B){const D=new s(y.VSBuffer.alloc(B+1+4),0);return D.writeUInt8(M),D.writeUInt32(V),D}static read(M,V){return new s(M,V)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(M){this._buff.writeUInt8(M,this._offset),this._offset+=1}readUInt8(){const M=this._buff.readUInt8(this._offset);return this._offset+=1,M}writeUInt32(M){this._buff.writeUInt32BE(M,this._offset),this._offset+=4}readUInt32(){const M=this._buff.readUInt32BE(this._offset);return this._offset+=4,M}static sizeShortString(M){return 1+M.byteLength}writeShortString(M){this._buff.writeUInt8(M.byteLength,this._offset),this._offset+=1,this._buff.set(M,this._offset),this._offset+=M.byteLength}readShortString(){const M=this._buff.readUInt8(this._offset);this._offset+=1;const B=this._buff.slice(this._offset,this._offset+M).toString();return this._offset+=M,B}static sizeLongString(M){return 4+M.byteLength}writeLongString(M){this._buff.writeUInt32BE(M.byteLength,this._offset),this._offset+=4,this._buff.set(M,this._offset),this._offset+=M.byteLength}readLongString(){const M=this._buff.readUInt32BE(this._offset);this._offset+=4;const B=this._buff.slice(this._offset,this._offset+M).toString();return this._offset+=M,B}writeBuffer(M){this._buff.writeUInt32BE(M.byteLength,this._offset),this._offset+=4,this._buff.set(M,this._offset),this._offset+=M.byteLength}static sizeVSBuffer(M){return 4+M.byteLength}writeVSBuffer(M){this._buff.writeUInt32BE(M.byteLength,this._offset),this._offset+=4,this._buff.set(M,this._offset),this._offset+=M.byteLength}readVSBuffer(){const M=this._buff.readUInt32BE(this._offset);this._offset+=4;const V=this._buff.slice(this._offset,this._offset+M);return this._offset+=M,V}static sizeMixedArray(M){let V=0;V+=1;for(let B=0,D=M.length;B<D;B++){const x=M[B];switch(V+=1,x.type){case 1:V+=this.sizeLongString(x.value);break;case 2:V+=this.sizeVSBuffer(x.value);break;case 3:V+=this.sizeUInt32,V+=this.sizeLongString(x.value);for(let U=0;U<x.buffers.length;++U)V+=this.sizeVSBuffer(x.buffers[U]);break;case 4:break}}return V}writeMixedArray(M){this._buff.writeUInt8(M.length,this._offset),this._offset+=1;for(let V=0,B=M.length;V<B;V++){const D=M[V];switch(D.type){case 1:this.writeUInt8(1),this.writeLongString(D.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(D.value);break;case 3:this.writeUInt8(3),this.writeUInt32(D.buffers.length),this.writeLongString(D.value);for(let x=0;x<D.buffers.length;++x)this.writeBuffer(D.buffers[x]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const M=this._buff.readUInt8(this._offset);this._offset+=1;const V=new Array(M);for(let B=0;B<M;B++)switch(this.readUInt8()){case 1:V[B]=this.readLongString();break;case 2:V[B]=this.readVSBuffer();break;case 3:{const x=this.readUInt32(),U=this.readLongString(),R=[];for(let K=0;K<x;++K)R.push(this.readVSBuffer());V[B]=new F.SerializableObjectWithBuffers(u(U,R,null));break}case 4:V[B]=void 0;break}return V}}s.sizeUInt32=4;var a;(function(P){P[P.Simple=0]="Simple",P[P.Mixed=1]="Mixed"})(a||(a={}));class o{static _useMixedArgSerialization(M){for(let V=0,B=M.length;V<B;V++)if(M[V]instanceof y.VSBuffer||M[V]instanceof F.SerializableObjectWithBuffers||typeof M[V]>"u")return!0;return!1}static serializeRequestArguments(M,V){if(this._useMixedArgSerialization(M)){const B=[];for(let D=0,x=M.length;D<x;D++){const U=M[D];if(U instanceof y.VSBuffer)B[D]={type:2,value:U};else if(typeof U>"u")B[D]={type:4};else if(U instanceof F.SerializableObjectWithBuffers){const{jsonString:R,referencedBuffers:K}=h(U.value,V);B[D]={type:3,value:y.VSBuffer.fromString(R),buffers:K}}else B[D]={type:1,value:y.VSBuffer.fromString(v(U,V))}}return{type:1,args:B}}return{type:0,args:v(M,V)}}static serializeRequest(M,V,B,D,x){switch(D.type){case 0:return this._requestJSONArgs(M,V,B,D.args,x);case 1:return this._requestMixedArgs(M,V,B,D.args,x)}}static _requestJSONArgs(M,V,B,D,x){const U=y.VSBuffer.fromString(B),R=y.VSBuffer.fromString(D);let K=0;K+=s.sizeUInt8(),K+=s.sizeShortString(U),K+=s.sizeLongString(R);const W=s.alloc(x?2:1,M,K);return W.writeUInt8(V),W.writeShortString(U),W.writeLongString(R),W.buffer}static deserializeRequestJSONArgs(M){const V=M.readUInt8(),B=M.readShortString(),D=M.readLongString();return{rpcId:V,method:B,args:JSON.parse(D)}}static _requestMixedArgs(M,V,B,D,x){const U=y.VSBuffer.fromString(B);let R=0;R+=s.sizeUInt8(),R+=s.sizeShortString(U),R+=s.sizeMixedArray(D);const K=s.alloc(x?4:3,M,R);return K.writeUInt8(V),K.writeShortString(U),K.writeMixedArray(D),K.buffer}static deserializeRequestMixedArgs(M){const V=M.readUInt8(),B=M.readShortString(),D=M.readMixedArray(),x=new Array(D.length);for(let U=0,R=D.length;U<R;U++){const K=D[U];typeof K=="string"?x[U]=JSON.parse(K):x[U]=K}return{rpcId:V,method:B,args:x}}static serializeAcknowledged(M){return s.alloc(5,M,0).buffer}static serializeCancel(M){return s.alloc(6,M,0).buffer}static serializeReplyOK(M,V,B){if(typeof V>"u")return this._serializeReplyOKEmpty(M);if(V instanceof y.VSBuffer)return this._serializeReplyOKVSBuffer(M,V);if(V instanceof F.SerializableObjectWithBuffers){const{jsonString:D,referencedBuffers:x}=h(V.value,B,!0);return this._serializeReplyOKJSONWithBuffers(M,D,x)}else return this._serializeReplyOKJSON(M,m(V,B))}static _serializeReplyOKEmpty(M){return s.alloc(7,M,0).buffer}static _serializeReplyOKVSBuffer(M,V){let B=0;B+=s.sizeVSBuffer(V);const D=s.alloc(8,M,B);return D.writeVSBuffer(V),D.buffer}static deserializeReplyOKVSBuffer(M){return M.readVSBuffer()}static _serializeReplyOKJSON(M,V){const B=y.VSBuffer.fromString(V);let D=0;D+=s.sizeLongString(B);const x=s.alloc(9,M,D);return x.writeLongString(B),x.buffer}static _serializeReplyOKJSONWithBuffers(M,V,B){const D=y.VSBuffer.fromString(V);let x=0;x+=s.sizeUInt32,x+=s.sizeLongString(D);for(const R of B)x+=s.sizeVSBuffer(R);const U=s.alloc(10,M,x);U.writeUInt32(B.length),U.writeLongString(D);for(const R of B)U.writeBuffer(R);return U.buffer}static deserializeReplyOKJSON(M){const V=M.readLongString();return JSON.parse(V)}static deserializeReplyOKJSONWithBuffers(M,V){const B=M.readUInt32(),D=M.readLongString(),x=[];for(let U=0;U<B;++U)x.push(M.readVSBuffer());return new F.SerializableObjectWithBuffers(u(D,x,V))}static serializeReplyErr(M,V){const B=V?m(L.transformErrorForSerialization(V),null):void 0;if(typeof B!="string")return this._serializeReplyErrEmpty(M);const D=y.VSBuffer.fromString(B);let x=0;x+=s.sizeLongString(D);const U=s.alloc(11,M,x);return U.writeLongString(D),U.buffer}static deserializeReplyErrError(M){const V=M.readLongString();return JSON.parse(V)}static _serializeReplyErrEmpty(M){return s.alloc(12,M,0).buffer}}var g;(function(P){P[P.RequestJSONArgs=1]="RequestJSONArgs",P[P.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",P[P.RequestMixedArgs=3]="RequestMixedArgs",P[P.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",P[P.Acknowledged=5]="Acknowledged",P[P.Cancel=6]="Cancel",P[P.ReplyOKEmpty=7]="ReplyOKEmpty",P[P.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",P[P.ReplyOKJSON=9]="ReplyOKJSON",P[P.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",P[P.ReplyErrError=11]="ReplyErrError",P[P.ReplyErrEmpty=12]="ReplyErrEmpty"})(g||(g={}));var p;(function(P){P[P.String=1]="String",P[P.VSBuffer=2]="VSBuffer",P[P.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",P[P.Undefined=4]="Undefined"})(p||(p={}))}),define(Ce[223],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const r=function(L){const _=A=>{self.removeEventListener("message",_);const E=A.data;Object.defineProperties(self,{postMessage:{value(k,F){E.postMessage(k,F)}},onmessage:{get(){return E.onmessage},set(k){E.onmessage=k}}}),E.addEventListener("message",k=>{self.dispatchEvent(new MessageEvent("message",{data:k.data}))}),E.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(L)};self.addEventListener("message",_)}.toString();class y extends EventTarget{constructor(L,_,A){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const E=`((${r})('${_}'))`,k=new Blob([E],{type:"application/javascript"}),F=URL.createObjectURL(k),S=new MessageChannel,m=F,T={type:"_newWorker",id:m,port:S.port2,url:F,options:A};L(T,[S.port2]),this.postMessage=S.port1.postMessage.bind(S.port1),this.terminate=()=>{L({type:"_terminateWorker",id:m}),URL.revokeObjectURL(F),S.port1.close(),S.port2.close()},Object.defineProperties(this,{onmessage:{get(){return S.port1.onmessage},set(f){S.port1.onmessage=f}},onmessageerror:{get(){return S.port1.onmessageerror},set(f){S.port1.onmessageerror=f}}}),S.port1.addEventListener("messageerror",f=>{const c=new MessageEvent("messageerror",{data:f.data});this.dispatchEvent(c)}),S.port1.addEventListener("message",f=>{const c=new MessageEvent("message",{data:f.data});this.dispatchEvent(c)}),S.port1.start()}}e.NestedWorker=y}),define(Ce[224],Ie([1,0,5,30,38,3,39,11,14]),function(te,e,r,y,w,L,_,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new w.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new w.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new w.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,L.createDecorator)(e.OUTPUT_SERVICE_ID);var k;(function(T){T[T.Append=1]="Append",T[T.Replace=2]="Replace",T[T.Clear=3]="Clear"})(k=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class F{constructor(){this.channels=new Map,this._onDidRegisterChannel=new r.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new r.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(f){this.channels.has(f.id)||(this.channels.set(f.id,f),this._onDidRegisterChannel.fire(f.id))}getChannels(){const f=[];return this.channels.forEach(c=>f.push(c)),f}getChannel(f){return this.channels.get(f)}removeChannel(f){this.channels.delete(f),this._onDidRemoveChannel.fire(f)}}y.Registry.add(e.Extensions.OutputChannels,new F);function S(T,f,c,h,u){return(0,E.createCancelablePromise)(async v=>{await(0,_.whenProviderRegistered)(c,h);const I=y.Registry.as(e.Extensions.OutputChannels);try{await m(c,1,h,u,v),I.registerChannel({id:T,label:f,file:c,log:!0})}catch(l){(0,A.isCancellationError)(l)||u.error("Error while registering log channel",c.toString(),(0,A.getErrorMessage)(l))}})}e.registerLogChannel=S;async function m(T,f,c,h,u){if(!await c.exists(T)){if(u.isCancellationRequested)throw new A.CancellationError;if(f>10)throw new Error("Timed out while waiting for file to be created");h.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",T.toString()),await(0,E.timeout)(1e3,u),await m(T,f+1,c,h,u)}}}),define(Ce[99],Ie([1,0,4,7,3,13,15,224,52,28,35,112,23,10]),function(te,e,r,y,w,L,_,A,E,k,F,S,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class f extends y.Disposable{constructor(u,v,I,l){super(),this.id=u,this.name=v,this.logger=I,this.proxy=l,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(u){this.append(u+`
`)}append(u){this.write(u),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Append))}clear(){const u=this.offset;this.logger.flush(),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Clear,u)}replace(u){const v=this.offset;this.write(u),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Replace,v),this.visible&&this.logger.flush()}show(u,v){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof u=="boolean"?u:v))}hide(){this.proxy.$close(this.id)}write(u){this.offset+=m.VSBuffer.fromString(u).byteLength,this.logger.info(u)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=f;let c=class{constructor(u,v,I,l,b){this.extHostFileSystem=I,this.extHostFileSystemInfo=l,this.loggerService=b,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=u.getProxy(r.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(v.logsLocation,`output_logging_${(0,S.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(u){this.visibleChannelId=u;for(const[v,I]of this.channels)I.visible=v===this.visibleChannelId}createOutputChannel(u,v,I){if(u=u.trim(),!u)throw new Error("illegal argument `name`. must not be falsy");if((0,T.isString)(v)&&!v.trim())throw new Error("illegal argument `languageId`. must not be empty");const l=this.doCreateOutputChannel(u,v,I);return l.then(b=>{this.channels.set(b.id,b),b.visible=b.id===this.visibleChannelId}),this.createExtHostOutputChannel(u,l)}async doCreateOutputChannel(u,v,I){const l=await this.createOutputDirectory(),b=this.extHostFileSystemInfo.extUri.joinPath(l,`${this.namePool++}-${u.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),t=this.loggerService.createLogger(b,{always:!0,donotRotate:!0,donotUseFormatters:!0}),d=await this.proxy.$register(u,!1,b,v,I.identifier.value);return new f(d,u,t,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(u,v){let I=!1;const l=()=>{if(I)throw new Error("Channel has been closed")};return{get name(){return u},append(b){l(),v.then(t=>t.append(b))},appendLine(b){l(),v.then(t=>t.appendLine(b))},clear(){l(),v.then(b=>b.clear())},replace(b){l(),v.then(t=>t.replace(b))},show(b,t){l(),v.then(d=>d.show(b,t))},hide(){l(),v.then(b=>b.hide())},dispose(){I=!0,v.then(b=>b.dispose())}}}};c=ze([xe(0,L.IExtHostRpcService),xe(1,k.IExtHostInitDataService),xe(2,E.IExtHostConsumerFileSystem),xe(3,F.IExtHostFileSystemInfo),xe(4,_.ILoggerService)],c),e.ExtHostOutputService=c,e.IExtHostOutputService=(0,w.createDecorator)("IExtHostOutputService")}),define(Ce[225],Ie([1,0,3]),function(te,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,r.createDecorator)("remoteAgentService")}),define(Ce[226],Ie([1,0,37,12,19,21,22,2,3,156,45,171,225]),function(te,e,r,y,w,L,_,A,E,k,F,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,E.createDecorator)("pathService");let T=class Zi{constructor(c,h,u,v){this.localUserHome=c,this.remoteAgentService=h,this.environmentService=u,this.contextService=v,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||L.OS)(),this.resolveUserHome=(async()=>{const I=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=I?.userHome??c})()}hasValidBasename(c,h,u){return typeof h=="string"||typeof h>"u"?this.resolveOS.then(v=>this.doHasValidBasename(c,v,h)):this.doHasValidBasename(c,h,u)}doHasValidBasename(c,h,u){return c.scheme===y.Schemas.file||c.scheme===y.Schemas.vscodeRemote?(0,r.isValidBasename)(u??(0,_.basename)(c),h===1):!0}get defaultUriScheme(){return Zi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(c,h){if(c.remoteAuthority)return y.Schemas.vscodeRemote;const u=(0,k.getVirtualWorkspaceScheme)(h.getWorkspace());if(u)return u;const v=h.getWorkspace().folders[0];if(v)return v.uri.scheme;const I=h.getWorkspace().configuration;return I?I.scheme:y.Schemas.file}userHome(c){return c?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(c=>c===1?w.win32:w.posix)}async fileURI(c){let h="";if(await this.resolveOS===1&&(c=c.replace(/\\/g,"/")),c[0]==="/"&&c[1]==="/"){const v=c.indexOf("/",2);v===-1?(h=c.substring(2),c="/"):(h=c.substring(2,v),c=c.substring(v)||"/")}return A.URI.from({scheme:y.Schemas.file,authority:h,path:c,query:"",fragment:""})}};T=ze([xe(1,m.IRemoteAgentService),xe(2,S.IWorkbenchEnvironmentService),xe(3,F.IWorkspaceContextService)],T),e.AbstractPathService=T}),define(Ce[100],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class r{constructor(_,A){this.line=_,this.character=A}isBefore(_){return!1}isBeforeOrEqual(_){return!1}isAfter(_){return!1}isAfterOrEqual(_){return!1}isEqual(_){return!1}compareTo(_){return 0}translate(_,A){return new r(0,0)}with(_){return new r(0,0)}}e.Position=r;class y{constructor(_,A,E,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new r(_,A),this.end=new r(E,k)}contains(_){return!1}isEqual(_){return!1}intersection(_){}union(_){return new y(0,0,0,0)}with(_){return new y(0,0,0,0)}}e.Range=y;var w;(function(L){L[L.Information=1]="Information",L[L.Warning=2]="Warning"})(w=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ce[41],Ie([1,0,16,34,26,37,9,3,19,11,100,14]),function(te,e,r,y,w,L,_,A,E,k,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return F.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const m="\u27EA ",T=" characters skipped \u27EB",f=(m.length+T.length+5)*2;e.ISearchService=(0,A.createDecorator)("searchService");var c;(function(oe){oe[oe.file=0]="file",oe[oe.text=1]="text"})(c=e.SearchProviderType||(e.SearchProviderType={}));var h;(function(oe){oe[oe.File=1]="File",oe[oe.Text=2]="Text"})(h=e.QueryType||(e.QueryType={}));function u(oe){return!!oe.preview}e.resultIsMatch=u;function v(oe){return!!oe.resource}e.isFileMatch=v;function I(oe){return!!oe.message}e.isProgressMessage=I;var l;(function(oe){oe[oe.Normal=0]="Normal",oe[oe.NewSearchStarted=1]="NewSearchStarted"})(l=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class b{constructor(de){this.resource=de,this.results=[]}}e.FileMatch=b;class t{constructor(de,ie,ve){this.ranges=ie;const be=Array.isArray(ie)?ie:[ie];if(ve&&ve.matchLines===1&&d(be)){de=(0,_.getNLines)(de,ve.matchLines);let ne="",Ee=0,Pe=0;const Fe=Math.floor(ve.charsPerLine/5),$e=[];for(const Qe of be){const Te=Math.max(Qe.startColumn-Fe,0),_e=Qe.startColumn+ve.charsPerLine;if(Te>Pe+Fe+f){const ye=m+(Te-Pe)+T;ne+=ye+de.slice(Te,_e),Ee+=Te-(Pe+ye.length)}else ne+=de.slice(Pe,_e);$e.push(new i(0,Qe.startColumn-Ee,Qe.endColumn-Ee)),Pe=_e}this.preview={text:ne,matches:Array.isArray(this.ranges)?$e:$e[0]}}else{const ne=Array.isArray(ie)?ie[0].startLineNumber:ie.startLineNumber;this.preview={text:de,matches:(0,r.mapArrayOrNot)(ie,Ee=>new n(Ee.startLineNumber-ne,Ee.startColumn,Ee.endLineNumber-ne,Ee.endColumn))}}}}e.TextSearchMatch=t;function d(oe){const de=oe[0].startLineNumber;for(const ie of oe)if(ie.startLineNumber!==de||ie.endLineNumber!==de)return!1;return!0}class n{constructor(de,ie,ve,be){this.startLineNumber=de,this.startColumn=ie,this.endLineNumber=ve,this.endColumn=be}}e.SearchRange=n;class i extends n{constructor(de,ie,ve){super(de,ie,de,ve)}}e.OneLineRange=i;var s;(function(oe){oe.Default="default",oe.FileNames="fileNames",oe.Type="type",oe.Modified="modified",oe.CountDescending="countDescending",oe.CountAscending="countAscending"})(s=e.SearchSortOrder||(e.SearchSortOrder={}));function a(oe,de=!0){const ie=oe&&oe.files&&oe.files.exclude,ve=de&&oe&&oe.search&&oe.search.exclude;if(!ie&&!ve)return;if(!ie||!ve)return ie||ve;let be=Object.create(null);return be=w.mixin(be,w.deepClone(ie)),be=w.mixin(be,w.deepClone(ve),!0),be}e.getExcludes=a;function o(oe,de){return oe.excludePattern&&y.match(oe.excludePattern,de)?!1:oe.includePattern||oe.usingSearchPaths?oe.includePattern&&y.match(oe.includePattern,de)?!0:oe.usingSearchPaths?!!oe.folderQueries&&oe.folderQueries.some(ie=>{const ve=ie.folder.fsPath;if(L.isEqualOrParent(de,ve)){const be=E.relative(ve,de);return!ie.includePattern||!!y.match(ie.includePattern,be)}else return!1}):!1:!0}e.pathIncludedInQuery=o;var g;(function(oe){oe[oe.unknownEncoding=1]="unknownEncoding",oe[oe.regexParseError=2]="regexParseError",oe[oe.globParseError=3]="globParseError",oe[oe.invalidLiteral=4]="invalidLiteral",oe[oe.rgProcessError=5]="rgProcessError",oe[oe.other=6]="other",oe[oe.canceled=7]="canceled"})(g=e.SearchErrorCode||(e.SearchErrorCode={}));class p extends Error{constructor(de,ie){super(de),this.code=ie}}e.SearchError=p;function P(oe){const de=oe.message;if((0,k.isCancellationError)(oe))return new p(de,g.canceled);try{const ie=JSON.parse(de);return new p(ie.message,ie.code)}catch{return new p(de,g.other)}}e.deserializeSearchError=P;function M(oe){const de={message:oe.message,code:oe.code};return new Error(JSON.stringify(de))}e.serializeSearchError=M;function V(oe){return oe.type==="error"?!0:oe.type==="success"}e.isSerializedSearchComplete=V;function B(oe){return oe.type==="success"}e.isSerializedSearchSuccess=B;function D(oe){return!!oe.path}e.isSerializedFileMatch=D;function x(oe,de){const ie=oe.searchPath?oe.searchPath:oe.relativePath;return(0,_.fuzzyContains)(ie,de)}e.isFilePatternMatch=x;class U{constructor(de){this.path=de,this.results=[]}addMatch(de){this.results.push(de)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=U;function R(oe,de){const ie={...oe||{},...de||{}};return Object.keys(ie).filter(ve=>{const be=ie[ve];return typeof be=="boolean"&&be})}e.resolvePatternsForProvider=R;class K{constructor(de,ie){this._parsedIncludeExpression=null,this._excludeExpression={...de.excludePattern||{},...ie.excludePattern||{}},this._parsedExcludeExpression=y.parse(this._excludeExpression);let ve=de.includePattern;ie.includePattern&&(ve?ve={...ve,...ie.includePattern}:ve=ie.includePattern),ve&&(this._parsedIncludeExpression=y.parse(ve))}matchesExcludesSync(de,ie,ve){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(de,ie,ve))}includedInQuerySync(de,ie,ve){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(de,ie,ve)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(de,ie,ve))}includedInQuery(de,ie,ve){const be=this._parsedExcludeExpression(de,ie,ve),ne=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(de,ie,ve):!0;return(0,S.isThenable)(be)?be.then(Ee=>Ee?!1:ne()):ne()}hasSiblingExcludeClauses(){return W(this._excludeExpression)}}e.QueryGlobTester=K;function W(oe){for(const de in oe)if(typeof oe[de]!="boolean")return!0;return!1}function O(oe){if(!oe)return;let de;return ie=>(de||(de=(oe()||Promise.resolve([])).then(ve=>ve?ue(ve):{})),de.then(ve=>!!ve[ie]))}e.hasSiblingPromiseFn=O;function Z(oe){if(!oe)return;let de;return ie=>{if(!de){const ve=oe();de=ve?ue(ve):{}}return!!de[ie]}}e.hasSiblingFn=Z;function ue(oe){const de={};for(const ie of oe)de[ie]=!0;return de}}),define(Ce[31],Ie([1,0,16,14,20,5,7,25,12,107,22,9,10,2,135,3,15,148,45,35,28,13,8,6,46,41,4]),function(te,e,r,y,w,L,_,A,E,k,F,S,m,T,f,c,h,u,v,I,l,b,t,d,n,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function a(D,x,U){return new F.ExtUri(R=>P(R,U)).isEqual(D,x)}function o(D,x,U){return a(D.uri,x.uri,U)?0:(0,S.compare)(D.uri.toString(),x.uri.toString())}function g(D,x,U){return D.index!==x.index?D.index<x.index?-1:1:a(D.uri,x.uri,U)?(0,S.compare)(D.name,x.name):(0,S.compare)(D.uri.toString(),x.uri.toString())}function p(D,x,U,R){const K=D.slice(0).sort((O,Z)=>U(O,Z,R)),W=x.slice(0).sort((O,Z)=>U(O,Z,R));return(0,r.delta)(K,W,(O,Z)=>U(O,Z,R))}function P(D,x){const U=x.getCapabilities(D.scheme);return!(U&&U&1024)}class M extends v.Workspace{constructor(x,U,R,K,W,O,Z){super(x,R.map(ue=>new v.WorkspaceFolder(ue)),K,W,Z),this._name=U,this._isUntitled=O,this._workspaceFolders=[],this._structure=A.TernarySearchTree.forUris(Z),R.forEach(ue=>{this._workspaceFolders.push(ue),this._structure.set(ue.uri,ue)})}static toExtHostWorkspace(x,U,R,K){if(!x)return{workspace:null,added:[],removed:[]};const{id:W,name:O,folders:Z,configuration:ue,transient:oe,isUntitled:de}=x,ie=[],ve=U;U?Z.forEach((Pe,Fe)=>{const $e=T.URI.revive(Pe.uri),Qe=M._findFolder(R||U,$e,K);Qe?(Qe.name=Pe.name,Qe.index=Pe.index,ie.push(Qe)):ie.push({uri:$e,name:Pe.name,index:Fe})}):ie.push(...Z.map(({uri:Pe,name:Fe,index:$e})=>({uri:T.URI.revive(Pe),name:Fe,index:$e}))),ie.sort((Pe,Fe)=>Pe.index<Fe.index?-1:1);const be=new M(W,O,ie,!!oe,ue?T.URI.revive(ue):null,!!de,Pe=>P(Pe,K)),{added:ne,removed:Ee}=p(ve?ve.workspaceFolders:[],be.workspaceFolders,o,K);return{workspace:be,added:ne,removed:Ee}}static _findFolder(x,U,R){for(let K=0;K<x.folders.length;K++){const W=x.workspaceFolders[K];if(a(W.uri,U,R))return W}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(x,U){return U&&this._structure.get(x)&&(x=(0,F.dirname)(x)),this._structure.findSubstr(x)}resolveWorkspaceFolder(x){return this._structure.get(x)}}let V=class{constructor(x,U,R,K,W){this._onDidChangeWorkspace=new L.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new L.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._logService=K,this._extHostFileSystemInfo=R,this._uriTransformerService=W,this._requestIdProvider=new k.Counter,this._barrier=new y.Barrier,this._proxy=x.getProxy(s.MainContext.MainThreadWorkspace),this._messageService=x.getProxy(s.MainContext.MainThreadMessageService);const O=U.workspace;this._confirmedWorkspace=O?new M(O.id,O.name,[],!!O.transient,O.configuration?T.URI.revive(O.configuration):null,!!O.isUntitled,Z=>P(Z,R)):void 0}$initializeWorkspace(x,U){this._trusted=U,this.$acceptWorkspaceData(x),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?T.URI.from({scheme:E.Schemas.untitled,path:(0,F.basename)((0,F.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(x,U,R,...K){const W=[];if(Array.isArray(K)&&K.forEach(de=>{T.URI.isUri(de.uri)&&!W.some(ie=>a(ie.uri,de.uri,this._extHostFileSystemInfo))&&W.push({uri:de.uri,name:de.name||(0,F.basenameOrAuthority)(de.uri)})}),this._unconfirmedWorkspace||[U,R].some(de=>typeof de!="number"||de<0)||R===0&&W.length===0)return!1;const O=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(U+R>O.length)return!1;const Z=O.slice(0);Z.splice(U,R,...W.map(de=>({uri:de.uri,name:de.name||(0,F.basenameOrAuthority)(de.uri),index:void 0})));for(let de=0;de<Z.length;de++){const ie=Z[de];if(Z.some((ve,be)=>be!==de&&a(ie.uri,ve.uri,this._extHostFileSystemInfo)))return!1}Z.forEach((de,ie)=>de.index=ie);const{added:ue,removed:oe}=p(O,Z,g,this._extHostFileSystemInfo);if(ue.length===0&&oe.length===0)return!1;if(this._proxy){const de=x.displayName||x.name;this._proxy.$updateWorkspaceFolders(de,U,R,W).then(void 0,ie=>{this._unconfirmedWorkspace=void 0;const ve={source:{identifier:x.identifier,label:x.displayName||x.name}};this._messageService.$showMessage(u.Severity.Error,(0,f.localize)(0,null,de,ie.toString()),ve,[])})}return this.trySetWorkspaceFolders(Z),!0}getWorkspaceFolder(x,U){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(x,U)}async getWorkspaceFolder2(x,U){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(x,U)}async resolveWorkspaceFolder(x){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(x)}getPath(){if(!this._actualWorkspace)return;const{folders:x}=this._actualWorkspace;if(x.length!==0)return x[0].uri.fsPath}getRelativePath(x,U){let R,K="";if(typeof x=="string"?(R=T.URI.file(x),K=x):typeof x<"u"&&(R=x,K=x.fsPath),!R)return K;const W=this.getWorkspaceFolder(R,!0);if(!W)return K;typeof U>"u"&&this._actualWorkspace&&(U=this._actualWorkspace.folders.length>1);let O=(0,F.relativePath)(W.uri,R);return U&&W.name&&(O=`${W.name}/${O}`),O}trySetWorkspaceFolders(x){this._actualWorkspace&&(this._unconfirmedWorkspace=M.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:x,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(x){const{workspace:U,added:R,removed:K}=M.toExtHostWorkspace(x,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=U||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:R,removed:K}))}findFiles(x,U,R,K,W=w.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${K.value}, entryPoint: findFiles`);let O;if(U===null?O=!1:U&&(typeof U=="string"?O=U:O=U.pattern),W&&W.isCancellationRequested)return Promise.resolve([]);const{includePattern:Z,folder:ue}=B(t.GlobPattern.from(x));return this._proxy.$startFileSearch((0,m.withUndefinedAsNull)(Z),(0,m.withUndefinedAsNull)(ue),(0,m.withUndefinedAsNull)(O),(0,m.withUndefinedAsNull)(R),W).then(oe=>Array.isArray(oe)?oe.map(de=>T.URI.revive(de)):[])}async findTextInFiles(x,U,R,K,W=w.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${K.value}, entryPoint: findTextInFiles`);const O=this._requestIdProvider.getNext(),Z=typeof U.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:ue,folder:oe}=B(t.GlobPattern.from(U.include)),de=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,ie={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof U.useParentIgnoreFiles=="boolean"?!U.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:Z,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:ue,excludePattern:de},ve=!1;if(this._activeSearchCallbacks[O]=be=>{if(ve)return;const ne=T.URI.revive(be.resource);be.results.forEach(Ee=>{(0,i.resultIsMatch)(Ee)?R({uri:ne,preview:{text:Ee.preview.text,matches:(0,r.mapArrayOrNot)(Ee.preview.matches,Pe=>new d.Range(Pe.startLineNumber,Pe.startColumn,Pe.endLineNumber,Pe.endColumn))},ranges:(0,r.mapArrayOrNot)(Ee.ranges,Pe=>new d.Range(Pe.startLineNumber,Pe.startColumn,Pe.endLineNumber,Pe.endColumn))}):R({uri:ne,text:Ee.text,lineNumber:Ee.lineNumber})})},W.isCancellationRequested)return{};try{const be=await this._proxy.$startTextSearch(x,(0,m.withUndefinedAsNull)(oe),ie,O,W);return delete this._activeSearchCallbacks[O],be||{}}catch(be){throw delete this._activeSearchCallbacks[O],be}}$handleTextSearchResult(x,U){this._activeSearchCallbacks[U]?.(x)}saveAll(x){return this._proxy.$saveAll(x)}resolveProxy(x){return this._proxy.$resolveProxy(x)}get trusted(){return this._trusted}requestWorkspaceTrust(x){return this._proxy.$requestWorkspaceTrust(x)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(x,U){if(this._editSessionIdentityProviders.has(x))throw new Error(`A provider has already been registered for scheme ${x}`);this._editSessionIdentityProviders.set(x,U);const R=this._uriTransformerService.transformOutgoingScheme(x),K=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(K,R),(0,_.toDisposable)(()=>{this._editSessionIdentityProviders.delete(x),this._proxy.$unregisterEditSessionIdentityProvider(K)})}async $getEditSessionIdentifier(x,U){this._logService.info("Getting edit session identifier for workspaceFolder",x);const R=await this.resolveWorkspaceFolder(T.URI.revive(x));if(!R){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",R);const K=this._editSessionIdentityProviders.get(R.uri.scheme);if(this._logService.info(`Provider for scheme ${R.uri.scheme} is defined: `,!!K),!K)return;const W=await K.provideEditSessionIdentity(R,U);if(this._logService.info("Provider returned edit session identifier: ",W),!!W)return W}};V=ze([xe(0,b.IExtHostRpcService),xe(1,l.IExtHostInitDataService),xe(2,I.IExtHostFileSystemInfo),xe(3,h.ILogService),xe(4,n.IURITransformerService)],V),e.ExtHostWorkspace=V,e.IExtHostWorkspace=(0,c.createDecorator)("IExtHostWorkspace");function B(D){let x,U;return D&&(typeof D=="string"?x=D:(x=D.pattern,U=T.URI.revive(D.baseUri))),{includePattern:x,folder:U}}}),define(Ce[32],Ie([1,0,26,5,31,4,6,151,84,10,14,3,13,15,2]),function(te,e,r,y,w,L,_,A,E,k,F,S,m,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function c(d,n){if(n){const i=n.split(".");let s=d;for(let a=0;s&&a<i.length;a++)s=s[i[a]];return s}}function h(d){return d instanceof f.URI}function u(d){return d&&d.uri instanceof f.URI&&d.languageId&&typeof d.languageId=="string"}function v(d){return d&&!d.uri&&d.languageId&&typeof d.languageId=="string"}function I(d){return d&&d.uri instanceof f.URI&&(!d.name||typeof d.name=="string")&&(!d.index||typeof d.index=="number")}function l(d){if(h(d))return{resource:d};if(u(d))return{resource:d.uri,overrideIdentifier:d.languageId};if(v(d))return{overrideIdentifier:d.languageId};if(I(d))return{resource:d.uri};if(d===null)return{resource:null}}let b=class{constructor(n,i,s){this._proxy=n.getProxy(L.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=s,this._barrier=new F.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(n=>this._actual)}$initializeConfiguration(n){this._actual=new t(this._proxy,this._extHostWorkspace,n,this._logService),this._barrier.open()}$acceptConfigurationChanged(n,i){this.getConfigProvider().then(s=>s.$acceptConfigurationChanged(n,i))}};b=ze([xe(0,m.IExtHostRpcService),xe(1,w.IExtHostWorkspace),xe(2,T.ILogService)],b),e.ExtHostConfiguration=b;class t{constructor(n,i,s,a){this._onDidChangeConfiguration=new y.Emitter,this._proxy=n,this._logService=a,this._extHostWorkspace=i,this._configuration=A.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(n,i){const s={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=A.Configuration.parse(n),this._configurationScopes=this._toMap(n.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,s))}getConfiguration(n,i,s){const a=l(i)||{},o=this._toReadonlyValue(n?c(this._configuration.getValue(void 0,a,this._extHostWorkspace.workspace),n):this._configuration.getValue(void 0,a,this._extHostWorkspace.workspace));n&&this._validateConfigurationAccess(n,a,s?.identifier);function g(P){if(P==null)return null;if(typeof P=="boolean")return P?2:5;switch(P){case _.ConfigurationTarget.Global:return 2;case _.ConfigurationTarget.Workspace:return 5;case _.ConfigurationTarget.WorkspaceFolder:return 6}}const p={has(P){return typeof c(o,P)<"u"},get:(P,M)=>{this._validateConfigurationAccess(n?`${n}.${P}`:P,a,s?.identifier);let V=c(o,P);if(typeof V>"u")V=M;else{let B;const D=(x,U)=>{let R;const K=()=>{B=B||(0,r.deepClone)(o),R=R||c(B,U)};return(0,k.isObject)(x)?new Proxy(x,{get:(W,O)=>{if(typeof O=="string"&&O.toLowerCase()==="tojson")return K(),()=>R;if(B)return R=R||c(B,U),R[O];const Z=W[O];return typeof O=="string"?D(Z,`${U}.${O}`):Z},set:(W,O,Z)=>(K(),R&&(R[O]=Z),!0),deleteProperty:(W,O)=>(K(),R&&delete R[O],!0),defineProperty:(W,O,Z)=>(K(),R&&Object.defineProperty(R,O,Z),!0)}):x};V=D(V,P)}return V},update:(P,M,V,B)=>{P=n?`${n}.${P}`:P;const D=g(V);return M!==void 0?this._proxy.$updateConfigurationOption(D,P,M,a,B):this._proxy.$removeConfigurationOption(D,P,a,B)},inspect:P=>{P=n?`${n}.${P}`:P;const M=(0,r.deepClone)(this._configuration.inspect(P,a,this._extHostWorkspace.workspace));if(M)return{key:P,defaultValue:M.policy?.value??M.default?.value,globalValue:M.user?.value??M.application?.value,workspaceValue:M.workspace?.value,workspaceFolderValue:M.workspaceFolder?.value,defaultLanguageValue:M.default?.override,globalLanguageValue:M.user?.override??M.application?.override,workspaceLanguageValue:M.workspace?.override,workspaceFolderLanguageValue:M.workspaceFolder?.override,languageIds:M.overrideIdentifiers}}};return typeof o=="object"&&(0,r.mixin)(p,o,!1),Object.freeze(p)}_toReadonlyValue(n){const i=s=>(0,k.isObject)(s)?new Proxy(s,{get:(a,o)=>i(a[o]),set:(a,o,g)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(o)}' of object`)},deleteProperty:(a,o)=>{throw new Error(`TypeError: Cannot delete read only property '${String(o)}' of object`)},defineProperty:(a,o)=>{throw new Error(`TypeError: Cannot define property '${String(o)}' for a readonly object`)},setPrototypeOf:a=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):s;return i(n)}_validateConfigurationAccess(n,i,s){const a=E.OVERRIDE_PROPERTY_REGEX.test(n)?4:this._configurationScopes.get(n),o=s?`[${s.value}] `:"";if(a===4){typeof i?.resource>"u"&&this._logService.warn(`${o}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${n}', provide the URI of a resource or 'null' for any resource.`);return}if(a===3){i?.resource&&this._logService.warn(`${o}Accessing a window scoped configuration for a resource is not expected. To associate '${n}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(n,i){const s=new A.ConfigurationChangeEvent(n,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(a,o)=>s.affectsConfiguration(a,l(o))})}_toMap(n){return n.reduce((i,s)=>(i.set(s[0],s[1]),i),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,S.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(te,e,r,y,w){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!w:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?w.call(te,r):w?w.value=r:e.set(te,r),r},Oe=this&&this.__classPrivateFieldGet||function(te,e,r,y){if(r==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?y:r==="a"?y.call(te):y?y.value:e.get(te)};define(Ce[101],Ie([1,0,2,14,5,4,6,31,50,32,20,53,13,28,3,12,21,15,67,184,11]),function(te,e,r,y,w,L,_,A,E,k,F,S,m,T,f,c,h,u,v,I,l){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(U){function R(W){if(W!=null)return W}U.from=R;function K(W){if(W!=null)return W}U.to=K})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var d;(function(U){function R(W){if(W!=null)return W}U.from=R;function K(W){if(W!=null)return W}U.to=K})(d=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var n;(function(U){function R(W){if(W!=null)return W}U.from=R;function K(W){if(W!=null)return W}U.to=K})(n=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(U){function R(O){if(O){const Z=O;return Z&&!!Z.process}else return!1}U.is=R;function K(O){if(O==null)return;const Z={process:O.process,args:O.args};return O.options&&(Z.options=n.from(O.options)),Z}U.from=K;function W(O){if(O!=null)return new _.ProcessExecution(O.process,O.args,O.options)}U.to=W})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var s;(function(U){function R(W){if(W!=null)return W}U.from=R;function K(W){if(W!=null)return W}U.to=K})(s=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var a;(function(U){function R(O){if(O){const Z=O;return Z&&(!!Z.commandLine||!!Z.command)}else return!1}U.is=R;function K(O){if(O==null)return;const Z={};return O.commandLine!==void 0?Z.commandLine=O.commandLine:(Z.command=O.command,Z.args=O.args),O.options&&(Z.options=s.from(O.options)),Z}U.from=K;function W(O){if(!(O==null||O.command===void 0&&O.commandLine===void 0))return O.commandLine?new _.ShellExecution(O.commandLine,O.options):new _.ShellExecution(O.command,O.args?O.args:[],O.options)}U.to=W})(a=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var o;(function(U){function R(O){if(O){const Z=O;return Z&&Z.customExecution==="customExecution"}else return!1}U.is=R;function K(O){return{customExecution:"customExecution"}}U.from=K;function W(O,Z){return Z.get(O)}U.to=W})(o=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var g;(function(U){function R(K,W){let O;return K.scope!==void 0&&typeof K.scope!="number"?O=K.scope.uri:K.scope!==void 0&&typeof K.scope=="number"&&(K.scope===_.TaskScope.Workspace&&W&&W.workspaceFile?O=W.workspaceFile:O=I.USER_TASKS_GROUP_KEY),{id:K._id,workspaceFolder:O}}U.from=R})(g=e.TaskHandleDTO||(e.TaskHandleDTO={}));var p;(function(U){function R(K){if(K!=null)return{_id:K.id,isDefault:K.isDefault}}U.from=R})(p=e.TaskGroupDTO||(e.TaskGroupDTO={}));var P;(function(U){function R(O,Z){if(O==null)return[];const ue=[];for(const oe of O){const de=K(oe,Z);de&&ue.push(de)}return ue}U.fromMany=R;function K(O,Z){if(O==null)return;let ue;O.execution instanceof _.ProcessExecution?ue=i.from(O.execution):O.execution instanceof _.ShellExecution?ue=a.from(O.execution):O.execution&&O.execution instanceof _.CustomExecution&&(ue=o.from(O.execution));const oe=t.from(O.definition);let de;return O.scope?typeof O.scope=="number"?de=O.scope:de=O.scope.uri:de=_.TaskScope.Workspace,!oe||!de?void 0:{_id:O._id,definition:oe,name:O.name,source:{extensionId:Z.identifier.value,label:O.source,scope:de},execution:ue,isBackground:O.isBackground,group:p.from(O.group),presentationOptions:d.from(O.presentationOptions),problemMatchers:O.problemMatchers,hasDefinedMatchers:O.hasDefinedMatchers,runOptions:O.runOptions?O.runOptions:{reevaluateOnRerun:!0},detail:O.detail}}U.from=K;async function W(O,Z,ue){if(O==null)return;let oe;i.is(O.execution)?oe=i.to(O.execution):a.is(O.execution)?oe=a.to(O.execution):o.is(O.execution)&&(oe=o.to(O._id,ue));const de=t.to(O.definition);let ie;if(O.source&&(O.source.scope!==void 0?typeof O.source.scope=="number"?ie=O.source.scope:ie=await Z.resolveWorkspaceFolder(r.URI.revive(O.source.scope)):ie=_.TaskScope.Workspace),!de||!ie)return;const ve=new _.Task(de,ie,O.name,O.source.label,oe,O.problemMatchers);return O.isBackground!==void 0&&(ve.isBackground=O.isBackground),O.group!==void 0&&(ve.group=_.TaskGroup.from(O.group._id),ve.group&&O.group.isDefault&&(ve.group=new _.TaskGroup(ve.group.id,ve.group.label),O.group.isDefault===!0&&(ve.group.isDefault=O.group.isDefault))),O.presentationOptions&&(ve.presentationOptions=d.to(O.presentationOptions)),O._id&&(ve._id=O._id),O.detail&&(ve.detail=O.detail),ve}U.to=W})(P=e.TaskDTO||(e.TaskDTO={}));var M;(function(U){function R(W){return W}U.from=R;function K(W){if(!!W)return Object.assign(Object.create(null),W)}U.to=K})(M=e.TaskFilterDTO||(e.TaskFilterDTO={}));class V{constructor(R,K,W){this._id=K,this._task=W,b.set(this,void 0),Je(this,b,R,"f")}get task(){return this._task}terminate(){Oe(this,b,"f").terminateTask(this)}fireDidStartProcess(R){}fireDidEndProcess(R){}}b=new WeakMap;var B;(function(U){function R(K){return{id:K._id,task:void 0}}U.from=R})(B=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let D=class{constructor(R,K,W,O,Z,ue,oe,de){this._onDidExecuteTask=new w.Emitter,this._onDidTerminateTask=new w.Emitter,this._onDidTaskProcessStarted=new w.Emitter,this._onDidTaskProcessEnded=new w.Emitter,this._proxy=R.getProxy(L.MainContext.MainThreadTask),this._workspaceProvider=W,this._editorService=O,this._configurationService=Z,this._terminalService=ue,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=oe,this._deprecationService=de,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(R,K,W){if(!W)return new _.Disposable(()=>{});const O=this.nextHandle();return this._handlers.set(O,{type:K,provider:W,extension:R}),this._proxy.$registerTaskProvider(O,K),new _.Disposable(()=>{this._handlers.delete(O),this._proxy.$unregisterTaskProvider(O)})}registerTaskSystem(R,K){this._proxy.$registerTaskSystem(R,K)}fetchTasks(R){return this._proxy.$fetchTasks(M.from(R)).then(async K=>{const W=[];for(const O of K){const Z=await P.to(O,this._workspaceProvider,this._providedCustomExecutions2);Z&&W.push(Z)}return W})}get taskExecutions(){const R=[];return this._taskExecutions.forEach(K=>R.push(K)),R}terminateTask(R){if(!(R instanceof V))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(R._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(R,K,W){const O=this._providedCustomExecutions2.get(R.id);O&&(this._activeCustomExecutions2.set(R.id,O),this._terminalService.attachPtyToTerminal(K,await O.callback(W))),this._lastStartedTask=R.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(R)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(R){const K=await this.getTaskExecution(R);this._taskExecutionPromises.delete(R.id),this._taskExecutions.delete(R.id),this.customExecutionComplete(R),this._onDidTerminateTask.fire({execution:K})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(R){const K=await this.getTaskExecution(R.id);this._onDidTaskProcessStarted.fire({execution:K,processId:R.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(R){const K=await this.getTaskExecution(R.id);this._onDidTaskProcessEnded.fire({execution:K,exitCode:R.exitCode})}$provideTasks(R,K){const W=this._handlers.get(R);if(!W)return Promise.reject(new Error("no handler found"));const O=[],Z=(0,y.asPromise)(()=>W.provider.provideTasks(F.CancellationToken.None)).then(ue=>this.provideTasksInternal(K,O,W,ue));return new Promise(ue=>{Z.then(oe=>{Promise.all(O).then(()=>{ue(oe)})})})}async $resolveTask(R,K){const W=this._handlers.get(R);if(!W)return Promise.reject(new Error("no handler found"));if(K.definition.type!==W.type)throw new Error(`Unexpected: Task of type [${K.definition.type}] cannot be resolved by provider of type [${W.type}].`);const O=await P.to(K,this._workspaceProvider,this._providedCustomExecutions2);if(!O)throw new Error("Unexpected: Task cannot be resolved.");const Z=await W.provider.resolveTask(O,F.CancellationToken.None);if(!Z)return;this.checkDeprecation(Z,W);const ue=P.from(Z,W.extension);if(!ue)throw new Error("Unexpected: Task cannot be resolved.");if(Z.definition!==O.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return o.is(ue.execution)&&await this.addCustomExecution(ue,Z,!0),await this.resolveTaskInternal(ue)}nextHandle(){return this._handleCounter++}async addCustomExecution(R,K,W){const O=await this._proxy.$createTaskId(R);!W&&!this._providedCustomExecutions2.has(O)&&(this._notProvidedCustomExecutions.add(O),this._activeCustomExecutions2.set(O,K.execution)),this._providedCustomExecutions2.set(O,K.execution)}async getTaskExecution(R,K){if(typeof R=="string"){const Z=this._taskExecutionPromises.get(R);if(!Z)throw new Error("Unexpected: The specified task is missing an execution");return Z}const W=this._taskExecutionPromises.get(R.id);if(W)return W;const O=new Promise((Z,ue)=>{function oe(de,ie,ve){ve?Z(new V(de,ie.id,ve)):ue("Unexpected: Task does not exist.")}K?oe(this,R,K):P.to(R.task,this._workspaceProvider,this._providedCustomExecutions2).then(de=>oe(this,R,de))});return this._taskExecutionPromises.set(R.id,O),O.then(Z=>(this._taskExecutions.set(R.id,Z),Z),Z=>Promise.reject(Z))}checkDeprecation(R,K){R._deprecated&&this._deprecationService.report("Task.constructor",K.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(R){this._activeCustomExecutions2.get(R.id)&&this._activeCustomExecutions2.delete(R.id),this._notProvidedCustomExecutions.has(R.id)&&this._lastStartedTask!==R.id&&(this._providedCustomExecutions2.delete(R.id),this._notProvidedCustomExecutions.delete(R.id));const W=this._notProvidedCustomExecutions.values();let O=W.next();for(;!O.done;)!this._activeCustomExecutions2.has(O.value)&&this._lastStartedTask!==O.value&&(this._providedCustomExecutions2.delete(O.value),this._notProvidedCustomExecutions.delete(O.value)),O=W.next()}};D=ze([xe(0,m.IExtHostRpcService),xe(1,T.IExtHostInitDataService),xe(2,A.IExtHostWorkspace),xe(3,E.IExtHostDocumentsAndEditors),xe(4,k.IExtHostConfiguration),xe(5,S.IExtHostTerminalService),xe(6,u.ILogService),xe(7,v.IExtHostApiDeprecationService)],D),e.ExtHostTaskBase=D;let x=class extends D{constructor(R,K,W,O,Z,ue,oe,de){super(R,K,W,O,Z,ue,oe,de),this.registerTaskSystem(c.Schemas.vscodeRemote,{scheme:c.Schemas.vscodeRemote,authority:"",platform:h.PlatformToString(0)})}async executeTask(R,K){if(!K.execution)throw new Error("Tasks to execute must include an execution");const W=P.from(K,R);if(W===void 0)throw new Error("Task is not valid");if(o.is(W.execution))await this.addCustomExecution(W,K,!1);else throw new l.NotSupportedError;const O=await this.getTaskExecution(await this._proxy.$getTaskExecution(W),K);return this._proxy.$executeTask(W).catch(Z=>{throw new Error(Z)}),O}provideTasksInternal(R,K,W,O){const Z=[];if(O)for(const ue of O){this.checkDeprecation(ue,W),(!ue.definition||!R[ue.definition.type])&&this._logService.warn(`The task [${ue.source}, ${ue.name}] uses an undefined task type. The task will be ignored in the future.`);const oe=P.from(ue,W.extension);oe&&o.is(oe.execution)?(Z.push(oe),K.push(this.addCustomExecution(oe,ue,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:Z,extension:W.extension}}async resolveTaskInternal(R){if(o.is(R.execution))return R;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(R,K){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(R,K,W){}};x=ze([xe(0,m.IExtHostRpcService),xe(1,T.IExtHostInitDataService),xe(2,A.IExtHostWorkspace),xe(3,E.IExtHostDocumentsAndEditors),xe(4,k.IExtHostConfiguration),xe(5,S.IExtHostTerminalService),xe(6,u.ILogService),xe(7,v.IExtHostApiDeprecationService)],x),e.WorkerExtHostTask=x,e.IExtHostTask=(0,f.createDecorator)("IExtHostTask")}),define(Ce[227],Ie([1,0,19,20,43,34,22,202,41]),function(te,e,r,y,w,L,_,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(m,T,f){this.config=m,this.provider=T,this.sessionToken=f,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=m.filePattern,this.includePattern=m.includePattern&&L.parse(m.includePattern),this.maxResults=m.maxResults||void 0,this.exists=m.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=m.excludePattern&&L.parse(m.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(m=>m.cancel()),this.activeCancellationTokens=new Set}search(m){const T=this.config.folderQueries||[];return new Promise((f,c)=>{const h=u=>{this.resultCount++,m(u)};if(this.isCanceled)return f({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(u=>{const v=u.toString(),I=r.basename(v);this.globalExcludePattern&&this.globalExcludePattern(v,I)||this.matchFile(h,{base:u,basename:I})}),Promise.all(T.map(u=>this.searchInFolder(u,h))).then(u=>{f({limitHit:this.isLimitHit,stats:u[0]||void 0})},u=>{c(new Error((0,w.toErrorMessage)(u)))})})}async searchInFolder(m,T){const f=new y.CancellationTokenSource,c=this.getSearchOptionsForFolder(m),h=this.initDirectoryTree(),u=new E.QueryGlobTester(this.config,m),v=!u.hasSiblingExcludeClauses();let I;try{this.activeCancellationTokens.add(f),I=A.StopWatch.create();const l=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},c,f.token),b=I.elapsed(),t=A.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(l&&l.forEach(d=>{const n=r.posix.relative(m.folder.path,d.path);if(v){const i=r.basename(d.path);this.matchFile(T,{base:m.folder,relativePath:n,basename:i});return}this.addDirectoryEntries(h,m.folder,n,T)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(h,u,T),{providerTime:b,postProcessTime:t.elapsed()})}finally{f.dispose(),this.activeCancellationTokens.delete(f)}}getSearchOptionsForFolder(m){const T=(0,E.resolvePatternsForProvider)(this.config.includePattern,m.includePattern),f=(0,E.resolvePatternsForProvider)(this.config.excludePattern,m.excludePattern);return{folder:m.folder,excludes:f,includes:T,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const m={rootEntries:[],pathToEntries:Object.create(null)};return m.pathToEntries["."]=m.rootEntries,m}addDirectoryEntries({pathToEntries:m},T,f,c){if(f===this.filePattern){const u=r.basename(this.filePattern);this.matchFile(c,{base:T,relativePath:this.filePattern,basename:u})}function h(u){const v=r.basename(u),I=r.dirname(u);let l=m[I];l||(l=m[I]=[],h(I)),l.push({base:T,relativePath:u,basename:v})}h(f)}matchDirectoryTree({rootEntries:m,pathToEntries:T},f,c){const h=this,u=this.filePattern;function v(I){const l=(0,E.hasSiblingFn)(()=>I.map(b=>b.basename));for(let b=0,t=I.length;b<t;b++){const d=I[b],{relativePath:n,basename:i}=d;if(f.matchesExcludesSync(n,i,u!==i?l:void 0))continue;const s=T[n];if(s)v(s);else{if(n===u)continue;h.matchFile(c,d)}if(h.isLimitHit)break}}v(m)}matchFile(m,T){(!this.includePattern||T.relativePath&&this.includePattern(T.relativePath,T.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||m(T))}}class F{constructor(){this.sessions=new Map}fileSearch(m,T,f,c){const h=this.getSessionTokenSource(m.cacheKey),u=new k(m,T,h&&h.token);let v=0;const I=l=>{v+=l.length,f(l.map(b=>this.rawMatchToSearchItem(b)))};return this.doSearch(u,F.BATCH_SIZE,I,c).then(l=>({limitHit:l.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:v,detailStats:l.stats}}))}clearCache(m){this.getSessionTokenSource(m)?.cancel()}getSessionTokenSource(m){if(!!m)return this.sessions.has(m)||this.sessions.set(m,new y.CancellationTokenSource),this.sessions.get(m)}rawMatchToSearchItem(m){return m.relativePath?{resource:_.joinPath(m.base,m.relativePath)}:{resource:m.base}}doSearch(m,T,f,c){c.onCancellationRequested(()=>{m.cancel()});const h=v=>{v&&(u.push(v),T>0&&u.length>=T&&(f(u),u=[]))};let u=[];return m.search(h).then(v=>(u.length&&f(u),v),v=>(u.length&&f(u),Promise.reject(v)))}}e.FileSearchManager=F,F.BATCH_SIZE=512}),define(Ce[228],Ie([1,0,16,72,34,77,25,12,19,22,9,10,2,245,143,57,15,45,90,226,41]),function(te,e,r,y,w,L,_,A,E,k,F,S,m,T,f,c,h,u,v,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let b=class{constructor(p,P,M,V,B){this.configurationService=p,this.workspaceContextService=P,this.editorGroupsService=M,this.logService=V,this.pathService=B}text(p,P,M={}){p=this.getContentPattern(p,M);const V=this.configurationService.getValue(),B=P&&P.some(x=>!this.configurationService.getValue({resource:x}).search.useRipgrep);return{...this.commonQuery(P?.map(u.toWorkspaceFolder),M),type:2,contentPattern:p,previewOptions:M.previewOptions,maxFileSize:M.maxFileSize,usePCRE2:V.search.usePCRE2||B||!1,beforeContext:M.beforeContext,afterContext:M.afterContext,userDisabledExcludesAndIgnoreFiles:M.disregardExcludeSettings&&M.disregardIgnoreFiles}}getContentPattern(p,P){const M=this.configurationService.getValue();p.isRegExp&&(p.pattern=p.pattern.replace(/\r?\n/g,"\\n"));const V={...p,wordSeparators:M.editor.wordSeparators};return this.isCaseSensitive(p,P)&&(V.isCaseSensitive=!0),this.isMultiline(p)&&(V.isMultiline=!0),V}file(p,P={}){return{...this.commonQuery(p,P),type:1,filePattern:P.filePattern?P.filePattern.trim():P.filePattern,exists:P.exists,sortByScore:P.sortByScore,cacheKey:P.cacheKey}}handleIncludeExclude(p,P){return p?(p=Array.isArray(p)?p.map(s):s(p),P?this.parseSearchPaths(p):{pattern:d(...Array.isArray(p)?p:[p])}):{}}commonQuery(p=[],P={}){const M=this.handleIncludeExclude(P.includePattern,P.expandPatterns),V=this.handleIncludeExclude(P.excludePattern,P.expandPatterns),B=p.length>1,D=(M.searchPaths&&M.searchPaths.length?M.searchPaths.map(R=>this.getFolderQueryForSearchPath(R,P,V)):p.map(R=>this.getFolderQueryForRoot(R,P,V,B))).filter(R=>!!R),x={_reason:P._reason,folderQueries:D,usingSearchPaths:!!(M.searchPaths&&M.searchPaths.length),extraFileResources:P.extraFileResources,excludePattern:V.pattern,includePattern:M.pattern,onlyOpenEditors:P.onlyOpenEditors,maxResults:P.maxResults};if(P.onlyOpenEditors){const R=r.coalesce(r.flatten(this.editorGroupsService.groups.map(O=>O.editors.map(Z=>Z.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(R));const K=R.filter(O=>(0,l.pathIncludedInQuery)(x,O.fsPath)),W=this.commonQueryFromFileList(K);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(W)),{...x,...W}}const U=P.extraFileResources&&P.extraFileResources.filter(R=>(0,l.pathIncludedInQuery)(x,R.fsPath));return x.extraFileResources=U&&U.length?U:void 0,x}commonQueryFromFileList(p){const P=[],M=new _.ResourceMap,V={};let B=!1;return p.forEach(D=>{if(D.scheme===A.Schemas.walkThrough)return;if((0,k.isAbsolutePath)(D)){const U=this.workspaceContextService.getWorkspaceFolder(D)?.uri??D.with({path:E.dirname(D.fsPath)});let R=M.get(U);R||(B=!0,R={folder:U,includePattern:{}},P.push(R),M.set(U,R));const K=E.relative(U.fsPath,D.fsPath);(0,S.assertIsDefined)(R.includePattern)[K.replace(/\\/g,"/")]=!0}else D.fsPath&&(B=!0,V[D.fsPath]=!0)}),{folderQueries:P,includePattern:V,usingSearchPaths:!0,excludePattern:B?void 0:{"**/*":!0}}}isCaseSensitive(p,P){if(P.isSmartCase){if(p.isRegExp){if(F.containsUppercaseCharacter(p.pattern,!0))return!0}else if(F.containsUppercaseCharacter(p.pattern))return!0}return!!p.isCaseSensitive}isMultiline(p){return p.isMultiline||p.isRegExp&&(0,T.isMultilineRegexSource)(p.pattern)||p.pattern.indexOf(`
`)>=0?!0:!!p.isMultiline}parseSearchPaths(p){const P=W=>E.isAbsolute(W)||/^\.\.?([\/\\]|$)/.test(W),V=(Array.isArray(p)?p:n(p)).map(W=>{const O=this.pathService.resolvedUserHome;return O?(0,L.untildify)(W,O.scheme===A.Schemas.file?O.fsPath:O.path):W}),B=y.groupBy(V,W=>P(W)?"searchPaths":"exprSegments"),D=(B.exprSegments||[]).map(W=>F.rtrim(W,"/")).map(W=>F.rtrim(W,"\\")).map(W=>(W[0]==="."&&(W="*"+W),i(W))),x={},U=this.expandSearchPathPatterns(B.searchPaths||[]);U&&U.length&&(x.searchPaths=U);const R=r.flatten(D),K=d(...R);return K&&(x.pattern=K),x}getExcludesForFolder(p,P){return P.disregardExcludeSettings?void 0:(0,l.getExcludes)(p,!P.disregardSearchExcludeSettings)}expandSearchPathPatterns(p){if(!p||!p.length)return[];const P=r.flatten(p.map(V=>{let{pathPortion:B,globPortion:D}=t(V);D&&(D=a(D));const x=this.expandOneSearchPath(B);return r.flatten(x.map(U=>this.resolveOneSearchPathPattern(U,D)))})),M=new Map;return P.forEach(V=>{const B=V.searchPath.toString(),D=M.get(B);D?V.pattern&&(D.pattern=D.pattern||{},D.pattern[V.pattern]=!0):M.set(B,{searchPath:V.searchPath,pattern:V.pattern?d(V.pattern):void 0})}),Array.from(M.values())}expandOneSearchPath(p){if(E.isAbsolute(p)){const P=this.workspaceContextService.getWorkspace().folders;return P[0]&&P[0].uri.scheme!==A.Schemas.file?[{searchPath:P[0].uri.with({path:p})}]:[{searchPath:m.URI.file(E.normalize(p))}]}if(this.workspaceContextService.getWorkbenchState()===2){const P=this.workspaceContextService.getWorkspace().folders[0].uri;if(p=s(p),p.startsWith("../")||p===".."){const V=E.posix.resolve(P.path,p);return[{searchPath:P.with({path:V})}]}const M=a(p);return[{searchPath:P,pattern:M}]}else{if(p==="./"||p===".\\")return[];{const P=p.replace(/^\.[\/\\]/,""),V=this.workspaceContextService.getWorkspace().folders.map(B=>{const D=P.match(new RegExp(`^${F.escapeRegExpCharacters(B.name)}(?:/(.*)|$)`));return D?{match:D,folder:B}:null}).filter(S.isDefined);if(V.length)return V.map(B=>{const D=B.match[1];return{searchPath:B.folder.uri,pattern:D&&a(D)}});{const B=p.match(/\.[\/\\](.+)[\/\\]?/),D=B?B[1]:p,x=f.localize(0,null,D);throw new Error(x)}}}}resolveOneSearchPathPattern(p,P){const M=p.pattern&&P?`${p.pattern}/${P}`:p.pattern||P,V=[{searchPath:p.searchPath,pattern:M}];return M&&!M.endsWith("**")&&V.push({searchPath:p.searchPath,pattern:M+"/**"}),V}getFolderQueryForSearchPath(p,P,M){const V=this.getFolderQueryForRoot((0,u.toWorkspaceFolder)(p.searchPath),P,M,!1);return V?{...V,includePattern:p.pattern}:null}getFolderQueryForRoot(p,P,M,V){let B;const D=m.URI.isUri(p)?p:p.uri;if(M.searchPaths){const W=M.searchPaths.filter(O=>(0,k.isEqual)(O.searchPath,D))[0];if(W&&!W.pattern)return null;W&&(B=W.pattern)}const x=this.configurationService.getValue({resource:D}),R={...this.getExcludesForFolder(x,P)||{},...B||{}},K=m.URI.isUri(p)?(0,k.basename)(p):p.name;return{folder:D,folderName:V?K:void 0,excludePattern:Object.keys(R).length>0?R:void 0,fileEncoding:x.files&&x.files.encoding,disregardIgnoreFiles:typeof P.disregardIgnoreFiles=="boolean"?P.disregardIgnoreFiles:!x.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof P.disregardGlobalIgnoreFiles=="boolean"?P.disregardGlobalIgnoreFiles:!x.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof P.disregardParentIgnoreFiles=="boolean"?P.disregardParentIgnoreFiles:!x.search.useParentIgnoreFiles,ignoreSymlinks:typeof P.ignoreSymlinks=="boolean"?P.ignoreSymlinks:!x.search.followSymlinks}}};b=ze([xe(0,c.IConfigurationService),xe(1,u.IWorkspaceContextService),xe(2,v.IEditorGroupsService),xe(3,h.ILogService),xe(4,I.IPathService)],b),e.QueryBuilder=b;function t(g){const p=g.match(/[\*\{\}\(\)\[\]\?]/);if(p){const P=p.index,M=g.substr(0,P).match(/[/|\\][^/\\]*$/);if(M){let V=g.substr(0,M.index);return V.match(/[/\\]/)||(V+="/"),{pathPortion:V,globPortion:g.substr((M.index||0)+1)}}}return{pathPortion:g}}function d(...g){return g.length?g.reduce((p,P)=>(p[P]=!0,p),Object.create(null)):void 0}function n(g){return w.splitGlobAware(g,",").map(p=>p.trim()).filter(p=>!!p.length)}function i(g){return[`**/${g}/**`,`**/${g}`].map(P=>P.replace(/\*\*\/\*\*/g,"**"))}function s(g){return g.replace(/\\/g,"/")}function a(g){return s(g).replace(/^\.\//,"").replace(/\/+$/g,"")}function o(g,p){g=r.distinct(g,V=>V.toString());const P=[],M=p.getWorkspace();return g&&g.forEach(V=>{let B;if(p.getWorkbenchState()===2)B=(0,k.relativePath)(M.folders[0].uri,V),B&&B!=="."&&(B="./"+B);else{const D=p.getWorkspaceFolder(V);if(D){const x=D.name;if(M.folders.filter(R=>R.name===x).length===1){const R=(0,k.relativePath)(D.uri,V);R===""?B=`./${D.name}`:B=`./${D.name}/${R}`}else B=V.fsPath}}B&&P.push(B)}),P}e.resolveResourcesForSearchIncludes=o}),define(Ce[229],Ie([1,0,22,2,20,11,3,228,41,45]),function(te,e,r,y,w,L,_,A,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const F=7e3;function S(c,h){const u=h.activationEvents;if(!u)return Promise.resolve(void 0);const v=[],I=[];for(const i of u)if(/^workspaceContains:/.test(i)){const s=i.substr(18);s.indexOf("*")>=0||s.indexOf("?")>=0||c.forceUsingSearch?I.push(s):v.push(s)}if(v.length===0&&I.length===0)return Promise.resolve(void 0);let l;const b=new Promise((i,s)=>{l=i}),t=i=>l({activationEvent:i}),d=Promise.all(v.map(i=>m(c,i,t))).then(()=>{}),n=T(c,h.identifier,I,t);return Promise.all([d,n]).then(()=>{l(void 0)}),b}e.checkActivateWorkspaceContainsExtension=S;async function m(c,h,u){for(const v of c.folders)if(await c.exists(r.joinPath(y.URI.revive(v),h))){u(`workspaceContains:${h}`);return}}async function T(c,h,u,v){if(u.length===0)return Promise.resolve(void 0);const I=new w.CancellationTokenSource,l=c.checkExists(c.folders,u,I.token),b=setTimeout(async()=>{I.cancel(),c.logService.info(`Not activating extension '${h.value}': Timed out while searching for 'workspaceContains' pattern ${u.join(",")}`)},F);let t=!1;try{t=await l}catch(d){L.isCancellationError(d)||L.onUnexpectedError(d)}I.dispose(),clearTimeout(b),t&&v(`workspaceContains:${u.join(",")}`)}function f(c,h,u,v){const I=c.get(_.IInstantiationService),l=c.get(E.ISearchService),t=I.createInstance(A.QueryBuilder).file(h.map(d=>(0,k.toWorkspaceFolder)(y.URI.revive(d))),{_reason:"checkExists",includePattern:u,exists:!0});return l.fileSearch(t,v).then(d=>!!d.limitHit,d=>L.isCancellationError(d)?!1:Promise.reject(d))}e.checkGlobFileExists=f});var Je=this&&this.__classPrivateFieldSet||function(te,e,r,y,w){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!w:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?w.call(te,r):w?w.value=r:e.set(te,r),r},Oe=this&&this.__classPrivateFieldGet||function(te,e,r,y){if(r==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?y:r==="a"?y.call(te):y?y.value:e.get(te)};define(Ce[33],Ie([1,0,130,19,71,22,14,7,25,2,15,4,32,173,69,31,24,172,11,27,23,157,6,85,3,28,70,13,58,62,53,5,229,68,159,12]),function(te,e,r,y,w,L,_,A,E,k,F,S,m,T,f,c,h,u,v,I,l,b,t,d,n,i,s,a,o,g,p,P,M,V,B,D){"use strict";var x,U,R;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,n.createDecorator)("IHostUtils");let K=class Ai extends A.Disposable{constructor(ie,ve,be,ne,Ee,Pe,Fe,$e,Qe,Te){super(),this._onDidChangeRemoteConnectionData=this._register(new P.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=ve,this._extHostContext=be,this._initData=Fe,this._extHostWorkspace=ne,this._extHostConfiguration=Ee,this._logService=Pe,this._extHostTunnelService=Qe,this._extHostTerminalService=Te,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(S.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(S.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(S.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new _.Barrier,this._readyToStartExtensionHost=new _.Barrier,this._readyToRunExtensions=new _.Barrier,this._eagerExtensionsActivated=new _.Barrier,this._globalRegistry=new u.ExtensionDescriptionRegistry(this._initData.allExtensions);const _e=(0,h.extensionIdentifiersArrayToSet)(this._initData.myExtensions);this._myRegistry=new u.ExtensionDescriptionRegistry(Z(this._globalRegistry,_e)),this._storage=new f.ExtHostStorage(this._extHostContext),this._secretState=new V.ExtHostSecretState(this._extHostContext),this._storagePath=$e,this._instaService=ie.createChild(new o.ServiceCollection([f.IExtHostStorage,this._storage],[V.IExtHostSecretState,this._secretState]));let ye=[],ae=[];this._initData.remote.isRemote&&(ye=this._initData.allExtensions.filter(Q=>!Q.main&&!Q.browser).map(Q=>Q.identifier),ae=this._initData.allExtensions.filter(Q=>!_e.has(I.ExtensionIdentifier.toKey(Q.identifier.value))).filter(Q=>(Q.main||Q.browser)&&Q.api==="none").map(Q=>Q.identifier));const le=(0,h.extensionIdentifiersArrayToSet)(ae);this._activator=this._register(new T.ExtensionsActivator(this._myRegistry,ye,ae,{onExtensionActivationError:(Q,J,C)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Q,v.transformErrorForSerialization(J),C)},actualActivateExtension:async(Q,J)=>{if(le.has(I.ExtensionIdentifier.toKey(Q)))return await this._mainThreadExtensionsProxy.$activateExtension(Q,J),new T.HostExtension;const C=this._myRegistry.getExtensionDescription(Q);return this._activateExtension(C,J)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),w.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(ie){v.onUnexpectedError(ie)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let ie=[];try{ie=this._myRegistry.getAllExtensionDescriptions().map(Ee=>Ee.identifier).filter(Ee=>this.isActivated(Ee)).map(Ee=>this._deactivate(Ee))}catch{}await Promise.all(ie)}terminate(ie,ve=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${ie}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),v.setUnexpectedErrorHandler(ne=>{this._logService.error(ne)}),this._extHostContext.dispose();const be=this._deactivateAll();Promise.race([(0,_.timeout)(5e3),be]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${ve}`):this._logService.info(`Extension host exiting with code ${ve}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(ve)})}isActivated(ie){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(ie):!1}async getExtension(ie){const ve=await this._mainThreadExtensionsProxy.$getExtension(ie);let be;if(ve?.browserNlsBundleUris){be={};for(const ne of Object.keys(ve.browserNlsBundleUris))be[ne]=k.URI.revive(ve.browserNlsBundleUris[ne])}return ve&&{...ve,identifier:new I.ExtensionIdentifier(ve.identifier.value),extensionLocation:k.URI.revive(ve.extensionLocation),browserNlsBundleUris:be}}_activateByEvent(ie,ve){return this._activator.activateByEvent(ie,ve)}_activateById(ie,ve){return this._activator.activateById(ie,ve)}activateByIdWithErrors(ie,ve){return this._activateById(ie,ve).then(()=>{const be=this._activator.getActivatedExtension(ie);if(be.activationFailed)return Promise.reject(be.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(ie=>this._myRegistry)}getExtensionExports(ie){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(ie).exports:null}async _realPathExtensionUri(ie){if(ie.scheme!==D.Schemas.file)return ie;const ve=await this._hostUtils.realpath(ie.fsPath);return k.URI.file(ve)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(ie=>new oe(ie))),this._extensionPathIndex}async _createExtensionPathIndex(ie){const ve=E.TernarySearchTree.forUris(be=>L.extUriBiasedIgnorePathCase.ignorePathCasing(be));return await Promise.all(ie.map(async be=>{if(this._getEntryPoint(be)){const ne=await this._realPathExtensionUri(be.extensionLocation);ve.set(ne,be)}})),ve}_deactivate(ie){let ve=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(ie))return ve;const be=this._activator.getActivatedExtension(ie);if(!be)return ve;try{typeof be.module.deactivate=="function"&&(ve=Promise.resolve(be.module.deactivate()).then(void 0,ne=>(this._logService.error(ne),Promise.resolve(void 0))))}catch(ne){this._logService.error(`An error occurred when deactivating the extension '${ie.value}':`),this._logService.error(ne)}try{(0,A.dispose)(be.subscriptions)}catch(ne){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${ie.value}':`),this._logService.error(ne)}return ve}async _activateExtension(ie,ve){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(ie.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(ie.identifier),this._doActivateExtension(ie,ve).then(be=>{const ne=be.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(ie.identifier,ne.codeLoadingTime,ne.activateCallTime,ne.activateResolvedTime,ve),this._logExtensionActivationTimes(ie,ve,"success",ne),be},be=>{throw this._logExtensionActivationTimes(ie,ve,"failure"),be})}_logExtensionActivationTimes(ie,ve,be,ne){const Ee=W(ie,ve);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Ee,...ne||{},outcome:be})}_doActivateExtension(ie,ve){const be=W(ie,ve);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",be);const ne=this._getEntryPoint(ie);if(!ne)return Promise.resolve(new T.EmptyExtension(T.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${ie.identifier.value}, startup: ${ve.startup}, activationEvent: '${ve.activationEvent}'${ie.identifier.value!==ve.extensionId.value?`, root cause: ${ve.extensionId.value}`:""}`),this._logService.flush();const Ee=new T.ExtensionActivationTimesBuilder(ve.startup);return Promise.all([this._loadCommonJSModule(ie,(0,L.joinPath)(ie.extensionLocation,ne),Ee),this._loadExtensionContext(ie)]).then(Pe=>(w.mark(`code/extHost/willActivateExtension/${ie.identifier.value}`),Ai._callActivate(this._logService,ie.identifier,Pe[0],Pe[1],Ee))).then(Pe=>(w.mark(`code/extHost/didActivateExtension/${ie.identifier.value}`),Pe))}_loadExtensionContext(ie){const ve=new b.ExtensionGlobalMemento(ie,this._storage),be=new b.ExtensionMemento(ie.identifier.value,!1,this._storage),ne=new B.ExtensionSecrets(ie,this._secretState),Ee=ie.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,Pe=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${ie.identifier.value}`),Promise.all([ve.whenReady,be.whenReady,this._storagePath.whenReady]).then(()=>{const Fe=this;let $e,Qe;const Te=(0,h.isProposedApiEnabled)(ie,"ipc")?this._initData.messagePorts?.get(I.ExtensionIdentifier.toKey(ie.identifier)):void 0;return Object.freeze({globalState:ve,workspaceState:be,secrets:ne,subscriptions:[],get extensionUri(){return ie.extensionLocation},get extensionPath(){return ie.extensionLocation.fsPath},asAbsolutePath(_e){return y.join(ie.extensionLocation.fsPath,_e)},get storagePath(){return Fe._storagePath.workspaceValue(ie)?.fsPath},get globalStoragePath(){return Fe._storagePath.globalValue(ie).fsPath},get logPath(){return y.join(Fe._initData.logsLocation.fsPath,ie.identifier.value)},get logUri(){return k.URI.joinPath(Fe._initData.logsLocation,ie.identifier.value)},get storageUri(){return Fe._storagePath.workspaceValue(ie)},get globalStorageUri(){return Fe._storagePath.globalValue(ie)},get extensionMode(){return Ee},get extension(){return $e===void 0&&($e=new O(Fe,ie.identifier,ie,Pe,!1)),$e},get extensionRuntime(){return(0,h.checkProposedApiEnabled)(ie,"extensionRuntime"),Fe.extensionRuntime},get environmentVariableCollection(){return Fe._extHostTerminalService.getEnvironmentVariableCollection(ie)},get messagePassingProtocol(){if(!Qe){if(!Te)return;const _e=P.Event.buffer(P.Event.fromDOMEventEmitter(Te,"message",ye=>ye.data));Te.start(),Qe={onDidReceiveMessage:_e,postMessage:Te.postMessage.bind(Te)}}return Qe}})})}static _callActivate(ie,ve,be,ne,Ee){return be=be||{activate:void 0,deactivate:void 0},this._callActivateOptional(ie,ve,be,ne,Ee).then(Pe=>new T.ActivatedExtension(!1,null,Ee.build(),be,Pe,ne.subscriptions))}static _callActivateOptional(ie,ve,be,ne,Ee){if(typeof be.activate=="function")try{Ee.activateCallStart(),ie.trace(`ExtensionService#_callActivateOptional ${ve.value}`);const Pe=typeof global=="object"?global:self,Fe=be.activate.apply(Pe,[ne]);return Ee.activateCallStop(),Ee.activateResolveStart(),Promise.resolve(Fe).then($e=>(Ee.activateResolveStop(),$e))}catch(Pe){return Promise.reject(Pe)}else return Promise.resolve(be)}_activateOneStartupFinished(ie,ve){this._activateById(ie.identifier,{startup:!1,extensionId:ie.identifier,activationEvent:ve}).then(void 0,be=>{this._logService.error(be)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(w.getMarks());for(const ie of this._myRegistry.getAllExtensionDescriptions())if(ie.activationEvents)for(const ve of ie.activationEvents)ve==="onStartupFinished"&&this._activateOneStartupFinished(ie,ve)}_handleEagerExtensions(){const ie=this._activateByEvent("*",!0).then(void 0,Ee=>{this._logService.error(Ee)});this._register(this._extHostWorkspace.onDidChangeWorkspace(Ee=>this._handleWorkspaceContainsEagerExtensions(Ee.added)));const ve=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],be=this._handleWorkspaceContainsEagerExtensions(ve),ne=Promise.all([ie,be]).then(()=>{});return Promise.race([ne,(0,_.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),ne}_handleWorkspaceContainsEagerExtensions(ie){return ie.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(ve=>this._handleWorkspaceContainsEagerExtension(ie,ve))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(ie,ve){if(this.isActivated(ve.identifier))return;const be=!this._initData.remote.isRemote&&!!this._initData.remote.authority,ne={logService:this._logService,folders:ie.map(Pe=>Pe.uri),forceUsingSearch:be,exists:Pe=>this._hostUtils.exists(Pe.fsPath),checkExists:(Pe,Fe,$e)=>this._mainThreadWorkspaceProxy.$checkExists(Pe,Fe,$e)},Ee=await(0,M.checkActivateWorkspaceContainsExtension)(ne,ve);if(!!Ee)return this._activateById(ve.identifier,{startup:!0,extensionId:ve.identifier,activationEvent:Ee.activationEvent}).then(void 0,Pe=>this._logService.error(Pe))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(ie){throw console.error(ie),ie}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:ie,extensionTestsLocationURI:ve}=this._initData.environment;if(!ie||!ve)throw new Error(r.localize(0,null));const be=await this._loadCommonJSModule(null,ve,new T.ExtensionActivationTimesBuilder(!1));if(!be||typeof be.run!="function")throw new Error(r.localize(1,null,ve.toString()));return new Promise((ne,Ee)=>{const Pe=(Qe,Te)=>{Qe?Ee(Qe):ne(typeof Te=="number"&&Te>0?1:0)},Fe=(0,L.originalFSPath)(ve),$e=be.run(Fe,Pe);$e&&$e.then&&$e.then(()=>{ne(0)}).catch(Qe=>{Ee(Qe instanceof Error&&Qe.stack?Qe.stack:String(Qe))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(ie,ve){return this._resolvers[ie]=ve,(0,A.toDisposable)(()=>{delete this._resolvers[ie]})}async _activateAndGetResolver(ie){const ve=ie.indexOf("+");if(ve===-1)throw new Error("Not an authority that can be resolved!");const be=ie.substr(0,ve);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${be}`,!1),{authorityPrefix:be,resolver:this._resolvers[be]}}async $resolveAuthority(ie,ve){this._logService.info(`$resolveAuthority invoked for authority (${ue(ie)})`);const{authorityPrefix:be,resolver:ne}=await this._activateAndGetResolver(ie);if(!ne)return{type:"error",error:{code:d.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${be}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(ne)),w.mark(`code/extHost/willResolveAuthority/${be}`);const Ee=await ne.resolve(ie,{resolveAttempt:ve});w.mark(`code/extHost/didResolveAuthorityOK/${be}`);const Pe={authority:ie,host:Ee.host,port:Ee.port,connectionToken:Ee.connectionToken},Fe={extensionHostEnv:Ee.extensionHostEnv,isTrusted:Ee.isTrusted,authenticationSession:Ee.authenticationSessionForInitializingExtensions?{id:Ee.authenticationSessionForInitializingExtensions.id,providerId:Ee.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Pe,options:Fe,tunnelInformation:{environmentTunnels:Ee.environmentTunnels,features:Ee.tunnelFeatures}}}}catch(Ee){if(w.mark(`code/extHost/didResolveAuthorityError/${be}`),Ee instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:Ee._code,message:Ee._message,detail:Ee._detail}};throw Ee}}async $getCanonicalURI(ie,ve){this._logService.info(`$getCanonicalURI invoked for authority (${ue(ie)})`);const{resolver:be}=await this._activateAndGetResolver(ie);if(!be)return null;const ne=k.URI.revive(ve);if(typeof be.getCanonicalURI>"u")return ne;const Ee=await(0,_.asPromise)(()=>be.getCanonicalURI(ne));return Ee||ne}static _applyExtensionsDelta(ie,ve,be){const ne=new u.ExtensionDescriptionRegistry(ie.getAllExtensionDescriptions());ne.deltaExtensions(be.toAdd,be.toRemove);const Ee=(0,h.extensionIdentifiersArrayToSet)(ve.getAllExtensionDescriptions().map(Fe=>Fe.identifier));for(const Fe of be.myToRemove)Ee.delete(I.ExtensionIdentifier.toKey(Fe));for(const Fe of be.myToAdd)Ee.add(I.ExtensionIdentifier.toKey(Fe));const Pe=Z(ne,Ee);return{globalRegistry:ne,myExtensions:Pe}}$startExtensionHost(ie){ie.toAdd.forEach(ne=>ne.extensionLocation=k.URI.revive(ne.extensionLocation));const{globalRegistry:ve,myExtensions:be}=Ai._applyExtensionsDelta(this._globalRegistry,this._myRegistry,ie);return this._globalRegistry.set(ve.getAllExtensionDescriptions()),this._myRegistry.set(be),this._startExtensionHost()}$activateByEvent(ie,ve){return ve===1?this._activateByEvent(ie,!1):this._readyToRunExtensions.wait().then(be=>this._activateByEvent(ie,!1))}async $activate(ie,ve){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(ie)?(await this._activateById(ie,ve),!0):!1}async $deltaExtensions(ie){ie.toAdd.forEach(Pe=>Pe.extensionLocation=k.URI.revive(Pe.extensionLocation));const{globalRegistry:ve,myExtensions:be}=Ai._applyExtensionsDelta(this._globalRegistry,this._myRegistry,ie),ne=await this._createExtensionPathIndex(be);return(await this.getExtensionPathIndex()).setSearchTree(ne),this._globalRegistry.set(ve.getAllExtensionDescriptions()),this._myRegistry.set(be),Promise.resolve(void 0)}async $test_latency(ie){return ie}async $test_up(ie){return ie.byteLength}async $test_down(ie){const ve=l.VSBuffer.alloc(ie),be=Math.random()%256;for(let ne=0;ne<ie;ne++)ve.writeUInt8(be,ne);return ve}async $updateRemoteConnectionData(ie){this._remoteConnectionData=ie,this._onDidChangeRemoteConnectionData.fire()}};K=ze([xe(0,n.IInstantiationService),xe(1,e.IHostUtils),xe(2,a.IExtHostRpcService),xe(3,c.IExtHostWorkspace),xe(4,m.IExtHostConfiguration),xe(5,F.ILogService),xe(6,i.IExtHostInitDataService),xe(7,s.IExtensionStoragePaths),xe(8,g.IExtHostTunnelService),xe(9,p.IExtHostTerminalService)],K),e.AbstractExtHostExtensionService=K;function W(de,ie){return{id:de.identifier.value,name:de.name,extensionVersion:de.version,publisherDisplayName:de.publisher,activationEvents:de.activationEvents?de.activationEvents.join(","):null,isBuiltin:de.isBuiltin,reason:ie.activationEvent,reasonId:ie.extensionId.value}}e.IExtHostExtensionService=(0,n.createDecorator)("IExtHostExtensionService");class O{constructor(ie,ve,be,ne,Ee){x.set(this,void 0),U.set(this,void 0),R.set(this,void 0),Je(this,x,ie,"f"),Je(this,U,ve,"f"),Je(this,R,be.identifier,"f"),this.id=be.identifier.value,this.extensionUri=be.extensionLocation,this.extensionPath=y.normalize((0,L.originalFSPath)(be.extensionLocation)),this.packageJSON=be,this.extensionKind=ne,this.isFromDifferentExtensionHost=Ee}get isActive(){return Oe(this,x,"f").isActivated(Oe(this,R,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Oe(this,x,"f").getExtensionExports(Oe(this,R,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Oe(this,x,"f").activateByIdWithErrors(Oe(this,R,"f"),{startup:!1,extensionId:Oe(this,U,"f"),activationEvent:"api"}),this.exports}}e.Extension=O,x=new WeakMap,U=new WeakMap,R=new WeakMap;function Z(de,ie){return de.getAllExtensionDescriptions().filter(ve=>ie.has(I.ExtensionIdentifier.toKey(ve.identifier)))}function ue(de){const ie=de.indexOf("+");return ie===-1?de:de.substring(0,ie)}class oe{constructor(ie){this._searchTree=ie}setSearchTree(ie){this._searchTree=ie}findSubstr(ie){return this._searchTree.findSubstr(ie)}forEach(ie){return this._searchTree.forEach(ie)}}e.ExtensionPaths=oe}),define(Ce[230],Ie([1,0,71,2,4,32,24,27,13,28,3,33,59,15,9]),function(te,e,r,y,w,L,_,A,E,k,F,S,m,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let c=class{constructor(b,t,d,n,i,s,a){this._apiFactory=b,this._extensionRegistry=t,this._instaService=d,this._extHostConfiguration=n,this._extHostExtensionService=i,this._initData=s,this._logService=a,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),r.mark("code/extHost/willWaitForConfig");const b=await this._extHostConfiguration.getConfigProvider();r.mark("code/extHost/didWaitForConfig");const t=await this._extHostExtensionService.getExtensionPathIndex();this.register(new u(this._apiFactory,t,this._extensionRegistry,b,this._logService)),this.register(this._instaService.createInstance(v,t)),this.register(this._instaService.createInstance(h)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(I,t,this._initData.environment.appUriScheme))}register(b){if("nodeModuleName"in b)if(Array.isArray(b.nodeModuleName))for(const t of b.nodeModuleName)this._factories.set(t,b);else this._factories.set(b.nodeModuleName,b);typeof b.alternativeModuleName=="function"&&this._alternatives.push(t=>b.alternativeModuleName(t))}};c=ze([xe(2,F.IInstantiationService),xe(3,L.IExtHostConfiguration),xe(4,S.IExtHostExtensionService),xe(5,k.IExtHostInitDataService),xe(6,T.ILogService)],c),e.RequireInterceptor=c;let h=class Xi{constructor(b){if(b.environment.appRoot&&Xi.aliased.size){const t=(0,f.escapeRegExpCharacters)(this.forceForwardSlashes(b.environment.appRoot.fsPath)),d="[a-z0-9_.-]",n=`@${d}+\\/${d}+|${d}+`,i="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${t}/${i}\\/)(${n})(.*)$`,"i")}}alternativeModuleName(b){if(!this.re)return;const t=this.re.exec(this.forceForwardSlashes(b));if(!t)return;const[,d,n,i]=t,s=Xi.aliased.get(n);if(s!==void 0)return console.warn(`${n} as been renamed to ${s}, please update your imports`),d+s+i}forceForwardSlashes(b){return b.replace(/\\/g,"/")}};h.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),h=ze([xe(0,k.IExtHostInitDataService)],h);class u{constructor(b,t,d,n,i){this._apiFactory=b,this._extensionPaths=t,this._extensionRegistry=d,this._configProvider=n,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(b,t){const d=this._extensionPaths.findSubstr(t);if(d){let n=this._extApiImpl.get(A.ExtensionIdentifier.toKey(d.identifier));return n||(n=this._apiFactory(d,this._extensionRegistry,this._configProvider),this._extApiImpl.set(A.ExtensionIdentifier.toKey(d.identifier),n)),n}if(!this._defaultApiImpl){let n="";this._extensionPaths.forEach((i,s)=>n+=`	${s} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${n}`),this._defaultApiImpl=this._apiFactory(_.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let v=class{constructor(b,t,d){this._extensionPaths=b,this.nodeModuleName="keytar",this._mainThreadTelemetry=t.getProxy(w.MainContext.MainThreadTelemetry);const{environment:n}=d,i=t.getProxy(w.MainContext.MainThreadKeytar);if(n.appRoot){let s=n.appRoot.fsPath;m.platform==="win32"&&(s=s.replace(/\\/g,"/")),s[s.length-1]==="/"&&(s=s.substr(0,s.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${s}/node_modules.asar/keytar`),this.alternativeNames.add(`${s}/node_modules/keytar`)}this._impl={getPassword:(s,a)=>i.$getPassword(s,a),setPassword:(s,a,o)=>i.$setPassword(s,a,o),deletePassword:(s,a)=>i.$deletePassword(s,a),findPassword:s=>i.$findPassword(s),findCredentials(s){return i.$findCredentials(s)}}}load(b,t){const d=this._extensionPaths.findSubstr(t);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:d?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(b){const t=b.length;if(t<=7||!this.alternativeNames)return;const d=t-7;if((b.charAt(d)==="/"||b.charAt(d)==="\\")&&b.endsWith("keytar")&&(b=b.replace(/\\/g,"/"),this.alternativeNames.has(b)))return"keytar"}};v=ze([xe(1,E.IExtHostRpcService),xe(2,k.IExtHostInitDataService)],v);let I=class{constructor(b,t,d){this._extensionPaths=b,this._appUriScheme=t,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=d.getProxy(w.MainContext.MainThreadTelemetry);const n=d.getProxy(w.MainContext.MainThreadWindow);this._impl=(i,s)=>{const a=y.URI.parse(i);return s?this.callOriginal(i,s):a.scheme==="http"||a.scheme==="https"?n.$openUri(a,i,{allowTunneling:!0}):a.scheme==="mailto"||a.scheme===this._appUriScheme?n.$openUri(a,i,{}):this.callOriginal(i,s)}}load(b,t,d){const n=this._extensionPaths.findSubstr(t);return n&&(this._extensionId=n.identifier.value,this.sendShimmingTelemetry()),this._original=d(b),this._impl}callOriginal(b,t){return this.sendNoForwardTelemetry(),this._original(b,t)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};I=ze([xe(2,E.IExtHostRpcService)],I)}),define(Ce[102],Ie([1,0,196,7,19,59,3,50,51,33,6,31,169,32]),function(te,e,r,y,w,L,_,A,E,k,F,S,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,_.createDecorator)("IExtHostVariableResolverProvider");class f extends m.AbstractVariableResolverService{constructor(u,v,I,l,b,t,d){function n(){if(I){const i=I.activeEditor();if(i)return i.document.uri;const s=l.tabGroups.all.find(a=>a.isActive)?.activeTab;if(s!==void 0){if(s.input instanceof F.TextDiffTabInput||s.input instanceof F.NotebookDiffEditorTabInput)return s.input.modified;if(s.input instanceof F.TextTabInput||s.input instanceof F.NotebookEditorTabInput||s.input instanceof F.CustomEditorTabInput)return s.input.uri}}}super({getFolderUri:i=>{const s=t.folders.filter(a=>a.name===i);if(s&&s.length>0)return s[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(i,s)=>b.getConfiguration(void 0,i).get(s),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const i=n();if(i)return w.normalize(i.fsPath)},getWorkspaceFolderPathForFile:()=>{if(v){const i=n();if(i){const s=v.getWorkspaceFolder(i);if(s)return w.normalize(s.uri.fsPath)}}},getSelectedText:()=>{if(I){const i=I.activeEditor();if(i&&!i.selection.isEmpty)return i.document.getText(i.selection)}},getLineNumber:()=>{if(I){const i=I.activeEditor();if(i)return String(i.selection.end.line+1)}},getExtension:i=>u.getExtension(i)},void 0,d?Promise.resolve(d):void 0,Promise.resolve(L.env))}}let c=class extends y.Disposable{constructor(u,v,I,l,b){super(),this.extensionService=u,this.workspaceService=v,this.editorService=I,this.configurationService=l,this.editorTabs=b,this._resolver=new r.Lazy(async()=>{const t=await this.configurationService.getConfigProvider(),n={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async i=>{n.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new f(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,t,n,this.homeDir())})}getResolver(){return this._resolver.getValue()}homeDir(){}};c=ze([xe(0,k.IExtHostExtensionService),xe(1,S.IExtHostWorkspace),xe(2,A.IExtHostDocumentsAndEditors),xe(3,T.IExtHostConfiguration),xe(4,E.IExtHostEditorTabs)],c),e.ExtHostVariableResolverProviderService=c}),define(Ce[103],Ie([1,0,14,5,10,2,3,4,51,33,13,6,31,162,164,32,102]),function(te,e,r,y,w,L,_,A,E,k,F,S,m,T,f,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,_.createDecorator)("IExtHostDebugService");let u=class{constructor(n,i,s,a,o,g){this._workspaceService=i,this._extensionService=s,this._configurationService=a,this._editorTabs=o,this._variableResolver=g,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new y.Emitter,this._onDidTerminateDebugSession=new y.Emitter,this._onDidChangeActiveDebugSession=new y.Emitter,this._onDidReceiveDebugSessionCustomEvent=new y.Emitter,this._debugServiceProxy=n.getProxy(A.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new y.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new I(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(p=>{p.onDidChange(P=>{this.registerAllDebugTypes(p)}),this.registerAllDebugTypes(p)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(n,i){const s=n;if(typeof s.sourceReference=="number"&&s.sourceReference>0){let a=`debug:${encodeURIComponent(s.path||"")}`,o="?";return i&&(a+=`${o}session=${encodeURIComponent(i.id)}`,o="&"),a+=`${o}ref=${s.sourceReference}`,L.URI.parse(a)}else{if(s.path)return L.URI.file(s.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(n){const i=[];for(const s of n.getAllExtensionDescriptions())if(s.contributes){const a=s.contributes.debuggers;if(a&&a.length>0)for(const o of a)(0,f.isDebuggerMainContribution)(o)&&i.push(o.type)}this._debugServiceProxy.$registerDebugTypes(i)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const n=[];return this._breakpoints.forEach(i=>n.push(i)),n}addBreakpoints(n){this.startBreakpoints();const i=n.filter(o=>{const g=o.id;return this._breakpoints.has(g)?!1:(this._breakpoints.set(g,o),!0)});this.fireBreakpointChanges(i,[],[]);const s=[],a=new Map;for(const o of i)if(o instanceof S.SourceBreakpoint){let g=a.get(o.location.uri.toString());g||(g={type:"sourceMulti",uri:o.location.uri,lines:[]},a.set(o.location.uri.toString(),g),s.push(g)),g.lines.push({id:o.id,enabled:o.enabled,condition:o.condition,hitCondition:o.hitCondition,logMessage:o.logMessage,line:o.location.range.start.line,character:o.location.range.start.character})}else o instanceof S.FunctionBreakpoint&&s.push({type:"function",id:o.id,enabled:o.enabled,hitCondition:o.hitCondition,logMessage:o.logMessage,condition:o.condition,functionName:o.functionName});return this._debugServiceProxy.$registerBreakpoints(s)}removeBreakpoints(n){this.startBreakpoints();const i=n.filter(g=>this._breakpoints.delete(g.id));this.fireBreakpointChanges([],i,[]);const s=i.filter(g=>g instanceof S.SourceBreakpoint).map(g=>g.id),a=i.filter(g=>g instanceof S.FunctionBreakpoint).map(g=>g.id),o=i.filter(g=>g instanceof S.DataBreakpoint).map(g=>g.id);return this._debugServiceProxy.$unregisterBreakpoints(s,a,o)}startDebugging(n,i,s){return this._debugServiceProxy.$startDebugging(n?n.uri:void 0,i,{parentSessionID:s.parentSession?s.parentSession.id:void 0,lifecycleManagedByParent:s.lifecycleManagedByParent,repl:s.consoleMode===S.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:s.noDebug,compact:s.compact,debugUI:s.debugUI,suppressSaveBeforeStart:s.suppressSaveBeforeStart})}stopDebugging(n){return this._debugServiceProxy.$stopDebugging(n?n.id:void 0)}registerDebugConfigurationProvider(n,i,s){if(!i)return new S.Disposable(()=>{});const a=this._configProviderHandleCounter++;return this._configProviders.push({type:n,handle:a,provider:i}),this._debugServiceProxy.$registerDebugConfigurationProvider(n,s,!!i.provideDebugConfigurations,!!i.resolveDebugConfiguration,!!i.resolveDebugConfigurationWithSubstitutedVariables,a),new S.Disposable(()=>{this._configProviders=this._configProviders.filter(o=>o.provider!==i),this._debugServiceProxy.$unregisterDebugConfigurationProvider(a)})}registerDebugAdapterDescriptorFactory(n,i,s){if(!s)return new S.Disposable(()=>{});if(!this.definesDebugType(n,i))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${i}' debugger.`);if(this.getAdapterDescriptorFactoryByType(i))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const a=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:i,handle:a,factory:s}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(i,a),new S.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(o=>o.factory!==s),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(a)})}registerDebugAdapterTrackerFactory(n,i){if(!i)return new S.Disposable(()=>{});const s=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:n,handle:s,factory:i}),new S.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(a=>a.factory!==i)})}async $runInTerminal(n,i){return Promise.resolve(void 0)}async $substituteVariables(n,i){let s;const a=await this.getFolder(n);return a&&(s={uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(s,i)}createDebugAdapter(n,i){if(n.type==="implementation")return new b(n.implementation)}createSignService(){}async $startDASession(n,i){const s=this,a=await this.getSession(i);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(a.type),a).then(o=>{if(!o)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}' (extension might have failed to activate)`);const g=this.convertToDto(o),p=this.createDebugAdapter(g,a);if(!p)throw new Error(`Couldn't create a debug adapter for type '${a.type}'.`);const P=p;return this._debugAdapters.set(n,P),this.getDebugAdapterTrackers(a).then(M=>(M&&this._debugAdaptersTrackers.set(n,M),P.onMessage(async V=>{if(V.type==="request"&&V.command==="handshake"){const B=V,D={type:"response",seq:0,command:B.command,request_seq:B.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const x=await this._signService.sign(B.arguments.value);D.body={signature:x},P.sendResponse(D)}else throw new Error("no signer")}catch(x){D.success=!1,D.message=x.message,P.sendResponse(D)}}else M&&M.onDidSendMessage&&M.onDidSendMessage(V),V=(0,f.convertToVSCPaths)(V,!0),s._debugServiceProxy.$acceptDAMessage(n,V)}),P.onError(V=>{M&&M.onError&&M.onError(V),this._debugServiceProxy.$acceptDAError(n,V.name,V.message,V.stack)}),P.onExit(V=>{M&&M.onExit&&M.onExit((0,w.withNullAsUndefined)(V),void 0),this._debugServiceProxy.$acceptDAExit(n,(0,w.withNullAsUndefined)(V),void 0)}),M&&M.onWillStartSession&&M.onWillStartSession(),P.startSession()))})}$sendDAMessage(n,i){i=(0,f.convertToDAPaths)(i,!1);const s=this._debugAdaptersTrackers.get(n);s&&s.onWillReceiveMessage&&s.onWillReceiveMessage(i),this._debugAdapters.get(n)?.sendMessage(i)}$stopDASession(n){const i=this._debugAdaptersTrackers.get(n);this._debugAdaptersTrackers.delete(n),i&&i.onWillStopSession&&i.onWillStopSession();const s=this._debugAdapters.get(n);return this._debugAdapters.delete(n),s?s.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(n){const i=[],s=[],a=[];if(n.added)for(const o of n.added){const g=o.id;if(g&&!this._breakpoints.has(g)){let p;if(o.type==="function")p=new S.FunctionBreakpoint(o.functionName,o.enabled,o.condition,o.hitCondition,o.logMessage);else if(o.type==="data")p=new S.DataBreakpoint(o.label,o.dataId,o.canPersist,o.enabled,o.hitCondition,o.condition,o.logMessage);else{const P=L.URI.revive(o.uri);p=new S.SourceBreakpoint(new S.Location(P,new S.Position(o.line,o.character)),o.enabled,o.condition,o.hitCondition,o.logMessage)}p._id=g,this._breakpoints.set(g,p),i.push(p)}}if(n.removed)for(const o of n.removed){const g=this._breakpoints.get(o);g&&(this._breakpoints.delete(o),s.push(g))}if(n.changed){for(const o of n.changed)if(o.id){const g=this._breakpoints.get(o.id);if(g){if(g instanceof S.FunctionBreakpoint&&o.type==="function"){const p=g;p.enabled=o.enabled,p.condition=o.condition,p.hitCondition=o.hitCondition,p.logMessage=o.logMessage,p.functionName=o.functionName}else if(g instanceof S.SourceBreakpoint&&o.type==="source"){const p=g;p.enabled=o.enabled,p.condition=o.condition,p.hitCondition=o.hitCondition,p.logMessage=o.logMessage,p.location=new S.Location(L.URI.revive(o.uri),new S.Position(o.line,o.character))}a.push(g)}}}this.fireBreakpointChanges(i,s,a)}$provideDebugConfigurations(n,i,s){return(0,r.asPromise)(async()=>{const a=this.getConfigProviderByHandle(n);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const o=await this.getFolder(i);return a.provideDebugConfigurations(o,s)}).then(a=>{if(!a)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return a})}$resolveDebugConfiguration(n,i,s,a){return(0,r.asPromise)(async()=>{const o=this.getConfigProviderByHandle(n);if(!o)throw new Error("no DebugConfigurationProvider found");if(!o.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const g=await this.getFolder(i);return o.resolveDebugConfiguration(g,s,a)})}$resolveDebugConfigurationWithSubstitutedVariables(n,i,s,a){return(0,r.asPromise)(async()=>{const o=this.getConfigProviderByHandle(n);if(!o)throw new Error("no DebugConfigurationProvider found");if(!o.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const g=await this.getFolder(i);return o.resolveDebugConfigurationWithSubstitutedVariables(g,s,a)})}async $provideDebugAdapter(n,i){const s=this.getAdapterDescriptorFactoryByHandle(n);if(!s)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const a=await this.getSession(i);return this.getAdapterDescriptor(s,a).then(o=>{if(!o)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}'`);return this.convertToDto(o)})}async $acceptDebugSessionStarted(n){const i=await this.getSession(n);this._onDidStartDebugSession.fire(i)}async $acceptDebugSessionTerminated(n){const i=await this.getSession(n);i&&(this._onDidTerminateDebugSession.fire(i),this._debugSessions.delete(i.id))}async $acceptDebugSessionActiveChanged(n){this._activeDebugSession=n?await this.getSession(n):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(n,i){(await this.getSession(n))?._acceptNameChanged(i)}async $acceptDebugSessionCustomEvent(n,i){const a={session:await this.getSession(n),event:i.event,body:i.body};this._onDidReceiveDebugSessionCustomEvent.fire(a)}convertToDto(n){if(n instanceof S.DebugAdapterExecutable)return{type:"executable",command:n.command,args:n.args,options:n.options};if(n instanceof S.DebugAdapterServer)return{type:"server",port:n.port,host:n.host};if(n instanceof S.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:n.path};if(n instanceof S.DebugAdapterInlineImplementation)return{type:"implementation",implementation:n.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(n){const i=this._adapterFactories.filter(s=>s.type===n);if(i.length>0)return i[0].factory}getAdapterDescriptorFactoryByHandle(n){const i=this._adapterFactories.filter(s=>s.handle===n);if(i.length>0)return i[0].factory}getConfigProviderByHandle(n){const i=this._configProviders.filter(s=>s.handle===n);if(i.length>0)return i[0].provider}definesDebugType(n,i){if(n.contributes){const s=n.contributes.debuggers;if(s&&s.length>0){for(const a of s)if(a.label&&a.type&&a.type===i)return!0}}return!1}getDebugAdapterTrackers(n){const s=n.configuration.type,a=this._trackerFactories.filter(o=>o.type===s||o.type==="*").map(o=>(0,r.asPromise)(()=>o.factory.createDebugAdapterTracker(n)).then(g=>g,g=>null));return Promise.race([Promise.all(a).then(o=>{const g=o.filter(p=>!!p);if(g.length>0)return new l(g)}),new Promise((o,g)=>{const p=setTimeout(()=>{clearTimeout(p),g(new Error("timeout"))},1e3)})]).catch(o=>{})}async getAdapterDescriptor(n,i){const s=i.configuration.debugServer;if(typeof s=="number")return Promise.resolve(new S.DebugAdapterServer(s));if(n){const o=await this._extensionService.getExtensionRegistry();return(0,r.asPromise)(()=>n.createDebugAdapterDescriptor(i,this.daExecutableFromPackage(i,o))).then(g=>{if(g)return g})}const a=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(i,a))}daExecutableFromPackage(n,i){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(n,i,s){(n.length>0||i.length>0||s.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:n,removed:i,changed:s}))}async getSession(n){if(n)if(typeof n=="string"){const i=this._debugSessions.get(n);if(i)return i}else{let i=this._debugSessions.get(n.id);if(!i){const s=await this.getFolder(n.folderUri),a=n.parent?this._debugSessions.get(n.parent):void 0;i=new v(this._debugServiceProxy,n.id,n.type,n.name,s,n.configuration,a),this._debugSessions.set(i.id,i),this._debugServiceProxy.$sessionCached(i.id)}return i}throw new Error("cannot find session")}getFolder(n){if(n){const i=L.URI.revive(n);return this._workspaceService.resolveWorkspaceFolder(i)}return Promise.resolve(void 0)}};u=ze([xe(0,F.IExtHostRpcService),xe(1,m.IExtHostWorkspace),xe(2,k.IExtHostExtensionService),xe(3,c.IExtHostConfiguration),xe(4,E.IExtHostEditorTabs),xe(5,h.IExtHostVariableResolverProvider)],u),e.ExtHostDebugServiceBase=u;class v{constructor(n,i,s,a,o,g,p){this._debugServiceProxy=n,this._id=i,this._type=s,this._name=a,this._workspaceFolder=o,this._configuration=g,this._parentSession=p}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(n){this._name=n,this._debugServiceProxy.$setDebugSessionName(this._id,n)}get parentSession(){return this._parentSession}_acceptNameChanged(n){this._name=n}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(n,i){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,n,i)}getDebugProtocolBreakpoint(n){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,n.id)}}e.ExtHostDebugSession=v;class I{constructor(n){this.value=Object.freeze({append(i){n.$appendDebugConsole(i)},appendLine(i){this.append(i+`
`)}})}}e.ExtHostDebugConsole=I;class l{constructor(n){this.trackers=n}onWillStartSession(){this.trackers.forEach(n=>n.onWillStartSession?n.onWillStartSession():void 0)}onWillReceiveMessage(n){this.trackers.forEach(i=>i.onWillReceiveMessage?i.onWillReceiveMessage(n):void 0)}onDidSendMessage(n){this.trackers.forEach(i=>i.onDidSendMessage?i.onDidSendMessage(n):void 0)}onWillStopSession(){this.trackers.forEach(n=>n.onWillStopSession?n.onWillStopSession():void 0)}onError(n){this.trackers.forEach(i=>i.onError?i.onError(n):void 0)}onExit(n,i){this.trackers.forEach(s=>s.onExit?s.onExit(n,i):void 0)}}class b extends T.AbstractDebugAdapter{constructor(n){super(),this.implementation=n,n.onDidSendMessage(i=>{this.acceptMessage(i)})}startSession(){return Promise.resolve(void 0)}sendMessage(n){this.implementation.handleMessage(n)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let t=class extends u{constructor(n,i,s,a,o,g){super(n,i,s,a,o,g)}};t=ze([xe(0,F.IExtHostRpcService),xe(1,m.IExtHostWorkspace),xe(2,k.IExtHostExtensionService),xe(3,c.IExtHostConfiguration),xe(4,E.IExtHostEditorTabs),xe(5,h.IExtHostVariableResolverProvider)],t),e.WorkerExtHostDebugService=t}),define(Ce[231],Ie([1,0,11,71,2,4,222,15,56,58,28,147,13,46,33]),function(te,e,r,y,w,L,_,A,E,k,F,S,m,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class c{constructor(u,v,I,l,b){this._hostUtils=I,this._rpcProtocol=new _.RPCProtocol(u,null,l),v=c._transform(v,this._rpcProtocol);const t=new k.ServiceCollection(...(0,E.getSingletonServiceDescriptors)());t.set(F.IExtHostInitDataService,{_serviceBrand:void 0,...v,messagePorts:b}),t.set(m.IExtHostRpcService,new m.ExtHostRpcService(this._rpcProtocol)),t.set(T.IURITransformerService,new T.URITransformerService(l)),t.set(f.IHostUtils,I);const d=new S.InstantiationService(t,!0);this._logService=d.invokeFunction(a=>a.get(A.ILogService)),y.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",v),this._extensionService=d.invokeFunction(a=>a.get(f.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const n=new WeakMap;this._extensionService.getExtensionPathIndex().then(a=>{Error.prepareStackTrace=(o,g)=>{let p="",P,M;for(const V of g)p+=`
	at ${V.toString()}`,M=V.getFileName(),!P&&M&&(P=a.findSubstr(w.URI.file(M)));return n.set(o,P),`${o.name||"Error"}: ${o.message||""}${p}`}});const i=this._rpcProtocol.getProxy(L.MainContext.MainThreadExtensionService),s=this._rpcProtocol.getProxy(L.MainContext.MainThreadErrors);r.setUnexpectedErrorHandler(a=>{const o=r.transformErrorForSerialization(a),g=n.get(a);g?i.$onExtensionRuntimeError(g.identifier,o):s.$onUnexpectedError(o)})}async asBrowserUri(u){const v=this._rpcProtocol.getProxy(L.MainContext.MainThreadExtensionService);return w.URI.revive(await v.$asBrowserUri(u))}terminate(u){this._extensionService.terminate(u)}static _transform(u,v){u.allExtensions.forEach(l=>{l.extensionLocation=w.URI.revive(v.transformIncomingURIs(l.extensionLocation));const b={};l.browserNlsBundleUris&&(Object.keys(l.browserNlsBundleUris).forEach(t=>b[t]=w.URI.revive(v.transformIncomingURIs(l.browserNlsBundleUris[t]))),l.browserNlsBundleUris=b)}),u.environment.appRoot=w.URI.revive(v.transformIncomingURIs(u.environment.appRoot));const I=u.environment.extensionDevelopmentLocationURI;return I&&(u.environment.extensionDevelopmentLocationURI=I.map(l=>w.URI.revive(v.transformIncomingURIs(l)))),u.environment.extensionTestsLocationURI=w.URI.revive(v.transformIncomingURIs(u.environment.extensionTestsLocationURI)),u.environment.globalStorageHome=w.URI.revive(v.transformIncomingURIs(u.environment.globalStorageHome)),u.environment.workspaceStorageHome=w.URI.revive(v.transformIncomingURIs(u.environment.workspaceStorageHome)),u.logsLocation=w.URI.revive(v.transformIncomingURIs(u.logsLocation)),u.logFile=w.URI.revive(v.transformIncomingURIs(u.logFile)),u.workspace=v.transformIncomingURIs(u.workspace),u}}e.ExtensionHostMain=c}),define(Ce[232],Ie([1,0,16,14,20,43,12,19,22,2,41]),function(te,e,r,y,w,L,_,A,E,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class S{constructor(v,I,l,b){this.query=v,this.provider=I,this.fileUtils=l,this.processType=b,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(v,I){const l=this.query.folderQueries||[],b=new w.CancellationTokenSource;return I.onCancellationRequested(()=>b.cancel()),new Promise((t,d)=>{this.collector=new T(v);let n=!1;const i=(s,a)=>{if(!n&&!this.isLimitHit){const o=this.resultSize(s);c(s)&&typeof this.query.maxResults=="number"&&this.resultCount+o>this.query.maxResults&&(this.isLimitHit=!0,n=!0,b.cancel(),s=this.trimResultToSize(s,this.query.maxResults-this.resultCount));const g=this.resultSize(s);this.resultCount+=g,(g>0||!c(s))&&this.collector.add(s,a)}};Promise.all(l.map((s,a)=>this.searchInFolder(s,o=>i(o,a),b.token))).then(s=>{b.dispose(),this.collector.flush();const a=s.some(o=>!!o&&!!o.limitHit);t({limitHit:this.isLimitHit||a,messages:(0,r.flatten)(s.map(o=>o?.message?Array.isArray(o.message)?o.message:[o.message]:[])),stats:{type:this.processType}})},s=>{b.dispose();const a=(0,L.toErrorMessage)(s);d(new Error(a))})})}resultSize(v){return c(v)?Array.isArray(v.ranges)?v.ranges.length:1:0}trimResultToSize(v,I){const l=Array.isArray(v.ranges)?v.ranges:[v.ranges],b=Array.isArray(v.preview.matches)?v.preview.matches:[v.preview.matches];return{ranges:l.slice(0,I),preview:{matches:b.slice(0,I),text:v.preview.text},uri:v.uri}}async searchInFolder(v,I,l){const b=new F.QueryGlobTester(this.query,v),t=[],d={report:s=>{if(!this.validateProviderResult(s))return;const a=v.folder.scheme===_.Schemas.file?(0,F.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(E.dirname(s.uri))):void 0,o=E.relativePath(v.folder,s.uri);if(o){const g=b.includedInQuery(o,A.basename(o),a);(0,y.isThenable)(g)?t.push(g.then(p=>{p&&I(s)})):g&&I(s)}}},n=this.getSearchOptionsForFolder(v),i=await this.provider.provideTextSearchResults(m(this.query.contentPattern),n,d,l);return t.length&&await Promise.all(t),i}validateProviderResult(v){if(c(v)){if(Array.isArray(v.ranges)){if(!Array.isArray(v.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(v.preview.matches.length!==v.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(v.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(v){const I=(0,F.resolvePatternsForProvider)(this.query.includePattern,v.includePattern),l=(0,F.resolvePatternsForProvider)(this.query.excludePattern,v.excludePattern),b={folder:k.URI.from(v.folder),excludes:l,includes:I,useIgnoreFiles:!v.disregardIgnoreFiles,useGlobalIgnoreFiles:!v.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!v.disregardParentIgnoreFiles,followSymlinks:!v.ignoreSymlinks,encoding:v.fileEncoding&&this.fileUtils.toCanonicalName(v.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return b.usePCRE2=this.query.usePCRE2,b}}e.TextSearchManager=S;function m(u){return{isCaseSensitive:u.isCaseSensitive||!1,isRegExp:u.isRegExp||!1,isWordMatch:u.isWordMatch||!1,isMultiline:u.isMultiline||!1,pattern:u.pattern}}class T{constructor(v){this._onResult=v,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new h(512,I=>this.sendItems(I))}add(v,I){this._currentFileMatch&&(this._currentFolderIdx!==I||!E.isEqual(this._currentUri,v.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=I,this._currentFileMatch={resource:v.uri,results:[]}),this._currentFileMatch.results.push(f(v))}pushToCollector(){const v=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,v)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(v){this._onResult(v)}}e.TextSearchResultsCollector=T;function f(u){return c(u)?{preview:{matches:(0,r.mapArrayOrNot)(u.preview.matches,v=>({startLineNumber:v.start.line,startColumn:v.start.character,endLineNumber:v.end.line,endColumn:v.end.character})),text:u.preview.text},ranges:(0,r.mapArrayOrNot)(u.ranges,v=>({startLineNumber:v.start.line,startColumn:v.start.character,endLineNumber:v.end.line,endColumn:v.end.character}))}:{text:u.text,lineNumber:u.lineNumber}}function c(u){return!!u.preview}e.extensionResultIsMatch=c;class h{constructor(v,I){this.maxBatchSize=v,this.cb=I,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(v,I){!v||this.addItemToBatch(v,I)}addItems(v,I){!v||this.addItemsToBatch(v,I)}addItemToBatch(v,I){this.batch.push(v),this.batchSize+=I,this.onUpdate()}addItemsToBatch(v,I){this.batch=this.batch.concat(v),this.batchSize+=I,this.onUpdate()}onUpdate(){this.totalNumberCompleted<h.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},h.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=h,h.TIMEOUT=4e3,h.START_BATCH_AFTER_COUNT=50}),define(Ce[104],Ie([1,0,7,4,3,227,13,46,15,2,232]),function(te,e,r,y,w,L,_,A,E,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,w.createDecorator)("IExtHostSearch");let S=class{constructor(c,h,u){this.extHostRpc=c,this._uriTransformer=h,this._logService=u,this._proxy=this.extHostRpc.getProxy(y.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new L.FileSearchManager}_transformScheme(c){return this._uriTransformer.transformOutgoingScheme(c)}registerTextSearchProvider(c,h){if(this._textSearchUsedSchemes.has(c))throw new Error(`a text search provider for the scheme '${c}' is already registered`);this._textSearchUsedSchemes.add(c);const u=this._handlePool++;return this._textSearchProvider.set(u,h),this._proxy.$registerTextSearchProvider(u,this._transformScheme(c)),(0,r.toDisposable)(()=>{this._textSearchUsedSchemes.delete(c),this._textSearchProvider.delete(u),this._proxy.$unregisterProvider(u)})}registerFileSearchProvider(c,h){if(this._fileSearchUsedSchemes.has(c))throw new Error(`a file search provider for the scheme '${c}' is already registered`);this._fileSearchUsedSchemes.add(c);const u=this._handlePool++;return this._fileSearchProvider.set(u,h),this._proxy.$registerFileSearchProvider(u,this._transformScheme(c)),(0,r.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(c),this._fileSearchProvider.delete(u),this._proxy.$unregisterProvider(u)})}$provideFileSearchResults(c,h,u,v){const I=m(u),l=this._fileSearchProvider.get(c);if(l)return this._fileSearchManager.fileSearch(I,l,b=>{this._proxy.$handleFileMatch(c,h,b.map(t=>t.resource))},v);throw new Error("unknown provider: "+c)}$clearCache(c){return this._fileSearchManager.clearCache(c),Promise.resolve(void 0)}$provideTextSearchResults(c,h,u,v){const I=this._textSearchProvider.get(c);if(!I||!I.provideTextSearchResults)throw new Error(`Unknown provider ${c}`);const l=m(u);return this.createTextSearchManager(l,I).search(t=>this._proxy.$handleTextMatch(c,h,t),v)}$enableExtensionHostSearch(){}createTextSearchManager(c,h){return new F.TextSearchManager(c,h,{readdir:u=>Promise.resolve([]),toCanonicalName:u=>u},"textSearchProvider")}};S=ze([xe(0,_.IExtHostRpcService),xe(1,A.IURITransformerService),xe(2,E.ILogService)],S),e.ExtHostSearch=S;function m(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(T),extraFileResources:f.extraFileResources&&f.extraFileResources.map(c=>k.URI.revive(c))}}e.reviveQuery=m;function T(f){return{...f,folder:k.URI.revive(f.folder)}}}),define(Ce[233],Ie([1,0,56,99,31,96,32,36,50,53,101,103,104,69,62,67,98,52,35,68,87,51,204,15,174,102,97]),function(te,e,r,y,w,L,_,A,E,k,F,S,m,T,f,c,h,u,v,I,l,b,t,d,n,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.registerSingleton)(d.ILoggerService,t.ExtHostLoggerService,!0),(0,r.registerSingleton)(d.ILogService,n.ExtHostLogService,!0),(0,r.registerSingleton)(c.IExtHostApiDeprecationService,c.ExtHostApiDeprecationService,!1),(0,r.registerSingleton)(A.IExtHostCommands,A.ExtHostCommands,!1),(0,r.registerSingleton)(_.IExtHostConfiguration,_.ExtHostConfiguration,!1),(0,r.registerSingleton)(u.IExtHostConsumerFileSystem,u.ExtHostConsumerFileSystem,!1),(0,r.registerSingleton)(S.IExtHostDebugService,S.WorkerExtHostDebugService,!1),(0,r.registerSingleton)(L.IExtHostDecorations,L.ExtHostDecorations,!1),(0,r.registerSingleton)(E.IExtHostDocumentsAndEditors,E.ExtHostDocumentsAndEditors,!1),(0,r.registerSingleton)(v.IExtHostFileSystemInfo,v.ExtHostFileSystemInfo,!1),(0,r.registerSingleton)(y.IExtHostOutputService,y.ExtHostOutputService,!0),(0,r.registerSingleton)(m.IExtHostSearch,m.ExtHostSearch,!1),(0,r.registerSingleton)(T.IExtHostStorage,T.ExtHostStorage,!1),(0,r.registerSingleton)(F.IExtHostTask,F.WorkerExtHostTask,!1),(0,r.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService,!1),(0,r.registerSingleton)(f.IExtHostTunnelService,f.ExtHostTunnelService,!1),(0,r.registerSingleton)(h.IExtHostWindow,h.ExtHostWindow,!1),(0,r.registerSingleton)(w.IExtHostWorkspace,w.ExtHostWorkspace,!1),(0,r.registerSingleton)(I.IExtHostSecretState,I.ExtHostSecretState,!1),(0,r.registerSingleton)(l.IExtHostTelemetry,l.ExtHostTelemetry,!1),(0,r.registerSingleton)(s.IExtHostTelemetryLogService,s.ExtHostTelemetryLogService,!1),(0,r.registerSingleton)(b.IExtHostEditorTabs,b.ExtHostEditorTabs,!1),(0,r.registerSingleton)(i.IExtHostVariableResolverProvider,i.ExtHostVariableResolverProviderService,!1)}),define(Ce[234],Ie([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class r{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(w){if(w&&this._dragOperations.has(w)){const L=this._dragOperations.get(w);return this._dragOperations.delete(w),L}}addDragOperationTransfer(w,L){this._dragOperations.set(w,L)}getRenderedTreeElement(w){if(this._renderedElements.has(w))return this._renderedElements.get(w)}addRenderedTreeItemElement(w,L){this._renderedElements.set(w,L)}removeRenderedTreeItemElement(w){this._renderedElements.has(w)&&this._renderedElements.delete(w)}}e.TreeviewsService=r}),define(Ce[235],Ie([1,0,134,6,22,2,5,7,14,6,10,16,8,20,234,24]),function(te,e,r,y,w,L,_,A,E,k,F,S,m,T,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function h(I,l){if((0,F.isString)(I))return{label:I};if(I&&typeof I=="object"&&typeof I.label=="string"){let b;return Array.isArray(I.highlights)&&(b=I.highlights.filter(t=>t.length===2&&typeof t[0]=="number"&&typeof t[1]=="number"),b=b.length?b:void 0),{label:I.label,highlights:b}}}class u{constructor(l,b,t){this._proxy=l,this.commands=b,this.logService=t,this.treeViews=new Map,this.treeDragAndDropService=new f.TreeviewsService;function d(n){return n&&n.$treeViewId&&(n.$treeItemHandle||n.$selectedTreeItems||n.$focusedTreeItem)}b.registerArgumentProcessor({processArgument:n=>d(n)?this.convertArgument(n):Array.isArray(n)&&n.length>0?n.map(i=>d(i)?this.convertArgument(i):i):n})}registerTreeDataProvider(l,b,t){const d=this.createTreeView(l,{treeDataProvider:b},t);return{dispose:()=>d.dispose()}}createTreeView(l,b,t){if(!b||!b.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=b.dragAndDropController?.dropMimeTypes??[],n=b.dragAndDropController?.dragMimeTypes??[],i=!!b.dragAndDropController?.handleDrag,s=!!b.dragAndDropController?.handleDrop,a=this._proxy.$registerTreeViewDataProvider(l,{showCollapseAll:!!b.showCollapseAll,canSelectMany:!!b.canSelectMany,dropMimeTypes:d,dragMimeTypes:n,hasHandleDrag:i,hasHandleDrop:s}),o=this.createExtHostTreeView(l,b,t);return{get onDidCollapseElement(){return o.onDidCollapseElement},get onDidExpandElement(){return o.onDidExpandElement},get selection(){return o.selectedElements},get onDidChangeSelection(){return o.onDidChangeSelection},get visible(){return o.visible},get onDidChangeVisibility(){return o.onDidChangeVisibility},get onDidChangeTreeCheckbox(){return(0,c.checkProposedApiEnabled)(t,"treeItemCheckbox"),o.onDidChangeTreeCheckbox},get message(){return o.message},set message(g){o.message=g},get title(){return o.title},set title(g){o.title=g},get description(){return o.description},set description(g){o.description=g},get badge(){return o.badge},set badge(g){o.badge=g},reveal:(g,p)=>o.reveal(g,p),dispose:async()=>{await a,this.treeViews.delete(l),o.dispose()}}}$getChildren(l,b){const t=this.treeViews.get(l);return t?t.getChildren(b):Promise.reject(new Error((0,r.localize)(0,null,l)))}async $handleDrop(l,b,t,d,n,i,s,a){const o=this.treeViews.get(l);if(!o)return Promise.reject(new Error((0,r.localize)(1,null,l)));const g=m.DataTransfer.toDataTransfer(t,async p=>(await this._proxy.$resolveDropFileData(l,b,p)).buffer);return s===l&&a&&await this.addAdditionalTransferItems(g,o,a,n,i),o.onDrop(g,d,n)}async addAdditionalTransferItems(l,b,t,d,n){const i=this.treeDragAndDropService.removeDragOperationTransfer(n);if(i)(await i)?.forEach((s,a)=>{s&&l.set(a,s)});else if(n&&b.handleDrag){const s=b.handleDrag(t,l,d);this.treeDragAndDropService.addDragOperationTransfer(n,s),await s}return l}async $handleDrag(l,b,t,d){const n=this.treeViews.get(l);if(!n)return Promise.reject(new Error((0,r.localize)(2,null,l)));const i=await this.addAdditionalTransferItems(new y.DataTransfer,n,b,d,t);if(!!i)return m.DataTransfer.toDataTransferDTO(i)}async $hasResolve(l){const b=this.treeViews.get(l);if(!b)throw new Error((0,r.localize)(3,null,l));return b.hasResolve}$resolve(l,b,t){const d=this.treeViews.get(l);if(!d)throw new Error((0,r.localize)(4,null,l));return d.resolveTreeItem(b,t)}$setExpanded(l,b,t){const d=this.treeViews.get(l);if(!d)throw new Error((0,r.localize)(5,null,l));d.setExpanded(b,t)}$setSelection(l,b){const t=this.treeViews.get(l);if(!t)throw new Error((0,r.localize)(6,null,l));t.setSelection(b)}$setFocus(l,b){const t=this.treeViews.get(l);if(!t)throw new Error((0,r.localize)(7,null,l));t.setFocus(b)}$setVisible(l,b){const t=this.treeViews.get(l);if(!t)throw new Error((0,r.localize)(8,null,l));t.setVisible(b)}$changeCheckboxState(l,b){const t=this.treeViews.get(l);if(!t)throw new Error((0,r.localize)(9,null,l));t.setCheckboxState(b)}createExtHostTreeView(l,b,t){const d=new v(l,b,this._proxy,this.commands.converter,this.logService,t);return this.treeViews.set(l,d),d}convertArgument(l){const b=this.treeViews.get(l.$treeViewId);return b&&"$treeItemHandle"in l?b.getExtensionElement(l.$treeItemHandle):b&&"$focusedTreeItem"in l&&l.$focusedTreeItem?b.focusedElement:null}}e.ExtHostTreeViews=u;class v extends A.Disposable{constructor(l,b,t,d,n,i){if(super(),this.viewId=l,this.proxy=t,this.commands=d,this.logService=n,this.extension=i,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new _.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new _.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new _.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new _.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeTreeCheckbox=this._register(new _.Emitter),this.onDidChangeTreeCheckbox=this._onDidChangeTreeCheckbox.event,this._onDidChangeData=this._register(new _.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new T.CancellationTokenSource,i.contributes&&i.contributes.views)for(const o in i.contributes.views)for(const g of i.contributes.views[o])g.id===l&&(this._title=g.name);this.dataProvider=b.treeDataProvider,this.dndController=b.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(o=>this._onDidChangeData.fire({message:!1,element:o})));let s,a;this._register(_.Event.debounce(this._onDidChangeData.event,(o,g)=>(o||(o={message:!1,elements:[]}),g.element!==!1&&(s||(s=new Promise(p=>a=p),this.refreshPromise=this.refreshPromise.then(()=>s)),Array.isArray(g.element)?o.elements.push(...g.element):o.elements.push(g.element)),g.message&&(o.message=!0),o),200,!0)(({message:o,elements:g})=>{g.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const p=a;return s=null,this.refresh(g).then(()=>p())})),o&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(l=>this.getExtensionElement(l)).filter(l=>!(0,F.isUndefinedOrNull)(l))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}async getChildren(l){const b=l?this.getExtensionElement(l):void 0;if(l&&!b)return this.logService.error(`No tree item with id '${l}' found.`),Promise.resolve([]);let t=this.getChildrenNodes(l);return t||(t=await this.fetchChildrenNodes(b)),t?t.map(d=>d.item):void 0}getExtensionElement(l){return this.elements.get(l)}reveal(l,b){b=b||{select:!0,focus:!1};const t=(0,F.isUndefinedOrNull)(b.select)?!0:b.select,d=(0,F.isUndefinedOrNull)(b.focus)?!1:b.focus,n=(0,F.isUndefinedOrNull)(b.expand)?!1:b.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):l?this.refreshPromise.then(()=>this.resolveUnknownParentChain(l)).then(i=>this.resolveTreeNode(l,i[i.length-1]).then(s=>this.proxy.$reveal(this.viewId,{item:s.item,parentChain:i.map(a=>a.item)},{select:t,focus:d,expand:n})),i=>this.logService.error(i)):this.proxy.$reveal(this.viewId,void 0,{select:t,focus:d,expand:n})}get message(){return this._message}set message(l){this._message=l,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(l){this._title=l,this.proxy.$setTitle(this.viewId,l,this._description)}get description(){return this._description}set description(l){this._description=l,this.proxy.$setTitle(this.viewId,this._title,l)}get badge(){return this._badge}set badge(l){this._badge?.value===l?.value&&this._badge?.tooltip===l?.tooltip||(this._badge=m.ViewBadge.from(l),this.proxy.$setBadge(this.viewId,l))}setExpanded(l,b){const t=this.getExtensionElement(l);t&&(b?this._onDidExpandElement.fire(Object.freeze({element:t})):this._onDidCollapseElement.fire(Object.freeze({element:t})))}setSelection(l){(0,S.equals)(this._selectedHandles,l)||(this._selectedHandles=l,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setFocus(l){this._focusedHandle=l}setVisible(l){l!==this._visible&&(this._visible=l,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(l){const b=(await Promise.all(l.map(async t=>{const d=this.getExtensionElement(t.treeItemHandle);return d?{extensionItem:d,treeItem:await this.dataProvider.getTreeItem(d),newState:t.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(t=>t!==void 0);b.forEach(t=>{t.treeItem.checkboxState=t.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}),this._onDidChangeTreeCheckbox.fire({items:b.map(t=>[t.extensionItem,t.newState])})}async handleDrag(l,b,t){const d=[];for(const n of l){const i=this.getExtensionElement(n);i&&d.push(i)}if(!(!this.dndController?.handleDrag||d.length===0))return await this.dndController.handleDrag(d,b,t),b}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(l,b,t){const d=b?this.getExtensionElement(b):void 0;if(!(!d&&b||!this.dndController?.handleDrop))return(0,E.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(d,l,t):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(l,b){if(!this.dataProvider.resolveTreeItem)return;const t=this.elements.get(l);if(t){const d=this.nodes.get(t);if(d){const n=await this.dataProvider.resolveTreeItem(d.extensionItem,t,b)??d.extensionItem;return this.validateTreeItem(n),d.item.tooltip=this.getTooltip(n.tooltip),d.item.command=this.getCommand(d.disposableStore,n.command),d.item}}}resolveUnknownParentChain(l){return this.resolveParent(l).then(b=>b?this.resolveUnknownParentChain(b).then(t=>this.resolveTreeNode(b,t[t.length-1]).then(d=>(t.push(d),t))):Promise.resolve([]))}resolveParent(l){const b=this.nodes.get(l);return b?Promise.resolve(b.parent?this.elements.get(b.parent.item.handle):void 0):(0,E.asPromise)(()=>this.dataProvider.getParent(l))}resolveTreeNode(l,b){const t=this.nodes.get(l);return t?Promise.resolve(t):(0,E.asPromise)(()=>this.dataProvider.getTreeItem(l)).then(d=>this.createHandle(l,d,b,!0)).then(d=>this.getChildren(b?b.item.handle:void 0).then(()=>{const n=this.getExtensionElement(d);if(n){const i=this.nodes.get(n);if(i)return Promise.resolve(i)}throw new Error(`Cannot resolve tree item for element ${d}`)}))}getChildrenNodes(l){if(l){let b;if(typeof l=="string"){const t=this.getExtensionElement(l);b=t?this.nodes.get(t):void 0}else b=l;return b&&b.children||void 0}return this.roots}async fetchChildrenNodes(l){this.clearChildren(l);const b=new T.CancellationTokenSource(this._refreshCancellationSource.token);try{const t=l?this.nodes.get(l):void 0,d=await this.dataProvider.getChildren(l);if(b.token.isCancellationRequested)return;const n=await Promise.all((0,S.coalesce)(d||[]).map(async i=>{const s=await this.dataProvider.getTreeItem(i);return s&&!b.token.isCancellationRequested?this.createAndRegisterTreeNode(i,s,t):null}));return b.token.isCancellationRequested?void 0:(0,S.coalesce)(n)}finally{b.dispose()}}refresh(l){if(l.some(t=>!t))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new T.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const t=this.getHandlesToRefresh(l);if(t.length)return this.refreshHandles(t)}return Promise.resolve(void 0)}getHandlesToRefresh(l){const b=new Set,t=l.map(n=>this.nodes.get(n));for(const n of t)if(n&&!b.has(n.item.handle)){let i=n;for(;i&&i.parent&&t.findIndex(s=>i&&i.parent&&s&&s.item.handle===i.parent.item.handle)===-1;){const s=this.elements.get(i.parent.item.handle);i=s?this.nodes.get(s):void 0}i&&!i.parent&&b.add(n.item.handle)}const d=[];return b.forEach(n=>{const i=this.elements.get(n);if(i){const s=this.nodes.get(i);s&&(!s.parent||!b.has(s.parent.item.handle))&&d.push(n)}}),d}refreshHandles(l){const b={};return Promise.all(l.map(t=>this.refreshNode(t).then(d=>{d&&(b[t]=d.item)}))).then(()=>Object.keys(b).length?this.proxy.$refresh(this.viewId,b):void 0)}refreshNode(l){const b=this.getExtensionElement(l);if(b){const t=this.nodes.get(b);if(t)return this.clearChildren(b),(0,E.asPromise)(()=>this.dataProvider.getTreeItem(b)).then(d=>{if(d){const n=this.createTreeNode(b,d,t.parent);return this.updateNodeCache(b,n,t,t.parent),t.dispose(),n}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(l,b,t){const d=this.createTreeNode(l,b,t);if(b.id&&this.elements.has(d.item.handle))throw new Error((0,r.localize)(10,null,b.id));return this.addNodeToCache(l,d),this.addNodeToParentCache(d,t),d}getTooltip(l){return k.MarkdownString.isMarkdownString(l)?m.MarkdownString.from(l):l}getCommand(l,b){return b?{...this.commands.toInternal(b,l),originalId:b.command}:void 0}getCheckbox(l){return l.checkboxState!==void 0?l.checkboxState===k.TreeItemCheckboxState.Checked:void 0}validateTreeItem(l){if(!k.TreeItem.isTreeItem(l,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(l,b,t){this.validateTreeItem(b);const d=new A.DisposableStore,n=this.createHandle(l,b,t),i=this.getLightIconPath(b);return{item:{handle:n,parentHandle:t?t.item.handle:void 0,label:h(b.label,this.extension),description:b.description,resourceUri:b.resourceUri,tooltip:this.getTooltip(b.tooltip),command:this.getCommand(d,b.command),contextValue:b.contextValue,icon:i,iconDark:this.getDarkIconPath(b)||i,themeIcon:this.getThemeIcon(b),collapsibleState:(0,F.isUndefinedOrNull)(b.collapsibleState)?k.TreeItemCollapsibleState.None:b.collapsibleState,accessibilityInformation:b.accessibilityInformation,checkboxChecked:this.getCheckbox(b)},extensionItem:b,parent:t,children:void 0,disposableStore:d,dispose(){d.dispose()}}}getThemeIcon(l){return l.iconPath instanceof k.ThemeIcon?l.iconPath:void 0}createHandle(l,{id:b,label:t,resourceUri:d},n,i){if(b)return`${v.ID_HANDLE_PREFIX}/${b}`;const s=h(t,this.extension),a=n?n.item.handle:v.LABEL_HANDLE_PREFIX;let o=s?s.label:d?(0,w.basename)(d):"";o=o.indexOf("/")!==-1?o.replace("/","//"):o;const g=this.nodes.has(l)?this.nodes.get(l).item.handle:void 0,p=this.getChildrenNodes(n)||[];let P,M=0;do{if(P=`${a}/${M}:${o}`,i||!this.elements.has(P)||g===P)break;M++}while(M<=p.length);return P}getLightIconPath(l){if(l.iconPath&&!(l.iconPath instanceof k.ThemeIcon))return typeof l.iconPath=="string"||L.URI.isUri(l.iconPath)?this.getIconPath(l.iconPath):this.getIconPath(l.iconPath.light)}getDarkIconPath(l){if(l.iconPath&&!(l.iconPath instanceof k.ThemeIcon)&&l.iconPath.dark)return this.getIconPath(l.iconPath.dark)}getIconPath(l){return L.URI.isUri(l)?l:L.URI.file(l)}addNodeToCache(l,b){this.elements.set(b.item.handle,l),this.nodes.set(l,b)}updateNodeCache(l,b,t,d){this.elements.delete(b.item.handle),this.nodes.delete(l),b.item.handle!==t.item.handle&&this.elements.delete(t.item.handle),this.addNodeToCache(l,b);const n=this.getChildrenNodes(d)||[],i=n.filter(s=>s.item.handle===t.item.handle)[0];i&&n.splice(n.indexOf(i),1,b)}addNodeToParentCache(l,b){b?(b.children||(b.children=[]),b.children.push(l)):(this.roots||(this.roots=[]),this.roots.push(l))}clearChildren(l){if(l){const b=this.nodes.get(l);if(b){if(b.children)for(const t of b.children){const d=this.elements.get(t.item.handle);d&&this.clear(d)}b.children=void 0}}else this.clearAll()}clear(l){const b=this.nodes.get(l);if(b){if(b.children)for(const t of b.children){const d=this.elements.get(t.item.handle);d&&this.clear(d)}this.nodes.delete(l),this.elements.delete(b.item.handle),b.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(l=>l.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}v.LABEL_HANDLE_PREFIX="0",v.ID_HANDLE_PREFIX="1"}),define(Ce[236],Ie([1,0,20,11,5,29,2,121,246,110,119,39,4,91,189,188,36,190,32,192,193,194,177,195,50,33,197,198,201,203,205,99,180,209,210,211,69,53,214,235,8,6,217,54,98,31,161,200,86,96,101,103,104,15,46,13,28,206,175,62,67,186,215,70,52,220,218,219,187,35,212,216,68,51,87,207,100,208,12,82,179,158,199,7,24,163,97]),function(te,e,r,y,w,L,_,A,E,k,F,S,m,T,f,c,h,u,v,I,l,b,t,d,n,i,s,a,o,g,p,P,M,V,B,D,x,U,R,K,W,O,Z,ue,oe,de,ie,ve,be,ne,Ee,Pe,Fe,$e,Qe,Te,_e,ye,ae,le,Q,J,C,z,H,j,se,ce,Y,pe,ge,Ne,Be,Ye,Xe,ke,nt,G,X,fe,Ue,We,et,qe,Ve,it,st){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function dt(at){const rt=at.get(_e.IExtHostInitDataService),_t=at.get(pe.IExtHostFileSystemInfo),Rt=at.get(H.IExtHostConsumerFileSystem),Ot=at.get(i.IExtHostExtensionService),mt=at.get(de.IExtHostWorkspace),Dt=at.get(Xe.IExtHostTelemetry),Nt=at.get(v.IExtHostConfiguration),Mt=at.get(Qe.IURITransformerService),je=at.get(Te.IExtHostRpcService),Ut=at.get(x.IExtHostStorage),Ft=at.get(z.IExtensionStoragePaths),Tt=at.get($e.ILoggerService),gt=at.get($e.ILogService),yt=at.get(le.IExtHostTunnelService),Se=at.get(st.IExtHostTelemetryLogService),De=at.get(Q.IExtHostApiDeprecationService),me=at.get(oe.IExtHostWindow),q=at.get(Be.IExtHostSecretState),Ae=at.get(Ye.IExtHostEditorTabs);je.set(m.ExtHostContext.ExtHostFileSystemInfo,_t),je.set(m.ExtHostContext.ExtHostLogLevelServiceShape,Tt),je.set(m.ExtHostContext.ExtHostWorkspace,mt),je.set(m.ExtHostContext.ExtHostConfiguration,Nt),je.set(m.ExtHostContext.ExtHostExtensionService,Ot),je.set(m.ExtHostContext.ExtHostStorage,Ut),je.set(m.ExtHostContext.ExtHostTunnelService,yt),je.set(m.ExtHostContext.ExtHostWindow,me),je.set(m.ExtHostContext.ExtHostSecretState,q),je.set(m.ExtHostContext.ExtHostTelemetry,Dt),je.set(m.ExtHostContext.ExtHostEditorTabs,Ae);const Le=je.set(m.ExtHostContext.ExtHostDecorations,at.get(ne.IExtHostDecorations)),tt=je.set(m.ExtHostContext.ExtHostDocumentsAndEditors,at.get(n.IExtHostDocumentsAndEditors)),Ge=je.set(m.ExtHostContext.ExtHostCommands,at.get(h.IExtHostCommands)),Ke=je.set(m.ExtHostContext.ExtHostTerminalService,at.get(U.IExtHostTerminalService)),ct=je.set(m.ExtHostContext.ExtHostDebugService,at.get(Pe.IExtHostDebugService)),Ct=je.set(m.ExtHostContext.ExtHostSearch,at.get(Fe.IExtHostSearch)),pt=je.set(m.ExtHostContext.ExtHostTask,at.get(Ee.IExtHostTask)),It=je.set(m.ExtHostContext.ExtHostOutputService,at.get(P.IExtHostOutputService)),bt=je.set(m.ExtHostContext.ExtHostUrls,new Z.ExtHostUrls(je)),vt=je.set(m.ExtHostContext.ExtHostDocuments,new d.ExtHostDocuments(je,tt)),wt=je.set(m.ExtHostContext.ExtHostDocumentContentProviders,new b.ExtHostDocumentContentProvider(je,tt,gt)),ti=je.set(m.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(gt,vt,je.getProxy(m.MainContext.MainThreadBulkEdits))),Et=je.set(m.ExtHostContext.ExtHostNotebook,new ye.ExtHostNotebookController(je,Ge,tt,vt)),$t=je.set(m.ExtHostContext.ExtHostNotebookDocuments,new We.ExtHostNotebookDocuments(Et)),Wt=je.set(m.ExtHostContext.ExtHostNotebookEditors,new Ue.ExtHostNotebookEditors(gt,Et)),ii=je.set(m.ExtHostContext.ExtHostNotebookKernels,new ke.ExtHostNotebookKernels(je,rt,Et,Ge,gt)),gi=je.set(m.ExtHostContext.ExtHostNotebookRenderers,new G.ExtHostNotebookRenderers(je,Et)),kt=je.set(m.ExtHostContext.ExtHostEditors,new R.ExtHostEditors(je,tt)),ni=je.set(m.ExtHostContext.ExtHostTreeViews,new K.ExtHostTreeViews(je.getProxy(m.MainContext.MainThreadTreeViews),Ge,gt)),Ht=je.set(m.ExtHostContext.ExtHostEditorInsets,new ie.ExtHostEditorInsets(je.getProxy(m.MainContext.MainThreadEditorInsets),kt,rt.remote)),Yt=je.set(m.ExtHostContext.ExtHostDiagnostics,new I.ExtHostDiagnostics(je,gt,_t)),ri=je.set(m.ExtHostContext.ExtHostLanguages,new g.ExtHostLanguages(je,vt,Ge.converter,Mt)),ut=je.set(m.ExtHostContext.ExtHostLanguageFeatures,new o.ExtHostLanguageFeatures(je,Mt,vt,Ge,Yt,gt,De)),Jt=je.set(m.ExtHostContext.ExtHostFileSystem,new s.ExtHostFileSystem(je,ut)),zt=je.set(m.ExtHostContext.ExtHostFileSystemEventService,new a.ExtHostFileSystemEventService(je,gt,tt)),Kt=je.set(m.ExtHostContext.ExtHostQuickOpen,(0,V.createExtHostQuickOpen)(je,mt,Ge)),si=je.set(m.ExtHostContext.ExtHostSCM,new B.ExtHostSCM(je,Ge,gt)),pi=je.set(m.ExtHostContext.ExtHostComments,(0,u.createExtHostComments)(je,Ge,vt)),oi=je.set(m.ExtHostContext.ExtHostProgress,new M.ExtHostProgress(je.getProxy(m.MainContext.MainThreadProgress))),vi=je.set(m.ExtHostContext.ExtHosLabelService,new ve.ExtHostLabelService(je)),ai=je.set(m.ExtHostContext.ExtHostTheming,new ae.ExtHostTheming(je)),Zt=je.set(m.ExtHostContext.ExtHostAuthentication,new J.ExtHostAuthentication(je)),Ri=je.set(m.ExtHostContext.ExtHostTimeline,new C.ExtHostTimeline(je,Ge)),Ei=je.set(m.ExtHostContext.ExtHostWebviews,new ue.ExtHostWebviews(je,rt.remote,mt,gt,De)),ei=je.set(m.ExtHostContext.ExtHostWebviewPanels,new ce.ExtHostWebviewPanels(je,Ei,mt)),bi=je.set(m.ExtHostContext.ExtHostCustomEditors,new se.ExtHostCustomEditors(je,vt,Ft,Ei,ei)),wi=je.set(m.ExtHostContext.ExtHostWebviewViews,new j.ExtHostWebviewViews(je,Ei)),Gt=je.set(m.ExtHostContext.ExtHostTesting,new ge.ExtHostTesting(je,Ge,tt)),Oi=je.set(m.ExtHostContext.ExtHostUriOpeners,new Ne.ExtHostUriOpeners(je));je.set(m.ExtHostContext.ExtHostInteractive,new et.ExtHostInteractive(je,Et,tt,Ge,gt));const Si=Object.values(m.ExtHostContext);je.assertRegistered(Si);const _i=new Y.ExtHostBulkEdits(je,tt),Fi=new c.ExtHostClipboard(je),yi=new p.ExtHostMessageService(je,gt),Ii=new l.ExtHostDialogs(je),Ti=new D.ExtHostStatusBar(je,Ge.converter);return f.ExtHostApiCommands.register(Ge),function(Me,Vt,ci){const ft=function(){let re=!Me.isUnderDevelopment;function he(){re||(gt.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),re=!0)}return function Re(ot){if(Array.isArray(ot))ot.forEach(Re);else if(typeof ot=="string")he();else{const St=ot;typeof St.scheme>"u"&&he(),typeof St.exclusive=="boolean"&&(0,Ve.checkProposedApiEnabled)(Me,"documentFiltersExclusive")}return ot}}(),Ni={getSession(re,he,Re){return Zt.getSession(Me,re,he,Re)},async hasSession(re,he){return(0,Ve.checkProposedApiEnabled)(Me,"authSession"),!!await Zt.getSession(Me,re,he,{silent:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(re,he,Re,ot){return Zt.registerAuthenticationProvider(re,he,Re,ot)}},Mi={registerCommand(re,he,Re){return Ge.registerCommand(!0,re,he,Re,void 0,Me)},registerTextEditorCommand(re,he,Re){return Ge.registerCommand(!0,re,(...ot)=>{const St=kt.getActiveTextEditor();if(!St){gt.warn("Cannot execute "+re+" because there is no active text editor.");return}return St.edit(Pt=>{he.apply(Re,[St,Pt,...ot])}).then(Pt=>{Pt||gt.warn("Edits from command "+re+" were not applied.")},Pt=>{gt.warn("An error occurred while running command "+re,Pt)})},void 0,void 0,Me)},registerDiffInformationCommand:(re,he,Re)=>((0,Ve.checkProposedApiEnabled)(Me,"diffCommand"),Ge.registerCommand(!0,re,async(...ot)=>{const St=tt.activeEditor(!0);if(!St){gt.warn("Cannot execute "+re+" because there is no active text editor.");return}const Pt=await kt.getDiffInformation(St.id);he.apply(Re,[Pt,...ot])},void 0,void 0,Me)),executeCommand(re,...he){return Ge.executeCommand(re,...he)},getCommands(re=!1){return Ge.getCommands(re)}},ki={get machineId(){return rt.telemetryInfo.machineId},get sessionId(){return rt.telemetryInfo.sessionId},get language(){return rt.environment.appLanguage},get appName(){return rt.environment.appName},get appRoot(){return rt.environment.appRoot?.fsPath??""},get appHost(){return rt.environment.appHost},get uriScheme(){return rt.environment.appUriScheme},get clipboard(){return Fi.value},get shell(){return Ke.getDefaultShell(!1)},get isTelemetryEnabled(){return Dt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Dt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ve.checkProposedApiEnabled)(Me,"telemetry"),Dt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ve.checkProposedApiEnabled)(Me,"telemetry"),Dt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){const re=Date.now()-new Date(rt.telemetryInfo.firstSessionDate).getTime();return isNaN(re)?!1:re<1e3*60*60*24},openExternal(re,he){return me.openUri(re,{allowTunneling:!!rt.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(re){if(re.scheme===rt.environment.appUriScheme)return bt.createAppUri(re);try{return await me.asExternalUri(re,{allowTunneling:!!rt.remote.authority})}catch(he){if((0,fe.matchesScheme)(re,X.Schemas.http)||(0,fe.matchesScheme)(re,X.Schemas.https))return re;throw he}},get remoteName(){return(0,be.getRemoteName)(rt.remote.authority)},get remoteAuthority(){return(0,Ve.checkProposedApiEnabled)(Me,"resolvers"),rt.remote.authority},get uiKind(){return rt.uiKind}};rt.environment.extensionTestsLocationURI||Object.freeze(ki);const li={createTestController(re,he,Re){return Gt.createTestController(re,he,Re)},createTestObserver(){return(0,Ve.checkProposedApiEnabled)(Me,"testObserver"),Gt.createTestObserver()},runTests(re){return(0,Ve.checkProposedApiEnabled)(Me,"testObserver"),Gt.runTests(re)},get onDidChangeTestResults(){return(0,Ve.checkProposedApiEnabled)(Me,"testObserver"),Gt.onResultsChanged},get testResults(){return(0,Ve.checkProposedApiEnabled)(Me,"testObserver"),Gt.results}},ui=rt.remote.isRemote?O.ExtensionKind.Workspace:O.ExtensionKind.UI,Li={getExtension(re,he){(0,Ve.isProposedApiEnabled)(Me,"extensionsAny")||(he=!1);const Re=Vt.mine.getExtensionDescription(re);if(Re)return new i.Extension(Ot,Me.identifier,Re,ui,!1);if(he){const ot=Vt.all.getExtensionDescription(re);if(ot)return new i.Extension(Ot,Me.identifier,ot,ui,!0)}},get all(){const re=[];for(const he of Vt.mine.getAllExtensionDescriptions())re.push(new i.Extension(Ot,Me.identifier,he,ui,!1));return re},get allAcrossExtensionHosts(){(0,Ve.checkProposedApiEnabled)(Me,"extensionsAny");const re=new Ve.ExtensionIdentifierSet(Vt.mine.getAllExtensionDescriptions().map(Re=>Re.identifier)),he=[];for(const Re of Vt.all.getAllExtensionDescriptions()){const ot=!re.has(Re.identifier);he.push(new i.Extension(Ot,Me.identifier,Re,ui,ot))}return he},get onDidChange(){return(0,Ve.isProposedApiEnabled)(Me,"extensionsAny")?w.Event.any(Vt.mine.onDidChange,Vt.all.onDidChange):Vt.mine.onDidChange}},Ui={createDiagnosticCollection(re){return Yt.createDiagnosticCollection(Me.identifier,re)},get onDidChangeDiagnostics(){return Yt.onDidChangeDiagnostics},getDiagnostics:re=>Yt.getDiagnostics(re),getLanguages(){return ri.getLanguages()},setTextDocumentLanguage(re,he){return ri.changeLanguage(re.uri,he)},match(re,he){const Re=vt.getDocumentData(he.uri)?.notebook;return(0,F.score)(W.LanguageSelector.from(re),he.uri,he.languageId,!0,Re?.uri,Re?.notebookType)},registerCodeActionsProvider(re,he,Re){return ut.registerCodeActionProvider(Me,ft(re),he,Re)},registerDocumentPasteEditProvider(re,he,Re){return(0,Ve.checkProposedApiEnabled)(Me,"documentPaste"),ut.registerDocumentPasteEditProvider(Me,ft(re),he,Re)},registerCodeLensProvider(re,he){return ut.registerCodeLensProvider(Me,ft(re),he)},registerDefinitionProvider(re,he){return ut.registerDefinitionProvider(Me,ft(re),he)},registerDeclarationProvider(re,he){return ut.registerDeclarationProvider(Me,ft(re),he)},registerImplementationProvider(re,he){return ut.registerImplementationProvider(Me,ft(re),he)},registerTypeDefinitionProvider(re,he){return ut.registerTypeDefinitionProvider(Me,ft(re),he)},registerHoverProvider(re,he){return ut.registerHoverProvider(Me,ft(re),he,Me.identifier)},registerEvaluatableExpressionProvider(re,he){return ut.registerEvaluatableExpressionProvider(Me,ft(re),he,Me.identifier)},registerInlineValuesProvider(re,he){return ut.registerInlineValuesProvider(Me,ft(re),he,Me.identifier)},registerDocumentHighlightProvider(re,he){return ut.registerDocumentHighlightProvider(Me,ft(re),he)},registerLinkedEditingRangeProvider(re,he){return ut.registerLinkedEditingRangeProvider(Me,ft(re),he)},registerReferenceProvider(re,he){return ut.registerReferenceProvider(Me,ft(re),he)},registerRenameProvider(re,he){return ut.registerRenameProvider(Me,ft(re),he)},registerDocumentSymbolProvider(re,he,Re){return ut.registerDocumentSymbolProvider(Me,ft(re),he,Re)},registerWorkspaceSymbolProvider(re){return ut.registerWorkspaceSymbolProvider(Me,re)},registerDocumentFormattingEditProvider(re,he){return ut.registerDocumentFormattingEditProvider(Me,ft(re),he)},registerDocumentRangeFormattingEditProvider(re,he){return ut.registerDocumentRangeFormattingEditProvider(Me,ft(re),he)},registerOnTypeFormattingEditProvider(re,he,Re,...ot){return ut.registerOnTypeFormattingEditProvider(Me,ft(re),he,[Re].concat(ot))},registerDocumentSemanticTokensProvider(re,he,Re){return ut.registerDocumentSemanticTokensProvider(Me,ft(re),he,Re)},registerDocumentRangeSemanticTokensProvider(re,he,Re){return ut.registerDocumentRangeSemanticTokensProvider(Me,ft(re),he,Re)},registerSignatureHelpProvider(re,he,Re,...ot){return typeof Re=="object"?ut.registerSignatureHelpProvider(Me,ft(re),he,Re):ut.registerSignatureHelpProvider(Me,ft(re),he,typeof Re>"u"?[]:[Re,...ot])},registerCompletionItemProvider(re,he,...Re){return ut.registerCompletionItemProvider(Me,ft(re),he,Re)},registerInlineCompletionItemProvider(re,he){return he.handleDidShowCompletionItem&&(0,Ve.checkProposedApiEnabled)(Me,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(Me,ft(re),he)},registerInlineCompletionItemProviderNew(re,he){if((0,Ve.checkProposedApiEnabled)(Me,"inlineCompletionsNew"),he.handleDidShowCompletionItem&&!(0,Ve.isProposedApiEnabled)(Me,"inlineCompletionsAdditions"))throw new Error(`When the method "handleDidShowCompletionItem" is implemented on a provider, the usage of the proposed api 'inlineCompletionsAdditions' must be declared!`);return ut.registerInlineCompletionsProviderNew(Me,ft(re),he)},registerDocumentLinkProvider(re,he){return ut.registerDocumentLinkProvider(Me,ft(re),he)},registerColorProvider(re,he){return ut.registerColorProvider(Me,ft(re),he)},registerFoldingRangeProvider(re,he){return ut.registerFoldingRangeProvider(Me,ft(re),he)},registerSelectionRangeProvider(re,he){return ut.registerSelectionRangeProvider(Me,re,he)},registerCallHierarchyProvider(re,he){return ut.registerCallHierarchyProvider(Me,re,he)},registerTypeHierarchyProvider(re,he){return ut.registerTypeHierarchyProvider(Me,re,he)},setLanguageConfiguration:(re,he)=>ut.setLanguageConfiguration(Me,re,he),getTokenInformationAtPosition(re,he){return(0,Ve.checkProposedApiEnabled)(Me,"tokenInformation"),ri.tokenAtPosition(re,he)},registerInlayHintsProvider(re,he){return ut.registerInlayHintsProvider(Me,re,he)},createLanguageStatusItem(re,he){return ri.createLanguageStatusItem(Me,re,he)},registerDocumentDropEditProvider(re,he){return ut.registerDocumentOnDropEditProvider(Me,re,he)}},Bi={get activeTextEditor(){return kt.getActiveTextEditor()},get visibleTextEditors(){return kt.getVisibleTextEditors()},get activeTerminal(){return Ke.activeTerminal},get terminals(){return Ke.terminals},async showTextDocument(re,he,Re){const ot=await(_.URI.isUri(re)?Promise.resolve(di.openTextDocument(re)):Promise.resolve(re));return kt.showTextDocument(ot,he,Re)},createTextEditorDecorationType(re){return kt.createTextEditorDecorationType(Me,re)},onDidChangeActiveTextEditor(re,he,Re){return kt.onDidChangeActiveTextEditor(re,he,Re)},onDidChangeVisibleTextEditors(re,he,Re){return kt.onDidChangeVisibleTextEditors(re,he,Re)},onDidChangeTextEditorSelection(re,he,Re){return kt.onDidChangeTextEditorSelection(re,he,Re)},onDidChangeTextEditorOptions(re,he,Re){return kt.onDidChangeTextEditorOptions(re,he,Re)},onDidChangeTextEditorVisibleRanges(re,he,Re){return kt.onDidChangeTextEditorVisibleRanges(re,he,Re)},onDidChangeTextEditorViewColumn(re,he,Re){return kt.onDidChangeTextEditorViewColumn(re,he,Re)},onDidCloseTerminal(re,he,Re){return Ke.onDidCloseTerminal(re,he,Re)},onDidOpenTerminal(re,he,Re){return Ke.onDidOpenTerminal(re,he,Re)},onDidChangeActiveTerminal(re,he,Re){return Ke.onDidChangeActiveTerminal(re,he,Re)},onDidChangeTerminalDimensions(re,he,Re){return(0,Ve.checkProposedApiEnabled)(Me,"terminalDimensions"),Ke.onDidChangeTerminalDimensions(re,he,Re)},onDidChangeTerminalState(re,he,Re){return Ke.onDidChangeTerminalState(re,he,Re)},onDidWriteTerminalData(re,he,Re){return(0,Ve.checkProposedApiEnabled)(Me,"terminalDataWriteEvent"),Ke.onDidWriteTerminalData(re,he,Re)},get state(){return me.state},onDidChangeWindowState(re,he,Re){return me.onDidChangeWindowState(re,he,Re)},showInformationMessage(re,...he){return yi.showMessage(Me,L.default.Info,re,he[0],he.slice(1))},showWarningMessage(re,...he){return yi.showMessage(Me,L.default.Warning,re,he[0],he.slice(1))},showErrorMessage(re,...he){return yi.showMessage(Me,L.default.Error,re,he[0],he.slice(1))},showQuickPick(re,he,Re){return Kt.showQuickPick(re,he,Re)},showWorkspaceFolderPick(re){return Kt.showWorkspaceFolderPick(re)},showInputBox(re,he){return Kt.showInput(re,he)},showOpenDialog(re){return Ii.showOpenDialog(re)},showSaveDialog(re){return Ii.showSaveDialog(re)},createStatusBarItem(re,he,Re){let ot,St,Pt;return typeof re=="string"?(ot=re,St=he,Pt=Re):(St=re,Pt=he),Ti.createStatusBarEntry(Me,ot,St,Pt)},setStatusBarMessage(re,he){return Ti.setStatusBarMessage(re,he)},withScmProgress(re){return De.report("window.withScmProgress",Me,"Use 'withProgress' instead."),oi.withProgress(Me,{location:O.ProgressLocation.SourceControl},(he,Re)=>re({report(ot){}}))},withProgress(re,he){return oi.withProgress(Me,re,he)},createOutputChannel(re,he){return It.createOutputChannel(re,he,Me)},createWebviewPanel(re,he,Re,ot){return ei.createWebviewPanel(Me,re,he,Re,ot)},createWebviewTextEditorInset(re,he,Re,ot){return(0,Ve.checkProposedApiEnabled)(Me,"editorInsets"),Ht.createWebviewEditorInset(re,he,Re,ot,Me)},createTerminal(re,he,Re){return typeof re=="object"?"pty"in re?Ke.createExtensionTerminal(re):Ke.createTerminalFromOptions(re):Ke.createTerminal(re,he,Re)},registerTerminalLinkProvider(re){return Ke.registerLinkProvider(re)},registerTerminalProfileProvider(re,he){return Ke.registerProfileProvider(Me,re,he)},registerTreeDataProvider(re,he){return ni.registerTreeDataProvider(re,he,Me)},createTreeView(re,he){return ni.createTreeView(re,he,Me)},registerWebviewPanelSerializer:(re,he)=>ei.registerWebviewPanelSerializer(Me,re,he),registerCustomEditorProvider:(re,he,Re={})=>bi.registerCustomEditorProvider(Me,re,he,Re),registerFileDecorationProvider(re){return Le.registerFileDecorationProvider(re,Me.identifier)},registerUriHandler(re){return bt.registerUriHandler(Me.identifier,re)},createQuickPick(){return Kt.createQuickPick(Me)},createInputBox(){return Kt.createInputBox(Me)},get activeColorTheme(){return ai.activeColorTheme},onDidChangeActiveColorTheme(re,he,Re){return ai.onDidChangeActiveColorTheme(re,he,Re)},registerWebviewViewProvider(re,he,Re){return wi.registerWebviewViewProvider(Me,re,he,Re?.webviewOptions)},get activeNotebookEditor(){return Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(re,he,Re){return Et.onDidChangeActiveNotebookEditor(re,he,Re)},get visibleNotebookEditors(){return Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(re,he,Re){return Wt.onDidChangeNotebookEditorSelection(re,he,Re)},onDidChangeNotebookEditorVisibleRanges(re,he,Re){return Wt.onDidChangeNotebookEditorVisibleRanges(re,he,Re)},showNotebookDocument(re,he){return _.URI.isUri(re)&&De.report("window.showNotebookDocument(uri)",Me,"Please use 'workspace.openNotebookDocument' and 'window.showNotebookDocument'"),Et.showNotebookDocument(re,he)},registerExternalUriOpener(re,he,Re){return(0,Ve.checkProposedApiEnabled)(Me,"externalUriOpener"),Oi.registerExternalUriOpener(Me.identifier,re,he,Re)},get tabGroups(){return Ae.tabGroups},logTelemetryToOutputChannel(re,he){(0,Ve.checkProposedApiEnabled)(Me,"telemetryLog"),Se.logToTelemetryOutputChannel(Me,re,he)}},di={get rootPath(){return De.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),mt.getPath()},set rootPath(re){throw y.readonly()},getWorkspaceFolder(re){return mt.getWorkspaceFolder(re)},get workspaceFolders(){return mt.getWorkspaceFolders()},get name(){return mt.name},set name(re){throw y.readonly()},get workspaceFile(){return mt.workspaceFile},set workspaceFile(re){throw y.readonly()},updateWorkspaceFolders:(re,he,...Re)=>mt.updateWorkspaceFolders(Me,re,he||0,...Re),onDidChangeWorkspaceFolders:function(re,he,Re){return mt.onDidChangeWorkspace(re,he,Re)},asRelativePath:(re,he)=>mt.getRelativePath(re,he),findFiles:(re,he,Re,ot)=>mt.findFiles(re,he,Re,Me.identifier,ot),findTextInFiles:(re,he,Re,ot)=>{(0,Ve.checkProposedApiEnabled)(Me,"findTextInFiles");let St,Pt;return typeof he=="object"?(St=he,Pt=Re):(St={},Pt=he,ot=Re),mt.findTextInFiles(re,St||{},Pt,Me.identifier,ot)},saveAll:re=>mt.saveAll(re),applyEdit(re,he){return _i.applyWorkspaceEdit(re,Me,he)},createFileSystemWatcher:(re,he,Re,ot)=>zt.createFileSystemWatcher(mt,Me,re,he,Re,ot),get textDocuments(){return vt.getAllDocumentData().map(re=>re.document)},set textDocuments(re){throw y.readonly()},openTextDocument(re){let he;const Re=re;if(typeof re=="string")he=Promise.resolve(_.URI.file(re));else if(_.URI.isUri(re))he=Promise.resolve(re);else if(!Re||typeof Re=="object")he=vt.createDocumentData(Re);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(ot=>vt.ensureDocumentData(ot).then(St=>St.document))},onDidOpenTextDocument:(re,he,Re)=>vt.onDidAddDocument(re,he,Re),onDidCloseTextDocument:(re,he,Re)=>vt.onDidRemoveDocument(re,he,Re),onDidChangeTextDocument:(re,he,Re)=>vt.onDidChangeDocument(re,he,Re),onDidSaveTextDocument:(re,he,Re)=>vt.onDidSaveDocument(re,he,Re),onWillSaveTextDocument:(re,he,Re)=>ti.getOnWillSaveTextDocumentEvent(Me)(re,he,Re),get notebookDocuments(){return Et.notebookDocuments.map(re=>re.apiNotebook)},async openNotebookDocument(re,he){let Re;if(_.URI.isUri(re))Re=re,await Et.openNotebookDocument(re);else if(typeof re=="string")Re=_.URI.revive(await Et.createNotebookDocument({viewType:re,content:he}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(Re).apiNotebook},onDidSaveNotebookDocument(re,he,Re){return $t.onDidSaveNotebookDocument(re,he,Re)},onDidChangeNotebookDocument(re,he,Re){return $t.onDidChangeNotebookDocument(re,he,Re)},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(re,he,Re,ot){return Et.registerNotebookSerializer(Me,re,he,Re,(0,Ve.isProposedApiEnabled)(Me,"notebookLiveShare")?ot:void 0)},registerNotebookContentProvider:(re,he,Re,ot)=>((0,Ve.checkProposedApiEnabled)(Me,"notebookContentProvider"),De.report("workspace.registerNotebookContentProvider",Me,"The notebookContentProvider API is not on track for finalization and will be removed."),Et.registerNotebookContentProvider(Me,re,he,Re,(0,Ve.isProposedApiEnabled)(Me,"notebookLiveShare")?ot:void 0)),onDidChangeConfiguration:(re,he,Re)=>ci.onDidChangeConfiguration(re,he,Re),getConfiguration(re,he){return he=arguments.length===1?void 0:he,ci.getConfiguration(re,he,Me)},registerTextDocumentContentProvider(re,he){return wt.registerTextDocumentContentProvider(re,he)},registerTaskProvider:(re,he)=>(De.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),pt.registerTaskProvider(Me,re,he)),registerFileSystemProvider(re,he,Re){return(0,qe.combinedDisposable)(Jt.registerFileSystemProvider(Me,re,he,Re),Rt.addFileSystemProvider(re,he))},get fs(){return Rt.value},registerFileSearchProvider:(re,he)=>((0,Ve.checkProposedApiEnabled)(Me,"fileSearchProvider"),Ct.registerFileSearchProvider(re,he)),registerTextSearchProvider:(re,he)=>((0,Ve.checkProposedApiEnabled)(Me,"textSearchProvider"),Ct.registerTextSearchProvider(re,he)),registerRemoteAuthorityResolver:(re,he)=>((0,Ve.checkProposedApiEnabled)(Me,"resolvers"),Ot.registerRemoteAuthorityResolver(re,he)),registerResourceLabelFormatter:re=>((0,Ve.checkProposedApiEnabled)(Me,"resolvers"),vi.$registerResourceLabelFormatter(re)),onDidCreateFiles:(re,he,Re)=>zt.onDidCreateFile(re,he,Re),onDidDeleteFiles:(re,he,Re)=>zt.onDidDeleteFile(re,he,Re),onDidRenameFiles:(re,he,Re)=>zt.onDidRenameFile(re,he,Re),onWillCreateFiles:(re,he,Re)=>zt.getOnWillCreateFileEvent(Me)(re,he,Re),onWillDeleteFiles:(re,he,Re)=>zt.getOnWillDeleteFileEvent(Me)(re,he,Re),onWillRenameFiles:(re,he,Re)=>zt.getOnWillRenameFileEvent(Me)(re,he,Re),openTunnel:re=>((0,Ve.checkProposedApiEnabled)(Me,"resolvers"),yt.openTunnel(Me,re).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,Ve.checkProposedApiEnabled)(Me,"resolvers"),yt.getTunnels()},onDidChangeTunnels:(re,he,Re)=>((0,Ve.checkProposedApiEnabled)(Me,"resolvers"),yt.onDidChangeTunnels(re,he,Re)),registerPortAttributesProvider:(re,he)=>((0,Ve.checkProposedApiEnabled)(Me,"portsAttributes"),yt.registerPortsAttributesProvider(re,he)),registerTimelineProvider:(re,he)=>((0,Ve.checkProposedApiEnabled)(Me,"timeline"),Ri.registerTimelineProvider(re,he,Me.identifier,Ge.converter)),get isTrusted(){return mt.trusted},requestWorkspaceTrust:re=>((0,Ve.checkProposedApiEnabled)(Me,"workspaceTrust"),mt.requestWorkspaceTrust(re)),onDidGrantWorkspaceTrust:(re,he,Re)=>mt.onDidGrantWorkspaceTrust(re,he,Re),registerEditSessionIdentityProvider:(re,he)=>((0,Ve.checkProposedApiEnabled)(Me,"editSessionIdentityProvider"),mt.registerEditSessionIdentityProvider(re,he))},zi={get inputBox(){return De.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),si.getLastInputBox(Me)},createSourceControl(re,he,Re){return si.createSourceControl(Me,re,he,Re)}},jt={createCommentController(re,he){return pi.createCommentController(Me,re,he)}},hi={get activeDebugSession(){return ct.activeDebugSession},get activeDebugConsole(){return ct.activeDebugConsole},get breakpoints(){return ct.breakpoints},onDidStartDebugSession(re,he,Re){return ct.onDidStartDebugSession(re,he,Re)},onDidTerminateDebugSession(re,he,Re){return ct.onDidTerminateDebugSession(re,he,Re)},onDidChangeActiveDebugSession(re,he,Re){return ct.onDidChangeActiveDebugSession(re,he,Re)},onDidReceiveDebugSessionCustomEvent(re,he,Re){return ct.onDidReceiveDebugSessionCustomEvent(re,he,Re)},onDidChangeBreakpoints(re,he,Re){return ct.onDidChangeBreakpoints(re,he,Re)},registerDebugConfigurationProvider(re,he,Re){return ct.registerDebugConfigurationProvider(re,he,Re||it.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(re,he){return ct.registerDebugAdapterDescriptorFactory(Me,re,he)},registerDebugAdapterTrackerFactory(re,he){return ct.registerDebugAdapterTrackerFactory(re,he)},startDebugging(re,he,Re){return!Re||typeof Re=="object"&&"configuration"in Re?ct.startDebugging(re,he,{parentSession:Re}):ct.startDebugging(re,he,Re||{})},stopDebugging(re){return ct.stopDebugging(re)},addBreakpoints(re){return ct.addBreakpoints(re)},removeBreakpoints(re){return ct.removeBreakpoints(re)},asDebugSourceUri(re,he){return ct.asDebugSourceUri(re,he)}},xi={registerTaskProvider:(re,he)=>pt.registerTaskProvider(Me,re,he),fetchTasks:re=>pt.fetchTasks(re),executeTask:re=>pt.executeTask(Me,re),get taskExecutions(){return pt.taskExecutions},onDidStartTask:(re,he,Re)=>pt.onDidStartTask(re,he,Re),onDidEndTask:(re,he,Re)=>pt.onDidEndTask(re,he,Re),onDidStartTaskProcess:(re,he,Re)=>pt.onDidStartTaskProcess(re,he,Re),onDidEndTaskProcess:(re,he,Re)=>pt.onDidEndTaskProcess(re,he,Re)},Lt={createNotebookController(re,he,Re,ot,St){return ii.createNotebookController(Me,re,he,Re,ot,(0,Ve.isProposedApiEnabled)(Me,"notebookMessaging")?St:void 0)},registerNotebookCellStatusBarItemProvider:(re,he)=>Et.registerNotebookCellStatusBarItemProvider(Me,re,he),createRendererMessaging(re){return gi.createRendererMessaging(Me,re)},onDidChangeNotebookCellExecutionState(re,he,Re){return(0,Ve.checkProposedApiEnabled)(Me,"notebookCellExecutionState"),ii.onDidChangeNotebookCellExecutionState(re,he,Re)}};return{version:rt.version,authentication:Ni,commands:Mi,comments:jt,debug:hi,env:ki,extensions:Li,languages:Ui,notebooks:Lt,scm:zi,tasks:xi,tests:li,window:Bi,workspace:di,Breakpoint:O.Breakpoint,CallHierarchyIncomingCall:O.CallHierarchyIncomingCall,CallHierarchyItem:O.CallHierarchyItem,CallHierarchyOutgoingCall:O.CallHierarchyOutgoingCall,CancellationError:y.CancellationError,CancellationTokenSource:r.CancellationTokenSource,CandidatePortSource:m.CandidatePortSource,CodeAction:O.CodeAction,CodeActionKind:O.CodeActionKind,CodeActionTriggerKind:O.CodeActionTriggerKind,CodeLens:O.CodeLens,Color:O.Color,ColorInformation:O.ColorInformation,ColorPresentation:O.ColorPresentation,ColorThemeKind:O.ColorThemeKind,CommentMode:O.CommentMode,CommentThreadCollapsibleState:O.CommentThreadCollapsibleState,CommentThreadState:O.CommentThreadState,CompletionItem:O.CompletionItem,CompletionItemKind:O.CompletionItemKind,CompletionItemTag:O.CompletionItemTag,CompletionList:O.CompletionList,CompletionTriggerKind:O.CompletionTriggerKind,ConfigurationTarget:O.ConfigurationTarget,CustomExecution:O.CustomExecution,DebugAdapterExecutable:O.DebugAdapterExecutable,DebugAdapterInlineImplementation:O.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:O.DebugAdapterNamedPipeServer,DebugAdapterServer:O.DebugAdapterServer,DebugConfigurationProviderTriggerKind:it.DebugConfigurationProviderTriggerKind,DebugConsoleMode:O.DebugConsoleMode,DecorationRangeBehavior:O.DecorationRangeBehavior,Diagnostic:O.Diagnostic,DiagnosticRelatedInformation:O.DiagnosticRelatedInformation,DiagnosticSeverity:O.DiagnosticSeverity,DiagnosticTag:O.DiagnosticTag,Disposable:O.Disposable,DocumentHighlight:O.DocumentHighlight,DocumentHighlightKind:O.DocumentHighlightKind,DocumentLink:O.DocumentLink,DocumentSymbol:O.DocumentSymbol,EndOfLine:O.EndOfLine,EnvironmentVariableMutatorType:O.EnvironmentVariableMutatorType,EvaluatableExpression:O.EvaluatableExpression,InlineValueText:O.InlineValueText,InlineValueVariableLookup:O.InlineValueVariableLookup,InlineValueEvaluatableExpression:O.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:O.InlineCompletionTriggerKind,InlineCompletionTriggerKindNew:O.InlineCompletionTriggerKindNew,EventEmitter:w.Emitter,ExtensionKind:O.ExtensionKind,ExtensionMode:O.ExtensionMode,ExternalUriOpenerPriority:O.ExternalUriOpenerPriority,FileChangeType:O.FileChangeType,FileDecoration:O.FileDecoration,FileSystemError:O.FileSystemError,FileType:S.FileType,FilePermission:S.FilePermission,FoldingRange:O.FoldingRange,FoldingRangeKind:O.FoldingRangeKind,FunctionBreakpoint:O.FunctionBreakpoint,InlineCompletionItem:O.InlineSuggestion,InlineCompletionItemNew:O.InlineSuggestionNew,InlineCompletionList:O.InlineSuggestionList,InlineCompletionListNew:O.InlineSuggestionsNew,Hover:O.Hover,IndentAction:k.IndentAction,Location:O.Location,MarkdownString:O.MarkdownString,OverviewRulerLane:E.OverviewRulerLane,ParameterInformation:O.ParameterInformation,PortAutoForwardAction:O.PortAutoForwardAction,Position:O.Position,ProcessExecution:O.ProcessExecution,ProgressLocation:O.ProgressLocation,QuickInputButtons:O.QuickInputButtons,Range:O.Range,RelativePattern:O.RelativePattern,Selection:O.Selection,SelectionRange:O.SelectionRange,SemanticTokens:O.SemanticTokens,SemanticTokensBuilder:O.SemanticTokensBuilder,SemanticTokensEdit:O.SemanticTokensEdit,SemanticTokensEdits:O.SemanticTokensEdits,SemanticTokensLegend:O.SemanticTokensLegend,ShellExecution:O.ShellExecution,ShellQuoting:O.ShellQuoting,SignatureHelp:O.SignatureHelp,SignatureHelpTriggerKind:O.SignatureHelpTriggerKind,SignatureInformation:O.SignatureInformation,SnippetString:O.SnippetString,SourceBreakpoint:O.SourceBreakpoint,StandardTokenType:O.StandardTokenType,StatusBarAlignment:O.StatusBarAlignment,SymbolInformation:O.SymbolInformation,SymbolKind:O.SymbolKind,SymbolTag:O.SymbolTag,Task:O.Task,TaskGroup:O.TaskGroup,TaskPanelKind:O.TaskPanelKind,TaskRevealKind:O.TaskRevealKind,TaskScope:O.TaskScope,TerminalLink:O.TerminalLink,TerminalLocation:O.TerminalLocation,TerminalProfile:O.TerminalProfile,TextDocumentSaveReason:O.TextDocumentSaveReason,TextEdit:O.TextEdit,SnippetTextEdit:O.SnippetTextEdit,TextEditorCursorStyle:A.TextEditorCursorStyle,TextEditorLineNumbersStyle:O.TextEditorLineNumbersStyle,TextEditorRevealType:O.TextEditorRevealType,TextEditorSelectionChangeKind:O.TextEditorSelectionChangeKind,TextDocumentChangeReason:O.TextDocumentChangeReason,ThemeColor:O.ThemeColor,ThemeIcon:O.ThemeIcon,TreeItem:O.TreeItem,TreeItem2:O.TreeItem,TreeItemCheckboxState:O.TreeItemCheckboxState,TreeItemCollapsibleState:O.TreeItemCollapsibleState,TypeHierarchyItem:O.TypeHierarchyItem,UIKind:T.UIKind,Uri:_.URI,ViewColumn:O.ViewColumn,WorkspaceEdit:O.WorkspaceEdit,DocumentDropEdit:O.DocumentDropEdit,DocumentPasteEdit:O.DocumentPasteEdit,InlayHint:O.InlayHint,InlayHintLabelPart:O.InlayHintLabelPart,InlayHintKind:O.InlayHintKind,RemoteAuthorityResolverError:O.RemoteAuthorityResolverError,ResolvedAuthority:O.ResolvedAuthority,SourceControlInputBoxValidationType:O.SourceControlInputBoxValidationType,ExtensionRuntime:O.ExtensionRuntime,TimelineItem:O.TimelineItem,NotebookRange:O.NotebookRange,NotebookCellKind:O.NotebookCellKind,NotebookCellExecutionState:O.NotebookCellExecutionState,NotebookCellData:O.NotebookCellData,NotebookData:O.NotebookData,NotebookRendererScript:O.NotebookRendererScript,NotebookCellStatusBarAlignment:O.NotebookCellStatusBarAlignment,NotebookEditorRevealType:O.NotebookEditorRevealType,NotebookCellOutput:O.NotebookCellOutput,NotebookCellOutputItem:O.NotebookCellOutputItem,NotebookCellStatusBarItem:O.NotebookCellStatusBarItem,NotebookControllerAffinity:O.NotebookControllerAffinity,NotebookEdit:O.NotebookEdit,PortAttributes:O.PortAttributes,LinkedEditingRanges:O.LinkedEditingRanges,TestResultState:O.TestResultState,TestRunRequest:O.TestRunRequest,TestMessage:O.TestMessage,TestTag:O.TestTag,TestRunProfileKind:O.TestRunProfileKind,TextSearchCompleteMessageType:nt.TextSearchCompleteMessageType,DataTransfer:O.DataTransfer,DataTransferItem:O.DataTransferItem,CoveredCount:O.CoveredCount,FileCoverage:O.FileCoverage,StatementCoverage:O.StatementCoverage,BranchCoverage:O.BranchCoverage,FunctionCoverage:O.FunctionCoverage,WorkspaceTrustState:O.WorkspaceTrustState,LanguageStatusSeverity:O.LanguageStatusSeverity,QuickPickItemKind:O.QuickPickItemKind,InputBoxValidationSeverity:O.InputBoxValidationSeverity,TabInputText:O.TextTabInput,TabInputTextDiff:O.TextDiffTabInput,TabInputTextMerge:O.TextMergeTabInput,TabInputCustom:O.CustomEditorTabInput,TabInputNotebook:O.NotebookEditorTabInput,TabInputNotebookDiff:O.NotebookDiffEditorTabInput,TabInputWebview:O.WebviewEditorTabInput,TabInputTerminal:O.TerminalEditorTabInput,TabInputInteractiveWindow:O.InteractiveWindowInput,TerminalExitReason:O.TerminalExitReason}}}e.createApiFactoryAndRegisterActors=dt}),define(Ce[237],Ie([1,0,236,33,2,230,6,14,221,21]),function(te,e,r,y,w,L,_,A,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class F extends L.RequireInterceptor{_installInterceptor(){}getModule(f,c){for(const h of this._alternatives){const u=h(f);if(u){f=u;break}}if(this._factories.has(f))return this._factories.get(f).load(f,c,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class S extends y.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=_.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(E.ExtHostConsoleForwarder);const f=this._instaService.invokeFunction(r.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(F,f,{mine:this._myRegistry,all:this._globalRegistry}),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(f){return f.browser}async _loadCommonJSModule(f,c,h){c=c.with({path:m(c.path,".js")});const u=f?.identifier.value;u&&performance.mark(`code/extHost/willFetchExtensionCode/${u}`);const v=w.URI.revive(await this._mainThreadExtensionsProxy.$asBrowserUri(c)),I=await fetch(v.toString(!0));if(u&&performance.mark(`code/extHost/didFetchExtensionCode/${u}`),I.status!==200)throw new Error(I.statusText);const l=await I.text(),b=`${c.toString(!0)}#vscode-extension`,t=`${l}
//# sourceURL=${b}`;let d;try{d=new Function("module","exports","require",t)}catch(o){throw console.error(u?`Loading code for extension ${u} failed: ${o.message}`:`Loading code failed: ${o.message}`),console.error(`${c.toString(!0)}${typeof o.line=="number"?` line ${o.line}`:""}${typeof o.column=="number"?` column ${o.column}`:""}`),console.error(o),o}const n=await this.fetchTranslatedStrings(f),i={},s={exports:i},a=o=>{if(o==="vscode-nls-web-data")return n;const g=this._fakeModules.getModule(o,c);if(g===void 0)throw new Error(`Cannot load module '${o}'`);return g};try{return h.codeLoadingStart(),u&&performance.mark(`code/extHost/willLoadExtensionCode/${u}`),d(s,i,a),s.exports!==i?s.exports:i}finally{u&&performance.mark(`code/extHost/didLoadExtensionCode/${u}`),h.codeLoadingStop()}}async $setRemoteEnvironment(f){}async _waitForDebuggerAttachment(f=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const c=Date.now()+f;for(;Date.now()<c&&!("__jsDebugIsReady"in globalThis);)await(0,A.timeout)(10)}async fetchTranslatedStrings(f){let c={};if(!f)return{};const h=k.Language.isDefaultVariant()?f.browserNlsBundleUris?.en:f.browserNlsBundleUris?.[k.Language.value()]??f.browserNlsBundleUris?.en;if(f&&h)try{const u=await fetch(h.toString(!0));if(!u.ok)throw new Error(await u.text());c=await u.json()}catch(u){try{console.error(`Failed to load translations for ${f.identifier.value} from ${h}: ${u.message}`);const v=f.browserNlsBundleUris?.en;if(v){const I=await fetch(v.toString(!0));if(!I.ok)throw new Error(await I.text());c=await I.json()}throw new Error("No English strings found")}catch(v){console.error(v)}}return c}}e.ExtHostExtensionService=S;function m(T,f){return T.endsWith(f)?T:T+f}}),define(Ce[238],Ie([1,0,56,33,70,237]),function(te,e,r,y,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.registerSingleton)(y.IExtHostExtensionService,L.ExtHostExtensionService,!1),(0,r.registerSingleton)(w.IExtensionStoragePaths,w.ExtensionStoragePaths,!1)}),define(Ce[247],Ie([1,0,23,5,91,231,223,19,71,12,2,233,238]),function(te,e,r,y,w,L,_,A,E,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const S=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const m=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function T(t){return/^(file|vscode-remote):/i.test(t)}const f=fetch.bind(self);function c(t){self.fetch=async function(d,n){return d instanceof Request||T(String(d))&&(d=(await t(F.URI.parse(String(d)))).toString(!0)),f(d,n)},self.XMLHttpRequest=class extends XMLHttpRequest{open(d,n,i,s,a){(async()=>(T(n.toString())&&(n=(await t(F.URI.parse(n.toString()))).toString(!0)),super.open(d,n,i??!0,s,a)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(d,n){if(/^file:/i.test(d.toString()))d=k.FileAccess.asBrowserUri(F.URI.parse(d.toString())).toString(!0);else if(/^vscode-remote:/i.test(d.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const s=`(${function(p){function P(B){return typeof B=="string"||B instanceof URL?String(B).replace(/^file:\/\//i,"vscode-file://vscode-app"):B}const M=fetch.bind(self);self.fetch=function(B,D){return B instanceof Request?M(B,D):M(P(B),D)},self.XMLHttpRequest=class extends XMLHttpRequest{open(B,D,x,U,R){return super.open(B,P(D),x??!0,U,R)}};const V=importScripts.bind(self);self.importScripts=(...B)=>{V(...B.map(P))},V(p)}.toString()}('${d}'))`;n=n||{},n.name=n.name||A.basename(d.toString());const a=new Blob([s],{type:"application/javascript"}),o=URL.createObjectURL(a);return new t(o,n)}}else self.Worker=class extends _.NestedWorker{constructor(t,d){super(m,t,{name:A.basename(t.toString()),...d})}};const h=new class{constructor(){this.pid=void 0}exit(t){S()}async exists(t){return!0}async realpath(t){return t}};class u{constructor(){const d=new MessageChannel,n=new y.Emitter;let i=!1;m(d.port2,[d.port2]),d.port1.onmessage=s=>{const{data:a}=s;if(!(a instanceof ArrayBuffer)){console.warn("UNKNOWN data received",a);return}const o=r.VSBuffer.wrap(new Uint8Array(a,0,a.byteLength));if((0,w.isMessageOfType)(o,2)){i=!0,I("received terminate message from renderer");return}n.fire(o)},this.protocol={onMessage:n.event,send:s=>{if(!i){const a=s.buffer.buffer.slice(s.buffer.byteOffset,s.buffer.byteOffset+s.buffer.byteLength);d.port1.postMessage(a,[a])}}}}}function v(t){return new Promise(d=>{const n=t.onMessage(i=>{n.dispose();const s=JSON.parse(i.toString());t.send((0,w.createMessageOfType)(0)),d({protocol:t,initData:s})});t.send((0,w.createMessageOfType)(1))})}let I=t=>S();function l(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function b(){E.mark("code/extHost/willConnectToRenderer");const t=new u;return{onmessage(d){!l(d)||v(t.protocol).then(n=>{E.mark("code/extHost/didWaitForInitData");const i=new L.ExtensionHostMain(n.protocol,n.initData,h,null,d.data);c(s=>i.asBrowserUri(s)),I=s=>i.terminate(s)})}}}e.create=b})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/1a55beb2aaee64eb8d0cbe5b61b10088bbc6c895/core/vs/workbench/api/worker/extensionHostWorker.js.map
